/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ve=["exports","require","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/network","vs/platform/log/common/log","vs/base/common/platform","vs/base/common/types","vs/workbench/api/common/extHostTypeConverters","vs/base/common/errors","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/base/common/map","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/platform/extensions/common/extensions","vs/base/node/pfs","vs/base/common/extpath","vs/workbench/services/extensions/common/extensions","vs/workbench/services/search/common/search","vs/base/common/glob","vs/base/common/uuid","vs/workbench/api/common/extHostTerminalService","vs/editor/common/core/range","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","child_process","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostExtensionService","vs/base/common/process","vs/platform/files/common/files","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/stopwatch","vs/base/common/severity","vs/editor/common/core/position","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/workbench/api/common/extHostTunnelService","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDebugService","vs/base/common/assert","vs/base/common/decorators","vs/base/common/hash","vs/base/common/marshalling","fs","os","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/codicons","vs/base/common/collections","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/normalization","vs/editor/common/languages","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/common/webview","vs/workbench/contrib/testing/common/testCollection","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/numbers","vs/base/common/mime","vs/base/common/processes","vs/base/common/stream","vs/base/common/filters","vs/base/common/uint","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/uriIpc","string_decoder","vs/base/node/extpath","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/languageSelector","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/services/semanticTokensDto","vs/base/node/processes","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/configuration/common/configuration","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/tunnel/common/tunnel","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/cache","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagement","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/node/uriTransformer","vs/workbench/common/editor","vs/workbench/api/common/extHostCodeInsets","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/output/common/output","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/textfile/common/encoding","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","util","https","tls","vscode-proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],we=function(te){for(var e=[],f=0,i=te.length;f<i;f++)e[f]=ve[te[f]];return e};define(ve[55],we([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function f(i,I){if(!i)throw new Error(I?`Assertion failed (${I})`:"Assertion Failed")}e.ok=f}),define(ve[72],we([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function f(C){return C?C.replace(/\$\((.*?)\)/g,(k,S)=>` ${S} `).trim():""}e.getCodiconAriaLabel=f;class i{constructor(k,S,R){this.id=k,this.definition=S,this.description=R,i._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return i._allCodicons}}e.Codicon=i,i._allCodicons=[],i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",i.add.definition),i.gistNew=new i("gist-new",i.add.definition),i.repoCreate=new i("repo-create",i.add.definition),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolCustomColor=new i("symbol-customcolor",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.debugContinueSmall=new i("debug-continue-small",{fontCharacter:"\\ebe0"}),i.beakerStop=new i("beaker-stop",{fontCharacter:"\\ebe1"}),i.graphLine=new i("graph-line",{fontCharacter:"\\ebe2"}),i.graphScatter=new i("graph-scatter",{fontCharacter:"\\ebe3"}),i.pieChart=new i("pie-chart",{fontCharacter:"\\ebe4"}),i.bracket=new i("bracket",i.json.definition),i.bracketDot=new i("bracket-dot",{fontCharacter:"\\ebe5"}),i.bracketError=new i("bracket-error",{fontCharacter:"\\ebe6"}),i.lockSmall=new i("lock-small",{fontCharacter:"\\ebe7"}),i.azureDevops=new i("azure-devops",{fontCharacter:"\\ebe8"}),i.verifiedFilled=new i("verified-filled",{fontCharacter:"\\ebe9"}),i.newLine=new i("newline",{fontCharacter:"\\ebea"}),i.layout=new i("layout",{fontCharacter:"\\ebeb"}),i.layoutActivitybarLeft=new i("layout-activitybar-left",{fontCharacter:"\\ebec"}),i.layoutActivitybarRight=new i("layout-activitybar-right",{fontCharacter:"\\ebed"}),i.layoutPanelLeft=new i("layout-panel-left",{fontCharacter:"\\ebee"}),i.layoutPanelCenter=new i("layout-panel-center",{fontCharacter:"\\ebef"}),i.layoutPanelJustify=new i("layout-panel-justify",{fontCharacter:"\\ebf0"}),i.layoutPanelRight=new i("layout-panel-right",{fontCharacter:"\\ebf1"}),i.layoutPanel=new i("layout-panel",{fontCharacter:"\\ebf2"}),i.layoutSidebarLeft=new i("layout-sidebar-left",{fontCharacter:"\\ebf3"}),i.layoutSidebarRight=new i("layout-sidebar-right",{fontCharacter:"\\ebf4"}),i.layoutStatusbar=new i("layout-statusbar",{fontCharacter:"\\ebf5"}),i.layoutMenubar=new i("layout-menubar",{fontCharacter:"\\ebf6"}),i.layoutCentered=new i("layout-centered",{fontCharacter:"\\ebf7"}),i.target=new i("target",{fontCharacter:"\\ebf8"}),i.indent=new i("indent",{fontCharacter:"\\ebf9"}),i.recordSmall=new i("record-small",{fontCharacter:"\\ebfa"}),i.errorSmall=new i("error-small",{fontCharacter:"\\ebfb"}),i.arrowCircleDown=new i("arrow-circle-down",{fontCharacter:"\\ebfc"}),i.arrowCircleLeft=new i("arrow-circle-left",{fontCharacter:"\\ebfd"}),i.arrowCircleRight=new i("arrow-circle-right",{fontCharacter:"\\ebfe"}),i.arrowCircleUp=new i("arrow-circle-up",{fontCharacter:"\\ebff"}),i.dialogError=new i("dialog-error",i.error.definition),i.dialogWarning=new i("dialog-warning",i.warning.definition),i.dialogInfo=new i("dialog-info",i.info.definition),i.dialogClose=new i("dialog-close",i.close.definition),i.treeItemExpanded=new i("tree-item-expanded",i.chevronDown.definition),i.treeFilterOnTypeOn=new i("tree-filter-on-type-on",i.listFilter.definition),i.treeFilterOnTypeOff=new i("tree-filter-on-type-off",i.listSelection.definition),i.treeFilterClear=new i("tree-filter-clear",i.close.definition),i.treeItemLoading=new i("tree-item-loading",i.loading.definition),i.menuSelection=new i("menu-selection",i.check.definition),i.menuSubmenu=new i("menu-submenu",i.chevronRight.definition),i.menuBarMore=new i("menubar-more",i.more.definition),i.scrollbarButtonLeft=new i("scrollbar-button-left",i.triangleLeft.definition),i.scrollbarButtonRight=new i("scrollbar-button-right",i.triangleRight.definition),i.scrollbarButtonUp=new i("scrollbar-button-up",i.triangleUp.definition),i.scrollbarButtonDown=new i("scrollbar-button-down",i.triangleDown.definition),i.toolBarMore=new i("toolbar-more",i.more.definition),i.quickInputBack=new i("quick-input-back",i.arrowLeft.definition);function I(C,k){const S=["codicon","codicon-"+C];return k&&S.push("codicon-modifier-"+k),S}e.getClassNamesArray=I;var A;(function(C){C.iconNameSegment="[A-Za-z0-9]+",C.iconNameExpression="[A-Za-z0-9-]+",C.iconModifierExpression="~[A-Za-z]+",C.iconNameCharacter="[A-Za-z0-9~-]";const k=new RegExp(`^(${C.iconNameExpression})(${C.iconModifierExpression})?$`);function S(D){if(D instanceof i)return["codicon","codicon-"+D.id];const v=k.exec(D.id);if(!v)return S(i.error);let[,b,g]=v;const d=["codicon","codicon-"+b];return g&&d.push("codicon-modifier-"+g.substr(1)),d}C.asClassNameArray=S;function R(D){return S(D).join(" ")}C.asClassName=R;function F(D){return"."+S(D).join(".")}C.asCSSSelector=F})(A=e.CSSIcon||(e.CSSIcon={}))}),define(ve[73],we([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const f=Object.prototype.hasOwnProperty;function i(F){const D=[];for(let v in F)f.call(F,v)&&D.push(F[v]);return D}e.values=i;function I(F,D){for(let v in F)if(f.call(F,v)&&D({key:v,value:F[v]},function(){delete F[v]})===!1)return}e.forEach=I;function A(F,D){const v=Object.create(null);for(const b of F){const g=D(b);let d=v[g];d||(d=v[g]=[]),d.push(b)}return v}e.groupBy=A;function C(F){const D=Object.create(null);return F&&F.forEach((v,b)=>{D[b]=v}),D}e.fromMap=C;function k(F,D){const v=[],b=[];for(let g of F)D.has(g)||v.push(g);for(let g of D)F.has(g)||b.push(g);return{removed:v,added:b}}e.diffSets=k;function S(F,D){const v=[],b=[];for(let[g,d]of F)D.has(g)||v.push(d);for(let[g,d]of D)F.has(g)||b.push(d);return{removed:v,added:b}}e.diffMaps=S;class R{constructor(){this.map=new Map}add(D,v){let b=this.map.get(D);b||(b=new Set,this.map.set(D,b)),b.add(v)}delete(D,v){const b=this.map.get(D);!b||(b.delete(v),b.size===0&&this.map.delete(D))}forEach(D,v){const b=this.map.get(D);!b||b.forEach(v)}}e.SetMap=R}),define(ve[56],we([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function f(C){return(k,S,R)=>{let F=null,D=null;if(typeof R.value=="function"?(F="value",D=R.value):typeof R.get=="function"&&(F="get",D=R.get),!D)throw new Error("not supported");R[F]=C(D,S)}}e.createDecorator=f;function i(C,k,S){let R=null,F=null;if(typeof S.value=="function"?(R="value",F=S.value,F.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(R="get",F=S.get),!F)throw new Error("not supported");const D=`$memoize$${k}`;S[R]=function(...v){return this.hasOwnProperty(D)||Object.defineProperty(this,D,{configurable:!1,enumerable:!1,writable:!1,value:F.apply(this,v)}),this[D]}}e.memoize=i;function I(C,k,S){return f((R,F)=>{const D=`$debounce$${F}`,v=`$debounce$result$${F}`;return function(...b){this[v]||(this[v]=S?S():void 0),clearTimeout(this[D]),k&&(this[v]=k(this[v],...b),b=[this[v]]),this[D]=setTimeout(()=>{R.apply(this,b),this[v]=S?S():void 0},C)}})}e.debounce=I;function A(C,k,S){return f((R,F)=>{const D=`$throttle$timer$${F}`,v=`$throttle$result$${F}`,b=`$throttle$lastRun$${F}`,g=`$throttle$pending$${F}`;return function(...d){if(this[v]||(this[v]=S?S():void 0),(this[b]===null||this[b]===void 0)&&(this[b]=-Number.MAX_VALUE),k&&(this[v]=k(this[v],...d)),this[g])return;const p=this[b]+C;p<=Date.now()?(this[b]=Date.now(),R.apply(this,[this[v]]),this[v]=S?S():void 0):(this[g]=!0,this[D]=setTimeout(()=>{this[g]=!1,this[b]=Date.now(),R.apply(this,[this[v]]),this[v]=S?S():void 0},p-Date.now()))}})}e.throttle=A}),define(ve[15],we([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class f{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(u){setTimeout(()=>{throw u.stack?new Error(u.message+`

`+u.stack):u},0)}}addListener(u){return this.listeners.push(u),()=>{this._removeListener(u)}}emit(u){this.listeners.forEach(a=>{a(u)})}_removeListener(u){this.listeners.splice(this.listeners.indexOf(u),1)}setUnexpectedErrorHandler(u){this.unexpectedErrorHandler=u}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(u){this.unexpectedErrorHandler(u),this.emit(u)}onUnexpectedExternalError(u){this.unexpectedErrorHandler(u)}}e.ErrorHandler=f,e.errorHandler=new f;function i(c){e.errorHandler.setUnexpectedErrorHandler(c)}e.setUnexpectedErrorHandler=i;function I(c){S(c)||e.errorHandler.onUnexpectedError(c)}e.onUnexpectedError=I;function A(c){S(c)||e.errorHandler.onUnexpectedExternalError(c)}e.onUnexpectedExternalError=A;function C(c){if(c instanceof Error){let{name:u,message:a}=c;const E=c.stacktrace||c.stack;return{$isError:!0,name:u,message:a,stack:E}}return c}e.transformErrorForSerialization=C;const k="Canceled";function S(c){return c instanceof R?!0:c instanceof Error&&c.name===k&&c.message===k}e.isCancellationError=S;class R extends Error{constructor(){super(k);this.name=this.message}}e.CancellationError=R;function F(){const c=new Error(k);return c.name=c.message,c}e.canceled=F;function D(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}e.illegalArgument=D;function v(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}e.illegalState=v;function b(c){return c?new Error(`readonly property '${c} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=b;function g(c){const u=new Error(`${c} has been disposed`);return u.name="DISPOSED",u}e.disposed=g;function d(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}e.getErrorMessage=d;class p extends Error{constructor(u){super("NotImplemented");u&&(this.message=u)}}e.NotImplementedError=p;class P extends Error{constructor(u){super("NotSupported");u&&(this.message=u)}}e.NotSupportedError=P;class _ extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=_;class l extends Error{constructor(){super(...arguments);this.logTelemetry=!1}}e.ErrorNoTelemetry=l}),define(ve[18],we([1,0,15]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.compareBy=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function i(Z,Y=0){return Z[Z.length-(1+Y)]}e.tail=i;function I(Z){if(Z.length===0)throw new Error("Invalid tail call");return[Z.slice(0,Z.length-1),Z[Z.length-1]]}e.tail2=I;function A(Z,Y,se=(de,ge)=>de===ge){if(Z===Y)return!0;if(!Z||!Y||Z.length!==Y.length)return!1;for(let de=0,ge=Z.length;de<ge;de++)if(!se(Z[de],Y[de]))return!1;return!0}e.equals=A;function C(Z,Y,se){let de=0,ge=Z.length-1;for(;de<=ge;){const Te=(de+ge)/2|0,Ne=se(Z[Te],Y);if(Ne<0)de=Te+1;else if(Ne>0)ge=Te-1;else return Te}return-(de+1)}e.binarySearch=C;function k(Z,Y){let se=0,de=Z.length;if(de===0)return 0;for(;se<de;){const ge=Math.floor((se+de)/2);Y(Z[ge])?de=ge:se=ge+1}return se}e.findFirstInSorted=k;function S(Z,Y,se){if(Z=Z|0,Z>=Y.length)throw new TypeError("invalid index");let de=Y[Math.floor(Y.length*Math.random())],ge=[],Te=[],Ne=[];for(let be of Y){const Ee=se(be,de);Ee<0?ge.push(be):Ee>0?Te.push(be):Ne.push(be)}return Z<ge.length?S(Z,ge,se):Z<ge.length+Ne.length?Ne[0]:S(Z-(ge.length+Ne.length),Te,se)}e.quickSelect=S;function R(Z,Y){const se=[];let de;for(const ge of Z.slice(0).sort(Y))!de||Y(de[0],ge)!==0?(de=[ge],se.push(de)):de.push(ge);return se}e.groupBy=R;function F(Z,Y,se){const de=[];function ge(be,Ee,z){if(Ee===0&&z.length===0)return;const B=de[de.length-1];B&&B.start+B.deleteCount===be?(B.deleteCount+=Ee,B.toInsert.push(...z)):de.push({start:be,deleteCount:Ee,toInsert:z})}let Te=0,Ne=0;for(;;){if(Te===Z.length){ge(Te,0,Y.slice(Ne));break}if(Ne===Y.length){ge(Te,Z.length-Te,[]);break}const be=Z[Te],Ee=Y[Ne],z=se(be,Ee);z===0?(Te+=1,Ne+=1):z<0?(ge(Te,1,[]),Te+=1):z>0&&(ge(Te,0,[Ee]),Ne+=1)}return de}e.sortedDiff=F;function D(Z,Y,se){const de=F(Z,Y,se),ge=[],Te=[];for(const Ne of de)ge.push(...Z.slice(Ne.start,Ne.start+Ne.deleteCount)),Te.push(...Ne.toInsert);return{removed:ge,added:Te}}e.delta=D;function v(Z,Y,se){if(se===0)return[];const de=Z.slice(0,se).sort(Y);return g(Z,Y,de,se,Z.length),de}e.top=v;function b(Z,Y,se,de,ge){return se===0?Promise.resolve([]):new Promise((Te,Ne)=>{(async()=>{const be=Z.length,Ee=Z.slice(0,se).sort(Y);for(let z=se,B=Math.min(se+de,be);z<be;z=B,B=Math.min(B+de,be)){if(z>se&&await new Promise(N=>setTimeout(N)),ge&&ge.isCancellationRequested)throw(0,f.canceled)();g(Z,Y,Ee,z,B)}return Ee})().then(Te,Ne)})}e.topAsync=b;function g(Z,Y,se,de,ge){for(const Te=se.length;de<ge;de++){const Ne=Z[de];if(Y(Ne,se[Te-1])<0){se.pop();const be=k(se,Ee=>Y(Ne,Ee)<0);se.splice(be,0,Ne)}}}function d(Z){return Z.filter(Y=>!!Y)}e.coalesce=d;function p(Z){let Y=0;for(let se=0;se<Z.length;se++)Z[se]&&(Z[Y]=Z[se],Y+=1);Z.length=Y}e.coalesceInPlace=p;function P(Z,Y,se){Z.splice(se,0,Z.splice(Y,1)[0])}e.move=P;function _(Z){return!Array.isArray(Z)||Z.length===0}e.isFalsyOrEmpty=_;function l(Z){return Array.isArray(Z)&&Z.length>0}e.isNonEmptyArray=l;function c(Z,Y=se=>se){const se=new Set;return Z.filter(de=>{const ge=Y(de);return se.has(ge)?!1:(se.add(ge),!0)})}e.distinct=c;function u(Z){const Y=new Set;return se=>{const de=Z(se);return Y.has(de)?!1:(Y.add(de),!0)}}e.uniqueFilter=u;function a(Z,Y){const se=E(Z,Y);if(se!==-1)return Z[se]}e.findLast=a;function E(Z,Y){for(let se=Z.length-1;se>=0;se--){const de=Z[se];if(Y(de))return se}return-1}e.lastIndex=E;function s(Z,Y){return Z.length>0?Z[0]:Y}e.firstOrDefault=s;function t(Z,Y,se=(de,ge)=>de===ge){let de=0;for(let ge=0,Te=Math.min(Z.length,Y.length);ge<Te&&se(Z[ge],Y[ge]);ge++)de++;return de}e.commonPrefixLength=t;function r(Z){return[].concat(...Z)}e.flatten=r;function n(Z,Y){let se=typeof Y=="number"?Z:0;typeof Y=="number"?se=Z:(se=0,Y=Z);const de=[];if(se<=Y)for(let ge=se;ge<Y;ge++)de.push(ge);else for(let ge=se;ge>Y;ge--)de.push(ge);return de}e.range=n;function o(Z,Y,se){return Z.reduce((de,ge)=>(de[Y(ge)]=se?se(ge):ge,de),Object.create(null))}e.index=o;function m(Z,Y){return Z.push(Y),()=>h(Z,Y)}e.insert=m;function h(Z,Y){const se=Z.indexOf(Y);if(se>-1)return Z.splice(se,1),Y}e.remove=h;function w(Z,Y,se){const de=Z.slice(0,Y),ge=Z.slice(Y);return de.concat(se,ge)}e.arrayInsert=w;function T(Z,Y){let se;if(typeof Y=="number"){let de=Y;se=()=>{const ge=Math.sin(de++)*179426549;return ge-Math.floor(ge)}}else se=Math.random;for(let de=Z.length-1;de>0;de-=1){const ge=Math.floor(se()*(de+1)),Te=Z[de];Z[de]=Z[ge],Z[ge]=Te}}e.shuffle=T;function L(Z,Y){const se=Z.indexOf(Y);se>-1&&(Z.splice(se,1),Z.unshift(Y))}e.pushToStart=L;function O(Z,Y){const se=Z.indexOf(Y);se>-1&&(Z.splice(se,1),Z.push(Y))}e.pushToEnd=O;function y(Z,Y){return Array.isArray(Z)?Z.map(Y):Y(Z)}e.mapArrayOrNot=y;function H(Z){return Array.isArray(Z)?Z:[Z]}e.asArray=H;function M(Z){return Z[Math.floor(Math.random()*Z.length)]}e.getRandomElement=M;function j(Z,Y){for(const se of Z){const de=Y(se);if(de!==void 0)return de}}e.mapFind=j;function X(Z,Y,se){const de=U(Z,Y),ge=Z.length,Te=se.length;Z.length=ge+Te;for(let Ne=ge-1;Ne>=de;Ne--)Z[Ne+Te]=Z[Ne];for(let Ne=0;Ne<Te;Ne++)Z[Ne+de]=se[Ne]}e.insertInto=X;function $(Z,Y,se,de){const ge=U(Z,Y),Te=Z.splice(ge,se);return X(Z,ge,de),Te}e.splice=$;function U(Z,Y){return Y<0?Math.max(Y+Z.length,0):Math.min(Y,Z.length)}function q(Z,Y){return(se,de)=>Y(Z(se),Z(de))}e.compareBy=q;const K=(Z,Y)=>Z-Y;e.numberComparator=K;function G(Z,Y){if(Z.length===0)return;let se=Z[0];for(let de=1;de<Z.length;de++){const ge=Z[de];Y(ge,se)>0&&(se=ge)}return se}e.findMaxBy=G;function ee(Z,Y){if(Z.length===0)return;let se=Z[0];for(let de=1;de<Z.length;de++){const ge=Z[de];Y(ge,se)>=0&&(se=ge)}return se}e.findLastMaxBy=ee;function oe(Z,Y){return G(Z,(se,de)=>-Y(se,de))}e.findMinBy=oe;class ue{constructor(Y){this.items=Y,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(Y){let se=this.firstIdx;for(;se<this.items.length&&Y(this.items[se]);)se++;const de=se===this.firstIdx?null:this.items.slice(this.firstIdx,se);return this.firstIdx=se,de}takeFromEndWhile(Y){let se=this.lastIdx;for(;se>=0&&Y(this.items[se]);)se--;const de=se===this.lastIdx?null:this.items.slice(se+1,this.lastIdx+1);return this.lastIdx=se,de}peek(){return this.items[this.firstIdx]}dequeue(){const Y=this.items[this.firstIdx];return this.firstIdx++,Y}takeCount(Y){const se=this.items.slice(this.firstIdx,this.firstIdx+Y);return this.firstIdx+=Y,se}}e.ArrayQueue=ue}),define(ve[74],we([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function f(i){const I=this;let A=!1,C;return function(){return A||(A=!0,C=i.apply(I,arguments)),C}}e.once=f}),define(ve[75],we([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class f{constructor(I){this._prefix=I,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=f,e.defaultGenerator=new f("id#")}),define(ve[76],we([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var f;(function(i){function I(u){return u&&typeof u=="object"&&typeof u[Symbol.iterator]=="function"}i.is=I;const A=Object.freeze([]);function C(){return A}i.empty=C;function*k(u){yield u}i.single=k;function S(u){return u||A}i.from=S;function R(u){return!u||u[Symbol.iterator]().next().done===!0}i.isEmpty=R;function F(u){return u[Symbol.iterator]().next().value}i.first=F;function D(u,a){for(const E of u)if(a(E))return!0;return!1}i.some=D;function v(u,a){for(const E of u)if(a(E))return E}i.find=v;function*b(u,a){for(const E of u)a(E)&&(yield E)}i.filter=b;function*g(u,a){let E=0;for(const s of u)yield a(s,E++)}i.map=g;function*d(...u){for(const a of u)for(const E of a)yield E}i.concat=d;function*p(u){for(const a of u)for(const E of a)yield E}i.concatNested=p;function P(u,a,E){let s=E;for(const t of u)s=a(s,t);return s}i.reduce=P;function*_(u,a,E=u.length){for(a<0&&(a+=u.length),E<0?E+=u.length:E>u.length&&(E=u.length);a<E;a++)yield u[a]}i.slice=_;function l(u,a=Number.POSITIVE_INFINITY){const E=[];if(a===0)return[E,u];const s=u[Symbol.iterator]();for(let t=0;t<a;t++){const r=s.next();if(r.done)return[E,i.empty()];E.push(r.value)}return[E,{[Symbol.iterator](){return s}}]}i.consume=l;function c(u,a,E=(s,t)=>s===t){const s=u[Symbol.iterator](),t=a[Symbol.iterator]();for(;;){const r=s.next(),n=t.next();if(r.done!==n.done)return!1;if(r.done)return!0;if(!E(r.value,n.value))return!1}}i.equals=c})(f=e.Iterable||(e.Iterable={}))}),define(ve[141],we([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var f;(function(a){a[a.None=0]="None",a[a.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",a[a.UnexpectedEndOfString=2]="UnexpectedEndOfString",a[a.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",a[a.InvalidUnicode=4]="InvalidUnicode",a[a.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",a[a.InvalidCharacter=6]="InvalidCharacter"})(f=e.ScanError||(e.ScanError={}));var i;(function(a){a[a.OpenBraceToken=1]="OpenBraceToken",a[a.CloseBraceToken=2]="CloseBraceToken",a[a.OpenBracketToken=3]="OpenBracketToken",a[a.CloseBracketToken=4]="CloseBracketToken",a[a.CommaToken=5]="CommaToken",a[a.ColonToken=6]="ColonToken",a[a.NullKeyword=7]="NullKeyword",a[a.TrueKeyword=8]="TrueKeyword",a[a.FalseKeyword=9]="FalseKeyword",a[a.StringLiteral=10]="StringLiteral",a[a.NumericLiteral=11]="NumericLiteral",a[a.LineCommentTrivia=12]="LineCommentTrivia",a[a.BlockCommentTrivia=13]="BlockCommentTrivia",a[a.LineBreakTrivia=14]="LineBreakTrivia",a[a.Trivia=15]="Trivia",a[a.Unknown=16]="Unknown",a[a.EOF=17]="EOF"})(i=e.SyntaxKind||(e.SyntaxKind={}));var I;(function(a){a[a.InvalidSymbol=1]="InvalidSymbol",a[a.InvalidNumberFormat=2]="InvalidNumberFormat",a[a.PropertyNameExpected=3]="PropertyNameExpected",a[a.ValueExpected=4]="ValueExpected",a[a.ColonExpected=5]="ColonExpected",a[a.CommaExpected=6]="CommaExpected",a[a.CloseBraceExpected=7]="CloseBraceExpected",a[a.CloseBracketExpected=8]="CloseBracketExpected",a[a.EndOfFileExpected=9]="EndOfFileExpected",a[a.InvalidCommentToken=10]="InvalidCommentToken",a[a.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",a[a.UnexpectedEndOfString=12]="UnexpectedEndOfString",a[a.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",a[a.InvalidUnicode=14]="InvalidUnicode",a[a.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",a[a.InvalidCharacter=16]="InvalidCharacter"})(I=e.ParseErrorCode||(e.ParseErrorCode={}));var A;(function(a){a.DEFAULT={allowTrailingComma:!0}})(A=e.ParseOptions||(e.ParseOptions={}));function C(a,E=!1){let s=0,t=a.length,r="",n=0,o=16,m=0;function h(M){let j=0,X=0;for(;j<M;){const $=a.charCodeAt(s);if($>=48&&$<=57)X=X*16+$-48;else if($>=65&&$<=70)X=X*16+$-65+10;else if($>=97&&$<=102)X=X*16+$-97+10;else break;s++,j++}return j<M&&(X=-1),X}function w(M){s=M,r="",n=0,o=16,m=0}function T(){const M=s;if(a.charCodeAt(s)===48)s++;else for(s++;s<a.length&&R(a.charCodeAt(s));)s++;if(s<a.length&&a.charCodeAt(s)===46)if(s++,s<a.length&&R(a.charCodeAt(s)))for(s++;s<a.length&&R(a.charCodeAt(s));)s++;else return m=3,a.substring(M,s);let j=s;if(s<a.length&&(a.charCodeAt(s)===69||a.charCodeAt(s)===101))if(s++,(s<a.length&&a.charCodeAt(s)===43||a.charCodeAt(s)===45)&&s++,s<a.length&&R(a.charCodeAt(s))){for(s++;s<a.length&&R(a.charCodeAt(s));)s++;j=s}else m=3;return a.substring(M,j)}function L(){let M="",j=s;for(;;){if(s>=t){M+=a.substring(j,s),m=2;break}const X=a.charCodeAt(s);if(X===34){M+=a.substring(j,s),s++;break}if(X===92){if(M+=a.substring(j,s),s++,s>=t){m=2;break}switch(a.charCodeAt(s++)){case 34:M+='"';break;case 92:M+="\\";break;case 47:M+="/";break;case 98:M+="\b";break;case 102:M+="\f";break;case 110:M+=`
`;break;case 114:M+="\r";break;case 116:M+="	";break;case 117:{const U=h(4);U>=0?M+=String.fromCharCode(U):m=4;break}default:m=5}j=s;continue}if(X>=0&&X<=31)if(S(X)){M+=a.substring(j,s),m=2;break}else m=6;s++}return M}function O(){if(r="",m=0,n=s,s>=t)return n=t,o=17;let M=a.charCodeAt(s);if(k(M)){do s++,r+=String.fromCharCode(M),M=a.charCodeAt(s);while(k(M));return o=15}if(S(M))return s++,r+=String.fromCharCode(M),M===13&&a.charCodeAt(s)===10&&(s++,r+=`
`),o=14;switch(M){case 123:return s++,o=1;case 125:return s++,o=2;case 91:return s++,o=3;case 93:return s++,o=4;case 58:return s++,o=6;case 44:return s++,o=5;case 34:return s++,r=L(),o=10;case 47:{const j=s-1;if(a.charCodeAt(s+1)===47){for(s+=2;s<t&&!S(a.charCodeAt(s));)s++;return r=a.substring(j,s),o=12}if(a.charCodeAt(s+1)===42){s+=2;const X=t-1;let $=!1;for(;s<X;){if(a.charCodeAt(s)===42&&a.charCodeAt(s+1)===47){s+=2,$=!0;break}s++}return $||(s++,m=1),r=a.substring(j,s),o=13}return r+=String.fromCharCode(M),s++,o=16}case 45:if(r+=String.fromCharCode(M),s++,s===t||!R(a.charCodeAt(s)))return o=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=T(),o=11;default:for(;s<t&&y(M);)s++,M=a.charCodeAt(s);if(n!==s){switch(r=a.substring(n,s),r){case"true":return o=8;case"false":return o=9;case"null":return o=7}return o=16}return r+=String.fromCharCode(M),s++,o=16}}function y(M){if(k(M)||S(M))return!1;switch(M){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function H(){let M;do M=O();while(M>=12&&M<=15);return M}return{setPosition:w,getPosition:()=>s,scan:E?H:O,getToken:()=>o,getTokenValue:()=>r,getTokenOffset:()=>n,getTokenLength:()=>s-n,getTokenError:()=>m}}e.createScanner=C;function k(a){return a===32||a===9||a===11||a===12||a===160||a===5760||a>=8192&&a<=8203||a===8239||a===8287||a===12288||a===65279}function S(a){return a===10||a===13||a===8232||a===8233}function R(a){return a>=48&&a<=57}var F;(function(a){a[a.nullCharacter=0]="nullCharacter",a[a.maxAsciiCharacter=127]="maxAsciiCharacter",a[a.lineFeed=10]="lineFeed",a[a.carriageReturn=13]="carriageReturn",a[a.lineSeparator=8232]="lineSeparator",a[a.paragraphSeparator=8233]="paragraphSeparator",a[a.nextLine=133]="nextLine",a[a.space=32]="space",a[a.nonBreakingSpace=160]="nonBreakingSpace",a[a.enQuad=8192]="enQuad",a[a.emQuad=8193]="emQuad",a[a.enSpace=8194]="enSpace",a[a.emSpace=8195]="emSpace",a[a.threePerEmSpace=8196]="threePerEmSpace",a[a.fourPerEmSpace=8197]="fourPerEmSpace",a[a.sixPerEmSpace=8198]="sixPerEmSpace",a[a.figureSpace=8199]="figureSpace",a[a.punctuationSpace=8200]="punctuationSpace",a[a.thinSpace=8201]="thinSpace",a[a.hairSpace=8202]="hairSpace",a[a.zeroWidthSpace=8203]="zeroWidthSpace",a[a.narrowNoBreakSpace=8239]="narrowNoBreakSpace",a[a.ideographicSpace=12288]="ideographicSpace",a[a.mathematicalSpace=8287]="mathematicalSpace",a[a.ogham=5760]="ogham",a[a._=95]="_",a[a.$=36]="$",a[a._0=48]="_0",a[a._1=49]="_1",a[a._2=50]="_2",a[a._3=51]="_3",a[a._4=52]="_4",a[a._5=53]="_5",a[a._6=54]="_6",a[a._7=55]="_7",a[a._8=56]="_8",a[a._9=57]="_9",a[a.a=97]="a",a[a.b=98]="b",a[a.c=99]="c",a[a.d=100]="d",a[a.e=101]="e",a[a.f=102]="f",a[a.g=103]="g",a[a.h=104]="h",a[a.i=105]="i",a[a.j=106]="j",a[a.k=107]="k",a[a.l=108]="l",a[a.m=109]="m",a[a.n=110]="n",a[a.o=111]="o",a[a.p=112]="p",a[a.q=113]="q",a[a.r=114]="r",a[a.s=115]="s",a[a.t=116]="t",a[a.u=117]="u",a[a.v=118]="v",a[a.w=119]="w",a[a.x=120]="x",a[a.y=121]="y",a[a.z=122]="z",a[a.A=65]="A",a[a.B=66]="B",a[a.C=67]="C",a[a.D=68]="D",a[a.E=69]="E",a[a.F=70]="F",a[a.G=71]="G",a[a.H=72]="H",a[a.I=73]="I",a[a.J=74]="J",a[a.K=75]="K",a[a.L=76]="L",a[a.M=77]="M",a[a.N=78]="N",a[a.O=79]="O",a[a.P=80]="P",a[a.Q=81]="Q",a[a.R=82]="R",a[a.S=83]="S",a[a.T=84]="T",a[a.U=85]="U",a[a.V=86]="V",a[a.W=87]="W",a[a.X=88]="X",a[a.Y=89]="Y",a[a.Z=90]="Z",a[a.ampersand=38]="ampersand",a[a.asterisk=42]="asterisk",a[a.at=64]="at",a[a.backslash=92]="backslash",a[a.bar=124]="bar",a[a.caret=94]="caret",a[a.closeBrace=125]="closeBrace",a[a.closeBracket=93]="closeBracket",a[a.closeParen=41]="closeParen",a[a.colon=58]="colon",a[a.comma=44]="comma",a[a.dot=46]="dot",a[a.doubleQuote=34]="doubleQuote",a[a.equals=61]="equals",a[a.exclamation=33]="exclamation",a[a.greaterThan=62]="greaterThan",a[a.lessThan=60]="lessThan",a[a.minus=45]="minus",a[a.openBrace=123]="openBrace",a[a.openBracket=91]="openBracket",a[a.openParen=40]="openParen",a[a.percent=37]="percent",a[a.plus=43]="plus",a[a.question=63]="question",a[a.semicolon=59]="semicolon",a[a.singleQuote=39]="singleQuote",a[a.slash=47]="slash",a[a.tilde=126]="tilde",a[a.backspace=8]="backspace",a[a.formFeed=12]="formFeed",a[a.byteOrderMark=65279]="byteOrderMark",a[a.tab=9]="tab",a[a.verticalTab=11]="verticalTab"})(F||(F={}));function D(a,E){const s=[],t=new Object;let r;const n={value:{},offset:0,length:0,type:"object",parent:void 0};let o=!1;function m(h,w,T,L){n.value=h,n.offset=w,n.length=T,n.type=L,n.colonOffset=void 0,r=n}try{l(a,{onObjectBegin:(h,w)=>{if(E<=h)throw t;r=void 0,o=E>h,s.push("")},onObjectProperty:(h,w,T)=>{if(E<w||(m(h,w,T,"property"),s[s.length-1]=h,E<=w+T))throw t},onObjectEnd:(h,w)=>{if(E<=h)throw t;r=void 0,s.pop()},onArrayBegin:(h,w)=>{if(E<=h)throw t;r=void 0,s.push(0)},onArrayEnd:(h,w)=>{if(E<=h)throw t;r=void 0,s.pop()},onLiteralValue:(h,w,T)=>{if(E<w||(m(h,w,T,u(h)),E<=w+T))throw t},onSeparator:(h,w,T)=>{if(E<=w)throw t;if(h===":"&&r&&r.type==="property")r.colonOffset=w,o=!1,r=void 0;else if(h===","){const L=s[s.length-1];typeof L=="number"?s[s.length-1]=L+1:(o=!0,s[s.length-1]=""),r=void 0}}})}catch(h){if(h!==t)throw h}return{path:s,previousNode:r,isAtPropertyKey:o,matches:h=>{let w=0;for(let T=0;w<h.length&&T<s.length;T++)if(h[w]===s[T]||h[w]==="*")w++;else if(h[w]!=="**")return!1;return w===h.length}}}e.getLocation=D;function v(a,E=[],s=A.DEFAULT){let t=null,r=[];const n=[];function o(h){Array.isArray(r)?r.push(h):t!==null&&(r[t]=h)}return l(a,{onObjectBegin:()=>{const h={};o(h),n.push(r),r=h,t=null},onObjectProperty:h=>{t=h},onObjectEnd:()=>{r=n.pop()},onArrayBegin:()=>{const h=[];o(h),n.push(r),r=h,t=null},onArrayEnd:()=>{r=n.pop()},onLiteralValue:o,onError:(h,w,T)=>{E.push({error:h,offset:w,length:T})}},s),r[0]}e.parse=v;function b(a,E=[],s=A.DEFAULT){let t={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(h){t.type==="property"&&(t.length=h-t.offset,t=t.parent)}function n(h){return t.children.push(h),h}l(a,{onObjectBegin:h=>{t=n({type:"object",offset:h,length:-1,parent:t,children:[]})},onObjectProperty:(h,w,T)=>{t=n({type:"property",offset:w,length:-1,parent:t,children:[]}),t.children.push({type:"string",value:h,offset:w,length:T,parent:t})},onObjectEnd:(h,w)=>{t.length=h+w-t.offset,t=t.parent,r(h+w)},onArrayBegin:(h,w)=>{t=n({type:"array",offset:h,length:-1,parent:t,children:[]})},onArrayEnd:(h,w)=>{t.length=h+w-t.offset,t=t.parent,r(h+w)},onLiteralValue:(h,w,T)=>{n({type:u(h),offset:w,length:T,parent:t,value:h}),r(w+T)},onSeparator:(h,w,T)=>{t.type==="property"&&(h===":"?t.colonOffset=w:h===","&&r(w))},onError:(h,w,T)=>{E.push({error:h,offset:w,length:T})}},s);const m=t.children[0];return m&&delete m.parent,m}e.parseTree=b;function g(a,E){if(!a)return;let s=a;for(let t of E)if(typeof t=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let r=!1;for(const n of s.children)if(Array.isArray(n.children)&&n.children[0].value===t){s=n.children[1],r=!0;break}if(!r)return}else{const r=t;if(s.type!=="array"||r<0||!Array.isArray(s.children)||r>=s.children.length)return;s=s.children[r]}return s}e.findNodeAtLocation=g;function d(a){if(!a.parent||!a.parent.children)return[];const E=d(a.parent);if(a.parent.type==="property"){const s=a.parent.children[0].value;E.push(s)}else if(a.parent.type==="array"){const s=a.parent.children.indexOf(a);s!==-1&&E.push(s)}return E}e.getNodePath=d;function p(a){switch(a.type){case"array":return a.children.map(p);case"object":{const E=Object.create(null);for(let s of a.children){const t=s.children[1];t&&(E[s.children[0].value]=p(t))}return E}case"null":case"string":case"number":case"boolean":return a.value;default:return}}e.getNodeValue=p;function P(a,E,s=!1){return E>=a.offset&&E<a.offset+a.length||s&&E===a.offset+a.length}e.contains=P;function _(a,E,s=!1){if(P(a,E,s)){const t=a.children;if(Array.isArray(t))for(let r=0;r<t.length&&t[r].offset<=E;r++){const n=_(t[r],E,s);if(n)return n}return a}}e.findNodeAtOffset=_;function l(a,E,s=A.DEFAULT){const t=C(a,!1);function r(ue){return ue?()=>ue(t.getTokenOffset(),t.getTokenLength()):()=>!0}function n(ue){return ue?Z=>ue(Z,t.getTokenOffset(),t.getTokenLength()):()=>!0}const o=r(E.onObjectBegin),m=n(E.onObjectProperty),h=r(E.onObjectEnd),w=r(E.onArrayBegin),T=r(E.onArrayEnd),L=n(E.onLiteralValue),O=n(E.onSeparator),y=r(E.onComment),H=n(E.onError),M=s&&s.disallowComments,j=s&&s.allowTrailingComma;function X(){for(;;){const ue=t.scan();switch(t.getTokenError()){case 4:$(14);break;case 5:$(15);break;case 3:$(13);break;case 1:M||$(11);break;case 2:$(12);break;case 6:$(16);break}switch(ue){case 12:case 13:M?$(10):y();break;case 16:$(1);break;case 15:case 14:break;default:return ue}}}function $(ue,Z=[],Y=[]){if(H(ue),Z.length+Y.length>0){let se=t.getToken();for(;se!==17;){if(Z.indexOf(se)!==-1){X();break}else if(Y.indexOf(se)!==-1)break;se=X()}}}function U(ue){const Z=t.getTokenValue();return ue?L(Z):m(Z),X(),!0}function q(){switch(t.getToken()){case 11:{let ue=0;try{ue=JSON.parse(t.getTokenValue()),typeof ue!="number"&&($(2),ue=0)}catch{$(2)}L(ue);break}case 7:L(null);break;case 8:L(!0);break;case 9:L(!1);break;default:return!1}return X(),!0}function K(){return t.getToken()!==10?($(3,[],[2,5]),!1):(U(!1),t.getToken()===6?(O(":"),X(),oe()||$(4,[],[2,5])):$(5,[],[2,5]),!0)}function G(){o(),X();let ue=!1;for(;t.getToken()!==2&&t.getToken()!==17;){if(t.getToken()===5){if(ue||$(4,[],[]),O(","),X(),t.getToken()===2&&j)break}else ue&&$(6,[],[]);K()||$(4,[],[2,5]),ue=!0}return h(),t.getToken()!==2?$(7,[2],[]):X(),!0}function ee(){w(),X();let ue=!1;for(;t.getToken()!==4&&t.getToken()!==17;){if(t.getToken()===5){if(ue||$(4,[],[]),O(","),X(),t.getToken()===4&&j)break}else ue&&$(6,[],[]);oe()||$(4,[],[4,5]),ue=!0}return T(),t.getToken()!==4?$(8,[4],[]):X(),!0}function oe(){switch(t.getToken()){case 3:return ee();case 1:return G();case 10:return U(!0);default:return q()}}return X(),t.getToken()===17?s.allowEmptyContent?!0:($(4,[],[]),!1):oe()?(t.getToken()!==17&&$(9,[],[]),!0):($(4,[],[]),!1)}e.visit=l;function c(a,E){let s=C(a),t=[],r,n=0,o;do switch(o=s.getPosition(),r=s.scan(),r){case 12:case 13:case 17:n!==o&&t.push(a.substring(n,o)),E!==void 0&&t.push(s.getTokenValue().replace(/[^\r\n]/g,E)),n=s.getPosition();break}while(r!==17);return t.join("")}e.stripComments=c;function u(a){switch(typeof a){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(a){if(Array.isArray(a))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=u}),define(ve[89],we([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class f{constructor(I){this.executor=I,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(I){this._error=I}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(I){return new f(()=>I(this.getValue()))}}e.Lazy=f}),define(ve[6],we([1,0,74,76]),function(te,e,f,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const I=!1;let A=null;function C(r){A=r}if(e.setDisposableTracker=C,I){const r="__is_disposable_tracked__";C(new class{trackDisposable(n){const o=new Error("Potentially leaked disposable").stack;setTimeout(()=>{n[r]||console.log(o)},3e3)}setParent(n,o){if(n&&n!==_.None)try{n[r]=!0}catch{}}markAsDisposed(n){if(n&&n!==_.None)try{n[r]=!0}catch{}}markAsSingleton(n){}})}function k(r){return A?.trackDisposable(r),r}function S(r){A?.markAsDisposed(r)}function R(r,n){A?.setParent(r,n)}function F(r,n){if(!!A)for(const o of r)A.setParent(o,n)}function D(r){return A?.markAsSingleton(r),r}e.markAsSingleton=D;class v extends Error{constructor(n){super(`Encountered errors while disposing of store. Errors: [${n.join(", ")}]`);this.errors=n}}e.MultiDisposeError=v;function b(r){return typeof r.dispose=="function"&&r.dispose.length===0}e.isDisposable=b;function g(r){if(i.Iterable.is(r)){let n=[];for(const o of r)if(o)try{o.dispose()}catch(m){n.push(m)}if(n.length===1)throw n[0];if(n.length>1)throw new v(n);return Array.isArray(r)?[]:r}else if(r)return r.dispose(),r}e.dispose=g;function d(...r){const n=p(()=>g(r));return F(r,n),n}e.combinedDisposable=d;function p(r){const n=k({dispose:(0,f.once)(()=>{S(n),r()})});return n}e.toDisposable=p;class P{constructor(){this._toDispose=new Set,this._isDisposed=!1,k(this)}dispose(){this._isDisposed||(S(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{g(this._toDispose.values())}finally{this._toDispose.clear()}}add(n){if(!n)return n;if(n===this)throw new Error("Cannot register a disposable on itself!");return R(n,this),this._isDisposed?P.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(n),n}}e.DisposableStore=P,P.DISABLE_DISPOSED_WARNING=!1;class _{constructor(){this._store=new P,k(this),R(this._store,this)}dispose(){S(this),this._store.dispose()}_register(n){if(n===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(n)}}e.Disposable=_,_.None=Object.freeze({dispose(){}});class l{constructor(){this._isDisposed=!1,k(this)}get value(){return this._isDisposed?void 0:this._value}set value(n){this._isDisposed||n===this._value||(this._value?.dispose(),n&&R(n,this),this._value=n)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,S(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const n=this._value;return this._value=void 0,n&&R(n,null),n}}e.MutableDisposable=l;class c{constructor(n){this._disposable=n,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=c;class u{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,k(this)}set(n){let o=n;return this.unset=()=>o=void 0,this.isset=()=>o!==void 0,this.dispose=()=>{o&&(o(),o=void 0,S(this))},this}}e.SafeDisposable=u;class a{constructor(){this.references=new Map}acquire(n,...o){let m=this.references.get(n);m||(m={counter:0,object:this.createReferencedObject(n,...o)},this.references.set(n,m));const{object:h}=m,w=(0,f.once)(()=>{--m.counter==0&&(this.destroyReferencedObject(n,m.object),this.references.delete(n))});return m.counter++,{object:h,dispose:w}}}e.ReferenceCollection=a;class E{constructor(n){this.referenceCollection=n}async acquire(n,...o){const m=this.referenceCollection.acquire(n,...o);try{return{object:await m.object,dispose:()=>m.dispose()}}catch(h){throw m.dispose(),h}}}e.AsyncReferenceCollection=E;class s{constructor(n){this.object=n}dispose(){}}e.ImmortalReference=s;function t(r){const n=new P;try{r(n)}finally{n.dispose()}}e.disposeOnReturn=t}),define(ve[90],we([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class f{constructor(A){this.element=A,this.next=f.Undefined,this.prev=f.Undefined}}f.Undefined=new f(void 0);class i{constructor(){this._first=f.Undefined,this._last=f.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===f.Undefined}clear(){let A=this._first;for(;A!==f.Undefined;){const C=A.next;A.prev=f.Undefined,A.next=f.Undefined,A=C}this._first=f.Undefined,this._last=f.Undefined,this._size=0}unshift(A){return this._insert(A,!1)}push(A){return this._insert(A,!0)}_insert(A,C){const k=new f(A);if(this._first===f.Undefined)this._first=k,this._last=k;else if(C){const R=this._last;this._last=k,k.prev=R,R.next=k}else{const R=this._first;this._first=k,k.next=R,R.prev=k}this._size+=1;let S=!1;return()=>{S||(S=!0,this._remove(k))}}shift(){if(this._first!==f.Undefined){const A=this._first.element;return this._remove(this._first),A}}pop(){if(this._last!==f.Undefined){const A=this._last.element;return this._remove(this._last),A}}_remove(A){if(A.prev!==f.Undefined&&A.next!==f.Undefined){const C=A.prev;C.next=A.next,A.next.prev=C}else A.prev===f.Undefined&&A.next===f.Undefined?(this._first=f.Undefined,this._last=f.Undefined):A.next===f.Undefined?(this._last=this._last.prev,this._last.next=f.Undefined):A.prev===f.Undefined&&(this._first=this._first.next,this._first.prev=f.Undefined);this._size-=1}*[Symbol.iterator](){let A=this._first;for(;A!==f.Undefined;)yield A.element,A=A.next}}e.LinkedList=i}),function(te,e){typeof exports=="object"&&typeof module!="undefined"?e(exports):typeof define=="function"&&define.amd?define(ve[142],we([0]),e):(te=typeof globalThis!="undefined"?globalThis:te||self,e(te.marked={}))}(this,function(te){"use strict";function e(be,Ee){for(var z=0;z<Ee.length;z++){var B=Ee[z];B.enumerable=B.enumerable||!1,B.configurable=!0,"value"in B&&(B.writable=!0),Object.defineProperty(be,B.key,B)}}function f(be,Ee,z){return Ee&&e(be.prototype,Ee),z&&e(be,z),Object.defineProperty(be,"prototype",{writable:!1}),be}function i(be,Ee){if(!!be){if(typeof be=="string")return I(be,Ee);var z=Object.prototype.toString.call(be).slice(8,-1);if(z==="Object"&&be.constructor&&(z=be.constructor.name),z==="Map"||z==="Set")return Array.from(be);if(z==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(z))return I(be,Ee)}}function I(be,Ee){(Ee==null||Ee>be.length)&&(Ee=be.length);for(var z=0,B=new Array(Ee);z<Ee;z++)B[z]=be[z];return B}function A(be,Ee){var z=typeof Symbol!="undefined"&&be[Symbol.iterator]||be["@@iterator"];if(z)return(z=z.call(be)).next.bind(z);if(Array.isArray(be)||(z=i(be))||Ee&&be&&typeof be.length=="number"){z&&(be=z);var B=0;return function(){return B>=be.length?{done:!0}:{done:!1,value:be[B++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function C(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}te.defaults=C();function k(be){te.defaults=be}var S=/[&<>"']/,R=/[&<>"']/g,F=/[<>"']|&(?!#?\w+;)/,D=/[<>"']|&(?!#?\w+;)/g,v={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},b=function(Ee){return v[Ee]};function g(be,Ee){if(Ee){if(S.test(be))return be.replace(R,b)}else if(F.test(be))return be.replace(D,b);return be}var d=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function p(be){return be.replace(d,function(Ee,z){return z=z.toLowerCase(),z==="colon"?":":z.charAt(0)==="#"?z.charAt(1)==="x"?String.fromCharCode(parseInt(z.substring(2),16)):String.fromCharCode(+z.substring(1)):""})}var P=/(^|[^\[])\^/g;function _(be,Ee){be=be.source||be,Ee=Ee||"";var z={replace:function(N,W){return W=W.source||W,W=W.replace(P,"$1"),be=be.replace(N,W),z},getRegex:function(){return new RegExp(be,Ee)}};return z}var l=/[^\w:]/g,c=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function u(be,Ee,z){if(be){var B;try{B=decodeURIComponent(p(z)).replace(l,"").toLowerCase()}catch{return null}if(B.indexOf("javascript:")===0||B.indexOf("vbscript:")===0||B.indexOf("data:")===0)return null}Ee&&!c.test(z)&&(z=r(Ee,z));try{z=encodeURI(z).replace(/%25/g,"%")}catch{return null}return z}var a={},E=/^[^:]+:\/*[^/]*$/,s=/^([^:]+:)[\s\S]*$/,t=/^([^:]+:\/*[^/]*)[\s\S]*$/;function r(be,Ee){a[" "+be]||(E.test(be)?a[" "+be]=be+"/":a[" "+be]=h(be,"/",!0)),be=a[" "+be];var z=be.indexOf(":")===-1;return Ee.substring(0,2)==="//"?z?Ee:be.replace(s,"$1")+Ee:Ee.charAt(0)==="/"?z?Ee:be.replace(t,"$1")+Ee:be+Ee}var n={exec:function(){}};function o(be){for(var Ee=1,z,B;Ee<arguments.length;Ee++){z=arguments[Ee];for(B in z)Object.prototype.hasOwnProperty.call(z,B)&&(be[B]=z[B])}return be}function m(be,Ee){var z=be.replace(/\|/g,function(W,V,re){for(var he=!1,Ce=V;--Ce>=0&&re[Ce]==="\\";)he=!he;return he?"|":" |"}),B=z.split(/ \|/),N=0;if(B[0].trim()||B.shift(),B[B.length-1].trim()||B.pop(),B.length>Ee)B.splice(Ee);else for(;B.length<Ee;)B.push("");for(;N<B.length;N++)B[N]=B[N].trim().replace(/\\\|/g,"|");return B}function h(be,Ee,z){var B=be.length;if(B===0)return"";for(var N=0;N<B;){var W=be.charAt(B-N-1);if(W===Ee&&!z)N++;else if(W!==Ee&&z)N++;else break}return be.substr(0,B-N)}function w(be,Ee){if(be.indexOf(Ee[1])===-1)return-1;for(var z=be.length,B=0,N=0;N<z;N++)if(be[N]==="\\")N++;else if(be[N]===Ee[0])B++;else if(be[N]===Ee[1]&&(B--,B<0))return N;return-1}function T(be){be&&be.sanitize&&!be.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function L(be,Ee){if(Ee<1)return"";for(var z="";Ee>1;)Ee&1&&(z+=be),Ee>>=1,be+=be;return z+be}function O(be,Ee,z,B){var N=Ee.href,W=Ee.title?g(Ee.title):null,V=be[1].replace(/\\([\[\]])/g,"$1");if(be[0].charAt(0)!=="!"){B.state.inLink=!0;var re={type:"link",raw:z,href:N,title:W,text:V,tokens:B.inlineTokens(V,[])};return B.state.inLink=!1,re}else return{type:"image",raw:z,href:N,title:W,text:g(V)}}function y(be,Ee){var z=be.match(/^(\s+)(?:```)/);if(z===null)return Ee;var B=z[1];return Ee.split(`
`).map(function(N){var W=N.match(/^\s+/);if(W===null)return N;var V=W[0];return V.length>=B.length?N.slice(B.length):N}).join(`
`)}var H=function(){function be(z){this.options=z||te.defaults}var Ee=be.prototype;return Ee.space=function(B){var N=this.rules.block.newline.exec(B);if(N&&N[0].length>0)return{type:"space",raw:N[0]}},Ee.code=function(B){var N=this.rules.block.code.exec(B);if(N){var W=N[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:N[0],codeBlockStyle:"indented",text:this.options.pedantic?W:h(W,`
`)}}},Ee.fences=function(B){var N=this.rules.block.fences.exec(B);if(N){var W=N[0],V=y(W,N[3]||"");return{type:"code",raw:W,lang:N[2]?N[2].trim():N[2],text:V}}},Ee.heading=function(B){var N=this.rules.block.heading.exec(B);if(N){var W=N[2].trim();if(/#$/.test(W)){var V=h(W,"#");(this.options.pedantic||!V||/ $/.test(V))&&(W=V.trim())}var re={type:"heading",raw:N[0],depth:N[1].length,text:W,tokens:[]};return this.lexer.inline(re.text,re.tokens),re}},Ee.hr=function(B){var N=this.rules.block.hr.exec(B);if(N)return{type:"hr",raw:N[0]}},Ee.blockquote=function(B){var N=this.rules.block.blockquote.exec(B);if(N){var W=N[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:N[0],tokens:this.lexer.blockTokens(W,[]),text:W}}},Ee.list=function(B){var N=this.rules.block.list.exec(B);if(N){var W,V,re,he,Ce,Ae,We,ze,qe,He,Ue,Je,et=N[1].trim(),Le=et.length>1,it={type:"list",raw:"",ordered:Le,start:Le?+et.slice(0,-1):"",loose:!1,items:[]};et=Le?"\\d{1,9}\\"+et.slice(-1):"\\"+et,this.options.pedantic&&(et=Le?et:"[*+-]");for(var ne=new RegExp("^( {0,3}"+et+")((?: [^\\n]*)?(?:\\n|$))");B&&(Je=!1,!(!(N=ne.exec(B))||this.rules.block.hr.test(B)));){if(W=N[0],B=B.substring(W.length),ze=N[2].split(`
`,1)[0],qe=B.split(`
`,1)[0],this.options.pedantic?(he=2,Ue=ze.trimLeft()):(he=N[2].search(/[^ ]/),he=he>4?1:he,Ue=ze.slice(he),he+=N[1].length),Ae=!1,!ze&&/^ *$/.test(qe)&&(W+=qe+`
`,B=B.substring(qe.length+1),Je=!0),!Je)for(var ae=new RegExp("^ {0,"+Math.min(3,he-1)+"}(?:[*+-]|\\d{1,9}[.)])");B&&(He=B.split(`
`,1)[0],ze=He,this.options.pedantic&&(ze=ze.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!ae.test(ze));){if(ze.search(/[^ ]/)>=he||!ze.trim())Ue+=`
`+ze.slice(he);else if(!Ae)Ue+=`
`+ze;else break;!Ae&&!ze.trim()&&(Ae=!0),W+=He+`
`,B=B.substring(He.length+1)}it.loose||(We?it.loose=!0:/\n *\n *$/.test(W)&&(We=!0)),this.options.gfm&&(V=/^\[[ xX]\] /.exec(Ue),V&&(re=V[0]!=="[ ] ",Ue=Ue.replace(/^\[[ xX]\] +/,""))),it.items.push({type:"list_item",raw:W,task:!!V,checked:re,loose:!1,text:Ue}),it.raw+=W}it.items[it.items.length-1].raw=W.trimRight(),it.items[it.items.length-1].text=Ue.trimRight(),it.raw=it.raw.trimRight();var J=it.items.length;for(Ce=0;Ce<J;Ce++){this.lexer.state.top=!1,it.items[Ce].tokens=this.lexer.blockTokens(it.items[Ce].text,[]);var pe=it.items[Ce].tokens.filter(function(Me){return Me.type==="space"}),Se=pe.every(function(Me){for(var $e=Me.raw.split(""),Ye=0,lt=A($e),vt;!(vt=lt()).done;){var wt=vt.value;if(wt===`
`&&(Ye+=1),Ye>1)return!0}return!1});!it.loose&&pe.length&&Se&&(it.loose=!0,it.items[Ce].loose=!0)}return it}},Ee.html=function(B){var N=this.rules.block.html.exec(B);if(N){var W={type:"html",raw:N[0],pre:!this.options.sanitizer&&(N[1]==="pre"||N[1]==="script"||N[1]==="style"),text:N[0]};return this.options.sanitize&&(W.type="paragraph",W.text=this.options.sanitizer?this.options.sanitizer(N[0]):g(N[0]),W.tokens=[],this.lexer.inline(W.text,W.tokens)),W}},Ee.def=function(B){var N=this.rules.block.def.exec(B);if(N){N[3]&&(N[3]=N[3].substring(1,N[3].length-1));var W=N[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:W,raw:N[0],href:N[2],title:N[3]}}},Ee.table=function(B){var N=this.rules.block.table.exec(B);if(N){var W={type:"table",header:m(N[1]).map(function(We){return{text:We}}),align:N[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:N[3]?N[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(W.header.length===W.align.length){W.raw=N[0];var V=W.align.length,re,he,Ce,Ae;for(re=0;re<V;re++)/^ *-+: *$/.test(W.align[re])?W.align[re]="right":/^ *:-+: *$/.test(W.align[re])?W.align[re]="center":/^ *:-+ *$/.test(W.align[re])?W.align[re]="left":W.align[re]=null;for(V=W.rows.length,re=0;re<V;re++)W.rows[re]=m(W.rows[re],W.header.length).map(function(We){return{text:We}});for(V=W.header.length,he=0;he<V;he++)W.header[he].tokens=[],this.lexer.inlineTokens(W.header[he].text,W.header[he].tokens);for(V=W.rows.length,he=0;he<V;he++)for(Ae=W.rows[he],Ce=0;Ce<Ae.length;Ce++)Ae[Ce].tokens=[],this.lexer.inlineTokens(Ae[Ce].text,Ae[Ce].tokens);return W}}},Ee.lheading=function(B){var N=this.rules.block.lheading.exec(B);if(N){var W={type:"heading",raw:N[0],depth:N[2].charAt(0)==="="?1:2,text:N[1],tokens:[]};return this.lexer.inline(W.text,W.tokens),W}},Ee.paragraph=function(B){var N=this.rules.block.paragraph.exec(B);if(N){var W={type:"paragraph",raw:N[0],text:N[1].charAt(N[1].length-1)===`
`?N[1].slice(0,-1):N[1],tokens:[]};return this.lexer.inline(W.text,W.tokens),W}},Ee.text=function(B){var N=this.rules.block.text.exec(B);if(N){var W={type:"text",raw:N[0],text:N[0],tokens:[]};return this.lexer.inline(W.text,W.tokens),W}},Ee.escape=function(B){var N=this.rules.inline.escape.exec(B);if(N)return{type:"escape",raw:N[0],text:g(N[1])}},Ee.tag=function(B){var N=this.rules.inline.tag.exec(B);if(N)return!this.lexer.state.inLink&&/^<a /i.test(N[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(N[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(N[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(N[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:N[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(N[0]):g(N[0]):N[0]}},Ee.link=function(B){var N=this.rules.inline.link.exec(B);if(N){var W=N[2].trim();if(!this.options.pedantic&&/^</.test(W)){if(!/>$/.test(W))return;var V=h(W.slice(0,-1),"\\");if((W.length-V.length)%2==0)return}else{var re=w(N[2],"()");if(re>-1){var he=N[0].indexOf("!")===0?5:4,Ce=he+N[1].length+re;N[2]=N[2].substring(0,re),N[0]=N[0].substring(0,Ce).trim(),N[3]=""}}var Ae=N[2],We="";if(this.options.pedantic){var ze=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ae);ze&&(Ae=ze[1],We=ze[3])}else We=N[3]?N[3].slice(1,-1):"";return Ae=Ae.trim(),/^</.test(Ae)&&(this.options.pedantic&&!/>$/.test(W)?Ae=Ae.slice(1):Ae=Ae.slice(1,-1)),O(N,{href:Ae&&Ae.replace(this.rules.inline._escapes,"$1"),title:We&&We.replace(this.rules.inline._escapes,"$1")},N[0],this.lexer)}},Ee.reflink=function(B,N){var W;if((W=this.rules.inline.reflink.exec(B))||(W=this.rules.inline.nolink.exec(B))){var V=(W[2]||W[1]).replace(/\s+/g," ");if(V=N[V.toLowerCase()],!V||!V.href){var re=W[0].charAt(0);return{type:"text",raw:re,text:re}}return O(W,V,W[0],this.lexer)}},Ee.emStrong=function(B,N,W){W===void 0&&(W="");var V=this.rules.inline.emStrong.lDelim.exec(B);if(!!V&&!(V[3]&&W.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var re=V[1]||V[2]||"";if(!re||re&&(W===""||this.rules.inline.punctuation.exec(W))){var he=V[0].length-1,Ce,Ae,We=he,ze=0,qe=V[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(qe.lastIndex=0,N=N.slice(-1*B.length+he);(V=qe.exec(N))!=null;)if(Ce=V[1]||V[2]||V[3]||V[4]||V[5]||V[6],!!Ce){if(Ae=Ce.length,V[3]||V[4]){We+=Ae;continue}else if((V[5]||V[6])&&he%3&&!((he+Ae)%3)){ze+=Ae;continue}if(We-=Ae,!(We>0)){if(Ae=Math.min(Ae,Ae+We+ze),Math.min(he,Ae)%2){var He=B.slice(1,he+V.index+Ae);return{type:"em",raw:B.slice(0,he+V.index+Ae+1),text:He,tokens:this.lexer.inlineTokens(He,[])}}var Ue=B.slice(2,he+V.index+Ae-1);return{type:"strong",raw:B.slice(0,he+V.index+Ae+1),text:Ue,tokens:this.lexer.inlineTokens(Ue,[])}}}}}},Ee.codespan=function(B){var N=this.rules.inline.code.exec(B);if(N){var W=N[2].replace(/\n/g," "),V=/[^ ]/.test(W),re=/^ /.test(W)&&/ $/.test(W);return V&&re&&(W=W.substring(1,W.length-1)),W=g(W,!0),{type:"codespan",raw:N[0],text:W}}},Ee.br=function(B){var N=this.rules.inline.br.exec(B);if(N)return{type:"br",raw:N[0]}},Ee.del=function(B){var N=this.rules.inline.del.exec(B);if(N)return{type:"del",raw:N[0],text:N[2],tokens:this.lexer.inlineTokens(N[2],[])}},Ee.autolink=function(B,N){var W=this.rules.inline.autolink.exec(B);if(W){var V,re;return W[2]==="@"?(V=g(this.options.mangle?N(W[1]):W[1]),re="mailto:"+V):(V=g(W[1]),re=V),{type:"link",raw:W[0],text:V,href:re,tokens:[{type:"text",raw:V,text:V}]}}},Ee.url=function(B,N){var W;if(W=this.rules.inline.url.exec(B)){var V,re;if(W[2]==="@")V=g(this.options.mangle?N(W[0]):W[0]),re="mailto:"+V;else{var he;do he=W[0],W[0]=this.rules.inline._backpedal.exec(W[0])[0];while(he!==W[0]);V=g(W[0]),W[1]==="www."?re="http://"+V:re=V}return{type:"link",raw:W[0],text:V,href:re,tokens:[{type:"text",raw:V,text:V}]}}},Ee.inlineText=function(B,N){var W=this.rules.inline.text.exec(B);if(W){var V;return this.lexer.state.inRawBlock?V=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(W[0]):g(W[0]):W[0]:V=g(this.options.smartypants?N(W[0]):W[0]),{type:"text",raw:W[0],text:V}}},be}(),M={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:n,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};M._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,M._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,M.def=_(M.def).replace("label",M._label).replace("title",M._title).getRegex(),M.bullet=/(?:[*+-]|\d{1,9}[.)])/,M.listItemStart=_(/^( *)(bull) */).replace("bull",M.bullet).getRegex(),M.list=_(M.list).replace(/bull/g,M.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+M.def.source+")").getRegex(),M._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",M._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,M.html=_(M.html,"i").replace("comment",M._comment).replace("tag",M._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),M.paragraph=_(M._paragraph).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.blockquote=_(M.blockquote).replace("paragraph",M.paragraph).getRegex(),M.normal=o({},M),M.gfm=o({},M.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),M.gfm.table=_(M.gfm.table).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.gfm.paragraph=_(M._paragraph).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",M.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.pedantic=o({},M.normal,{html:_(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",M._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:n,paragraph:_(M.normal._paragraph).replace("hr",M.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",M.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var j={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:n,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:n,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};j._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",j.punctuation=_(j.punctuation).replace(/punctuation/g,j._punctuation).getRegex(),j.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,j.escapedEmSt=/\\\*|\\_/g,j._comment=_(M._comment).replace("(?:-->|$)","-->").getRegex(),j.emStrong.lDelim=_(j.emStrong.lDelim).replace(/punct/g,j._punctuation).getRegex(),j.emStrong.rDelimAst=_(j.emStrong.rDelimAst,"g").replace(/punct/g,j._punctuation).getRegex(),j.emStrong.rDelimUnd=_(j.emStrong.rDelimUnd,"g").replace(/punct/g,j._punctuation).getRegex(),j._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,j._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,j._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,j.autolink=_(j.autolink).replace("scheme",j._scheme).replace("email",j._email).getRegex(),j._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,j.tag=_(j.tag).replace("comment",j._comment).replace("attribute",j._attribute).getRegex(),j._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,j._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,j._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,j.link=_(j.link).replace("label",j._label).replace("href",j._href).replace("title",j._title).getRegex(),j.reflink=_(j.reflink).replace("label",j._label).replace("ref",M._label).getRegex(),j.nolink=_(j.nolink).replace("ref",M._label).getRegex(),j.reflinkSearch=_(j.reflinkSearch,"g").replace("reflink",j.reflink).replace("nolink",j.nolink).getRegex(),j.normal=o({},j),j.pedantic=o({},j.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:_(/^!?\[(label)\]\((.*?)\)/).replace("label",j._label).getRegex(),reflink:_(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",j._label).getRegex()}),j.gfm=o({},j.normal,{escape:_(j.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),j.gfm.url=_(j.gfm.url,"i").replace("email",j.gfm._extended_email).getRegex(),j.breaks=o({},j.gfm,{br:_(j.br).replace("{2,}","*").getRegex(),text:_(j.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function X(be){return be.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function $(be){var Ee="",z,B,N=be.length;for(z=0;z<N;z++)B=be.charCodeAt(z),Math.random()>.5&&(B="x"+B.toString(16)),Ee+="&#"+B+";";return Ee}var U=function(){function be(z){this.tokens=[],this.tokens.links=Object.create(null),this.options=z||te.defaults,this.options.tokenizer=this.options.tokenizer||new H,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var B={block:M.normal,inline:j.normal};this.options.pedantic?(B.block=M.pedantic,B.inline=j.pedantic):this.options.gfm&&(B.block=M.gfm,this.options.breaks?B.inline=j.breaks:B.inline=j.gfm),this.tokenizer.rules=B}be.lex=function(B,N){var W=new be(N);return W.lex(B)},be.lexInline=function(B,N){var W=new be(N);return W.inlineTokens(B)};var Ee=be.prototype;return Ee.lex=function(B){B=B.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(B,this.tokens);for(var N;N=this.inlineQueue.shift();)this.inlineTokens(N.src,N.tokens);return this.tokens},Ee.blockTokens=function(B,N){var W=this;N===void 0&&(N=[]),this.options.pedantic&&(B=B.replace(/^ +$/gm,""));for(var V,re,he,Ce;B;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(We){return(V=We.call({lexer:W},B,N))?(B=B.substring(V.raw.length),N.push(V),!0):!1}))){if(V=this.tokenizer.space(B)){B=B.substring(V.raw.length),V.raw.length===1&&N.length>0?N[N.length-1].raw+=`
`:N.push(V);continue}if(V=this.tokenizer.code(B)){B=B.substring(V.raw.length),re=N[N.length-1],re&&(re.type==="paragraph"||re.type==="text")?(re.raw+=`
`+V.raw,re.text+=`
`+V.text,this.inlineQueue[this.inlineQueue.length-1].src=re.text):N.push(V);continue}if(V=this.tokenizer.fences(B)){B=B.substring(V.raw.length),N.push(V);continue}if(V=this.tokenizer.heading(B)){B=B.substring(V.raw.length),N.push(V);continue}if(V=this.tokenizer.hr(B)){B=B.substring(V.raw.length),N.push(V);continue}if(V=this.tokenizer.blockquote(B)){B=B.substring(V.raw.length),N.push(V);continue}if(V=this.tokenizer.list(B)){B=B.substring(V.raw.length),N.push(V);continue}if(V=this.tokenizer.html(B)){B=B.substring(V.raw.length),N.push(V);continue}if(V=this.tokenizer.def(B)){B=B.substring(V.raw.length),re=N[N.length-1],re&&(re.type==="paragraph"||re.type==="text")?(re.raw+=`
`+V.raw,re.text+=`
`+V.raw,this.inlineQueue[this.inlineQueue.length-1].src=re.text):this.tokens.links[V.tag]||(this.tokens.links[V.tag]={href:V.href,title:V.title});continue}if(V=this.tokenizer.table(B)){B=B.substring(V.raw.length),N.push(V);continue}if(V=this.tokenizer.lheading(B)){B=B.substring(V.raw.length),N.push(V);continue}if(he=B,this.options.extensions&&this.options.extensions.startBlock&&function(){var We=1/0,ze=B.slice(1),qe=void 0;W.options.extensions.startBlock.forEach(function(He){qe=He.call({lexer:this},ze),typeof qe=="number"&&qe>=0&&(We=Math.min(We,qe))}),We<1/0&&We>=0&&(he=B.substring(0,We+1))}(),this.state.top&&(V=this.tokenizer.paragraph(he))){re=N[N.length-1],Ce&&re.type==="paragraph"?(re.raw+=`
`+V.raw,re.text+=`
`+V.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=re.text):N.push(V),Ce=he.length!==B.length,B=B.substring(V.raw.length);continue}if(V=this.tokenizer.text(B)){B=B.substring(V.raw.length),re=N[N.length-1],re&&re.type==="text"?(re.raw+=`
`+V.raw,re.text+=`
`+V.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=re.text):N.push(V);continue}if(B){var Ae="Infinite loop on byte: "+B.charCodeAt(0);if(this.options.silent){console.error(Ae);break}else throw new Error(Ae)}}return this.state.top=!0,N},Ee.inline=function(B,N){this.inlineQueue.push({src:B,tokens:N})},Ee.inlineTokens=function(B,N){var W=this;N===void 0&&(N=[]);var V,re,he,Ce=B,Ae,We,ze;if(this.tokens.links){var qe=Object.keys(this.tokens.links);if(qe.length>0)for(;(Ae=this.tokenizer.rules.inline.reflinkSearch.exec(Ce))!=null;)qe.includes(Ae[0].slice(Ae[0].lastIndexOf("[")+1,-1))&&(Ce=Ce.slice(0,Ae.index)+"["+L("a",Ae[0].length-2)+"]"+Ce.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ae=this.tokenizer.rules.inline.blockSkip.exec(Ce))!=null;)Ce=Ce.slice(0,Ae.index)+"["+L("a",Ae[0].length-2)+"]"+Ce.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ae=this.tokenizer.rules.inline.escapedEmSt.exec(Ce))!=null;)Ce=Ce.slice(0,Ae.index)+"++"+Ce.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;B;)if(We||(ze=""),We=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Ue){return(V=Ue.call({lexer:W},B,N))?(B=B.substring(V.raw.length),N.push(V),!0):!1}))){if(V=this.tokenizer.escape(B)){B=B.substring(V.raw.length),N.push(V);continue}if(V=this.tokenizer.tag(B)){B=B.substring(V.raw.length),re=N[N.length-1],re&&V.type==="text"&&re.type==="text"?(re.raw+=V.raw,re.text+=V.text):N.push(V);continue}if(V=this.tokenizer.link(B)){B=B.substring(V.raw.length),N.push(V);continue}if(V=this.tokenizer.reflink(B,this.tokens.links)){B=B.substring(V.raw.length),re=N[N.length-1],re&&V.type==="text"&&re.type==="text"?(re.raw+=V.raw,re.text+=V.text):N.push(V);continue}if(V=this.tokenizer.emStrong(B,Ce,ze)){B=B.substring(V.raw.length),N.push(V);continue}if(V=this.tokenizer.codespan(B)){B=B.substring(V.raw.length),N.push(V);continue}if(V=this.tokenizer.br(B)){B=B.substring(V.raw.length),N.push(V);continue}if(V=this.tokenizer.del(B)){B=B.substring(V.raw.length),N.push(V);continue}if(V=this.tokenizer.autolink(B,$)){B=B.substring(V.raw.length),N.push(V);continue}if(!this.state.inLink&&(V=this.tokenizer.url(B,$))){B=B.substring(V.raw.length),N.push(V);continue}if(he=B,this.options.extensions&&this.options.extensions.startInline&&function(){var Ue=1/0,Je=B.slice(1),et=void 0;W.options.extensions.startInline.forEach(function(Le){et=Le.call({lexer:this},Je),typeof et=="number"&&et>=0&&(Ue=Math.min(Ue,et))}),Ue<1/0&&Ue>=0&&(he=B.substring(0,Ue+1))}(),V=this.tokenizer.inlineText(he,X)){B=B.substring(V.raw.length),V.raw.slice(-1)!=="_"&&(ze=V.raw.slice(-1)),We=!0,re=N[N.length-1],re&&re.type==="text"?(re.raw+=V.raw,re.text+=V.text):N.push(V);continue}if(B){var He="Infinite loop on byte: "+B.charCodeAt(0);if(this.options.silent){console.error(He);break}else throw new Error(He)}}return N},f(be,null,[{key:"rules",get:function(){return{block:M,inline:j}}}]),be}(),q=function(){function be(z){this.options=z||te.defaults}var Ee=be.prototype;return Ee.code=function(B,N,W){var V=(N||"").match(/\S*/)[0];if(this.options.highlight){var re=this.options.highlight(B,V);re!=null&&re!==B&&(W=!0,B=re)}return B=B.replace(/\n$/,"")+`
`,V?'<pre><code class="'+this.options.langPrefix+g(V,!0)+'">'+(W?B:g(B,!0))+`</code></pre>
`:"<pre><code>"+(W?B:g(B,!0))+`</code></pre>
`},Ee.blockquote=function(B){return`<blockquote>
`+B+`</blockquote>
`},Ee.html=function(B){return B},Ee.heading=function(B,N,W,V){return this.options.headerIds?"<h"+N+' id="'+this.options.headerPrefix+V.slug(W)+'">'+B+"</h"+N+`>
`:"<h"+N+">"+B+"</h"+N+`>
`},Ee.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Ee.list=function(B,N,W){var V=N?"ol":"ul",re=N&&W!==1?' start="'+W+'"':"";return"<"+V+re+`>
`+B+"</"+V+`>
`},Ee.listitem=function(B){return"<li>"+B+`</li>
`},Ee.checkbox=function(B){return"<input "+(B?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Ee.paragraph=function(B){return"<p>"+B+`</p>
`},Ee.table=function(B,N){return N&&(N="<tbody>"+N+"</tbody>"),`<table>
<thead>
`+B+`</thead>
`+N+`</table>
`},Ee.tablerow=function(B){return`<tr>
`+B+`</tr>
`},Ee.tablecell=function(B,N){var W=N.header?"th":"td",V=N.align?"<"+W+' align="'+N.align+'">':"<"+W+">";return V+B+"</"+W+`>
`},Ee.strong=function(B){return"<strong>"+B+"</strong>"},Ee.em=function(B){return"<em>"+B+"</em>"},Ee.codespan=function(B){return"<code>"+B+"</code>"},Ee.br=function(){return this.options.xhtml?"<br/>":"<br>"},Ee.del=function(B){return"<del>"+B+"</del>"},Ee.link=function(B,N,W){if(B=u(this.options.sanitize,this.options.baseUrl,B),B===null)return W;var V='<a href="'+g(B)+'"';return N&&(V+=' title="'+N+'"'),V+=">"+W+"</a>",V},Ee.image=function(B,N,W){if(B=u(this.options.sanitize,this.options.baseUrl,B),B===null)return W;var V='<img src="'+B+'" alt="'+W+'"';return N&&(V+=' title="'+N+'"'),V+=this.options.xhtml?"/>":">",V},Ee.text=function(B){return B},be}(),K=function(){function be(){}var Ee=be.prototype;return Ee.strong=function(B){return B},Ee.em=function(B){return B},Ee.codespan=function(B){return B},Ee.del=function(B){return B},Ee.html=function(B){return B},Ee.text=function(B){return B},Ee.link=function(B,N,W){return""+W},Ee.image=function(B,N,W){return""+W},Ee.br=function(){return""},be}(),G=function(){function be(){this.seen={}}var Ee=be.prototype;return Ee.serialize=function(B){return B.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Ee.getNextSafeSlug=function(B,N){var W=B,V=0;if(this.seen.hasOwnProperty(W)){V=this.seen[B];do V++,W=B+"-"+V;while(this.seen.hasOwnProperty(W))}return N||(this.seen[B]=V,this.seen[W]=0),W},Ee.slug=function(B,N){N===void 0&&(N={});var W=this.serialize(B);return this.getNextSafeSlug(W,N.dryrun)},be}(),ee=function(){function be(z){this.options=z||te.defaults,this.options.renderer=this.options.renderer||new q,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new K,this.slugger=new G}be.parse=function(B,N){var W=new be(N);return W.parse(B)},be.parseInline=function(B,N){var W=new be(N);return W.parseInline(B)};var Ee=be.prototype;return Ee.parse=function(B,N){N===void 0&&(N=!0);var W="",V,re,he,Ce,Ae,We,ze,qe,He,Ue,Je,et,Le,it,ne,ae,J,pe,Se,Me=B.length;for(V=0;V<Me;V++){if(Ue=B[V],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ue.type]&&(Se=this.options.extensions.renderers[Ue.type].call({parser:this},Ue),Se!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Ue.type))){W+=Se||"";continue}switch(Ue.type){case"space":continue;case"hr":{W+=this.renderer.hr();continue}case"heading":{W+=this.renderer.heading(this.parseInline(Ue.tokens),Ue.depth,p(this.parseInline(Ue.tokens,this.textRenderer)),this.slugger);continue}case"code":{W+=this.renderer.code(Ue.text,Ue.lang,Ue.escaped);continue}case"table":{for(qe="",ze="",Ce=Ue.header.length,re=0;re<Ce;re++)ze+=this.renderer.tablecell(this.parseInline(Ue.header[re].tokens),{header:!0,align:Ue.align[re]});for(qe+=this.renderer.tablerow(ze),He="",Ce=Ue.rows.length,re=0;re<Ce;re++){for(We=Ue.rows[re],ze="",Ae=We.length,he=0;he<Ae;he++)ze+=this.renderer.tablecell(this.parseInline(We[he].tokens),{header:!1,align:Ue.align[he]});He+=this.renderer.tablerow(ze)}W+=this.renderer.table(qe,He);continue}case"blockquote":{He=this.parse(Ue.tokens),W+=this.renderer.blockquote(He);continue}case"list":{for(Je=Ue.ordered,et=Ue.start,Le=Ue.loose,Ce=Ue.items.length,He="",re=0;re<Ce;re++)ne=Ue.items[re],ae=ne.checked,J=ne.task,it="",ne.task&&(pe=this.renderer.checkbox(ae),Le?ne.tokens.length>0&&ne.tokens[0].type==="paragraph"?(ne.tokens[0].text=pe+" "+ne.tokens[0].text,ne.tokens[0].tokens&&ne.tokens[0].tokens.length>0&&ne.tokens[0].tokens[0].type==="text"&&(ne.tokens[0].tokens[0].text=pe+" "+ne.tokens[0].tokens[0].text)):ne.tokens.unshift({type:"text",text:pe}):it+=pe),it+=this.parse(ne.tokens,Le),He+=this.renderer.listitem(it,J,ae);W+=this.renderer.list(He,Je,et);continue}case"html":{W+=this.renderer.html(Ue.text);continue}case"paragraph":{W+=this.renderer.paragraph(this.parseInline(Ue.tokens));continue}case"text":{for(He=Ue.tokens?this.parseInline(Ue.tokens):Ue.text;V+1<Me&&B[V+1].type==="text";)Ue=B[++V],He+=`
`+(Ue.tokens?this.parseInline(Ue.tokens):Ue.text);W+=N?this.renderer.paragraph(He):He;continue}default:{var $e='Token with "'+Ue.type+'" type was not found.';if(this.options.silent){console.error($e);return}else throw new Error($e)}}}return W},Ee.parseInline=function(B,N){N=N||this.renderer;var W="",V,re,he,Ce=B.length;for(V=0;V<Ce;V++){if(re=B[V],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[re.type]&&(he=this.options.extensions.renderers[re.type].call({parser:this},re),he!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(re.type))){W+=he||"";continue}switch(re.type){case"escape":{W+=N.text(re.text);break}case"html":{W+=N.html(re.text);break}case"link":{W+=N.link(re.href,re.title,this.parseInline(re.tokens,N));break}case"image":{W+=N.image(re.href,re.title,re.text);break}case"strong":{W+=N.strong(this.parseInline(re.tokens,N));break}case"em":{W+=N.em(this.parseInline(re.tokens,N));break}case"codespan":{W+=N.codespan(re.text);break}case"br":{W+=N.br();break}case"del":{W+=N.del(this.parseInline(re.tokens,N));break}case"text":{W+=N.text(re.text);break}default:{var Ae='Token with "'+re.type+'" type was not found.';if(this.options.silent){console.error(Ae);return}else throw new Error(Ae)}}}return W},be}();function oe(be,Ee,z){if(typeof be=="undefined"||be===null)throw new Error("marked(): input parameter is undefined or null");if(typeof be!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(be)+", string expected");if(typeof Ee=="function"&&(z=Ee,Ee=null),Ee=o({},oe.defaults,Ee||{}),T(Ee),z){var B=Ee.highlight,N;try{N=U.lex(be,Ee)}catch(he){return z(he)}var W=function(Ce){var Ae;if(!Ce)try{Ee.walkTokens&&oe.walkTokens(N,Ee.walkTokens),Ae=ee.parse(N,Ee)}catch(We){Ce=We}return Ee.highlight=B,Ce?z(Ce):z(null,Ae)};if(!B||B.length<3||(delete Ee.highlight,!N.length))return W();var V=0;oe.walkTokens(N,function(he){he.type==="code"&&(V++,setTimeout(function(){B(he.text,he.lang,function(Ce,Ae){if(Ce)return W(Ce);Ae!=null&&Ae!==he.text&&(he.text=Ae,he.escaped=!0),V--,V===0&&W()})},0))}),V===0&&W();return}try{var re=U.lex(be,Ee);return Ee.walkTokens&&oe.walkTokens(re,Ee.walkTokens),ee.parse(re,Ee)}catch(he){if(he.message+=`
Please report this to https://github.com/markedjs/marked.`,Ee.silent)return"<p>An error occurred:</p><pre>"+g(he.message+"",!0)+"</pre>";throw he}}oe.options=oe.setOptions=function(be){return o(oe.defaults,be),k(oe.defaults),oe},oe.getDefaults=C,oe.defaults=te.defaults,oe.use=function(){for(var be=arguments.length,Ee=new Array(be),z=0;z<be;z++)Ee[z]=arguments[z];var B=o.apply(void 0,[{}].concat(Ee)),N=oe.defaults.extensions||{renderers:{},childTokens:{}},W;Ee.forEach(function(V){if(V.extensions&&(W=!0,V.extensions.forEach(function(he){if(!he.name)throw new Error("extension name required");if(he.renderer){var Ce=N.renderers?N.renderers[he.name]:null;Ce?N.renderers[he.name]=function(){for(var Ae=arguments.length,We=new Array(Ae),ze=0;ze<Ae;ze++)We[ze]=arguments[ze];var qe=he.renderer.apply(this,We);return qe===!1&&(qe=Ce.apply(this,We)),qe}:N.renderers[he.name]=he.renderer}if(he.tokenizer){if(!he.level||he.level!=="block"&&he.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");N[he.level]?N[he.level].unshift(he.tokenizer):N[he.level]=[he.tokenizer],he.start&&(he.level==="block"?N.startBlock?N.startBlock.push(he.start):N.startBlock=[he.start]:he.level==="inline"&&(N.startInline?N.startInline.push(he.start):N.startInline=[he.start]))}he.childTokens&&(N.childTokens[he.name]=he.childTokens)})),V.renderer&&function(){var he=oe.defaults.renderer||new q,Ce=function(ze){var qe=he[ze];he[ze]=function(){for(var He=arguments.length,Ue=new Array(He),Je=0;Je<He;Je++)Ue[Je]=arguments[Je];var et=V.renderer[ze].apply(he,Ue);return et===!1&&(et=qe.apply(he,Ue)),et}};for(var Ae in V.renderer)Ce(Ae);B.renderer=he}(),V.tokenizer&&function(){var he=oe.defaults.tokenizer||new H,Ce=function(ze){var qe=he[ze];he[ze]=function(){for(var He=arguments.length,Ue=new Array(He),Je=0;Je<He;Je++)Ue[Je]=arguments[Je];var et=V.tokenizer[ze].apply(he,Ue);return et===!1&&(et=qe.apply(he,Ue)),et}};for(var Ae in V.tokenizer)Ce(Ae);B.tokenizer=he}(),V.walkTokens){var re=oe.defaults.walkTokens;B.walkTokens=function(he){V.walkTokens.call(this,he),re&&re.call(this,he)}}W&&(B.extensions=N),oe.setOptions(B)})},oe.walkTokens=function(be,Ee){for(var z=function(){var V=N.value;switch(Ee.call(oe,V),V.type){case"table":{for(var re=A(V.header),he;!(he=re()).done;){var Ce=he.value;oe.walkTokens(Ce.tokens,Ee)}for(var Ae=A(V.rows),We;!(We=Ae()).done;)for(var ze=We.value,qe=A(ze),He;!(He=qe()).done;){var Ue=He.value;oe.walkTokens(Ue.tokens,Ee)}break}case"list":{oe.walkTokens(V.items,Ee);break}default:oe.defaults.extensions&&oe.defaults.extensions.childTokens&&oe.defaults.extensions.childTokens[V.type]?oe.defaults.extensions.childTokens[V.type].forEach(function(Je){oe.walkTokens(V[Je],Ee)}):V.tokens&&oe.walkTokens(V.tokens,Ee)}},B=A(be),N;!(N=B()).done;)z()},oe.parseInline=function(be,Ee){if(typeof be=="undefined"||be===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof be!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(be)+", string expected");Ee=o({},oe.defaults,Ee||{}),T(Ee);try{var z=U.lexInline(be,Ee);return Ee.walkTokens&&oe.walkTokens(z,Ee.walkTokens),ee.parseInline(z,Ee)}catch(B){if(B.message+=`
Please report this to https://github.com/markedjs/marked.`,Ee.silent)return"<p>An error occurred:</p><pre>"+g(B.message+"",!0)+"</pre>";throw B}},oe.Parser=ee,oe.parser=ee.parse,oe.Renderer=q,oe.TextRenderer=K,oe.Lexer=U,oe.lexer=U.lex,oe.Tokenizer=H,oe.Slugger=G,oe.parse=oe;var ue=oe.options,Z=oe.setOptions,Y=oe.use,se=oe.walkTokens,de=oe.parseInline,ge=oe,Te=ee.parse,Ne=U.lex;te.Lexer=U,te.Parser=ee,te.Renderer=q,te.Slugger=G,te.TextRenderer=K,te.Tokenizer=H,te.getDefaults=C,te.lexer=Ne,te.marked=oe,te.options=ue,te.parse=ge,te.parseInline=de,te.parser=Te,te.setOptions=Z,te.use=Y,te.walkTokens=se,Object.defineProperty(te,"__esModule",{value:!0})}),define(ve[91],we([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function f(k,S,R){return Math.min(Math.max(k,S),R)}e.clamp=f;function i(k,S){return(S+k%S)%S}e.rot=i;class I{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=I;class A{constructor(){this._n=1,this._val=0}update(S){return this._val=this._val+(S-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=A;class C{constructor(S){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(S),this._values.fill(0,0,S)}update(S){const R=this._values[this._index];return this._values[this._index]=S,this._index=(this._index+1)%this._values.length,this._sum-=R,this._sum+=S,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=C}),function(){function te(I){const A=[];typeof I=="number"&&A.push("code/timeOrigin",I);function C(S){A.push(S,Date.now())}function k(){const S=[];for(let R=0;R<A.length;R+=2)S.push({name:A[R],startTime:A[R+1]});return S}return{mark:C,getMarks:k}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?te():{mark(I){performance.mark(I)},getMarks(){let I=performance.timeOrigin;typeof I!="number"&&(I=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(I)}];for(const C of performance.getEntriesByType("mark"))A.push({name:C.name,startTime:Math.round(I+C.startTime)});return A}};if(typeof process=="object"){const I=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return te(I)}else return console.trace("perf-util loaded in UNKNOWN environment"),te()}function f(I){return I.MonacoPerformanceMarks||(I.MonacoPerformanceMarks=e()),I.MonacoPerformanceMarks}var i;typeof global=="object"?i=global:typeof self=="object"?i=self:i={},typeof define=="function"?define("vs/base/common/performance",[],function(){return f(i)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=f(i):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),i.perf=f(i))}(),define(ve[12],we([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const f="en";let i=!1,I=!1,A=!1,C=!1,k=!1,S=!1,R=!1,F=!1,D=!1,v,b=f,g,d;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let p;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?p=e.globals.vscode.process:typeof process!="undefined"&&(p=process);const P=typeof p?.versions?.electron=="string",_=P&&p?.type==="renderer";if(e.isElectronSandboxed=_&&p?.sandboxed,typeof navigator=="object"&&!_)d=navigator.userAgent,i=d.indexOf("Windows")>=0,I=d.indexOf("Macintosh")>=0,F=(d.indexOf("Macintosh")>=0||d.indexOf("iPad")>=0||d.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=d.indexOf("Linux")>=0,S=!0,v=navigator.language,b=v;else if(typeof p=="object"){i=p.platform==="win32",I=p.platform==="darwin",A=p.platform==="linux",C=A&&!!p.env.SNAP&&!!p.env.SNAP_REVISION,R=P,D=!!p.env.CI||!!p.env.BUILD_ARTIFACTSTAGINGDIRECTORY,v=f,b=f;const n=p.env.VSCODE_NLS_CONFIG;if(n)try{const o=JSON.parse(n),m=o.availableLanguages["*"];v=o.locale,b=m||f,g=o._translationsConfigFile}catch{}k=!0}else console.error("Unable to resolve platform.");var l;(function(n){n[n.Web=0]="Web",n[n.Mac=1]="Mac",n[n.Linux=2]="Linux",n[n.Windows=3]="Windows"})(l=e.Platform||(e.Platform={}));function c(n){switch(n){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=c;let u=0;I?u=1:i?u=3:A&&(u=2),e.isWindows=i,e.isMacintosh=I,e.isLinux=A,e.isLinuxSnap=C,e.isNative=k,e.isElectron=R,e.isWeb=S,e.isWebWorker=S&&typeof e.globals.importScripts=="function",e.isIOS=F,e.isCI=D,e.platform=u,e.userAgent=d,e.language=b;var a;(function(n){function o(){return e.language}n.value=o;function m(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}n.isDefaultVariant=m;function h(){return e.language==="en"}n.isDefault=h})(a=e.Language||(e.Language={})),e.locale=v,e.translationsConfigFile=g,e.setTimeout0=(()=>{if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let n=[];e.globals.addEventListener("message",m=>{if(m.data&&m.data.vscodeScheduleAsyncWork)for(let h=0,w=n.length;h<w;h++){const T=n[h];if(T.id===m.data.vscodeScheduleAsyncWork){n.splice(h,1),T.callback();return}}});let o=0;return m=>{const h=++o;n.push({id:h,callback:m}),e.globals.postMessage({vscodeScheduleAsyncWork:h},"*")}}return n=>setTimeout(n)})();var E;(function(n){n[n.Windows=1]="Windows",n[n.Macintosh=2]="Macintosh",n[n.Linux=3]="Linux"})(E=e.OperatingSystem||(e.OperatingSystem={})),e.OS=I||F?2:i?1:3;let s=!0,t=!1;function r(){if(!t){t=!0;const n=new Uint8Array(2);n[0]=1,n[1]=2,s=new Uint16Array(n.buffer)[0]===(2<<8)+1}return s}e.isLittleEndian=r,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ve[41],we([1,0,12]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let i;if(typeof f.globals.vscode!="undefined"&&typeof f.globals.vscode.process!="undefined"){const I=f.globals.vscode.process;i={get platform(){return I.platform},get arch(){return I.arch},get env(){return I.env},cwd(){return I.cwd()}}}else typeof process!="undefined"?i={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:i={get platform(){return f.isWindows?"win32":f.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=i.cwd,e.env=i.env,e.platform=i.platform,e.arch=i.arch}),define(ve[9],we([1,0,41]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const i=65,I=97,A=90,C=122,k=46,S=47,R=92,F=58,D=63;class v extends Error{constructor(c,u,a){let E;typeof u=="string"&&u.indexOf("not ")===0?(E="must not be",u=u.replace(/^not /,"")):E="must be";const s=c.indexOf(".")!==-1?"property":"argument";let t=`The "${c}" ${s} ${E} of type ${u}`;t+=`. Received type ${typeof a}`;super(t);this.code="ERR_INVALID_ARG_TYPE"}}function b(l,c){if(typeof l!="string")throw new v(c,"string",l)}function g(l){return l===S||l===R}function d(l){return l===S}function p(l){return l>=i&&l<=A||l>=I&&l<=C}function P(l,c,u,a){let E="",s=0,t=-1,r=0,n=0;for(let o=0;o<=l.length;++o){if(o<l.length)n=l.charCodeAt(o);else{if(a(n))break;n=S}if(a(n)){if(!(t===o-1||r===1))if(r===2){if(E.length<2||s!==2||E.charCodeAt(E.length-1)!==k||E.charCodeAt(E.length-2)!==k){if(E.length>2){const m=E.lastIndexOf(u);m===-1?(E="",s=0):(E=E.slice(0,m),s=E.length-1-E.lastIndexOf(u)),t=o,r=0;continue}else if(E.length!==0){E="",s=0,t=o,r=0;continue}}c&&(E+=E.length>0?`${u}..`:"..",s=2)}else E.length>0?E+=`${u}${l.slice(t+1,o)}`:E=l.slice(t+1,o),s=o-t-1;t=o,r=0}else n===k&&r!==-1?++r:r=-1}return E}function _(l,c){if(c===null||typeof c!="object")throw new v("pathObject","Object",c);const u=c.dir||c.root,a=c.base||`${c.name||""}${c.ext||""}`;return u?u===c.root?`${u}${a}`:`${u}${l}${a}`:a}e.win32={resolve(...l){let c="",u="",a=!1;for(let E=l.length-1;E>=-1;E--){let s;if(E>=0){if(s=l[E],b(s,"path"),s.length===0)continue}else c.length===0?s=f.cwd():(s=f.env[`=${c}`]||f.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==c.toLowerCase()&&s.charCodeAt(2)===R)&&(s=`${c}\\`));const t=s.length;let r=0,n="",o=!1;const m=s.charCodeAt(0);if(t===1)g(m)&&(r=1,o=!0);else if(g(m))if(o=!0,g(s.charCodeAt(1))){let h=2,w=h;for(;h<t&&!g(s.charCodeAt(h));)h++;if(h<t&&h!==w){const T=s.slice(w,h);for(w=h;h<t&&g(s.charCodeAt(h));)h++;if(h<t&&h!==w){for(w=h;h<t&&!g(s.charCodeAt(h));)h++;(h===t||h!==w)&&(n=`\\\\${T}\\${s.slice(w,h)}`,r=h)}}}else r=1;else p(m)&&s.charCodeAt(1)===F&&(n=s.slice(0,2),r=2,t>2&&g(s.charCodeAt(2))&&(o=!0,r=3));if(n.length>0)if(c.length>0){if(n.toLowerCase()!==c.toLowerCase())continue}else c=n;if(a){if(c.length>0)break}else if(u=`${s.slice(r)}\\${u}`,a=o,o&&c.length>0)break}return u=P(u,!a,"\\",g),a?`${c}\\${u}`:`${c}${u}`||"."},normalize(l){b(l,"path");const c=l.length;if(c===0)return".";let u=0,a,E=!1;const s=l.charCodeAt(0);if(c===1)return d(s)?"\\":l;if(g(s))if(E=!0,g(l.charCodeAt(1))){let r=2,n=r;for(;r<c&&!g(l.charCodeAt(r));)r++;if(r<c&&r!==n){const o=l.slice(n,r);for(n=r;r<c&&g(l.charCodeAt(r));)r++;if(r<c&&r!==n){for(n=r;r<c&&!g(l.charCodeAt(r));)r++;if(r===c)return`\\\\${o}\\${l.slice(n)}\\`;r!==n&&(a=`\\\\${o}\\${l.slice(n,r)}`,u=r)}}}else u=1;else p(s)&&l.charCodeAt(1)===F&&(a=l.slice(0,2),u=2,c>2&&g(l.charCodeAt(2))&&(E=!0,u=3));let t=u<c?P(l.slice(u),!E,"\\",g):"";return t.length===0&&!E&&(t="."),t.length>0&&g(l.charCodeAt(c-1))&&(t+="\\"),a===void 0?E?`\\${t}`:t:E?`${a}\\${t}`:`${a}${t}`},isAbsolute(l){b(l,"path");const c=l.length;if(c===0)return!1;const u=l.charCodeAt(0);return g(u)||c>2&&p(u)&&l.charCodeAt(1)===F&&g(l.charCodeAt(2))},join(...l){if(l.length===0)return".";let c,u;for(let s=0;s<l.length;++s){const t=l[s];b(t,"path"),t.length>0&&(c===void 0?c=u=t:c+=`\\${t}`)}if(c===void 0)return".";let a=!0,E=0;if(typeof u=="string"&&g(u.charCodeAt(0))){++E;const s=u.length;s>1&&g(u.charCodeAt(1))&&(++E,s>2&&(g(u.charCodeAt(2))?++E:a=!1))}if(a){for(;E<c.length&&g(c.charCodeAt(E));)E++;E>=2&&(c=`\\${c.slice(E)}`)}return e.win32.normalize(c)},relative(l,c){if(b(l,"from"),b(c,"to"),l===c)return"";const u=e.win32.resolve(l),a=e.win32.resolve(c);if(u===a||(l=u.toLowerCase(),c=a.toLowerCase(),l===c))return"";let E=0;for(;E<l.length&&l.charCodeAt(E)===R;)E++;let s=l.length;for(;s-1>E&&l.charCodeAt(s-1)===R;)s--;const t=s-E;let r=0;for(;r<c.length&&c.charCodeAt(r)===R;)r++;let n=c.length;for(;n-1>r&&c.charCodeAt(n-1)===R;)n--;const o=n-r,m=t<o?t:o;let h=-1,w=0;for(;w<m;w++){const L=l.charCodeAt(E+w);if(L!==c.charCodeAt(r+w))break;L===R&&(h=w)}if(w!==m){if(h===-1)return a}else{if(o>m){if(c.charCodeAt(r+w)===R)return a.slice(r+w+1);if(w===2)return a.slice(r+w)}t>m&&(l.charCodeAt(E+w)===R?h=w:w===2&&(h=3)),h===-1&&(h=0)}let T="";for(w=E+h+1;w<=s;++w)(w===s||l.charCodeAt(w)===R)&&(T+=T.length===0?"..":"\\..");return r+=h,T.length>0?`${T}${a.slice(r,n)}`:(a.charCodeAt(r)===R&&++r,a.slice(r,n))},toNamespacedPath(l){if(typeof l!="string")return l;if(l.length===0)return"";const c=e.win32.resolve(l);if(c.length<=2)return l;if(c.charCodeAt(0)===R){if(c.charCodeAt(1)===R){const u=c.charCodeAt(2);if(u!==D&&u!==k)return`\\\\?\\UNC\\${c.slice(2)}`}}else if(p(c.charCodeAt(0))&&c.charCodeAt(1)===F&&c.charCodeAt(2)===R)return`\\\\?\\${c}`;return l},dirname(l){b(l,"path");const c=l.length;if(c===0)return".";let u=-1,a=0;const E=l.charCodeAt(0);if(c===1)return g(E)?l:".";if(g(E)){if(u=a=1,g(l.charCodeAt(1))){let r=2,n=r;for(;r<c&&!g(l.charCodeAt(r));)r++;if(r<c&&r!==n){for(n=r;r<c&&g(l.charCodeAt(r));)r++;if(r<c&&r!==n){for(n=r;r<c&&!g(l.charCodeAt(r));)r++;if(r===c)return l;r!==n&&(u=a=r+1)}}}}else p(E)&&l.charCodeAt(1)===F&&(u=c>2&&g(l.charCodeAt(2))?3:2,a=u);let s=-1,t=!0;for(let r=c-1;r>=a;--r)if(g(l.charCodeAt(r))){if(!t){s=r;break}}else t=!1;if(s===-1){if(u===-1)return".";s=u}return l.slice(0,s)},basename(l,c){c!==void 0&&b(c,"ext"),b(l,"path");let u=0,a=-1,E=!0,s;if(l.length>=2&&p(l.charCodeAt(0))&&l.charCodeAt(1)===F&&(u=2),c!==void 0&&c.length>0&&c.length<=l.length){if(c===l)return"";let t=c.length-1,r=-1;for(s=l.length-1;s>=u;--s){const n=l.charCodeAt(s);if(g(n)){if(!E){u=s+1;break}}else r===-1&&(E=!1,r=s+1),t>=0&&(n===c.charCodeAt(t)?--t==-1&&(a=s):(t=-1,a=r))}return u===a?a=r:a===-1&&(a=l.length),l.slice(u,a)}for(s=l.length-1;s>=u;--s)if(g(l.charCodeAt(s))){if(!E){u=s+1;break}}else a===-1&&(E=!1,a=s+1);return a===-1?"":l.slice(u,a)},extname(l){b(l,"path");let c=0,u=-1,a=0,E=-1,s=!0,t=0;l.length>=2&&l.charCodeAt(1)===F&&p(l.charCodeAt(0))&&(c=a=2);for(let r=l.length-1;r>=c;--r){const n=l.charCodeAt(r);if(g(n)){if(!s){a=r+1;break}continue}E===-1&&(s=!1,E=r+1),n===k?u===-1?u=r:t!==1&&(t=1):u!==-1&&(t=-1)}return u===-1||E===-1||t===0||t===1&&u===E-1&&u===a+1?"":l.slice(u,E)},format:_.bind(null,"\\"),parse(l){b(l,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(l.length===0)return c;const u=l.length;let a=0,E=l.charCodeAt(0);if(u===1)return g(E)?(c.root=c.dir=l,c):(c.base=c.name=l,c);if(g(E)){if(a=1,g(l.charCodeAt(1))){let h=2,w=h;for(;h<u&&!g(l.charCodeAt(h));)h++;if(h<u&&h!==w){for(w=h;h<u&&g(l.charCodeAt(h));)h++;if(h<u&&h!==w){for(w=h;h<u&&!g(l.charCodeAt(h));)h++;h===u?a=h:h!==w&&(a=h+1)}}}}else if(p(E)&&l.charCodeAt(1)===F){if(u<=2)return c.root=c.dir=l,c;if(a=2,g(l.charCodeAt(2))){if(u===3)return c.root=c.dir=l,c;a=3}}a>0&&(c.root=l.slice(0,a));let s=-1,t=a,r=-1,n=!0,o=l.length-1,m=0;for(;o>=a;--o){if(E=l.charCodeAt(o),g(E)){if(!n){t=o+1;break}continue}r===-1&&(n=!1,r=o+1),E===k?s===-1?s=o:m!==1&&(m=1):s!==-1&&(m=-1)}return r!==-1&&(s===-1||m===0||m===1&&s===r-1&&s===t+1?c.base=c.name=l.slice(t,r):(c.name=l.slice(t,s),c.base=l.slice(t,r),c.ext=l.slice(s,r))),t>0&&t!==a?c.dir=l.slice(0,t-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...l){let c="",u=!1;for(let a=l.length-1;a>=-1&&!u;a--){const E=a>=0?l[a]:f.cwd();b(E,"path"),E.length!==0&&(c=`${E}/${c}`,u=E.charCodeAt(0)===S)}return c=P(c,!u,"/",d),u?`/${c}`:c.length>0?c:"."},normalize(l){if(b(l,"path"),l.length===0)return".";const c=l.charCodeAt(0)===S,u=l.charCodeAt(l.length-1)===S;return l=P(l,!c,"/",d),l.length===0?c?"/":u?"./":".":(u&&(l+="/"),c?`/${l}`:l)},isAbsolute(l){return b(l,"path"),l.length>0&&l.charCodeAt(0)===S},join(...l){if(l.length===0)return".";let c;for(let u=0;u<l.length;++u){const a=l[u];b(a,"path"),a.length>0&&(c===void 0?c=a:c+=`/${a}`)}return c===void 0?".":e.posix.normalize(c)},relative(l,c){if(b(l,"from"),b(c,"to"),l===c||(l=e.posix.resolve(l),c=e.posix.resolve(c),l===c))return"";const u=1,a=l.length,E=a-u,s=1,t=c.length-s,r=E<t?E:t;let n=-1,o=0;for(;o<r;o++){const h=l.charCodeAt(u+o);if(h!==c.charCodeAt(s+o))break;h===S&&(n=o)}if(o===r)if(t>r){if(c.charCodeAt(s+o)===S)return c.slice(s+o+1);if(o===0)return c.slice(s+o)}else E>r&&(l.charCodeAt(u+o)===S?n=o:o===0&&(n=0));let m="";for(o=u+n+1;o<=a;++o)(o===a||l.charCodeAt(o)===S)&&(m+=m.length===0?"..":"/..");return`${m}${c.slice(s+n)}`},toNamespacedPath(l){return l},dirname(l){if(b(l,"path"),l.length===0)return".";const c=l.charCodeAt(0)===S;let u=-1,a=!0;for(let E=l.length-1;E>=1;--E)if(l.charCodeAt(E)===S){if(!a){u=E;break}}else a=!1;return u===-1?c?"/":".":c&&u===1?"//":l.slice(0,u)},basename(l,c){c!==void 0&&b(c,"ext"),b(l,"path");let u=0,a=-1,E=!0,s;if(c!==void 0&&c.length>0&&c.length<=l.length){if(c===l)return"";let t=c.length-1,r=-1;for(s=l.length-1;s>=0;--s){const n=l.charCodeAt(s);if(n===S){if(!E){u=s+1;break}}else r===-1&&(E=!1,r=s+1),t>=0&&(n===c.charCodeAt(t)?--t==-1&&(a=s):(t=-1,a=r))}return u===a?a=r:a===-1&&(a=l.length),l.slice(u,a)}for(s=l.length-1;s>=0;--s)if(l.charCodeAt(s)===S){if(!E){u=s+1;break}}else a===-1&&(E=!1,a=s+1);return a===-1?"":l.slice(u,a)},extname(l){b(l,"path");let c=-1,u=0,a=-1,E=!0,s=0;for(let t=l.length-1;t>=0;--t){const r=l.charCodeAt(t);if(r===S){if(!E){u=t+1;break}continue}a===-1&&(E=!1,a=t+1),r===k?c===-1?c=t:s!==1&&(s=1):c!==-1&&(s=-1)}return c===-1||a===-1||s===0||s===1&&c===a-1&&c===u+1?"":l.slice(c,a)},format:_.bind(null,"/"),parse(l){b(l,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(l.length===0)return c;const u=l.charCodeAt(0)===S;let a;u?(c.root="/",a=1):a=0;let E=-1,s=0,t=-1,r=!0,n=l.length-1,o=0;for(;n>=a;--n){const m=l.charCodeAt(n);if(m===S){if(!r){s=n+1;break}continue}t===-1&&(r=!1,t=n+1),m===k?E===-1?E=n:o!==1&&(o=1):E!==-1&&(o=-1)}if(t!==-1){const m=s===0&&u?1:s;E===-1||o===0||o===1&&E===t-1&&E===s+1?c.base=c.name=l.slice(m,t):(c.name=l.slice(m,E),c.base=l.slice(m,t),c.ext=l.slice(E,t))}return s>0?c.dir=l.slice(0,s-1):u&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=f.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=f.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=f.platform==="win32"?e.win32.join:e.posix.join,e.resolve=f.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=f.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=f.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=f.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=f.platform==="win32"?e.win32.extname:e.posix.extname,e.format=f.platform==="win32"?e.win32.format:e.posix.format,e.parse=f.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=f.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=f.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=f.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ve[92],we([1,0,9]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0;var i;(function(D){D.text="text/plain",D.binary="application/octet-stream",D.unknown="application/unknown",D.markdown="text/markdown",D.latex="text/latex",D.uriList="text/uri-list"})(i=e.Mimes||(e.Mimes={}));const I={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},A={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function C(D){const v=(0,f.extname)(D),b=I[v.toLowerCase()];return b!==void 0?b:k(D)}e.getMediaOrTextMime=C;function k(D){const v=(0,f.extname)(D);return A[v.toLowerCase()]}e.getMediaMime=k;function S(D){for(const v in A)if(A[v]===D)return v}e.getExtensionForMimeType=S;const R=/^(.+)\/(.+?)(;.+)?$/;function F(D,v){const b=R.exec(D);return b?`${b[1].toLowerCase()}/${b[2].toLowerCase()}${b[3]??""}`:v?void 0:D}e.normalizeMimeType=F}),define(ve[93],we([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var f;(function(A){A[A.stdout=0]="stdout",A[A.stderr=1]="stderr"})(f=e.Source||(e.Source={}));var i;(function(A){A[A.Success=0]="Success",A[A.Unknown=1]="Unknown",A[A.AccessDenied=2]="AccessDenied",A[A.ProcessNotFound=3]="ProcessNotFound"})(i=e.TerminateResponseCode||(e.TerminateResponseCode={}));function I(A,...C){const k=C.reduce((F,D)=>(F[D]=!0,F),{}),S=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(A).filter(F=>!k[F]).forEach(F=>{for(let D=0;D<S.length;D++)if(F.search(S[D])!==-1){delete A[F];break}})}e.sanitizeProcessEnvironment=I}),define(ve[46],we([1,0,12]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const i=f.globals.performance&&typeof f.globals.performance.now=="function";class I{constructor(C){this._highResolution=i&&C,this._startTime=this._now(),this._stopTime=-1}static create(C=!0){return new I(C)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?f.globals.performance.now():Date.now()}}e.StopWatch=I}),define(ve[3],we([1,0,15,74,6,90,46]),function(te,e,f,i,I,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;let k=!1,S=!1;var R;(function(s){s.None=()=>I.Disposable.None;function t(ee){if(S){const{onListenerDidAdd:oe}=ee,ue=g.create();let Z=0;ee.onListenerDidAdd=()=>{++Z==2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ue.print()),oe?.()}}}function r(ee){return(oe,ue=null,Z)=>{let Y=!1,se;return se=ee(de=>{if(!Y)return se?se.dispose():Y=!0,oe.call(ue,de)},null,Z),Y&&se.dispose(),se}}s.once=r;function n(ee,oe,ue){return L((Z,Y=null,se)=>ee(de=>Z.call(Y,oe(de)),null,se),ue)}s.map=n;function o(ee,oe,ue){return L((Z,Y=null,se)=>ee(de=>{oe(de),Z.call(Y,de)},null,se),ue)}s.forEach=o;function m(ee,oe,ue){return L((Z,Y=null,se)=>ee(de=>oe(de)&&Z.call(Y,de),null,se),ue)}s.filter=m;function h(ee){return ee}s.signal=h;function w(...ee){return(oe,ue=null,Z)=>(0,I.combinedDisposable)(...ee.map(Y=>Y(se=>oe.call(ue,se),null,Z)))}s.any=w;function T(ee,oe,ue,Z){let Y=ue;return n(ee,se=>(Y=oe(Y,se),Y),Z)}s.reduce=T;function L(ee,oe){let ue;const Z={onFirstListenerAdd(){ue=ee(Y.fire,Y)},onLastListenerRemove(){ue.dispose()}};oe||t(Z);const Y=new p(Z);return oe&&oe.add(Y),Y.event}function O(ee,oe,ue=100,Z=!1,Y,se){let de,ge,Te,Ne=0;const be={leakWarningThreshold:Y,onFirstListenerAdd(){de=ee(z=>{Ne++,ge=oe(ge,z),Z&&!Te&&(Ee.fire(ge),ge=void 0),clearTimeout(Te),Te=setTimeout(()=>{const B=ge;ge=void 0,Te=void 0,(!Z||Ne>1)&&Ee.fire(B),Ne=0},ue)})},onLastListenerRemove(){de.dispose()}};se||t(be);const Ee=new p(be);return se&&se.add(Ee),Ee.event}s.debounce=O;function y(ee,oe=(Z,Y)=>Z===Y,ue){let Z=!0,Y;return m(ee,se=>{const de=Z||!oe(se,Y);return Z=!1,Y=se,de},ue)}s.latch=y;function H(ee,oe,ue){return[s.filter(ee,oe,ue),s.filter(ee,Z=>!oe(Z),ue)]}s.split=H;function M(ee,oe=!1,ue=[]){let Z=ue.slice(),Y=ee(ge=>{Z?Z.push(ge):de.fire(ge)});const se=()=>{Z&&Z.forEach(ge=>de.fire(ge)),Z=null},de=new p({onFirstListenerAdd(){Y||(Y=ee(ge=>de.fire(ge)))},onFirstListenerDidAdd(){Z&&(oe?setTimeout(se):se())},onLastListenerRemove(){Y&&Y.dispose(),Y=null}});return de.event}s.buffer=M;class j{constructor(oe){this.event=oe}map(oe){return new j(n(this.event,oe))}forEach(oe){return new j(o(this.event,oe))}filter(oe){return new j(m(this.event,oe))}reduce(oe,ue){return new j(T(this.event,oe,ue))}latch(){return new j(y(this.event))}debounce(oe,ue=100,Z=!1,Y){return new j(O(this.event,oe,ue,Z,Y))}on(oe,ue,Z){return this.event(oe,ue,Z)}once(oe,ue,Z){return r(this.event)(oe,ue,Z)}}function X(ee){return new j(ee)}s.chain=X;function $(ee,oe,ue=Z=>Z){const Z=(...ge)=>de.fire(ue(...ge)),Y=()=>ee.on(oe,Z),se=()=>ee.removeListener(oe,Z),de=new p({onFirstListenerAdd:Y,onLastListenerRemove:se});return de.event}s.fromNodeEventEmitter=$;function U(ee,oe,ue=Z=>Z){const Z=(...ge)=>de.fire(ue(...ge)),Y=()=>ee.addEventListener(oe,Z),se=()=>ee.removeEventListener(oe,Z),de=new p({onFirstListenerAdd:Y,onLastListenerRemove:se});return de.event}s.fromDOMEventEmitter=U;function q(ee){return new Promise(oe=>r(ee)(oe))}s.toPromise=q;function K(ee,oe){return oe(void 0),ee(ue=>oe(ue))}s.runAndSubscribe=K;function G(ee,oe){let ue=null;function Z(se){ue?.dispose(),ue=new I.DisposableStore,oe(se,ue)}Z(void 0);const Y=ee(se=>Z(se));return(0,I.toDisposable)(()=>{Y.dispose(),ue?.dispose()})}s.runAndSubscribeWithStore=G})(R=e.Event||(e.Event={}));class F{constructor(t){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${t}_${F._idPool++}`}start(t){this._stopWatch=new C.StopWatch(!0),this._listenerCount=t}stop(){if(this._stopWatch){const t=this._stopWatch.elapsed();this._elapsedOverall+=t,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${t.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}F._idPool=0;let D=-1;function v(s){const t=D;return D=s,{dispose(){D=t}}}e.setGlobalLeakWarningThreshold=v;class b{constructor(t,r=Math.random().toString(18).slice(2,5)){this.customThreshold=t,this.name=r,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(t,r){let n=D;if(typeof this.customThreshold=="number"&&(n=this.customThreshold),n<=0||r<n)return;this._stacks||(this._stacks=new Map);const o=this._stacks.get(t.value)||0;if(this._stacks.set(t.value,o+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=n*.5;let m,h=0;for(const[w,T]of this._stacks)(!m||h<T)&&(m=w,h=T);console.warn(`[${this.name}] potential listener LEAK detected, having ${r} listeners already. MOST frequent listener (${h}):`),console.warn(m)}return()=>{const m=this._stacks.get(t.value)||0;this._stacks.set(t.value,m-1)}}}class g{constructor(t){this.value=t}static create(){return new g(new Error().stack??"")}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class d{constructor(t,r,n){this.callback=t,this.callbackThis=r,this.stack=n,this.subscription=new I.SafeDisposable}invoke(t){this.callback.call(this.callbackThis,t)}}class p{constructor(t){this._disposed=!1,this._options=t,this._leakageMon=D>0?new b(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new F(this._options._profName):void 0}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(k){const t=Array.from(this._listeners);queueMicrotask(()=>{for(const r of t)r.subscription.isset()&&(r.subscription.unset(),r.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(t,r,n)=>{this._listeners||(this._listeners=new A.LinkedList);const o=this._listeners.isEmpty();o&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let m,h;this._leakageMon&&this._listeners.size>=30&&(h=g.create(),m=this._leakageMon.check(h,this._listeners.size+1)),k&&(h=h??g.create());const w=new d(t,r,h),T=this._listeners.push(w);o&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,t,r);const L=w.subscription.set(()=>{m&&m(),this._disposed||(T(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return n instanceof I.DisposableStore?n.add(L):Array.isArray(n)&&n.push(L),L}),this._event}fire(t){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new A.LinkedList);for(let r of this._listeners)this._deliveryQueue.push([r,t]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[r,n]=this._deliveryQueue.shift();try{r.invoke(n)}catch(o){(0,f.onUnexpectedError)(o)}}this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=p;class P extends p{async fireAsync(t,r,n){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new A.LinkedList);for(const o of this._listeners)this._asyncDeliveryQueue.push([o,t]);for(;this._asyncDeliveryQueue.size>0&&!r.isCancellationRequested;){const[o,m]=this._asyncDeliveryQueue.shift(),h=[],w={...m,token:r,waitUntil:T=>{if(Object.isFrozen(h))throw new Error("waitUntil can NOT be called asynchronous");n&&(T=n(T,o.callback)),h.push(T)}};try{o.invoke(w)}catch(T){(0,f.onUnexpectedError)(T);continue}Object.freeze(h),await Promise.allSettled(h).then(T=>{for(const L of T)L.status==="rejected"&&(0,f.onUnexpectedError)(L.reason)})}}}}e.AsyncEmitter=P;class _ extends p{constructor(t){super(t);this._isPaused=0,this._eventQueue=new A.LinkedList,this._mergeFn=t?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const t=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(t))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(t){this._listeners&&(this._isPaused!==0?this._eventQueue.push(t):super.fire(t))}}e.PauseableEmitter=_;class l extends _{constructor(t){super(t);this._delay=t.delay??100}fire(t){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(t)}}e.DebounceEmitter=l;class c extends p{constructor(t){super(t);this._queuedEvents=[],this._mergeFn=t?.merge}fire(t){this._queuedEvents.push(t),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(r=>super.fire(r)),this._queuedEvents=[]})}}e.MicrotaskEmitter=c;class u{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new p({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(t){const r={event:t,listener:null};this.events.push(r),this.hasListeners&&this.hook(r);const n=()=>{this.hasListeners&&this.unhook(r);const o=this.events.indexOf(r);this.events.splice(o,1)};return(0,I.toDisposable)((0,i.once)(n))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(t=>this.hook(t))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(t=>this.unhook(t))}hook(t){t.listener=t.event(r=>this.emitter.fire(r))}unhook(t){t.listener&&t.listener.dispose(),t.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=u;class a{constructor(){this.buffers=[]}wrapEvent(t){return(r,n,o)=>t(m=>{const h=this.buffers[this.buffers.length-1];h?h.push(()=>r.call(n,m)):r.call(n,m)},void 0,o)}bufferEvents(t){const r=[];this.buffers.push(r);const n=t();return this.buffers.pop(),r.forEach(o=>o()),n}}e.EventBufferer=a;class E{constructor(){this.listening=!1,this.inputEvent=R.None,this.inputEventListener=I.Disposable.None,this.emitter=new p({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(t){this.inputEvent=t,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=t(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=E}),define(ve[21],we([1,0,3]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const i=Object.freeze(function(k,S){const R=setTimeout(k.bind(S),0);return{dispose(){clearTimeout(R)}}});var I;(function(k){function S(R){return R===k.None||R===k.Cancelled||R instanceof A?!0:!R||typeof R!="object"?!1:typeof R.isCancellationRequested=="boolean"&&typeof R.onCancellationRequested=="function"}k.isCancellationToken=S,k.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:f.Event.None}),k.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:i})})(I=e.CancellationToken||(e.CancellationToken={}));class A{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?i:(this._emitter||(this._emitter=new f.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class C{constructor(S){this._token=void 0,this._parentListener=void 0,this._parentListener=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new A),this._token}cancel(){this._token?this._token instanceof A&&this._token.cancel():this._token=I.Cancelled}dispose(S=!1){S&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof A&&this._token.dispose():this._token=I.None}}e.CancellationTokenSource=C}),define(ve[143],we([1,0,21]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCachedComputed=e.Cache=void 0;class i{constructor(C){this.task=C,this.result=null}get(){if(this.result)return this.result;const C=new f.CancellationTokenSource,k=this.task(C.token);return this.result={promise:k,dispose:()=>{this.result=null,C.cancel(),C.dispose()}},this.result}}e.Cache=i;class I{constructor(C){this.computeFn=C,this.lastCache=void 0,this.lastArgKey=void 0}get(C){const k=JSON.stringify(C);return this.lastArgKey!==k&&(this.lastArgKey=k,this.lastCache=this.computeFn(C)),this.lastCache}}e.LRUCachedComputed=I}),define(ve[94],we([1,0,15,6]),function(te,e,f,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function I(c){const u=c;return u?typeof u.read=="function":!1}e.isReadable=I;function A(c){const u=c;return u?[u.on,u.pause,u.resume,u.destroy].every(a=>typeof a=="function"):!1}e.isReadableStream=A;function C(c){const u=c;return u?A(u.stream)&&Array.isArray(u.buffer)&&typeof u.ended=="boolean":!1}e.isReadableBufferedStream=C;function k(c,u){return new S(c,u)}e.newWriteableStream=k;class S{constructor(u,a){this.reducer=u,this.options=a,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(u){if(!this.state.destroyed){if(this.state.flowing)this.emitData(u);else if(this.buffer.data.push(u),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(a=>this.pendingWritePromises.push(a))}}error(u){this.state.destroyed||(this.state.flowing?this.emitError(u):this.buffer.error.push(u))}end(u){this.state.destroyed||(typeof u!="undefined"&&this.write(u),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(u){this.listeners.data.slice(0).forEach(a=>a(u))}emitError(u){this.listeners.error.length===0?(0,f.onUnexpectedError)(u):this.listeners.error.slice(0).forEach(a=>a(u))}emitEnd(){this.listeners.end.slice(0).forEach(u=>u())}on(u,a){if(!this.state.destroyed)switch(u){case"data":this.listeners.data.push(a),this.resume();break;case"end":this.listeners.end.push(a),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(a),this.state.flowing&&this.flowErrors();break}}removeListener(u,a){if(this.state.destroyed)return;let E;switch(u){case"data":E=this.listeners.data;break;case"end":E=this.listeners.end;break;case"error":E=this.listeners.error;break}if(E){const s=E.indexOf(a);s>=0&&E.splice(s,1)}}flowData(){if(this.buffer.data.length>0){const u=this.reducer(this.buffer.data);this.emitData(u),this.buffer.data.length=0;const a=[...this.pendingWritePromises];this.pendingWritePromises.length=0,a.forEach(E=>E())}}flowErrors(){if(this.listeners.error.length>0){for(const u of this.buffer.error)this.emitError(u);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function R(c,u){const a=[];let E;for(;(E=c.read())!==null;)a.push(E);return u(a)}e.consumeReadable=R;function F(c,u,a){const E=[];let s;for(;(s=c.read())!==null&&E.length<a;)E.push(s);return s===null&&E.length>0?u(E):{read:()=>{if(E.length>0)return E.shift();if(typeof s!="undefined"){const t=s;return s=void 0,t}return c.read()}}}e.peekReadable=F;function D(c,u){return new Promise((a,E)=>{const s=[];v(c,{onData:t=>{u&&s.push(t)},onError:t=>{u?E(t):a(void 0)},onEnd:()=>{a(u?u(s):void 0)}})})}e.consumeStream=D;function v(c,u){let a=!1;return c.on("error",E=>{a||u.onError(E)}),c.on("end",()=>{a||u.onEnd()}),c.on("data",E=>{a||u.onData(E)}),(0,i.toDisposable)(()=>a=!0)}e.listenStream=v;function b(c,u){return new Promise((a,E)=>{const s=new i.DisposableStore,t=[],r=m=>{if(t.push(m),t.length>u)return s.dispose(),c.pause(),a({stream:c,buffer:t,ended:!1})},n=m=>E(m),o=()=>a({stream:c,buffer:t,ended:!0});s.add((0,i.toDisposable)(()=>c.removeListener("error",n))),c.on("error",n),s.add((0,i.toDisposable)(()=>c.removeListener("end",o))),c.on("end",o),s.add((0,i.toDisposable)(()=>c.removeListener("data",r))),c.on("data",r)})}e.peekStream=b;function g(c,u){const a=k(u);return a.end(c),a}e.toStream=g;function d(){const c=k(()=>{throw new Error("not supported")});return c.end(),c}e.emptyStream=d;function p(c){let u=!1;return{read:()=>u?null:(u=!0,c)}}e.toReadable=p;function P(c,u,a){const E=k(a);return v(c,{onData:s=>E.write(u.data(s)),onError:s=>E.error(u.error?u.error(s):s),onEnd:()=>E.end()}),E}e.transform=P;function _(c,u,a){let E=!1;return{read:()=>{const s=u.read();return E?s:(E=!0,s!==null?a([c,s]):c)}}}e.prefixedReadable=_;function l(c,u,a){let E=!1;const s=k(a);return v(u,{onData:t=>E?s.write(t):(E=!0,s.write(a([c,t]))),onError:t=>s.error(t),onEnd:()=>{E||(E=!0,s.write(c)),s.end()}}),s}e.prefixedStream=l}),define(ve[22],we([1,0,94]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const i=typeof Buffer!="undefined";let I,A;class C{constructor(m){this.buffer=m,this.byteLength=this.buffer.byteLength}static alloc(m){return i?new C(Buffer.allocUnsafe(m)):new C(new Uint8Array(m))}static wrap(m){return i&&!Buffer.isBuffer(m)&&(m=Buffer.from(m.buffer,m.byteOffset,m.byteLength)),new C(m)}static fromString(m,h){return!(h?.dontUseNodeBuffer||!1)&&i?new C(Buffer.from(m)):(I||(I=new TextEncoder),new C(I.encode(m)))}static fromByteArray(m){const h=C.alloc(m.length);for(let w=0,T=m.length;w<T;w++)h.buffer[w]=m[w];return h}static concat(m,h){if(typeof h=="undefined"){h=0;for(let L=0,O=m.length;L<O;L++)h+=m[L].byteLength}const w=C.alloc(h);let T=0;for(let L=0,O=m.length;L<O;L++){const y=m[L];w.set(y,T),T+=y.byteLength}return w}clone(){const m=C.alloc(this.byteLength);return m.set(this),m}toString(){return i?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(m,h){return new C(this.buffer.subarray(m,h))}set(m,h){if(m instanceof C)this.buffer.set(m.buffer,h);else if(m instanceof Uint8Array)this.buffer.set(m,h);else if(m instanceof ArrayBuffer)this.buffer.set(new Uint8Array(m),h);else if(ArrayBuffer.isView(m))this.buffer.set(new Uint8Array(m.buffer,m.byteOffset,m.byteLength),h);else throw new Error("Unknown argument 'array'")}readUInt32BE(m){return R(this.buffer,m)}writeUInt32BE(m,h){F(this.buffer,m,h)}readUInt32LE(m){return D(this.buffer,m)}writeUInt32LE(m,h){v(this.buffer,m,h)}readUInt8(m){return b(this.buffer,m)}writeUInt8(m,h){g(this.buffer,m,h)}}e.VSBuffer=C;function k(o,m){return o[m+0]<<0>>>0|o[m+1]<<8>>>0}e.readUInt16LE=k;function S(o,m,h){o[h+0]=m&255,m=m>>>8,o[h+1]=m&255}e.writeUInt16LE=S;function R(o,m){return o[m]*2**24+o[m+1]*2**16+o[m+2]*2**8+o[m+3]}e.readUInt32BE=R;function F(o,m,h){o[h+3]=m,m=m>>>8,o[h+2]=m,m=m>>>8,o[h+1]=m,m=m>>>8,o[h]=m}e.writeUInt32BE=F;function D(o,m){return o[m+0]<<0>>>0|o[m+1]<<8>>>0|o[m+2]<<16>>>0|o[m+3]<<24>>>0}e.readUInt32LE=D;function v(o,m,h){o[h+0]=m&255,m=m>>>8,o[h+1]=m&255,m=m>>>8,o[h+2]=m&255,m=m>>>8,o[h+3]=m&255}e.writeUInt32LE=v;function b(o,m){return o[m]}e.readUInt8=b;function g(o,m,h){o[h]=m}e.writeUInt8=g;function d(o){return f.consumeReadable(o,m=>C.concat(m))}e.readableToBuffer=d;function p(o){return f.toReadable(o)}e.bufferToReadable=p;function P(o){return f.consumeStream(o,m=>C.concat(m))}e.streamToBuffer=P;async function _(o){return o.ended?C.concat(o.buffer):C.concat([...o.buffer,await P(o.stream)])}e.bufferedStreamToBuffer=_;function l(o){return f.toStream(o,m=>C.concat(m))}e.bufferToStream=l;function c(o){return f.transform(o,{data:m=>typeof m=="string"?C.fromString(m):C.wrap(m)},m=>C.concat(m))}e.streamToBufferReadableStream=c;function u(o){return f.newWriteableStream(m=>C.concat(m),o)}e.newWriteableBufferStream=u;function a(o,m){return f.prefixedReadable(o,m,h=>C.concat(h))}e.prefixedBufferReadable=a;function E(o,m){return f.prefixedStream(o,m,h=>C.concat(h))}e.prefixedBufferStream=E;function s(o){let m=0,h=0,w=0;const T=new Uint8Array(Math.floor(o.length/4*3)),L=y=>{switch(h){case 3:T[w++]=m|y,h=0;break;case 2:T[w++]=m|y>>>2,m=y<<6,h=3;break;case 1:T[w++]=m|y>>>4,m=y<<4,h=2;break;default:m=y<<2,h=1}};for(let y=0;y<o.length;y++){const H=o.charCodeAt(y);if(H>=65&&H<=90)L(H-65);else if(H>=97&&H<=122)L(H-97+26);else if(H>=48&&H<=57)L(H-48+52);else if(H===43||H===45)L(62);else if(H===47||H===95)L(63);else{if(H===61)break;throw new SyntaxError(`Unexpected base64 character ${o[y]}`)}}const O=w;for(;h>0;)L(0);return C.wrap(T).slice(0,O)}e.decodeBase64=s;const t="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function n({buffer:o},m=!0,h=!1){const w=h?r:t;let T="";const L=o.byteLength%3;let O=0;for(;O<o.byteLength-L;O+=3){const y=o[O+0],H=o[O+1],M=o[O+2];T+=w[y>>>2],T+=w[(y<<4|H>>>4)&63],T+=w[(H<<2|M>>>6)&63],T+=w[M&63]}if(L===1){const y=o[O+0];T+=w[y>>>2],T+=w[y<<4&63],m&&(T+="==")}else if(L===2){const y=o[O+0],H=o[O+1];T+=w[y>>>2],T+=w[(y<<4|H>>>4)&63],T+=w[H<<2&63],m&&(T+="=")}return T}e.encodeBase64=n}),define(ve[8],we([1,0,143,89]),function(te,e,f,i){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function A(J){return!J||typeof J!="string"?!0:J.trim().length===0}e.isFalsyOrWhitespace=A;const C=/{(\d+)}/g;function k(J,...pe){return pe.length===0?J:J.replace(C,function(Se,Me){const $e=parseInt(Me,10);return isNaN($e)||$e<0||$e>=pe.length?Se:pe[$e]})}e.format=k;const S=/{([^}]+)}/g;function R(J,pe){return J.replace(S,(Se,Me)=>pe[Me]??Se)}e.format2=R;function F(J){return J.replace(/[<>&]/g,function(pe){switch(pe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return pe}})}e.escape=F;function D(J){return J.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=D;function v(J,pe){let Se=0;const Me=pe.charCodeAt(0);for(let $e=J.length-1;$e>=0;$e--)J.charCodeAt($e)===Me&&Se++;return Se}e.count=v;function b(J,pe,Se="\u2026"){return J.length<=pe?J:`${J.substr(0,pe)}${Se}`}e.truncate=b;function g(J,pe=" "){const Se=d(J,pe);return p(Se,pe)}e.trim=g;function d(J,pe){if(!J||!pe)return J;const Se=pe.length;if(Se===0||J.length===0)return J;let Me=0;for(;J.indexOf(pe,Me)===Me;)Me=Me+Se;return J.substring(Me)}e.ltrim=d;function p(J,pe){if(!J||!pe)return J;const Se=pe.length,Me=J.length;if(Se===0||Me===0)return J;let $e=Me,Ye=-1;for(;Ye=J.lastIndexOf(pe,$e-1),!(Ye===-1||Ye+Se!==$e);){if(Ye===0)return"";$e=Ye}return J.substring(0,$e)}e.rtrim=p;function P(J){return J.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=P;function _(J){return J.replace(/\*/g,"")}e.stripWildcards=_;function l(J,pe,Se={}){if(!J)throw new Error("Cannot create regex from empty string");pe||(J=D(J)),Se.wholeWord&&(/\B/.test(J.charAt(0))||(J="\\b"+J),/\B/.test(J.charAt(J.length-1))||(J=J+"\\b"));let Me="";return Se.global&&(Me+="g"),Se.matchCase||(Me+="i"),Se.multiline&&(Me+="m"),Se.unicode&&(Me+="u"),new RegExp(J,Me)}e.createRegExp=l;function c(J){return J.source==="^"||J.source==="^$"||J.source==="$"||J.source==="^\\s*$"?!1:!!(J.exec("")&&J.lastIndex===0)}e.regExpLeadsToEndlessLoop=c;function u(J){return!!J.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=u;function a(J){return(J.global?"g":"")+(J.ignoreCase?"i":"")+(J.multiline?"m":"")+(J.unicode?"u":"")}e.regExpFlags=a;function E(J){return J.split(/\r\n|\r|\n/)}e.splitLines=E;function s(J){for(let pe=0,Se=J.length;pe<Se;pe++){const Me=J.charCodeAt(pe);if(Me!==32&&Me!==9)return pe}return-1}e.firstNonWhitespaceIndex=s;function t(J,pe=0,Se=J.length){for(let Me=pe;Me<Se;Me++){const $e=J.charCodeAt(Me);if($e!==32&&$e!==9)return J.substring(pe,Me)}return J.substring(pe,Se)}e.getLeadingWhitespace=t;function r(J,pe=J.length-1){for(let Se=pe;Se>=0;Se--){const Me=J.charCodeAt(Se);if(Me!==32&&Me!==9)return Se}return-1}e.lastNonWhitespaceIndex=r;function n(J,pe){return J<pe?-1:J>pe?1:0}e.compare=n;function o(J,pe,Se=0,Me=J.length,$e=0,Ye=pe.length){for(;Se<Me&&$e<Ye;Se++,$e++){let wt=J.charCodeAt(Se),je=pe.charCodeAt($e);if(wt<je)return-1;if(wt>je)return 1}const lt=Me-Se,vt=Ye-$e;return lt<vt?-1:lt>vt?1:0}e.compareSubstring=o;function m(J,pe){return h(J,pe,0,J.length,0,pe.length)}e.compareIgnoreCase=m;function h(J,pe,Se=0,Me=J.length,$e=0,Ye=pe.length){for(;Se<Me&&$e<Ye;Se++,$e++){let wt=J.charCodeAt(Se),je=pe.charCodeAt($e);if(wt===je)continue;if(wt>=128||je>=128)return o(J.toLowerCase(),pe.toLowerCase(),Se,Me,$e,Ye);w(wt)&&(wt-=32),w(je)&&(je-=32);const st=wt-je;if(st!==0)return st}const lt=Me-Se,vt=Ye-$e;return lt<vt?-1:lt>vt?1:0}e.compareSubstringIgnoreCase=h;function w(J){return J>=97&&J<=122}e.isLowerAsciiLetter=w;function T(J){return J>=65&&J<=90}e.isUpperAsciiLetter=T;function L(J,pe){return J.length===pe.length&&h(J,pe)===0}e.equalsIgnoreCase=L;function O(J,pe){const Se=pe.length;return pe.length>J.length?!1:h(J,pe,0,Se)===0}e.startsWithIgnoreCase=O;function y(J,pe){let Se,Me=Math.min(J.length,pe.length);for(Se=0;Se<Me;Se++)if(J.charCodeAt(Se)!==pe.charCodeAt(Se))return Se;return Me}e.commonPrefixLength=y;function H(J,pe){let Se,Me=Math.min(J.length,pe.length);const $e=J.length-1,Ye=pe.length-1;for(Se=0;Se<Me;Se++)if(J.charCodeAt($e-Se)!==pe.charCodeAt(Ye-Se))return Se;return Me}e.commonSuffixLength=H;function M(J){return 55296<=J&&J<=56319}e.isHighSurrogate=M;function j(J){return 56320<=J&&J<=57343}e.isLowSurrogate=j;function X(J,pe){return(J-55296<<10)+(pe-56320)+65536}e.computeCodePoint=X;function $(J,pe,Se){const Me=J.charCodeAt(Se);if(M(Me)&&Se+1<pe){const $e=J.charCodeAt(Se+1);if(j($e))return X(Me,$e)}return Me}e.getNextCodePoint=$;function U(J,pe){const Se=J.charCodeAt(pe-1);if(j(Se)&&pe>1){const Me=J.charCodeAt(pe-2);if(M(Me))return X(Me,Se)}return Se}class q{constructor(pe,Se=0){this._str=pe,this._len=pe.length,this._offset=Se}get offset(){return this._offset}setOffset(pe){this._offset=pe}prevCodePoint(){const pe=U(this._str,this._offset);return this._offset-=pe>=65536?2:1,pe}nextCodePoint(){const pe=$(this._str,this._len,this._offset);return this._offset+=pe>=65536?2:1,pe}eol(){return this._offset>=this._len}}e.CodePointIterator=q;class K{constructor(pe,Se=0){this._iterator=new q(pe,Se)}get offset(){return this._iterator.offset}nextGraphemeLength(){const pe=He.getInstance(),Se=this._iterator,Me=Se.offset;let $e=pe.getGraphemeBreakType(Se.nextCodePoint());for(;!Se.eol();){const Ye=Se.offset,lt=pe.getGraphemeBreakType(Se.nextCodePoint());if(ze($e,lt)){Se.setOffset(Ye);break}$e=lt}return Se.offset-Me}prevGraphemeLength(){const pe=He.getInstance(),Se=this._iterator,Me=Se.offset;let $e=pe.getGraphemeBreakType(Se.prevCodePoint());for(;Se.offset>0;){const Ye=Se.offset,lt=pe.getGraphemeBreakType(Se.prevCodePoint());if(ze(lt,$e)){Se.setOffset(Ye);break}$e=lt}return Me-Se.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=K;function G(J,pe){return new K(J,pe).nextGraphemeLength()}e.nextCharLength=G;function ee(J,pe){return new K(J,pe).prevGraphemeLength()}e.prevCharLength=ee;function oe(J,pe){pe>0&&j(J.charCodeAt(pe))&&pe--;const Se=pe+G(J,pe);return[Se-ee(J,Se),Se]}e.getCharContainingOffset=oe;const ue=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function Z(J){return ue.test(J)}e.containsRTL=Z;const Y=/^[\t\n\r\x20-\x7E]*$/;function se(J){return Y.test(J)}e.isBasicASCII=se,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function de(J){return e.UNUSUAL_LINE_TERMINATORS.test(J)}e.containsUnusualLineTerminators=de;function ge(J){return J>=11904&&J<=55215||J>=63744&&J<=64255||J>=65281&&J<=65374}e.isFullWidthCharacter=ge;function Te(J){return J>=127462&&J<=127487||J===8986||J===8987||J===9200||J===9203||J>=9728&&J<=10175||J===11088||J===11093||J>=127744&&J<=128591||J>=128640&&J<=128764||J>=128992&&J<=129008||J>=129280&&J<=129535||J>=129648&&J<=129782}e.isEmojiImprecise=Te;function Ne(J,pe){if(J.length<pe)return J;const Se=/\b/g;let Me=0;for(;Se.test(J)&&!(J.length-Se.lastIndex<pe);)Me=Se.lastIndex,Se.lastIndex+=1;return J.substring(Me).replace(/^\s/,"")}e.lcut=Ne;const be=/\x1B\x5B[12]?K/g,Ee=/\x1b\[\d+m/g,z=/\x1b\[0?m/g;function B(J){return J&&(J=J.replace(be,""),J=J.replace(Ee,""),J=J.replace(z,"")),J}e.removeAnsiEscapeCodes=B,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function N(J){return!!(J&&J.length>0&&J.charCodeAt(0)===65279)}e.startsWithUTF8BOM=N;function W(J){return N(J)?J.substr(1):J}e.stripUTF8BOM=W;function V(J,pe){if(!J||!pe||J.length<pe.length)return!1;const Se=pe.length,Me=J.toLowerCase();let $e=0,Ye=-1;for(;$e<Se;){const lt=Me.indexOf(pe[$e],Ye+1);if(lt<0)return!1;Ye=lt,$e++}return!0}e.fuzzyContains=V;function re(J,pe=!1){return J?(pe&&(J=J.replace(/\\./g,"")),J.toLowerCase()!==J):!1}e.containsUppercaseCharacter=re;function he(J){return J.charAt(0).toUpperCase()+J.slice(1)}e.uppercaseFirstLetter=he;function Ce(J,pe=1){if(pe===0)return"";let Se=-1;do Se=J.indexOf(`
`,Se+1),pe--;while(pe>0&&Se>=0);return Se===-1?J:(J[Se-1]==="\r"&&Se--,J.substr(0,Se))}e.getNLines=Ce;function Ae(J){const pe=90-65+1;return J=J%(2*pe),J<pe?String.fromCharCode(97+J):String.fromCharCode(65+J-pe)}e.singleLetterHash=Ae;function We(J){return He.getInstance().getGraphemeBreakType(J)}e.getGraphemeBreakType=We;function ze(J,pe){return J===0?pe!==5&&pe!==7:J===2&&pe===3?!1:J===4||J===2||J===3||pe===4||pe===2||pe===3?!0:!(J===8&&(pe===8||pe===9||pe===11||pe===12)||(J===11||J===9)&&(pe===9||pe===10)||(J===12||J===10)&&pe===10||pe===5||pe===13||pe===7||J===1||J===13&&pe===14||J===6&&pe===6)}var qe;(function(J){J[J.Other=0]="Other",J[J.Prepend=1]="Prepend",J[J.CR=2]="CR",J[J.LF=3]="LF",J[J.Control=4]="Control",J[J.Extend=5]="Extend",J[J.Regional_Indicator=6]="Regional_Indicator",J[J.SpacingMark=7]="SpacingMark",J[J.L=8]="L",J[J.V=9]="V",J[J.T=10]="T",J[J.LV=11]="LV",J[J.LVT=12]="LVT",J[J.ZWJ=13]="ZWJ",J[J.Extended_Pictographic=14]="Extended_Pictographic"})(qe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class He{constructor(){this._data=Ue()}static getInstance(){return He._INSTANCE||(He._INSTANCE=new He),He._INSTANCE}getGraphemeBreakType(pe){if(pe<32)return pe===10?3:pe===13?2:4;if(pe<127)return 0;const Se=this._data,Me=Se.length/3;let $e=1;for(;$e<=Me;)if(pe<Se[3*$e])$e=2*$e;else if(pe>Se[3*$e+1])$e=2*$e+1;else return Se[3*$e+2];return 0}}He._INSTANCE=null;function Ue(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Je(J,pe){if(J===0)return 0;const Se=et(J,pe);if(Se!==void 0)return Se;const Me=new q(pe,J);return Me.prevCodePoint(),Me.offset}e.getLeftDeleteOffset=Je;function et(J,pe){const Se=new q(pe,J);let Me=Se.prevCodePoint();for(;Le(Me)||Me===65039||Me===8419;){if(Se.offset===0)return;Me=Se.prevCodePoint()}if(!Te(Me))return;let $e=Se.offset;return $e>0&&Se.prevCodePoint()===8205&&($e=Se.offset),$e}function Le(J){return 127995<=J&&J<=127999}var it;(function(J){J[J.zwj=8205]="zwj",J[J.emojiVariantSelector=65039]="emojiVariantSelector",J[J.enclosingKeyCap=8419]="enclosingKeyCap"})(it||(it={})),e.noBreakWhitespace="\xA0";class ne{constructor(pe){this.confusableDictionary=pe}static getInstance(pe){return ne.cache.get(Array.from(pe))}static getLocales(){return ne._locales.getValue()}isAmbiguous(pe){return this.confusableDictionary.has(pe)}getPrimaryConfusable(pe){return this.confusableDictionary.get(pe)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=ne,I=ne,ne.ambiguousCharacterData=new i.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),ne.cache=new f.LRUCachedComputed(J=>{function pe(je){const st=new Map;for(let _t=0;_t<je.length;_t+=2)st.set(je[_t],je[_t+1]);return st}function Se(je,st){const _t=new Map(je);for(const[nt,ct]of st)_t.set(nt,ct);return _t}function Me(je,st){if(!je)return st;const _t=new Map;for(const[nt,ct]of je)st.has(nt)&&_t.set(nt,ct);return _t}const $e=I.ambiguousCharacterData.getValue();let Ye=J.filter(je=>!je.startsWith("_")&&je in $e);Ye.length===0&&(Ye=["_default"]);let lt;for(const je of Ye){const st=pe($e[je]);lt=Me(lt,st)}const vt=pe($e._common),wt=Se(vt,lt);return new ne(wt)}),ne._locales=new i.Lazy(()=>Object.keys(ne.ambiguousCharacterData.getValue()).filter(J=>!J.startsWith("_")));class ae{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(ae.getRawData())),this._data}static isInvisibleCharacter(pe){return ae.getData().has(pe)}static get codePoints(){return ae.getData()}}e.InvisibleCharacters=ae,ae._data=void 0}),define(ve[57],we([1,0,8]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function i(P){return I(P,0)}e.hash=i;function I(P,_){switch(typeof P){case"object":return P===null?A(349,_):Array.isArray(P)?S(P,_):R(P,_);case"string":return k(P,_);case"boolean":return C(P,_);case"number":return A(P,_);case"undefined":return A(937,_);default:return A(617,_)}}e.doHash=I;function A(P,_){return(_<<5)-_+P|0}e.numberHash=A;function C(P,_){return A(P?433:863,_)}function k(P,_){_=A(149417,_);for(let l=0,c=P.length;l<c;l++)_=A(P.charCodeAt(l),_);return _}e.stringHash=k;function S(P,_){return _=A(104579,_),P.reduce((l,c)=>I(c,l),_)}function R(P,_){return _=A(181387,_),Object.keys(P).sort().reduce((l,c)=>(l=k(c,l),I(P[c],l)),_)}class F{constructor(){this._value=0}get value(){return this._value}hash(_){return this._value=I(_,this._value),this._value}}e.Hasher=F;var D;(function(P){P[P.BLOCK_SIZE=64]="BLOCK_SIZE",P[P.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(D||(D={}));function v(P,_,l=32){const c=l-_,u=~((1<<c)-1);return(P<<_|(u&P)>>>c)>>>0}function b(P,_=0,l=P.byteLength,c=0){for(let u=0;u<l;u++)P[_+u]=c}function g(P,_,l="0"){for(;P.length<_;)P=l+P;return P}function d(P,_=32){return P instanceof ArrayBuffer?Array.from(new Uint8Array(P)).map(l=>l.toString(16).padStart(2,"0")).join(""):g((P>>>0).toString(16),_/4)}e.toHexString=d;class p{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(_){const l=_.length;if(l===0)return;const c=this._buff;let u=this._buffLen,a=this._leftoverHighSurrogate,E,s;for(a!==0?(E=a,s=-1,a=0):(E=_.charCodeAt(0),s=0);;){let t=E;if(f.isHighSurrogate(E))if(s+1<l){const r=_.charCodeAt(s+1);f.isLowSurrogate(r)?(s++,t=f.computeCodePoint(E,r)):t=65533}else{a=E;break}else f.isLowSurrogate(E)&&(t=65533);if(u=this._push(c,u,t),s++,s<l)E=_.charCodeAt(s);else break}this._buffLen=u,this._leftoverHighSurrogate=a}_push(_,l,c){return c<128?_[l++]=c:c<2048?(_[l++]=192|(c&1984)>>>6,_[l++]=128|(c&63)>>>0):c<65536?(_[l++]=224|(c&61440)>>>12,_[l++]=128|(c&4032)>>>6,_[l++]=128|(c&63)>>>0):(_[l++]=240|(c&1835008)>>>18,_[l++]=128|(c&258048)>>>12,_[l++]=128|(c&4032)>>>6,_[l++]=128|(c&63)>>>0),l>=64&&(this._step(),l-=64,this._totalLen+=64,_[0]=_[64+0],_[1]=_[64+1],_[2]=_[64+2]),l}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),d(this._h0)+d(this._h1)+d(this._h2)+d(this._h3)+d(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,b(this._buff,this._buffLen),this._buffLen>56&&(this._step(),b(this._buff));const _=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(_/4294967296),!1),this._buffDV.setUint32(60,_%4294967296,!1),this._step()}_step(){const _=p._bigBlock32,l=this._buffDV;for(let o=0;o<64;o+=4)_.setUint32(o,l.getUint32(o,!1),!1);for(let o=64;o<320;o+=4)_.setUint32(o,v(_.getUint32(o-12,!1)^_.getUint32(o-32,!1)^_.getUint32(o-56,!1)^_.getUint32(o-64,!1),1),!1);let c=this._h0,u=this._h1,a=this._h2,E=this._h3,s=this._h4,t,r,n;for(let o=0;o<80;o++)o<20?(t=u&a|~u&E,r=1518500249):o<40?(t=u^a^E,r=1859775393):o<60?(t=u&a|u&E|a&E,r=2400959708):(t=u^a^E,r=3395469782),n=v(c,5)+t+s+r+_.getUint32(o*4,!1)&4294967295,s=E,E=a,a=v(u,30),u=c,c=n;this._h0=this._h0+c&4294967295,this._h1=this._h1+u&4294967295,this._h2=this._h2+a&4294967295,this._h3=this._h3+E&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=p,p._bigBlock32=new DataView(new ArrayBuffer(320))});var Xe=this&&this.__classPrivateFieldSet||function(te,e,f,i,I){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!I:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?I.call(te,f):I?I.value=f:e.set(te,f),f},Pe=this&&this.__classPrivateFieldGet||function(te,e,f,i){if(f==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!i:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?i:f==="a"?i.call(te):i?i.value:e.get(te)};define(ve[24],we([1,0,18,8]),function(te,e,f,i){"use strict";var I,A,C;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function k(s,t,r){let n=s.get(t);return n===void 0&&(n=r,s.set(t,n)),n}e.getOrSet=k;function S(s){const t=[];return s.forEach((r,n)=>{t.push(`${n} => ${r}`)}),`Map(${s.size}) {${t.join(", ")}}`}e.mapToString=S;function R(s){const t=[];return s.forEach(r=>{t.push(r)}),`Set(${s.size}) {${t.join(", ")}}`}e.setToString=R;class F{constructor(){this._value="",this._pos=0}reset(t){return this._value=t,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(t){const r=t.charCodeAt(0),n=this._value.charCodeAt(this._pos);return r-n}value(){return this._value[this._pos]}}e.StringIterator=F;class D{constructor(t=!0){this._caseSensitive=t}reset(t){return this._value=t,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(t)this._from++;else break;else t=!1;return this}cmp(t){return this._caseSensitive?(0,i.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,i.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=D;class v{constructor(t=!0,r=!0){this._splitOnBackslash=t,this._caseSensitive=r}reset(t){this._from=0,this._to=0,this._value=t,this._valueLen=t.length;for(let r=t.length-1;r>=0;r--,this._valueLen--){const n=this._value.charCodeAt(r);if(!(n===47||this._splitOnBackslash&&n===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let t=!0;for(;this._to<this._valueLen;this._to++){const r=this._value.charCodeAt(this._to);if(r===47||this._splitOnBackslash&&r===92)if(t)this._from++;else break;else t=!1}return this}cmp(t){return this._caseSensitive?(0,i.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,i.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=v;var b;(function(s){s[s.Scheme=1]="Scheme",s[s.Authority=2]="Authority",s[s.Path=3]="Path",s[s.Query=4]="Query",s[s.Fragment=5]="Fragment"})(b||(b={}));class g{constructor(t){this._ignorePathCasing=t,this._states=[],this._stateIdx=0}reset(t){return this._value=t,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new v(!1,!this._ignorePathCasing(t)),this._pathIterator.reset(t.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(t){if(this._states[this._stateIdx]===1)return(0,i.compareIgnoreCase)(t,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,i.compareIgnoreCase)(t,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(t);if(this._states[this._stateIdx]===4)return(0,i.compare)(t,this._value.query);if(this._states[this._stateIdx]===5)return(0,i.compare)(t,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=g;class d{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const t=this.right;return this.right=t.left,t.left=this,this.updateHeight(),t.updateHeight(),t}rotateRight(){const t=this.left;return this.left=t.right,t.right=this,this.updateHeight(),t.updateHeight(),t}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var p;(function(s){s[s.Left=-1]="Left",s[s.Mid=0]="Mid",s[s.Right=1]="Right"})(p||(p={}));class P{constructor(t){this._iter=t}static forUris(t=()=>!1){return new P(new g(t))}static forPaths(t=!1){return new P(new v(void 0,!t))}static forStrings(){return new P(new F)}static forConfigKeys(){return new P(new D)}clear(){this._root=void 0}fill(t,r){if(r){const n=r.slice(0);(0,f.shuffle)(n);for(let o of n)this.set(o,t)}else{const n=t.slice(0);(0,f.shuffle)(n);for(let o of n)this.set(o[0],o[1])}}set(t,r){const n=this._iter.reset(t);let o;this._root||(this._root=new d,this._root.segment=n.value());const m=[];for(o=this._root;;){const w=n.cmp(o.segment);if(w>0)o.left||(o.left=new d,o.left.segment=n.value()),m.push([-1,o]),o=o.left;else if(w<0)o.right||(o.right=new d,o.right.segment=n.value()),m.push([1,o]),o=o.right;else if(n.hasNext())n.next(),o.mid||(o.mid=new d,o.mid.segment=n.value()),m.push([0,o]),o=o.mid;else break}const h=o.value;o.value=r,o.key=t;for(let w=m.length-1;w>=0;w--){const T=m[w][1];T.updateHeight();const L=T.balanceFactor();if(L<-1||L>1){const O=m[w][0],y=m[w+1][0];if(O===1&&y===1)m[w][1]=T.rotateLeft();else if(O===-1&&y===-1)m[w][1]=T.rotateRight();else if(O===1&&y===-1)T.right=m[w+1][1]=m[w+1][1].rotateRight(),m[w][1]=T.rotateLeft();else if(O===-1&&y===1)T.left=m[w+1][1]=m[w+1][1].rotateLeft(),m[w][1]=T.rotateRight();else throw new Error;if(w>0)switch(m[w-1][0]){case-1:m[w-1][1].left=m[w][1];break;case 1:m[w-1][1].right=m[w][1];break;case 0:m[w-1][1].mid=m[w][1];break}else this._root=m[0][1]}}return h}get(t){return this._getNode(t)?.value}_getNode(t){const r=this._iter.reset(t);let n=this._root;for(;n;){const o=r.cmp(n.segment);if(o>0)n=n.left;else if(o<0)n=n.right;else if(r.hasNext())r.next(),n=n.mid;else break}return n}has(t){const r=this._getNode(t);return!(r?.value===void 0&&r?.mid===void 0)}delete(t){return this._delete(t,!1)}deleteSuperstr(t){return this._delete(t,!0)}_delete(t,r){const n=this._iter.reset(t),o=[];let m=this._root;for(;m;){const h=n.cmp(m.segment);if(h>0)o.push([-1,m]),m=m.left;else if(h<0)o.push([1,m]),m=m.right;else if(n.hasNext())n.next(),o.push([0,m]),m=m.mid;else break}if(!!m){if(r?(m.left=void 0,m.mid=void 0,m.right=void 0,m.height=1):(m.key=void 0,m.value=void 0),!m.mid&&!m.value)if(m.left&&m.right){const h=this._min(m.right),{key:w,value:T,segment:L}=h;this._delete(h.key,!1),m.key=w,m.value=T,m.segment=L}else{const h=m.left??m.right;if(o.length>0){const[w,T]=o[o.length-1];switch(w){case-1:T.left=h;break;case 0:T.mid=h;break;case 1:T.right=h;break}}else this._root=h}for(let h=o.length-1;h>=0;h--){const w=o[h][1];w.updateHeight();const T=w.balanceFactor();if(T>1?(w.right.balanceFactor()>=0||(w.right=w.right.rotateRight()),o[h][1]=w.rotateLeft()):T<-1&&(w.left.balanceFactor()<=0||(w.left=w.left.rotateLeft()),o[h][1]=w.rotateRight()),h>0)switch(o[h-1][0]){case-1:o[h-1][1].left=o[h][1];break;case 1:o[h-1][1].right=o[h][1];break;case 0:o[h-1][1].mid=o[h][1];break}else this._root=o[0][1]}}}_min(t){for(;t.left;)t=t.left;return t}findSubstr(t){const r=this._iter.reset(t);let n=this._root,o;for(;n;){const m=r.cmp(n.segment);if(m>0)n=n.left;else if(m<0)n=n.right;else if(r.hasNext())r.next(),o=n.value||o,n=n.mid;else break}return n&&n.value||o}findSuperstr(t){const r=this._iter.reset(t);let n=this._root;for(;n;){const o=r.cmp(n.segment);if(o>0)n=n.left;else if(o<0)n=n.right;else if(r.hasNext())r.next(),n=n.mid;else return n.mid?this._entries(n.mid):void 0}}forEach(t){for(const[r,n]of this)t(n,r)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(t){!t||(t.left&&(yield*this._entries(t.left)),t.value&&(yield[t.key,t.value]),t.mid&&(yield*this._entries(t.mid)),t.right&&(yield*this._entries(t.right)))}_isBalanced(){const t=r=>{if(!r)return!0;const n=r.balanceFactor();return n<-1||n>1?!1:t(r.left)&&t(r.right)};return t(this._root)}}e.TernarySearchTree=P;class _{constructor(t,r){this.uri=t,this.value=r}}class l{constructor(t,r){this[I]="ResourceMap",t instanceof l?(this.map=new Map(t.map),this.toKey=r??l.defaultToKey):(this.map=new Map,this.toKey=t??l.defaultToKey)}set(t,r){return this.map.set(this.toKey(t),new _(t,r)),this}get(t){return this.map.get(this.toKey(t))?.value}has(t){return this.map.has(this.toKey(t))}get size(){return this.map.size}clear(){this.map.clear()}delete(t){return this.map.delete(this.toKey(t))}forEach(t,r){typeof r!="undefined"&&(t=t.bind(r));for(let[n,o]of this.map)t(o.value,o.uri,this)}*values(){for(let t of this.map.values())yield t.value}*keys(){for(let t of this.map.values())yield t.uri}*entries(){for(let t of this.map.values())yield[t.uri,t.value]}*[(I=Symbol.toStringTag,Symbol.iterator)](){for(let[,t]of this.map)yield[t.uri,t.value]}}e.ResourceMap=l,l.defaultToKey=s=>s.toString();var c;(function(s){s[s.None=0]="None",s[s.AsOld=1]="AsOld",s[s.AsNew=2]="AsNew"})(c=e.Touch||(e.Touch={}));class u{constructor(){this[A]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(t){return this._map.has(t)}get(t,r=0){const n=this._map.get(t);if(!!n)return r!==0&&this.touch(n,r),n.value}set(t,r,n=0){let o=this._map.get(t);if(o)o.value=r,n!==0&&this.touch(o,n);else{switch(o={key:t,value:r,next:void 0,previous:void 0},n){case 0:this.addItemLast(o);break;case 1:this.addItemFirst(o);break;case 2:this.addItemLast(o);break;default:this.addItemLast(o);break}this._map.set(t,o),this._size++}return this}delete(t){return!!this.remove(t)}remove(t){const r=this._map.get(t);if(!!r)return this._map.delete(t),this.removeItem(r),this._size--,r.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}forEach(t,r){const n=this._state;let o=this._head;for(;o;){if(r?t.bind(r)(o.value,o.key,this):t(o.value,o.key,this),this._state!==n)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const t=this,r=this._state;let n=this._head;const o={[Symbol.iterator](){return o},next(){if(t._state!==r)throw new Error("LinkedMap got modified during iteration.");if(n){const m={value:n.key,done:!1};return n=n.next,m}else return{value:void 0,done:!0}}};return o}values(){const t=this,r=this._state;let n=this._head;const o={[Symbol.iterator](){return o},next(){if(t._state!==r)throw new Error("LinkedMap got modified during iteration.");if(n){const m={value:n.value,done:!1};return n=n.next,m}else return{value:void 0,done:!0}}};return o}entries(){const t=this,r=this._state;let n=this._head;const o={[Symbol.iterator](){return o},next(){if(t._state!==r)throw new Error("LinkedMap got modified during iteration.");if(n){const m={value:[n.key,n.value],done:!1};return n=n.next,m}else return{value:void 0,done:!0}}};return o}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(t>=this.size)return;if(t===0){this.clear();return}let r=this._head,n=this.size;for(;r&&n>t;)this._map.delete(r.key),r=r.next,n--;this._head=r,this._size=n,r&&(r.previous=void 0),this._state++}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous}else{const r=t.next,n=t.previous;if(!r||!n)throw new Error("Invalid list");r.previous=n,n.next=r}t.next=void 0,t.previous=void 0,this._state++}touch(t,r){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(t===this._head)return;const n=t.next,o=t.previous;t===this._tail?(o.next=void 0,this._tail=o):(n.previous=o,o.next=n),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++}else if(r===2){if(t===this._tail)return;const n=t.next,o=t.previous;t===this._head?(n.previous=void 0,this._head=n):(n.previous=o,o.next=n),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++}}}toJSON(){const t=[];return this.forEach((r,n)=>{t.push([n,r])}),t}fromJSON(t){this.clear();for(const[r,n]of t)this.set(r,n)}}e.LinkedMap=u;class a extends u{constructor(t,r=1){super();this._limit=t,this._ratio=Math.min(Math.max(0,r),1)}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim()}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim()}get(t,r=2){return super.get(t,r)}peek(t){return super.get(t,0)}set(t,r){return super.set(t,r,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=a;class E{constructor(t){C.set(this,void 0),Xe(this,C,t,"f")}get size(){return Pe(this,C,"f").size}forEach(t,r){Pe(this,C,"f").forEach(t,r)}get(t){return Pe(this,C,"f").get(t)}has(t){return Pe(this,C,"f").has(t)}entries(){return Pe(this,C,"f").entries()}keys(){return Pe(this,C,"f").keys()}values(){return Pe(this,C,"f").values()}[(C=new WeakMap,Symbol.iterator)](){return Pe(this,C,"f").entries()}}e.ReadonlyMapView=E}),define(ve[95],we([1,0,24,8]),function(te,e,f,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function I(...N){return function(W,V){for(let re=0,he=N.length;re<he;re++){const Ce=N[re](W,V);if(Ce)return Ce}return null}}e.or=I,e.matchesStrictPrefix=A.bind(void 0,!1),e.matchesPrefix=A.bind(void 0,!0);function A(N,W,V){if(!V||V.length<W.length)return null;let re;return N?re=i.startsWithIgnoreCase(V,W):re=V.indexOf(W)===0,re?W.length>0?[{start:0,end:W.length}]:[]:null}function C(N,W){const V=W.toLowerCase().indexOf(N.toLowerCase());return V===-1?null:[{start:V,end:V+N.length}]}e.matchesContiguousSubString=C;function k(N,W){return S(N.toLowerCase(),W.toLowerCase(),0,0)}e.matchesSubString=k;function S(N,W,V,re){if(V===N.length)return[];if(re===W.length)return null;if(N[V]===W[re]){let he=null;return(he=S(N,W,V+1,re+1))?P({start:re,end:re+1},he):null}return S(N,W,V,re+1)}function R(N){return 97<=N&&N<=122}function F(N){return 65<=N&&N<=90}e.isUpper=F;function D(N){return 48<=N&&N<=57}function v(N){return N===32||N===9||N===10||N===13}const b=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(N=>b.add(N.charCodeAt(0)));function g(N){return v(N)||b.has(N)}function d(N,W){return N===W||g(N)&&g(W)}function p(N){return R(N)||F(N)||D(N)}function P(N,W){return W.length===0?W=[N]:N.end===W[0].start?W[0].start=N.start:W.unshift(N),W}function _(N,W){for(let V=W;V<N.length;V++){const re=N.charCodeAt(V);if(F(re)||D(re)||V>0&&!p(N.charCodeAt(V-1)))return V}return N.length}function l(N,W,V,re){if(V===N.length)return[];if(re===W.length)return null;if(N[V]!==W[re].toLowerCase())return null;{let he=null,Ce=re+1;for(he=l(N,W,V+1,re+1);!he&&(Ce=_(W,Ce))<W.length;)he=l(N,W,V+1,Ce),Ce++;return he===null?null:P({start:re,end:re+1},he)}}function c(N){let W=0,V=0,re=0,he=0,Ce=0;for(let He=0;He<N.length;He++)Ce=N.charCodeAt(He),F(Ce)&&W++,R(Ce)&&V++,p(Ce)&&re++,D(Ce)&&he++;const Ae=W/N.length,We=V/N.length,ze=re/N.length,qe=he/N.length;return{upperPercent:Ae,lowerPercent:We,alphaPercent:ze,numericPercent:qe}}function u(N){const{upperPercent:W,lowerPercent:V}=N;return V===0&&W>.6}function a(N){const{upperPercent:W,lowerPercent:V,alphaPercent:re,numericPercent:he}=N;return V>.2&&W<.8&&re>.6&&he<.2}function E(N){let W=0,V=0,re=0,he=0;for(let Ce=0;Ce<N.length;Ce++)re=N.charCodeAt(Ce),F(re)&&W++,R(re)&&V++,v(re)&&he++;return(W===0||V===0)&&he===0?N.length<=30:W<=5}function s(N,W){if(!W||(W=W.trim(),W.length===0)||!E(N)||W.length>60)return null;const V=c(W);if(!a(V)){if(!u(V))return null;W=W.toLowerCase()}let re=null,he=0;for(N=N.toLowerCase();he<W.length&&(re=l(N,W,0,he))===null;)he=_(W,he+1);return re}e.matchesCamelCase=s;function t(N,W,V=!1){if(!W||W.length===0)return null;let re=null,he=0;for(N=N.toLowerCase(),W=W.toLowerCase();he<W.length&&(re=r(N,W,0,he,V))===null;)he=n(W,he+1);return re}e.matchesWords=t;function r(N,W,V,re,he){if(V===N.length)return[];if(re===W.length)return null;if(d(N.charCodeAt(V),W.charCodeAt(re))){let Ce=null,Ae=re+1;if(Ce=r(N,W,V+1,re+1,he),!he)for(;!Ce&&(Ae=n(W,Ae))<W.length;)Ce=r(N,W,V+1,Ae,he),Ae++;return Ce===null?null:P({start:re,end:re+1},Ce)}else return null}function n(N,W){for(let V=W;V<N.length;V++)if(g(N.charCodeAt(V))||V>0&&g(N.charCodeAt(V-1)))return V;return N.length}const o=I(e.matchesPrefix,s,C),m=I(e.matchesPrefix,s,k),h=new f.LRUCache(1e4);function w(N,W,V=!1){if(typeof N!="string"||typeof W!="string")return null;let re=h.get(N);re||(re=new RegExp(i.convertSimple2RegExpPattern(N),"i"),h.set(N,re));const he=re.exec(W);return he?[{start:he.index,end:he.index+he[0].length}]:V?m(N,W):o(N,W)}e.matchesFuzzy=w;function T(N,W){const V=ge(N,N.toLowerCase(),0,W,W.toLowerCase(),0,!0);return V?O(V):null}e.matchesFuzzy2=T;function L(N,W,V,re,he,Ce){const Ae=Math.min(13,N.length);for(;V<Ae;V++){const We=ge(N,W,V,re,he,Ce,!1);if(We)return We}return[0,Ce]}e.anyScore=L;function O(N){if(typeof N=="undefined")return[];const W=[],V=N[1];for(let re=N.length-1;re>1;re--){const he=N[re]+V,Ce=W[W.length-1];Ce&&Ce.end===he?Ce.end=he+1:W.push({start:he,end:he+1})}return W}e.createMatches=O;const y=128;function H(){const N=[],W=[];for(let V=0;V<=y;V++)W[V]=0;for(let V=0;V<=y;V++)N.push(W.slice(0));return N}function M(N){const W=[];for(let V=0;V<=N;V++)W[V]=0;return W}const j=M(2*y),X=M(2*y),$=H(),U=H(),q=H(),K=!1;function G(N,W,V,re,he){function Ce(We,ze,qe=" "){for(;We.length<ze;)We=qe+We;return We}let Ae=` |   |${re.split("").map(We=>Ce(We,3)).join("|")}
`;for(let We=0;We<=V;We++)We===0?Ae+=" |":Ae+=`${W[We-1]}|`,Ae+=N[We].slice(0,he+1).map(ze=>Ce(ze.toString(),3)).join("|")+`
`;return Ae}function ee(N,W,V,re){N=N.substr(W),V=V.substr(re),console.log(G(U,N,N.length,V,V.length)),console.log(G(q,N,N.length,V,V.length)),console.log(G($,N,N.length,V,V.length))}function oe(N,W){if(W<0||W>=N.length)return!1;const V=N.codePointAt(W);switch(V){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!i.isEmojiImprecise(V)}}function ue(N,W){if(W<0||W>=N.length)return!1;switch(N.charCodeAt(W)){case 32:case 9:return!0;default:return!1}}function Z(N,W,V){return W[N]!==V[N]}function Y(N,W,V,re,he,Ce,Ae=!1){for(;W<V&&he<Ce;)N[W]===re[he]&&(Ae&&(j[W]=he),W+=1),he+=1;return W===V}e.isPatternInWord=Y;var se;(function(N){N[N.Diag=1]="Diag",N[N.Left=2]="Left",N[N.LeftLeft=3]="LeftLeft"})(se||(se={}));var de;(function(N){N.Default=[-100,0];function W(V){return!V||V.length===2&&V[0]===-100&&V[1]===0}N.isDefault=W})(de=e.FuzzyScore||(e.FuzzyScore={}));function ge(N,W,V,re,he,Ce,Ae){const We=N.length>y?y:N.length,ze=re.length>y?y:re.length;if(V>=We||Ce>=ze||We-V>ze-Ce||!Y(W,V,We,he,Ce,ze,!0))return;Te(We,ze,V,Ce,W,he);let qe=1,He=1,Ue=V,Je=Ce;const et=[!1];for(qe=1,Ue=V;Ue<We;qe++,Ue++){const J=j[Ue],pe=X[Ue],Se=Ue+1<We?X[Ue+1]:ze;for(He=J-Ce+1,Je=J;Je<Se;He++,Je++){let Me=Number.MIN_SAFE_INTEGER,$e=!1;Je<=pe&&(Me=Ne(N,W,Ue,V,re,he,Je,ze,Ce,$[qe-1][He-1]===0,et));let Ye=0;Me!==Number.MAX_SAFE_INTEGER&&($e=!0,Ye=Me+U[qe-1][He-1]);const lt=Je>J,vt=lt?U[qe][He-1]+($[qe][He-1]>0?-5:0):0,wt=Je>J+1&&$[qe][He-1]>0,je=wt?U[qe][He-2]+($[qe][He-2]>0?-5:0):0;if(wt&&(!lt||je>=vt)&&(!$e||je>=Ye))U[qe][He]=je,q[qe][He]=3,$[qe][He]=0;else if(lt&&(!$e||vt>=Ye))U[qe][He]=vt,q[qe][He]=2,$[qe][He]=0;else if($e)U[qe][He]=Ye,q[qe][He]=1,$[qe][He]=$[qe-1][He-1]+1;else throw new Error("not possible")}}if(K&&ee(N,V,re,Ce),!et[0]&&!Ae)return;qe--,He--;const Le=[U[qe][He],Ce];let it=0,ne=0;for(;qe>=1;){let J=He;do{const pe=q[qe][J];if(pe===3)J=J-2;else if(pe===2)J=J-1;else break}while(J>=1);it>1&&W[V+qe-1]===he[Ce+He-1]&&!Z(J+Ce-1,re,he)&&it+1>$[qe][J]&&(J=He),J===He?it++:it=1,ne||(ne=J),qe--,He=J-1,Le.push(He)}ze===We&&(Le[0]+=2);const ae=ne-We;return Le[0]-=ae,Le}e.fuzzyScore=ge;function Te(N,W,V,re,he,Ce){let Ae=N-1,We=W-1;for(;Ae>=V&&We>=re;)he[Ae]===Ce[We]&&(X[Ae]=We,Ae--),We--}function Ne(N,W,V,re,he,Ce,Ae,We,ze,qe,He){if(W[V]!==Ce[Ae])return Number.MIN_SAFE_INTEGER;let Ue=1,Je=!1;return Ae===V-re?Ue=N[V]===he[Ae]?7:5:Z(Ae,he,Ce)&&(Ae===0||!Z(Ae-1,he,Ce))?(Ue=N[V]===he[Ae]?7:5,Je=!0):oe(Ce,Ae)&&(Ae===0||!oe(Ce,Ae-1))?Ue=5:(oe(Ce,Ae-1)||ue(Ce,Ae-1))&&(Ue=5,Je=!0),Ue>1&&V===re&&(He[0]=!0),Je||(Je=Z(Ae,he,Ce)||oe(Ce,Ae-1)||ue(Ce,Ae-1)),V===re?Ae>ze&&(Ue-=Je?3:5):qe?Ue+=Je?2:0:Ue+=Je?0:1,Ae+1===We&&(Ue-=Je?3:5),Ue}function be(N,W,V,re,he,Ce,Ae){return z(N,W,V,re,he,Ce,!0,Ae)}e.fuzzyScoreGracefulAggressive=be;function Ee(N,W,V,re,he,Ce,Ae){return z(N,W,V,re,he,Ce,!1,Ae)}e.fuzzyScoreGraceful=Ee;function z(N,W,V,re,he,Ce,Ae,We){let ze=ge(N,W,V,re,he,Ce,We);if(ze&&!Ae)return ze;if(N.length>=3){const qe=Math.min(7,N.length-1);for(let He=V+1;He<qe;He++){const Ue=B(N,He);if(Ue){const Je=ge(Ue,Ue.toLowerCase(),V,re,he,Ce,We);Je&&(Je[0]-=3,(!ze||Je[0]>ze[0])&&(ze=Je))}}}return ze}function B(N,W){if(W+1>=N.length)return;const V=N[W],re=N[W+1];if(V!==re)return N.slice(0,W)+re+V+N.slice(W+2)}}),define(ve[144],we([1,0,72,95,8]),function(te,e,f,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const A=new RegExp(`\\$\\(${f.CSSIcon.iconNameExpression}(?:${f.CSSIcon.iconModifierExpression})?\\)`,"g"),C=new RegExp(f.CSSIcon.iconNameCharacter),k=new RegExp(`(\\\\)?${A.source}`,"g");function S(p){return p.replace(k,(P,_)=>_?P:`\\${P}`)}e.escapeIcons=S;const R=new RegExp(`\\\\${A.source}`,"g");function F(p){return p.replace(R,P=>`\\${P}`)}e.markdownEscapeEscapedIcons=F;const D=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function v(p){return p.indexOf(e.iconStartMarker)===-1?p:p.replace(D,(P,_,l,c)=>l?P:_||c||"")}e.stripIcons=v;function b(p){const P=p.indexOf(e.iconStartMarker);return P===-1?{text:p}:g(p,P)}e.parseLabelWithIcons=b;function g(p,P){const _=[];let l="";function c(o){if(o){l+=o;for(const m of o)_.push(E)}}let u=-1,a="",E=0,s,t,r=P;const n=p.length;for(c(p.substr(0,P));r<n;)s=p[r],t=p[r+1],s===e.iconStartMarker[0]&&t===e.iconStartMarker[1]?(u=r,c(a),a=e.iconStartMarker,r++):s===")"&&u!==-1?(E+=r-u+1,u=-1,a=""):u!==-1?C.test(s)?a+=s:(c(a),u=-1,a=""):c(s),r++;return c(a),{text:l,iconOffsets:_}}function d(p,P,_=!1){const{text:l,iconOffsets:c}=P;if(!c||c.length===0)return(0,i.matchesFuzzy)(p,l,_);const u=(0,I.ltrim)(l," "),a=l.length-u.length,E=(0,i.matchesFuzzy)(p,u,_);if(E)for(const s of E){const t=c[s.start+a]+a;s.start+=t,s.end+=t}return E}e.matchesFuzzyIconAware=d}),define(ve[77],we([1,0,24]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const i=new f.LRUCache(1e4);function I(R){return S(R,"NFC",i)}e.normalizeNFC=I;const A=new f.LRUCache(1e4);function C(R){return S(R,"NFD",A)}e.normalizeNFD=C;const k=/[^\u0000-\u0080]/;function S(R,F,D){if(!R)return R;const v=D.get(R);if(v)return v;let b;return k.test(R)?b=R.normalize(F):b=R,D.set(R,b),b}e.removeAccents=function(){const R=/[\u0300-\u036f]/g;return function(F){return C(F).replace(R,"")}}()}),define(ve[47],we([1,0,8]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var i;(function(I){I[I.Ignore=0]="Ignore",I[I.Info=1]="Info",I[I.Warning=2]="Warning",I[I.Error=3]="Error"})(i||(i={})),function(I){const A="error",C="warning",k="warn",S="info",R="ignore";function F(v){return v?f.equalsIgnoreCase(A,v)?I.Error:f.equalsIgnoreCase(C,v)||f.equalsIgnoreCase(k,v)?I.Warning:f.equalsIgnoreCase(S,v)?I.Info:I.Ignore:I.Ignore}I.fromValue=F;function D(v){switch(v){case I.Error:return A;case I.Warning:return C;case I.Info:return S;default:return R}}I.toString=D}(i||(i={})),e.default=i}),define(ve[13],we([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function f(n){return Array.isArray(n)}e.isArray=f;function i(n){return typeof n=="string"}e.isString=i;function I(n){return Array.isArray(n)&&n.every(o=>i(o))}e.isStringArray=I;function A(n){return typeof n=="object"&&n!==null&&!Array.isArray(n)&&!(n instanceof RegExp)&&!(n instanceof Date)}e.isObject=A;function C(n){return typeof n=="number"&&!isNaN(n)}e.isNumber=C;function k(n){return!!n&&typeof n[Symbol.iterator]=="function"}e.isIterable=k;function S(n){return n===!0||n===!1}e.isBoolean=S;function R(n){return typeof n=="undefined"}e.isUndefined=R;function F(n){return!D(n)}e.isDefined=F;function D(n){return R(n)||n===null}e.isUndefinedOrNull=D;function v(n,o){if(!n)throw new Error(o?`Unexpected type, expected '${o}'`:"Unexpected type")}e.assertType=v;function b(n){if(D(n))throw new Error("Assertion Failed: argument is undefined or null");return n}e.assertIsDefined=b;function g(...n){const o=[];for(let m=0;m<n.length;m++){const h=n[m];if(D(h))throw new Error(`Assertion Failed: argument at index ${m} is undefined or null`);o.push(h)}return o}e.assertAllDefined=g;const d=Object.prototype.hasOwnProperty;function p(n){if(!A(n))return!1;for(let o in n)if(d.call(n,o))return!1;return!0}e.isEmptyObject=p;function P(n){return typeof n=="function"}e.isFunction=P;function _(...n){return n.length>0&&n.every(P)}e.areFunctions=_;function l(n,o){const m=Math.min(n.length,o.length);for(let h=0;h<m;h++)c(n[h],o[h])}e.validateConstraints=l;function c(n,o){if(i(o)){if(typeof n!==o)throw new Error(`argument does not match constraint: typeof ${o}`)}else if(P(o)){try{if(n instanceof o)return}catch{}if(!D(n)&&n.constructor===o||o.length===1&&o.call(void 0,n)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=c;function u(n){let o=[],m=Object.getPrototypeOf(n);for(;Object.prototype!==m;)o=o.concat(Object.getOwnPropertyNames(m)),m=Object.getPrototypeOf(m);return o}e.getAllPropertyNames=u;function a(n){const o=[];for(const m of u(n))typeof n[m]=="function"&&o.push(m);return o}e.getAllMethodNames=a;function E(n,o){const m=w=>function(){const T=Array.prototype.slice.call(arguments,0);return o(w,T)};let h={};for(const w of n)h[w]=m(w);return h}e.createProxyObject=E;function s(n){return n===null?void 0:n}e.withNullAsUndefined=s;function t(n){return typeof n=="undefined"?null:n}e.withUndefinedAsNull=t;function r(n,o="Unreachable"){throw new Error(o)}e.assertNever=r}),define(ve[29],we([1,0,9,12,8,13]),function(te,e,f,i,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function C(r){return r===47||r===92}e.isPathSeparator=C;function k(r){return r.replace(/[\\/]/g,f.posix.sep)}e.toSlashes=k;function S(r){return r.indexOf("/")===-1&&(r=k(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=S;function R(r,n=f.posix.sep){if(!r)return"";const o=r.length,m=r.charCodeAt(0);if(C(m)){if(C(r.charCodeAt(1))&&!C(r.charCodeAt(2))){let w=3;const T=w;for(;w<o&&!C(r.charCodeAt(w));w++);if(T!==w&&!C(r.charCodeAt(w+1))){for(w+=1;w<o;w++)if(C(r.charCodeAt(w)))return r.slice(0,w+1).replace(/[\\/]/g,n)}}return n}else if(P(m)&&r.charCodeAt(1)===58)return C(r.charCodeAt(2))?r.slice(0,2)+n:r.slice(0,2);let h=r.indexOf("://");if(h!==-1){for(h+=3;h<o;h++)if(C(r.charCodeAt(h)))return r.slice(0,h+1)}return""}e.getRoot=R;function F(r){if(!i.isWindows||!r||r.length<5)return!1;let n=r.charCodeAt(0);if(n!==92||(n=r.charCodeAt(1),n!==92))return!1;let o=2;const m=o;for(;o<r.length&&(n=r.charCodeAt(o),n!==92);o++);return!(m===o||(n=r.charCodeAt(o+1),isNaN(n)||n===92))}e.isUNC=F;const D=/[\\/:\*\?"<>\|]/g,v=/[\\/]/g,b=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function g(r,n=i.isWindows){const o=n?D:v;return!(!r||r.length===0||/^\s+$/.test(r)||(o.lastIndex=0,o.test(r))||n&&b.test(r)||r==="."||r===".."||n&&r[r.length-1]==="."||n&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=g;function d(r,n,o){const m=r===n;return!o||m?m:!r||!n?!1:(0,I.equalsIgnoreCase)(r,n)}e.isEqual=d;function p(r,n,o,m=f.sep){if(r===n)return!0;if(!r||!n||n.length>r.length)return!1;if(o){if(!(0,I.startsWithIgnoreCase)(r,n))return!1;if(n.length===r.length)return!0;let w=n.length;return n.charAt(n.length-1)===m&&w--,r.charAt(w)===m}return n.charAt(n.length-1)!==m&&(n+=m),r.indexOf(n)===0}e.isEqualOrParent=p;function P(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=P;function _(r,n){return i.isWindows&&r.endsWith(":")&&(r+=f.sep),(0,f.isAbsolute)(r)||(r=(0,f.join)(n,r)),r=(0,f.normalize)(r),i.isWindows?(r=(0,I.rtrim)(r,f.sep),r.endsWith(":")&&(r+=f.sep)):(r=(0,I.rtrim)(r,f.sep),r||(r=f.sep)),r}e.sanitizeFilePath=_;function l(r){const n=(0,f.normalize)(r);return i.isWindows?r.length>3?!1:c(n)&&(r.length===2||n.charCodeAt(2)===92):n===f.posix.sep}e.isRootOrDriveLetter=l;function c(r,n){return(n!==void 0?n:i.isWindows)?P(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=c;function u(r){return c(r)?r[0]:void 0}e.getDriveLetter=u;function a(r,n,o){return n.length>r.length?-1:r===n?0:(o&&(r=r.toLowerCase(),n=n.toLowerCase()),r.indexOf(n))}e.indexOfPath=a;function E(r){const n=r.split(":");let o,m,h;for(const w of n){const T=Number(w);(0,A.isNumber)(T)?m===void 0?m=T:h===void 0&&(h=T):o=o?[o,w].join(":"):w}if(!o)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:o,line:m!==void 0?m:void 0,column:h!==void 0?h:m!==void 0?1:void 0}}e.parseLineAndColumnAware=E;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function t(r,n,o=8){let m="";for(let w=0;w<o;w++)m+=s.charAt(Math.floor(Math.random()*s.length));let h;return n?h=`${n}-${m}`:h=m,r?(0,f.join)(r,h):h}e.randomPath=t}),define(ve[25],we([1,0,13]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function i(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const p=Array.isArray(d)?[]:{};return Object.keys(d).forEach(P=>{d[P]&&typeof d[P]=="object"?p[P]=i(d[P]):p[P]=d[P]}),p}e.deepClone=i;function I(d){if(!d||typeof d!="object")return d;const p=[d];for(;p.length>0;){const P=p.shift();Object.freeze(P);for(const _ in P)if(A.call(P,_)){const l=P[_];typeof l=="object"&&!Object.isFrozen(l)&&p.push(l)}}return d}e.deepFreeze=I;const A=Object.prototype.hasOwnProperty;function C(d,p){return k(d,p,new Set)}e.cloneAndChange=C;function k(d,p,P){if((0,f.isUndefinedOrNull)(d))return d;const _=p(d);if(typeof _!="undefined")return _;if((0,f.isArray)(d)){const l=[];for(const c of d)l.push(k(c,p,P));return l}if((0,f.isObject)(d)){if(P.has(d))throw new Error("Cannot clone recursive data-structure");P.add(d);const l={};for(let c in d)A.call(d,c)&&(l[c]=k(d[c],p,P));return P.delete(d),l}return d}function S(d,p,P=!0){return(0,f.isObject)(d)?((0,f.isObject)(p)&&Object.keys(p).forEach(_=>{_ in d?P&&((0,f.isObject)(d[_])&&(0,f.isObject)(p[_])?S(d[_],p[_],P):d[_]=p[_]):d[_]=p[_]}),d):p}e.mixin=S;function R(d,p){if(d===p)return!0;if(d==null||p===null||p===void 0||typeof d!=typeof p||typeof d!="object"||Array.isArray(d)!==Array.isArray(p))return!1;let P,_;if(Array.isArray(d)){if(d.length!==p.length)return!1;for(P=0;P<d.length;P++)if(!R(d[P],p[P]))return!1}else{const l=[];for(_ in d)l.push(_);l.sort();const c=[];for(_ in p)c.push(_);if(c.sort(),!R(l,c))return!1;for(P=0;P<l.length;P++)if(!R(d[l[P]],p[l[P]]))return!1}return!0}e.equals=R;function F(d){const p=new Set;return JSON.stringify(d,(P,_)=>{if((0,f.isObject)(_)||Array.isArray(_)){if(p.has(_))return"[Circular]";p.add(_)}return _})}e.safeStringify=F;function D(d,p,P){const _=p(d);return typeof _=="undefined"?P:_}e.getOrDefault=D;function v(d,p){const P=Object.create(null);return!d||!p||Object.keys(p).forEach(l=>{const c=d[l],u=p[l];R(c,u)||(P[l]=u)}),P}e.distinct=v;function b(d,p){const P=p.toLowerCase(),_=Object.keys(d).find(l=>l.toLowerCase()===P);return _?d[_]:d[p]}e.getCaseInsensitive=b;function g(d,p){const P=Object.create(null);for(const[_,l]of Object.entries(d))p(_,l)&&(P[_]=l);return P}e.filter=g}),define(ve[96],we([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var f;(function(A){A[A.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",A[A.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",A[A.MAX_UINT_8=255]="MAX_UINT_8",A[A.MAX_UINT_16=65535]="MAX_UINT_16",A[A.MAX_UINT_32=4294967295]="MAX_UINT_32",A[A.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(f=e.Constants||(e.Constants={}));function i(A){return A<0?0:A>255?255:A|0}e.toUint8=i;function I(A){return A<0?0:A>4294967295?4294967295:A|0}e.toUint32=I}),define(ve[2],we([1,0,9,12]),function(te,e,f,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const I=/^\w[\w\d+.-]*$/,A=/^\//,C=/^\/\//;function k(s,t){if(!s.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!I.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!A.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(C.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(s,t){return!s&&!t?"file":s}function R(s,t){switch(s){case"https":case"http":case"file":t?t[0]!==D&&(t=D+t):t=D;break}return t}const F="",D="/",v=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class b{constructor(t,r,n,o,m,h=!1){typeof t=="object"?(this.scheme=t.scheme||F,this.authority=t.authority||F,this.path=t.path||F,this.query=t.query||F,this.fragment=t.fragment||F):(this.scheme=S(t,h),this.authority=r||F,this.path=R(this.scheme,n||F),this.query=o||F,this.fragment=m||F,k(this,h))}static isUri(t){return t instanceof b?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}get fsPath(){return l(this,!1)}with(t){if(!t)return this;let{scheme:r,authority:n,path:o,query:m,fragment:h}=t;return r===void 0?r=this.scheme:r===null&&(r=F),n===void 0?n=this.authority:n===null&&(n=F),o===void 0?o=this.path:o===null&&(o=F),m===void 0?m=this.query:m===null&&(m=F),h===void 0?h=this.fragment:h===null&&(h=F),r===this.scheme&&n===this.authority&&o===this.path&&m===this.query&&h===this.fragment?this:new d(r,n,o,m,h)}static parse(t,r=!1){const n=v.exec(t);return n?new d(n[2]||F,E(n[4]||F),E(n[5]||F),E(n[7]||F),E(n[9]||F),r):new d(F,F,F,F,F)}static file(t){let r=F;if(i.isWindows&&(t=t.replace(/\\/g,D)),t[0]===D&&t[1]===D){const n=t.indexOf(D,2);n===-1?(r=t.substring(2),t=D):(r=t.substring(2,n),t=t.substring(n)||D)}return new d("file",r,t,F,F)}static from(t){const r=new d(t.scheme,t.authority,t.path,t.query,t.fragment);return k(r,!0),r}static joinPath(t,...r){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let n;return i.isWindows&&t.scheme==="file"?n=b.file(f.win32.join(l(t,!0),...r)).path:n=f.posix.join(t.path,...r),t.with({path:n})}toString(t=!1){return c(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof b)return t;{const r=new d(t);return r._formatted=t.external,r._fsPath=t._sep===g?t.fsPath:null,r}}else return t}}e.URI=b;const g=i.isWindows?1:void 0;class d extends b{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=l(this,!1)),this._fsPath}toString(t=!1){return t?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=g),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const p={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function P(s,t){let r,n=-1;for(let o=0;o<s.length;o++){const m=s.charCodeAt(o);if(m>=97&&m<=122||m>=65&&m<=90||m>=48&&m<=57||m===45||m===46||m===95||m===126||t&&m===47)n!==-1&&(r+=encodeURIComponent(s.substring(n,o)),n=-1),r!==void 0&&(r+=s.charAt(o));else{r===void 0&&(r=s.substr(0,o));const h=p[m];h!==void 0?(n!==-1&&(r+=encodeURIComponent(s.substring(n,o)),n=-1),r+=h):n===-1&&(n=o)}}return n!==-1&&(r+=encodeURIComponent(s.substring(n))),r!==void 0?r:s}function _(s){let t;for(let r=0;r<s.length;r++){const n=s.charCodeAt(r);n===35||n===63?(t===void 0&&(t=s.substr(0,r)),t+=p[n]):t!==void 0&&(t+=s[r])}return t!==void 0?t:s}function l(s,t){let r;return s.authority&&s.path.length>1&&s.scheme==="file"?r=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?t?r=s.path.substr(1):r=s.path[1].toLowerCase()+s.path.substr(2):r=s.path,i.isWindows&&(r=r.replace(/\//g,"\\")),r}e.uriToFsPath=l;function c(s,t){const r=t?_:P;let n="",{scheme:o,authority:m,path:h,query:w,fragment:T}=s;if(o&&(n+=o,n+=":"),(m||o==="file")&&(n+=D,n+=D),m){let L=m.indexOf("@");if(L!==-1){const O=m.substr(0,L);m=m.substr(L+1),L=O.indexOf(":"),L===-1?n+=r(O,!1):(n+=r(O.substr(0,L),!1),n+=":",n+=r(O.substr(L+1),!1)),n+="@"}m=m.toLowerCase(),L=m.indexOf(":"),L===-1?n+=r(m,!1):(n+=r(m.substr(0,L),!1),n+=m.substr(L))}if(h){if(h.length>=3&&h.charCodeAt(0)===47&&h.charCodeAt(2)===58){const L=h.charCodeAt(1);L>=65&&L<=90&&(h=`/${String.fromCharCode(L+32)}:${h.substr(3)}`)}else if(h.length>=2&&h.charCodeAt(1)===58){const L=h.charCodeAt(0);L>=65&&L<=90&&(h=`${String.fromCharCode(L+32)}:${h.substr(2)}`)}n+=r(h,!0)}return w&&(n+="?",n+=r(w,!1)),T&&(n+="#",n+=t?T:P(T,!1)),n}function u(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+u(s.substr(3)):s}}const a=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function E(s){return s.match(a)?s.replace(a,t=>u(t)):s}}),define(ve[58],we([1,0,22,8,2]),function(te,e,f,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function A(R){return JSON.stringify(R,k)}e.stringify=A;function C(R){let F=JSON.parse(R);return F=S(F),F}e.parse=C;function k(R,F){return F instanceof RegExp?{$mid:2,source:F.source,flags:(0,i.regExpFlags)(F)}:F}function S(R,F=0){if(!R||F>200)return R;if(typeof R=="object"){switch(R.$mid){case 1:return I.URI.revive(R);case 2:return new RegExp(R.source,R.flags);case 14:return new Date(R.source)}if(R instanceof f.VSBuffer||R instanceof Uint8Array)return R;if(Array.isArray(R))for(let D=0;D<R.length;++D)R[D]=S(R[D],F+1);else for(const D in R)Object.hasOwnProperty.call(R,D)&&(R[D]=S(R[D],F+1))}return R}e.revive=S}),define(ve[10],we([1,0,12,2]),function(te,e,f,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var I;(function(k){k.inMemory="inmemory",k.vscode="vscode",k.internal="private",k.walkThrough="walkThrough",k.walkThroughSnippet="walkThroughSnippet",k.http="http",k.https="https",k.file="file",k.mailto="mailto",k.untitled="untitled",k.data="data",k.command="command",k.vscodeRemote="vscode-remote",k.vscodeRemoteResource="vscode-remote-resource",k.userData="vscode-userdata",k.vscodeCustomEditor="vscode-custom-editor",k.vscodeNotebook="vscode-notebook",k.vscodeNotebookCell="vscode-notebook-cell",k.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",k.vscodeNotebookCellOutput="vscode-notebook-cell-output",k.vscodeInteractive="vscode-interactive",k.vscodeInteractiveInput="vscode-interactive-input",k.vscodeSettings="vscode-settings",k.vscodeWorkspaceTrust="vscode-workspace-trust",k.vscodeTerminal="vscode-terminal",k.webviewPanel="webview-panel",k.vscodeWebview="vscode-webview",k.extension="extension",k.vscodeFileResource="vscode-file",k.tmp="tmp",k.vsls="vsls"})(I=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class A{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(S){this._preferredWebSchema=S}setDelegate(S){this._delegate=S}set(S,R,F){this._hosts[S]=R,this._ports[S]=F}setConnectionToken(S,R){this._connectionTokens[S]=R}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(S){if(this._delegate)return this._delegate(S);const R=S.authority;let F=this._hosts[R];F&&F.indexOf(":")!==-1&&(F=`[${F}]`);const D=this._ports[R],v=this._connectionTokens[R];let b=`path=${encodeURIComponent(S.path)}`;return typeof v=="string"&&(b+=`&${e.connectionTokenQueryName}=${encodeURIComponent(v)}`),i.URI.from({scheme:f.isWeb?this._preferredWebSchema:I.vscodeRemoteResource,authority:`${F}:${D}`,path:"/vscode-remote-resource",query:b})}}e.RemoteAuthorities=new A;class C{asBrowserUri(S,R){const F=this.toUri(S,R);return F.scheme===I.vscodeRemote?e.RemoteAuthorities.rewrite(F):F.scheme===I.file&&(f.isNative||f.isWebWorker&&f.globals.origin===`${I.vscodeFileResource}://${C.FALLBACK_AUTHORITY}`)?F.with({scheme:I.vscodeFileResource,authority:F.authority||C.FALLBACK_AUTHORITY,query:null,fragment:null}):F}asFileUri(S,R){const F=this.toUri(S,R);return F.scheme===I.vscodeFileResource?F.with({scheme:I.file,authority:F.authority!==C.FALLBACK_AUTHORITY?F.authority:null,query:null,fragment:null}):F}toUri(S,R){return i.URI.isUri(S)?S:i.URI.parse(R.toUrl(S))}}C.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new C}),define(ve[23],we([1,0,29,10,9,12,8,2]),function(te,e,f,i,I,A,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(b){return(0,k.uriToFsPath)(b,!0)}e.originalFSPath=S;class R{constructor(g){this._ignorePathCasing=g}compare(g,d,p=!1){return g===d?0:(0,C.compare)(this.getComparisonKey(g,p),this.getComparisonKey(d,p))}isEqual(g,d,p=!1){return g===d?!0:!g||!d?!1:this.getComparisonKey(g,p)===this.getComparisonKey(d,p)}getComparisonKey(g,d=!1){return g.with({path:this._ignorePathCasing(g)?g.path.toLowerCase():void 0,fragment:d?null:void 0}).toString()}ignorePathCasing(g){return this._ignorePathCasing(g)}isEqualOrParent(g,d,p=!1){if(g.scheme===d.scheme){if(g.scheme===i.Schemas.file)return f.isEqualOrParent(S(g),S(d),this._ignorePathCasing(g))&&g.query===d.query&&(p||g.fragment===d.fragment);if((0,e.isEqualAuthority)(g.authority,d.authority))return f.isEqualOrParent(g.path,d.path,this._ignorePathCasing(g),"/")&&g.query===d.query&&(p||g.fragment===d.fragment)}return!1}joinPath(g,...d){return k.URI.joinPath(g,...d)}basenameOrAuthority(g){return(0,e.basename)(g)||g.authority}basename(g){return I.posix.basename(g.path)}extname(g){return I.posix.extname(g.path)}dirname(g){if(g.path.length===0)return g;let d;return g.scheme===i.Schemas.file?d=k.URI.file(I.dirname(S(g))).path:(d=I.posix.dirname(g.path),g.authority&&d.length&&d.charCodeAt(0)!==47&&(console.error(`dirname("${g.toString})) resulted in a relative path`),d="/")),g.with({path:d})}normalizePath(g){if(!g.path.length)return g;let d;return g.scheme===i.Schemas.file?d=k.URI.file(I.normalize(S(g))).path:d=I.posix.normalize(g.path),g.with({path:d})}relativePath(g,d){if(g.scheme!==d.scheme||!(0,e.isEqualAuthority)(g.authority,d.authority))return;if(g.scheme===i.Schemas.file){const _=I.relative(S(g),S(d));return A.isWindows?f.toSlashes(_):_}let p=g.path||"/",P=d.path||"/";if(this._ignorePathCasing(g)){let _=0;for(const l=Math.min(p.length,P.length);_<l&&!(p.charCodeAt(_)!==P.charCodeAt(_)&&p.charAt(_).toLowerCase()!==P.charAt(_).toLowerCase());_++);p=P.substr(0,_)+p.substr(_)}return I.posix.relative(p,P)}resolvePath(g,d){if(g.scheme===i.Schemas.file){const p=k.URI.file(I.resolve(S(g),d));return g.with({authority:p.authority,path:p.path})}return d=f.toPosixPath(d),g.with({path:I.posix.resolve(g.path,d)})}isAbsolutePath(g){return!!g.path&&g.path[0]==="/"}isEqualAuthority(g,d){return g===d||g!==void 0&&d!==void 0&&(0,C.equalsIgnoreCase)(g,d)}hasTrailingPathSeparator(g,d=I.sep){if(g.scheme===i.Schemas.file){const p=S(g);return p.length>f.getRoot(p).length&&p[p.length-1]===d}else{const p=g.path;return p.length>1&&p.charCodeAt(p.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(g.fsPath)}}removeTrailingPathSeparator(g,d=I.sep){return(0,e.hasTrailingPathSeparator)(g,d)?g.with({path:g.path.substr(0,g.path.length-1)}):g}addTrailingPathSeparator(g,d=I.sep){let p=!1;if(g.scheme===i.Schemas.file){const P=S(g);p=P!==void 0&&P.length===f.getRoot(P).length&&P[P.length-1]===d}else{d="/";const P=g.path;p=P.length===1&&P.charCodeAt(P.length-1)===47}return!p&&!(0,e.hasTrailingPathSeparator)(g,d)?g.with({path:g.path+"/"}):g}}e.ExtUri=R,e.extUri=new R(()=>!1),e.extUriBiasedIgnorePathCase=new R(b=>b.scheme===i.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new R(b=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function F(b,g){const d=[];for(let p=0;p<b.length;p++){const P=g(b[p]);b.some((_,l)=>l===p?!1:(0,e.isEqualOrParent)(P,g(_)))||d.push(b[p])}return d}e.distinctParents=F;var D;(function(b){b.META_DATA_LABEL="label",b.META_DATA_DESCRIPTION="description",b.META_DATA_SIZE="size",b.META_DATA_MIME="mime";function g(d){const p=new Map;d.path.substring(d.path.indexOf(";")+1,d.path.lastIndexOf(";")).split(";").forEach(l=>{const[c,u]=l.split(":");c&&u&&p.set(c,u)});const _=d.path.substring(0,d.path.indexOf(";"));return _&&p.set(b.META_DATA_MIME,_),p}b.parseMetaData=g})(D=e.DataUri||(e.DataUri={}));function v(b,g,d){if(g){let p=b.path;return p&&p[0]!==I.posix.sep&&(p=I.posix.sep+p),b.with({scheme:d,authority:g,path:p})}return b.with({scheme:d})}e.toLocalResource=v}),define(ve[16],we([1,0,21,15,3,6,23,12]),function(te,e,f,i,I,A,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function S(Z){return!!Z&&typeof Z.then=="function"}e.isThenable=S;function R(Z){const Y=new f.CancellationTokenSource,se=Z(Y.token),de=new Promise((ge,Te)=>{const Ne=Y.token.onCancellationRequested(()=>{Ne.dispose(),Y.dispose(),Te(new i.CancellationError)});Promise.resolve(se).then(be=>{Ne.dispose(),Y.dispose(),ge(be)},be=>{Ne.dispose(),Y.dispose(),Te(be)})});return new class{cancel(){Y.cancel()}then(ge,Te){return de.then(ge,Te)}catch(ge){return this.then(void 0,ge)}finally(ge){return de.finally(ge)}}}e.createCancelablePromise=R;function F(Z,Y,se){return new Promise((de,ge)=>{const Te=Y.onCancellationRequested(()=>{Te.dispose(),de(se)});Z.then(de,ge).finally(()=>Te.dispose())})}e.raceCancellation=F;function D(Z,Y){return new Promise((se,de)=>{const ge=Y.onCancellationRequested(()=>{ge.dispose(),de(new i.CancellationError)});Z.then(se,de).finally(()=>ge.dispose())})}e.raceCancellationError=D;async function v(Z){let Y=-1;const se=Z.map((ge,Te)=>ge.then(Ne=>(Y=Te,Ne))),de=await Promise.race(se);return Z.forEach((ge,Te)=>{Te!==Y&&ge.cancel()}),de}e.raceCancellablePromises=v;function b(Z,Y,se){let de;const ge=setTimeout(()=>{de?.(void 0),se?.()},Y);return Promise.race([Z.finally(()=>clearTimeout(ge)),new Promise(Te=>de=Te)])}e.raceTimeout=b;function g(Z){return new Promise((Y,se)=>{const de=Z();S(de)?de.then(Y,se):Y(de)})}e.asPromise=g;class d{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(Y){if(this.activePromise){if(this.queuedPromiseFactory=Y,!this.queuedPromise){const se=()=>{this.queuedPromise=null;const de=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,de};this.queuedPromise=new Promise(de=>{this.activePromise.then(se,se).then(de)})}return new Promise((se,de)=>{this.queuedPromise.then(se,de)})}return this.activePromise=Y(),new Promise((se,de)=>{this.activePromise.then(ge=>{this.activePromise=null,se(ge)},ge=>{this.activePromise=null,de(ge)})})}}e.Throttler=d;class p{constructor(){this.current=Promise.resolve(null)}queue(Y){return this.current=this.current.then(()=>Y(),()=>Y())}}e.Sequencer=p;class P{constructor(){this.promiseMap=new Map}queue(Y,se){const ge=(this.promiseMap.get(Y)??Promise.resolve()).catch(()=>{}).then(se).finally(()=>{this.promiseMap.get(Y)===ge&&this.promiseMap.delete(Y)});return this.promiseMap.set(Y,ge),ge}}e.SequencerByKey=P;const _=(Z,Y)=>{let se=!0;const de=setTimeout(()=>{se=!1,Y()},Z);return{isTriggered:()=>se,dispose:()=>{clearTimeout(de),se=!1}}},l=Z=>{let Y=!0;return queueMicrotask(()=>{Y&&(Y=!1,Z())}),{isTriggered:()=>Y,dispose:()=>{Y=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class c{constructor(Y){this.defaultDelay=Y,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(Y,se=this.defaultDelay){this.task=Y,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((ge,Te)=>{this.doResolve=ge,this.doReject=Te}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const ge=this.task;return this.task=null,ge()}}));const de=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=se===e.MicrotaskDelay?l(de):_(se,de),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(new i.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=c;class u{constructor(Y){this.delayer=new c(Y),this.throttler=new d}trigger(Y,se){return this.delayer.trigger(()=>this.throttler.queue(Y),se)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=u;class a{constructor(){this._isOpen=!1,this._promise=new Promise((Y,se)=>{this._completePromise=Y})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=a;class E extends a{constructor(Y){super();this._timeout=setTimeout(()=>this.open(),Y)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=E;function s(Z,Y){return Y?new Promise((se,de)=>{const ge=setTimeout(()=>{Te.dispose(),se()},Z),Te=Y.onCancellationRequested(()=>{clearTimeout(ge),Te.dispose(),de(new i.CancellationError)})}):R(se=>s(Z,se))}e.timeout=s;function t(Z,Y=0){const se=setTimeout(Z,Y);return(0,A.toDisposable)(()=>clearTimeout(se))}e.disposableTimeout=t;function r(Z){const Y=[];let se=0;const de=Z.length;function ge(){return se<de?Z[se++]():null}function Te(Ne){Ne!=null&&Y.push(Ne);const be=ge();return be?be.then(Te):Promise.resolve(Y)}return Promise.resolve(null).then(Te)}e.sequence=r;function n(Z,Y=de=>!!de,se=null){let de=0;const ge=Z.length,Te=()=>{if(de>=ge)return Promise.resolve(se);const Ne=Z[de++];return Promise.resolve(Ne()).then(Ee=>Y(Ee)?Promise.resolve(Ee):Te())};return Te()}e.first=n;function o(Z,Y=de=>!!de,se=null){if(Z.length===0)return Promise.resolve(se);let de=Z.length;const ge=()=>{de=-1;for(const Te of Z)Te.cancel?.()};return new Promise((Te,Ne)=>{for(const be of Z)be.then(Ee=>{--de>=0&&Y(Ee)?(ge(),Te(Ee)):de===0&&Te(se)}).catch(Ee=>{--de>=0&&(ge(),Ne(Ee))})})}e.firstParallel=o;class m{constructor(Y){this._size=0,this.maxDegreeOfParalellism=Y,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new I.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(Y){return this._size++,new Promise((se,de)=>{this.outstandingPromises.push({factory:Y,c:se,e:de}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const Y=this.outstandingPromises.shift();this.runningPromises++;const se=Y.factory();se.then(Y.c,Y.e),se.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=m;class h extends m{constructor(){super(1)}}e.Queue=h;class w{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const Y=new q;return this.drainers.add(Y),Y.p}isDrained(){for(const[,Y]of this.queues)if(Y.size>0)return!1;return!0}queueFor(Y,se=C.extUri){const de=se.getComparisonKey(Y);let ge=this.queues.get(de);return ge||(ge=new h,I.Event.once(ge.onFinished)(()=>{ge?.dispose(),this.queues.delete(de),this.onDidQueueFinish()}),this.queues.set(de,ge)),ge}onDidQueueFinish(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const Y of this.drainers)Y.complete();this.drainers.clear()}dispose(){for(const[,Y]of this.queues)Y.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=w;class T{constructor(Y,se){this._token=-1,typeof Y=="function"&&typeof se=="number"&&this.setIfNotSet(Y,se)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(Y,se){this.cancel(),this._token=setTimeout(()=>{this._token=-1,Y()},se)}setIfNotSet(Y,se){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,Y()},se))}}e.TimeoutTimer=T;class L{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(Y,se){this.cancel(),this._token=setInterval(()=>{Y()},se)}}e.IntervalTimer=L;class O{constructor(Y,se){this.timeoutToken=-1,this.runner=Y,this.timeout=se,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(Y=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,Y)}get delay(){return this.timeout}set delay(Y){this.timeout=Y}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=O;class y{constructor(Y,se){se%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${se}ms is not a multiple of 1000ms.`),this.runner=Y,this.timeout=se,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(Y=this.timeout){Y%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Y}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(Y/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=y;class H extends O{constructor(Y,se){super(Y,se);this.units=[]}work(Y){this.units.push(Y),this.isScheduled()||this.schedule()}doRun(){const Y=this.units;this.units=[],this.runner&&this.runner(Y)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=H;class M extends A.Disposable{constructor(Y,se){super();this.options=Y,this.handler=se,this.pendingWork=[],this.throttler=this._register(new A.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(Y){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+Y.length>this.options.maxBufferedWork)return!1}else if(this.pending+Y.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...Y),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new O(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=M,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=Z=>{(0,k.setTimeout0)(()=>{if(Y)return;const se=Date.now()+15;Z(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,se-Date.now())}}))});let Y=!1;return{dispose(){Y||(Y=!0)}}}:e.runWhenIdle=(Z,Y)=>{const se=requestIdleCallback(Z,typeof Y=="number"?{timeout:Y}:void 0);let de=!1;return{dispose(){de||(de=!0,cancelIdleCallback(se))}}}}();class j{constructor(Y){this._didRun=!1,this._executor=()=>{try{this._value=Y()}catch(se){this._error=se}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=j;async function X(Z,Y,se){let de;for(let ge=0;ge<se;ge++)try{return await Z()}catch(Te){de=Te,await s(Y)}throw de}e.retry=X;class ${hasPending(Y){return this._pending?typeof Y=="number"?this._pending.taskId===Y:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(Y,se,de){return this._pending={taskId:Y,cancel:()=>de?.(),promise:se},se.then(()=>this.donePending(Y),()=>this.donePending(Y)),se}donePending(Y){this._pending&&Y===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const Y=this._next;this._next=void 0,Y.run().then(Y.promiseResolve,Y.promiseReject)}}setNext(Y){if(this._next)this._next.run=Y;else{let se,de;const ge=new Promise((Te,Ne)=>{se=Te,de=Ne});this._next={run:Y,promise:ge,promiseResolve:se,promiseReject:de}}return this._next.promise}}e.TaskSequentializer=$;class U{constructor(Y,se=()=>Date.now()){this.interval=Y,this.nowFn=se,this.lastIncrementTime=0,this.value=0}increment(){const Y=this.nowFn();return Y-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=Y,this.value=0),this.value++,this.value}}e.IntervalCounter=U;class q{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((Y,se)=>{this.completeCallback=Y,this.errorCallback=se})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(Y){return new Promise(se=>{this.completeCallback(Y),this.resolved=!0,se()})}error(Y){return new Promise(se=>{this.errorCallback(Y),this.rejected=!0,se()})}cancel(){new Promise(Y=>{this.errorCallback(new i.CancellationError),this.rejected=!0,Y()})}}e.DeferredPromise=q;var K;(function(Z){async function Y(de){let ge;const Te=await Promise.all(de.map(Ne=>Ne.then(be=>be,be=>{ge||(ge=be)})));if(typeof ge!="undefined")throw ge;return Te}Z.settled=Y;function se(de){return new Promise(async(ge,Te)=>{try{await de(ge,Te)}catch(Ne){Te(Ne)}})}Z.withAsyncBody=se})(K=e.Promises||(e.Promises={}));var G;(function(Z){Z[Z.Initial=0]="Initial",Z[Z.DoneOK=1]="DoneOK",Z[Z.DoneError=2]="DoneError"})(G||(G={}));class ee{constructor(Y){this._state=0,this._results=[],this._error=null,this._onStateChanged=new I.Emitter,queueMicrotask(async()=>{const se={emitOne:de=>this.emitOne(de),emitMany:de=>this.emitMany(de),reject:de=>this.reject(de)};try{await Promise.resolve(Y(se)),this.resolve()}catch(de){this.reject(de)}finally{se.emitOne=void 0,se.emitMany=void 0,se.reject=void 0}})}static fromArray(Y){return new ee(se=>{se.emitMany(Y)})}static fromPromise(Y){return new ee(async se=>{se.emitMany(await Y)})}static fromPromises(Y){return new ee(async se=>{await Promise.all(Y.map(async de=>se.emitOne(await de)))})}static merge(Y){return new ee(async se=>{await Promise.all(Y.map(async de=>{for await(const ge of de)se.emitOne(ge)}))})}[Symbol.asyncIterator](){let Y=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(Y<this._results.length)return{done:!1,value:this._results[Y++]};if(this._state===1)return{done:!0,value:void 0};await I.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(Y,se){return new ee(async de=>{for await(const ge of Y)de.emitOne(se(ge))})}map(Y){return ee.map(this,Y)}static filter(Y,se){return new ee(async de=>{for await(const ge of Y)se(ge)&&de.emitOne(ge)})}filter(Y){return ee.filter(this,Y)}static coalesce(Y){return ee.filter(Y,se=>!!se)}coalesce(){return ee.coalesce(this)}static async toPromise(Y){const se=[];for await(const de of Y)se.push(de);return se}toPromise(){return ee.toPromise(this)}emitOne(Y){this._state===0&&(this._results.push(Y),this._onStateChanged.fire())}emitMany(Y){this._state===0&&(this._results=this._results.concat(Y),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(Y){this._state===0&&(this._state=2,this._error=Y,this._onStateChanged.fire())}}e.AsyncIterableObject=ee,ee.EMPTY=ee.fromArray([]);class oe extends ee{constructor(Y,se){super(se);this._source=Y}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=oe;function ue(Z){const Y=new f.CancellationTokenSource,se=Z(Y.token);return new oe(Y,async de=>{const ge=Y.token.onCancellationRequested(()=>{ge.dispose(),Y.dispose(),de.reject(new i.CancellationError)});try{for await(const Te of se){if(Y.token.isCancellationRequested)return;de.emitOne(Te)}ge.dispose(),Y.dispose()}catch(Te){ge.dispose(),Y.dispose(),de.reject(Te)}})}e.createCancelableAsyncIterable=ue}),define(ve[97],we([1,0,16,9]),function(te,e,f,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const I=new f.IdleValue(()=>{const h=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:h,collatorIsNumeric:h.resolvedOptions().numeric}}),A=new f.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),C=new f.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function k(h,w,T=!1){const L=h||"",O=w||"",y=I.value.collator.compare(L,O);return I.value.collatorIsNumeric&&y===0&&L!==O?L<O?-1:1:y}e.compareFileNames=k;function S(h,w){const T=A.value.collator;return h=h||"",w=w||"",u(T,h,w)}e.compareFileNamesDefault=S;function R(h,w){const T=A.value.collator;return h=h||"",w=w||"",t(h,w)||u(T,h,w)}e.compareFileNamesUpper=R;function F(h,w){const T=A.value.collator;return h=h||"",w=w||"",s(h,w)||u(T,h,w)}e.compareFileNamesLower=F;function D(h,w){return h=h||"",w=w||"",h===w?0:h<w?-1:1}e.compareFileNamesUnicode=D;function v(h,w,T=!1){T||(h=h&&h.toLowerCase(),w=w&&w.toLowerCase());const[L,O]=l(h),[y,H]=l(w);return L!==y?L<y?-1:1:O===H?0:O<H?-1:1}e.noIntlCompareFileNames=v;function b(h,w){const[T,L]=l(h),[O,y]=l(w);let H=I.value.collator.compare(L,y);if(H===0){if(I.value.collatorIsNumeric&&L!==y)return L<y?-1:1;if(H=I.value.collator.compare(T,O),I.value.collatorIsNumeric&&H===0&&T!==O)return T<O?-1:1}return H}e.compareFileExtensions=b;function g(h,w){h=h||"",w=w||"";const T=c(h),L=c(w),O=A.value.collator,y=C.value.collator;return u(y,T,L)||u(O,h,w)}e.compareFileExtensionsDefault=g;function d(h,w){h=h||"",w=w||"";const T=c(h),L=c(w),O=A.value.collator,y=C.value.collator;return u(y,T,L)||t(h,w)||u(O,h,w)}e.compareFileExtensionsUpper=d;function p(h,w){h=h||"",w=w||"";const T=c(h),L=c(w),O=A.value.collator,y=C.value.collator;return u(y,T,L)||s(h,w)||u(O,h,w)}e.compareFileExtensionsLower=p;function P(h,w){h=h||"",w=w||"";const T=c(h).toLowerCase(),L=c(w).toLowerCase();return T!==L?T<L?-1:1:h!==w?h<w?-1:1:0}e.compareFileExtensionsUnicode=P;const _=/^(.*?)(\.([^.]*))?$/;function l(h,w=!1){const T=h?_.exec(h):[];let L=[T&&T[1]||"",T&&T[3]||""];return w&&(!L[0]&&L[1]||L[0]&&L[0].charAt(0)===".")&&(L=[L[0]+"."+L[1],""]),L}function c(h){const w=h?_.exec(h):[];return w&&w[1]&&w[1].charAt(0)!=="."&&w[3]||""}function u(h,w,T){let L=h.compare(w,T);return L!==0?L:w.length!==T.length?w.length<T.length?-1:1:0}function a(h){const w=h.charAt(0);return w.toLocaleUpperCase()!==w}function E(h){const w=h.charAt(0);return w.toLocaleLowerCase()!==w}function s(h,w){return a(h)&&E(w)?-1:E(h)&&a(w)?1:0}function t(h,w){return E(h)&&a(w)?-1:a(h)&&E(w)?1:0}function r(h,w,T=!1){return T||(h=h&&h.toLowerCase(),w=w&&w.toLowerCase()),h===w?0:h<w?-1:1}function n(h,w,T=!1){const L=h.split(i.sep),O=w.split(i.sep),y=L.length-1,H=O.length-1;let M,j;for(let X=0;;X++){if(M=y===X,j=H===X,M&&j)return k(L[X],O[X],T);if(M)return-1;if(j)return 1;const $=r(L[X],O[X],T);if($!==0)return $}}e.comparePaths=n;function o(h,w,T){const L=h.toLowerCase(),O=w.toLowerCase(),y=m(h,w,T);if(y)return y;const H=L.endsWith(T),M=O.endsWith(T);if(H!==M)return H?-1:1;const j=k(L,O);return j!==0?j:L.localeCompare(O)}e.compareAnything=o;function m(h,w,T){const L=h.toLowerCase(),O=w.toLowerCase(),y=L.startsWith(T),H=O.startsWith(T);if(y!==H)return y?-1:1;if(y&&H){if(L.length<O.length)return-1;if(L.length>O.length)return 1}return 0}e.compareByPrefix=m}),define(ve[98],we([1,0,97,95,57,9,12,8]),function(te,e,f,i,I,A,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const S=0,R=[S,[]];function F($,U,q,K){if(!$||!U)return R;const G=$.length,ee=U.length;if(G<ee)return R;const oe=$.toLowerCase();return D(U,q,ee,$,oe,G,K)}e.scoreFuzzy=F;function D($,U,q,K,G,ee,oe){const ue=[],Z=[];for(let ge=0;ge<q;ge++){const Te=ge*ee,Ne=Te-ee,be=ge>0,Ee=$[ge],z=U[ge];for(let B=0;B<ee;B++){const N=B>0,W=Te+B,V=W-1,re=Ne+B-1,he=N?ue[V]:0,Ce=be&&N?ue[re]:0,Ae=be&&N?Z[re]:0;let We;!Ce&&be?We=0:We=v(Ee,z,K,G,B,Ae),We&&Ce+We>=he&&(oe||be||G.startsWith(U,B))?(Z[W]=Ae+1,ue[W]=Ce+We):(Z[W]=S,ue[W]=he)}}const Y=[];let se=q-1,de=ee-1;for(;se>=0&&de>=0;){const ge=se*ee+de;Z[ge]===S||(Y.push(de),se--),de--}return[ue[q*ee-1],Y.reverse()]}function v($,U,q,K,G,ee){let oe=0;if(!b(U,K[G]))return oe;if(oe+=1,ee>0&&(oe+=ee*5),$===q[G]&&(oe+=1),G===0)oe+=8;else{const ue=g(q.charCodeAt(G-1));ue?oe+=ue:(0,i.isUpper)(q.charCodeAt(G))&&ee===0&&(oe+=2)}return oe}function b($,U){return $===U?!0:$==="/"||$==="\\"?U==="/"||U==="\\":!1}function g($){switch($){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const d=[void 0,[]];function p($,U,q=0,K=0){const G=U;return G.values&&G.values.length>1?P($,G.values,q,K):_($,U,q,K)}e.scoreFuzzy2=p;function P($,U,q,K){let G=0;const ee=[];for(const oe of U){const[ue,Z]=_($,oe,q,K);if(typeof ue!="number")return d;G+=ue,ee.push(...Z)}return[G,m(ee)]}function _($,U,q,K){const G=(0,i.fuzzyScore)(U.original,U.originalLowercase,q,$,$.toLowerCase(),K,!0);return G?[G[0],(0,i.createMatches)(G)]:d}const l=Object.freeze({score:0}),c=1<<18,u=1<<17,a=1<<16;function E($,U,q,K){const G=K.values?K.values:[K];return(0,I.hash)({[K.normalized]:{values:G.map(oe=>({value:oe.normalized,expectContiguousMatch:oe.expectContiguousMatch})),label:$,description:U,allowNonContiguousMatches:q}})}function s($,U,q,K,G){if(!$||!U.normalized)return l;const ee=K.getItemLabel($);if(!ee)return l;const oe=K.getItemDescription($),ue=E(ee,oe,q,U),Z=G[ue];if(Z)return Z;const Y=t(ee,oe,K.getItemPath($),U,q);return G[ue]=Y,Y}e.scoreItemFuzzy=s;function t($,U,q,K,G){const ee=!q||!K.containsPathSeparator;return q&&(C.isLinux?K.pathNormalized===q:(0,k.equalsIgnoreCase)(K.pathNormalized,q))?{score:c,labelMatch:[{start:0,end:$.length}],descriptionMatch:U?[{start:0,end:U.length}]:void 0}:K.values&&K.values.length>1?r($,U,q,K.values,ee,G):n($,U,q,K,ee,G)}function r($,U,q,K,G,ee){let oe=0;const ue=[],Z=[];for(const Y of K){const{score:se,labelMatch:de,descriptionMatch:ge}=n($,U,q,Y,G,ee);if(se===S)return l;oe+=se,de&&ue.push(...de),ge&&Z.push(...ge)}return{score:oe,labelMatch:m(ue),descriptionMatch:m(Z)}}function n($,U,q,K,G,ee){if(G||!U){const[oe,ue]=F($,K.normalized,K.normalizedLowercase,ee&&!K.expectContiguousMatch);if(oe){const Z=(0,i.matchesPrefix)(K.normalized,$);let Y;return Z?(Y=u,Y+=Math.round(K.normalized.length/$.length*100)):Y=a,{score:Y+oe,labelMatch:Z||o(ue)}}}if(U){let oe=U;q&&(oe=`${U}${A.sep}`);const ue=oe.length,Z=`${oe}${$}`,[Y,se]=F(Z,K.normalized,K.normalizedLowercase,ee&&!K.expectContiguousMatch);if(Y){const de=o(se),ge=[],Te=[];return de.forEach(Ne=>{Ne.start<ue&&Ne.end>ue?(ge.push({start:0,end:Ne.end-ue}),Te.push({start:Ne.start,end:ue})):Ne.start>=ue?ge.push({start:Ne.start-ue,end:Ne.end-ue}):Te.push(Ne)}),{score:Y,labelMatch:ge,descriptionMatch:Te}}}return l}function o($){const U=[];if(!$)return U;let q;for(const K of $)q&&q.end===K?q.end+=1:(q={start:K,end:K+1},U.push(q));return U}function m($){const U=$.sort((G,ee)=>G.start-ee.start),q=[];let K;for(const G of U)!K||!h(K,G)?(K=G,q.push(G)):(K.start=Math.min(K.start,G.start),K.end=Math.max(K.end,G.end));return q}function h($,U){return!($.end<U.start||U.end<$.start)}function w($,U,q,K,G,ee){const oe=s($,q,K,G,ee),ue=s(U,q,K,G,ee),Z=oe.score,Y=ue.score;if((Z===c||Y===c)&&Z!==Y)return Z===c?-1:1;if(Z>a||Y>a){if(Z!==Y)return Z>Y?-1:1;if(Z<u&&Y<u){const Ee=L(oe.labelMatch,ue.labelMatch);if(Ee!==0)return Ee}const Ne=G.getItemLabel($)||"",be=G.getItemLabel(U)||"";if(Ne.length!==be.length)return Ne.length-be.length}if(Z!==Y)return Z>Y?-1:1;const se=Array.isArray(oe.labelMatch)&&oe.labelMatch.length>0,de=Array.isArray(ue.labelMatch)&&ue.labelMatch.length>0;if(se&&!de)return-1;if(de&&!se)return 1;const ge=T($,oe,G),Te=T(U,ue,G);return ge&&Te&&ge!==Te?Te>ge?-1:1:O($,U,q,G)}e.compareItemsByFuzzyScore=w;function T($,U,q){let K=-1,G=-1;if(U.descriptionMatch&&U.descriptionMatch.length?K=U.descriptionMatch[0].start:U.labelMatch&&U.labelMatch.length&&(K=U.labelMatch[0].start),U.labelMatch&&U.labelMatch.length){if(G=U.labelMatch[U.labelMatch.length-1].end,U.descriptionMatch&&U.descriptionMatch.length){const ee=q.getItemDescription($);ee&&(G+=ee.length)}}else U.descriptionMatch&&U.descriptionMatch.length&&(G=U.descriptionMatch[U.descriptionMatch.length-1].end);return G-K}function L($,U){if(!$&&!U||(!$||!$.length)&&(!U||!U.length))return 0;if(!U||!U.length)return-1;if(!$||!$.length)return 1;const q=$[0].start,G=$[$.length-1].end-q,ee=U[0].start,ue=U[U.length-1].end-ee;return G===ue?0:ue<G?1:-1}function O($,U,q,K){const G=K.getItemLabel($)||"",ee=K.getItemLabel(U)||"",oe=K.getItemDescription($),ue=K.getItemDescription(U),Z=G.length+(oe?oe.length:0),Y=ee.length+(ue?ue.length:0);if(Z!==Y)return Z-Y;const se=K.getItemPath($),de=K.getItemPath(U);return se&&de&&se.length!==de.length?se.length-de.length:G!==ee?(0,f.compareAnything)(G,ee,q.normalized):oe&&ue&&oe!==ue?(0,f.compareAnything)(oe,ue,q.normalized):se&&de&&se!==de?(0,f.compareAnything)(se,de,q.normalized):0}function y($){return $.startsWith('"')&&$.endsWith('"')}const H=" ";function M($){typeof $!="string"&&($="");const U=$.toLowerCase(),{pathNormalized:q,normalized:K,normalizedLowercase:G}=j($),ee=q.indexOf(A.sep)>=0,oe=y($);let ue;const Z=$.split(H);if(Z.length>1)for(const Y of Z){const se=y(Y),{pathNormalized:de,normalized:ge,normalizedLowercase:Te}=j(Y);ge&&(ue||(ue=[]),ue.push({original:Y,originalLowercase:Y.toLowerCase(),pathNormalized:de,normalized:ge,normalizedLowercase:Te,expectContiguousMatch:se}))}return{original:$,originalLowercase:U,pathNormalized:q,normalized:K,normalizedLowercase:G,values:ue,containsPathSeparator:ee,expectContiguousMatch:oe}}e.prepareQuery=M;function j($){let U;C.isWindows?U=$.replace(/\//g,A.sep):U=$.replace(/\\/g,A.sep);const q=(0,k.stripWildcards)(U).replace(/\s|"/g,"");return{pathNormalized:U,normalized:q,normalizedLowercase:q.toLowerCase()}}function X($){return Array.isArray($)?M($.map(U=>U.original).join(H)):M($.original)}e.pieceToQuery=X}),define(ve[32],we([1,0,16,29,24,9,12,8]),function(te,e,f,i,I,A,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function S(){return Object.create(null)}e.getEmptyExpression=S,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const R="[/\\\\]",F="[^/\\\\]",D=/\//g;function v(q){switch(q){case 0:return"";case 1:return`${F}*?`;default:return`(?:${R}|${F}+${R}|${R}${F}+)*?`}}function b(q,K){if(!q)return[];const G=[];let ee=!1,oe=!1,ue="";for(const Z of q){switch(Z){case K:if(!ee&&!oe){G.push(ue),ue="";continue}break;case"{":ee=!0;break;case"}":ee=!1;break;case"[":oe=!0;break;case"]":oe=!1;break}ue+=Z}return ue&&G.push(ue),G}e.splitGlobAware=b;function g(q){if(!q)return"";let K="";const G=b(q,e.GLOB_SPLIT);if(G.every(ee=>ee===e.GLOBSTAR))K=".*";else{let ee=!1;G.forEach((oe,ue)=>{if(oe===e.GLOBSTAR){ee||(K+=v(2),ee=!0);return}let Z=!1,Y="",se=!1,de="";for(const ge of oe){if(ge!=="}"&&Z){Y+=ge;continue}if(se&&(ge!=="]"||!de)){let Te;ge==="-"?Te=ge:(ge==="^"||ge==="!")&&!de?Te="^":ge===e.GLOB_SPLIT?Te="":Te=(0,k.escapeRegExpCharacters)(ge),de+=Te;continue}switch(ge){case"{":Z=!0;continue;case"[":se=!0;continue;case"}":{K+=`(?:${b(Y,",").map(be=>g(be)).join("|")})`,Z=!1,Y="";break}case"]":K+="["+de+"]",se=!1,de="";break;case"?":K+=F;continue;case"*":K+=v(1);continue;default:K+=(0,k.escapeRegExpCharacters)(ge)}}ue<G.length-1&&(G[ue+1]!==e.GLOBSTAR||ue+2<G.length)&&(K+=R),ee=!1})}return K}const d=/^\*\*\/\*\.[\w\.-]+$/,p=/^\*\*\/([\w\.-]+)\/?$/,P=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,_=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,l=/^\*\*((\/[\w\.-]+)+)\/?$/,c=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,u=new I.LRUCache(1e4),a=function(){return!1},E=function(){return null};function s(q,K){if(!q)return E;let G;typeof q!="string"?G=q.pattern:G=q,G=G.trim();const ee=`${G}_${!!K.trimForExclusions}`;let oe=u.get(ee);if(oe)return t(oe,q);let ue;if(d.test(G)){const Z=G.substr(4);oe=function(Y,se){return typeof Y=="string"&&Y.endsWith(Z)?G:null}}else(ue=p.exec(r(G,K)))?oe=n(ue[1],G):(K.trimForExclusions?_:P).test(G)?oe=o(G,K):(ue=l.exec(r(G,K)))?oe=m(ue[1].substr(1),G,!0):(ue=c.exec(r(G,K)))?oe=m(ue[1],G,!1):oe=h(G);return u.set(ee,oe),t(oe,q)}function t(q,K){return typeof K=="string"?q:function(G,ee){return(0,i.isEqualOrParent)(G,K.base,!C.isLinux)?q(G.substr(K.base.length+1),ee):null}}function r(q,K){return K.trimForExclusions&&q.endsWith("/**")?q.substr(0,q.length-2):q}function n(q,K){const G=`/${q}`,ee=`\\${q}`,oe=function(Z,Y){return typeof Z!="string"?null:Y?Y===q?K:null:Z===q||Z.endsWith(G)||Z.endsWith(ee)?K:null},ue=[q];return oe.basenames=ue,oe.patterns=[K],oe.allBasenames=ue,oe}function o(q,K){const G=U(q.slice(1,-1).split(",").map(Y=>s(Y,K)).filter(Y=>Y!==E),q),ee=G.length;if(!ee)return E;if(ee===1)return G[0];const oe=function(Y,se){for(let de=0,ge=G.length;de<ge;de++)if(G[de](Y,se))return q;return null},ue=G.find(Y=>!!Y.allBasenames);ue&&(oe.allBasenames=ue.allBasenames);const Z=G.reduce((Y,se)=>se.allPaths?Y.concat(se.allPaths):Y,[]);return Z.length&&(oe.allPaths=Z),oe}function m(q,K,G){const ee=A.sep===A.posix.sep,oe=ee?q:q.replace(D,A.sep),ue=A.sep+oe,Z=A.posix.sep+q,Y=G?function(se,de){return typeof se=="string"&&(se===oe||se.endsWith(ue)||!ee&&(se===q||se.endsWith(Z)))?K:null}:function(se,de){return typeof se=="string"&&(se===oe||!ee&&se===q)?K:null};return Y.allPaths=[(G?"*/":"./")+q],Y}function h(q){try{const K=new RegExp(`^${g(q)}$`);return function(G){return K.lastIndex=0,typeof G=="string"&&K.test(G)?q:null}}catch{return E}}function w(q,K,G){return!q||typeof K!="string"?!1:T(q)(K,void 0,G)}e.match=w;function T(q,K={}){if(!q)return a;if(typeof q=="string"||H(q)){const G=s(q,K);if(G===E)return a;const ee=function(oe,ue){return!!G(oe,ue)};return G.allBasenames&&(ee.allBasenames=G.allBasenames),G.allPaths&&(ee.allPaths=G.allPaths),ee}return X(q,K)}e.parse=T;function L(q){if(!q)return;let K;return G=>(K||(K=(q()||Promise.resolve([])).then(ee=>ee?y(ee):{})),K.then(ee=>!!ee[G]))}e.hasSiblingPromiseFn=L;function O(q){if(!q)return;let K;return G=>{if(!K){const ee=q();K=ee?y(ee):{}}return!!K[G]}}e.hasSiblingFn=O;function y(q){const K={};for(const G of q)K[G]=!0;return K}function H(q){const K=q;return K?typeof K.base=="string"&&typeof K.pattern=="string":!1}e.isRelativePattern=H;function M(q){return q.allBasenames||[]}e.getBasenameTerms=M;function j(q){return q.allPaths||[]}e.getPathTerms=j;function X(q,K){const G=U(Object.getOwnPropertyNames(q).map(Y=>$(Y,q[Y],K)).filter(Y=>Y!==E)),ee=G.length;if(!ee)return E;if(!G.some(Y=>!!Y.requiresSiblings)){if(ee===1)return G[0];const Y=function(ge,Te){for(let Ne=0,be=G.length;Ne<be;Ne++){const Ee=G[Ne](ge,Te);if(Ee)return Ee}return null},se=G.find(ge=>!!ge.allBasenames);se&&(Y.allBasenames=se.allBasenames);const de=G.reduce((ge,Te)=>Te.allPaths?ge.concat(Te.allPaths):ge,[]);return de.length&&(Y.allPaths=de),Y}const oe=function(Y,se,de){let ge;for(let Te=0,Ne=G.length;Te<Ne;Te++){const be=G[Te];be.requiresSiblings&&de&&(se||(se=(0,A.basename)(Y)),ge||(ge=se.substr(0,se.length-(0,A.extname)(Y).length)));const Ee=be(Y,se,ge,de);if(Ee)return Ee}return null},ue=G.find(Y=>!!Y.allBasenames);ue&&(oe.allBasenames=ue.allBasenames);const Z=G.reduce((Y,se)=>se.allPaths?Y.concat(se.allPaths):Y,[]);return Z.length&&(oe.allPaths=Z),oe}function $(q,K,G){if(K===!1)return E;const ee=s(q,G);if(ee===E)return E;if(typeof K=="boolean")return ee;if(K){const oe=K.when;if(typeof oe=="string"){const ue=(Z,Y,se,de)=>{if(!de||!ee(Z,Y))return null;const ge=oe.replace("$(basename)",se),Te=de(ge);return(0,f.isThenable)(Te)?Te.then(Ne=>Ne?q:null):Te?q:null};return ue.requiresSiblings=!0,ue}}return ee}function U(q,K){const G=q.filter(Y=>!!Y.basenames);if(G.length<2)return q;const ee=G.reduce((Y,se)=>{const de=se.basenames;return de?Y.concat(de):Y},[]);let oe;if(K){oe=[];for(let Y=0,se=ee.length;Y<se;Y++)oe.push(K)}else oe=G.reduce((Y,se)=>{const de=se.patterns;return de?Y.concat(de):Y},[]);const ue=function(Y,se){if(typeof Y!="string")return null;if(!se){let ge;for(ge=Y.length;ge>0;ge--){const Te=Y.charCodeAt(ge-1);if(Te===47||Te===92)break}se=Y.substr(ge)}const de=ee.indexOf(se);return de!==-1?oe[de]:null};ue.basenames=ee,ue.patterns=oe,ue.allBasenames=ee;const Z=q.filter(Y=>!Y.basenames);return Z.push(ue),Z}}),define(ve[99],we([1,0,15,144,23,8,2]),function(te,e,f,i,I,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var k;(function(d){d[d.Paragraph=0]="Paragraph",d[d.Break=1]="Break"})(k=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class S{constructor(p="",P=!1){if(this.value=p,typeof this.value!="string")throw(0,f.illegalArgument)("value");typeof P=="boolean"?(this.isTrusted=P,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=P.isTrusted??void 0,this.supportThemeIcons=P.supportThemeIcons??!1,this.supportHtml=P.supportHtml??!1)}appendText(p,P=0){return this.value+=v(this.supportThemeIcons?(0,i.escapeIcons)(p):p).replace(/([ \t]+)/g,(_,l)=>"&nbsp;".repeat(l.length)).replace(/\>/gm,"\\>").replace(/\n/g,P===1?`\\
`:`

`),this}appendMarkdown(p){return this.value+=p,this}appendCodeblock(p,P){return this.value+="\n```",this.value+=p,this.value+=`
`,this.value+=P,this.value+="\n```\n",this}appendLink(p,P,_){return this.value+="[",this.value+=this._escape(P,"]"),this.value+="](",this.value+=this._escape(String(p),")"),_&&(this.value+=` "${this._escape(this._escape(_,'"'),")")}"`),this.value+=")",this}_escape(p,P){const _=new RegExp((0,A.escapeRegExpCharacters)(P),"g");return p.replace(_,(l,c)=>p.charAt(c-1)!=="\\"?`\\${l}`:l)}}e.MarkdownString=S;function R(d){return F(d)?!d.value:Array.isArray(d)?d.every(R):!0}e.isEmptyMarkdownString=R;function F(d){return d instanceof S?!0:d&&typeof d=="object"?typeof d.value=="string"&&(typeof d.isTrusted=="boolean"||d.isTrusted===void 0)&&(typeof d.supportThemeIcons=="boolean"||d.supportThemeIcons===void 0):!1}e.isMarkdownString=F;function D(d,p){return d===p?!0:!d||!p?!1:d.value===p.value&&d.isTrusted===p.isTrusted&&d.supportThemeIcons===p.supportThemeIcons&&d.supportHtml===p.supportHtml&&(d.baseUri===p.baseUri||!!d.baseUri&&!!p.baseUri&&(0,I.isEqual)(C.URI.from(d.baseUri),C.URI.from(p.baseUri)))}e.markdownStringEqual=D;function v(d){return d.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=v;function b(d){return d&&d.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=b;function g(d){const p=[],P=d.split("|").map(l=>l.trim());d=P[0];const _=P[1];if(_){const l=/height=(\d+)/.exec(_),c=/width=(\d+)/.exec(_),u=l?l[1]:"",a=c?c[1]:"",E=isFinite(parseInt(a)),s=isFinite(parseInt(u));E&&p.push(`width="${a}"`),s&&p.push(`height="${u}"`)}return{href:d,dimensions:p}}e.parseHrefAndDimensions=g}),define(ve[100],we([1,0,29,10,9,12,23,8,2]),function(te,e,f,i,I,A,C,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function R(t,r,n){if(typeof t=="string"&&(t=S.URI.file(t)),n){const m=n.getWorkspaceFolder(t);if(m){const h=n.getWorkspace().folders.length>1;let w;if((0,C.isEqual)(m.uri,t)?w="":w=(0,C.relativePath)(m.uri,t),h){const T=m.name?m.name:(0,C.basename)(m.uri);w=w?T+" \u2022 "+w:T}return w}}if(t.scheme!==i.Schemas.file&&t.scheme!==i.Schemas.untitled)return t.with({query:null,fragment:null}).toString(!0);if((0,f.hasDriveLetter)(t.fsPath))return(0,I.normalize)(D(t.fsPath));let o=(0,I.normalize)(t.fsPath);return!A.isWindows&&r?.userHome&&(o=b(o,r.userHome.fsPath)),o}e.getPathLabel=R;function F(t){if(!t)return;typeof t=="string"&&(t=S.URI.file(t));const r=(0,C.basename)(t)||(t.scheme===i.Schemas.file?t.fsPath:t.path);return A.isWindows&&(0,f.isRootOrDriveLetter)(r)?D(r):r}e.getBaseLabel=F;function D(t,r){return(0,f.hasDriveLetter)(t,r)?t.charAt(0).toUpperCase()+t.slice(1):t}e.normalizeDriveLetter=D;let v=Object.create(null);function b(t,r){if(A.isWindows||!t||!r)return t;let n=v.original===r?v.normalized:void 0;return n||(n=`${(0,k.rtrim)(r,I.posix.sep)}${I.posix.sep}`,v={original:r,normalized:n}),(A.isLinux?t.startsWith(n):(0,k.startsWithIgnoreCase)(t,n))&&(t=`~/${t.substr(n.length)}`),t}e.tildify=b;function g(t,r){return t.replace(/^~($|\/|\\)/,`${r}$1`)}e.untildify=g;const d="\u2026",p="\\\\",P="~";function _(t,r=I.sep){const n=new Array(t.length);let o=!1;for(let m=0;m<t.length;m++){let h=t[m];if(h===""){n[m]=`.${r}`;continue}if(!h){n[m]=h;continue}o=!0;let w="";h.indexOf(p)===0?(w=h.substr(0,h.indexOf(p)+p.length),h=h.substr(h.indexOf(p)+p.length)):h.indexOf(r)===0?(w=h.substr(0,h.indexOf(r)+r.length),h=h.substr(h.indexOf(r)+r.length)):h.indexOf(P)===0&&(w=h.substr(0,h.indexOf(P)+P.length),h=h.substr(h.indexOf(P)+P.length));const T=h.split(r);for(let L=1;o&&L<=T.length;L++)for(let O=T.length-L;o&&O>=0;O--){o=!1;let y=T.slice(O,O+L).join(r);for(let H=0;!o&&H<t.length;H++)if(H!==m&&t[H]&&t[H].indexOf(y)>-1){const M=O+L===T.length,j=O>0&&t[H].indexOf(r)>-1?r+y:y,X=t[H].endsWith(j);o=!M||X}if(!o){let H="";(T[0].endsWith(":")||w!=="")&&(O===1&&(O=0,L++,y=T[0]+r+y),O>0&&(H=T[0]+r),H=w+H),O>0&&(H=H+d+r),H=H+y,O+L<T.length&&(H=H+r+d),n[m]=H}}o&&(n[m]=h)}return n}e.shorten=_;var l;(function(t){t[t.TEXT=0]="TEXT",t[t.VARIABLE=1]="VARIABLE",t[t.SEPARATOR=2]="SEPARATOR"})(l||(l={}));function c(t,r=Object.create(null)){const n=[];let o=!1,m="";for(const h of t)if(h==="$"||o&&h==="{")m&&n.push({value:m,type:l.TEXT}),m="",o=!0;else if(h==="}"&&o){const w=r[m];if(typeof w=="string")w.length&&n.push({value:w,type:l.VARIABLE});else if(w){const T=n[n.length-1];(!T||T.type!==l.SEPARATOR)&&n.push({value:w.label,type:l.SEPARATOR})}m="",o=!1}else m+=h;return m&&!o&&n.push({value:m,type:l.TEXT}),n.filter((h,w)=>{if(h.type===l.SEPARATOR){const T=n[w-1],L=n[w+1];return[T,L].every(O=>O&&(O.type===l.VARIABLE||O.type===l.TEXT)&&O.value.length>0)}return!0}).map(h=>h.value).join("")}e.template=c;function u(t,r){return A.isMacintosh||r?t.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.isMacintosh?"&":"&&"):t.replace(/&&|&/g,n=>n==="&"?"&&":"&")}e.mnemonicMenuLabel=u;function a(t,r){return A.isMacintosh||r?t.replace(/\(&&\w\)|&&/g,""):A.isWindows?t.replace(/&&|&/g,n=>n==="&"?"&&":"&"):t.replace(/&&/g,"_")}e.mnemonicButtonLabel=a;function E(t){return t.replace(/&/g,"&&")}e.unmnemonicLabel=E;function s(t){const r=t.indexOf("/")!==-1?I.posix:I.win32,n=r.basename(t),o=r.dirname(t);return n.length?{name:n,parentPath:o}:{name:o,parentPath:""}}e.splitName=s}),define(ve[101],we([1,0,2]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function i(F){return F.toJSON()}class I{constructor(D){this._uriTransformer=D}transformIncoming(D){const v=this._uriTransformer.transformIncoming(D);return v===D?D:i(f.URI.from(v))}transformOutgoing(D){const v=this._uriTransformer.transformOutgoing(D);return v===D?D:i(f.URI.from(v))}transformOutgoingURI(D){const v=this._uriTransformer.transformOutgoing(D);return v===D?D:f.URI.from(v)}transformOutgoingScheme(D){return this._uriTransformer.transformOutgoingScheme(D)}}e.URITransformer=I,e.DefaultURITransformer=new class{transformIncoming(F){return F}transformOutgoing(F){return F}transformOutgoingURI(F){return F}transformOutgoingScheme(F){return F}};function A(F,D,v){if(!F||v>200)return null;if(typeof F=="object"){if(F instanceof f.URI)return D.transformOutgoing(F);for(let b in F)if(Object.hasOwnProperty.call(F,b)){const g=A(F[b],D,v+1);g!==null&&(F[b]=g)}}return null}function C(F,D){const v=A(F,D,0);return v===null?F:v}e.transformOutgoingURIs=C;function k(F,D,v,b){if(!F||b>200)return null;if(typeof F=="object"){if(F.$mid===1)return v?f.URI.revive(D.transformIncoming(F)):D.transformIncoming(F);for(let g in F)if(Object.hasOwnProperty.call(F,g)){const d=k(F[g],D,v,b+1);d!==null&&(F[g]=d)}}return null}function S(F,D){const v=k(F,D,!1,0);return v===null?F:v}e.transformIncomingURIs=S;function R(F,D){const v=k(F,D,!0,0);return v===null?F:v}e.transformAndReviveIncomingURIs=R}),define(ve[33],we([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const f=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function i(S){return f.test(S)}e.isUUID=i;const I=new Uint8Array(16),A=[];for(let S=0;S<256;S++)A.push(S.toString(16).padStart(2,"0"));let C;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?C=crypto.getRandomValues.bind(crypto):C=function(S){for(let R=0;R<S.length;R++)S[R]=Math.floor(Math.random()*256);return S};function k(){C(I),I[6]=I[6]&15|64,I[8]=I[8]&63|128;let S=0,R="";return R+=A[I[S++]],R+=A[I[S++]],R+=A[I[S++]],R+=A[I[S++]],R+="-",R+=A[I[S++]],R+=A[I[S++]],R+="-",R+=A[I[S++]],R+=A[I[S++]],R+="-",R+=A[I[S++]],R+=A[I[S++]],R+="-",R+=A[I[S++]],R+=A[I[S++]],R+=A[I[S++]],R+=A[I[S++]],R+=A[I[S++]],R+=A[I[S++]],R}e.generateUuid=k}),define(ve[145],we([1,0,102]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class i{constructor(A="utf8"){this.stringDecoder=new f.StringDecoder(A),this.remaining=null}write(A){const C=[],k=this.remaining?this.remaining+this.stringDecoder.write(A):this.stringDecoder.write(A);if(k.length<1)return C;let S=0,R,F=S;for(;F<k.length;)if(R=k.charCodeAt(F),R===13||R===10){if(C.push(k.substring(S,F)),F++,F<k.length){const D=R;R=k.charCodeAt(F),(D===13&&R===10||D===10&&R===13)&&F++}S=F}else F++;return this.remaining=S<k.length?k.substr(S):null,C}end(){return this.remaining}}e.LineDecoder=i}),define(ve[28],we([1,0,59,60,291,16,29,77,9,12,23,2]),function(te,e,f,i,I,A,C,k,S,R,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var v;(function(M){M[M.UNLINK=0]="UNLINK",M[M.MOVE=1]="MOVE"})(v=e.RimRafMode||(e.RimRafMode={}));async function b(M,j=v.UNLINK){if((0,C.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");return j===v.UNLINK?d(M):g(M)}async function g(M){try{const j=(0,C.randomPath)((0,i.tmpdir)());try{await f.promises.rename(M,j)}catch{return d(M)}d(j).catch(X=>{})}catch(j){if(j.code!=="ENOENT")throw j}}async function d(M){return(0,I.promisify)(f.rm)(M,{recursive:!0,force:!0,maxRetries:3})}function p(M){if((0,C.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");f.rmSync(M,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=p;async function P(M,j){return c(await(j?_(M):(0,I.promisify)(f.readdir)(M)))}async function _(M){try{return await(0,I.promisify)(f.readdir)(M,{withFileTypes:!0})}catch($){console.warn("[node.js fs] readdir with filetypes failed with error: ",$)}const j=[],X=await P(M);for(const $ of X){let U=!1,q=!1,K=!1;try{const G=await e.Promises.lstat((0,S.join)(M,$));U=G.isFile(),q=G.isDirectory(),K=G.isSymbolicLink()}catch(G){console.warn("[node.js fs] unexpected error from lstat after readdir: ",G)}j.push({name:$,isFile:()=>U,isDirectory:()=>q,isSymbolicLink:()=>K})}return j}function l(M){return c(f.readdirSync(M))}e.readdirSync=l;function c(M){return M.map(j=>typeof j=="string"?R.isMacintosh?(0,k.normalizeNFC)(j):j:(j.name=R.isMacintosh?(0,k.normalizeNFC)(j.name):j.name,j))}async function u(M){const j=await P(M),X=[];for(const $ of j)await E.existsDirectory((0,S.join)(M,$))&&X.push($);return X}function a(M,j=1e3){return new Promise(X=>{let $=!1;const U=setInterval(()=>{$||($=!0,f.access(M,q=>{$=!1,q&&(clearInterval(U),X(void 0))}))},j)})}e.whenDeleted=a;var E;(function(M){async function j(U){let q;try{if(q=await e.Promises.lstat(U),!q.isSymbolicLink())return{stat:q}}catch{}try{return{stat:await e.Promises.stat(U),symbolicLink:q?.isSymbolicLink()?{dangling:!1}:void 0}}catch(K){if(K.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};if(R.isWindows&&K.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(U)),symbolicLink:{dangling:!1}}}catch(G){if(G.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};throw G}throw K}}M.stat=j;async function X(U){try{const{stat:q,symbolicLink:K}=await M.stat(U);return q.isFile()&&K?.dangling!==!0}catch{}return!1}M.existsFile=X;async function $(U){try{const{stat:q,symbolicLink:K}=await M.stat(U);return q.isDirectory()&&K?.dangling!==!0}catch{}return!1}M.existsDirectory=$})(E=e.SymlinkSupport||(e.SymlinkSupport={}));const s=new A.ResourceQueue;function t(M,j,X){return s.queueFor(D.URI.file(M),F.extUriBiasedIgnorePathCase).queue(()=>{const $=m(X);return new Promise((U,q)=>n(M,j,$,K=>K?q(K):U()))})}let r=!0;function n(M,j,X,$){if(!r)return f.writeFile(M,j,{mode:X.mode,flag:X.flag},$);f.open(M,X.flag,X.mode,(U,q)=>{if(U)return $(U);f.writeFile(q,j,K=>{if(K)return f.close(q,()=>$(K));f.fdatasync(q,G=>(G&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",G),r=!1),f.close(q,ee=>$(ee))))})})}function o(M,j,X){const $=m(X);if(!r)return f.writeFileSync(M,j,{mode:$.mode,flag:$.flag});const U=f.openSync(M,$.flag,$.mode);try{f.writeFileSync(U,j);try{f.fdatasyncSync(U)}catch(q){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",q),r=!1}}finally{f.closeSync(U)}}e.writeFileSync=o;function m(M){return M?{mode:typeof M.mode=="number"?M.mode:438,flag:typeof M.flag=="string"?M.flag:"w"}:{mode:438,flag:"w"}}async function h(M,j){if(M!==j)try{await e.Promises.rename(M,j)}catch(X){if(M.toLowerCase()!==j.toLowerCase()&&X.code==="EXDEV"||M.endsWith("."))await w(M,j,{preserveSymlinks:!1}),await b(M,v.MOVE);else throw X}}async function w(M,j,X){return L(M,j,{root:{source:M,target:j},options:X,handledSourcePaths:new Set})}const T=511;async function L(M,j,X){if(X.handledSourcePaths.has(M))return;X.handledSourcePaths.add(M);const{stat:$,symbolicLink:U}=await E.stat(M);if(U){if(X.options.preserveSymlinks)try{return await H(M,j,X)}catch(q){console.warn("[node.js fs] copy of symlink failed: ",q)}if(U.dangling)return}return $.isDirectory()?O(M,j,$.mode&T,X):y(M,j,$.mode&T)}async function O(M,j,X,$){await e.Promises.mkdir(j,{recursive:!0,mode:X});const U=await P(M);for(const q of U)await L((0,S.join)(M,q),(0,S.join)(j,q),$)}async function y(M,j,X){await e.Promises.copyFile(M,j),await e.Promises.chmod(j,X)}async function H(M,j,X){let $=await e.Promises.readlink(M);(0,C.isEqualOrParent)($,X.root.source,!R.isLinux)&&($=(0,S.join)(X.root.target,$.substr(X.root.source.length+1))),await e.Promises.symlink($,j)}e.Promises=new class{get access(){return(0,I.promisify)(f.access)}get stat(){return(0,I.promisify)(f.stat)}get lstat(){return(0,I.promisify)(f.lstat)}get utimes(){return(0,I.promisify)(f.utimes)}get read(){return(M,j,X,$,U)=>new Promise((q,K)=>{f.read(M,j,X,$,U,(G,ee,oe)=>G?K(G):q({bytesRead:ee,buffer:oe}))})}get readFile(){return(0,I.promisify)(f.readFile)}get write(){return(M,j,X,$,U)=>new Promise((q,K)=>{f.write(M,j,X,$,U,(G,ee,oe)=>G?K(G):q({bytesWritten:ee,buffer:oe}))})}get appendFile(){return(0,I.promisify)(f.appendFile)}get fdatasync(){return(0,I.promisify)(f.fdatasync)}get truncate(){return(0,I.promisify)(f.truncate)}get rename(){return(0,I.promisify)(f.rename)}get copyFile(){return(0,I.promisify)(f.copyFile)}get open(){return(0,I.promisify)(f.open)}get close(){return(0,I.promisify)(f.close)}get symlink(){return(0,I.promisify)(f.symlink)}get readlink(){return(0,I.promisify)(f.readlink)}get chmod(){return(0,I.promisify)(f.chmod)}get mkdir(){return(0,I.promisify)(f.mkdir)}get unlink(){return(0,I.promisify)(f.unlink)}get rmdir(){return(0,I.promisify)(f.rmdir)}get realpath(){return(0,I.promisify)(f.realpath)}async exists(M){try{return await e.Promises.access(M),!0}catch{return!1}}get readdir(){return P}get readDirsInDir(){return u}get writeFile(){return t}get rm(){return b}get move(){return h}get copy(){return w}}}),define(ve[103],we([1,0,59,9,12,8,28]),function(te,e,f,i,I,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function k(v){if(I.isLinux)return v;const b=(0,i.dirname)(v);if(v===b)return v;const g=((0,i.basename)(v)||v).toLowerCase();try{const p=(0,C.readdirSync)(b).filter(P=>P.toLowerCase()===g);if(p.length===1){const P=k(b);if(P)return(0,i.join)(P,p[0])}else if(p.length>1){const P=p.indexOf(g);if(P>=0){const _=k(b);if(_)return(0,i.join)(_,p[P])}}}catch{}return null}e.realcaseSync=k;async function S(v){if(I.isLinux)return v;const b=(0,i.dirname)(v);if(v===b)return v;const g=((0,i.basename)(v)||v).toLowerCase();try{const p=(await C.Promises.readdir(b)).filter(P=>P.toLowerCase()===g);if(p.length===1){const P=await S(b);if(P)return(0,i.join)(P,p[0])}else if(p.length>1){const P=p.indexOf(g);if(P>=0){const _=await S(b);if(_)return(0,i.join)(_,p[P])}}}catch{}return null}e.realcase=S;async function R(v){try{return await C.Promises.realpath(v)}catch{const g=D(v);return await C.Promises.access(g,f.constants.R_OK),g}}e.realpath=R;function F(v){try{return f.realpathSync(v)}catch{const g=D(v);return f.accessSync(g,f.constants.R_OK),g}}e.realpathSync=F;function D(v){return(0,A.rtrim)((0,i.normalize)(v),i.sep)}});var Be=this&&this.__decorate||function(te,e,f,i){var I=arguments.length,A=I<3?e:i===null?i=Object.getOwnPropertyDescriptor(e,f):i,C;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(te,e,f,i);else for(var k=te.length-1;k>=0;k--)(C=te[k])&&(A=(I<3?C(A):I>3?C(e,f,A):C(e,f))||A);return I>3&&A&&Object.defineProperty(e,f,A),A};define(ve[104],we([1,0,18,16,22,21,56,15,3,6,58,8,13]),function(te,e,f,i,I,A,C,k,S,R,F,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var b;(function(q){q[q.Promise=100]="Promise",q[q.PromiseCancel=101]="PromiseCancel",q[q.EventListen=102]="EventListen",q[q.EventDispose=103]="EventDispose"})(b=e.RequestType||(e.RequestType={}));function g(q){switch(q){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var d;(function(q){q[q.Initialize=200]="Initialize",q[q.PromiseSuccess=201]="PromiseSuccess",q[q.PromiseError=202]="PromiseError",q[q.PromiseErrorObj=203]="PromiseErrorObj",q[q.EventFire=204]="EventFire"})(d=e.ResponseType||(e.ResponseType={}));function p(q){switch(q){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var P;(function(q){q[q.Uninitialized=0]="Uninitialized",q[q.Idle=1]="Idle"})(P||(P={}));class _{constructor(K){this.buffer=K,this.pos=0}read(K){const G=this.buffer.slice(this.pos,this.pos+K);return this.pos+=G.byteLength,G}}class l{constructor(){this.buffers=[]}get buffer(){return I.VSBuffer.concat(this.buffers)}write(K){this.buffers.push(K)}}var c;(function(q){q[q.Undefined=0]="Undefined",q[q.String=1]="String",q[q.Buffer=2]="Buffer",q[q.VSBuffer=3]="VSBuffer",q[q.Array=4]="Array",q[q.Object=5]="Object"})(c||(c={}));function u(q){const K=I.VSBuffer.alloc(4);return K.writeUInt32BE(q,0),K}function a(q){return q.read(4).readUInt32BE(0)}function E(q){const K=I.VSBuffer.alloc(1);return K.writeUInt8(q,0),K}const s={Undefined:E(c.Undefined),String:E(c.String),Buffer:E(c.Buffer),VSBuffer:E(c.VSBuffer),Array:E(c.Array),Object:E(c.Object)},t=typeof Buffer!="undefined";function r(q,K){if(typeof K=="undefined")q.write(s.Undefined);else if(typeof K=="string"){const G=I.VSBuffer.fromString(K);q.write(s.String),q.write(u(G.byteLength)),q.write(G)}else if(t&&Buffer.isBuffer(K)){const G=I.VSBuffer.wrap(K);q.write(s.Buffer),q.write(u(G.byteLength)),q.write(G)}else if(K instanceof I.VSBuffer)q.write(s.VSBuffer),q.write(u(K.byteLength)),q.write(K);else if(Array.isArray(K)){q.write(s.Array),q.write(u(K.length));for(const G of K)r(q,G)}else{const G=I.VSBuffer.fromString(JSON.stringify(K));q.write(s.Object),q.write(u(G.byteLength)),q.write(G)}}function n(q){switch(q.read(1).readUInt8(0)){case c.Undefined:return;case c.String:return q.read(a(q)).toString();case c.Buffer:return q.read(a(q)).buffer;case c.VSBuffer:return q.read(a(q));case c.Array:{const G=a(q),ee=[];for(let oe=0;oe<G;oe++)ee.push(n(q));return ee}case c.Object:return JSON.parse(q.read(a(q)).toString())}}class o{constructor(K,G,ee=null,oe=1e3){this.protocol=K,this.ctx=G,this.logger=ee,this.timeoutDelay=oe,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(ue=>this.onRawMessage(ue)),this.sendResponse({type:200})}registerChannel(K,G){this.channels.set(K,G),setTimeout(()=>this.flushPendingRequests(K),0)}sendResponse(K){switch(K.type){case 200:{const G=this.send([K.type]);this.logger?.logOutgoing(G,0,1,p(K.type));return}case 201:case 202:case 204:case 203:{const G=this.send([K.type,K.id],K.data);this.logger?.logOutgoing(G,K.id,1,p(K.type),K.data);return}}}send(K,G=void 0){const ee=new l;return r(ee,K),r(ee,G),this.sendBuffer(ee.buffer)}sendBuffer(K){try{return this.protocol.send(K),K.byteLength}catch{return 0}}onRawMessage(K){const G=new _(K),ee=n(G),oe=n(G),ue=ee[0];switch(ue){case 100:return this.logger?.logIncoming(K.byteLength,ee[1],1,`${g(ue)}: ${ee[2]}.${ee[3]}`,oe),this.onPromise({type:ue,id:ee[1],channelName:ee[2],name:ee[3],arg:oe});case 102:return this.logger?.logIncoming(K.byteLength,ee[1],1,`${g(ue)}: ${ee[2]}.${ee[3]}`,oe),this.onEventListen({type:ue,id:ee[1],channelName:ee[2],name:ee[3],arg:oe});case 101:return this.logger?.logIncoming(K.byteLength,ee[1],1,`${g(ue)}`),this.disposeActiveRequest({type:ue,id:ee[1]});case 103:return this.logger?.logIncoming(K.byteLength,ee[1],1,`${g(ue)}`),this.disposeActiveRequest({type:ue,id:ee[1]})}}onPromise(K){const G=this.channels.get(K.channelName);if(!G){this.collectPendingRequest(K);return}const ee=new A.CancellationTokenSource;let oe;try{oe=G.call(this.ctx,K.name,K.arg,ee.token)}catch(Y){oe=Promise.reject(Y)}const ue=K.id;oe.then(Y=>{this.sendResponse({id:ue,data:Y,type:201}),this.activeRequests.delete(K.id)},Y=>{Y instanceof Error?this.sendResponse({id:ue,data:{message:Y.message,name:Y.name,stack:Y.stack?Y.stack.split?Y.stack.split(`
`):Y.stack:void 0},type:202}):this.sendResponse({id:ue,data:Y,type:203}),this.activeRequests.delete(K.id)});const Z=(0,R.toDisposable)(()=>ee.cancel());this.activeRequests.set(K.id,Z)}onEventListen(K){const G=this.channels.get(K.channelName);if(!G){this.collectPendingRequest(K);return}const ee=K.id,ue=G.listen(this.ctx,K.name,K.arg)(Z=>this.sendResponse({id:ee,data:Z,type:204}));this.activeRequests.set(K.id,ue)}disposeActiveRequest(K){const G=this.activeRequests.get(K.id);G&&(G.dispose(),this.activeRequests.delete(K.id))}collectPendingRequest(K){let G=this.pendingRequests.get(K.channelName);G||(G=[],this.pendingRequests.set(K.channelName,G));const ee=setTimeout(()=>{console.error(`Unknown channel: ${K.channelName}`),K.type===100&&this.sendResponse({id:K.id,data:{name:"Unknown channel",message:`Channel name '${K.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);G.push({request:K,timeoutTimer:ee})}flushPendingRequests(K){const G=this.pendingRequests.get(K);if(G){for(const ee of G)switch(clearTimeout(ee.timeoutTimer),ee.request.type){case 100:this.onPromise(ee.request);break;case 102:this.onEventListen(ee.request);break}this.pendingRequests.delete(K)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,R.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=o;var m;(function(q){q[q.LocalSide=0]="LocalSide",q[q.OtherSide=1]="OtherSide"})(m=e.RequestInitiator||(e.RequestInitiator={}));class h{constructor(K,G=null){this.protocol=K,this.isDisposed=!1,this.state=P.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new S.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(ee=>this.onBuffer(ee)),this.logger=G}getChannel(K){const G=this;return{call(ee,oe,ue){return G.isDisposed?Promise.reject(k.canceled()):G.requestPromise(K,ee,oe,ue)},listen(ee,oe){return G.isDisposed?S.Event.None:G.requestEvent(K,ee,oe)}}}requestPromise(K,G,ee,oe=A.CancellationToken.None){const ue=this.lastRequestId++,Y={id:ue,type:100,channelName:K,name:G,arg:ee};if(oe.isCancellationRequested)return Promise.reject(k.canceled());let se;return new Promise((ge,Te)=>{if(oe.isCancellationRequested)return Te(k.canceled());const Ne=()=>{const B=N=>{switch(N.type){case 201:this.handlers.delete(ue),ge(N.data);break;case 202:{this.handlers.delete(ue);const W=new Error(N.data.message);W.stack=N.data.stack,W.name=N.data.name,Te(W);break}case 203:this.handlers.delete(ue),Te(N.data);break}};this.handlers.set(ue,B),this.sendRequest(Y)};let be=null;this.state===P.Idle?Ne():(be=(0,i.createCancelablePromise)(B=>this.whenInitialized()),be.then(()=>{be=null,Ne()}));const Ee=()=>{be?(be.cancel(),be=null):this.sendRequest({id:ue,type:101}),Te(k.canceled())},z=oe.onCancellationRequested(Ee);se=(0,R.combinedDisposable)((0,R.toDisposable)(Ee),z),this.activeRequests.add(se)}).finally(()=>{this.activeRequests.delete(se)})}requestEvent(K,G,ee){const oe=this.lastRequestId++,Z={id:oe,type:102,channelName:K,name:G,arg:ee};let Y=null;const se=new S.Emitter({onFirstListenerAdd:()=>{Y=(0,i.createCancelablePromise)(ge=>this.whenInitialized()),Y.then(()=>{Y=null,this.activeRequests.add(se),this.sendRequest(Z)})},onLastListenerRemove:()=>{Y?(Y.cancel(),Y=null):(this.activeRequests.delete(se),this.sendRequest({id:oe,type:103}))}}),de=ge=>se.fire(ge.data);return this.handlers.set(oe,de),se.event}sendRequest(K){switch(K.type){case 100:case 102:{const G=this.send([K.type,K.id,K.channelName,K.name],K.arg);this.logger&&this.logger.logOutgoing(G,K.id,0,`${g(K.type)}: ${K.channelName}.${K.name}`,K.arg);return}case 101:case 103:{const G=this.send([K.type,K.id]);this.logger&&this.logger.logOutgoing(G,K.id,0,g(K.type));return}}}send(K,G=void 0){const ee=new l;return r(ee,K),r(ee,G),this.sendBuffer(ee.buffer)}sendBuffer(K){try{return this.protocol.send(K),K.byteLength}catch{return 0}}onBuffer(K){const G=new _(K),ee=n(G),oe=n(G),ue=ee[0];switch(ue){case 200:return this.logger&&this.logger.logIncoming(K.byteLength,0,0,p(ue)),this.onResponse({type:ee[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(K.byteLength,ee[1],0,p(ue),oe),this.onResponse({type:ee[0],id:ee[1],data:oe})}}onResponse(K){if(K.type===200){this.state=P.Idle,this._onDidInitialize.fire();return}const G=this.handlers.get(K.id);G&&G(K)}get onDidInitializePromise(){return S.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===P.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,R.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}Be([C.memoize],h.prototype,"onDidInitializePromise",null),e.ChannelClient=h;class w{constructor(K){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new S.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new S.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,K(({protocol:G,onDidClientDisconnect:ee})=>{S.Event.once(G.onMessage)(ue=>{const Z=new _(ue),Y=n(Z),se=new o(G,Y),de=new h(G);this.channels.forEach((Te,Ne)=>se.registerChannel(Ne,Te));const ge={channelServer:se,channelClient:de,ctx:Y};this._connections.add(ge),this._onDidAddConnection.fire(ge),ee(()=>{se.dispose(),de.dispose(),this._connections.delete(ge),this._onDidRemoveConnection.fire(ge)})})})}get connections(){const K=[];return this._connections.forEach(G=>K.push(G)),K}getChannel(K,G){const ee=this;return{call(oe,ue,Z){let Y;if((0,v.isFunction)(G)){let de=(0,f.getRandomElement)(ee.connections.filter(G));Y=de?Promise.resolve(de):S.Event.toPromise(S.Event.filter(ee.onDidAddConnection,G))}else Y=G.routeCall(ee,oe,ue);const se=Y.then(de=>de.channelClient.getChannel(K));return L(se).call(oe,ue,Z)},listen(oe,ue){if((0,v.isFunction)(G))return ee.getMulticastEvent(K,G,oe,ue);const Z=G.routeEvent(ee,oe,ue).then(Y=>Y.channelClient.getChannel(K));return L(Z).listen(oe,ue)}}}getMulticastEvent(K,G,ee,oe){const ue=this;let Z=new R.DisposableStore;const Y=new S.Emitter({onFirstListenerAdd:()=>{Z=new R.DisposableStore;const se=new S.EventMultiplexer,de=new Map,ge=Ne=>{const Ee=Ne.channelClient.getChannel(K).listen(ee,oe),z=se.add(Ee);de.set(Ne,z)},Te=Ne=>{const be=de.get(Ne);!be||(be.dispose(),de.delete(Ne))};ue.connections.filter(G).forEach(ge),S.Event.filter(ue.onDidAddConnection,G)(ge,void 0,Z),ue.onDidRemoveConnection(Te,void 0,Z),se.event(Y.fire,Y,Z),Z.add(se)},onLastListenerRemove:()=>{Z.dispose()}});return Y.event}registerChannel(K,G){this.channels.set(K,G),this._connections.forEach(ee=>{ee.channelServer.registerChannel(K,G)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=w;class T{constructor(K,G,ee=null){const oe=new l;r(oe,G),K.send(oe.buffer),this.channelClient=new h(K,ee),this.channelServer=new o(K,G,ee)}getChannel(K){return this.channelClient.getChannel(K)}registerChannel(K,G){this.channelServer.registerChannel(K,G)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=T;function L(q){return{call(K,G,ee){return q.then(oe=>oe.call(K,G,ee))},listen(K,G){const ee=new S.Relay;return q.then(oe=>ee.input=oe.listen(K,G)),ee.event}}}e.getDelayedChannel=L;function O(q){let K=!1;return{call(G,ee,oe){return K?q.call(G,ee,oe):(0,i.timeout)(0).then(()=>K=!0).then(()=>q.call(G,ee,oe))},listen(G,ee){if(K)return q.listen(G,ee);const oe=new S.Relay;return(0,i.timeout)(0).then(()=>K=!0).then(()=>oe.input=q.listen(G,ee)),oe.event}}}e.getNextTickChannel=O;class y{constructor(K){this.fn=K}routeCall(K){return this.route(K)}routeEvent(K){return this.route(K)}async route(K){for(const G of K.connections)if(await Promise.resolve(this.fn(G.ctx)))return Promise.resolve(G);return await S.Event.toPromise(K.onDidAddConnection),await this.route(K)}}e.StaticRouter=y;var H;(function(q){function K(ue,Z){const Y=ue,se=Z&&Z.disableMarshalling,de=new Map;for(const ge in Y)ee(ge)&&de.set(ge,S.Event.buffer(Y[ge],!0));return new class{listen(ge,Te,Ne){const be=de.get(Te);if(be)return be;if(oe(Te)){const Ee=Y[Te];if(typeof Ee=="function")return Ee.call(Y,Ne)}throw new Error(`Event not found: ${Te}`)}call(ge,Te,Ne){const be=Y[Te];if(typeof be=="function"){if(!se&&Array.isArray(Ne))for(let Ee=0;Ee<Ne.length;Ee++)Ne[Ee]=(0,F.revive)(Ne[Ee]);return be.apply(Y,Ne)}throw new Error(`Method not found: ${Te}`)}}}q.fromService=K;function G(ue,Z){const Y=Z&&Z.disableMarshalling;return new Proxy({},{get(se,de){if(typeof de=="string")return Z?.properties?.has(de)?Z.properties.get(de):oe(de)?function(ge){return ue.listen(de,ge)}:ee(de)?ue.listen(de):async function(...ge){let Te;Z&&!(0,v.isUndefinedOrNull)(Z.context)?Te=[Z.context,...ge]:Te=ge;const Ne=await ue.call(de,Te);return Y?Ne:(0,F.revive)(Ne)};throw new Error(`Property not found: ${String(de)}`)}})}q.toService=G;function ee(ue){return ue[0]==="o"&&ue[1]==="n"&&D.isUpperAsciiLetter(ue.charCodeAt(2))}function oe(ue){return/^onDynamic/.test(ue)&&D.isUpperAsciiLetter(ue.charCodeAt(9))}})(H=e.ProxyChannel||(e.ProxyChannel={}));const M=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function j(q){if(Array.isArray(q))return q;if(q&&typeof q=="object"&&typeof q.toString=="function"){let K=q.toString();if(K!=="[object Object]")return K}return q}function X(q){return Array.isArray(q)?q.map(j):j(q)}function $(q,K,G,ee,oe,ue,Z){Z=X(Z);const Y=M[oe],se=Y[ee%Y.length];let de=[`%c[${q}]%c[${String(K).padStart(7," ")}]%c[len: ${String(G).padStart(5," ")}]%c${String(ee).padStart(5," ")} - ${ue}`,"color: darkgreen","color: grey","color: grey",`color: ${se}`];/\($/.test(ue)?(de=de.concat(Z),de.push(")")):de.push(Z),console.log.apply(console,de)}e.logWithColors=$;class U{constructor(K,G){this._outgoingPrefix=K,this._incomingPrefix=G,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(K,G,ee,oe,ue){this._totalOutgoing+=K,$(this._outgoingPrefix,this._totalOutgoing,K,G,ee,oe,ue)}logIncoming(K,G,ee,oe,ue){this._totalIncoming+=K,$(this._incomingPrefix,this._totalIncoming,K,G,ee,oe,ue)}}e.IPCLogger=U}),define(ve[105],we([1,0,22,3,6,104]),function(te,e,f,i,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var C;(function(t){t.Created="created",t.Read="read",t.Write="write",t.Open="open",t.Error="error",t.Close="close",t.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",t.NodeEndReceived="nodeEndReceived",t.NodeEndSent="nodeEndSent",t.NodeDrainBegin="nodeDrainBegin",t.NodeDrainEnd="nodeDrainEnd",t.zlibInflateError="zlibInflateError",t.zlibInflateData="zlibInflateData",t.zlibInflateInitialWrite="zlibInflateInitialWrite",t.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",t.zlibInflateWrite="zlibInflateWrite",t.zlibInflateFlushFired="zlibInflateFlushFired",t.zlibDeflateError="zlibDeflateError",t.zlibDeflateData="zlibDeflateData",t.zlibDeflateWrite="zlibDeflateWrite",t.zlibDeflateFlushFired="zlibDeflateFlushFired",t.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",t.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",t.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",t.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",t.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",t.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",t.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",t.ProtocolHeaderRead="protocolHeaderRead",t.ProtocolMessageRead="protocolMessageRead",t.ProtocolHeaderWrite="protocolHeaderWrite",t.ProtocolMessageWrite="protocolMessageWrite",t.ProtocolWrite="protocolWrite"})(C=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var k;(function(t){t.enableDiagnostics=!1,t.records=[];const r=new WeakMap;let n=0;function o(h,w){if(!r.has(h)){const T=String(++n);r.set(h,T)}return r.get(h)}function m(h,w,T,L){if(!t.enableDiagnostics)return;const O=o(h,w);if(L instanceof f.VSBuffer||L instanceof Uint8Array||L instanceof ArrayBuffer||ArrayBuffer.isView(L)){const y=f.VSBuffer.alloc(L.byteLength);y.set(L),t.records.push({timestamp:Date.now(),id:O,label:w,type:T,buff:y})}else t.records.push({timestamp:Date.now(),id:O,label:w,type:T,data:L})}t.traceSocketEvent=m})(k=e.SocketDiagnostics||(e.SocketDiagnostics={}));var S;(function(t){t[t.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",t[t.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(S=e.SocketCloseEventType||(e.SocketCloseEventType={}));let R=null;function F(){return R||(R=f.VSBuffer.alloc(0)),R}class D{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(r){this._chunks.push(r),this._totalLength+=r.byteLength}read(r){return this._read(r,!0)}peek(r){return this._read(r,!1)}_read(r,n){if(r===0)return F();if(r>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===r){const w=this._chunks[0];return n&&(this._chunks.shift(),this._totalLength-=r),w}if(this._chunks[0].byteLength>r){const w=this._chunks[0].slice(0,r);return n&&(this._chunks[0]=this._chunks[0].slice(r),this._totalLength-=r),w}let o=f.VSBuffer.alloc(r),m=0,h=0;for(;r>0;){const w=this._chunks[h];if(w.byteLength>r){const T=w.slice(0,r);o.set(T,m),m+=r,n&&(this._chunks[h]=w.slice(r),this._totalLength-=r),r-=r}else o.set(w,m),m+=w.byteLength,n?(this._chunks.shift(),this._totalLength-=w.byteLength):h++,r-=w.byteLength}return o}}e.ChunkStream=D;var v;(function(t){t[t.None=0]="None",t[t.Regular=1]="Regular",t[t.Control=2]="Control",t[t.Ack=3]="Ack",t[t.Disconnect=5]="Disconnect",t[t.ReplayRequest=6]="ReplayRequest",t[t.Pause=7]="Pause",t[t.Resume=8]="Resume"})(v||(v={}));function b(t){switch(t){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var g;(function(t){t[t.HeaderLength=13]="HeaderLength",t[t.AcknowledgeTime=2e3]="AcknowledgeTime",t[t.TimeoutTime=2e4]="TimeoutTime",t[t.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",t[t.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(g=e.ProtocolConstants||(e.ProtocolConstants={}));class d{constructor(r,n,o,m){this.type=r,this.id=n,this.ack=o,this.data=m,this.writtenTime=0}get size(){return this.data.byteLength}}class p extends I.Disposable{constructor(r){super();this._onMessage=this._register(new i.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=r,this._isDisposed=!1,this._incomingData=new D,this._register(this._socket.onData(n=>this.acceptChunk(n))),this.lastReadTime=Date.now()}acceptChunk(r){if(!(!r||r.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(r);this._incomingData.byteLength>=this._state.readLen;){const n=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=n.readUInt32BE(9),this._state.messageType=n.readUInt8(0),this._state.id=n.readUInt32BE(1),this._state.ack=n.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:b(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const o=this._state.messageType,m=this._state.id,h=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",n),this._onMessage.fire(new d(o,m,h,n)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class P{constructor(r){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=r,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(r){if(this._isDisposed)return;r.writtenTime=Date.now(),this.lastWriteTime=Date.now();const n=f.VSBuffer.alloc(13);n.writeUInt8(r.type,0),n.writeUInt32BE(r.id,1),n.writeUInt32BE(r.ack,5),n.writeUInt32BE(r.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:b(r.type),id:r.id,ack:r.ack,messageSize:r.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",r.data),this._writeSoon(n,r.data)}_bufferAdd(r,n){const o=this._totalLength===0;return this._data.push(r,n),this._totalLength+=r.byteLength+n.byteLength,o}_bufferTake(){const r=f.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,r}_writeSoon(r,n){this._bufferAdd(r,n)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const r=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:r.byteLength}),this._socket.write(r)}}class _ extends I.Disposable{constructor(r){super();this._onMessage=new i.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new i.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=r,this._socketWriter=this._register(new P(this._socket)),this._socketReader=this._register(new p(this._socket)),this._register(this._socketReader.onMessage(n=>{n.type===1&&this._onMessage.fire(n.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(r){this._socketWriter.write(new d(1,0,0,r))}}e.Protocol=_;class l extends A.IPCClient{constructor(r,n,o=null){super(r,n,o);this.protocol=r}static fromSocket(r,n){return new l(new _(r),n)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const r=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),r.end()}}e.Client=l;class c{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new i.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(r){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(r):this._emitter.fire(r):this._bufferedMessages.push(r)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=c;class u{constructor(r){this.data=r,this.next=null}}class a{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let r=[],n=0,o=this._first;for(;o;)r[n++]=o.data,o=o.next;return r}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(r){const n=new u(r);if(!this._first){this._first=n,this._last=n;return}this._last.next=n,this._last=n}}class E{constructor(){this.lastRuns=[];const r=Date.now();for(let n=0;n<E._HISTORY_LENGTH;n++)this.lastRuns[n]=r-1e3*n;setInterval(()=>{for(let n=E._HISTORY_LENGTH;n>=1;n--)this.lastRuns[n]=this.lastRuns[n-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return E._INSTANCE||(E._INSTANCE=new E),E._INSTANCE}load(){const r=Date.now(),n=(1+E._HISTORY_LENGTH)*1e3;let o=0;for(let m=0;m<E._HISTORY_LENGTH;m++)r-this.lastRuns[m]<=n&&o++;return 1-o/E._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}E._HISTORY_LENGTH=10,E._INSTANCE=null;class s{constructor(r,n=null,o=E.getInstance()){this._onControlMessage=new c,this.onControlMessage=this._onControlMessage.event,this._onMessage=new c,this.onMessage=this._onMessage.event,this._onDidDispose=new c,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new c,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new c,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=o,this._isReconnecting=!1,this._outgoingUnackMsg=new a,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=r,this._socketWriter=new P(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new p(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(m=>this._receiveMessage(m))),this._socketDisposables.push(this._socket.onClose(m=>this._onSocketClose.fire(m))),n&&this._socketReader.acceptChunk(n)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,I.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const r=new d(5,0,0,F());this._socketWriter.write(r),this._socketWriter.flush()}sendPause(){const r=new d(7,0,0,F());this._socketWriter.write(r)}sendResume(){const r=new d(8,0,0,F());this._socketWriter.write(r)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(r,n){this._isReconnecting=!0,this._socketDisposables=(0,I.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=r,this._socketWriter=new P(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new p(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(o=>this._receiveMessage(o))),this._socketDisposables.push(this._socket.onClose(o=>this._onSocketClose.fire(o))),this._socketReader.acceptChunk(n)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const r=new d(3,0,this._incomingAckId,F());this._socketWriter.write(r);const n=this._outgoingUnackMsg.toArray();for(let o=0,m=n.length;o<m;o++)this._socketWriter.write(n[o]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(r){if(r.ack>this._outgoingAckId){this._outgoingAckId=r.ack;do{const n=this._outgoingUnackMsg.peek();if(n&&n.id<=r.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(r.type){case 0:break;case 1:{if(r.id>this._incomingMsgId)if(r.id!==this._incomingMsgId+1){const n=Date.now();n-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=n,this._socketWriter.write(new d(6,0,0,F())))}else this._incomingMsgId=r.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(r.data);break}case 2:{this._onControlMessage.fire(r.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const n=this._outgoingUnackMsg.toArray();for(let o=0,m=n.length;o<m;o++)this._socketWriter.write(n[o]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(r){const n=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const o=new d(1,n,this._incomingAckId,r);this._outgoingUnackMsg.push(o),this._isReconnecting||(this._socketWriter.write(o),this._recvAckCheck())}sendControl(r){const n=new d(2,0,0,r);this._socketWriter.write(n)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const r=Date.now()-this._incomingMsgLastTime;if(r>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-r+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const r=this._outgoingUnackMsg.peek(),n=Date.now()-r.writtenTime,o=Date.now()-this._socketReader.lastReadTime,m=Date.now()-this._lastSocketTimeoutTime;if(n>=2e4&&o>=2e4&&m>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const h=Math.max(2e4-n,2e4-o,2e4-m,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},h)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const r=new d(3,0,this._incomingAckId,F());this._socketWriter.write(r)}}e.PersistentProtocol=s}),define(ve[106],we([1,0,96]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class i{constructor(k){const S=(0,f.toUint8)(k);this._defaultValue=S,this._asciiMap=i._createAsciiMap(S),this._map=new Map}static _createAsciiMap(k){const S=new Uint8Array(256);for(let R=0;R<256;R++)S[R]=k;return S}set(k,S){const R=(0,f.toUint8)(S);k>=0&&k<256?this._asciiMap[k]=R:this._map.set(k,R)}get(k){return k>=0&&k<256?this._asciiMap[k]:this._map.get(k)||this._defaultValue}}e.CharacterClassifier=i;var I;(function(C){C[C.False=0]="False",C[C.True=1]="True"})(I||(I={}));class A{constructor(){this._actual=new i(0)}add(k){this._actual.set(k,1)}has(k){return this._actual.get(k)===1}}e.CharacterSet=A}),define(ve[48],we([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class f{constructor(I,A){this.lineNumber=I,this.column=A}with(I=this.lineNumber,A=this.column){return I===this.lineNumber&&A===this.column?this:new f(I,A)}delta(I=0,A=0){return this.with(this.lineNumber+I,this.column+A)}equals(I){return f.equals(this,I)}static equals(I,A){return!I&&!A?!0:!!I&&!!A&&I.lineNumber===A.lineNumber&&I.column===A.column}isBefore(I){return f.isBefore(this,I)}static isBefore(I,A){return I.lineNumber<A.lineNumber?!0:A.lineNumber<I.lineNumber?!1:I.column<A.column}isBeforeOrEqual(I){return f.isBeforeOrEqual(this,I)}static isBeforeOrEqual(I,A){return I.lineNumber<A.lineNumber?!0:A.lineNumber<I.lineNumber?!1:I.column<=A.column}static compare(I,A){const C=I.lineNumber|0,k=A.lineNumber|0;if(C===k){const S=I.column|0,R=A.column|0;return S-R}return C-k}clone(){return new f(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(I){return new f(I.lineNumber,I.column)}static isIPosition(I){return I&&typeof I.lineNumber=="number"&&typeof I.column=="number"}}e.Position=f}),define(ve[35],we([1,0,48]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class i{constructor(A,C,k,S){A>k||A===k&&C>S?(this.startLineNumber=k,this.startColumn=S,this.endLineNumber=A,this.endColumn=C):(this.startLineNumber=A,this.startColumn=C,this.endLineNumber=k,this.endColumn=S)}isEmpty(){return i.isEmpty(this)}static isEmpty(A){return A.startLineNumber===A.endLineNumber&&A.startColumn===A.endColumn}containsPosition(A){return i.containsPosition(this,A)}static containsPosition(A,C){return!(C.lineNumber<A.startLineNumber||C.lineNumber>A.endLineNumber||C.lineNumber===A.startLineNumber&&C.column<A.startColumn||C.lineNumber===A.endLineNumber&&C.column>A.endColumn)}static strictContainsPosition(A,C){return!(C.lineNumber<A.startLineNumber||C.lineNumber>A.endLineNumber||C.lineNumber===A.startLineNumber&&C.column<=A.startColumn||C.lineNumber===A.endLineNumber&&C.column>=A.endColumn)}containsRange(A){return i.containsRange(this,A)}static containsRange(A,C){return!(C.startLineNumber<A.startLineNumber||C.endLineNumber<A.startLineNumber||C.startLineNumber>A.endLineNumber||C.endLineNumber>A.endLineNumber||C.startLineNumber===A.startLineNumber&&C.startColumn<A.startColumn||C.endLineNumber===A.endLineNumber&&C.endColumn>A.endColumn)}strictContainsRange(A){return i.strictContainsRange(this,A)}static strictContainsRange(A,C){return!(C.startLineNumber<A.startLineNumber||C.endLineNumber<A.startLineNumber||C.startLineNumber>A.endLineNumber||C.endLineNumber>A.endLineNumber||C.startLineNumber===A.startLineNumber&&C.startColumn<=A.startColumn||C.endLineNumber===A.endLineNumber&&C.endColumn>=A.endColumn)}plusRange(A){return i.plusRange(this,A)}static plusRange(A,C){let k,S,R,F;return C.startLineNumber<A.startLineNumber?(k=C.startLineNumber,S=C.startColumn):C.startLineNumber===A.startLineNumber?(k=C.startLineNumber,S=Math.min(C.startColumn,A.startColumn)):(k=A.startLineNumber,S=A.startColumn),C.endLineNumber>A.endLineNumber?(R=C.endLineNumber,F=C.endColumn):C.endLineNumber===A.endLineNumber?(R=C.endLineNumber,F=Math.max(C.endColumn,A.endColumn)):(R=A.endLineNumber,F=A.endColumn),new i(k,S,R,F)}intersectRanges(A){return i.intersectRanges(this,A)}static intersectRanges(A,C){let k=A.startLineNumber,S=A.startColumn,R=A.endLineNumber,F=A.endColumn,D=C.startLineNumber,v=C.startColumn,b=C.endLineNumber,g=C.endColumn;return k<D?(k=D,S=v):k===D&&(S=Math.max(S,v)),R>b?(R=b,F=g):R===b&&(F=Math.min(F,g)),k>R||k===R&&S>F?null:new i(k,S,R,F)}equalsRange(A){return i.equalsRange(this,A)}static equalsRange(A,C){return!!A&&!!C&&A.startLineNumber===C.startLineNumber&&A.startColumn===C.startColumn&&A.endLineNumber===C.endLineNumber&&A.endColumn===C.endColumn}getEndPosition(){return i.getEndPosition(this)}static getEndPosition(A){return new f.Position(A.endLineNumber,A.endColumn)}getStartPosition(){return i.getStartPosition(this)}static getStartPosition(A){return new f.Position(A.startLineNumber,A.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(A,C){return new i(this.startLineNumber,this.startColumn,A,C)}setStartPosition(A,C){return new i(A,C,this.endLineNumber,this.endColumn)}collapseToStart(){return i.collapseToStart(this)}static collapseToStart(A){return new i(A.startLineNumber,A.startColumn,A.startLineNumber,A.startColumn)}static fromPositions(A,C=A){return new i(A.lineNumber,A.column,C.lineNumber,C.column)}static lift(A){return A?new i(A.startLineNumber,A.startColumn,A.endLineNumber,A.endColumn):null}static isIRange(A){return A&&typeof A.startLineNumber=="number"&&typeof A.startColumn=="number"&&typeof A.endLineNumber=="number"&&typeof A.endColumn=="number"}static areIntersectingOrTouching(A,C){return!(A.endLineNumber<C.startLineNumber||A.endLineNumber===C.startLineNumber&&A.endColumn<C.startColumn||C.endLineNumber<A.startLineNumber||C.endLineNumber===A.startLineNumber&&C.endColumn<A.startColumn)}static areIntersecting(A,C){return!(A.endLineNumber<C.startLineNumber||A.endLineNumber===C.startLineNumber&&A.endColumn<=C.startColumn||C.endLineNumber<A.startLineNumber||C.endLineNumber===A.startLineNumber&&C.endColumn<=A.startColumn)}static compareRangesUsingStarts(A,C){if(A&&C){const R=A.startLineNumber|0,F=C.startLineNumber|0;if(R===F){const D=A.startColumn|0,v=C.startColumn|0;if(D===v){const b=A.endLineNumber|0,g=C.endLineNumber|0;if(b===g){const d=A.endColumn|0,p=C.endColumn|0;return d-p}return b-g}return D-v}return R-F}return(A?1:0)-(C?1:0)}static compareRangesUsingEnds(A,C){return A.endLineNumber===C.endLineNumber?A.endColumn===C.endColumn?A.startLineNumber===C.startLineNumber?A.startColumn-C.startColumn:A.startLineNumber-C.startLineNumber:A.endColumn-C.endColumn:A.endLineNumber-C.endLineNumber}static spansMultipleLines(A){return A.endLineNumber>A.startLineNumber}toJSON(){return this}}e.Range=i}),define(ve[146],we([1,0,48,35]),function(te,e,f,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var I;(function(C){C[C.LTR=0]="LTR",C[C.RTL=1]="RTL"})(I=e.SelectionDirection||(e.SelectionDirection={}));class A extends i.Range{constructor(k,S,R,F){super(k,S,R,F);this.selectionStartLineNumber=k,this.selectionStartColumn=S,this.positionLineNumber=R,this.positionColumn=F}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(k){return A.selectionsEqual(this,k)}static selectionsEqual(k,S){return k.selectionStartLineNumber===S.selectionStartLineNumber&&k.selectionStartColumn===S.selectionStartColumn&&k.positionLineNumber===S.positionLineNumber&&k.positionColumn===S.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(k,S){return this.getDirection()===0?new A(this.startLineNumber,this.startColumn,k,S):new A(k,S,this.startLineNumber,this.startColumn)}getPosition(){return new f.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new f.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(k,S){return this.getDirection()===0?new A(k,S,this.endLineNumber,this.endColumn):new A(this.endLineNumber,this.endColumn,k,S)}static fromPositions(k,S=k){return new A(k.lineNumber,k.column,S.lineNumber,S.column)}static fromRange(k,S){return S===0?new A(k.startLineNumber,k.startColumn,k.endLineNumber,k.endColumn):new A(k.endLineNumber,k.endColumn,k.startLineNumber,k.startColumn)}static liftSelection(k){return new A(k.selectionStartLineNumber,k.selectionStartColumn,k.positionLineNumber,k.positionColumn)}static selectionsArrEqual(k,S){if(k&&!S||!k&&S)return!1;if(!k&&!S)return!0;if(k.length!==S.length)return!1;for(let R=0,F=k.length;R<F;R++)if(!this.selectionsEqual(k[R],S[R]))return!1;return!0}static isISelection(k){return k&&typeof k.selectionStartLineNumber=="number"&&typeof k.selectionStartColumn=="number"&&typeof k.positionLineNumber=="number"&&typeof k.positionColumn=="number"}static createWithDirection(k,S,R,F,D){return D===0?new A(k,S,R,F):new A(R,F,k,S)}}e.Selection=A}),define(ve[147],we([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}}}),define(ve[148],we([1,0,106]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var i;(function(C){C[C.Regular=0]="Regular",C[C.Whitespace=1]="Whitespace",C[C.WordSeparator=2]="WordSeparator"})(i=e.WordCharacterClass||(e.WordCharacterClass={}));class I extends f.CharacterClassifier{constructor(k){super(0);for(let S=0,R=k.length;S<R;S++)this.set(k.charCodeAt(S),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=I;function A(C){const k={};return S=>(k.hasOwnProperty(S)||(k[S]=C(S)),k[S])}e.getMapForWordSeparators=A(C=>new I(C))}),define(ve[107],we([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function f(k=""){let S="(-?\\d*\\.\\d\\w*)|([^";for(const R of e.USUAL_WORD_SEPARATORS)k.indexOf(R)>=0||(S+="\\"+R);return S+="\\s]+)",new RegExp(S,"g")}e.DEFAULT_WORD_REGEXP=f();function i(k){let S=e.DEFAULT_WORD_REGEXP;if(k&&k instanceof RegExp)if(k.global)S=k;else{let R="g";k.ignoreCase&&(R+="i"),k.multiline&&(R+="m"),k.unicode&&(R+="u"),S=new RegExp(k.source,R)}return S.lastIndex=0,S}e.ensureValidWordDefinition=i;const I={maxLen:1e3,windowSize:15,timeBudget:150};function A(k,S,R,F,D=I){if(R.length>D.maxLen){let p=k-D.maxLen/2;return p<0?p=0:F+=p,R=R.substring(p,k+D.maxLen/2),A(k,S,R,F,D)}const v=Date.now(),b=k-1-F;let g=-1,d=null;for(let p=1;!(Date.now()-v>=D.timeBudget);p++){const P=b-D.windowSize*p;S.lastIndex=Math.max(0,P);const _=C(S,R,b,g);if(!_&&d||(d=_,P<=0))break;g=P}if(d){const p={word:d[0],startColumn:F+1+d.index,endColumn:F+1+d.index+d[0].length};return S.lastIndex=0,p}return null}e.getWordAtText=A;function C(k,S,R,F){let D;for(;D=k.exec(S);){const v=D.index||0;if(v<=R&&k.lastIndex>=R)return D;if(F>0&&v>F)return null}return null}}),define(ve[108],we([1,0,32,9]),function(te,e,f,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function I(A,C,k,S,R){if(Array.isArray(A)){let F=0;for(const D of A){const v=I(D,C,k,S,R);if(v===10)return v;v>F&&(F=v)}return F}else{if(typeof A=="string")return S?A==="*"?5:A===k?10:0:0;if(A){const{language:F,pattern:D,scheme:v,hasAccessToAllModels:b,notebookType:g}=A;if(!S&&!b)return 0;let d=0;if(v)if(v===C.scheme)d=10;else if(v==="*")d=5;else return 0;if(F)if(F===k)d=10;else if(F==="*")d=Math.max(d,5);else return 0;if(g)if(g===R)d=10;else if(g==="*")d=Math.max(d,5);else return 0;if(D){let p;if(typeof D=="string"?p=D:p={...D,base:(0,i.normalize)(D.base)},p===C.fsPath||(0,f.match)(p,C.fsPath))d=10;else return 0}return d}else return 0}}e.score=I}),define(ve[149],we([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var f;(function(C){C[C.None=0]="None",C[C.Indent=1]="Indent",C[C.IndentOutdent=2]="IndentOutdent",C[C.Outdent=3]="Outdent"})(f=e.IndentAction||(e.IndentAction={}));class i{constructor(k){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=k.open,this.close=k.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(k.notIn))for(let S=0,R=k.notIn.length;S<R;S++)switch(k.notIn[S]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(k){switch(k){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(k,S){if(k.getTokenCount()===0)return!0;const R=k.findTokenIndexAtOffset(S-2),F=k.getStandardTokenType(R);return this.isOK(F)}_findNeutralCharacterInRange(k,S){for(let R=k;R<=S;R++){const F=String.fromCharCode(R);if(!this.open.includes(F)&&!this.close.includes(F))return F}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=i;class I{constructor(k){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const S of k)A(this.autoClosingPairsOpenByStart,S.open.charAt(0),S),A(this.autoClosingPairsOpenByEnd,S.open.charAt(S.open.length-1),S),A(this.autoClosingPairsCloseByStart,S.close.charAt(0),S),A(this.autoClosingPairsCloseByEnd,S.close.charAt(S.close.length-1),S),S.close.length===1&&S.open.length===1&&A(this.autoClosingPairsCloseSingleChar,S.close,S)}}e.AutoClosingPairs=I;function A(C,k,S){C.has(k)?C.get(k).push(S):C.set(k,[S])}}),define(ve[150],we([1,0,106]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var i;(function(b){b[b.Invalid=0]="Invalid",b[b.Start=1]="Start",b[b.H=2]="H",b[b.HT=3]="HT",b[b.HTT=4]="HTT",b[b.HTTP=5]="HTTP",b[b.F=6]="F",b[b.FI=7]="FI",b[b.FIL=8]="FIL",b[b.BeforeColon=9]="BeforeColon",b[b.AfterColon=10]="AfterColon",b[b.AlmostThere=11]="AlmostThere",b[b.End=12]="End",b[b.Accept=13]="Accept",b[b.LastKnownState=14]="LastKnownState"})(i=e.State||(e.State={}));class I{constructor(g,d,p){const P=new Uint8Array(g*d);for(let _=0,l=g*d;_<l;_++)P[_]=p;this._data=P,this.rows=g,this.cols=d}get(g,d){return this._data[g*this.cols+d]}set(g,d,p){this._data[g*this.cols+d]=p}}e.Uint8Matrix=I;class A{constructor(g){let d=0,p=0;for(let _=0,l=g.length;_<l;_++){const[c,u,a]=g[_];u>d&&(d=u),c>p&&(p=c),a>p&&(p=a)}d++,p++;const P=new I(p,d,0);for(let _=0,l=g.length;_<l;_++){const[c,u,a]=g[_];P.set(c,u,a)}this._states=P,this._maxCharCode=d}nextState(g,d){return d<0||d>=this._maxCharCode?0:this._states.get(g,d)}}e.StateMachine=A;let C=null;function k(){return C===null&&(C=new A([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),C}var S;(function(b){b[b.None=0]="None",b[b.ForceTermination=1]="ForceTermination",b[b.CannotEndIn=2]="CannotEndIn"})(S||(S={}));let R=null;function F(){if(R===null){R=new f.CharacterClassifier(0);const b=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let d=0;d<b.length;d++)R.set(b.charCodeAt(d),1);const g=".,;";for(let d=0;d<g.length;d++)R.set(g.charCodeAt(d),2)}return R}class D{static _createLink(g,d,p,P,_){let l=_-1;do{const c=d.charCodeAt(l);if(g.get(c)!==2)break;l--}while(l>P);if(P>0){const c=d.charCodeAt(P-1),u=d.charCodeAt(l);(c===40&&u===41||c===91&&u===93||c===123&&u===125)&&l--}return{range:{startLineNumber:p,startColumn:P+1,endLineNumber:p,endColumn:l+2},url:d.substring(P,l+1)}}static computeLinks(g,d=k()){const p=F(),P=[];for(let _=1,l=g.getLineCount();_<=l;_++){const c=g.getLineContent(_),u=c.length;let a=0,E=0,s=0,t=1,r=!1,n=!1,o=!1,m=!1;for(;a<u;){let h=!1;const w=c.charCodeAt(a);if(t===13){let T;switch(w){case 40:r=!0,T=0;break;case 41:T=r?0:1;break;case 91:o=!0,n=!0,T=0;break;case 93:o=!1,T=n?0:1;break;case 123:m=!0,T=0;break;case 125:T=m?0:1;break;case 39:T=s===34||s===96?0:1;break;case 34:T=s===39||s===96?0:1;break;case 96:T=s===39||s===34?0:1;break;case 42:T=s===42?1:0;break;case 124:T=s===124?1:0;break;case 32:T=o?0:1;break;default:T=p.get(w)}T===1&&(P.push(D._createLink(p,c,_,E,a)),h=!0)}else if(t===12){let T;w===91?(n=!0,T=0):T=p.get(w),T===1?h=!0:t=13}else t=d.nextState(t,w),t===0&&(h=!0);h&&(t=1,r=!1,n=!1,m=!1,E=a+1,s=w),a++}t===13&&P.push(D._createLink(p,c,_,E,u))}return P}}e.LinkComputer=D;function v(b){return!b||typeof b.getLineCount!="function"||typeof b.getLineContent!="function"?[]:D.computeLinks(b)}e.computeLinks=v}),define(ve[109],we([1,0,25]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.OverviewRulerLane=void 0;var i;(function(_){_[_.Left=1]="Left",_[_.Center=2]="Center",_[_.Right=4]="Right",_[_.Full=7]="Full"})(i=e.OverviewRulerLane||(e.OverviewRulerLane={}));var I;(function(_){_[_.Inline=1]="Inline",_[_.Gutter=2]="Gutter"})(I=e.MinimapPosition||(e.MinimapPosition={}));var A;(function(_){_[_.Both=0]="Both",_[_.Right=1]="Right",_[_.Left=2]="Left",_[_.None=3]="None"})(A=e.InjectedTextCursorStops||(e.InjectedTextCursorStops={}));var C;(function(_){_[_.TextDefined=0]="TextDefined",_[_.LF=1]="LF",_[_.CRLF=2]="CRLF"})(C=e.EndOfLinePreference||(e.EndOfLinePreference={}));var k;(function(_){_[_.LF=1]="LF",_[_.CRLF=2]="CRLF"})(k=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var S;(function(_){_[_.LF=0]="LF",_[_.CRLF=1]="CRLF"})(S=e.EndOfLineSequence||(e.EndOfLineSequence={}));class R{constructor(l){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,l.tabSize|0),this.indentSize=l.tabSize|0,this.insertSpaces=Boolean(l.insertSpaces),this.defaultEOL=l.defaultEOL|0,this.trimAutoWhitespace=Boolean(l.trimAutoWhitespace),this.bracketPairColorizationOptions=l.bracketPairColorizationOptions}equals(l){return this.tabSize===l.tabSize&&this.indentSize===l.indentSize&&this.insertSpaces===l.insertSpaces&&this.defaultEOL===l.defaultEOL&&this.trimAutoWhitespace===l.trimAutoWhitespace&&(0,f.equals)(this.bracketPairColorizationOptions,l.bracketPairColorizationOptions)}createChangeEvent(l){return{tabSize:this.tabSize!==l.tabSize,indentSize:this.indentSize!==l.indentSize,insertSpaces:this.insertSpaces!==l.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==l.trimAutoWhitespace}}}e.TextModelResolvedOptions=R;class F{constructor(l,c){this._findMatchBrand=void 0,this.range=l,this.matches=c}}e.FindMatch=F;var D;(function(_){_[_.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",_[_.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",_[_.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",_[_.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(D=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var v;(function(_){_[_.Left=0]="Left",_[_.Right=1]="Right",_[_.None=2]="None"})(v=e.PositionAffinity||(e.PositionAffinity={}));var b;(function(_){_[_.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(b=e.ModelConstants||(e.ModelConstants={}));class g{constructor(l,c,u,a,E,s){this.identifier=l,this.range=c,this.text=u,this.forceMoveMarkers=a,this.isAutoWhitespaceEdit=E,this._isTracked=s}}e.ValidAnnotatedEditOperation=g;class d{constructor(l,c,u){this.regex=l,this.wordSeparators=c,this.simpleSearch=u}}e.SearchData=d;class p{constructor(l,c,u){this.reverseEdits=l,this.changes=c,this.trimAutoWhitespaceLineNumbers=u}}e.ApplyEditsResult=p;function P(_){return!_.isTooLargeForSyncing()&&!_.isForSimpleWidget}e.shouldSynchronizeModel=P}),define(ve[110],we([1,0,18,96]),function(te,e,f,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class I{constructor(S){this.values=S,this.prefixSum=new Uint32Array(S.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(S,R){S=(0,i.toUint32)(S);const F=this.values,D=this.prefixSum,v=R.length;return v===0?!1:(this.values=new Uint32Array(F.length+v),this.values.set(F.subarray(0,S),0),this.values.set(F.subarray(S),S+v),this.values.set(R,S),S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(D.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(S,R){return S=(0,i.toUint32)(S),R=(0,i.toUint32)(R),this.values[S]===R?!1:(this.values[S]=R,S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),!0)}removeValues(S,R){S=(0,i.toUint32)(S),R=(0,i.toUint32)(R);const F=this.values,D=this.prefixSum;if(S>=F.length)return!1;const v=F.length-S;return R>=v&&(R=v),R===0?!1:(this.values=new Uint32Array(F.length-R),this.values.set(F.subarray(0,S),0),this.values.set(F.subarray(S+R),S),this.prefixSum=new Uint32Array(this.values.length),S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(D.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(S){return S<0?0:(S=(0,i.toUint32)(S),this._getPrefixSum(S))}_getPrefixSum(S){if(S<=this.prefixSumValidIndex[0])return this.prefixSum[S];let R=this.prefixSumValidIndex[0]+1;R===0&&(this.prefixSum[0]=this.values[0],R++),S>=this.values.length&&(S=this.values.length-1);for(let F=R;F<=S;F++)this.prefixSum[F]=this.prefixSum[F-1]+this.values[F];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],S),this.prefixSum[S]}getIndexOf(S){S=Math.floor(S),this.getTotalSum();let R=0,F=this.values.length-1,D=0,v=0,b=0;for(;R<=F;)if(D=R+(F-R)/2|0,v=this.prefixSum[D],b=v-this.values[D],S<b)F=D-1;else if(S>=v)R=D+1;else break;return new C(D,S-b)}}e.PrefixSumComputer=I;class A{constructor(S){this._values=S,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(S){return this._ensureValid(),S===0?0:this._prefixSum[S-1]}getIndexOf(S){this._ensureValid();const R=this._indexBySum[S],F=R>0?this._prefixSum[R-1]:0;return new C(R,S-F)}removeValues(S,R){this._values.splice(S,R),this._invalidate(S)}insertValues(S,R){this._values=(0,f.arrayInsert)(this._values,S,R),this._invalidate(S)}_invalidate(S){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,S-1)}_ensureValid(){if(!this._isValid){for(let S=this._validEndIndex+1,R=this._values.length;S<R;S++){const F=this._values[S],D=S>0?this._prefixSum[S-1]:0;this._prefixSum[S]=D+F;for(let v=0;v<F;v++)this._indexBySum[D+v]=S}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(S,R){this._values[S]!==R&&(this._values[S]=R,this._invalidate(S))}}e.ConstantTimePrefixSumComputer=A;class C{constructor(S,R){this.index=S,this.remainder=R,this._prefixSumIndexOfResultBrand=void 0,this.index=S,this.remainder=R}}e.PrefixSumIndexOfResult=C}),define(ve[151],we([1,0,8,48,110]),function(te,e,f,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class A{constructor(k,S,R,F){this._uri=k,this._lines=S,this._eol=R,this._versionId=F,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(k){k.eol&&k.eol!==this._eol&&(this._eol=k.eol,this._lineStarts=null);const S=k.changes;for(const R of S)this._acceptDeleteRange(R.range),this._acceptInsertText(new i.Position(R.range.startLineNumber,R.range.startColumn),R.text);this._versionId=k.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const k=this._eol.length,S=this._lines.length,R=new Uint32Array(S);for(let F=0;F<S;F++)R[F]=this._lines[F].length+k;this._lineStarts=new I.PrefixSumComputer(R)}}_setLineText(k,S){this._lines[k]=S,this._lineStarts&&this._lineStarts.setValue(k,this._lines[k].length+this._eol.length)}_acceptDeleteRange(k){if(k.startLineNumber===k.endLineNumber){if(k.startColumn===k.endColumn)return;this._setLineText(k.startLineNumber-1,this._lines[k.startLineNumber-1].substring(0,k.startColumn-1)+this._lines[k.startLineNumber-1].substring(k.endColumn-1));return}this._setLineText(k.startLineNumber-1,this._lines[k.startLineNumber-1].substring(0,k.startColumn-1)+this._lines[k.endLineNumber-1].substring(k.endColumn-1)),this._lines.splice(k.startLineNumber,k.endLineNumber-k.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(k.startLineNumber,k.endLineNumber-k.startLineNumber)}_acceptInsertText(k,S){if(S.length===0)return;const R=(0,f.splitLines)(S);if(R.length===1){this._setLineText(k.lineNumber-1,this._lines[k.lineNumber-1].substring(0,k.column-1)+R[0]+this._lines[k.lineNumber-1].substring(k.column-1));return}R[R.length-1]+=this._lines[k.lineNumber-1].substring(k.column-1),this._setLineText(k.lineNumber-1,this._lines[k.lineNumber-1].substring(0,k.column-1)+R[0]);const F=new Uint32Array(R.length-1);for(let D=1;D<R.length;D++)this._lines.splice(k.lineNumber+D-1,0,R[D]),F[D-1]=R[D].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(k.lineNumber,F)}}e.MirrorTextModel=A}),define(ve[152],we([1,0,8,148,48,35,109]),function(te,e,f,i,I,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.isMultilineRegexSource=e.SearchParams=void 0;const k=999;class S{constructor(_,l,c,u){this.searchString=_,this.isRegex=l,this.matchCase=c,this.wordSeparators=u}parseSearchRequest(){if(this.searchString==="")return null;let _;this.isRegex?_=R(this.searchString):_=this.searchString.indexOf(`
`)>=0;let l=null;try{l=f.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:_,global:!0,unicode:!0})}catch{return null}if(!l)return null;let c=!this.isRegex&&!_;return c&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(c=this.matchCase),new C.SearchData(l,this.wordSeparators?(0,i.getMapForWordSeparators)(this.wordSeparators):null,c?this.searchString:null)}}e.SearchParams=S;function R(P){if(!P||P.length===0)return!1;for(let _=0,l=P.length;_<l;_++)if(P.charCodeAt(_)===92){if(_++,_>=l)break;const u=P.charCodeAt(_);if(u===110||u===114||u===87)return!0}return!1}e.isMultilineRegexSource=R;function F(P,_,l){if(!l)return new C.FindMatch(P,null);const c=[];for(let u=0,a=_.length;u<a;u++)c[u]=_[u];return new C.FindMatch(P,c)}e.createFindMatch=F;class D{constructor(_){const l=[];let c=0;for(let u=0,a=_.length;u<a;u++)_.charCodeAt(u)===10&&(l[c++]=u);this._lineFeedsOffsets=l}findLineFeedCountBeforeOffset(_){const l=this._lineFeedsOffsets;let c=0,u=l.length-1;if(u===-1||_<=l[0])return 0;for(;c<u;){const a=c+((u-c)/2>>0);l[a]>=_?u=a-1:l[a+1]>=_?(c=a,u=a):c=a+1}return c+1}}class v{static findMatches(_,l,c,u,a){const E=l.parseSearchRequest();return E?E.regex.multiline?this._doFindMatchesMultiline(_,c,new p(E.wordSeparators,E.regex),u,a):this._doFindMatchesLineByLine(_,c,E,u,a):[]}static _getMultilineMatchRange(_,l,c,u,a,E){let s,t=0;u?(t=u.findLineFeedCountBeforeOffset(a),s=l+a+t):s=l+a;let r;if(u){const h=u.findLineFeedCountBeforeOffset(a+E.length)-t;r=s+E.length+h}else r=s+E.length;const n=_.getPositionAt(s),o=_.getPositionAt(r);return new A.Range(n.lineNumber,n.column,o.lineNumber,o.column)}static _doFindMatchesMultiline(_,l,c,u,a){const E=_.getOffsetAt(l.getStartPosition()),s=_.getValueInRange(l,1),t=_.getEOL()===`\r
`?new D(s):null,r=[];let n=0,o;for(c.reset(0);o=c.next(s);)if(r[n++]=F(this._getMultilineMatchRange(_,E,s,t,o.index,o[0]),o,u),n>=a)return r;return r}static _doFindMatchesLineByLine(_,l,c,u,a){const E=[];let s=0;if(l.startLineNumber===l.endLineNumber){const r=_.getLineContent(l.startLineNumber).substring(l.startColumn-1,l.endColumn-1);return s=this._findMatchesInLine(c,r,l.startLineNumber,l.startColumn-1,s,E,u,a),E}const t=_.getLineContent(l.startLineNumber).substring(l.startColumn-1);s=this._findMatchesInLine(c,t,l.startLineNumber,l.startColumn-1,s,E,u,a);for(let r=l.startLineNumber+1;r<l.endLineNumber&&s<a;r++)s=this._findMatchesInLine(c,_.getLineContent(r),r,0,s,E,u,a);if(s<a){const r=_.getLineContent(l.endLineNumber).substring(0,l.endColumn-1);s=this._findMatchesInLine(c,r,l.endLineNumber,0,s,E,u,a)}return E}static _findMatchesInLine(_,l,c,u,a,E,s,t){const r=_.wordSeparators;if(!s&&_.simpleSearch){const m=_.simpleSearch,h=m.length,w=l.length;let T=-h;for(;(T=l.indexOf(m,T+h))!==-1;)if((!r||d(r,l,w,T,h))&&(E[a++]=new C.FindMatch(new A.Range(c,T+1+u,c,T+1+h+u),null),a>=t))return a;return a}const n=new p(_.wordSeparators,_.regex);let o;n.reset(0);do if(o=n.next(l),o&&(E[a++]=F(new A.Range(c,o.index+1+u,c,o.index+1+o[0].length+u),o,s),a>=t))return a;while(o);return a}static findNextMatch(_,l,c,u){const a=l.parseSearchRequest();if(!a)return null;const E=new p(a.wordSeparators,a.regex);return a.regex.multiline?this._doFindNextMatchMultiline(_,c,E,u):this._doFindNextMatchLineByLine(_,c,E,u)}static _doFindNextMatchMultiline(_,l,c,u){const a=new I.Position(l.lineNumber,1),E=_.getOffsetAt(a),s=_.getLineCount(),t=_.getValueInRange(new A.Range(a.lineNumber,a.column,s,_.getLineMaxColumn(s)),1),r=_.getEOL()===`\r
`?new D(t):null;c.reset(l.column-1);let n=c.next(t);return n?F(this._getMultilineMatchRange(_,E,t,r,n.index,n[0]),n,u):l.lineNumber!==1||l.column!==1?this._doFindNextMatchMultiline(_,new I.Position(1,1),c,u):null}static _doFindNextMatchLineByLine(_,l,c,u){const a=_.getLineCount(),E=l.lineNumber,s=_.getLineContent(E),t=this._findFirstMatchInLine(c,s,E,l.column,u);if(t)return t;for(let r=1;r<=a;r++){const n=(E+r-1)%a,o=_.getLineContent(n+1),m=this._findFirstMatchInLine(c,o,n+1,1,u);if(m)return m}return null}static _findFirstMatchInLine(_,l,c,u,a){_.reset(u-1);const E=_.next(l);return E?F(new A.Range(c,E.index+1,c,E.index+1+E[0].length),E,a):null}static findPreviousMatch(_,l,c,u){const a=l.parseSearchRequest();if(!a)return null;const E=new p(a.wordSeparators,a.regex);return a.regex.multiline?this._doFindPreviousMatchMultiline(_,c,E,u):this._doFindPreviousMatchLineByLine(_,c,E,u)}static _doFindPreviousMatchMultiline(_,l,c,u){const a=this._doFindMatchesMultiline(_,new A.Range(1,1,l.lineNumber,l.column),c,u,10*k);if(a.length>0)return a[a.length-1];const E=_.getLineCount();return l.lineNumber!==E||l.column!==_.getLineMaxColumn(E)?this._doFindPreviousMatchMultiline(_,new I.Position(E,_.getLineMaxColumn(E)),c,u):null}static _doFindPreviousMatchLineByLine(_,l,c,u){const a=_.getLineCount(),E=l.lineNumber,s=_.getLineContent(E).substring(0,l.column-1),t=this._findLastMatchInLine(c,s,E,u);if(t)return t;for(let r=1;r<=a;r++){const n=(a+E-r-1)%a,o=_.getLineContent(n+1),m=this._findLastMatchInLine(c,o,n+1,u);if(m)return m}return null}static _findLastMatchInLine(_,l,c,u){let a=null,E;for(_.reset(0);E=_.next(l);)a=F(new A.Range(c,E.index+1,c,E.index+1+E[0].length),E,u);return a}}e.TextModelSearch=v;function b(P,_,l,c,u){if(c===0)return!0;const a=_.charCodeAt(c-1);if(P.get(a)!==0||a===13||a===10)return!0;if(u>0){const E=_.charCodeAt(c);if(P.get(E)!==0)return!0}return!1}function g(P,_,l,c,u){if(c+u===l)return!0;const a=_.charCodeAt(c+u);if(P.get(a)!==0||a===13||a===10)return!0;if(u>0){const E=_.charCodeAt(c+u-1);if(P.get(E)!==0)return!0}return!1}function d(P,_,l,c,u){return b(P,_,l,c,u)&&g(P,_,l,c,u)}e.isValidMatch=d;class p{constructor(_,l){this._wordSeparators=_,this._searchRegex=l,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(_){this._searchRegex.lastIndex=_,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(_){const l=_.length;let c;do{if(this._prevMatchStartIndex+this._prevMatchLength===l||(c=this._searchRegex.exec(_),!c))return null;const u=c.index,a=c[0].length;if(u===this._prevMatchStartIndex&&a===this._prevMatchLength){if(a===0){f.getNextCodePoint(_,l,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=u,this._prevMatchLength=a,!this._wordSeparators||d(this._wordSeparators,_,l,u,a))return c}while(c);return null}}e.Searcher=p}),define(ve[111],we([1,0,22,12]),function(te,e,f,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var I;(function(D){D[D.Full=1]="Full",D[D.Delta=2]="Delta"})(I||(I={}));function A(D){for(let v=0,b=D.length;v<b;v+=4){const g=D[v+0],d=D[v+1],p=D[v+2],P=D[v+3];D[v+0]=P,D[v+1]=p,D[v+2]=d,D[v+3]=g}}function C(D){const v=new Uint8Array(D.buffer,D.byteOffset,D.length*4);return i.isLittleEndian()||A(v),f.VSBuffer.wrap(v)}function k(D){const v=D.buffer;if(i.isLittleEndian()||A(v),v.byteOffset%4==0)return new Uint32Array(v.buffer,v.byteOffset,v.length/4);{const b=new Uint8Array(v.byteLength);return b.set(v),new Uint32Array(b.buffer,b.byteOffset,b.length/4)}}function S(D){const v=new Uint32Array(R(D));let b=0;if(v[b++]=D.id,D.type==="full")v[b++]=1,v[b++]=D.data.length,v.set(D.data,b),b+=D.data.length;else{v[b++]=2,v[b++]=D.deltas.length;for(const g of D.deltas)v[b++]=g.start,v[b++]=g.deleteCount,g.data?(v[b++]=g.data.length,v.set(g.data,b),b+=g.data.length):v[b++]=0}return C(v)}e.encodeSemanticTokensDto=S;function R(D){let v=0;if(v+=1+1,D.type==="full")v+=1+D.data.length;else{v+=1,v+=(1+1+1)*D.deltas.length;for(const b of D.deltas)b.data&&(v+=b.data.length)}return v}function F(D){const v=k(D);let b=0;const g=v[b++];if(v[b++]===1){const _=v[b++],l=v.subarray(b,b+_);return b+=_,{id:g,type:"full",data:l}}const p=v[b++],P=[];for(let _=0;_<p;_++){const l=v[b++],c=v[b++],u=v[b++];let a;u>0&&(a=v.subarray(b,b+u),b+=u),P[_]={start:l,deleteCount:c,data:a}}return{id:g,type:"delta",deltas:P}}e.decodeSemanticTokensDto=F}),define(ve[153],we([1,0,3,6]),function(te,e,f,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class I{constructor(){this._map=new Map,this._factories=new Map,this._onDidChange=new f.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(k){this._onDidChange.fire({changedLanguages:k,changedColorMap:!1})}register(k,S){return this._map.set(k,S),this.fire([k]),(0,i.toDisposable)(()=>{this._map.get(k)===S&&(this._map.delete(k),this.fire([k]))})}registerFactory(k,S){this._factories.get(k)?.dispose();const R=new A(this,k,S);return this._factories.set(k,R),(0,i.toDisposable)(()=>{const F=this._factories.get(k);!F||F!==R||(this._factories.delete(k),F.dispose())})}async getOrCreate(k){const S=this.get(k);if(S)return S;const R=this._factories.get(k);return!R||R.isResolved?null:(await R.resolve(),this.get(k))}get(k){return this._map.get(k)||null}isResolved(k){if(this.get(k))return!0;const R=this._factories.get(k);return!!(!R||R.isResolved)}setColorMap(k){this._colorMap=k,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistry=I;class A extends i.Disposable{constructor(k,S,R){super();this._registry=k,this._languageId=S,this._factory=R,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}get isResolved(){return this._isResolved}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const k=await Promise.resolve(this._factory.createTokenizationSupport());this._isResolved=!0,k&&!this._isDisposed&&this._register(this._registry.register(this._languageId,k))}}}),define(ve[78],we([1,0,2,35,153,72]),function(te,e,f,i,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var C;(function(O){O[O.Null=0]="Null",O[O.PlainText=1]="PlainText"})(C=e.LanguageId||(e.LanguageId={}));var k;(function(O){O[O.NotSet=-1]="NotSet",O[O.None=0]="None",O[O.Italic=1]="Italic",O[O.Bold=2]="Bold",O[O.Underline=4]="Underline",O[O.Strikethrough=8]="Strikethrough"})(k=e.FontStyle||(e.FontStyle={}));var S;(function(O){O[O.None=0]="None",O[O.DefaultForeground=1]="DefaultForeground",O[O.DefaultBackground=2]="DefaultBackground"})(S=e.ColorId||(e.ColorId={}));var R;(function(O){O[O.Other=0]="Other",O[O.Comment=1]="Comment",O[O.String=2]="String",O[O.RegEx=3]="RegEx"})(R=e.StandardTokenType||(e.StandardTokenType={}));var F;(function(O){O[O.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",O[O.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",O[O.FONT_STYLE_MASK=15360]="FONT_STYLE_MASK",O[O.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",O[O.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",O[O.ITALIC_MASK=1024]="ITALIC_MASK",O[O.BOLD_MASK=2048]="BOLD_MASK",O[O.UNDERLINE_MASK=4096]="UNDERLINE_MASK",O[O.STRIKETHROUGH_MASK=8192]="STRIKETHROUGH_MASK",O[O.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",O[O.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",O[O.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",O[O.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",O[O.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",O[O.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",O[O.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",O[O.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",O[O.FONT_STYLE_OFFSET=10]="FONT_STYLE_OFFSET",O[O.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",O[O.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(F=e.MetadataConsts||(e.MetadataConsts={}));class D{static getLanguageId(y){return(y&255)>>>0}static getTokenType(y){return(y&768)>>>8}static getFontStyle(y){return(y&15360)>>>10}static getForeground(y){return(y&8372224)>>>14}static getBackground(y){return(y&4286578688)>>>23}static getClassNameFromMetadata(y){const H=this.getForeground(y);let M="mtk"+H;const j=this.getFontStyle(y);return j&1&&(M+=" mtki"),j&2&&(M+=" mtkb"),j&4&&(M+=" mtku"),j&8&&(M+=" mtks"),M}static getInlineStyleFromMetadata(y,H){const M=this.getForeground(y),j=this.getFontStyle(y);let X=`color: ${H[M]};`;j&1&&(X+="font-style: italic;"),j&2&&(X+="font-weight: bold;");let $="";return j&4&&($+=" underline"),j&8&&($+=" line-through"),$&&(X+=`text-decoration:${$};`),X}static getPresentationFromMetadata(y){const H=this.getForeground(y),M=this.getFontStyle(y);return{foreground:H,italic:Boolean(M&1),bold:Boolean(M&2),underline:Boolean(M&4),strikethrough:Boolean(M&8)}}}e.TokenMetadata=D;class v{constructor(y,H,M){this._tokenBrand=void 0,this.offset=y,this.type=H,this.language=M}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=v;class b{constructor(y,H){this._tokenizationResultBrand=void 0,this.tokens=y,this.endState=H}}e.TokenizationResult=b;class g{constructor(y,H){this._encodedTokenizationResultBrand=void 0,this.tokens=y,this.endState=H}}e.EncodedTokenizationResult=g;var d;(function(O){O[O.Method=0]="Method",O[O.Function=1]="Function",O[O.Constructor=2]="Constructor",O[O.Field=3]="Field",O[O.Variable=4]="Variable",O[O.Class=5]="Class",O[O.Struct=6]="Struct",O[O.Interface=7]="Interface",O[O.Module=8]="Module",O[O.Property=9]="Property",O[O.Event=10]="Event",O[O.Operator=11]="Operator",O[O.Unit=12]="Unit",O[O.Value=13]="Value",O[O.Constant=14]="Constant",O[O.Enum=15]="Enum",O[O.EnumMember=16]="EnumMember",O[O.Keyword=17]="Keyword",O[O.Text=18]="Text",O[O.Color=19]="Color",O[O.File=20]="File",O[O.Reference=21]="Reference",O[O.Customcolor=22]="Customcolor",O[O.Folder=23]="Folder",O[O.TypeParameter=24]="TypeParameter",O[O.User=25]="User",O[O.Issue=26]="Issue",O[O.Snippet=27]="Snippet"})(d=e.CompletionItemKind||(e.CompletionItemKind={}));var p;(function(O){const y=new Map;y.set(0,A.Codicon.symbolMethod),y.set(1,A.Codicon.symbolFunction),y.set(2,A.Codicon.symbolConstructor),y.set(3,A.Codicon.symbolField),y.set(4,A.Codicon.symbolVariable),y.set(5,A.Codicon.symbolClass),y.set(6,A.Codicon.symbolStruct),y.set(7,A.Codicon.symbolInterface),y.set(8,A.Codicon.symbolModule),y.set(9,A.Codicon.symbolProperty),y.set(10,A.Codicon.symbolEvent),y.set(11,A.Codicon.symbolOperator),y.set(12,A.Codicon.symbolUnit),y.set(13,A.Codicon.symbolValue),y.set(15,A.Codicon.symbolEnum),y.set(14,A.Codicon.symbolConstant),y.set(15,A.Codicon.symbolEnum),y.set(16,A.Codicon.symbolEnumMember),y.set(17,A.Codicon.symbolKeyword),y.set(27,A.Codicon.symbolSnippet),y.set(18,A.Codicon.symbolText),y.set(19,A.Codicon.symbolColor),y.set(20,A.Codicon.symbolFile),y.set(21,A.Codicon.symbolReference),y.set(22,A.Codicon.symbolCustomColor),y.set(23,A.Codicon.symbolFolder),y.set(24,A.Codicon.symbolTypeParameter),y.set(25,A.Codicon.account),y.set(26,A.Codicon.issues);function H(X){let $=y.get(X);return $||(console.info("No codicon found for CompletionItemKind "+X),$=A.Codicon.symbolProperty),$}O.toIcon=H;const M=new Map;M.set("method",0),M.set("function",1),M.set("constructor",2),M.set("field",3),M.set("variable",4),M.set("class",5),M.set("struct",6),M.set("interface",7),M.set("module",8),M.set("property",9),M.set("event",10),M.set("operator",11),M.set("unit",12),M.set("value",13),M.set("constant",14),M.set("enum",15),M.set("enum-member",16),M.set("enumMember",16),M.set("keyword",17),M.set("snippet",27),M.set("text",18),M.set("color",19),M.set("file",20),M.set("reference",21),M.set("customcolor",22),M.set("folder",23),M.set("type-parameter",24),M.set("typeParameter",24),M.set("account",25),M.set("issue",26);function j(X,$){let U=M.get(X);return typeof U=="undefined"&&!$&&(U=9),U}O.fromString=j})(p=e.CompletionItemKinds||(e.CompletionItemKinds={}));var P;(function(O){O[O.Deprecated=1]="Deprecated"})(P=e.CompletionItemTag||(e.CompletionItemTag={}));var _;(function(O){O[O.KeepWhitespace=1]="KeepWhitespace",O[O.InsertAsSnippet=4]="InsertAsSnippet"})(_=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var l;(function(O){O[O.Invoke=0]="Invoke",O[O.TriggerCharacter=1]="TriggerCharacter",O[O.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(l=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var c;(function(O){O[O.Automatic=0]="Automatic",O[O.Explicit=1]="Explicit"})(c=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var u;(function(O){O[O.Invoke=1]="Invoke",O[O.Auto=2]="Auto"})(u=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var a;(function(O){O[O.Invoke=1]="Invoke",O[O.TriggerCharacter=2]="TriggerCharacter",O[O.ContentChange=3]="ContentChange"})(a=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var E;(function(O){O[O.Text=0]="Text",O[O.Read=1]="Read",O[O.Write=2]="Write"})(E=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function s(O){return O&&f.URI.isUri(O.uri)&&i.Range.isIRange(O.range)&&(i.Range.isIRange(O.originSelectionRange)||i.Range.isIRange(O.targetSelectionRange))}e.isLocationLink=s;var t;(function(O){O[O.File=0]="File",O[O.Module=1]="Module",O[O.Namespace=2]="Namespace",O[O.Package=3]="Package",O[O.Class=4]="Class",O[O.Method=5]="Method",O[O.Property=6]="Property",O[O.Field=7]="Field",O[O.Constructor=8]="Constructor",O[O.Enum=9]="Enum",O[O.Interface=10]="Interface",O[O.Function=11]="Function",O[O.Variable=12]="Variable",O[O.Constant=13]="Constant",O[O.String=14]="String",O[O.Number=15]="Number",O[O.Boolean=16]="Boolean",O[O.Array=17]="Array",O[O.Object=18]="Object",O[O.Key=19]="Key",O[O.Null=20]="Null",O[O.EnumMember=21]="EnumMember",O[O.Struct=22]="Struct",O[O.Event=23]="Event",O[O.Operator=24]="Operator",O[O.TypeParameter=25]="TypeParameter"})(t=e.SymbolKind||(e.SymbolKind={}));var r;(function(O){O[O.Deprecated=1]="Deprecated"})(r=e.SymbolTag||(e.SymbolTag={}));var n;(function(O){const y=new Map;y.set(0,A.Codicon.symbolFile),y.set(1,A.Codicon.symbolModule),y.set(2,A.Codicon.symbolNamespace),y.set(3,A.Codicon.symbolPackage),y.set(4,A.Codicon.symbolClass),y.set(5,A.Codicon.symbolMethod),y.set(6,A.Codicon.symbolProperty),y.set(7,A.Codicon.symbolField),y.set(8,A.Codicon.symbolConstructor),y.set(9,A.Codicon.symbolEnum),y.set(10,A.Codicon.symbolInterface),y.set(11,A.Codicon.symbolFunction),y.set(12,A.Codicon.symbolVariable),y.set(13,A.Codicon.symbolConstant),y.set(14,A.Codicon.symbolString),y.set(15,A.Codicon.symbolNumber),y.set(16,A.Codicon.symbolBoolean),y.set(17,A.Codicon.symbolArray),y.set(18,A.Codicon.symbolObject),y.set(19,A.Codicon.symbolKey),y.set(20,A.Codicon.symbolNull),y.set(21,A.Codicon.symbolEnumMember),y.set(22,A.Codicon.symbolStruct),y.set(23,A.Codicon.symbolEvent),y.set(24,A.Codicon.symbolOperator),y.set(25,A.Codicon.symbolTypeParameter);function H(M){let j=y.get(M);return j||(console.info("No codicon found for SymbolKind "+M),j=A.Codicon.symbolProperty),j}O.toIcon=H})(n=e.SymbolKinds||(e.SymbolKinds={}));class o{constructor(y){this.value=y}}e.FoldingRangeKind=o,o.Comment=new o("comment"),o.Imports=new o("imports"),o.Region=new o("region");var m;(function(O){function y(H){return!H||typeof H!="object"?!1:typeof H.id=="string"&&typeof H.title=="string"}O.is=y})(m=e.Command||(e.Command={}));var h;(function(O){O[O.Collapsed=0]="Collapsed",O[O.Expanded=1]="Expanded"})(h=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var w;(function(O){O[O.Editing=0]="Editing",O[O.Preview=1]="Preview"})(w=e.CommentMode||(e.CommentMode={}));var T;(function(O){O[O.Type=1]="Type",O[O.Parameter=2]="Parameter"})(T=e.InlayHintKind||(e.InlayHintKind={})),e.TokenizationRegistry=new I.TokenizationRegistry;var L;(function(O){O[O.None=0]="None",O[O.Option=1]="Option",O[O.Default=2]="Default",O[O.Preferred=3]="Preferred"})(L=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(ve[154],we([19,20]),function(te,e){return te.create("vs/base/common/date",e)}),define(ve[155],we([1,0,154]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const i=60,I=i*60,A=I*24,C=A*7,k=A*30,S=A*365;function R(D,v,b){typeof D!="number"&&(D=D.getTime());const g=Math.round((new Date().getTime()-D)/1e3);if(g<-30)return(0,f.localize)(0,null,R(new Date().getTime()+g*1e3,!1));if(g<30)return(0,f.localize)(1,null);let d;return g<i?(d=g,v?d===1?b?(0,f.localize)(2,null,d):(0,f.localize)(3,null,d):b?(0,f.localize)(4,null,d):(0,f.localize)(5,null,d):d===1?b?(0,f.localize)(6,null,d):(0,f.localize)(7,null,d):b?(0,f.localize)(8,null,d):(0,f.localize)(9,null,d)):g<I?(d=Math.floor(g/i),v?d===1?b?(0,f.localize)(10,null,d):(0,f.localize)(11,null,d):b?(0,f.localize)(12,null,d):(0,f.localize)(13,null,d):d===1?b?(0,f.localize)(14,null,d):(0,f.localize)(15,null,d):b?(0,f.localize)(16,null,d):(0,f.localize)(17,null,d)):g<A?(d=Math.floor(g/I),v?d===1?b?(0,f.localize)(18,null,d):(0,f.localize)(19,null,d):b?(0,f.localize)(20,null,d):(0,f.localize)(21,null,d):d===1?b?(0,f.localize)(22,null,d):(0,f.localize)(23,null,d):b?(0,f.localize)(24,null,d):(0,f.localize)(25,null,d)):g<C?(d=Math.floor(g/A),v?d===1?(0,f.localize)(26,null,d):(0,f.localize)(27,null,d):d===1?(0,f.localize)(28,null,d):(0,f.localize)(29,null,d)):g<k?(d=Math.floor(g/C),v?d===1?b?(0,f.localize)(30,null,d):(0,f.localize)(31,null,d):b?(0,f.localize)(32,null,d):(0,f.localize)(33,null,d):d===1?b?(0,f.localize)(34,null,d):(0,f.localize)(35,null,d):b?(0,f.localize)(36,null,d):(0,f.localize)(37,null,d)):g<S?(d=Math.floor(g/k),v?d===1?b?(0,f.localize)(38,null,d):(0,f.localize)(39,null,d):b?(0,f.localize)(40,null,d):(0,f.localize)(41,null,d):d===1?b?(0,f.localize)(42,null,d):(0,f.localize)(43,null,d):b?(0,f.localize)(44,null,d):(0,f.localize)(45,null,d)):(d=Math.floor(g/S),v?d===1?b?(0,f.localize)(46,null,d):(0,f.localize)(47,null,d):b?(0,f.localize)(48,null,d):(0,f.localize)(49,null,d):d===1?b?(0,f.localize)(50,null,d):(0,f.localize)(51,null,d):b?(0,f.localize)(52,null,d):(0,f.localize)(53,null,d))}e.fromNow=R;function F(D){return D.getFullYear()+"-"+String(D.getMonth()+1).padStart(2,"0")+"-"+String(D.getDate()).padStart(2,"0")+"T"+String(D.getHours()).padStart(2,"0")+":"+String(D.getMinutes()).padStart(2,"0")+":"+String(D.getSeconds()).padStart(2,"0")+"."+(D.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=F}),define(ve[156],we([19,20]),function(te,e){return te.create("vs/base/common/errorMessage",e)}),define(ve[49],we([1,0,18,13,156]),function(te,e,f,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function A(D,v){return v&&(D.stack||D.stacktrace)?I.localize(0,null,k(D),C(D.stack)||C(D.stacktrace)):k(D)}function C(D){return Array.isArray(D)?D.join(`
`):D}function k(D){return typeof D.code=="string"&&typeof D.errno=="number"&&typeof D.syscall=="string"?I.localize(1,null,D.message):D.message||I.localize(2,null)}function S(D=null,v=!1){if(!D)return I.localize(3,null);if(Array.isArray(D)){const b=f.coalesce(D),g=S(b[0],v);return b.length>1?I.localize(4,null,g,b.length):g}if(i.isString(D))return D;if(D.detail){const b=D.detail;if(b.error)return A(b.error,v);if(b.exception)return A(b.exception,v)}return D.stack?A(D,v):D.message?D.message:I.localize(5,null)}e.toErrorMessage=S;function R(D){const v=D;return v instanceof Error&&Array.isArray(v.actions)}e.isErrorWithActions=R;function F(D,v=Object.create(null)){const b=new Error(D);return v.actions&&(b.actions=v.actions),b}e.createErrorWithActions=F}),define(ve[157],we([19,20]),function(te,e){return te.create("vs/base/node/processes",e)}),define(ve[112],we([1,0,38,29,10,25,9,12,41,93,13,145,28,157]),function(te,e,f,i,I,A,C,k,S,R,F,D,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function g(a){switch(a){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function d(a,E){if(k.isWindows)try{const s={stdio:["pipe","pipe","ignore"]};E&&(s.cwd=E);const t=f.execFile("taskkill",["/T","/F","/PID",a.pid.toString()],s);return new Promise(r=>{t.once("error",n=>{r({success:!1,error:n})}),t.once("exit",(n,o)=>{r(n===0?{success:!0}:{success:!1,code:n!==null?n:1})})})}catch(s){return Promise.resolve({success:!1,error:s,code:s.status?g(s.status):1})}else if(k.isLinux||k.isMacintosh)try{const s=I.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",te).fsPath;return new Promise(t=>{f.execFile(s,[a.pid.toString()],{encoding:"utf8",shell:!0},(r,n,o)=>{t(r?{success:!1,error:r}:{success:!0})})})}catch(s){return Promise.resolve({success:!1,error:s})}else a.kill("SIGKILL");return Promise.resolve({success:!0})}function p(a){!a||(delete a.DEBUG,k.isMacintosh&&delete a.DYLD_LIBRARY_PATH,k.isLinux&&delete a.LD_PRELOAD)}e.removeDangerousEnvVariables=p;function P(a=S.env){return a.comspec||"cmd.exe"}e.getWindowsShell=P;class _{constructor(E,s,t,r){if(s!==void 0&&t!==void 0&&r!==void 0)this.cmd=E,this.args=s,this.shell=t,this.options=r;else{const n=E;this.cmd=n.command,this.shell=n.isShellCommand,this.args=n.args.slice(0),this.options=n.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const n=Object.create(null);Object.keys(S.env).forEach(o=>{n[o]=S.env[o]}),Object.keys(this.options.env).forEach(o=>{n[o]=this.options.env[o]}),this.options.env=n}}getSanitizedCommand(){let E=this.cmd.toLowerCase();const s=E.lastIndexOf(C.sep);return s!==-1&&(E=E.substring(s+1)),_.WellKnowCommands[E]?E:"other"}start(E){return k.isWindows&&(this.options&&this.options.cwd&&i.isUNC(this.options.cwd)||!this.options&&i.isUNC(S.cwd()))?Promise.reject(new Error(b.localize(0,null))):this.useExec().then(s=>{let t,r;const n=new Promise((o,m)=>{t=o,r=m});if(s){let o=this.cmd;this.args&&(o=o+" "+this.args.join(" ")),this.childProcess=f.exec(o,this.options,(m,h,w)=>{this.childProcess=null;const T=m;T&&T.killed?r({killed:this.terminateRequested,stdout:h.toString(),stderr:w.toString()}):this.handleExec(t,E,m,h,w)})}else{let o=null;const m=h=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(h,t,E,r);const w={terminated:this.terminateRequested};F.isNumber(h)&&(w.cmdCode=h),t(w)};if(this.shell&&k.isWindows){const h=A.deepClone(this.options);h.windowsVerbatimArguments=!0,h.detached=!1;let w=!1,T=!1;const L=[];let O=this.ensureQuotes(this.cmd);L.push(O.value),w=O.quoted,this.args&&this.args.forEach(H=>{O=this.ensureQuotes(H),L.push(O.value),T=T&&O.quoted});const y=["/s","/c"];w?T?y.push('"'+L.join(" ")+'"'):L.length>1?y.push('"'+L[0]+'" '+L.slice(1).join(" ")):y.push('"'+L[0]+'"'):y.push(L.join(" ")),o=f.spawn(P(),y,h)}else this.cmd&&(o=f.spawn(this.cmd,this.args,this.options));o&&(this.childProcess=o,this.childProcessPromise=Promise.resolve(o),this.pidResolve&&(this.pidResolve(F.isNumber(o.pid)?o.pid:-1),this.pidResolve=void 0),o.on("error",h=>{this.childProcess=null,r({terminated:this.terminateRequested,error:h})}),o.pid&&(this.childProcess.on("close",m),this.handleSpawn(o,t,E,r,!0)))}return n})}handleClose(E,s,t,r){}ensureQuotes(E){return _.regexp.test(E)?{value:'"'+E+'"',quoted:!0}:{value:E,quoted:E.length>0&&E[0]==='"'&&E[E.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(E=>E.pid,E=>-1):new Promise(E=>{this.pidResolve=E})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(E=>(this.terminateRequested=!0,d(E,this.options.cwd).then(s=>(s.success&&(this.childProcess=null),s))),E=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(E=>{if(!this.shell||!k.isWindows)return E(!1);const s=f.spawn(P(),["/s","/c"]);s.on("error",t=>E(!0)),s.on("exit",t=>E(!1))})}}e.AbstractProcess=_,_.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},_.regexp=/^[^"].* .*[^"]/;class l extends _{constructor(E,s,t,r){super(E,s,t,r);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(E,s,t,r,n){[r,n].forEach((o,m)=>{const h=new D.LineDecoder;h.write(o).forEach(L=>{s({line:L,source:m===0?0:1})});const T=h.end();T&&s({line:T,source:m===0?0:1})}),E({terminated:this.terminateRequested,error:t})}handleSpawn(E,s,t,r,n){const o=new D.LineDecoder,m=new D.LineDecoder;E.stdout.on("data",h=>{o.write(h).forEach(T=>t({line:T,source:0}))}),E.stderr.on("data",h=>{m.write(h).forEach(T=>t({line:T,source:1}))}),this.stdoutLineDecoder=o,this.stderrLineDecoder=m}handleClose(E,s,t,r){const n=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;n&&t({line:n,source:0});const o=this.stderrLineDecoder?this.stderrLineDecoder.end():null;o&&t({line:o,source:1})}}e.LineProcess=l;function c(a){let E=[],s=!1;const t=function(r){if(s){E.push(r);return}(!a.send(r,o=>{if(o&&console.error(o),s=!1,E.length>0){const m=E.slice(0);E=[],m.forEach(h=>t(h))}})||k.isWindows)&&(s=!0)};return{send:t}}e.createQueuedSender=c;var u;(function(a){async function E(s,t,r){if(C.isAbsolute(s))return s;if(t===void 0&&(t=S.cwd()),C.dirname(s)!=="."||(r===void 0&&F.isString(S.env.PATH)&&(r=S.env.PATH.split(C.delimiter)),r===void 0||r.length===0))return C.join(t,s);async function o(m){if(await v.Promises.exists(m)){let h;try{h=await v.Promises.stat(m)}catch(w){w.message.startsWith("EACCES")&&(h=await v.Promises.lstat(m))}return h?!h.isDirectory():!1}return!1}for(let m of r){let h;if(C.isAbsolute(m)?h=C.join(m,s):h=C.join(t,m,s),await o(h))return h;let w=h+".com";if(await o(w)||(w=h+".exe",await o(w)))return w}return C.join(t,s)}a.findExecutable=E})(u=e.win32||(e.win32={}))}),define(ve[158],we([19,20]),function(te,e){return te.create("vs/editor/common/config/editorOptions",e)}),define(ve[113],we([1,0,158,12,107,18,25,147]),function(te,e,f,i,I,A,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var S;(function(ne){ne[ne.None=0]="None",ne[ne.Keep=1]="Keep",ne[ne.Brackets=2]="Brackets",ne[ne.Advanced=3]="Advanced",ne[ne.Full=4]="Full"})(S=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class R{constructor(ae){this._values=ae}hasChanged(ae){return this._values[ae]}}e.ConfigurationChangedEvent=R;class F{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=F;class D{constructor(ae,J,pe,Se){this.id=ae,this.name=J,this.defaultValue=pe,this.schema=Se}applyUpdate(ae,J){return b(ae,J)}compute(ae,J,pe){return pe}}class v{constructor(ae,J){this.newValue=ae,this.didChange=J}}e.ApplyUpdateResult=v;function b(ne,ae){if(typeof ne!="object"||typeof ae!="object"||!ne||!ae)return new v(ae,ne!==ae);if(Array.isArray(ne)||Array.isArray(ae)){const pe=Array.isArray(ne)&&Array.isArray(ae)&&A.equals(ne,ae);return new v(ae,pe)}let J=!1;for(const pe in ae)if(ae.hasOwnProperty(pe)){const Se=b(ne[pe],ae[pe]);Se.didChange&&(ne[pe]=Se.newValue,J=!0)}return new v(ne,J)}class g{constructor(ae){this.schema=void 0,this.id=ae,this.name="_never_",this.defaultValue=void 0}applyUpdate(ae,J){return b(ae,J)}validate(ae){return this.defaultValue}}class d{constructor(ae,J,pe,Se){this.id=ae,this.name=J,this.defaultValue=pe,this.schema=Se}applyUpdate(ae,J){return b(ae,J)}validate(ae){return typeof ae=="undefined"?this.defaultValue:ae}compute(ae,J,pe){return pe}}function p(ne,ae){return typeof ne=="undefined"?ae:ne==="false"?!1:Boolean(ne)}e.boolean=p;class P extends d{constructor(ae,J,pe,Se=void 0){typeof Se!="undefined"&&(Se.type="boolean",Se.default=pe);super(ae,J,pe,Se)}validate(ae){return p(ae,this.defaultValue)}}function _(ne,ae,J,pe){if(typeof ne=="undefined")return ae;let Se=parseInt(ne,10);return isNaN(Se)?ae:(Se=Math.max(J,Se),Se=Math.min(pe,Se),Se|0)}e.clampedInt=_;class l extends d{constructor(ae,J,pe,Se,Me,$e=void 0){typeof $e!="undefined"&&($e.type="integer",$e.default=pe,$e.minimum=Se,$e.maximum=Me);super(ae,J,pe,$e);this.minimum=Se,this.maximum=Me}static clampedInt(ae,J,pe,Se){return _(ae,J,pe,Se)}validate(ae){return l.clampedInt(ae,this.defaultValue,this.minimum,this.maximum)}}class c extends d{constructor(ae,J,pe,Se,Me){typeof Me!="undefined"&&(Me.type="number",Me.default=pe);super(ae,J,pe,Me);this.validationFn=Se}static clamp(ae,J,pe){return ae<J?J:ae>pe?pe:ae}static float(ae,J){if(typeof ae=="number")return ae;if(typeof ae=="undefined")return J;const pe=parseFloat(ae);return isNaN(pe)?J:pe}validate(ae){return this.validationFn(c.float(ae,this.defaultValue))}}class u extends d{static string(ae,J){return typeof ae!="string"?J:ae}constructor(ae,J,pe,Se=void 0){typeof Se!="undefined"&&(Se.type="string",Se.default=pe);super(ae,J,pe,Se)}validate(ae){return u.string(ae,this.defaultValue)}}function a(ne,ae,J){return typeof ne!="string"||J.indexOf(ne)===-1?ae:ne}e.stringSet=a;class E extends d{constructor(ae,J,pe,Se,Me=void 0){typeof Me!="undefined"&&(Me.type="string",Me.enum=Se,Me.default=pe);super(ae,J,pe,Me);this._allowedValues=Se}validate(ae){return a(ae,this.defaultValue,this._allowedValues)}}class s extends D{constructor(ae,J,pe,Se,Me,$e,Ye=void 0){typeof Ye!="undefined"&&(Ye.type="string",Ye.enum=Me,Ye.default=Se);super(ae,J,pe,Ye);this._allowedValues=Me,this._convert=$e}validate(ae){return typeof ae!="string"?this.defaultValue:this._allowedValues.indexOf(ae)===-1?this.defaultValue:this._convert(ae)}}function t(ne){switch(ne){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class r extends D{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[f.localize(0,null),f.localize(1,null),f.localize(2,null)],default:"auto",description:f.localize(3,null)})}validate(ae){switch(ae){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ae,J,pe){return pe===0?ae.accessibilitySupport:pe}}class n extends D{constructor(){const ae={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",ae,{"editor.comments.insertSpace":{type:"boolean",default:ae.insertSpace,description:f.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ae.ignoreEmptyLines,description:f.localize(5,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const J=ae;return{insertSpace:p(J.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:p(J.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var o;(function(ne){ne[ne.Hidden=0]="Hidden",ne[ne.Blink=1]="Blink",ne[ne.Smooth=2]="Smooth",ne[ne.Phase=3]="Phase",ne[ne.Expand=4]="Expand",ne[ne.Solid=5]="Solid"})(o=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function m(ne){switch(ne){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var h;(function(ne){ne[ne.Line=1]="Line",ne[ne.Block=2]="Block",ne[ne.Underline=3]="Underline",ne[ne.LineThin=4]="LineThin",ne[ne.BlockOutline=5]="BlockOutline",ne[ne.UnderlineThin=6]="UnderlineThin"})(h=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function w(ne){switch(ne){case h.Line:return"line";case h.Block:return"block";case h.Underline:return"underline";case h.LineThin:return"line-thin";case h.BlockOutline:return"block-outline";case h.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=w;function T(ne){switch(ne){case"line":return h.Line;case"block":return h.Block;case"underline":return h.Underline;case"line-thin":return h.LineThin;case"block-outline":return h.BlockOutline;case"underline-thin":return h.UnderlineThin}}class L extends g{constructor(){super(128)}compute(ae,J,pe){const Se=["monaco-editor"];return J.get(33)&&Se.push(J.get(33)),ae.extraEditorClassName&&Se.push(ae.extraEditorClassName),J.get(66)==="default"?Se.push("mouse-default"):J.get(66)==="copy"&&Se.push("mouse-copy"),J.get(100)&&Se.push("showUnused"),J.get(126)&&Se.push("showDeprecated"),Se.join(" ")}}class O extends P{constructor(){super(32,"emptySelectionClipboard",!0,{description:f.localize(6,null)})}compute(ae,J,pe){return pe&&ae.emptySelectionClipboard}}class y extends D{constructor(){const ae={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(35,"find",ae,{"editor.find.cursorMoveOnType":{type:"boolean",default:ae.cursorMoveOnType,description:f.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:ae.seedSearchStringFromSelection,enumDescriptions:[f.localize(8,null),f.localize(9,null),f.localize(10,null)],description:f.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ae.autoFindInSelection,enumDescriptions:[f.localize(12,null),f.localize(13,null),f.localize(14,null)],description:f.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ae.globalFindClipboard,description:f.localize(16,null),included:i.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ae.addExtraSpaceOnTop,description:f.localize(17,null)},"editor.find.loop":{type:"boolean",default:ae.loop,description:f.localize(18,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const J=ae;return{cursorMoveOnType:p(J.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof ae.seedSearchStringFromSelection=="boolean"?ae.seedSearchStringFromSelection?"always":"never":a(J.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof ae.autoFindInSelection=="boolean"?ae.autoFindInSelection?"always":"never":a(J.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:p(J.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:p(J.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:p(J.loop,this.defaultValue.loop)}}}class H extends D{constructor(){super(45,"fontLigatures",H.OFF,{anyOf:[{type:"boolean",description:f.localize(19,null)},{type:"string",description:f.localize(20,null)}],description:f.localize(21,null),default:!1})}validate(ae){return typeof ae=="undefined"?this.defaultValue:typeof ae=="string"?ae==="false"?H.OFF:ae==="true"?H.ON:ae:Boolean(ae)?H.ON:H.OFF}}e.EditorFontLigatures=H,H.OFF='"liga" off, "calt" off',H.ON='"liga" on, "calt" on';class M extends g{constructor(){super(44)}compute(ae,J,pe){return ae.fontInfo}}class j extends d{constructor(){super(46,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:f.localize(22,null)})}validate(ae){const J=c.float(ae,this.defaultValue);return J===0?e.EDITOR_FONT_DEFAULTS.fontSize:c.clamp(J,6,100)}compute(ae,J,pe){return ae.fontInfo.fontSize}}class X extends D{constructor(){super(47,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:X.MINIMUM_VALUE,maximum:X.MAXIMUM_VALUE,errorMessage:f.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:X.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:f.localize(24,null)})}validate(ae){return ae==="normal"||ae==="bold"?ae:String(l.clampedInt(ae,e.EDITOR_FONT_DEFAULTS.fontWeight,X.MINIMUM_VALUE,X.MAXIMUM_VALUE))}}X.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],X.MINIMUM_VALUE=1,X.MAXIMUM_VALUE=1e3;class $ extends D{constructor(){const ae={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},J={type:"string",enum:["peek","gotoAndPeek","goto"],default:ae.multiple,enumDescriptions:[f.localize(25,null),f.localize(26,null),f.localize(27,null)]},pe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(51,"gotoLocation",ae,{"editor.gotoLocation.multiple":{deprecationMessage:f.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:f.localize(29,null),...J},"editor.gotoLocation.multipleTypeDefinitions":{description:f.localize(30,null),...J},"editor.gotoLocation.multipleDeclarations":{description:f.localize(31,null),...J},"editor.gotoLocation.multipleImplementations":{description:f.localize(32,null),...J},"editor.gotoLocation.multipleReferences":{description:f.localize(33,null),...J},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ae.alternativeDefinitionCommand,enum:pe,description:f.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ae.alternativeTypeDefinitionCommand,enum:pe,description:f.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ae.alternativeDeclarationCommand,enum:pe,description:f.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ae.alternativeImplementationCommand,enum:pe,description:f.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ae.alternativeReferenceCommand,enum:pe,description:f.localize(38,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const J=ae;return{multiple:a(J.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:J.multipleDefinitions??a(J.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:J.multipleTypeDefinitions??a(J.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:J.multipleDeclarations??a(J.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:J.multipleImplementations??a(J.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:J.multipleReferences??a(J.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:u.string(J.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:u.string(J.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:u.string(J.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:u.string(J.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:u.string(J.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class U extends D{constructor(){const ae={enabled:!0,delay:300,sticky:!0,above:!0};super(53,"hover",ae,{"editor.hover.enabled":{type:"boolean",default:ae.enabled,description:f.localize(39,null)},"editor.hover.delay":{type:"number",default:ae.delay,minimum:0,maximum:1e4,description:f.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:ae.sticky,description:f.localize(41,null)},"editor.hover.above":{type:"boolean",default:ae.above,description:f.localize(42,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const J=ae;return{enabled:p(J.enabled,this.defaultValue.enabled),delay:l.clampedInt(J.delay,this.defaultValue.delay,0,1e4),sticky:p(J.sticky,this.defaultValue.sticky),above:p(J.above,this.defaultValue.above)}}}var q;(function(ne){ne[ne.None=0]="None",ne[ne.Text=1]="Text",ne[ne.Blocks=2]="Blocks"})(q=e.RenderMinimap||(e.RenderMinimap={}));class K extends g{constructor(){super(131)}compute(ae,J,pe){return K.computeLayout(J,{memory:ae.memory,outerWidth:ae.outerWidth,outerHeight:ae.outerHeight,isDominatedByLongLines:ae.isDominatedByLongLines,lineHeight:ae.fontInfo.lineHeight,viewLineCount:ae.viewLineCount,lineNumbersDigitCount:ae.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ae.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ae.fontInfo.maxDigitWidth,pixelRatio:ae.pixelRatio})}static computeContainedMinimapLineCount(ae){const J=ae.height/ae.lineHeight,pe=ae.scrollBeyondLastLine?J-1:0,Se=(ae.viewLineCount+pe)/(ae.pixelRatio*ae.height),Me=Math.floor(ae.viewLineCount/Se);return{typicalViewportLineCount:J,extraLinesBeyondLastLine:pe,desiredRatio:Se,minimapLineCount:Me}}static _computeMinimapLayout(ae,J){const pe=ae.outerWidth,Se=ae.outerHeight,Me=ae.pixelRatio;if(!ae.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Me*Se),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Se};const $e=J.stableMinimapLayoutInput,Ye=$e&&ae.outerHeight===$e.outerHeight&&ae.lineHeight===$e.lineHeight&&ae.typicalHalfwidthCharacterWidth===$e.typicalHalfwidthCharacterWidth&&ae.pixelRatio===$e.pixelRatio&&ae.scrollBeyondLastLine===$e.scrollBeyondLastLine&&ae.minimap.enabled===$e.minimap.enabled&&ae.minimap.side===$e.minimap.side&&ae.minimap.size===$e.minimap.size&&ae.minimap.showSlider===$e.minimap.showSlider&&ae.minimap.renderCharacters===$e.minimap.renderCharacters&&ae.minimap.maxColumn===$e.minimap.maxColumn&&ae.minimap.scale===$e.minimap.scale&&ae.verticalScrollbarWidth===$e.verticalScrollbarWidth&&ae.isViewportWrapping===$e.isViewportWrapping,lt=ae.lineHeight,vt=ae.typicalHalfwidthCharacterWidth,wt=ae.scrollBeyondLastLine,je=ae.minimap.renderCharacters;let st=Me>=2?Math.round(ae.minimap.scale*2):ae.minimap.scale;const _t=ae.minimap.maxColumn,nt=ae.minimap.size,ct=ae.minimap.side,Rt=ae.verticalScrollbarWidth,Tt=ae.viewLineCount,yt=ae.remainingWidth,mt=ae.isViewportWrapping,Lt=je?2:3;let Mt=Math.floor(Me*Se);const Ft=Mt/Me;let xe=!1,_e=!1,ye=Lt*st,me=st/Me,ie=1;if(nt==="fill"||nt==="fit"){const{typicalViewportLineCount:St,extraLinesBeyondLastLine:ot,desiredRatio:dt,minimapLineCount:ut}=K.computeContainedMinimapLineCount({viewLineCount:Tt,scrollBeyondLastLine:wt,height:Se,lineHeight:lt,pixelRatio:Me});if(Tt/ut>1)xe=!0,_e=!0,st=1,ye=1,me=st/Me;else{let pt=!1,kt=st+1;if(nt==="fit"){const Ut=Math.ceil((Tt+ot)*ye);mt&&Ye&&yt<=J.stableFitRemainingWidth?(pt=!0,kt=J.stableFitMaxMinimapScale):pt=Ut>Mt}if(nt==="fill"||pt){xe=!0;const Ut=st;ye=Math.min(lt*Me,Math.max(1,Math.floor(1/dt))),mt&&Ye&&yt<=J.stableFitRemainingWidth&&(kt=J.stableFitMaxMinimapScale),st=Math.min(kt,Math.max(1,Math.floor(ye/Lt))),st>Ut&&(ie=Math.min(2,st/Ut)),me=st/Me/ie,Mt=Math.ceil(Math.max(St,Tt+ot)*ye),mt?(J.stableMinimapLayoutInput=ae,J.stableFitRemainingWidth=yt,J.stableFitMaxMinimapScale=st):(J.stableMinimapLayoutInput=null,J.stableFitRemainingWidth=0)}}}const Ie=Math.floor(_t*me),Re=Math.min(Ie,Math.max(0,Math.floor((yt-Rt-2)*me/(vt+me)))+e.MINIMAP_GUTTER_WIDTH);let Ve=Math.floor(Me*Re);const Ke=Ve/Me;Ve=Math.floor(Ve*ie);const ht=je?1:2,Et=ct==="left"?0:pe-Re-Rt;return{renderMinimap:ht,minimapLeft:Et,minimapWidth:Re,minimapHeightIsEditorHeight:xe,minimapIsSampling:_e,minimapScale:st,minimapLineHeight:ye,minimapCanvasInnerWidth:Ve,minimapCanvasInnerHeight:Mt,minimapCanvasOuterWidth:Ke,minimapCanvasOuterHeight:Ft}}static computeLayout(ae,J){const pe=J.outerWidth|0,Se=J.outerHeight|0,Me=J.lineHeight|0,$e=J.lineNumbersDigitCount|0,Ye=J.typicalHalfwidthCharacterWidth,lt=J.maxDigitWidth,vt=J.pixelRatio,wt=J.viewLineCount,je=ae.get(123),st=je==="inherit"?ae.get(122):je,_t=st==="inherit"?ae.get(118):st,nt=ae.get(121),ct=ae.get(2),Rt=J.isDominatedByLongLines,Tt=ae.get(50),yt=ae.get(60).renderType!==0,mt=ae.get(61),Lt=ae.get(94),Mt=ae.get(65),Ft=ae.get(92),xe=Ft.verticalScrollbarSize,_e=Ft.verticalHasArrows,ye=Ft.arrowSize,me=Ft.horizontalScrollbarSize,ie=ae.get(58),Ie=ae.get(37);let Re;if(typeof ie=="string"&&/^\d+(\.\d+)?ch$/.test(ie)){const Ht=parseFloat(ie.substr(0,ie.length-2));Re=l.clampedInt(Ht*Ye,0,0,1e3)}else Re=l.clampedInt(ie,0,0,1e3);Ie&&(Re+=16);let Ve=0;if(yt){const Ht=Math.max($e,mt);Ve=Math.round(Ht*lt)}let Ke=0;Tt&&(Ke=Me);let ht=0,Et=ht+Ke,St=Et+Ve,ot=St+Re;const dt=pe-Ke-Ve-Re;let ut=!1,Nt=!1,pt=-1;ct!==2&&(st==="inherit"&&Rt?(ut=!0,Nt=!0):_t==="on"||_t==="bounded"?Nt=!0:_t==="wordWrapColumn"&&(pt=nt));const kt=K._computeMinimapLayout({outerWidth:pe,outerHeight:Se,lineHeight:Me,typicalHalfwidthCharacterWidth:Ye,pixelRatio:vt,scrollBeyondLastLine:Lt,minimap:Mt,verticalScrollbarWidth:xe,viewLineCount:wt,remainingWidth:dt,isViewportWrapping:Nt},J.memory||new F);kt.renderMinimap!==0&&kt.minimapLeft===0&&(ht+=kt.minimapWidth,Et+=kt.minimapWidth,St+=kt.minimapWidth,ot+=kt.minimapWidth);const Ut=dt-kt.minimapWidth,Ct=Math.max(1,Math.floor((Ut-xe-2)/Ye)),Bt=_e?ye:0;return Nt&&(pt=Math.max(1,Ct),_t==="bounded"&&(pt=Math.min(pt,nt))),{width:pe,height:Se,glyphMarginLeft:ht,glyphMarginWidth:Ke,lineNumbersLeft:Et,lineNumbersWidth:Ve,decorationsLeft:St,decorationsWidth:Re,contentLeft:ot,contentWidth:Ut,minimap:kt,viewportColumn:Ct,isWordWrapMinified:ut,isViewportWrapping:Nt,wrappingColumn:pt,verticalScrollbarWidth:xe,horizontalScrollbarHeight:me,overviewRuler:{top:Bt,width:xe,height:Se-2*Bt,right:0}}}}e.EditorLayoutInfoComputer=K;class G extends D{constructor(){const ae={enabled:!0};super(57,"lightbulb",ae,{"editor.lightbulb.enabled":{type:"boolean",default:ae.enabled,description:f.localize(43,null)}})}validate(ae){return!ae||typeof ae!="object"?this.defaultValue:{enabled:p(ae.enabled,this.defaultValue.enabled)}}}class ee extends D{constructor(){const ae={enabled:!0,fontSize:0,fontFamily:""};super(127,"inlayHints",ae,{"editor.inlayHints.enabled":{type:"boolean",default:ae.enabled,description:f.localize(44,null)},"editor.inlayHints.fontSize":{type:"number",default:ae.fontSize,markdownDescription:f.localize(45,null)},"editor.inlayHints.fontFamily":{type:"string",default:ae.fontFamily,markdownDescription:f.localize(46,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const J=ae;return{enabled:p(J.enabled,this.defaultValue.enabled),fontSize:l.clampedInt(J.fontSize,this.defaultValue.fontSize,0,100),fontFamily:u.string(J.fontFamily,this.defaultValue.fontFamily)}}}class oe extends c{constructor(){super(59,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ae=>c.clamp(ae,0,150),{markdownDescription:f.localize(47,null)})}compute(ae,J,pe){return ae.fontInfo.lineHeight}}class ue extends D{constructor(){const ae={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(65,"minimap",ae,{"editor.minimap.enabled":{type:"boolean",default:ae.enabled,description:f.localize(48,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[f.localize(49,null),f.localize(50,null),f.localize(51,null)],default:ae.size,description:f.localize(52,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ae.side,description:f.localize(53,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ae.showSlider,description:f.localize(54,null)},"editor.minimap.scale":{type:"number",default:ae.scale,minimum:1,maximum:3,enum:[1,2,3],description:f.localize(55,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ae.renderCharacters,description:f.localize(56,null)},"editor.minimap.maxColumn":{type:"number",default:ae.maxColumn,description:f.localize(57,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const J=ae;return{enabled:p(J.enabled,this.defaultValue.enabled),size:a(J.size,this.defaultValue.size,["proportional","fill","fit"]),side:a(J.side,this.defaultValue.side,["right","left"]),showSlider:a(J.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:p(J.renderCharacters,this.defaultValue.renderCharacters),scale:l.clampedInt(J.scale,1,1,3),maxColumn:l.clampedInt(J.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Z(ne){return ne==="ctrlCmd"?i.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Y extends D{constructor(){super(75,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:f.localize(58,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:f.localize(59,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const J=ae;return{top:l.clampedInt(J.top,0,0,1e3),bottom:l.clampedInt(J.bottom,0,0,1e3)}}}class se extends D{constructor(){const ae={enabled:!0,cycle:!1};super(76,"parameterHints",ae,{"editor.parameterHints.enabled":{type:"boolean",default:ae.enabled,description:f.localize(60,null)},"editor.parameterHints.cycle":{type:"boolean",default:ae.cycle,description:f.localize(61,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const J=ae;return{enabled:p(J.enabled,this.defaultValue.enabled),cycle:p(J.cycle,this.defaultValue.cycle)}}}class de extends g{constructor(){super(129)}compute(ae,J,pe){return ae.pixelRatio}}class ge extends D{constructor(){const ae={other:!0,comments:!1,strings:!1};super(79,"quickSuggestions",ae,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:ae.strings,description:f.localize(62,null)},comments:{type:"boolean",default:ae.comments,description:f.localize(63,null)},other:{type:"boolean",default:ae.other,description:f.localize(64,null)}}}],default:ae,description:f.localize(65,null)});this.defaultValue=ae}validate(ae){if(typeof ae=="boolean")return ae;if(ae&&typeof ae=="object"){const J=ae,pe={other:p(J.other,this.defaultValue.other),comments:p(J.comments,this.defaultValue.comments),strings:p(J.strings,this.defaultValue.strings)};return pe.other&&pe.comments&&pe.strings?!0:!pe.other&&!pe.comments&&!pe.strings?!1:pe}return this.defaultValue}}var Te;(function(ne){ne[ne.Off=0]="Off",ne[ne.On=1]="On",ne[ne.Relative=2]="Relative",ne[ne.Interval=3]="Interval",ne[ne.Custom=4]="Custom"})(Te=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Ne extends D{constructor(){super(60,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[f.localize(66,null),f.localize(67,null),f.localize(68,null),f.localize(69,null)],default:"on",description:f.localize(70,null)})}validate(ae){let J=this.defaultValue.renderType,pe=this.defaultValue.renderFn;return typeof ae!="undefined"&&(typeof ae=="function"?(J=4,pe=ae):ae==="interval"?J=3:ae==="relative"?J=2:ae==="on"?J=1:J=0),{renderType:J,renderFn:pe}}}function be(ne){const ae=ne.get(87);return ae==="editable"?ne.get(81):ae!=="on"}e.filterValidationDecorations=be;class Ee extends D{constructor(){const ae=[],J={type:"number",description:f.localize(71,null)};super(91,"rulers",ae,{type:"array",items:{anyOf:[J,{type:["object"],properties:{column:J,color:{type:"string",description:f.localize(72,null),format:"color-hex"}}}]},default:ae,description:f.localize(73,null)})}validate(ae){if(Array.isArray(ae)){const J=[];for(let pe of ae)if(typeof pe=="number")J.push({column:l.clampedInt(pe,0,0,1e4),color:null});else if(pe&&typeof pe=="object"){const Se=pe;J.push({column:l.clampedInt(Se.column,0,0,1e4),color:Se.color})}return J.sort((pe,Se)=>pe.column-Se.column),J}return this.defaultValue}}function z(ne,ae){if(typeof ne!="string")return ae;switch(ne){case"hidden":return 2;case"visible":return 3;default:return 1}}class B extends D{constructor(){const ae={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(92,"scrollbar",ae,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[f.localize(74,null),f.localize(75,null),f.localize(76,null)],default:"auto",description:f.localize(77,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[f.localize(78,null),f.localize(79,null),f.localize(80,null)],default:"auto",description:f.localize(81,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ae.verticalScrollbarSize,description:f.localize(82,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ae.horizontalScrollbarSize,description:f.localize(83,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ae.scrollByPage,description:f.localize(84,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const J=ae,pe=l.clampedInt(J.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Se=l.clampedInt(J.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:l.clampedInt(J.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:z(J.vertical,this.defaultValue.vertical),horizontal:z(J.horizontal,this.defaultValue.horizontal),useShadows:p(J.useShadows,this.defaultValue.useShadows),verticalHasArrows:p(J.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:p(J.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:p(J.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:p(J.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:pe,horizontalSliderSize:l.clampedInt(J.horizontalSliderSize,pe,0,1e3),verticalScrollbarSize:Se,verticalSliderSize:l.clampedInt(J.verticalSliderSize,Se,0,1e3),scrollByPage:p(J.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class N extends D{constructor(){const ae={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(113,"unicodeHighlight",ae,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ae.nonBasicASCII,description:f.localize(85,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:ae.invisibleCharacters,description:f.localize(86,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:ae.ambiguousCharacters,description:f.localize(87,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ae.includeComments,description:f.localize(88,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ae.includeStrings,description:f.localize(89,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:ae.allowedCharacters,description:f.localize(90,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:ae.allowedLocales,description:f.localize(91,null)}})}applyUpdate(ae,J){let pe=!1;J.allowedCharacters&&(C.equals(ae.allowedCharacters,J.allowedCharacters)||(ae={...ae,allowedCharacters:J.allowedCharacters},pe=!0)),J.allowedLocales&&(C.equals(ae.allowedLocales,J.allowedLocales)||(ae={...ae,allowedLocales:J.allowedLocales},pe=!0));const Se=super.applyUpdate(ae,J);return pe?new v(Se.newValue,!0):Se}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const J=ae;return{nonBasicASCII:he(J.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:p(J.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:p(J.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:he(J.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:he(J.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(ae.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(ae.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(ae,J){if(typeof ae!="object"||!ae)return J;const pe={};for(const[Se,Me]of Object.entries(ae))Me===!0&&(pe[Se]=!0);return pe}}class W extends D{constructor(){const ae={enabled:!0,mode:"subwordSmart"};super(55,"inlineSuggest",ae,{"editor.inlineSuggest.enabled":{type:"boolean",default:ae.enabled,description:f.localize(92,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const J=ae;return{enabled:p(J.enabled,this.defaultValue.enabled),mode:a(J.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class V extends D{constructor(){const ae={enabled:k.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",ae,{"editor.bracketPairColorization.enabled":{type:"boolean",default:ae.enabled,description:f.localize(93,null)}})}validate(ae){return!ae||typeof ae!="object"?this.defaultValue:{enabled:p(ae.enabled,this.defaultValue.enabled)}}}class re extends D{constructor(){const ae={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",ae,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[f.localize(94,null),f.localize(95,null),f.localize(96,null)],default:ae.bracketPairs,description:f.localize(97,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[f.localize(98,null),f.localize(99,null),f.localize(100,null)],default:ae.bracketPairsHorizontal,description:f.localize(101,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:ae.highlightActiveBracketPair,description:f.localize(102,null)},"editor.guides.indentation":{type:"boolean",default:ae.indentation,description:f.localize(103,null)},"editor.guides.highlightActiveIndentation":{type:"boolean",default:ae.highlightActiveIndentation,description:f.localize(104,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const J=ae;return{bracketPairs:he(J.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:he(J.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:p(J.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:p(J.indentation,this.defaultValue.indentation),highlightActiveIndentation:p(J.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation)}}}function he(ne,ae,J){const pe=J.indexOf(ne);return pe===-1?ae:J[pe]}class Ce extends D{constructor(){const ae={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(106,"suggest",ae,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[f.localize(105,null),f.localize(106,null)],default:ae.insertMode,description:f.localize(107,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ae.filterGraceful,description:f.localize(108,null)},"editor.suggest.localityBonus":{type:"boolean",default:ae.localityBonus,description:f.localize(109,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ae.shareSuggestSelections,markdownDescription:f.localize(110,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ae.snippetsPreventQuickSuggestions,description:f.localize(111,null)},"editor.suggest.showIcons":{type:"boolean",default:ae.showIcons,description:f.localize(112,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ae.showStatusBar,description:f.localize(113,null)},"editor.suggest.preview":{type:"boolean",default:ae.preview,description:f.localize(114,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ae.showInlineDetails,description:f.localize(115,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:f.localize(116,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:f.localize(117,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:f.localize(118,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:f.localize(119,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:f.localize(120,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:f.localize(121,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:f.localize(122,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:f.localize(123,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:f.localize(124,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:f.localize(125,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:f.localize(126,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:f.localize(127,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:f.localize(128,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:f.localize(129,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:f.localize(130,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:f.localize(131,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:f.localize(132,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:f.localize(133,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:f.localize(134,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:f.localize(135,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:f.localize(136,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:f.localize(137,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:f.localize(138,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:f.localize(139,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:f.localize(140,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:f.localize(141,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:f.localize(142,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:f.localize(143,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:f.localize(144,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:f.localize(145,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:f.localize(146,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const J=ae;return{insertMode:a(J.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:p(J.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:p(J.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:p(J.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:p(J.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:p(J.showIcons,this.defaultValue.showIcons),showStatusBar:p(J.showStatusBar,this.defaultValue.showStatusBar),preview:p(J.preview,this.defaultValue.preview),previewMode:a(J.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:p(J.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:p(J.showMethods,this.defaultValue.showMethods),showFunctions:p(J.showFunctions,this.defaultValue.showFunctions),showConstructors:p(J.showConstructors,this.defaultValue.showConstructors),showDeprecated:p(J.showDeprecated,this.defaultValue.showDeprecated),showFields:p(J.showFields,this.defaultValue.showFields),showVariables:p(J.showVariables,this.defaultValue.showVariables),showClasses:p(J.showClasses,this.defaultValue.showClasses),showStructs:p(J.showStructs,this.defaultValue.showStructs),showInterfaces:p(J.showInterfaces,this.defaultValue.showInterfaces),showModules:p(J.showModules,this.defaultValue.showModules),showProperties:p(J.showProperties,this.defaultValue.showProperties),showEvents:p(J.showEvents,this.defaultValue.showEvents),showOperators:p(J.showOperators,this.defaultValue.showOperators),showUnits:p(J.showUnits,this.defaultValue.showUnits),showValues:p(J.showValues,this.defaultValue.showValues),showConstants:p(J.showConstants,this.defaultValue.showConstants),showEnums:p(J.showEnums,this.defaultValue.showEnums),showEnumMembers:p(J.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:p(J.showKeywords,this.defaultValue.showKeywords),showWords:p(J.showWords,this.defaultValue.showWords),showColors:p(J.showColors,this.defaultValue.showColors),showFiles:p(J.showFiles,this.defaultValue.showFiles),showReferences:p(J.showReferences,this.defaultValue.showReferences),showFolders:p(J.showFolders,this.defaultValue.showFolders),showTypeParameters:p(J.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:p(J.showSnippets,this.defaultValue.showSnippets),showUsers:p(J.showUsers,this.defaultValue.showUsers),showIssues:p(J.showIssues,this.defaultValue.showIssues)}}}class Ae extends D{constructor(){super(102,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:f.localize(147,null),default:!0,type:"boolean"}})}validate(ae){return!ae||typeof ae!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:p(ae.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class We extends g{constructor(){super(130)}compute(ae,J,pe){return J.get(81)?!0:ae.tabFocusMode}}var ze;(function(ne){ne[ne.None=0]="None",ne[ne.Same=1]="Same",ne[ne.Indent=2]="Indent",ne[ne.DeepIndent=3]="DeepIndent"})(ze=e.WrappingIndent||(e.WrappingIndent={}));function qe(ne){switch(ne){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class He extends g{constructor(){super(132)}compute(ae,J,pe){const Se=J.get(131);return{isDominatedByLongLines:ae.isDominatedByLongLines,isWordWrapMinified:Se.isWordWrapMinified,isViewportWrapping:Se.isViewportWrapping,wrappingColumn:Se.wrappingColumn}}}const Ue="Consolas, 'Courier New', monospace",Je="Menlo, Monaco, 'Courier New', monospace",et="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:i.isMacintosh?Je:i.isLinux?et:Ue,fontWeight:"normal",fontSize:i.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Le(ne){return e.editorOptionsRegistry[ne.id]=ne,ne}var it;(function(ne){ne[ne.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ne[ne.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ne[ne.accessibilitySupport=2]="accessibilitySupport",ne[ne.accessibilityPageSize=3]="accessibilityPageSize",ne[ne.ariaLabel=4]="ariaLabel",ne[ne.autoClosingBrackets=5]="autoClosingBrackets",ne[ne.autoClosingDelete=6]="autoClosingDelete",ne[ne.autoClosingOvertype=7]="autoClosingOvertype",ne[ne.autoClosingQuotes=8]="autoClosingQuotes",ne[ne.autoIndent=9]="autoIndent",ne[ne.automaticLayout=10]="automaticLayout",ne[ne.autoSurround=11]="autoSurround",ne[ne.bracketPairColorization=12]="bracketPairColorization",ne[ne.guides=13]="guides",ne[ne.codeLens=14]="codeLens",ne[ne.codeLensFontFamily=15]="codeLensFontFamily",ne[ne.codeLensFontSize=16]="codeLensFontSize",ne[ne.colorDecorators=17]="colorDecorators",ne[ne.columnSelection=18]="columnSelection",ne[ne.comments=19]="comments",ne[ne.contextmenu=20]="contextmenu",ne[ne.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",ne[ne.cursorBlinking=22]="cursorBlinking",ne[ne.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",ne[ne.cursorStyle=24]="cursorStyle",ne[ne.cursorSurroundingLines=25]="cursorSurroundingLines",ne[ne.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",ne[ne.cursorWidth=27]="cursorWidth",ne[ne.disableLayerHinting=28]="disableLayerHinting",ne[ne.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",ne[ne.domReadOnly=30]="domReadOnly",ne[ne.dragAndDrop=31]="dragAndDrop",ne[ne.emptySelectionClipboard=32]="emptySelectionClipboard",ne[ne.extraEditorClassName=33]="extraEditorClassName",ne[ne.fastScrollSensitivity=34]="fastScrollSensitivity",ne[ne.find=35]="find",ne[ne.fixedOverflowWidgets=36]="fixedOverflowWidgets",ne[ne.folding=37]="folding",ne[ne.foldingStrategy=38]="foldingStrategy",ne[ne.foldingHighlight=39]="foldingHighlight",ne[ne.foldingImportsByDefault=40]="foldingImportsByDefault",ne[ne.foldingMaximumRegions=41]="foldingMaximumRegions",ne[ne.unfoldOnClickAfterEndOfLine=42]="unfoldOnClickAfterEndOfLine",ne[ne.fontFamily=43]="fontFamily",ne[ne.fontInfo=44]="fontInfo",ne[ne.fontLigatures=45]="fontLigatures",ne[ne.fontSize=46]="fontSize",ne[ne.fontWeight=47]="fontWeight",ne[ne.formatOnPaste=48]="formatOnPaste",ne[ne.formatOnType=49]="formatOnType",ne[ne.glyphMargin=50]="glyphMargin",ne[ne.gotoLocation=51]="gotoLocation",ne[ne.hideCursorInOverviewRuler=52]="hideCursorInOverviewRuler",ne[ne.hover=53]="hover",ne[ne.inDiffEditor=54]="inDiffEditor",ne[ne.inlineSuggest=55]="inlineSuggest",ne[ne.letterSpacing=56]="letterSpacing",ne[ne.lightbulb=57]="lightbulb",ne[ne.lineDecorationsWidth=58]="lineDecorationsWidth",ne[ne.lineHeight=59]="lineHeight",ne[ne.lineNumbers=60]="lineNumbers",ne[ne.lineNumbersMinChars=61]="lineNumbersMinChars",ne[ne.linkedEditing=62]="linkedEditing",ne[ne.links=63]="links",ne[ne.matchBrackets=64]="matchBrackets",ne[ne.minimap=65]="minimap",ne[ne.mouseStyle=66]="mouseStyle",ne[ne.mouseWheelScrollSensitivity=67]="mouseWheelScrollSensitivity",ne[ne.mouseWheelZoom=68]="mouseWheelZoom",ne[ne.multiCursorMergeOverlapping=69]="multiCursorMergeOverlapping",ne[ne.multiCursorModifier=70]="multiCursorModifier",ne[ne.multiCursorPaste=71]="multiCursorPaste",ne[ne.occurrencesHighlight=72]="occurrencesHighlight",ne[ne.overviewRulerBorder=73]="overviewRulerBorder",ne[ne.overviewRulerLanes=74]="overviewRulerLanes",ne[ne.padding=75]="padding",ne[ne.parameterHints=76]="parameterHints",ne[ne.peekWidgetDefaultFocus=77]="peekWidgetDefaultFocus",ne[ne.definitionLinkOpensInPeek=78]="definitionLinkOpensInPeek",ne[ne.quickSuggestions=79]="quickSuggestions",ne[ne.quickSuggestionsDelay=80]="quickSuggestionsDelay",ne[ne.readOnly=81]="readOnly",ne[ne.renameOnType=82]="renameOnType",ne[ne.renderControlCharacters=83]="renderControlCharacters",ne[ne.renderFinalNewline=84]="renderFinalNewline",ne[ne.renderLineHighlight=85]="renderLineHighlight",ne[ne.renderLineHighlightOnlyWhenFocus=86]="renderLineHighlightOnlyWhenFocus",ne[ne.renderValidationDecorations=87]="renderValidationDecorations",ne[ne.renderWhitespace=88]="renderWhitespace",ne[ne.revealHorizontalRightPadding=89]="revealHorizontalRightPadding",ne[ne.roundedSelection=90]="roundedSelection",ne[ne.rulers=91]="rulers",ne[ne.scrollbar=92]="scrollbar",ne[ne.scrollBeyondLastColumn=93]="scrollBeyondLastColumn",ne[ne.scrollBeyondLastLine=94]="scrollBeyondLastLine",ne[ne.scrollPredominantAxis=95]="scrollPredominantAxis",ne[ne.selectionClipboard=96]="selectionClipboard",ne[ne.selectionHighlight=97]="selectionHighlight",ne[ne.selectOnLineNumbers=98]="selectOnLineNumbers",ne[ne.showFoldingControls=99]="showFoldingControls",ne[ne.showUnused=100]="showUnused",ne[ne.snippetSuggestions=101]="snippetSuggestions",ne[ne.smartSelect=102]="smartSelect",ne[ne.smoothScrolling=103]="smoothScrolling",ne[ne.stickyTabStops=104]="stickyTabStops",ne[ne.stopRenderingLineAfter=105]="stopRenderingLineAfter",ne[ne.suggest=106]="suggest",ne[ne.suggestFontSize=107]="suggestFontSize",ne[ne.suggestLineHeight=108]="suggestLineHeight",ne[ne.suggestOnTriggerCharacters=109]="suggestOnTriggerCharacters",ne[ne.suggestSelection=110]="suggestSelection",ne[ne.tabCompletion=111]="tabCompletion",ne[ne.tabIndex=112]="tabIndex",ne[ne.unicodeHighlighting=113]="unicodeHighlighting",ne[ne.unusualLineTerminators=114]="unusualLineTerminators",ne[ne.useShadowDOM=115]="useShadowDOM",ne[ne.useTabStops=116]="useTabStops",ne[ne.wordSeparators=117]="wordSeparators",ne[ne.wordWrap=118]="wordWrap",ne[ne.wordWrapBreakAfterCharacters=119]="wordWrapBreakAfterCharacters",ne[ne.wordWrapBreakBeforeCharacters=120]="wordWrapBreakBeforeCharacters",ne[ne.wordWrapColumn=121]="wordWrapColumn",ne[ne.wordWrapOverride1=122]="wordWrapOverride1",ne[ne.wordWrapOverride2=123]="wordWrapOverride2",ne[ne.wrappingIndent=124]="wrappingIndent",ne[ne.wrappingStrategy=125]="wrappingStrategy",ne[ne.showDeprecated=126]="showDeprecated",ne[ne.inlayHints=127]="inlayHints",ne[ne.editorClassName=128]="editorClassName",ne[ne.pixelRatio=129]="pixelRatio",ne[ne.tabFocusMode=130]="tabFocusMode",ne[ne.layoutInfo=131]="layoutInfo",ne[ne.wrappingInfo=132]="wrappingInfo"})(it=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Le(new P(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:f.localize(148,null)})),acceptSuggestionOnEnter:Le(new E(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",f.localize(149,null),""],markdownDescription:f.localize(150,null)})),accessibilitySupport:Le(new r),accessibilityPageSize:Le(new l(3,"accessibilityPageSize",10,1,1073741824,{description:f.localize(151,null)})),ariaLabel:Le(new u(4,"ariaLabel",f.localize(152,null))),autoClosingBrackets:Le(new E(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",f.localize(153,null),f.localize(154,null),""],description:f.localize(155,null)})),autoClosingDelete:Le(new E(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",f.localize(156,null),""],description:f.localize(157,null)})),autoClosingOvertype:Le(new E(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",f.localize(158,null),""],description:f.localize(159,null)})),autoClosingQuotes:Le(new E(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",f.localize(160,null),f.localize(161,null),""],description:f.localize(162,null)})),autoIndent:Le(new s(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],t,{enumDescriptions:[f.localize(163,null),f.localize(164,null),f.localize(165,null),f.localize(166,null),f.localize(167,null)],description:f.localize(168,null)})),automaticLayout:Le(new P(10,"automaticLayout",!1)),autoSurround:Le(new E(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[f.localize(169,null),f.localize(170,null),f.localize(171,null),""],description:f.localize(172,null)})),bracketPairColorization:Le(new V),bracketPairGuides:Le(new re),stickyTabStops:Le(new P(104,"stickyTabStops",!1,{description:f.localize(173,null)})),codeLens:Le(new P(14,"codeLens",!0,{description:f.localize(174,null)})),codeLensFontFamily:Le(new u(15,"codeLensFontFamily","",{description:f.localize(175,null)})),codeLensFontSize:Le(new l(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:f.localize(176,null)})),colorDecorators:Le(new P(17,"colorDecorators",!0,{description:f.localize(177,null)})),columnSelection:Le(new P(18,"columnSelection",!1,{description:f.localize(178,null)})),comments:Le(new n),contextmenu:Le(new P(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Le(new P(21,"copyWithSyntaxHighlighting",!0,{description:f.localize(179,null)})),cursorBlinking:Le(new s(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],m,{description:f.localize(180,null)})),cursorSmoothCaretAnimation:Le(new P(23,"cursorSmoothCaretAnimation",!1,{description:f.localize(181,null)})),cursorStyle:Le(new s(24,"cursorStyle",h.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],T,{description:f.localize(182,null)})),cursorSurroundingLines:Le(new l(25,"cursorSurroundingLines",0,0,1073741824,{description:f.localize(183,null)})),cursorSurroundingLinesStyle:Le(new E(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[f.localize(184,null),f.localize(185,null)],description:f.localize(186,null)})),cursorWidth:Le(new l(27,"cursorWidth",0,0,1073741824,{markdownDescription:f.localize(187,null)})),disableLayerHinting:Le(new P(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Le(new P(29,"disableMonospaceOptimizations",!1)),domReadOnly:Le(new P(30,"domReadOnly",!1)),dragAndDrop:Le(new P(31,"dragAndDrop",!0,{description:f.localize(188,null)})),emptySelectionClipboard:Le(new O),extraEditorClassName:Le(new u(33,"extraEditorClassName","")),fastScrollSensitivity:Le(new c(34,"fastScrollSensitivity",5,ne=>ne<=0?5:ne,{markdownDescription:f.localize(189,null)})),find:Le(new y),fixedOverflowWidgets:Le(new P(36,"fixedOverflowWidgets",!1)),folding:Le(new P(37,"folding",!0,{description:f.localize(190,null)})),foldingStrategy:Le(new E(38,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[f.localize(191,null),f.localize(192,null)],description:f.localize(193,null)})),foldingHighlight:Le(new P(39,"foldingHighlight",!0,{description:f.localize(194,null)})),foldingImportsByDefault:Le(new P(40,"foldingImportsByDefault",!1,{description:f.localize(195,null)})),foldingMaximumRegions:Le(new l(41,"foldingMaximumRegions",5e3,10,65e3,{description:f.localize(196,null)})),unfoldOnClickAfterEndOfLine:Le(new P(42,"unfoldOnClickAfterEndOfLine",!1,{description:f.localize(197,null)})),fontFamily:Le(new u(43,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:f.localize(198,null)})),fontInfo:Le(new M),fontLigatures2:Le(new H),fontSize:Le(new j),fontWeight:Le(new X),formatOnPaste:Le(new P(48,"formatOnPaste",!1,{description:f.localize(199,null)})),formatOnType:Le(new P(49,"formatOnType",!1,{description:f.localize(200,null)})),glyphMargin:Le(new P(50,"glyphMargin",!0,{description:f.localize(201,null)})),gotoLocation:Le(new $),hideCursorInOverviewRuler:Le(new P(52,"hideCursorInOverviewRuler",!1,{description:f.localize(202,null)})),hover:Le(new U),inDiffEditor:Le(new P(54,"inDiffEditor",!1)),letterSpacing:Le(new c(56,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ne=>c.clamp(ne,-5,20),{description:f.localize(203,null)})),lightbulb:Le(new G),lineDecorationsWidth:Le(new d(58,"lineDecorationsWidth",10)),lineHeight:Le(new oe),lineNumbers:Le(new Ne),lineNumbersMinChars:Le(new l(61,"lineNumbersMinChars",5,1,300)),linkedEditing:Le(new P(62,"linkedEditing",!1,{description:f.localize(204,null)})),links:Le(new P(63,"links",!0,{description:f.localize(205,null)})),matchBrackets:Le(new E(64,"matchBrackets","always",["always","near","never"],{description:f.localize(206,null)})),minimap:Le(new ue),mouseStyle:Le(new E(66,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Le(new c(67,"mouseWheelScrollSensitivity",1,ne=>ne===0?1:ne,{markdownDescription:f.localize(207,null)})),mouseWheelZoom:Le(new P(68,"mouseWheelZoom",!1,{markdownDescription:f.localize(208,null)})),multiCursorMergeOverlapping:Le(new P(69,"multiCursorMergeOverlapping",!0,{description:f.localize(209,null)})),multiCursorModifier:Le(new s(70,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Z,{markdownEnumDescriptions:[f.localize(210,null),f.localize(211,null)],markdownDescription:f.localize(212,null)})),multiCursorPaste:Le(new E(71,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[f.localize(213,null),f.localize(214,null)],markdownDescription:f.localize(215,null)})),occurrencesHighlight:Le(new P(72,"occurrencesHighlight",!0,{description:f.localize(216,null)})),overviewRulerBorder:Le(new P(73,"overviewRulerBorder",!0,{description:f.localize(217,null)})),overviewRulerLanes:Le(new l(74,"overviewRulerLanes",3,0,3)),padding:Le(new Y),parameterHints:Le(new se),peekWidgetDefaultFocus:Le(new E(77,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[f.localize(218,null),f.localize(219,null)],description:f.localize(220,null)})),definitionLinkOpensInPeek:Le(new P(78,"definitionLinkOpensInPeek",!1,{description:f.localize(221,null)})),quickSuggestions:Le(new ge),quickSuggestionsDelay:Le(new l(80,"quickSuggestionsDelay",10,0,1073741824,{description:f.localize(222,null)})),readOnly:Le(new P(81,"readOnly",!1)),renameOnType:Le(new P(82,"renameOnType",!1,{description:f.localize(223,null),markdownDeprecationMessage:f.localize(224,null)})),renderControlCharacters:Le(new P(83,"renderControlCharacters",!0,{description:f.localize(225,null),restricted:!0})),renderFinalNewline:Le(new P(84,"renderFinalNewline",!0,{description:f.localize(226,null)})),renderLineHighlight:Le(new E(85,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",f.localize(227,null)],description:f.localize(228,null)})),renderLineHighlightOnlyWhenFocus:Le(new P(86,"renderLineHighlightOnlyWhenFocus",!1,{description:f.localize(229,null)})),renderValidationDecorations:Le(new E(87,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Le(new E(88,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",f.localize(230,null),f.localize(231,null),f.localize(232,null),""],description:f.localize(233,null)})),revealHorizontalRightPadding:Le(new l(89,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Le(new P(90,"roundedSelection",!0,{description:f.localize(234,null)})),rulers:Le(new Ee),scrollbar:Le(new B),scrollBeyondLastColumn:Le(new l(93,"scrollBeyondLastColumn",5,0,1073741824,{description:f.localize(235,null)})),scrollBeyondLastLine:Le(new P(94,"scrollBeyondLastLine",!0,{description:f.localize(236,null)})),scrollPredominantAxis:Le(new P(95,"scrollPredominantAxis",!0,{description:f.localize(237,null)})),selectionClipboard:Le(new P(96,"selectionClipboard",!0,{description:f.localize(238,null),included:i.isLinux})),selectionHighlight:Le(new P(97,"selectionHighlight",!0,{description:f.localize(239,null)})),selectOnLineNumbers:Le(new P(98,"selectOnLineNumbers",!0)),showFoldingControls:Le(new E(99,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[f.localize(240,null),f.localize(241,null)],description:f.localize(242,null)})),showUnused:Le(new P(100,"showUnused",!0,{description:f.localize(243,null)})),showDeprecated:Le(new P(126,"showDeprecated",!0,{description:f.localize(244,null)})),inlayHints:Le(new ee),snippetSuggestions:Le(new E(101,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[f.localize(245,null),f.localize(246,null),f.localize(247,null),f.localize(248,null)],description:f.localize(249,null)})),smartSelect:Le(new Ae),smoothScrolling:Le(new P(103,"smoothScrolling",!1,{description:f.localize(250,null)})),stopRenderingLineAfter:Le(new l(105,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Le(new Ce),inlineSuggest:Le(new W),suggestFontSize:Le(new l(107,"suggestFontSize",0,0,1e3,{markdownDescription:f.localize(251,null)})),suggestLineHeight:Le(new l(108,"suggestLineHeight",0,0,1e3,{markdownDescription:f.localize(252,null)})),suggestOnTriggerCharacters:Le(new P(109,"suggestOnTriggerCharacters",!0,{description:f.localize(253,null)})),suggestSelection:Le(new E(110,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[f.localize(254,null),f.localize(255,null),f.localize(256,null)],description:f.localize(257,null)})),tabCompletion:Le(new E(111,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[f.localize(258,null),f.localize(259,null),f.localize(260,null)],description:f.localize(261,null)})),tabIndex:Le(new l(112,"tabIndex",0,-1,1073741824)),unicodeHighlight:Le(new N),unusualLineTerminators:Le(new E(114,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[f.localize(262,null),f.localize(263,null),f.localize(264,null)],description:f.localize(265,null)})),useShadowDOM:Le(new P(115,"useShadowDOM",!0)),useTabStops:Le(new P(116,"useTabStops",!0,{description:f.localize(266,null)})),wordSeparators:Le(new u(117,"wordSeparators",I.USUAL_WORD_SEPARATORS,{description:f.localize(267,null)})),wordWrap:Le(new E(118,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[f.localize(268,null),f.localize(269,null),f.localize(270,null),f.localize(271,null)],description:f.localize(272,null)})),wordWrapBreakAfterCharacters:Le(new u(119,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Le(new u(120,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Le(new l(121,"wordWrapColumn",80,1,1073741824,{markdownDescription:f.localize(273,null)})),wordWrapOverride1:Le(new E(122,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Le(new E(123,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Le(new s(124,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],qe,{enumDescriptions:[f.localize(274,null),f.localize(275,null),f.localize(276,null),f.localize(277,null)],description:f.localize(278,null)})),wrappingStrategy:Le(new E(125,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[f.localize(279,null),f.localize(280,null)],description:f.localize(281,null)})),editorClassName:Le(new L),pixelRatio:Le(new de),tabFocusMode:Le(new We),layoutInfo:Le(new K),wrappingInfo:Le(new He)}}),define(ve[159],we([19,20]),function(te,e){return te.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ve[160],we([19,20]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ve[161],we([19,20]),function(te,e){return te.create("vs/platform/extensions/common/extensionValidator",e)}),define(ve[162],we([19,20]),function(te,e){return te.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ve[163],we([19,20]),function(te,e){return te.create("vs/platform/files/common/files",e)}),define(ve[164],we([19,20]),function(te,e){return te.create("vs/platform/markers/common/markers",e)}),define(ve[165],we([19,20]),function(te,e){return te.create("vs/platform/workspace/common/workspace",e)}),define(ve[166],we([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ve[167],we([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ve[168],we([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostProgress",e)}),define(ve[169],we([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ve[170],we([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ve[171],we([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ve[172],we([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ve[173],we([19,20]),function(te,e){return te.create("vs/workbench/api/node/extHostDebugService",e)}),define(ve[174],we([19,20]),function(te,e){return te.create("vs/workbench/api/node/extHostTunnelService",e)}),define(ve[175],we([19,20]),function(te,e){return te.create("vs/workbench/common/editor",e)}),define(ve[176],we([19,20]),function(te,e){return te.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ve[177],we([19,20]),function(te,e){return te.create("vs/workbench/contrib/debug/common/debug",e)}),define(ve[178],we([19,20]),function(te,e){return te.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ve[179],we([19,20]),function(te,e){return te.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(ve[180],we([19,20]),function(te,e){return te.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ve[181],we([19,20]),function(te,e){return te.create("vs/workbench/services/search/common/queryBuilder",e)}),define(ve[182],we([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionSource=e.TextEditorSelectionRevealType=e.EditorOpenSource=e.EditorResolution=e.EditorActivation=void 0;var f;(function(k){k[k.ACTIVATE=1]="ACTIVATE",k[k.RESTORE=2]="RESTORE",k[k.PRESERVE=3]="PRESERVE"})(f=e.EditorActivation||(e.EditorActivation={}));var i;(function(k){k[k.PICK=0]="PICK",k[k.DISABLED=1]="DISABLED",k[k.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(i=e.EditorResolution||(e.EditorResolution={}));var I;(function(k){k[k.API=0]="API",k[k.USER=1]="USER"})(I=e.EditorOpenSource||(e.EditorOpenSource={}));var A;(function(k){k[k.Center=0]="Center",k[k.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",k[k.NearTop=2]="NearTop",k[k.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(A=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}));var C;(function(k){k.PROGRAMMATIC="api",k.NAVIGATION="code.navigation",k.JUMP="code.jump"})(C=e.TextEditorSelectionSource||(e.TextEditorSelectionSource={}))}),define(ve[183],we([1,0,161]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const i=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,I=/^-(\d{4})(\d{2})(\d{2})$/;function A(v){return v=v.trim(),v==="*"||i.test(v)}e.isValidVersionStr=A;function C(v){if(!A(v))return null;if(v=v.trim(),v==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let b=v.match(i);return b?{hasCaret:b[1]==="^",hasGreaterEquals:b[1]===">=",majorBase:b[2]==="x"?0:parseInt(b[2],10),majorMustEqual:b[2]!=="x",minorBase:b[4]==="x"?0:parseInt(b[4],10),minorMustEqual:b[4]!=="x",patchBase:b[6]==="x"?0:parseInt(b[6],10),patchMustEqual:b[6]!=="x",preRelease:b[8]||null}:null}e.parseVersion=C;function k(v){if(!v)return null;let b=v.majorBase,g=v.majorMustEqual,d=v.minorBase,p=v.minorMustEqual,P=v.patchBase,_=v.patchMustEqual;v.hasCaret&&(b===0||(p=!1),_=!1);let l=0;if(v.preRelease){const c=I.exec(v.preRelease);if(c){const[,u,a,E]=c;l=Date.UTC(Number(u),Number(a)-1,Number(E))}}return{majorBase:b,majorMustEqual:g,minorBase:d,minorMustEqual:p,patchBase:P,patchMustEqual:_,isMinimum:v.hasGreaterEquals,notBefore:l}}e.normalizeVersion=k;function S(v,b,g){let d;typeof v=="string"?d=k(C(v)):d=v;let p;b instanceof Date?p=b.getTime():typeof b=="string"&&(p=new Date(b).getTime());let P;if(typeof g=="string"?P=k(C(g)):P=g,!d||!P)return!1;let _=d.majorBase,l=d.minorBase,c=d.patchBase,u=P.majorBase,a=P.minorBase,E=P.patchBase,s=P.notBefore,t=P.majorMustEqual,r=P.minorMustEqual,n=P.patchMustEqual;return P.isMinimum?_>u?!0:_<u?!1:l>a?!0:l<a||p&&p<s?!1:c>=E:(_===1&&u===0&&(!t||!r||!n)&&(u=1,a=0,E=0,t=!0,r=!1,n=!1),_<u?!1:_>u?!t:l<a?!1:l>a?!r:c<E?!1:c>E?!n:!(p&&p<s))}e.isValidVersion=S;function R(v,b,g,d){return g.isBuiltin||typeof g.main=="undefined"?!0:D(v,b,g.engines.vscode,d)}e.isValidExtensionVersion=R;function F(v,b,g){return v==="*"||D(b,g,v)}e.isEngineValid=F;function D(v,b,g,d=[]){let p=k(C(g));if(!p)return d.push(f.localize(0,null,g)),!1;if(p.majorBase===0){if(!p.majorMustEqual||!p.minorMustEqual)return d.push(f.localize(1,null,g)),!1}else if(!p.majorMustEqual)return d.push(f.localize(2,null,g)),!1;return S(v,b,p)?!0:(d.push(f.localize(3,null,v,g)),!1)}}),define(ve[114],we([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class f{constructor(I,A=[],C=!1){this.ctor=I,this.staticArguments=A,this.supportsDelayedInstantiation=C}}e.SyncDescriptor=f}),define(ve[79],we([1,0,114]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const i=[];function I(C,k,S){k instanceof f.SyncDescriptor||(k=new f.SyncDescriptor(k,[],S)),i.push([C,k])}e.registerSingleton=I;function A(){return i}e.getSingletonServiceDescriptors=A}),define(ve[184],we([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class f{constructor(A){this.incoming=new Map,this.outgoing=new Map,this.data=A}}e.Node=f;class i{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(let C of this._nodes.values())C.outgoing.size===0&&A.push(C);return A}insertEdge(A,C){const k=this.lookupOrInsertNode(A),S=this.lookupOrInsertNode(C);k.outgoing.set(this._hashFn(C),S),S.incoming.set(this._hashFn(A),k)}removeNode(A){const C=this._hashFn(A);this._nodes.delete(C);for(let k of this._nodes.values())k.outgoing.delete(C),k.incoming.delete(C)}lookupOrInsertNode(A){const C=this._hashFn(A);let k=this._nodes.get(C);return k||(k=new f(A),this._nodes.set(C,k)),k}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){let A=[];for(let[C,k]of this._nodes)A.push(`${C}, (incoming)[${[...k.incoming.keys()].join(", ")}], (outgoing)[${[...k.outgoing.keys()].join(",")}]`);return A.join(`
`)}findCycleSlow(){for(let[A,C]of this._nodes){const k=new Set([A]),S=this._findCycle(C,k);if(S)return S}}_findCycle(A,C){for(let[k,S]of A.outgoing){if(C.has(k))return[...C,k].join(" -> ");C.add(k);const R=this._findCycle(S,C);if(R)return R;C.delete(k)}}}e.Graph=i}),define(ve[4],we([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var f;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function k(S){return S[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=k})(f=e._util||(e._util={})),e.IInstantiationService=I("instantiationService");function i(C,k,S){k[f.DI_TARGET]===k?k[f.DI_DEPENDENCIES].push({id:C,index:S}):(k[f.DI_DEPENDENCIES]=[{id:C,index:S}],k[f.DI_TARGET]=k)}function I(C){if(f.serviceIds.has(C))return f.serviceIds.get(C);const k=function(S,R,F){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");i(k,S,F)};return k.toString=()=>C,f.serviceIds.set(C,k),k}e.createDecorator=I;function A(C){return C}e.refineServiceDecorator=A}),define(ve[115],we([1,0,13,2,4]),function(te,e,f,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,I.createDecorator)("configurationService");function A(p){return p&&typeof p=="object"&&(!p.overrideIdentifier||typeof p.overrideIdentifier=="string")&&(!p.resource||p.resource instanceof i.URI)}e.isConfigurationOverrides=A;function C(p){return p&&typeof p=="object"&&(!p.overrideIdentifiers||f.isArray(p.overrideIdentifiers))&&!p.overrideIdentifier&&(!p.resource||p.resource instanceof i.URI)}e.isConfigurationUpdateOverrides=C;var k;(function(p){p[p.USER=1]="USER",p[p.USER_LOCAL=2]="USER_LOCAL",p[p.USER_REMOTE=3]="USER_REMOTE",p[p.WORKSPACE=4]="WORKSPACE",p[p.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",p[p.DEFAULT=6]="DEFAULT",p[p.MEMORY=7]="MEMORY"})(k=e.ConfigurationTarget||(e.ConfigurationTarget={}));function S(p){switch(p){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=S;function R(p,P){const _=Object.create(null);for(let l in p)F(_,l,p[l],P);return _}e.toValuesTree=R;function F(p,P,_,l){const c=P.split("."),u=c.pop();let a=p;for(let E=0;E<c.length;E++){let s=c[E],t=a[s];switch(typeof t){case"undefined":t=a[s]=Object.create(null);break;case"object":break;default:l(`Ignoring ${P} as ${c.slice(0,E+1).join(".")} is ${JSON.stringify(t)}`);return}a=t}if(typeof a=="object"&&a!==null)try{a[u]=_}catch{l(`Ignoring ${P} as ${c.join(".")} is ${JSON.stringify(a)}`)}else l(`Ignoring ${P} as ${c.join(".")} is ${JSON.stringify(a)}`)}e.addToValueTree=F;function D(p,P){const _=P.split(".");v(p,_)}e.removeFromValueTree=D;function v(p,P){const _=P.shift();if(P.length===0){delete p[_];return}if(Object.keys(p).indexOf(_)!==-1){const l=p[_];typeof l=="object"&&!Array.isArray(l)&&(v(l,P),Object.keys(l).length===0&&delete p[_])}}function b(p,P,_){function l(a,E){let s=a;for(const t of E){if(typeof s!="object"||s===null)return;s=s[t]}return s}const c=P.split("."),u=l(p,c);return typeof u=="undefined"?_:u}e.getConfigurationValue=b;function g(p,P,_){Object.keys(P).forEach(l=>{l!=="__proto__"&&(l in p?f.isObject(p[l])&&f.isObject(P[l])?g(p[l],P[l],_):_&&(p[l]=P[l]):p[l]=P[l])})}e.merge=g;function d(p,P,_){const l=p.inspect(P),c=p.inspect(_);return typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:l.defaultValue}e.getMigratedSettingValue=d}),define(ve[61],we([1,0,12,8,4]),function(te,e,f,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const A=new Map;A.set("false",!1),A.set("true",!0),A.set("isMac",f.isMacintosh),A.set("isLinux",f.isLinux),A.set("isWindows",f.isWindows),A.set("isWeb",f.isWeb),A.set("isMacNative",f.isMacintosh&&!f.isWeb),A.set("isEdge",f.isEdge),A.set("isFirefox",f.isFirefox),A.set("isChrome",f.isChrome),A.set("isSafari",f.isSafari);const C=Object.prototype.hasOwnProperty;var k;(function(O){O[O.False=0]="False",O[O.True=1]="True",O[O.Defined=2]="Defined",O[O.Not=3]="Not",O[O.Equals=4]="Equals",O[O.NotEquals=5]="NotEquals",O[O.And=6]="And",O[O.Regex=7]="Regex",O[O.NotRegex=8]="NotRegex",O[O.Or=9]="Or",O[O.In=10]="In",O[O.NotIn=11]="NotIn",O[O.Greater=12]="Greater",O[O.GreaterEquals=13]="GreaterEquals",O[O.Smaller=14]="Smaller",O[O.SmallerEquals=15]="SmallerEquals"})(k=e.ContextKeyExprType||(e.ContextKeyExprType={}));class S{static false(){return D.INSTANCE}static true(){return v.INSTANCE}static has(y){return b.create(y)}static equals(y,H){return g.create(y,H)}static notEquals(y,H){return P.create(y,H)}static regex(y,H){return s.create(y,H)}static in(y,H){return d.create(y,H)}static not(y){return _.create(y)}static and(...y){return n.create(y,null)}static or(...y){return o.create(y,null,!0)}static greater(y,H){return c.create(y,H)}static greaterEquals(y,H){return u.create(y,H)}static smaller(y,H){return a.create(y,H)}static smallerEquals(y,H){return E.create(y,H)}static deserialize(y,H=!1){if(!!y)return this._deserializeOrExpression(y,H)}static _deserializeOrExpression(y,H){let M=y.split("||");return o.create(M.map(j=>this._deserializeAndExpression(j,H)),null,!0)}static _deserializeAndExpression(y,H){let M=y.split("&&");return n.create(M.map(j=>this._deserializeOne(j,H)),null)}static _deserializeOne(y,H){if(y=y.trim(),y.indexOf("!=")>=0){let M=y.split("!=");return P.create(M[0].trim(),this._deserializeValue(M[1],H))}if(y.indexOf("==")>=0){let M=y.split("==");return g.create(M[0].trim(),this._deserializeValue(M[1],H))}if(y.indexOf("=~")>=0){let M=y.split("=~");return s.create(M[0].trim(),this._deserializeRegexValue(M[1],H))}if(y.indexOf(" in ")>=0){let M=y.split(" in ");return d.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(y)){const M=y.split(">=");return u.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(y)){const M=y.split(">");return c.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(y)){const M=y.split("<=");return E.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(y)){const M=y.split("<");return a.create(M[0].trim(),M[1].trim())}return/^\!\s*/.test(y)?_.create(y.substr(1).trim()):b.create(y)}static _deserializeValue(y,H){if(y=y.trim(),y==="true")return!0;if(y==="false")return!1;let M=/^'([^']*)'$/.exec(y);return M?M[1].trim():y}static _deserializeRegexValue(y,H){if((0,i.isFalsyOrWhitespace)(y)){if(H)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let M=y.indexOf("/"),j=y.lastIndexOf("/");if(M===j||M<0){if(H)throw new Error(`bad regexp-value '${y}', missing /-enclosure`);return console.warn(`bad regexp-value '${y}', missing /-enclosure`),null}let X=y.slice(M+1,j),$=y[j+1]==="i"?"i":"";try{return new RegExp(X,$)}catch(U){if(H)throw new Error(`bad regexp-value '${y}', parse error: ${U}`);return console.warn(`bad regexp-value '${y}', parse error: ${U}`),null}}}e.ContextKeyExpr=S;function R(O,y){const H=O?O.substituteConstants():void 0,M=y?y.substituteConstants():void 0;return!H&&!M?!0:!H||!M?!1:H.equals(M)}e.expressionsAreEqualWithConstantSubstitution=R;function F(O,y){return O.cmp(y)}class D{constructor(){this.type=0}cmp(y){return this.type-y.type}equals(y){return y.type===this.type}substituteConstants(){return this}evaluate(y){return!1}serialize(){return"false"}keys(){return[]}map(y){return this}negate(){return v.INSTANCE}}e.ContextKeyFalseExpr=D,D.INSTANCE=new D;class v{constructor(){this.type=1}cmp(y){return this.type-y.type}equals(y){return y.type===this.type}substituteConstants(){return this}evaluate(y){return!0}serialize(){return"true"}keys(){return[]}map(y){return this}negate(){return D.INSTANCE}}e.ContextKeyTrueExpr=v,v.INSTANCE=new v;class b{constructor(y,H){this.key=y,this.negated=H,this.type=2}static create(y,H=null){const M=A.get(y);return typeof M=="boolean"?M?v.INSTANCE:D.INSTANCE:new b(y,H)}cmp(y){return y.type!==this.type?this.type-y.type:h(this.key,y.key)}equals(y){return y.type===this.type?this.key===y.key:!1}substituteConstants(){const y=A.get(this.key);return typeof y=="boolean"?y?v.INSTANCE:D.INSTANCE:this}evaluate(y){return!!y.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(y){return y.mapDefined(this.key)}negate(){return this.negated||(this.negated=_.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=b;class g{constructor(y,H,M){this.key=y,this.value=H,this.negated=M,this.type=4}static create(y,H,M=null){if(typeof H=="boolean")return H?b.create(y,M):_.create(y,M);const j=A.get(y);return typeof j=="boolean"?H===(j?"true":"false")?v.INSTANCE:D.INSTANCE:new g(y,H,M)}cmp(y){return y.type!==this.type?this.type-y.type:w(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){const y=A.get(this.key);if(typeof y=="boolean"){const H=y?"true":"false";return this.value===H?v.INSTANCE:D.INSTANCE}return this}evaluate(y){return y.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(y){return y.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=P.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=g;class d{constructor(y,H){this.key=y,this.valueKey=H,this.type=10,this.negated=null}static create(y,H){return new d(y,H)}cmp(y){return y.type!==this.type?this.type-y.type:w(this.key,this.valueKey,y.key,y.valueKey)}equals(y){return y.type===this.type?this.key===y.key&&this.valueKey===y.valueKey:!1}substituteConstants(){return this}evaluate(y){const H=y.getValue(this.valueKey),M=y.getValue(this.key);return Array.isArray(H)?H.indexOf(M)>=0:typeof M=="string"&&typeof H=="object"&&H!==null?C.call(H,M):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(y){return y.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=p.create(this)),this.negated}}e.ContextKeyInExpr=d;class p{constructor(y){this._actual=y,this.type=11}static create(y){return new p(y)}cmp(y){return y.type!==this.type?this.type-y.type:this._actual.cmp(y._actual)}equals(y){return y.type===this.type?this._actual.equals(y._actual):!1}substituteConstants(){return this}evaluate(y){return!this._actual.evaluate(y)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(y){return new p(this._actual.map(y))}negate(){return this._actual}}e.ContextKeyNotInExpr=p;class P{constructor(y,H,M){this.key=y,this.value=H,this.negated=M,this.type=5}static create(y,H,M=null){if(typeof H=="boolean")return H?_.create(y,M):b.create(y,M);const j=A.get(y);return typeof j=="boolean"?H===(j?"true":"false")?D.INSTANCE:v.INSTANCE:new P(y,H,M)}cmp(y){return y.type!==this.type?this.type-y.type:w(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){const y=A.get(this.key);if(typeof y=="boolean"){const H=y?"true":"false";return this.value===H?D.INSTANCE:v.INSTANCE}return this}evaluate(y){return y.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(y){return y.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=g.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=P;class _{constructor(y,H){this.key=y,this.negated=H,this.type=3}static create(y,H=null){const M=A.get(y);return typeof M=="boolean"?M?D.INSTANCE:v.INSTANCE:new _(y,H)}cmp(y){return y.type!==this.type?this.type-y.type:h(this.key,y.key)}equals(y){return y.type===this.type?this.key===y.key:!1}substituteConstants(){const y=A.get(this.key);return typeof y=="boolean"?y?D.INSTANCE:v.INSTANCE:this}evaluate(y){return!y.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(y){return y.mapNot(this.key)}negate(){return this.negated||(this.negated=b.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=_;function l(O,y){if(typeof O=="string"){const H=parseFloat(O);isNaN(H)||(O=H)}return typeof O=="string"||typeof O=="number"?y(O):D.INSTANCE}class c{constructor(y,H,M){this.key=y,this.value=H,this.negated=M,this.type=12}static create(y,H,M=null){return l(H,j=>new c(y,j,M))}cmp(y){return y.type!==this.type?this.type-y.type:w(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){return this}evaluate(y){return typeof this.value=="string"?!1:parseFloat(y.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(y){return y.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=E.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=c;class u{constructor(y,H,M){this.key=y,this.value=H,this.negated=M,this.type=13}static create(y,H,M=null){return l(H,j=>new u(y,j,M))}cmp(y){return y.type!==this.type?this.type-y.type:w(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){return this}evaluate(y){return typeof this.value=="string"?!1:parseFloat(y.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(y){return y.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=a.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=u;class a{constructor(y,H,M){this.key=y,this.value=H,this.negated=M,this.type=14}static create(y,H,M=null){return l(H,j=>new a(y,j,M))}cmp(y){return y.type!==this.type?this.type-y.type:w(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){return this}evaluate(y){return typeof this.value=="string"?!1:parseFloat(y.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(y){return y.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=a;class E{constructor(y,H,M){this.key=y,this.value=H,this.negated=M,this.type=15}static create(y,H,M=null){return l(H,j=>new E(y,j,M))}cmp(y){return y.type!==this.type?this.type-y.type:w(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){return this}evaluate(y){return typeof this.value=="string"?!1:parseFloat(y.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(y){return y.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=c.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=E;class s{constructor(y,H){this.key=y,this.regexp=H,this.type=7,this.negated=null}static create(y,H){return new s(y,H)}cmp(y){if(y.type!==this.type)return this.type-y.type;if(this.key<y.key)return-1;if(this.key>y.key)return 1;const H=this.regexp?this.regexp.source:"",M=y.regexp?y.regexp.source:"";return H<M?-1:H>M?1:0}equals(y){if(y.type===this.type){const H=this.regexp?this.regexp.source:"",M=y.regexp?y.regexp.source:"";return this.key===y.key&&H===M}return!1}substituteConstants(){return this}evaluate(y){let H=y.getValue(this.key);return this.regexp?this.regexp.test(H):!1}serialize(){const y=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${y}`}keys(){return[this.key]}map(y){return y.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=t.create(this)),this.negated}}e.ContextKeyRegexExpr=s;class t{constructor(y){this._actual=y,this.type=8}static create(y){return new t(y)}cmp(y){return y.type!==this.type?this.type-y.type:this._actual.cmp(y._actual)}equals(y){return y.type===this.type?this._actual.equals(y._actual):!1}substituteConstants(){return this}evaluate(y){return!this._actual.evaluate(y)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(y){return new t(this._actual.map(y))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=t;function r(O){let y=null;for(let H=0,M=O.length;H<M;H++){const j=O[H].substituteConstants();if(O[H]!==j&&y===null){y=[];for(let X=0;X<H;X++)y[X]=O[X]}y!==null&&(y[H]=j)}return y===null?O:y}class n{constructor(y,H){this.expr=y,this.negated=H,this.type=6}static create(y,H){return n._normalizeArr(y,H)}cmp(y){if(y.type!==this.type)return this.type-y.type;if(this.expr.length<y.expr.length)return-1;if(this.expr.length>y.expr.length)return 1;for(let H=0,M=this.expr.length;H<M;H++){const j=F(this.expr[H],y.expr[H]);if(j!==0)return j}return 0}equals(y){if(y.type===this.type){if(this.expr.length!==y.expr.length)return!1;for(let H=0,M=this.expr.length;H<M;H++)if(!this.expr[H].equals(y.expr[H]))return!1;return!0}return!1}substituteConstants(){const y=r(this.expr);return y===this.expr?this:n.create(y,this.negated)}evaluate(y){for(let H=0,M=this.expr.length;H<M;H++)if(!this.expr[H].evaluate(y))return!1;return!0}static _normalizeArr(y,H){const M=[];let j=!1;for(const X of y)if(!!X){if(X.type===1){j=!0;continue}if(X.type===0)return D.INSTANCE;if(X.type===6){M.push(...X.expr);continue}M.push(X)}if(M.length===0&&j)return v.INSTANCE;if(M.length!==0){if(M.length===1)return M[0];M.sort(F);for(let X=1;X<M.length;X++)M[X-1].equals(M[X])&&(M.splice(X,1),X--);if(M.length===1)return M[0];for(;M.length>1;){const X=M[M.length-1];if(X.type!==9)break;M.pop();const $=M.pop(),U=M.length===0,q=o.create(X.expr.map(K=>n.create([K,$],null)),null,U);q&&(M.push(q),M.sort(F))}return M.length===1?M[0]:new n(M,H)}}serialize(){return this.expr.map(y=>y.serialize()).join(" && ")}keys(){const y=[];for(let H of this.expr)y.push(...H.keys());return y}map(y){return new n(this.expr.map(H=>H.map(y)),null)}negate(){if(!this.negated){const y=[];for(let H of this.expr)y.push(H.negate());this.negated=o.create(y,this,!0)}return this.negated}}class o{constructor(y,H){this.expr=y,this.negated=H,this.type=9}static create(y,H,M){return o._normalizeArr(y,H,M)}cmp(y){if(y.type!==this.type)return this.type-y.type;if(this.expr.length<y.expr.length)return-1;if(this.expr.length>y.expr.length)return 1;for(let H=0,M=this.expr.length;H<M;H++){const j=F(this.expr[H],y.expr[H]);if(j!==0)return j}return 0}equals(y){if(y.type===this.type){if(this.expr.length!==y.expr.length)return!1;for(let H=0,M=this.expr.length;H<M;H++)if(!this.expr[H].equals(y.expr[H]))return!1;return!0}return!1}substituteConstants(){const y=r(this.expr);return y===this.expr?this:o.create(y,this.negated,!1)}evaluate(y){for(let H=0,M=this.expr.length;H<M;H++)if(this.expr[H].evaluate(y))return!0;return!1}static _normalizeArr(y,H,M){let j=[],X=!1;if(y){for(let $=0,U=y.length;$<U;$++){const q=y[$];if(!!q){if(q.type===0){X=!0;continue}if(q.type===1)return v.INSTANCE;if(q.type===9){j=j.concat(q.expr);continue}j.push(q)}}if(j.length===0&&X)return D.INSTANCE;j.sort(F)}if(j.length!==0){if(j.length===1)return j[0];for(let $=1;$<j.length;$++)j[$-1].equals(j[$])&&(j.splice($,1),$--);if(j.length===1)return j[0];if(M){for(let $=0;$<j.length;$++)for(let U=$+1;U<j.length;U++)T(j[$],j[U])&&(j.splice(U,1),U--);if(j.length===1)return j[0]}return new o(j,H)}}serialize(){return this.expr.map(y=>y.serialize()).join(" || ")}keys(){const y=[];for(let H of this.expr)y.push(...H.keys());return y}map(y){return new o(this.expr.map(H=>H.map(y)),null)}negate(){if(!this.negated){let y=[];for(let H of this.expr)y.push(H.negate());for(;y.length>1;){const H=y.shift(),M=y.shift(),j=[];for(const $ of L(H))for(const U of L(M))j.push(n.create([$,U],null));const X=y.length===0;y.unshift(o.create(j,null,X))}this.negated=y[0]}return this.negated}}class m extends b{constructor(y,H,M){super(y,null);this._defaultValue=H,typeof M=="object"?m._info.push({...M,key:y}):M!==!0&&m._info.push({key:y,description:M,type:H!=null?typeof H:void 0})}static all(){return m._info.values()}bindTo(y){return y.createKey(this.key,this._defaultValue)}getValue(y){return y.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(y){return g.create(this.key,y)}notEqualsTo(y){return P.create(this.key,y)}}e.RawContextKey=m,m._info=[],e.IContextKeyService=(0,I.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function h(O,y){return O<y?-1:O>y?1:0}function w(O,y,H,M){return O<H?-1:O>H?1:y<M?-1:y>M?1:0}function T(O,y){if(y.type===6&&O.type!==9&&O.type!==6){for(const j of y.expr)if(O.equals(j))return!0}const H=O.negate(),M=L(H).concat(L(y));M.sort(F);for(let j=0;j<M.length;j++){const $=M[j].negate();for(let U=j+1;U<M.length;U++){const q=M[U];if($.equals(q))return!0}}return!1}e.implies=T;function L(O){return O.type===9?O.expr:[O]}}),define(ve[185],we([1,0,4]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,f.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,f.refineServiceDecorator)(e.IEnvironmentService)}),define(ve[186],we([1,0,4]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,f.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,f.createDecorator)("externalTerminal")}),define(ve[187],we([1,0,38,10,9,12,93,28,112,162,186]),function(te,e,f,i,I,A,C,k,S,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const D=R.localize(0,null);class v{async getDefaultTerminalForPlatforms(){return{windows:b.getDefaultTerminalWindows(),linux:await d.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class b extends v{openTerminal(c,u){return this.spawnTerminal(f,c,S.getWindowsShell(),u)}spawnTerminal(c,u,a,E){const s=u.windowsExec||b.getDefaultTerminalWindows();E&&E[1]===":"&&(E=E[0].toUpperCase()+E.substr(1));const t=I.basename(s).toLowerCase();if(t==="cmder"||t==="cmder.exe")return c.spawn(s,E?[E]:void 0),Promise.resolve(void 0);const r=["/c","start","/wait"];return s.indexOf(" ")>=0&&r.push('""'),r.push(s),(t==="wt"||t==="wt.exe")&&r.push("-d ."),new Promise((n,o)=>{const m=p(process),h=c.spawn(a,r,{cwd:E,env:m});h.on("error",o),h.on("exit",()=>n())})}runInTerminal(c,u,a,E,s){const t="windowsExec"in s&&s.windowsExec?s.windowsExec:b.getDefaultTerminalWindows();return new Promise((r,n)=>{const o=`"${u} - ${D}"`,m=`""${a.join('" "')}" & pause"`,h=["/c","start",o,"/wait",t,"/c",m],w=Object.assign({},p(process),E);Object.keys(w).filter(O=>w[O]===null).forEach(O=>delete w[O]);const T={cwd:u,env:w,windowsVerbatimArguments:!0};f.spawn(b.CMD,h,T).on("error",O=>{n(P(O))}),r(void 0)})}static getDefaultTerminalWindows(){if(!b._DEFAULT_TERMINAL_WINDOWS){const c=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");b._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${c?"Sysnative":"System32"}\\cmd.exe`}return b._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=b,b.CMD="cmd.exe";class g extends v{openTerminal(c,u){return this.spawnTerminal(f,c,u)}runInTerminal(c,u,a,E,s){const t=s.osxExec||F.DEFAULT_TERMINAL_OSX;return new Promise((r,n)=>{if(t===F.DEFAULT_TERMINAL_OSX||t==="iTerm.app"){const o=t===F.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",h=[i.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${o}.scpt`,te).fsPath,"-t",c||D,"-w",u];for(let L of a)h.push("-a"),h.push(L);if(E){const L=Object.assign({},p(process),E);for(let O in L){const y=L[O];y===null?(h.push("-u"),h.push(O)):(h.push("-e"),h.push(`${O}=${y}`))}}let w="";const T=f.spawn(g.OSASCRIPT,h);T.on("error",L=>{n(P(L))}),T.stderr.on("data",L=>{w+=L.toString()}),T.on("exit",L=>{if(L===0)r(void 0);else if(w){const O=w.split(`
`,1);n(new Error(O[0]))}else n(new Error(R.localize(1,null,o,L)))})}else n(new Error(R.localize(2,null,t)))})}spawnTerminal(c,u,a){const E=u.osxExec||F.DEFAULT_TERMINAL_OSX;return new Promise((s,t)=>{const r=["-a",E];a&&r.push(a);const n=p(process),o=c.spawn("/usr/bin/open",r,{cwd:a,env:n});o.on("error",t),o.on("exit",()=>s())})}}e.MacExternalTerminalService=g,g.OSASCRIPT="/usr/bin/osascript";class d extends v{openTerminal(c,u){return this.spawnTerminal(f,c,u)}runInTerminal(c,u,a,E,s){const t=s.linuxExec?Promise.resolve(s.linuxExec):d.getDefaultTerminalLinuxReady();return new Promise((r,n)=>{let o=[];t.then(m=>{m.indexOf("gnome-terminal")>=0?o.push("-x"):o.push("-e"),o.push("bash"),o.push("-c");const h=`${_(a)}; echo; read -p "${d.WAIT_MESSAGE}" -n1;`;o.push(`''${h}''`);const w=Object.assign({},p(process),E);Object.keys(w).filter(y=>w[y]===null).forEach(y=>delete w[y]);const T={cwd:u,env:w};let L="";const O=f.spawn(m,o,T);O.on("error",y=>{n(P(y))}),O.stderr.on("data",y=>{L+=y.toString()}),O.on("exit",y=>{if(y===0)r(void 0);else if(L){const H=L.split(`
`,1);n(new Error(H[0]))}else n(new Error(R.localize(4,null,m,y)))})})})}static async getDefaultTerminalLinuxReady(){if(!d._DEFAULT_TERMINAL_LINUX_READY)if(!A.isLinux)d._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const c=await k.Promises.exists("/etc/debian_version");d._DEFAULT_TERMINAL_LINUX_READY=new Promise(u=>{c?u("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?u("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?u("konsole"):process.env.COLORTERM?u(process.env.COLORTERM):process.env.TERM?u(process.env.TERM):u("xterm")})}return d._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(c,u,a){const E=u.linuxExec?Promise.resolve(u.linuxExec):d.getDefaultTerminalLinuxReady();return new Promise((s,t)=>{E.then(r=>{const n=p(process),o=c.spawn(r,[],{cwd:a,env:n});o.on("error",t),o.on("exit",()=>s())})})}}e.LinuxExternalTerminalService=d,d.WAIT_MESSAGE=R.localize(3,null);function p(l){const c={...l.env};return(0,C.sanitizeProcessEnvironment)(c),c}function P(l){return"errno"in l&&l.errno==="ENOENT"&&"path"in l&&typeof l.path=="string"?new Error(R.localize(5,null,l.path)):l}function _(l){let c="";for(let u of l)u.indexOf(" ")>=0?c+='"'+u+'"':c+=u,c+=" ";return c}}),define(ve[42],we([1,0,15,24,9,8,13,2,163,4]),function(te,e,f,i,I,A,C,k,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,R.createDecorator)("fileService");function F($){return $.create===!0}e.isFileOpenForWriteOptions=F;var D;(function($){$[$.Unknown=0]="Unknown",$[$.File=1]="File",$[$.Directory=2]="Directory",$[$.SymbolicLink=64]="SymbolicLink"})(D=e.FileType||(e.FileType={}));var v;(function($){$[$.Readonly=1]="Readonly"})(v=e.FilePermission||(e.FilePermission={}));var b;(function($){$[$.FileReadWrite=2]="FileReadWrite",$[$.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",$[$.FileReadStream=16]="FileReadStream",$[$.FileFolderCopy=8]="FileFolderCopy",$[$.PathCaseSensitive=1024]="PathCaseSensitive",$[$.Readonly=2048]="Readonly",$[$.Trash=4096]="Trash",$[$.FileWriteUnlock=8192]="FileWriteUnlock",$[$.FileAtomicRead=16384]="FileAtomicRead"})(b=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function g($){return!!($.capabilities&2)}e.hasReadWriteCapability=g;function d($){return!!($.capabilities&8)}e.hasFileFolderCopyCapability=d;function p($){return!!($.capabilities&4)}e.hasOpenReadWriteCloseCapability=p;function P($){return!!($.capabilities&16)}e.hasFileReadStreamCapability=P;function _($){return g($)?!!($.capabilities&16384):!1}e.hasFileAtomicReadCapability=_;var l;(function($){$.FileExists="EntryExists",$.FileNotFound="EntryNotFound",$.FileNotADirectory="EntryNotADirectory",$.FileIsADirectory="EntryIsADirectory",$.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",$.FileTooLarge="EntryTooLarge",$.FileWriteLocked="EntryWriteLocked",$.NoPermissions="NoPermissions",$.Unavailable="Unavailable",$.Unknown="Unknown"})(l=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class c extends Error{constructor(U,q){super(U);this.code=q}}e.FileSystemProviderError=c;function u($,U){const q=new c($.toString(),U);return E(q,U),q}e.createFileSystemProviderError=u;function a($){return $||u((0,S.localize)(0,null),l.Unknown)}e.ensureFileSystemProviderError=a;function E($,U){return $.name=U?`${U} (FileSystemError)`:"FileSystemError",$}e.markAsFileSystemProviderError=E;function s($){if(!$)return l.Unknown;if($ instanceof c)return $.code;const U=/^(.+) \(FileSystemError\)$/.exec($.name);if(!U)return l.Unknown;switch(U[1]){case l.FileExists:return l.FileExists;case l.FileIsADirectory:return l.FileIsADirectory;case l.FileNotADirectory:return l.FileNotADirectory;case l.FileNotFound:return l.FileNotFound;case l.FileExceedsMemoryLimit:return l.FileExceedsMemoryLimit;case l.FileTooLarge:return l.FileTooLarge;case l.FileWriteLocked:return l.FileWriteLocked;case l.NoPermissions:return l.NoPermissions;case l.Unavailable:return l.Unavailable}return l.Unknown}e.toFileSystemProviderErrorCode=s;function t($){if($ instanceof w)return $.fileOperationResult;switch(s($)){case l.FileNotFound:return 1;case l.FileIsADirectory:return 0;case l.FileNotADirectory:return 10;case l.FileWriteLocked:return 5;case l.NoPermissions:return 6;case l.FileExists:return 4;case l.FileExceedsMemoryLimit:return 9;case l.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=t;var r;(function($){$[$.CREATE=0]="CREATE",$[$.DELETE=1]="DELETE",$[$.MOVE=2]="MOVE",$[$.COPY=3]="COPY",$[$.WRITE=4]="WRITE"})(r=e.FileOperation||(e.FileOperation={}));class n{constructor(U,q,K){this.resource=U,this.operation=q,this.target=K}isOperation(U){return this.operation===U}}e.FileOperationEvent=n;var o;(function($){$[$.UPDATED=0]="UPDATED",$[$.ADDED=1]="ADDED",$[$.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class m{constructor(U,q){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=U;const K=new Map;for(const G of U){const ee=K.get(G.type);switch(ee?ee.push([G.resource,G]):K.set(G.type,[[G.resource,G]]),G.type){case 1:this.rawAdded.push(G.resource);break;case 0:this.rawUpdated.push(G.resource);break;case 2:this.rawDeleted.push(G.resource);break}}for(const[G,ee]of K)switch(G){case 1:this.added=i.TernarySearchTree.forUris(()=>q),this.added.fill(ee);break;case 0:this.updated=i.TernarySearchTree.forUris(()=>q),this.updated.fill(ee);break;case 2:this.deleted=i.TernarySearchTree.forUris(()=>q),this.deleted.fill(ee);break}}contains(U,...q){return this.doContains(U,{includeChildren:!1},...q)}affects(U,...q){return this.doContains(U,{includeChildren:!0},...q)}doContains(U,q,...K){if(!U)return!1;const G=K.length>0;return!!((!G||K.includes(1))&&(this.added?.get(U)||q.includeChildren&&this.added?.findSuperstr(U))||(!G||K.includes(0))&&(this.updated?.get(U)||q.includeChildren&&this.updated?.findSuperstr(U))||(!G||K.includes(2))&&(this.deleted?.findSubstr(U)||q.includeChildren&&this.deleted?.findSuperstr(U)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=m;function h($,U,q){return!$||!U||$===U||U.length>$.length?!1:(U.charAt(U.length-1)!==I.sep&&(U+=I.sep),q?(0,A.startsWithIgnoreCase)($,U):$.indexOf(U)===0)}e.isParent=h;class w extends f.ErrorNoTelemetry{constructor(U,q,K){super(U);this.fileOperationResult=q,this.options=K}}e.FileOperationError=w;class T extends w{constructor(U,q,K){super(U,2,K);this.stat=q}}e.NotModifiedSinceFileOperationError=T;var L;(function($){$[$.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",$[$.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",$[$.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",$[$.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",$[$.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",$[$.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",$[$.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",$[$.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",$[$.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",$[$.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",$[$.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",$[$.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(L=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var O;(function($){$[$.FILE=0]="FILE",$[$.FOLDER=1]="FOLDER",$[$.ROOT_FOLDER=2]="ROOT_FOLDER"})(O=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function y($){if(!(typeof $.size!="number"||typeof $.mtime!="number"))return $.mtime.toString(29)+$.size.toString(31)}e.etag=y;async function H($,U){if(!U.hasProvider(k.URI.from({scheme:$.scheme})))return new Promise(q=>{const K=U.onDidChangeFileSystemProviderRegistrations(G=>{G.scheme===$.scheme&&G.added&&(K.dispose(),q())})})}e.whenProviderRegistered=H,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class M{static formatSize(U){return(0,C.isNumber)(U)||(U=0),U<M.KB?(0,S.localize)(1,null,U.toFixed(0)):U<M.MB?(0,S.localize)(2,null,(U/M.KB).toFixed(2)):U<M.GB?(0,S.localize)(3,null,(U/M.MB).toFixed(2)):U<M.TB?(0,S.localize)(4,null,(U/M.GB).toFixed(2)):(0,S.localize)(5,null,(U/M.TB).toFixed(2))}}e.ByteSize=M,M.KB=1024,M.MB=M.KB*M.KB,M.GB=M.MB*M.KB,M.TB=M.GB*M.KB;var j;(function($){$[$.IA32=0]="IA32",$[$.OTHER=1]="OTHER"})(j=e.Arch||(e.Arch={}));function X($){return{maxFileSize:$===0?300*M.MB:16*M.GB,maxHeapSize:$===0?700*M.MB:2*700*M.MB}}e.getPlatformLimits=X}),define(ve[80],we([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class f{constructor(...I){this._entries=new Map;for(let[A,C]of I)this.set(A,C)}set(I,A){const C=this._entries.get(I);return this._entries.set(I,A),C}has(I){return this._entries.has(I)}get(I){return this._entries.get(I)}}e.ServiceCollection=f}),define(ve[188],we([1,0,16,15,114,184,4,80]),function(te,e,f,i,I,A,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const S=!1;class R extends Error{constructor(g){super("cyclic dependency between services");this.message=g.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${g.toString()}`}}class F{constructor(g=new k.ServiceCollection,d=!1,p){this._activeInstantiations=new Set,this._services=g,this._strict=d,this._parent=p,this._services.set(C.IInstantiationService,this)}createChild(g){return new F(g,this._strict,this)}invokeFunction(g,...d){let p=v.traceInvocation(g),P=!1;try{return g({get:l=>{if(P)throw(0,i.illegalState)("service accessor is only valid during the invocation of its target method");const c=this._getOrCreateServiceInstance(l,p);if(!c)throw new Error(`[invokeFunction] unknown service '${l}'`);return c}},...d)}finally{P=!0,p.stop()}}createInstance(g,...d){let p,P;return g instanceof I.SyncDescriptor?(p=v.traceCreation(g.ctor),P=this._createInstance(g.ctor,g.staticArguments.concat(d),p)):(p=v.traceCreation(g),P=this._createInstance(g,d,p)),p.stop(),P}_createInstance(g,d=[],p){let P=C._util.getServiceDependencies(g).sort((c,u)=>c.index-u.index),_=[];for(const c of P){let u=this._getOrCreateServiceInstance(c.id,p);u||this._throwIfStrict(`[createInstance] ${g.name} depends on UNKNOWN service ${c.id}.`,!1),_.push(u)}let l=P.length>0?P[0].index:d.length;if(d.length!==l){console.warn(`[createInstance] First service dependency of ${g.name} at position ${l+1} conflicts with ${d.length} static arguments`);let c=l-d.length;c>0?d=d.concat(new Array(c)):d=d.slice(0,l)}return new g(...[...d,..._])}_setServiceInstance(g,d){if(this._services.get(g)instanceof I.SyncDescriptor)this._services.set(g,d);else if(this._parent)this._parent._setServiceInstance(g,d);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(g){let d=this._services.get(g);return!d&&this._parent?this._parent._getServiceInstanceOrDescriptor(g):d}_getOrCreateServiceInstance(g,d){let p=this._getServiceInstanceOrDescriptor(g);return p instanceof I.SyncDescriptor?this._safeCreateAndCacheServiceInstance(g,p,d.branch(g,!0)):(d.branch(g,!1),p)}_safeCreateAndCacheServiceInstance(g,d,p){if(this._activeInstantiations.has(g))throw new Error(`illegal state - RECURSIVELY instantiating service '${g}'`);this._activeInstantiations.add(g);try{return this._createAndCacheServiceInstance(g,d,p)}finally{this._activeInstantiations.delete(g)}}_createAndCacheServiceInstance(g,d,p){const P=new A.Graph(c=>c.id.toString());let _=0;const l=[{id:g,desc:d,_trace:p}];for(;l.length;){const c=l.pop();if(P.lookupOrInsertNode(c),_++>1e3)throw new R(P);for(let u of C._util.getServiceDependencies(c.desc.ctor)){let a=this._getServiceInstanceOrDescriptor(u.id);if(a||this._throwIfStrict(`[createInstance] ${g} depends on ${u.id} which is NOT registered.`,!0),a instanceof I.SyncDescriptor){const E={id:u.id,desc:a,_trace:c._trace.branch(u.id,!0)};P.insertEdge(c,E),l.push(E)}}}for(;;){const c=P.roots();if(c.length===0){if(!P.isEmpty())throw new R(P);break}for(const{data:u}of c){if(this._getServiceInstanceOrDescriptor(u.id)instanceof I.SyncDescriptor){const E=this._createServiceInstanceWithOwner(u.id,u.desc.ctor,u.desc.staticArguments,u.desc.supportsDelayedInstantiation,u._trace);this._setServiceInstance(u.id,E)}P.removeNode(u)}}return this._getServiceInstanceOrDescriptor(g)}_createServiceInstanceWithOwner(g,d,p=[],P,_){if(this._services.get(g)instanceof I.SyncDescriptor)return this._createServiceInstance(d,p,P,_);if(this._parent)return this._parent._createServiceInstanceWithOwner(g,d,p,P,_);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}_createServiceInstance(g,d=[],p,P){if(p){const _=new f.IdleValue(()=>this._createInstance(g,d,P));return new Proxy(Object.create(null),{get(l,c){if(c in l)return l[c];let u=_.value,a=u[c];return typeof a!="function"||(a=a.bind(u),l[c]=a),a},set(l,c,u){return _.value[c]=u,!0}})}else return this._createInstance(g,d,P)}_throwIfStrict(g,d){if(d&&console.warn(d),this._strict)throw new Error(g)}}e.InstantiationService=F;var D;(function(b){b[b.Creation=0]="Creation",b[b.Invocation=1]="Invocation",b[b.Branch=2]="Branch"})(D||(D={}));class v{constructor(g,d){this.type=g,this.name=d,this._start=Date.now(),this._dep=[]}static traceInvocation(g){return S?new v(1,g.name||g.toString().substring(0,42).replace(/\n/g,"")):v._None}static traceCreation(g){return S?new v(0,g.name):v._None}branch(g,d){let p=new v(2,g.toString());return this._dep.push([g,d,p]),p}stop(){let g=Date.now()-this._start;v._totals+=g;let d=!1;function p(_,l){let c=[],u=new Array(_+1).join("	");for(const[a,E,s]of l._dep)if(E&&s){d=!0,c.push(`${u}CREATES -> ${a}`);let t=p(_+1,s);t&&c.push(t)}else c.push(`${u}uses -> ${a}`);return c.join(`
`)}let P=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${g.toFixed(2)}ms (grand total ${v._totals.toFixed(2)}ms)`];(g>2||d)&&console.log(P.join(`
`))}}e.Trace=v,v._None=new class extends v{constructor(){super(-1,null)}stop(){}branch(){return this}},v._totals=0}),define(ve[11],we([1,0,49,3,6,12,4]),function(te,e,f,i,I,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,C.createDecorator)("logService"),e.ILoggerService=(0,C.createDecorator)("loggerService");function k(){return new Date().toISOString()}var S;(function(E){E[E.Trace=0]="Trace",E[E.Debug=1]="Debug",E[E.Info=2]="Info",E[E.Warning=3]="Warning",E[E.Error=4]="Error",E[E.Critical=5]="Critical",E[E.Off=6]="Off"})(S=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=S.Info;function R(E,s,t){switch(s){case S.Trace:E.trace(t);break;case S.Debug:E.debug(t);break;case S.Info:E.info(t);break;case S.Warning:E.warn(t);break;case S.Error:E.error(t);break;case S.Critical:E.critical(t);break;default:throw new Error("Invalid log level")}}e.log=R;function F(E){let s="";for(let t=0;t<E.length;t++){let r=E[t];if(typeof r=="object")try{r=JSON.stringify(r)}catch{}s+=(t>0?" ":"")+r}return s}e.format=F;class D extends I.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new i.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(s){this.level!==s&&(this.level=s,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=D;class v extends D{constructor(s){super();this.logAlways=s}checkLogLevel(s){return this.logAlways||this.getLevel()<=s}trace(s,...t){this.checkLogLevel(S.Trace)&&this.log(S.Trace,F([s,...t]))}debug(s,...t){this.checkLogLevel(S.Debug)&&this.log(S.Debug,F([s,...t]))}info(s,...t){this.checkLogLevel(S.Info)&&this.log(S.Info,F([s,...t]))}warn(s,...t){this.checkLogLevel(S.Warning)&&this.log(S.Warning,F([s,...t]))}error(s,...t){if(this.checkLogLevel(S.Error))if(s instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=s.stack,this.log(S.Error,F(r))}else this.log(S.Error,F([s,...t]))}critical(s,...t){this.checkLogLevel(S.Critical)&&this.log(S.Critical,F([s,...t]))}flush(){}}e.AbstractMessageLogger=v;class b extends D{constructor(s=e.DEFAULT_LOG_LEVEL){super();this.setLevel(s),this.useColors=!A.isWindows}trace(s,...t){this.getLevel()<=S.Trace&&(this.useColors?console.log(`[90m[main ${k()}][0m`,s,...t):console.log(`[main ${k()}]`,s,...t))}debug(s,...t){this.getLevel()<=S.Debug&&(this.useColors?console.log(`[90m[main ${k()}][0m`,s,...t):console.log(`[main ${k()}]`,s,...t))}info(s,...t){this.getLevel()<=S.Info&&(this.useColors?console.log(`[90m[main ${k()}][0m`,s,...t):console.log(`[main ${k()}]`,s,...t))}warn(s,...t){this.getLevel()<=S.Warning&&(this.useColors?console.warn(`[93m[main ${k()}][0m`,s,...t):console.warn(`[main ${k()}]`,s,...t))}error(s,...t){this.getLevel()<=S.Error&&(this.useColors?console.error(`[91m[main ${k()}][0m`,s,...t):console.error(`[main ${k()}]`,s,...t))}critical(s,...t){this.getLevel()<=S.Critical&&(this.useColors?console.error(`[90m[main ${k()}][0m`,s,...t):console.error(`[main ${k()}]`,s,...t))}dispose(){}flush(){}}e.ConsoleMainLogger=b;class g extends D{constructor(s=e.DEFAULT_LOG_LEVEL){super();this.setLevel(s)}trace(s,...t){this.getLevel()<=S.Trace&&console.log("%cTRACE","color: #888",s,...t)}debug(s,...t){this.getLevel()<=S.Debug&&console.log("%cDEBUG","background: #eee; color: #888",s,...t)}info(s,...t){this.getLevel()<=S.Info&&console.log("%c INFO","color: #33f",s,...t)}warn(s,...t){this.getLevel()<=S.Warning&&console.log("%c WARN","color: #993",s,...t)}error(s,...t){this.getLevel()<=S.Error&&console.log("%c  ERR","color: #f33",s,...t)}critical(s,...t){this.getLevel()<=S.Critical&&console.log("%cCRITI","background: #f33; color: white",s,...t)}dispose(){}flush(){}}e.ConsoleLogger=g;class d extends D{constructor(s,t=e.DEFAULT_LOG_LEVEL){super();this.adapter=s,this.setLevel(t)}trace(s,...t){this.getLevel()<=S.Trace&&this.adapter.log(S.Trace,[this.extractMessage(s),...t])}debug(s,...t){this.getLevel()<=S.Debug&&this.adapter.log(S.Debug,[this.extractMessage(s),...t])}info(s,...t){this.getLevel()<=S.Info&&this.adapter.log(S.Info,[this.extractMessage(s),...t])}warn(s,...t){this.getLevel()<=S.Warning&&this.adapter.log(S.Warning,[this.extractMessage(s),...t])}error(s,...t){this.getLevel()<=S.Error&&this.adapter.log(S.Error,[this.extractMessage(s),...t])}critical(s,...t){this.getLevel()<=S.Critical&&this.adapter.log(S.Critical,[this.extractMessage(s),...t])}extractMessage(s){return typeof s=="string"?s:(0,f.toErrorMessage)(s,this.getLevel()<=S.Trace)}dispose(){}flush(){}}e.AdapterLogger=d;class p extends D{constructor(s){super();this.logServices=s,s.length&&this.setLevel(s[0].getLevel())}setLevel(s){for(const t of this.logServices)t.setLevel(s);super.setLevel(s)}trace(s,...t){for(const r of this.logServices)r.trace(s,...t)}debug(s,...t){for(const r of this.logServices)r.debug(s,...t)}info(s,...t){for(const r of this.logServices)r.info(s,...t)}warn(s,...t){for(const r of this.logServices)r.warn(s,...t)}error(s,...t){for(const r of this.logServices)r.error(s,...t)}critical(s,...t){for(const r of this.logServices)r.critical(s,...t)}flush(){for(const s of this.logServices)s.flush()}dispose(){for(const s of this.logServices)s.dispose()}}e.MultiplexLogService=p;class P extends I.Disposable{constructor(s){super();this.logger=s,this._register(s)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(s){this.logger.setLevel(s)}getLevel(){return this.logger.getLevel()}trace(s,...t){this.logger.trace(s,...t)}debug(s,...t){this.logger.debug(s,...t)}info(s,...t){this.logger.info(s,...t)}warn(s,...t){this.logger.warn(s,...t)}error(s,...t){this.logger.error(s,...t)}critical(s,...t){this.logger.critical(s,...t)}flush(){this.logger.flush()}}e.LogService=P;class _ extends I.Disposable{constructor(s,t){super();this.logLevel=s,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(t(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(n=>n.setLevel(r))}))}getLogger(s){return this.loggers.get(s.toString())}createLogger(s,t){let r=this.loggers.get(s.toString());return r||(r=this.doCreateLogger(s,t?.always?S.Trace:this.logLevel,t),this.loggers.set(s.toString(),r),t?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(s=>s.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=_;class l{constructor(){this.onDidChangeLogLevel=new i.Emitter().event}setLevel(s){}getLevel(){return S.Info}trace(s,...t){}debug(s,...t){}info(s,...t){}warn(s,...t){}error(s,...t){}critical(s,...t){}dispose(){}flush(){}}e.NullLogService=l;function c(E){if(E.verbose)return S.Trace;if(typeof E.logLevel=="string"){const s=u(E.logLevel.toLowerCase());if(s!==void 0)return s}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=c;function u(E){switch(E){case"trace":return S.Trace;case"debug":return S.Debug;case"info":return S.Info;case"warn":return S.Warning;case"error":return S.Error;case"critical":return S.Critical;case"off":return S.Off}}e.parseLogLevel=u;function a(E){switch(E){case S.Trace:return"trace";case S.Debug:return"debug";case S.Info:return"info";case S.Warning:return"warn";case S.Error:return"error";case S.Critical:return"critical";case S.Off:return"off"}}e.LogLevelToString=a}),define(ve[189],we([1,0,42,11]),function(te,e,f,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function I(k,S,R,F,D){try{const v=await new Promise((g,d)=>{te(["spdlog"],g,d)});v.setFlushOn(i.LogLevel.Trace);const b=await v.createAsyncRotatingLogger(k,S,R,F);return D&&b.clearFormatters(),b}catch(v){console.error(v)}return null}function A(k,S,R){switch(S){case i.LogLevel.Trace:k.trace(R);break;case i.LogLevel.Debug:k.debug(R);break;case i.LogLevel.Info:k.info(R);break;case i.LogLevel.Warning:k.warn(R);break;case i.LogLevel.Error:k.error(R);break;case i.LogLevel.Critical:k.critical(R);break;default:throw new Error("Invalid log level")}}class C extends i.AbstractMessageLogger{constructor(S,R,F,D,v){super();this.buffer=[],this.setLevel(v),this._loggerCreationPromise=this._createSpdLogLogger(S,R,F,D),this._register(this.onDidChangeLogLevel(b=>{this._logger&&this._logger.setLevel(b)}))}async _createSpdLogLogger(S,R,F,D){const v=F?6:1,b=30/v*f.ByteSize.MB,g=await I(S,R,b,v,D);if(g){this._logger=g,this._logger.setLevel(this.getLevel());for(const{level:d,message:p}of this.buffer)A(this._logger,d,p);this.buffer=[]}}log(S,R){this._logger?A(this._logger,S,R):this.getLevel()<=S&&this.buffer.push({level:S,message:R})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=C}),define(ve[116],we([1,0,47,164,4]),function(te,e,f,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var A;(function(S){S[S.Unnecessary=1]="Unnecessary",S[S.Deprecated=2]="Deprecated"})(A=e.MarkerTag||(e.MarkerTag={}));var C;(function(S){S[S.Hint=1]="Hint",S[S.Info=2]="Info",S[S.Warning=4]="Warning",S[S.Error=8]="Error"})(C=e.MarkerSeverity||(e.MarkerSeverity={})),function(S){function R(g,d){return d-g}S.compare=R;const F=Object.create(null);F[S.Error]=(0,i.localize)(0,null),F[S.Warning]=(0,i.localize)(1,null),F[S.Info]=(0,i.localize)(2,null);function D(g){return F[g]||""}S.toString=D;function v(g){switch(g){case f.default.Error:return S.Error;case f.default.Warning:return S.Warning;case f.default.Info:return S.Info;case f.default.Ignore:return S.Hint}}S.fromSeverity=v;function b(g){switch(g){case S.Error:return f.default.Error;case S.Warning:return f.default.Warning;case S.Info:return f.default.Info;case S.Hint:return f.default.Ignore}}S.toSeverity=b}(C=e.MarkerSeverity||(e.MarkerSeverity={}));var k;(function(S){const R="";function F(v){return D(v,!0)}S.makeKey=F;function D(v,b){let g=[R];return v.source?g.push(v.source.replace("\xA6","\\\xA6")):g.push(R),v.code?typeof v.code=="string"?g.push(v.code.replace("\xA6","\\\xA6")):g.push(v.code.value.replace("\xA6","\\\xA6")):g.push(R),v.severity!==void 0&&v.severity!==null?g.push(C.toString(v.severity)):g.push(R),v.message&&b?g.push(v.message.replace("\xA6","\\\xA6")):g.push(R),v.startLineNumber!==void 0&&v.startLineNumber!==null?g.push(v.startLineNumber.toString()):g.push(R),v.startColumn!==void 0&&v.startColumn!==null?g.push(v.startColumn.toString()):g.push(R),v.endLineNumber!==void 0&&v.endLineNumber!==null?g.push(v.endLineNumber.toString()):g.push(R),v.endColumn!==void 0&&v.endColumn!==null?g.push(v.endColumn.toString()):g.push(R),g.push(R),g.join("\xA6")}S.makeKeyOptionalMessage=D})(k=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,I.createDecorator)("markerService")}),define(ve[190],we([1,0,3,47,4]),function(te,e,f,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=i.default,e.INotificationService=(0,I.createDecorator)("notificationService");var A;(function(R){R[R.WORKSPACE=0]="WORKSPACE",R[R.GLOBAL=1]="GLOBAL"})(A=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var C;(function(R){R[R.OFF=0]="OFF",R[R.SILENT=1]="SILENT",R[R.ERROR=2]="ERROR"})(C=e.NotificationsFilter||(e.NotificationsFilter={}));class k{constructor(){this.progress=new S,this.onDidClose=f.Event.None,this.onDidChangeVisibility=f.Event.None}updateSeverity(F){}updateMessage(F){}updateActions(F){}close(){}}e.NoOpNotification=k;class S{infinite(){}done(){}total(F){}worked(F){}}e.NoOpProgress=S}),define(ve[117],we([1,0,6,8,2,4]),function(te,e,f,i,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,A.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return f.Disposable.None},registerValidator(){return f.Disposable.None},registerExternalUriResolver(){return f.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return f.Disposable.None},async open(){return!1},async resolveExternalUri(F){return{resolved:F,dispose(){}}}});function C(F,D){return I.URI.isUri(F)?(0,i.equalsIgnoreCase)(F.scheme,D):(0,i.startsWithIgnoreCase)(F,D+":")}e.matchesScheme=C;function k(F,...D){return D.some(v=>C(F,v))}e.matchesSomeScheme=k;function S(F,D){return F.with({fragment:`${D.startLineNumber},${D.startColumn}${D.endLineNumber?`-${D.endLineNumber}${D.endColumn?`,${D.endColumn}`:""}`:""}`})}e.withSelection=S;function R(F){let D;const v=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(F.fragment);return v&&(D={startLineNumber:parseInt(v[1]),startColumn:v[2]?parseInt(v[2]):1,endLineNumber:v[4]?parseInt(v[4]):void 0,endColumn:v[4]?v[5]?parseInt(v[5]):1:void 0},F=F.with({fragment:""})),{selection:D,uri:F}}e.extractSelection=R}),define(ve[191],we([1,0,10,12,41,23]),function(te,e,f,i,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let C;if(typeof i.globals.vscode!="undefined"&&typeof i.globals.vscode.context!="undefined"){const k=i.globals.vscode.context.configuration();if(k)C=k.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof te?.__$__nodeRequire=="function"){const k=(0,A.dirname)(f.FileAccess.asFileUri("",te));C=te.__$__nodeRequire((0,A.joinPath)(k,"product.json").fsPath);const S=te.__$__nodeRequire((0,A.joinPath)(k,"package.json").fsPath);I.env.VSCODE_DEV&&Object.assign(C,{nameShort:`${C.nameShort} Dev`,nameLong:`${C.nameLong} Dev`,dataFolderName:`${C.dataFolderName}-dev`,serverDataFolderName:C.serverDataFolderName?`${C.serverDataFolderName}-dev`:void 0}),Object.assign(C,{version:S.version})}else C={},Object.keys(C).length===0&&Object.assign(C,{version:"1.65.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=C});var Fe=this&&this.__param||function(te,e){return function(f,i){e(f,i,te)}};define(ve[118],we([1,0,16,21,6,4]),function(te,e,f,i,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,A.createDecorator)("progressService");var C;(function(F){F[F.Explorer=1]="Explorer",F[F.Scm=3]="Scm",F[F.Extensions=5]="Extensions",F[F.Window=10]="Window",F[F.Notification=15]="Notification",F[F.Dialog=20]="Dialog"})(C=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class k{constructor(D){this.callback=D}get value(){return this._value}report(D){this._value=D,this.callback(this._value)}}e.Progress=k,k.None=Object.freeze({report(){}});let S=class extends I.Disposable{constructor(D,v){super();this.deferred=new f.DeferredPromise,v.withProgress(D,b=>(this.reporter=b,this.lastStep&&b.report(this.lastStep),this.deferred.p)),this._register((0,I.toDisposable)(()=>this.deferred.complete()))}report(D){this.reporter?this.reporter.report(D):this.lastStep=D}};S=Be([Fe(1,e.IProgressService)],S),e.UnmanagedProgress=S;class R extends I.Disposable{constructor(D){super();this.progressIndicator=D,this.currentOperationId=0,this.currentOperationDisposables=this._register(new I.DisposableStore)}start(D){this.stop();const v=++this.currentOperationId,b=new i.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{v===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},D),this.currentOperationDisposables.add((0,I.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,I.toDisposable)(()=>b.cancel())),this.currentOperationDisposables.add((0,I.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:v,token:b.token,stop:()=>this.doStop(v),isCurrent:()=>this.currentOperationId===v}}stop(){this.doStop(this.currentOperationId)}doStop(D){this.currentOperationId===D&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=R,e.IEditorProgressService=(0,A.createDecorator)("editorProgressService")}),define(ve[50],we([1,0,55,13]),function(te,e,f,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class I{constructor(){this.data=new Map}add(C,k){f.ok(i.isString(C)),f.ok(i.isObject(k)),f.ok(!this.data.has(C),"There is already an extension with this id"),this.data.set(C,k)}knows(C){return this.data.has(C)}as(C){return this.data.get(C)||null}}e.Registry=new I}),define(ve[192],we([1,0,3,50]),function(te,e,f,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function I(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class A{constructor(){this._onDidChangeSchema=new f.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(S,R){this.schemasById[I(S)]=R,this._onDidChangeSchema.fire(S)}notifySchemaChanged(S){this._onDidChangeSchema.fire(S)}getSchemaContributions(){return{schemas:this.schemasById}}}const C=new A;i.Registry.add(e.Extensions.JSONContribution,C)}),define(ve[119],we([1,0,18,3,13,159,192,50]),function(te,e,f,i,I,A,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var S;(function(c){c.Multiline="multilineText",c.Singleline="singlelineText"})(S=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var R;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.MACHINE=2]="MACHINE",c[c.WINDOW=3]="WINDOW",c[c.RESOURCE=4]="RESOURCE",c[c.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",c[c.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const F=k.Registry.as(C.Extensions.JSONContribution);class D{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new i.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new i.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},F.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(u,a=!0){this.registerConfigurations([u],a)}registerConfigurations(u,a=!0){const E=this.doRegisterConfigurations(u,a);F.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:E})}deregisterConfigurations(u){const a=this.doDeregisterConfigurations(u);F.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a})}updateConfigurations({add:u,remove:a}){const E=[];E.push(...this.doDeregisterConfigurations(a)),E.push(...this.doRegisterConfigurations(u,!1)),F.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,f.distinct)(E)})}registerDefaultConfigurations(u){const a=[],E=[];for(const{overrides:s,source:t}of u)for(const r in s)if(a.push(r),e.OVERRIDE_PROPERTY_REGEX.test(r)){const n={...this.configurationDefaultsOverrides.get(r)?.value||{},...s[r]};this.configurationDefaultsOverrides.set(r,{source:t,value:n});const o={type:"object",default:n,description:A.localize(1,null,r),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:n,source:I.isString(t)?void 0:t};E.push(...g(r)),this.configurationProperties[r]=o,this.defaultLanguageConfigurationOverridesNode.properties[r]=o}else{this.configurationDefaultsOverrides.set(r,{value:s[r],source:t});const n=this.configurationProperties[r];n&&(this.updatePropertyDefaultValue(r,n),this.updateSchema(r,n))}this.registerOverrideIdentifiers(E),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a,defaultsOverrides:!0})}deregisterDefaultConfigurations(u){const a=[];for(const{overrides:E,source:s}of u)for(const t in E){const r=this.configurationDefaultsOverrides.get(t),n=I.isString(s)?s:s?.id,o=I.isString(r?.source)?r?.source:r?.source?.id;if(n===o)if(a.push(t),this.configurationDefaultsOverrides.delete(t),e.OVERRIDE_PROPERTY_REGEX.test(t))delete this.configurationProperties[t],delete this.defaultLanguageConfigurationOverridesNode.properties[t];else{const m=this.configurationProperties[t];m&&(this.updatePropertyDefaultValue(t,m),this.updateSchema(t,m))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...u){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(u){for(const a of u)this.overrideIdentifiers.add(a);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(u,a){const E=[];return u.forEach(s=>{E.push(...this.validateAndRegisterProperties(s,a,s.extensionInfo,s.restrictedProperties)),this.configurationContributors.push(s),this.registerJSONConfiguration(s)}),E}doDeregisterConfigurations(u){const a=[],E=s=>{if(s.properties)for(const t in s.properties)a.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,s.properties[t]);s.allOf&&s.allOf.forEach(t=>E(t))};for(const s of u){E(s);const t=this.configurationContributors.indexOf(s);t!==-1&&this.configurationContributors.splice(t,1)}return a}validateAndRegisterProperties(u,a=!0,E,s,t=3){t=I.isUndefinedOrNull(u.scope)?t:u.scope;let r=[],n=u.properties;if(n)for(let m in n){if(a&&_(m)){delete n[m];continue}const h=n[m];if(h.source=E,h.defaultDefaultValue=n[m].default,this.updatePropertyDefaultValue(m,h),e.OVERRIDE_PROPERTY_REGEX.test(m)?h.scope=void 0:(h.scope=I.isUndefinedOrNull(h.scope)?t:h.scope,h.restricted=I.isUndefinedOrNull(h.restricted)?!!s?.includes(m):h.restricted),n[m].hasOwnProperty("included")&&!n[m].included){this.excludedConfigurationProperties[m]=n[m],delete n[m];continue}else this.configurationProperties[m]=n[m];!n[m].deprecationMessage&&n[m].markdownDeprecationMessage&&(n[m].deprecationMessage=n[m].markdownDeprecationMessage),r.push(m)}let o=u.allOf;if(o)for(let m of o)r.push(...this.validateAndRegisterProperties(m,a,E,s,t));return r}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(u){const a=E=>{let s=E.properties;if(s)for(const r in s)this.updateSchema(r,s[r]);let t=E.allOf;t&&t.forEach(a)};a(u)}updateSchema(u,a){switch(e.allSettings.properties[u]=a,a.scope){case 1:e.applicationSettings.properties[u]=a;break;case 2:e.machineSettings.properties[u]=a;break;case 6:e.machineOverridableSettings.properties[u]=a;break;case 3:e.windowSettings.properties[u]=a;break;case 4:e.resourceSettings.properties[u]=a;break;case 5:e.resourceSettings.properties[u]=a,this.resourceLanguageSettingsSchema.properties[u]=a;break}}removeFromSchema(u,a){switch(delete e.allSettings.properties[u],a.scope){case 1:delete e.applicationSettings.properties[u];break;case 2:delete e.machineSettings.properties[u];break;case 6:delete e.machineOverridableSettings.properties[u];break;case 3:delete e.windowSettings.properties[u];break;case 4:case 5:delete e.resourceSettings.properties[u],delete this.resourceLanguageSettingsSchema.properties[u];break}}updateOverridePropertyPatternKey(){for(const u of this.overrideIdentifiers.values()){const a=`[${u}]`,E={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(a,E),e.allSettings.properties[a]=E,e.applicationSettings.properties[a]=E,e.machineSettings.properties[a]=E,e.machineOverridableSettings.properties[a]=E,e.windowSettings.properties[a]=E,e.resourceSettings.properties[a]=E}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const u={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(u,a){const E=this.configurationDefaultsOverrides.get(u);let s=E?.value,t=E?.source;I.isUndefined(s)&&(s=a.defaultDefaultValue,t=void 0),I.isUndefined(s)&&(s=p(a.type)),a.default=s,a.defaultValueSource=t}}const v="\\[([^\\]]+)\\]",b=new RegExp(v,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${v})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function g(c){const u=[];if(e.OVERRIDE_PROPERTY_REGEX.test(c)){let a=b.exec(c);for(;a?.length;){const E=a[1].trim();E&&u.push(E),a=b.exec(c)}}return(0,f.distinct)(u)}e.overrideIdentifiersFromKey=g;function d(c){return c.reduce((u,a)=>`${u}[${a}]`,"")}e.keyFromOverrideIdentifiers=d;function p(c){switch(Array.isArray(c)?c[0]:c){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=p;const P=new D;k.Registry.add(e.Extensions.Configuration,P);function _(c){return c.trim()?e.OVERRIDE_PROPERTY_REGEX.test(c)?A.localize(7,null,c):P.getConfigurationProperties()[c]!==void 0?A.localize(8,null,c):null:A.localize(6,null)}e.validateProperty=_;function l(){const c=[],u=P.getConfigurationProperties();for(const a of Object.keys(u))c.push([a,u[a].scope]);return c.push(["launch",4]),c.push(["task",4]),c}e.getScopes=l}),define(ve[193],we([1,0,18,3,141,6,24,25,13,2,115,119,50]),function(te,e,f,i,I,A,C,k,S,R,F,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class b{constructor(s={},t=[],r=[]){this._contents=s,this._keys=t,this._overrides=r,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(s){return s?(0,F.getConfigurationValue)(this.contents,s):this.contents}getOverrideValue(s,t){const r=this.getContentsForOverrideIdentifer(t);return r?s?(0,F.getConfigurationValue)(r,s):r:void 0}getKeysForOverrideIdentifier(s){const t=[];for(const r of this.overrides)r.identifiers.includes(s)&&t.push(...r.keys);return f.distinct(t)}getAllOverrideIdentifiers(){const s=[];for(const t of this.overrides)s.push(...t.identifiers);return f.distinct(s)}override(s){let t=this.overrideConfigurations.get(s);return t||(t=this.createOverrideConfigurationModel(s),this.overrideConfigurations.set(s,t)),t}merge(...s){const t=k.deepClone(this.contents),r=k.deepClone(this.overrides),n=[...this.keys];for(const o of s){this.mergeContents(t,o.contents);for(const m of o.overrides){const[h]=r.filter(w=>f.equals(w.identifiers,m.identifiers));h?(this.mergeContents(h.contents,m.contents),h.keys.push(...m.keys),h.keys=f.distinct(h.keys)):r.push(k.deepClone(m))}for(const m of o.keys)n.indexOf(m)===-1&&n.push(m)}return new b(t,n,r)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(s){const t=this.getContentsForOverrideIdentifer(s);if(!t||typeof t!="object"||!Object.keys(t).length)return this;let r={};for(const n of f.distinct([...Object.keys(this.contents),...Object.keys(t)])){let o=this.contents[n],m=t[n];m&&(typeof o=="object"&&typeof m=="object"?(o=k.deepClone(o),this.mergeContents(o,m)):o=m),r[n]=o}return new b(r,this.keys,this.overrides)}mergeContents(s,t){for(const r of Object.keys(t)){if(r in s&&S.isObject(s[r])&&S.isObject(t[r])){this.mergeContents(s[r],t[r]);continue}s[r]=k.deepClone(t[r])}}checkAndFreeze(s){return this.isFrozen&&!Object.isFrozen(s)?k.deepFreeze(s):s}getContentsForOverrideIdentifer(s){let t=null,r=null;const n=o=>{o&&(r?this.mergeContents(r,o):r=k.deepClone(o))};for(const o of this.overrides)f.equals(o.identifiers,[s])?t=o.contents:o.identifiers.includes(s)&&n(o.contents);return n(t),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(s,t){this.addKey(s),(0,F.addToValueTree)(this.contents,s,t,r=>{throw new Error(r)})}removeValue(s){this.removeKey(s)&&(0,F.removeFromValueTree)(this.contents,s)}addKey(s){let t=this.keys.length;for(let r=0;r<t;r++)s.indexOf(this.keys[r])===0&&(t=r);this.keys.splice(t,1,s)}removeKey(s){let t=this.keys.indexOf(s);return t!==-1?(this.keys.splice(t,1),!0):!1}}e.ConfigurationModel=b;class g extends b{constructor(s={}){const t=v.Registry.as(D.Extensions.Configuration).getConfigurationProperties(),r=Object.keys(t),n=Object.create(null),o=[];for(const m in t){const h=s[m],w=h!==void 0?h:t[m].default;(0,F.addToValueTree)(n,m,w,T=>console.error(`Conflict in default settings: ${T}`))}for(const m of Object.keys(n))D.OVERRIDE_PROPERTY_REGEX.test(m)&&o.push({identifiers:(0,D.overrideIdentifiersFromKey)(m),keys:Object.keys(n[m]),contents:(0,F.toValuesTree)(n[m],h=>console.error(`Conflict in default settings file: ${h}`))});super(n,r,o)}}e.DefaultConfigurationModel=g;class d{constructor(s){this._name=s,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new b}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(s,t){if(!S.isUndefinedOrNull(s)){const r=this.doParseContent(s);this.parseRaw(r,t)}}reparse(s){this._raw&&this.parseRaw(this._raw,s)}parseRaw(s,t){this._raw=s;const{contents:r,keys:n,overrides:o,restricted:m}=this.doParseRaw(s,t);this._configurationModel=new b(r,n,o),this._restrictedConfigurations=m||[]}doParseContent(s){let t={},r=null,n=[],o=[],m=[];function h(T){Array.isArray(n)?n.push(T):r!==null&&(n[r]=T)}let w={onObjectBegin:()=>{let T={};h(T),o.push(n),n=T,r=null},onObjectProperty:T=>{r=T},onObjectEnd:()=>{n=o.pop()},onArrayBegin:()=>{let T=[];h(T),o.push(n),n=T,r=null},onArrayEnd:()=>{n=o.pop()},onLiteralValue:h,onError:(T,L,O)=>{m.push({error:T,offset:L,length:O})}};if(s)try{I.visit(s,w),t=n[0]||{}}catch(T){console.error(`Error while parsing settings file ${this._name}: ${T}`),this._parseErrors=[T]}return t}doParseRaw(s,t){const r=v.Registry.as(D.Extensions.Configuration).getConfigurationProperties(),n=this.filter(s,r,!0,t);s=n.raw;const o=(0,F.toValuesTree)(s,w=>console.error(`Conflict in settings file ${this._name}: ${w}`)),m=Object.keys(s),h=this.toOverrides(s,w=>console.error(`Conflict in settings file ${this._name}: ${w}`));return{contents:o,keys:m,overrides:h,restricted:n.restricted}}filter(s,t,r,n){if(!n?.scopes&&!n?.skipRestricted)return{raw:s,restricted:[]};const o={},m=[];for(let h in s)if(D.OVERRIDE_PROPERTY_REGEX.test(h)&&r){const w=this.filter(s[h],t,!1,n);o[h]=w.raw,m.push(...w.restricted)}else{const w=t[h],T=w?typeof w.scope!="undefined"?w.scope:3:void 0;w?.restricted&&m.push(h),(T===void 0||n.scopes===void 0||n.scopes.includes(T))&&(n.skipRestricted&&w?.restricted||(o[h]=s[h]))}return{raw:o,restricted:m}}toOverrides(s,t){const r=[];for(const n of Object.keys(s))if(D.OVERRIDE_PROPERTY_REGEX.test(n)){const o={};for(const m in s[n])o[m]=s[n][m];r.push({identifiers:(0,D.overrideIdentifiersFromKey)(n),keys:Object.keys(o),contents:(0,F.toValuesTree)(o,t)})}return r}}e.ConfigurationModelParser=d;class p extends A.Disposable{constructor(s,t,r,n){super();this.userSettingsResource=s,this.scopes=t,this.fileService=n,this._onDidChange=this._register(new i.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new d(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(i.Event.any(i.Event.filter(this.fileService.onDidFilesChange,o=>o.contains(this.userSettingsResource)),i.Event.filter(this.fileService.onDidRunOperation,o=>(o.isOperation(0)||o.isOperation(1)||o.isOperation(4))&&r.isEqual(o.resource,s)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const s=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(s.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new b}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=p;class P{constructor(s,t,r=new b,n=new b,o=new C.ResourceMap,m=new b,h=new C.ResourceMap,w=!0){this._defaultConfiguration=s,this._localUserConfiguration=t,this._remoteUserConfiguration=r,this._workspaceConfiguration=n,this._folderConfigurations=o,this._memoryConfiguration=m,this._memoryConfigurationByResource=h,this._freeze=w,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new C.ResourceMap,this._userConfiguration=null}getValue(s,t,r){return this.getConsolidateConfigurationModel(t,r).getValue(s)}updateValue(s,t,r={}){let n;r.resource?(n=this._memoryConfigurationByResource.get(r.resource),n||(n=new b,this._memoryConfigurationByResource.set(r.resource,n))):n=this._memoryConfiguration,t===void 0?n.removeValue(s):n.setValue(s,t),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(s,t,r){const n=this.getConsolidateConfigurationModel(t,r),o=this.getFolderConfigurationModelForResource(t.resource,r),m=t.resource?this._memoryConfigurationByResource.get(t.resource)||this._memoryConfiguration:this._memoryConfiguration,h=t.overrideIdentifier?this._defaultConfiguration.freeze().override(t.overrideIdentifier).getValue(s):this._defaultConfiguration.freeze().getValue(s),w=t.overrideIdentifier?this.userConfiguration.freeze().override(t.overrideIdentifier).getValue(s):this.userConfiguration.freeze().getValue(s),T=t.overrideIdentifier?this.localUserConfiguration.freeze().override(t.overrideIdentifier).getValue(s):this.localUserConfiguration.freeze().getValue(s),L=t.overrideIdentifier?this.remoteUserConfiguration.freeze().override(t.overrideIdentifier).getValue(s):this.remoteUserConfiguration.freeze().getValue(s),O=r?t.overrideIdentifier?this._workspaceConfiguration.freeze().override(t.overrideIdentifier).getValue(s):this._workspaceConfiguration.freeze().getValue(s):void 0,y=o?t.overrideIdentifier?o.freeze().override(t.overrideIdentifier).getValue(s):o.freeze().getValue(s):void 0,H=t.overrideIdentifier?m.override(t.overrideIdentifier).getValue(s):m.getValue(s),M=n.getValue(s),j=f.distinct(f.flatten(n.overrides.map(X=>X.identifiers))).filter(X=>n.getOverrideValue(s,X)!==void 0);return{defaultValue:h,userValue:w,userLocalValue:T,userRemoteValue:L,workspaceValue:O,workspaceFolderValue:y,memoryValue:H,value:M,default:h!==void 0?{value:this._defaultConfiguration.freeze().getValue(s),override:t.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(s,t.overrideIdentifier):void 0}:void 0,user:w!==void 0?{value:this.userConfiguration.freeze().getValue(s),override:t.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(s,t.overrideIdentifier):void 0}:void 0,userLocal:T!==void 0?{value:this.localUserConfiguration.freeze().getValue(s),override:t.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(s,t.overrideIdentifier):void 0}:void 0,userRemote:L!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(s),override:t.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(s,t.overrideIdentifier):void 0}:void 0,workspace:O!==void 0?{value:this._workspaceConfiguration.freeze().getValue(s),override:t.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(s,t.overrideIdentifier):void 0}:void 0,workspaceFolder:y!==void 0?{value:o?.freeze().getValue(s),override:t.overrideIdentifier?o?.freeze().getOverrideValue(s,t.overrideIdentifier):void 0}:void 0,memory:H!==void 0?{value:m.getValue(s),override:t.overrideIdentifier?m.getOverrideValue(s,t.overrideIdentifier):void 0}:void 0,overrideIdentifiers:j.length?j:void 0}}keys(s){const t=this.getFolderConfigurationModelForResource(void 0,s);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:t?t.freeze().keys:[]}}updateDefaultConfiguration(s){this._defaultConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(s){this._localUserConfiguration=s,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(s){this._remoteUserConfiguration=s,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(s){this._workspaceConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(s,t){this._folderConfigurations.set(s,t),this._foldersConsolidatedConfigurations.delete(s)}deleteFolderConfiguration(s){this.folderConfigurations.delete(s),this._foldersConsolidatedConfigurations.delete(s)}compareAndUpdateDefaultConfiguration(s,t){const r=[];if(!t){const{added:n,updated:o,removed:m}=u(this._defaultConfiguration,s);t=[...n,...o,...m]}for(const n of t)for(const o of(0,D.overrideIdentifiersFromKey)(n)){const m=this._defaultConfiguration.getKeysForOverrideIdentifier(o),h=s.getKeysForOverrideIdentifier(o),w=[...h.filter(T=>m.indexOf(T)===-1),...m.filter(T=>h.indexOf(T)===-1),...m.filter(T=>!k.equals(this._defaultConfiguration.override(o).getValue(T),s.override(o).getValue(T)))];r.push([o,w])}return this.updateDefaultConfiguration(s),{keys:t,overrides:r}}compareAndUpdateLocalUserConfiguration(s){const{added:t,updated:r,removed:n,overrides:o}=u(this.localUserConfiguration,s),m=[...t,...r,...n];return m.length&&this.updateLocalUserConfiguration(s),{keys:m,overrides:o}}compareAndUpdateRemoteUserConfiguration(s){const{added:t,updated:r,removed:n,overrides:o}=u(this.remoteUserConfiguration,s);let m=[...t,...r,...n];return m.length&&this.updateRemoteUserConfiguration(s),{keys:m,overrides:o}}compareAndUpdateWorkspaceConfiguration(s){const{added:t,updated:r,removed:n,overrides:o}=u(this.workspaceConfiguration,s);let m=[...t,...r,...n];return m.length&&this.updateWorkspaceConfiguration(s),{keys:m,overrides:o}}compareAndUpdateFolderConfiguration(s,t){const r=this.folderConfigurations.get(s),{added:n,updated:o,removed:m,overrides:h}=u(r,t);let w=[...n,...o,...m];return(w.length||!r)&&this.updateFolderConfiguration(s,t),{keys:w,overrides:h}}compareAndDeleteFolderConfiguration(s){const t=this.folderConfigurations.get(s);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:r,updated:n,removed:o,overrides:m}=u(t,void 0);return{keys:[...r,...n,...o],overrides:m}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(s,t){let r=this.getConsolidatedConfigurationModelForResource(s,t);return s.overrideIdentifier?r.override(s.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:s},t){let r=this.getWorkspaceConsolidatedConfiguration();if(t&&s){const n=t.getFolder(s);n&&(r=this.getFolderConsolidatedConfiguration(n.uri)||r);const o=this._memoryConfigurationByResource.get(s);o&&(r=r.merge(o))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(s){let t=this._foldersConsolidatedConfigurations.get(s);if(!t){const r=this.getWorkspaceConsolidatedConfiguration(),n=this._folderConfigurations.get(s);n?(t=r.merge(n),this._freeze&&(t=t.freeze()),this._foldersConsolidatedConfigurations.set(s,t)):t=r}return t}getFolderConfigurationModelForResource(s,t){if(t&&s){const r=t.getFolder(s);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((s,t)=>{const{contents:r,overrides:n,keys:o}=this._folderConfigurations.get(t);return s.push([t,{contents:r,overrides:n,keys:o}]),s},[])}}allKeys(){const s=new Set;return this._defaultConfiguration.freeze().keys.forEach(t=>s.add(t)),this.userConfiguration.freeze().keys.forEach(t=>s.add(t)),this._workspaceConfiguration.freeze().keys.forEach(t=>s.add(t)),this._folderConfigurations.forEach(t=>t.freeze().keys.forEach(r=>s.add(r))),[...s.values()]}allOverrideIdentifiers(){const s=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>s.add(t)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>s.add(t)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>s.add(t)),this._folderConfigurations.forEach(t=>t.freeze().getAllOverrideIdentifiers().forEach(r=>s.add(r))),[...s.values()]}getAllKeysForOverrideIdentifier(s){const t=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(s).forEach(r=>t.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(r=>t.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(s).forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(s).forEach(n=>t.add(n))),[...t.values()]}static parse(s){const t=this.parseConfigurationModel(s.defaults),r=this.parseConfigurationModel(s.user),n=this.parseConfigurationModel(s.workspace),o=s.folders.reduce((m,h)=>(m.set(R.URI.revive(h[0]),this.parseConfigurationModel(h[1])),m),new C.ResourceMap);return new P(t,r,new b,n,o,new b,new C.ResourceMap,!1)}static parseConfigurationModel(s){return new b(s.contents,s.keys,s.overrides).freeze()}}e.Configuration=P;function _(...E){if(E.length===0)return{keys:[],overrides:[]};if(E.length===1)return E[0];const s=new Set,t=new Map;for(const n of E)n.keys.forEach(o=>s.add(o)),n.overrides.forEach(([o,m])=>{const h=(0,C.getOrSet)(t,o,new Set);m.forEach(w=>h.add(w))});const r=[];return t.forEach((n,o)=>r.push([o,[...n.values()]])),{keys:[...s.values()],overrides:r}}e.mergeChanges=_;class l{constructor(s,t,r,n){this.change=s,this.previous=t,this.currentConfiguraiton=r,this.currentWorkspace=n,this._previousConfiguration=void 0;const o=new Set;s.keys.forEach(h=>o.add(h)),s.overrides.forEach(([,h])=>h.forEach(w=>o.add(w))),this.affectedKeys=[...o.values()];const m=new b;this.affectedKeys.forEach(h=>m.setValue(h,{})),this.affectedKeysTree=m.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=P.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(s,t){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,s)){if(t){const r=this.previousConfiguration?this.previousConfiguration.getValue(s,t,this.previous?.workspace):void 0,n=this.currentConfiguraiton.getValue(s,t,this.currentWorkspace);return!k.equals(r,n)}return!0}return!1}doesAffectedKeysTreeContains(s,t){let r=(0,F.toValuesTree)({[t]:!0},()=>{}),n;for(;typeof r=="object"&&(n=Object.keys(r)[0]);){if(s=s[n],!s)return!1;r=r[n]}return!0}}e.ConfigurationChangeEvent=l;class c extends l{constructor(s,t,r,n){super({keys:s.allKeys(),overrides:[]},void 0,s,t);this.source=r,this.sourceConfig=n}}e.AllKeysConfigurationChangeEvent=c;function u(E,s){const{added:t,removed:r,updated:n}=a(s,E),o=[],m=E?.getAllOverrideIdentifiers()||[],h=s?.getAllOverrideIdentifiers()||[];if(s){const w=h.filter(T=>!m.includes(T));for(const T of w)o.push([T,s.getKeysForOverrideIdentifier(T)])}if(E){const w=m.filter(T=>!h.includes(T));for(const T of w)o.push([T,E.getKeysForOverrideIdentifier(T)])}if(s&&E){for(const w of m)if(h.includes(w)){const T=a({contents:E.getOverrideValue(void 0,w)||{},keys:E.getKeysForOverrideIdentifier(w)},{contents:s.getOverrideValue(void 0,w)||{},keys:s.getKeysForOverrideIdentifier(w)});o.push([w,[...T.added,...T.removed,...T.updated]])}}return{added:t,removed:r,updated:n,overrides:o}}function a(E,s){const t=E?s?E.keys.filter(o=>s.keys.indexOf(o)===-1):[...E.keys]:[],r=s?E?s.keys.filter(o=>E.keys.indexOf(o)===-1):[...s.keys]:[],n=[];if(E&&s){for(const o of s.keys)if(E.keys.indexOf(o)!==-1){const m=(0,F.getConfigurationValue)(s.contents,o),h=(0,F.getConfigurationValue)(E.contents,o);k.equals(m,h)||n.push(o)}}return{added:t,removed:r,updated:n}}}),define(ve[120],we([1,0,4]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,f.createDecorator)("remoteAuthorityResolverService");var i;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound"})(i=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class I extends Error{constructor(C,k=i.Unknown,S){super(C);this._message=C,this._code=k,this._detail=S,this.isHandled=k===i.NotAvailable&&S===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,I.prototype)}static isTemporarilyNotAvailable(C){return C instanceof I&&C._code===i.TemporarilyNotAvailable}static isNoResolverFound(C){return C instanceof I&&C._code===i.NoResolverFound}static isHandled(C){return C instanceof I&&C.isHandled}}e.RemoteAuthorityResolverError=I}),define(ve[121],we([1,0,10]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteName=e.getRemoteAuthority=void 0;function i(A){return A.scheme===f.Schemas.vscodeRemote?A.authority:void 0}e.getRemoteAuthority=i;function I(A){if(!A)return;const C=A.indexOf("+");return C<0?A:A.substr(0,C)}e.getRemoteName=I}),define(ve[27],we([1,0,8,4,121]),function(te,e,f,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function A(v){if(typeof v=="object"&&v!==null&&v.supported!==!0)return v.description}e.getWorkspaceSupportTypeMessage=A;function C(v){return v&&typeof v=="object"&&typeof v.id=="string"&&(!v.uuid||typeof v.uuid=="string")}e.isIExtensionIdentifier=C,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var k;(function(v){v[v.System=0]="System",v[v.User=1]="User"})(k=e.ExtensionType||(e.ExtensionType={}));class S{constructor(b){this.value=b,this._lower=b.toLowerCase()}static equals(b,g){if(typeof b=="undefined"||b===null)return typeof g=="undefined"||g===null;if(typeof g=="undefined"||g===null)return!1;if(typeof b=="string"||typeof g=="string"){let d=typeof b=="string"?b:b.value,p=typeof g=="string"?g:g.value;return f.equalsIgnoreCase(d,p)}return b._lower===g._lower}static toKey(b){return typeof b=="string"?b.toLowerCase():b._lower}}e.ExtensionIdentifier=S;function R(v){return v.contributes&&v.contributes.localizations?v.contributes.localizations.length>0:!1}e.isLanguagePackExtension=R;function F(v){return v.contributes&&v.contributes.authentication?v.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=F;function D(v,b){if(b){const g=`onResolveRemoteAuthority:${(0,I.getRemoteName)(b)}`;return v.activationEvents?.indexOf(g)!==-1}return!1}e.isResolverExtension=D,e.IBuiltinExtensionsScannerService=(0,i.createDecorator)("IBuiltinExtensionsScannerService")}),define(ve[122],we([1,0,8,27]),function(te,e,f,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function I(g,d){return g.uuid&&d.uuid?g.uuid===d.uuid:g.id===d.id?!0:(0,f.compareIgnoreCase)(g.id,d.id)===0}e.areSameExtensions=I;class A{constructor(d,p){this.version=p,this.id=d.id,this.uuid=d.uuid}key(){return`${this.id}-${this.version}`}equals(d){return d instanceof A?I(this,d)&&this.version===d.version:!1}}e.ExtensionIdentifierWithVersion=A;function C(g,d){return`${g}.${d}`}e.getExtensionId=C;function k(g){return g.toLocaleLowerCase()}e.adoptToGalleryExtensionId=k;function S(g,d){return k(C(g,d))}e.getGalleryExtensionId=S;function R(g,d){const p=[],P=_=>{for(const l of p)if(l.some(c=>I(d(c),d(_))))return l;return null};for(const _ of g){const l=P(_);l?l.push(_):p.push([_])}return p}e.groupByExtension=R;function F(g){return{id:g.identifier.id,name:g.manifest.name,galleryId:null,publisherId:g.publisherId,publisherName:g.manifest.publisher,publisherDisplayName:g.publisherDisplayName,dependencies:g.manifest.extensionDependencies&&g.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=F;function D(g){return{id:g.identifier.id,name:g.name,galleryId:g.identifier.uuid,publisherId:g.publisherId,publisherName:g.publisher,publisherDisplayName:g.publisherDisplayName,isPreReleaseVersion:g.properties.isPreReleaseVersion,dependencies:!!(g.properties.dependencies&&g.properties.dependencies.length>0),...g.telemetryData}}e.getGalleryExtensionTelemetryData=D,e.BetterMergeId=new i.ExtensionIdentifier("pprice.better-merge");function v(g){const d=new Set;if(g.malicious)for(const p of g.malicious)d.add(p.id);return d}e.getMaliciousExtensionsSet=v;function b(g,d){const p=[],P=d.manifest.extensionDependencies?.slice(0)??[];for(;P.length;){const _=P.shift();if(_&&p.every(l=>!I(l.identifier,{id:_}))){const l=g.filter(c=>I(c.identifier,{id:_}));l.length===1&&(p.push(l[0]),P.push(...l[0].manifest.extensionDependencies?.slice(0)??[]))}}return p}e.getExtensionDependencies=b}),define(ve[194],we([1,0,160,122,4]),function(te,e,f,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.getIdAndVersion=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";const A=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function C(u){const a=A.exec(u);return a&&a[1]?[(0,i.adoptToGalleryExtensionId)(a[1]),a[2]]:[(0,i.adoptToGalleryExtensionId)(u),void 0]}e.getIdAndVersion=C;var k;(function(u){u.WIN32_X64="win32-x64",u.WIN32_IA32="win32-ia32",u.WIN32_ARM64="win32-arm64",u.LINUX_X64="linux-x64",u.LINUX_ARM64="linux-arm64",u.LINUX_ARMHF="linux-armhf",u.ALPINE_X64="alpine-x64",u.ALPINE_ARM64="alpine-arm64",u.DARWIN_X64="darwin-x64",u.DARWIN_ARM64="darwin-arm64",u.WEB="web",u.UNIVERSAL="universal",u.UNKNOWN="unknown",u.UNDEFINED="undefined"})(k=e.TargetPlatform||(e.TargetPlatform={}));function S(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=S;function R(u){switch(u){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=R;function F(u,a){switch(u){case 3:return a==="x64"?"win32-x64":a==="ia32"?"win32-ia32":a==="arm64"?"win32-arm64":"unknown";case 2:return a==="x64"?"linux-x64":a==="arm64"?"linux-arm64":a==="arm"?"linux-armhf":"unknown";case"alpine":return a==="x64"?"alpine-x64":a==="arm64"?"alpine-arm64":"unknown";case 1:return a==="x64"?"darwin-x64":a==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=F;function D(u,a){return a==="web"&&!u.includes("web")}e.isNotWebExtensionInWebTargetPlatform=D;function v(u,a,E){return D(a,E)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===E?!0:b(E).includes(u)}e.isTargetPlatformCompatible=v;function b(u){switch(u){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=b;function g(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.isIExtensionIdentifier=g;var d;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(d=e.SortBy||(e.SortBy={}));var p;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(p=e.SortOrder||(e.SortOrder={}));var P;(function(u){u.Install="install",u.Uninstall="uninstall"})(P=e.StatisticType||(e.StatisticType={}));var _;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(_=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,I.createDecorator)("extensionGalleryService");var l;(function(u){u.Unsupported="Unsupported",u.UnsupportedPreRelease="UnsupportedPreRelease",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatiblePreRelease="IncompatiblePreRelease",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Internal="Internal"})(l=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class c extends Error{constructor(a,E){super(a);this.code=E,this.name=E}}e.ExtensionManagementError=c,e.IExtensionManagementService=(0,I.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,I.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,I.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,f.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,f.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,I.createDecorator)("IExtensionManagementCLIService")}),define(ve[195],we([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class f{constructor(){this.validators=new Map}vsda(){return new Promise((I,A)=>te(["vsda"],I,A))}async createNewMessage(I){try{const A=await this.vsda(),C=new A.validator;if(C){const k=String(f._nextId++);return this.validators.set(k,C),{id:k,data:C.createNewMessage(I)}}}catch{}return{id:"",data:I}}async validate(I,A){if(!I.id)return!0;const C=this.validators.get(I.id);if(!C)return!1;this.validators.delete(I.id);try{return C.validate(A)==="ok"}catch{return!1}}async sign(I){try{const A=await this.vsda(),C=new A.signer;if(C)return C.sign(I)}catch{}return I}}e.SignService=f,f._nextId=1}),define(ve[196],we([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class f{constructor(I){this._callback=I,this._terminalBufferMap=new Map}dispose(){for(const I of this._terminalBufferMap.values())I.dispose()}startBuffering(I,A,C=5){let k;return k=A(S=>{const R=typeof S=="string"?S:S.data;let F=this._terminalBufferMap.get(I);if(F){F.data.push(R);return}const D=setTimeout(()=>this.flushBuffer(I),C);F={data:[R],timeoutId:D,dispose:()=>{clearTimeout(D),this.flushBuffer(I),k.dispose()}},this._terminalBufferMap.set(I,F)}),k}stopBuffering(I){const A=this._terminalBufferMap.get(I);A&&A.dispose()}flushBuffer(I){const A=this._terminalBufferMap.get(I);A&&(this._terminalBufferMap.delete(I),this._callback(I,A.data.join("")))}}e.TerminalDataBufferer=f}),define(ve[197],we([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var f;(function(i){i.DARK="dark",i.LIGHT="light",i.HIGH_CONTRAST="hc"})(f=e.ColorScheme||(e.ColorScheme={}))}),define(ve[81],we([1,0,72,3,6,4,50,197]),function(te,e,f,i,I,A,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,A.createDecorator)("themeService");var S;(function(p){function P(_){return _&&typeof _=="object"&&typeof _.id=="string"}p.isThemeColor=P})(S=e.ThemeColor||(e.ThemeColor={}));function R(p){return{id:p}}e.themeColorFromId=R;var F;(function(p){function P(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||S.isThemeColor(t.color))}p.isThemeIcon=P;const _=new RegExp(`^\\$\\((${f.CSSIcon.iconNameExpression}(?:${f.CSSIcon.iconModifierExpression})?)\\)$`);function l(t){const r=_.exec(t);if(!r)return;let[,n]=r;return{id:n}}p.fromString=l;function c(t){return{id:t}}p.fromId=c;function u(t,r){let n=t.id;const o=n.lastIndexOf("~");return o!==-1&&(n=n.substring(0,o)),r&&(n=`${n}~${r}`),{id:n}}p.modify=u;function a(t){const r=t.id.lastIndexOf("~");if(r!==-1)return t.id.substring(r+1)}p.getModifier=a;function E(t,r){return t.id===r.id&&t.color?.id===r.color?.id}p.isEqual=E;function s(t,r){return{id:t.id,color:r?R(r):void 0}}p.asThemeIcon=s,p.asClassNameArray=f.CSSIcon.asClassNameArray,p.asClassName=f.CSSIcon.asClassName,p.asCSSSelector=f.CSSIcon.asCSSSelector})(F=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=f.Codicon.file,e.FolderThemeIcon=f.Codicon.folder;function D(p){switch(p){case k.ColorScheme.DARK:return"vs-dark";case k.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=D,e.Extensions={ThemingContribution:"base.contributions.theming"};class v{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new i.Emitter}onColorThemeChange(P){return this.themingParticipants.push(P),this.onThemingParticipantAddedEmitter.fire(P),(0,I.toDisposable)(()=>{const _=this.themingParticipants.indexOf(P);this.themingParticipants.splice(_,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let b=new v;C.Registry.add(e.Extensions.ThemingContribution,b);function g(p){return b.onColorThemeChange(p)}e.registerThemingParticipant=g;class d extends I.Disposable{constructor(P){super();this.themeService=P,this.theme=P.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(_=>this.onThemeChange(_)))}onThemeChange(P){this.theme=P,this.updateStyles()}updateStyles(){}getColor(P,_){let l=this.theme.getColor(P);return l&&_&&(l=_(l,this.theme)),l?l.toString():null}}e.Themable=d}),define(ve[123],we([1,0,3,12,4,11]),function(te,e,f,i,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,I.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,I.createDecorator)("sharedTunnelsService");var C;(function(g){g.Http="http",g.Https="https"})(C=e.TunnelProtocol||(e.TunnelProtocol={}));var k;(function(g){g.ConstantPrivate="constantPrivate",g.Private="private",g.Public="public"})(k=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var S;(function(g){g[g.Notify=1]="Notify",g[g.OpenBrowser=2]="OpenBrowser",g[g.OpenPreview=3]="OpenPreview",g[g.Silent=4]="Silent",g[g.Ignore=5]="Ignore",g[g.OpenBrowserOnce=6]="OpenBrowserOnce"})(S=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function R(g){if(g.scheme!=="http"&&g.scheme!=="https")return;const d=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(g.authority);if(!!d)return{address:d[1],port:+d[2]}}e.extractLocalHostUriMetaDataForPortMapping=R,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function F(g){return e.LOCALHOST_ADDRESSES.indexOf(g)>=0}e.isLocalhost=F,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function D(g){return e.ALL_INTERFACES_ADDRESSES.indexOf(g)>=0}e.isAllInterfaces=D;function v(g,d){return d?d!==1&&g<1024:!i.isWindows&&g<1024}e.isPortPrivileged=v;let b=class{constructor(d){this.logService=d,this._onTunnelOpened=new f.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new f.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new f.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(d){return this._tunnelProvider=d,d?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(d){this._canElevate=d.elevation,this._privacyOptions=d.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const d=[],p=Array.from(this._tunnels.values());for(let P of p){const _=Array.from(P.values());for(let l of _){const c=await l.value;c&&d.push(c)}}return d}async dispose(){for(const d of this._tunnels.values()){for(const{value:p}of d.values())await p.then(P=>P?.dispose());d.clear()}this._tunnels.clear()}openTunnel(d,p,P,_,l=!1,c=k.Private,u){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${p}:${P} on local port ${_}.`),!d)return;p||(p="localhost");const a=this.retainOrCreateTunnel(d,p,P,_,l,c,u);return a?a.then(E=>{if(!E){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(p,P);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const s=this.makeTunnel(E);return(E.tunnelRemoteHost!==p||E.tunnelRemotePort!==P)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(s),s}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),a)}makeTunnel(d){return{tunnelRemotePort:d.tunnelRemotePort,tunnelRemoteHost:d.tunnelRemoteHost,tunnelLocalPort:d.tunnelLocalPort,localAddress:d.localAddress,privacy:d.privacy,protocol:d.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${d.tunnelRemoteHost}:${d.tunnelRemotePort} `);const p=this._tunnels.get(d.tunnelRemoteHost);if(p){const P=p.get(d.tunnelRemotePort);P&&(P.refcount--,await this.tryDisposeTunnel(d.tunnelRemoteHost,d.tunnelRemotePort,P))}}}}async tryDisposeTunnel(d,p,P){if(P.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${d}:${p}.`);const _=P.value.then(async l=>{l&&(await l.dispose(!0),this._onTunnelClosed.fire({host:l.tunnelRemoteHost,port:l.tunnelRemotePort}))});return this._tunnels.has(d)&&this._tunnels.get(d).delete(p),_}}async closeTunnel(d,p){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${d}:${p} `);const P=this._tunnels.get(d);if(P&&P.has(p)){const _=P.get(p);_.refcount=0,await this.tryDisposeTunnel(d,p,_)}}addTunnelToMap(d,p,P){this._tunnels.has(d)||this._tunnels.set(d,new Map),this._tunnels.get(d).set(p,{refcount:1,value:P})}async removeEmptyTunnelFromMap(d,p){const P=this._tunnels.get(d);P&&(await P.get(p)||P.delete(p),P.size===0&&this._tunnels.delete(d))}getTunnelFromMap(d,p){let P=[d];F(d)?(P.push(...e.LOCALHOST_ADDRESSES),P.push(...e.ALL_INTERFACES_ADDRESSES)):D(d)&&P.push(...e.ALL_INTERFACES_ADDRESSES);const _=P.map(l=>this._tunnels.get(l));for(const l of _){const c=l?.get(p);if(c)return c}}canTunnel(d){return!!R(d)}createWithProvider(d,p,P,_,l,c,u){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${p}:${P} on local port ${_}.`);const E={elevationRequired:l?v(_===void 0?P:_):!1},s={remoteAddress:{host:p,port:P},localAddressPort:_,privacy:c,public:c!==k.Private,protocol:u},t=d.forwardPort(s,E);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),t&&this.addTunnelToMap(p,P,t),t}};b=Be([Fe(0,A.ILogService)],b),e.AbstractTunnelService=b}),define(ve[198],we([1,0,10]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function i(k){return k.scheme!==f.Schemas.file&&k.scheme!==f.Schemas.vscodeRemote}e.isVirtualResource=i;function I(k){if(k.folders.length)return k.folders.every(S=>i(S.uri))?k.folders[0].uri:void 0;if(k.configuration&&i(k.configuration))return k.configuration}e.getVirtualWorkspaceLocation=I;function A(k){return I(k)?.scheme}e.getVirtualWorkspaceScheme=A;function C(k){return I(k)!==void 0}e.isVirtualWorkspace=C}),define(ve[43],we([1,0,165,9,24,23,2,4,10]),function(te,e,f,i,I,A,C,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,k.createDecorator)("contextService");function R(s){const t=s;return typeof t?.id=="string"&&C.URI.isUri(t.uri)}e.isSingleFolderWorkspaceIdentifier=R;function F(s){if(s.configuration)return{id:s.id,configPath:s.configuration};if(s.folders.length===1)return{id:s.id,uri:s.folders[0].uri}}e.toWorkspaceIdentifier=F;function D(s){const t=s;return typeof t?.id=="string"&&C.URI.isUri(t.configPath)}e.isWorkspaceIdentifier=D;function v(s){const t=s;if(t?.uri)return{id:t.id,uri:C.URI.revive(t.uri)};const r=s;if(r?.configPath)return{id:r.id,configPath:C.URI.revive(r.configPath)};if(s?.id)return{id:s.id}}e.reviveIdentifier=v;var b;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(b=e.WorkbenchState||(e.WorkbenchState={}));function g(s){const t=s;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&Array.isArray(t.folders))}e.isWorkspace=g;function d(s){const t=s;return!!(t&&typeof t=="object"&&C.URI.isUri(t.uri)&&typeof t.name=="string"&&typeof t.toResource=="function")}e.isWorkspaceFolder=d;class p{constructor(t,r,n,o,m){this._id=t,this._transient=n,this._configuration=o,this._ignorePathCasing=m,this._foldersMap=I.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=r}update(t){this._id=t.id,this._configuration=t.configuration,this._transient=t.transient,this._ignorePathCasing=t._ignorePathCasing,this.folders=t.folders}get folders(){return this._folders}set folders(t){this._folders=t,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(t){this._configuration=t}getFolder(t){return t&&this._foldersMap.findSubstr(t.with({scheme:t.scheme,authority:t.authority,path:t.path}))||null}updateFoldersMap(){this._foldersMap=I.TernarySearchTree.forUris(this._ignorePathCasing);for(const t of this.folders)this._foldersMap.set(t.uri,t)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=p;class P{constructor(t,r){this.raw=r,this.uri=t.uri,this.index=t.index,this.name=t.name}toResource(t){return(0,A.joinPath)(this.uri,t)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=P;function _(s){return new P({uri:s,index:0,name:(0,A.basenameOrAuthority)(s)},{uri:s.toString()})}e.toWorkspaceFolder=_,e.WORKSPACE_EXTENSION="code-workspace";const l=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,f.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function c(s,t){return A.extUriBiasedIgnorePathCase.isEqualOrParent(s,t.untitledWorkspacesHome)}e.isUntitledWorkspace=c;function u(s){let t;return C.URI.isUri(s)?t=s:t=s.configuration,t?.scheme===S.Schemas.tmp}e.isTemporaryWorkspace=u;function a(s,t){return!c(s,t)&&!u(s)}e.isSavedWorkspace=a;function E(s){return(typeof s=="string"?(0,i.extname)(s):(0,A.extname)(s))===l}e.hasWorkspaceFileExtension=E}),define(ve[82],we([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class f{constructor(I){this.id=I,this._data=new Map,this._idPool=1}add(I){const A=this._idPool++;return this._data.set(A,I),this.logDebugInfo(),A}get(I,A){return this._data.has(I)?this._data.get(I)[A]:void 0}delete(I){this._data.delete(I),this.logDebugInfo()}logDebugInfo(){!f.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=f,f.enableDebugLogging=!1}),define(ve[44],we([1,0,10,23,4]),function(te,e,f,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class A{constructor(){this._systemSchemes=new Set(Object.keys(f.Schemas)),this._providerInfo=new Map,this.extUri=new i.ExtUri(k=>{const S=this._providerInfo.get(k.scheme);return!(S===void 0||S&1024)})}$acceptProviderInfos(k,S){S===null?this._providerInfo.delete(k.scheme):this._providerInfo.set(k.scheme,S)}isFreeScheme(k){return!this._providerInfo.has(k)&&!this._systemSchemes.has(k)}getCapabilities(k){return this._providerInfo.get(k)}}e.ExtHostFileSystemInfo=A,e.IExtHostFileSystemInfo=(0,I.createDecorator)("IExtHostFileSystemInfo")}),define(ve[26],we([1,0,4]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,f.createDecorator)("IExtHostInitDataService")}),define(ve[199],we([1,0,16]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class i{constructor(C,k,S){this._deferredPromises=new Map,this._id=C,this._shared=k,this._storage=S,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(R=>(this._value=R,this)),this._storageListener=this._storage.onDidChangeStorage(R=>{R.shared===this._shared&&R.key===this._id&&(this._value=R.value)}),this._scheduler=new f.RunOnceScheduler(()=>{const R=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const F of R.values())F.complete()}catch(F){for(const D of R.values())D.error(F)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,C])=>C!==void 0).map(([C])=>C)}get whenReady(){return this._init}get(C,k){let S=this._value[C];return typeof S=="undefined"&&(S=k),S}update(C,k){this._value[C]=k;let S=this._deferredPromises.get(C);if(S!==void 0)return S.p;const R=new f.DeferredPromise;return this._deferredPromises.set(C,R),this._scheduler.isScheduled()||this._scheduler.schedule(),R.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=i;class I extends i{constructor(C,k){super(C.identifier.value,!0,k);this._extension=C}setKeysForSync(C){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},C)}}e.ExtensionGlobalMemento=I}),define(ve[200],we([1,0,3,2,11]),function(te,e,f,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let A=class{constructor(k,S){this._logService=k,this._notebooksAndEditors=S,this._onDidChangeNotebookDocumentMetadata=new f.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new f.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(k,S,R){this._notebooksAndEditors.getNotebookDocument(i.URI.revive(k)).acceptModelChanged(S.value,R)}$acceptDirtyStateChanged(k,S){this._notebooksAndEditors.getNotebookDocument(i.URI.revive(k)).acceptDirty(S)}$acceptModelSaved(k){const S=this._notebooksAndEditors.getNotebookDocument(i.URI.revive(k));this._onDidSaveNotebookDocument.fire(S.apiNotebook)}$acceptDocumentPropertiesChanged(k,S){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",k.path,S);const R=this._notebooksAndEditors.getNotebookDocument(i.URI.revive(k));R.acceptDocumentPropertiesChanged(S),S.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:R.apiNotebook})}};A=Be([Fe(0,I.ILogService)],A),e.ExtHostNotebookDocuments=A}),define(ve[17],we([1,0,4]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,f.createDecorator)("IExtHostRpcService");class i{constructor(A){this.getProxy=A.getProxy.bind(A),this.set=A.set.bind(A),this.assertRegistered=A.assertRegistered.bind(A),this.drain=A.drain.bind(A)}}e.ExtHostRpcService=i});var Xe=this&&this.__classPrivateFieldSet||function(te,e,f,i,I){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!I:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?I.call(te,f):I?I.value=f:e.set(te,f),f},Pe=this&&this.__classPrivateFieldGet||function(te,e,f,i){if(f==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!i:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?i:f==="a"?i.call(te):i?i.value:e.get(te)};define(ve[201],we([1,0,27,3]),function(te,e,f,i){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class A{constructor(k,S){I.set(this,void 0),this._onDidChange=new i.Emitter,this.onDidChange=this._onDidChange.event,this._id=f.ExtensionIdentifier.toKey(k.identifier),Xe(this,I,S,"f"),Pe(this,I,"f").onDidChangePassword(R=>{R.extensionId===this._id&&this._onDidChange.fire({key:R.key})})}get(k){return Pe(this,I,"f").get(this._id,k)}store(k,S){return Pe(this,I,"f").store(this._id,k,S)}delete(k){return Pe(this,I,"f").delete(this._id,k)}}e.ExtensionSecrets=A,I=new WeakMap}),define(ve[124],we([1,0,4,3]),function(te,e,f,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class I{constructor(){this._onDidChangeTelemetryEnabled=new i.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=new i.Emitter,this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._level=0}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._level>=2,isUsageEnabled:this._level>=3}}$initializeTelemetryLevel(C){this._level=C}$onDidChangeTelemetryLevel(C){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=C,this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails())}}e.ExtHostTelemetry=I,e.IExtHostTelemetry=(0,f.createDecorator)("IExtHostTelemetry")}),define(ve[62],we([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var f;(function(_){_[_.Upsert=0]="Upsert",_[_.RemoveChild=1]="RemoveChild",_[_.Invalidated=2]="Invalidated",_[_.SetProp=3]="SetProp",_[_.Bulk=4]="Bulk"})(f=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const i=new WeakMap,I=(_,l)=>{const c={controllerId:l};return i.set(_,c),c};e.createPrivateApiFor=I;const A=_=>i.get(_);e.getPrivateApiFor=A;const C=(_,l,c,u)=>{let a=c;return{enumerable:!0,configurable:!1,get(){return a},set(E){if(!u(a,E)){const s=a;a=E,_.listener?.({op:3,key:l,value:E,previous:s})}}}},k=(_,l)=>_===l,S={range:(_,l)=>_===l?!0:!_||!l?!1:_.isEqual(l),label:k,description:k,sortText:k,busy:k,error:k,canResolveChildren:k,tags:(_,l)=>!(_.length!==l.length||_.some(c=>!l.find(u=>c.id===u.id)))},R=Object.keys(S),F=(_,l)=>({range:C(_,"range",void 0,S.range),label:C(_,"label",l,S.label),description:C(_,"description",void 0,S.description),sortText:C(_,"sortText",void 0,S.sortText),canResolveChildren:C(_,"canResolveChildren",!1,S.canResolveChildren),busy:C(_,"busy",!1,S.busy),error:C(_,"error",void 0,S.error),tags:C(_,"tags",[],S.tags)}),D=(_,l)=>{const c=new Map;for(const u of R)S[u](_[u],l[u])||c.set(u,l[u]);return c};e.diffTestItems=D;class v extends Error{constructor(l){super(`Attempted to insert a duplicate test item ID ${l}`)}}e.DuplicateTestItemError=v;class b extends Error{constructor(l){super(`TestItem with ID "${l}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=b;class g extends Error{constructor(l,c,u){super(`TestItem with ID "${l}" is from controller "${c}" and cannot be added as a child of an item from controller "${u}".`)}}e.MixedTestItemController=g;const d=_=>{const l=(0,e.getPrivateApiFor)(_);let c=new Map;return{get size(){return c.size},forEach(u,a){for(const E of c.values())u.call(a,E,this)},replace(u){const a=new Map,E=new Set(c.keys()),s={op:4,ops:[]};for(const t of u){if(!(t instanceof p))throw new b(t.id);const r=(0,e.getPrivateApiFor)(t).controllerId;if(r!==l.controllerId)throw new g(t.id,r,l.controllerId);if(a.has(t.id))throw new v(t.id);a.set(t.id,t),E.delete(t.id),s.ops.push({op:0,item:t})}for(const t of E.keys())s.ops.push({op:1,id:t});l.listener?.(s),c=a},add(u){if(!(u instanceof p))throw new b(u.id);c.set(u.id,u),l.listener?.({op:0,item:u})},delete(u){c.delete(u)&&l.listener?.({op:1,id:u})},get(u){return c.get(u)},toJSON(){return Array.from(c.values())},[Symbol.iterator](){return c.values()}}};class p{constructor(l,c,u,a){if(c.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(c)} symbol`);const E=(0,e.createPrivateApiFor)(this,l);Object.defineProperties(this,{id:{value:c,enumerable:!0,writable:!1},uri:{value:a,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return E.parent instanceof P?void 0:E.parent}},children:{value:d(this),enumerable:!0,writable:!1},...F(E,u)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=p;class P extends p{constructor(l,c){super(l,l,c,void 0)}}e.TestItemRootImpl=P}),define(ve[51],we([1,0,4,123,3,17]),function(te,e,f,i,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var C;(function(S){function R(D){return{remoteAddress:D.remoteAddress,localAddress:D.localAddress,public:!!D.public,privacy:D.privacy??(D.public?i.TunnelPrivacyId.Public:i.TunnelPrivacyId.Private),protocol:D.protocol}}S.fromApiTunnel=R;function F(D){return{remoteAddress:{host:D.tunnelRemoteHost,port:D.tunnelRemotePort},localAddress:D.localAddress,public:D.privacy!==i.TunnelPrivacyId.ConstantPrivate&&D.privacy!==i.TunnelPrivacyId.ConstantPrivate,privacy:D.privacy,protocol:D.protocol}}S.fromServiceTunnel=F})(C=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,f.createDecorator)("IExtHostTunnelService");let k=class{constructor(R){this.onDidChangeTunnels=new I.Emitter().event}async $applyCandidateFilter(R){return R}async openTunnel(R,F){}async getTunnels(){return[]}async setTunnelFactory(R){return{dispose:()=>{}}}registerPortsAttributesProvider(R,F){return{dispose:()=>{}}}async $providePortAttributes(R,F,D,v,b){return[]}async $forwardPort(R,F){}async $closeTunnel(R){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};k=Be([Fe(0,A.IExtHostRpcService)],k),e.ExtHostTunnelService=k});var Xe=this&&this.__classPrivateFieldSet||function(te,e,f,i,I){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!I:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?I.call(te,f):I?I.value=f:e.set(te,f),f},Pe=this&&this.__classPrivateFieldGet||function(te,e,f,i){if(f==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!i:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?i:f==="a"?i.call(te):i?i.value:e.get(te)};define(ve[7],we([1,0,18,15,99,24,92,8,13,2,33,42,120]),function(te,e,f,i,I,A,C,k,S,R,F,D,v){"use strict";var b,g,d,p,P,_,l,c,u,a,E,s,t,r,n,o,m,h,w,T;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeDataTransfer=e.TreeDataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function L(Q){function x(){return Reflect.construct(Q,arguments,this.constructor)}return Object.defineProperty(x,"name",Object.getOwnPropertyDescriptor(Q,"name")),Object.setPrototypeOf(x,Q),Object.setPrototypeOf(x.prototype,Q.prototype),x}let O=P=class{constructor(x){b.set(this,void 0),Xe(this,b,x,"f")}static from(...x){let ce=x;return new P(function(){if(ce){for(const De of ce)De&&typeof De.dispose=="function"&&De.dispose();ce=void 0}})}dispose(){typeof Pe(this,b,"f")=="function"&&(Pe(this,b,"f").call(this),Xe(this,b,void 0,"f"))}};b=new WeakMap,O=P=Be([L],O),e.Disposable=O;let y=_=class{constructor(x,ce){if(x<0)throw(0,i.illegalArgument)("line must be non-negative");if(ce<0)throw(0,i.illegalArgument)("character must be non-negative");this._line=x,this._character=ce}static Min(...x){if(x.length===0)throw new TypeError;let ce=x[0];for(let De=1;De<x.length;De++){const Ge=x[De];Ge.isBefore(ce)&&(ce=Ge)}return ce}static Max(...x){if(x.length===0)throw new TypeError;let ce=x[0];for(let De=1;De<x.length;De++){const Ge=x[De];Ge.isAfter(ce)&&(ce=Ge)}return ce}static isPosition(x){if(!x)return!1;if(x instanceof _)return!0;let{line:ce,character:De}=x;return typeof ce=="number"&&typeof De=="number"}static of(x){if(x instanceof _)return x;if(this.isPosition(x))return new _(x.line,x.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}isBefore(x){return this._line<x._line?!0:x._line<this._line?!1:this._character<x._character}isBeforeOrEqual(x){return this._line<x._line?!0:x._line<this._line?!1:this._character<=x._character}isAfter(x){return!this.isBeforeOrEqual(x)}isAfterOrEqual(x){return!this.isBefore(x)}isEqual(x){return this._line===x._line&&this._character===x._character}compareTo(x){return this._line<x._line?-1:this._line>x.line?1:this._character<x._character?-1:this._character>x._character?1:0}translate(x,ce=0){if(x===null||ce===null)throw(0,i.illegalArgument)();let De;return typeof x=="undefined"?De=0:typeof x=="number"?De=x:(De=typeof x.lineDelta=="number"?x.lineDelta:0,ce=typeof x.characterDelta=="number"?x.characterDelta:0),De===0&&ce===0?this:new _(this.line+De,this.character+ce)}with(x,ce=this.character){if(x===null||ce===null)throw(0,i.illegalArgument)();let De;return typeof x=="undefined"?De=this.line:typeof x=="number"?De=x:(De=typeof x.line=="number"?x.line:this.line,ce=typeof x.character=="number"?x.character:this.character),De===this.line&&ce===this.character?this:new _(De,ce)}toJSON(){return{line:this.line,character:this.character}}};y=_=Be([L],y),e.Position=y;let H=l=class{constructor(x,ce,De,Ge){let Qe,Ze;if(typeof x=="number"&&typeof ce=="number"&&typeof De=="number"&&typeof Ge=="number"?(Qe=new y(x,ce),Ze=new y(De,Ge)):y.isPosition(x)&&y.isPosition(ce)&&(Qe=y.of(x),Ze=y.of(ce)),!Qe||!Ze)throw new Error("Invalid arguments");Qe.isBefore(Ze)?(this._start=Qe,this._end=Ze):(this._start=Ze,this._end=Qe)}static isRange(x){return x instanceof l?!0:x?y.isPosition(x.start)&&y.isPosition(x.end):!1}static of(x){if(x instanceof l)return x;if(this.isRange(x))return new l(x.start,x.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}contains(x){return l.isRange(x)?this.contains(x.start)&&this.contains(x.end):y.isPosition(x)?!(y.of(x).isBefore(this._start)||this._end.isBefore(x)):!1}isEqual(x){return this._start.isEqual(x._start)&&this._end.isEqual(x._end)}intersection(x){const ce=y.Max(x.start,this._start),De=y.Min(x.end,this._end);if(!ce.isAfter(De))return new l(ce,De)}union(x){if(this.contains(x))return this;if(x.contains(this))return x;const ce=y.Min(x.start,this._start),De=y.Max(x.end,this.end);return new l(ce,De)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(x,ce=this.end){if(x===null||ce===null)throw(0,i.illegalArgument)();let De;return x?y.isPosition(x)?De=x:(De=x.start||this.start,ce=x.end||this.end):De=this.start,De.isEqual(this._start)&&ce.isEqual(this.end)?this:new l(De,ce)}toJSON(){return[this.start,this.end]}};H=l=Be([L],H),e.Range=H;let M=c=class extends H{constructor(x,ce,De,Ge){let Qe,Ze;if(typeof x=="number"&&typeof ce=="number"&&typeof De=="number"&&typeof Ge=="number"?(Qe=new y(x,ce),Ze=new y(De,Ge)):y.isPosition(x)&&y.isPosition(ce)&&(Qe=y.of(x),Ze=y.of(ce)),!Qe||!Ze)throw new Error("Invalid arguments");super(Qe,Ze);this._anchor=Qe,this._active=Ze}static isSelection(x){return x instanceof c?!0:x?H.isRange(x)&&y.isPosition(x.anchor)&&y.isPosition(x.active)&&typeof x.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};M=c=Be([L],M),e.Selection=M;class j{constructor(x,ce,De){if(typeof x!="string"||x.length===0)throw(0,i.illegalArgument)("host");if(typeof ce!="number"||ce===0||Math.round(ce)!==ce)throw(0,i.illegalArgument)("port");if(typeof De!="undefined"&&(typeof De!="string"||De.length===0||!/^[0-9A-Za-z\-]+$/.test(De)))throw(0,i.illegalArgument)("connectionToken");this.host=x,this.port=Math.round(ce),this.connectionToken=De}}e.ResolvedAuthority=j;class X extends Error{constructor(x,ce=v.RemoteAuthorityResolverErrorCode.Unknown,De){super(x);this._message=x,this._code=ce,this._detail=De,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,X.prototype)}static NotAvailable(x,ce){return new X(x,v.RemoteAuthorityResolverErrorCode.NotAvailable,ce)}static TemporarilyNotAvailable(x){return new X(x,v.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=X;var $;(function(Q){Q[Q.LF=1]="LF",Q[Q.CRLF=2]="CRLF"})($=e.EndOfLine||(e.EndOfLine={}));var U;(function(Q){Q[Q.Replace=1]="Replace",Q[Q.Append=2]="Append",Q[Q.Prepend=3]="Prepend"})(U=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let q=u=class{constructor(x,ce){this._range=x,this._newText=ce}static isTextEdit(x){return x instanceof u?!0:x?H.isRange(x)&&typeof x.newText=="string":!1}static replace(x,ce){return new u(x,ce)}static insert(x,ce){return u.replace(new H(x,x),ce)}static delete(x){return u.replace(x,"")}static setEndOfLine(x){const ce=new u(new H(new y(0,0),new y(0,0)),"");return ce.newEol=x,ce}get range(){return this._range}set range(x){if(x&&!H.isRange(x))throw(0,i.illegalArgument)("range");this._range=x}get newText(){return this._newText||""}set newText(x){if(x&&typeof x!="string")throw(0,i.illegalArgument)("newText");this._newText=x}get newEol(){return this._newEol}set newEol(x){if(x&&typeof x!="number")throw(0,i.illegalArgument)("newEol");this._newEol=x}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};q=u=Be([L],q),e.TextEdit=q;var K;(function(Q){Q[Q.File=1]="File",Q[Q.Text=2]="Text",Q[Q.Cell=3]="Cell",Q[Q.CellReplace=5]="CellReplace"})(K=e.FileEditType||(e.FileEditType={}));let G=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(x,ce,De,Ge){this._edits.push({_type:1,from:x,to:ce,options:De,metadata:Ge})}createFile(x,ce,De){this._edits.push({_type:1,from:void 0,to:x,options:ce,metadata:De})}deleteFile(x,ce,De){this._edits.push({_type:1,from:x,to:void 0,options:ce,metadata:De})}replaceNotebookMetadata(x,ce,De){this._edits.push({_type:3,metadata:De,uri:x,edit:{editType:5,metadata:ce},notebookMetadata:ce})}replaceNotebookCells(x,ce,De,Ge,Qe){let Ze,rt,Dt=[],At;if(Kt.isNotebookRange(ce)&&Oe.isNotebookCellDataArray(De)&&!Oe.isNotebookCellDataArray(Ge)?(Ze=ce.start,rt=ce.end,Dt=De,At=Ge):typeof ce=="number"&&typeof De=="number"&&Oe.isNotebookCellDataArray(Ge)&&(Ze=ce,rt=De,Dt=Ge,At=Qe),Ze===void 0||rt===void 0)throw new Error("Invalid arguments");(Ze!==rt||Dt.length>0)&&this._edits.push({_type:5,uri:x,index:Ze,count:rt-Ze,cells:Dt,metadata:At})}replaceNotebookCellMetadata(x,ce,De,Ge){this._edits.push({_type:3,metadata:Ge,uri:x,edit:{editType:8,index:ce,metadata:De}})}replace(x,ce,De,Ge){this._edits.push({_type:2,uri:x,edit:new q(ce,De),metadata:Ge})}insert(x,ce,De,Ge){this.replace(x,new H(ce,ce),De,Ge)}delete(x,ce,De){this.replace(x,ce,"",De)}has(x){return this._edits.some(ce=>ce._type===2&&ce.uri.toString()===x.toString())}set(x,ce){if(ce)for(const De of ce)De&&this._edits.push({_type:2,uri:x,edit:De});else{for(let De=0;De<this._edits.length;De++){const Ge=this._edits[De];Ge._type===2&&Ge.uri.toString()===x.toString()&&(this._edits[De]=void 0)}(0,f.coalesceInPlace)(this._edits)}}get(x){const ce=[];for(let De of this._edits)De._type===2&&De.uri.toString()===x.toString()&&ce.push(De.edit);return ce}entries(){const x=new A.ResourceMap;for(let ce of this._edits)if(ce._type===2){let De=x.get(ce.uri);De||(De=[ce.uri,[]],x.set(ce.uri,De)),De[1].push(ce.edit)}return[...x.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};G=Be([L],G),e.WorkspaceEdit=G;let ee=a=class{constructor(x){this._tabstop=1,this.value=x||""}static isSnippetString(x){return x instanceof a?!0:x?typeof x.value=="string":!1}static _escape(x){return x.replace(/\$|}|\\/g,"\\$&")}appendText(x){return this.value+=a._escape(x),this}appendTabstop(x=this._tabstop++){return this.value+="$",this.value+=x,this}appendPlaceholder(x,ce=this._tabstop++){if(typeof x=="function"){const De=new a;De._tabstop=this._tabstop,x(De),this._tabstop=De._tabstop,x=De.value}else x=a._escape(x);return this.value+="${",this.value+=ce,this.value+=":",this.value+=x,this.value+="}",this}appendChoice(x,ce=this._tabstop++){const De=x.map(Ge=>Ge.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ce,this.value+="|",this.value+=De,this.value+="|}",this}appendVariable(x,ce){if(typeof ce=="function"){const De=new a;De._tabstop=this._tabstop,ce(De),this._tabstop=De._tabstop,ce=De.value}else typeof ce=="string"&&(ce=ce.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=x,ce&&(this.value+=":",this.value+=ce),this.value+="}",this}};ee=a=Be([L],ee),e.SnippetString=ee;var oe;(function(Q){Q[Q.Unnecessary=1]="Unnecessary",Q[Q.Deprecated=2]="Deprecated"})(oe=e.DiagnosticTag||(e.DiagnosticTag={}));var ue;(function(Q){Q[Q.Hint=3]="Hint",Q[Q.Information=2]="Information",Q[Q.Warning=1]="Warning",Q[Q.Error=0]="Error"})(ue=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let Z=E=class{constructor(x,ce){if(this.uri=x,ce)if(H.isRange(ce))this.range=H.of(ce);else if(y.isPosition(ce))this.range=new H(ce,ce);else throw new Error("Illegal argument")}static isLocation(x){return x instanceof E?!0:x?H.isRange(x.range)&&R.URI.isUri(x.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};Z=E=Be([L],Z),e.Location=Z;let Y=class{constructor(x,ce){this.location=x,this.message=ce}static is(x){return x?typeof x.message=="string"&&x.location&&H.isRange(x.location.range)&&R.URI.isUri(x.location.uri):!1}static isEqual(x,ce){return x===ce?!0:!x||!ce?!1:x.message===ce.message&&x.location.range.isEqual(ce.location.range)&&x.location.uri.toString()===ce.location.uri.toString()}};Y=Be([L],Y),e.DiagnosticRelatedInformation=Y;let se=class{constructor(x,ce,De=ue.Error){if(!H.isRange(x))throw new TypeError("range must be set");if(!ce)throw new TypeError("message must be set");this.range=x,this.message=ce,this.severity=De}toJSON(){return{severity:ue[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(x,ce){return x===ce?!0:!x||!ce?!1:x.message===ce.message&&x.severity===ce.severity&&x.code===ce.code&&x.severity===ce.severity&&x.source===ce.source&&x.range.isEqual(ce.range)&&(0,f.equals)(x.tags,ce.tags)&&(0,f.equals)(x.relatedInformation,ce.relatedInformation,Y.isEqual)}};se=Be([L],se),e.Diagnostic=se;let de=class{constructor(x,ce){if(!x)throw new Error("Illegal argument, contents must be defined");Array.isArray(x)?this.contents=x:this.contents=[x],this.range=ce}};de=Be([L],de),e.Hover=de;var ge;(function(Q){Q[Q.Text=0]="Text",Q[Q.Read=1]="Read",Q[Q.Write=2]="Write"})(ge=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Te=class{constructor(x,ce=ge.Text){this.range=x,this.kind=ce}toJSON(){return{range:this.range,kind:ge[this.kind]}}};Te=Be([L],Te),e.DocumentHighlight=Te;var Ne;(function(Q){Q[Q.File=0]="File",Q[Q.Module=1]="Module",Q[Q.Namespace=2]="Namespace",Q[Q.Package=3]="Package",Q[Q.Class=4]="Class",Q[Q.Method=5]="Method",Q[Q.Property=6]="Property",Q[Q.Field=7]="Field",Q[Q.Constructor=8]="Constructor",Q[Q.Enum=9]="Enum",Q[Q.Interface=10]="Interface",Q[Q.Function=11]="Function",Q[Q.Variable=12]="Variable",Q[Q.Constant=13]="Constant",Q[Q.String=14]="String",Q[Q.Number=15]="Number",Q[Q.Boolean=16]="Boolean",Q[Q.Array=17]="Array",Q[Q.Object=18]="Object",Q[Q.Key=19]="Key",Q[Q.Null=20]="Null",Q[Q.EnumMember=21]="EnumMember",Q[Q.Struct=22]="Struct",Q[Q.Event=23]="Event",Q[Q.Operator=24]="Operator",Q[Q.TypeParameter=25]="TypeParameter"})(Ne=e.SymbolKind||(e.SymbolKind={}));var be;(function(Q){Q[Q.Deprecated=1]="Deprecated"})(be=e.SymbolTag||(e.SymbolTag={}));let Ee=s=class{constructor(x,ce,De,Ge,Qe){this.name=x,this.kind=ce,this.containerName=Qe,typeof De=="string"&&(this.containerName=De),Ge instanceof Z?this.location=Ge:De instanceof H&&(this.location=new Z(Ge,De)),s.validate(this)}static validate(x){if(!x.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Ne[this.kind],location:this.location,containerName:this.containerName}}};Ee=s=Be([L],Ee),e.SymbolInformation=Ee;let z=t=class{constructor(x,ce,De,Ge,Qe){this.name=x,this.detail=ce,this.kind=De,this.range=Ge,this.selectionRange=Qe,this.children=[],t.validate(this)}static validate(x){if(!x.name)throw new Error("name must not be falsy");if(!x.range.contains(x.selectionRange))throw new Error("selectionRange must be contained in fullRange");x.children&&x.children.forEach(t.validate)}};z=t=Be([L],z),e.DocumentSymbol=z;var B;(function(Q){Q[Q.Invoke=1]="Invoke",Q[Q.Automatic=2]="Automatic"})(B=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let N=class{constructor(x,ce){this.title=x,this.kind=ce}};N=Be([L],N),e.CodeAction=N;let W=r=class{constructor(x){this.value=x}append(x){return new r(this.value?this.value+r.sep+x:x)}intersects(x){return this.contains(x)||x.contains(this)}contains(x){return this.value===x.value||x.value.startsWith(this.value+r.sep)}};W.sep=".",W=r=Be([L],W),e.CodeActionKind=W,W.Empty=new W(""),W.QuickFix=W.Empty.append("quickfix"),W.Refactor=W.Empty.append("refactor"),W.RefactorExtract=W.Refactor.append("extract"),W.RefactorInline=W.Refactor.append("inline"),W.RefactorRewrite=W.Refactor.append("rewrite"),W.Source=W.Empty.append("source"),W.SourceOrganizeImports=W.Source.append("organizeImports"),W.SourceFixAll=W.Source.append("fixAll");let V=class{constructor(x,ce){if(this.range=x,this.parent=ce,ce&&!ce.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};V=Be([L],V),e.SelectionRange=V;class re{constructor(x,ce,De,Ge,Qe,Ze){this.kind=x,this.name=ce,this.detail=De,this.uri=Ge,this.range=Qe,this.selectionRange=Ze}}e.CallHierarchyItem=re;class he{constructor(x,ce){this.fromRanges=ce,this.from=x}}e.CallHierarchyIncomingCall=he;class Ce{constructor(x,ce){this.fromRanges=ce,this.to=x}}e.CallHierarchyOutgoingCall=Ce;var Ae;(function(Q){Q[Q.Information=0]="Information",Q[Q.Warning=1]="Warning",Q[Q.Error=2]="Error"})(Ae=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let We=class{constructor(x,ce){this.range=x,this.command=ce}get isResolved(){return!!this.command}};We=Be([L],We),e.CodeLens=We;let ze=n=class{constructor(x,ce=!1){g.set(this,void 0),Xe(this,g,new I.MarkdownString(x,{supportThemeIcons:ce}),"f")}static isMarkdownString(x){return x instanceof n?!0:x&&x.appendCodeblock&&x.appendMarkdown&&x.appendText&&x.value!==void 0}get value(){return Pe(this,g,"f").value}set value(x){Pe(this,g,"f").value=x}get isTrusted(){return Pe(this,g,"f").isTrusted}set isTrusted(x){Pe(this,g,"f").isTrusted=x}get supportThemeIcons(){return Pe(this,g,"f").supportThemeIcons}set supportThemeIcons(x){Pe(this,g,"f").supportThemeIcons=x}get supportHtml(){return Pe(this,g,"f").supportHtml}set supportHtml(x){Pe(this,g,"f").supportHtml=x}get baseUri(){return Pe(this,g,"f").baseUri}set baseUri(x){Pe(this,g,"f").baseUri=x}appendText(x){return Pe(this,g,"f").appendText(x),this}appendMarkdown(x){return Pe(this,g,"f").appendMarkdown(x),this}appendCodeblock(x,ce){return Pe(this,g,"f").appendCodeblock(ce??"",x),this}};g=new WeakMap,ze=n=Be([L],ze),e.MarkdownString=ze;let qe=class{constructor(x,ce){this.label=x,this.documentation=ce}};qe=Be([L],qe),e.ParameterInformation=qe;let He=class{constructor(x,ce){this.label=x,this.documentation=ce,this.parameters=[]}};He=Be([L],He),e.SignatureInformation=He;let Ue=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};Ue=Be([L],Ue),e.SignatureHelp=Ue;var Je;(function(Q){Q[Q.Invoke=1]="Invoke",Q[Q.TriggerCharacter=2]="TriggerCharacter",Q[Q.ContentChange=3]="ContentChange"})(Je=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var et;(function(Q){Q[Q.Type=1]="Type",Q[Q.Parameter=2]="Parameter"})(et=e.InlayHintKind||(e.InlayHintKind={}));let Le=class{constructor(x){this.value=x}};Le=Be([L],Le),e.InlayHintLabelPart=Le;let it=class{constructor(x,ce,De){this.position=x,this.label=ce,this.kind=De}};it=Be([L],it),e.InlayHint=it;var ne;(function(Q){Q[Q.Invoke=0]="Invoke",Q[Q.TriggerCharacter=1]="TriggerCharacter",Q[Q.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ne=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ae;(function(Q){Q[Q.Text=0]="Text",Q[Q.Method=1]="Method",Q[Q.Function=2]="Function",Q[Q.Constructor=3]="Constructor",Q[Q.Field=4]="Field",Q[Q.Variable=5]="Variable",Q[Q.Class=6]="Class",Q[Q.Interface=7]="Interface",Q[Q.Module=8]="Module",Q[Q.Property=9]="Property",Q[Q.Unit=10]="Unit",Q[Q.Value=11]="Value",Q[Q.Enum=12]="Enum",Q[Q.Keyword=13]="Keyword",Q[Q.Snippet=14]="Snippet",Q[Q.Color=15]="Color",Q[Q.File=16]="File",Q[Q.Reference=17]="Reference",Q[Q.Folder=18]="Folder",Q[Q.EnumMember=19]="EnumMember",Q[Q.Constant=20]="Constant",Q[Q.Struct=21]="Struct",Q[Q.Event=22]="Event",Q[Q.Operator=23]="Operator",Q[Q.TypeParameter=24]="TypeParameter",Q[Q.User=25]="User",Q[Q.Issue=26]="Issue"})(ae=e.CompletionItemKind||(e.CompletionItemKind={}));var J;(function(Q){Q[Q.Deprecated=1]="Deprecated"})(J=e.CompletionItemTag||(e.CompletionItemTag={}));let pe=class{constructor(x,ce){this.label=x,this.kind=ce}toJSON(){return{label:this.label,kind:this.kind&&ae[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};pe=Be([L],pe),e.CompletionItem=pe;let Se=class{constructor(x=[],ce=!1){this.items=x,this.isIncomplete=ce}};Se=Be([L],Se),e.CompletionList=Se;let Me=class{constructor(x,ce,De){this.insertText=x,this.range=ce,this.command=De}};Me=Be([L],Me),e.InlineSuggestion=Me;let $e=class{constructor(x){this.items=x}};$e=Be([L],$e),e.InlineSuggestions=$e;var Ye;(function(Q){Q[Q.Active=-1]="Active",Q[Q.Beside=-2]="Beside",Q[Q.One=1]="One",Q[Q.Two=2]="Two",Q[Q.Three=3]="Three",Q[Q.Four=4]="Four",Q[Q.Five=5]="Five",Q[Q.Six=6]="Six",Q[Q.Seven=7]="Seven",Q[Q.Eight=8]="Eight",Q[Q.Nine=9]="Nine"})(Ye=e.ViewColumn||(e.ViewColumn={}));var lt;(function(Q){Q[Q.Left=1]="Left",Q[Q.Right=2]="Right"})(lt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var vt;(function(Q){Q[Q.Off=0]="Off",Q[Q.On=1]="On",Q[Q.Relative=2]="Relative"})(vt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var wt;(function(Q){Q[Q.Manual=1]="Manual",Q[Q.AfterDelay=2]="AfterDelay",Q[Q.FocusOut=3]="FocusOut"})(wt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var je;(function(Q){Q[Q.Default=0]="Default",Q[Q.InCenter=1]="InCenter",Q[Q.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",Q[Q.AtTop=3]="AtTop"})(je=e.TextEditorRevealType||(e.TextEditorRevealType={}));var st;(function(Q){Q[Q.Keyboard=1]="Keyboard",Q[Q.Mouse=2]="Mouse",Q[Q.Command=3]="Command"})(st=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var _t;(function(Q){Q[Q.Undo=1]="Undo",Q[Q.Redo=2]="Redo"})(_t=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var nt;(function(Q){Q[Q.OpenOpen=0]="OpenOpen",Q[Q.ClosedClosed=1]="ClosedClosed",Q[Q.OpenClosed=2]="OpenClosed",Q[Q.ClosedOpen=3]="ClosedOpen"})(nt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(Q){function x(ce){switch(ce){case"keyboard":return Q.Keyboard;case"mouse":return Q.Mouse;case"api":return Q.Command}}Q.fromValue=x}(st=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let ct=class{constructor(x,ce){if(ce&&!R.URI.isUri(ce))throw(0,i.illegalArgument)("target");if(!H.isRange(x)||x.isEmpty)throw(0,i.illegalArgument)("range");this.range=x,this.target=ce}};ct=Be([L],ct),e.DocumentLink=ct;let Rt=class{constructor(x,ce,De,Ge){this.red=x,this.green=ce,this.blue=De,this.alpha=Ge}};Rt=Be([L],Rt),e.Color=Rt;let Tt=class{constructor(x,ce){if(ce&&!(ce instanceof Rt))throw(0,i.illegalArgument)("color");if(!H.isRange(x)||x.isEmpty)throw(0,i.illegalArgument)("range");this.range=x,this.color=ce}};Tt=Be([L],Tt),e.ColorInformation=Tt;let yt=class{constructor(x){if(!x||typeof x!="string")throw(0,i.illegalArgument)("label");this.label=x}};yt=Be([L],yt),e.ColorPresentation=yt;var mt;(function(Q){Q[Q.RGB=0]="RGB",Q[Q.HEX=1]="HEX",Q[Q.HSL=2]="HSL"})(mt=e.ColorFormat||(e.ColorFormat={}));var Lt;(function(Q){Q[Q.Error=0]="Error",Q[Q.Warning=1]="Warning",Q[Q.Information=2]="Information"})(Lt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class Mt{constructor(x,ce,De){if(this.startIndex=x,this.length=ce,this.tooltip=De,typeof x!="number"||x<0)throw(0,i.illegalArgument)("startIndex");if(typeof ce!="number"||ce<1)throw(0,i.illegalArgument)("length");if(De!==void 0&&typeof De!="string")throw(0,i.illegalArgument)("tooltip")}}e.TerminalLink=Mt;var Ft;(function(Q){Q[Q.Panel=1]="Panel",Q[Q.Editor=2]="Editor"})(Ft=e.TerminalLocation||(e.TerminalLocation={}));class xe{constructor(x){this.options=x,typeof x!="object"&&(0,i.illegalArgument)("options")}}e.TerminalProfile=xe;var _e;(function(Q){Q[Q.Always=1]="Always",Q[Q.Silent=2]="Silent",Q[Q.Never=3]="Never"})(_e=e.TaskRevealKind||(e.TaskRevealKind={}));var ye;(function(Q){Q[Q.Shared=1]="Shared",Q[Q.Dedicated=2]="Dedicated",Q[Q.New=3]="New"})(ye=e.TaskPanelKind||(e.TaskPanelKind={}));let me=o=class{constructor(x,ce){if(this.label=ce,typeof x!="string"||typeof ce!="string")throw(0,i.illegalArgument)("name");this._id=x}static from(x){switch(x){case"clean":return o.Clean;case"build":return o.Build;case"rebuild":return o.Rebuild;case"test":return o.Test;default:return}}get id(){return this._id}};me.Clean=new o("clean","Clean"),me.Build=new o("build","Build"),me.Rebuild=new o("rebuild","Rebuild"),me.Test=new o("test","Test"),me=o=Be([L],me),e.TaskGroup=me;function ie(Q){let x="";for(let ce=0;ce<Q.length;ce++)x+=Q[ce].replace(/,/g,",,")+",";return x}let Ie=class{constructor(x,ce,De){if(typeof x!="string")throw(0,i.illegalArgument)("process");this._args=[],this._process=x,ce!==void 0&&(Array.isArray(ce)?(this._args=ce,this._options=De):this._options=ce)}get process(){return this._process}set process(x){if(typeof x!="string")throw(0,i.illegalArgument)("process");this._process=x}get args(){return this._args}set args(x){Array.isArray(x)||(x=[]),this._args=x}get options(){return this._options}set options(x){this._options=x}computeId(){const x=[];if(x.push("process"),this._process!==void 0&&x.push(this._process),this._args&&this._args.length>0)for(let ce of this._args)x.push(ce);return ie(x)}};Ie=Be([L],Ie),e.ProcessExecution=Ie;let Re=class{constructor(x,ce,De){if(this._args=[],Array.isArray(ce)){if(!x)throw(0,i.illegalArgument)("command can't be undefined or null");if(typeof x!="string"&&typeof x.value!="string")throw(0,i.illegalArgument)("command");this._command=x,this._args=ce,this._options=De}else{if(typeof x!="string")throw(0,i.illegalArgument)("commandLine");this._commandLine=x,this._options=ce}}get commandLine(){return this._commandLine}set commandLine(x){if(typeof x!="string")throw(0,i.illegalArgument)("commandLine");this._commandLine=x}get command(){return this._command?this._command:""}set command(x){if(typeof x!="string"&&typeof x.value!="string")throw(0,i.illegalArgument)("command");this._command=x}get args(){return this._args}set args(x){this._args=x||[]}get options(){return this._options}set options(x){this._options=x}computeId(){const x=[];if(x.push("shell"),this._commandLine!==void 0&&x.push(this._commandLine),this._command!==void 0&&x.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let ce of this._args)x.push(typeof ce=="string"?ce:ce.value);return ie(x)}};Re=Be([L],Re),e.ShellExecution=Re;var Ve;(function(Q){Q[Q.Escape=1]="Escape",Q[Q.Strong=2]="Strong",Q[Q.Weak=3]="Weak"})(Ve=e.ShellQuoting||(e.ShellQuoting={}));var Ke;(function(Q){Q[Q.Global=1]="Global",Q[Q.Workspace=2]="Workspace"})(Ke=e.TaskScope||(e.TaskScope={}));class ht{constructor(x){this._callback=x}computeId(){return"customExecution"+(0,F.generateUuid)()}set callback(x){this._callback=x}get callback(){return this._callback}}e.CustomExecution=ht;let Et=m=class{constructor(x,ce,De,Ge,Qe,Ze){this.__deprecated=!1,this._definition=this.definition=x;let rt;typeof ce=="string"?(this._name=this.name=ce,this._source=this.source=De,this.execution=Ge,rt=Qe,this.__deprecated=!0):ce===Ke.Global||ce===Ke.Workspace?(this.target=ce,this._name=this.name=De,this._source=this.source=Ge,this.execution=Qe,rt=Ze):(this.target=ce,this._name=this.name=De,this._source=this.source=Ge,this.execution=Qe,rt=Ze),typeof rt=="string"?(this._problemMatchers=[rt],this._hasDefinedMatchers=!0):Array.isArray(rt)?(this._problemMatchers=rt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(x){this.__id=x}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Ie?this._definition={type:m.ProcessType,id:this._execution.computeId()}:this._execution instanceof Re?this._definition={type:m.ShellType,id:this._execution.computeId()}:this._execution instanceof ht?this._definition={type:m.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:m.EmptyType,id:(0,F.generateUuid)()}}get definition(){return this._definition}set definition(x){if(x==null)throw(0,i.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=x}get scope(){return this._scope}set target(x){this.clear(),this._scope=x}get name(){return this._name}set name(x){if(typeof x!="string")throw(0,i.illegalArgument)("name");this.clear(),this._name=x}get execution(){return this._execution}set execution(x){x===null&&(x=void 0),this.clear(),this._execution=x;const ce=this._definition.type;(m.EmptyType===ce||m.ProcessType===ce||m.ShellType===ce||m.ExtensionCallbackType===ce)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(x){if(Array.isArray(x))this.clear(),this._problemMatchers=x,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(x){x!==!0&&x!==!1&&(x=!1),this.clear(),this._isBackground=x}get source(){return this._source}set source(x){if(typeof x!="string"||x.length===0)throw(0,i.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=x}get group(){return this._group}set group(x){x===null&&(x=void 0),this.clear(),this._group=x}get detail(){return this._detail}set detail(x){x===null&&(x=void 0),this._detail=x}get presentationOptions(){return this._presentationOptions}set presentationOptions(x){x==null&&(x=Object.create(null)),this.clear(),this._presentationOptions=x}get runOptions(){return this._runOptions}set runOptions(x){x==null&&(x=Object.create(null)),this.clear(),this._runOptions=x}};Et.ExtensionCallbackType="customExecution",Et.ProcessType="process",Et.ShellType="shell",Et.EmptyType="$empty",Et=m=Be([L],Et),e.Task=Et;var St;(function(Q){Q[Q.SourceControl=1]="SourceControl",Q[Q.Window=10]="Window",Q[Q.Notification=15]="Notification"})(St=e.ProgressLocation||(e.ProgressLocation={}));let ot=class{constructor(x,ce=dt.None){this.collapsibleState=ce,R.URI.isUri(x)?this.resourceUri=x:this.label=x}};ot=Be([L],ot),e.TreeItem=ot;var dt;(function(Q){Q[Q.None=0]="None",Q[Q.Collapsed=1]="Collapsed",Q[Q.Expanded=2]="Expanded"})(dt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let ut=class{constructor(x){this.value=x}async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}};ut=Be([L],ut),e.TreeDataTransferItem=ut;let Nt=class{constructor(){this._items=new Map}get(x){return this._items.get(x)}set(x,ce){this._items.set(x,ce)}forEach(x){this._items.forEach(x)}};Nt=Be([L],Nt),e.TreeDataTransfer=Nt;let pt=class{constructor(x,ce){this.id=x,this.color=ce}};pt=Be([L],pt),e.ThemeIcon=pt,pt.File=new pt("file"),pt.Folder=new pt("folder");let kt=class{constructor(x){this.id=x}};kt=Be([L],kt),e.ThemeColor=kt;var Ut;(function(Q){Q[Q.Global=1]="Global",Q[Q.Workspace=2]="Workspace",Q[Q.WorkspaceFolder=3]="WorkspaceFolder"})(Ut=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Ct=class{constructor(x,ce){if(typeof x!="string"&&(!x||!R.URI.isUri(x)&&!R.URI.isUri(x.uri)))throw(0,i.illegalArgument)("base");if(typeof ce!="string")throw(0,i.illegalArgument)("pattern");typeof x=="string"?this.baseUri=R.URI.file(x):R.URI.isUri(x)?this.baseUri=x:this.baseUri=x.uri,this.pattern=ce}get base(){return this._base}set base(x){this._base=x,this._baseUri=R.URI.file(x)}get baseUri(){return this._baseUri}set baseUri(x){this._baseUri=x,this._base=x.fsPath}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};Ct=Be([L],Ct),e.RelativePattern=Ct;let Bt=class{constructor(x,ce,De,Ge){this.enabled=typeof x=="boolean"?x:!0,typeof ce=="string"&&(this.condition=ce),typeof De=="string"&&(this.hitCondition=De),typeof Ge=="string"&&(this.logMessage=Ge)}get id(){return this._id||(this._id=(0,F.generateUuid)()),this._id}};Bt=Be([L],Bt),e.Breakpoint=Bt;let Ht=class extends Bt{constructor(x,ce,De,Ge,Qe){super(ce,De,Ge,Qe);if(x===null)throw(0,i.illegalArgument)("location");this.location=x}};Ht=Be([L],Ht),e.SourceBreakpoint=Ht;let bt=class extends Bt{constructor(x,ce,De,Ge,Qe){super(ce,De,Ge,Qe);this.functionName=x}};bt=Be([L],bt),e.FunctionBreakpoint=bt;let ei=class extends Bt{constructor(x,ce,De,Ge,Qe,Ze,rt){super(Ge,Qe,Ze,rt);if(!ce)throw(0,i.illegalArgument)("dataId");this.label=x,this.dataId=ce,this.canPersist=De}};ei=Be([L],ei),e.DataBreakpoint=ei;let Xt=class{constructor(x,ce,De){this.command=x,this.args=ce||[],this.options=De}};Xt=Be([L],Xt),e.DebugAdapterExecutable=Xt;let ti=class{constructor(x,ce){this.port=x,this.host=ce}};ti=Be([L],ti),e.DebugAdapterServer=ti;let ai=class{constructor(x){this.path=x}};ai=Be([L],ai),e.DebugAdapterNamedPipeServer=ai;let Pt=class{constructor(x){this.implementation=x}};Pt=Be([L],Pt),e.DebugAdapterInlineImplementation=Pt;let ii=class{constructor(x,ce){this.range=x,this.expression=ce}};ii=Be([L],ii),e.EvaluatableExpression=ii;var bi;(function(Q){Q[Q.Automatic=0]="Automatic",Q[Q.Explicit=1]="Explicit"})(bi=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let qt=class{constructor(x,ce){this.range=x,this.text=ce}};qt=Be([L],qt),e.InlineValueText=qt;let Gt=class{constructor(x,ce,De=!0){this.range=x,this.variableName=ce,this.caseSensitiveLookup=De}};Gt=Be([L],Gt),e.InlineValueVariableLookup=Gt;let at=class{constructor(x,ce){this.range=x,this.expression=ce}};at=Be([L],at),e.InlineValueEvaluatableExpression=at;let li=class{constructor(x,ce){this.frameId=x,this.stoppedLocation=ce}};li=Be([L],li),e.InlineValueContext=li;var $t;(function(Q){Q[Q.Changed=1]="Changed",Q[Q.Created=2]="Created",Q[Q.Deleted=3]="Deleted"})($t=e.FileChangeType||(e.FileChangeType={}));let xt=h=class extends Error{constructor(x,ce=D.FileSystemProviderErrorCode.Unknown,De){super(R.URI.isUri(x)?x.toString(!0):x);this.code=De?.name??"Unknown",(0,D.markAsFileSystemProviderError)(this,ce),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,h.prototype),typeof Error.captureStackTrace=="function"&&typeof De=="function"&&Error.captureStackTrace(this,De)}static FileExists(x){return new h(x,D.FileSystemProviderErrorCode.FileExists,h.FileExists)}static FileNotFound(x){return new h(x,D.FileSystemProviderErrorCode.FileNotFound,h.FileNotFound)}static FileNotADirectory(x){return new h(x,D.FileSystemProviderErrorCode.FileNotADirectory,h.FileNotADirectory)}static FileIsADirectory(x){return new h(x,D.FileSystemProviderErrorCode.FileIsADirectory,h.FileIsADirectory)}static NoPermissions(x){return new h(x,D.FileSystemProviderErrorCode.NoPermissions,h.NoPermissions)}static Unavailable(x){return new h(x,D.FileSystemProviderErrorCode.Unavailable,h.Unavailable)}};xt=h=Be([L],xt),e.FileSystemError=xt;let ni=class{constructor(x,ce,De){this.start=x,this.end=ce,this.kind=De}};ni=Be([L],ni),e.FoldingRange=ni;var _i;(function(Q){Q[Q.Comment=1]="Comment",Q[Q.Imports=2]="Imports",Q[Q.Region=3]="Region"})(_i=e.FoldingRangeKind||(e.FoldingRangeKind={}));var fi;(function(Q){Q[Q.Collapsed=0]="Collapsed",Q[Q.Expanded=1]="Expanded"})(fi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Si;(function(Q){Q[Q.Editing=0]="Editing",Q[Q.Preview=1]="Preview"})(Si=e.CommentMode||(e.CommentMode={}));var mi;(function(Q){Q[Q.Unresolved=0]="Unresolved",Q[Q.Resolved=1]="Resolved"})(mi=e.CommentThreadState||(e.CommentThreadState={}));class ri{constructor(x,ce=[]){this.tokenTypes=x,this.tokenModifiers=ce}}e.SemanticTokensLegend=ri;function Ci(Q){return typeof Q=="undefined"||(0,S.isStringArray)(Q)}class Qt{constructor(x){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,x){this._hasLegend=!0;for(let ce=0,De=x.tokenTypes.length;ce<De;ce++)this._tokenTypeStrToInt.set(x.tokenTypes[ce],ce);for(let ce=0,De=x.tokenModifiers.length;ce<De;ce++)this._tokenModifierStrToInt.set(x.tokenModifiers[ce],ce)}}push(x,ce,De,Ge,Qe){if(typeof x=="number"&&typeof ce=="number"&&typeof De=="number"&&typeof Ge=="number"&&(typeof Qe=="number"||typeof Qe=="undefined"))return typeof Qe=="undefined"&&(Qe=0),this._pushEncoded(x,ce,De,Ge,Qe);if(H.isRange(x)&&typeof ce=="string"&&Ci(De))return this._push(x,ce,De);throw(0,i.illegalArgument)()}_push(x,ce,De){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(x.start.line!==x.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ce))throw new Error("`tokenType` is not in the provided legend");const Ge=x.start.line,Qe=x.start.character,Ze=x.end.character-x.start.character,rt=this._tokenTypeStrToInt.get(ce);let Dt=0;if(De)for(const At of De){if(!this._tokenModifierStrToInt.has(At))throw new Error("`tokenModifier` is not in the provided legend");const Wt=this._tokenModifierStrToInt.get(At);Dt|=1<<Wt>>>0}this._pushEncoded(Ge,Qe,Ze,rt,Dt)}_pushEncoded(x,ce,De,Ge,Qe){if(this._dataIsSortedAndDeltaEncoded&&(x<this._prevLine||x===this._prevLine&&ce<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Dt=this._data.length/5|0;let At=0,Wt=0;for(let zt=0;zt<Dt;zt++){let Vt=this._data[5*zt],di=this._data[5*zt+1];Vt===0?(Vt=At,di+=Wt):Vt+=At,this._data[5*zt]=Vt,this._data[5*zt+1]=di,At=Vt,Wt=di}}let Ze=x,rt=ce;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(Ze-=this._prevLine,Ze===0&&(rt-=this._prevChar)),this._data[this._dataLen++]=Ze,this._data[this._dataLen++]=rt,this._data[this._dataLen++]=De,this._data[this._dataLen++]=Ge,this._data[this._dataLen++]=Qe,this._prevLine=x,this._prevChar=ce}static _sortAndDeltaEncode(x){let ce=[];const De=x.length/5|0;for(let rt=0;rt<De;rt++)ce[rt]=rt;ce.sort((rt,Dt)=>{const At=x[5*rt],Wt=x[5*Dt];if(At===Wt){const zt=x[5*rt+1],Vt=x[5*Dt+1];return zt-Vt}return At-Wt});const Ge=new Uint32Array(x.length);let Qe=0,Ze=0;for(let rt=0;rt<De;rt++){const Dt=5*ce[rt],At=x[Dt+0],Wt=x[Dt+1],zt=x[Dt+2],Vt=x[Dt+3],di=x[Dt+4],xi=At-Qe,Ji=xi===0?Wt-Ze:Wt,hi=5*rt;Ge[hi+0]=xi,Ge[hi+1]=Ji,Ge[hi+2]=zt,Ge[hi+3]=Vt,Ge[hi+4]=di,Qe=At,Ze=Wt}return Ge}build(x){return this._dataIsSortedAndDeltaEncoded?new Yt(new Uint32Array(this._data),x):new Yt(Qt._sortAndDeltaEncode(this._data),x)}}e.SemanticTokensBuilder=Qt;class Yt{constructor(x,ce){this.resultId=ce,this.data=x}}e.SemanticTokens=Yt;class yi{constructor(x,ce,De){this.start=x,this.deleteCount=ce,this.data=De}}e.SemanticTokensEdit=yi;class Di{constructor(x,ce){this.resultId=ce,this.edits=x}}e.SemanticTokensEdits=Di;var Jt;(function(Q){Q[Q.Separate=0]="Separate",Q[Q.MergeWithParent=1]="MergeWithParent"})(Jt=e.DebugConsoleMode||(e.DebugConsoleMode={}));let si=class{constructor(){}};si.Back={iconPath:new pt("arrow-left")},si=Be([L],si),e.QuickInputButtons=si;var Ii;(function(Q){Q[Q.Separator=-1]="Separator",Q[Q.Default=0]="Default"})(Ii=e.QuickPickItemKind||(e.QuickPickItemKind={}));var ki;(function(Q){Q[Q.UI=1]="UI",Q[Q.Workspace=2]="Workspace"})(ki=e.ExtensionKind||(e.ExtensionKind={}));class Pi{constructor(x,ce,De){this.badge=x,this.tooltip=ce,this.color=De}static validate(x){if(x.badge){let ce=(0,k.nextCharLength)(x.badge,0);if(ce<x.badge.length&&(ce+=(0,k.nextCharLength)(x.badge,ce)),x.badge.length>ce)throw new Error("The 'badge'-property must be undefined or a short character")}if(!x.color&&!x.badge&&!x.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=Pi;let Zt=class{constructor(x){this.kind=x}};Zt=Be([L],Zt),e.ColorTheme=Zt;var gi;(function(Q){Q[Q.Light=1]="Light",Q[Q.Dark=2]="Dark",Q[Q.HighContrast=3]="HighContrast"})(gi=e.ColorThemeKind||(e.ColorThemeKind={}));class Kt{constructor(x,ce){if(x<0)throw(0,i.illegalArgument)("start must be positive");if(ce<0)throw(0,i.illegalArgument)("end must be positive");x<=ce?(this._start=x,this._end=ce):(this._start=ce,this._end=x)}static isNotebookRange(x){return x instanceof Kt?!0:x?typeof x.start=="number"&&typeof x.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(x){let ce=this._start,De=this._end;return x.start!==void 0&&(ce=x.start),x.end!==void 0&&(De=x.end),ce===this._start&&De===this._end?this:new Kt(ce,De)}}e.NotebookRange=Kt;class Oe{constructor(x,ce,De,Ge,Qe,Ze,rt){this.kind=x,this.value=ce,this.languageId=De,this.mime=Ge,this.outputs=Qe??[],this.metadata=Ze,this.executionSummary=rt,Oe.validate(this)}static validate(x){if(typeof x.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof x.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof x.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(x){return Array.isArray(x)&&x.every(ce=>Oe.isNotebookCellData(ce))}static isNotebookCellData(x){return!0}}e.NotebookCellData=Oe;class ci{constructor(x){this.cells=x}}e.NotebookData=ci;class Ot{constructor(x,ce){this.data=x,this.mime=ce;const De=(0,C.normalizeMimeType)(ce,!0);if(!De)throw new Error(`INVALID mime type: ${ce}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=De}static isNotebookCellOutputItem(x){return x instanceof Ot?!0:x?typeof x.mime=="string"&&x.data instanceof Uint8Array:!1}static error(x){const ce={name:x.name,message:x.message,stack:x.stack};return Ot.json(ce,"application/vnd.code.notebook.error")}static stdout(x){return Ot.text(x,"application/vnd.code.notebook.stdout")}static stderr(x){return Ot.text(x,"application/vnd.code.notebook.stderr")}static bytes(x,ce="application/octet-stream"){return new Ot(x,ce)}static text(x,ce=C.Mimes.text){const De=Pe(Ot,d,"f",p).encode(String(x));return new Ot(De,ce)}static json(x,ce="application/json"){const De=JSON.stringify(x,void 0,"	");return Ot.text(De,ce)}}e.NotebookCellOutputItem=Ot,d=Ot,p={value:new TextEncoder};class ft{constructor(x,ce,De){this.items=ft.ensureUniqueMimeTypes(x,!0),typeof ce=="string"?(this.id=ce,this.metadata=De):(this.id=(0,F.generateUuid)(),this.metadata=ce??De)}static isNotebookCellOutput(x){return x instanceof ft?!0:!x||typeof x!="object"?!1:typeof x.id=="string"&&(0,S.isArray)(x.items)}static ensureUniqueMimeTypes(x,ce=!1){const De=new Set,Ge=new Set;for(let Qe=0;Qe<x.length;Qe++){const Ze=x[Qe],rt=(0,C.normalizeMimeType)(Ze.mime);if(!De.has(rt)){De.add(rt);continue}Ge.add(Qe),ce&&console.warn(`DUPLICATED mime type '${Ze.mime}' will be dropped`)}return Ge.size===0?x:x.filter((Qe,Ze)=>!Ge.has(Ze))}}e.NotebookCellOutput=ft;var Ti;(function(Q){Q[Q.Markup=1]="Markup",Q[Q.Code=2]="Code"})(Ti=e.NotebookCellKind||(e.NotebookCellKind={}));var Ai;(function(Q){Q[Q.Idle=1]="Idle",Q[Q.Pending=2]="Pending",Q[Q.Executing=3]="Executing"})(Ai=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var pi;(function(Q){Q[Q.Left=1]="Left",Q[Q.Right=2]="Right"})(pi=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var vi;(function(Q){Q[Q.Default=0]="Default",Q[Q.InCenter=1]="InCenter",Q[Q.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",Q[Q.AtTop=3]="AtTop"})(vi=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Ri{constructor(x,ce){this.text=x,this.alignment=ce}}e.NotebookCellStatusBarItem=Ri;var Li;(function(Q){Q[Q.Default=1]="Default",Q[Q.Preferred=2]="Preferred"})(Li=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Oi{constructor(x,ce=[]){this.uri=x,this.provides=(0,f.asArray)(ce)}}e.NotebookRendererScript=Oi;let ui=class{constructor(x,ce){this.label=x,this.timestamp=ce}};ui=Be([L],ui),e.TimelineItem=ui;var wi;(function(Q){Q[Q.Production=1]="Production",Q[Q.Development=2]="Development",Q[Q.Test=3]="Test"})(wi=e.ExtensionMode||(e.ExtensionMode={}));var Fi;(function(Q){Q[Q.Node=1]="Node",Q[Q.Webworker=2]="Webworker"})(Fi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Ni;(function(Q){Q[Q.Other=0]="Other",Q[Q.Comment=1]="Comment",Q[Q.String=2]="String",Q[Q.RegEx=3]="RegEx"})(Ni=e.StandardTokenType||(e.StandardTokenType={}));class Mi{constructor(x,ce){this.ranges=x,this.wordPattern=ce}}e.LinkedEditingRanges=Mi;class Ui{constructor(x,ce){this._port=x,this._autoForwardAction=ce}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Ui;var Bi;(function(Q){Q[Q.Queued=1]="Queued",Q[Q.Running=2]="Running",Q[Q.Passed=3]="Passed",Q[Q.Failed=4]="Failed",Q[Q.Skipped=5]="Skipped",Q[Q.Errored=6]="Errored"})(Bi=e.TestResultState||(e.TestResultState={}));var le;(function(Q){Q[Q.Run=1]="Run",Q[Q.Debug=2]="Debug",Q[Q.Coverage=3]="Coverage"})(le=e.TestRunProfileKind||(e.TestRunProfileKind={}));let fe=class{constructor(x=void 0,ce=void 0,De=void 0){this.include=x,this.exclude=ce,this.profile=De}};fe=Be([L],fe),e.TestRunRequest=fe;let ke=w=class{constructor(x){this.message=x}static diff(x,ce,De){const Ge=new w(x);return Ge.expectedOutput=ce,Ge.actualOutput=De,Ge}};ke=w=Be([L],ke),e.TestMessage=ke;let tt=class{constructor(x){this.id=x}};tt=Be([L],tt),e.TestTag=tt;let gt=class{constructor(x,ce){this.covered=x,this.total=ce}};gt=Be([L],gt),e.CoveredCount=gt;let It=T=class{constructor(x,ce,De,Ge){this.uri=x,this.statementCoverage=ce,this.branchCoverage=De,this.functionCoverage=Ge}static fromDetails(x,ce){const De=new gt(0,0),Ge=new gt(0,0),Qe=new gt(0,0);for(const rt of ce)if("branches"in rt){De.total+=1,De.covered+=rt.executionCount>0?1:0;for(const Dt of rt.branches)Ge.total+=1,Ge.covered+=Dt.executionCount>0?1:0}else Qe.total+=1,Qe.covered+=rt.executionCount>0?1:0;const Ze=new T(x,De,Ge.total>0?Ge:void 0,Qe.total>0?Qe:void 0);return Ze.detailedCoverage=ce,Ze}};It=T=Be([L],It),e.FileCoverage=It;let Wi=class{constructor(x,ce,De=[]){this.executionCount=x,this.location=ce,this.branches=De}};Wi=Be([L],Wi),e.StatementCoverage=Wi;let zi=class{constructor(x,ce){this.executionCount=x,this.location=ce}};zi=Be([L],zi),e.BranchCoverage=zi;let Hi=class{constructor(x,ce){this.executionCount=x,this.location=ce}};Hi=Be([L],Hi),e.FunctionCoverage=Hi;var Ki;(function(Q){Q[Q.None=0]="None",Q[Q.Option=1]="Option",Q[Q.Default=2]="Default",Q[Q.Preferred=3]="Preferred"})(Ki=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Xi;(function(Q){Q[Q.Untrusted=0]="Untrusted",Q[Q.Trusted=1]="Trusted",Q[Q.Unspecified=2]="Unspecified"})(Xi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Qi;(function(Q){Q[Q.Notify=1]="Notify",Q[Q.OpenBrowser=2]="OpenBrowser",Q[Q.OpenPreview=3]="OpenPreview",Q[Q.Silent=4]="Silent",Q[Q.Ignore=5]="Ignore",Q[Q.OpenBrowserOnce=6]="OpenBrowserOnce"})(Qi=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class Yi{constructor(x,ce,De,Ge,Qe,Ze){this.kind=x,this.name=ce,this.detail=De,this.uri=Ge,this.range=Qe,this.selectionRange=Ze}}e.TypeHierarchyItem=Yi}),define(ve[125],we([1,0,55,10,8,151,107,7,18]),function(te,e,f,i,I,A,C,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const R=new Map;function F(g,d){d?R.set(g,d):R.delete(g)}e.setWordDefinitionFor=F;function D(g){return R.get(g)}e.getWordDefinitionFor=D;class v extends A.MirrorTextModel{constructor(d,p,P,_,l,c,u,a){super(p,P,_,l);this._proxy=d,this._languageId=c,this._isDirty=u,this._notebook=a,this._isDisposed=!1}dispose(){(0,f.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(d){return(0,S.equals)(this._lines,d)}get document(){if(!this._document){const d=this;this._document={get uri(){return d._uri},get fileName(){return d._uri.fsPath},get isUntitled(){return d._uri.scheme===i.Schemas.untitled},get languageId(){return d._languageId},get version(){return d._versionId},get isClosed(){return d._isDisposed},get isDirty(){return d._isDirty},get notebook(){return d._notebook},save(){return d._save()},getText(p){return p?d._getTextInRange(p):d.getText()},get eol(){return d._eol===`
`?k.EndOfLine.LF:k.EndOfLine.CRLF},get lineCount(){return d._lines.length},lineAt(p){return d._lineAt(p)},offsetAt(p){return d._offsetAt(p)},positionAt(p){return d._positionAt(p)},validateRange(p){return d._validateRange(p)},validatePosition(p){return d._validatePosition(p)},getWordRangeAtPosition(p,P){return d._getWordRangeAtPosition(p,P)}}}return Object.freeze(this._document)}_acceptLanguageId(d){(0,f.ok)(!this._isDisposed),this._languageId=d}_acceptIsDirty(d){(0,f.ok)(!this._isDisposed),this._isDirty=d}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(d){const p=this._validateRange(d);if(p.isEmpty)return"";if(p.isSingleLine)return this._lines[p.start.line].substring(p.start.character,p.end.character);const P=this._eol,_=p.start.line,l=p.end.line,c=[];c.push(this._lines[_].substring(p.start.character));for(let u=_+1;u<l;u++)c.push(this._lines[u]);return c.push(this._lines[l].substring(0,p.end.character)),c.join(P)}_lineAt(d){let p;if(d instanceof k.Position?p=d.line:typeof d=="number"&&(p=d),typeof p!="number"||p<0||p>=this._lines.length||Math.floor(p)!==p)throw new Error("Illegal value for `line`");return new b(p,this._lines[p],p===this._lines.length-1)}_offsetAt(d){return d=this._validatePosition(d),this._ensureLineStarts(),this._lineStarts.getPrefixSum(d.line-1)+d.character}_positionAt(d){d=Math.floor(d),d=Math.max(0,d),this._ensureLineStarts();const p=this._lineStarts.getIndexOf(d),P=this._lines[p.index].length;return new k.Position(p.index,Math.min(p.remainder,P))}_validateRange(d){if(!(d instanceof k.Range))throw new Error("Invalid argument");const p=this._validatePosition(d.start),P=this._validatePosition(d.end);return p===d.start&&P===d.end?d:new k.Range(p.line,p.character,P.line,P.character)}_validatePosition(d){if(!(d instanceof k.Position))throw new Error("Invalid argument");if(this._lines.length===0)return d.with(0,0);let{line:p,character:P}=d,_=!1;if(p<0)p=0,P=0,_=!0;else if(p>=this._lines.length)p=this._lines.length-1,P=this._lines[p].length,_=!0;else{const l=this._lines[p].length;P<0?(P=0,_=!0):P>l&&(P=l,_=!0)}return _?new k.Position(p,P):d}_getWordRangeAtPosition(d,p){const P=this._validatePosition(d);if(!p)p=D(this._languageId);else if((0,I.regExpLeadsToEndlessLoop)(p))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${p.source}' because it matches the empty string.`);const _=(0,C.getWordAtText)(P.character+1,(0,C.ensureValidWordDefinition)(p),this._lines[P.line],0);if(_)return new k.Range(P.line,_.startColumn-1,P.line,_.endColumn-1)}}e.ExtHostDocumentData=v;class b{constructor(d,p,P){this._line=d,this._text=p,this._isLastLine=P}get lineNumber(){return this._line}get text(){return this._text}get range(){return new k.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new k.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=b}),define(ve[202],we([1,0,7,3,110,6,108,24,2,33]),function(te,e,f,i,I,A,C,k,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class F{constructor(v,b,g,d){this._notebook=g,this._selector=d,this._disposables=new A.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new i.Emitter,this.onDidChange=this._onDidChange.event,this.uri=S.URI.from({scheme:"vscode-concat-doc",path:(0,R.generateUuid)()}),this._init(),this._disposables.add(b.onDidChangeDocument(P=>{const _=this._cellUris.get(P.document.uri);_!==void 0&&(this._cellLengths.setValue(_,this._cells[_].document.getText().length+1),this._cellLines.setValue(_,this._cells[_].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const p=P=>{P===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(v.onDidChangeNotebookCells(P=>p(P.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new k.ResourceMap;const v=[],b=[];for(const g of this._notebook.getCells())g.kind===f.NotebookCellKind.Code&&(!this._selector||(0,C.score)(this._selector,g.document.uri,g.document.languageId,!0,void 0))&&(this._cellUris.set(g.document.uri,this._cells.length),this._cells.push(g),v.push(g.document.getText().length+1),b.push(g.document.lineCount));this._cellLengths=new I.PrefixSumComputer(new Uint32Array(v)),this._cellLines=new I.PrefixSumComputer(new Uint32Array(b))}get version(){return this._versionId}getText(v){if(!v){let _="";for(const l of this._cells)_+=l.document.getText()+`
`;return _=_.slice(0,-1),_}if(v.isEmpty)return"";const b=this.locationAt(v.start),g=this.locationAt(v.end),d=this._cellUris.get(b.uri),p=this._cellUris.get(g.uri);if(d===void 0||p===void 0)return"";if(d===p)return this._cells[d].document.getText(new f.Range(b.range.start,g.range.end));const P=[this._cells[d].document.getText(new f.Range(b.range.start,new f.Position(this._cells[d].document.lineCount,0)))];for(let _=d+1;_<p;_++)P.push(this._cells[_].document.getText());return P.push(this._cells[p].document.getText(new f.Range(new f.Position(0,0),g.range.end))),P.join(`
`)}offsetAt(v){const b=this._cellLines.getIndexOf(v.line),g=this._cellLengths.getPrefixSum(b.index-1),d=this._cells[b.index].document.offsetAt(v.with(b.remainder));return g+d}positionAt(v){if(typeof v=="number"){const g=this._cellLengths.getIndexOf(v),d=this._cellLines.getPrefixSum(g.index-1);return this._cells[g.index].document.positionAt(g.remainder).translate(d)}const b=this._cellUris.get(v.uri);if(b!==void 0){const g=this._cellLines.getPrefixSum(b-1);return new f.Position(g+v.range.start.line,v.range.start.character)}return new f.Position(0,0)}locationAt(v){f.Range.isRange(v)||(v=new f.Range(v,v));const b=this._cellLines.getIndexOf(v.start.line);let g=b;v.isEmpty||(g=this._cellLines.getIndexOf(v.end.line));const d=new f.Position(b.remainder,v.start.character),p=new f.Position(g.remainder,v.end.character),P=new f.Range(d,p),_=this._cells[b.index];return new f.Location(_.document.uri,_.document.validateRange(P))}contains(v){return this._cellUris.has(v)}validateRange(v){const b=this.validatePosition(v.start),g=this.validatePosition(v.end);return v.with(b,g)}validatePosition(v){const b=this._cellLines.getIndexOf(v.line),g=new f.Position(b.remainder,v.character),d=this._cells[b.index].document.validatePosition(g),p=this._cellLines.getPrefixSum(b.index-1);return new f.Position(p+d.line,d.character)}}e.ExtHostNotebookConcatDocument=F}),define(ve[203],we([1,0,7,17,3]),function(te,e,f,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let A=class{constructor(k){this._actual=new f.ColorTheme(f.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new I.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(k){let S=k==="light"?f.ColorThemeKind.Light:k==="dark"?f.ColorThemeKind.Dark:f.ColorThemeKind.HighContrast;this._actual=new f.ColorTheme(S),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};A=Be([Fe(0,i.IExtHostRpcService)],A),e.ExtHostTheming=A}),define(ve[63],we([1,0,4]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,f.createDecorator)("IURITransformerService");class i{constructor(A){A?(this.transformIncoming=A.transformIncoming.bind(A),this.transformOutgoing=A.transformOutgoing.bind(A),this.transformOutgoingURI=A.transformOutgoingURI.bind(A),this.transformOutgoingScheme=A.transformOutgoingScheme.bind(A)):(this.transformIncoming=C=>C,this.transformOutgoing=C=>C,this.transformOutgoingURI=C=>C,this.transformOutgoingScheme=C=>C)}}e.URITransformerService=i}),define(ve[204],we([1,0,22]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class i{constructor(){this.buffers=[]}add(S){let R=this.buffers.indexOf(S);return R<0&&(R=this.buffers.length,this.buffers.push(S)),R}}function I(k,S){if(S.serializeBuffersForPostMessage){const R=new i,F=(b,g)=>{if(g instanceof ArrayBuffer){const d=R.add(g);return{$$vscode_array_buffer_reference$$:!0,index:d}}else if(ArrayBuffer.isView(g)){const d=A(g);if(d){const p=R.add(g.buffer);return{$$vscode_array_buffer_reference$$:!0,index:p,view:{type:d,byteLength:g.byteLength,byteOffset:g.byteOffset}}}}return g},D=JSON.stringify(k,F),v=R.buffers.map(b=>{const g=new Uint8Array(b);return f.VSBuffer.wrap(g)});return{message:D,buffers:v}}else return{message:JSON.stringify(k),buffers:[]}}e.serializeWebviewMessage=I;function A(k){switch(k.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function C(k,S){const R=S.map(v=>{const b=new ArrayBuffer(v.byteLength);return new Uint8Array(b).set(v.buffer),b}),F=S.length?(v,b)=>{if(b&&typeof b=="object"&&b.$$vscode_array_buffer_reference$$){const g=b,{index:d}=g,p=R[d];if(g.view)switch(g.view.type){case 1:return new Int8Array(p,g.view.byteOffset,g.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(p,g.view.byteOffset,g.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(p,g.view.byteOffset,g.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(p,g.view.byteOffset,g.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(p,g.view.byteOffset,g.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(p,g.view.byteOffset,g.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(p,g.view.byteOffset,g.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(p,g.view.byteOffset,g.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(p,g.view.byteOffset,g.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(p,g.view.byteOffset,g.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(p,g.view.byteOffset,g.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return p}return b}:void 0;return{message:JSON.parse(k,F),arrayBuffers:R}}e.deserializeWebviewMessage=C}),define(ve[205],we([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var f;(function(i){function I(C){const k=new Map;return C.types.forEach((S,R)=>{k.set(S,{asString:async()=>C.items[R].asString,value:void 0})}),k}i.toITreeDataTransfer=I;async function A(C){const k={types:[],items:[]},S=Array.from(C.entries());for(const R of S)k.types.push(R[0]),k.items.push({asString:await R[1].asString()});return k}i.toTreeDataTransferDTO=A})(f=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(ve[206],we([1,0,101]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function i(A){return{transformIncoming:C=>C.scheme==="vscode-remote"?{scheme:"file",path:C.path,query:C.query,fragment:C.fragment}:C.scheme==="file"?{scheme:"vscode-local",path:C.path,query:C.query,fragment:C.fragment}:C,transformOutgoing:C=>C.scheme==="file"?{scheme:"vscode-remote",authority:A,path:C.path,query:C.query,fragment:C.fragment}:C.scheme==="vscode-local"?{scheme:"file",path:C.path,query:C.query,fragment:C.fragment}:C,transformOutgoingScheme:C=>C==="file"?"vscode-remote":C==="vscode-local"?"file":C}}function I(A){return new f.URITransformer(i(A))}e.createURITransformer=I}),define(ve[207],we([1,0,175,13,2,6,4,50,42,18,10]),function(te,e,f,i,I,A,C,k,S,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,f.localize)(0,null),providerDisplayName:(0,f.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var D;(function(X){X[X.PROGRAMMATIC=1]="PROGRAMMATIC",X[X.USER=2]="USER",X[X.EDIT=3]="EDIT",X[X.NAVIGATION=4]="NAVIGATION",X[X.JUMP=5]="JUMP"})(D=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var v;(function(X){X[X.IDENTICAL=1]="IDENTICAL",X[X.SIMILAR=2]="SIMILAR",X[X.DIFFERENT=3]="DIFFERENT"})(v=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function b(X){const $=X;return!!$&&typeof $.getSelection=="function"&&!!$.onDidChangeSelection}e.isEditorPaneWithSelection=b;function g(X,$,U){for(const q of U.visibleEditorPanes)if(q.group.id===$&&X.matches(q.input))return q.getViewState()}e.findViewStateForEditor=g;function d(X){if(E(X))return!1;const $=X;return I.URI.isUri($?.resource)}e.isResourceEditorInput=d;function p(X){if(E(X))return!1;const $=X;return $?.original!==void 0&&$.modified!==void 0}e.isResourceDiffEditorInput=p;function P(X){if(E(X)||p(X))return!1;const $=X;return $?.primary!==void 0&&$.secondary!==void 0}e.isResourceSideBySideEditorInput=P;function _(X){if(E(X))return!1;const $=X;return $?$.resource===void 0||$.resource.scheme===F.Schemas.untitled||$.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=_;var l;(function(X){X[X.SHORT=0]="SHORT",X[X.MEDIUM=1]="MEDIUM",X[X.LONG=2]="LONG"})(l=e.Verbosity||(e.Verbosity={}));var c;(function(X){X[X.EXPLICIT=1]="EXPLICIT",X[X.AUTO=2]="AUTO",X[X.FOCUS_CHANGE=3]="FOCUS_CHANGE",X[X.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(c=e.SaveReason||(e.SaveReason={}));var u;(function(X){X[X.None=0]="None",X[X.Readonly=2]="Readonly",X[X.Untitled=4]="Untitled",X[X.Singleton=8]="Singleton",X[X.RequiresTrust=16]="RequiresTrust",X[X.CanSplitInGroup=32]="CanSplitInGroup",X[X.ForceDescription=64]="ForceDescription"})(u=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class a extends A.Disposable{}e.AbstractEditorInput=a;function E(X){return X instanceof a}e.isEditorInput=E;function s(X){const $=X;return I.URI.isUri($?.preferredResource)}function t(X){const $=X;return E($?.primary)&&E($?.secondary)}e.isSideBySideEditorInput=t;function r(X){const $=X;return E($?.modified)&&E($?.original)}e.isDiffEditorInput=r;function n(X){return E(X?.editor)}e.isEditorInputWithOptions=n;function o(X){const $=X;return n(X)&&$?.group!==void 0}e.isEditorInputWithOptionsAndGroup=o;function m(X){const $=X;return typeof $?.groupId=="number"&&E($.editor)}e.isEditorIdentifier=m;var h;(function(X){X[X.UNKNOWN=0]="UNKNOWN",X[X.REPLACE=1]="REPLACE",X[X.MOVE=2]="MOVE",X[X.UNPIN=3]="UNPIN"})(h=e.EditorCloseContext||(e.EditorCloseContext={}));var w;(function(X){X[X.GROUP_ACTIVE=0]="GROUP_ACTIVE",X[X.GROUP_INDEX=1]="GROUP_INDEX",X[X.GROUP_LOCKED=2]="GROUP_LOCKED",X[X.EDITOR_OPEN=3]="EDITOR_OPEN",X[X.EDITOR_CLOSE=4]="EDITOR_CLOSE",X[X.EDITOR_MOVE=5]="EDITOR_MOVE",X[X.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",X[X.EDITOR_LABEL=7]="EDITOR_LABEL",X[X.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",X[X.EDITOR_PIN=9]="EDITOR_PIN",X[X.EDITOR_STICKY=10]="EDITOR_STICKY",X[X.EDITOR_DIRTY=11]="EDITOR_DIRTY",X[X.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(w=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var T;(function(X){X[X.PRIMARY=1]="PRIMARY",X[X.SECONDARY=2]="SECONDARY",X[X.BOTH=3]="BOTH",X[X.ANY=4]="ANY"})(T=e.SideBySideEditor||(e.SideBySideEditor={}));class L{getOriginalUri($,U){if(!$)return;if(U?.supportSideBySide){const{primary:K,secondary:G}=this.getSideEditors($);if(K&&G){if(U?.supportSideBySide===T.BOTH)return{primary:this.getOriginalUri(K,{filterByScheme:U.filterByScheme}),secondary:this.getOriginalUri(G,{filterByScheme:U.filterByScheme})};if(U?.supportSideBySide===T.ANY)return this.getOriginalUri(K,{filterByScheme:U.filterByScheme})??this.getOriginalUri(G,{filterByScheme:U.filterByScheme});$=U.supportSideBySide===T.PRIMARY?K:G}}if(p($)||P($))return;const q=s($)?$.preferredResource:$.resource;return!q||!U||!U.filterByScheme?q:this.filterUri(q,U.filterByScheme)}getSideEditors($){return t($)||P($)?{primary:$.primary,secondary:$.secondary}:r($)||p($)?{primary:$.modified,secondary:$.original}:{primary:void 0,secondary:void 0}}getCanonicalUri($,U){if(!$)return;if(U?.supportSideBySide){const{primary:K,secondary:G}=this.getSideEditors($);if(K&&G){if(U?.supportSideBySide===T.BOTH)return{primary:this.getCanonicalUri(K,{filterByScheme:U.filterByScheme}),secondary:this.getCanonicalUri(G,{filterByScheme:U.filterByScheme})};if(U?.supportSideBySide===T.ANY)return this.getCanonicalUri(K,{filterByScheme:U.filterByScheme})??this.getCanonicalUri(G,{filterByScheme:U.filterByScheme});$=U.supportSideBySide===T.PRIMARY?K:G}}if(p($)||P($))return;const q=$.resource;return!q||!U||!U.filterByScheme?q:this.filterUri(q,U.filterByScheme)}filterUri($,U){if(Array.isArray(U)){if(U.some(q=>$.scheme===q))return $}else if(U===$.scheme)return $}}e.EditorResourceAccessor=new L;var O;(function(X){X[X.LEFT=0]="LEFT",X[X.RIGHT=1]="RIGHT"})(O=e.CloseDirection||(e.CloseDirection={}));class y{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start($){const U=this.instantiationService=$.get(C.IInstantiationService);for(const[q,K]of this.editorSerializerConstructors)this.createEditorSerializer(q,K,U);this.editorSerializerConstructors.clear()}createEditorSerializer($,U,q){const K=q.createInstance(U);this.editorSerializerInstances.set($,K)}registerFileEditorFactory($){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=$}getFileEditorFactory(){return(0,i.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer($,U){if(this.editorSerializerConstructors.has($)||this.editorSerializerInstances.has($))throw new Error(`A editor serializer with type ID '${$}' was already registered.`);return this.instantiationService?this.createEditorSerializer($,U,this.instantiationService):this.editorSerializerConstructors.set($,U),(0,A.toDisposable)(()=>{this.editorSerializerConstructors.delete($),this.editorSerializerInstances.delete($)})}getEditorSerializer($){return this.editorSerializerInstances.get(typeof $=="string"?$:$.typeId)}}k.Registry.add(e.EditorExtensions.EditorFactory,new y);async function H(X,$){if(!X||!X.length)return[];const U=await Promise.all(X.map(async q=>{const K=I.URI.revive(q.fileUri);if(!K||!await $.canHandleResource(K))return;let ee=q.exists,oe=q.type;if(typeof ee!="boolean"||typeof oe!="number")try{oe=(await $.stat(K)).isDirectory?S.FileType.Directory:S.FileType.Unknown,ee=!0}catch{ee=!1}if(!ee&&q.openOnlyIfExists||oe===S.FileType.Directory)return;const ue={selection:ee?q.selection:void 0,pinned:!0,override:q.editorOverrideId};let Z;return ee?Z={resource:K,options:ue}:Z={resource:K,options:ue,forceUntitled:!0},Z}));return(0,R.coalesce)(U)}e.pathsToEditors=H;var M;(function(X){X[X.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",X[X.SEQUENTIAL=1]="SEQUENTIAL"})(M=e.EditorsOrder||(e.EditorsOrder={}));function j(X){const $=X;if(!$)return!1;const U=$;if(U.modified)return j(U.modified);const q=$;return!!(q.contributionsState&&q.viewState&&Array.isArray(q.cursorState))}e.isTextEditorViewState=j}),define(ve[83],we([1,0,10,2]),function(te,e,f,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function I(k,S){return k.scheme===f.Schemas.http||k.scheme===f.Schemas.https?k:(S&&S.authority&&S.isRemote&&k.scheme===f.Schemas.file&&(k=i.URI.from({scheme:f.Schemas.vscodeRemote,authority:S.authority,path:k.path})),i.URI.from({scheme:f.Schemas.https,authority:`${k.scheme}+${A(k.authority)}.${e.webviewRootResourceAuthority}`,path:k.path,fragment:k.fragment,query:k.query}))}e.asWebviewUri=I;function A(k){return k.replace(/./g,S=>{const R=S.charCodeAt(0);return R>=97&&R<=122||R>=65&&R<=90||R>=48&&R<=57?S:"-"+R.toString(16).padStart(4,"0")})}function C(k){return k.replace(/-([0-9a-f]{4})/g,(S,R)=>String.fromCharCode(parseInt(R,16)))}e.decodeAuthority=C}),define(ve[208],we([1,0,3,6,83]),function(te,e,f,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class A{constructor(k,S,R){this._proxy=k,this._editors=S,this._initData=R,this._handlePool=0,this._disposables=new i.DisposableStore,this._insets=new Map,this._disposables.add(S.onDidChangeVisibleTextEditors(()=>{const F=S.getVisibleTextEditors();for(const D of this._insets.values())F.indexOf(D.editor)<0&&D.inset.dispose()}))}dispose(){this._insets.forEach(k=>k.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(k,S,R,F,D){let v;for(const l of this._editors.getVisibleTextEditors(!0))if(l.value===k){v=l;break}if(!v)throw new Error("not a visible editor");const b=this,g=this._handlePool++,d=new f.Emitter,p=new f.Emitter,P=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(l){return(0,I.asWebviewUri)(l,b._initData.remote)}get cspSource(){return I.webviewGenericCspSource}set options(l){this._options=l,b._proxy.$setOptions(g,l)}get options(){return this._options}set html(l){this._html=l,b._proxy.$setHtml(g,l)}get html(){return this._html}get onDidReceiveMessage(){return d.event}postMessage(l){return b._proxy.$postMessage(g,l)}},_=new class{constructor(){this.editor=k,this.line=S,this.height=R,this.webview=P,this.onDidDispose=p.event}dispose(){b._insets.has(g)&&(b._insets.delete(g),b._proxy.$disposeEditorInset(g),p.fire(),p.dispose(),d.dispose())}};return this._proxy.$createEditorInset(g,v.id,v.value.document.uri,S+1,R,F||{},D.identifier,D.extensionLocation),this._insets.set(g,{editor:k,inset:_,onDidReceiveMessage:d}),_}$onDidDispose(k){const S=this._insets.get(k);S&&S.inset.dispose()}$onDidReceiveMessage(k,S){const R=this._insets.get(k);R&&R.onDidReceiveMessage.fire(S)}}e.ExtHostEditorInsets=A}),define(ve[126],we([1,0,3,16,176]),function(te,e,f,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class A{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new f.Emitter,this._onExit=new f.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(k){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=k}onEvent(k){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=k}onRequest(k){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=k}sendResponse(k){k.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${k.command}`)):this.internalSend("response",k)}sendRequest(k,S,R,F){const D={command:k};if(S&&Object.keys(S).length>0&&(D.arguments=S),this.internalSend("request",D),typeof F=="number"){const v=setTimeout(()=>{clearTimeout(v);const b=this.pendingRequests.get(D.seq);if(b){this.pendingRequests.delete(D.seq);const g={type:"response",seq:0,request_seq:D.seq,success:!1,command:k,message:(0,I.localize)(0,null,F,k)};b(g)}},F)}return R&&this.pendingRequests.set(D.seq,R),D.seq}acceptMessage(k){this.messageCallback?this.messageCallback(k):(this.queue.push(k),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(k,S){return k.type!=="event"||S.type!=="event"}async processQueue(){let k;for(;this.queue.length;){if((!k||this.needsTaskBoundaryBetween(this.queue[0],k))&&await(0,i.timeout)(0),k=this.queue.shift(),!k)return;switch(k.type){case"event":this.eventCallback&&this.eventCallback(k);break;case"request":this.requestCallback&&this.requestCallback(k);break;case"response":{const S=k,R=this.pendingRequests.get(S.request_seq);R&&(this.pendingRequests.delete(S.request_seq),R(S));break}}}}internalSend(k,S){S.type=k,S.seq=this.sequence++,this.sendMessage(S)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const k=new Map;this.pendingRequests.forEach((S,R)=>k.set(R,S)),await(0,i.timeout)(500),k.forEach((S,R)=>{S({type:"response",seq:0,request_seq:R,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(R)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=A}),define(ve[209],we([1,0,177,61,4]),function(te,e,f,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ACCESS_TYPE=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.DEBUG_SERVICE_ID=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.DEBUG_SERVICE_ID="debugService",e.CONTEXT_DEBUG_TYPE=new i.RawContextKey("debugType",void 0,{type:"string",description:f.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new i.RawContextKey("debugConfigurationType",void 0,{type:"string",description:f.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new i.RawContextKey("debugState","inactive",{type:"string",description:f.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new i.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:f.localize(3,null)}),e.CONTEXT_IN_DEBUG_MODE=new i.RawContextKey("inDebugMode",!1,{type:"boolean",description:f.localize(4,null)}),e.CONTEXT_IN_DEBUG_REPL=new i.RawContextKey("inDebugRepl",!1,{type:"boolean",description:f.localize(5,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new i.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:f.localize(6,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new i.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:f.localize(7,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new i.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:f.localize(8,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new i.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:f.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new i.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:f.localize(10,null)}),e.CONTEXT_VARIABLES_FOCUSED=new i.RawContextKey("variablesFocused",!0,{type:"boolean",description:f.localize(11,null)}),e.CONTEXT_EXPRESSION_SELECTED=new i.RawContextKey("expressionSelected",!1,{type:"boolean",description:f.localize(12,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new i.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:f.localize(13,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new i.RawContextKey("callStackItemType",void 0,{type:"string",description:f.localize(14,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new i.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:f.localize(15,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new i.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:f.localize(16,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new i.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:f.localize(17,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new i.RawContextKey("watchItemType",void 0,{type:"string",description:f.localize(18,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new i.RawContextKey("canViewMemory",void 0,{type:"boolean",description:f.localize(19,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new i.RawContextKey("breakpointItemType",void 0,{type:"string",description:f.localize(20,null)}),e.CONTEXT_BREAKPOINT_ACCESS_TYPE=new i.RawContextKey("breakpointAccessType",void 0,{type:"string",description:f.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new i.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:f.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new i.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:f.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new i.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:f.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new i.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:f.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new i.RawContextKey("stepBackSupported",!1,{type:"boolean",description:f.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new i.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:f.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new i.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:f.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new i.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:f.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new i.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:f.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new i.RawContextKey("breakpointsExist",!1,{type:"boolean",description:f.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new i.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:f.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new i.RawContextKey("debugExtensionAvailable",!1,{type:"boolean",description:f.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new i.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:f.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new i.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:f.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new i.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:f.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new i.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:f.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new i.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:f.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new i.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:f.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new i.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:f.localize(40,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new i.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:f.localize(41,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new i.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:f.localize(42,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new i.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:f.localize(43,null)}),e.CONTEXT_MULTI_SESSION_REPL=new i.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:f.localize(44,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new i.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:f.localize(45,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new i.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:f.localize(46,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new i.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:f.localize(47,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new i.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:f.localize(48,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new i.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:f.localize(49,null)});const A=D=>f.localize(50,null,D);e.debuggerDisabledMessage=A,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:f.localize(51,null)};var C;(function(D){D[D.Inactive=0]="Inactive",D[D.Initializing=1]="Initializing",D[D.Stopped=2]="Stopped",D[D.Running=3]="Running"})(C=e.State||(e.State={}));function k(D){switch(D){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=k;var S;(function(D){D[D.Valid=0]="Valid",D[D.Unreadable=1]="Unreadable",D[D.Error=2]="Error"})(S=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var R;(function(D){D[D.Initial=1]="Initial",D[D.Dynamic=2]="Dynamic"})(R=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={})),e.IDebugService=(0,I.createDecorator)(e.DEBUG_SERVICE_ID);var F;(function(D){D[D.CONDITION=0]="CONDITION",D[D.HIT_COUNT=1]="HIT_COUNT",D[D.LOG_MESSAGE=2]="LOG_MESSAGE"})(F=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(ve[210],we([1,0,8,2,9,25,10]),function(te,e,f,i,I,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const k=/{([^}]+)}/g;function S(s,t,r){return s.replace(k,function(n,o){return t&&o.length>0&&o[0]!=="_"?n:r&&r.hasOwnProperty(o)?r[o]:n})}e.formatPII=S;function R(s){const t={};for(const r of Object.keys(s))r.startsWith("!")||(t[r]=s[r]);return t}e.filterExceptionsFromTelemetry=R;function F(s){return s.configuration.request==="attach"&&!D(s)&&(!s.parentSession||F(s.parentSession))}e.isSessionAttach=F;function D(s){let t=s.configuration.type;if(!!t)return t==="vslsShare"&&(t=s.configuration.adapterProxy.configuration.type),(0,f.equalsIgnoreCase)(t,"extensionhost")||(0,f.equalsIgnoreCase)(t,"pwa-extensionhost")?s:s.parentSession?D(s.parentSession):void 0}e.getExtensionHostDebugSession=D;function v(s){return s.type&&(s.label||s.program||s.runtime)}e.isDebuggerMainContribution=v;function b(s,t,r){let n,o=0;const m=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let h=null;for(;h=m.exec(s);){const w=h.index+1,T=w+h[0].length;if(w<=t&&T>=r){n=h[0],o=w;break}}if(n){const w=/\w+/g;let T=null;for(;(T=w.exec(n))&&!(T.index+1+o+T[0].length>=r););T&&(n=n.substring(0,w.lastIndex))}return n?{start:o,end:o+n.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=b;const g=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function d(s){return!!(s&&s.match(g))}e.isUri=d;function p(s){if(typeof s.path=="string"&&!(typeof s.sourceReference=="number"&&s.sourceReference>0)){if(d(s.path))return i.URI.parse(s.path);if((0,I.isAbsolute)(s.path))return i.URI.file(s.path)}return s.path}function P(s){if(typeof s.path=="object"){const t=i.URI.revive(s.path);if(t)return t.scheme===C.Schemas.file?t.fsPath:t.toString()}return s.path}function _(s,t){const r=t?p:P,n=(0,A.deepClone)(s);return c(n,(o,m)=>{o&&m&&(m.path=r(m))}),n}e.convertToDAPaths=_;function l(s,t){const r=t?p:P,n=(0,A.deepClone)(s);return c(n,(o,m)=>{!o&&m&&(m.path=r(m))}),n}e.convertToVSCPaths=l;function c(s,t){switch(s.type){case"event":{const r=s;switch(r.event){case"output":t(!1,r.body.source);break;case"loadedSource":t(!1,r.body.source);break;case"breakpoint":t(!1,r.body.breakpoint.source);break;default:break}break}case"request":{const r=s;switch(r.command){case"setBreakpoints":t(!0,r.arguments.source);break;case"breakpointLocations":t(!0,r.arguments.source);break;case"source":t(!0,r.arguments.source);break;case"gotoTargets":t(!0,r.arguments.source);break;case"launchVSCode":r.arguments.args.forEach(n=>t(!1,n));break;default:break}break}case"response":{const r=s;if(r.success&&r.body)switch(r.command){case"stackTrace":r.body.stackFrames.forEach(n=>t(!1,n.source));break;case"loadedSources":r.body.sources.forEach(n=>t(!1,n));break;case"scopes":r.body.scopes.forEach(n=>t(!1,n.source));break;case"setFunctionBreakpoints":r.body.breakpoints.forEach(n=>t(!1,n.source));break;case"setBreakpoints":r.body.breakpoints.forEach(n=>t(!1,n.source));break;case"disassemble":{const n=r;n.body&&n.body.instructions.forEach(o=>t(!1,o.location))}break;default:break}break}}}function u(s){return s.filter(t=>!t.presentation?.hidden).sort((t,r)=>t.presentation?r.presentation?t.presentation.group?r.presentation.group?t.presentation.group!==r.presentation.group?t.presentation.group.localeCompare(r.presentation.group):a(t.presentation.order,r.presentation.order):-1:r.presentation.group?1:a(t.presentation.order,r.presentation.order):-1:r.presentation?1:0)}e.getVisibleAndSorted=u;function a(s,t){return typeof s!="number"?typeof t!="number"?0:1:typeof t!="number"?-1:s-t}async function E(s,t){const r=s.getValue("debug.saveBeforeStart",{overrideIdentifier:t.activeTextEditorLanguageId});if(r!=="none"&&(await t.saveAll(),r==="allEditorsInActiveGroup")){const n=t.activeEditorPane;n&&n.input.resource?.scheme===C.Schemas.untitled&&await t.save({editor:n.input,groupId:n.group.id})}await s.reloadConfiguration()}e.saveAllBeforeDebugStart=E}),define(ve[211],we([1,0,28,38,178,127,9,8,25,12,194,126]),function(te,e,f,i,I,A,C,k,S,R,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class v extends D.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(_,l){this.outputStream=l,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,_.on("data",c=>this.handleData(c))}sendMessage(_){if(this.outputStream){const l=JSON.stringify(_);this.outputStream.write(`Content-Length: ${Buffer.byteLength(l,"utf8")}${v.TWO_CRLF}${l}`,"utf8")}}handleData(_){for(this.rawData=Buffer.concat([this.rawData,_]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const l=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,l.length>0)try{this.acceptMessage(JSON.parse(l))}catch(c){this._onError.fire(new Error((c.message||c)+`
`+l))}continue}}else{const l=this.rawData.indexOf(v.TWO_CRLF);if(l!==-1){const u=this.rawData.toString("utf8",0,l).split(v.HEADER_LINESEPARATOR);for(const a of u){const E=a.split(v.HEADER_FIELDSEPARATOR);E[0]==="Content-Length"&&(this.contentLength=Number(E[1]))}this.rawData=this.rawData.slice(l+v.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=v,v.TWO_CRLF=`\r
\r
`,v.HEADER_LINESEPARATOR=/\r?\n/,v.HEADER_FIELDSEPARATOR=/: */;class b extends v{startSession(){return new Promise((_,l)=>{let c=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),_(),c=!0}),this.socket.on("close",()=>{c?this._onError.fire(new Error("connection closed")):l(new Error("connection closed"))}),this.socket.on("error",u=>{c?this._onError.fire(u):l(u)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=b;class g extends b{constructor(_){super();this.adapterServer=_}createConnection(_){return A.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",_)}}e.SocketDebugAdapter=g;class d extends b{constructor(_){super();this.adapterServer=_}createConnection(_){return A.createConnection(this.adapterServer.path,_)}}e.NamedPipeDebugAdapter=d;class p extends v{constructor(_,l,c){super();this.adapterExecutable=_,this.debugType=l,this.outputService=c}async startSession(){const _=this.adapterExecutable.command,l=this.adapterExecutable.args,c=this.adapterExecutable.options||{};try{if(_)if(C.isAbsolute(_)){if(!await f.Promises.exists(_))throw new Error(I.localize(0,null,_))}else _.indexOf("/")<0&&_.indexOf("\\")<0;else throw new Error(I.localize(1,null,this.debugType));let u=process.env;if(c.env&&Object.keys(c.env).length>0&&(u=S.mixin(S.deepClone(process.env),c.env)),_==="node")if(Array.isArray(l)&&l.length>0){const E=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,s={env:u,execArgv:E?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};c.cwd&&(s.cwd=c.cwd);const t=i.fork(l[0],l.slice(1),s);if(!t.pid)throw new Error(I.localize(2,null,l[0]));this.serverProcess=t}else throw new Error(I.localize(3,null));else{const E={env:u};c.cwd&&(E.cwd=c.cwd),this.serverProcess=i.spawn(_,l,E)}this.serverProcess.on("error",E=>{this._onError.fire(E)}),this.serverProcess.on("exit",(E,s)=>{this._onExit.fire(E)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",E=>{this._onError.fire(E)}),this.serverProcess.stdin.on("error",E=>{this._onError.fire(E)});const a=this.outputService;if(a){const E=s=>s.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",s=>{const t=a.getChannel(F.ExtensionsChannelId);t&&t.append(E(s))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(u){this._onError.fire(u)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),R.isWindows?new Promise((_,l)=>{const c=i.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(u,a,E){if(u)return l(u)});c.on("exit",_),c.on("error",l)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(_,l){if(!_)return;const c=Object.create(null);_.runtime&&(_.runtime.indexOf("./")===0?c.runtime=C.join(l,_.runtime):c.runtime=_.runtime),_.runtimeArgs&&(c.runtimeArgs=_.runtimeArgs),_.program&&(C.isAbsolute(_.program)?c.program=_.program:c.program=C.join(l,_.program)),_.args&&(c.args=_.args);const u=_;return u.win&&(c.win=p.extract(u.win,l)),u.winx86&&(c.winx86=p.extract(u.winx86,l)),u.windows&&(c.windows=p.extract(u.windows,l)),u.osx&&(c.osx=p.extract(u.osx,l)),u.linux&&(c.linux=p.extract(u.linux,l)),c}static platformAdapterExecutable(_,l){let c=Object.create(null);l=l.toLowerCase();for(const r of _)if(r.contributes){const n=r.contributes.debuggers;n&&n.length>0&&n.filter(o=>typeof o.type=="string"&&k.equalsIgnoreCase(o.type,l)).forEach(o=>{const m=p.extract(o,r.extensionLocation.fsPath);c=S.mixin(c,m,r.isBuiltin)})}let u;R.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?u=c.winx86||c.win||c.windows:R.isWindows?u=c.win||c.windows:R.isMacintosh?u=c.osx:R.isLinux&&(u=c.linux),u=u||c;const a=u.program||c.program,E=u.args||c.args,s=u.runtime||c.runtime,t=u.runtimeArgs||c.runtimeArgs;if(s)return{type:"executable",command:s,args:(t||[]).concat(typeof a=="string"?[a]:[]).concat(E||[])};if(a)return{type:"executable",command:a,args:E||[]}}}e.ExecutableDebugAdapter=p}),define(ve[212],we([1,0,38,29,12]),function(te,e,f,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=void 0;function A(R,F){return new Promise((D,v)=>{let b="";const g=f.spawn(R,F);g.pid&&g.stdout.on("data",d=>{b+=d.toString()}),g.on("error",d=>{v(d)}),g.on("close",d=>{D(b)})})}async function C(R){if(R)if(I.isWindows){const F=await new Promise((D,v)=>{te(["windows-process-tree"],D,v)});return new Promise(D=>{F.getProcessTree(R,v=>{D(v.children.length>0)})})}else return A("/usr/bin/pgrep",["-lP",String(R)]).then(F=>{const D=F.trim();return!(D.length===0||D.indexOf(" tmux")>=0)},F=>!0);return Promise.resolve(!0)}e.hasChildProcesses=C;var k;(function(R){R[R.cmd=0]="cmd",R[R.powershell=1]="powershell",R[R.bash=2]="bash"})(k||(k={}));function S(R,F,D,v){R=R.trim().toLowerCase();let b;R.indexOf("powershell")>=0||R.indexOf("pwsh")>=0?b=1:R.indexOf("cmd.exe")>=0?b=0:R.indexOf("bash")>=0?b=2:I.isWindows?b=0:b=2;let g,d=" ";switch(b){case 1:if(g=p=>(p=p.replace(/\'/g,"''"),p.length>0&&p.charAt(p.length-1)==="\\"?`'${p}\\'`:`'${p}'`),D){const p=(0,i.getDriveLetter)(D);p&&(d+=`${p}:; `),d+=`cd ${g(D)}; `}if(v)for(const p in v){const P=v[p];P===null?d+=`Remove-Item env:${p}; `:d+=`\${env:${p}}='${P}'; `}if(F.length>0){const p=g(F.shift());d+=p[0]==="'"?`& ${p} `:`${p} `;for(const P of F)d+=`${g(P)} `}break;case 0:if(g=p=>(p=p.replace(/\"/g,'""'),p.indexOf(" ")>=0||p.indexOf('"')>=0||p.length===0?`"${p}"`:p),D){const p=(0,i.getDriveLetter)(D);p&&(d+=`${p}: && `),d+=`cd ${g(D)} && `}if(v){d+='cmd /C "';for(const p in v){let P=v[p];P===null?d+=`set "${p}=" && `:(P=P.replace(/[\^\&\|\<\>]/g,_=>`^${_}`),d+=`set "${p}=${P}" && `)}}for(const p of F)d+=`${g(p)} `;v&&(d+='"');break;case 2:{g=P=>(P=P.replace(/(["'\\\$])/g,"\\$1"),P.indexOf(" ")>=0||P.indexOf(";")>=0||P.length===0?`"${P}"`:P);const p=P=>/[^\w@%\/+=,.:^-]/.test(P)?`'${P.replace(/'/g,"'\\''")}'`:P;if(D&&(d+=`cd ${g(D)} ; `),v){d+="/usr/bin/env";for(const P in v){const _=v[P];_===null?d+=` -u ${p(P)}`:d+=` ${p(`${P}=${_}`)}`}d+=" "}for(const P of F)d+=`${g(P)} `;break}}return d}e.prepareCommand=S}),define(ve[128],we([1,0,32,76,92,10,9,12,61]),function(te,e,f,i,I,A,C,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor";var R;(function(n){n[n.Markup=1]="Markup",n[n.Code=2]="Code"})(R=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",I.Mimes.latex,I.Mimes.markdown,"image/png","image/jpeg",I.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[I.Mimes.latex,I.Mimes.markdown,"application/json",I.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var F;(function(n){n[n.Running=1]="Running",n[n.Idle=2]="Idle"})(F=e.NotebookRunState||(e.NotebookRunState={}));var D;(function(n){n[n.Unconfirmed=1]="Unconfirmed",n[n.Pending=2]="Pending",n[n.Executing=3]="Executing"})(D=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var v;(function(n){n[n.WithHardKernelDependency=0]="WithHardKernelDependency",n[n.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",n[n.Pure=2]="Pure",n[n.Never=3]="Never"})(v=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var b;(function(n){n.Always="always",n.Never="never",n.Optional="optional"})(b=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var g;(function(n){n[n.ModelChange=1]="ModelChange",n[n.Move=2]="Move",n[n.ChangeLanguage=5]="ChangeLanguage",n[n.Initialize=6]="Initialize",n[n.ChangeCellMetadata=7]="ChangeCellMetadata",n[n.Output=8]="Output",n[n.OutputItem=9]="OutputItem",n[n.ChangeCellContent=10]="ChangeCellContent",n[n.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",n[n.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",n[n.ChangeCellMime=13]="ChangeCellMime",n[n.Unknown=100]="Unknown"})(g=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var d;(function(n){n[n.Handle=0]="Handle",n[n.Index=1]="Index"})(d=e.SelectionStateType||(e.SelectionStateType={}));var p;(function(n){n[n.Replace=1]="Replace",n[n.Output=2]="Output",n[n.Metadata=3]="Metadata",n[n.CellLanguage=4]="CellLanguage",n[n.DocumentMetadata=5]="DocumentMetadata",n[n.Move=6]="Move",n[n.OutputItems=7]="OutputItems",n[n.PartialMetadata=8]="PartialMetadata",n[n.PartialInternalMetadata=9]="PartialInternalMetadata"})(p=e.CellEditType||(e.CellEditType={}));var P;(function(n){n.scheme=A.Schemas.vscodeNotebookCell;const o=/^ch(\d{7,})/;function m(y,H){return y.with({scheme:n.scheme,fragment:`ch${H.toString().padStart(7,"0")}${y.scheme!==A.Schemas.file?y.scheme:""}`})}n.generate=m;function h(y){if(y.scheme!==n.scheme)return;const H=o.exec(y.fragment);return H?{handle:Number(H[1]),notebook:y.with({scheme:y.fragment.substring(H[0].length)||A.Schemas.file,fragment:null})}:void 0}n.parse=h;function w(y,H){return y.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${H??""},${y.scheme!==A.Schemas.file?y.scheme:""}`})}n.generateCellOutputUri=w;function T(y){if(y.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const H=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(y.fragment);if(!H)return;const M=H[1]&&H[1]!==""?H[1]:void 0,j=H[2];return{outputId:M,notebook:y.with({scheme:j||A.Schemas.file,fragment:null})}}n.parseCellOutputUri=T;function L(y,H,M){return y.with({scheme:M,fragment:`ch${H.toString().padStart(7,"0")}${y.scheme!==A.Schemas.file?y.scheme:""}`})}n.generateCellUri=L;function O(y,H){if(y.scheme!==H)return;const M=o.exec(y.fragment);return M?{handle:Number(M[1]),notebook:y.with({scheme:y.fragment.substring(M[0].length)||A.Schemas.file,fragment:null})}:void 0}n.parseCellUri=O})(P=e.CellUri||(e.CellUri={}));const _=n=>k.isWindows?n.replace(/\//g,"\\"):n;class l{constructor(o=[],m=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=m,this.order=[...new Set(o)].map(h=>({pattern:h,matches:f.parse(_(h))}))}sort(o){const m=new Map(i.Iterable.map(o,w=>[w,_(w)]));let h=[];for(const{matches:w}of this.order)for(const[T,L]of m)if(w(L)){h.push(T),m.delete(T);break}return m.size&&(h=h.concat([...m.keys()].sort((w,T)=>this.defaultOrder.indexOf(w)-this.defaultOrder.indexOf(T)))),h}prioritize(o,m){const h=this.findIndex(o);if(h===-1){this.order.unshift({pattern:o,matches:f.parse(_(o))});return}const w=new Set(m.map(L=>this.findIndex(L,h)));w.delete(-1);const T=Array.from(w).sort();this.order.splice(h+1,0,...T.map(L=>this.order[L]));for(let L=T.length-1;L>=0;L--)this.order.splice(T[L],1)}toArray(){return this.order.map(o=>o.pattern)}findIndex(o,m=this.order.length){const h=_(o);for(let w=0;w<m;w++)if(this.order[w].matches(h))return w;return-1}}e.MimeTypeDisplayOrder=l;function c(n,o,m,h=(w,T)=>w===T){const w=[];function T(y,H,M){if(H===0&&M.length===0)return;const j=w[w.length-1];j&&j.start+j.deleteCount===y?(j.deleteCount+=H,j.toInsert.push(...M)):w.push({start:y,deleteCount:H,toInsert:M})}let L=0,O=0;for(;;){if(L===n.length){T(L,0,o.slice(O));break}if(O===o.length){T(L,n.length-L,[]);break}const y=n[L],H=o[O];if(h(y,H)){L+=1,O+=1;continue}m(H)?(T(L,1,[]),L+=1):(T(L,0,[H]),O+=1)}return w}e.diff=c,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new S.RawContextKey("notebookEditorCursorAtBoundary","none");var u;(function(n){n.default="default",n.option="option"})(u=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function a(n){const o=n;return!!((typeof o.include=="string"||f.isRelativePattern(o.include))&&(typeof o.exclude=="string"||f.isRelativePattern(o.exclude)))}e.isDocumentExcludePattern=a;function E(n,o,m){if(Array.isArray(n.viewType)&&n.viewType.indexOf(o)>=0||n.viewType===o)return!0;if(n.filenamePattern){const h=a(n.filenamePattern)?n.filenamePattern.include:n.filenamePattern,w=a(n.filenamePattern)?n.filenamePattern.exclude:void 0;if(f.match(h,(0,C.basename)(m.fsPath).toLowerCase()))return!(w&&f.match(w,(0,C.basename)(m.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=E;class s{constructor(o){this.textModel=o}getElements(){const o=new Int32Array(this.textModel.cells.length);for(let m=0;m<this.textModel.cells.length;m++)o[m]=this.textModel.cells[m].getHashValue();return o}}e.CellSequence=s,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode"};var t;(function(n){n[n.Left=1]="Left",n[n.Right=2]="Right"})(t=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class r{static create(o){return`${r._prefix}${o}`}static parse(o){if(o.startsWith(r._prefix))return o.substring(r._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=r,r._prefix="notebook/"}),define(ve[213],we([1,0,4]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var i;(function(I){I[I.Output=1]="Output",I[I.OutputItems=2]="OutputItems",I[I.ExecutionState=3]="ExecutionState"})(i=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,f.createDecorator)("INotebookExecutionService")}),define(ve[214],we([1,0,4,61]),function(te,e,f,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new i.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new i.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new i.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,f.createDecorator)(e.OUTPUT_SERVICE_ID);var I;(function(A){A[A.Append=1]="Append",A[A.Replace=2]="Replace",A[A.Clear=3]="Clear"})(I=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={}))}),define(ve[215],we([1,0,179,4,61]),function(te,e,f,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new I.RawContextKey("customExecutionSupported",!0,f.localize(0,null)),e.ShellExecutionSupportedContext=new I.RawContextKey("shellExecutionSupported",!1,f.localize(1,null)),e.ProcessExecutionSupportedContext=new I.RawContextKey("processExecutionSupported",!1,f.localize(2,null)),e.ITaskService=(0,i.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(ve[216],we([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function f(I){return[...I.entries()]}e.serializeEnvironmentVariableCollection=f;function i(I){return new Map(I)}e.deserializeEnvironmentVariableCollection=i}),define(ve[84],we([1,0,2,35]),function(te,e,f,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var I;(function(r){r[r.Unset=0]="Unset",r[r.Queued=1]="Queued",r[r.Running=2]="Running",r[r.Passed=3]="Passed",r[r.Failed=4]="Failed",r[r.Skipped=5]="Skipped",r[r.Errored=6]="Errored"})(I=e.TestResultState||(e.TestResultState={}));var A;(function(r){r[r.Run=2]="Run",r[r.Debug=4]="Debug",r[r.Coverage=8]="Coverage",r[r.HasNonDefaultProfile=16]="HasNonDefaultProfile",r[r.HasConfigurable=32]="HasConfigurable"})(A=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var C;(function(r){r.serialize=n=>({range:n.range.toJSON(),uri:n.uri.toJSON()}),r.deserialize=n=>({range:i.Range.lift(n.range),uri:f.URI.revive(n.uri)})})(C=e.IRichLocation||(e.IRichLocation={}));var k;(function(r){r[r.Error=0]="Error",r[r.Info=1]="Info"})(k=e.TestMessageType||(e.TestMessageType={}));var S;(function(r){r.serialize=n=>({message:n.message,type:0,expected:n.expected,actual:n.actual,location:n.location&&C.serialize(n.location)}),r.deserialize=n=>({message:n.message,type:0,expected:n.expected,actual:n.actual,location:n.location&&C.deserialize(n.location)})})(S=e.ITestErrorMessage||(e.ITestErrorMessage={}));var R;(function(r){r.serialize=n=>({message:n.message,type:1,offset:n.offset,location:n.location&&C.serialize(n.location)}),r.deserialize=n=>({message:n.message,type:1,offset:n.offset,location:n.location&&C.deserialize(n.location)})})(R=e.ITestOutputMessage||(e.ITestOutputMessage={}));var F;(function(r){r.serialize=n=>n.type===0?S.serialize(n):R.serialize(n),r.deserialize=n=>n.type===0?S.deserialize(n):R.deserialize(n)})(F=e.ITestMessage||(e.ITestMessage={}));var D;(function(r){r.serialize=n=>({state:n.state,duration:n.duration,messages:n.messages.map(F.serialize)}),r.deserialize=n=>({state:n.state,duration:n.duration,messages:n.messages.map(F.deserialize)})})(D=e.ITestTaskState||(e.ITestTaskState={}));const v="\0",b=(r,n)=>r+v+n;e.namespaceTestTag=b;const g=r=>{const n=r.indexOf(v);return{ctrlId:r.slice(0,n),tagId:r.slice(n+1)}};e.denamespaceTestTag=g;var d;(function(r){r.serialize=n=>({extId:n.extId,label:n.label,tags:n.tags,busy:n.busy,children:void 0,uri:n.uri?.toJSON(),range:n.range?.toJSON()||null,description:n.description,error:n.error,sortText:n.sortText}),r.deserialize=n=>({extId:n.extId,label:n.label,tags:n.tags,busy:n.busy,children:void 0,uri:n.uri?f.URI.revive(n.uri):void 0,range:n.range?i.Range.lift(n.range):null,description:n.description,error:n.error,sortText:n.sortText})})(d=e.ITestItem||(e.ITestItem={}));var p;(function(r){r[r.NotExpandable=0]="NotExpandable",r[r.Expandable=1]="Expandable",r[r.BusyExpanding=2]="BusyExpanding",r[r.Expanded=3]="Expanded"})(p=e.TestItemExpandState||(e.TestItemExpandState={}));var P;(function(r){r.serialize=n=>({controllerId:n.controllerId,expand:n.expand,parent:n.parent,item:d.serialize(n.item)}),r.deserialize=n=>({controllerId:n.controllerId,expand:n.expand,parent:n.parent,item:d.deserialize(n.item)})})(P=e.InternalTestItem||(e.InternalTestItem={}));var _;(function(r){r.serialize=n=>{let o;return n.item&&(o={},n.item.label!==void 0&&(o.label=n.item.label),n.item.tags!==void 0&&(o.tags=n.item.tags),n.item.busy!==void 0&&(o.busy=n.item.busy),n.item.uri!==void 0&&(o.uri=n.item.uri?.toJSON()),n.item.range!==void 0&&(o.range=n.item.range?.toJSON()),n.item.description!==void 0&&(o.description=n.item.description),n.item.error!==void 0&&(o.error=n.item.error),n.item.sortText!==void 0&&(o.sortText=n.item.sortText)),{extId:n.extId,expand:n.expand,item:o}},r.deserialize=n=>{let o;return n.item&&(o={},n.item.label!==void 0&&(o.label=n.item.label),n.item.tags!==void 0&&(o.tags=n.item.tags),n.item.busy!==void 0&&(o.busy=n.item.busy),n.item.range!==void 0&&(o.range=n.item.range?i.Range.lift(n.item.range):null),n.item.description!==void 0&&(o.description=n.item.description),n.item.error!==void 0&&(o.error=n.item.error),n.item.sortText!==void 0&&(o.sortText=n.item.sortText)),{extId:n.extId,expand:n.expand,item:o}}})(_=e.ITestItemUpdate||(e.ITestItemUpdate={}));const l=(r,n)=>{n.expand!==void 0&&(r.expand=n.expand),n.item!==void 0&&(r.item=r.item?Object.assign(r.item,n.item):n.item)};e.applyTestItemUpdate=l;var c;(function(r){r.serialize=(n,o)=>({...P.serialize(n),children:o,ownComputedState:n.ownComputedState,computedState:n.computedState,tasks:n.tasks.map(D.serialize)})})(c=e.TestResultItem||(e.TestResultItem={}));var u;(function(r){r[r.Function=0]="Function",r[r.Statement=1]="Statement"})(u=e.DetailType||(e.DetailType={}));var a;(function(r){r[r.Add=0]="Add",r[r.Update=1]="Update",r[r.Remove=2]="Remove",r[r.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",r[r.Retire=4]="Retire",r[r.AddTag=5]="AddTag",r[r.RemoveTag=6]="RemoveTag"})(a=e.TestDiffOpType||(e.TestDiffOpType={}));var E;(function(r){r.deserialize=n=>n.op===0?{op:n.op,item:P.deserialize(n.item)}:n.op===1?{op:n.op,item:_.deserialize(n.item)}:n,r.serialize=n=>n.op===0?{op:n.op,item:P.serialize(n.item)}:n.op===1?{op:n.op,item:_.serialize(n.item)}:n})(E=e.TestsDiffOp||(e.TestsDiffOp={}));class s{add(n){}update(n){}remove(n,o){}complete(){}}e.IncrementalChangeCollector=s;class t{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(n){const o=this.createChangeCollector();for(const m of n)switch(m.op){case 0:{const h=P.deserialize(m.item);if(h.parent){if(this.items.has(h.parent)){const w=this.items.get(h.parent);w.children.add(h.item.extId);const T=this.createItem(h,w);this.items.set(h.item.extId,T),o.add(T)}}else{const w=this.createItem(h);this.roots.add(w),this.items.set(h.item.extId,w),o.add(w)}h.expand===2&&this.busyControllerCount++;break}case 1:{const h=_.deserialize(m.item),w=this.items.get(h.extId);if(!w)break;h.expand!==void 0&&(w.expand===2&&this.busyControllerCount--,h.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(w,h),o.update(w);break}case 2:{const h=this.items.get(m.itemId);if(!h)break;h.parent?this.items.get(h.parent).children.delete(h.item.extId):this.roots.delete(h);const w=[[m.itemId]];for(;w.length;)for(const T of w.pop()){const L=this.items.get(T);L&&(w.push(L.children),this.items.delete(T),o.remove(L,L!==h),L.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(m.itemId);break;case 3:this.updatePendingRoots(m.amount);break;case 5:this._tags.set(m.tag.id,m.tag);break;case 6:this._tags.delete(m.id);break}o.complete()}retireTest(n){}updatePendingRoots(n){this.pendingRootCount+=n}createChangeCollector(){return new s}}e.AbstractIncrementalTestCollection=t}),define(ve[85],we([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var f;(function(A){A.Delimiter="\0"})(f=e.TestIdPathParts||(e.TestIdPathParts={}));var i;(function(A){A[A.IsSame=0]="IsSame",A[A.Disconnected=1]="Disconnected",A[A.IsChild=2]="IsChild",A[A.IsParent=3]="IsParent"})(i=e.TestPosition||(e.TestPosition={}));class I{constructor(C,k=C.length){if(this.path=C,this.viewEnd=k,C.length===0||k<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(C,k,S=C.parent){if(C.id===k)return new I([k]);let R=[C.id];for(let F=S;F&&F.id!==k;F=F.parent)R.push(F.id);return R.push(k),new I(R.reverse())}static isRoot(C){return!C.includes("\0")}static root(C){const k=C.indexOf("\0");return k===-1?C:C.slice(0,k)}static fromString(C){return new I(C.split("\0"))}static join(C,k){return new I([...C.path,k])}static joinToString(C,k){return C.toString()+"\0"+k}static compare(C,k){return C===k?0:k.startsWith(C+"\0")?2:C.startsWith(k+"\0")?3:1}get parentId(){return this.viewEnd>1?new I(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let C=1;C<=this.viewEnd;C++)yield new I(this.path,C)}compare(C){if(typeof C=="string")return I.compare(this.toString(),C);for(let k=0;k<C.viewEnd&&k<this.viewEnd;k++)if(C.path[k]!==this.path[k])return 1;return C.viewEnd>this.viewEnd?2:C.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let C=1;C<this.viewEnd;C++)this.stringifed+="\0",this.stringifed+=this.path[C]}return this.stringifed}}e.TestId=I}),define(ve[217],we([1,0,9,41,13,25,12,100,180]),function(te,e,f,i,I,A,C,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class R{constructor(D,v,b,g){this._contributedVariables=new Map,this._context=D,this._labelService=v,this._userHomePromise=b,g&&(this._envVariablesPromise=g.then(d=>this.prepareEnv(d)))}prepareEnv(D){if(C.isWindows){const v=Object.create(null);return Object.keys(D).forEach(b=>{v[b.toLowerCase()]=D[b]}),v}return D}resolveWithEnvironment(D,v,b){return this.recursiveResolve(this.prepareEnv(D),v?v.uri:void 0,b)}async resolveAsync(D,v){const b={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(b,D?D.uri:void 0,v)}async resolveAnyBase(D,v,b,g){const d=A.deepClone(v);C.isWindows&&d.windows?Object.keys(d.windows).forEach(P=>d[P]=d.windows[P]):C.isMacintosh&&d.osx?Object.keys(d.osx).forEach(P=>d[P]=d.osx[P]):C.isLinux&&d.linux&&Object.keys(d.linux).forEach(P=>d[P]=d.linux[P]),delete d.windows,delete d.osx,delete d.linux;const p={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(p,D?D.uri:void 0,d,b,g)}async resolveAnyAsync(D,v,b){return this.resolveAnyBase(D,v,b)}async resolveAnyMap(D,v,b){const g=new Map;return{newConfig:await this.resolveAnyBase(D,v,b,g),resolvedVariables:g}}resolveWithInteractionReplace(D,v,b,g){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(D,v,b,g){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(D,v){if(this._contributedVariables.has(D))throw new Error("Variable "+D+" is contributed twice.");this._contributedVariables.set(D,v)}recursiveResolve(D,v,b,g,d){if(I.isString(b))return this.resolveString(D,v,b,g,d);if(I.isArray(b))return b.map(p=>this.recursiveResolve(D,v,p,g,d));if(I.isObject(b)){let p=Object.create(null);return Object.keys(b).forEach(P=>{const _=this.resolveString(D,v,P,g,d);p[_]=this.recursiveResolve(D,v,b[P],g,d)}),p}return b}resolveString(D,v,b,g,d){return b.replace(R.VARIABLE_REGEXP,(P,_)=>{if(_.includes(R.VARIABLE_LHS))return P;let l=this.evaluateSingleVariable(D,P,_,v,g);return d&&d.set(_,l),l!==P&&I.isString(l)&&l.match(R.VARIABLE_REGEXP)&&(l=this.resolveString(D,v,l,g,d)),l})}fsPath(D){return this._labelService?this._labelService.getUriLabel(D,{noPrefix:!0}):D.fsPath}evaluateSingleVariable(D,v,b,g,d){let p;const P=b.split(":");P.length>1&&(b=P[0],p=P[1]);const _=()=>{const u=this._context.getFilePath();if(u)return u;throw new Error((0,S.localize)(0,null,v))},l=()=>{const u=_();if(this._context.getWorkspaceFolderPathForFile){const a=this._context.getWorkspaceFolderPathForFile();if(a)return a}throw new Error((0,S.localize)(1,null,v,f.basename(u)))},c=()=>{if(p){const u=this._context.getFolderUri(p);if(u)return u;throw new Error((0,S.localize)(2,null,v,p))}if(g)return g;throw this._context.getWorkspaceFolderCount()>1?new Error((0,S.localize)(3,null,v)):new Error((0,S.localize)(4,null,v))};switch(b){case"env":if(p){if(D.env){const u=D.env[C.isWindows?p.toLowerCase():p];if(I.isString(u))return u}return""}throw new Error((0,S.localize)(5,null,v));case"config":if(p){const u=this._context.getConfigurationValue(g,p);if(I.isUndefinedOrNull(u))throw new Error((0,S.localize)(6,null,v,p));if(I.isObject(u))throw new Error((0,S.localize)(7,null,v,p));return u}throw new Error((0,S.localize)(8,null,v));case"command":return this.resolveFromMap(v,p,d,"command");case"input":return this.resolveFromMap(v,p,d,"input");default:switch(b){case"workspaceRoot":case"workspaceFolder":return(0,k.normalizeDriveLetter)(this.fsPath(c()));case"cwd":return g||p?(0,k.normalizeDriveLetter)(this.fsPath(c())):i.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return f.basename(this.fsPath(c()));case"userHome":{if(D.userHome)return D.userHome;throw new Error((0,S.localize)(9,null,v))}case"lineNumber":{const u=this._context.getLineNumber();if(u)return u;throw new Error((0,S.localize)(10,null,v))}case"selectedText":{const u=this._context.getSelectedText();if(u)return u;throw new Error((0,S.localize)(11,null,v))}case"file":return _();case"fileWorkspaceFolder":return l();case"relativeFile":return g||p?f.relative(this.fsPath(c()),_()):_();case"relativeFileDirname":{const u=f.dirname(_());if(g||p){const a=f.relative(this.fsPath(c()),u);return a.length===0?".":a}return u}case"fileDirname":return f.dirname(_());case"fileExtname":return f.extname(_());case"fileBasename":return f.basename(_());case"fileBasenameNoExtension":{const u=f.basename(_());return u.slice(0,u.length-f.extname(u).length)}case"fileDirnameBasename":return f.basename(f.dirname(_()));case"execPath":{const u=this._context.getExecPath();return u||v}case"execInstallFolder":{const u=this._context.getAppRoot();return u||v}case"pathSeparator":return f.sep;default:try{const u=p?`${b}:${p}`:b;return this.resolveFromMap(v,u,d,void 0)}catch{return v}}}}resolveFromMap(D,v,b,g){if(v&&b){const d=g===void 0?b[v]:b[g+":"+v];if(typeof d=="string")return d;throw new Error((0,S.localize)(12,null,D))}return D}}e.AbstractVariableResolverService=R,R.VARIABLE_LHS="${",R.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(ve[129],we([1,0,4,207]),function(te,e,f,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,f.createDecorator)("editorGroupsService");var I;(function(g){g[g.UP=0]="UP",g[g.DOWN=1]="DOWN",g[g.LEFT=2]="LEFT",g[g.RIGHT=3]="RIGHT"})(I=e.GroupDirection||(e.GroupDirection={}));var A;(function(g){g[g.HORIZONTAL=0]="HORIZONTAL",g[g.VERTICAL=1]="VERTICAL"})(A=e.GroupOrientation||(e.GroupOrientation={}));var C;(function(g){g[g.FIRST=0]="FIRST",g[g.LAST=1]="LAST",g[g.NEXT=2]="NEXT",g[g.PREVIOUS=3]="PREVIOUS"})(C=e.GroupLocation||(e.GroupLocation={}));var k;(function(g){g[g.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",g[g.EVEN=1]="EVEN",g[g.TOGGLE=2]="TOGGLE"})(k=e.GroupsArrangement||(e.GroupsArrangement={}));var S;(function(g){g[g.COPY_EDITORS=0]="COPY_EDITORS",g[g.MOVE_EDITORS=1]="MOVE_EDITORS"})(S=e.MergeGroupMode||(e.MergeGroupMode={}));function R(g){const d=g;return(0,i.isEditorInput)(d?.editor)&&(0,i.isEditorInput)(d?.replacement)}e.isEditorReplacement=R;var F;(function(g){g[g.CREATION_TIME=0]="CREATION_TIME",g[g.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",g[g.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(F=e.GroupsOrder||(e.GroupsOrder={}));var D;(function(g){g[g.NEW_EDITOR=1]="NEW_EDITOR",g[g.MOVE_EDITOR=2]="MOVE_EDITOR",g[g.COPY_EDITOR=3]="COPY_EDITOR"})(D=e.OpenEditorContext||(e.OpenEditorContext={}));function v(g){const d=g;return!!d&&typeof d.id=="number"&&Array.isArray(d.editors)}e.isEditorGroup=v;function b(g){return g.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=b}),define(ve[218],we([1,0,4,129]),function(te,e,f,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,f.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function I(A){const C=A;return typeof A=="number"||(0,i.isEditorGroup)(C)}e.isPreferredGroup=I}),define(ve[14],we([1,0,18,22,99,142,58,25,13,2,35,78,182,116,62,128,84,85,218,7]),function(te,e,f,i,I,A,C,k,S,R,F,D,v,b,g,d,p,P,_,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var c;(function(_e){function ye(ie){const{selectionStartLineNumber:Ie,selectionStartColumn:Re,positionLineNumber:Ve,positionColumn:Ke}=ie,ht=new l.Position(Ie-1,Re-1),Et=new l.Position(Ve-1,Ke-1);return new l.Selection(ht,Et)}_e.to=ye;function me(ie){const{anchor:Ie,active:Re}=ie;return{selectionStartLineNumber:Ie.line+1,selectionStartColumn:Ie.character+1,positionLineNumber:Re.line+1,positionColumn:Re.character+1}}_e.from=me})(c=e.Selection||(e.Selection={}));var u;(function(_e){function ye(ie){if(!ie)return;const{start:Ie,end:Re}=ie;return{startLineNumber:Ie.line+1,startColumn:Ie.character+1,endLineNumber:Re.line+1,endColumn:Re.character+1}}_e.from=ye;function me(ie){if(!ie)return;const{startLineNumber:Ie,startColumn:Re,endLineNumber:Ve,endColumn:Ke}=ie;return new l.Range(Ie-1,Re-1,Ve-1,Ke-1)}_e.to=me})(u=e.Range||(e.Range={}));var a;(function(_e){function ye(me){switch(me){case 1:return l.StandardTokenType.Comment;case 0:return l.StandardTokenType.Other;case 3:return l.StandardTokenType.RegEx;case 2:return l.StandardTokenType.String}}_e.to=ye})(a=e.TokenType||(e.TokenType={}));var E;(function(_e){function ye(ie){return new l.Position(ie.lineNumber-1,ie.column-1)}_e.to=ye;function me(ie){return{lineNumber:ie.line+1,column:ie.character+1}}_e.from=me})(E=e.Position||(e.Position={}));var s;(function(_e){function ye(Ie,Re){return(0,f.coalesce)((0,f.asArray)(Ie).map(Ve=>me(Ve,Re)))}_e.from=ye;function me(Ie,Re){if(typeof Ie=="string")return{$serialized:!0,language:Ie};if(Ie)return{$serialized:!0,language:Ie.language,scheme:ie(Ie.scheme,Re),pattern:J.from(Ie.pattern)??void 0,exclusive:Ie.exclusive,notebookType:Ie.notebookType}}function ie(Ie,Re){return Re&&typeof Ie=="string"?Re.transformOutgoingScheme(Ie):Ie}})(s=e.DocumentSelector||(e.DocumentSelector={}));var t;(function(_e){function ye(ie){switch(ie){case l.DiagnosticTag.Unnecessary:return 1;case l.DiagnosticTag.Deprecated:return 2}}_e.from=ye;function me(ie){switch(ie){case 1:return l.DiagnosticTag.Unnecessary;case 2:return l.DiagnosticTag.Deprecated;default:return}}_e.to=me})(t=e.DiagnosticTag||(e.DiagnosticTag={}));var r;(function(_e){function ye(ie){let Ie;return ie.code&&((0,S.isString)(ie.code)||(0,S.isNumber)(ie.code)?Ie=String(ie.code):Ie={value:String(ie.code.value),target:ie.code.target}),{...u.from(ie.range),message:ie.message,source:ie.source,code:Ie,severity:o.from(ie.severity),relatedInformation:ie.relatedInformation&&ie.relatedInformation.map(n.from),tags:Array.isArray(ie.tags)?(0,f.coalesce)(ie.tags.map(t.from)):void 0}}_e.from=ye;function me(ie){const Ie=new l.Diagnostic(u.to(ie),ie.message,o.to(ie.severity));return Ie.source=ie.source,Ie.code=(0,S.isString)(ie.code)?ie.code:ie.code?.value,Ie.relatedInformation=ie.relatedInformation&&ie.relatedInformation.map(n.to),Ie.tags=ie.tags&&(0,f.coalesce)(ie.tags.map(t.to)),Ie}_e.to=me})(r=e.Diagnostic||(e.Diagnostic={}));var n;(function(_e){function ye(ie){return{...u.from(ie.location.range),message:ie.message,resource:ie.location.uri}}_e.from=ye;function me(ie){return new l.DiagnosticRelatedInformation(new l.Location(ie.resource,u.to(ie)),ie.message)}_e.to=me})(n=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var o;(function(_e){function ye(ie){switch(ie){case l.DiagnosticSeverity.Error:return b.MarkerSeverity.Error;case l.DiagnosticSeverity.Warning:return b.MarkerSeverity.Warning;case l.DiagnosticSeverity.Information:return b.MarkerSeverity.Info;case l.DiagnosticSeverity.Hint:return b.MarkerSeverity.Hint}return b.MarkerSeverity.Error}_e.from=ye;function me(ie){switch(ie){case b.MarkerSeverity.Info:return l.DiagnosticSeverity.Information;case b.MarkerSeverity.Warning:return l.DiagnosticSeverity.Warning;case b.MarkerSeverity.Error:return l.DiagnosticSeverity.Error;case b.MarkerSeverity.Hint:return l.DiagnosticSeverity.Hint;default:return l.DiagnosticSeverity.Error}}_e.to=me})(o=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var m;(function(_e){function ye(ie){return typeof ie=="number"&&ie>=l.ViewColumn.One?ie-1:ie===l.ViewColumn.Beside?_.SIDE_GROUP:_.ACTIVE_GROUP}_e.from=ye;function me(ie){if(typeof ie=="number"&&ie>=0)return ie+1;throw new Error("invalid 'EditorGroupColumn'")}_e.to=me})(m=e.ViewColumn||(e.ViewColumn={}));function h(_e){return typeof _e.range!="undefined"}function w(_e){return _e.length===0?!0:!!h(_e[0])}e.isDecorationOptionsArr=w;var T;(function(_e){function ye(Ke){return Ke.map(_e.from)}_e.fromMany=ye;function me(Ke){return Ke&&typeof Ke=="object"&&typeof Ke.language=="string"&&typeof Ke.value=="string"}function ie(Ke){let ht;if(me(Ke)){const{language:dt,value:ut}=Ke;ht={value:"```"+dt+`
`+ut+"\n```\n"}}else l.MarkdownString.isMarkdownString(Ke)?ht={value:Ke.value,isTrusted:Ke.isTrusted,supportThemeIcons:Ke.supportThemeIcons,supportHtml:Ke.supportHtml,baseUri:Ke.baseUri}:typeof Ke=="string"?ht={value:Ke}:ht={value:""};const Et=Object.create(null);ht.uris=Et;const St=dt=>{try{let ut=R.URI.parse(dt,!0);ut=ut.with({query:Ie(ut.query,Et)}),Et[dt]=ut}catch{}return""},ot=new A.marked.Renderer;return ot.link=St,ot.image=dt=>typeof dt=="string"?St(I.parseHrefAndDimensions(dt).href):"",(0,A.marked)(ht.value,{renderer:ot}),ht}_e.from=ie;function Ie(Ke,ht){if(!Ke)return Ke;let Et;try{Et=(0,C.parse)(Ke)}catch{}if(!Et)return Ke;let St=!1;return Et=(0,k.cloneAndChange)(Et,ot=>{if(R.URI.isUri(ot)){const dt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ht[dt]=ot,St=!0,dt}else return}),St?JSON.stringify(Et):Ke}function Re(Ke){const ht=new l.MarkdownString(Ke.value,Ke.supportThemeIcons);return ht.isTrusted=Ke.isTrusted,ht.supportHtml=Ke.supportHtml,ht.baseUri=Ke.baseUri?R.URI.from(Ke.baseUri):void 0,ht}_e.to=Re;function Ve(Ke){if(!!Ke)return typeof Ke=="string"?Ke:_e.from(Ke)}_e.fromStrict=Ve})(T=e.MarkdownString||(e.MarkdownString={}));function L(_e){return w(_e)?_e.map(ye=>({range:u.from(ye.range),hoverMessage:Array.isArray(ye.hoverMessage)?T.fromMany(ye.hoverMessage):ye.hoverMessage?T.from(ye.hoverMessage):void 0,renderOptions:ye.renderOptions})):_e.map(ye=>({range:u.from(ye)}))}e.fromRangeOrRangeWithMessage=L;function O(_e){return typeof _e=="undefined"?_e:typeof _e=="string"?R.URI.file(_e):_e}e.pathOrURIToURI=O;var y;(function(_e){function ye(me){return typeof me=="undefined"?me:{contentText:me.contentText,contentIconPath:me.contentIconPath?O(me.contentIconPath):void 0,border:me.border,borderColor:me.borderColor,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,color:me.color,backgroundColor:me.backgroundColor,margin:me.margin,width:me.width,height:me.height}}_e.from=ye})(y=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var H;(function(_e){function ye(me){return typeof me=="undefined"?me:{backgroundColor:me.backgroundColor,outline:me.outline,outlineColor:me.outlineColor,outlineStyle:me.outlineStyle,outlineWidth:me.outlineWidth,border:me.border,borderColor:me.borderColor,borderRadius:me.borderRadius,borderSpacing:me.borderSpacing,borderStyle:me.borderStyle,borderWidth:me.borderWidth,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,cursor:me.cursor,color:me.color,opacity:me.opacity,letterSpacing:me.letterSpacing,gutterIconPath:me.gutterIconPath?O(me.gutterIconPath):void 0,gutterIconSize:me.gutterIconSize,overviewRulerColor:me.overviewRulerColor,before:me.before?y.from(me.before):void 0,after:me.after?y.from(me.after):void 0}}_e.from=ye})(H=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var M;(function(_e){function ye(me){if(typeof me=="undefined")return me;switch(me){case l.DecorationRangeBehavior.OpenOpen:return 0;case l.DecorationRangeBehavior.ClosedClosed:return 1;case l.DecorationRangeBehavior.OpenClosed:return 2;case l.DecorationRangeBehavior.ClosedOpen:return 3}}_e.from=ye})(M=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var j;(function(_e){function ye(me){return{isWholeLine:me.isWholeLine,rangeBehavior:me.rangeBehavior?M.from(me.rangeBehavior):void 0,overviewRulerLane:me.overviewRulerLane,light:me.light?H.from(me.light):void 0,dark:me.dark?H.from(me.dark):void 0,backgroundColor:me.backgroundColor,outline:me.outline,outlineColor:me.outlineColor,outlineStyle:me.outlineStyle,outlineWidth:me.outlineWidth,border:me.border,borderColor:me.borderColor,borderRadius:me.borderRadius,borderSpacing:me.borderSpacing,borderStyle:me.borderStyle,borderWidth:me.borderWidth,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,cursor:me.cursor,color:me.color,opacity:me.opacity,letterSpacing:me.letterSpacing,gutterIconPath:me.gutterIconPath?O(me.gutterIconPath):void 0,gutterIconSize:me.gutterIconSize,overviewRulerColor:me.overviewRulerColor,before:me.before?y.from(me.before):void 0,after:me.after?y.from(me.after):void 0}}_e.from=ye})(j=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var X;(function(_e){function ye(ie){return{text:ie.newText,eol:ie.newEol&&et.from(ie.newEol),range:u.from(ie.range)}}_e.from=ye;function me(ie){const Ie=new l.TextEdit(u.to(ie.range),ie.text);return Ie.newEol=typeof ie.eol=="undefined"?void 0:et.to(ie.eol),Ie}_e.to=me})(X=e.TextEdit||(e.TextEdit={}));var $;(function(_e){function ye(ie,Ie){const Re={edits:[]};if(ie instanceof l.WorkspaceEdit)for(let Ve of ie._allEntries())Ve._type===1?Re.edits.push({_type:1,oldUri:Ve.from,newUri:Ve.to,options:Ve.options,metadata:Ve.metadata}):Ve._type===2?Re.edits.push({_type:2,resource:Ve.uri,edit:X.from(Ve.edit),modelVersionId:Ie?.getTextDocumentVersion(Ve.uri),metadata:Ve.metadata}):Ve._type===3?Re.edits.push({_type:3,metadata:Ve.metadata,resource:Ve.uri,edit:Ve.edit,notebookMetadata:Ve.notebookMetadata,notebookVersionId:Ie?.getNotebookDocumentVersion(Ve.uri)}):Ve._type===5&&Re.edits.push({_type:3,metadata:Ve.metadata,resource:Ve.uri,notebookVersionId:Ie?.getNotebookDocumentVersion(Ve.uri),edit:{editType:1,index:Ve.index,count:Ve.count,cells:Ve.cells.map(vt.from)}});return Re}_e.from=ye;function me(ie){const Ie=new l.WorkspaceEdit;for(const Re of ie.edits)Re.edit?Ie.replace(R.URI.revive(Re.resource),u.to(Re.edit.range),Re.edit.text):Ie.renameFile(R.URI.revive(Re.oldUri),R.URI.revive(Re.newUri),Re.options);return Ie}_e.to=me})($=e.WorkspaceEdit||(e.WorkspaceEdit={}));var U;(function(_e){const ye=Object.create(null);ye[l.SymbolKind.File]=0,ye[l.SymbolKind.Module]=1,ye[l.SymbolKind.Namespace]=2,ye[l.SymbolKind.Package]=3,ye[l.SymbolKind.Class]=4,ye[l.SymbolKind.Method]=5,ye[l.SymbolKind.Property]=6,ye[l.SymbolKind.Field]=7,ye[l.SymbolKind.Constructor]=8,ye[l.SymbolKind.Enum]=9,ye[l.SymbolKind.Interface]=10,ye[l.SymbolKind.Function]=11,ye[l.SymbolKind.Variable]=12,ye[l.SymbolKind.Constant]=13,ye[l.SymbolKind.String]=14,ye[l.SymbolKind.Number]=15,ye[l.SymbolKind.Boolean]=16,ye[l.SymbolKind.Array]=17,ye[l.SymbolKind.Object]=18,ye[l.SymbolKind.Key]=19,ye[l.SymbolKind.Null]=20,ye[l.SymbolKind.EnumMember]=21,ye[l.SymbolKind.Struct]=22,ye[l.SymbolKind.Event]=23,ye[l.SymbolKind.Operator]=24,ye[l.SymbolKind.TypeParameter]=25;function me(Ie){return typeof ye[Ie]=="number"?ye[Ie]:6}_e.from=me;function ie(Ie){for(const Re in ye)if(ye[Re]===Ie)return Number(Re);return l.SymbolKind.Property}_e.to=ie})(U=e.SymbolKind||(e.SymbolKind={}));var q;(function(_e){function ye(ie){switch(ie){case l.SymbolTag.Deprecated:return 1}}_e.from=ye;function me(ie){switch(ie){case 1:return l.SymbolTag.Deprecated}}_e.to=me})(q=e.SymbolTag||(e.SymbolTag={}));var K;(function(_e){function ye(ie){return{name:ie.name,kind:U.from(ie.kind),tags:ie.tags&&ie.tags.map(q.from),containerName:ie.containerName,location:Z.from(ie.location)}}_e.from=ye;function me(ie){const Ie=new l.SymbolInformation(ie.name,U.to(ie.kind),ie.containerName,Z.to(ie.location));return Ie.tags=ie.tags&&ie.tags.map(q.to),Ie}_e.to=me})(K=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var G;(function(_e){function ye(ie){const Ie={name:ie.name||"!!MISSING: name!!",detail:ie.detail,range:u.from(ie.range),selectionRange:u.from(ie.selectionRange),kind:U.from(ie.kind),tags:ie.tags?.map(q.from)??[]};return ie.children&&(Ie.children=ie.children.map(ye)),Ie}_e.from=ye;function me(ie){const Ie=new l.DocumentSymbol(ie.name,ie.detail,U.to(ie.kind),u.to(ie.range),u.to(ie.selectionRange));return(0,f.isNonEmptyArray)(ie.tags)&&(Ie.tags=ie.tags.map(q.to)),ie.children&&(Ie.children=ie.children.map(me)),Ie}_e.to=me})(G=e.DocumentSymbol||(e.DocumentSymbol={}));var ee;(function(_e){function ye(ie){const Ie=new l.CallHierarchyItem(U.to(ie.kind),ie.name,ie.detail||"",R.URI.revive(ie.uri),u.to(ie.range),u.to(ie.selectionRange));return Ie._sessionId=ie._sessionId,Ie._itemId=ie._itemId,Ie}_e.to=ye;function me(ie,Ie,Re){if(Ie=Ie??ie._sessionId,Re=Re??ie._itemId,Ie===void 0||Re===void 0)throw new Error("invalid item");return{_sessionId:Ie,_itemId:Re,name:ie.name,detail:ie.detail,kind:U.from(ie.kind),uri:ie.uri,range:u.from(ie.range),selectionRange:u.from(ie.selectionRange),tags:ie.tags?.map(q.from)}}_e.from=me})(ee=e.CallHierarchyItem||(e.CallHierarchyItem={}));var oe;(function(_e){function ye(me){return new l.CallHierarchyIncomingCall(ee.to(me.from),me.fromRanges.map(ie=>u.to(ie)))}_e.to=ye})(oe=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var ue;(function(_e){function ye(me){return new l.CallHierarchyOutgoingCall(ee.to(me.to),me.fromRanges.map(ie=>u.to(ie)))}_e.to=ye})(ue=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var Z;(function(_e){function ye(ie){return{range:ie.range&&u.from(ie.range),uri:ie.uri}}_e.from=ye;function me(ie){return new l.Location(R.URI.revive(ie.uri),u.to(ie.range))}_e.to=me})(Z=e.location||(e.location={}));var Y;(function(_e){function ye(ie){const Ie=ie,Re=ie;return{originSelectionRange:Ie.originSelectionRange?u.from(Ie.originSelectionRange):void 0,uri:Ie.targetUri?Ie.targetUri:Re.uri,range:u.from(Ie.targetRange?Ie.targetRange:Re.range),targetSelectionRange:Ie.targetSelectionRange?u.from(Ie.targetSelectionRange):void 0}}_e.from=ye;function me(ie){return{targetUri:R.URI.revive(ie.uri),targetRange:u.to(ie.range),targetSelectionRange:ie.targetSelectionRange?u.to(ie.targetSelectionRange):void 0,originSelectionRange:ie.originSelectionRange?u.to(ie.originSelectionRange):void 0}}_e.to=me})(Y=e.DefinitionLink||(e.DefinitionLink={}));var se;(function(_e){function ye(ie){return{range:u.from(ie.range),contents:T.fromMany(ie.contents)}}_e.from=ye;function me(ie){return new l.Hover(ie.contents.map(T.to),u.to(ie.range))}_e.to=me})(se=e.Hover||(e.Hover={}));var de;(function(_e){function ye(ie){return{range:u.from(ie.range),expression:ie.expression}}_e.from=ye;function me(ie){return new l.EvaluatableExpression(u.to(ie.range),ie.expression)}_e.to=me})(de=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ge;(function(_e){function ye(ie){if(ie instanceof l.InlineValueText)return{type:"text",range:u.from(ie.range),text:ie.text};if(ie instanceof l.InlineValueVariableLookup)return{type:"variable",range:u.from(ie.range),variableName:ie.variableName,caseSensitiveLookup:ie.caseSensitiveLookup};if(ie instanceof l.InlineValueEvaluatableExpression)return{type:"expression",range:u.from(ie.range),expression:ie.expression};throw new Error("Unknown 'InlineValue' type")}_e.from=ye;function me(ie){switch(ie.type){case"text":return{range:u.to(ie.range),text:ie.text};case"variable":return{range:u.to(ie.range),variableName:ie.variableName,caseSensitiveLookup:ie.caseSensitiveLookup};case"expression":return{range:u.to(ie.range),expression:ie.expression}}}_e.to=me})(ge=e.InlineValue||(e.InlineValue={}));var Te;(function(_e){function ye(ie){return{frameId:ie.frameId,stoppedLocation:u.from(ie.stoppedLocation)}}_e.from=ye;function me(ie){return new l.InlineValueContext(ie.frameId,u.to(ie.stoppedLocation))}_e.to=me})(Te=e.InlineValueContext||(e.InlineValueContext={}));var Ne;(function(_e){function ye(ie){return{range:u.from(ie.range),kind:ie.kind}}_e.from=ye;function me(ie){return new l.DocumentHighlight(u.to(ie.range),ie.kind)}_e.to=me})(Ne=e.DocumentHighlight||(e.DocumentHighlight={}));var be;(function(_e){function ye(me){switch(me){case 1:return l.CompletionTriggerKind.TriggerCharacter;case 2:return l.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return l.CompletionTriggerKind.Invoke}}_e.to=ye})(be=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ee;(function(_e){function ye(me){return{triggerKind:be.to(me.triggerKind),triggerCharacter:me.triggerCharacter}}_e.to=ye})(Ee=e.CompletionContext||(e.CompletionContext={}));var z;(function(_e){function ye(ie){switch(ie){case l.CompletionItemTag.Deprecated:return 1}}_e.from=ye;function me(ie){switch(ie){case 1:return l.CompletionItemTag.Deprecated}}_e.to=me})(z=e.CompletionItemTag||(e.CompletionItemTag={}));var B;(function(_e){const ye=new Map([[l.CompletionItemKind.Method,0],[l.CompletionItemKind.Function,1],[l.CompletionItemKind.Constructor,2],[l.CompletionItemKind.Field,3],[l.CompletionItemKind.Variable,4],[l.CompletionItemKind.Class,5],[l.CompletionItemKind.Interface,7],[l.CompletionItemKind.Struct,6],[l.CompletionItemKind.Module,8],[l.CompletionItemKind.Property,9],[l.CompletionItemKind.Unit,12],[l.CompletionItemKind.Value,13],[l.CompletionItemKind.Constant,14],[l.CompletionItemKind.Enum,15],[l.CompletionItemKind.EnumMember,16],[l.CompletionItemKind.Keyword,17],[l.CompletionItemKind.Snippet,27],[l.CompletionItemKind.Text,18],[l.CompletionItemKind.Color,19],[l.CompletionItemKind.File,20],[l.CompletionItemKind.Reference,21],[l.CompletionItemKind.Folder,23],[l.CompletionItemKind.Event,10],[l.CompletionItemKind.Operator,11],[l.CompletionItemKind.TypeParameter,24],[l.CompletionItemKind.Issue,26],[l.CompletionItemKind.User,25]]);function me(Re){return ye.get(Re)??9}_e.from=me;const ie=new Map([[0,l.CompletionItemKind.Method],[1,l.CompletionItemKind.Function],[2,l.CompletionItemKind.Constructor],[3,l.CompletionItemKind.Field],[4,l.CompletionItemKind.Variable],[5,l.CompletionItemKind.Class],[7,l.CompletionItemKind.Interface],[6,l.CompletionItemKind.Struct],[8,l.CompletionItemKind.Module],[9,l.CompletionItemKind.Property],[12,l.CompletionItemKind.Unit],[13,l.CompletionItemKind.Value],[14,l.CompletionItemKind.Constant],[15,l.CompletionItemKind.Enum],[16,l.CompletionItemKind.EnumMember],[17,l.CompletionItemKind.Keyword],[27,l.CompletionItemKind.Snippet],[18,l.CompletionItemKind.Text],[19,l.CompletionItemKind.Color],[20,l.CompletionItemKind.File],[21,l.CompletionItemKind.Reference],[23,l.CompletionItemKind.Folder],[10,l.CompletionItemKind.Event],[11,l.CompletionItemKind.Operator],[24,l.CompletionItemKind.TypeParameter],[25,l.CompletionItemKind.User],[26,l.CompletionItemKind.Issue]]);function Ie(Re){return ie.get(Re)??l.CompletionItemKind.Property}_e.to=Ie})(B=e.CompletionItemKind||(e.CompletionItemKind={}));var N;(function(_e){function ye(me,ie){const Ie=new l.CompletionItem(me.label);return Ie.insertText=me.insertText,Ie.kind=B.to(me.kind),Ie.tags=me.tags?.map(z.to),Ie.detail=me.detail,Ie.documentation=I.isMarkdownString(me.documentation)?T.to(me.documentation):me.documentation,Ie.sortText=me.sortText,Ie.filterText=me.filterText,Ie.preselect=me.preselect,Ie.commitCharacters=me.commitCharacters,F.Range.isIRange(me.range)?Ie.range=u.to(me.range):typeof me.range=="object"&&(Ie.range={inserting:u.to(me.range.insert),replacing:u.to(me.range.replace)}),Ie.keepWhitespace=typeof me.insertTextRules=="undefined"?!1:Boolean(me.insertTextRules&1),typeof me.insertTextRules!="undefined"&&me.insertTextRules&4?Ie.insertText=new l.SnippetString(me.insertText):(Ie.insertText=me.insertText,Ie.textEdit=Ie.range instanceof l.Range?new l.TextEdit(Ie.range,Ie.insertText):void 0),me.additionalTextEdits&&me.additionalTextEdits.length>0&&(Ie.additionalTextEdits=me.additionalTextEdits.map(Re=>X.to(Re))),Ie.command=ie&&me.command?ie.fromInternal(me.command):void 0,Ie}_e.to=ye})(N=e.CompletionItem||(e.CompletionItem={}));var W;(function(_e){function ye(ie){return{label:ie.label,documentation:T.fromStrict(ie.documentation)}}_e.from=ye;function me(ie){return{label:ie.label,documentation:I.isMarkdownString(ie.documentation)?T.to(ie.documentation):ie.documentation}}_e.to=me})(W=e.ParameterInformation||(e.ParameterInformation={}));var V;(function(_e){function ye(ie){return{label:ie.label,documentation:T.fromStrict(ie.documentation),parameters:Array.isArray(ie.parameters)?ie.parameters.map(W.from):[],activeParameter:ie.activeParameter}}_e.from=ye;function me(ie){return{label:ie.label,documentation:I.isMarkdownString(ie.documentation)?T.to(ie.documentation):ie.documentation,parameters:Array.isArray(ie.parameters)?ie.parameters.map(W.to):[],activeParameter:ie.activeParameter}}_e.to=me})(V=e.SignatureInformation||(e.SignatureInformation={}));var re;(function(_e){function ye(ie){return{activeSignature:ie.activeSignature,activeParameter:ie.activeParameter,signatures:Array.isArray(ie.signatures)?ie.signatures.map(V.from):[]}}_e.from=ye;function me(ie){return{activeSignature:ie.activeSignature,activeParameter:ie.activeParameter,signatures:Array.isArray(ie.signatures)?ie.signatures.map(V.to):[]}}_e.to=me})(re=e.SignatureHelp||(e.SignatureHelp={}));var he;(function(_e){function ye(me,ie){const Ie=new l.InlayHint(E.to(ie.position),typeof ie.label=="string"?ie.label:ie.label.map(Ce.to.bind(void 0,me)),ie.kind&&Ae.to(ie.kind));return Ie.textEdits=ie.textEdits&&ie.textEdits.map(X.to),Ie.tooltip=I.isMarkdownString(ie.tooltip)?T.to(ie.tooltip):ie.tooltip,Ie.paddingLeft=ie.paddingLeft,Ie.paddingRight=ie.paddingRight,Ie}_e.to=ye})(he=e.InlayHint||(e.InlayHint={}));var Ce;(function(_e){function ye(me,ie){const Ie=new l.InlayHintLabelPart(ie.label);return Ie.tooltip=I.isMarkdownString(ie.tooltip)?T.to(ie.tooltip):ie.tooltip,D.Command.is(ie.command)&&(Ie.command=me.fromInternal(ie.command)),ie.location&&(Ie.location=Z.to(ie.location)),Ie}_e.to=ye})(Ce=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var Ae;(function(_e){function ye(ie){return ie}_e.from=ye;function me(ie){return ie}_e.to=me})(Ae=e.InlayHintKind||(e.InlayHintKind={}));var We;(function(_e){function ye(ie){return{range:u.from(ie.range),url:ie.target,tooltip:ie.tooltip}}_e.from=ye;function me(ie){let Ie;if(ie.url)try{Ie=typeof ie.url=="string"?R.URI.parse(ie.url,!0):R.URI.revive(ie.url)}catch{}return new l.DocumentLink(u.to(ie.range),Ie)}_e.to=me})(We=e.DocumentLink||(e.DocumentLink={}));var ze;(function(_e){function ye(ie){const Ie=new l.ColorPresentation(ie.label);return ie.textEdit&&(Ie.textEdit=X.to(ie.textEdit)),ie.additionalTextEdits&&(Ie.additionalTextEdits=ie.additionalTextEdits.map(Re=>X.to(Re))),Ie}_e.to=ye;function me(ie){return{label:ie.label,textEdit:ie.textEdit?X.from(ie.textEdit):void 0,additionalTextEdits:ie.additionalTextEdits?ie.additionalTextEdits.map(Ie=>X.from(Ie)):void 0}}_e.from=me})(ze=e.ColorPresentation||(e.ColorPresentation={}));var qe;(function(_e){function ye(ie){return new l.Color(ie[0],ie[1],ie[2],ie[3])}_e.to=ye;function me(ie){return[ie.red,ie.green,ie.blue,ie.alpha]}_e.from=me})(qe=e.Color||(e.Color={}));var He;(function(_e){function ye(ie){return{range:u.from(ie.range)}}_e.from=ye;function me(ie){return new l.SelectionRange(u.to(ie.range))}_e.to=me})(He=e.SelectionRange||(e.SelectionRange={}));var Ue;(function(_e){function ye(me){switch(me){case 2:return l.TextDocumentSaveReason.AfterDelay;case 1:return l.TextDocumentSaveReason.Manual;case 3:case 4:return l.TextDocumentSaveReason.FocusOut}}_e.to=ye})(Ue=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Je;(function(_e){function ye(ie){switch(ie){case l.TextEditorLineNumbersStyle.Off:return 0;case l.TextEditorLineNumbersStyle.Relative:return 2;case l.TextEditorLineNumbersStyle.On:default:return 1}}_e.from=ye;function me(ie){switch(ie){case 0:return l.TextEditorLineNumbersStyle.Off;case 2:return l.TextEditorLineNumbersStyle.Relative;case 1:default:return l.TextEditorLineNumbersStyle.On}}_e.to=me})(Je=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var et;(function(_e){function ye(ie){if(ie===l.EndOfLine.CRLF)return 1;if(ie===l.EndOfLine.LF)return 0}_e.from=ye;function me(ie){if(ie===1)return l.EndOfLine.CRLF;if(ie===0)return l.EndOfLine.LF}_e.to=me})(et=e.EndOfLine||(e.EndOfLine={}));var Le;(function(_e){function ye(me){if(typeof me=="object")return me.viewId;switch(me){case l.ProgressLocation.SourceControl:return 3;case l.ProgressLocation.Window:return 10;case l.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}_e.from=ye})(Le=e.ProgressLocation||(e.ProgressLocation={}));var it;(function(_e){function ye(me){const ie={start:me.start+1,end:me.end+1};return me.kind&&(ie.kind=ne.from(me.kind)),ie}_e.from=ye})(it=e.FoldingRange||(e.FoldingRange={}));var ne;(function(_e){function ye(me){if(me)switch(me){case l.FoldingRangeKind.Comment:return D.FoldingRangeKind.Comment;case l.FoldingRangeKind.Imports:return D.FoldingRangeKind.Imports;case l.FoldingRangeKind.Region:return D.FoldingRangeKind.Region}}_e.from=ye})(ne=e.FoldingRangeKind||(e.FoldingRangeKind={}));var ae;(function(_e){function ye(me){if(me)return{pinned:typeof me.preview=="boolean"?!me.preview:void 0,inactive:me.background,preserveFocus:me.preserveFocus,selection:typeof me.selection=="object"?u.from(me.selection):void 0,override:typeof me.override=="boolean"?v.EditorResolution.DISABLED:void 0}}_e.from=ye})(ae=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var J;(function(_e){function ye(Re){return Re instanceof l.RelativePattern?Re.toJSON():typeof Re=="string"?Re:me(Re)||ie(Re)?new l.RelativePattern(Re.baseUri??Re.base,Re.pattern).toJSON():Re}_e.from=ye;function me(Re){const Ve=Re;return Ve?R.URI.isUri(Ve.baseUri)&&typeof Ve.pattern=="string":!1}function ie(Re){const Ve=Re;return Ve?typeof Ve.base=="string"&&typeof Ve.pattern=="string":!1}function Ie(Re){return typeof Re=="string"?Re:new l.RelativePattern(R.URI.revive(Re.baseUri),Re.pattern)}_e.to=Ie})(J=e.GlobPattern||(e.GlobPattern={}));var pe;(function(_e){function ye(me){if(me){if(Array.isArray(me))return me.map(ye);if(typeof me=="string")return me;{const ie=me;return{language:ie.language,scheme:ie.scheme,pattern:J.from(ie.pattern),exclusive:ie.exclusive}}}else return}_e.from=ye})(pe=e.LanguageSelector||(e.LanguageSelector={}));var Se;(function(_e){function ye(ie){return{start:ie.start,end:ie.end}}_e.from=ye;function me(ie){return new l.NotebookRange(ie.start,ie.end)}_e.to=me})(Se=e.NotebookRange||(e.NotebookRange={}));var Me;(function(_e){function ye(ie){return{timing:typeof ie.runStartTime=="number"&&typeof ie.runEndTime=="number"?{startTime:ie.runStartTime,endTime:ie.runEndTime}:void 0,executionOrder:ie.executionOrder,success:ie.lastRunSuccess}}_e.to=ye;function me(ie){return{lastRunSuccess:ie.success,runStartTime:ie.timing?.startTime,runEndTime:ie.timing?.endTime,executionOrder:ie.executionOrder}}_e.from=me})(Me=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var $e;(function(_e){function ye(me){if(me===d.NotebookCellExecutionState.Executing)return l.NotebookCellExecutionState.Executing;if(me===d.NotebookCellExecutionState.Pending)return l.NotebookCellExecutionState.Pending;if(me===d.NotebookCellExecutionState.Unconfirmed)return l.NotebookCellExecutionState.Pending;throw new Error(`Unknown state: ${me}`)}_e.to=ye})($e=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Ye;(function(_e){function ye(ie){switch(ie){case l.NotebookCellKind.Markup:return d.CellKind.Markup;case l.NotebookCellKind.Code:default:return d.CellKind.Code}}_e.from=ye;function me(ie){switch(ie){case d.CellKind.Markup:return l.NotebookCellKind.Markup;case d.CellKind.Code:default:return l.NotebookCellKind.Code}}_e.to=me})(Ye=e.NotebookCellKind||(e.NotebookCellKind={}));var lt;(function(_e){function ye(ie){const Ie={metadata:ie.metadata??Object.create(null),cells:[]};for(let Re of ie.cells)l.NotebookCellData.validate(Re),Ie.cells.push(vt.from(Re));return Ie}_e.from=ye;function me(ie){const Ie=new l.NotebookData(ie.cells.map(vt.to));return(0,S.isEmptyObject)(ie.metadata)||(Ie.metadata=ie.metadata),Ie}_e.to=me})(lt=e.NotebookData||(e.NotebookData={}));var vt;(function(_e){function ye(ie){return{cellKind:Ye.from(ie.kind),language:ie.languageId,mime:ie.mime,source:ie.value,metadata:ie.metadata,internalMetadata:Me.from(ie.executionSummary??{}),outputs:ie.outputs?ie.outputs.map(je.from):[]}}_e.from=ye;function me(ie){return new l.NotebookCellData(Ye.to(ie.cellKind),ie.source,ie.language,ie.mime,ie.outputs?ie.outputs.map(je.to):void 0,ie.metadata,ie.internalMetadata?Me.to(ie.internalMetadata):void 0)}_e.to=me})(vt=e.NotebookCellData||(e.NotebookCellData={}));var wt;(function(_e){function ye(ie){return{mime:ie.mime,valueBytes:i.VSBuffer.wrap(ie.data)}}_e.from=ye;function me(ie){return new l.NotebookCellOutputItem(ie.valueBytes.buffer,ie.mime)}_e.to=me})(wt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var je;(function(_e){function ye(ie){return{outputId:ie.id,items:ie.items.map(wt.from),metadata:ie.metadata}}_e.from=ye;function me(ie){const Ie=ie.items.map(wt.to);return new l.NotebookCellOutput(Ie,ie.outputId,ie.metadata)}_e.to=me})(je=e.NotebookCellOutput||(e.NotebookCellOutput={}));var st;(function(_e){function ye(Ie){return ie(Ie)?{include:(0,S.withNullAsUndefined)(J.from(Ie.include)),exclude:(0,S.withNullAsUndefined)(J.from(Ie.exclude))}:(0,S.withNullAsUndefined)(J.from(Ie))}_e.from=ye;function me(Ie){return ie(Ie)?{include:J.to(Ie.include),exclude:J.to(Ie.exclude)}:J.to(Ie)}_e.to=me;function ie(Ie){const Re=Ie;return Re?!!Re.include&&!!Re.exclude:!1}})(st=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var _t;(function(_e){function ye(me){return{backgroundColor:me.backgroundColor,borderColor:me.borderColor,top:me.top?y.from(me.top):void 0}}_e.from=ye})(_t=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var nt;(function(_e){function ye(me,ie,Ie){const Re=typeof me.command=="string"?{title:"",command:me.command}:me.command;return{alignment:me.alignment===l.NotebookCellStatusBarAlignment.Left?1:2,command:ie.toInternal(Re,Ie),text:me.text,tooltip:me.tooltip,accessibilityInformation:me.accessibilityInformation,priority:me.priority}}_e.from=ye})(nt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var ct;(function(_e){function ye(me){return{transientOutputs:me?.transientOutputs??!1,transientCellMetadata:me?.transientCellMetadata??{},transientDocumentMetadata:me?.transientDocumentMetadata??{}}}_e.from=ye})(ct=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Rt;(function(_e){function ye(ie){return{uri:ie.uri,provides:ie.provides}}_e.from=ye;function me(ie){return new l.NotebookRendererScript(R.URI.revive(ie.uri),ie.provides)}_e.to=me})(Rt=e.NotebookRendererScript||(e.NotebookRendererScript={}));var Tt;(function(_e){function ye(ie){return{message:T.fromStrict(ie.message)||"",type:0,expected:ie.expectedOutput,actual:ie.actualOutput,location:ie.location&&{range:u.from(ie.location.range),uri:ie.location.uri}}}_e.from=ye;function me(ie){const Ie=new l.TestMessage(typeof ie.message=="string"?ie.message:T.to(ie.message));return Ie.actualOutput=ie.actual,Ie.expectedOutput=ie.expected,Ie.location=ie.location?Z.to(ie.location):void 0,Ie}_e.to=me})(Tt=e.TestMessage||(e.TestMessage={}));var yt;(function(_e){_e.namespace=p.namespaceTestTag,_e.denamespace=p.denamespaceTestTag})(yt=e.TestTag||(e.TestTag={}));var mt;(function(_e){function ye(Re){const Ve=(0,g.getPrivateApiFor)(Re).controllerId;return{extId:P.TestId.fromExtHostTestItem(Re,Ve).toString(),label:Re.label,uri:R.URI.revive(Re.uri),busy:!1,tags:Re.tags.map(Ke=>yt.namespace(Ve,Ke.id)),range:F.Range.lift(u.from(Re.range)),description:Re.description||null,sortText:Re.sortText||null,error:Re.error&&T.fromStrict(Re.error)||null}}_e.from=ye;function me(Re){return{parent:void 0,error:void 0,id:P.TestId.fromString(Re.extId).localId,label:Re.label,uri:R.URI.revive(Re.uri),tags:(Re.tags||[]).map(Ve=>{const{tagId:Ke}=yt.denamespace(Ve);return new l.TestTag(Ke)}),range:u.to(Re.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Re.description||void 0,sortText:Re.sortText||void 0}}_e.toPlain=me;function ie(Re){const Ve=P.TestId.fromString(Re.extId),Ke=new g.TestItemImpl(Ve.controllerId,Ve.localId,Re.label,R.URI.revive(Re.uri)||void 0);return Ke.range=u.to(Re.range||void 0),Ke.description=Re.description||void 0,Ke.sortText=Re.sortText||void 0,Ke}function Ie(Re){let Ve;for(const Ke of Re.tests){const ht=ie(Ke.item);(0,g.getPrivateApiFor)(ht).parent=Ve,Ve=ht}return Ve}_e.toItemFromContext=Ie})(mt=e.TestItem||(e.TestItem={})),function(_e){function ye(ie){return{id:ie.id}}_e.from=ye;function me(ie){return new l.TestTag(ie.id)}_e.to=me}(yt=e.TestTag||(e.TestTag={}));var Lt;(function(_e){const ye=(ie,Ie)=>{const Re={...mt.toPlain(ie.item),parent:void 0,taskStates:ie.tasks.map(Ve=>({state:Ve.state,duration:Ve.duration,messages:Ve.messages.filter(Ke=>Ke.type===0).map(Tt.to)})),children:ie.children.map(Ve=>Ie.get(Ve)).filter(S.isDefined).map(Ve=>ye(Ve,Ie))};for(const Ve of Re.children)Ve.parent=Re;return Re};function me(ie){const Ie=[],Re=new Map;for(const Ve of ie.items)Re.set(Ve.item.extId,Ve),ie.request.targets.some(Ke=>Ke.controllerId===Ve.controllerId&&Ke.testIds.includes(Ve.item.extId))&&Ie.push(Ve);return{completedAt:ie.completedAt,results:Ie.map(Ve=>ye(Ve,Re))}}_e.to=me})(Lt=e.TestResults||(e.TestResults={}));var Mt;(function(_e){function ye(Re){return{covered:Re.covered,total:Re.covered}}function me(Re){return"line"in Re?E.from(Re):u.from(Re)}function ie(Re){return"branches"in Re?{count:Re.executionCount,location:me(Re.location),type:1,branches:Re.branches.length?Re.branches.map(Ve=>({count:Ve.executionCount,location:Ve.location&&me(Ve.location)})):void 0}:{type:0,count:Re.executionCount,location:me(Re.location)}}_e.fromDetailed=ie;function Ie(Re){return{uri:Re.uri,statement:ye(Re.statementCoverage),branch:Re.branchCoverage&&ye(Re.branchCoverage),function:Re.functionCoverage&&ye(Re.functionCoverage),details:Re.detailedCoverage?.map(ie)}}_e.fromFile=Ie})(Mt=e.TestCoverage||(e.TestCoverage={}));var Ft;(function(_e){function ye(me){switch(me){case 1:return l.CodeActionTriggerKind.Invoke;case 2:return l.CodeActionTriggerKind.Automatic}}_e.to=ye})(Ft=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var xe;(function(_e){function ye(ie){const Ie=new l.TypeHierarchyItem(U.to(ie.kind),ie.name,ie.detail||"",R.URI.revive(ie.uri),u.to(ie.range),u.to(ie.selectionRange));return Ie._sessionId=ie._sessionId,Ie._itemId=ie._itemId,Ie}_e.to=ye;function me(ie,Ie,Re){if(Ie=Ie??ie._sessionId,Re=Re??ie._itemId,Ie===void 0||Re===void 0)throw new Error("invalid item");return{_sessionId:Ie,_itemId:Re,kind:U.from(ie.kind),name:ie.name,detail:ie.detail??"",uri:ie.uri,range:u.from(ie.range),selectionRange:u.from(ie.selectionRange),tags:ie.tags?.map(q.from)}}_e.from=me})(xe=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(ve[219],we([1,0,2,15,7,14,90]),function(te,e,f,i,I,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class k{constructor(R,F,D,v={timeout:1500,errors:3}){this._logService=R,this._documents=F,this._mainThreadBulkEdits=D,this._thresholds=v,this._callbacks=new C.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(R){return(F,D,v)=>{const g={dispose:this._callbacks.push([F,D,R])};return Array.isArray(v)&&v.push(g),g}}async $participateInSave(R,F){const D=f.URI.revive(R);let v=!1;const b=setTimeout(()=>v=!0,this._thresholds.timeout),g=[];try{for(let d of[...this._callbacks]){if(v)break;const p=this._documents.getDocument(D),P=await this._deliverEventAsyncAndBlameBadListeners(d,{document:p,reason:A.TextDocumentSaveReason.to(F)});g.push(P)}}finally{clearTimeout(b)}return g}_deliverEventAsyncAndBlameBadListeners([R,F,D],v){const b=this._badListeners.get(R);return typeof b=="number"&&b>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(D,R,F,v).then(()=>!0,g=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' threw ERROR`),this._logService.error(g),!(g instanceof Error)||g.message!=="concurrent_edits"){const d=this._badListeners.get(R);this._badListeners.set(R,d?d+1:1),typeof d=="number"&&d>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(R,F,D,v){const b=[],g=Date.now(),{document:d,reason:p}=v,{version:P}=d,_=Object.freeze({document:d,reason:p,waitUntil(l){if(Object.isFrozen(b))throw(0,i.illegalState)("waitUntil can not be called async");b.push(Promise.resolve(l))}});try{F.apply(D,[_])}catch(l){return Promise.reject(l)}return Object.freeze(b),new Promise((l,c)=>{const u=setTimeout(()=>c(new Error("timeout")),this._thresholds.timeout);return Promise.all(b).then(a=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${R.identifier.value}' finished after ${Date.now()-g}ms`),clearTimeout(u),l(a)}).catch(a=>{clearTimeout(u),c(a)})}).then(l=>{const c={edits:[]};for(const u of l)if(Array.isArray(u)&&u.every(a=>a instanceof I.TextEdit))for(const{newText:a,newEol:E,range:s}of u)c.edits.push({_type:2,resource:d.uri,edit:{range:s&&A.Range.from(s),text:a,eol:E&&A.EndOfLine.from(E)}});if(c.edits.length!==0)return P===d.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(c):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=k}),define(ve[220],we([1,0,10,25,2,14,128]),function(te,e,f,i,I,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class k{constructor(D,v,b,g){this.start=D,this.deletedCount=v,this.deletedItems=b,this.items=g}static asApiEvents(D){return D.map(v=>({start:v.start,deletedCount:v.deletedCount,deletedItems:v.deletedItems,items:v.items.map(b=>b.apiCell)}))}}class S{constructor(D,v,b){this.notebook=D,this._extHostDocument=v,this._cellData=b,this.handle=b.handle,this.uri=I.URI.revive(b.uri),this.cellKind=b.cellKind,this._outputs=b.outputs.map(A.NotebookCellOutput.to),this._internalMetadata=b.internalMetadata??{},this._metadata=Object.freeze(b.metadata??{}),this._previousResult=Object.freeze(A.NotebookCellExecutionSummary.to(b.internalMetadata??{}))}static asModelAddData(D,v){return{EOL:v.eol,lines:v.source,languageId:v.language,uri:v.uri,isDirty:!1,versionId:1,notebook:D}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const D=this,v=this._extHostDocument.getDocument(this.uri);if(!v)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return D.notebook.getCellIndex(D)},notebook:D.notebook.apiNotebook,kind:A.NotebookCellKind.to(this._cellData.cellKind),document:v.document,get mime(){return D._mime},set mime(b){D._mime=b},get outputs(){return D._outputs.slice(0)},get metadata(){return D._metadata},get executionSummary(){return D._previousResult}})}return this._apiCell}setOutputs(D){this._outputs=D.map(A.NotebookCellOutput.to)}setOutputItems(D,v,b){const g=b.map(A.NotebookCellOutputItem.to),d=this._outputs.find(p=>p.id===D);d&&(v||(d.items.length=0),d.items.push(...g))}setMetadata(D){this._metadata=Object.freeze(D)}setInternalMetadata(D){this._internalMetadata=D,this._previousResult=Object.freeze(A.NotebookCellExecutionSummary.to(D))}setMime(D){}}e.ExtHostCell=S;class R{constructor(D,v,b,g,d,p){this._proxy=D,this._textDocumentsAndEditors=v,this._textDocuments=b,this._emitter=g,this.uri=d,this.handle=R._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=p.viewType,this._metadata=Object.freeze(p.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,p.cells]],!0),this._versionId=p.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const D=this;this._notebook={get uri(){return D.uri},get version(){return D._versionId},get notebookType(){return D._notebookType},get isDirty(){return D._isDirty},get isUntitled(){return D.uri.scheme===f.Schemas.untitled},get isClosed(){return D._disposed},get metadata(){return D._metadata},get cellCount(){return D._cells.length},cellAt(v){return v=D._validateIndex(v),D._cells[v].apiCell},getCells(v){return(v?D._getCells(v):D._cells).map(g=>g.apiCell)},save(){return D._save()}}}return this._notebook}updateBackup(D){this._backup?.delete(),this._backup=D}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(D){D.metadata&&(this._metadata=Object.freeze({...this._metadata,...D.metadata}))}acceptDirty(D){this._isDirty=D}acceptModelChanged(D,v){this._versionId=D.versionId,this._isDirty=v;for(const b of D.rawEvents)b.kind===C.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(b.changes,!1):b.kind===C.NotebookCellsChangeType.Move?this._moveCell(b.index,b.newIdx):b.kind===C.NotebookCellsChangeType.Output?this._setCellOutputs(b.index,b.outputs):b.kind===C.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(b.index,b.outputId,b.append,b.outputItems):b.kind===C.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(b.index,b.language):b.kind===C.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(b.index,b.mime):b.kind===C.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(b.index,b.metadata):b.kind===C.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(b.index,b.internalMetadata)}_validateIndex(D){return D=D|0,D<0?0:D>=this._cells.length?this._cells.length-1:D}_validateRange(D){let v=D.start|0,b=D.end|0;return v<0&&(v=0),b>this._cells.length&&(b=this._cells.length),D.with({start:v,end:b})}_getCells(D){D=this._validateRange(D);const v=[];for(let b=D.start;b<D.end;b++)v.push(this._cells[b]);return v}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(D,v){if(this._disposed)return;const b=[],g=[],d=[];D.reverse().forEach(p=>{const _=p[2].map(u=>{const a=new S(this,this._textDocumentsAndEditors,u);return v||g.push(S.asModelAddData(this.apiNotebook,u)),a}),l=new k(p[0],p[1],[],_),c=this._cells.splice(p[0],p[1],..._);for(const u of c)d.push(u.uri),l.deletedItems.push(u.apiCell);b.push(l)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:g,removedDocuments:d}),v||this._emitter.emitModelChange((0,i.deepFreeze)({document:this.apiNotebook,changes:k.asApiEvents(b)}))}_moveCell(D,v){const b=this._cells.splice(D,1);this._cells.splice(v,0,...b);const g=[new k(D,1,b.map(d=>d.apiCell),[]),new k(v,0,[],b)];this._emitter.emitModelChange((0,i.deepFreeze)({document:this.apiNotebook,changes:k.asApiEvents(g)}))}_setCellOutputs(D,v){const b=this._cells[D];b.setOutputs(v),this._emitter.emitCellOutputsChange((0,i.deepFreeze)({document:this.apiNotebook,cells:[b.apiCell]}))}_setCellOutputItems(D,v,b,g){const d=this._cells[D];d.setOutputItems(v,b,g),this._emitter.emitCellOutputsChange((0,i.deepFreeze)({document:this.apiNotebook,cells:[d.apiCell]}))}_changeCellLanguage(D,v){const b=this._cells[D];b.apiCell.document.languageId!==v&&this._textDocuments.$acceptModelLanguageChanged(b.uri,v)}_changeCellMime(D,v){const b=this._cells[D];b.apiCell.mime=v}_changeCellMetadata(D,v){const b=this._cells[D],g=b.apiCell.metadata;b.setMetadata(v);const d=b.apiCell.metadata;(0,i.equals)(g,d)||this._emitter.emitCellMetadataChange((0,i.deepFreeze)({document:this.apiNotebook,cell:b.apiCell}))}_changeCellInternalMetadata(D,v){this._cells[D].setInternalMetadata(v)}getCellFromApiCell(D){return this._cells.find(v=>v.apiCell===D)}getCellFromIndex(D){return this._cells[D]}getCell(D){return this._cells.find(v=>v.handle===D)}getCellIndex(D){return this._cells.indexOf(D)}}e.ExtHostNotebookDocument=R,R._handlePool=0}),define(ve[130],we([1,0,7,14,15]),function(te,e,f,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class A{constructor(S){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=S}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(S){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:S})}replaceCellMetadata(S,R){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:S,metadata:R})}replaceCells(S,R,F){this._throwIfFinalized(),!(S===R&&F.length===0)&&this._collectedEdits.push({editType:1,index:S,count:R-S,cells:F.map(i.NotebookCellData.from)})}}class C{constructor(S,R,F,D,v,b){this.id=S,this._proxy=R,this.notebookData=F,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=v,this._visibleRanges=D,this._viewColumn=b}get apiEditor(){if(!this._editor){const S=this;this._editor={get document(){return S.notebookData.apiNotebook},get selections(){return S._selections},set selections(R){if(!Array.isArray(R)||!R.every(f.NotebookRange.isNotebookRange))throw(0,I.illegalArgument)("selections");S._selections=R,S._trySetSelections(R)},get visibleRanges(){return S._visibleRanges},revealRange(R,F){S._proxy.$tryRevealRange(S.id,i.NotebookRange.from(R),F??f.NotebookEditorRevealType.Default)},get viewColumn(){return S._viewColumn},edit(R){const F=new A(this.document.version);return R(F),S._applyEdit(F.finalize())},setDecorations(R,F){return S.setDecorations(R,F)}},C.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(S){this._visible=S}_acceptVisibleRanges(S){this._visibleRanges=S}_acceptSelections(S){this._selections=S}_trySetSelections(S){this._proxy.$trySetSelections(this.id,S.map(i.NotebookRange.from))}_acceptViewColumn(S){this._viewColumn=S}_applyEdit(S){if(S.cellEdits.length===0)return Promise.resolve(!0);const R=[];let F=-1;for(let D=0;D<S.cellEdits.length;D++){if(F<0){R.push(S.cellEdits[D]),F++;continue}const b=R[F],g=S.cellEdits[D];if(b.editType===1&&g.editType===1&&b.index===g.index){b.cells.push(...S.cellEdits[D].cells),b.count+=S.cellEdits[D].count;continue}R.push(S.cellEdits[D]),F++}return this._proxy.$tryApplyEdits(this.id,S.documentVersionId,R)}setDecorations(S,R){if(!(R.isEmpty&&!this._hasDecorationsForKey.has(S.key)))return R.isEmpty?this._hasDecorationsForKey.delete(S.key):this._hasDecorationsForKey.add(S.key),this._proxy.$trySetDecorations(this.id,i.NotebookRange.from(R),S.key)}}e.ExtHostNotebookEditor=C,C.apiEditorsToExtHost=new WeakMap}),define(ve[221],we([1,0,14,118,168,21,56,15]),function(te,e,f,i,I,A,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class S{constructor(v){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=v}async withProgress(v,b,g){const d=this._handles++,{title:p,location:P,cancellable:_}=b,l={label:(0,I.localize)(0,null,v.displayName||v.name),id:v.identifier.value};return this._proxy.$startProgress(d,{location:f.ProgressLocation.from(P),title:p,source:l,cancellable:_},v.isUnderDevelopment?void 0:v.identifier.value).catch(k.onUnexpectedExternalError),this._withProgress(d,g,!!_)}_withProgress(v,b,g){let d;g&&(d=new A.CancellationTokenSource,this._mapHandleToCancellationSource.set(v,d));const p=_=>{this._proxy.$progressEnd(_),this._mapHandleToCancellationSource.delete(_),d&&d.dispose()};let P;try{P=b(new F(this._proxy,v),g&&d?d.token:A.CancellationToken.None)}catch(_){throw p(v),_}return P.then(_=>p(v),_=>p(v)),P}$acceptProgressCanceled(v){const b=this._mapHandleToCancellationSource.get(v);b&&(b.cancel(),this._mapHandleToCancellationSource.delete(v))}}e.ExtHostProgress=S;function R(D,v){return D.message=v.message,typeof v.increment=="number"&&(typeof D.increment=="number"?D.increment+=v.increment:D.increment=v.increment),D}class F extends i.Progress{constructor(v,b){super(g=>this.throttledReport(g));this._proxy=v,this._handle=b}throttledReport(v){this._proxy.$progressReport(this._handle,v)}}Be([(0,C.throttle)(100,(D,v)=>R(D,v),()=>Object.create(null))],F.prototype,"throttledReport",null)}),define(ve[131],we([1,0,55,15,75,14,7]),function(te,e,f,i,I,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class k{constructor(v,b,g){const d=k._Keys.nextId();v.$registerTextEditorDecorationType(b.identifier,d,A.DecorationRenderOptions.from(g)),this.value=Object.freeze({key:d,dispose(){v.$removeTextEditorDecorationType(d)}})}}e.TextEditorDecorationType=k,k._Keys=new I.IdGenerator("TextEditorDecorationType");class S{constructor(v,b){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=v,this._documentVersionId=v.version,this._undoStopBefore=b.undoStopBefore,this._undoStopAfter=b.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(v,b){this._throwIfFinalized();let g=null;if(v instanceof C.Position)g=new C.Range(v,v);else if(v instanceof C.Range)g=v;else throw new Error("Unrecognized location");this._pushEdit(g,b,!1)}insert(v,b){this._throwIfFinalized(),this._pushEdit(new C.Range(v,v),b,!0)}delete(v){this._throwIfFinalized();let b=null;if(v instanceof C.Range)b=v;else throw new Error("Unrecognized location");this._pushEdit(b,null,!0)}_pushEdit(v,b,g){const d=this._document.validateRange(v);this._collectedEdits.push({range:d,text:b,forceMoveMarkers:g})}setEndOfLine(v){if(this._throwIfFinalized(),v!==C.EndOfLine.LF&&v!==C.EndOfLine.CRLF)throw(0,i.illegalArgument)("endOfLine");this._setEndOfLine=v}}e.TextEditorEdit=S;class R{constructor(v,b,g,d){this._proxy=v,this._id=b,this._accept(g),this._logService=d;const p=this;this.value={get tabSize(){return p._tabSize},set tabSize(P){p._setTabSize(P)},get insertSpaces(){return p._insertSpaces},set insertSpaces(P){p._setInsertSpaces(P)},get cursorStyle(){return p._cursorStyle},set cursorStyle(P){p._setCursorStyle(P)},get lineNumbers(){return p._lineNumbers},set lineNumbers(P){p._setLineNumbers(P)}}}_accept(v){this._tabSize=v.tabSize,this._insertSpaces=v.insertSpaces,this._cursorStyle=v.cursorStyle,this._lineNumbers=A.TextEditorLineNumbersStyle.to(v.lineNumbers)}_validateTabSize(v){if(v==="auto")return"auto";if(typeof v=="number"){const b=Math.floor(v);return b>0?b:null}if(typeof v=="string"){const b=parseInt(v,10);return isNaN(b)?null:b>0?b:null}return null}_setTabSize(v){const b=this._validateTabSize(v);if(b!==null){if(typeof b=="number"){if(this._tabSize===b)return;this._tabSize=b}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:b}))}}_validateInsertSpaces(v){return v==="auto"?"auto":v==="false"?!1:Boolean(v)}_setInsertSpaces(v){const b=this._validateInsertSpaces(v);if(typeof b=="boolean"){if(this._insertSpaces===b)return;this._insertSpaces=b}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:b}))}_setCursorStyle(v){this._cursorStyle!==v&&(this._cursorStyle=v,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:v})))}_setLineNumbers(v){this._lineNumbers!==v&&(this._lineNumbers=v,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:A.TextEditorLineNumbersStyle.from(v)})))}assign(v){const b={};let g=!1;if(typeof v.tabSize!="undefined"){const d=this._validateTabSize(v.tabSize);d==="auto"?(g=!0,b.tabSize=d):typeof d=="number"&&this._tabSize!==d&&(this._tabSize=d,g=!0,b.tabSize=d)}if(typeof v.insertSpaces!="undefined"){const d=this._validateInsertSpaces(v.insertSpaces);d==="auto"?(g=!0,b.insertSpaces=d):this._insertSpaces!==d&&(this._insertSpaces=d,g=!0,b.insertSpaces=d)}typeof v.cursorStyle!="undefined"&&this._cursorStyle!==v.cursorStyle&&(this._cursorStyle=v.cursorStyle,g=!0,b.cursorStyle=v.cursorStyle),typeof v.lineNumbers!="undefined"&&this._lineNumbers!==v.lineNumbers&&(this._lineNumbers=v.lineNumbers,g=!0,b.lineNumbers=A.TextEditorLineNumbersStyle.from(v.lineNumbers)),g&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,b))}_warnOnError(v,b){b.catch(g=>{this._logService.warn(`ExtHostTextEditorOptions '${v}' failed:'`),this._logService.warn(g)})}}e.ExtHostTextEditorOptions=R;class F{constructor(v,b,g,d,p,P,_,l){this.id=v,this._proxy=b,this._logService=g,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=p,this._options=new R(this._proxy,this.id,P,g),this._visibleRanges=_,this._viewColumn=l;const c=this;this.value=Object.freeze({get document(){return d.getValue()},set document(u){throw(0,i.readonly)("document")},get selection(){return c._selections&&c._selections[0]},set selection(u){if(!(u instanceof C.Selection))throw(0,i.illegalArgument)("selection");c._selections=[u],c._trySetSelection()},get selections(){return c._selections},set selections(u){if(!Array.isArray(u)||u.some(a=>!(a instanceof C.Selection)))throw(0,i.illegalArgument)("selections");c._selections=u,c._trySetSelection()},get visibleRanges(){return c._visibleRanges},set visibleRanges(u){throw(0,i.readonly)("visibleRanges")},get options(){return c._options.value},set options(u){c._disposed||c._options.assign(u)},get viewColumn(){return c._viewColumn},set viewColumn(u){throw(0,i.readonly)("viewColumn")},edit(u,a={undoStopBefore:!0,undoStopAfter:!0}){if(c._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const E=new S(d.getValue(),a);return u(E),c._applyEdit(E)},insertSnippet(u,a,E={undoStopBefore:!0,undoStopAfter:!0}){if(c._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!a||Array.isArray(a)&&a.length===0)s=c._selections.map(t=>A.Range.from(t));else if(a instanceof C.Position){const{lineNumber:t,column:r}=A.Position.from(a);s=[{startLineNumber:t,startColumn:r,endLineNumber:t,endColumn:r}]}else if(a instanceof C.Range)s=[A.Range.from(a)];else{s=[];for(const t of a)if(t instanceof C.Range)s.push(A.Range.from(t));else{const{lineNumber:r,column:n}=A.Position.from(t);s.push({startLineNumber:r,startColumn:n,endLineNumber:r,endColumn:n})}}return b.$tryInsertSnippet(v,u.value,s,E)},setDecorations(u,a){const E=a.length===0;E&&!c._hasDecorationsForKey.has(u.key)||(E?c._hasDecorationsForKey.delete(u.key):c._hasDecorationsForKey.add(u.key),c._runOnProxy(()=>{if(A.isDecorationOptionsArr(a))return b.$trySetDecorations(v,u.key,A.fromRangeOrRangeWithMessage(a));{const s=new Array(4*a.length);for(let t=0,r=a.length;t<r;t++){const n=a[t];s[4*t]=n.start.line+1,s[4*t+1]=n.start.character+1,s[4*t+2]=n.end.line+1,s[4*t+3]=n.end.character+1}return b.$trySetDecorationsFast(v,u.key,s)}}))},revealRange(u,a){c._runOnProxy(()=>b.$tryRevealRange(v,A.Range.from(u),a||C.TextEditorRevealType.Default))},show(u){b.$tryShowEditor(v,A.ViewColumn.from(u))},hide(){b.$tryHideEditor(v)}})}dispose(){(0,f.ok)(!this._disposed),this._disposed=!0}_acceptOptions(v){(0,f.ok)(!this._disposed),this._options._accept(v)}_acceptVisibleRanges(v){(0,f.ok)(!this._disposed),this._visibleRanges=v}_acceptViewColumn(v){(0,f.ok)(!this._disposed),this._viewColumn=v}_acceptSelections(v){(0,f.ok)(!this._disposed),this._selections=v}async _trySetSelection(){const v=this._selections.map(A.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,v)),this.value}_applyEdit(v){const b=v.finalize();if(b.edits.length===0&&!b.setEndOfLine)return Promise.resolve(!0);const g=b.edits.map(p=>p.range);g.sort((p,P)=>p.end.line===P.end.line?p.end.character===P.end.character?p.start.line===P.start.line?p.start.character-P.start.character:p.start.line-P.start.line:p.end.character-P.end.character:p.end.line-P.end.line);for(let p=0,P=g.length-1;p<P;p++){const _=g[p].end;if(g[p+1].start.isBefore(_))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const d=b.edits.map(p=>({range:A.Range.from(p.range),text:p.text,forceMoveMarkers:p.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,b.documentVersionId,d,{setEndOfLine:typeof b.setEndOfLine=="number"?A.EndOfLine.from(b.setEndOfLine):void 0,undoStopBefore:b.undoStopBefore,undoStopAfter:b.undoStopAfter})}_runOnProxy(v){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):v().then(()=>this,b=>(b instanceof Error&&b.name==="DISPOSED"||this._logService.warn(b),null))}}e.ExtHostTextEditor=F}),define(ve[222],we([1,0,16,3,6,13,62,14,84,85,35]),function(te,e,f,i,I,A,C,k,S,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class D extends I.Disposable{constructor(b){super();this.controllerId=b,this.debounceSendDiff=this._register(new f.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new i.Emitter),this.root=new C.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(b){this._resolveHandler=b;for(const g of this.tree.values())this.updateExpandability(g)}collectDiff(){const b=this.diff;return this.diff=[],b}pushDiff(b){const g=this.diff[this.diff.length-1];if(g&&b.op===1){if(g.op===1&&g.item.extId===b.item.extId){(0,S.applyTestItemUpdate)(g.item,b.item);return}if(g.op===0&&g.item.item.extId===b.item.extId){(0,S.applyTestItemUpdate)(g.item,b.item);return}}this.diff.push(b),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(b,g){const d=this.tree.get(b);if(!!d){if((d.expandLevels===void 0||g>d.expandLevels)&&(d.expandLevels=g),d.expand===1){const p=this.resolveChildren(d);return p.isOpen()?this.expandChildren(d,g-1):p.wait().then(()=>this.expandChildren(d,g-1))}else if(d.expand===3)return d.resolveBarrier?.isOpen()===!1?d.resolveBarrier.wait().then(()=>this.expandChildren(d,g-1)):this.expandChildren(d,g-1)}}dispose(){for(const b of this.tree.values())(0,C.getPrivateApiFor)(b.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(b,g){switch(g.op){case 2:this.pushDiff({op:4,itemId:b.fullId.toString()});break;case 1:this.removeItem(R.TestId.joinToString(b.fullId,g.id));break;case 0:this.upsertItem(g.item,b);break;case 4:for(const d of g.ops)this.onTestItemEvent(b,d);break;case 3:{const{key:d,value:p,previous:P}=g,_=b.fullId.toString();switch(d){case"canResolveChildren":this.updateExpandability(b);break;case"tags":this.diffTagRefs(p,P,_);break;case"range":this.pushDiff({op:1,item:{extId:_,item:{range:F.Range.lift(k.Range.from(p))}}});break;case"error":this.pushDiff({op:1,item:{extId:_,item:{error:k.MarkdownString.fromStrict(p)||null}}});break;default:this.pushDiff({op:1,item:{extId:_,item:{[d]:p??null}}});break}break}default:(0,A.assertNever)(g)}}upsertItem(b,g){if(!(b instanceof C.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${b.id} did not`);const d=R.TestId.fromExtHostTestItem(b,this.root.id,g?.actual),p=(0,C.getPrivateApiFor)(b);p.parent&&p.parent!==g?.actual&&p.parent.children.delete(b.id);let P=this.tree.get(d.toString());if(!P){P={fullId:d,actual:b,parent:g?d.parentId:null,expandLevels:g?.expandLevels?g.expandLevels-1:void 0,expand:0},b.tags.forEach(this.incrementTagRefs,this),this.tree.set(P.fullId.toString(),P),this.setItemParent(b,g),this.pushDiff({op:0,item:{parent:P.parent&&P.parent.toString(),controllerId:this.controllerId,expand:P.expand,item:k.TestItem.from(b)}}),this.connectItemAndChildren(b,P,g);return}if(P.actual===b){this.connectItem(b,P,g);return}const _=P.actual.children,l=P.actual,c=(0,C.diffTestItems)(l,b);(0,C.getPrivateApiFor)(l).listener=void 0,P.actual=b,P.expand=0;for(const[u,a]of c)this.onTestItemEvent(P,{op:3,key:u,value:a,previous:l[u]});this.connectItemAndChildren(b,P,g);for(const u of _)b.children.get(u.id)||this.removeItem(R.TestId.joinToString(d,u.id))}diffTagRefs(b,g,d){const p=new Set(g.map(P=>P.id));for(const P of b)p.delete(P.id)||this.incrementTagRefs(P);this.pushDiff({op:1,item:{extId:d,item:{tags:b.map(P=>k.TestTag.namespace(this.controllerId,P.id))}}}),p.forEach(this.decrementTagRefs,this)}incrementTagRefs(b){const g=this.tags.get(b.id);g?g.refCount++:(this.tags.set(b.id,{refCount:1}),this.pushDiff({op:5,tag:{id:k.TestTag.namespace(this.controllerId,b.id),ctrlLabel:this.root.label}}))}decrementTagRefs(b){const g=this.tags.get(b);g&&!--g.refCount&&(this.tags.delete(b),this.pushDiff({op:6,id:(0,S.namespaceTestTag)(this.controllerId,b)}))}setItemParent(b,g){(0,C.getPrivateApiFor)(b).parent=g&&g.actual!==this.root?g.actual:void 0}connectItem(b,g,d){this.setItemParent(b,d);const p=(0,C.getPrivateApiFor)(b);p.parent=d?.actual,p.listener=P=>this.onTestItemEvent(g,P),this.updateExpandability(g)}connectItemAndChildren(b,g,d){this.connectItem(b,g,d);for(const p of b.children)this.upsertItem(p,g)}updateExpandability(b){let g;this._resolveHandler?b.resolveBarrier?g=b.resolveBarrier.isOpen()?3:2:g=b.actual.canResolveChildren?1:0:g=0,g!==b.expand&&(b.expand=g,this.pushDiff({op:1,item:{extId:b.fullId.toString(),expand:g}}),g===1&&b.expandLevels!==void 0&&this.resolveChildren(b))}expandChildren(b,g){if(g<0)return;const d=[];for(const p of b.actual.children){const P=this.expand(R.TestId.joinToString(b.fullId,p.id),g);(0,f.isThenable)(P)&&d.push(P)}if(d.length)return Promise.all(d).then(()=>{})}resolveChildren(b){if(b.resolveBarrier)return b.resolveBarrier;if(!this._resolveHandler){const P=new f.Barrier;return P.open(),P}b.expand=2,this.pushExpandStateUpdate(b);const g=b.resolveBarrier=new f.Barrier,d=P=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),b.actual!==this.root&&(b.actual.error=P.stack||P.message||String(P))};let p;try{p=this._resolveHandler(b.actual===this.root?void 0:b.actual)}catch(P){d(P)}return(0,f.isThenable)(p)?p.catch(d).then(()=>{g.open(),this.updateExpandability(b)}):(g.open(),this.updateExpandability(b)),b.resolveBarrier}pushExpandStateUpdate(b){this.pushDiff({op:1,item:{extId:b.fullId.toString(),expand:b.expand}})}removeItem(b){const g=this.tree.get(b);if(!g)throw new Error("attempting to remove non-existent child");this.pushDiff({op:2,itemId:b});const d=[g];for(;d.length;){const p=d.pop();if(!!p){(0,C.getPrivateApiFor)(p.actual).listener=void 0;for(const P of p.actual.tags)this.decrementTagRefs(P.id);this.tree.delete(p.fullId.toString());for(const P of p.actual.children)d.push(this.tree.get(R.TestId.joinToString(p.fullId,P.id)))}}}flushDiff(){const b=this.collectDiff();b.length&&this.diffOpEmitter.fire(b)}}e.SingleUseTestCollection=D}),define(ve[223],we([1,0,4,185]),function(te,e,f,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,f.refineServiceDecorator)(i.IEnvironmentService)}),define(ve[224],we([1,0,27,3,9]),function(te,e,f,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class A{constructor(F){this.removedDueToLooping=F}}e.DeltaExtensionsResult=A;class C{constructor(F){this._onDidChange=new i.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=F,this._initialize()}_initialize(){this._extensionDescriptions.sort(S),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const F of this._extensionDescriptions){if(this._extensionsMap.has(f.ExtensionIdentifier.toKey(F.identifier))){console.error("Extension `"+F.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(f.ExtensionIdentifier.toKey(F.identifier),F),this._extensionsArr.push(F),Array.isArray(F.activationEvents))for(let D of F.activationEvents)D==="onUri"&&(D=`onUri:${f.ExtensionIdentifier.toKey(F.identifier)}`),this._activationMap.has(D)||this._activationMap.set(D,[]),this._activationMap.get(D).push(F)}}keepOnly(F){const D=new Set;F.forEach(v=>D.add(f.ExtensionIdentifier.toKey(v))),this._extensionDescriptions=this._extensionDescriptions.filter(v=>D.has(f.ExtensionIdentifier.toKey(v.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(F,D){F.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(F));const v=C._findLoopingExtensions(this._extensionDescriptions);if(D=D.concat(v.map(b=>b.identifier)),D.length>0){const b=new Set;D.forEach(g=>b.add(f.ExtensionIdentifier.toKey(g))),this._extensionDescriptions=this._extensionDescriptions.filter(g=>!b.has(f.ExtensionIdentifier.toKey(g.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new A(v)}static _findLoopingExtensions(F){const D=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(p){this._nodesSet.has(p)||(this._nodesSet.add(p),this._nodesArr.push(p))}addArc(p,P){this.addNode(p),this.addNode(P),this._arcs.has(p)?this._arcs.get(p).push(P):this._arcs.set(p,[P])}getArcs(p){return this._arcs.has(p)?this._arcs.get(p):[]}hasOnlyGoodArcs(p,P){const _=D.getArcs(p);for(let l=0;l<_.length;l++)if(!P.has(_[l]))return!1;return!0}getNodes(){return this._nodesArr}};let v=new Map;for(let p of F){const P=f.ExtensionIdentifier.toKey(p.identifier);if(v.set(P,p),p.extensionDependencies)for(let _ of p.extensionDependencies){const l=f.ExtensionIdentifier.toKey(_);D.addArc(P,l)}}let b=new Set;D.getNodes().filter(p=>D.getArcs(p).length===0).forEach(p=>b.add(p));let g=D.getNodes().filter(p=>!b.has(p)),d;do{d=!1;for(let p=0;p<g.length;p++){const P=g[p];D.hasOnlyGoodArcs(P,b)&&(g.splice(p,1),p--,b.add(P),d=!0)}}while(d);return g.map(p=>v.get(p))}containsActivationEvent(F){return this._activationMap.has(F)}containsExtension(F){return this._extensionsMap.has(f.ExtensionIdentifier.toKey(F))}getExtensionDescriptionsForActivationEvent(F){const D=this._activationMap.get(F);return D?D.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(F){const D=this._extensionsMap.get(f.ExtensionIdentifier.toKey(F));return D||void 0}}e.ExtensionDescriptionRegistry=C;var k;(function(R){R[R.Builtin=0]="Builtin",R[R.User=1]="User",R[R.Dev=2]="Dev"})(k||(k={}));function S(R,F){const D=R.isBuiltin?0:R.isUnderDevelopment?2:1,v=F.isBuiltin?0:F.isUnderDevelopment?2:1;if(D!==v)return D-v;const b=I.posix.basename(R.extensionLocation.path),g=I.posix.basename(F.extensionLocation.path);return b<g?-1:b>g?1:0}}),define(ve[132],we([1,0,22]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var i;(function(S){S[S.Desktop=1]="Desktop",S[S.Web=2]="Web"})(i=e.UIKind||(e.UIKind={}));var I;(function(S){S[S.VersionMismatch=55]="VersionMismatch",S[S.UnexpectedError=81]="UnexpectedError"})(I=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var A;(function(S){S[S.Initialized=0]="Initialized",S[S.Ready=1]="Ready",S[S.Terminate=2]="Terminate"})(A=e.MessageType||(e.MessageType={}));function C(S){const R=f.VSBuffer.alloc(1);switch(S){case 0:R.writeUInt8(1,0);break;case 1:R.writeUInt8(2,0);break;case 2:R.writeUInt8(3,0);break}return R}e.createMessageOfType=C;function k(S,R){if(S.byteLength!==1)return!1;switch(S.readUInt8(0)){case 1:return R===0;case 2:return R===1;case 3:return R===2;default:return!1}}e.isMessageOfType=k}),define(ve[30],we([1,0,3,2,4,27,122]),function(te,e,f,i,I,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.extensionRunningLocationToString=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new A.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:i.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,I.createDecorator)("extensionService");var k;(function(c){c[c.None=0]="None",c[c.LocalProcess=1]="LocalProcess",c[c.LocalWebWorker=2]="LocalWebWorker",c[c.Remote=3]="Remote"})(k=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));function S(c){switch(c){case 0:return"None";case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionRunningLocationToString=S;class R{constructor(u){this.dependency=u}}e.MissingExtensionDependency=R;var F;(function(c){c[c.LocalProcess=0]="LocalProcess",c[c.LocalWebWorker=1]="LocalWebWorker",c[c.Remote=2]="Remote"})(F=e.ExtensionHostKind||(e.ExtensionHostKind={}));function D(c){switch(c){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=D;function v(c,u){return c.enabledApiProposals?c.enabledApiProposals.includes(u):!1}e.isProposedApiEnabled=v;function b(c,u){if(!v(c,u))throw new Error(`Extension '${c.identifier.value}' CANNOT use API proposal: ${u}.
Its package.json#enabledApiProposals-property declares: ${c.enabledApiProposals?.join(", ")??"[]"} but NOT ${u}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${c.identifier.value}`)}e.checkProposedApiEnabled=b;class g{constructor(u,a,E,s){this.codeLoadingTime=u,this.activateCallTime=a,this.activateResolvedTime=E,this.activationReason=s}}e.ActivationTimes=g;class d{constructor(u,a){this.description=u,this.value=a}}e.ExtensionPointContribution=d,e.ExtensionHostLogFileName="exthost";var p;(function(c){c[c.Normal=0]="Normal",c[c.Immediate=1]="Immediate"})(p=e.ActivationKind||(e.ActivationKind={}));function P(c){return{type:c.isBuiltin?0:1,isBuiltin:c.isBuiltin||c.isUserBuiltin,identifier:{id:(0,C.getGalleryExtensionId)(c.publisher,c.name),uuid:c.uuid},manifest:c,location:c.extensionLocation}}e.toExtension=P;function _(c,u){return{identifier:new A.ExtensionIdentifier((0,C.getExtensionId)(c.manifest.publisher,c.manifest.name)),isBuiltin:c.type===0,isUserBuiltin:c.type===1&&c.isBuiltin,isUnderDevelopment:!!u,extensionLocation:c.location,...c.manifest,uuid:c.identifier.uuid}}e.toExtensionDescription=_;class l{constructor(){this.onDidRegisterExtensions=f.Event.None,this.onDidChangeExtensionsStatus=f.Event.None,this.onDidChangeExtensions=f.Event.None,this.onWillActivateByEvent=f.Event.None,this.onDidChangeResponsiveChange=f.Event.None}activateByEvent(u){return Promise.resolve(void 0)}activationEventIsDone(u){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(u){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(u){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(u){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(u,a){return Promise.resolve()}}e.NullExtensionService=l}),define(ve[225],we([1,0,15,27,30,11]),function(te,e,f,i,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const C=Promise.resolve(void 0);class k{constructor(d,p,P,_){this.startup=d,this.codeLoadingTime=p,this.activateCallTime=P,this.activateResolvedTime=_}}e.ExtensionActivationTimes=k,k.NONE=new k(!1,-1,-1,-1);class S{constructor(d){this._startup=d,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(d,p){return d===-1||p===-1?-1:p-d}build(){return new k(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=S;class R{constructor(d,p,P,_,l,c){this.activationFailed=d,this.activationFailedError=p,this.activationTimes=P,this.module=_,this.exports=l,this.subscriptions=c}}e.ActivatedExtension=R;class F extends R{constructor(d){super(!1,null,d,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=F;class D extends R{constructor(){super(!1,null,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=D;class v extends R{constructor(d){super(!0,d,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=v;let b=class{constructor(d,p,P,_,l){this._logService=l,this._isDisposed=!1,this._registry=d,this._resolvedExtensionsSet=new Set,p.forEach(c=>this._resolvedExtensionsSet.add(i.ExtensionIdentifier.toKey(c))),this._hostExtensionsMap=new Map,P.forEach(c=>this._hostExtensionsMap.set(i.ExtensionIdentifier.toKey(c),c)),this._host=_,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){this._isDisposed=!0}isActivated(d){const p=i.ExtensionIdentifier.toKey(d);return this._activatedExtensions.has(p)}getActivatedExtension(d){const p=i.ExtensionIdentifier.toKey(d),P=this._activatedExtensions.get(p);if(!P)throw new Error("Extension `"+d.value+"` is not known or not activated");return P}activateByEvent(d,p){if(this._alreadyActivatedEvents[d])return C;const P=this._registry.getExtensionDescriptionsForActivationEvent(d);return this._activateExtensions(P.map(_=>({id:_.identifier,reason:{startup:p,extensionId:_.identifier,activationEvent:d}}))).then(()=>{this._alreadyActivatedEvents[d]=!0})}activateById(d,p){const P=this._registry.getExtensionDescription(d);if(!P)throw new Error("Extension `"+d+"` is not known");return this._activateExtensions([{id:P.identifier,reason:p}])}_handleActivateRequest(d,p,P){if(this._hostExtensionsMap.has(i.ExtensionIdentifier.toKey(d.id))){p[i.ExtensionIdentifier.toKey(d.id)]=d;return}const _=this._registry.getExtensionDescription(d.id);if(!_){const u=new Error(`Cannot activate unknown extension '${d.id.value}'`);this._host.onExtensionActivationError(d.id,u,new I.MissingExtensionDependency(d.id.value)),this._activatedExtensions.set(i.ExtensionIdentifier.toKey(d.id),new v(u));return}const l=typeof _.extensionDependencies=="undefined"?[]:_.extensionDependencies;let c=!0;for(let u=0,a=l.length;u<a;u++){const E=l[u];if(this._resolvedExtensionsSet.has(i.ExtensionIdentifier.toKey(E)))continue;const s=this._activatedExtensions.get(i.ExtensionIdentifier.toKey(E));if(s&&!s.activationFailed)continue;if(s&&s.activationFailed){const o=_.displayName||_.identifier.value,m=this._registry.getExtensionDescription(E),h=m&&m.displayName||E,w=new Error(`Cannot activate the '${o}' extension because its dependency '${h}' failed to activate`);w.detail=s.activationFailedError,this._host.onExtensionActivationError(_.identifier,w,null),this._activatedExtensions.set(i.ExtensionIdentifier.toKey(_.identifier),new v(w));return}if(this._hostExtensionsMap.has(i.ExtensionIdentifier.toKey(E))){c=!1,p[i.ExtensionIdentifier.toKey(E)]={id:this._hostExtensionsMap.get(i.ExtensionIdentifier.toKey(E)),reason:d.reason};continue}const t=this._registry.getExtensionDescription(E);if(t){if(!t.main&&!t.browser)continue;c=!1,p[i.ExtensionIdentifier.toKey(E)]={id:t.identifier,reason:d.reason};continue}const r=_.displayName||_.identifier.value,n=new Error(`Cannot activate the '${r}' extension because it depends on unknown extension '${E}'`);this._host.onExtensionActivationError(_.identifier,n,new I.MissingExtensionDependency(E)),this._activatedExtensions.set(i.ExtensionIdentifier.toKey(_.identifier),new v(n));return}c?p[i.ExtensionIdentifier.toKey(_.identifier)]=d:P.push(d)}_activateExtensions(d){if(d.length===0||(d=d.filter(l=>!this._activatedExtensions.has(i.ExtensionIdentifier.toKey(l.id))),d.length===0))return Promise.resolve(void 0);const p=Object.create(null),P=[];for(let l=0,c=d.length;l<c;l++)this._handleActivateRequest(d[l],p,P);for(let l=0,c=P.length;l<c;l++){const u=i.ExtensionIdentifier.toKey(P[l].id);p[u]&&delete p[u]}const _=Object.keys(p).map(l=>p[l]);return P.length===0?Promise.all(_.map(l=>this._activateExtension(l.id,l.reason))).then(l=>{}):this._activateExtensions(_).then(l=>this._activateExtensions(P))}_activateExtension(d,p){const P=i.ExtensionIdentifier.toKey(d);if(this._activatedExtensions.has(P))return Promise.resolve(void 0);const _=this._activatingExtensions.get(P);if(_)return _;const l=this._host.actualActivateExtension(d,p).then(void 0,c=>{const u=new Error;return c&&c.name&&(u.name=c.name),c&&c.message?u.message=`Activating extension '${d.value}' failed: ${c.message}.`:u.message=`Activating extension '${d.value}' failed: ${c}.`,c&&c.stack&&(u.stack=c.stack),this._isDisposed&&f.isCancellationError(c)?new v(c):(this._host.onExtensionActivationError(d,u,null),this._logService.error(`Activating extension ${d.value} failed due to an error:`),this._logService.error(c),new v(c))}).then(c=>{this._activatedExtensions.set(P,c),this._activatingExtensions.delete(P)});return this._activatingExtensions.set(P,l),l}};b=Be([Fe(4,A.ILogService)],b),e.ExtensionsActivator=b}),define(ve[226],we([1,0,11,26,30]),function(te,e,f,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let A=class extends f.LogService{constructor(k,S){super(k.createLogger(S.logFile,{name:I.ExtensionHostLogFileName}))}};A=Be([Fe(0,f.ILoggerService),Fe(1,i.IExtHostInitDataService)],A),e.ExtHostLogService=A}),define(ve[227],we([1,0,15]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class i{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((A,C)=>{this._actualOk=A,this._actualErr=C,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(A){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=A,this._actual&&this._actualOk(A))}resolveErr(A){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=A,this._actual?this._actualErr(A):(0,f.onUnexpectedError)(A))}then(A,C){return this._ensureActual().then(A,C)}catch(A){return this._ensureActual().then(void 0,A)}finally(A){return this._ensureActual().finally(A)}}e.LazyPromise=i}),define(ve[52],we([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class f{constructor(S){this._proxyIdentifierBrand=void 0,this.sid=S,this.nid=++f.count}}e.ProxyIdentifier=f,f.count=0;const i=[];function I(k){const S=new f(k);return i[S.nid]=S,S}e.createProxyIdentifier=I;function A(k){return i[k].sid}e.getStringIdentifierForProxy=A;class C{constructor(S){this.value=S}}e.SerializableObjectWithBuffers=C}),define(ve[5],we([1,0,58,2,52]),function(te,e,f,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabKind=e.TextEditorRevealType=void 0;var A;(function(_){_[_.Default=0]="Default",_[_.InCenter=1]="InCenter",_[_.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",_[_.AtTop=3]="AtTop"})(A=e.TextEditorRevealType||(e.TextEditorRevealType={}));var C;(function(_){_[_.Singular=0]="Singular",_[_.Diff=1]="Diff",_[_.SidebySide=2]="SidebySide",_[_.Other=3]="Other"})(C=e.TabKind||(e.TabKind={}));var k;(function(_){_[_.Editable=0]="Editable",_[_.SupportsHotExit=1]="SupportsHotExit"})(k=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var S;(function(_){_[_.Int8Array=1]="Int8Array",_[_.Uint8Array=2]="Uint8Array",_[_.Uint8ClampedArray=3]="Uint8ClampedArray",_[_.Int16Array=4]="Int16Array",_[_.Uint16Array=5]="Uint16Array",_[_.Int32Array=6]="Int32Array",_[_.Uint32Array=7]="Uint32Array",_[_.Float32Array=8]="Float32Array",_[_.Float64Array=9]="Float64Array",_[_.BigInt64Array=10]="BigInt64Array",_[_.BigUint64Array=11]="BigUint64Array"})(S=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var R;(function(_){_[_.Text=1]="Text",_[_.Error=2]="Error",_[_.Rich=3]="Rich"})(R=e.CellOutputKind||(e.CellOutputKind={}));var F;(function(_){_[_.Default=0]="Default",_[_.InCenter=1]="InCenter",_[_.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",_[_.AtTop=3]="AtTop"})(F=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var D;(function(_){_[_.None=0]="None",_[_.Process=1]="Process",_[_.Output=2]="Output"})(D=e.CandidatePortSource||(e.CandidatePortSource={}));class v{static mixin(l){return l._id=v._n++,l}}e.IdObject=v,v._n=0;var b;(function(_){_.label="a",_.kind="b",_.detail="c",_.documentation="d",_.sortText="e",_.filterText="f",_.preselect="g",_.insertText="h",_.insertTextRules="i",_.range="j",_.commitCharacters="k",_.additionalTextEdits="l",_.command="m",_.kindModifier="n"})(b=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var g;(function(_){_.defaultRanges="a",_.completions="b",_.isIncomplete="c",_.duration="d"})(g=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var d;(function(_){_[_.File=1]="File",_[_.Text=2]="Text",_[_.Cell=3]="Cell"})(d=e.WorkspaceEditType||(e.WorkspaceEditType={}));function p(_){if(_&&_.edits)for(const l of _.edits)typeof l.resource=="object"?l.resource=i.URI.revive(l.resource):(l.newUri=i.URI.revive(l.newUri),l.oldUri=i.URI.revive(l.oldUri)),l.metadata&&l.metadata.iconPath&&(l.metadata=(0,f.revive)(l.metadata));return _}e.reviveWorkspaceEditDto=p;var P;(function(_){_[_.Workspace=0]="Workspace",_[_.TextDocument=1]="TextDocument"})(P=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,I.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,I.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,I.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,I.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,I.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,I.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,I.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,I.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,I.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,I.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,I.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,I.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,I.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,I.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,I.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,I.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,I.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,I.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,I.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,I.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,I.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,I.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,I.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,I.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,I.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,I.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,I.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,I.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,I.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,I.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,I.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,I.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,I.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,I.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,I.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,I.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,I.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,I.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,I.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,I.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,I.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,I.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,I.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,I.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,I.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,I.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,I.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,I.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,I.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,I.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,I.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,I.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,I.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,I.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,I.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,I.createProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,I.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,I.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,I.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,I.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,I.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,I.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,I.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,I.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,I.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,I.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,I.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,I.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,I.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,I.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,I.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,I.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,I.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,I.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,I.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,I.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,I.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,I.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,I.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,I.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,I.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,I.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,I.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,I.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,I.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,I.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,I.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,I.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,I.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,I.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,I.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,I.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,I.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,I.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,I.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,I.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,I.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,I.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,I.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,I.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,I.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,I.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,I.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,I.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,I.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,I.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,I.createProxyIdentifier)("ExtHostTelemetry")}}),define(ve[86],we([1,0,5,3,4]),function(te,e,f,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class A{constructor(k){this._onDidChangePassword=new i.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=k.getProxy(f.MainContext.MainThreadSecretState)}async $onDidChangePassword(k){this._onDidChangePassword.fire(k)}get(k,S){return this._proxy.$getPassword(k,S)}store(k,S,R){return this._proxy.$setPassword(k,S,R)}delete(k,S){return this._proxy.$deletePassword(k,S)}}e.ExtHostSecretState=A,e.IExtHostSecretState=(0,I.createDecorator)("IExtHostSecretState")}),define(ve[64],we([1,0,4,11,5,17]),function(te,e,f,i,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,f.createDecorator)("IExtHostApiDeprecationService");let C=class{constructor(S,R){this._extHostLogService=R,this._reportedUsages=new Set,this._telemetryShape=S.getProxy(I.MainContext.MainThreadTelemetry)}report(S,R,F){const D=this.getUsageKey(S,R);this._reportedUsages.has(D)||(this._reportedUsages.add(D),R.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${S}' is deprecated. ${F}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:R.identifier.value,apiId:S}))}getUsageKey(S,R){return`${S}-${R.identifier.value}`}};C=Be([Fe(0,A.IExtHostRpcService),Fe(1,i.ILogService)],C),e.ExtHostApiDeprecationService=C,e.NullApiDeprecationService=Object.freeze(new class{report(k,S,R){}})}),define(ve[228],we([1,0,3,5,7,27]),function(te,e,f,i,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class C{constructor(S){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new f.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=S.getProxy(i.MainContext.MainThreadAuthentication)}$setProviders(S){return this._providers=S,Promise.resolve()}async getSession(S,R,F,D={}){const v=A.ExtensionIdentifier.toKey(S.identifier),b=this._inFlightRequests.get(v)||[],g=[...F].sort().join(" ");let d=b.find(p=>p.scopes===g);if(d)return d.result;{const p=this._getSession(S,v,R,F,D);d={scopes:g,result:p},b.push(d),this._inFlightRequests.set(v,b);try{await p}finally{const P=b.findIndex(_=>_.scopes===g);P>-1&&(b.splice(P),this._inFlightRequests.set(v,b))}return p}}async _getSession(S,R,F,D,v={}){await this._proxy.$ensureProvider(F);const b=S.displayName||S.name;return this._proxy.$getSession(F,D,R,b,v)}async removeSession(S,R){const F=this._authenticationProviders.get(S);return F?F.provider.removeSession(R):this._proxy.$removeSession(S,R)}registerAuthenticationProvider(S,R,F,D){if(this._authenticationProviders.get(S))throw new Error(`An authentication provider with id '${S}' is already registered.`);this._authenticationProviders.set(S,{label:R,provider:F,options:D??{supportsMultipleAccounts:!1}}),this._providers.find(b=>b.id===S)||this._providers.push({id:S,label:R});const v=F.onDidChangeSessions(b=>{this._proxy.$sendDidChangeSessions(S,{added:b.added??[],changed:b.changed??[],removed:b.removed??[]})});return this._proxy.$registerAuthenticationProvider(S,R,D?.supportsMultipleAccounts??!1),new I.Disposable(()=>{v.dispose(),this._authenticationProviders.delete(S);const b=this._providers.findIndex(g=>g.id===S);b>-1&&this._providers.splice(b),this._proxy.$unregisterAuthenticationProvider(S)})}$createSession(S,R){const F=this._authenticationProviders.get(S);if(F)return Promise.resolve(F.provider.createSession(R));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$removeSession(S,R){const F=this._authenticationProviders.get(S);if(F)return Promise.resolve(F.provider.removeSession(R));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$getSessions(S,R){const F=this._authenticationProviders.get(S);if(F)return Promise.resolve(F.provider.getSessions(R));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$onDidChangeAuthenticationSessions(S,R){return this._onDidChangeSessions.fire({provider:{id:S,label:R}}),Promise.resolve()}}e.ExtHostAuthentication=C}),define(ve[229],we([1,0,5,17,14]),function(te,e,f,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let A=class{constructor(k,S){this._proxy=k.getProxy(f.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:R=>S.getDocument(R)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(k){const S=I.WorkspaceEdit.from(k,this._versionInformationProvider);return this._proxy.$tryApplyWorkspaceEdit(S)}};A=Be([Fe(0,i.IExtHostRpcService)],A),e.ExtHostBulkEdits=A}),define(ve[230],we([1,0,5]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class i{constructor(A){const C=A.getProxy(f.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return C.$readText()},writeText(k){return C.$writeText(k)}})}}e.ExtHostClipboard=i});var Xe=this&&this.__classPrivateFieldSet||function(te,e,f,i,I){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!I:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?I.call(te,f):I?I.value=f:e.set(te,f),f},Pe=this&&this.__classPrivateFieldGet||function(te,e,f,i){if(f==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!i:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?i:f==="a"?i.call(te):i?i.value:e.get(te)};define(ve[39],we([1,0,13,7,14,25,5,18,11,58,35,48,2,6,4,17,62,22,52,49]),function(te,e,f,i,I,A,C,k,S,R,F,D,v,b,g,d,p,P,_,l){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let u=class{constructor(n,o){c.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,Xe(this,c,n.getProxy(C.MainContext.MainThreadCommands),"f"),this._logService=o,this.converter=new a(this,m=>{const h=this._apiCommands.get(m);return h?.result===s.Void?h:void 0},o),this._argumentProcessors=[{processArgument(m){return(0,R.revive)(m)}},{processArgument(m){return(0,A.cloneAndChange)(m,function(h){if(F.Range.isIRange(h))return I.Range.to(h);if(D.Position.isIPosition(h))return I.Position.to(h);if(F.Range.isIRange(h.range)&&v.URI.isUri(h.uri))return I.location.to(h);if(h instanceof P.VSBuffer)return h.buffer.buffer;if(!Array.isArray(h))return h})}}]}registerArgumentProcessor(n){this._argumentProcessors.push(n)}registerApiCommand(n){const o=this.registerCommand(!1,n.id,async(...m)=>{const h=n.args.map((T,L)=>{if(!T.validate(m[L]))throw new Error(`Invalid argument '${T.name}' when running '${n.id}', received: ${m[L]}`);return T.convert(m[L])}),w=await this.executeCommand(n.internalId,...h);return n.result.convert(w,m,this.converter)},void 0,{description:n.description,args:n.args,returns:n.result.description});return this._apiCommands.set(n.id,n),new i.Disposable(()=>{o.dispose(),this._apiCommands.delete(n.id)})}registerCommand(n,o,m,h,w,T){if(this._logService.trace("ExtHostCommands#registerCommand",o),!o.trim().length)throw new Error("invalid id");if(this._commands.has(o))throw new Error(`command '${o}' already exists`);return this._commands.set(o,{callback:m,thisArg:h,description:w,extension:T}),n&&Pe(this,c,"f").$registerCommand(o),new i.Disposable(()=>{this._commands.delete(o)&&n&&Pe(this,c,"f").$unregisterCommand(o)})}executeCommand(n,...o){return this._logService.trace("ExtHostCommands#executeCommand",n),this._doExecuteCommand(n,o,!0)}async _doExecuteCommand(n,o,m){if(this._commands.has(n))return this._executeContributedCommand(n,o,!1);{let h=!1;const w=(0,A.cloneAndChange)(o,function(T){if(T instanceof i.Position)return I.Position.from(T);if(T instanceof i.Range)return I.Range.from(T);if(T instanceof i.Location)return I.location.from(T);if(i.NotebookRange.isNotebookRange(T))return I.NotebookRange.from(T);if(T instanceof ArrayBuffer)return h=!0,P.VSBuffer.wrap(new Uint8Array(T));if(T instanceof Uint8Array)return h=!0,P.VSBuffer.wrap(T);if(!Array.isArray(T))return T});try{const T=await Pe(this,c,"f").$executeCommand(n,h?new _.SerializableObjectWithBuffers(w):w,m);return(0,R.revive)(T)}catch(T){if(T instanceof Error&&T.message==="$executeCommand:retry")return this._doExecuteCommand(n,o,!1);throw T}}}async _executeContributedCommand(n,o,m){const h=this._commands.get(n);if(!h)throw new Error("Unknown command");let{callback:w,thisArg:T,description:L}=h;if(L)for(let O=0;O<L.args.length;O++)try{(0,f.validateConstraint)(o[O],L.args[O].constraint)}catch{throw new Error(`Running the contributed command: '${n}' failed. Illegal argument '${L.args[O].name}' - ${L.args[O].description}`)}try{return await w.apply(T,o)}catch(O){if(n===this.converter.delegatingCommandId){const y=this.converter.getActualCommand(...o);y&&(n=y.command)}throw this._logService.error(O,n,h.extension?.identifier),m?new class extends Error{constructor(){super((0,l.toErrorMessage)(O));this.id=n,this.source=h.extension?.displayName??h.extension?.name}}:O}}$executeContributedCommand(n,...o){return this._logService.trace("ExtHostCommands#$executeContributedCommand",n),this._commands.has(n)?(o=o.map(m=>this._argumentProcessors.reduce((h,w)=>w.processArgument(h),m)),this._executeContributedCommand(n,o,!0)):Promise.reject(new Error(`Contributed command '${n}' does not exist.`))}getCommands(n=!1){return this._logService.trace("ExtHostCommands#getCommands",n),Pe(this,c,"f").$getCommands().then(o=>(n&&(o=o.filter(m=>m[0]!=="_")),o))}$getContributedCommandHandlerDescriptions(){const n=Object.create(null);for(let[o,m]of this._commands){let{description:h}=m;h&&(n[o]=h)}return Promise.resolve(n)}};c=new WeakMap,u=Be([Fe(0,d.IExtHostRpcService),Fe(1,S.ILogService)],u),e.ExtHostCommands=u,e.IExtHostCommands=(0,g.createDecorator)("IExtHostCommands");class a{constructor(n,o,m){this._commands=n,this._lookupApiCommand=o,this._logService=m,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(n,o){if(!n)return;const m={$ident:void 0,id:n.command,title:n.title,tooltip:n.tooltip};if(!n.command)return m;const h=this._lookupApiCommand(n.command);if(h)m.id=h.internalId,m.arguments=h.args.map((w,T)=>w.convert(n.arguments&&n.arguments[T]));else if((0,k.isNonEmptyArray)(n.arguments)){const w=++this._cachIdPool;this._cache.set(w,n),o.add((0,b.toDisposable)(()=>{this._cache.delete(w),this._logService.trace("CommandsConverter#DISPOSE",w)})),m.$ident=w,m.id=this.delegatingCommandId,m.arguments=[w],this._logService.trace("CommandsConverter#CREATE",n.command,w)}return m}fromInternal(n){return typeof n.$ident=="number"?this._cache.get(n.$ident):{command:n.id,title:n.title,arguments:n.arguments}}getActualCommand(...n){return this._cache.get(n[0])}_executeConvertedCommand(...n){const o=this.getActualCommand(...n);return this._logService.trace("CommandsConverter#EXECUTE",n[0],o?o.command:"MISSING"),o?this._commands.executeCommand(o.command,...o.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=a;class E{constructor(n,o,m,h){this.name=n,this.description=o,this.validate=m,this.convert=h}optional(){return new E(this.name,`(optional) ${this.description}`,n=>n==null||this.validate(n),n=>n===void 0?void 0:n===null?null:this.convert(n))}with(n,o){return new E(n??this.name,o??this.description,this.validate,this.convert)}}e.ApiCommandArgument=E,E.Uri=new E("uri","Uri of a text document",r=>v.URI.isUri(r),r=>r),E.Position=new E("position","A position in a text document",r=>i.Position.isPosition(r),I.Position.from),E.Range=new E("range","A range in a text document",r=>i.Range.isRange(r),I.Range.from),E.Selection=new E("selection","A selection in a text document",r=>i.Selection.isSelection(r),I.Selection.from),E.Number=new E("number","",r=>typeof r=="number",r=>r),E.String=new E("string","",r=>typeof r=="string",r=>r),E.CallHierarchyItem=new E("item","A call hierarchy item",r=>r instanceof i.CallHierarchyItem,I.CallHierarchyItem.from),E.TypeHierarchyItem=new E("item","A type hierarchy item",r=>r instanceof i.TypeHierarchyItem,I.TypeHierarchyItem.from),E.TestItem=new E("testItem","A VS Code TestItem",r=>r instanceof p.TestItemImpl,I.TestItem.from);class s{constructor(n,o){this.description=n,this.convert=o}}e.ApiCommandResult=s,s.Void=new s("no result",r=>r);class t{constructor(n,o,m,h,w){this.id=n,this.internalId=o,this.description=m,this.args=h,this.result=w}}e.ApiCommand=t}),define(ve[231],we([1,0,2,14,7,78,39,18,111,117,10]),function(te,e,f,i,I,A,C,k,S,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const D=[new C.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",b(i.DocumentHighlight.to))),new C.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(d,p)=>{if((0,k.isFalsyOrEmpty)(d))return;class P extends I.SymbolInformation{static to(l){const c=new P(l.name,i.SymbolKind.to(l.kind),l.containerName||"",new I.Location(p[0],i.Range.to(l.range)));return c.detail=l.detail,c.range=c.location.range,c.selectionRange=i.Range.to(l.selectionRange),c.children=l.children?l.children.map(P.to):[],c}}return d.map(P.to)})),new C.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("options","Formatting options",d=>!0,d=>d)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",b(i.TextEdit.to))),new C.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range,new C.ApiCommandArgument("options","Formatting options",d=>!0,d=>d)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",b(i.TextEdit.to))),new C.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,new C.ApiCommandArgument("ch","Trigger character",d=>typeof d=="string",d=>d),new C.ApiCommandArgument("options","Formatting options",d=>!0,d=>d)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",b(i.TextEdit.to))),new C.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new C.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new C.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new C.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new C.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location-instances.",b(i.location.to))),new C.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Hover-instances.",b(i.Hover.to))),new C.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("position","A position in a text document",d=>Array.isArray(d)&&d.every(p=>I.Position.isPosition(p)),d=>d.map(i.Position.from))],new C.ApiCommandResult("A promise that resolves to an array of ranges.",d=>d.map(p=>{let P;for(const _ of p.reverse())P=new I.SelectionRange(i.Range.to(_),P);return P}))),new C.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[C.ApiCommandArgument.String.with("query","Search string")],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",d=>d.map(i.WorkspaceSymbol.to))),new C.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A CallHierarchyItem or undefined",d=>d.map(i.CallHierarchyItem.to))),new C.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A CallHierarchyItem or undefined",d=>d.map(i.CallHierarchyIncomingCall.to))),new C.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A CallHierarchyItem or undefined",d=>d.map(i.CallHierarchyOutgoingCall.to))),new C.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to a range and placeholder text.",d=>{if(!!d)return{range:i.Range.to(d.range),placeholder:d.text}})),new C.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("newName","The new symbol name")],new C.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",d=>{if(!!d){if(d.rejectReason)throw new Error(d.rejectReason);return i.WorkspaceEdit.to(d)}})),new C.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new C.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",d=>d.map(i.DocumentLink.to))),new C.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",d=>{if(!!d)return new I.SemanticTokensLegend(d.tokenTypes,d.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",d=>{if(!d)return;const p=(0,S.decodeSemanticTokensDto)(d);if(p.type==="full")return new I.SemanticTokens(p.data,void 0)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range.optional()],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",d=>{if(!!d)return new I.SemanticTokensLegend(d.tokenTypes,d.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",d=>{if(!d)return;const p=(0,S.decodeSemanticTokensDto)(d);if(p.type==="full")return new I.SemanticTokens(p.data,void 0)})),new C.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new C.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(d,p,P)=>{if(!d)return new I.CompletionList([]);const _=d.suggestions.map(l=>i.CompletionItem.to(l,P));return new I.CompletionList(_,d.incomplete)})),new C.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new C.ApiCommandResult("A promise that resolves to SignatureHelp.",d=>{if(d)return i.SignatureHelp.to(d)})),new C.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new C.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(d,p,P)=>b(_=>new I.CodeLens(i.Range.to(_.range),_.command&&P.fromInternal(_.command)))(d))),new C.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",d=>I.Range.isRange(d),d=>I.Selection.isSelection(d)?i.Selection.from(d):i.Range.from(d)),C.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new C.ApiCommandResult("A promise that resolves to an array of Command-instances.",(d,p,P)=>b(_=>{if(_._isSynthetic){if(!_.command)throw new Error("Synthetic code actions must have a command");return P.fromInternal(_.command)}else{const l=new I.CodeAction(_.title,_.kind?new I.CodeActionKind(_.kind):void 0);return _.edit&&(l.edit=i.WorkspaceEdit.to(_.edit)),_.command&&(l.command=P.fromInternal(_.command)),l.isPreferred=_.isPreferred,l}})(d))),new C.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",d=>d?d.map(p=>new I.ColorInformation(i.Range.to(p.range),i.Color.to(p.color))):[])),new C.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new C.ApiCommandArgument("color","The color to show and insert",d=>d instanceof I.Color,i.Color.from),new C.ApiCommandArgument("context","Context object with uri and range",d=>!0,d=>({uri:d.uri,range:i.Range.from(d.range)}))],new C.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",d=>d?d.map(i.ColorPresentation.to):[])),new C.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of Inlay objects",(d,p,P)=>d.map(i.InlayHint.to.bind(void 0,P)))),new C.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new C.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",b(d=>({viewType:d.viewType,displayName:d.displayName,options:{transientOutputs:d.options.transientOutputs,transientCellMetadata:d.options.transientCellMetadata,transientDocumentMetadata:d.options.transientDocumentMetadata},filenamePattern:d.filenamePattern.map(p=>i.NotebookExclusiveDocumentPattern.to(p))})))),new C.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of InlineValue objects",d=>d.map(i.InlineValue.to))),new C.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new C.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",d=>f.URI.isUri(d)||typeof d=="string"&&(0,R.matchesSomeScheme)(d,F.Schemas.http,F.Schemas.https),d=>d),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",d=>d===void 0||typeof d=="number"||typeof d=="object",d=>d&&(typeof d=="number"?[i.ViewColumn.from(d),void 0]:[i.ViewColumn.from(d.viewColumn),i.TextEditorOpenOptions.from(d)])).optional(),C.ApiCommandArgument.String.with("label","").optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[C.ApiCommandArgument.Uri.with("resource","Resource to open"),C.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",d=>d===void 0||typeof d=="number"||typeof d=="object",d=>d&&(typeof d=="number"?[i.ViewColumn.from(d),void 0]:[i.ViewColumn.from(d.viewColumn),i.TextEditorOpenOptions.from(d)])).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[C.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),C.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),C.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",d=>d===void 0||typeof d=="object",d=>d&&[i.ViewColumn.from(d.viewColumn),i.TextEditorOpenOptions.from(d)]).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A TypeHierarchyItem or undefined",d=>d.map(i.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A TypeHierarchyItem or undefined",d=>d.map(i.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A TypeHierarchyItem or undefined",d=>d.map(i.TypeHierarchyItem.to))),new C.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[C.ApiCommandArgument.TestItem],C.ApiCommandResult.Void)];class v{static register(p){D.forEach(p.registerApiCommand,p)}}e.ExtHostApiCommands=v;function b(d){return p=>{if(Array.isArray(p))return p.map(d)}}function g(d){if(!Array.isArray(d))return;const p=[];for(const P of d)A.isLocationLink(P)?p.push(i.DefinitionLink.to(P)):p.push(i.location.to(P));return p}}),define(ve[232],we([1,0,16,56,3,6,2,78,27,14,7,5]),function(te,e,f,i,I,A,C,k,S,R,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function v(b,g,d){const p=b.getProxy(D.MainContext.MainThreadComments);class P{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,g.registerArgumentProcessor({processArgument:t=>{if(t&&t.$mid===6){const r=this._commentControllers.get(t.handle);return r||t}else if(t&&t.$mid===7){const r=this._commentControllers.get(t.commentControlHandle);if(!r)return t;const n=r.getCommentThread(t.commentThreadHandle);return n||t}else if(t&&t.$mid===8){const r=this._commentControllers.get(t.thread.commentControlHandle);if(!r)return t;const n=r.getCommentThread(t.thread.commentThreadHandle);return n?{thread:n,text:t.text}:t}else if(t&&t.$mid===9){const r=this._commentControllers.get(t.thread.commentControlHandle);if(!r)return t;const n=r.getCommentThread(t.thread.commentThreadHandle);if(!n)return t;let o=t.commentUniqueId,m=n.getCommentByUniqueId(o);return m||t}else if(t&&t.$mid===10){const r=this._commentControllers.get(t.thread.commentControlHandle);if(!r)return t;const n=r.getCommentThread(t.thread.commentThreadHandle);if(!n)return t;let o=t.text,m=t.commentUniqueId,h=n.getCommentByUniqueId(m);return h?(h.body=o,h):t}return t}})}createCommentController(t,r,n){const o=P.handlePool++,m=new l(t,o,r,n);this._commentControllers.set(m.handle,m);const h=this._commentControllersByExtension.get(S.ExtensionIdentifier.toKey(t.identifier))||[];return h.push(m),this._commentControllersByExtension.set(S.ExtensionIdentifier.toKey(t.identifier),h),m.value}$createCommentThreadTemplate(t,r,n){const o=this._commentControllers.get(t);!o||o.$createCommentThreadTemplate(r,n)}async $updateCommentThreadTemplate(t,r,n){const o=this._commentControllers.get(t);!o||o.$updateCommentThreadTemplate(r,n)}$deleteCommentThread(t,r){const n=this._commentControllers.get(t);n&&n.$deleteCommentThread(r)}$provideCommentingRanges(t,r,n){const o=this._commentControllers.get(t);if(!o||!o.commentingRangeProvider)return Promise.resolve(void 0);const m=d.getDocument(C.URI.revive(r));return(0,f.asPromise)(()=>o.commentingRangeProvider.provideCommentingRanges(m,n)).then(h=>h?h.map(w=>R.Range.from(w)):void 0)}$toggleReaction(t,r,n,o,m){const h=this._commentControllers.get(t);return!h||!h.reactionHandler?Promise.resolve(void 0):(0,f.asPromise)(()=>{const w=h.getCommentThread(r);if(w){const T=w.getCommentByUniqueId(o.uniqueIdInThread);if(h!==void 0&&T&&h.reactionHandler)return h.reactionHandler(T,a(m))}return Promise.resolve(void 0)})}dispose(){}}P.handlePool=0;class _{constructor(t,r,n,o,m,h,w){this._commentControllerHandle=r,this._id=n,this._uri=o,this._range=m,this._comments=h,this.extensionDescription=w,this.handle=_._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new I.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputDisposables.value=new A.DisposableStore,this._id===void 0&&(this._id=`${t}.${this.handle}`),p.$createCommentThread(r,this.handle,this._id,this._uri,R.Range.from(this._range),w.identifier),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=h,this._localDisposables.push({dispose:()=>{p.$deleteCommentThread(r,this.handle)}});const T=this;this.value={get uri(){return T.uri},get range(){return T.range},set range(L){T.range=L},get comments(){return T.comments},set comments(L){T.comments=L},get collapsibleState(){return T.collapsibleState},set collapsibleState(L){T.collapsibleState=L},get canReply(){return T.canReply},set canReply(L){T.canReply=L},get contextValue(){return T.contextValue},set contextValue(L){T.contextValue=L},get label(){return T.label},set label(L){T.label=L},dispose:()=>{T.dispose()}}}set threadId(t){this._id=t}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(t){t.isEqual(this._range)||(this._range=t,this.modifications.range=t,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(t){this._canReply!==t&&(this._canReply=t,this.modifications.canReply=t,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(t){this._label=t,this.modifications.label=t,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(t){this._contextValue=t,this.modifications.contextValue=t,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(t){this._comments=t,this.modifications.comments=t,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(t){this._collapseState=t,this.modifications.collapsibleState=t,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new A.DisposableStore);const t=n=>Object.prototype.hasOwnProperty.call(this.modifications,n),r={};t("range")&&(r.range=R.Range.from(this._range)),t("label")&&(r.label=this.label),t("contextValue")&&(r.contextValue=this.contextValue??null),t("comments")&&(r.comments=this._comments.map(n=>c(this,n,this._commentsMap))),t("collapsibleState")&&(r.collapseState=E(this._collapseState)),t("canReply")&&(r.canReply=this.canReply),this.modifications={},p.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,r)}getCommentByUniqueId(t){for(let r of this._commentsMap){let n=r[0],o=r[1];if(t===o)return n}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(t=>t.dispose())}}_._handlePool=0,Be([(0,i.debounce)(100)],_.prototype,"eventuallyUpdateCommentThread",null);class l{constructor(t,r,n,o){this._extension=t,this._handle=r,this._id=n,this._label=o,this._threads=new Map,p.$registerCommentController(this.handle,n,o);const m=this;this.value=Object.freeze({id:m.id,label:m.label,get options(){return m.options},set options(h){m.options=h},get commentingRangeProvider(){return m.commentingRangeProvider},set commentingRangeProvider(h){m.commentingRangeProvider=h},get reactionHandler(){return m.reactionHandler},set reactionHandler(h){m.reactionHandler=h},createCommentThread(h,w,T){return m.createCommentThread(h,w,T).value},dispose:()=>{m.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{p.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(t){this._commentingRangeProvider=t,p.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(t){this._reactionHandler=t,p.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!t})}get options(){return this._options}set options(t){this._options=t,p.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(t,r,n,o){if(typeof t=="string"){const m=new _(this.id,this.handle,t,r,n,o,this._extension);return this._threads.set(m.handle,m),m}else{const m=new _(this.id,this.handle,void 0,t,r,n,this._extension);return this._threads.set(m.handle,m),m}}$createCommentThreadTemplate(t,r){const n=new _(this.id,this.handle,void 0,C.URI.revive(t),R.Range.to(r),[],this._extension);return n.collapsibleState=k.CommentThreadCollapsibleState.Expanded,this._threads.set(n.handle,n),n}$updateCommentThreadTemplate(t,r){let n=this._threads.get(t);n&&(n.range=R.Range.to(r))}$deleteCommentThread(t){let r=this._threads.get(t);r&&r.dispose(),this._threads.delete(t)}getCommentThread(t){return this._threads.get(t)}dispose(){this._threads.forEach(t=>{t.dispose()}),this._localDisposables.forEach(t=>t.dispose())}}function c(s,t,r){let n=r.get(t);n||(n=++s.commentHandle,r.set(t,n));const o=t.author&&t.author.iconPath?t.author.iconPath.toString():void 0;return{mode:t.mode,contextValue:t.contextValue,uniqueIdInThread:n,body:typeof t.body=="string"?t.body:R.MarkdownString.from(t.body),userName:t.author.name,userIconPath:o,label:t.label,commentReactions:t.reactions?t.reactions.map(m=>u(m)):void 0,timestamp:t.timestamp?.toJSON()}}function u(s){return{label:s.label,iconPath:s.iconPath?R.pathOrURIToURI(s.iconPath):void 0,count:s.count,hasReacted:s.authorHasReacted}}function a(s){return{label:s.label||"",count:s.count||0,iconPath:s.iconPath?C.URI.revive(s.iconPath):"",authorHasReacted:s.hasReacted||!1}}function E(s){if(s!==void 0)switch(s){case F.CommentThreadCollapsibleState.Expanded:return k.CommentThreadCollapsibleState.Expanded;case F.CommentThreadCollapsibleState.Collapsed:return k.CommentThreadCollapsibleState.Collapsed}return k.CommentThreadCollapsibleState.Collapsed}return new P}e.createExtHostComments=v}),define(ve[133],we([1,0,2,5,7,4,17,11,18,8,9]),function(te,e,f,i,I,A,C,k,S,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let D=class Ei{constructor(b,g){this._logService=g,this._provider=new Map,this._proxy=b.getProxy(i.MainContext.MainThreadDecorations)}registerFileDecorationProvider(b,g){const d=Ei._handlePool++;this._provider.set(d,{provider:b,extensionId:g}),this._proxy.$registerDecorationProvider(d,g.value);const p=b.onDidChangeFileDecorations&&b.onDidChangeFileDecorations(P=>{if(!P){this._proxy.$onDidChange(d,null);return}let _=(0,S.asArray)(P);if(_.length<=Ei._maxEventSize){this._proxy.$onDidChange(d,_);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",g.value,_.length);const l=_.map(a=>({uri:a,rank:(0,R.count)(a.path,"/")})),c=(0,S.groupBy)(l,(a,E)=>a.rank-E.rank||(0,R.compare)(a.uri.path,E.uri.path));let u=[];e:for(let a of c){let E;for(let s of a){let t=(0,F.dirname)(s.uri.path);if(E!==t&&(E=t,u.push(s.uri)>=Ei._maxEventSize))break e}}this._proxy.$onDidChange(d,u)});return new I.Disposable(()=>{p?.dispose(),this._proxy.$unregisterDecorationProvider(d),this._provider.delete(d)})}async $provideDecorations(b,g,d){if(!this._provider.has(b))return Object.create(null);const p=Object.create(null),{provider:P,extensionId:_}=this._provider.get(b);return await Promise.all(g.map(async l=>{try{const{uri:c,id:u}=l,a=await Promise.resolve(P.provideFileDecoration(f.URI.revive(c),d));if(!a)return;try{I.FileDecoration.validate(a),p[u]=[a.propagate,a.tooltip,a.badge,a.color]}catch(E){this._logService.warn(`INVALID decoration from extension '${_.value}': ${E}`)}}catch(c){this._logService.error(c)}})),p}};D._handlePool=0,D._maxEventSize=250,D=Be([Fe(0,C.IExtHostRpcService),Fe(1,k.ILogService)],D),e.ExtHostDecorations=D,e.IExtHostDecorations=(0,A.createDecorator)("IExtHostDecorations")});var Xe=this&&this.__classPrivateFieldSet||function(te,e,f,i,I){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!I:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?I.call(te,f):I?I.value=f:e.set(te,f),f},Pe=this&&this.__classPrivateFieldGet||function(te,e,f,i){if(f==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!i:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?i:f==="a"?i.call(te):i?i.value:e.get(te)};define(ve[233],we([1,0,166,116,2,5,7,14,3,11,24,44]),function(te,e,f,i,I,A,C,k,S,R,F,D){"use strict";var v,b,g;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class d{constructor(_,l,c,u,a,E){this._name=_,this._owner=l,this._maxDiagnosticsPerFile=c,v.set(this,void 0),b.set(this,void 0),g.set(this,void 0),this._isDisposed=!1,Xe(this,g,new F.ResourceMap(s=>u.getComparisonKey(s)),"f"),Xe(this,v,a,"f"),Xe(this,b,E,"f")}dispose(){this._isDisposed||(Pe(this,b,"f").fire([...Pe(this,g,"f").keys()]),Pe(this,v,"f")&&Pe(this,v,"f").$clear(this._owner),Pe(this,g,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(_,l){if(!_){this.clear();return}this._checkDisposed();let c=[];if(I.URI.isUri(_)){if(!l){this.delete(_);return}Pe(this,g,"f").set(_,l.slice()),c=[_]}else if(Array.isArray(_)){c=[];let a;_=[..._].sort(d._compareIndexedTuplesByUri);for(const E of _){const[s,t]=E;if((!a||s.toString()!==a.toString())&&(a&&Pe(this,g,"f").get(a).length===0&&Pe(this,g,"f").delete(a),a=s,c.push(s),Pe(this,g,"f").set(s,[])),t){const r=Pe(this,g,"f").get(s);r&&r.push(...t)}else{const r=Pe(this,g,"f").get(s);r&&(r.length=0)}}}if(Pe(this,b,"f").fire(c),!Pe(this,v,"f"))return;const u=[];for(let a of c){let E=[];const s=Pe(this,g,"f").get(a);if(s)if(s.length>this._maxDiagnosticsPerFile){E=[];const t=[C.DiagnosticSeverity.Error,C.DiagnosticSeverity.Warning,C.DiagnosticSeverity.Information,C.DiagnosticSeverity.Hint];e:for(let r=0;r<4;r++)for(let n of s)if(n.severity===t[r]&&E.push(k.Diagnostic.from(n))===this._maxDiagnosticsPerFile)break e;E.push({severity:i.MarkerSeverity.Info,message:(0,f.localize)(0,null,s.length-this._maxDiagnosticsPerFile),startLineNumber:E[E.length-1].startLineNumber,startColumn:E[E.length-1].startColumn,endLineNumber:E[E.length-1].endLineNumber,endColumn:E[E.length-1].endColumn})}else E=s.map(t=>k.Diagnostic.from(t));u.push([a,E])}Pe(this,v,"f").$changeMany(this._owner,u)}delete(_){this._checkDisposed(),Pe(this,b,"f").fire([_]),Pe(this,g,"f").delete(_),Pe(this,v,"f")&&Pe(this,v,"f").$changeMany(this._owner,[[_,void 0]])}clear(){this._checkDisposed(),Pe(this,b,"f").fire([...Pe(this,g,"f").keys()]),Pe(this,g,"f").clear(),Pe(this,v,"f")&&Pe(this,v,"f").$clear(this._owner)}forEach(_,l){this._checkDisposed();for(let c of Pe(this,g,"f").keys())_.apply(l,[c,this.get(c),this])}get(_){this._checkDisposed();const l=Pe(this,g,"f").get(_);return Array.isArray(l)?Object.freeze(l.slice(0)):[]}has(_){return this._checkDisposed(),Array.isArray(Pe(this,g,"f").get(_))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(_,l){return _[0].toString()<l[0].toString()?-1:_[0].toString()>l[0].toString()?1:0}}e.DiagnosticCollection=d,v=new WeakMap,b=new WeakMap,g=new WeakMap;let p=class oi{constructor(_,l,c){this._logService=l,this._fileSystemInfoService=c,this._collections=new Map,this._onDidChangeDiagnostics=new S.DebounceEmitter({merge:u=>u.flat(),delay:50}),this.onDidChangeDiagnostics=S.Event.map(this._onDidChangeDiagnostics.event,oi._mapper),this._proxy=_.getProxy(A.MainContext.MainThreadDiagnostics)}static _mapper(_){const l=new F.ResourceMap;for(const c of _)l.set(c,c);return{uris:Object.freeze(Array.from(l.values()))}}createDiagnosticCollection(_,l){const{_collections:c,_proxy:u,_onDidChangeDiagnostics:a,_logService:E,_fileSystemInfoService:s}=this,t=new class{$changeMany(o,m){u.$changeMany(o,m),E.trace("[DiagnosticCollection] change many (extension, owner, uris)",_.value,o,m.length===0?"CLEARING":m)}$clear(o){u.$clear(o),E.trace("[DiagnosticCollection] remove all (extension, owner)",_.value,o)}dispose(){u.dispose()}};let r;if(!l)l="_generated_diagnostic_collection_name_#"+oi._idPool++,r=l;else if(!c.has(l))r=l;else{this._logService.warn(`DiagnosticCollection with name '${l}' does already exist.`);do r=l+oi._idPool++;while(c.has(r))}return new class extends d{constructor(){super(l,r,oi._maxDiagnosticsPerFile,s.extUri,t,a);c.set(r,this)}dispose(){super.dispose(),c.delete(r)}}}getDiagnostics(_){if(_)return this._getDiagnostics(_);{const l=new Map,c=[];for(const u of this._collections.values())u.forEach((a,E)=>{let s=l.get(a.toString());typeof s=="undefined"&&(s=c.length,l.set(a.toString(),s),c.push([a,[]])),c[s][1]=c[s][1].concat(...E)});return c}}_getDiagnostics(_){let l=[];for(let c of this._collections.values())c.has(_)&&(l=l.concat(c.get(_)));return l}$acceptMarkersChange(_){if(!this._mirrorCollection){const l="_generated_mirror",c=new d(l,l,oi._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(l,c),this._mirrorCollection=c}for(const[l,c]of _)this._mirrorCollection.set(I.URI.revive(l),c.map(k.Diagnostic.to))}};p._idPool=0,p._maxDiagnosticsPerFile=1e3,p=Be([Fe(1,R.ILogService),Fe(2,D.IExtHostFileSystemInfo)],p),e.ExtHostDiagnostics=p}),define(ve[234],we([1,0,2,5]),function(te,e,f,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class I{constructor(C){this._proxy=C.getProxy(i.MainContext.MainThreadDialogs)}showOpenDialog(C){return this._proxy.$showOpenDialog(C).then(k=>k?k.map(S=>f.URI.revive(S)):void 0)}showSaveDialog(C){return this._proxy.$showSaveDialog(C).then(k=>k?f.URI.revive(k):void 0)}}e.ExtHostDialogs=I}),define(ve[235],we([1,0,15,2,7,5,10,21,8]),function(te,e,f,i,I,A,C,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class R{constructor(D,v,b){this._documentsAndEditors=v,this._logService=b,this._documentContentProviders=new Map,this._proxy=D.getProxy(A.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(D,v){if(Object.keys(C.Schemas).indexOf(D)>=0)throw new Error(`scheme '${D}' already registered`);const b=R._handlePool++;this._documentContentProviders.set(b,v),this._proxy.$registerTextContentProvider(b,D);let g;return typeof v.onDidChange=="function"&&(g=v.onDidChange(d=>{if(d.scheme!==D){this._logService.warn(`Provider for scheme '${D}' is firing event for schema '${d.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(d)&&this.$provideTextDocumentContent(b,d).then(p=>{if(!p&&typeof p!="string")return;const P=this._documentsAndEditors.getDocument(d);if(!P)return;const _=(0,S.splitLines)(p);if(!P.equalLines(_))return this._proxy.$onVirtualDocumentChange(d,p)},f.onUnexpectedError)})),new I.Disposable(()=>{this._documentContentProviders.delete(b)&&this._proxy.$unregisterTextContentProvider(b),g&&(g.dispose(),g=void 0)})}$provideTextDocumentContent(D,v){const b=this._documentContentProviders.get(D);return b?Promise.resolve(b.provideTextDocumentContent(i.URI.revive(v),k.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${v.scheme}`))}}e.ExtHostDocumentContentProvider=R,R._handlePool=0}),define(ve[236],we([1,0,3,6,2,5,125,14,13,25,7]),function(te,e,f,i,I,A,C,k,S,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class D{constructor(b,g){this._onDidAddDocument=new f.Emitter,this._onDidRemoveDocument=new f.Emitter,this._onDidChangeDocument=new f.Emitter,this._onDidSaveDocument=new f.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new i.DisposableStore,this._documentLoader=new Map,this._proxy=b.getProxy(A.MainContext.MainThreadDocuments),this._documentsAndEditors=g,this._documentsAndEditors.onDidRemoveDocuments(d=>{for(const p of d)this._onDidRemoveDocument.fire(p.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(d=>{for(const p of d)this._onDidAddDocument.fire(p.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(b){if(!b)return;const g=this._documentsAndEditors.getDocument(b);if(g)return g}getDocument(b){const g=this.getDocumentData(b);if(!g?.document)throw new Error(`Unable to retrieve document from URI '${b}'`);return g.document}ensureDocumentData(b){const g=this._documentsAndEditors.getDocument(b);if(g)return Promise.resolve(g);let d=this._documentLoader.get(b.toString());return d||(d=this._proxy.$tryOpenDocument(b).then(p=>{this._documentLoader.delete(b.toString());const P=I.URI.revive(p);return(0,S.assertIsDefined)(this._documentsAndEditors.getDocument(P))},p=>(this._documentLoader.delete(b.toString()),Promise.reject(p))),this._documentLoader.set(b.toString(),d)),d}createDocumentData(b){return this._proxy.$tryCreateDocument(b).then(g=>I.URI.revive(g))}$acceptModelLanguageChanged(b,g){const d=I.URI.revive(b),p=this._documentsAndEditors.getDocument(d);if(!p)throw new Error("unknown document");this._onDidRemoveDocument.fire(p.document),p._acceptLanguageId(g),this._onDidAddDocument.fire(p.document)}$acceptModelSaved(b){const g=I.URI.revive(b),d=this._documentsAndEditors.getDocument(g);if(!d)throw new Error("unknown document");this.$acceptDirtyStateChanged(b,!1),this._onDidSaveDocument.fire(d.document)}$acceptDirtyStateChanged(b,g){const d=I.URI.revive(b),p=this._documentsAndEditors.getDocument(d);if(!p)throw new Error("unknown document");p._acceptIsDirty(g),this._onDidChangeDocument.fire({document:p.document,contentChanges:[],reason:void 0})}$acceptModelChanged(b,g,d){const p=I.URI.revive(b),P=this._documentsAndEditors.getDocument(p);if(!P)throw new Error("unknown document");P._acceptIsDirty(d),P.onEvents(g);let _;g.isUndoing?_=F.TextDocumentChangeReason.Undo:g.isRedoing&&(_=F.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,R.deepFreeze)({document:P.document,contentChanges:g.changes.map(l=>({range:k.Range.to(l.range),rangeOffset:l.rangeOffset,rangeLength:l.rangeLength,text:l.text})),reason:_}))}setWordDefinitionFor(b,g){(0,C.setWordDefinitionFor)(b,g)}}e.ExtHostDocuments=D}),define(ve[45],we([1,0,55,3,6,2,4,5,125,17,131,14,11,24,10,76,89]),function(te,e,f,i,I,A,C,k,S,R,F,D,v,b,g,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class P{constructor(c){this.value=c,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let _=class{constructor(c,u){this._extHostRpc=c,this._logService=u,this._activeEditorId=null,this._editors=new Map,this._documents=new b.ResourceMap,this._onDidAddDocuments=new i.Emitter,this._onDidRemoveDocuments=new i.Emitter,this._onDidChangeVisibleTextEditors=new i.Emitter,this._onDidChangeActiveTextEditor=new i.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(c){this.acceptDocumentsAndEditorsDelta(c)}acceptDocumentsAndEditorsDelta(c){const u=[],a=[],E=[];if(c.removedDocuments)for(const s of c.removedDocuments){const t=A.URI.revive(s),r=this._documents.get(t);r?.unref()&&(this._documents.delete(t),u.push(r.value))}if(c.addedDocuments)for(const s of c.addedDocuments){const t=A.URI.revive(s.uri);let r=this._documents.get(t);if(r&&t.scheme!==g.Schemas.vscodeNotebookCell&&t.scheme!==g.Schemas.vscodeInteractiveInput)throw new Error(`document '${t} already exists!'`);r||(r=new P(new S.ExtHostDocumentData(this._extHostRpc.getProxy(k.MainContext.MainThreadDocuments),t,s.lines,s.EOL,s.versionId,s.languageId,s.isDirty,s.notebook)),this._documents.set(t,r),a.push(r.value)),r.ref()}if(c.removedEditors)for(const s of c.removedEditors){const t=this._editors.get(s);this._editors.delete(s),t&&E.push(t)}if(c.addedEditors)for(const s of c.addedEditors){const t=A.URI.revive(s.documentUri);f.ok(this._documents.has(t),`document '${t}' does not exist`),f.ok(!this._editors.has(s.id),`editor '${s.id}' already exists!`);const r=this._documents.get(t).value,n=new F.ExtHostTextEditor(s.id,this._extHostRpc.getProxy(k.MainContext.MainThreadTextEditors),this._logService,new p.Lazy(()=>r.document),s.selections.map(D.Selection.to),s.options,s.visibleRanges.map(o=>D.Range.to(o)),typeof s.editorPosition=="number"?D.ViewColumn.to(s.editorPosition):void 0);this._editors.set(s.id,n)}c.newActiveEditor!==void 0&&(f.ok(c.newActiveEditor===null||this._editors.has(c.newActiveEditor),`active editor '${c.newActiveEditor}' does not exist`),this._activeEditorId=c.newActiveEditor),(0,I.dispose)(u),(0,I.dispose)(E),c.removedDocuments&&this._onDidRemoveDocuments.fire(u),c.addedDocuments&&this._onDidAddDocuments.fire(a),(c.removedEditors||c.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(s=>s.value)),c.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(c){return this._documents.get(c)?.value}allDocuments(){return d.Iterable.map(this._documents.values(),c=>c.value)}getEditor(c){return this._editors.get(c)}activeEditor(c){if(!this._activeEditorId)return;const u=this._editors.get(this._activeEditorId);return c?u:u?.value}allEditors(){return[...this._editors.values()]}};_=Be([Fe(0,R.IExtHostRpcService),Fe(1,v.ILogService)],_),e.ExtHostDocumentsAndEditors=_,e.IExtHostDocumentsAndEditors=(0,C.createDecorator)("IExtHostDocumentsAndEditors")}),define(ve[53],we([1,0,14,5,2,3,4,17]),function(te,e,f,i,I,A,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,C.createDecorator)("IExtHostEditorTabs");let S=class{constructor(F){this._onDidChangeTabGroup=new A.Emitter,this.onDidChangeTabGroup=this._onDidChangeTabGroup.event,this._tabGroups={all:[],activeTabGroup:void 0,onDidChangeTabGroup:this._onDidChangeTabGroup.event},this._proxy=F.getProxy(i.MainContext.MainThreadEditorTabs)}get tabGroups(){return this._tabGroups}$acceptEditorTabModel(F){this._tabGroups.all.length=0;for(const D of F){let v;const b=D.tabs.map(g=>{const d=this.createExtHostTabObject(g);return g.isActive&&(v=d),d});this._tabGroups.all.push(Object.freeze({isActive:D.isActive,viewColumn:f.ViewColumn.to(D.viewColumn),activeTab:v,tabs:b})),D.isActive&&(this._tabGroups.activeTabGroup=this._tabGroups.all[this._tabGroups.all.length-1])}this._onDidChangeTabGroup.fire()}createExtHostTabObject(F){return Object.freeze({label:F.label,viewColumn:f.ViewColumn.to(F.viewColumn),resource:I.URI.revive(F.resource),additionalResourcesAndViewIds:F.additionalResourcesAndViewIds.map(({resource:D,viewId:v})=>({resource:I.URI.revive(D),viewId:v})),viewId:F.editorId,isActive:F.isActive,kind:F.kind,isDirty:F.isDirty,isPinned:F.isPinned,move:async(D,v)=>{this._proxy.$moveTab(F,D,f.ViewColumn.from(v))},close:async()=>{await this._proxy.$closeTab(F)}})}};S=Be([Fe(0,k.IExtHostRpcService)],S),e.ExtHostEditorTabs=S}),define(ve[237],we([1,0,2,5,6,7,14,150,8,22,30]),function(te,e,f,i,I,A,C,k,S,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class D{constructor(){this._schemes=[]}add(g){this._stateMachine=void 0,this._schemes.push(g)}delete(g){const d=this._schemes.indexOf(g);d>=0&&(this._schemes.splice(d,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const g=this._schemes.sort(),d=[];let p,P,_=14,l=14;for(const c of g){let u=p?(0,S.commonPrefixLength)(p,c):0;for(u===0?P=1:P=l;u<c.length;u++)u+1===c.length?(_=l,l=9):l+=1,d.push([P,c.toUpperCase().charCodeAt(u),l]),d.push([P,c.toLowerCase().charCodeAt(u),l]),P=l;p=c,l=_}d.push([9,58,10]),d.push([10,47,12]),this._stateMachine=new k.StateMachine(d)}}provideDocumentLinks(g){this._initStateMachine();const d=[],p=k.LinkComputer.computeLinks({getLineContent(P){return g.lineAt(P-1).text},getLineCount(){return g.lineCount}},this._stateMachine);for(const P of p){const _=C.DocumentLink.to(P);_.target&&d.push(_)}return d}}class v{constructor(g,d){this._extHostLanguageFeatures=d,this._linkProvider=new D,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=g.getProxy(i.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(g,d,p,P={}){if(this._registeredSchemes.has(d))throw new Error(`a provider for the scheme '${d}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(g,"*",this._linkProvider));const _=this._handlePool++;this._linkProvider.add(d),this._registeredSchemes.add(d),this._fsProvider.set(_,p);let l=2;P.isCaseSensitive&&(l+=1024),P.isReadonly&&(l+=2048),typeof p.copy=="function"&&(l+=8),typeof p.open=="function"&&typeof p.close=="function"&&typeof p.read=="function"&&typeof p.write=="function"&&((0,F.checkProposedApiEnabled)(g,"fsChunks"),l+=4),this._proxy.$registerFileSystemProvider(_,d,l).catch(u=>{console.error(`FAILED to register filesystem provider of ${g.identifier.value}-extension for the scheme ${d}`),console.error(u)});const c=p.onDidChangeFile(u=>{const a=[];for(const E of u){let{uri:s,type:t}=E;if(s.scheme!==d)continue;let r;switch(t){case A.FileChangeType.Changed:r=0;break;case A.FileChangeType.Created:r=1;break;case A.FileChangeType.Deleted:r=2;break;default:throw new Error("Unknown FileChangeType")}a.push({resource:s,type:r})}this._proxy.$onFileSystemChange(_,a)});return(0,I.toDisposable)(()=>{c.dispose(),this._linkProvider.delete(d),this._registeredSchemes.delete(d),this._fsProvider.delete(_),this._proxy.$unregisterProvider(_)})}static _asIStat(g){const{type:d,ctime:p,mtime:P,size:_,permissions:l}=g;return{type:d,ctime:p,mtime:P,size:_,permissions:l}}$stat(g,d){return Promise.resolve(this._getFsProvider(g).stat(f.URI.revive(d))).then(p=>v._asIStat(p))}$readdir(g,d){return Promise.resolve(this._getFsProvider(g).readDirectory(f.URI.revive(d)))}$readFile(g,d){return Promise.resolve(this._getFsProvider(g).readFile(f.URI.revive(d))).then(p=>R.VSBuffer.wrap(p))}$writeFile(g,d,p,P){return Promise.resolve(this._getFsProvider(g).writeFile(f.URI.revive(d),p.buffer,P))}$delete(g,d,p){return Promise.resolve(this._getFsProvider(g).delete(f.URI.revive(d),p))}$rename(g,d,p,P){return Promise.resolve(this._getFsProvider(g).rename(f.URI.revive(d),f.URI.revive(p),P))}$copy(g,d,p,P){const _=this._getFsProvider(g);if(!_.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(_.copy(f.URI.revive(d),f.URI.revive(p),P))}$mkdir(g,d){return Promise.resolve(this._getFsProvider(g).createDirectory(f.URI.revive(d)))}$watch(g,d,p,P){const _=this._getFsProvider(g).watch(f.URI.revive(p),P);this._watches.set(d,_)}$unwatch(g,d){const p=this._watches.get(d);p&&(p.dispose(),this._watches.delete(d))}$open(g,d,p){const P=this._getFsProvider(g);if(!P.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(P.open(f.URI.revive(d),p))}$close(g,d){const p=this._getFsProvider(g);if(!p.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(p.close(d))}$read(g,d,p,P){const _=this._getFsProvider(g);if(!_.read)throw new Error('FileSystemProvider does not implement "read"');const l=R.VSBuffer.alloc(P);return Promise.resolve(_.read(d,p,l.buffer,0,P)).then(c=>l.slice(0,c))}$write(g,d,p,P){const _=this._getFsProvider(g);if(!_.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(_.write(d,p,P.buffer,0,P.byteLength))}_getFsProvider(g){const d=this._fsProvider.get(g);if(!d){const p=new Error;throw p.name="ENOPRO",p.message="no provider",p}return d}}e.ExtHostFileSystem=v}),define(ve[65],we([1,0,5,42,7,22,4,17,44,6]),function(te,e,f,i,I,A,C,k,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let F=class jt{constructor(v,b){this._fileSystemProvider=new Map,this._proxy=v.getProxy(f.MainContext.MainThreadFileSystem);const g=this;this.value=Object.freeze({async stat(d){try{const p=g._fileSystemProvider.get(d.scheme);if(!p)return await g._proxy.$stat(d);await g._proxy.$ensureActivation(d.scheme);const P=await p.stat(d);return{type:P.type,ctime:P.ctime,mtime:P.mtime,size:P.size,permissions:P.permissions}}catch(p){jt._handleError(p)}},async readDirectory(d){try{const p=g._fileSystemProvider.get(d.scheme);return p?(await g._proxy.$ensureActivation(d.scheme),(await p.readDirectory(d)).slice()):await g._proxy.$readdir(d)}catch(p){return jt._handleError(p)}},async createDirectory(d){try{return await g._proxy.$mkdir(d)}catch(p){return jt._handleError(p)}},async readFile(d){try{const p=g._fileSystemProvider.get(d.scheme);return p?(await g._proxy.$ensureActivation(d.scheme),(await p.readFile(d)).slice()):(await g._proxy.$readFile(d)).buffer}catch(p){return jt._handleError(p)}},async writeFile(d,p){try{return await g._proxy.$writeFile(d,A.VSBuffer.wrap(p))}catch(P){return jt._handleError(P)}},async delete(d,p){try{const P=g._fileSystemProvider.get(d.scheme);return P?(await g._proxy.$ensureActivation(d.scheme),await P.delete(d,{recursive:!1,...p})):await g._proxy.$delete(d,{recursive:!1,useTrash:!1,...p})}catch(P){return jt._handleError(P)}},async rename(d,p,P){try{return await g._proxy.$rename(d,p,{overwrite:!1,...P})}catch(_){return jt._handleError(_)}},async copy(d,p,P){try{return await g._proxy.$copy(d,p,{overwrite:!1,...P})}catch(_){return jt._handleError(_)}},isWritableFileSystem(d){const p=b.getCapabilities(d);if(typeof p=="number")return!(p&2048)}})}static _handleError(v){if(v instanceof I.FileSystemError)throw v;if(!(v instanceof Error))throw new I.FileSystemError(String(v));if(v.name==="ENOPRO")throw I.FileSystemError.Unavailable(v.message);switch(v.name){case i.FileSystemProviderErrorCode.FileExists:throw I.FileSystemError.FileExists(v.message);case i.FileSystemProviderErrorCode.FileNotFound:throw I.FileSystemError.FileNotFound(v.message);case i.FileSystemProviderErrorCode.FileNotADirectory:throw I.FileSystemError.FileNotADirectory(v.message);case i.FileSystemProviderErrorCode.FileIsADirectory:throw I.FileSystemError.FileIsADirectory(v.message);case i.FileSystemProviderErrorCode.NoPermissions:throw I.FileSystemError.NoPermissions(v.message);case i.FileSystemProviderErrorCode.Unavailable:throw I.FileSystemError.Unavailable(v.message);default:throw new I.FileSystemError(v.message,v.name)}}addFileSystemProvider(v,b){return this._fileSystemProvider.set(v,b),(0,R.toDisposable)(()=>this._fileSystemProvider.delete(v))}};F=Be([Fe(0,k.IExtHostRpcService),Fe(1,S.IExtHostFileSystemInfo)],F),e.ExtHostConsumerFileSystem=F,e.IExtHostConsumerFileSystem=(0,C.createDecorator)("IExtHostConsumerFileSystem")}),define(ve[238],we([1,0,3,32,2,5,14,7]),function(te,e,f,i,I,A,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class S{constructor(D,v,b,g,d,p,P,_){this._onDidCreate=new f.Emitter,this._onDidChange=new f.Emitter,this._onDidDelete=new f.Emitter;const l=this.ensureWatching(D,b,d);this._config=0,p&&(this._config+=1),P&&(this._config+=2),_&&(this._config+=4);const c=(0,i.parse)(d),u=typeof d=="string",a=g(E=>{if(!p)for(let s of E.created){const t=I.URI.revive(s);c(t.fsPath)&&(!u||v.getWorkspaceFolder(t))&&this._onDidCreate.fire(t)}if(!P)for(let s of E.changed){const t=I.URI.revive(s);c(t.fsPath)&&(!u||v.getWorkspaceFolder(t))&&this._onDidChange.fire(t)}if(!_)for(let s of E.deleted){const t=I.URI.revive(s);c(t.fsPath)&&(!u||v.getWorkspaceFolder(t))&&this._onDidDelete.fire(t)}});this._disposable=k.Disposable.from(l,this._onDidCreate,this._onDidChange,this._onDidDelete,a)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}ensureWatching(D,v,b){let g=k.Disposable.from();if(typeof b=="string")return g;const d=D.getProxy(A.MainContext.MainThreadFileSystem);let p=!1;(b.pattern.includes(i.GLOBSTAR)||b.pattern.includes(i.GLOB_SPLIT))&&(p=!0);const P=Math.random();return d.$watch(v.identifier.value,P,b.baseUri,{recursive:p,excludes:[]}),k.Disposable.from({dispose:()=>d.$unwatch(P)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class R{constructor(D,v,b){this._mainContext=D,this._logService=v,this._extHostDocumentsAndEditors=b,this._onFileSystemEvent=new f.Emitter,this._onDidRenameFile=new f.Emitter,this._onDidCreateFile=new f.Emitter,this._onDidDeleteFile=new f.Emitter,this._onWillRenameFile=new f.AsyncEmitter,this._onWillCreateFile=new f.AsyncEmitter,this._onWillDeleteFile=new f.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(D,v,b,g,d,p){return new S(this._mainContext,D,v,this._onFileSystemEvent.event,C.GlobPattern.from(b),g,d,p)}$onFileEvent(D){this._onFileSystemEvent.fire(D)}$onDidRunFileOperation(D,v){switch(D){case 2:this._onDidRenameFile.fire(Object.freeze({files:v.map(b=>({oldUri:I.URI.revive(b.source),newUri:I.URI.revive(b.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:v.map(b=>I.URI.revive(b.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:v.map(b=>I.URI.revive(b.target))}));break;default:}}getOnWillRenameFileEvent(D){return this._createWillExecuteEvent(D,this._onWillRenameFile)}getOnWillCreateFileEvent(D){return this._createWillExecuteEvent(D,this._onWillCreateFile)}getOnWillDeleteFileEvent(D){return this._createWillExecuteEvent(D,this._onWillDeleteFile)}_createWillExecuteEvent(D,v){return(b,g,d)=>{const p=function(_){b.call(g,_)};return p.extension=D,v.event(p,void 0,d)}}async $onWillRunFileOperation(D,v,b,g){switch(D){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:v.map(d=>({oldUri:I.URI.revive(d.source),newUri:I.URI.revive(d.target)}))},b,g);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:v.map(d=>I.URI.revive(d.target))},b,g);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:v.map(d=>I.URI.revive(d.target))},b,g)}}async _fireWillEvent(D,v,b,g){const d=new Set,p=[];if(await D.fireAsync(v,g,async(_,l)=>{const c=Date.now(),u=await Promise.resolve(_);u instanceof k.WorkspaceEdit&&(p.push(u),d.add(l.extension.displayName??l.extension.identifier.value)),Date.now()-c>b&&this._logService.warn("SLOW file-participant",l.extension.identifier)}),g.isCancellationRequested||p.length===0)return;const P={edits:[]};for(let _ of p){let{edits:l}=C.WorkspaceEdit.from(_,{getTextDocumentVersion:c=>this._extHostDocumentsAndEditors.getDocument(c)?.version,getNotebookDocumentVersion:()=>{}});P.edits=P.edits.concat(l)}return{edit:P,extensionNames:Array.from(d)}}}e.ExtHostFileSystemEventService=R}),define(ve[239],we([1,0,2,39]),function(te,e,f,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class I{constructor(C,k,S,R){this._extHostNotebooks=k,this._textDocumentsAndEditors=S,this._commands=R;const F=new i.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new i.ApiCommandArgument("showOptions","Show Options",D=>!0,D=>D),new i.ApiCommandArgument("resource","Interactive resource Uri",D=>!0,D=>D),new i.ApiCommandArgument("controllerId","Notebook controller Id",D=>!0,D=>D),new i.ApiCommandArgument("title","Interactive editor title",D=>!0,D=>D)],new i.ApiCommandResult("Notebook and input URI",D=>{if(D.notebookEditorId!==void 0){const v=this._extHostNotebooks.getEditorById(D.notebookEditorId);return{notebookUri:f.URI.revive(D.notebookUri),inputUri:f.URI.revive(D.inputUri),notebookEditor:v.apiEditor}}return{notebookUri:f.URI.revive(D.notebookUri),inputUri:f.URI.revive(D.inputUri)}}));this._commands.registerApiCommand(F)}$willAddInteractiveDocument(C,k,S,R){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:k,lines:[""],languageId:S,uri:C,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(f.URI.revive(R))?.apiNotebook}]})}$willRemoveInteractiveDocument(C,k){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[C]})}}e.ExtHostInteractive=I}),define(ve[240],we([1,0,6,5]),function(te,e,f,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class I{constructor(C){this._handlePool=0,this._proxy=C.getProxy(i.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(C){const k=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(k,C),(0,f.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(k)})}}e.ExtHostLabelService=I}),define(ve[241],we([1,0,2,25,14,7,5,8,35,18,13,146,21,6,111,75,82,46,15,3,16]),function(te,e,f,i,I,A,C,k,S,R,F,D,v,b,g,d,p,P,_,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class u{constructor(z,B){this._documents=z,this._provider=B}async provideDocumentSymbols(z,B){const N=this._documents.getDocument(z),W=await this._provider.provideDocumentSymbols(N,B);if(!(0,R.isFalsyOrEmpty)(W))return W[0]instanceof A.DocumentSymbol?W.map(I.DocumentSymbol.from):u._asDocumentSymbolTree(W)}static _asDocumentSymbolTree(z){z=z.slice(0).sort((W,V)=>{let re=W.location.range.start.compareTo(V.location.range.start);return re===0&&(re=V.location.range.end.compareTo(W.location.range.end)),re});const B=[],N=[];for(const W of z){const V={name:W.name||"!!MISSING: name!!",kind:I.SymbolKind.from(W.kind),tags:W.tags?.map(I.SymbolTag.from)||[],detail:"",containerName:W.containerName,range:I.Range.from(W.location.range),selectionRange:I.Range.from(W.location.range),children:[]};for(;;){if(N.length===0){N.push(V),B.push(V);break}const re=N[N.length-1];if(S.Range.containsRange(re.range,V.range)&&!S.Range.equalsRange(re.range,V.range)){re.children&&re.children.push(V),N.push(V);break}N.pop()}}return B}}class a{constructor(z,B,N){this._documents=z,this._commands=B,this._provider=N,this._cache=new p.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(z,B){const N=this._documents.getDocument(z),W=await this._provider.provideCodeLenses(N,B);if(!W||B.isCancellationRequested)return;const V=this._cache.add(W),re=new b.DisposableStore;this._disposables.set(V,re);const he={cacheId:V,lenses:[]};for(let Ce=0;Ce<W.length;Ce++)he.lenses.push({cacheId:[V,Ce],range:I.Range.from(W[Ce].range),command:this._commands.toInternal(W[Ce].command,re)});return he}async resolveCodeLens(z,B){const N=z.cacheId&&this._cache.get(...z.cacheId);if(!N)return;let W;if(typeof this._provider.resolveCodeLens!="function"||N.isResolved?W=N:W=await this._provider.resolveCodeLens(N,B),W||(W=N),B.isCancellationRequested)return;const V=z.cacheId&&this._disposables.get(z.cacheId[0]);if(!!V)return z.command=this._commands.toInternal(W.command??a._badCmd,V),z}releaseCodeLenses(z){this._disposables.get(z)?.dispose(),this._disposables.delete(z),this._cache.delete(z)}}a._badCmd={command:"missing",title:"!!MISSING: command!!"};function E(Ee){return Array.isArray(Ee)?Ee.map(I.DefinitionLink.from):Ee?[I.DefinitionLink.from(Ee)]:[]}class s{constructor(z,B){this._documents=z,this._provider=B}async provideDefinition(z,B,N){const W=this._documents.getDocument(z),V=I.Position.to(B),re=await this._provider.provideDefinition(W,V,N);return E(re)}}class t{constructor(z,B){this._documents=z,this._provider=B}async provideDeclaration(z,B,N){const W=this._documents.getDocument(z),V=I.Position.to(B),re=await this._provider.provideDeclaration(W,V,N);return E(re)}}class r{constructor(z,B){this._documents=z,this._provider=B}async provideImplementation(z,B,N){const W=this._documents.getDocument(z),V=I.Position.to(B),re=await this._provider.provideImplementation(W,V,N);return E(re)}}class n{constructor(z,B){this._documents=z,this._provider=B}async provideTypeDefinition(z,B,N){const W=this._documents.getDocument(z),V=I.Position.to(B),re=await this._provider.provideTypeDefinition(W,V,N);return E(re)}}class o{constructor(z,B){this._documents=z,this._provider=B}async provideHover(z,B,N){const W=this._documents.getDocument(z),V=I.Position.to(B),re=await this._provider.provideHover(W,V,N);if(!(!re||(0,R.isFalsyOrEmpty)(re.contents)))return re.range||(re.range=W.getWordRangeAtPosition(V)),re.range||(re.range=new A.Range(V,V)),I.Hover.from(re)}}class m{constructor(z,B){this._documents=z,this._provider=B}async provideEvaluatableExpression(z,B,N){const W=this._documents.getDocument(z),V=I.Position.to(B),re=await this._provider.provideEvaluatableExpression(W,V,N);if(re)return I.EvaluatableExpression.from(re)}}class h{constructor(z,B){this._documents=z,this._provider=B}async provideInlineValues(z,B,N,W){const V=this._documents.getDocument(z),re=await this._provider.provideInlineValues(V,I.Range.to(B),I.InlineValueContext.to(N),W);if(Array.isArray(re))return re.map(he=>I.InlineValue.from(he))}}class w{constructor(z,B){this._documents=z,this._provider=B}async provideDocumentHighlights(z,B,N){const W=this._documents.getDocument(z),V=I.Position.to(B),re=await this._provider.provideDocumentHighlights(W,V,N);if(Array.isArray(re))return re.map(I.DocumentHighlight.from)}}class T{constructor(z,B){this._documents=z,this._provider=B}async provideLinkedEditingRanges(z,B,N){const W=this._documents.getDocument(z),V=I.Position.to(B),re=await this._provider.provideLinkedEditingRanges(W,V,N);if(re&&Array.isArray(re.ranges))return{ranges:(0,R.coalesce)(re.ranges.map(I.Range.from)),wordPattern:re.wordPattern}}}class L{constructor(z,B){this._documents=z,this._provider=B}async provideReferences(z,B,N,W){const V=this._documents.getDocument(z),re=I.Position.to(B),he=await this._provider.provideReferences(V,re,N,W);if(Array.isArray(he))return he.map(I.location.from)}}class O{constructor(z,B,N,W,V,re,he){this._documents=z,this._commands=B,this._diagnostics=N,this._provider=W,this._logService=V,this._extension=re,this._apiDeprecation=he,this._cache=new p.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(z,B,N,W){const V=this._documents.getDocument(z),re=D.Selection.isISelection(B)?I.Selection.to(B):I.Range.to(B),he=[];for(const He of this._diagnostics.getDiagnostics(z))if(re.intersection(He.range)&&he.push(He)>O._maxCodeActionsPerFile)break;const Ce={diagnostics:he,only:N.only?new A.CodeActionKind(N.only):void 0,triggerKind:I.CodeActionTriggerKind.to(N.trigger)},Ae=await this._provider.provideCodeActions(V,re,Ce,W);if(!(0,R.isNonEmptyArray)(Ae)||W.isCancellationRequested)return;const We=this._cache.add(Ae),ze=new b.DisposableStore;this._disposables.set(We,ze);const qe=[];for(let He=0;He<Ae.length;He++){const Ue=Ae[He];!Ue||(O._isCommand(Ue)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),qe.push({_isSynthetic:!0,title:Ue.title,command:this._commands.toInternal(Ue,ze)})):(Ce.only&&(Ue.kind?Ce.only.contains(Ue.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ce.only.value} 'requested but returned code action is of kind '${Ue.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ce.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),qe.push({cacheId:[We,He],title:Ue.title,command:Ue.command&&this._commands.toInternal(Ue.command,ze),diagnostics:Ue.diagnostics&&Ue.diagnostics.map(I.Diagnostic.from),edit:Ue.edit&&I.WorkspaceEdit.from(Ue.edit),kind:Ue.kind&&Ue.kind.value,isPreferred:Ue.isPreferred,disabled:Ue.disabled?.reason})))}return{cacheId:We,actions:qe}}async resolveCodeAction(z,B){const[N,W]=z,V=this._cache.get(N,W);if(!V||O._isCommand(V)||!this._provider.resolveCodeAction)return;const re=await this._provider.resolveCodeAction(V,B)??V;return re?.edit?I.WorkspaceEdit.from(re.edit):void 0}releaseCodeActions(z){this._disposables.get(z)?.dispose(),this._disposables.delete(z),this._cache.delete(z)}static _isCommand(z){return typeof z.command=="string"&&typeof z.title=="string"}}O._maxCodeActionsPerFile=1e3;class y{constructor(z,B){this._documents=z,this._provider=B}async provideDocumentFormattingEdits(z,B,N){const W=this._documents.getDocument(z),V=await this._provider.provideDocumentFormattingEdits(W,B,N);if(Array.isArray(V))return V.map(I.TextEdit.from)}}class H{constructor(z,B){this._documents=z,this._provider=B}async provideDocumentRangeFormattingEdits(z,B,N,W){const V=this._documents.getDocument(z),re=I.Range.to(B),he=await this._provider.provideDocumentRangeFormattingEdits(V,re,N,W);if(Array.isArray(he))return he.map(I.TextEdit.from)}}class M{constructor(z,B){this._documents=z,this._provider=B,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(z,B,N,W,V){const re=this._documents.getDocument(z),he=I.Position.to(B),Ce=await this._provider.provideOnTypeFormattingEdits(re,he,N,W,V);if(Array.isArray(Ce))return Ce.map(I.TextEdit.from)}}class j{constructor(z,B){this._provider=z,this._logService=B,this._cache=new p.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(z,B){const N=await this._provider.provideWorkspaceSymbols(z,B);if(!(0,R.isNonEmptyArray)(N))return{symbols:[]};const W=this._cache.add(N),V={cacheId:W,symbols:[]};for(let re=0;re<N.length;re++){const he=N[re];if(!he||!he.name){this._logService.warn("INVALID SymbolInformation",he);continue}V.symbols.push({...I.WorkspaceSymbol.from(he),cacheId:[W,re]})}return V}async resolveWorkspaceSymbol(z,B){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!z.cacheId)return z;const N=this._cache.get(...z.cacheId);if(N){const W=await this._provider.resolveWorkspaceSymbol(N,B);return W&&(0,i.mixin)(z,I.WorkspaceSymbol.from(W),!0)}}releaseWorkspaceSymbols(z){this._cache.delete(z)}}class X{constructor(z,B,N){this._documents=z,this._provider=B,this._logService=N}static supportsResolving(z){return typeof z.prepareRename=="function"}async provideRenameEdits(z,B,N,W){const V=this._documents.getDocument(z),re=I.Position.to(B);try{const he=await this._provider.provideRenameEdits(V,re,N,W);return he?I.WorkspaceEdit.from(he):void 0}catch(he){const Ce=X._asMessage(he);return Ce?{rejectReason:Ce,edits:void 0}:Promise.reject(he)}}async resolveRenameLocation(z,B,N){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const W=this._documents.getDocument(z),V=I.Position.to(B);try{const re=await this._provider.prepareRename(W,V,N);let he,Ce;if(A.Range.isRange(re)?(he=re,Ce=W.getText(re)):(0,F.isObject)(re)&&(he=re.range,Ce=re.placeholder),!he||!Ce)return;if(he.start.line>V.line||he.end.line<V.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:I.Range.from(he),text:Ce}}catch(re){const he=X._asMessage(re);return he?{rejectReason:he,range:void 0,text:void 0}:Promise.reject(re)}}static _asMessage(z){return typeof z=="string"?z:z instanceof Error&&typeof z.message=="string"?z.message:void 0}}class ${constructor(z,B){this.resultId=z,this.tokens=B}}class U{constructor(z,B){this._documents=z,this._provider=B,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(z,B,N){const W=this._documents.getDocument(z),V=B!==0?this._previousResults.get(B):null;let re=typeof V?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(W,V.resultId,N):await this._provider.provideDocumentSemanticTokens(W,N);return V&&this._previousResults.delete(B),re?(re=U._fixProvidedSemanticTokens(re),this._send(U._convertToEdits(V,re),re)):null}async releaseDocumentSemanticColoring(z){this._previousResults.delete(z)}static _fixProvidedSemanticTokens(z){return U._isSemanticTokens(z)?U._isCorrectSemanticTokens(z)?z:new A.SemanticTokens(new Uint32Array(z.data),z.resultId):U._isSemanticTokensEdits(z)?U._isCorrectSemanticTokensEdits(z)?z:new A.SemanticTokensEdits(z.edits.map(B=>new A.SemanticTokensEdit(B.start,B.deleteCount,B.data?new Uint32Array(B.data):B.data)),z.resultId):z}static _isSemanticTokens(z){return z&&!!z.data}static _isCorrectSemanticTokens(z){return z.data instanceof Uint32Array}static _isSemanticTokensEdits(z){return z&&Array.isArray(z.edits)}static _isCorrectSemanticTokensEdits(z){for(const B of z.edits)if(!(B.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(z,B){if(!U._isSemanticTokens(B)||!z||!z.tokens)return B;const N=z.tokens,W=N.length,V=B.data,re=V.length;let he=0;const Ce=Math.min(W,re);for(;he<Ce&&N[he]===V[he];)he++;if(he===W&&he===re)return new A.SemanticTokensEdits([],B.resultId);let Ae=0;const We=Ce-he;for(;Ae<We&&N[W-Ae-1]===V[re-Ae-1];)Ae++;return new A.SemanticTokensEdits([{start:he,deleteCount:W-he-Ae,data:V.subarray(he,re-Ae)}],B.resultId)}_send(z,B){if(U._isSemanticTokens(z)){const N=this._nextResultId++;return this._previousResults.set(N,new $(z.resultId,z.data)),(0,g.encodeSemanticTokensDto)({id:N,type:"full",data:z.data})}if(U._isSemanticTokensEdits(z)){const N=this._nextResultId++;return U._isSemanticTokens(B)?this._previousResults.set(N,new $(B.resultId,B.data)):this._previousResults.set(N,new $(z.resultId)),(0,g.encodeSemanticTokensDto)({id:N,type:"delta",deltas:(z.edits||[]).map(W=>({start:W.start,deleteCount:W.deleteCount,data:W.data}))})}return null}}e.DocumentSemanticTokensAdapter=U;class q{constructor(z,B){this._documents=z,this._provider=B}async provideDocumentRangeSemanticTokens(z,B,N){const W=this._documents.getDocument(z),V=await this._provider.provideDocumentRangeSemanticTokens(W,I.Range.to(B),N);return V?this._send(V):null}_send(z){return(0,g.encodeSemanticTokensDto)({id:0,type:"full",data:z.data})}}e.DocumentRangeSemanticTokensAdapter=q;class K{constructor(z,B,N,W,V){this._documents=z,this._commands=B,this._provider=N,this._apiDeprecation=W,this._extension=V,this._cache=new p.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(z){return typeof z.resolveCompletionItem=="function"}async provideCompletionItems(z,B,N,W){const V=this._documents.getDocument(z),re=I.Position.to(B),he=V.getWordRangeAtPosition(re)||new A.Range(re,re),Ce=he.with({end:re}),Ae=new P.StopWatch(!0),We=await this._provider.provideCompletionItems(V,re,W,I.CompletionContext.to(N));if(!We||W.isCancellationRequested)return;const ze=Array.isArray(We)?new A.CompletionList(We):We,qe=K.supportsResolving(this._provider)?this._cache.add(ze.items):this._cache.add([]),He=new b.DisposableStore;this._disposables.set(qe,He);const Ue=[],Je={x:qe,b:Ue,a:{replace:I.Range.from(he),insert:I.Range.from(Ce)},c:ze.isIncomplete||void 0,d:Ae.elapsed()};for(let et=0;et<ze.items.length;et++){const Le=ze.items[et],it=this._convertCompletionItem(Le,[qe,et],Ce,he);Ue.push(it)}return Je}async resolveCompletionItem(z,B){if(typeof this._provider.resolveCompletionItem!="function")return;const N=this._cache.get(...z);if(!N)return;const W=await this._provider.resolveCompletionItem(N,B);if(!!W)return this._convertCompletionItem(W,z)}releaseCompletionItems(z){this._disposables.get(z)?.dispose(),this._disposables.delete(z),this._cache.delete(z)}_convertCompletionItem(z,B,N,W){const V=this._disposables.get(B[0]);if(!V)throw Error("DisposableStore is missing...");const re={x:B,a:z.label,b:z.kind!==void 0?I.CompletionItemKind.from(z.kind):void 0,n:z.tags&&z.tags.map(I.CompletionItemTag.from),c:z.detail,d:typeof z.documentation=="undefined"?void 0:I.MarkdownString.fromStrict(z.documentation),e:z.sortText!==z.label?z.sortText:void 0,f:z.filterText!==z.label?z.filterText:void 0,g:z.preselect||void 0,i:z.keepWhitespace?1:0,k:z.commitCharacters,l:z.additionalTextEdits&&z.additionalTextEdits.map(I.TextEdit.from),m:this._commands.toInternal(z.command,V)};z.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),re.h=z.textEdit.newText):typeof z.insertText=="string"?re.h=z.insertText:z.insertText instanceof A.SnippetString&&(re.h=z.insertText.value,re.i|=4);let he;return z.textEdit?he=z.textEdit.range:z.range&&(he=z.range),A.Range.isRange(he)?re.j=I.Range.from(he):he&&(!N?.isEqual(he.inserting)||!W?.isEqual(he.replacing))&&(re.j={insert:I.Range.from(he.inserting),replace:I.Range.from(he.replacing)}),re}}class G{constructor(z,B,N){this._documents=z,this._provider=B,this._commands=N,this._cache=new p.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(z,B,N,W){const V=this._documents.getDocument(z),re=I.Position.to(B),he=await this._provider.provideInlineCompletionItems(V,re,{selectedCompletionInfo:N.selectedSuggestionInfo?{range:I.Range.to(N.selectedSuggestionInfo.range),text:N.selectedSuggestionInfo.text,isSnippetText:N.selectedSuggestionInfo.isSnippetText,completionKind:I.CompletionItemKind.to(N.selectedSuggestionInfo.completionKind)}:void 0,triggerKind:N.triggerKind},W);if(!he||W.isCancellationRequested)return;const Ce=(0,F.isArray)(he)?he:he.items,Ae=this._cache.add(Ce);let We;return{pid:Ae,items:Ce.map((ze,qe)=>{let He;ze.command&&(We||(We=new b.DisposableStore,this._disposables.set(Ae,We)),He=this._commands.toInternal(ze.command,We));const Ue=ze.insertText??ze.text;if(Ue===void 0)throw new Error("text or insertText must be defined");return{text:Ue,range:ze.range?I.Range.from(ze.range):void 0,command:He,idx:qe,completeBracketPairs:ze.completeBracketPairs}})}}disposeCompletions(z){this._cache.delete(z);const B=this._disposables.get(z);B&&B.clear(),this._disposables.delete(z)}handleDidShowCompletionItem(z,B){const N=this._cache.get(z,B);N&&ee.get(this._provider).fireOnDidShowCompletionItem({completionItem:N})}}class ee{constructor(){this._onDidShowCompletionItemEmitter=new l.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(z){let B=ee.map.get(z);return B||(B=new ee,ee.map.set(z,B)),B}fireOnDidShowCompletionItem(z){this._onDidShowCompletionItemEmitter.fire(z)}}e.InlineCompletionController=ee,ee.map=new WeakMap;class oe{constructor(z,B){this._documents=z,this._provider=B,this._cache=new p.Cache("SignatureHelp")}async provideSignatureHelp(z,B,N,W){const V=this._documents.getDocument(z),re=I.Position.to(B),he=this.reviveContext(N),Ce=await this._provider.provideSignatureHelp(V,re,W,he);if(Ce){const Ae=this._cache.add([Ce]);return{...I.SignatureHelp.from(Ce),id:Ae}}}reviveContext(z){let B;if(z.activeSignatureHelp){const N=I.SignatureHelp.to(z.activeSignatureHelp),W=this._cache.get(z.activeSignatureHelp.id,0);W?(B=W,B.activeSignature=N.activeSignature,B.activeParameter=N.activeParameter):B=N}return{...z,activeSignatureHelp:B}}releaseSignatureHelp(z){this._cache.delete(z)}}class ue{constructor(z,B,N,W,V){this._documents=z,this._commands=B,this._provider=N,this._logService=W,this._extension=V,this._cache=new p.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(z,B,N){const W=this._documents.getDocument(z),V=I.Range.to(B),re=await this._provider.provideInlayHints(W,V,N);if(!Array.isArray(re)||re.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${B}`);return}if(N.isCancellationRequested)return;const he=this._cache.add(re);this._disposables.set(he,new b.DisposableStore);const Ce={hints:[],cacheId:he};for(let Ae=0;Ae<re.length;Ae++)this._isValidInlayHint(re[Ae],V)&&Ce.hints.push(this._convertInlayHint(re[Ae],[he,Ae]));return this._logService.trace(`[InlayHints] ${Ce.hints.length} inlay hints from '${this._extension.identifier.value}' for ${B}`),Ce}async resolveInlayHint(z,B){if(typeof this._provider.resolveInlayHint!="function")return;const N=this._cache.get(...z);if(!N)return;const W=await this._provider.resolveInlayHint(N,B);if(!!W&&!!this._isValidInlayHint(W))return this._convertInlayHint(W,z)}releaseHints(z){this._disposables.get(z)?.dispose(),this._disposables.delete(z),this._cache.delete(z)}_isValidInlayHint(z,B){return z.label.length===0||Array.isArray(z.label)&&z.label.every(N=>N.value.length===0)?(console.log("INVALID inlay hint, empty label",z),!1):!(B&&!B.contains(z.position))}_convertInlayHint(z,B){const N=this._disposables.get(B[0]);if(!N)throw Error("DisposableStore is missing...");const W={label:"",cacheId:B,tooltip:I.MarkdownString.fromStrict(z.tooltip),position:I.Position.from(z.position),textEdits:z.textEdits&&z.textEdits.map(I.TextEdit.from),kind:z.kind&&I.InlayHintKind.from(z.kind),paddingLeft:z.paddingLeft,paddingRight:z.paddingRight};return typeof z.label=="string"?W.label=z.label:W.label=z.label.map(V=>{let re={label:V.value};return re.tooltip=I.MarkdownString.fromStrict(V.tooltip),A.Location.isLocation(V.location)&&(re.location=I.location.from(V.location)),V.command&&(re.command=this._commands.toInternal(V.command,N)),re}),W}}class Z{constructor(z,B){this._documents=z,this._provider=B,this._cache=new p.Cache("DocumentLink")}async provideLinks(z,B){const N=this._documents.getDocument(z),W=await this._provider.provideDocumentLinks(N,B);if(!(!Array.isArray(W)||W.length===0)&&!B.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:W.filter(Z._validateLink).map(I.DocumentLink.from)};{const V=this._cache.add(W),re={links:[],cacheId:V};for(let he=0;he<W.length;he++){if(!Z._validateLink(W[he]))continue;const Ce=I.DocumentLink.from(W[he]);Ce.cacheId=[V,he],re.links.push(Ce)}return re}}}static _validateLink(z){return z.target&&z.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(z,B){if(typeof this._provider.resolveDocumentLink!="function")return;const N=this._cache.get(...z);if(!N)return;const W=await this._provider.resolveDocumentLink(N,B);if(!(!W||!Z._validateLink(W)))return I.DocumentLink.from(W)}releaseLinks(z){this._cache.delete(z)}}class Y{constructor(z,B){this._documents=z,this._provider=B}async provideColors(z,B){const N=this._documents.getDocument(z),W=await this._provider.provideDocumentColors(N,B);return Array.isArray(W)?W.map(re=>({color:I.Color.from(re.color),range:I.Range.from(re.range)})):[]}async provideColorPresentations(z,B,N){const W=this._documents.getDocument(z),V=I.Range.to(B.range),re=I.Color.to(B.color),he=await this._provider.provideColorPresentations(re,{document:W,range:V},N);if(!!Array.isArray(he))return he.map(I.ColorPresentation.from)}}class se{constructor(z,B){this._documents=z,this._provider=B}async provideFoldingRanges(z,B,N){const W=this._documents.getDocument(z),V=await this._provider.provideFoldingRanges(W,B,N);if(!!Array.isArray(V))return V.map(I.FoldingRange.from)}}class de{constructor(z,B,N){this._documents=z,this._provider=B,this._logService=N}async provideSelectionRanges(z,B,N){const W=this._documents.getDocument(z),V=B.map(I.Position.to),re=await this._provider.provideSelectionRanges(W,V,N);if(!(0,R.isNonEmptyArray)(re))return[];if(re.length!==V.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const he=[];for(let Ce=0;Ce<V.length;Ce++){const Ae=[];he.push(Ae);let We=V[Ce],ze=re[Ce];for(;;){if(!ze.range.contains(We))throw new Error("INVALID selection range, must contain the previous range");if(Ae.push(I.SelectionRange.from(ze)),!ze.parent)break;We=ze.range,ze=ze.parent}}return he}}class ge{constructor(z,B){this._documents=z,this._provider=B,this._idPool=new d.IdGenerator(""),this._cache=new Map}async prepareSession(z,B,N){const W=this._documents.getDocument(z),V=I.Position.to(B),re=await this._provider.prepareCallHierarchy(W,V,N);if(!re)return;const he=this._idPool.nextId();return this._cache.set(he,new Map),Array.isArray(re)?re.map(Ce=>this._cacheAndConvertItem(he,Ce)):[this._cacheAndConvertItem(he,re)]}async provideCallsTo(z,B,N){const W=this._itemFromCache(z,B);if(!W)throw new Error("missing call hierarchy item");const V=await this._provider.provideCallHierarchyIncomingCalls(W,N);if(!!V)return V.map(re=>({from:this._cacheAndConvertItem(z,re.from),fromRanges:re.fromRanges.map(he=>I.Range.from(he))}))}async provideCallsFrom(z,B,N){const W=this._itemFromCache(z,B);if(!W)throw new Error("missing call hierarchy item");const V=await this._provider.provideCallHierarchyOutgoingCalls(W,N);if(!!V)return V.map(re=>({to:this._cacheAndConvertItem(z,re.to),fromRanges:re.fromRanges.map(he=>I.Range.from(he))}))}releaseSession(z){this._cache.delete(z)}_cacheAndConvertItem(z,B){const N=this._cache.get(z),W=I.CallHierarchyItem.from(B,z,N.size.toString(36));return N.set(W._itemId,B),W}_itemFromCache(z,B){return this._cache.get(z)?.get(B)}}class Te{constructor(z,B){this._documents=z,this._provider=B,this._idPool=new d.IdGenerator(""),this._cache=new Map}async prepareSession(z,B,N){const W=this._documents.getDocument(z),V=I.Position.to(B),re=await this._provider.prepareTypeHierarchy(W,V,N);if(!re)return;const he=this._idPool.nextId();return this._cache.set(he,new Map),Array.isArray(re)?re.map(Ce=>this._cacheAndConvertItem(he,Ce)):[this._cacheAndConvertItem(he,re)]}async provideSupertypes(z,B,N){const W=this._itemFromCache(z,B);if(!W)throw new Error("missing type hierarchy item");const V=await this._provider.provideTypeHierarchySupertypes(W,N);if(!!V)return V.map(re=>this._cacheAndConvertItem(z,re))}async provideSubtypes(z,B,N){const W=this._itemFromCache(z,B);if(!W)throw new Error("missing type hierarchy item");const V=await this._provider.provideTypeHierarchySubtypes(W,N);if(!!V)return V.map(re=>this._cacheAndConvertItem(z,re))}releaseSession(z){this._cache.delete(z)}_cacheAndConvertItem(z,B){const N=this._cache.get(z),W=I.TypeHierarchyItem.from(B,z,N.size.toString(36));return N.set(W._itemId,B),W}_itemFromCache(z,B){return this._cache.get(z)?.get(B)}}class Ne{constructor(z,B){this.adapter=z,this.extension=B}}class be{constructor(z,B,N,W,V,re,he){this._adapter=new Map,this._uriTransformer=B,this._proxy=z.getProxy(C.MainContext.MainThreadLanguageFeatures),this._documents=N,this._commands=W,this._diagnostics=V,this._logService=re,this._apiDeprecation=he}_transformDocumentSelector(z){return I.DocumentSelector.from(z,this._uriTransformer)}_createDisposable(z){return new A.Disposable(()=>{this._adapter.delete(z),this._proxy.$unregister(z)})}_nextHandle(){return be._handlePool++}async _withAdapter(z,B,N,W,V){const re=this._adapter.get(z);if(!re||!(re.adapter instanceof B))return W;const he=Date.now();this._logService.trace(`[${re.extension.identifier.value}] INVOKE provider '${N.toString().replace(/[\r\n]/g,"")}'`);const Ce=N(re.adapter,re.extension);return Promise.resolve(Ce).catch(Ae=>{(0,_.isCancellationError)(Ae)||(this._logService.error(`[${re.extension.identifier.value}] provider FAILED`),this._logService.error(Ae))}).finally(()=>{this._logService.trace(`[${re.extension.identifier.value}] provider DONE after ${Date.now()-he}ms`)}),v.CancellationToken.isCancellationToken(V)?(0,c.raceCancellationError)(Ce,V):Ce}_addNewAdapter(z,B){const N=this._nextHandle();return this._adapter.set(N,new Ne(z,B)),N}static _extLabel(z){return z.displayName||z.name}registerDocumentSymbolProvider(z,B,N,W){const V=this._addNewAdapter(new u(this._documents,N),z),re=W&&W.label||be._extLabel(z);return this._proxy.$registerDocumentSymbolProvider(V,this._transformDocumentSelector(B),re),this._createDisposable(V)}$provideDocumentSymbols(z,B,N){return this._withAdapter(z,u,W=>W.provideDocumentSymbols(f.URI.revive(B),N),void 0,N)}registerCodeLensProvider(z,B,N){const W=this._nextHandle(),V=typeof N.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(W,new Ne(new a(this._documents,this._commands.converter,N),z)),this._proxy.$registerCodeLensSupport(W,this._transformDocumentSelector(B),V);let re=this._createDisposable(W);if(V!==void 0){const he=N.onDidChangeCodeLenses(Ce=>this._proxy.$emitCodeLensEvent(V));re=A.Disposable.from(re,he)}return re}$provideCodeLenses(z,B,N){return this._withAdapter(z,a,W=>W.provideCodeLenses(f.URI.revive(B),N),void 0,N)}$resolveCodeLens(z,B,N){return this._withAdapter(z,a,W=>W.resolveCodeLens(B,N),void 0,void 0)}$releaseCodeLenses(z,B){this._withAdapter(z,a,N=>Promise.resolve(N.releaseCodeLenses(B)),void 0,void 0)}registerDefinitionProvider(z,B,N){const W=this._addNewAdapter(new s(this._documents,N),z);return this._proxy.$registerDefinitionSupport(W,this._transformDocumentSelector(B)),this._createDisposable(W)}$provideDefinition(z,B,N,W){return this._withAdapter(z,s,V=>V.provideDefinition(f.URI.revive(B),N,W),[],W)}registerDeclarationProvider(z,B,N){const W=this._addNewAdapter(new t(this._documents,N),z);return this._proxy.$registerDeclarationSupport(W,this._transformDocumentSelector(B)),this._createDisposable(W)}$provideDeclaration(z,B,N,W){return this._withAdapter(z,t,V=>V.provideDeclaration(f.URI.revive(B),N,W),[],W)}registerImplementationProvider(z,B,N){const W=this._addNewAdapter(new r(this._documents,N),z);return this._proxy.$registerImplementationSupport(W,this._transformDocumentSelector(B)),this._createDisposable(W)}$provideImplementation(z,B,N,W){return this._withAdapter(z,r,V=>V.provideImplementation(f.URI.revive(B),N,W),[],W)}registerTypeDefinitionProvider(z,B,N){const W=this._addNewAdapter(new n(this._documents,N),z);return this._proxy.$registerTypeDefinitionSupport(W,this._transformDocumentSelector(B)),this._createDisposable(W)}$provideTypeDefinition(z,B,N,W){return this._withAdapter(z,n,V=>V.provideTypeDefinition(f.URI.revive(B),N,W),[],W)}registerHoverProvider(z,B,N,W){const V=this._addNewAdapter(new o(this._documents,N),z);return this._proxy.$registerHoverProvider(V,this._transformDocumentSelector(B)),this._createDisposable(V)}$provideHover(z,B,N,W){return this._withAdapter(z,o,V=>V.provideHover(f.URI.revive(B),N,W),void 0,W)}registerEvaluatableExpressionProvider(z,B,N,W){const V=this._addNewAdapter(new m(this._documents,N),z);return this._proxy.$registerEvaluatableExpressionProvider(V,this._transformDocumentSelector(B)),this._createDisposable(V)}$provideEvaluatableExpression(z,B,N,W){return this._withAdapter(z,m,V=>V.provideEvaluatableExpression(f.URI.revive(B),N,W),void 0,W)}registerInlineValuesProvider(z,B,N,W){const V=typeof N.onDidChangeInlineValues=="function"?this._nextHandle():void 0,re=this._addNewAdapter(new h(this._documents,N),z);this._proxy.$registerInlineValuesProvider(re,this._transformDocumentSelector(B),V);let he=this._createDisposable(re);if(V!==void 0){const Ce=N.onDidChangeInlineValues(Ae=>this._proxy.$emitInlineValuesEvent(V));he=A.Disposable.from(he,Ce)}return he}$provideInlineValues(z,B,N,W,V){return this._withAdapter(z,h,re=>re.provideInlineValues(f.URI.revive(B),N,W,V),void 0,V)}registerDocumentHighlightProvider(z,B,N){const W=this._addNewAdapter(new w(this._documents,N),z);return this._proxy.$registerDocumentHighlightProvider(W,this._transformDocumentSelector(B)),this._createDisposable(W)}$provideDocumentHighlights(z,B,N,W){return this._withAdapter(z,w,V=>V.provideDocumentHighlights(f.URI.revive(B),N,W),void 0,W)}registerLinkedEditingRangeProvider(z,B,N){const W=this._addNewAdapter(new T(this._documents,N),z);return this._proxy.$registerLinkedEditingRangeProvider(W,this._transformDocumentSelector(B)),this._createDisposable(W)}$provideLinkedEditingRanges(z,B,N,W){return this._withAdapter(z,T,async V=>{const re=await V.provideLinkedEditingRanges(f.URI.revive(B),N,W);if(re)return{ranges:re.ranges,wordPattern:re.wordPattern?be._serializeRegExp(re.wordPattern):void 0}},void 0,W)}registerReferenceProvider(z,B,N){const W=this._addNewAdapter(new L(this._documents,N),z);return this._proxy.$registerReferenceSupport(W,this._transformDocumentSelector(B)),this._createDisposable(W)}$provideReferences(z,B,N,W,V){return this._withAdapter(z,L,re=>re.provideReferences(f.URI.revive(B),N,W,V),void 0,V)}registerCodeActionProvider(z,B,N,W){const V=new b.DisposableStore,re=this._addNewAdapter(new O(this._documents,this._commands.converter,this._diagnostics,N,this._logService,z,this._apiDeprecation),z);return this._proxy.$registerQuickFixSupport(re,this._transformDocumentSelector(B),{providedKinds:W?.providedCodeActionKinds?.map(he=>he.value),documentation:W?.documentation?.map(he=>({kind:he.kind.value,command:this._commands.converter.toInternal(he.command,V)}))},be._extLabel(z),Boolean(N.resolveCodeAction)),V.add(this._createDisposable(re)),V}$provideCodeActions(z,B,N,W,V){return this._withAdapter(z,O,re=>re.provideCodeActions(f.URI.revive(B),N,W,V),void 0,V)}$resolveCodeAction(z,B,N){return this._withAdapter(z,O,W=>W.resolveCodeAction(B,N),void 0,void 0)}$releaseCodeActions(z,B){this._withAdapter(z,O,N=>Promise.resolve(N.releaseCodeActions(B)),void 0,void 0)}registerDocumentFormattingEditProvider(z,B,N){const W=this._addNewAdapter(new y(this._documents,N),z);return this._proxy.$registerDocumentFormattingSupport(W,this._transformDocumentSelector(B),z.identifier,z.displayName||z.name),this._createDisposable(W)}$provideDocumentFormattingEdits(z,B,N,W){return this._withAdapter(z,y,V=>V.provideDocumentFormattingEdits(f.URI.revive(B),N,W),void 0,W)}registerDocumentRangeFormattingEditProvider(z,B,N){const W=this._addNewAdapter(new H(this._documents,N),z);return this._proxy.$registerRangeFormattingSupport(W,this._transformDocumentSelector(B),z.identifier,z.displayName||z.name),this._createDisposable(W)}$provideDocumentRangeFormattingEdits(z,B,N,W,V){return this._withAdapter(z,H,re=>re.provideDocumentRangeFormattingEdits(f.URI.revive(B),N,W,V),void 0,V)}registerOnTypeFormattingEditProvider(z,B,N,W){const V=this._addNewAdapter(new M(this._documents,N),z);return this._proxy.$registerOnTypeFormattingSupport(V,this._transformDocumentSelector(B),W,z.identifier),this._createDisposable(V)}$provideOnTypeFormattingEdits(z,B,N,W,V,re){return this._withAdapter(z,M,he=>he.provideOnTypeFormattingEdits(f.URI.revive(B),N,W,V,re),void 0,re)}registerWorkspaceSymbolProvider(z,B){const N=this._addNewAdapter(new j(B,this._logService),z);return this._proxy.$registerNavigateTypeSupport(N,typeof B.resolveWorkspaceSymbol=="function"),this._createDisposable(N)}$provideWorkspaceSymbols(z,B,N){return this._withAdapter(z,j,W=>W.provideWorkspaceSymbols(B,N),{symbols:[]},N)}$resolveWorkspaceSymbol(z,B,N){return this._withAdapter(z,j,W=>W.resolveWorkspaceSymbol(B,N),void 0,void 0)}$releaseWorkspaceSymbols(z,B){this._withAdapter(z,j,N=>N.releaseWorkspaceSymbols(B),void 0,void 0)}registerRenameProvider(z,B,N){const W=this._addNewAdapter(new X(this._documents,N,this._logService),z);return this._proxy.$registerRenameSupport(W,this._transformDocumentSelector(B),X.supportsResolving(N)),this._createDisposable(W)}$provideRenameEdits(z,B,N,W,V){return this._withAdapter(z,X,re=>re.provideRenameEdits(f.URI.revive(B),N,W,V),void 0,V)}$resolveRenameLocation(z,B,N,W){return this._withAdapter(z,X,V=>V.resolveRenameLocation(f.URI.revive(B),N,W),void 0,W)}registerDocumentSemanticTokensProvider(z,B,N,W){const V=this._addNewAdapter(new U(this._documents,N),z),re=typeof N.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(V,this._transformDocumentSelector(B),W,re);let he=this._createDisposable(V);if(re){const Ce=N.onDidChangeSemanticTokens(Ae=>this._proxy.$emitDocumentSemanticTokensEvent(re));he=A.Disposable.from(he,Ce)}return he}$provideDocumentSemanticTokens(z,B,N,W){return this._withAdapter(z,U,V=>V.provideDocumentSemanticTokens(f.URI.revive(B),N,W),null,W)}$releaseDocumentSemanticTokens(z,B){this._withAdapter(z,U,N=>N.releaseDocumentSemanticColoring(B),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(z,B,N,W){const V=this._addNewAdapter(new q(this._documents,N),z);return this._proxy.$registerDocumentRangeSemanticTokensProvider(V,this._transformDocumentSelector(B),W),this._createDisposable(V)}$provideDocumentRangeSemanticTokens(z,B,N,W){return this._withAdapter(z,q,V=>V.provideDocumentRangeSemanticTokens(f.URI.revive(B),N,W),null,W)}registerCompletionItemProvider(z,B,N,W){const V=this._addNewAdapter(new K(this._documents,this._commands.converter,N,this._apiDeprecation,z),z);return this._proxy.$registerSuggestSupport(V,this._transformDocumentSelector(B),W,K.supportsResolving(N),`${z.identifier.value}(${W.join("")})`),this._createDisposable(V)}$provideCompletionItems(z,B,N,W,V){return this._withAdapter(z,K,re=>re.provideCompletionItems(f.URI.revive(B),N,W,V),void 0,V)}$resolveCompletionItem(z,B,N){return this._withAdapter(z,K,W=>W.resolveCompletionItem(B,N),void 0,N)}$releaseCompletionItems(z,B){this._withAdapter(z,K,N=>N.releaseCompletionItems(B),void 0,void 0)}registerInlineCompletionsProvider(z,B,N){const W=this._addNewAdapter(new G(this._documents,N,this._commands.converter),z);return this._proxy.$registerInlineCompletionsSupport(W,this._transformDocumentSelector(B)),this._createDisposable(W)}$provideInlineCompletions(z,B,N,W,V){return this._withAdapter(z,G,re=>re.provideInlineCompletions(f.URI.revive(B),N,W,V),void 0,V)}$handleInlineCompletionDidShow(z,B,N){this._withAdapter(z,G,async W=>{W.handleDidShowCompletionItem(B,N)},void 0,void 0)}$freeInlineCompletionsList(z,B){this._withAdapter(z,G,async N=>{N.disposeCompletions(B)},void 0,void 0)}registerSignatureHelpProvider(z,B,N,W){const V=Array.isArray(W)?{triggerCharacters:W,retriggerCharacters:[]}:W,re=this._addNewAdapter(new oe(this._documents,N),z);return this._proxy.$registerSignatureHelpProvider(re,this._transformDocumentSelector(B),V),this._createDisposable(re)}$provideSignatureHelp(z,B,N,W,V){return this._withAdapter(z,oe,re=>re.provideSignatureHelp(f.URI.revive(B),N,W,V),void 0,V)}$releaseSignatureHelp(z,B){this._withAdapter(z,oe,N=>N.releaseSignatureHelp(B),void 0,void 0)}registerInlayHintsProvider(z,B,N){const W=typeof N.onDidChangeInlayHints=="function"?this._nextHandle():void 0,V=this._addNewAdapter(new ue(this._documents,this._commands.converter,N,this._logService,z),z);this._proxy.$registerInlayHintsProvider(V,this._transformDocumentSelector(B),typeof N.resolveInlayHint=="function",W,be._extLabel(z));let re=this._createDisposable(V);if(W!==void 0){const he=N.onDidChangeInlayHints(Ce=>this._proxy.$emitInlayHintsEvent(W));re=A.Disposable.from(re,he)}return re}$provideInlayHints(z,B,N,W){return this._withAdapter(z,ue,V=>V.provideInlayHints(f.URI.revive(B),N,W),void 0,W)}$resolveInlayHint(z,B,N){return this._withAdapter(z,ue,W=>W.resolveInlayHint(B,N),void 0,N)}$releaseInlayHints(z,B){this._withAdapter(z,ue,N=>N.releaseHints(B),void 0,void 0)}registerDocumentLinkProvider(z,B,N){const W=this._addNewAdapter(new Z(this._documents,N),z);return this._proxy.$registerDocumentLinkProvider(W,this._transformDocumentSelector(B),typeof N.resolveDocumentLink=="function"),this._createDisposable(W)}$provideDocumentLinks(z,B,N){return this._withAdapter(z,Z,W=>W.provideLinks(f.URI.revive(B),N),void 0,N)}$resolveDocumentLink(z,B,N){return this._withAdapter(z,Z,W=>W.resolveLink(B,N),void 0,void 0)}$releaseDocumentLinks(z,B){this._withAdapter(z,Z,N=>N.releaseLinks(B),void 0,void 0)}registerColorProvider(z,B,N){const W=this._addNewAdapter(new Y(this._documents,N),z);return this._proxy.$registerDocumentColorProvider(W,this._transformDocumentSelector(B)),this._createDisposable(W)}$provideDocumentColors(z,B,N){return this._withAdapter(z,Y,W=>W.provideColors(f.URI.revive(B),N),[],N)}$provideColorPresentations(z,B,N,W){return this._withAdapter(z,Y,V=>V.provideColorPresentations(f.URI.revive(B),N,W),void 0,W)}registerFoldingRangeProvider(z,B,N){const W=this._nextHandle(),V=typeof N.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(W,new Ne(new se(this._documents,N),z)),this._proxy.$registerFoldingRangeProvider(W,this._transformDocumentSelector(B),V);let re=this._createDisposable(W);if(V!==void 0){const he=N.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(V));re=A.Disposable.from(re,he)}return re}$provideFoldingRanges(z,B,N,W){return this._withAdapter(z,se,V=>V.provideFoldingRanges(f.URI.revive(B),N,W),void 0,W)}registerSelectionRangeProvider(z,B,N){const W=this._addNewAdapter(new de(this._documents,N,this._logService),z);return this._proxy.$registerSelectionRangeProvider(W,this._transformDocumentSelector(B)),this._createDisposable(W)}$provideSelectionRanges(z,B,N,W){return this._withAdapter(z,de,V=>V.provideSelectionRanges(f.URI.revive(B),N,W),[],W)}registerCallHierarchyProvider(z,B,N){const W=this._addNewAdapter(new ge(this._documents,N),z);return this._proxy.$registerCallHierarchyProvider(W,this._transformDocumentSelector(B)),this._createDisposable(W)}$prepareCallHierarchy(z,B,N,W){return this._withAdapter(z,ge,V=>Promise.resolve(V.prepareSession(f.URI.revive(B),N,W)),void 0,W)}$provideCallHierarchyIncomingCalls(z,B,N,W){return this._withAdapter(z,ge,V=>V.provideCallsTo(B,N,W),void 0,W)}$provideCallHierarchyOutgoingCalls(z,B,N,W){return this._withAdapter(z,ge,V=>V.provideCallsFrom(B,N,W),void 0,W)}$releaseCallHierarchy(z,B){this._withAdapter(z,ge,N=>Promise.resolve(N.releaseSession(B)),void 0,void 0)}registerTypeHierarchyProvider(z,B,N){const W=this._addNewAdapter(new Te(this._documents,N),z);return this._proxy.$registerTypeHierarchyProvider(W,this._transformDocumentSelector(B)),this._createDisposable(W)}$prepareTypeHierarchy(z,B,N,W){return this._withAdapter(z,Te,V=>Promise.resolve(V.prepareSession(f.URI.revive(B),N,W)),void 0,W)}$provideTypeHierarchySupertypes(z,B,N,W){return this._withAdapter(z,Te,V=>V.provideSupertypes(B,N,W),void 0,W)}$provideTypeHierarchySubtypes(z,B,N,W){return this._withAdapter(z,Te,V=>V.provideSubtypes(B,N,W),void 0,W)}$releaseTypeHierarchy(z,B){this._withAdapter(z,Te,N=>Promise.resolve(N.releaseSession(B)),void 0,void 0)}static _serializeRegExp(z){return{pattern:z.source,flags:(0,k.regExpFlags)(z)}}static _serializeIndentationRule(z){return{decreaseIndentPattern:be._serializeRegExp(z.decreaseIndentPattern),increaseIndentPattern:be._serializeRegExp(z.increaseIndentPattern),indentNextLinePattern:z.indentNextLinePattern?be._serializeRegExp(z.indentNextLinePattern):void 0,unIndentedLinePattern:z.unIndentedLinePattern?be._serializeRegExp(z.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(z){return{beforeText:be._serializeRegExp(z.beforeText),afterText:z.afterText?be._serializeRegExp(z.afterText):void 0,previousLineText:z.previousLineText?be._serializeRegExp(z.previousLineText):void 0,action:z.action}}static _serializeOnEnterRules(z){return z.map(be._serializeOnEnterRule)}setLanguageConfiguration(z,B,N){let{wordPattern:W}=N;if(W&&(0,k.regExpLeadsToEndlessLoop)(W))throw new Error(`Invalid language configuration: wordPattern '${W}' is not allowed to match the empty string.`);W?this._documents.setWordDefinitionFor(B,W):this._documents.setWordDefinitionFor(B,void 0),N.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",z,"Do not use."),N.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",z,"Do not use.");const V=this._nextHandle(),re={comments:N.comments,brackets:N.brackets,wordPattern:N.wordPattern?be._serializeRegExp(N.wordPattern):void 0,indentationRules:N.indentationRules?be._serializeIndentationRule(N.indentationRules):void 0,onEnterRules:N.onEnterRules?be._serializeOnEnterRules(N.onEnterRules):void 0,__electricCharacterSupport:N.__electricCharacterSupport,__characterPairSupport:N.__characterPairSupport};return this._proxy.$setLanguageConfiguration(V,B,re),this._createDisposable(V)}$setWordDefinitions(z){for(const B of z)this._documents.setWordDefinitionFor(B.languageId,new RegExp(B.regexSource,B.regexFlags))}}e.ExtHostLanguageFeatures=be,be._handlePool=0}),define(ve[242],we([1,0,5,14,7,47,16,6]),function(te,e,f,i,I,A,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class S{constructor(F,D,v,b){this._documents=D,this._commands=v,this._uriTransformer=b,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=F.getProxy(f.MainContext.MainThreadLanguages)}$acceptLanguageIds(F){this._languageIds=F}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(F,D){await this._proxy.$changeLanguage(F,D);const v=this._documents.getDocumentData(F);if(!v)throw new Error(`document '${F.toString()}' NOT found`);return v.document}async tokenAtPosition(F,D){const v=F.version,b=i.Position.from(D),g=await this._proxy.$tokensAtPosition(F.uri,b),d={type:I.StandardTokenType.Other,range:F.getWordRangeAtPosition(D)??new I.Range(D.line,D.character,D.line,D.character)};if(!g)return d;const p={range:i.Range.to(g.range),type:i.TokenType.to(g.type)};return!p.range.contains(D)||v!==F.version?d:p}createLanguageStatusItem(F,D,v){const b=this._handlePool++,g=this._proxy,d=this._ids,p=`${F.identifier.value}/${D}`;if(d.has(p))throw new Error(`LanguageStatusItem with id '${D}' ALREADY exists`);d.add(p);const P={selector:v,id:D,name:F.displayName??F.name,severity:I.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let _,l=new k.DisposableStore;const c=()=>{_?.dispose(),_=(0,C.disposableTimeout)(()=>{l.clear(),this._proxy.$setLanguageStatus(b,{id:p,name:P.name??F.displayName??F.name,source:F.displayName??F.name,selector:i.DocumentSelector.from(P.selector,this._uriTransformer),label:P.text,detail:P.detail??"",severity:P.severity===I.LanguageStatusSeverity.Error?A.default.Error:P.severity===I.LanguageStatusSeverity.Warning?A.default.Warning:A.default.Info,command:P.command&&this._commands.toInternal(P.command,l),accessibilityInfo:P.accessibilityInformation,busy:P.busy})},0)},u={dispose(){l.dispose(),_?.dispose(),g.$removeLanguageStatus(b),d.delete(p)},get id(){return P.id},get name(){return P.name},set name(a){P.name=a,c()},get selector(){return P.selector},set selector(a){P.selector=a,c()},get text(){return P.text},set text(a){P.text=a,c()},get detail(){return P.detail},set detail(a){P.detail=a,c()},get severity(){return P.severity},set severity(a){P.severity=a,c()},get accessibilityInformation(){return P.accessibilityInformation},set accessibilityInformation(a){P.accessibilityInformation=a,c()},get command(){return P.command},set command(a){P.command=a,c()},get busy(){return P.busy},set busy(a){P.busy=a,c()}};return c(),u}}e.ExtHostLanguages=S}),define(ve[134],we([1,0,11,5,26,17,3]),function(te,e,f,i,I,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let k=class extends f.AbstractLoggerService{constructor(F,D){const v=new C.Emitter;super(D.logLevel,v.event);this._proxy=F.getProxy(i.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(v)}$setLevel(F){this._onDidChangeLogLevel.fire(F)}doCreateLogger(F,D,v){return new S(this._proxy,F,D,v)}};k=Be([Fe(0,A.IExtHostRpcService),Fe(1,I.IExtHostInitDataService)],k),e.ExtHostLoggerService=k;class S extends f.AbstractMessageLogger{constructor(F,D,v,b){super(b?.always);this.proxy=F,this.file=D,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(v),this.proxy.$createLogger(D,b).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(F,D){const v=[[F,D]];this.isLoggerCreated?this.doLog(v):this.buffer.push(...v)}doLog(F){this.proxy.$log(this.file,F)}}}),define(ve[243],we([1,0,5,11,30]),function(te,e,f,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function A(k){return k&&k.title}let C=class{constructor(S,R){this._logService=R,this._proxy=S.getProxy(f.MainContext.MainThreadMessageService)}showMessage(S,R,F,D,v){const b={source:{identifier:S.identifier,label:S.displayName||S.name}};let g;typeof D=="string"||A(D)?g=[D,...v]:(b.modal=D?.modal,b.useCustom=D?.useCustom,b.detail=D?.detail,g=v),b.useCustom&&(0,I.checkProposedApiEnabled)(S,"resolvers");const d=[];for(let p=0;p<g.length;p++){const P=g[p];if(typeof P=="string")d.push({title:P,handle:p,isCloseAffordance:!1});else if(typeof P=="object"){let{title:_,isCloseAffordance:l}=P;d.push({title:_,isCloseAffordance:!!l,handle:p})}else this._logService.warn("Invalid message item:",P)}return this._proxy.$showMessage(R,F,b,d).then(p=>{if(typeof p=="number")return g[p]})}};C=Be([Fe(1,i.ILogService)],C),e.ExtHostMessageService=C}),define(ve[244],we([1,0,22,3,57,6,24,8,13,2,82,5,14,7,52,220,130]),function(te,e,f,i,I,A,C,k,S,R,F,D,v,b,g,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class P{constructor(l,c,u,a,E){this._textDocumentsAndEditors=u,this._textDocuments=a,this._extensionStoragePaths=E,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new C.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new i.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new i.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new i.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new i.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new i.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new i.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new i.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new F.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=l.getProxy(D.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=l.getProxy(D.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=l.getProxy(D.MainContext.MainThreadNotebookEditors),this._commandsConverter=c.converter,c.registerArgumentProcessor({processArgument:s=>{if(s&&s.$mid===12){const t=s.notebookEditor?.notebookUri,r=s.cell.handle,o=this._documents.get(t)?.getCell(r);if(o)return o.apiCell}return s}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(l=>l.apiEditor)}getEditorById(l){const c=this._editors.get(l);if(!c)throw new Error(`unknown text editor: ${l}. known editors: ${[...this._editors.keys()]} `);return c}getIdByEditor(l){for(const[c,u]of this._editors)if(u.apiEditor===l)return c}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(l,c){const u=this._documents.get(l);if(!u&&!c)throw new Error(`NO notebook document for '${l}'`);return u}_getProviderData(l){const c=this._notebookContentProviders.get(l);if(!c)throw new Error(`NO provider for '${l}'`);return c}registerNotebookContentProvider(l,c,u,a,E){if((0,k.isFalsyOrWhitespace)(c))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(c))throw new Error(`Notebook provider for '${c}' already registered`);this._notebookContentProviders.set(c,{extension:l,provider:u});let s;return u.onDidChangeNotebookContentOptions&&(s=u.onDidChangeNotebookContentOptions(()=>{const t=v.NotebookDocumentContentOptions.from(u.options);this._notebookProxy.$updateNotebookProviderOptions(c,t)})),this._notebookProxy.$registerNotebookProvider({id:l.identifier,location:l.extensionLocation},c,v.NotebookDocumentContentOptions.from(a),P._convertNotebookRegistrationData(l,E)),new b.Disposable(()=>{s?.dispose(),this._notebookContentProviders.delete(c),this._notebookProxy.$unregisterNotebookProvider(c)})}static _convertNotebookRegistrationData(l,c){if(!c)return;const u=c.filenamePattern.map(a=>v.NotebookExclusiveDocumentPattern.from(a)).filter(a=>a!==void 0);if(c.filenamePattern&&!u){console.warn(`Notebook content provider view options file name pattern is invalid ${c.filenamePattern}`);return}return{extension:l.identifier,providerDisplayName:l.displayName||l.name,displayName:c.displayName,filenamePattern:u,exclusive:c.exclusive||!1}}registerNotebookCellStatusBarItemProvider(l,c,u){const a=P._notebookStatusBarItemProviderHandlePool++,E=typeof u.onDidChangeCellStatusBarItems=="function"?P._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(a,u),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(a,E,c);let s;return E!==void 0&&(s=u.onDidChangeCellStatusBarItems(t=>this._notebookProxy.$emitCellStatusBarEvent(E))),new b.Disposable(()=>{this._notebookStatusBarItemProviders.delete(a),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(a,E),s&&s.dispose()})}async createNotebookDocument(l){const c=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:l.viewType,content:l.content&&v.NotebookData.from(l.content)});return R.URI.revive(c)}async openNotebookDocument(l){const c=this._documents.get(l);if(c)return c.apiNotebook;const u=await this._notebookDocumentsProxy.$tryOpenNotebook(l),a=this._documents.get(R.URI.revive(u));return(0,S.assertIsDefined)(a?.apiNotebook)}async showNotebookDocument(l,c){R.URI.isUri(l)&&(l=await this.openNotebookDocument(l));let u;typeof c=="object"?u={position:v.ViewColumn.from(c.viewColumn),preserveFocus:c.preserveFocus,selections:c.selections&&c.selections.map(v.NotebookRange.from),pinned:typeof c.preview=="boolean"?!c.preview:void 0}:u={preserveFocus:!1};const a=await this._notebookEditorsProxy.$tryShowNotebookDocument(l.uri,l.notebookType,u),E=a&&this._editors.get(a)?.apiEditor;if(E)return E;throw a?new Error(`Could NOT open editor for "${l.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${l.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(l,c,u,a){const E=this._notebookStatusBarItemProviders.get(l),s=R.URI.revive(c),t=this._documents.get(s);if(!t||!E)return;const r=t.getCellFromIndex(u);if(!r)return;const n=await E.provideCellStatusBarItems(r.apiCell,a);if(!n)return;const o=new A.DisposableStore,m=this._statusBarCache.add([o]),w=(Array.isArray(n)?n:[n]).map(T=>v.NotebookStatusBarItem.from(T,this._commandsConverter,o));return{cacheId:m,items:w}}$releaseNotebookCellStatusBarItems(l){this._statusBarCache.delete(l)}registerNotebookSerializer(l,c,u,a,E){if((0,k.isFalsyOrWhitespace)(c))throw new Error("viewType cannot be empty or just whitespace");const s=this._handlePool++;return this._notebookSerializer.set(s,u),this._notebookProxy.$registerNotebookSerializer(s,{id:l.identifier,location:l.extensionLocation},c,v.NotebookDocumentContentOptions.from(a),P._convertNotebookRegistrationData(l,E)),(0,A.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(s)})}async $dataToNotebook(l,c,u){const a=this._notebookSerializer.get(l);if(!a)throw new Error("NO serializer found");const E=await a.deserializeNotebook(c.buffer,u);return new g.SerializableObjectWithBuffers(v.NotebookData.from(E))}async $notebookToData(l,c,u){const a=this._notebookSerializer.get(l);if(!a)throw new Error("NO serializer found");const E=await a.serializeNotebook(v.NotebookData.to(c.value),u);return f.VSBuffer.wrap(E)}async $openNotebook(l,c,u,a,E){const{provider:s}=this._getProviderData(l),t=await s.openNotebook(R.URI.revive(c),{backupId:u,untitledDocumentData:a?.buffer},E);return new g.SerializableObjectWithBuffers({metadata:t.metadata??Object.create(null),cells:t.cells.map(v.NotebookCellData.from)})}async $saveNotebook(l,c,u){const a=this.getNotebookDocument(R.URI.revive(c)),{provider:E}=this._getProviderData(l);return await E.saveNotebook(a.apiNotebook,u),!0}async $saveNotebookAs(l,c,u,a){const E=this.getNotebookDocument(R.URI.revive(c)),{provider:s}=this._getProviderData(l);return await s.saveNotebookAs(R.URI.revive(u),E.apiNotebook,a),!0}async $backupNotebook(l,c,u){const a=this.getNotebookDocument(R.URI.revive(c)),E=this._getProviderData(l),s=this._extensionStoragePaths.workspaceValue(E.extension)??this._extensionStoragePaths.globalValue(E.extension),t=String((0,I.hash)([a.uri.toString(),this._backupIdPool++])),r=R.URI.joinPath(s,t),n=await E.provider.backupNotebook(a.apiNotebook,{destination:r},u);return a.updateBackup(n),n.id}_createExtHostEditor(l,c,u){if(this._editors.has(c))throw new Error(`editor with id ALREADY EXSIST: ${c}`);const a=new p.ExtHostNotebookEditor(c,this._notebookEditorsProxy,l,u.visibleRanges.map(v.NotebookRange.to),u.selections.map(v.NotebookRange.to),typeof u.viewColumn=="number"?v.ViewColumn.to(u.viewColumn):void 0);this._editors.set(c,a)}$acceptDocumentAndEditorsDelta(l){if(l.value.removedDocuments)for(const u of l.value.removedDocuments){const a=R.URI.revive(u),E=this._documents.get(a);E&&(E.dispose(),this._documents.delete(a),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:E.apiNotebook.getCells().map(s=>s.document.uri)}),this._onDidCloseNotebookDocument.fire(E.apiNotebook));for(const s of this._editors.values())s.notebookData.uri.toString()===a.toString()&&this._editors.delete(s.id)}if(l.value.addedDocuments){const u=[];for(const a of l.value.addedDocuments){const E=R.URI.revive(a.uri);if(this._documents.has(E))throw new Error(`adding EXISTING notebook ${E} `);const s=this,t=new d.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(r){s._onDidChangeNotebookCells.fire(r)},emitCellOutputsChange(r){s._onDidChangeCellOutputs.fire(r)},emitCellMetadataChange(r){s._onDidChangeCellMetadata.fire(r)}},E,a);u.push(...a.cells.map(r=>d.ExtHostCell.asModelAddData(t.apiNotebook,r))),this._documents.get(E)?.dispose(),this._documents.set(E,t),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:u}),this._onDidOpenNotebookDocument.fire(t.apiNotebook)}}if(l.value.addedEditors)for(const u of l.value.addedEditors){if(this._editors.has(u.id))return;const a=R.URI.revive(u.documentUri),E=this._documents.get(a);E&&this._createExtHostEditor(E,u.id,u)}const c=[];if(l.value.removedEditors)for(const u of l.value.removedEditors){const a=this._editors.get(u);a&&(this._editors.delete(u),this._activeNotebookEditor?.id===a.id&&(this._activeNotebookEditor=void 0),c.push(a))}if(l.value.visibleEditors){this._visibleNotebookEditors=l.value.visibleEditors.map(a=>this._editors.get(a)).filter(a=>!!a);const u=new Set;this._visibleNotebookEditors.forEach(a=>u.add(a.id));for(const a of this._editors.values()){const E=u.has(a.id);a._acceptVisibility(E)}this._visibleNotebookEditors=[...this._editors.values()].map(a=>a).filter(a=>a.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}l.value.newActiveEditor===null?this._activeNotebookEditor=void 0:l.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(l.value.newActiveEditor)),l.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=P,P._notebookStatusBarItemProviderHandlePool=0}),define(ve[245],we([1,0,3,75,11,5,17,14]),function(te,e,f,i,I,A,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class S{constructor(D,v){const b=S._Keys.nextId();D.$registerNotebookEditorDecorationType(b,k.NotebookDecorationRenderOptions.from(v)),this.value={key:b,dispose(){D.$removeNotebookEditorDecorationType(b)}}}}S._Keys=new i.IdGenerator("NotebookEditorDecorationType");let R=class{constructor(D,v,b){this._logService=D,this._extHostRpc=v,this._notebooksAndEditors=b,this._onDidChangeNotebookEditorSelection=new f.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new f.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(D){return new S(this._extHostRpc.getProxy(A.MainContext.MainThreadNotebookEditors),D).value}$acceptEditorPropertiesChanged(D,v){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",D,v);const b=this._notebooksAndEditors.getEditorById(D);v.visibleRanges&&b._acceptVisibleRanges(v.visibleRanges.ranges.map(k.NotebookRange.to)),v.selections&&b._acceptSelections(v.selections.selections.map(k.NotebookRange.to)),v.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:b.apiEditor,visibleRanges:b.apiEditor.visibleRanges}),v.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:b.apiEditor,selections:b.apiEditor.selections}))}$acceptEditorViewColumns(D){for(const v in D)this._notebooksAndEditors.getEditorById(v)._acceptViewColumn(k.ViewColumn.to(D[v]))}};R=Be([Fe(0,I.ILogService),Fe(1,C.IExtHostRpcService)],R),e.ExtHostNotebookEditors=R}),define(ve[246],we([1,0,18,16,21,3,6,24,2,27,11,5,39,14,7,83,213,30,52]),function(te,e,f,i,I,A,C,k,S,R,F,D,v,b,g,d,p,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let l=class{constructor(t,r,n,o,m){this._initData=r,this._extHostNotebook=n,this._commands=o,this._logService=m,this._activeExecutions=new k.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new A.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=t.getProxy(D.MainContext.MainThreadNotebookKernels);const h=new v.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new v.ApiCommandArgument("options","Select kernel options",w=>!0,w=>{if(w&&"notebookEditor"in w&&"id"in w){const T=this._extHostNotebook.getIdByEditor(w.notebookEditor);return{id:w.id,extension:w.extension,notebookEditorId:T}}else if(w&&"notebookEditor"in w){const T=this._extHostNotebook.getIdByEditor(w.notebookEditor);if(T===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${w.notebookEditor.document.uri.toString()}`);return{notebookEditorId:T}}return w})],v.ApiCommandResult.Void);this._commands.registerApiCommand(h)}createNotebookController(t,r,n,o,m,h){for(const ee of this._kernelData.values())if(ee.controller.id===r&&R.ExtensionIdentifier.equals(t.identifier,ee.extensionId))throw new Error(`notebook controller with id '${r}' ALREADY exist`);const w=this._handlePool++,T=this;this._logService.trace(`NotebookController[${w}], CREATED by ${t.identifier.value}, ${r}`);const L=()=>console.warn(`NO execute handler from notebook controller '${j.id}' of extension: '${t.identifier}'`);let O=!1;const y=new C.DisposableStore,H=new A.Emitter,M=new A.Emitter,j={id:E(t,r),notebookType:n,extensionId:t.identifier,extensionLocation:t.extensionLocation,label:o||t.identifier.value,preloads:h?h.map(b.NotebookRendererScript.from):[]};let X=m??L,$;this._proxy.$addKernel(w,j).catch(ee=>{console.log(ee),O=!0});let U=0;const q=()=>{if(O)return;const ee=++U;Promise.resolve().then(()=>{ee===U&&this._proxy.$updateKernel(w,j)})},K=new k.ResourceMap,G={get id(){return r},get notebookType(){return j.notebookType},onDidChangeSelectedNotebooks:H.event,get label(){return j.label},set label(ee){j.label=ee??t.displayName??t.name,q()},get detail(){return j.detail??""},set detail(ee){j.detail=ee,q()},get description(){return j.description??""},set description(ee){j.description=ee,q()},get kind(){return(0,P.checkProposedApiEnabled)(t,"notebookControllerKind"),j.kind??""},set kind(ee){(0,P.checkProposedApiEnabled)(t,"notebookControllerKind"),j.kind=ee,q()},get supportedLanguages(){return j.supportedLanguages},set supportedLanguages(ee){j.supportedLanguages=ee,q()},get supportsExecutionOrder(){return j.supportsExecutionOrder??!1},set supportsExecutionOrder(ee){j.supportsExecutionOrder=ee,q()},get rendererScripts(){return j.preloads?j.preloads.map(b.NotebookRendererScript.to):[]},get executeHandler(){return X},set executeHandler(ee){X=ee??L},get interruptHandler(){return $},set interruptHandler(ee){$=ee,j.supportsInterrupt=Boolean(ee),q()},createNotebookCellExecution(ee){if(O)throw new Error("notebook controller is DISPOSED");if(!K.has(ee.notebook.uri))throw T._logService.trace(`NotebookController[${w}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(K.keys()).map(oe=>oe.toString())),new Error(`notebook controller is NOT associated to notebook: ${ee.notebook.uri.toString()}`);return T._createNotebookCellExecution(ee,E(t,this.id))},dispose:()=>{O||(this._logService.trace(`NotebookController[${w}], DISPOSED`),O=!0,this._kernelData.delete(w),y.dispose(),H.dispose(),M.dispose(),this._proxy.$removeKernel(w))},updateNotebookAffinity(ee,oe){T._proxy.$updateNotebookPriority(w,ee.uri,oe)},onDidReceiveMessage:M.event,postMessage(ee,oe){return(0,P.checkProposedApiEnabled)(t,"notebookMessaging"),T._proxy.$postMessage(w,oe&&T._extHostNotebook.getIdByEditor(oe),ee)},asWebviewUri(ee){return(0,P.checkProposedApiEnabled)(t,"notebookMessaging"),(0,d.asWebviewUri)(ee,T._initData.remote)}};return this._kernelData.set(w,{extensionId:t.identifier,controller:G,onDidReceiveMessage:M,onDidChangeSelection:H,associatedNotebooks:K}),G}$acceptNotebookAssociation(t,r,n){const o=this._kernelData.get(t);if(o){const m=this._extHostNotebook.getNotebookDocument(S.URI.revive(r));n?o.associatedNotebooks.set(m.uri,!0):o.associatedNotebooks.delete(m.uri),this._logService.trace(`NotebookController[${t}] ASSOCIATE notebook`,m.uri.toString(),n),o.onDidChangeSelection.fire({selected:n,notebook:m.apiNotebook})}}async $executeCells(t,r,n){const o=this._kernelData.get(t);if(!o)return;const m=this._extHostNotebook.getNotebookDocument(S.URI.revive(r)),h=[];for(const w of n){const T=m.getCell(w);T&&h.push(T.apiCell)}try{this._logService.trace(`NotebookController[${t}] EXECUTE cells`,m.uri.toString(),h.length),await o.controller.executeHandler.call(o.controller,h,m.apiNotebook,o.controller)}catch(w){this._logService.error(`NotebookController[${t}] execute cells FAILED`,w),console.error(w)}}async $cancelCells(t,r,n){const o=this._kernelData.get(t);if(!o)return;const m=this._extHostNotebook.getNotebookDocument(S.URI.revive(r));if(o.controller.interruptHandler)await o.controller.interruptHandler.call(o.controller,m.apiNotebook);else for(const h of n){const w=m.getCell(h);w&&this._activeExecutions.get(w.uri)?.cancel()}}$acceptKernelMessageFromRenderer(t,r,n){const o=this._kernelData.get(t);if(!o)return;const m=this._extHostNotebook.getEditorById(r);o.onDidReceiveMessage.fire(Object.freeze({editor:m.apiEditor,message:n}))}$cellExecutionChanged(t,r,n){const m=this._extHostNotebook.getNotebookDocument(S.URI.revive(t)).getCell(r);m&&this._onDidChangeCellExecutionState.fire({cell:m.apiCell,state:n?b.NotebookCellExecutionState.to(n):g.NotebookCellExecutionState.Idle})}_createNotebookCellExecution(t,r){if(t.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const o=this._extHostNotebook.getNotebookDocument(t.notebook.uri).getCellFromApiCell(t);if(!o)throw new Error("invalid cell");if(this._activeExecutions.has(o.uri))throw new Error(`duplicate execution for ${o.uri}`);const m=new u(r,o,this._proxy);this._activeExecutions.set(o.uri,m);const h=m.onDidChangeState(()=>{m.state===c.Resolved&&(m.dispose(),h.dispose(),this._activeExecutions.delete(o.uri))});return m.asApiObject()}};l=Be([Fe(4,F.ILogService)],l),e.ExtHostNotebookKernels=l;var c;(function(s){s[s.Init=0]="Init",s[s.Started=1]="Started",s[s.Resolved=2]="Resolved"})(c||(c={}));class u extends C.Disposable{constructor(t,r,n){super();this._cell=r,this._proxy=n,this._handle=u.HANDLE++,this._onDidChangeState=new A.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=c.Init,this._tokenSource=this._register(new I.CancellationTokenSource),this._collector=new a(10,o=>this.update(o)),this._executionOrder=r.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,t,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(t){await this._collector.addItem(t)}async update(t){const r=Array.isArray(t)?t:[t];return this._proxy.$updateExecution(this._handle,new _.SerializableObjectWithBuffers(r))}verifyStateForOutput(){if(this._state===c.Init)throw new Error("Must call start before modifying cell output");if(this._state===c.Resolved)throw new Error("Cannot modify cell output after calling resolve")}validateAndConvertOutputs(t){return t.map(r=>{const n=g.NotebookCellOutput.ensureUniqueMimeTypes(r.items,!0);return n===r.items?b.NotebookCellOutput.from(r):b.NotebookCellOutput.from({items:n,id:r.id,metadata:r.metadata})})}async updateOutputs(t,r,n){const o=this.validateAndConvertOutputs((0,f.asArray)(t));return this.updateSoon({editType:p.CellExecutionUpdateType.Output,append:n,outputs:o})}async updateOutputItems(t,r,n){return t=g.NotebookCellOutput.ensureUniqueMimeTypes((0,f.asArray)(t),!0),this.updateSoon({editType:p.CellExecutionUpdateType.OutputItems,items:t.map(b.NotebookCellOutputItem.from),outputId:r.id,append:n})}asApiObject(){const t=this;return Object.freeze({get token(){return t._tokenSource.token},get cell(){return t._cell.apiCell},get executionOrder(){return t._executionOrder},set executionOrder(n){t._executionOrder=n,t.update([{editType:p.CellExecutionUpdateType.ExecutionState,executionOrder:t._executionOrder}])},start(n){if(t._state===c.Resolved||t._state===c.Started)throw new Error("Cannot call start again");t._state=c.Started,t._onDidChangeState.fire(),t.update({editType:p.CellExecutionUpdateType.ExecutionState,runStartTime:n})},end(n,o){if(t._state===c.Resolved)throw new Error("Cannot call resolve twice");t._state=c.Resolved,t._onDidChangeState.fire(),t._collector.flush(),t._proxy.$completeExecution(t._handle,new _.SerializableObjectWithBuffers({runEndTime:o,lastRunSuccess:n}))},clearOutput(n){return t.verifyStateForOutput(),t.updateOutputs([],n,!1)},appendOutput(n,o){return t.verifyStateForOutput(),t.updateOutputs(n,o,!0)},replaceOutput(n,o){return t.verifyStateForOutput(),t.updateOutputs(n,o,!1)},appendOutputItems(n,o){return t.verifyStateForOutput(),t.updateOutputItems(n,o,!0)},replaceOutputItems(n,o){return t.verifyStateForOutput(),t.updateOutputItems(n,o,!1)}})}}u.HANDLE=0;class a{constructor(t,r){this.delay=t,this.callback=r,this.batch=[],this.startedTimer=Date.now()}addItem(t){return this.batch.push(t),this.currentDeferred||(this.currentDeferred=new i.DeferredPromise,this.startedTimer=Date.now(),(0,i.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const t=this.currentDeferred;this.currentDeferred=void 0;const r=this.batch;return this.batch=[],this.callback(r).finally(()=>t.complete())}}function E(s,t){return`${s.identifier.value}/${t}`}}),define(ve[247],we([1,0,3,5,130,30]),function(te,e,f,i,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class C{constructor(S,R){this._extHostNotebook=R,this._rendererMessageEmitters=new Map,this.proxy=S.getProxy(i.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(S,R,F){const D=this._extHostNotebook.getEditorById(S);this._rendererMessageEmitters.get(R)?.fire({editor:D.apiEditor,message:F})}createRendererMessaging(S,R){if(!S.contributes?.notebookRenderer?.some(b=>b.id===R))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${R})`);const F=(0,A.isProposedApiEnabled)(S,"notebookEditor"),D=new WeakMap;return{onDidReceiveMessage:(b,g,d)=>{const p=F?b:P=>{const _={};D.set(_,P.editor),b({editor:_,message:P.message})};return this.getOrCreateEmitterFor(R).event(p,g,d)},postMessage:(b,g)=>{I.ExtHostNotebookEditor.apiEditorsToExtHost.has(b)&&([b,g]=[g,b]);const d=F?g:D.get(g),p=d&&I.ExtHostNotebookEditor.apiEditorsToExtHost.get(d);return this.proxy.$postMessage(p?.id,R,b)}}}getOrCreateEmitterFor(S){let R=this._rendererMessageEmitters.get(S);return R||(R=new f.Emitter({onLastListenerRemove:()=>{R?.dispose(),this._rendererMessageEmitters.delete(S)}}),this._rendererMessageEmitters.set(S,R),R)}}e.ExtHostNotebookRenderers=C}),define(ve[135],we([1,0,5,6,4,17,11,214,65,26,44,155,22,13]),function(te,e,f,i,I,A,C,k,S,R,F,D,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class g extends i.Disposable{constructor(P,_,l,c){super();this.id=P,this.name=_,this.logger=l,this.proxy=c,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(P){this.append(P+`
`)}append(P){this.write(P),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,k.OutputChannelUpdateMode.Append))}clear(){const P=this.offset;this.logger.flush(),this.proxy.$update(this.id,k.OutputChannelUpdateMode.Clear,P)}replace(P){const _=this.offset;this.write(P),this.proxy.$update(this.id,k.OutputChannelUpdateMode.Replace,_),this.visible&&this.logger.flush()}show(P,_){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof P=="boolean"?P:_))}hide(){this.proxy.$close(this.id)}write(P){this.offset+=v.VSBuffer.fromString(P).byteLength,this.logger.info(P)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=g;let d=class{constructor(P,_,l,c,u){this.extHostFileSystem=l,this.extHostFileSystemInfo=c,this.loggerService=u,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=P.getProxy(f.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(_.logsLocation,`output_logging_${(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(P){this.visibleChannelId=P;for(const[_,l]of this.channels)l.visible=_===this.visibleChannelId}createOutputChannel(P,_,l){if(P=P.trim(),!P)throw new Error("illegal argument `name`. must not be falsy");if((0,b.isString)(_)&&!_.trim())throw new Error("illegal argument `languageId`. must not be empty");const c=this.doCreateOutputChannel(P,_,l);return c.then(u=>{this.channels.set(u.id,u),u.visible=u.id===this.visibleChannelId}),this.createExtHostOutputChannel(P,c)}async doCreateOutputChannel(P,_,l){const c=await this.createOutputDirectory(),u=this.extHostFileSystemInfo.extUri.joinPath(c,`${this.namePool++}-${P.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),a=this.loggerService.createLogger(u,{always:!0,donotRotate:!0,donotUseFormatters:!0}),E=await this.proxy.$register(P,!1,u,_,l.identifier.value);return new g(E,P,a,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(P,_){let l=!1;const c=()=>{if(l)throw new Error("Channel has been closed")};return{get name(){return P},append(u){c(),_.then(a=>a.append(u))},appendLine(u){c(),_.then(a=>a.appendLine(u))},clear(){c(),_.then(u=>u.clear())},replace(u){c(),_.then(a=>a.replace(u))},show(u,a){c(),_.then(E=>E.show(u,a))},hide(){c(),_.then(u=>u.hide())},dispose(){l=!0,_.then(u=>u.dispose())}}}};d=Be([Fe(0,A.IExtHostRpcService),Fe(1,R.IExtHostInitDataService),Fe(2,S.IExtHostConsumerFileSystem),Fe(3,F.IExtHostFileSystemInfo),Fe(4,C.ILoggerService)],d),e.ExtHostOutputService=d,e.IExtHostOutputService=(0,I.createDecorator)("IExtHostOutputService")}),define(ve[248],we([1,0,16,21,3,6,5,2,7,15,18,47,81]),function(te,e,f,i,I,A,C,k,S,R,F,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function b(g,d,p){const P=g.getProxy(C.MainContext.MainThreadQuickOpen);class _{constructor(n,o){this._sessions=new Map,this._instances=0,this._workspace=n,this._commands=o}showQuickPick(n,o,m=i.CancellationToken.None){this._onDidSelectItem=void 0;const h=Promise.resolve(n),w=++this._instances,T=P.$show(w,{title:o?.title,placeHolder:o?.placeHolder,matchOnDescription:o?.matchOnDescription,matchOnDetail:o?.matchOnDetail,ignoreFocusLost:o?.ignoreFocusOut,canPickMany:o?.canPickMany},m),L={},O=T.then(()=>L);return Promise.race([O,h]).then(y=>{if(y!==L)return h.then(H=>{const M=[];for(let j=0;j<H.length;j++){const X=H[j];typeof X=="string"?M.push({label:X,handle:j}):X.kind===S.QuickPickItemKind.Separator?M.push({type:"separator",label:X.label}):M.push({label:X.label,description:X.description,detail:X.detail,picked:X.picked,alwaysShow:X.alwaysShow,handle:j})}return o&&typeof o.onDidSelectItem=="function"&&(this._onDidSelectItem=j=>{o.onDidSelectItem(H[j])}),P.$setItems(w,M),T.then(j=>{if(typeof j=="number")return H[j];if(Array.isArray(j))return j.map(X=>H[X])})})}).then(void 0,y=>{if(!(0,R.isCancellationError)(y))return P.$setError(w,y),Promise.reject(y)})}$onItemSelected(n){this._onDidSelectItem&&this._onDidSelectItem(n)}showInput(n,o=i.CancellationToken.None){return this._validateInput=n?n.validateInput:void 0,P.$input(n,typeof this._validateInput=="function",o).then(void 0,m=>{if(!(0,R.isCancellationError)(m))return Promise.reject(m)})}$validateInput(n){return this._validateInput?(0,f.asPromise)(()=>this._validateInput(n)):Promise.resolve(void 0)}async showWorkspaceFolderPick(n,o=i.CancellationToken.None){const m=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[n]);if(!m)return;const h=await this._workspace.getWorkspaceFolders2();if(!!h)return h.find(w=>w.uri.toString()===m.uri.toString())}createQuickPick(n){const o=new s(n,()=>this._sessions.delete(o._id));return this._sessions.set(o._id,o),o}createInputBox(n){const o=new t(n,()=>this._sessions.delete(o._id));return this._sessions.set(o._id,o),o}$onDidChangeValue(n,o){const m=this._sessions.get(n);m&&m._fireDidChangeValue(o)}$onDidAccept(n){const o=this._sessions.get(n);o&&o._fireDidAccept()}$onDidChangeActive(n,o){const m=this._sessions.get(n);m instanceof s&&m._fireDidChangeActive(o)}$onDidChangeSelection(n,o){const m=this._sessions.get(n);m instanceof s&&m._fireDidChangeSelection(o)}$onDidTriggerButton(n,o){const m=this._sessions.get(n);m&&m._fireDidTriggerButton(o)}$onDidTriggerItemButton(n,o,m){const h=this._sessions.get(n);h instanceof s&&h._fireDidTriggerItemButton(o,m)}$onDidHide(n){const o=this._sessions.get(n);o&&o._fireDidHide()}}class l{constructor(n,o){this._extensionId=n,this._onDidDispose=o,this._id=s._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new I.Emitter,this._onDidChangeValueEmitter=new I.Emitter,this._onDidTriggerButtonEmitter=new I.Emitter,this._onDidHideEmitter=new I.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(n){this._title=n,this.update({title:n})}get step(){return this._steps}set step(n){this._steps=n,this.update({step:n})}get totalSteps(){return this._totalSteps}set totalSteps(n){this._totalSteps=n,this.update({totalSteps:n})}get enabled(){return this._enabled}set enabled(n){this._enabled=n,this.update({enabled:n})}get busy(){return this._busy}set busy(n){this._busy=n,this.update({busy:n})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(n){this._ignoreFocusOut=n,this.update({ignoreFocusOut:n})}get value(){return this._value}set value(n){this._value=n,this.update({value:n})}get placeholder(){return this._placeholder}set placeholder(n){this._placeholder=n,this.update({placeholder:n})}get buttons(){return this._buttons}set buttons(n){this._buttons=n.slice(),this._handlesToButtons.clear(),n.forEach((o,m)=>{const h=o===S.QuickInputButtons.Back?-1:m;this._handlesToButtons.set(h,o)}),this.update({buttons:n.map((o,m)=>({...E(o),tooltip:o.tooltip,handle:o===S.QuickInputButtons.Back?-1:m}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(n){this._value=n,this._onDidChangeValueEmitter.fire(n)}_fireDidTriggerButton(n){const o=this._handlesToButtons.get(n);o&&this._onDidTriggerButtonEmitter.fire(o)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,A.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),P.$dispose(this._id))}update(n){if(!this._disposed){for(const o of Object.keys(n)){const m=n[o];this._pendingUpdate[o]=m===void 0?null:m}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){P.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}l._nextId=1;function c(r){if(r instanceof S.ThemeIcon)return{id:r.id};const n=a(r),o=u(r);return{dark:typeof n=="string"?k.URI.file(n):n,light:typeof o=="string"?k.URI.file(o):o}}function u(r){return typeof r=="object"&&"light"in r?r.light:r}function a(r){return typeof r=="object"&&"dark"in r?r.dark:r}function E(r){const n=c(r.iconPath);let o,m;return"id"in n?m=v.ThemeIcon.asClassName(n):o=n,{iconPath:o,iconClass:m}}class s extends l{constructor(n,o){super(n.identifier,o);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new I.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new I.Emitter,this._onDidTriggerItemButtonEmitter=new I.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(n){this._items=n.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),n.forEach((m,h)=>{this._handlesToItems.set(h,m),this._itemsToHandles.set(m,h)});const o=[];for(let m=0;m<n.length;m++){const h=n[m];h.kind===S.QuickPickItemKind.Separator?o.push({type:"separator",label:h.label}):o.push({handle:m,label:h.label,description:h.description,detail:h.detail,picked:h.picked,alwaysShow:h.alwaysShow,buttons:h.buttons?.map((w,T)=>({...E(w),tooltip:w.tooltip,handle:T}))})}this.update({items:o})}get canSelectMany(){return this._canSelectMany}set canSelectMany(n){this._canSelectMany=n,this.update({canSelectMany:n})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(n){this._matchOnDescription=n,this.update({matchOnDescription:n})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(n){this._matchOnDetail=n,this.update({matchOnDetail:n})}get sortByLabel(){return this._sortByLabel}set sortByLabel(n){this._sortByLabel=n,this.update({sortByLabel:n})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(n){this._keepScrollPosition=n,this.update({keepScrollPosition:n})}get activeItems(){return this._activeItems}set activeItems(n){this._activeItems=n.filter(o=>this._itemsToHandles.has(o)),this.update({activeItems:this._activeItems.map(o=>this._itemsToHandles.get(o))})}get selectedItems(){return this._selectedItems}set selectedItems(n){this._selectedItems=n.filter(o=>this._itemsToHandles.has(o)),this.update({selectedItems:this._selectedItems.map(o=>this._itemsToHandles.get(o))})}_fireDidChangeActive(n){const o=(0,F.coalesce)(n.map(m=>this._handlesToItems.get(m)));this._activeItems=o,this._onDidChangeActiveEmitter.fire(o)}_fireDidChangeSelection(n){const o=(0,F.coalesce)(n.map(m=>this._handlesToItems.get(m)));this._selectedItems=o,this._onDidChangeSelectionEmitter.fire(o)}_fireDidTriggerItemButton(n,o){const m=this._handlesToItems.get(n);if(!m||!m.buttons||!m.buttons.length)return;const h=m.buttons[o];h&&this._onDidTriggerItemButtonEmitter.fire({button:h,item:m})}}class t extends l{constructor(n,o){super(n,o);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(n){this._password=n,this.update({password:n})}get prompt(){return this._prompt}set prompt(n){this._prompt=n,this.update({prompt:n})}get validationMessage(){return this._validationMessage}set validationMessage(n){this._validationMessage=n,this.update({validationMessage:n,severity:n?D.default.Error:D.default.Ignore})}}return new _(d,p)}e.createExtHostQuickOpen=b});var Xe=this&&this.__classPrivateFieldSet||function(te,e,f,i,I){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!I:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?I.call(te,f):I?I.value=f:e.set(te,f),f},Pe=this&&this.__classPrivateFieldGet||function(te,e,f,i){if(f==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!i:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?i:f==="a"?i.call(te):i?i.value:e.get(te)};define(ve[249],we([1,0,2,3,56,6,16,5,18,97,11,27,81,14,30]),function(te,e,f,i,I,A,C,k,S,R,F,D,v,b,g){"use strict";var d,p;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function P(m){if(m)return typeof m.iconPath=="string"?f.URI.file(m.iconPath):f.URI.isUri(m.iconPath)||v.ThemeIcon.isThemeIcon(m.iconPath)?m.iconPath:void 0}function _(m,h){if(!m.iconPath&&!h.iconPath)return 0;if(m.iconPath){if(!h.iconPath)return 1}else return-1;const w=typeof m.iconPath=="string"?m.iconPath:f.URI.isUri(m.iconPath)?m.iconPath.fsPath:m.iconPath.id,T=typeof h.iconPath=="string"?h.iconPath:f.URI.isUri(h.iconPath)?h.iconPath.fsPath:h.iconPath.id;return(0,R.comparePaths)(w,T)}function l(m,h){let w=0;if(m.strikeThrough!==h.strikeThrough)return m.strikeThrough?1:-1;if(m.faded!==h.faded)return m.faded?1:-1;if(m.tooltip!==h.tooltip)return(m.tooltip||"").localeCompare(h.tooltip||"");if(w=_(m,h),w!==0)return w;if(m.light&&h.light)w=_(m.light,h.light);else{if(m.light)return 1;if(h.light)return-1}if(w!==0)return w;if(m.dark&&h.dark)w=_(m.dark,h.dark);else{if(m.dark)return 1;if(h.dark)return-1}return w}function c(m,h){if(m.command!==h.command)return m.command<h.command?-1:1;if(m.title!==h.title)return m.title<h.title?-1:1;if(m.tooltip!==h.tooltip){if(m.tooltip!==void 0&&h.tooltip!==void 0)return m.tooltip<h.tooltip?-1:1;if(m.tooltip!==void 0)return 1;if(h.tooltip!==void 0)return-1}if(m.arguments===h.arguments)return 0;if(m.arguments)if(h.arguments){if(m.arguments.length!==h.arguments.length)return m.arguments.length-h.arguments.length}else return 1;else return-1;for(let w=0;w<m.arguments.length;w++){const T=m.arguments[w],L=h.arguments[w];if(T!==L)return T<L?-1:1}return 0}function u(m,h){let w=(0,R.comparePaths)(m.resourceUri.fsPath,h.resourceUri.fsPath,!0);if(w!==0)return w;if(m.command&&h.command)w=c(m.command,h.command);else{if(m.command)return 1;if(h.command)return-1}if(w!==0)return w;if(m.decorations&&h.decorations)w=l(m.decorations,h.decorations);else{if(m.decorations)return 1;if(h.decorations)return-1}return w}function a(m,h){for(let w=0;w<m.length;w++)if(m[w]!==h[w])return!1;return!0}function E(m,h){return m.command===h.command&&m.title===h.title&&m.tooltip===h.tooltip&&(m.arguments&&h.arguments?a(m.arguments,h.arguments):m.arguments===h.arguments)}function s(m,h){return(0,S.equals)(m,h,E)}class t{constructor(h,w,T){this._extension=h,this._sourceControlHandle=T,d.set(this,void 0),this._value="",this._onDidChange=new i.Emitter,this._placeholder="",this._visible=!0,Xe(this,d,w,"f")}get value(){return this._value}set value(h){h=h??"",Pe(this,d,"f").$setInputBoxValue(this._sourceControlHandle,h),this.updateValue(h)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(h){Pe(this,d,"f").$setInputBoxPlaceholder(this._sourceControlHandle,h),this._placeholder=h}get validateInput(){return(0,g.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(h){if((0,g.checkProposedApiEnabled)(this._extension,"scmValidation"),h&&typeof h!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=h,Pe(this,d,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!h)}get visible(){return this._visible}set visible(h){h=!!h,this._visible!==h&&(this._visible=h,Pe(this,d,"f").$setInputBoxVisibility(this._sourceControlHandle,h))}showValidationMessage(h,w){(0,g.checkProposedApiEnabled)(this._extension,"scmValidation"),Pe(this,d,"f").$showValidationMessage(this._sourceControlHandle,h,w)}$onInputBoxValueChange(h){this.updateValue(h)}updateValue(h){this._value=h,this._onDidChange.fire(h)}}e.ExtHostSCMInputBox=t,d=new WeakMap;class r{constructor(h,w,T,L,O){this._proxy=h,this._commands=w,this._sourceControlHandle=T,this._id=L,this._label=O,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new i.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new i.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=r._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(h){this._label=h,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,h)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(h){this._hideWhenEmpty=h,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(h){this._resourceStates=[...h],this._onDidUpdateResourceStates.fire()}getResourceState(h){return this._resourceStatesMap.get(h)}$executeResourceCommand(h,w){const T=this._resourceStatesCommandsMap.get(h);return T?(0,C.asPromise)(()=>this._commands.executeCommand(T.command,...T.arguments||[],w)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const h=[...this._resourceStates].sort(u),T=(0,S.sortedDiff)(this._resourceSnapshot,h,u).map(y=>{const H=y.toInsert.map(M=>{const j=this._resourceHandlePool++;this._resourceStatesMap.set(j,M);const X=M.resourceUri;let $;if(M.command)if(M.command.command==="vscode.open"||M.command.command==="vscode.diff"){const se=new A.DisposableStore;$=this._commands.converter.toInternal(M.command,se),this._resourceStatesDisposablesMap.set(j,se)}else this._resourceStatesCommandsMap.set(j,M.command);const U=P(M.decorations),q=M.decorations&&P(M.decorations.light)||U,K=M.decorations&&P(M.decorations.dark)||U,G=[q,K],ee=M.decorations&&M.decorations.tooltip||"",oe=M.decorations&&!!M.decorations.strikeThrough,ue=M.decorations&&!!M.decorations.faded,Z=M.contextValue||"";return{rawResource:[j,X,G,ee,oe,ue,Z,$],handle:j}});return{start:y.start,deleteCount:y.deleteCount,toInsert:H}}),L=T.map(({start:y,deleteCount:H,toInsert:M})=>[y,H,M.map(j=>j.rawResource)]),O=T.reverse();for(const{start:y,deleteCount:H,toInsert:M}of O){const j=M.map($=>$.handle),X=this._handlesSnapshot.splice(y,H,...j);for(const $ of X)this._resourceStatesMap.delete($),this._resourceStatesCommandsMap.delete($),this._resourceStatesDisposablesMap.get($)?.dispose(),this._resourceStatesDisposablesMap.delete($)}return this._resourceSnapshot=h,L}dispose(){this._disposed=!0,this._onDidDispose.fire()}}r._handlePool=0;class n{constructor(h,w,T,L,O,y){this._extension=h,this._commands=T,this._id=L,this._label=O,this._rootUri=y,p.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new A.MutableDisposable,this._statusBarDisposables=new A.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new i.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=n._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,Xe(this,p,w,"f"),this._inputBox=new t(h,Pe(this,p,"f"),this.handle),Pe(this,p,"f").$registerSourceControl(this.handle,L,O,y)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(h){this._count!==h&&(this._count=h,Pe(this,p,"f").$updateSourceControl(this.handle,{count:h}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(h){this._quickDiffProvider=h,Pe(this,p,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!h})}get commitTemplate(){return this._commitTemplate}set commitTemplate(h){h!==this._commitTemplate&&(this._commitTemplate=h,Pe(this,p,"f").$updateSourceControl(this.handle,{commitTemplate:h}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(h){this._acceptInputDisposables.value=new A.DisposableStore,this._acceptInputCommand=h;const w=this._commands.converter.toInternal(h,this._acceptInputDisposables.value);Pe(this,p,"f").$updateSourceControl(this.handle,{acceptInputCommand:w})}get actionButton(){return(0,g.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(h){(0,g.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new A.DisposableStore,this._actionButton=h;const w=h!==void 0?{command:this._commands.converter.toInternal(h.command,this._actionButtonDisposables.value),description:h.description}:void 0;Pe(this,p,"f").$updateSourceControl(this.handle,{actionButton:w??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(h){if(this._statusBarCommands&&h&&s(this._statusBarCommands,h))return;this._statusBarDisposables.value=new A.DisposableStore,this._statusBarCommands=h;const w=(h||[]).map(T=>this._commands.converter.toInternal(T,this._statusBarDisposables.value));Pe(this,p,"f").$updateSourceControl(this.handle,{statusBarCommands:w})}get selected(){return this._selected}createResourceGroup(h,w){const T=new r(Pe(this,p,"f"),this._commands,this.handle,h,w),L=i.Event.once(T.onDidDispose)(()=>this.createdResourceGroups.delete(T));return this.createdResourceGroups.set(T,L),this.eventuallyAddResourceGroups(),T}eventuallyAddResourceGroups(){const h=[],w=[];for(const[T,L]of this.createdResourceGroups){L.dispose();const O=T.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(T),this.eventuallyUpdateResourceStates()});i.Event.once(T.onDidDispose)(()=>{this.updatedResourceGroups.delete(T),O.dispose(),this._groups.delete(T.handle),Pe(this,p,"f").$unregisterGroup(this.handle,T.handle)}),h.push([T.handle,T.id,T.label,T.features]);const y=T._takeResourceStateSnapshot();y.length>0&&w.push([T.handle,y]),this._groups.set(T.handle,T)}Pe(this,p,"f").$registerGroups(this.handle,h,w),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const h=[];this.updatedResourceGroups.forEach(w=>{const T=w._takeResourceStateSnapshot();T.length!==0&&h.push([w.handle,T])}),h.length>0&&Pe(this,p,"f").$spliceResourceStates(this.handle,h),this.updatedResourceGroups.clear()}getResourceGroup(h){return this._groups.get(h)}setSelectionState(h){this._selected=h,this._onDidChangeSelection.fire(h)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(h=>h.dispose()),Pe(this,p,"f").$unregisterSourceControl(this.handle)}}p=new WeakMap,n._handlePool=0,Be([(0,I.debounce)(100)],n.prototype,"eventuallyAddResourceGroups",null),Be([(0,I.debounce)(100)],n.prototype,"eventuallyUpdateResourceStates",null);let o=class Vi{constructor(h,w,T){this._commands=w,this.logService=T,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new i.Emitter,this._proxy=h.getProxy(k.MainContext.MainThreadSCM),this._telemetry=h.getProxy(k.MainContext.MainThreadTelemetry),w.registerArgumentProcessor({processArgument:L=>{if(L&&L.$mid===3){const O=this._sourceControls.get(L.sourceControlHandle);if(!O)return L;const y=O.getResourceGroup(L.groupHandle);return y?y.getResourceState(L.handle):L}else if(L&&L.$mid===4){const O=this._sourceControls.get(L.sourceControlHandle);return O?O.getResourceGroup(L.groupHandle):L}else if(L&&L.$mid===5){const O=this._sourceControls.get(L.handle);return O||L}return L}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(h,w,T,L){this.logService.trace("ExtHostSCM#createSourceControl",h.identifier.value,w,T,L),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:h.identifier.value});const O=Vi._handlePool++,y=new n(h,this._proxy,this._commands,w,T,L);this._sourceControls.set(O,y);const H=this._sourceControlsByExtension.get(D.ExtensionIdentifier.toKey(h.identifier))||[];return H.push(y),this._sourceControlsByExtension.set(D.ExtensionIdentifier.toKey(h.identifier),H),y}getLastInputBox(h){this.logService.trace("ExtHostSCM#getLastInputBox",h.identifier.value);const w=this._sourceControlsByExtension.get(D.ExtensionIdentifier.toKey(h.identifier)),T=w&&w[w.length-1];return T&&T.inputBox}$provideOriginalResource(h,w,T){const L=f.URI.revive(w);this.logService.trace("ExtHostSCM#$provideOriginalResource",h,L.toString());const O=this._sourceControls.get(h);return!O||!O.quickDiffProvider||!O.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,C.asPromise)(()=>O.quickDiffProvider.provideOriginalResource(L,T)).then(y=>y||null)}$onInputBoxValueChange(h,w){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",h);const T=this._sourceControls.get(h);return T&&T.inputBox.$onInputBoxValueChange(w),Promise.resolve(void 0)}$executeResourceCommand(h,w,T,L){this.logService.trace("ExtHostSCM#$executeResourceCommand",h,w,T);const O=this._sourceControls.get(h);if(!O)return Promise.resolve(void 0);const y=O.getResourceGroup(w);return y?y.$executeResourceCommand(T,L):Promise.resolve(void 0)}$validateInput(h,w,T){this.logService.trace("ExtHostSCM#$validateInput",h);const L=this._sourceControls.get(h);return!L||!L.inputBox.validateInput?Promise.resolve(void 0):(0,C.asPromise)(()=>L.inputBox.validateInput(w,T)).then(O=>{if(!O)return Promise.resolve(void 0);const y=b.MarkdownString.fromStrict(O.message);return y?Promise.resolve([y,O.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(h){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",h),h!==void 0&&this._sourceControls.get(h)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=h,Promise.resolve(void 0)}};o._handlePool=0,o=Be([Fe(2,F.ILogService)],o),e.ExtHostSCM=o});var Xe=this&&this.__classPrivateFieldSet||function(te,e,f,i,I){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!I:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?I.call(te,f):I?I.value=f:e.set(te,f),f},Pe=this&&this.__classPrivateFieldGet||function(te,e,f,i){if(f==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!i:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?i:f==="a"?i.call(te):i?i.value:e.get(te)};define(ve[250],we([1,0,7,5,169,6,14,13]),function(te,e,f,i,I,A,C,k){"use strict";var S,R;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class F{constructor(g,d,p,P,_=f.StatusBarAlignment.Left,l){S.set(this,void 0),R.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new A.DisposableStore,Xe(this,S,g,"f"),Xe(this,R,d,"f"),this._entryId=F.ID_GEN++,this._extension=p,this._id=P,this._alignment=_,this._priority=this.validatePriority(l)}validatePriority(g){if(!!(0,k.isNumber)(g))return g===Number.POSITIVE_INFINITY?Number.MAX_VALUE:g===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:g}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(g){this._text=g,this.update()}set name(g){this._name=g,this.update()}set tooltip(g){this._tooltip=g,this.update()}set color(g){this._color=g,this.update()}set backgroundColor(g){g&&!F.ALLOWED_BACKGROUND_COLORS.has(g.id)&&(g=void 0),this._backgroundColor=g,this.update()}set command(g){this._command?.fromApi!==g&&(this._internalCommandRegistration.clear(),typeof g=="string"?this._command={fromApi:g,internal:Pe(this,R,"f").toInternal({title:"",command:g},this._internalCommandRegistration)}:g?this._command={fromApi:g,internal:Pe(this,R,"f").toInternal(g,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(g){this._accessibilityInformation=g,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Pe(this,S,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let g;this._extension?this._id?g=`${this._extension.identifier.value}.${this._id}`:g=this._extension.identifier.value:g=this._id;let d;this._name?d=this._name:d=(0,I.localize)(0,null,this._extension.displayName||this._extension.name);let p=this._color;this._backgroundColor&&(p=F.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const P=C.MarkdownString.fromStrict(this._tooltip);Pe(this,S,"f").$setEntry(this._entryId,g,d,this._text,P,this._command?.internal,p,this._backgroundColor,this._alignment===f.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=F,S=new WeakMap,R=new WeakMap,F.ID_GEN=0,F.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new f.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new f.ThemeColor("statusBarItem.warningForeground")]]);class D{constructor(g){this._messages=[],this._item=g.createStatusBarEntry(void 0,"status.extensionMessage",f.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,I.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(g){const d={message:g};return this._messages.unshift(d),this._update(),new f.Disposable(()=>{const p=this._messages.indexOf(d);p>=0&&(this._messages.splice(p,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class v{constructor(g,d){this._proxy=g.getProxy(i.MainContext.MainThreadStatusBar),this._commands=d,this._statusMessage=new D(this)}createStatusBarEntry(g,d,p,P){return new F(this._proxy,this._commands,g,d,p,P)}setStatusBarMessage(g,d){const p=this._statusMessage.setMessage(g);let P;return typeof d=="number"?P=setTimeout(()=>p.dispose(),d):typeof d!="undefined"&&d.then(()=>p.dispose(),()=>p.dispose()),new f.Disposable(()=>{p.dispose(),clearTimeout(P)})}}e.ExtHostStatusBar=v}),define(ve[87],we([1,0,5,3,4]),function(te,e,f,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class A{constructor(k){this._onDidChangeStorage=new i.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=k.getProxy(f.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(k,S){this._proxy.$registerExtensionStorageKeysToSync(k,S)}initializeExtensionStorage(k,S,R){return this._proxy.$initializeExtensionStorage(k,S).then(F=>F||R)}setValue(k,S,R){return this._proxy.$setValue(k,S,R)}$acceptValue(k,S,R){this._onDidChangeStorage.fire({shared:k,key:S,value:R})}}e.ExtHostStorage=A,e.IExtHostStorage=(0,I.createDecorator)("IExtHostStorage")}),define(ve[66],we([1,0,4,26,11,65,2]),function(te,e,f,i,I,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,f.createDecorator)("IExtensionStoragePaths");let k=class{constructor(R,F,D){this._logService=F,this._extHostFileSystem=D,this._workspace=R.workspace??void 0,this._environment=R.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(v=>this._value=v)}async _getWorkspaceStorageURI(R){return C.URI.joinPath(this._environment.workspaceStorageHome,R)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const R=this._workspace.id,F=await this._getWorkspaceStorageURI(R);try{return await this._extHostFileSystem.value.stat(F),this._logService.trace("[ExtHostStorage] storage dir already exists",F),F}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",F),await this._extHostFileSystem.value.createDirectory(F),await this._extHostFileSystem.value.writeFile(C.URI.joinPath(F,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:C.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),F}catch(D){this._logService.error("[ExtHostStorage]",D);return}}workspaceValue(R){if(this._value)return C.URI.joinPath(this._value,R.identifier.value)}globalValue(R){return C.URI.joinPath(this._environment.globalStorageHome,R.identifier.value.toLowerCase())}onWillDeactivateAll(){}};k=Be([Fe(0,i.IExtHostInitDataService),Fe(1,I.ILogService),Fe(2,A.IExtHostConsumerFileSystem)],k),e.ExtensionStoragePaths=k}),define(ve[34],we([1,0,3,5,4,2,17,6,7,170,15,216,21,33,196,81,13,16]),function(te,e,f,i,I,A,C,k,S,R,F,D,v,b,g,d,p,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,I.createDecorator)("IExtHostTerminalService");class _{constructor(n,o,m,h){this._proxy=n,this._id=o,this._creationOptions=m,this._name=h,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(T=>this._pidPromiseComplete=T);const w=this;this.value={get name(){return w._name||""},get processId(){return w._pidPromise},get creationOptions(){return w._creationOptions},get exitStatus(){return w._exitStatus},get state(){return w._state},sendText(T,L=!0){w._checkDisposed(),w._proxy.$sendText(w._id,T,L)},show(T){w._checkDisposed(),w._proxy.$show(w._id,T)},hide(){w._checkDisposed(),w._proxy.$hide(w._id)},dispose(){w._disposed||(w._disposed=!0,w._proxy.$dispose(w._id))},get dimensions(){if(!(w._cols===void 0||w._rows===void 0))return{columns:w._cols,rows:w._rows}}}}async create(n,o){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:n.name,shellPath:(0,p.withNullAsUndefined)(n.shellPath),shellArgs:(0,p.withNullAsUndefined)(n.shellArgs),cwd:(0,p.withNullAsUndefined)(n.cwd),env:(0,p.withNullAsUndefined)(n.env),icon:(0,p.withNullAsUndefined)(s(n.iconPath)),color:d.ThemeColor.isThemeColor(n.color)?n.color.id:void 0,initialText:(0,p.withNullAsUndefined)(n.message),strictEnv:(0,p.withNullAsUndefined)(n.strictEnv),hideFromUser:(0,p.withNullAsUndefined)(n.hideFromUser),isFeatureTerminal:(0,p.withNullAsUndefined)(o?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,p.withNullAsUndefined)(o?.useShellEnvironment),location:o?.location||this._serializeParentTerminal(n.location,o?.resolvedExtHostIdentifier),isTransient:(0,p.withNullAsUndefined)(n.isTransient)})}async createExtensionTerminal(n,o,m,h){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:m,color:d.ThemeColor.isThemeColor(h)?h.id:void 0,location:this._serializeParentTerminal(n,o),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(n,o){return typeof n=="object"?"parentTerminal"in n&&n.parentTerminal&&o?{parentTerminal:o}:"viewColumn"in n?{viewColumn:n.viewColumn,preserveFocus:n.preserveFocus}:void 0:n}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(n){this._name=n}setExitCode(n){this._exitStatus=Object.freeze({code:n})}setDimensions(n,o){return n===this._cols&&o===this._rows||n===0||o===0?!1:(this._cols=n,this._rows=o,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(n){this._pidPromiseComplete?(this._pidPromiseComplete(n),this._pidPromiseComplete=void 0):this._pidPromise.then(o=>{o!==n&&(this._pidPromise=Promise.resolve(n))})}}e.ExtHostTerminal=_;class l{constructor(n){this._pty=n,this.id=0,this.shouldPersist=!1,this._onProcessData=new f.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new f.Emitter,this._onDidChangeProperty=new f.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new f.Emitter,this.onProcessExit=this._onProcessExit.event}get onProcessReady(){return this._onProcessReady.event}refreshProperty(n){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${n}`)}updateProperty(n,o){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${n}, value: ${o}`)}async start(){}shutdown(){this._pty.close()}input(n){this._pty.handleInput?.(n)}resize(n,o){this._pty.setDimensions?.({columns:n,rows:o})}async processBinary(n){}acknowledgeDataEvent(n){}async setUnicodeVersion(n){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(n){this._pty.onDidWrite(o=>this._onProcessData.fire(o)),this._pty.onDidClose?.((o=void 0)=>{this._onProcessExit.fire(o===void 0?void 0:o)}),this._pty.onDidOverrideDimensions?.(o=>{o&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:o.columns,rows:o.rows}})}),this._pty.onDidChangeName?.(o=>{this._onDidChangeProperty.fire({type:"title",value:o})}),this._pty.open(n||void 0),n&&this._pty.setDimensions?.(n),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=l;let c=1,u=class extends k.Disposable{constructor(n,o){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new f.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new f.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new f.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new f.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new f.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=o.getProxy(i.MainContext.MainThreadTerminalService),this._bufferer=new g.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new f.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(n),this._register({dispose:()=>{for(const[m,h]of this._terminalProcesses)h.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(n=>n.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(n){return(n?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(n){return(n?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(n,o){const m=new _(this._proxy,(0,b.generateUuid)(),n,n.name),h=new l(n.pty);return m.createExtensionTerminal(n.location,this._serializeParentTerminal(n,o).resolvedExtHostIdentifier,s(n.iconPath),t(n.color)).then(w=>{const T=this._setupExtHostProcessListeners(w,h);this._terminalProcessDisposables[w]=T}),this._terminals.push(m),m.value}_serializeParentTerminal(n,o){if(o=o||{},n.location&&typeof n.location=="object"&&"parentTerminal"in n.location){const m=n.location.parentTerminal;if(m){const h=this._terminals.find(w=>w.value===m);h&&(o.resolvedExtHostIdentifier=h._id)}}else n.location&&typeof n.location!="object"?o.location=n.location:o.location&&typeof o.location=="object"&&"splitActiveTerminal"in o.location&&(o.location={splitActiveTerminal:!0});return o}attachPtyToTerminal(n,o){if(!this._getTerminalById(n))throw new Error(`Cannot resolve terminal with id ${n} for virtual process`);const h=new l(o),w=this._setupExtHostProcessListeners(n,h);this._terminalProcessDisposables[n]=w}async $acceptActiveTerminalChanged(n){const o=this._activeTerminal;if(n===null){this._activeTerminal=void 0,o!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const m=this._getTerminalById(n);m&&(this._activeTerminal=m,o!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(n,o){const m=this._getTerminalById(n);m&&this._onDidWriteTerminalData.fire({terminal:m.value,data:o})}async $acceptTerminalDimensions(n,o,m){const h=this._getTerminalById(n);h&&h.setDimensions(o,m)&&this._onDidChangeTerminalDimensions.fire({terminal:h.value,dimensions:h.value.dimensions})}async $acceptTerminalMaximumDimensions(n,o,m){this._terminalProcesses.get(n)?.resize(o,m)}async $acceptTerminalTitleChange(n,o){const m=this._getTerminalById(n);m&&(m.name=o)}async $acceptTerminalClosed(n,o){const m=this._getTerminalObjectIndexById(this._terminals,n);if(m!==null){const h=this._terminals.splice(m,1)[0];h.setExitCode(o),this._onDidCloseTerminal.fire(h.value)}}$acceptTerminalOpened(n,o,m,h){if(o){const L=this._getTerminalObjectIndexById(this._terminals,o);if(L!==null){this._terminals[L]._id=n,this._onDidOpenTerminal.fire(this.terminals[L]),this._terminals[L].isOpen=!0;return}}const w={name:h.name,shellPath:h.executable,shellArgs:h.args,cwd:typeof h.cwd=="string"?h.cwd:A.URI.revive(h.cwd),env:h.env,hideFromUser:h.hideFromUser},T=new _(this._proxy,n,w,m);this._terminals.push(T),this._onDidOpenTerminal.fire(T.value),T.isOpen=!0}async $acceptTerminalProcessId(n,o){const m=this._getTerminalById(n);m&&m._setProcessId(o)}async $startExtensionTerminal(n,o){const m=this._getTerminalById(n);if(!m)return{message:(0,R.localize)(0,null,n)};m.isOpen||await new Promise(w=>{const T=this.onDidOpenTerminal(async L=>{L===m.value&&(T.dispose(),w())})});const h=this._terminalProcesses.get(n);h?h.startSendingEvents(o):this._extensionTerminalAwaitingStart[n]={initialDimensions:o}}_setupExtHostProcessListeners(n,o){const m=new k.DisposableStore;m.add(o.onProcessReady(w=>this._proxy.$sendProcessReady(n,w.pid,w.cwd))),m.add(o.onDidChangeProperty(w=>this._proxy.$sendProcessProperty(n,w))),this._bufferer.startBuffering(n,o.onProcessData),m.add(o.onProcessExit(w=>this._onProcessExit(n,w))),this._terminalProcesses.set(n,o);const h=this._extensionTerminalAwaitingStart[n];return h&&o instanceof l&&(o.startSendingEvents(h.initialDimensions),delete this._extensionTerminalAwaitingStart[n]),m}$acceptProcessAckDataEvent(n,o){this._terminalProcesses.get(n)?.acknowledgeDataEvent(o)}$acceptProcessInput(n,o){this._terminalProcesses.get(n)?.input(o)}$acceptTerminalInteraction(n){const o=this._getTerminalById(n);o?.setInteractedWith()&&this._onDidChangeTerminalState.fire(o.value)}$acceptProcessResize(n,o,m){try{this._terminalProcesses.get(n)?.resize(o,m)}catch(h){if(h.code!=="EPIPE"&&h.code!=="ERR_IPC_CHANNEL_CLOSED")throw h}}$acceptProcessShutdown(n,o){this._terminalProcesses.get(n)?.shutdown(o)}$acceptProcessRequestInitialCwd(n){this._terminalProcesses.get(n)?.getInitialCwd().then(o=>this._proxy.$sendProcessProperty(n,{type:"initialCwd",value:o}))}$acceptProcessRequestCwd(n){this._terminalProcesses.get(n)?.getCwd().then(o=>this._proxy.$sendProcessProperty(n,{type:"cwd",value:o}))}$acceptProcessRequestLatency(n){return Promise.resolve(n)}registerLinkProvider(n){return this._linkProviders.add(n),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new S.Disposable(()=>{this._linkProviders.delete(n),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(n,o,m){if(this._profileProviders.has(o))throw new Error(`Terminal profile provider "${o}" already registered`);return this._profileProviders.set(o,m),this._proxy.$registerProfileProvider(o,n.identifier.value),new S.Disposable(()=>{this._profileProviders.delete(o),this._proxy.$unregisterProfileProvider(o)})}async $createContributedProfileTerminal(n,o){const m=new v.CancellationTokenSource().token;let h=await this._profileProviders.get(n)?.provideTerminalProfile(m);if(!m.isCancellationRequested){if(h&&!("options"in h)&&(h={options:h}),!h||!("options"in h))throw new Error(`No terminal profile options provided for id "${n}"`);if("pty"in h.options){this.createExtensionTerminal(h.options,o);return}this.createTerminalFromOptions(h.options,o)}}async $provideLinks(n,o){const m=this._getTerminalById(n);if(!m)return[];this._terminalLinkCache.delete(n);const h=this._terminalLinkCancellationSource.get(n);h&&h.dispose(!0);const w=new v.CancellationTokenSource;this._terminalLinkCancellationSource.set(n,w);const T=[],L={terminal:m.value,line:o},O=[];for(const M of this._linkProviders)O.push(P.Promises.withAsyncBody(async j=>{w.token.onCancellationRequested(()=>j({provider:M,links:[]}));const X=await M.provideTerminalLinks(L,w.token)||[];w.token.isCancellationRequested||j({provider:M,links:X})}));const y=await Promise.all(O);if(w.token.isCancellationRequested)return[];const H=new Map;for(const M of y)M&&M.links.length>0&&T.push(...M.links.map(j=>{const X={id:c++,startIndex:j.startIndex,length:j.length,label:j.tooltip};return H.set(X.id,{provider:M.provider,link:j}),X}));return this._terminalLinkCache.set(n,H),T}$activateLink(n,o){const m=this._terminalLinkCache.get(n)?.get(o);!m||m.provider.handleTerminalLink(m.link)}_onProcessExit(n,o){this._bufferer.stopBuffering(n),this._terminalProcesses.delete(n),delete this._extensionTerminalAwaitingStart[n];const m=this._terminalProcessDisposables[n];m&&(m.dispose(),delete this._terminalProcessDisposables[n]),this._proxy.$sendProcessExit(n,o)}_getTerminalById(n){return this._getTerminalObjectById(this._terminals,n)}_getTerminalObjectById(n,o){const m=this._getTerminalObjectIndexById(n,o);return m!==null?n[m]:null}_getTerminalObjectIndexById(n,o){let m=null;return n.some((h,w)=>h._id===o?(m=w,!0):!1),m}getEnvironmentVariableCollection(n){let o=this._environmentVariableCollections.get(n.identifier.value);return o||(o=new a,this._setEnvironmentVariableCollection(n.identifier.value,o)),o}_syncEnvironmentVariableCollection(n,o){const m=(0,D.serializeEnvironmentVariableCollection)(o.map);this._proxy.$setEnvironmentVariableCollection(n,o.persistent,m.length===0?void 0:m)}$initEnvironmentVariableCollections(n){n.forEach(o=>{const m=o[0],h=new a(o[1]);this._setEnvironmentVariableCollection(m,h)})}$acceptDefaultProfile(n,o){this._defaultProfile=n,this._defaultAutomationProfile=o}_setEnvironmentVariableCollection(n,o){this._environmentVariableCollections.set(n,o),o.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(n,o)})}};u=Be([Fe(1,C.IExtHostRpcService)],u),e.BaseExtHostTerminalService=u;class a{constructor(n){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new f.Emitter,this.map=new Map(n)}get persistent(){return this._persistent}set persistent(n){this._persistent=n,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(n,o){this._setIfDiffers(n,{value:o,type:S.EnvironmentVariableMutatorType.Replace})}append(n,o){this._setIfDiffers(n,{value:o,type:S.EnvironmentVariableMutatorType.Append})}prepend(n,o){this._setIfDiffers(n,{value:o,type:S.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(n,o){const m=this.map.get(n);(!m||m.value!==o.value||m.type!==o.type)&&(this.map.set(n,o),this._onDidChangeCollection.fire())}get(n){return this.map.get(n)}forEach(n,o){this.map.forEach((m,h)=>n.call(o,h,m,this))}delete(n){this.map.delete(n),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=a;let E=class extends u{constructor(n){super(!1,n)}createTerminal(n,o,m){throw new F.NotSupportedError}createTerminalFromOptions(n,o){throw new F.NotSupportedError}};E=Be([Fe(0,C.IExtHostRpcService)],E),e.WorkerExtHostTerminalService=E;function s(r){if(!(!r||typeof r=="string"))return"id"in r?{id:r.id,color:r.color}:r}function t(r){return d.ThemeColor.isThemeColor(r)?r:void 0}});var Xe=this&&this.__classPrivateFieldSet||function(te,e,f,i,I){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!I:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?I.call(te,f):I?I.value=f:e.set(te,f),f},Pe=this&&this.__classPrivateFieldGet||function(te,e,f,i){if(f==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!i:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?i:f==="a"?i.call(te):i?i.value:e.get(te)};define(ve[251],we([1,0,18,22,21,3,74,57,6,25,13,33,5,17,62,14,7,222,84,85]),function(te,e,f,i,I,A,C,k,S,R,F,D,v,b,g,d,p,P,_,l){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let u=class{constructor(L,O){this.resultsChangedEmitter=new A.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=L.getProxy(v.MainContext.MainThreadTesting),this.observer=new m(this.proxy),this.runTracker=new E(this.proxy),O.registerArgumentProcessor({processArgument:y=>y?.$mid===13?d.TestItem.toItemFromContext(y):y})}createTestController(L,O,y){if(this.controllers.has(L))throw new Error(`Attempt to insert a duplicate controller with ID "${L}"`);const H=new S.DisposableStore,M=H.add(new P.SingleUseTestCollection(L));M.root.label=O;const j=new Map,X=this.proxy,$={items:M.root.children,get label(){return O},set label(q){O=q,M.root.label=q,X.$updateController(L,{label:O})},get refreshHandler(){return y},set refreshHandler(q){y=q,X.$updateController(L,{canRefresh:!!q})},get id(){return L},createRunProfile:(q,K,G,ee,oe)=>{let ue=(0,k.hash)(q);for(;j.has(ue);)ue++;const Z=new h(this.proxy,L,ue,q,K,G,ee,oe);return j.set(ue,Z),Z},createTestItem(q,K,G){return new g.TestItemImpl(L,q,K,G)},createTestRun:(q,K,G=!0)=>this.runTracker.createTestRun(L,M,q,K,G),set resolveHandler(q){M.resolveHandler=q},get resolveHandler(){return M.resolveHandler},dispose:()=>{H.dispose()}};X.$registerTestController(L,O,!!y),H.add((0,S.toDisposable)(()=>X.$unregisterTestController(L)));const U={controller:$,collection:M,profiles:j};return this.controllers.set(L,U),H.add((0,S.toDisposable)(()=>this.controllers.delete(L))),H.add(M.onDidGenerateDiff(q=>X.$publishDiff(L,q.map(_.TestsDiffOp.serialize)))),$}createTestObserver(){return this.observer.checkout()}async runTests(L,O=I.CancellationToken.None){const y=s(L);if(!y)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const H=this.controllers.get(y.controllerId);if(!H)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:L.include?.map(M=>M.id)??[H.collection.root.id],profileGroup:w[y.kind],profileId:y.profileId,controllerId:y.controllerId}],exclude:L.exclude?.map(M=>M.id)},O)}$provideFileCoverage(L,O,y){return(0,f.mapFind)(this.runTracker.trackers,M=>M.id===L?M.getCoverage(O):void 0)?.provideFileCoverage(y)??Promise.resolve([])}$resolveFileCoverage(L,O,y,H){return(0,f.mapFind)(this.runTracker.trackers,j=>j.id===L?j.getCoverage(O):void 0)?.resolveFileCoverage(y,H)??Promise.resolve([])}$configureRunProfile(L,O){this.controllers.get(L)?.profiles.get(O)?.configureHandler?.()}async $refreshTests(L,O){await this.controllers.get(L)?.controller.refreshHandler?.(O)}$publishTestResults(L){this.results=Object.freeze(L.map(O=>(0,R.deepFreeze)(d.TestResults.to(O))).concat(this.results).sort((O,y)=>y.completedAt-O.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(L,O){const y=this.controllers.get(l.TestId.fromString(L).controllerId)?.collection;y&&(await y.expand(L,O<0?1/0:O),y.flushDiff())}$acceptDiff(L){this.observer.applyDiff(L.map(_.TestsDiffOp.deserialize))}async $runControllerTests(L,O){const y=this.controllers.get(L.controllerId);if(!y)return;const{collection:H,profiles:M}=y,j=M.get(L.profileId);if(!j)return;const X=L.testIds.map(K=>H.tree.get(K)).filter(F.isDefined),$=L.excludeExtIds.map(K=>y.collection.tree.get(K)).filter(F.isDefined).filter(K=>X.some(G=>G.fullId.compare(K.fullId)===2));if(!X.length)return;const U=new p.TestRunRequest(X.some(K=>K.actual instanceof g.TestItemRootImpl)?void 0:X.map(K=>K.actual),$.map(K=>K.actual),j),q=this.runTracker.prepareForMainThreadTestRun(U,t.fromInternal(L,y.collection),O);try{await j.runHandler(U,O)}finally{q.isRunning&&!O.isCancellationRequested&&await A.Event.toPromise(q.onEnd),q.dispose()}}$cancelExtensionTestRun(L){L===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(L)}};u=Be([Fe(0,b.IExtHostRpcService)],u),e.ExtHostTesting=u;class a extends S.Disposable{constructor(L,O,y){super();this.dto=L,this.proxy=O,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new A.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new I.CancellationTokenSource(y)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:H}of this.tasks.values())H.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(L){return this.tasks.get(L)?.coverage}createRun(L){const O=this.dto.id,y=this.dto.controllerId,H=(0,D.generateUuid)(),M=new r(this.proxy,O,H),j=q=>(K,...G)=>{if($){console.warn(`Setting the state of test "${K.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(K)||(this.ensureTestIsKnown(K),q(K,...G))},X=(q,K)=>{const G=K instanceof Array?K.map(d.TestMessage.from):[d.TestMessage.from(K)];if(q.uri&&q.range){const ee={range:d.Range.from(q.range),uri:q.uri};for(const oe of G)oe.location=oe.location||ee}this.proxy.$appendTestMessagesInRun(O,H,l.TestId.fromExtHostTestItem(q,y).toString(),G)};let $=!1;const U={isPersisted:this.dto.isPersisted,token:this.cts.token,name:L,get coverageProvider(){return M.coverageProvider},set coverageProvider(q){M.coverageProvider=q},enqueued:j(q=>{this.proxy.$updateTestStateInRun(O,H,l.TestId.fromExtHostTestItem(q,y).toString(),1)}),skipped:j(q=>{this.proxy.$updateTestStateInRun(O,H,l.TestId.fromExtHostTestItem(q,y).toString(),5)}),started:j(q=>{this.proxy.$updateTestStateInRun(O,H,l.TestId.fromExtHostTestItem(q,y).toString(),2)}),errored:j((q,K,G)=>{X(q,K),this.proxy.$updateTestStateInRun(O,H,l.TestId.fromExtHostTestItem(q,y).toString(),6,G)}),failed:j((q,K,G)=>{X(q,K),this.proxy.$updateTestStateInRun(O,H,l.TestId.fromExtHostTestItem(q,y).toString(),4,G)}),passed:j((q,K)=>{this.proxy.$updateTestStateInRun(O,H,l.TestId.fromExtHostTestItem(q,this.dto.controllerId).toString(),3,K)}),appendOutput:(q,K,G)=>{$||(G&&(this.dto.isIncluded(G)?this.ensureTestIsKnown(G):G=void 0),this.proxy.$appendOutputToRun(O,H,i.VSBuffer.fromString(q),K&&d.location.from(K),G&&l.TestId.fromExtHostTestItem(G,y).toString()))},end:()=>{$||($=!0,this.proxy.$finishedTestRunTask(O,H),this.tasks.delete(H),this.isRunning||this.dispose())}};return this.tasks.set(H,{run:U,coverage:M}),this.proxy.$startedTestRunTask(O,{id:H,name:L,running:!0}),U}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(L){if(!(L instanceof g.TestItemImpl))throw new g.InvalidTestItemError(L.id);if(this.sharedTestIds.has(l.TestId.fromExtHostTestItem(L,this.dto.controllerId).toString()))return;const O=[],y=this.dto.colllection.root;for(;;){const H=d.TestItem.from(L);if(O.unshift(H),this.sharedTestIds.has(H.extId)||(this.sharedTestIds.add(H.extId),L===y))break;L=L.parent||y}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,O)}}class E{constructor(L){this.proxy=L,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(L,O,y){return this.getTracker(L,O,y)}cancelRunById(L){for(const O of this.tracked.values())if(O.id===L){O.dispose();return}}cancelAllRuns(){for(const L of this.tracked.values())L.dispose()}createTestRun(L,O,y,H,M){const j=this.tracked.get(y);if(j)return j.createRun(H);const X=t.fromPublic(L,O,y,M),$=s(y);this.proxy.$startedExtensionTestRun({controllerId:L,profile:$&&{group:w[$.kind],id:$.profileId},exclude:y.exclude?.map(q=>q.id)??[],id:X.id,include:y.include?.map(q=>q.id)??[O.root.id],persist:M});const U=this.getTracker(y,X);return U.onEnd(()=>this.proxy.$finishedExtensionTestRun(X.id)),U.createRun(H)}getTracker(L,O,y){const H=new a(O,this.proxy,y);return this.tracked.set(L,H),H.onEnd(()=>this.tracked.delete(L)),H}}e.TestRunCoordinator=E;const s=T=>{if(!!T.profile){if(!(T.profile instanceof h))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return T.profile}};class t{constructor(L,O,y,H,M,j){this.controllerId=L,this.id=O,this.isPersisted=M,this.colllection=j,this.includePrefix=y.map(X=>X+"\0"),this.excludePrefix=H.map(X=>X+"\0")}static fromPublic(L,O,y,H){return new t(L,(0,D.generateUuid)(),y.include?.map(M=>l.TestId.fromExtHostTestItem(M,L).toString())??[L],y.exclude?.map(M=>l.TestId.fromExtHostTestItem(M,L).toString())??[],H,O)}static fromInternal(L,O){return new t(L.controllerId,L.runId,L.testIds,L.excludeExtIds,!0,O)}isIncluded(L){const O=l.TestId.fromExtHostTestItem(L,this.controllerId).toString()+"\0";for(const y of this.excludePrefix)if(O===y||O.startsWith(y))return!1;for(const y of this.includePrefix)if(O===y||O.startsWith(y))return!0;return!1}}e.TestRunDto=t;class r{constructor(L,O,y){this.proxy=L,this.runId=O,this.taskId=y}set coverageProvider(L){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!L||(this._coverageProvider=L,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(L){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(L))());try{return(await this.fileCoverage)?.map(d.TestCoverage.fromFile)??[]}catch(O){throw this.fileCoverage=void 0,O}}async resolveFileCoverage(L,O){const y=await this.fileCoverage;let H=y?.[L];return!this._coverageProvider||!y||!H?[]:(H.detailedCoverage||(H=y[L]=await this._coverageProvider.resolveFileCoverage?.(H,O)??H),H.detailedCoverage?.map(d.TestCoverage.fromDetailed)??[])}}class n extends _.IncrementalChangeCollector{constructor(L){super();this.emitter=L,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(L){this.added.add(L)}update(L){Object.assign(L.revived,d.TestItem.toPlain(L.item)),this.added.has(L)||this.updated.add(L)}remove(L){if(this.added.has(L)){this.added.delete(L);return}if(this.updated.delete(L),L.parent&&this.alreadyRemoved.has(L.parent)){this.alreadyRemoved.add(L.item.extId);return}this.removed.add(L)}getChangeEvent(){const{added:L,updated:O,removed:y}=this;return{get added(){return[...L].map(H=>H.revived)},get updated(){return[...O].map(H=>H.revived)},get removed(){return[...y].map(H=>H.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class o extends _.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new A.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(L){return this.items.get(L)}getMirroredTestDataByReference(L){return this.items.get(L.id)}createItem(L,O){return{...L,revived:d.TestItem.toPlain(L.item),depth:O?O.depth+1:0,children:new Set}}createChangeCollector(){return new n(this.changeEmitter)}}e.MirroredTestCollection=o;class m{constructor(L){this.proxy=L}checkout(){this.current||(this.current=this.createObserverData());const L=this.current;return L.observers++,{onDidChangeTest:L.tests.onDidChangeTests,get tests(){return[...L.tests.rootTests].map(O=>O.revived)},dispose:(0,C.once)(()=>{--L.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(L){return this.current?.tests.getMirroredTestDataByReference(L)}applyDiff(L){this.current?.tests.apply(L)}createObserverData(){const L=new o;return this.proxy.$subscribeToDiffs(),{observers:0,tests:L}}}class h{constructor(L,O,y,H,M,j,X=!1,$=void 0){this.controllerId=O,this.profileId=y,this._label=H,this.kind=M,this.runHandler=j,this._isDefault=X,this._tag=$,c.set(this,void 0),Xe(this,c,L,"f");const U=w[M];if(typeof U!="number")throw new Error(`Unknown TestRunProfile.group ${M}`);Pe(this,c,"f").$publishTestRunProfile({profileId:y,controllerId:O,tag:$?d.TestTag.namespace(this.controllerId,$.id):null,label:H,group:U,isDefault:X,hasConfigurationHandler:!1})}get label(){return this._label}set label(L){L!==this._label&&(this._label=L,Pe(this,c,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:L}))}get isDefault(){return this._isDefault}set isDefault(L){L!==this._isDefault&&(this._isDefault=L,Pe(this,c,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:L}))}get tag(){return this._tag}set tag(L){L?.id!==this._tag?.id&&(this._tag=L,Pe(this,c,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:L?d.TestTag.namespace(this.controllerId,L.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(L){L!==this._configureHandler&&(this._configureHandler=L,Pe(this,c,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!L}))}dispose(){Pe(this,c,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=h,c=new WeakMap;const w={[p.TestRunProfileKind.Coverage]:8,[p.TestRunProfileKind.Debug]:4,[p.TestRunProfileKind.Run]:2}}),define(ve[252],we([1,0,3,18,5,131,14,7]),function(te,e,f,i,I,A,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class S{constructor(F,D){this._extHostDocumentsAndEditors=D,this._onDidChangeTextEditorSelection=new f.Emitter,this._onDidChangeTextEditorOptions=new f.Emitter,this._onDidChangeTextEditorVisibleRanges=new f.Emitter,this._onDidChangeTextEditorViewColumn=new f.Emitter,this._onDidChangeActiveTextEditor=new f.Emitter,this._onDidChangeVisibleTextEditors=new f.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=F.getProxy(I.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(v=>this._onDidChangeVisibleTextEditors.fire(v)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(v=>this._onDidChangeActiveTextEditor.fire(v))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(F){const D=this._extHostDocumentsAndEditors.allEditors();return F?D:D.map(v=>v.value)}async showTextDocument(F,D,v){let b;typeof D=="number"?b={position:C.ViewColumn.from(D),preserveFocus:v}:typeof D=="object"?b={position:C.ViewColumn.from(D.viewColumn),preserveFocus:D.preserveFocus,selection:typeof D.selection=="object"?C.Range.from(D.selection):void 0,pinned:typeof D.preview=="boolean"?!D.preview:void 0}:b={preserveFocus:!1};const g=await this._proxy.$tryShowTextDocument(F.uri,b),d=g&&this._extHostDocumentsAndEditors.getEditor(g);if(d)return d.value;throw g?new Error(`Could NOT open editor for "${F.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${F.uri.toString()}".`)}createTextEditorDecorationType(F,D){return new A.TextEditorDecorationType(this._proxy,F,D).value}$acceptEditorPropertiesChanged(F,D){const v=this._extHostDocumentsAndEditors.getEditor(F);if(!v)throw new Error("unknown text editor");if(D.options&&v._acceptOptions(D.options),D.selections){const b=D.selections.selections.map(C.Selection.to);v._acceptSelections(b)}if(D.visibleRanges){const b=i.coalesce(D.visibleRanges.map(C.Range.to));v._acceptVisibleRanges(b)}if(D.options&&this._onDidChangeTextEditorOptions.fire({textEditor:v.value,options:{...D.options,lineNumbers:C.TextEditorLineNumbersStyle.to(D.options.lineNumbers)}}),D.selections){const b=k.TextEditorSelectionChangeKind.fromValue(D.selections.source),g=D.selections.selections.map(C.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:v.value,selections:g,kind:b})}if(D.visibleRanges){const b=i.coalesce(D.visibleRanges.map(C.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:v.value,visibleRanges:b})}}$acceptEditorPositionData(F){for(const D in F){const v=this._extHostDocumentsAndEditors.getEditor(D);if(!v)throw new Error("Unknown text editor");const b=C.ViewColumn.to(F[D]);v.value.viewColumn!==b&&(v._acceptViewColumn(b),this._onDidChangeTextEditorViewColumn.fire({textEditor:v.value,viewColumn:b}))}}getDiffInformation(F){return Promise.resolve(this._proxy.$getDiffInformation(F))}}e.ExtHostEditors=S}),define(ve[253],we([1,0,2,4,5,6,7,14,13]),function(te,e,f,i,I,A,C,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,i.createDecorator)("IExtHostTimeline");class R{constructor(v,b){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=v.getProxy(I.MainContext.MainThreadTimeline),b.registerArgumentProcessor({processArgument:g=>{if(g&&g.$mid===11){const d=g.uri===void 0?void 0:f.URI.revive(g.uri);return this._itemsBySourceAndUriMap.get(g.source)?.get(F(d))?.get(g.handle)}return g}})}async $getTimeline(v,b,g,d,p){return this._providers.get(v)?.provideTimeline(f.URI.revive(b),g,d,p)}registerTimelineProvider(v,b,g,d){const p=new A.DisposableStore,P=this.convertTimelineItem(b.id,d,p).bind(this);let _;b.onDidChange&&(_=b.onDidChange(c=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...c,id:b.id}),this));const l=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...b,scheme:v,onDidChange:void 0,async provideTimeline(c,u,a,E){E?.resetCache&&(p.clear(),l.get(b.id)?.clear());const s=await b.provideTimeline(c,u,a);if(s==null)return;const t=P(c,E);return{...s,source:b.id,items:s.items.map(t)}},dispose(){for(const c of l.values())c.get(b.id)?.clear();_?.dispose(),p.dispose()}})}convertTimelineItem(v,b,g){return(d,p)=>{let P;if(p?.cacheResults){let _=this._itemsBySourceAndUriMap.get(v);_===void 0&&(_=new Map,this._itemsBySourceAndUriMap.set(v,_));const l=F(d);P=_.get(l),P===void 0&&(P=new Map,_.set(l,P))}return _=>{const{iconPath:l,...c}=_,u=`${v}|${_.id??_.timestamp}`;P?.set(u,_);let a,E,s;_.iconPath&&(l instanceof C.ThemeIcon?s={id:l.id,color:l.color}:f.URI.isUri(l)?(a=l,E=l):{light:a,dark:E}=l);let t;return C.MarkdownString.isMarkdownString(c.detail)?t=k.MarkdownString.from(c.detail):(0,S.isString)(c.detail)&&(t=c.detail),{...c,id:c.id??void 0,handle:u,source:v,command:_.command?b.toInternal(_.command,g):void 0,icon:a,iconDark:E,themeIcon:s,detail:t,accessibilityInformation:_.accessibilityInformation}}}}registerTimelineProviderCore(v){if(this._providers.get(v.id))throw new Error(`Timeline Provider ${v.id} already exists.`);return this._proxy.$registerTimelineProvider({id:v.id,label:v.label,scheme:v.scheme}),this._providers.set(v.id,v),(0,A.toDisposable)(()=>{for(const g of this._itemsBySourceAndUriMap.values())g.get(v.id)?.clear();this._providers.delete(v.id),this._proxy.$unregisterTimelineProvider(v.id),v.dispose()})}}e.ExtHostTimeline=R;function F(D){return D?.toString()}}),define(ve[254],we([1,0,6,10,2,5]),function(te,e,f,i,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class C{constructor(S){this._openers=new Map,this._proxy=S.getProxy(A.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(S,R,F,D){if(this._openers.has(R))throw new Error(`Opener with id '${R}' already registered`);const v=D.schemes.find(b=>!C.supportedSchemes.has(b));if(v)throw new Error(`Scheme '${v}' is not supported. Only http and https are currently supported.`);return this._openers.set(R,F),this._proxy.$registerUriOpener(R,D.schemes,S,D.label),(0,f.toDisposable)(()=>{this._openers.delete(R),this._proxy.$unregisterUriOpener(R)})}async $canOpenUri(S,R,F){const D=this._openers.get(S);if(!D)throw new Error(`Unknown opener with id: ${S}`);const v=I.URI.revive(R);return D.canOpenExternalUri(v,F)}async $openUri(S,R,F){const D=this._openers.get(S);if(!D)throw new Error(`Unknown opener id: '${S}'`);return D.openExternalUri(I.URI.revive(R.resolvedUri),{sourceUri:I.URI.revive(R.sourceUri)},F)}}e.ExtHostUriOpeners=C,C.supportedSchemes=new Set([i.Schemas.http,i.Schemas.https])}),define(ve[255],we([1,0,5,2,6,15,27]),function(te,e,f,i,I,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class k{constructor(R){this.handles=new Set,this.handlers=new Map,this._proxy=R.getProxy(f.MainContext.MainThreadUrls)}registerUriHandler(R,F){if(this.handles.has(C.ExtensionIdentifier.toKey(R)))throw new Error(`Protocol handler already registered for extension ${R}`);const D=k.HandlePool++;return this.handles.add(C.ExtensionIdentifier.toKey(R)),this.handlers.set(D,F),this._proxy.$registerUriHandler(D,R),(0,I.toDisposable)(()=>{this.handles.delete(C.ExtensionIdentifier.toKey(R)),this.handlers.delete(D),this._proxy.$unregisterUriHandler(D)})}$handleExternalUri(R,F){const D=this.handlers.get(R);if(!D)return Promise.resolve(void 0);try{D.handleUri(i.URI.revive(F))}catch(v){(0,A.onUnexpectedError)(v)}return Promise.resolve(void 0)}async createAppUri(R){return i.URI.revive(await this._proxy.$createAppUri(R))}}e.ExtHostUrls=k,k.HandlePool=0});var Xe=this&&this.__classPrivateFieldSet||function(te,e,f,i,I){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!I:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?I.call(te,f):I?I.value=f:e.set(te,f),f},Pe=this&&this.__classPrivateFieldGet||function(te,e,f,i){if(f==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!i:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?i:f==="a"?i.call(te):i?i.value:e.get(te)};define(ve[67],we([1,0,3,10,2,183,204,83,5]),function(te,e,f,i,I,A,C,k,S){"use strict";var R,F,D,v,b,g,d,p,P,_,l,c;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class u{constructor(m,h,w,T,L,O,y){R.set(this,void 0),F.set(this,void 0),D.set(this,void 0),v.set(this,void 0),b.set(this,void 0),g.set(this,void 0),d.set(this,""),p.set(this,void 0),P.set(this,!1),_.set(this,!1),l.set(this,!1),this._onMessageEmitter=new f.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,c.set(this,new f.Emitter),this._onDidDispose=Pe(this,c,"f").event,Xe(this,R,m,"f"),Xe(this,F,h,"f"),Xe(this,p,w,"f"),Xe(this,v,T,"f"),Xe(this,b,L,"f"),Xe(this,g,O,"f"),Xe(this,l,a(O),"f"),Xe(this,D,y,"f")}dispose(){Xe(this,P,!0,"f"),Pe(this,c,"f").fire(),Pe(this,c,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(m){return Xe(this,_,!0,"f"),(0,k.asWebviewUri)(m,Pe(this,v,"f").remote)}get cspSource(){const m=Pe(this,g,"f").extensionLocation;if(m.scheme===i.Schemas.https||m.scheme===i.Schemas.http){let h=m.toString();return h.endsWith("/")||(h+="/"),h+" "+k.webviewGenericCspSource}return k.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Pe(this,d,"f")}set html(m){this.assertNotDisposed(),Pe(this,d,"f")!==m&&(Xe(this,d,m,"f"),!Pe(this,_,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(m)&&(Xe(this,_,!0,"f"),Pe(this,D,"f").report("Webview vscode-resource: uris",Pe(this,g,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Pe(this,F,"f").$setHtml(Pe(this,R,"f"),m))}get options(){return this.assertNotDisposed(),Pe(this,p,"f")}set options(m){this.assertNotDisposed(),Pe(this,F,"f").$setOptions(Pe(this,R,"f"),t(Pe(this,g,"f"),Pe(this,b,"f"),m)),Xe(this,p,m,"f")}async postMessage(m){if(Pe(this,P,"f"))return!1;const h=(0,C.serializeWebviewMessage)(m,{serializeBuffersForPostMessage:Pe(this,l,"f")});return Pe(this,F,"f").$postMessage(Pe(this,R,"f"),h.message,...h.buffers)}assertNotDisposed(){if(Pe(this,P,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=u,R=new WeakMap,F=new WeakMap,D=new WeakMap,v=new WeakMap,b=new WeakMap,g=new WeakMap,d=new WeakMap,p=new WeakMap,P=new WeakMap,_=new WeakMap,l=new WeakMap,c=new WeakMap;function a(o){try{const m=(0,A.normalizeVersion)((0,A.parseVersion)(o.engines.vscode));return!!m&&m.majorBase>=1&&m.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=a;class E{constructor(m,h,w,T,L){this.initData=h,this.workspace=w,this._logService=T,this._deprecationService=L,this._webviews=new Map,this._webviewProxy=m.getProxy(S.MainContext.MainThreadWebviews)}$onMessage(m,h,w){const T=this.getWebview(m);if(T){const{message:L}=(0,C.deserializeWebviewMessage)(h,w.value);T._onMessageEmitter.fire(L)}}$onMissingCsp(m,h){this._logService.warn(`${h} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(m,h,w){const T=new u(m,this._webviewProxy,r(h),this.initData,this.workspace,w,this._deprecationService);return this._webviews.set(m,T),T._onDidDispose(()=>{this._webviews.delete(m)}),T}deleteWebview(m){this._webviews.delete(m)}getWebview(m){return this._webviews.get(m)}}e.ExtHostWebviews=E;function s(o){return{id:o.identifier,location:o.extensionLocation}}e.toExtensionData=s;function t(o,m,h){return{enableCommandUris:h.enableCommandUris,enableScripts:h.enableScripts,enableForms:h.enableForms,portMapping:h.portMapping,localResourceRoots:h.localResourceRoots||n(o,m)}}e.serializeWebviewOptions=t;function r(o){return{enableCommandUris:o.enableCommandUris,enableScripts:o.enableScripts,enableForms:o.enableForms,portMapping:o.portMapping,localResourceRoots:o.localResourceRoots?.map(m=>I.URI.from(m))}}e.reviveOptions=r;function n(o,m){return[...(m?.getWorkspaceFolders()||[]).map(h=>h.uri),o.extensionLocation]}}),define(ve[256],we([1,0,21,57,6,10,23,2,14,67,82,5,7]),function(te,e,f,i,I,A,C,k,S,R,F,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class b{constructor(a,E){this.document=a,this._storagePath=E,this._backupCounter=1,this._edits=new F.Cache("custom documents")}addEdit(a){return this._edits.add([a])}async undo(a,E){await this.getEdit(a).undo(),E||this.disposeBackup()}async redo(a,E){await this.getEdit(a).redo(),E||this.disposeBackup()}disposeEdits(a){for(const E of a)this._edits.delete(E)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const a=c(this.document.uri)+this._backupCounter++;return(0,C.joinPath)(this._storagePath,a)}updateBackup(a){this._backup?.delete(),this._backup=a}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(a){const E=this._edits.get(a,0);if(!E)throw new Error("No edit found");return E}}class g{constructor(){this._documents=new Map}get(a,E){return this._documents.get(this.key(a,E))}add(a,E,s){const t=this.key(a,E.uri);if(this._documents.has(t))throw new Error(`Document already exists for viewType:${a} resource:${E.uri}`);const r=new b(E,s);return this._documents.set(t,r),r}delete(a,E){const s=this.key(a,E.uri);this._documents.delete(s)}key(a,E){return`${a}@@@${E}`}}var d;(function(u){u[u.Text=0]="Text",u[u.Custom=1]="Custom"})(d||(d={}));class p{constructor(){this._providers=new Map}addTextProvider(a,E,s){return this.add(0,a,E,s)}addCustomProvider(a,E,s){return this.add(1,a,E,s)}get(a){return this._providers.get(a)}add(a,E,s,t){if(this._providers.has(E))throw new Error(`Provider for viewType:${E} already registered`);return this._providers.set(E,{type:a,extension:s,provider:t}),new v.Disposable(()=>this._providers.delete(E))}}class P{constructor(a,E,s,t,r){this._extHostDocuments=E,this._extensionStoragePaths=s,this._extHostWebview=t,this._extHostWebviewPanels=r,this._editorProviders=new p,this._documents=new g,this._proxy=a.getProxy(D.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(a,E,s,t){const r=new I.DisposableStore;return _(s)?(r.add(this._editorProviders.addTextProvider(E,a,s)),this._proxy.$registerTextEditorProvider((0,R.toExtensionData)(a),E,t.webviewOptions||{},{supportsMove:!!s.moveCustomTextEditor},(0,R.shouldSerializeBuffersForPostMessage)(a))):(r.add(this._editorProviders.addCustomProvider(E,a,s)),this.supportEditing(s)&&r.add(s.onDidChangeCustomDocument(n=>{const o=this.getCustomDocumentEntry(E,n.document.uri);if(l(n)){const m=o.addEdit(n);this._proxy.$onDidEdit(n.document.uri,E,m,n.label)}else this._proxy.$onContentChange(n.document.uri,E)})),this._proxy.$registerCustomEditorProvider((0,R.toExtensionData)(a),E,t.webviewOptions||{},!!t.supportsMultipleEditorsPerDocument,(0,R.shouldSerializeBuffersForPostMessage)(a))),v.Disposable.from(r,new v.Disposable(()=>{this._proxy.$unregisterEditorProvider(E)}))}async $createCustomDocument(a,E,s,t,r){const n=this._editorProviders.get(E);if(!n)throw new Error(`No provider found for '${E}'`);if(n.type!==1)throw new Error(`Invalid provide type for '${E}'`);const o=k.URI.revive(a),m=await n.provider.openCustomDocument(o,{backupId:s,untitledDocumentData:t?.buffer},r);let h;return this.supportEditing(n.provider)&&this._extensionStoragePaths&&(h=this._extensionStoragePaths.workspaceValue(n.extension)??this._extensionStoragePaths.globalValue(n.extension)),this._documents.add(E,m,h),{editable:this.supportEditing(n.provider)}}async $disposeCustomDocument(a,E){const s=this._editorProviders.get(E);if(!s)throw new Error(`No provider found for '${E}'`);if(s.type!==1)throw new Error(`Invalid provider type for '${E}'`);const t=k.URI.revive(a),{document:r}=this.getCustomDocumentEntry(E,t);this._documents.delete(E,r),r.dispose()}async $resolveWebviewEditor(a,E,s,t,r,n){const o=this._editorProviders.get(s);if(!o)throw new Error(`No provider found for '${s}'`);const m=S.ViewColumn.to(r),h=this._extHostWebview.createNewWebview(E,t.webviewOptions,o.extension),w=this._extHostWebviewPanels.createNewWebviewPanel(E,s,t.title,m,t.panelOptions,h),T=k.URI.revive(a);switch(o.type){case 1:{const{document:L}=this.getCustomDocumentEntry(s,T);return o.provider.resolveCustomEditor(L,w,n)}case 0:{const L=this._extHostDocuments.getDocument(T);return o.provider.resolveCustomTextEditor(L,w,n)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(a,E,s){this.getCustomDocumentEntry(E,a).disposeEdits(s)}async $onMoveCustomEditor(a,E,s){const t=this._editorProviders.get(s);if(!t)throw new Error(`No provider found for '${s}'`);if(!t.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${s}'`);const r=this._extHostWebviewPanels.getWebviewPanel(a);if(!r)throw new Error("No webview found");const n=k.URI.revive(E),o=this._extHostDocuments.getDocument(n);await t.provider.moveCustomTextEditor(o,r,f.CancellationToken.None)}async $undo(a,E,s,t){return this.getCustomDocumentEntry(E,a).undo(s,t)}async $redo(a,E,s,t){return this.getCustomDocumentEntry(E,a).redo(s,t)}async $revert(a,E,s){const t=this.getCustomDocumentEntry(E,a);await this.getCustomEditorProvider(E).revertCustomDocument(t.document,s),t.disposeBackup()}async $onSave(a,E,s){const t=this.getCustomDocumentEntry(E,a);await this.getCustomEditorProvider(E).saveCustomDocument(t.document,s),t.disposeBackup()}async $onSaveAs(a,E,s,t){const r=this.getCustomDocumentEntry(E,a);return this.getCustomEditorProvider(E).saveCustomDocumentAs(r.document,k.URI.revive(s),t)}async $backup(a,E,s){const t=this.getCustomDocumentEntry(E,a),n=await this.getCustomEditorProvider(E).backupCustomDocument(t.document,{destination:t.getNewBackupUri()},s);return t.updateBackup(n),n.id}getCustomDocumentEntry(a,E){const s=this._documents.get(a,k.URI.revive(E));if(!s)throw new Error("No custom document found");return s}getCustomEditorProvider(a){const s=this._editorProviders.get(a)?.provider;if(!s||!this.supportEditing(s))throw new Error("Custom document is not editable");return s}supportEditing(a){return!!a.onDidChangeCustomDocument}}e.ExtHostCustomEditors=P;function _(u){return typeof u.resolveCustomTextEditor=="function"}function l(u){return typeof u.undo=="function"&&typeof u.redo=="function"}function c(u){const a=u.scheme===A.Schemas.file||u.scheme===A.Schemas.untitled?u.fsPath:u.toString();return(0,i.hash)(a)+""}});var Xe=this&&this.__classPrivateFieldSet||function(te,e,f,i,I){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!I:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?I.call(te,f):I?I.value=f:e.set(te,f),f},Pe=this&&this.__classPrivateFieldGet||function(te,e,f,i){if(f==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!i:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?i:f==="a"?i.call(te):i?i.value:e.get(te)};define(ve[257],we([1,0,3,6,2,33,14,67,5,7]),function(te,e,f,i,I,A,C,k,S,R){"use strict";var F,D,v,b,g,d,p,P,_,l,c,u,a;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class E extends i.Disposable{constructor(n,o,m,h,w,T,L){super();F.set(this,void 0),D.set(this,void 0),v.set(this,void 0),b.set(this,void 0),g.set(this,void 0),d.set(this,void 0),p.set(this,void 0),P.set(this,void 0),_.set(this,!0),l.set(this,!0),c.set(this,!1),u.set(this,this._register(new f.Emitter)),this.onDidDispose=Pe(this,u,"f").event,a.set(this,this._register(new f.Emitter)),this.onDidChangeViewState=Pe(this,a,"f").event,Xe(this,F,n,"f"),Xe(this,D,o,"f"),Xe(this,v,m,"f"),Xe(this,g,T,"f"),Xe(this,P,w,"f"),Xe(this,d,h,"f"),Xe(this,b,L,"f")}dispose(){Pe(this,c,"f")||(Xe(this,c,!0,"f"),Pe(this,u,"f").fire(),Pe(this,D,"f").$disposeWebview(Pe(this,F,"f")),Pe(this,b,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Pe(this,b,"f")}get viewType(){return this.assertNotDisposed(),Pe(this,v,"f")}get title(){return this.assertNotDisposed(),Pe(this,d,"f")}set title(n){this.assertNotDisposed(),Pe(this,d,"f")!==n&&(Xe(this,d,n,"f"),Pe(this,D,"f").$setTitle(Pe(this,F,"f"),n))}get iconPath(){return this.assertNotDisposed(),Pe(this,p,"f")}set iconPath(n){this.assertNotDisposed(),Pe(this,p,"f")!==n&&(Xe(this,p,n,"f"),Pe(this,D,"f").$setIconPath(Pe(this,F,"f"),I.URI.isUri(n)?{light:n,dark:n}:n))}get options(){return Pe(this,g,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Pe(this,P,"f")=="number"&&Pe(this,P,"f")<0))return Pe(this,P,"f")}get active(){return this.assertNotDisposed(),Pe(this,l,"f")}get visible(){return this.assertNotDisposed(),Pe(this,_,"f")}_updateViewState(n){Pe(this,c,"f")||(this.active!==n.active||this.visible!==n.visible||this.viewColumn!==n.viewColumn)&&(Xe(this,l,n.active,"f"),Xe(this,_,n.visible,"f"),Xe(this,P,n.viewColumn,"f"),Pe(this,a,"f").fire({webviewPanel:this}))}reveal(n,o){this.assertNotDisposed(),Pe(this,D,"f").$reveal(Pe(this,F,"f"),{viewColumn:typeof n=="undefined"?void 0:C.ViewColumn.from(n),preserveFocus:!!o})}assertNotDisposed(){if(Pe(this,c,"f"))throw new Error("Webview is disposed")}}F=new WeakMap,D=new WeakMap,v=new WeakMap,b=new WeakMap,g=new WeakMap,d=new WeakMap,p=new WeakMap,P=new WeakMap,_=new WeakMap,l=new WeakMap,c=new WeakMap,u=new WeakMap,a=new WeakMap;class s{constructor(n,o,m){this.webviews=o,this.workspace=m,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=n.getProxy(S.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,A.generateUuid)()}createWebviewPanel(n,o,m,h,w={}){const T=typeof h=="object"?h.viewColumn:h,L={viewColumn:C.ViewColumn.from(T),preserveFocus:typeof h=="object"&&!!h.preserveFocus},O=(0,k.shouldSerializeBuffersForPostMessage)(n),y=s.newHandle();this._proxy.$createWebviewPanel((0,k.toExtensionData)(n),y,o,{title:m,panelOptions:t(w),webviewOptions:(0,k.serializeWebviewOptions)(n,this.workspace,w),serializeBuffersForPostMessage:O},L);const H=this.webviews.createNewWebview(y,w,n);return this.createNewWebviewPanel(y,o,m,T,w,H)}$onDidChangeWebviewPanelViewStates(n){const o=Object.keys(n);o.sort((m,h)=>{const w=n[m],T=n[h];return w.active?1:T.active?-1:+w.visible-+T.visible});for(const m of o){const h=this.getWebviewPanel(m);if(!h)continue;const w=n[m];h._updateViewState({active:w.active,visible:w.visible,viewColumn:C.ViewColumn.to(w.position)})}}async $onDidDisposeWebviewPanel(n){this.getWebviewPanel(n)?.dispose(),this._webviewPanels.delete(n),this.webviews.deleteWebview(n)}registerWebviewPanelSerializer(n,o,m){if(this._serializers.has(o))throw new Error(`Serializer for '${o}' already registered`);return this._serializers.set(o,{serializer:m,extension:n}),this._proxy.$registerSerializer(o,{serializeBuffersForPostMessage:(0,k.shouldSerializeBuffersForPostMessage)(n)}),new R.Disposable(()=>{this._serializers.delete(o),this._proxy.$unregisterSerializer(o)})}async $deserializeWebviewPanel(n,o,m,h){const w=this._serializers.get(o);if(!w)throw new Error(`No serializer found for '${o}'`);const{serializer:T,extension:L}=w,O=this.webviews.createNewWebview(n,m.webviewOptions,L),y=this.createNewWebviewPanel(n,o,m.title,h,m.panelOptions,O);await T.deserializeWebviewPanel(y,m.state)}createNewWebviewPanel(n,o,m,h,w,T){const L=new E(n,this._proxy,o,m,h,w,T);return this._webviewPanels.set(n,L),L}getWebviewPanel(n){return this._webviewPanels.get(n)}}e.ExtHostWebviewPanels=s;function t(r){return{enableFindWidget:r.enableFindWidget,retainContextWhenHidden:r.retainContextWhenHidden}}});var Xe=this&&this.__classPrivateFieldSet||function(te,e,f,i,I){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!I:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?I.call(te,f):I?I.value=f:e.set(te,f),f},Pe=this&&this.__classPrivateFieldGet||function(te,e,f,i){if(f==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!i:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?i:f==="a"?i.call(te):i?i.value:e.get(te)};define(ve[258],we([1,0,3,6,67,5,7]),function(te,e,f,i,I,A,C){"use strict";var k,S,R,F,D,v,b,g,d,p;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class P extends i.Disposable{constructor(c,u,a,E,s,t){super();k.set(this,void 0),S.set(this,void 0),R.set(this,void 0),F.set(this,void 0),D.set(this,!1),v.set(this,void 0),b.set(this,void 0),g.set(this,void 0),d.set(this,this._register(new f.Emitter)),this.onDidChangeVisibility=Pe(this,d,"f").event,p.set(this,this._register(new f.Emitter)),this.onDidDispose=Pe(this,p,"f").event,Xe(this,R,a,"f"),Xe(this,b,E,"f"),Xe(this,k,c,"f"),Xe(this,S,u,"f"),Xe(this,F,s,"f"),Xe(this,v,t,"f")}dispose(){Pe(this,D,"f")||(Xe(this,D,!0,"f"),Pe(this,p,"f").fire(),Pe(this,F,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Pe(this,b,"f")}set title(c){this.assertNotDisposed(),Pe(this,b,"f")!==c&&(Xe(this,b,c,"f"),Pe(this,S,"f").$setWebviewViewTitle(Pe(this,k,"f"),c))}get description(){return this.assertNotDisposed(),Pe(this,g,"f")}set description(c){this.assertNotDisposed(),Pe(this,g,"f")!==c&&(Xe(this,g,c,"f"),Pe(this,S,"f").$setWebviewViewDescription(Pe(this,k,"f"),c))}get visible(){return Pe(this,v,"f")}get webview(){return Pe(this,F,"f")}get viewType(){return Pe(this,R,"f")}_setVisible(c){c===Pe(this,v,"f")||Pe(this,D,"f")||(Xe(this,v,c,"f"),Pe(this,d,"f").fire())}show(c){this.assertNotDisposed(),Pe(this,S,"f").$show(Pe(this,k,"f"),!!c)}assertNotDisposed(){if(Pe(this,D,"f"))throw new Error("Webview is disposed")}}k=new WeakMap,S=new WeakMap,R=new WeakMap,F=new WeakMap,D=new WeakMap,v=new WeakMap,b=new WeakMap,g=new WeakMap,d=new WeakMap,p=new WeakMap;class _{constructor(c,u){this._extHostWebview=u,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=c.getProxy(A.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(c,u,a,E){if(this._viewProviders.has(u))throw new Error(`View provider for '${u}' already registered`);return this._viewProviders.set(u,{provider:a,extension:c}),this._proxy.$registerWebviewViewProvider((0,I.toExtensionData)(c),u,{retainContextWhenHidden:E?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new C.Disposable(()=>{this._viewProviders.delete(u),this._proxy.$unregisterWebviewViewProvider(u)})}async $resolveWebviewView(c,u,a,E,s){const t=this._viewProviders.get(u);if(!t)throw new Error(`No view provider found for '${u}'`);const{provider:r,extension:n}=t,o=this._extHostWebview.createNewWebview(c,{},n),m=new P(c,this._proxy,u,a,o,!0);this._webviewViews.set(c,m),await r.resolveWebviewView(m,{state:E},s)}async $onDidChangeWebviewViewVisibility(c,u){this.getWebviewView(c)._setVisible(u)}async $disposeWebviewView(c){const u=this.getWebviewView(c);this._webviewViews.delete(c),u.dispose(),this._extHostWebview.deleteWebview(c)}getWebviewView(c){const u=this._webviewViews.get(c);if(!u)throw new Error("No webview found");return u}}e.ExtHostWebviewViews=_}),define(ve[136],we([1,0,3,5,2,10,8,4,17]),function(te,e,f,i,I,A,C,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let R=class ji{constructor(D){this._onDidChangeWindowState=new f.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=ji.InitialState,this._proxy=D.getProxy(i.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(v=>this.$onDidChangeWindowFocus(v))}get state(){return this._state}$onDidChangeWindowFocus(D){D!==this._state.focused&&(this._state={...this._state,focused:D},this._onDidChangeWindowState.fire(this._state))}openUri(D,v){let b;if(typeof D=="string"){b=D;try{D=I.URI.parse(D)}catch{return Promise.reject(`Invalid uri - '${D}'`)}}return(0,C.isFalsyOrWhitespace)(D.scheme)?Promise.reject("Invalid scheme - cannot be empty"):D.scheme===A.Schemas.command?Promise.reject(`Invalid scheme '${D.scheme}'`):this._proxy.$openUri(D,b,v)}async asExternalUri(D,v){if((0,C.isFalsyOrWhitespace)(D.scheme))return Promise.reject("Invalid scheme - cannot be empty");const b=await this._proxy.$asExternalUri(D,v);return I.URI.from(b)}};R.InitialState={focused:!0},R=Be([Fe(0,S.IExtHostRpcService)],R),e.ExtHostWindow=R,e.IExtHostWindow=(0,k.createDecorator)("IExtHostWindow")}),define(ve[259],we([1,0,9,60,33,39,6,5,2,17]),function(te,e,f,i,I,A,C,k,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let F=class extends C.Disposable{constructor(v,b){super();const g=v.getProxy(k.MainContext.MainThreadDownloadService);b.registerCommand(!1,"_workbench.downloadResource",async d=>{const p=S.URI.file((0,f.join)((0,i.tmpdir)(),(0,I.generateUuid)()));return await g.$download(d,p),p})}};F=Be([Fe(0,R.IExtHostRpcService),Fe(1,A.IExtHostCommands)],F),e.ExtHostDownloadService=F}),define(ve[260],we([1,0,134,10,189,33]),function(te,e,f,i,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class C extends f.ExtHostLoggerService{doCreateLogger(S,R,F){return S.scheme===i.Schemas.file?new I.SpdLogLogger(F?.name||(0,A.generateUuid)(),S.fsPath,!F?.donotRotate,!!F?.donotUseFormatters,R):super.doCreateLogger(S,R,F)}}e.ExtHostLoggerService=C}),define(ve[261],we([1,0,59,9,2,66,6,10,16,28]),function(te,e,f,i,I,A,C,k,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class F extends A.ExtensionStoragePaths{constructor(){super(...arguments);this._workspaceStorageLock=null}async _getWorkspaceStorageURI(a){const E=await super._getWorkspaceStorageURI(a);if(E.scheme!==k.Schemas.file)return E;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${E.fsPath}.`),E;const s=E.fsPath;let t=0;do{let r;t===0?r=s:r=/[/\\]$/.test(s)?`${s.substr(0,s.length-1)}-${t}`:`${s}-${t}`,await D(r);const n=i.join(r,"vscode.lock"),o=await d(this._logService,n,!1);if(o)return this._workspaceStorageLock=o,process.on("exit",()=>{o.dispose()}),I.URI.file(r);t++}while(t<10);return E}onWillDeactivateAll(){this._workspaceStorageLock&&this._workspaceStorageLock.setWillRelease(6e3)}}e.ExtensionStoragePaths=F;async function D(u){try{await R.Promises.stat(u);return}catch{}try{await R.Promises.mkdir(u,{recursive:!0})}catch{}}const v=1e3,b=10*60*1e3;class g extends C.Disposable{constructor(a,E){super();this.logService=a,this.filename=E,this._timer=this._register(new S.IntervalTimer),this._timer.cancelAndSet(async()=>{const s=await p(a,E);(!s||s.pid!==process.pid)&&(a.info(`Lock '${E}': The lock was lost unexpectedly.`),this._timer.cancel());try{await R.Promises.utimes(E,new Date,new Date)}catch(t){a.error(t),a.info(`Lock '${E}': Could not update mtime.`)}},v)}dispose(){super.dispose();try{f.unlinkSync(this.filename)}catch{}}async setWillRelease(a){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${a} ms.`);try{const E={pid:process.pid,willReleaseAt:Date.now()+a};await R.Promises.writeFile(this.filename,JSON.stringify(E),{flag:"w"})}catch(E){this.logService.error(E)}}}async function d(u,a,E){try{const t={pid:process.pid,willReleaseAt:0};await R.Promises.writeFile(a,JSON.stringify(t),{flag:"wx"})}catch(t){u.error(t)}const s=await p(u,a);return!s||s.pid!==process.pid?E?(u.info(`Lock '${a}': Could not acquire lock, giving up.`),null):(u.info(`Lock '${a}': Could not acquire lock, checking if the file is stale.`),l(u,a)):(u.info(`Lock '${a}': Lock acquired.`),new g(u,a))}async function p(u,a){let E;try{E=await R.Promises.readFile(a)}catch(s){return u.error(s),null}try{return JSON.parse(String(E))}catch(s){return u.error(s),null}}async function P(u,a){let E;try{E=await R.Promises.stat(a)}catch(s){return u.error(s),0}return E.mtime.getTime()}function _(u){try{return process.kill(u,0),!0}catch{return!1}}async function l(u,a){const E=await p(u,a);if(!E)return u.info(`Lock '${a}': Could not read pid of lock holder.`),c(u,a);if(E.willReleaseAt){let o=E.willReleaseAt-Date.now();if(o<5e3){for(o>0?u.info(`Lock '${a}': The lockfile is scheduled to be released in ${o} ms.`):u.info(`Lock '${a}': The lockfile is scheduled to have been released.`);o>0;){if(await(0,S.timeout)(Math.min(100,o)),await P(u,a)===0)return c(u,a);o=E.willReleaseAt-Date.now()}return c(u,a)}}if(!_(E.pid))return u.info(`Lock '${a}': The pid ${E.pid} appears to be gone.`),c(u,a);const s=await P(u,a),t=Date.now()-s;if(t<=b)return u.info(`Lock '${a}': The lock does not look stale, elapsed: ${t} ms, giving up.`),null;u.info(`Lock '${a}': The lock looks stale, waiting for 2s.`),await(0,S.timeout)(2e3);const r=await P(u,a),n=Date.now()-r;return n<=b?(u.info(`Lock '${a}': The lock does not look stale, elapsed: ${n} ms, giving up.`),null):(u.info(`Lock '${a}': The lock looks stale even after waiting for 2s.`),c(u,a))}async function c(u,a){u.info(`Lock '${a}': Deleting a stale lock.`);try{await R.Promises.unlink(a)}catch{}return d(u,a,!0)}}),define(ve[262],we([1,0,33,17,34]),function(te,e,f,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let A=class extends I.BaseExtHostTerminalService{constructor(k){super(!0,k)}createTerminal(k,S,R){return this.createTerminalFromOptions({name:k,shellPath:S,shellArgs:R})}createTerminalFromOptions(k,S){const R=new I.ExtHostTerminal(this._proxy,(0,f.generateUuid)(),k,k.name);return this._terminals.push(R),R.create(k,this._serializeParentTerminal(k,S)),R.value}};A=Be([Fe(0,i.IExtHostRpcService)],A),e.ExtHostTerminalService=A}),define(ve[263],we([1,0,5,17,174,6,26,2,38,23,28,7,12,51,3,123,91,11]),function(te,e,f,i,I,A,C,k,S,R,F,D,v,b,g,d,p,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class _{constructor(m,h,w){this.remoteAddress=m,this.localAddress=h,this._dispose=w,this._onDispose=new g.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function l(o){const m=o.trim().split(`
`),h=[];return m.forEach(T=>{const L=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(T);L&&L.length>=3&&h.push({pid:parseInt(L[1],10),socket:parseInt(L[2],10)})}),h.reduce((T,L)=>(T[L.socket]=L,T),{})}e.getSockets=l;function c(...o){const m=[].concat(...o.map(a));return[...new Map(m.filter(h=>h.st==="0A").map(h=>{const w=h.local_address.split(":");return{socket:parseInt(h.inode,10),ip:u(w[0]),port:parseInt(w[1],16)}}).map(h=>[h.ip+":"+h.port,h])).values()]}e.loadListeningPorts=c;function u(o){let m="";if(o.length===8)for(let h=o.length-2;h>=0;h-=2)m+=parseInt(o.substr(h,2),16),h!==0&&(m+=".");else for(let h=o.length-4;h>=0;h-=4)m+=parseInt(o.substr(h,4),16).toString(16),h!==0&&(m+=":");return m}e.parseIpAddress=u;function a(o){const m=o.trim().split(`
`),h=m.shift().trim().split(/\s+/).filter(T=>T!=="rx_queue"&&T!=="tm->when");return m.map(T=>T.trim().split(/\s+/).reduce((L,O,y)=>(L[h[y]||y]=O,L),{}))}e.loadConnectionTable=a;function E(o){return!!o.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||o.indexOf("out/server-main.js")!==-1||o.indexOf("_productName=VSCode")!==-1}function s(o){const m=o.trim().split(`
`),h=[];return m.forEach(w=>{const T=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(w);T&&T.length>=4&&h.push({pid:parseInt(T[1],10),ppid:parseInt(T[2]),cmd:T[3]})}),h}e.getRootProcesses=s;async function t(o,m,h){const w=h.reduce((L,O)=>(L[O.pid]=O,L),{}),T=[];return o.forEach(({socket:L,ip:O,port:y})=>{const H=m[L]?m[L].pid:void 0,M=H?w[H]?.cmd:void 0;H&&M&&!E(M)&&T.push({host:O,port:y,detail:M,pid:H})}),T}e.findPorts=t;function r(o,m,h){const w=new Map,T=s(m);for(const L of o){const O=h.get(L.port);if(O){w.set(L.port,O);continue}const y=T.find(H=>H.cmd.includes(`${L.port}`));if(y){let H=y,M;do M=T.find(j=>j.ppid===H.pid),M&&(H=M);while(M);w.set(L.port,{host:L.ip,port:L.port,pid:H.pid,detail:H.cmd,ppid:H.ppid})}else w.set(L.port,{host:L.ip,port:L.port,ppid:Number.MAX_VALUE})}return w}e.tryFindRootPorts=r;let n=class extends A.Disposable{constructor(m,h,w){super();this.logService=w,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new g.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=m.getProxy(f.MainContext.MainThreadTunnelService),v.isLinux&&h.remote.isRemote&&h.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(m,h){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${m.identifier.value} called openTunnel API for ${h.remoteAddress.host}:${h.remoteAddress.port}.`);const w=await this._proxy.$openTunnel(h,m.displayName);if(w){const T=new _(w.remoteAddress,w.localAddress,()=>this._proxy.$closeTunnel(w.remoteAddress));return this._register(T),T}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(m){return Math.max(m*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(m,h){const w=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(w,{selector:m,provider:h}),this._proxy.$registerPortsAttributesProvider(m,w),new D.Disposable(()=>{this._portAttributesProviders.delete(w),this._proxy.$unregisterPortsAttributesProvider(w)})}async $providePortAttributes(m,h,w,T,L){const O=[];for(const H of m){const M=this._portAttributesProviders.get(H);if(!M)return[];O.push(...await Promise.all(h.map(async j=>M.provider.providePortAttributes(j,w,T,L))))}const y=O.filter(H=>!!H);return y.length>0?y.map(H=>({autoForwardAction:H.autoForwardAction,port:H.port})):[]}async $registerCandidateFinder(m){if(m&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=m;let h=new p.MovingAverage,w;for(;this._candidateFindingEnabled;){const T=new Date().getTime(),L=(await this.findCandidatePorts()).filter(y=>(0,d.isLocalhost)(y.host)||(0,d.isAllInterfaces)(y.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${L.map(y=>y.port).join(", ")}`);const O=new Date().getTime()-T;h.update(O),(!w||JSON.stringify(w)!==JSON.stringify(L))&&(w=L,await this._proxy.$onFoundNewCandidates(w)),await new Promise(y=>setTimeout(()=>y(),this.calculateDelay(h.value)))}}async setTunnelFactory(m){if(m){if(m.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(m.candidatePortSource),m.showCandidatePort&&(this._showCandidatePort=m.showCandidatePort,this._proxy.$setCandidateFilter()),m.tunnelFactory){this._forwardPortProvider=m.tunnelFactory;let h=m.tunnelFeatures?.privacyOptions??[];m.tunnelFeatures?.public&&h.length===0&&(h=[{id:"private",label:I.localize(0,null),themeIcon:"lock"},{id:"public",label:I.localize(1,null),themeIcon:"eye"}]);const w=m.tunnelFeatures?{elevation:!!m.tunnelFeatures?.elevation,public:!!m.tunnelFeatures?.public,privacyOptions:h}:void 0;this._proxy.$setTunnelProvider(w)}}else this._forwardPortProvider=void 0;return(0,A.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(m,h){if(this._extensionTunnels.has(m.host)){const w=this._extensionTunnels.get(m.host);w.has(m.port)&&(h&&w.get(m.port).disposeListener.dispose(),await w.get(m.port).tunnel.dispose(),w.delete(m.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(m,h){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const w=this._forwardPortProvider(m,h);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),w!==void 0){const T=await w;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(m.remoteAddress.host)||this._extensionTunnels.set(m.remoteAddress.host,new Map);const L=this._register(T.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(T.remoteAddress))));return this._extensionTunnels.get(m.remoteAddress.host).set(m.remoteAddress.port,{tunnel:T,disposeListener:L}),b.TunnelDtoConverter.fromApiTunnel(T)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(m){const h=await Promise.all(m.map(T=>this._showCandidatePort(T.host,T.port,T.detail??""))),w=m.filter((T,L)=>h[L]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${m.map(T=>T.port).join(", ")} to ${w.map(T=>T.port).join(", ")}`),w}async findCandidatePorts(){let m="",h="";try{m=await F.Promises.readFile("/proc/net/tcp","utf8"),h=await F.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const w=c(m,h),T=await new Promise($=>{(0,S.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(U,q,K)=>{$(q)})}),L=l(T),O=await F.Promises.readdir("/proc"),y=[];for(let $ of O)try{const U=Number($),q=R.joinPath(k.URI.file("/proc"),$);if((await F.Promises.stat(q.fsPath)).isDirectory()&&!isNaN(U)){const G=await F.Promises.readlink(R.joinPath(q,"cwd").fsPath),ee=await F.Promises.readFile(R.joinPath(q,"cmdline").fsPath,"utf8");y.push({pid:U,cwd:G,cmd:ee})}}catch{}const H=[],M=w.filter($=>{const U=L[$.socket];return U||H.push($),U}),j=t(M,L,y);let X;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${H.length}`),H.length>0){const $=await new Promise(U=>{(0,S.exec)("ps -F -A -l | grep root",(q,K,G)=>{U(K)})});this._foundRootPorts=r(H,$,this._foundRootPorts),X=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${X.join(", ")}`)}return j.then($=>X?$.concat(X):$)}};n=Be([Fe(0,i.IExtHostRpcService),Fe(1,C.IExtHostInitDataService),Fe(2,P.ILogService)],n),e.ExtHostTunnelService=n}),define(ve[264],we([1,0,16,22,21,15,3,6,101,227,52]),function(te,e,f,i,I,A,C,k,S,R,F){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function v(w,T){try{return JSON.stringify(w,T)}catch{return"null"}}const b="$$ref$$",g={[b]:-1};class d{constructor(T,L){this.jsonString=T,this.referencedBuffers=L}}function p(w,T=null,L=!1){const O=[];return{jsonString:(L?v:JSON.stringify)(w,(H,M)=>{if(typeof M=="undefined")return g;if(typeof M=="object"){if(M instanceof i.VSBuffer){const j=O.push(M)-1;return{[b]:j}}if(T)return T(H,M)}return M}),referencedBuffers:O}}e.stringifyJsonWithBufferRefs=p;function P(w,T,L){return JSON.parse(w,(O,y)=>{if(y){const H=y[b];if(typeof H=="number")return T[H];if(L&&y.$mid===1)return L.transformIncoming(y)}return y})}e.parseJsonAndRestoreBufferRefs=P;function _(w,T){return JSON.stringify(w,T)}function l(w){return w?(T,L)=>L&&L.$mid===1?w.transformOutgoing(L):L:null}var c;(function(w){w[w.LocalSide=0]="LocalSide",w[w.OtherSide=1]="OtherSide"})(c=e.RequestInitiator||(e.RequestInitiator={}));var u;(function(w){w[w.Responsive=0]="Responsive",w[w.Unresponsive=1]="Unresponsive"})(u=e.ResponsiveState||(e.ResponsiveState={}));const a=()=>{},E=Symbol.for("rpcProtocol"),s=Symbol.for("rpcProxy");class t extends k.Disposable{constructor(T,L=null,O=null){super();this[D]=!0,this._onDidChangeResponsiveState=this._register(new C.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=T,this._logger=L,this._uriTransformer=O,this._uriReplacer=l(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let y=0,H=F.ProxyIdentifier.count;y<H;y++)this._locals[y]=null,this._proxies[y]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new f.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(y=>this._receiveOneMessage(y))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(T=>{this._pendingRPCReplies[T].resolveErr(A.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(T){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+t.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(T){this._unresponsiveTime=Date.now()+t.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(T){this._responsiveState!==T&&(this._responsiveState=T,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(T){return this._uriTransformer?(0,S.transformIncomingURIs)(T,this._uriTransformer):T}getProxy(T){const{nid:L,sid:O}=T;return this._proxies[L]||(this._proxies[L]=this._createProxy(L,O)),this._proxies[L]}_createProxy(T,L){let O={get:(y,H)=>(typeof H=="string"&&!y[H]&&H.charCodeAt(0)===36&&(y[H]=(...M)=>this._remoteCall(T,H,M)),H===s?L:y[H])};return new Proxy(Object.create(null),O)}set(T,L){return this._locals[T.nid]=L,L}assertRegistered(T){for(let L=0,O=T.length;L<O;L++){const y=T[L];if(!this._locals[y.nid])throw new Error(`Missing proxy instance ${y.sid}`)}}_receiveOneMessage(T){if(this._isDisposed)return;const L=T.byteLength,O=r.read(T,0),y=O.readUInt8(),H=O.readUInt32();switch(y){case 1:case 2:{let{rpcId:M,method:j,args:X}=o.deserializeRequestJSONArgs(O);this._uriTransformer&&(X=(0,S.transformIncomingURIs)(X,this._uriTransformer)),this._receiveRequest(L,H,M,j,X,y===2);break}case 3:case 4:{let{rpcId:M,method:j,args:X}=o.deserializeRequestMixedArgs(O);this._uriTransformer&&(X=(0,S.transformIncomingURIs)(X,this._uriTransformer)),this._receiveRequest(L,H,M,j,X,y===4);break}case 5:{this._logger&&this._logger.logIncoming(L,H,0,"ack"),this._onDidReceiveAcknowledge(H);break}case 6:{this._receiveCancel(L,H);break}case 7:{this._receiveReply(L,H,void 0);break}case 9:{let M=o.deserializeReplyOKJSON(O);this._uriTransformer&&(M=(0,S.transformIncomingURIs)(M,this._uriTransformer)),this._receiveReply(L,H,M);break}case 10:{const M=o.deserializeReplyOKJSONWithBuffers(O,this._uriTransformer);this._receiveReply(L,H,M);break}case 8:{let M=o.deserializeReplyOKVSBuffer(O);this._receiveReply(L,H,M);break}case 11:{let M=o.deserializeReplyErrError(O);this._uriTransformer&&(M=(0,S.transformIncomingURIs)(M,this._uriTransformer)),this._receiveReplyErr(L,H,M);break}case 12:{this._receiveReplyErr(L,H,void 0);break}default:console.error("received unexpected message"),console.error(T)}}_receiveRequest(T,L,O,y,H,M){this._logger&&this._logger.logIncoming(T,L,1,`receiveRequest ${(0,F.getStringIdentifierForProxy)(O)}.${y}(`,H);const j=String(L);let X,$;if(M){const q=new I.CancellationTokenSource;H.push(q.token),X=this._invokeHandler(O,y,H),$=()=>q.cancel()}else X=this._invokeHandler(O,y,H),$=a;this._cancelInvokedHandlers[j]=$;const U=o.serializeAcknowledged(L);this._logger&&this._logger.logOutgoing(U.byteLength,L,1,"ack"),this._protocol.send(U),X.then(q=>{delete this._cancelInvokedHandlers[j];const K=o.serializeReplyOK(L,q,this._uriReplacer);this._logger&&this._logger.logOutgoing(K.byteLength,L,1,"reply:",q),this._protocol.send(K)},q=>{delete this._cancelInvokedHandlers[j];const K=o.serializeReplyErr(L,q);this._logger&&this._logger.logOutgoing(K.byteLength,L,1,"replyErr:",q),this._protocol.send(K)})}_receiveCancel(T,L){this._logger&&this._logger.logIncoming(T,L,1,"receiveCancel");const O=String(L);this._cancelInvokedHandlers[O]&&this._cancelInvokedHandlers[O]()}_receiveReply(T,L,O){this._logger&&this._logger.logIncoming(T,L,0,"receiveReply:",O);const y=String(L);if(!this._pendingRPCReplies.hasOwnProperty(y))return;const H=this._pendingRPCReplies[y];delete this._pendingRPCReplies[y],H.resolveOk(O)}_receiveReplyErr(T,L,O){this._logger&&this._logger.logIncoming(T,L,0,"receiveReplyErr:",O);const y=String(L);if(!this._pendingRPCReplies.hasOwnProperty(y))return;const H=this._pendingRPCReplies[y];delete this._pendingRPCReplies[y];let M;O&&(O.$isError?(M=new Error,M.name=O.name,M.message=O.message,M.stack=O.stack):M=O),H.resolveErr(M)}_invokeHandler(T,L,O){try{return Promise.resolve(this._doInvokeHandler(T,L,O))}catch(y){return Promise.reject(y)}}_doInvokeHandler(T,L,O){const y=this._locals[T];if(!y)throw new Error("Unknown actor "+(0,F.getStringIdentifierForProxy)(T));let H=y[L];if(typeof H!="function")throw new Error("Unknown method "+L+" on actor "+(0,F.getStringIdentifierForProxy)(T));return H.apply(y,O)}_remoteCall(T,L,O){if(this._isDisposed)return Promise.reject(A.canceled());let y=null;if(O.length>0&&I.CancellationToken.isCancellationToken(O[O.length-1])&&(y=O.pop()),y&&y.isCancellationRequested)return Promise.reject(A.canceled());const H=o.serializeRequestArguments(O,this._uriReplacer),M=++this._lastMessageId,j=String(M),X=new R.LazyPromise;y&&y.onCancellationRequested(()=>{const U=o.serializeCancel(M);this._logger&&this._logger.logOutgoing(U.byteLength,M,0,"cancel"),this._protocol.send(o.serializeCancel(M))}),this._pendingRPCReplies[j]=X,this._onWillSendRequest(M);const $=o.serializeRequest(M,T,L,H,!!y);return this._logger&&this._logger.logOutgoing($.byteLength,M,0,`request: ${(0,F.getStringIdentifierForProxy)(T)}.${L}(`,O),this._protocol.send($),X}}e.RPCProtocol=t,D=E,t.UNRESPONSIVE_TIME=3*1e3;class r{constructor(T,L){this._buff=T,this._offset=L}static alloc(T,L,O){let y=new r(i.VSBuffer.alloc(O+1+4),0);return y.writeUInt8(T),y.writeUInt32(L),y}static read(T,L){return new r(T,L)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(T){this._buff.writeUInt8(T,this._offset),this._offset+=1}readUInt8(){const T=this._buff.readUInt8(this._offset);return this._offset+=1,T}writeUInt32(T){this._buff.writeUInt32BE(T,this._offset),this._offset+=4}readUInt32(){const T=this._buff.readUInt32BE(this._offset);return this._offset+=4,T}static sizeShortString(T){return 1+T.byteLength}writeShortString(T){this._buff.writeUInt8(T.byteLength,this._offset),this._offset+=1,this._buff.set(T,this._offset),this._offset+=T.byteLength}readShortString(){const T=this._buff.readUInt8(this._offset);this._offset+=1;const O=this._buff.slice(this._offset,this._offset+T).toString();return this._offset+=T,O}static sizeLongString(T){return 4+T.byteLength}writeLongString(T){this._buff.writeUInt32BE(T.byteLength,this._offset),this._offset+=4,this._buff.set(T,this._offset),this._offset+=T.byteLength}readLongString(){const T=this._buff.readUInt32BE(this._offset);this._offset+=4;const O=this._buff.slice(this._offset,this._offset+T).toString();return this._offset+=T,O}writeBuffer(T){this._buff.writeUInt32BE(T.byteLength,this._offset),this._offset+=4,this._buff.set(T,this._offset),this._offset+=T.byteLength}static sizeVSBuffer(T){return 4+T.byteLength}writeVSBuffer(T){this._buff.writeUInt32BE(T.byteLength,this._offset),this._offset+=4,this._buff.set(T,this._offset),this._offset+=T.byteLength}readVSBuffer(){const T=this._buff.readUInt32BE(this._offset);this._offset+=4;const L=this._buff.slice(this._offset,this._offset+T);return this._offset+=T,L}static sizeMixedArray(T){let L=0;L+=1;for(let O=0,y=T.length;O<y;O++){const H=T[O];switch(L+=1,H.type){case 1:L+=this.sizeLongString(H.value);break;case 2:L+=this.sizeVSBuffer(H.value);break;case 3:L+=this.sizeUInt32,L+=this.sizeLongString(H.value);for(let M=0;M<H.buffers.length;++M)L+=this.sizeVSBuffer(H.buffers[M]);break;case 4:break}}return L}writeMixedArray(T){this._buff.writeUInt8(T.length,this._offset),this._offset+=1;for(let L=0,O=T.length;L<O;L++){const y=T[L];switch(y.type){case 1:this.writeUInt8(1),this.writeLongString(y.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(y.value);break;case 3:this.writeUInt8(3),this.writeUInt32(y.buffers.length),this.writeLongString(y.value);for(let H=0;H<y.buffers.length;++H)this.writeBuffer(y.buffers[H]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const T=this._buff.readUInt8(this._offset);this._offset+=1;let L=new Array(T);for(let O=0;O<T;O++)switch(this.readUInt8()){case 1:L[O]=this.readLongString();break;case 2:L[O]=this.readVSBuffer();break;case 3:{const H=this.readUInt32(),M=this.readLongString(),j=[];for(let X=0;X<H;++X)j.push(this.readVSBuffer());L[O]=new F.SerializableObjectWithBuffers(P(M,j,null));break}case 4:L[O]=void 0;break}return L}}r.sizeUInt32=4;var n;(function(w){w[w.Simple=0]="Simple",w[w.Mixed=1]="Mixed"})(n||(n={}));class o{static _useMixedArgSerialization(T){for(let L=0,O=T.length;L<O;L++)if(T[L]instanceof i.VSBuffer||T[L]instanceof F.SerializableObjectWithBuffers||typeof T[L]=="undefined")return!0;return!1}static serializeRequestArguments(T,L){if(this._useMixedArgSerialization(T)){const O=[];for(let y=0,H=T.length;y<H;y++){const M=T[y];if(M instanceof i.VSBuffer)O[y]={type:2,value:M};else if(typeof M=="undefined")O[y]={type:4};else if(M instanceof F.SerializableObjectWithBuffers){const{jsonString:j,referencedBuffers:X}=p(M.value,L);O[y]={type:3,value:i.VSBuffer.fromString(j),buffers:X}}else O[y]={type:1,value:i.VSBuffer.fromString(_(M,L))}}return{type:1,args:O}}return{type:0,args:_(T,L)}}static serializeRequest(T,L,O,y,H){switch(y.type){case 0:return this._requestJSONArgs(T,L,O,y.args,H);case 1:return this._requestMixedArgs(T,L,O,y.args,H)}}static _requestJSONArgs(T,L,O,y,H){const M=i.VSBuffer.fromString(O),j=i.VSBuffer.fromString(y);let X=0;X+=r.sizeUInt8(),X+=r.sizeShortString(M),X+=r.sizeLongString(j);let $=r.alloc(H?2:1,T,X);return $.writeUInt8(L),$.writeShortString(M),$.writeLongString(j),$.buffer}static deserializeRequestJSONArgs(T){const L=T.readUInt8(),O=T.readShortString(),y=T.readLongString();return{rpcId:L,method:O,args:JSON.parse(y)}}static _requestMixedArgs(T,L,O,y,H){const M=i.VSBuffer.fromString(O);let j=0;j+=r.sizeUInt8(),j+=r.sizeShortString(M),j+=r.sizeMixedArray(y);let X=r.alloc(H?4:3,T,j);return X.writeUInt8(L),X.writeShortString(M),X.writeMixedArray(y),X.buffer}static deserializeRequestMixedArgs(T){const L=T.readUInt8(),O=T.readShortString(),y=T.readMixedArray(),H=new Array(y.length);for(let M=0,j=y.length;M<j;M++){const X=y[M];typeof X=="string"?H[M]=JSON.parse(X):H[M]=X}return{rpcId:L,method:O,args:H}}static serializeAcknowledged(T){return r.alloc(5,T,0).buffer}static serializeCancel(T){return r.alloc(6,T,0).buffer}static serializeReplyOK(T,L,O){if(typeof L=="undefined")return this._serializeReplyOKEmpty(T);if(L instanceof i.VSBuffer)return this._serializeReplyOKVSBuffer(T,L);if(L instanceof F.SerializableObjectWithBuffers){const{jsonString:y,referencedBuffers:H}=p(L.value,O,!0);return this._serializeReplyOKJSONWithBuffers(T,y,H)}else return this._serializeReplyOKJSON(T,v(L,O))}static _serializeReplyOKEmpty(T){return r.alloc(7,T,0).buffer}static _serializeReplyOKVSBuffer(T,L){let O=0;O+=r.sizeVSBuffer(L);let y=r.alloc(8,T,O);return y.writeVSBuffer(L),y.buffer}static deserializeReplyOKVSBuffer(T){return T.readVSBuffer()}static _serializeReplyOKJSON(T,L){const O=i.VSBuffer.fromString(L);let y=0;y+=r.sizeLongString(O);let H=r.alloc(9,T,y);return H.writeLongString(O),H.buffer}static _serializeReplyOKJSONWithBuffers(T,L,O){const y=i.VSBuffer.fromString(L);let H=0;H+=r.sizeUInt32,H+=r.sizeLongString(y);for(const j of O)H+=r.sizeVSBuffer(j);let M=r.alloc(10,T,H);M.writeUInt32(O.length),M.writeLongString(y);for(const j of O)M.writeBuffer(j);return M.buffer}static deserializeReplyOKJSON(T){const L=T.readLongString();return JSON.parse(L)}static deserializeReplyOKJSONWithBuffers(T,L){const O=T.readUInt32(),y=T.readLongString(),H=[];for(let M=0;M<O;++M)H.push(T.readVSBuffer());return new F.SerializableObjectWithBuffers(P(y,H,L))}static serializeReplyErr(T,L){const O=L?v(A.transformErrorForSerialization(L),null):void 0;if(typeof O!="string")return this._serializeReplyErrEmpty(T);const y=i.VSBuffer.fromString(O);let H=0;H+=r.sizeLongString(y);let M=r.alloc(11,T,H);return M.writeLongString(y),M.buffer}static deserializeReplyErrError(T){const L=T.readLongString();return JSON.parse(L)}static _serializeReplyErrEmpty(T){return r.alloc(12,T,0).buffer}}var m;(function(w){w[w.RequestJSONArgs=1]="RequestJSONArgs",w[w.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",w[w.RequestMixedArgs=3]="RequestMixedArgs",w[w.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",w[w.Acknowledged=5]="Acknowledged",w[w.Cancel=6]="Cancel",w[w.ReplyOKEmpty=7]="ReplyOKEmpty",w[w.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",w[w.ReplyOKJSON=9]="ReplyOKJSON",w[w.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",w[w.ReplyErrError=11]="ReplyErrError",w[w.ReplyErrEmpty=12]="ReplyErrEmpty"})(m||(m={}));var h;(function(w){w[w.String=1]="String",w[w.VSBuffer=2]="VSBuffer",w[w.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",w[w.Undefined=4]="Undefined"})(h||(h={}))}),define(ve[265],we([1,0,4]),function(te,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,f.createDecorator)("remoteAgentService")}),define(ve[266],we([1,0,29,10,9,12,23,2,4,198,43,223,265]),function(te,e,f,i,I,A,C,k,S,R,F,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,S.createDecorator)("pathService");let b=class qi{constructor(d,p,P,_){this.localUserHome=d,this.remoteAgentService=p,this.environmentService=P,this.contextService=_,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||A.OS)(),this.resolveUserHome=(async()=>{const l=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=l?.userHome||d})()}hasValidBasename(d,p,P){return typeof p=="string"||typeof p=="undefined"?this.resolveOS.then(_=>this.doHasValidBasename(d,_,p)):this.doHasValidBasename(d,p,P)}doHasValidBasename(d,p,P){return d.scheme===i.Schemas.file||d.scheme===i.Schemas.vscodeRemote?(0,f.isValidBasename)(P??(0,C.basename)(d),p===1):!0}get defaultUriScheme(){return qi.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(d,p){if(d.remoteAuthority)return i.Schemas.vscodeRemote;const P=(0,R.getVirtualWorkspaceScheme)(p.getWorkspace());if(P)return P;const _=p.getWorkspace().folders[0];if(_)return _.uri.scheme;const l=p.getWorkspace().configuration;return l?l.scheme:i.Schemas.file}async userHome(d){return d?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(d=>d===1?I.win32:I.posix)}async fileURI(d){let p="";if(await this.resolveOS===1&&(d=d.replace(/\\/g,"/")),d[0]==="/"&&d[1]==="/"){const _=d.indexOf("/",2);_===-1?(p=d.substring(2),d="/"):(p=d.substring(2,_),d=d.substring(_)||"/")}return k.URI.from({scheme:i.Schemas.file,authority:p,path:d,query:"",fragment:""})}};b=Be([Fe(1,v.IRemoteAgentService),Fe(2,D.IWorkbenchEnvironmentService),Fe(3,F.IWorkspaceContextService)],b),e.AbstractPathService=b}),define(ve[68],we([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class f{constructor(C,k){this.line=C,this.character=k}isBefore(C){return!1}isBeforeOrEqual(C){return!1}isAfter(C){return!1}isAfterOrEqual(C){return!1}isEqual(C){return!1}compareTo(C){return 0}translate(C,k){return new f(0,0)}with(C){return new f(0,0)}}e.Position=f;class i{constructor(C,k,S,R){this.isEmpty=!1,this.isSingleLine=!1,this.start=new f(C,k),this.end=new f(S,R)}contains(C){return!1}isEqual(C){return!1}intersection(C){}union(C){return new i(0,0,0,0)}with(C){return new i(0,0,0,0)}}e.Range=i;var I;(function(A){A[A.Information=1]="Information",A[A.Warning=2]="Warning"})(I=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(ve[31],we([1,0,18,32,25,29,8,4,9,15,68,16]),function(te,e,f,i,I,A,C,k,S,R,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return F.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const v="\u27EA ",b=" characters skipped \u27EB",g=(v.length+b.length+5)*2;e.ISearchService=(0,k.createDecorator)("searchService");var d;(function(U){U[U.file=0]="file",U[U.text=1]="text"})(d=e.SearchProviderType||(e.SearchProviderType={}));var p;(function(U){U[U.File=1]="File",U[U.Text=2]="Text"})(p=e.QueryType||(e.QueryType={}));function P(U){return!!U.preview}e.resultIsMatch=P;function _(U){return!!U.resource}e.isFileMatch=_;function l(U){return!!U.message}e.isProgressMessage=l;var c;(function(U){U[U.Normal=0]="Normal",U[U.NewSearchStarted=1]="NewSearchStarted"})(c=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class u{constructor(q){this.resource=q,this.results=[]}}e.FileMatch=u;class a{constructor(q,K,G){this.ranges=K;const ee=Array.isArray(K)?K:[K];if(G&&G.matchLines===1&&E(ee)){q=(0,C.getNLines)(q,G.matchLines);let oe="",ue=0,Z=0;const Y=Math.floor(G.charsPerLine/5),se=[];for(const de of ee){const ge=Math.max(de.startColumn-Y,0),Te=de.startColumn+G.charsPerLine;if(ge>Z+Y+g){const Ne=v+(ge-Z)+b;oe+=Ne+q.slice(ge,Te),ue+=ge-(Z+Ne.length)}else oe+=q.slice(Z,Te);se.push(new t(0,de.startColumn-ue,de.endColumn-ue)),Z=Te}this.preview={text:oe,matches:Array.isArray(this.ranges)?se:se[0]}}else{const oe=Array.isArray(K)?K[0].startLineNumber:K.startLineNumber;this.preview={text:q,matches:(0,f.mapArrayOrNot)(K,ue=>new s(ue.startLineNumber-oe,ue.startColumn,ue.endLineNumber-oe,ue.endColumn))}}}}e.TextSearchMatch=a;function E(U){const q=U[0].startLineNumber;for(const K of U)if(K.startLineNumber!==q||K.endLineNumber!==q)return!1;return!0}class s{constructor(q,K,G,ee){this.startLineNumber=q,this.startColumn=K,this.endLineNumber=G,this.endColumn=ee}}e.SearchRange=s;class t extends s{constructor(q,K,G){super(q,K,q,G)}}e.OneLineRange=t;var r;(function(U){U.Default="default",U.FileNames="fileNames",U.Type="type",U.Modified="modified",U.CountDescending="countDescending",U.CountAscending="countAscending"})(r=e.SearchSortOrder||(e.SearchSortOrder={}));function n(U,q=!0){const K=U&&U.files&&U.files.exclude,G=q&&U&&U.search&&U.search.exclude;if(!K&&!G)return;if(!K||!G)return K||G;let ee=Object.create(null);return ee=I.mixin(ee,I.deepClone(K)),ee=I.mixin(ee,I.deepClone(G),!0),ee}e.getExcludes=n;function o(U,q){return U.excludePattern&&i.match(U.excludePattern,q)?!1:U.includePattern||U.usingSearchPaths?U.includePattern&&i.match(U.includePattern,q)?!0:U.usingSearchPaths?!!U.folderQueries&&U.folderQueries.some(K=>{const G=K.folder.fsPath;if(A.isEqualOrParent(q,G)){const ee=S.relative(G,q);return!K.includePattern||!!i.match(K.includePattern,ee)}else return!1}):!1:!0}e.pathIncludedInQuery=o;var m;(function(U){U[U.unknownEncoding=1]="unknownEncoding",U[U.regexParseError=2]="regexParseError",U[U.globParseError=3]="globParseError",U[U.invalidLiteral=4]="invalidLiteral",U[U.rgProcessError=5]="rgProcessError",U[U.other=6]="other",U[U.canceled=7]="canceled"})(m=e.SearchErrorCode||(e.SearchErrorCode={}));class h extends Error{constructor(q,K){super(q);this.code=K}}e.SearchError=h;function w(U){const q=U.message;if((0,R.isCancellationError)(U))return new h(q,m.canceled);try{const K=JSON.parse(q);return new h(K.message,K.code)}catch{return new h(q,m.other)}}e.deserializeSearchError=w;function T(U){const q={message:U.message,code:U.code};return new Error(JSON.stringify(q))}e.serializeSearchError=T;function L(U){return U.type==="error"?!0:U.type==="success"}e.isSerializedSearchComplete=L;function O(U){return U.type==="success"}e.isSerializedSearchSuccess=O;function y(U){return!!U.path}e.isSerializedFileMatch=y;function H(U,q){const K=U.searchPath?U.searchPath:U.relativePath;return(0,C.fuzzyContains)(K,q)}e.isFilePatternMatch=H;class M{constructor(q){this.path=q,this.results=[]}addMatch(q){this.results.push(q)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=M;function j(U,q){const K={...U||{},...q||{}};return Object.keys(K).filter(G=>{const ee=K[G];return typeof ee=="boolean"&&ee})}e.resolvePatternsForProvider=j;class X{constructor(q,K){this._parsedIncludeExpression=null,this._excludeExpression={...q.excludePattern||{},...K.excludePattern||{}},this._parsedExcludeExpression=i.parse(this._excludeExpression);let G=q.includePattern;K.includePattern&&(G?G={...G,...K.includePattern}:G=K.includePattern),G&&(this._parsedIncludeExpression=i.parse(G))}matchesExcludesSync(q,K,G){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(q,K,G))}includedInQuerySync(q,K,G){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(q,K,G)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(q,K,G))}includedInQuery(q,K,G){const ee=this._parsedExcludeExpression(q,K,G),oe=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(q,K,G):!0;return(0,D.isThenable)(ee)?ee.then(ue=>ue?!1:oe()):oe()}hasSiblingExcludeClauses(){return $(this._excludeExpression)}}e.QueryGlobTester=X;function $(U){for(const q in U)if(typeof U[q]!="boolean")return!0;return!1}}),define(ve[36],we([1,0,18,16,21,3,24,10,91,23,8,13,2,172,4,11,190,43,44,26,17,14,7,31,5]),function(te,e,f,i,I,A,C,k,S,R,F,D,v,b,g,d,p,P,_,l,c,u,a,E,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function t(L,O,y){return new R.ExtUri(H=>m(H,y)).isEqual(L,O)}function r(L,O,y){return t(L.uri,O.uri,y)?0:(0,F.compare)(L.uri.toString(),O.uri.toString())}function n(L,O,y){return L.index!==O.index?L.index<O.index?-1:1:t(L.uri,O.uri,y)?(0,F.compare)(L.name,O.name):(0,F.compare)(L.uri.toString(),O.uri.toString())}function o(L,O,y,H){const M=L.slice(0).sort((X,$)=>y(X,$,H)),j=O.slice(0).sort((X,$)=>y(X,$,H));return(0,f.delta)(M,j,(X,$)=>y(X,$,H))}function m(L,O){const y=O.getCapabilities(L.scheme);return!(y&&y&1024)}class h extends P.Workspace{constructor(O,y,H,M,j,X,$){super(O,H.map(U=>new P.WorkspaceFolder(U)),M,j,$);this._name=y,this._isUntitled=X,this._workspaceFolders=[],this._structure=C.TernarySearchTree.forUris($),H.forEach(U=>{this._workspaceFolders.push(U),this._structure.set(U.uri,U)})}static toExtHostWorkspace(O,y,H,M){if(!O)return{workspace:null,added:[],removed:[]};const{id:j,name:X,folders:$,configuration:U,transient:q,isUntitled:K}=O,G=[],ee=y;y?$.forEach((Y,se)=>{const de=v.URI.revive(Y.uri),ge=h._findFolder(H||y,de,M);ge?(ge.name=Y.name,ge.index=Y.index,G.push(ge)):G.push({uri:de,name:Y.name,index:se})}):G.push(...$.map(({uri:Y,name:se,index:de})=>({uri:v.URI.revive(Y),name:se,index:de}))),G.sort((Y,se)=>Y.index<se.index?-1:1);const oe=new h(j,X,G,!!q,U?v.URI.revive(U):null,!!K,Y=>m(Y,M)),{added:ue,removed:Z}=o(ee?ee.workspaceFolders:[],oe.workspaceFolders,r,M);return{workspace:oe,added:ue,removed:Z}}static _findFolder(O,y,H){for(let M=0;M<O.folders.length;M++){const j=O.workspaceFolders[M];if(t(j.uri,y,H))return j}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(O,y){return y&&this._structure.get(O)&&(O=(0,R.dirname)(O)),this._structure.findSubstr(O)}resolveWorkspaceFolder(O){return this._structure.get(O)}}let w=class{constructor(O,y,H,M){this._onDidChangeWorkspace=new A.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new A.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=M,this._extHostFileSystemInfo=H,this._requestIdProvider=new S.Counter,this._barrier=new i.Barrier,this._proxy=O.getProxy(s.MainContext.MainThreadWorkspace),this._messageService=O.getProxy(s.MainContext.MainThreadMessageService);const j=y.workspace;this._confirmedWorkspace=j?new h(j.id,j.name,[],!!j.transient,j.configuration?v.URI.revive(j.configuration):null,!!j.isUntitled,X=>m(X,H)):void 0}$initializeWorkspace(O,y){this._trusted=y,this.$acceptWorkspaceData(O),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?v.URI.from({scheme:k.Schemas.untitled,path:(0,R.basename)((0,R.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(O,y,H,...M){const j=[];if(Array.isArray(M)&&M.forEach(K=>{v.URI.isUri(K.uri)&&!j.some(G=>t(G.uri,K.uri,this._extHostFileSystemInfo))&&j.push({uri:K.uri,name:K.name||(0,R.basenameOrAuthority)(K.uri)})}),this._unconfirmedWorkspace||[y,H].some(K=>typeof K!="number"||K<0)||H===0&&j.length===0)return!1;const X=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(y+H>X.length)return!1;const $=X.slice(0);$.splice(y,H,...j.map(K=>({uri:K.uri,name:K.name||(0,R.basenameOrAuthority)(K.uri),index:void 0})));for(let K=0;K<$.length;K++){const G=$[K];if($.some((ee,oe)=>oe!==K&&t(G.uri,ee.uri,this._extHostFileSystemInfo)))return!1}$.forEach((K,G)=>K.index=G);const{added:U,removed:q}=o(X,$,n,this._extHostFileSystemInfo);if(U.length===0&&q.length===0)return!1;if(this._proxy){const K=O.displayName||O.name;this._proxy.$updateWorkspaceFolders(K,y,H,j).then(void 0,G=>{this._unconfirmedWorkspace=void 0;const ee={source:{identifier:O.identifier,label:O.displayName||O.name}};this._messageService.$showMessage(p.Severity.Error,(0,b.localize)(0,null,K,G.toString()),ee,[])})}return this.trySetWorkspaceFolders($),!0}getWorkspaceFolder(O,y){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(O,y)}async getWorkspaceFolder2(O,y){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(O,y)}async resolveWorkspaceFolder(O){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(O)}getPath(){if(!this._actualWorkspace)return;const{folders:O}=this._actualWorkspace;if(O.length!==0)return O[0].uri.fsPath}getRelativePath(O,y){let H,M="";if(typeof O=="string"?(H=v.URI.file(O),M=O):typeof O!="undefined"&&(H=O,M=O.fsPath),!H)return M;const j=this.getWorkspaceFolder(H,!0);if(!j)return M;typeof y=="undefined"&&this._actualWorkspace&&(y=this._actualWorkspace.folders.length>1);let X=(0,R.relativePath)(j.uri,H);return y&&j.name&&(X=`${j.name}/${X}`),X}trySetWorkspaceFolders(O){this._actualWorkspace&&(this._unconfirmedWorkspace=h.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:O,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(O){const{workspace:y,added:H,removed:M}=h.toExtHostWorkspace(O,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=y||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:H,removed:M}))}findFiles(O,y,H,M,j=I.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${M.value}, entryPoint: findFiles`);let X;if(y===null?X=!1:y&&(typeof y=="string"?X=y:X=y.pattern),j&&j.isCancellationRequested)return Promise.resolve([]);const{includePattern:$,folder:U}=T(u.GlobPattern.from(O));return this._proxy.$startFileSearch((0,D.withUndefinedAsNull)($),(0,D.withUndefinedAsNull)(U),(0,D.withUndefinedAsNull)(X),(0,D.withUndefinedAsNull)(H),j).then(q=>Array.isArray(q)?q.map(K=>v.URI.revive(K)):[])}async findTextInFiles(O,y,H,M,j=I.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${M.value}, entryPoint: findTextInFiles`);const X=this._requestIdProvider.getNext(),$=typeof y.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:y.previewOptions,{includePattern:U,folder:q}=T(u.GlobPattern.from(y.include)),K=typeof y.exclude=="string"?y.exclude:y.exclude?y.exclude.pattern:void 0,G={ignoreSymlinks:typeof y.followSymlinks=="boolean"?!y.followSymlinks:void 0,disregardIgnoreFiles:typeof y.useIgnoreFiles=="boolean"?!y.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof y.useGlobalIgnoreFiles=="boolean"?!y.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof y.useParentIgnoreFiles=="boolean"?!y.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof y.useDefaultExcludes=="boolean"?!y.useDefaultExcludes:!0,fileEncoding:y.encoding,maxResults:y.maxResults,previewOptions:$,afterContext:y.afterContext,beforeContext:y.beforeContext,includePattern:U,excludePattern:K},ee=!1;if(this._activeSearchCallbacks[X]=oe=>{if(ee)return;const ue=v.URI.revive(oe.resource);oe.results.forEach(Z=>{(0,E.resultIsMatch)(Z)?H({uri:ue,preview:{text:Z.preview.text,matches:(0,f.mapArrayOrNot)(Z.preview.matches,Y=>new a.Range(Y.startLineNumber,Y.startColumn,Y.endLineNumber,Y.endColumn))},ranges:(0,f.mapArrayOrNot)(Z.ranges,Y=>new a.Range(Y.startLineNumber,Y.startColumn,Y.endLineNumber,Y.endColumn))}):H({uri:ue,text:Z.text,lineNumber:Z.lineNumber})})},j.isCancellationRequested)return{};try{const oe=await this._proxy.$startTextSearch(O,(0,D.withUndefinedAsNull)(q),G,X,j);return delete this._activeSearchCallbacks[X],oe||{}}catch(oe){throw delete this._activeSearchCallbacks[X],oe}}$handleTextSearchResult(O,y){this._activeSearchCallbacks[y]&&this._activeSearchCallbacks[y](O)}saveAll(O){return this._proxy.$saveAll(O)}resolveProxy(O){return this._proxy.$resolveProxy(O)}get trusted(){return this._trusted}requestWorkspaceTrust(O){return this._proxy.$requestWorkspaceTrust(O)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};w=Be([Fe(0,c.IExtHostRpcService),Fe(1,l.IExtHostInitDataService),Fe(2,_.IExtHostFileSystemInfo),Fe(3,d.ILogService)],w),e.ExtHostWorkspace=w,e.IExtHostWorkspace=(0,g.createDecorator)("IExtHostWorkspace");function T(L){let O,y;return L&&(typeof L=="string"?O=L:(O=L.pattern,y=v.URI.revive(L.baseUri))),{includePattern:O,folder:y}}}),define(ve[37],we([1,0,25,3,36,5,7,193,119,13,16,4,17,11,2]),function(te,e,f,i,I,A,C,k,S,R,F,D,v,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function d(E,s){if(s){const t=s.split(".");let r=E;for(let n=0;r&&n<t.length;n++)r=r[t[n]];return r}}function p(E){return E instanceof g.URI}function P(E){return E&&E.uri instanceof g.URI&&E.languageId&&typeof E.languageId=="string"}function _(E){return E&&!E.uri&&E.languageId&&typeof E.languageId=="string"}function l(E){return E&&E.uri instanceof g.URI&&(!E.name||typeof E.name=="string")&&(!E.index||typeof E.index=="number")}function c(E){if(p(E))return{resource:E};if(P(E))return{resource:E.uri,overrideIdentifier:E.languageId};if(_(E))return{overrideIdentifier:E.languageId};if(l(E))return{resource:E.uri};if(E===null)return{resource:null}}let u=class{constructor(s,t,r){this._proxy=s.getProxy(A.MainContext.MainThreadConfiguration),this._extHostWorkspace=t,this._logService=r,this._barrier=new F.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(s=>this._actual)}$initializeConfiguration(s){this._actual=new a(this._proxy,this._extHostWorkspace,s,this._logService),this._barrier.open()}$acceptConfigurationChanged(s,t){this.getConfigProvider().then(r=>r.$acceptConfigurationChanged(s,t))}};u=Be([Fe(0,v.IExtHostRpcService),Fe(1,I.IExtHostWorkspace),Fe(2,b.ILogService)],u),e.ExtHostConfiguration=u;class a{constructor(s,t,r,n){this._onDidChangeConfiguration=new i.Emitter,this._proxy=s,this._logService=n,this._extHostWorkspace=t,this._configuration=k.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(s,t){const r={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=k.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(t,r))}getConfiguration(s,t,r){const n=c(t)||{},o=this._toReadonlyValue(s?d(this._configuration.getValue(void 0,n,this._extHostWorkspace.workspace),s):this._configuration.getValue(void 0,n,this._extHostWorkspace.workspace));s&&this._validateConfigurationAccess(s,n,r?.identifier);function m(w){if(w==null)return null;if(typeof w=="boolean")return w?1:4;switch(w){case C.ConfigurationTarget.Global:return 1;case C.ConfigurationTarget.Workspace:return 4;case C.ConfigurationTarget.WorkspaceFolder:return 5}}const h={has(w){return typeof d(o,w)!="undefined"},get:(w,T)=>{this._validateConfigurationAccess(s?`${s}.${w}`:w,n,r?.identifier);let L=d(o,w);if(typeof L=="undefined")L=T;else{let O;const y=(H,M)=>{let j;const X=()=>{O=O||(0,f.deepClone)(o),j=j||d(O,M)};return(0,R.isObject)(H)?new Proxy(H,{get:($,U)=>{if(typeof U=="string"&&U.toLowerCase()==="tojson")return X(),()=>j;if(O)return j=j||d(O,M),j[U];const q=$[U];return typeof U=="string"?y(q,`${M}.${U}`):q},set:($,U,q)=>(X(),j&&(j[U]=q),!0),deleteProperty:($,U)=>(X(),j&&delete j[U],!0),defineProperty:($,U,q)=>(X(),j&&Object.defineProperty(j,U,q),!0)}):H};L=y(L,w)}return L},update:(w,T,L,O)=>{w=s?`${s}.${w}`:w;const y=m(L);return T!==void 0?this._proxy.$updateConfigurationOption(y,w,T,n,O):this._proxy.$removeConfigurationOption(y,w,n,O)},inspect:w=>{w=s?`${s}.${w}`:w;const T=(0,f.deepClone)(this._configuration.inspect(w,n,this._extHostWorkspace.workspace));if(T)return{key:w,defaultValue:T.default?.value,globalValue:T.user?.value,workspaceValue:T.workspace?.value,workspaceFolderValue:T.workspaceFolder?.value,defaultLanguageValue:T.default?.override,globalLanguageValue:T.user?.override,workspaceLanguageValue:T.workspace?.override,workspaceFolderLanguageValue:T.workspaceFolder?.override,languageIds:T.overrideIdentifiers}}};return typeof o=="object"&&(0,f.mixin)(h,o,!1),Object.freeze(h)}_toReadonlyValue(s){const t=r=>(0,R.isObject)(r)?new Proxy(r,{get:(n,o)=>t(n[o]),set:(n,o,m)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(o)}' of object`)},deleteProperty:(n,o)=>{throw new Error(`TypeError: Cannot delete read only property '${String(o)}' of object`)},defineProperty:(n,o)=>{throw new Error(`TypeError: Cannot define property '${String(o)}' for a readonly object`)},setPrototypeOf:n=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):r;return t(s)}_validateConfigurationAccess(s,t,r){const n=S.OVERRIDE_PROPERTY_REGEX.test(s)?4:this._configurationScopes.get(s),o=r?`[${r.value}] `:"";if(n===4){typeof t?.resource=="undefined"&&this._logService.warn(`${o}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(n===3){t?.resource&&this._logService.warn(`${o}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(s,t){const r=new k.ConfigurationChangeEvent(s,t,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(n,o)=>r.affectsConfiguration(n,c(o))})}_toMap(s){return s.reduce((t,r)=>(t.set(r[0],r[1]),t),new Map)}}e.ExtHostConfigProvider=a,e.IExtHostConfiguration=(0,D.createDecorator)("IExtHostConfiguration")});var Xe=this&&this.__classPrivateFieldSet||function(te,e,f,i,I){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!I:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?I.call(te,f):I?I.value=f:e.set(te,f),f},Pe=this&&this.__classPrivateFieldGet||function(te,e,f,i){if(f==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!i:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?i:f==="a"?i.call(te):i?i.value:e.get(te)};define(ve[69],we([1,0,2,16,3,5,7,36,45,37,21,34,17,26,4,10,12,11,64,215,15]),function(te,e,f,i,I,A,C,k,S,R,F,D,v,b,g,d,p,P,_,l,c){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var a;(function(M){function j($){if($!=null)return $}M.from=j;function X($){if($!=null)return $}M.to=X})(a=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var E;(function(M){function j($){if($!=null)return $}M.from=j;function X($){if($!=null)return $}M.to=X})(E=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var s;(function(M){function j($){if($!=null)return $}M.from=j;function X($){if($!=null)return $}M.to=X})(s=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var t;(function(M){function j(U){if(U){const q=U;return q&&!!q.process}else return!1}M.is=j;function X(U){if(U==null)return;const q={process:U.process,args:U.args};return U.options&&(q.options=s.from(U.options)),q}M.from=X;function $(U){if(U!=null)return new C.ProcessExecution(U.process,U.args,U.options)}M.to=$})(t=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var r;(function(M){function j($){if($!=null)return $}M.from=j;function X($){if($!=null)return $}M.to=X})(r=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var n;(function(M){function j(U){if(U){const q=U;return q&&(!!q.commandLine||!!q.command)}else return!1}M.is=j;function X(U){if(U==null)return;const q={};return U.commandLine!==void 0?q.commandLine=U.commandLine:(q.command=U.command,q.args=U.args),U.options&&(q.options=r.from(U.options)),q}M.from=X;function $(U){if(!(U==null||U.command===void 0&&U.commandLine===void 0))return U.commandLine?new C.ShellExecution(U.commandLine,U.options):new C.ShellExecution(U.command,U.args?U.args:[],U.options)}M.to=$})(n=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var o;(function(M){function j(U){if(U){let q=U;return q&&q.customExecution==="customExecution"}else return!1}M.is=j;function X(U){return{customExecution:"customExecution"}}M.from=X;function $(U,q){return q.get(U)}M.to=$})(o=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var m;(function(M){function j(X,$){let U;return X.scope!==void 0&&typeof X.scope!="number"?U=X.scope.uri:X.scope!==void 0&&typeof X.scope=="number"&&(X.scope===C.TaskScope.Workspace&&$&&$.workspaceFile?U=$.workspaceFile:U=l.USER_TASKS_GROUP_KEY),{id:X._id,workspaceFolder:U}}M.from=j})(m=e.TaskHandleDTO||(e.TaskHandleDTO={}));var h;(function(M){function j(X){if(X!=null)return{_id:X.id,isDefault:X.isDefault}}M.from=j})(h=e.TaskGroupDTO||(e.TaskGroupDTO={}));var w;(function(M){function j(U,q){if(U==null)return[];const K=[];for(let G of U){const ee=X(G,q);ee&&K.push(ee)}return K}M.fromMany=j;function X(U,q){if(U==null)return;let K;U.execution instanceof C.ProcessExecution?K=t.from(U.execution):U.execution instanceof C.ShellExecution?K=n.from(U.execution):U.execution&&U.execution instanceof C.CustomExecution&&(K=o.from(U.execution));const G=a.from(U.definition);let ee;return U.scope?typeof U.scope=="number"?ee=U.scope:ee=U.scope.uri:ee=C.TaskScope.Workspace,!G||!ee?void 0:{_id:U._id,definition:G,name:U.name,source:{extensionId:q.identifier.value,label:U.source,scope:ee},execution:K,isBackground:U.isBackground,group:h.from(U.group),presentationOptions:E.from(U.presentationOptions),problemMatchers:U.problemMatchers,hasDefinedMatchers:U.hasDefinedMatchers,runOptions:U.runOptions?U.runOptions:{reevaluateOnRerun:!0},detail:U.detail}}M.from=X;async function $(U,q,K){if(U==null)return;let G;t.is(U.execution)?G=t.to(U.execution):n.is(U.execution)?G=n.to(U.execution):o.is(U.execution)&&(G=o.to(U._id,K));const ee=a.to(U.definition);let oe;if(U.source&&(U.source.scope!==void 0?typeof U.source.scope=="number"?oe=U.source.scope:oe=await q.resolveWorkspaceFolder(f.URI.revive(U.source.scope)):oe=C.TaskScope.Workspace),!ee||!oe)return;const ue=new C.Task(ee,oe,U.name,U.source.label,G,U.problemMatchers);return U.isBackground!==void 0&&(ue.isBackground=U.isBackground),U.group!==void 0&&(ue.group=C.TaskGroup.from(U.group._id),ue.group&&U.group.isDefault&&(ue.group=new C.TaskGroup(ue.group.id,ue.group.label),U.group.isDefault&&(ue.group.isDefault=U.group.isDefault))),U.presentationOptions&&(ue.presentationOptions=E.to(U.presentationOptions)),U._id&&(ue._id=U._id),U.detail&&(ue.detail=U.detail),ue}M.to=$})(w=e.TaskDTO||(e.TaskDTO={}));var T;(function(M){function j($){return $}M.from=j;function X($){if(!!$)return Object.assign(Object.create(null),$)}M.to=X})(T=e.TaskFilterDTO||(e.TaskFilterDTO={}));class L{constructor(j,X,$){this._id=X,this._task=$,u.set(this,void 0),Xe(this,u,j,"f")}get task(){return this._task}terminate(){Pe(this,u,"f").terminateTask(this)}fireDidStartProcess(j){}fireDidEndProcess(j){}}u=new WeakMap;var O;(function(M){function j(X){return{id:X._id,task:void 0}}M.from=j})(O=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let y=class{constructor(j,X,$,U,q,K,G,ee){this._onDidExecuteTask=new I.Emitter,this._onDidTerminateTask=new I.Emitter,this._onDidTaskProcessStarted=new I.Emitter,this._onDidTaskProcessEnded=new I.Emitter,this._proxy=j.getProxy(A.MainContext.MainThreadTask),this._workspaceProvider=$,this._editorService=U,this._configurationService=q,this._terminalService=K,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=G,this._deprecationService=ee,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(j,X,$){if(!$)return new C.Disposable(()=>{});const U=this.nextHandle();return this._handlers.set(U,{type:X,provider:$,extension:j}),this._proxy.$registerTaskProvider(U,X),new C.Disposable(()=>{this._handlers.delete(U),this._proxy.$unregisterTaskProvider(U)})}registerTaskSystem(j,X){this._proxy.$registerTaskSystem(j,X)}fetchTasks(j){return this._proxy.$fetchTasks(T.from(j)).then(async X=>{const $=[];for(let U of X){const q=await w.to(U,this._workspaceProvider,this._providedCustomExecutions2);q&&$.push(q)}return $})}get taskExecutions(){const j=[];return this._taskExecutions.forEach(X=>j.push(X)),j}terminateTask(j){if(!(j instanceof L))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(j._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(j,X,$){const U=this._providedCustomExecutions2.get(j.id);U&&(this._activeCustomExecutions2.set(j.id,U),this._terminalService.attachPtyToTerminal(X,await U.callback($))),this._lastStartedTask=j.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(j)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(j){const X=await this.getTaskExecution(j);this._taskExecutionPromises.delete(j.id),this._taskExecutions.delete(j.id),this.customExecutionComplete(j),this._onDidTerminateTask.fire({execution:X})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(j){const X=await this.getTaskExecution(j.id);this._onDidTaskProcessStarted.fire({execution:X,processId:j.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(j){const X=await this.getTaskExecution(j.id);this._onDidTaskProcessEnded.fire({execution:X,exitCode:j.exitCode})}$provideTasks(j,X){const $=this._handlers.get(j);if(!$)return Promise.reject(new Error("no handler found"));const U=[],q=(0,i.asPromise)(()=>$.provider.provideTasks(F.CancellationToken.None)).then(K=>this.provideTasksInternal(X,U,$,K));return new Promise(K=>{q.then(G=>{Promise.all(U).then(()=>{K(G)})})})}async $resolveTask(j,X){const $=this._handlers.get(j);if(!$)return Promise.reject(new Error("no handler found"));if(X.definition.type!==$.type)throw new Error(`Unexpected: Task of type [${X.definition.type}] cannot be resolved by provider of type [${$.type}].`);const U=await w.to(X,this._workspaceProvider,this._providedCustomExecutions2);if(!U)throw new Error("Unexpected: Task cannot be resolved.");const q=await $.provider.resolveTask(U,F.CancellationToken.None);if(!q)return;this.checkDeprecation(q,$);const K=w.from(q,$.extension);if(!K)throw new Error("Unexpected: Task cannot be resolved.");if(q.definition!==U.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return o.is(K.execution)&&await this.addCustomExecution(K,q,!0),await this.resolveTaskInternal(K)}nextHandle(){return this._handleCounter++}async addCustomExecution(j,X,$){const U=await this._proxy.$createTaskId(j);!$&&!this._providedCustomExecutions2.has(U)&&(this._notProvidedCustomExecutions.add(U),this._activeCustomExecutions2.set(U,X.execution)),this._providedCustomExecutions2.set(U,X.execution)}async getTaskExecution(j,X){if(typeof j=="string"){const q=this._taskExecutionPromises.get(j);if(!q)throw new Error("Unexpected: The specified task is missing an execution");return q}let $=this._taskExecutionPromises.get(j.id);if($)return $;const U=new Promise((q,K)=>{function G(ee,oe,ue){ue?q(new L(ee,oe.id,ue)):K("Unexpected: Task does not exist.")}X?G(this,j,X):w.to(j.task,this._workspaceProvider,this._providedCustomExecutions2).then(ee=>G(this,j,ee))});return this._taskExecutionPromises.set(j.id,U),U.then(q=>(this._taskExecutions.set(j.id,q),q),q=>Promise.reject(q))}checkDeprecation(j,X){j._deprecated&&this._deprecationService.report("Task.constructor",X.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(j){this._activeCustomExecutions2.get(j.id)&&this._activeCustomExecutions2.delete(j.id),this._notProvidedCustomExecutions.has(j.id)&&this._lastStartedTask!==j.id&&(this._providedCustomExecutions2.delete(j.id),this._notProvidedCustomExecutions.delete(j.id));let $=this._notProvidedCustomExecutions.values(),U=$.next();for(;!U.done;)!this._activeCustomExecutions2.has(U.value)&&this._lastStartedTask!==U.value&&(this._providedCustomExecutions2.delete(U.value),this._notProvidedCustomExecutions.delete(U.value)),U=$.next()}};y=Be([Fe(0,v.IExtHostRpcService),Fe(1,b.IExtHostInitDataService),Fe(2,k.IExtHostWorkspace),Fe(3,S.IExtHostDocumentsAndEditors),Fe(4,R.IExtHostConfiguration),Fe(5,D.IExtHostTerminalService),Fe(6,P.ILogService),Fe(7,_.IExtHostApiDeprecationService)],y),e.ExtHostTaskBase=y;let H=class extends y{constructor(j,X,$,U,q,K,G,ee){super(j,X,$,U,q,K,G,ee);this.registerTaskSystem(d.Schemas.vscodeRemote,{scheme:d.Schemas.vscodeRemote,authority:"",platform:p.PlatformToString(0)})}async executeTask(j,X){if(!X.execution)throw new Error("Tasks to execute must include an execution");const $=w.from(X,j);if($===void 0)throw new Error("Task is not valid");if(o.is($.execution))await this.addCustomExecution($,X,!1);else throw new c.NotSupportedError;const U=await this.getTaskExecution(await this._proxy.$getTaskExecution($),X);return this._proxy.$executeTask($).catch(q=>{throw new Error(q)}),U}provideTasksInternal(j,X,$,U){const q=[];if(U)for(let K of U){this.checkDeprecation(K,$),(!K.definition||!j[K.definition.type])&&this._logService.warn(`The task [${K.source}, ${K.name}] uses an undefined task type. The task will be ignored in the future.`);const G=w.from(K,$.extension);G&&o.is(G.execution)?(q.push(G),X.push(this.addCustomExecution(G,K,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:q,extension:$.extension}}async resolveTaskInternal(j){if(o.is(j.execution))return j;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(j,X){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(j,X,$){}};H=Be([Fe(0,v.IExtHostRpcService),Fe(1,b.IExtHostInitDataService),Fe(2,k.IExtHostWorkspace),Fe(3,S.IExtHostDocumentsAndEditors),Fe(4,R.IExtHostConfiguration),Fe(5,D.IExtHostTerminalService),Fe(6,P.ILogService),Fe(7,_.IExtHostApiDeprecationService)],H),e.WorkerExtHostTask=H,e.IExtHostTask=(0,g.createDecorator)("IExtHostTask")}),define(ve[267],we([1,0,9,21,49,32,23,46,31]),function(te,e,f,i,I,A,C,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class R{constructor(v,b,g){this.config=v,this.provider=b,this.sessionToken=g,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=v.filePattern,this.includePattern=v.includePattern&&A.parse(v.includePattern),this.maxResults=v.maxResults||void 0,this.exists=v.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=v.excludePattern&&A.parse(v.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(v=>v.cancel()),this.activeCancellationTokens=new Set}search(v){const b=this.config.folderQueries||[];return new Promise((g,d)=>{const p=P=>{this.resultCount++,v(P)};if(this.isCanceled)return g({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(P=>{const _=P.toString(),l=f.basename(_);this.globalExcludePattern&&this.globalExcludePattern(_,l)||this.matchFile(p,{base:P,basename:l})}),Promise.all(b.map(P=>this.searchInFolder(P,p))).then(P=>{g({limitHit:this.isLimitHit,stats:P[0]||void 0})},P=>{d(new Error((0,I.toErrorMessage)(P)))})})}async searchInFolder(v,b){const g=new i.CancellationTokenSource,d=this.getSearchOptionsForFolder(v),p=this.initDirectoryTree(),P=new S.QueryGlobTester(this.config,v),_=!P.hasSiblingExcludeClauses();let l;try{this.activeCancellationTokens.add(g),l=k.StopWatch.create();const c=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},d,g.token),u=l.elapsed(),a=k.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(c&&c.forEach(E=>{const s=f.posix.relative(v.folder.path,E.path);if(_){const t=f.basename(E.path);this.matchFile(b,{base:v.folder,relativePath:s,basename:t});return}this.addDirectoryEntries(p,v.folder,s,b)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(p,P,b),{providerTime:u,postProcessTime:a.elapsed()})}finally{g.dispose(),this.activeCancellationTokens.delete(g)}}getSearchOptionsForFolder(v){const b=(0,S.resolvePatternsForProvider)(this.config.includePattern,v.includePattern),g=(0,S.resolvePatternsForProvider)(this.config.excludePattern,v.excludePattern);return{folder:v.folder,excludes:g,includes:b,useIgnoreFiles:!v.disregardIgnoreFiles,useGlobalIgnoreFiles:!v.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!v.disregardParentIgnoreFiles,followSymlinks:!v.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const v={rootEntries:[],pathToEntries:Object.create(null)};return v.pathToEntries["."]=v.rootEntries,v}addDirectoryEntries({pathToEntries:v},b,g,d){if(g===this.filePattern){const P=f.basename(this.filePattern);this.matchFile(d,{base:b,relativePath:this.filePattern,basename:P})}function p(P){const _=f.basename(P),l=f.dirname(P);let c=v[l];c||(c=v[l]=[],p(l)),c.push({base:b,relativePath:P,basename:_})}p(g)}matchDirectoryTree({rootEntries:v,pathToEntries:b},g,d){const p=this,P=this.filePattern;function _(l){const c=A.hasSiblingFn(()=>l.map(u=>u.basename));for(let u=0,a=l.length;u<a;u++){const E=l[u],{relativePath:s,basename:t}=E;if(g.matchesExcludesSync(s,t,P!==t?c:void 0))continue;const r=b[s];if(r)_(r);else{if(s===P)continue;p.matchFile(d,E)}if(p.isLimitHit)break}}_(v)}matchFile(v,b){(!this.includePattern||b.relativePath&&this.includePattern(b.relativePath,b.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||v(b))}}class F{constructor(){this.sessions=new Map}fileSearch(v,b,g,d){const p=this.getSessionTokenSource(v.cacheKey),P=new R(v,b,p&&p.token);let _=0;const l=c=>{_+=c.length,g(c.map(u=>this.rawMatchToSearchItem(u)))};return this.doSearch(P,F.BATCH_SIZE,l,d).then(c=>({limitHit:c.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:_,detailStats:c.stats}}))}clearCache(v){const b=this.getSessionTokenSource(v);b&&b.cancel()}getSessionTokenSource(v){if(!!v)return this.sessions.has(v)||this.sessions.set(v,new i.CancellationTokenSource),this.sessions.get(v)}rawMatchToSearchItem(v){return v.relativePath?{resource:C.joinPath(v.base,v.relativePath)}:{resource:v.base}}doSearch(v,b,g,d){d.onCancellationRequested(()=>{v.cancel()});const p=_=>{_&&(P.push(_),b>0&&P.length>=b&&(g(P),P=[]))};let P=[];return v.search(p).then(_=>(P.length&&g(P),_),_=>(P.length&&g(P),Promise.reject(_)))}}e.FileSearchManager=F,F.BATCH_SIZE=512}),define(ve[268],we([1,0,18,73,32,100,24,10,9,23,8,13,2,152,181,115,11,43,129,266,31]),function(te,e,f,i,I,A,C,k,S,R,F,D,v,b,g,d,p,P,_,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let u=class{constructor(h,w,T,L,O){this.configurationService=h,this.workspaceContextService=w,this.editorGroupsService=T,this.logService=L,this.pathService=O}text(h,w,T={}){h=this.getContentPattern(h,T);const L=this.configurationService.getValue(),O=w&&w.some(H=>!this.configurationService.getValue({resource:H}).search.useRipgrep);return{...this.commonQuery(w?.map(P.toWorkspaceFolder),T),type:2,contentPattern:h,previewOptions:T.previewOptions,maxFileSize:T.maxFileSize,usePCRE2:L.search.usePCRE2||O||!1,beforeContext:T.beforeContext,afterContext:T.afterContext,userDisabledExcludesAndIgnoreFiles:T.disregardExcludeSettings&&T.disregardIgnoreFiles}}getContentPattern(h,w){const T=this.configurationService.getValue();h.isRegExp&&(h.pattern=h.pattern.replace(/\r?\n/g,"\\n"));const L={...h,wordSeparators:T.editor.wordSeparators};return this.isCaseSensitive(h,w)&&(L.isCaseSensitive=!0),this.isMultiline(h)&&(L.isMultiline=!0),L}file(h,w={}){return{...this.commonQuery(h,w),type:1,filePattern:w.filePattern?w.filePattern.trim():w.filePattern,exists:w.exists,sortByScore:w.sortByScore,cacheKey:w.cacheKey}}handleIncludeExclude(h,w){return h?(h=Array.isArray(h)?h.map(r):r(h),w?this.parseSearchPaths(h):{pattern:E(...Array.isArray(h)?h:[h])}):{}}commonQuery(h=[],w={}){const T=this.handleIncludeExclude(w.includePattern,w.expandPatterns),L=this.handleIncludeExclude(w.excludePattern,w.expandPatterns),O=h.length>1,y=(T.searchPaths&&T.searchPaths.length?T.searchPaths.map(j=>this.getFolderQueryForSearchPath(j,w,L)):h.map(j=>this.getFolderQueryForRoot(j,w,L,O))).filter(j=>!!j),H={_reason:w._reason,folderQueries:y,usingSearchPaths:!!(T.searchPaths&&T.searchPaths.length),extraFileResources:w.extraFileResources,excludePattern:L.pattern,includePattern:T.pattern,onlyOpenEditors:w.onlyOpenEditors,maxResults:w.maxResults};if(w.onlyOpenEditors){const j=f.coalesce(f.flatten(this.editorGroupsService.groups.map(U=>U.editors.map(q=>q.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(j));const X=j.filter(U=>(0,c.pathIncludedInQuery)(H,U.fsPath)),$=this.commonQueryFromFileList(X);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify($)),{...H,...$}}const M=w.extraFileResources&&w.extraFileResources.filter(j=>(0,c.pathIncludedInQuery)(H,j.fsPath));return H.extraFileResources=M&&M.length?M:void 0,H}commonQueryFromFileList(h){const w=[],T=new C.ResourceMap,L={};let O=!1;return h.forEach(y=>{if(y.scheme===k.Schemas.walkThrough)return;if((0,R.isAbsolutePath)(y)){const M=this.workspaceContextService.getWorkspaceFolder(y)?.uri??y.with({path:S.dirname(y.fsPath)});let j=T.get(M);j||(O=!0,j={folder:M,includePattern:{}},w.push(j),T.set(M,j));const X=S.relative(M.fsPath,y.fsPath);(0,D.assertIsDefined)(j.includePattern)[X.replace(/\\/g,"/")]=!0}else y.fsPath&&(O=!0,L[y.fsPath]=!0)}),{folderQueries:w,includePattern:L,usingSearchPaths:!0,excludePattern:O?void 0:{"**/*":!0}}}isCaseSensitive(h,w){if(w.isSmartCase){if(h.isRegExp){if(F.containsUppercaseCharacter(h.pattern,!0))return!0}else if(F.containsUppercaseCharacter(h.pattern))return!0}return!!h.isCaseSensitive}isMultiline(h){return h.isMultiline||h.isRegExp&&(0,b.isMultilineRegexSource)(h.pattern)||h.pattern.indexOf(`
`)>=0?!0:!!h.isMultiline}parseSearchPaths(h){const w=$=>S.isAbsolute($)||/^\.\.?([\/\\]|$)/.test($),L=(Array.isArray(h)?h:s(h)).map($=>{const U=this.pathService.resolvedUserHome;return U?(0,A.untildify)($,U.scheme===k.Schemas.file?U.fsPath:U.path):$}),O=i.groupBy(L,$=>w($)?"searchPaths":"exprSegments"),y=(O.exprSegments||[]).map($=>F.rtrim($,"/")).map($=>F.rtrim($,"\\")).map($=>($[0]==="."&&($="*"+$),t($))),H={},M=this.expandSearchPathPatterns(O.searchPaths||[]);M&&M.length&&(H.searchPaths=M);const j=f.flatten(y),X=E(...j);return X&&(H.pattern=X),H}getExcludesForFolder(h,w){return w.disregardExcludeSettings?void 0:(0,c.getExcludes)(h,!w.disregardSearchExcludeSettings)}expandSearchPathPatterns(h){if(!h||!h.length)return[];const w=f.flatten(h.map(L=>{let{pathPortion:O,globPortion:y}=a(L);y&&(y=n(y));const H=this.expandOneSearchPath(O);return f.flatten(H.map(M=>this.resolveOneSearchPathPattern(M,y)))})),T=new Map;return w.forEach(L=>{const O=L.searchPath.toString(),y=T.get(O);y?L.pattern&&(y.pattern=y.pattern||{},y.pattern[L.pattern]=!0):T.set(O,{searchPath:L.searchPath,pattern:L.pattern?E(L.pattern):void 0})}),Array.from(T.values())}expandOneSearchPath(h){if(S.isAbsolute(h)){const w=this.workspaceContextService.getWorkspace().folders;return w[0]&&w[0].uri.scheme!==k.Schemas.file?[{searchPath:w[0].uri.with({path:h})}]:[{searchPath:v.URI.file(S.normalize(h))}]}if(this.workspaceContextService.getWorkbenchState()===2){const w=this.workspaceContextService.getWorkspace().folders[0].uri;if(h=r(h),h.startsWith("../")||h===".."){const L=S.posix.resolve(w.path,h);return[{searchPath:w.with({path:L})}]}const T=n(h);return[{searchPath:w,pattern:T}]}else{if(h==="./"||h===".\\")return[];{const w=h.replace(/^\.[\/\\]/,""),L=this.workspaceContextService.getWorkspace().folders.map(O=>{const y=w.match(new RegExp(`^${F.escapeRegExpCharacters(O.name)}(?:/(.*)|$)`));return y?{match:y,folder:O}:null}).filter(D.isDefined);if(L.length)return L.map(O=>{const y=O.match[1];return{searchPath:O.folder.uri,pattern:y&&n(y)}});{const O=h.match(/\.[\/\\](.+)[\/\\]?/),y=O?O[1]:h,H=g.localize(0,null,y);throw new Error(H)}}}}resolveOneSearchPathPattern(h,w){const T=h.pattern&&w?`${h.pattern}/${w}`:h.pattern||w,L=[{searchPath:h.searchPath,pattern:T}];return T&&!T.endsWith("**")&&L.push({searchPath:h.searchPath,pattern:T+"/**"}),L}getFolderQueryForSearchPath(h,w,T){const L=this.getFolderQueryForRoot((0,P.toWorkspaceFolder)(h.searchPath),w,T,!1);return L?{...L,includePattern:h.pattern}:null}getFolderQueryForRoot(h,w,T,L){let O;const y=v.URI.isUri(h)?h:h.uri;if(T.searchPaths){const $=T.searchPaths.filter(U=>(0,R.isEqual)(U.searchPath,y))[0];if($&&!$.pattern)return null;$&&(O=$.pattern)}const H=this.configurationService.getValue({resource:y}),j={...this.getExcludesForFolder(H,w)||{},...O||{}},X=v.URI.isUri(h)?(0,R.basename)(h):h.name;return{folder:y,folderName:L?X:void 0,excludePattern:Object.keys(j).length>0?j:void 0,fileEncoding:H.files&&H.files.encoding,disregardIgnoreFiles:typeof w.disregardIgnoreFiles=="boolean"?w.disregardIgnoreFiles:!H.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof w.disregardGlobalIgnoreFiles=="boolean"?w.disregardGlobalIgnoreFiles:!H.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof w.disregardParentIgnoreFiles=="boolean"?w.disregardParentIgnoreFiles:!H.search.useParentIgnoreFiles,ignoreSymlinks:typeof w.ignoreSymlinks=="boolean"?w.ignoreSymlinks:!H.search.followSymlinks}}};u=Be([Fe(0,d.IConfigurationService),Fe(1,P.IWorkspaceContextService),Fe(2,_.IEditorGroupsService),Fe(3,p.ILogService),Fe(4,l.IPathService)],u),e.QueryBuilder=u;function a(m){const h=m.match(/[\*\{\}\(\)\[\]\?]/);if(h){const w=h.index,T=m.substr(0,w).match(/[/|\\][^/\\]*$/);if(T){let L=m.substr(0,T.index);return L.match(/[/\\]/)||(L+="/"),{pathPortion:L,globPortion:m.substr((T.index||0)+1)}}}return{pathPortion:m}}function E(...m){return m.length?m.reduce((h,w)=>(h[w]=!0,h),Object.create(null)):void 0}function s(m){return I.splitGlobAware(m,",").map(h=>h.trim()).filter(h=>!!h.length)}function t(m){return[`**/${m}/**`,`**/${m}`].map(w=>w.replace(/\*\*\/\*\*/g,"**"))}function r(m){return m.replace(/\\/g,"/")}function n(m){return r(m).replace(/^\.\//,"").replace(/\/+$/g,"")}function o(m,h){m=f.distinct(m,L=>L.toString());const w=[],T=h.getWorkspace();return m&&m.forEach(L=>{let O;if(h.getWorkbenchState()===2)O=(0,R.relativePath)(T.folders[0].uri,L),O&&O!=="."&&(O="./"+O);else{const y=h.getWorkspaceFolder(L);if(y){const H=y.name;if(T.folders.filter(j=>j.name===H).length===1){const j=(0,R.relativePath)(y.uri,L);j===""?O=`./${y.name}`:O=`./${y.name}/${j}`}else O=L.fsPath}}O&&w.push(O)}),w}e.resolveResourcesForSearchIncludes=o}),define(ve[269],we([1,0,23,2,21,15,4,268,31,43]),function(te,e,f,i,I,A,C,k,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const F=7e3;function D(d,p){const P=p.activationEvents;if(!P)return Promise.resolve(void 0);const _=[],l=[];for(const t of P)if(/^workspaceContains:/.test(t)){const r=t.substr("workspaceContains:".length);r.indexOf("*")>=0||r.indexOf("?")>=0||d.forceUsingSearch?l.push(r):_.push(r)}if(_.length===0&&l.length===0)return Promise.resolve(void 0);let c;const u=new Promise((t,r)=>{c=t}),a=t=>c({activationEvent:t}),E=Promise.all(_.map(t=>v(d,t,a))).then(()=>{}),s=b(d,p.identifier,l,a);return Promise.all([E,s]).then(()=>{c(void 0)}),u}e.checkActivateWorkspaceContainsExtension=D;async function v(d,p,P){for(const _ of d.folders)if(await d.exists(f.joinPath(i.URI.revive(_),p))){P(`workspaceContains:${p}`);return}}async function b(d,p,P,_){if(P.length===0)return Promise.resolve(void 0);const l=new I.CancellationTokenSource,c=d.checkExists(d.folders,P,l.token),u=setTimeout(async()=>{l.cancel(),d.logService.info(`Not activating extension '${p.value}': Timed out while searching for 'workspaceContains' pattern ${P.join(",")}`)},F);let a=!1;try{a=await c}catch(E){A.isCancellationError(E)||A.onUnexpectedError(E)}l.dispose(),clearTimeout(u),a&&_(`workspaceContains:${P.join(",")}`)}function g(d,p,P,_){const l=d.get(C.IInstantiationService),c=d.get(S.ISearchService),a=l.createInstance(k.QueryBuilder).file(p.map(E=>(0,R.toWorkspaceFolder)(i.URI.revive(E))),{_reason:"checkExists",includePattern:P,exists:!0});return c.fileSearch(a,_).then(E=>!!E.limitHit,E=>A.isCancellationError(E)?!1:Promise.reject(E))}e.checkGlobFileExists=g});var Xe=this&&this.__classPrivateFieldSet||function(te,e,f,i,I){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!I:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?I.call(te,f):I?I.value=f:e.set(te,f),f},Pe=this&&this.__classPrivateFieldGet||function(te,e,f,i){if(f==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!i:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?i:f==="a"?i.call(te):i?i.value:e.get(te)};define(ve[40],we([1,0,167,9,70,23,16,6,24,2,11,5,37,225,87,36,30,224,15,27,22,199,7,120,4,26,66,17,80,51,34,3,269,86,201,10]),function(te,e,f,i,I,A,C,k,S,R,F,D,v,b,g,d,p,P,_,l,c,u,a,E,s,t,r,n,o,m,h,w,T,L,O,y){"use strict";var H,M,j;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,s.createDecorator)("IHostUtils");let X=class Gi extends k.Disposable{constructor(G,ee,oe,ue,Z,Y,se,de,ge,Te){super();this._onDidChangeRemoteConnectionData=this._register(new w.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=ee,this._extHostContext=oe,this._initData=se,this._extHostWorkspace=ue,this._extHostConfiguration=Z,this._logService=Y,this._extHostTunnelService=ge,this._extHostTerminalService=Te,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(D.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(D.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(D.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new C.Barrier,this._readyToStartExtensionHost=new C.Barrier,this._readyToRunExtensions=new C.Barrier,this._eagerExtensionsActivated=new C.Barrier,this._registry=new P.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new g.ExtHostStorage(this._extHostContext),this._secretState=new L.ExtHostSecretState(this._extHostContext),this._storagePath=de,this._instaService=G.createChild(new o.ServiceCollection([g.IExtHostStorage,this._storage],[L.IExtHostSecretState,this._secretState]));const Ne=new Set;this._initData.hostExtensions.forEach(be=>Ne.add(l.ExtensionIdentifier.toKey(be))),this._activator=this._register(new b.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(be,Ee,z)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(be,_.transformErrorForSerialization(Ee),z)},actualActivateExtension:async(be,Ee)=>{if(Ne.has(l.ExtensionIdentifier.toKey(be)))return await this._mainThreadExtensionsProxy.$activateExtension(be,Ee),new b.HostExtension;const z=this._registry.getExtensionDescription(be);return this._activateExtension(z,Ee)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),I.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(G){_.onUnexpectedError(G)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let G=[];try{G=this._registry.getAllExtensionDescriptions().map(Z=>Z.identifier).filter(Z=>this.isActivated(Z)).map(Z=>this._deactivate(Z))}catch{}await Promise.all(G)}isActivated(G){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(G):!1}_activateByEvent(G,ee){return this._activator.activateByEvent(G,ee)}_activateById(G,ee){return this._activator.activateById(G,ee)}activateByIdWithErrors(G,ee){return this._activateById(G,ee).then(()=>{const oe=this._activator.getActivatedExtension(G);if(oe.activationFailed)return Promise.reject(oe.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(G=>this._registry)}getExtensionExports(G){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(G).exports:null}async _realPathExtensionUri(G){if(G.scheme!==y.Schemas.file)return G;const ee=await this._hostUtils.realpath(G.fsPath);return R.URI.file(ee)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=(async()=>{const G=S.TernarySearchTree.forUris(ee=>A.extUriBiasedIgnorePathCase.ignorePathCasing(ee));for(const ee of this._registry.getAllExtensionDescriptions())if(this._getEntryPoint(ee)){const oe=await this._realPathExtensionUri(ee.extensionLocation);G.set(oe,ee)}return G})()),this._extensionPathIndex}_deactivate(G){let ee=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(G))return ee;const oe=this._activator.getActivatedExtension(G);if(!oe)return ee;try{typeof oe.module.deactivate=="function"&&(ee=Promise.resolve(oe.module.deactivate()).then(void 0,ue=>(this._logService.error(ue),Promise.resolve(void 0))))}catch(ue){this._logService.error(`An error occurred when deactivating the extension '${G.value}':`),this._logService.error(ue)}try{(0,k.dispose)(oe.subscriptions)}catch(ue){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${G.value}':`),this._logService.error(ue)}return ee}async _activateExtension(G,ee){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(G.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(G.identifier),this._doActivateExtension(G,ee).then(oe=>{const ue=oe.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(G.identifier,ue.codeLoadingTime,ue.activateCallTime,ue.activateResolvedTime,ee),this._logExtensionActivationTimes(G,ee,"success",ue),oe},oe=>{throw this._logExtensionActivationTimes(G,ee,"failure"),oe})}_logExtensionActivationTimes(G,ee,oe,ue){const Z=$(G,ee);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...Z,...ue||{},outcome:oe})}_doActivateExtension(G,ee){const oe=$(G,ee);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",oe);const ue=this._getEntryPoint(G);if(!ue)return Promise.resolve(new b.EmptyExtension(b.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${G.identifier.value}, startup: ${ee.startup}, activationEvent: '${ee.activationEvent}'${G.identifier.value!==ee.extensionId.value?`, root cause: ${ee.extensionId.value}`:""}`),this._logService.flush();const Z=new b.ExtensionActivationTimesBuilder(ee.startup);return Promise.all([this._loadCommonJSModule(G.identifier,(0,A.joinPath)(G.extensionLocation,ue),Z),this._loadExtensionContext(G)]).then(Y=>(I.mark(`code/extHost/willActivateExtension/${G.identifier.value}`),Gi._callActivate(this._logService,G.identifier,Y[0],Y[1],Z))).then(Y=>(I.mark(`code/extHost/didActivateExtension/${G.identifier.value}`),Y))}_loadExtensionContext(G){const ee=new u.ExtensionGlobalMemento(G,this._storage),oe=new u.ExtensionMemento(G.identifier.value,!1,this._storage),ue=new O.ExtensionSecrets(G,this._secretState),Z=G.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?a.ExtensionMode.Test:a.ExtensionMode.Development:a.ExtensionMode.Production,Y=this._initData.remote.isRemote?a.ExtensionKind.Workspace:a.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${G.identifier.value}`),Promise.all([ee.whenReady,oe.whenReady,this._storagePath.whenReady]).then(()=>{const se=this;let de,ge;const Te=(0,p.isProposedApiEnabled)(G,"ipc")?this._initData.messagePorts?.get(l.ExtensionIdentifier.toKey(G.identifier)):void 0;return Object.freeze({globalState:ee,workspaceState:oe,secrets:ue,subscriptions:[],get extensionUri(){return G.extensionLocation},get extensionPath(){return G.extensionLocation.fsPath},asAbsolutePath(Ne){return i.join(G.extensionLocation.fsPath,Ne)},get storagePath(){return se._storagePath.workspaceValue(G)?.fsPath},get globalStoragePath(){return se._storagePath.globalValue(G).fsPath},get logPath(){return i.join(se._initData.logsLocation.fsPath,G.identifier.value)},get logUri(){return R.URI.joinPath(se._initData.logsLocation,G.identifier.value)},get storageUri(){return se._storagePath.workspaceValue(G)},get globalStorageUri(){return se._storagePath.globalValue(G)},get extensionMode(){return Z},get extension(){return de===void 0&&(de=new U(se,G.identifier,G,Y)),de},get extensionRuntime(){return(0,p.checkProposedApiEnabled)(G,"extensionRuntime"),se.extensionRuntime},get environmentVariableCollection(){return se._extHostTerminalService.getEnvironmentVariableCollection(G)},get messagePassingProtocol(){if(!ge){if(!Te)return;const Ne=w.Event.buffer(w.Event.fromDOMEventEmitter(Te,"message",be=>be.data));Te.start(),ge={onDidReceiveMessage:Ne,postMessage:Te.postMessage.bind(Te)}}return ge}})})}static _callActivate(G,ee,oe,ue,Z){return oe=oe||{activate:void 0,deactivate:void 0},this._callActivateOptional(G,ee,oe,ue,Z).then(Y=>new b.ActivatedExtension(!1,null,Z.build(),oe,Y,ue.subscriptions))}static _callActivateOptional(G,ee,oe,ue,Z){if(typeof oe.activate=="function")try{Z.activateCallStart(),G.trace(`ExtensionService#_callActivateOptional ${ee.value}`);const Y=typeof global=="object"?global:self,se=oe.activate.apply(Y,[ue]);return Z.activateCallStop(),Z.activateResolveStart(),Promise.resolve(se).then(de=>(Z.activateResolveStop(),de))}catch(Y){return Promise.reject(Y)}else return Promise.resolve(oe)}_activateOneStartupFinished(G,ee){this._activateById(G.identifier,{startup:!1,extensionId:G.identifier,activationEvent:ee}).then(void 0,oe=>{this._logService.error(oe)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(I.getMarks());for(const G of this._registry.getAllExtensionDescriptions())if(G.activationEvents)for(const ee of G.activationEvents)ee==="onStartupFinished"&&this._activateOneStartupFinished(G,ee)}_handleEagerExtensions(){const G=this._activateByEvent("*",!0).then(void 0,Z=>{this._logService.error(Z)});this._register(this._extHostWorkspace.onDidChangeWorkspace(Z=>this._handleWorkspaceContainsEagerExtensions(Z.added)));const ee=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],oe=this._handleWorkspaceContainsEagerExtensions(ee),ue=Promise.all([G,oe]).then(()=>{});return Promise.race([ue,(0,C.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),ue}_handleWorkspaceContainsEagerExtensions(G){return G.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(ee=>this._handleWorkspaceContainsEagerExtension(G,ee))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(G,ee){if(this.isActivated(ee.identifier))return;const oe=!this._initData.remote.isRemote&&!!this._initData.remote.authority,ue={logService:this._logService,folders:G.map(Y=>Y.uri),forceUsingSearch:oe,exists:Y=>this._hostUtils.exists(Y.fsPath),checkExists:(Y,se,de)=>this._mainThreadWorkspaceProxy.$checkExists(Y,se,de)},Z=await(0,T.checkActivateWorkspaceContainsExtension)(ue,ee);if(!!Z)return this._activateById(ee.identifier,{startup:!0,extensionId:ee.identifier,activationEvent:Z.activationEvent}).then(void 0,Y=>this._logService.error(Y))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(G){throw console.error(G),G}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:G,extensionTestsLocationURI:ee}=this._initData.environment;if(!G||!ee)throw new Error(f.localize(0,null));const oe=await this._loadCommonJSModule(null,ee,new b.ExtensionActivationTimesBuilder(!1));if(!oe||typeof oe.run!="function")throw new Error(f.localize(1,null,ee.toString()));return new Promise((ue,Z)=>{const Y=(ge,Te)=>{ge?Z(ge):ue(typeof Te=="number"&&Te>0?1:0)},se=(0,A.originalFSPath)(ee),de=oe.run(se,Y);de&&de.then&&de.then(()=>{ue(0)}).catch(ge=>{Z(ge instanceof Error&&ge.stack?ge.stack:String(ge))})})}async $extensionTestsExit(G){this._logService.info(`Extension host terminating: test runner requested exit with code ${G}`),this._hostUtils.pid&&this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${G}`),this._logService.flush(),this._hostUtils.exit(G)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(G,ee){return this._resolvers[G]=ee,(0,k.toDisposable)(()=>{delete this._resolvers[G]})}async _activateAndGetResolver(G){const ee=G.indexOf("+");if(ee===-1)throw new Error("Not an authority that can be resolved!");const oe=G.substr(0,ee);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${oe}`,!1),{authorityPrefix:oe,resolver:this._resolvers[oe]}}async $resolveAuthority(G,ee){this._logService.info(`$resolveAuthority invoked for authority (${q(G)})`);const{authorityPrefix:oe,resolver:ue}=await this._activateAndGetResolver(G);if(!ue)return{type:"error",error:{code:E.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${oe}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelFactory(ue)),I.mark(`code/extHost/willResolveAuthority/${oe}`);const Z=await ue.resolve(G,{resolveAttempt:ee});I.mark(`code/extHost/didResolveAuthorityOK/${oe}`);const Y={authority:G,host:Z.host,port:Z.port,connectionToken:Z.connectionToken},se={extensionHostEnv:Z.extensionHostEnv,isTrusted:Z.isTrusted,authenticationSession:Z.authenticationSessionForInitializingExtensions?{id:Z.authenticationSessionForInitializingExtensions.id,providerId:Z.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:Y,options:se,tunnelInformation:{environmentTunnels:Z.environmentTunnels,features:Z.tunnelFeatures}}}}catch(Z){if(I.mark(`code/extHost/didResolveAuthorityError/${oe}`),Z instanceof a.RemoteAuthorityResolverError)return{type:"error",error:{code:Z._code,message:Z._message,detail:Z._detail}};throw Z}}async $getCanonicalURI(G,ee){this._logService.info(`$getCanonicalURI invoked for authority (${q(G)})`);const{authorityPrefix:oe,resolver:ue}=await this._activateAndGetResolver(G);if(!ue)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${oe}`);const Z=R.URI.revive(ee);if(typeof ue.getCanonicalURI=="undefined")return Z;const Y=await(0,C.asPromise)(()=>ue.getCanonicalURI(Z));return Y||Z}$startExtensionHost(G){return this._registry.keepOnly(G),this._startExtensionHost()}$activateByEvent(G,ee){return ee===1?this._activateByEvent(G,!1):this._readyToRunExtensions.wait().then(oe=>this._activateByEvent(G,!1))}async $activate(G,ee){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(G)?(await this._activateById(G,ee),!0):!1}async $deltaExtensions(G,ee){G.forEach(ue=>ue.extensionLocation=R.URI.revive(ue.extensionLocation));const oe=await this.getExtensionPathIndex();return await Promise.all(ee.map(async ue=>{const Z=this._registry.getExtensionDescription(ue);Z&&oe.delete(await this._realPathExtensionUri(Z.extensionLocation))})),await Promise.all(G.map(async ue=>{const Z=await this._realPathExtensionUri(ue.extensionLocation);oe.set(Z,ue)})),this._registry.deltaExtensions(G,ee),Promise.resolve(void 0)}async $test_latency(G){return G}async $test_up(G){return G.byteLength}async $test_down(G){let ee=c.VSBuffer.alloc(G),oe=Math.random()%256;for(let ue=0;ue<G;ue++)ee.writeUInt8(oe,ue);return ee}async $updateRemoteConnectionData(G){this._remoteConnectionData=G,this._onDidChangeRemoteConnectionData.fire()}};X=Be([Fe(0,s.IInstantiationService),Fe(1,e.IHostUtils),Fe(2,n.IExtHostRpcService),Fe(3,d.IExtHostWorkspace),Fe(4,v.IExtHostConfiguration),Fe(5,F.ILogService),Fe(6,t.IExtHostInitDataService),Fe(7,r.IExtensionStoragePaths),Fe(8,m.IExtHostTunnelService),Fe(9,h.IExtHostTerminalService)],X),e.AbstractExtHostExtensionService=X;function $(K,G){return{id:K.identifier.value,name:K.name,extensionVersion:K.version,publisherDisplayName:K.publisher,activationEvents:K.activationEvents?K.activationEvents.join(","):null,isBuiltin:K.isBuiltin,reason:G.activationEvent,reasonId:G.extensionId.value}}e.IExtHostExtensionService=(0,s.createDecorator)("IExtHostExtensionService");class U{constructor(G,ee,oe,ue){H.set(this,void 0),M.set(this,void 0),j.set(this,void 0),Xe(this,H,G,"f"),Xe(this,M,ee,"f"),Xe(this,j,oe.identifier,"f"),this.id=oe.identifier.value,this.extensionUri=oe.extensionLocation,this.extensionPath=i.normalize((0,A.originalFSPath)(oe.extensionLocation)),this.packageJSON=oe,this.extensionKind=ue}get isActive(){return Pe(this,H,"f").isActivated(Pe(this,j,"f"))}get exports(){if(this.packageJSON.api!=="none")return Pe(this,H,"f").getExtensionExports(Pe(this,j,"f"))}activate(){return Pe(this,H,"f").activateByIdWithErrors(Pe(this,j,"f"),{startup:!1,extensionId:Pe(this,M,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=U,H=new WeakMap,M=new WeakMap,j=new WeakMap;function q(K){const G=K.indexOf("+");return G===-1?K:K.substring(0,G)}}),define(ve[54],we([1,0,9,2,3,16,5,7,126,36,40,45,217,37,210,17,4,13,41,53]),function(te,e,f,i,I,A,C,k,S,R,F,D,v,b,g,d,p,P,_,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,p.createDecorator)("IExtHostDebugService");let c=class{constructor(o,m,h,w,T,L){this._workspaceService=m,this._extensionService=h,this._editorsService=w,this._configurationService=T,this._editorTabs=L,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new I.Emitter,this._onDidTerminateDebugSession=new I.Emitter,this._onDidChangeActiveDebugSession=new I.Emitter,this._onDidReceiveDebugSessionCustomEvent=new I.Emitter,this._debugServiceProxy=o.getProxy(C.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new I.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new a(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(O=>{O.onDidChange(y=>{this.registerAllDebugTypes(O)}),this.registerAllDebugTypes(O)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(o,m){const h=o;if(typeof h.sourceReference=="number"&&h.sourceReference>0){let w=`debug:${encodeURIComponent(h.path||"")}`,T="?";return m&&(w+=`${T}session=${encodeURIComponent(m.id)}`,T="&"),w+=`${T}ref=${h.sourceReference}`,i.URI.parse(w)}else{if(h.path)return i.URI.file(h.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(o){const m=[];for(const h of o.getAllExtensionDescriptions())if(h.contributes){const w=h.contributes.debuggers;if(w&&w.length>0)for(const T of w)(0,g.isDebuggerMainContribution)(T)&&m.push(T.type)}this._debugServiceProxy.$registerDebugTypes(m)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const o=[];return this._breakpoints.forEach(m=>o.push(m)),o}addBreakpoints(o){this.startBreakpoints();const m=o.filter(T=>{const L=T.id;return this._breakpoints.has(L)?!1:(this._breakpoints.set(L,T),!0)});this.fireBreakpointChanges(m,[],[]);const h=[],w=new Map;for(const T of m)if(T instanceof k.SourceBreakpoint){let L=w.get(T.location.uri.toString());L||(L={type:"sourceMulti",uri:T.location.uri,lines:[]},w.set(T.location.uri.toString(),L),h.push(L)),L.lines.push({id:T.id,enabled:T.enabled,condition:T.condition,hitCondition:T.hitCondition,logMessage:T.logMessage,line:T.location.range.start.line,character:T.location.range.start.character})}else T instanceof k.FunctionBreakpoint&&h.push({type:"function",id:T.id,enabled:T.enabled,hitCondition:T.hitCondition,logMessage:T.logMessage,condition:T.condition,functionName:T.functionName});return this._debugServiceProxy.$registerBreakpoints(h)}removeBreakpoints(o){this.startBreakpoints();const m=o.filter(L=>this._breakpoints.delete(L.id));this.fireBreakpointChanges([],m,[]);const h=m.filter(L=>L instanceof k.SourceBreakpoint).map(L=>L.id),w=m.filter(L=>L instanceof k.FunctionBreakpoint).map(L=>L.id),T=m.filter(L=>L instanceof k.DataBreakpoint).map(L=>L.id);return this._debugServiceProxy.$unregisterBreakpoints(h,w,T)}startDebugging(o,m,h){return this._debugServiceProxy.$startDebugging(o?o.uri:void 0,m,{parentSessionID:h.parentSession?h.parentSession.id:void 0,lifecycleManagedByParent:h.lifecycleManagedByParent,repl:h.consoleMode===k.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:h.noDebug,compact:h.compact,debugUI:h.debugUI,suppressSaveBeforeStart:h.suppressSaveBeforeStart})}stopDebugging(o){return this._debugServiceProxy.$stopDebugging(o?o.id:void 0)}registerDebugConfigurationProvider(o,m,h){if(!m)return new k.Disposable(()=>{});const w=this._configProviderHandleCounter++;return this._configProviders.push({type:o,handle:w,provider:m}),this._debugServiceProxy.$registerDebugConfigurationProvider(o,h,!!m.provideDebugConfigurations,!!m.resolveDebugConfiguration,!!m.resolveDebugConfigurationWithSubstitutedVariables,w),new k.Disposable(()=>{this._configProviders=this._configProviders.filter(T=>T.provider!==m),this._debugServiceProxy.$unregisterDebugConfigurationProvider(w)})}registerDebugAdapterDescriptorFactory(o,m,h){if(!h)return new k.Disposable(()=>{});if(!this.definesDebugType(o,m))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${m}' debugger.`);if(this.getAdapterDescriptorFactoryByType(m))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const w=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:m,handle:w,factory:h}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(m,w),new k.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(T=>T.factory!==h),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(w)})}registerDebugAdapterTrackerFactory(o,m){if(!m)return new k.Disposable(()=>{});const h=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:o,handle:h,factory:m}),new k.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(w=>w.factory!==m)})}async $runInTerminal(o,m){return Promise.resolve(void 0)}async $substituteVariables(o,m){if(!this._variableResolver){const[T,L]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(T||[],this._editorsService,L)}let h;const w=await this.getFolder(o);return w&&(h={uri:w.uri,name:w.name,index:w.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(h,m)}createDebugAdapter(o,m){if(o.type==="implementation")return new t(o.implementation)}createSignService(){}async $startDASession(o,m){const h=this,w=await this.getSession(m);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(w.type),w).then(T=>{if(!T)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${w.type}' (extension might have failed to activate)`);const L=this.convertToDto(T),O=this.createDebugAdapter(L,w);if(!O)throw new Error(`Couldn't create a debug adapter for type '${w.type}'.`);const y=O;return this._debugAdapters.set(o,y),this.getDebugAdapterTrackers(w).then(H=>(H&&this._debugAdaptersTrackers.set(o,H),y.onMessage(async M=>{if(M.type==="request"&&M.command==="handshake"){const j=M,X={type:"response",seq:0,command:j.command,request_seq:j.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const $=await this._signService.sign(j.arguments.value);X.body={signature:$},y.sendResponse(X)}else throw new Error("no signer")}catch($){X.success=!1,X.message=$.message,y.sendResponse(X)}}else H&&H.onDidSendMessage&&H.onDidSendMessage(M),M=(0,g.convertToVSCPaths)(M,!0),h._debugServiceProxy.$acceptDAMessage(o,M)}),y.onError(M=>{H&&H.onError&&H.onError(M),this._debugServiceProxy.$acceptDAError(o,M.name,M.message,M.stack)}),y.onExit(M=>{H&&H.onExit&&H.onExit((0,P.withNullAsUndefined)(M),void 0),this._debugServiceProxy.$acceptDAExit(o,(0,P.withNullAsUndefined)(M),void 0)}),H&&H.onWillStartSession&&H.onWillStartSession(),y.startSession()))})}$sendDAMessage(o,m){m=(0,g.convertToDAPaths)(m,!1);const h=this._debugAdaptersTrackers.get(o);h&&h.onWillReceiveMessage&&h.onWillReceiveMessage(m);const w=this._debugAdapters.get(o);w&&w.sendMessage(m)}$stopDASession(o){const m=this._debugAdaptersTrackers.get(o);this._debugAdaptersTrackers.delete(o),m&&m.onWillStopSession&&m.onWillStopSession();const h=this._debugAdapters.get(o);return this._debugAdapters.delete(o),h?h.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(o){const m=[],h=[],w=[];if(o.added)for(const T of o.added){const L=T.id;if(L&&!this._breakpoints.has(L)){let O;if(T.type==="function")O=new k.FunctionBreakpoint(T.functionName,T.enabled,T.condition,T.hitCondition,T.logMessage);else if(T.type==="data")O=new k.DataBreakpoint(T.label,T.dataId,T.canPersist,T.enabled,T.hitCondition,T.condition,T.logMessage);else{const y=i.URI.revive(T.uri);O=new k.SourceBreakpoint(new k.Location(y,new k.Position(T.line,T.character)),T.enabled,T.condition,T.hitCondition,T.logMessage)}O._id=L,this._breakpoints.set(L,O),m.push(O)}}if(o.removed)for(const T of o.removed){const L=this._breakpoints.get(T);L&&(this._breakpoints.delete(T),h.push(L))}if(o.changed){for(const T of o.changed)if(T.id){const L=this._breakpoints.get(T.id);if(L){if(L instanceof k.FunctionBreakpoint&&T.type==="function"){const O=L;O.enabled=T.enabled,O.condition=T.condition,O.hitCondition=T.hitCondition,O.logMessage=T.logMessage,O.functionName=T.functionName}else if(L instanceof k.SourceBreakpoint&&T.type==="source"){const O=L;O.enabled=T.enabled,O.condition=T.condition,O.hitCondition=T.hitCondition,O.logMessage=T.logMessage,O.location=new k.Location(i.URI.revive(T.uri),new k.Position(T.line,T.character))}w.push(L)}}}this.fireBreakpointChanges(m,h,w)}$provideDebugConfigurations(o,m,h){return(0,A.asPromise)(async()=>{const w=this.getConfigProviderByHandle(o);if(!w)throw new Error("no DebugConfigurationProvider found");if(!w.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const T=await this.getFolder(m);return w.provideDebugConfigurations(T,h)}).then(w=>{if(!w)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return w})}$resolveDebugConfiguration(o,m,h,w){return(0,A.asPromise)(async()=>{const T=this.getConfigProviderByHandle(o);if(!T)throw new Error("no DebugConfigurationProvider found");if(!T.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const L=await this.getFolder(m);return T.resolveDebugConfiguration(L,h,w)})}$resolveDebugConfigurationWithSubstitutedVariables(o,m,h,w){return(0,A.asPromise)(async()=>{const T=this.getConfigProviderByHandle(o);if(!T)throw new Error("no DebugConfigurationProvider found");if(!T.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const L=await this.getFolder(m);return T.resolveDebugConfigurationWithSubstitutedVariables(L,h,w)})}async $provideDebugAdapter(o,m){const h=this.getAdapterDescriptorFactoryByHandle(o);if(!h)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const w=await this.getSession(m);return this.getAdapterDescriptor(h,w).then(T=>{if(!T)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${w.type}'`);return this.convertToDto(T)})}async $acceptDebugSessionStarted(o){const m=await this.getSession(o);this._onDidStartDebugSession.fire(m)}async $acceptDebugSessionTerminated(o){const m=await this.getSession(o);m&&(this._onDidTerminateDebugSession.fire(m),this._debugSessions.delete(m.id))}async $acceptDebugSessionActiveChanged(o){this._activeDebugSession=o?await this.getSession(o):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(o,m){const h=await this.getSession(o);h&&h._acceptNameChanged(m)}async $acceptDebugSessionCustomEvent(o,m){const w={session:await this.getSession(o),event:m.event,body:m.body};this._onDidReceiveDebugSessionCustomEvent.fire(w)}convertToDto(o){if(o instanceof k.DebugAdapterExecutable)return{type:"executable",command:o.command,args:o.args,options:o.options};if(o instanceof k.DebugAdapterServer)return{type:"server",port:o.port,host:o.host};if(o instanceof k.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:o.path};if(o instanceof k.DebugAdapterInlineImplementation)return{type:"implementation",implementation:o.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(o){const m=this._adapterFactories.filter(h=>h.type===o);if(m.length>0)return m[0].factory}getAdapterDescriptorFactoryByHandle(o){const m=this._adapterFactories.filter(h=>h.handle===o);if(m.length>0)return m[0].factory}getConfigProviderByHandle(o){const m=this._configProviders.filter(h=>h.handle===o);if(m.length>0)return m[0].provider}definesDebugType(o,m){if(o.contributes){const h=o.contributes.debuggers;if(h&&h.length>0){for(const w of h)if(w.label&&w.type&&w.type===m)return!0}}return!1}getDebugAdapterTrackers(o){const h=o.configuration.type,w=this._trackerFactories.filter(T=>T.type===h||T.type==="*").map(T=>(0,A.asPromise)(()=>T.factory.createDebugAdapterTracker(o)).then(L=>L,L=>null));return Promise.race([Promise.all(w).then(T=>{const L=T.filter(O=>!!O);if(L.length>0)return new s(L)}),new Promise((T,L)=>{const O=setTimeout(()=>{clearTimeout(O),L(new Error("timeout"))},1e3)})]).catch(T=>{})}async getAdapterDescriptor(o,m){const h=m.configuration.debugServer;if(typeof h=="number")return Promise.resolve(new k.DebugAdapterServer(h));if(o){const T=await this._extensionService.getExtensionRegistry();return(0,A.asPromise)(()=>o.createDebugAdapterDescriptor(m,this.daExecutableFromPackage(m,T))).then(L=>{if(L)return L})}const w=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(m,w))}daExecutableFromPackage(o,m){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(o,m,h){(o.length>0||m.length>0||h.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:o,removed:m,changed:h}))}async getSession(o){if(o)if(typeof o=="string"){const m=this._debugSessions.get(o);if(m)return m}else{let m=this._debugSessions.get(o.id);if(!m){const h=await this.getFolder(o.folderUri),w=o.parent?this._debugSessions.get(o.parent):void 0;m=new u(this._debugServiceProxy,o.id,o.type,o.name,h,o.configuration,w),this._debugSessions.set(m.id,m),this._debugServiceProxy.$sessionCached(m.id)}return m}throw new Error("cannot find session")}getFolder(o){if(o){const m=i.URI.revive(o);return this._workspaceService.resolveWorkspaceFolder(m)}return Promise.resolve(void 0)}};c=Be([Fe(0,d.IExtHostRpcService),Fe(1,R.IExtHostWorkspace),Fe(2,F.IExtHostExtensionService),Fe(3,D.IExtHostDocumentsAndEditors),Fe(4,b.IExtHostConfiguration),Fe(5,l.IExtHostEditorTabs)],c),e.ExtHostDebugServiceBase=c;class u{constructor(o,m,h,w,T,L,O){this._debugServiceProxy=o,this._id=m,this._type=h,this._name=w,this._workspaceFolder=T,this._configuration=L,this._parentSession=O}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(o){this._name=o,this._debugServiceProxy.$setDebugSessionName(this._id,o)}get parentSession(){return this._parentSession}_acceptNameChanged(o){this._name=o}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(o,m){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,o,m)}getDebugProtocolBreakpoint(o){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,o.id)}}e.ExtHostDebugSession=u;class a{constructor(o){this.value=Object.freeze({append(m){o.$appendDebugConsole(m)},appendLine(m){this.append(m+`
`)}})}}e.ExtHostDebugConsole=a;class E extends v.AbstractVariableResolverService{constructor(o,m,h,w,T,L){function O(){if(m){const y=m.activeEditor();if(y)return y.document.uri;const H=w.tabGroups.all.find(M=>M.isActive)?.activeTab;if(H!==void 0){const M=H.resource;return M&&(M.primary||M.secondary)?M.primary??M.secondary:H.resource}}}super({getFolderUri:y=>{const H=o.filter(M=>M.name===y);if(H&&H.length>0)return H[0].uri},getWorkspaceFolderCount:()=>o.length,getConfigurationValue:(y,H)=>h.getConfiguration(void 0,y).get(H),getAppRoot:()=>_.cwd(),getExecPath:()=>_.env.VSCODE_EXEC_PATH,getFilePath:()=>{const y=O();if(y)return f.normalize(y.fsPath)},getWorkspaceFolderPathForFile:()=>{if(T){const y=O();if(y){const H=T.getWorkspaceFolder(y);if(H)return f.normalize(H.uri.fsPath)}}},getSelectedText:()=>{if(m){const y=m.activeEditor();if(y&&!y.selection.isEmpty)return y.document.getText(y.selection)}},getLineNumber:()=>{if(m){const y=m.activeEditor();if(y)return String(y.selection.end.line+1)}}},void 0,L?Promise.resolve(L):void 0,Promise.resolve(_.env))}}e.ExtHostVariableResolverService=E;class s{constructor(o){this.trackers=o}onWillStartSession(){this.trackers.forEach(o=>o.onWillStartSession?o.onWillStartSession():void 0)}onWillReceiveMessage(o){this.trackers.forEach(m=>m.onWillReceiveMessage?m.onWillReceiveMessage(o):void 0)}onDidSendMessage(o){this.trackers.forEach(m=>m.onDidSendMessage?m.onDidSendMessage(o):void 0)}onWillStopSession(){this.trackers.forEach(o=>o.onWillStopSession?o.onWillStopSession():void 0)}onError(o){this.trackers.forEach(m=>m.onError?m.onError(o):void 0)}onExit(o,m){this.trackers.forEach(h=>h.onExit?h.onExit(o,m):void 0)}}class t extends S.AbstractDebugAdapter{constructor(o){super();this.implementation=o,o.onDidSendMessage(m=>{this.acceptMessage(m)})}startSession(){return Promise.resolve(void 0)}sendMessage(o){this.implementation.handleMessage(o)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let r=class extends c{constructor(o,m,h,w,T,L){super(o,m,h,w,T,L)}createVariableResolver(o,m,h){return new E(o,m,h,this._editorTabs)}};r=Be([Fe(0,d.IExtHostRpcService),Fe(1,R.IExtHostWorkspace),Fe(2,F.IExtHostExtensionService),Fe(3,D.IExtHostDocumentsAndEditors),Fe(4,b.IExtHostConfiguration),Fe(5,l.IExtHostEditorTabs)],r),e.WorkerExtHostDebugService=r}),define(ve[270],we([1,0,70,2,5,37,30,27,17,26,4,40,41,11,8]),function(te,e,f,i,I,A,C,k,S,R,F,D,v,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let d=class{constructor(u,a,E,s,t,r,n){this._apiFactory=u,this._extensionRegistry=a,this._instaService=E,this._extHostConfiguration=s,this._extHostExtensionService=t,this._initData=r,this._logService=n,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),f.mark("code/extHost/willWaitForConfig");const u=await this._extHostConfiguration.getConfigProvider();f.mark("code/extHost/didWaitForConfig");const a=await this._extHostExtensionService.getExtensionPathIndex();this.register(new P(this._apiFactory,a,this._extensionRegistry,u,this._logService)),this.register(this._instaService.createInstance(_,a)),this.register(this._instaService.createInstance(p)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(l,a,this._initData.environment.appUriScheme))}register(u){if("nodeModuleName"in u)if(Array.isArray(u.nodeModuleName))for(let a of u.nodeModuleName)this._factories.set(a,u);else this._factories.set(u.nodeModuleName,u);typeof u.alternativeModuleName=="function"&&this._alternatives.push(a=>u.alternativeModuleName(a))}};d=Be([Fe(2,F.IInstantiationService),Fe(3,A.IExtHostConfiguration),Fe(4,D.IExtHostExtensionService),Fe(5,R.IExtHostInitDataService),Fe(6,b.ILogService)],d),e.RequireInterceptor=d;let p=class $i{constructor(u){if(u.environment.appRoot&&$i.aliased.size){const a=(0,g.escapeRegExpCharacters)(this.forceForwardSlashes(u.environment.appRoot.fsPath)),E="[a-z0-9_.-]",s=`@${E}+\\/${E}+|${E}+`,t="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${a}/${t}\\/)(${s})(.*)$`,"i")}}alternativeModuleName(u){if(!this.re)return;const a=this.re.exec(this.forceForwardSlashes(u));if(!a)return;const[,E,s,t]=a,r=$i.aliased.get(s);if(r!==void 0)return console.warn(`${s} as been renamed to ${r}, please update your imports`),E+r+t}forceForwardSlashes(u){return u.replace(/\\/g,"/")}};p.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),p=Be([Fe(0,R.IExtHostInitDataService)],p);class P{constructor(u,a,E,s,t){this._apiFactory=u,this._extensionPaths=a,this._extensionRegistry=E,this._configProvider=s,this._logService=t,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(u,a){const E=this._extensionPaths.findSubstr(a);if(E){let s=this._extApiImpl.get(k.ExtensionIdentifier.toKey(E.identifier));return s||(s=this._apiFactory(E,this._extensionRegistry,this._configProvider),this._extApiImpl.set(k.ExtensionIdentifier.toKey(E.identifier),s)),s}if(!this._defaultApiImpl){let s="";this._extensionPaths.forEach((t,r)=>s+=`	${r} -> ${t.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${a}. These are the extension path mappings: 
${s}`),this._defaultApiImpl=this._apiFactory(C.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let _=class{constructor(u,a,E){this._extensionPaths=u,this.nodeModuleName="keytar",this._mainThreadTelemetry=a.getProxy(I.MainContext.MainThreadTelemetry);const{environment:s}=E,t=a.getProxy(I.MainContext.MainThreadKeytar);if(s.appRoot){let r=s.appRoot.fsPath;v.platform==="win32"&&(r=r.replace(/\\/g,"/")),r[r.length-1]==="/"&&(r=r.substr(0,r.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${r}/node_modules.asar/keytar`),this.alternativeNames.add(`${r}/node_modules/keytar`)}this._impl={getPassword:(r,n)=>t.$getPassword(r,n),setPassword:(r,n,o)=>t.$setPassword(r,n,o),deletePassword:(r,n)=>t.$deletePassword(r,n),findPassword:r=>t.$findPassword(r),findCredentials(r){return t.$findCredentials(r)}}}load(u,a){const E=this._extensionPaths.findSubstr(a);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:E?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(u){const a=u.length;if(a<=7||!this.alternativeNames)return;const E=a-7;if((u.charAt(E)==="/"||u.charAt(E)==="\\")&&u.endsWith("keytar")&&(u=u.replace(/\\/g,"/"),this.alternativeNames.has(u)))return"keytar"}};_=Be([Fe(1,S.IExtHostRpcService),Fe(2,R.IExtHostInitDataService)],_);let l=class{constructor(u,a,E){this._extensionPaths=u,this._appUriScheme=a,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=E.getProxy(I.MainContext.MainThreadTelemetry);const s=E.getProxy(I.MainContext.MainThreadWindow);this._impl=(t,r)=>{const n=i.URI.parse(t);return r?this.callOriginal(t,r):n.scheme==="http"||n.scheme==="https"?s.$openUri(n,t,{allowTunneling:!0}):n.scheme==="mailto"||n.scheme===this._appUriScheme?s.$openUri(n,t,{}):this.callOriginal(t,r)}}load(u,a,E){const s=this._extensionPaths.findSubstr(a);return s&&(this._extensionId=s.identifier.value,this.sendShimmingTelemetry()),this._original=E(u),this._impl}callOriginal(u,a){return this.sendNoForwardTelemetry(),this._original(u,a)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};l=Be([Fe(2,S.IExtHostRpcService)],l)}),define(ve[271],we([1,0,16,15,70,6,2,5,264,11,79,80,26,188,17,63,40,34]),function(te,e,f,i,I,A,C,k,S,R,F,D,v,b,g,d,p,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class _{constructor(c,u,a,E,s){this._disposables=new A.DisposableStore,this._isTerminating=!1,this._hostUtils=a,this._rpcProtocol=new S.RPCProtocol(c,null,E),u=_._transform(u,this._rpcProtocol);const t=new D.ServiceCollection(...(0,F.getSingletonServiceDescriptors)());t.set(v.IExtHostInitDataService,{_serviceBrand:void 0,...u,messagePorts:s}),t.set(g.IExtHostRpcService,new g.ExtHostRpcService(this._rpcProtocol)),t.set(d.IURITransformerService,new d.URITransformerService(E)),t.set(p.IHostUtils,a);const r=new b.InstantiationService(t,!0);this._disposables.add(r.invokeFunction(h=>h.get(P.IExtHostTerminalService))),this._disposables.add(r.invokeFunction(h=>h.get(p.IExtHostExtensionService))),this._logService=r.invokeFunction(h=>h.get(R.ILogService)),I.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",u),this._extensionService=r.invokeFunction(h=>h.get(p.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const n=new WeakMap;this._extensionService.getExtensionPathIndex().then(h=>{Error.prepareStackTrace=(w,T)=>{let L="",O,y;for(const H of T)L+=`
	at ${H.toString()}`,y=H.getFileName(),!O&&y&&(O=h.findSubstr(C.URI.file(y)));return n.set(w,O),`${w.name||"Error"}: ${w.message||""}${L}`}});const o=this._rpcProtocol.getProxy(k.MainContext.MainThreadExtensionService),m=this._rpcProtocol.getProxy(k.MainContext.MainThreadErrors);i.setUnexpectedErrorHandler(h=>{const w=i.transformErrorForSerialization(h),T=n.get(h);T?o.$onExtensionRuntimeError(T.identifier,w):m.$onUnexpectedError(w)})}async asBrowserUri(c){const u=this._rpcProtocol.getProxy(k.MainContext.MainThreadExtensionService);return C.URI.revive(await u.$asBrowserUri(c))}terminate(c){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${c}`),this._logService.flush(),this._disposables.dispose(),i.setUnexpectedErrorHandler(a=>{this._logService.error(a)}),this._rpcProtocol.dispose();const u=this._extensionService.deactivateAll();Promise.race([(0,f.timeout)(5e3),u]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code 0`):this._logService.info("Extension host exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})}static _transform(c,u){c.extensions.forEach(E=>E.extensionLocation=C.URI.revive(u.transformIncomingURIs(E.extensionLocation))),c.environment.appRoot=C.URI.revive(u.transformIncomingURIs(c.environment.appRoot));const a=c.environment.extensionDevelopmentLocationURI;return a&&(c.environment.extensionDevelopmentLocationURI=a.map(E=>C.URI.revive(u.transformIncomingURIs(E)))),c.environment.extensionTestsLocationURI=C.URI.revive(u.transformIncomingURIs(c.environment.extensionTestsLocationURI)),c.environment.globalStorageHome=C.URI.revive(u.transformIncomingURIs(c.environment.globalStorageHome)),c.environment.workspaceStorageHome=C.URI.revive(u.transformIncomingURIs(c.environment.workspaceStorageHome)),c.logsLocation=C.URI.revive(u.transformIncomingURIs(c.logsLocation)),c.logFile=C.URI.revive(u.transformIncomingURIs(c.logFile)),c.workspace=u.transformIncomingURIs(c.workspace),c}}e.ExtensionHostMain=_}),define(ve[272],we([1,0,173,60,12,7,211,36,40,45,37,34,17,54,195,16,212,53,187]),function(te,e,f,i,I,A,C,k,S,R,F,D,v,b,g,d,p,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.runInExternalTerminal=e.ExtHostDebugService=void 0;let l=class extends b.ExtHostDebugServiceBase{constructor(s,t,r,n,o,m,h){super(s,t,r,n,o,h);this._terminalService=m,this._integratedTerminalInstances=new a}createDebugAdapter(s,t){switch(s.type){case"server":return new C.SocketDebugAdapter(s);case"pipeServer":return new C.NamedPipeDebugAdapter(s);case"executable":return new C.ExecutableDebugAdapter(s,t.type)}return super.createDebugAdapter(s,t)}daExecutableFromPackage(s,t){const r=C.ExecutableDebugAdapter.platformAdapterExecutable(t.getAllExtensionDescriptions(),s.type);if(r)return new A.DebugAdapterExecutable(r.command,r.args,r.options)}createSignService(){return new g.SignService}async $runInTerminal(s,t){if(s.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(M=>{this._integratedTerminalInstances.onTerminalClosed(M)}));const r=await this._configurationService.getConfigProvider(),n=this._terminalService.getDefaultShell(!0),o=this._terminalService.getDefaultShellArgs(!0),m=s.title||f.localize(0,null),h=JSON.stringify({shell:n,shellArgs:o});let w=await this._integratedTerminalInstances.checkout(h,m),T,L=!1;if(w)T=s.cwd;else{const M={shellPath:n,shellArgs:o,cwd:s.cwd,name:m,iconPath:new A.ThemeIcon("debug")};L=!0,w=this._terminalService.createTerminalFromOptions(M,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(w,h)}w.show(!0);const O=await w.processId;L?await new Promise(M=>setTimeout(M,1e3)):r.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(n.indexOf("powershell")>=0||n.indexOf("pwsh")>=0||n.indexOf("cmd.exe")>=0?w.sendText("cls"):n.indexOf("bash")>=0?w.sendText("clear"):I.isWindows?w.sendText("cls"):w.sendText("clear"));const y=(0,p.prepareCommand)(n,s.args,T,s.env);w.sendText(y);const H=this.onDidTerminateDebugSession(M=>{M.id===t&&(this._integratedTerminalInstances.free(w),H.dispose())});return O}else if(s.kind==="external")return u(s,await this._configurationService.getConfigProvider());return super.$runInTerminal(s,t)}createVariableResolver(s,t,r){return new b.ExtHostVariableResolverService(s,t,r,this._editorTabs,this._workspaceService,(0,i.homedir)())}};l=Be([Fe(0,v.IExtHostRpcService),Fe(1,k.IExtHostWorkspace),Fe(2,S.IExtHostExtensionService),Fe(3,R.IExtHostDocumentsAndEditors),Fe(4,F.IExtHostConfiguration),Fe(5,D.IExtHostTerminalService),Fe(6,P.IExtHostEditorTabs)],l),e.ExtHostDebugService=l;let c;function u(E,s){if(!c)if(I.isWindows)c=new _.WindowsExternalTerminalService;else if(I.isMacintosh)c=new _.MacExternalTerminalService;else if(I.isLinux)c=new _.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const t=s.getConfiguration("terminal");return c.runInTerminal(E.title,E.cwd,E.args,E.env||{},t.external||{})}e.runInExternalTerminal=u;class a{constructor(){this._terminalInstances=new Map}async checkout(s,t){const n=[...this._terminalInstances.entries()].map(([o,m])=>(0,d.createCancelablePromise)(async h=>{if(o.name!==t||m.lastUsedAt!==-1&&await(0,p.hasChildProcesses)(await o.processId))return null;const w=Date.now();return m.lastUsedAt+a.minUseDelay>w||h.isCancellationRequested||m.config!==s?null:(m.lastUsedAt=w,o)}));return await(0,d.firstParallel)(n,o=>!!o)}insert(s,t){this._terminalInstances.set(s,{lastUsedAt:Date.now(),config:t})}free(s){const t=this._terminalInstances.get(s);t&&(t.lastUsedAt=-1)}onTerminalClosed(s){this._terminalInstances.delete(s)}}a.minUseDelay=1e3}),define(ve[273],we([1,0,9,2,112,36,54,45,37,43,34,17,26,69,10,11,64,53,23,60]),function(te,e,f,i,I,A,C,k,S,R,F,D,v,b,g,d,p,P,_,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let c=class extends b.ExtHostTaskBase{constructor(a,E,s,t,r,n,o,m,h){super(a,E,s,t,r,n,o,m);this.workspaceService=s,this.editorTabs=h,E.remote.isRemote&&E.remote.authority?this.registerTaskSystem(g.Schemas.vscodeRemote,{scheme:g.Schemas.vscodeRemote,authority:E.remote.authority,platform:process.platform}):this.registerTaskSystem(g.Schemas.file,{scheme:g.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(a,E){const s=E;if(!E.execution&&s._id===void 0)throw new Error("Tasks to execute must include an execution");if(s._id!==void 0){const t=b.TaskHandleDTO.from(s,this.workspaceService),r=await this._proxy.$getTaskExecution(t);if(r.task===void 0)throw new Error("Task from execution DTO is undefined");const n=await this.getTaskExecution(r,E);return this._proxy.$executeTask(t).catch(()=>{}),n}else{const t=b.TaskDTO.from(E,a);if(t===void 0)return Promise.reject(new Error("Task is not valid"));b.CustomExecutionDTO.is(t.execution)&&await this.addCustomExecution(t,E,!1);const r=await this.getTaskExecution(await this._proxy.$getTaskExecution(t),E);return this._proxy.$executeTask(t).catch(()=>{}),r}}provideTasksInternal(a,E,s,t){const r=[];if(t)for(let n of t){this.checkDeprecation(n,s),(!n.definition||!a[n.definition.type])&&this._logService.warn(`The task [${n.source}, ${n.name}] uses an undefined task type. The task will be ignored in the future.`);const o=b.TaskDTO.from(n,s.extension);o&&(r.push(o),b.CustomExecutionDTO.is(o.execution)&&E.push(this.addCustomExecution(o,n,!0)))}return{tasks:r,extension:s.extension}}async resolveTaskInternal(a){return a}async getVariableResolver(a){if(this._variableResolver===void 0){const E=await this._configurationService.getConfigProvider();this._variableResolver=new C.ExtHostVariableResolverService(a,this._editorService,E,this.editorTabs,this.workspaceService,(0,l.homedir)())}return this._variableResolver}async getAFolder(a){let E=a&&a.length>0?a[0]:void 0;if(!E){const s=i.URI.file((0,l.homedir)());E=new R.WorkspaceFolder({uri:s,name:_.basename(s),index:0})}return{uri:E.uri,name:E.name,index:E.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(a,E){const s=i.URI.revive(a),t={process:void 0,variables:Object.create(null)},r=await this._workspaceProvider.resolveWorkspaceFolder(s),n=await this._workspaceProvider.getWorkspaceFolders2()??[],o=await this.getVariableResolver(n),m=r?{uri:r.uri,name:r.name,index:r.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(n);for(let h of E.variables)t.variables[h]=await o.resolveAsync(m,h);if(E.process!==void 0){let h;if(E.process.path!==void 0){h=E.process.path.split(f.delimiter);for(let w=0;w<h.length;w++)h[w]=await o.resolveAsync(m,h[w])}t.process=await I.win32.findExecutable(await o.resolveAsync(m,E.process.name),E.process.cwd!==void 0?await o.resolveAsync(m,E.process.cwd):void 0,h)}return t}async $jsonTasksSupported(){return!0}async $findExecutable(a,E,s){return I.win32.findExecutable(a,E,s)}};c=Be([Fe(0,D.IExtHostRpcService),Fe(1,v.IExtHostInitDataService),Fe(2,A.IExtHostWorkspace),Fe(3,k.IExtHostDocumentsAndEditors),Fe(4,S.IExtHostConfiguration),Fe(5,F.IExtHostTerminalService),Fe(6,d.ILogService),Fe(7,p.IExtHostApiDeprecationService),Fe(8,P.IExtHostEditorTabs)],c),e.ExtHostTask=c}),define(ve[137],we([1,0,18,16,21,49,32,10,9,23,13,2,31]),function(te,e,f,i,I,A,C,k,S,R,F,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class b{constructor(c,u,a,E){this.query=c,this.provider=u,this.fileUtils=a,this.processType=E,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(c,u){const a=this.query.folderQueries||[],E=new I.CancellationTokenSource;return u.onCancellationRequested(()=>E.cancel()),new Promise((s,t)=>{this.collector=new d(c);let r=!1;const n=(o,m)=>{if(!r&&!this.isLimitHit){const h=this.resultSize(o);P(o)&&typeof this.query.maxResults=="number"&&this.resultCount+h>this.query.maxResults&&(this.isLimitHit=!0,r=!0,E.cancel(),o=this.trimResultToSize(o,this.query.maxResults-this.resultCount));const w=this.resultSize(o);this.resultCount+=w,(w>0||!P(o))&&this.collector.add(o,m)}};Promise.all(a.map((o,m)=>this.searchInFolder(o,h=>n(h,m),E.token))).then(o=>{E.dispose(),this.collector.flush();const m=o.some(h=>!!h&&!!h.limitHit);s({limitHit:this.isLimitHit||m,messages:(0,f.flatten)(o.map(h=>h?.message?(0,F.isArray)(h.message)?h.message:[h.message]:[])),stats:{type:this.processType}})},o=>{E.dispose();const m=(0,A.toErrorMessage)(o);t(new Error(m))})})}resultSize(c){return P(c)?Array.isArray(c.ranges)?c.ranges.length:1:0}trimResultToSize(c,u){const a=Array.isArray(c.ranges)?c.ranges:[c.ranges],E=Array.isArray(c.preview.matches)?c.preview.matches:[c.preview.matches];return{ranges:a.slice(0,u),preview:{matches:E.slice(0,u),text:c.preview.text},uri:c.uri}}async searchInFolder(c,u,a){const E=new v.QueryGlobTester(this.query,c),s=[],t={report:o=>{if(!this.validateProviderResult(o))return;const m=c.folder.scheme===k.Schemas.file?C.hasSiblingPromiseFn(()=>this.fileUtils.readdir(R.dirname(o.uri))):void 0,h=R.relativePath(c.folder,o.uri);if(h){const w=E.includedInQuery(h,S.basename(h),m);(0,i.isThenable)(w)?s.push(w.then(T=>{T&&u(o)})):w&&u(o)}}},r=this.getSearchOptionsForFolder(c),n=await this.provider.provideTextSearchResults(g(this.query.contentPattern),r,t,a);return s.length&&await Promise.all(s),n}validateProviderResult(c){if(P(c)){if(Array.isArray(c.ranges)){if(!Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(c.preview.matches.length!==c.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(c){const u=(0,v.resolvePatternsForProvider)(this.query.includePattern,c.includePattern),a=(0,v.resolvePatternsForProvider)(this.query.excludePattern,c.excludePattern),E={folder:D.URI.from(c.folder),excludes:a,includes:u,useIgnoreFiles:!c.disregardIgnoreFiles,useGlobalIgnoreFiles:!c.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!c.disregardParentIgnoreFiles,followSymlinks:!c.ignoreSymlinks,encoding:c.fileEncoding&&this.fileUtils.toCanonicalName(c.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return E.usePCRE2=this.query.usePCRE2,E}}e.TextSearchManager=b;function g(l){return{isCaseSensitive:l.isCaseSensitive||!1,isRegExp:l.isRegExp||!1,isWordMatch:l.isWordMatch||!1,isMultiline:l.isMultiline||!1,pattern:l.pattern}}class d{constructor(c){this._onResult=c,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new _(512,u=>this.sendItems(u))}add(c,u){this._currentFileMatch&&(this._currentFolderIdx!==u||!R.isEqual(this._currentUri,c.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=u,this._currentFileMatch={resource:c.uri,results:[]}),this._currentFileMatch.results.push(p(c))}pushToCollector(){const c=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,c)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(c){this._onResult(c)}}e.TextSearchResultsCollector=d;function p(l){return P(l)?{preview:{matches:(0,f.mapArrayOrNot)(l.preview.matches,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character})),text:l.preview.text},ranges:(0,f.mapArrayOrNot)(l.ranges,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character}))}:{text:l.text,lineNumber:l.lineNumber}}function P(l){return!!l.preview}e.extensionResultIsMatch=P;class _{constructor(c,u){this.maxBatchSize=c,this.cb=u,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(c,u){!c||this.addItemToBatch(c,u)}addItems(c,u){!c||this.addItemsToBatch(c,u)}addItemToBatch(c,u){this.batch.push(c),this.batchSize+=u,this.onUpdate()}addItemsToBatch(c,u){this.batch=this.batch.concat(c),this.batchSize+=u,this.onUpdate()}onUpdate(){this.totalNumberCompleted<_.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},_.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=_,_.TIMEOUT=4e3,_.START_BATCH_AFTER_COUNT=50}),define(ve[71],we([1,0,6,5,4,267,17,63,11,2,137]),function(te,e,f,i,I,A,C,k,S,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,I.createDecorator)("IExtHostSearch");let D=class{constructor(d,p,P){this.extHostRpc=d,this._uriTransformer=p,this._logService=P,this._proxy=this.extHostRpc.getProxy(i.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new A.FileSearchManager}_transformScheme(d){return this._uriTransformer.transformOutgoingScheme(d)}registerTextSearchProvider(d,p){if(this._textSearchUsedSchemes.has(d))throw new Error(`a text search provider for the scheme '${d}' is already registered`);this._textSearchUsedSchemes.add(d);const P=this._handlePool++;return this._textSearchProvider.set(P,p),this._proxy.$registerTextSearchProvider(P,this._transformScheme(d)),(0,f.toDisposable)(()=>{this._textSearchUsedSchemes.delete(d),this._textSearchProvider.delete(P),this._proxy.$unregisterProvider(P)})}registerFileSearchProvider(d,p){if(this._fileSearchUsedSchemes.has(d))throw new Error(`a file search provider for the scheme '${d}' is already registered`);this._fileSearchUsedSchemes.add(d);const P=this._handlePool++;return this._fileSearchProvider.set(P,p),this._proxy.$registerFileSearchProvider(P,this._transformScheme(d)),(0,f.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(d),this._fileSearchProvider.delete(P),this._proxy.$unregisterProvider(P)})}$provideFileSearchResults(d,p,P,_){const l=v(P),c=this._fileSearchProvider.get(d);if(c)return this._fileSearchManager.fileSearch(l,c,u=>{this._proxy.$handleFileMatch(d,p,u.map(a=>a.resource))},_);throw new Error("unknown provider: "+d)}$clearCache(d){return this._fileSearchManager.clearCache(d),Promise.resolve(void 0)}$provideTextSearchResults(d,p,P,_){const l=this._textSearchProvider.get(d);if(!l||!l.provideTextSearchResults)throw new Error(`Unknown provider ${d}`);const c=v(P);return this.createTextSearchManager(c,l).search(a=>this._proxy.$handleTextMatch(d,p,a),_)}$enableExtensionHostSearch(){}createTextSearchManager(d,p){return new F.TextSearchManager(d,p,{readdir:P=>Promise.resolve([]),toCanonicalName:P=>P},"textSearchProvider")}};D=Be([Fe(0,C.IExtHostRpcService),Fe(1,k.IURITransformerService),Fe(2,S.ILogService)],D),e.ExtHostSearch=D;function v(g){return{...g,folderQueries:g.folderQueries&&g.folderQueries.map(b),extraFileResources:g.extraFileResources&&g.extraFileResources.map(d=>R.URI.revive(d))}}e.reviveQuery=v;function b(g){return{...g,folder:R.URI.revive(g.folder)}}}),define(ve[274],we([1,0,79,135,36,133,37,39,45,34,69,54,71,87,51,64,136,65,44,86,124,53,134,11,226]),function(te,e,f,i,I,A,C,k,S,R,F,D,v,b,g,d,p,P,_,l,c,u,a,E,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,f.registerSingleton)(E.ILoggerService,a.ExtHostLoggerService),(0,f.registerSingleton)(E.ILogService,s.ExtHostLogService),(0,f.registerSingleton)(d.IExtHostApiDeprecationService,d.ExtHostApiDeprecationService),(0,f.registerSingleton)(k.IExtHostCommands,k.ExtHostCommands),(0,f.registerSingleton)(C.IExtHostConfiguration,C.ExtHostConfiguration),(0,f.registerSingleton)(P.IExtHostConsumerFileSystem,P.ExtHostConsumerFileSystem),(0,f.registerSingleton)(D.IExtHostDebugService,D.WorkerExtHostDebugService),(0,f.registerSingleton)(A.IExtHostDecorations,A.ExtHostDecorations),(0,f.registerSingleton)(S.IExtHostDocumentsAndEditors,S.ExtHostDocumentsAndEditors),(0,f.registerSingleton)(_.IExtHostFileSystemInfo,_.ExtHostFileSystemInfo),(0,f.registerSingleton)(i.IExtHostOutputService,i.ExtHostOutputService),(0,f.registerSingleton)(v.IExtHostSearch,v.ExtHostSearch),(0,f.registerSingleton)(b.IExtHostStorage,b.ExtHostStorage),(0,f.registerSingleton)(F.IExtHostTask,F.WorkerExtHostTask),(0,f.registerSingleton)(R.IExtHostTerminalService,R.WorkerExtHostTerminalService),(0,f.registerSingleton)(g.IExtHostTunnelService,g.ExtHostTunnelService),(0,f.registerSingleton)(p.IExtHostWindow,p.ExtHostWindow),(0,f.registerSingleton)(I.IExtHostWorkspace,I.ExtHostWorkspace),(0,f.registerSingleton)(l.IExtHostSecretState,l.ExtHostSecretState),(0,f.registerSingleton)(c.IExtHostTelemetry,c.ExtHostTelemetry),(0,f.registerSingleton)(u.IExtHostEditorTabs,u.ExtHostEditorTabs)}),define(ve[88],we([1,0,18,11,31,68]),function(te,e,f,i,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function C(D){return D.startsWith("**")||D.startsWith("/")?D:`/${D}`}e.anchorGlob=C;function k(D,v,b,g){const d=(0,f.mapArrayOrNot)(b,S),p=new I.TextSearchMatch(v,d,g),P=p.preview.matches;return{ranges:(0,f.mapArrayOrNot)(d,R),uri:D,preview:{text:p.preview.text,matches:(0,f.mapArrayOrNot)(P,R)}}}e.createTextSearchResult=k;function S(D){return new I.SearchRange(D.start.line,D.start.character,D.end.line,D.end.character)}function R(D){return new A.Range(D.startLineNumber,D.startColumn,D.endLineNumber,D.endColumn)}let F=class{constructor(v,b){this.prefix=v,this.logService=b}appendLine(v){this.logService.debug(`${this.prefix}#search`,v)}};F=Be([Fe(1,i.ILogService)],F),e.OutputChannel=F}),define(ve[275],we([1,0,38,9,77,29,12,8,88,276]),function(te,e,f,i,I,A,C,k,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const F=R.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function D(l,c,u,a){const E=v(l,c,u,a),s=c.folder.fsPath;return{cmd:f.spawn(F,E.args,{cwd:s}),rgDiskPath:F,siblingClauses:E.siblingClauses,rgArgs:E,cwd:s}}e.spawnRipgrepCmd=D;function v(l,c,u,a){const E=["--files","--hidden","--case-sensitive"];g([c],u,!1).forEach(t=>{const r=(0,S.anchorGlob)(t);if(E.push("-g",r),C.isMacintosh){const n=(0,I.normalizeNFD)(r);n!==r&&E.push("-g",n)}});const s=b([c],a,void 0,!1);return s.globArgs.forEach(t=>{const r=`!${(0,S.anchorGlob)(t)}`;if(E.push("-g",r),C.isMacintosh){const n=(0,I.normalizeNFD)(r);n!==r&&E.push("-g",n)}}),c.disregardIgnoreFiles!==!1?E.push("--no-ignore"):c.disregardParentIgnoreFiles!==!1&&E.push("--no-ignore-parent"),c.ignoreSymlinks||E.push("--follow"),l.exists&&E.push("--quiet"),E.push("--no-config"),c.disregardGlobalIgnoreFiles&&E.push("--no-ignore-global"),{args:E,siblingClauses:s.siblingClauses}}function b(l,c,u,a=!0){const E=[];let s={};return l.forEach(t=>{const r=Object.assign({},t.excludePattern||{},c||{}),n=d(r,a?t.folder.fsPath:void 0,u);E.push(...n.globArgs),n.siblingClauses&&(s=Object.assign(s,n.siblingClauses))}),{globArgs:E,siblingClauses:s}}e.foldersToRgExcludeGlobs=b;function g(l,c,u=!0){const a=[];return l.forEach(E=>{const s=Object.assign({},c||{},E.includePattern||{}),t=d(s,u?E.folder.fsPath:void 0);a.push(...t.globArgs)}),a}e.foldersToIncludeGlobs=g;function d(l,c,u){const a=[],E={};return Object.keys(l).forEach(s=>{if(u&&u.has(s)||!s)return;const t=l[s];s=P(c?p(c,s):s),s.startsWith("\\\\")?s="\\\\"+s.substr(2).replace(/\\/g,"/"):s=s.replace(/\\/g,"/"),typeof t=="boolean"&&t?(s.startsWith("\\\\")&&(s+="**"),a.push(_(s))):t&&t.when&&(E[s]=t)}),{globArgs:a,siblingClauses:E}}function p(l,c){return i.isAbsolute(c)?c:i.join(l,c)}e.getAbsoluteGlob=p;function P(l){return l=k.rtrim(l,"\\"),k.rtrim(l,"/")}function _(l){return A.getRoot(l).toLowerCase()==="c:/"?l.replace(/^c:[/\\]/i,"/"):l}e.fixDriveC=_}),define(ve[277],we([1,0,38,59,9,102,18,49,32,77,29,12,46,8,13,28,31,275,98]),function(te,e,f,i,I,A,C,k,S,R,F,D,v,b,g,d,p,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const l=new Set;process.on("exit",()=>{l.forEach(s=>s())});class c{constructor(t){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=t,this.filePattern=t.filePattern||"",this.includePattern=t.includePattern&&S.parse(t.includePattern),this.maxResults=t.maxResults||null,this.exists=!!t.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,_.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=t.excludePattern&&S.parse(t.excludePattern),this.folderExcludePatterns=new Map,t.folderQueries.forEach(r=>{const n=Object.assign({},r.excludePattern||{},this.config.excludePattern||{}),o=r.folder.fsPath;t.folderQueries.map(m=>m.folder.fsPath).filter(m=>m!==o).forEach(m=>{(0,F.isEqualOrParent)(m,o)&&(n[I.relative(o,m)]=!0)}),this.folderExcludePatterns.set(o,new a(n,o))})}cancel(){this.isCanceled=!0,l.forEach(t=>t())}walk(t,r,n,o,m){if(this.fileWalkSW=v.StopWatch.create(!1),this.isCanceled)return m(null,this.isLimitHit);r.forEach(h=>{const w=I.basename(h.fsPath);this.globalExcludePattern&&this.globalExcludePattern(h.fsPath,w)||this.matchFile(n,{relativePath:h.fsPath,searchPath:void 0})}),this.cmdSW=v.StopWatch.create(!1),this.parallel(t,(h,w)=>{this.call(this.cmdTraversal,this,h,n,o,T=>{if(T){const L=(0,k.toErrorMessage)(T);console.error(L),this.errors.push(L),w(T,void 0)}else w(null,void 0)})},(h,w)=>{this.fileWalkSW.stop();const T=h?C.coalesce(h)[0]:null;m(T,this.isLimitHit)})}parallel(t,r,n){const o=new Array(t.length),m=new Array(t.length);let h=!1,w=0;if(t.length===0)return n(null,[]);t.forEach((T,L)=>{r(T,(O,y)=>{if(O?(h=!0,o[L]=null,m[L]=O):(o[L]=y,m[L]=null),++w===t.length)return n(h?m:null,o)})})}call(t,r,...n){try{t.apply(r,n)}catch(o){n[n.length-1](o)}}cmdTraversal(t,r,n,o){const m=t.folder.fsPath,h=D.isMacintosh;let w;const T=()=>w&&w.kill();l.add(T);let L=$=>{l.delete(T),L=()=>{},o($)},O="";const y=this.initDirectoryTree();let H;const M=(0,P.spawnRipgrepCmd)(this.config,t,this.config.includePattern,this.folderExcludePatterns.get(t.folder.fsPath).expression);w=M.cmd,H=!Object.keys(M.siblingClauses).length;const j=M.rgArgs.args.map($=>$.match(/^-/)?$:`'${$}'`).join(" ");let X=`${M.rgDiskPath} ${j}
 - cwd: ${M.cwd}`;M.rgArgs.siblingClauses&&(X+=`
 - Sibling clauses: ${JSON.stringify(M.rgArgs.siblingClauses)}`),n({message:X}),this.cmdResultCount=0,this.collectStdout(w,"utf8",n,($,U,q)=>{if($){L($);return}if(this.isLimitHit){L();return}const G=(O+(h?R.normalizeNFC(U||""):U)).split(`
`);if(q){const ee=G.length;G[ee-1]=G[ee-1].trim(),G[ee-1]||G.pop()}else O=G.pop()||"";if(G.length&&G[0].indexOf(`
`)!==-1){L(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=G.length,H){for(const ee of G)if(this.matchFile(r,{base:m,relativePath:ee,searchPath:this.getSearchPath(t,ee)}),this.isLimitHit){T();break}(q||this.isLimitHit)&&L();return}this.addDirectoryEntries(t,y,m,G,r),q&&(this.matchDirectoryTree(y,m,r),L())})}spawnFindCmd(t){const r=this.folderExcludePatterns.get(t.folder.fsPath),n=r.getBasenameTerms(),o=r.getPathTerms(),m=["-L","."];if(n.length||o.length){m.push("-not","(","(");for(const h of n)m.push("-name",h),m.push("-o");for(const h of o)m.push("-path",h),m.push("-o");m.pop(),m.push(")","-prune",")")}return m.push("-type","f"),f.spawn("find",m,{cwd:t.folder.fsPath})}readStdout(t,r,n){let o="";this.collectStdout(t,r,()=>{},(m,h,w)=>{if(m){n(m);return}o+=h,w&&n(null,o)})}collectStdout(t,r,n,o){let m=(T,L,O)=>{(T||O)&&(m=()=>{},this.cmdSW&&this.cmdSW.stop()),o(T,L,O)},h=!1;t.stdout?(this.forwardData(t.stdout,r,m),t.stdout.once("data",()=>h=!0)):n({message:"stdout is null"});let w;t.stderr?w=this.collectData(t.stderr):n({message:"stderr is null"}),t.on("error",T=>{m(T)}),t.on("close",T=>{let L;!h&&(L=this.decodeData(w,r))&&E(L)?m(new Error(`command failed with error code ${T}: ${this.decodeData(w,r)}`)):(this.exists&&T===0&&(this.isLimitHit=!0),m(null,"",!0))})}forwardData(t,r,n){const o=new A.StringDecoder(r);return t.on("data",m=>{n(null,o.write(m))}),o}collectData(t){const r=[];return t.on("data",n=>{r.push(n)}),r}decodeData(t,r){const n=new A.StringDecoder(r);return t.map(o=>n.write(o)).join("")}initDirectoryTree(){const t={rootEntries:[],pathToEntries:Object.create(null)};return t.pathToEntries["."]=t.rootEntries,t}addDirectoryEntries(t,{pathToEntries:r},n,o,m){o.indexOf(this.filePattern)!==-1&&this.matchFile(m,{base:n,relativePath:this.filePattern,searchPath:this.getSearchPath(t,this.filePattern)});const h=w=>{const T=I.basename(w),L=I.dirname(w);let O=r[L];O||(O=r[L]=[],h(L)),O.push({base:n,relativePath:w,basename:T,searchPath:this.getSearchPath(t,w)})};o.forEach(h)}matchDirectoryTree({rootEntries:t,pathToEntries:r},n,o){const m=this,h=this.folderExcludePatterns.get(n),w=this.filePattern;function T(L){m.directoriesWalked++;const O=S.hasSiblingFn(()=>L.map(y=>y.basename));for(let y=0,H=L.length;y<H;y++){const M=L[y],{relativePath:j,basename:X}=M;if(h.test(j,X,w!==X?O:void 0))continue;const $=r[j];if($)T($);else{if(m.filesWalked++,j===w)continue;m.matchFile(o,M)}if(m.isLimitHit)break}}T(t)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(t,r,n,o,m){const h=t.folder,w=S.hasSiblingFn(()=>n);this.parallel(n,(T,L)=>{if(this.isCanceled||this.isLimitHit)return L(null);const O=r?[r,T].join(I.sep):T;if(this.folderExcludePatterns.get(t.folder.fsPath).test(O,T,this.config.filePattern!==T?w:void 0))return L(null);const y=[h.fsPath,O].join(I.sep);i.lstat(y,(H,M)=>{if(H||this.isCanceled||this.isLimitHit)return L(null);this.statLinkIfNeeded(y,M,(j,X)=>j||this.isCanceled||this.isLimitHit?L(null):X.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(y,M,($,U)=>$||this.isCanceled||this.isLimitHit||(U=U||"",this.walkedPaths[U])?L(null):(this.walkedPaths[U]=!0,d.Promises.readdir(y).then(q=>{if(this.isCanceled||this.isLimitHit)return L(null);this.doWalk(t,O,q,o,K=>L(K||null))},q=>{L(null)})))):(this.filesWalked++,O===this.filePattern||this.maxFilesize&&g.isNumber(X.size)&&X.size>this.maxFilesize||this.matchFile(o,{base:h.fsPath,relativePath:O,searchPath:this.getSearchPath(t,O)}),L(null,void 0)))})},T=>{const L=T&&C.coalesce(T);return m(L&&L.length>0?L[0]:void 0)})}matchFile(t,r){this.isFileMatch(r)&&(!this.includePattern||this.includePattern(r.relativePath,I.basename(r.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||t(r))}isFileMatch(t){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,p.isFilePatternMatch)(t,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(t,r,n){return r.isSymbolicLink()?i.stat(t,n):n(null,r)}realPathIfNeeded(t,r,n){return r.isSymbolicLink()?i.realpath(t,(o,m)=>o?n(o):n(null,m)):n(null,t)}getSearchPath(t,r){return t.folderName?I.join(t.folderName,r):r}}e.FileWalker=c;class u{constructor(t){this.folderQueries=t.folderQueries,this.extraFiles=t.extraFileResources||[],this.walker=new c(t)}search(t,r,n){this.walker.walk(this.folderQueries,this.extraFiles,t,r,(o,m)=>{n(o,{limitHit:m,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=u;class a{constructor(t,r){this.expression=t,this.root=r,this.init(t)}init(t){let r,n;Object.keys(t).filter(o=>t[o]).forEach(o=>{I.isAbsolute(o)?(r=r||S.getEmptyExpression(),r[o]=t[o]):(n=n||S.getEmptyExpression(),n[o]=t[o])}),this.absoluteParsedExpr=r&&S.parse(r,{trimForExclusions:!0}),this.relativeParsedExpr=n&&S.parse(n,{trimForExclusions:!0})}test(t,r,n){return this.relativeParsedExpr&&this.relativeParsedExpr(t,r,n)||this.absoluteParsedExpr&&this.absoluteParsedExpr(I.join(this.root,t),r,n)}getBasenameTerms(){const t=[];return this.absoluteParsedExpr&&t.push(...S.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&t.push(...S.getBasenameTerms(this.relativeParsedExpr)),t}getPathTerms(){const t=[];return this.absoluteParsedExpr&&t.push(...S.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&t.push(...S.getPathTerms(this.relativeParsedExpr)),t}}function E(s){const t=s.trim().split(`
`),r=t[0].trim();if(r.startsWith("Error parsing regex"))return r;if(r.startsWith("regex parse error"))return b.uppercaseFirstLetter(t[t.length-1].trim());if(r.startsWith("error parsing glob")||r.startsWith("unsupported encoding"))return r.charAt(0).toUpperCase()+r.substr(1);if(r==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(r.startsWith("Literal "))return r}e.rgErrorMsgForDisplay=E}),define(ve[278],we([1,0,94,22]),function(te,e,f,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function I(s){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(t=>t===s)}e.isUTFEncoding=I,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const A=512,C=512,k=512*8,S=512*128;var R;(function(s){s[s.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(R=e.DecodeStreamErrorKind||(e.DecodeStreamErrorKind={}));class F extends Error{constructor(t,r){super(t);this.decodeStreamErrorKind=r}}e.DecodeStreamError=F;class D{constructor(t){this.iconvLiteDecoder=t}static async create(t){let r;if(t!==e.UTF8)r=(await new Promise((o,m)=>{te(["@vscode/iconv-lite-umd"],o,m)})).getDecoder(d(t));else{const n=new TextDecoder;r={write(o){return n.decode(o,{stream:!0})},end(){return n.decode()}}}return new D(r)}write(t){return this.iconvLiteDecoder.write(t)}end(){return this.iconvLiteDecoder.end()}}function v(s,t){const r=t.minBytesRequiredForDetection??t.guessEncoding?k:C;return new Promise((n,o)=>{const m=(0,f.newWriteableStream)(y=>y.join("")),h=[];let w=0,T,L;const O=async()=>{try{const y=await E({buffer:i.VSBuffer.concat(h),bytesRead:w},t.guessEncoding);if(y.seemsBinary&&t.acceptTextOnly)throw new F("Stream is binary but only text is accepted for decoding",1);y.encoding=await t.overwriteEncoding(y.encoding),T=await D.create(y.encoding);const H=T.write(i.VSBuffer.concat(h).buffer);m.write(H),h.length=0,w=0,n({stream:m,detected:y})}catch(y){L?.dispose(),m.destroy(),o(y)}};L=(0,f.listenStream)(s,{onData:async y=>{T?m.write(T.write(y.buffer)):(h.push(y),w+=y.byteLength,w>=r&&(s.pause(),await O(),setTimeout(()=>s.resume())))},onError:y=>m.error(y),onEnd:async()=>{T||await O(),m.end(T?.end())}})})}e.toDecodeStream=v;async function b(s,t,r){const o=(await new Promise((w,T)=>{te(["@vscode/iconv-lite-umd"],w,T)})).getEncoder(d(t),r);let m=!1,h=!1;return{read(){if(h)return null;const w=s.read();if(typeof w!="string"){if(h=!0,!m&&r?.addBOM)switch(t){case e.UTF8:case e.UTF8_with_bom:return i.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return i.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return i.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const T=o.end();return T&&T.length>0?(m=!0,i.VSBuffer.wrap(T)):null}return m=!0,i.VSBuffer.wrap(o.write(w))}}}e.toEncodeReadable=b;async function g(s){return(await new Promise((r,n)=>{te(["@vscode/iconv-lite-umd"],r,n)})).encodingExists(d(s))}e.encodingExists=g;function d(s){return s===e.UTF8_with_bom||s===null?e.UTF8:s}e.toNodeEncoding=d;function p(s,t){if(!s||t<e.UTF16be_BOM.length)return null;const r=s.readUInt8(0),n=s.readUInt8(1);if(r===e.UTF16be_BOM[0]&&n===e.UTF16be_BOM[1])return e.UTF16be;if(r===e.UTF16le_BOM[0]&&n===e.UTF16le_BOM[1])return e.UTF16le;if(t<e.UTF8_BOM.length)return null;const o=s.readUInt8(2);return r===e.UTF8_BOM[0]&&n===e.UTF8_BOM[1]&&o===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=p;const P=["ascii","utf-16","utf-32"];async function _(s){const t=await new Promise((h,w)=>{te(["jschardet"],h,w)}),r=s.slice(0,S),n=u(r.buffer),o=t.detect(n);if(!o||!o.encoding)return null;const m=o.encoding.toLowerCase();return 0<=P.indexOf(m)?null:c(o.encoding)}const l={ibm866:"cp866",big5:"cp950"};function c(s){const t=s.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return l[t]||t}function u(s){let t="";for(let r=0;r<s.length;r++)t+=String.fromCharCode(s[r]);return t}function a(s){switch(s){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const t=s.match(/windows(\d+)/);return t?"windows-"+t[1]:s}}}e.toCanonicalName=a;function E({buffer:s,bytesRead:t},r){let n=p(s,t),o=!1;if(n!==e.UTF16be&&n!==e.UTF16le&&s){let m=!0,h=!0,w=!1;for(let T=0;T<t&&T<A;T++){const L=T%2==1,O=s.readUInt8(T)===0;if(O&&(w=!0),m&&(L&&!O||!L&&O)&&(m=!1),h&&(L&&O||!L&&!O)&&(h=!1),O&&!m&&!h)break}w&&(m?n=e.UTF16le:h?n=e.UTF16be:o=!0)}return r&&!o&&!n&&s?_(s.slice(0,t)).then(m=>({seemsBinary:!1,encoding:m})):{seemsBinary:o,encoding:n}}e.detectEncodingFromBuffer=E,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ve[138],we([1,0,278,28,137]),function(te,e,f,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class A extends I.TextSearchManager{constructor(k,S,R=i,F="searchProcess"){super(k,S,{readdir:D=>R.Promises.readdir(D.fsPath),toCanonicalName:D=>(0,f.toCanonicalName)(D)},F)}}e.NativeTextSearchManager=A}),define(ve[279],we([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class f{constructor(){this._dragOperations=new Map,this._renderedElements=new Map}removeDragOperationTransfer(I){if(I&&this._dragOperations.has(I)){const A=this._dragOperations.get(I);return this._dragOperations.delete(I),A}}addDragOperationTransfer(I,A){this._dragOperations.set(I,A)}getRenderedTreeElement(I){if(this._renderedElements.has(I))return this._renderedElements.get(I)}addRenderedTreeItemElement(I,A){this._renderedElements.set(I,A)}removeRenderedTreeItemElement(I){this._renderedElements.has(I)&&this._renderedElements.delete(I)}}e.TreeviewsService=f}),define(ve[280],we([1,0,171,23,2,3,6,16,7,13,18,14,21,205,279]),function(te,e,f,i,I,A,C,k,S,R,F,D,v,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function d(_,l){if((0,R.isString)(_))return{label:_};if(_&&typeof _=="object"&&typeof _.label=="string"){let c;return Array.isArray(_.highlights)&&(c=_.highlights.filter(u=>u.length===2&&typeof u[0]=="number"&&typeof u[1]=="number"),c=c.length?c:void 0),{label:_.label,highlights:c}}}class p{constructor(l,c,u){this._proxy=l,this.commands=c,this.logService=u,this.treeViews=new Map,this.treeDragAndDropService=new g.TreeviewsService;function a(E){return E&&E.$treeViewId&&E.$treeItemHandle}c.registerArgumentProcessor({processArgument:E=>a(E)?this.convertArgument(E):Array.isArray(E)&&E.length>0?E.map(s=>a(s)?this.convertArgument(s):s):E})}registerTreeDataProvider(l,c,u){const a=this.createTreeView(l,{treeDataProvider:c},u);return{dispose:()=>a.dispose()}}createTreeView(l,c,u){if(!c||!c.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const a=c.dragAndDropController?.dropMimeTypes??[],E=c.dragAndDropController?.dragMimeTypes??[],s=!!c.dragAndDropController?.handleDrag,t=!!c.dragAndDropController?.handleDrop,r=this._proxy.$registerTreeViewDataProvider(l,{showCollapseAll:!!c.showCollapseAll,canSelectMany:!!c.canSelectMany,dropMimeTypes:a,dragMimeTypes:E,hasHandleDrag:s,hasHandleDrop:t}),n=this.createExtHostTreeView(l,c,u);return{get onDidCollapseElement(){return n.onDidCollapseElement},get onDidExpandElement(){return n.onDidExpandElement},get selection(){return n.selectedElements},get onDidChangeSelection(){return n.onDidChangeSelection},get visible(){return n.visible},get onDidChangeVisibility(){return n.onDidChangeVisibility},get message(){return n.message},set message(o){n.message=o},get title(){return n.title},set title(o){n.title=o},get description(){return n.description},set description(o){n.description=o},reveal:(o,m)=>n.reveal(o,m),dispose:async()=>{await r,this.treeViews.delete(l),n.dispose()}}}$getChildren(l,c){const u=this.treeViews.get(l);return u?u.getChildren(c):Promise.reject(new Error((0,f.localize)(0,null,l)))}async $handleDrop(l,c,u,a,E,s,t){const r=this.treeViews.get(l);if(!r)return Promise.reject(new Error((0,f.localize)(1,null,l)));const n=b.TreeDataTransferConverter.toITreeDataTransfer(c);return s===l&&t&&await this.addAdditionalTransferItems(n,r,t,a,E),r.onDrop(n,u,a)}async addAdditionalTransferItems(l,c,u,a,E){const s=this.treeDragAndDropService.removeDragOperationTransfer(E);if(s)(await s)?.forEach((t,r)=>{t&&l.set(r,t)});else if(E&&c.handleDrag){const t=c.handleDrag(u,l,a);this.treeDragAndDropService.addDragOperationTransfer(E,t),await t}return l}async $handleDrag(l,c,u,a){const E=this.treeViews.get(l);if(!E)return Promise.reject(new Error((0,f.localize)(2,null,l)));const s=await this.addAdditionalTransferItems(new Map,E,c,a,u);if(!!s)return b.TreeDataTransferConverter.toTreeDataTransferDTO(s)}async $hasResolve(l){const c=this.treeViews.get(l);if(!c)throw new Error((0,f.localize)(3,null,l));return c.hasResolve}$resolve(l,c,u){const a=this.treeViews.get(l);if(!a)throw new Error((0,f.localize)(4,null,l));return a.resolveTreeItem(c,u)}$setExpanded(l,c,u){const a=this.treeViews.get(l);if(!a)throw new Error((0,f.localize)(5,null,l));a.setExpanded(c,u)}$setSelection(l,c){const u=this.treeViews.get(l);if(!u)throw new Error((0,f.localize)(6,null,l));u.setSelection(c)}$setVisible(l,c){const u=this.treeViews.get(l);if(!u)throw new Error((0,f.localize)(7,null,l));u.setVisible(c)}createExtHostTreeView(l,c,u){const a=new P(l,c,this._proxy,this.commands.converter,this.logService,u);return this.treeViews.set(l,a),a}convertArgument(l){const c=this.treeViews.get(l.$treeViewId);return c?c.getExtensionElement(l.$treeItemHandle):null}}e.ExtHostTreeViews=p;class P extends C.Disposable{constructor(l,c,u,a,E,s){super();if(this.viewId=l,this.proxy=u,this.commands=a,this.logService=E,this.extension=s,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new A.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new A.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new A.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new A.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new A.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new v.CancellationTokenSource,s.contributes&&s.contributes.views)for(const n in s.contributes.views)for(const o of s.contributes.views[n])o.id===l&&(this._title=o.name);this.dataProvider=c.treeDataProvider,this.dndController=c.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(n=>this._onDidChangeData.fire({message:!1,element:n}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(n=>this._onDidChangeData.fire({message:!1,element:n})));let t,r;this._register(A.Event.debounce(this._onDidChangeData.event,(n,o)=>(n||(n={message:!1,elements:[]}),o.element!==!1&&(t||(t=new Promise(m=>r=m),this.refreshPromise=this.refreshPromise.then(()=>t)),Array.isArray(o.element)?n.elements.push(...o.element):n.elements.push(o.element)),o.message&&(n.message=!0),n),200,!0)(({message:n,elements:o})=>{o.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const m=r;return t=null,this.refresh(o).then(()=>m())})),n&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(l=>this.getExtensionElement(l)).filter(l=>!(0,R.isUndefinedOrNull)(l))}async getChildren(l){const c=l?this.getExtensionElement(l):void 0;if(l&&!c)return this.logService.error(`No tree item with id '${l}' found.`),Promise.resolve([]);let u=this.getChildrenNodes(l);return u||(u=await this.fetchChildrenNodes(c)),u?u.map(a=>a.item):void 0}getExtensionElement(l){return this.elements.get(l)}reveal(l,c){c=c||{select:!0,focus:!1};const u=(0,R.isUndefinedOrNull)(c.select)?!0:c.select,a=(0,R.isUndefinedOrNull)(c.focus)?!1:c.focus,E=(0,R.isUndefinedOrNull)(c.expand)?!1:c.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):l?this.refreshPromise.then(()=>this.resolveUnknownParentChain(l)).then(s=>this.resolveTreeNode(l,s[s.length-1]).then(t=>this.proxy.$reveal(this.viewId,{item:t.item,parentChain:s.map(r=>r.item)},{select:u,focus:a,expand:E})),s=>this.logService.error(s)):this.proxy.$reveal(this.viewId,void 0,{select:u,focus:a,expand:E})}get message(){return this._message}set message(l){this._message=l,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(l){this._title=l,this.proxy.$setTitle(this.viewId,l,this._description)}get description(){return this._description}set description(l){this._description=l,this.proxy.$setTitle(this.viewId,this._title,l)}setExpanded(l,c){const u=this.getExtensionElement(l);u&&(c?this._onDidExpandElement.fire(Object.freeze({element:u})):this._onDidCollapseElement.fire(Object.freeze({element:u})))}setSelection(l){(0,F.equals)(this._selectedHandles,l)||(this._selectedHandles=l,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(l){l!==this._visible&&(this._visible=l,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async handleDrag(l,c,u){const a=[];for(const E of l){const s=this.getExtensionElement(E);s&&a.push(s)}if(!(!this.dndController?.handleDrag||a.length===0))return await this.dndController.handleDrag(a,c,u),c}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(l,c,u){const a=this.getExtensionElement(c);if(!(!a||!this.dndController?.handleDrop))return(0,k.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(a,l,u):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(l,c){if(!this.dataProvider.resolveTreeItem)return;const u=this.elements.get(l);if(u){const a=this.nodes.get(u);if(a){const E=await this.dataProvider.resolveTreeItem(a.extensionItem,u,c)??a.extensionItem;return a.item.tooltip=this.getTooltip(E.tooltip),a.item.command=this.getCommand(a.disposableStore,E.command),a.item}}}resolveUnknownParentChain(l){return this.resolveParent(l).then(c=>c?this.resolveUnknownParentChain(c).then(u=>this.resolveTreeNode(c,u[u.length-1]).then(a=>(u.push(a),u))):Promise.resolve([]))}resolveParent(l){const c=this.nodes.get(l);return c?Promise.resolve(c.parent?this.elements.get(c.parent.item.handle):void 0):(0,k.asPromise)(()=>this.dataProvider.getParent(l))}resolveTreeNode(l,c){const u=this.nodes.get(l);return u?Promise.resolve(u):(0,k.asPromise)(()=>this.dataProvider.getTreeItem(l)).then(a=>this.createHandle(l,a,c,!0)).then(a=>this.getChildren(c?c.item.handle:void 0).then(()=>{const E=this.getExtensionElement(a);if(E){const s=this.nodes.get(E);if(s)return Promise.resolve(s)}throw new Error(`Cannot resolve tree item for element ${a}`)}))}getChildrenNodes(l){if(l){let c;if(typeof l=="string"){const u=this.getExtensionElement(l);c=u?this.nodes.get(u):void 0}else c=l;return c&&c.children||void 0}return this.roots}async fetchChildrenNodes(l){this.clearChildren(l);const c=new v.CancellationTokenSource(this._refreshCancellationSource.token);try{const u=l?this.nodes.get(l):void 0,a=await this.dataProvider.getChildren(l);if(c.token.isCancellationRequested)return;const E=await Promise.all((0,F.coalesce)(a||[]).map(async s=>{const t=await this.dataProvider.getTreeItem(s);return t&&!c.token.isCancellationRequested?this.createAndRegisterTreeNode(s,t,u):null}));return c.token.isCancellationRequested?void 0:(0,F.coalesce)(E)}finally{c.dispose()}}refresh(l){if(l.some(u=>!u))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new v.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const u=this.getHandlesToRefresh(l);if(u.length)return this.refreshHandles(u)}return Promise.resolve(void 0)}getHandlesToRefresh(l){const c=new Set,u=l.map(E=>this.nodes.get(E));for(const E of u)if(E&&!c.has(E.item.handle)){let s=E;for(;s&&s.parent&&u.findIndex(t=>s&&s.parent&&t&&t.item.handle===s.parent.item.handle)===-1;){const t=this.elements.get(s.parent.item.handle);s=t?this.nodes.get(t):void 0}s&&!s.parent&&c.add(E.item.handle)}const a=[];return c.forEach(E=>{const s=this.elements.get(E);if(s){const t=this.nodes.get(s);t&&(!t.parent||!c.has(t.parent.item.handle))&&a.push(E)}}),a}refreshHandles(l){const c={};return Promise.all(l.map(u=>this.refreshNode(u).then(a=>{a&&(c[u]=a.item)}))).then(()=>Object.keys(c).length?this.proxy.$refresh(this.viewId,c):void 0)}refreshNode(l){const c=this.getExtensionElement(l);if(c){const u=this.nodes.get(c);if(u)return this.clearChildren(c),(0,k.asPromise)(()=>this.dataProvider.getTreeItem(c)).then(a=>{if(a){const E=this.createTreeNode(c,a,u.parent);return this.updateNodeCache(c,E,u,u.parent),u.dispose(),E}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(l,c,u){const a=this.createTreeNode(l,c,u);if(c.id&&this.elements.has(a.item.handle))throw new Error((0,f.localize)(8,null,c.id));return this.addNodeToCache(l,a),this.addNodeToParentCache(a,u),a}getTooltip(l){return S.MarkdownString.isMarkdownString(l)?D.MarkdownString.from(l):l}getCommand(l,c){return c?this.commands.toInternal(c,l):void 0}createTreeNode(l,c,u){const a=new C.DisposableStore,E=this.createHandle(l,c,u),s=this.getLightIconPath(c);return{item:{handle:E,parentHandle:u?u.item.handle:void 0,label:d(c.label,this.extension),description:c.description,resourceUri:c.resourceUri,tooltip:this.getTooltip(c.tooltip),command:this.getCommand(a,c.command),contextValue:c.contextValue,icon:s,iconDark:this.getDarkIconPath(c)||s,themeIcon:this.getThemeIcon(c),collapsibleState:(0,R.isUndefinedOrNull)(c.collapsibleState)?S.TreeItemCollapsibleState.None:c.collapsibleState,accessibilityInformation:c.accessibilityInformation},extensionItem:c,parent:u,children:void 0,disposableStore:a,dispose(){a.dispose()}}}getThemeIcon(l){return l.iconPath instanceof S.ThemeIcon?l.iconPath:void 0}createHandle(l,{id:c,label:u,resourceUri:a},E,s){if(c)return`${P.ID_HANDLE_PREFIX}/${c}`;const t=d(u,this.extension),r=E?E.item.handle:P.LABEL_HANDLE_PREFIX;let n=t?t.label:a?(0,i.basename)(a):"";n=n.indexOf("/")!==-1?n.replace("/","//"):n;const o=this.nodes.has(l)?this.nodes.get(l).item.handle:void 0,m=this.getChildrenNodes(E)||[];let h,w=0;do{if(h=`${r}/${w}:${n}`,s||!this.elements.has(h)||o===h)break;w++}while(w<=m.length);return h}getLightIconPath(l){if(l.iconPath&&!(l.iconPath instanceof S.ThemeIcon))return typeof l.iconPath=="string"||I.URI.isUri(l.iconPath)?this.getIconPath(l.iconPath):this.getIconPath(l.iconPath.light)}getDarkIconPath(l){if(l.iconPath&&!(l.iconPath instanceof S.ThemeIcon)&&l.iconPath.dark)return this.getIconPath(l.iconPath.dark)}getIconPath(l){return I.URI.isUri(l)?l:I.URI.file(l)}addNodeToCache(l,c){this.elements.set(c.item.handle,l),this.nodes.set(l,c)}updateNodeCache(l,c,u,a){this.elements.delete(c.item.handle),this.nodes.delete(l),c.item.handle!==u.item.handle&&this.elements.delete(u.item.handle),this.addNodeToCache(l,c);const E=this.getChildrenNodes(a)||[],s=E.filter(t=>t.item.handle===u.item.handle)[0];s&&E.splice(E.indexOf(s),1,c)}addNodeToParentCache(l,c){c?(c.children||(c.children=[]),c.children.push(l)):(this.roots||(this.roots=[]),this.roots.push(l))}clearChildren(l){if(l){const c=this.nodes.get(l);if(c){if(c.children)for(const u of c.children){const a=this.elements.get(u.item.handle);a&&this.clear(a)}c.children=void 0}}else this.clearAll()}clear(l){const c=this.nodes.get(l);if(c){if(c.children)for(const u of c.children){const a=this.elements.get(u.item.handle);a&&this.clear(a)}this.nodes.delete(l),this.elements.delete(c.item.handle),c.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(l=>l.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}P.LABEL_HANDLE_PREFIX="0",P.ID_HANDLE_PREFIX="1"}),define(ve[281],we([1,0,21,15,3,47,2,113,109,149,108,42,5,132,231,230,39,232,37,233,234,235,219,236,45,40,237,238,241,242,243,135,221,248,249,250,87,34,252,280,14,7,255,67,136,36,73,208,240,121,133,69,54,71,11,63,17,26,244,203,51,64,228,253,202,66,65,258,256,257,229,44,251,254,86,53,124,246,68,247,10,117,245,200,239,6,30,209]),function(te,e,f,i,I,A,C,k,S,R,F,D,v,b,g,d,p,P,_,l,c,u,a,E,s,t,r,n,o,m,h,w,T,L,O,y,H,M,j,X,$,U,q,K,G,ee,oe,ue,Z,Y,se,de,ge,Te,Ne,be,Ee,z,B,N,W,V,re,he,Ce,Ae,We,ze,qe,He,Ue,Je,et,Le,it,ne,ae,J,pe,Se,Me,$e,Ye,lt,vt,wt,je,st){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function _t(nt){const ct=nt.get(z.IExtHostInitDataService),Rt=nt.get(Je.IExtHostFileSystemInfo),Tt=nt.get(We.IExtHostConsumerFileSystem),yt=nt.get(t.IExtHostExtensionService),mt=nt.get(ee.IExtHostWorkspace),Lt=nt.get(ae.IExtHostTelemetry),Mt=nt.get(_.IExtHostConfiguration),Ft=nt.get(be.IURITransformerService),xe=nt.get(Ee.IExtHostRpcService),_e=nt.get(H.IExtHostStorage),ye=nt.get(Ae.IExtensionStoragePaths),me=nt.get(Ne.ILoggerService),ie=nt.get(Ne.ILogService),Ie=nt.get(W.IExtHostTunnelService),Re=nt.get(V.IExtHostApiDeprecationService),Ve=nt.get(G.IExtHostWindow),Ke=nt.get(it.IExtHostSecretState),ht=nt.get(ne.IExtHostEditorTabs);xe.set(v.ExtHostContext.ExtHostFileSystemInfo,Rt),xe.set(v.ExtHostContext.ExtHostLogLevelServiceShape,me),xe.set(v.ExtHostContext.ExtHostWorkspace,mt),xe.set(v.ExtHostContext.ExtHostConfiguration,Mt),xe.set(v.ExtHostContext.ExtHostExtensionService,yt),xe.set(v.ExtHostContext.ExtHostStorage,_e),xe.set(v.ExtHostContext.ExtHostTunnelService,Ie),xe.set(v.ExtHostContext.ExtHostWindow,Ve),xe.set(v.ExtHostContext.ExtHostSecretState,Ke),xe.set(v.ExtHostContext.ExtHostTelemetry,Lt),xe.set(v.ExtHostContext.ExtHostEditorTabs,ht);const Et=xe.set(v.ExtHostContext.ExtHostDecorations,nt.get(se.IExtHostDecorations)),St=xe.set(v.ExtHostContext.ExtHostDocumentsAndEditors,nt.get(s.IExtHostDocumentsAndEditors)),ot=xe.set(v.ExtHostContext.ExtHostCommands,nt.get(p.IExtHostCommands)),dt=xe.set(v.ExtHostContext.ExtHostTerminalService,nt.get(M.IExtHostTerminalService)),ut=xe.set(v.ExtHostContext.ExtHostDebugService,nt.get(ge.IExtHostDebugService)),Nt=xe.set(v.ExtHostContext.ExtHostSearch,nt.get(Te.IExtHostSearch)),pt=xe.set(v.ExtHostContext.ExtHostTask,nt.get(de.IExtHostTask)),kt=xe.set(v.ExtHostContext.ExtHostOutputService,nt.get(w.IExtHostOutputService)),Ut=xe.set(v.ExtHostContext.ExtHostUrls,new q.ExtHostUrls(xe)),Ct=xe.set(v.ExtHostContext.ExtHostDocuments,new E.ExtHostDocuments(xe,St)),Bt=xe.set(v.ExtHostContext.ExtHostDocumentContentProviders,new u.ExtHostDocumentContentProvider(xe,St,ie)),Ht=xe.set(v.ExtHostContext.ExtHostDocumentSaveParticipant,new a.ExtHostDocumentSaveParticipant(ie,Ct,xe.getProxy(v.MainContext.MainThreadBulkEdits))),bt=xe.set(v.ExtHostContext.ExtHostNotebook,new B.ExtHostNotebookController(xe,ot,St,Ct,ye)),ei=xe.set(v.ExtHostContext.ExtHostNotebookDocuments,new lt.ExtHostNotebookDocuments(ie,bt)),Xt=xe.set(v.ExtHostContext.ExtHostNotebookEditors,new Ye.ExtHostNotebookEditors(ie,xe,bt)),ti=xe.set(v.ExtHostContext.ExtHostNotebookKernels,new J.ExtHostNotebookKernels(xe,ct,bt,ot,ie)),ai=xe.set(v.ExtHostContext.ExtHostNotebookRenderers,new Se.ExtHostNotebookRenderers(xe,bt)),Pt=xe.set(v.ExtHostContext.ExtHostEditors,new j.ExtHostEditors(xe,St)),ii=xe.set(v.ExtHostContext.ExtHostTreeViews,new X.ExtHostTreeViews(xe.getProxy(v.MainContext.MainThreadTreeViews),ot,ie)),bi=xe.set(v.ExtHostContext.ExtHostEditorInsets,new ue.ExtHostEditorInsets(xe.getProxy(v.MainContext.MainThreadEditorInsets),Pt,ct)),qt=xe.set(v.ExtHostContext.ExtHostDiagnostics,new l.ExtHostDiagnostics(xe,ie,Rt)),Gt=xe.set(v.ExtHostContext.ExtHostLanguages,new m.ExtHostLanguages(xe,Ct,ot.converter,Ft)),at=xe.set(v.ExtHostContext.ExtHostLanguageFeatures,new o.ExtHostLanguageFeatures(xe,Ft,Ct,ot,qt,ie,Re)),li=xe.set(v.ExtHostContext.ExtHostFileSystem,new r.ExtHostFileSystem(xe,at)),$t=xe.set(v.ExtHostContext.ExtHostFileSystemEventService,new n.ExtHostFileSystemEventService(xe,ie,St)),xt=xe.set(v.ExtHostContext.ExtHostQuickOpen,(0,L.createExtHostQuickOpen)(xe,mt,ot)),ni=xe.set(v.ExtHostContext.ExtHostSCM,new O.ExtHostSCM(xe,ot,ie)),_i=xe.set(v.ExtHostContext.ExtHostComments,(0,P.createExtHostComments)(xe,ot,Ct)),fi=xe.set(v.ExtHostContext.ExtHostProgress,new T.ExtHostProgress(xe.getProxy(v.MainContext.MainThreadProgress))),Si=xe.set(v.ExtHostContext.ExtHosLabelService,new Z.ExtHostLabelService(xe)),mi=xe.set(v.ExtHostContext.ExtHostTheming,new N.ExtHostTheming(xe)),ri=xe.set(v.ExtHostContext.ExtHostAuthentication,new re.ExtHostAuthentication(xe)),Ci=xe.set(v.ExtHostContext.ExtHostTimeline,new he.ExtHostTimeline(xe,ot)),Qt=xe.set(v.ExtHostContext.ExtHostWebviews,new K.ExtHostWebviews(xe,{remote:ct.remote},mt,ie,Re)),Yt=xe.set(v.ExtHostContext.ExtHostWebviewPanels,new He.ExtHostWebviewPanels(xe,Qt,mt)),yi=xe.set(v.ExtHostContext.ExtHostCustomEditors,new qe.ExtHostCustomEditors(xe,Ct,ye,Qt,Yt)),Di=xe.set(v.ExtHostContext.ExtHostWebviewViews,new ze.ExtHostWebviewViews(xe,Qt)),Jt=xe.set(v.ExtHostContext.ExtHostTesting,new et.ExtHostTesting(xe,ot)),si=xe.set(v.ExtHostContext.ExtHostUriOpeners,new Le.ExtHostUriOpeners(xe));xe.set(v.ExtHostContext.ExtHostInteractive,new vt.ExtHostInteractive(xe,bt,St,ot));const Ii=(0,oe.values)(v.ExtHostContext);xe.assertRegistered(Ii);const ki=new Ue.ExtHostBulkEdits(xe,St),Pi=new d.ExtHostClipboard(xe),Zt=new h.ExtHostMessageService(xe,ie),gi=new c.ExtHostDialogs(xe),Kt=new y.ExtHostStatusBar(xe,ot.converter);return g.ExtHostApiCommands.register(ot),function(Oe,ci,Ot){const ft=function(){let le=!Oe.isUnderDevelopment;function fe(){le||(ie.info(`Extension '${Oe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),le=!0)}return function ke(tt){if(Array.isArray(tt))tt.forEach(ke);else if(typeof tt=="string")fe();else{const gt=tt;typeof gt.scheme=="undefined"&&fe(),typeof gt.exclusive=="boolean"&&(0,je.checkProposedApiEnabled)(Oe,"documentFiltersExclusive"),typeof gt.notebookType=="string"&&(0,je.checkProposedApiEnabled)(Oe,"notebookDocumentSelector")}return tt}}(),Ti={getSession(le,fe,ke){return ri.getSession(Oe,le,fe,ke)},async hasSession(le,fe){return(0,je.checkProposedApiEnabled)(Oe,"authSession"),!!await ri.getSession(Oe,le,fe,{silent:!0})},get onDidChangeSessions(){return ri.onDidChangeSessions},registerAuthenticationProvider(le,fe,ke,tt){return ri.registerAuthenticationProvider(le,fe,ke,tt)}},Ai={registerCommand(le,fe,ke){return ot.registerCommand(!0,le,fe,ke,void 0,Oe)},registerTextEditorCommand(le,fe,ke){return ot.registerCommand(!0,le,(...tt)=>{const gt=Pt.getActiveTextEditor();if(!gt){ie.warn("Cannot execute "+le+" because there is no active text editor.");return}return gt.edit(It=>{fe.apply(ke,[gt,It,...tt])}).then(It=>{It||ie.warn("Edits from command "+le+" were not applied.")},It=>{ie.warn("An error occurred while running command "+le,It)})},void 0,void 0,Oe)},registerDiffInformationCommand:(le,fe,ke)=>((0,je.checkProposedApiEnabled)(Oe,"diffCommand"),ot.registerCommand(!0,le,async(...tt)=>{const gt=St.activeEditor(!0);if(!gt){ie.warn("Cannot execute "+le+" because there is no active text editor.");return}const It=await Pt.getDiffInformation(gt.id);fe.apply(ke,[It,...tt])},void 0,void 0,Oe)),executeCommand(le,...fe){return ot.executeCommand(le,...fe)},getCommands(le=!1){return ot.getCommands(le)}},pi={get machineId(){return ct.telemetryInfo.machineId},get sessionId(){return ct.telemetryInfo.sessionId},get language(){return ct.environment.appLanguage},get appName(){return ct.environment.appName},get appRoot(){return ct.environment.appRoot?.fsPath??""},get appHost(){return ct.environment.appHost},get uriScheme(){return ct.environment.appUriScheme},get clipboard(){return Pi.value},get shell(){return dt.getDefaultShell(!1)},get isTelemetryEnabled(){return Lt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Lt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,je.checkProposedApiEnabled)(Oe,"telemetry"),Lt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,je.checkProposedApiEnabled)(Oe,"telemetry"),Lt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){const le=Date.now()-new Date(ct.telemetryInfo.firstSessionDate).getTime();return isNaN(le)?!1:le<1e3*60*60*24},openExternal(le,fe){return Ve.openUri(le,{allowTunneling:!!ct.remote.authority,allowContributedOpeners:fe?.allowContributedOpeners})},async asExternalUri(le){if(le.scheme===ct.environment.appUriScheme)return Ut.createAppUri(le);try{return await Ve.asExternalUri(le,{allowTunneling:!!ct.remote.authority})}catch(fe){if((0,$e.matchesScheme)(le,Me.Schemas.http)||(0,$e.matchesScheme)(le,Me.Schemas.https))return le;throw fe}},get remoteName(){return(0,Y.getRemoteName)(ct.remote.authority)},get remoteAuthority(){return(0,je.checkProposedApiEnabled)(Oe,"resolvers"),ct.remote.authority},get uiKind(){return ct.uiKind}};ct.environment.extensionTestsLocationURI||Object.freeze(pi);const vi=ct.remote.isRemote?U.ExtensionKind.Workspace:U.ExtensionKind.UI,Ri={createTestController(le,fe,ke){return Jt.createTestController(le,fe,ke)},createTestObserver(){return(0,je.checkProposedApiEnabled)(Oe,"testObserver"),Jt.createTestObserver()},runTests(le){return(0,je.checkProposedApiEnabled)(Oe,"testObserver"),Jt.runTests(le)},get onDidChangeTestResults(){return(0,je.checkProposedApiEnabled)(Oe,"testObserver"),Jt.onResultsChanged},get testResults(){return(0,je.checkProposedApiEnabled)(Oe,"testObserver"),Jt.results}},Li={getExtension(le){const fe=ci.getExtensionDescription(le);if(fe)return new t.Extension(yt,Oe.identifier,fe,vi)},get all(){return ci.getAllExtensionDescriptions().map(le=>new t.Extension(yt,Oe.identifier,le,vi))},get onDidChange(){return ci.onDidChange}},Oi={createDiagnosticCollection(le){return qt.createDiagnosticCollection(Oe.identifier,le)},get onDidChangeDiagnostics(){return qt.onDidChangeDiagnostics},getDiagnostics:le=>qt.getDiagnostics(le),getLanguages(){return Gt.getLanguages()},setTextDocumentLanguage(le,fe){return Gt.changeLanguage(le.uri,fe)},match(le,fe){return(0,F.score)($.LanguageSelector.from(le),fe.uri,fe.languageId,!0,fe.notebook?.notebookType)},registerCodeActionsProvider(le,fe,ke){return at.registerCodeActionProvider(Oe,ft(le),fe,ke)},registerCodeLensProvider(le,fe){return at.registerCodeLensProvider(Oe,ft(le),fe)},registerDefinitionProvider(le,fe){return at.registerDefinitionProvider(Oe,ft(le),fe)},registerDeclarationProvider(le,fe){return at.registerDeclarationProvider(Oe,ft(le),fe)},registerImplementationProvider(le,fe){return at.registerImplementationProvider(Oe,ft(le),fe)},registerTypeDefinitionProvider(le,fe){return at.registerTypeDefinitionProvider(Oe,ft(le),fe)},registerHoverProvider(le,fe){return at.registerHoverProvider(Oe,ft(le),fe,Oe.identifier)},registerEvaluatableExpressionProvider(le,fe){return at.registerEvaluatableExpressionProvider(Oe,ft(le),fe,Oe.identifier)},registerInlineValuesProvider(le,fe){return at.registerInlineValuesProvider(Oe,ft(le),fe,Oe.identifier)},registerDocumentHighlightProvider(le,fe){return at.registerDocumentHighlightProvider(Oe,ft(le),fe)},registerLinkedEditingRangeProvider(le,fe){return at.registerLinkedEditingRangeProvider(Oe,ft(le),fe)},registerReferenceProvider(le,fe){return at.registerReferenceProvider(Oe,ft(le),fe)},registerRenameProvider(le,fe){return at.registerRenameProvider(Oe,ft(le),fe)},registerDocumentSymbolProvider(le,fe,ke){return at.registerDocumentSymbolProvider(Oe,ft(le),fe,ke)},registerWorkspaceSymbolProvider(le){return at.registerWorkspaceSymbolProvider(Oe,le)},registerDocumentFormattingEditProvider(le,fe){return at.registerDocumentFormattingEditProvider(Oe,ft(le),fe)},registerDocumentRangeFormattingEditProvider(le,fe){return at.registerDocumentRangeFormattingEditProvider(Oe,ft(le),fe)},registerOnTypeFormattingEditProvider(le,fe,ke,...tt){return at.registerOnTypeFormattingEditProvider(Oe,ft(le),fe,[ke].concat(tt))},registerDocumentSemanticTokensProvider(le,fe,ke){return at.registerDocumentSemanticTokensProvider(Oe,ft(le),fe,ke)},registerDocumentRangeSemanticTokensProvider(le,fe,ke){return at.registerDocumentRangeSemanticTokensProvider(Oe,ft(le),fe,ke)},registerSignatureHelpProvider(le,fe,ke,...tt){return typeof ke=="object"?at.registerSignatureHelpProvider(Oe,ft(le),fe,ke):at.registerSignatureHelpProvider(Oe,ft(le),fe,typeof ke=="undefined"?[]:[ke,...tt])},registerCompletionItemProvider(le,fe,...ke){return at.registerCompletionItemProvider(Oe,ft(le),fe,ke)},registerInlineCompletionItemProvider(le,fe){return(0,je.checkProposedApiEnabled)(Oe,"inlineCompletions"),at.registerInlineCompletionsProvider(Oe,ft(le),fe)},registerDocumentLinkProvider(le,fe){return at.registerDocumentLinkProvider(Oe,ft(le),fe)},registerColorProvider(le,fe){return at.registerColorProvider(Oe,ft(le),fe)},registerFoldingRangeProvider(le,fe){return at.registerFoldingRangeProvider(Oe,ft(le),fe)},registerSelectionRangeProvider(le,fe){return at.registerSelectionRangeProvider(Oe,le,fe)},registerCallHierarchyProvider(le,fe){return at.registerCallHierarchyProvider(Oe,le,fe)},registerTypeHierarchyProvider(le,fe){return at.registerTypeHierarchyProvider(Oe,le,fe)},setLanguageConfiguration:(le,fe)=>at.setLanguageConfiguration(Oe,le,fe),getTokenInformationAtPosition(le,fe){return(0,je.checkProposedApiEnabled)(Oe,"tokenInformation"),Gt.tokenAtPosition(le,fe)},registerInlayHintsProvider(le,fe){return at.registerInlayHintsProvider(Oe,le,fe)},createLanguageStatusItem(le,fe){return Gt.createLanguageStatusItem(Oe,le,fe)}},ui={get activeTextEditor(){return Pt.getActiveTextEditor()},get visibleTextEditors(){return Pt.getVisibleTextEditors()},get activeTerminal(){return dt.activeTerminal},get terminals(){return dt.terminals},async showTextDocument(le,fe,ke){const tt=await(C.URI.isUri(le)?Promise.resolve(wi.openTextDocument(le)):Promise.resolve(le));return Pt.showTextDocument(tt,fe,ke)},createTextEditorDecorationType(le){return Pt.createTextEditorDecorationType(Oe,le)},onDidChangeActiveTextEditor(le,fe,ke){return Pt.onDidChangeActiveTextEditor(le,fe,ke)},onDidChangeVisibleTextEditors(le,fe,ke){return Pt.onDidChangeVisibleTextEditors(le,fe,ke)},onDidChangeTextEditorSelection(le,fe,ke){return Pt.onDidChangeTextEditorSelection(le,fe,ke)},onDidChangeTextEditorOptions(le,fe,ke){return Pt.onDidChangeTextEditorOptions(le,fe,ke)},onDidChangeTextEditorVisibleRanges(le,fe,ke){return Pt.onDidChangeTextEditorVisibleRanges(le,fe,ke)},onDidChangeTextEditorViewColumn(le,fe,ke){return Pt.onDidChangeTextEditorViewColumn(le,fe,ke)},onDidCloseTerminal(le,fe,ke){return dt.onDidCloseTerminal(le,fe,ke)},onDidOpenTerminal(le,fe,ke){return dt.onDidOpenTerminal(le,fe,ke)},onDidChangeActiveTerminal(le,fe,ke){return dt.onDidChangeActiveTerminal(le,fe,ke)},onDidChangeTerminalDimensions(le,fe,ke){return(0,je.checkProposedApiEnabled)(Oe,"terminalDimensions"),dt.onDidChangeTerminalDimensions(le,fe,ke)},onDidChangeTerminalState(le,fe,ke){return dt.onDidChangeTerminalState(le,fe,ke)},onDidWriteTerminalData(le,fe,ke){return(0,je.checkProposedApiEnabled)(Oe,"terminalDataWriteEvent"),dt.onDidWriteTerminalData(le,fe,ke)},get state(){return Ve.state},onDidChangeWindowState(le,fe,ke){return Ve.onDidChangeWindowState(le,fe,ke)},showInformationMessage(le,...fe){return Zt.showMessage(Oe,A.default.Info,le,fe[0],fe.slice(1))},showWarningMessage(le,...fe){return Zt.showMessage(Oe,A.default.Warning,le,fe[0],fe.slice(1))},showErrorMessage(le,...fe){return Zt.showMessage(Oe,A.default.Error,le,fe[0],fe.slice(1))},showQuickPick(le,fe,ke){return xt.showQuickPick(le,fe,ke)},showWorkspaceFolderPick(le){return xt.showWorkspaceFolderPick(le)},showInputBox(le,fe){return xt.showInput(le,fe)},showOpenDialog(le){return gi.showOpenDialog(le)},showSaveDialog(le){return gi.showSaveDialog(le)},createStatusBarItem(le,fe,ke){let tt,gt,It;return typeof le=="string"?(tt=le,gt=fe,It=ke):(gt=le,It=fe),Kt.createStatusBarEntry(Oe,tt,gt,It)},setStatusBarMessage(le,fe){return Kt.setStatusBarMessage(le,fe)},withScmProgress(le){return Re.report("window.withScmProgress",Oe,"Use 'withProgress' instead."),fi.withProgress(Oe,{location:U.ProgressLocation.SourceControl},(fe,ke)=>le({report(tt){}}))},withProgress(le,fe){return fi.withProgress(Oe,le,fe)},createOutputChannel(le,fe){return fe&&(0,je.checkProposedApiEnabled)(Oe,"outputChannelLanguage"),kt.createOutputChannel(le,fe,Oe)},createWebviewPanel(le,fe,ke,tt){return Yt.createWebviewPanel(Oe,le,fe,ke,tt)},createWebviewTextEditorInset(le,fe,ke,tt){return(0,je.checkProposedApiEnabled)(Oe,"editorInsets"),bi.createWebviewEditorInset(le,fe,ke,tt,Oe)},createTerminal(le,fe,ke){return typeof le=="object"?"pty"in le?dt.createExtensionTerminal(le):dt.createTerminalFromOptions(le):dt.createTerminal(le,fe,ke)},registerTerminalLinkProvider(le){return dt.registerLinkProvider(le)},registerTerminalProfileProvider(le,fe){return dt.registerProfileProvider(Oe,le,fe)},registerTreeDataProvider(le,fe){return ii.registerTreeDataProvider(le,fe,Oe)},createTreeView(le,fe){return ii.createTreeView(le,fe,Oe)},registerWebviewPanelSerializer:(le,fe)=>Yt.registerWebviewPanelSerializer(Oe,le,fe),registerCustomEditorProvider:(le,fe,ke={})=>yi.registerCustomEditorProvider(Oe,le,fe,ke),registerFileDecorationProvider(le){return Et.registerFileDecorationProvider(le,Oe.identifier)},registerUriHandler(le){return Ut.registerUriHandler(Oe.identifier,le)},createQuickPick(){return xt.createQuickPick(Oe)},createInputBox(){return xt.createInputBox(Oe.identifier)},get activeColorTheme(){return mi.activeColorTheme},onDidChangeActiveColorTheme(le,fe,ke){return mi.onDidChangeActiveColorTheme(le,fe,ke)},registerWebviewViewProvider(le,fe,ke){return Di.registerWebviewViewProvider(Oe,le,fe,ke?.webviewOptions)},get activeNotebookEditor(){return(0,je.checkProposedApiEnabled)(Oe,"notebookEditor"),bt.activeNotebookEditor},onDidChangeActiveNotebookEditor(le,fe,ke){return(0,je.checkProposedApiEnabled)(Oe,"notebookEditor"),bt.onDidChangeActiveNotebookEditor(le,fe,ke)},get visibleNotebookEditors(){return(0,je.checkProposedApiEnabled)(Oe,"notebookEditor"),bt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,je.checkProposedApiEnabled)(Oe,"notebookEditor"),bt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(le,fe,ke){return(0,je.checkProposedApiEnabled)(Oe,"notebookEditor"),Xt.onDidChangeNotebookEditorSelection(le,fe,ke)},onDidChangeNotebookEditorVisibleRanges(le,fe,ke){return(0,je.checkProposedApiEnabled)(Oe,"notebookEditor"),Xt.onDidChangeNotebookEditorVisibleRanges(le,fe,ke)},showNotebookDocument(le,fe){return(0,je.checkProposedApiEnabled)(Oe,"notebookEditor"),bt.showNotebookDocument(le,fe)},registerExternalUriOpener(le,fe,ke){return(0,je.checkProposedApiEnabled)(Oe,"externalUriOpener"),si.registerExternalUriOpener(Oe.identifier,le,fe,ke)},get tabGroups(){return(0,je.checkProposedApiEnabled)(Oe,"tabs"),ht.tabGroups},getInlineCompletionItemController(le){return(0,je.checkProposedApiEnabled)(Oe,"inlineCompletions"),o.InlineCompletionController.get(le)}},wi={get rootPath(){return Re.report("workspace.rootPath",Oe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),mt.getPath()},set rootPath(le){throw i.readonly()},getWorkspaceFolder(le){return mt.getWorkspaceFolder(le)},get workspaceFolders(){return mt.getWorkspaceFolders()},get name(){return mt.name},set name(le){throw i.readonly()},get workspaceFile(){return mt.workspaceFile},set workspaceFile(le){throw i.readonly()},updateWorkspaceFolders:(le,fe,...ke)=>mt.updateWorkspaceFolders(Oe,le,fe||0,...ke),onDidChangeWorkspaceFolders:function(le,fe,ke){return mt.onDidChangeWorkspace(le,fe,ke)},asRelativePath:(le,fe)=>mt.getRelativePath(le,fe),findFiles:(le,fe,ke,tt)=>mt.findFiles(le,fe,ke,Oe.identifier,tt),findTextInFiles:(le,fe,ke,tt)=>{(0,je.checkProposedApiEnabled)(Oe,"findTextInFiles");let gt,It;return typeof fe=="object"?(gt=fe,It=ke):(gt={},It=fe,tt=ke),mt.findTextInFiles(le,gt||{},It,Oe.identifier,tt)},saveAll:le=>mt.saveAll(le),applyEdit(le){return ki.applyWorkspaceEdit(le)},createFileSystemWatcher:(le,fe,ke,tt)=>$t.createFileSystemWatcher(mt,Oe,le,fe,ke,tt),get textDocuments(){return Ct.getAllDocumentData().map(le=>le.document)},set textDocuments(le){throw i.readonly()},openTextDocument(le){let fe;const ke=le;if(typeof le=="string")fe=Promise.resolve(C.URI.file(le));else if(C.URI.isUri(le))fe=Promise.resolve(le);else if(!ke||typeof ke=="object")fe=Ct.createDocumentData(ke);else throw new Error("illegal argument - uriOrFileNameOrOptions");return fe.then(tt=>Ct.ensureDocumentData(tt).then(gt=>gt.document))},onDidOpenTextDocument:(le,fe,ke)=>Ct.onDidAddDocument(le,fe,ke),onDidCloseTextDocument:(le,fe,ke)=>Ct.onDidRemoveDocument(le,fe,ke),onDidChangeTextDocument:(le,fe,ke)=>Ct.onDidChangeDocument(le,fe,ke),onDidSaveTextDocument:(le,fe,ke)=>Ct.onDidSaveDocument(le,fe,ke),onWillSaveTextDocument:(le,fe,ke)=>Ht.getOnWillSaveTextDocumentEvent(Oe)(le,fe,ke),get notebookDocuments(){return bt.notebookDocuments.map(le=>le.apiNotebook)},async openNotebookDocument(le,fe){let ke;if(C.URI.isUri(le))ke=le,await bt.openNotebookDocument(le);else if(typeof le=="string")ke=C.URI.revive(await bt.createNotebookDocument({viewType:le,content:fe}));else throw new Error("Invalid arguments");return bt.getNotebookDocument(ke).apiNotebook},get onDidOpenNotebookDocument(){return bt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return bt.onDidCloseNotebookDocument},registerNotebookSerializer(le,fe,ke,tt){return bt.registerNotebookSerializer(Oe,le,fe,ke,(0,je.isProposedApiEnabled)(Oe,"notebookLiveShare")?tt:void 0)},registerNotebookContentProvider:(le,fe,ke,tt)=>((0,je.checkProposedApiEnabled)(Oe,"notebookContentProvider"),bt.registerNotebookContentProvider(Oe,le,fe,ke,(0,je.isProposedApiEnabled)(Oe,"notebookLiveShare")?tt:void 0)),onDidChangeConfiguration:(le,fe,ke)=>Ot.onDidChangeConfiguration(le,fe,ke),getConfiguration(le,fe){return fe=arguments.length===1?void 0:fe,Ot.getConfiguration(le,fe,Oe)},registerTextDocumentContentProvider(le,fe){return Bt.registerTextDocumentContentProvider(le,fe)},registerTaskProvider:(le,fe)=>(Re.report("window.registerTaskProvider",Oe,"Use the corresponding function on the 'tasks' namespace instead"),pt.registerTaskProvider(Oe,le,fe)),registerFileSystemProvider(le,fe,ke){return(0,wt.combinedDisposable)(li.registerFileSystemProvider(Oe,le,fe,ke),Tt.addFileSystemProvider(le,fe))},get fs(){return Tt.value},registerFileSearchProvider:(le,fe)=>((0,je.checkProposedApiEnabled)(Oe,"fileSearchProvider"),Nt.registerFileSearchProvider(le,fe)),registerTextSearchProvider:(le,fe)=>((0,je.checkProposedApiEnabled)(Oe,"textSearchProvider"),Nt.registerTextSearchProvider(le,fe)),registerRemoteAuthorityResolver:(le,fe)=>((0,je.checkProposedApiEnabled)(Oe,"resolvers"),yt.registerRemoteAuthorityResolver(le,fe)),registerResourceLabelFormatter:le=>((0,je.checkProposedApiEnabled)(Oe,"resolvers"),Si.$registerResourceLabelFormatter(le)),onDidCreateFiles:(le,fe,ke)=>$t.onDidCreateFile(le,fe,ke),onDidDeleteFiles:(le,fe,ke)=>$t.onDidDeleteFile(le,fe,ke),onDidRenameFiles:(le,fe,ke)=>$t.onDidRenameFile(le,fe,ke),onWillCreateFiles:(le,fe,ke)=>$t.getOnWillCreateFileEvent(Oe)(le,fe,ke),onWillDeleteFiles:(le,fe,ke)=>$t.getOnWillDeleteFileEvent(Oe)(le,fe,ke),onWillRenameFiles:(le,fe,ke)=>$t.getOnWillRenameFileEvent(Oe)(le,fe,ke),openTunnel:le=>((0,je.checkProposedApiEnabled)(Oe,"resolvers"),Ie.openTunnel(Oe,le).then(fe=>{if(!fe)throw new Error("cannot open tunnel");return fe})),get tunnels(){return(0,je.checkProposedApiEnabled)(Oe,"resolvers"),Ie.getTunnels()},onDidChangeTunnels:(le,fe,ke)=>((0,je.checkProposedApiEnabled)(Oe,"resolvers"),Ie.onDidChangeTunnels(le,fe,ke)),registerPortAttributesProvider:(le,fe)=>((0,je.checkProposedApiEnabled)(Oe,"portsAttributes"),Ie.registerPortsAttributesProvider(le,fe)),registerTimelineProvider:(le,fe)=>((0,je.checkProposedApiEnabled)(Oe,"timeline"),Ci.registerTimelineProvider(le,fe,Oe.identifier,ot.converter)),get isTrusted(){return mt.trusted},requestWorkspaceTrust:le=>((0,je.checkProposedApiEnabled)(Oe,"workspaceTrust"),mt.requestWorkspaceTrust(le)),onDidGrantWorkspaceTrust:(le,fe,ke)=>mt.onDidGrantWorkspaceTrust(le,fe,ke)},Fi={get inputBox(){return Re.report("scm.inputBox",Oe,"Use 'SourceControl.inputBox' instead"),ni.getLastInputBox(Oe)},createSourceControl(le,fe,ke){return ni.createSourceControl(Oe,le,fe,ke)}},Ni={createCommentController(le,fe){return _i.createCommentController(Oe,le,fe)}},Mi={get activeDebugSession(){return ut.activeDebugSession},get activeDebugConsole(){return ut.activeDebugConsole},get breakpoints(){return ut.breakpoints},onDidStartDebugSession(le,fe,ke){return ut.onDidStartDebugSession(le,fe,ke)},onDidTerminateDebugSession(le,fe,ke){return ut.onDidTerminateDebugSession(le,fe,ke)},onDidChangeActiveDebugSession(le,fe,ke){return ut.onDidChangeActiveDebugSession(le,fe,ke)},onDidReceiveDebugSessionCustomEvent(le,fe,ke){return ut.onDidReceiveDebugSessionCustomEvent(le,fe,ke)},onDidChangeBreakpoints(le,fe,ke){return ut.onDidChangeBreakpoints(le,fe,ke)},registerDebugConfigurationProvider(le,fe,ke){return ut.registerDebugConfigurationProvider(le,fe,ke||st.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(le,fe){return ut.registerDebugAdapterDescriptorFactory(Oe,le,fe)},registerDebugAdapterTrackerFactory(le,fe){return ut.registerDebugAdapterTrackerFactory(le,fe)},startDebugging(le,fe,ke){return!ke||typeof ke=="object"&&"configuration"in ke?ut.startDebugging(le,fe,{parentSession:ke}):ut.startDebugging(le,fe,ke||{})},stopDebugging(le){return ut.stopDebugging(le)},addBreakpoints(le){return ut.addBreakpoints(le)},removeBreakpoints(le){return ut.removeBreakpoints(le)},asDebugSourceUri(le,fe){return ut.asDebugSourceUri(le,fe)}},Ui={registerTaskProvider:(le,fe)=>pt.registerTaskProvider(Oe,le,fe),fetchTasks:le=>pt.fetchTasks(le),executeTask:le=>pt.executeTask(Oe,le),get taskExecutions(){return pt.taskExecutions},onDidStartTask:(le,fe,ke)=>pt.onDidStartTask(le,fe,ke),onDidEndTask:(le,fe,ke)=>pt.onDidEndTask(le,fe,ke),onDidStartTaskProcess:(le,fe,ke)=>pt.onDidStartTaskProcess(le,fe,ke),onDidEndTaskProcess:(le,fe,ke)=>pt.onDidEndTaskProcess(le,fe,ke)},Bi={createNotebookController(le,fe,ke,tt,gt){return ti.createNotebookController(Oe,le,fe,ke,tt,(0,je.isProposedApiEnabled)(Oe,"notebookMessaging")?gt:void 0)},registerNotebookCellStatusBarItemProvider:(le,fe)=>bt.registerNotebookCellStatusBarItemProvider(Oe,le,fe),get onDidSaveNotebookDocument(){return(0,je.checkProposedApiEnabled)(Oe,"notebookEditor"),ei.onDidSaveNotebookDocument},createNotebookEditorDecorationType(le){return(0,je.checkProposedApiEnabled)(Oe,"notebookEditorDecorationType"),Xt.createNotebookEditorDecorationType(le)},createRendererMessaging(le){return ai.createRendererMessaging(Oe,le)},onDidChangeNotebookDocumentMetadata(le,fe,ke){return(0,je.checkProposedApiEnabled)(Oe,"notebookEditor"),ei.onDidChangeNotebookDocumentMetadata(le,fe,ke)},onDidChangeNotebookCells(le,fe,ke){return(0,je.checkProposedApiEnabled)(Oe,"notebookEditor"),bt.onDidChangeNotebookCells(le,fe,ke)},onDidChangeNotebookCellExecutionState(le,fe,ke){return(0,je.checkProposedApiEnabled)(Oe,"notebookCellExecutionState"),ti.onDidChangeNotebookCellExecutionState(le,fe,ke)},onDidChangeCellOutputs(le,fe,ke){return(0,je.checkProposedApiEnabled)(Oe,"notebookEditor"),bt.onDidChangeCellOutputs(le,fe,ke)},onDidChangeCellMetadata(le,fe,ke){return(0,je.checkProposedApiEnabled)(Oe,"notebookEditor"),bt.onDidChangeCellMetadata(le,fe,ke)},createConcatTextDocument(le,fe){return(0,je.checkProposedApiEnabled)(Oe,"notebookConcatTextDocument"),new Ce.ExtHostNotebookConcatDocument(bt,Ct,le,fe)}};return{version:ct.version,authentication:Ti,commands:Ai,comments:Ni,debug:Mi,env:pi,extensions:Li,languages:Oi,notebooks:Bi,scm:Fi,tasks:Ui,tests:Ri,window:ui,workspace:wi,Breakpoint:U.Breakpoint,CallHierarchyIncomingCall:U.CallHierarchyIncomingCall,CallHierarchyItem:U.CallHierarchyItem,CallHierarchyOutgoingCall:U.CallHierarchyOutgoingCall,CancellationError:i.CancellationError,CancellationTokenSource:f.CancellationTokenSource,CandidatePortSource:v.CandidatePortSource,CodeAction:U.CodeAction,CodeActionKind:U.CodeActionKind,CodeActionTriggerKind:U.CodeActionTriggerKind,CodeLens:U.CodeLens,Color:U.Color,ColorInformation:U.ColorInformation,ColorPresentation:U.ColorPresentation,ColorThemeKind:U.ColorThemeKind,CommentMode:U.CommentMode,CommentThreadCollapsibleState:U.CommentThreadCollapsibleState,CommentThreadState:U.CommentThreadState,CompletionItem:U.CompletionItem,CompletionItemKind:U.CompletionItemKind,CompletionItemTag:U.CompletionItemTag,CompletionList:U.CompletionList,CompletionTriggerKind:U.CompletionTriggerKind,ConfigurationTarget:U.ConfigurationTarget,CustomExecution:U.CustomExecution,DebugAdapterExecutable:U.DebugAdapterExecutable,DebugAdapterInlineImplementation:U.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:U.DebugAdapterNamedPipeServer,DebugAdapterServer:U.DebugAdapterServer,DebugConfigurationProviderTriggerKind:st.DebugConfigurationProviderTriggerKind,DebugConsoleMode:U.DebugConsoleMode,DecorationRangeBehavior:U.DecorationRangeBehavior,Diagnostic:U.Diagnostic,DiagnosticRelatedInformation:U.DiagnosticRelatedInformation,DiagnosticSeverity:U.DiagnosticSeverity,DiagnosticTag:U.DiagnosticTag,Disposable:U.Disposable,DocumentHighlight:U.DocumentHighlight,DocumentHighlightKind:U.DocumentHighlightKind,DocumentLink:U.DocumentLink,DocumentSymbol:U.DocumentSymbol,EndOfLine:U.EndOfLine,EnvironmentVariableMutatorType:U.EnvironmentVariableMutatorType,EvaluatableExpression:U.EvaluatableExpression,InlineValueText:U.InlineValueText,InlineValueVariableLookup:U.InlineValueVariableLookup,InlineValueEvaluatableExpression:U.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:U.InlineCompletionTriggerKind,EventEmitter:I.Emitter,ExtensionKind:U.ExtensionKind,ExtensionMode:U.ExtensionMode,ExternalUriOpenerPriority:U.ExternalUriOpenerPriority,FileChangeType:U.FileChangeType,FileDecoration:U.FileDecoration,FileSystemError:U.FileSystemError,FileType:D.FileType,FilePermission:D.FilePermission,FoldingRange:U.FoldingRange,FoldingRangeKind:U.FoldingRangeKind,FunctionBreakpoint:U.FunctionBreakpoint,InlineCompletionItem:U.InlineSuggestion,InlineCompletionList:U.InlineSuggestions,Hover:U.Hover,IndentAction:R.IndentAction,Location:U.Location,MarkdownString:U.MarkdownString,OverviewRulerLane:S.OverviewRulerLane,ParameterInformation:U.ParameterInformation,PortAutoForwardAction:U.PortAutoForwardAction,Position:U.Position,ProcessExecution:U.ProcessExecution,ProgressLocation:U.ProgressLocation,QuickInputButtons:U.QuickInputButtons,Range:U.Range,RelativePattern:U.RelativePattern,Selection:U.Selection,SelectionRange:U.SelectionRange,SemanticTokens:U.SemanticTokens,SemanticTokensBuilder:U.SemanticTokensBuilder,SemanticTokensEdit:U.SemanticTokensEdit,SemanticTokensEdits:U.SemanticTokensEdits,SemanticTokensLegend:U.SemanticTokensLegend,ShellExecution:U.ShellExecution,ShellQuoting:U.ShellQuoting,SignatureHelp:U.SignatureHelp,SignatureHelpTriggerKind:U.SignatureHelpTriggerKind,SignatureInformation:U.SignatureInformation,SnippetString:U.SnippetString,SourceBreakpoint:U.SourceBreakpoint,StandardTokenType:U.StandardTokenType,StatusBarAlignment:U.StatusBarAlignment,SymbolInformation:U.SymbolInformation,SymbolKind:U.SymbolKind,SymbolTag:U.SymbolTag,TabKind:v.TabKind,Task:U.Task,TaskGroup:U.TaskGroup,TaskPanelKind:U.TaskPanelKind,TaskRevealKind:U.TaskRevealKind,TaskScope:U.TaskScope,TerminalLink:U.TerminalLink,TerminalLocation:U.TerminalLocation,TerminalProfile:U.TerminalProfile,TextDocumentSaveReason:U.TextDocumentSaveReason,TextEdit:U.TextEdit,TextEditorCursorStyle:k.TextEditorCursorStyle,TextEditorLineNumbersStyle:U.TextEditorLineNumbersStyle,TextEditorRevealType:U.TextEditorRevealType,TextEditorSelectionChangeKind:U.TextEditorSelectionChangeKind,TextDocumentChangeReason:U.TextDocumentChangeReason,ThemeColor:U.ThemeColor,ThemeIcon:U.ThemeIcon,TreeItem:U.TreeItem,TreeItemCollapsibleState:U.TreeItemCollapsibleState,TypeHierarchyItem:U.TypeHierarchyItem,UIKind:b.UIKind,Uri:C.URI,ViewColumn:U.ViewColumn,WorkspaceEdit:U.WorkspaceEdit,InlayHint:U.InlayHint,InlayHintLabelPart:U.InlayHintLabelPart,InlayHintKind:U.InlayHintKind,RemoteAuthorityResolverError:U.RemoteAuthorityResolverError,ResolvedAuthority:U.ResolvedAuthority,SourceControlInputBoxValidationType:U.SourceControlInputBoxValidationType,ExtensionRuntime:U.ExtensionRuntime,TimelineItem:U.TimelineItem,NotebookRange:U.NotebookRange,NotebookCellKind:U.NotebookCellKind,NotebookCellExecutionState:U.NotebookCellExecutionState,NotebookCellData:U.NotebookCellData,NotebookData:U.NotebookData,NotebookRendererScript:U.NotebookRendererScript,NotebookCellStatusBarAlignment:U.NotebookCellStatusBarAlignment,NotebookEditorRevealType:U.NotebookEditorRevealType,NotebookCellOutput:U.NotebookCellOutput,NotebookCellOutputItem:U.NotebookCellOutputItem,NotebookCellStatusBarItem:U.NotebookCellStatusBarItem,NotebookControllerAffinity:U.NotebookControllerAffinity,PortAttributes:U.PortAttributes,LinkedEditingRanges:U.LinkedEditingRanges,TestResultState:U.TestResultState,TestRunRequest:U.TestRunRequest,TestMessage:U.TestMessage,TestTag:U.TestTag,TestRunProfileKind:U.TestRunProfileKind,TextSearchCompleteMessageType:pe.TextSearchCompleteMessageType,TreeDataTransfer:U.TreeDataTransfer,TreeDataTransferItem:U.TreeDataTransferItem,CoveredCount:U.CoveredCount,FileCoverage:U.FileCoverage,StatementCoverage:U.StatementCoverage,BranchCoverage:U.BranchCoverage,FunctionCoverage:U.FunctionCoverage,WorkspaceTrustState:U.WorkspaceTrustState,LanguageStatusSeverity:U.LanguageStatusSeverity,QuickPickItemKind:U.QuickPickItemKind}}}e.createApiFactoryAndRegisterActors=_t}),define(ve[282],we([1,0,283,292,293,2,294]),function(te,e,f,i,I,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function k(D,v,b,g,d,p){const P=p.environment.useHostProxy,_=typeof P=="boolean"?P:!p.remote.isRemote,l=(0,C.createProxyResolver)({resolveProxy:u=>D.resolveProxy(u),getHttpProxySetting:()=>v.getConfiguration("http").get("proxy"),log:(u,a,...E)=>{switch(u){case C.LogLevel.Trace:g.trace(a,...E);break;case C.LogLevel.Debug:g.debug(a,...E);break;case C.LogLevel.Info:g.info(a,...E);break;case C.LogLevel.Warning:g.warn(a,...E);break;case C.LogLevel.Error:g.error(a,...E);break;case C.LogLevel.Critical:g.critical(a,...E);break;case C.LogLevel.Off:break;default:s(u,a,E);break}function s(t,r,...n){g.error("Unknown log level",t),g.error(r,...n)}},getLogLevel:()=>g.getLevel(),proxyResolveTelemetry:()=>{},useHostProxy:_,env:process.env}),c=S(v,l);return F(b,c)}e.connectProxyResolver=k;function S(D,v){const b={config:D.getConfiguration("http").get("proxySupport")||"off"};D.onDidChangeConfiguration(d=>{b.config=D.getConfiguration("http").get("proxySupport")||"off"});const g={config:!!D.getConfiguration("http").get("systemCertificates")};return D.onDidChangeConfiguration(d=>{g.config=!!D.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},f,(0,C.createHttpPatch)(f,v,{config:"off"},g,!0)),on:Object.assign({},f,(0,C.createHttpPatch)(f,v,{config:"on"},g,!0)),override:Object.assign({},f,(0,C.createHttpPatch)(f,v,{config:"override"},g,!0)),onRequest:Object.assign({},f,(0,C.createHttpPatch)(f,v,b,g,!0)),default:Object.assign(f,(0,C.createHttpPatch)(f,v,b,g,!1))},https:{off:Object.assign({},i,(0,C.createHttpPatch)(i,v,{config:"off"},g,!0)),on:Object.assign({},i,(0,C.createHttpPatch)(i,v,{config:"on"},g,!0)),override:Object.assign({},i,(0,C.createHttpPatch)(i,v,{config:"override"},g,!0)),onRequest:Object.assign({},i,(0,C.createHttpPatch)(i,v,b,g,!0)),default:Object.assign(i,(0,C.createHttpPatch)(i,v,b,g,!1))},tls:Object.assign(I,(0,C.createTlsPatch)(I))}}const R=new Map;function F(D,v){return D.getExtensionPathIndex().then(b=>{const g=te.__$__nodeRequire("module"),d=g._load;g._load=function(P,_,l){if(P==="tls")return v.tls;if(P!=="http"&&P!=="https")return d.apply(this,arguments);const c=v[P],u=b.findSubstr(A.URI.file(_.filename));let a=R.get(u);if(a||R.set(u,a={}),!a[P]){let E=c.default;a[P]={...E}}return a[P]}})}}),define(ve[139],we([1,0,38,295,102,18,73,32,9,8,2,31,68,296,276,88]),function(te,e,f,i,I,A,C,k,S,R,F,D,v,b,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const p=g.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class P{constructor(h){this.outputChannel=h}provideTextSearchResults(h,w,T,L){return this.outputChannel.appendLine(`provideTextSearchResults ${h.pattern}, ${JSON.stringify({...w,folder:w.folder.toString()})}`),new Promise((O,y)=>{L.onCancellationRequested(()=>K());const H=E(h,w),M=w.folder.fsPath,j=H.map(Z=>Z.match(/^-/)?Z:`'${Z}'`).join(" ");this.outputChannel.appendLine(`${p} ${j}
 - cwd: ${M}`);let X=f.spawn(p,H,{cwd:M});X.on("error",Z=>{console.error(Z),this.outputChannel.appendLine("Error: "+(Z&&Z.message)),y((0,D.serializeSearchError)(new D.SearchError(Z&&Z.message,D.SearchErrorCode.rgProcessError)))});let $=!1;const U=new c(w.maxResults,M,w.previewOptions);U.on("result",Z=>{$=!0,ee="",T.report(Z)});let q=!1;const K=()=>{q=!0,X&&X.kill(),U&&U.cancel()};let G=!1;U.on("hitLimit",()=>{G=!0,K()});let ee="";X.stdout.on("data",Z=>{U.handleData(Z),$||(ee+=Z)});let oe=!1;X.stdout.once("data",()=>oe=!0);let ue="";X.stderr.on("data",Z=>{const Y=Z.toString();this.outputChannel.appendLine(Y),ue+=Y}),X.on("close",()=>{if(this.outputChannel.appendLine(oe?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine($?"Got result from parser":"No result from parser"),ee&&this.outputChannel.appendLine(`Got data without result: ${ee}`),this.outputChannel.appendLine(""),q)O({limitHit:G});else{U.flush(),X=null;let Z;ue&&!oe&&(Z=_(ue))?y((0,D.serializeSearchError)(new D.SearchError(Z.message,Z.code))):O({limitHit:G})}})})}}e.RipgrepTextSearchEngine=P;function _(m){const h=m.split(`
`),w=h[0].trim();if(h.some(L=>L.startsWith("regex parse error")))return new D.SearchError(l(h),D.SearchErrorCode.regexParseError);const T=w.match(/grep config error: unknown encoding: (.*)/);if(T)return new D.SearchError(`Unknown encoding: ${T[1]}`,D.SearchErrorCode.unknownEncoding);if(w.startsWith("error parsing glob"))return new D.SearchError(w.charAt(0).toUpperCase()+w.substr(1),D.SearchErrorCode.globParseError);if(w.startsWith("the literal"))return new D.SearchError(w.charAt(0).toUpperCase()+w.substr(1),D.SearchErrorCode.invalidLiteral);if(w.startsWith("PCRE2: error compiling pattern"))return new D.SearchError(w,D.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=_;function l(m){const h=["Regex parse error"],w=m.filter(T=>T.startsWith("PCRE2:"));if(w.length>=1){const T=w[0].replace("PCRE2:","");if(T.indexOf(":")!==-1&&T.split(":").length>=2){const L=T.split(":")[1];h.push(":"+L)}}return h.join("")}e.buildRegexParseError=l;class c extends i.EventEmitter{constructor(h,w,T){super();this.maxResults=h,this.rootFolder=w,this.previewOptions=T,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new I.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(h,w){return super.on(h,w),this}handleData(h){if(this.isDone)return;const w=typeof h=="string"?h:this.stringDecoder.write(h);this.handleDecodedData(w)}handleDecodedData(h){let w=h.indexOf(`
`);const T=this.remainder+h;if(w>=0)w+=this.remainder.length;else{this.remainder=T;return}let L=0;for(;w>=0;)this.handleLine(T.substring(L,w).trim()),L=w+1,w=T.indexOf(`
`,L);this.remainder=T.substring(L)}handleLine(h){if(this.isDone||!h)return;let w;try{w=JSON.parse(h)}catch{throw new Error(`malformed line from rg: ${h}`)}if(w.type==="match"){const T=u(w.data.path),L=F.URI.file(S.join(this.rootFolder,T)),O=this.createTextSearchMatch(w.data,L);this.onResult(O),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(w.type==="context"){const T=u(w.data.path),L=F.URI.file(S.join(this.rootFolder,T));this.createTextSearchContext(w.data,L).forEach(y=>this.onResult(y))}}createTextSearchMatch(h,w){const T=h.line_number-1,L=u(h.lines),O=Buffer.from(L);let y=0,H=0,M=T;h.submatches.length===0&&h.submatches.push(L.length?{start:0,end:1,match:{text:L[0]}}:{start:0,end:0,match:{text:""}});const j=(0,A.coalesce)(h.submatches.map((X,$)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const U=u(X.match),q=O.slice(y,X.start).toString().length,K=H+q,G=a(U),ee=M,oe=G.numLines+ee,ue=G.numLines>0?G.lastLineLength:G.lastLineLength+K;return y=X.end,H=ue,M=oe,new v.Range(ee,K,oe,ue)}));return(0,d.createTextSearchResult)(w,L,j,this.previewOptions)}createTextSearchContext(h,w){const T=u(h.lines),L=h.line_number;return T.replace(/\r?\n$/,"").split(`
`).map((O,y)=>({text:O,uri:w,lineNumber:L+y}))}onResult(h){this.emit("result",h)}}e.RipgrepParser=c;function u(m){return m.bytes?Buffer.from(m.bytes,"base64").toString():m.text}function a(m){const h=/\n/g;let w=0,T=-1,L;for(;L=h.exec(m);)w++,T=L.index;const O=T>=0?m.length-T-1:m.length;return{numLines:w,lastLineLength:O}}function E(m,h){const w=["--hidden"];w.push(m.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:T,otherIncludes:L}=(0,C.groupBy)(h.includes,y=>y.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(L&&L.length){const y=new Set;L.forEach(H=>{y.add(H)}),w.push("-g","!*"),y.forEach(H=>{s(H).map(d.anchorGlob).forEach(M=>{w.push("-g",M)})})}T&&T.length&&T.forEach(y=>{w.push("-g",y)}),h.excludes.map(d.anchorGlob).forEach(y=>w.push("-g",`!${y}`)),h.maxFileSize&&w.push("--max-filesize",h.maxFileSize+""),h.useIgnoreFiles?h.useParentIgnoreFiles||w.push("--no-ignore-parent"):w.push("--no-ignore"),h.followSymlinks&&w.push("--follow"),h.encoding&&h.encoding!=="utf8"&&w.push("--encoding",h.encoding),m.pattern==="--"&&(m.isRegExp=!0,m.pattern="\\-\\-"),m.isMultiline&&!m.isRegExp&&(m.pattern=(0,R.escapeRegExpCharacters)(m.pattern),m.isRegExp=!0),h.usePCRE2&&w.push("--pcre2"),w.push("--crlf"),m.isRegExp&&(m.pattern=t(m.pattern),w.push("--engine","auto"));let O;if(m.isWordMatch){const H=(0,R.createRegExp)(m.pattern,!!m.isRegExp,{wholeWord:m.isWordMatch}).source.replace(/\\\//g,"/");w.push("--regexp",H)}else if(m.isRegExp){let y=n(m.pattern);y=o(y),w.push("--regexp",y)}else O=m.pattern,w.push("--fixed-strings");return w.push("--no-config"),h.useGlobalIgnoreFiles||w.push("--no-ignore-global"),w.push("--json"),m.isMultiline&&w.push("--multiline"),h.beforeContext&&w.push("--before-context",h.beforeContext+""),h.afterContext&&w.push("--after-context",h.afterContext+""),w.push("--"),O&&w.push(O),w.push("."),w}function s(m){const h=(0,k.splitGlobAware)(m,"/");return h.map((w,T)=>h.slice(0,T+1).join("/"))}e.spreadGlobComponents=s;function t(m){const h=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;m.match(h);)m=m.replace(h,"$1\\x{$2}");const w=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;m.match(w);)m=m.replace(w,"$1\\x{$2}");return m}e.unicodeEscapesToPCRE2=t;const r=m=>m.type==="Assertion"&&m.kind==="lookbehind";function n(m){let h;try{h=new b.RegExpParser().parsePattern(m)}catch{return m}let w="",T=0;const L=(H,M,j)=>{w+=m.slice(T,H)+j,T=M},O=[];return new b.RegExpVisitor({onCharacterEnter(H){if(H.raw!=="\\n")return;const M=O[0];if(!M)L(H.start,H.end,"\\r?\\n");else if(!O.some(r))if(M.type==="CharacterClass")if(M.negate){const j=m.slice(M.start+2,H.start)+m.slice(H.end,M.end-1);M.parent?.type==="Quantifier"?L(M.start,M.end,j?`[^${j}]`:"."):L(M.start,M.end,"(?!\\r?\\n"+(j?`|[${j}]`:"")+")")}else{const j=m.slice(M.start+1,H.start)+m.slice(H.end,M.end-1);L(M.start,M.end,j===""?"\\r?\\n":`(?:[${j}]|\\r?\\n)`)}else M.type==="Quantifier"&&L(H.start,H.end,"(?:\\r?\\n)")},onQuantifierEnter(H){O.unshift(H)},onQuantifierLeave(){O.shift()},onCharacterClassRangeEnter(H){O.unshift(H)},onCharacterClassRangeLeave(){O.shift()},onCharacterClassEnter(H){O.unshift(H)},onCharacterClassLeave(){O.shift()},onAssertionEnter(H){r(H)&&O.push(H)},onAssertionLeave(H){O[0]===H&&O.shift()}}).visit(h),w+=m.slice(T),w}e.fixRegexNewline=n;function o(m){return m.replace(/\n/g,"\\r?\\n")}e.fixNewline=o}),define(ve[284],we([1,0,21,139,118,10]),function(te,e,f,i,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class C{constructor(R){this.outputChannel=R,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(R,F,D,v){const b=new i.RipgrepTextSearchEngine(this.outputChannel);if(F.folder.scheme===A.Schemas.userData){const g={...F,folder:F.folder.with({scheme:A.Schemas.file})},d=new I.Progress(p=>D.report({...p,uri:p.uri.with({scheme:F.folder.scheme})}));return this.withToken(v,p=>b.provideTextSearchResults(R,g,d,p))}else return this.withToken(v,g=>b.provideTextSearchResults(R,F,D,g))}async withToken(R,F){const D=k(R);this.inProgress.add(D);const v=await F(D.token);return this.inProgress.delete(D),v}dispose(){this.inProgress.forEach(R=>R.cancel())}}e.RipgrepSearchProvider=C;function k(S){const R=new f.CancellationTokenSource;return S.onCancellationRequested(()=>R.cancel()),R}}),define(ve[285],we([1,0,28,139,138]),function(te,e,f,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class A{constructor(S){this.query=S}search(S,R,F){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const D={appendLine(b){F({message:b})}},v=new I.NativeTextSearchManager(this.query,new i.RipgrepTextSearchEngine(D),f);return new Promise((b,g)=>v.search(d=>{R(d.map(C))},S).then(d=>b({limitHit:d.limitHit,type:"success",stats:d.stats}),g))}}e.TextSearchEngineAdapter=A;function C(k){return{path:k.resource&&k.resource.fsPath,results:k.results,numMatches:(k.results||[]).reduce((S,R)=>{if(R.ranges){const F=R;return S+(Array.isArray(F.ranges)?F.ranges.length:1)}else return S+1},0)}}}),define(ve[286],we([1,0,18,16,15,3,98,9,46,2,42,31,277,285]),function(te,e,f,i,I,A,C,k,S,R,F,D,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class g{constructor(c="searchProcess"){this.processType=c,this.caches=Object.create(null)}fileSearch(c){let u;const a=P(c),E=new A.Emitter({onFirstListenerDidAdd:()=>{u=(0,i.createCancelablePromise)(s=>this.doFileSearchWithEngine(v.Engine,a,t=>E.fire(t),s)),u.then(s=>E.fire(s),s=>E.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onLastListenerRemove:()=>{u.cancel()}});return E.event}textSearch(c){let u;const a=P(c),E=new A.Emitter({onFirstListenerDidAdd:()=>{u=(0,i.createCancelablePromise)(s=>this.ripgrepTextSearch(a,t=>E.fire(t),s)),u.then(s=>E.fire(s),s=>E.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onLastListenerRemove:()=>{u.cancel()}});return E.event}ripgrepTextSearch(c,u,a){return c.maxFileSize=(0,F.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new b.TextSearchEngineAdapter(c).search(a,u,u)}doFileSearch(c,u,a){return this.doFileSearchWithEngine(v.Engine,c,u,a)}doFileSearchWithEngine(c,u,a,E,s=g.BATCH_SIZE){let t=0;const r=o=>{Array.isArray(o)?(t+=o.length,a(o.map(m=>this.rawMatchToSearchItem(m)))):o.relativePath?(t++,a(this.rawMatchToSearchItem(o))):a(o)};if(u.sortByScore){let o=this.trySortedSearchFromCache(u,r,E);if(!o){const m=u.maxResults?Object.assign({},u,{maxResults:null}):u,h=new c(m);o=this.doSortedSearch(h,u,a,r,E)}return new Promise((m,h)=>{o.then(([w,T])=>{const L=T.map(O=>this.rawMatchToSearchItem(O));this.sendProgress(L,a,s),m(w)},h)})}const n=new c(u);return this.doSearch(n,r,s,E).then(o=>({limitHit:o.limitHit,type:"success",stats:{detailStats:o.stats,type:this.processType,fromCache:!1,resultCount:t,sortingTime:void 0}}))}rawMatchToSearchItem(c){return{path:c.base?(0,k.join)(c.base,c.relativePath):c.relativePath}}doSortedSearch(c,u,a,E,s){const t=new A.Emitter;let r=(0,i.createCancelablePromise)(o=>{let m=[];const h=w=>{Array.isArray(w)?m=w:(E(w),t.fire(w))};return this.doSearch(c,h,-1,o).then(w=>[w,m])}),n;if(u.cacheKey){n=this.getOrCreateCache(u.cacheKey);const o={promise:r,event:t.event,resolved:!1};n.resultsToSearchCache[u.filePattern||""]=o,r.then(()=>{o.resolved=!0},m=>{delete n.resultsToSearchCache[u.filePattern||""]}),r=this.preventCancellation(r)}return r.then(([o,m])=>{const h=n?n.scorerCache:Object.create(null),w=(typeof u.maxResults!="number"||u.maxResults>0)&&S.StopWatch.create(!1);return this.sortResults(u,m,h,s).then(T=>{const L=w?w.elapsed():-1;return[{type:"success",stats:{detailStats:o.stats,sortingTime:L,fromCache:!1,type:this.processType,workspaceFolderCount:u.folderQueries.length,resultCount:T.length},messages:o.messages,limitHit:o.limitHit||typeof u.maxResults=="number"&&m.length>u.maxResults},T]})})}getOrCreateCache(c){const u=this.caches[c];return u||(this.caches[c]=new d)}trySortedSearchFromCache(c,u,a){const E=c.cacheKey&&this.caches[c.cacheKey];if(!E)return;const s=this.getResultsFromCache(E,c.filePattern||"",u,a);if(s)return s.then(([t,r,n])=>{const o=S.StopWatch.create(!1);return this.sortResults(c,r,E.scorerCache,a).then(m=>{const h=o.elapsed(),w={fromCache:!0,detailStats:n,type:this.processType,resultCount:r.length,sortingTime:h};return[{type:"success",limitHit:t.limitHit||typeof c.maxResults=="number"&&r.length>c.maxResults,stats:w},m]})})}sortResults(c,u,a,E){const s=(0,C.prepareQuery)(c.filePattern||""),t=(n,o)=>(0,C.compareItemsByFuzzyScore)(n,o,s,!0,p,a),r=typeof c.maxResults=="number"?c.maxResults:Number.MAX_VALUE;return f.topAsync(u,t,r,1e4,E)}sendProgress(c,u,a){if(a&&a>0)for(let E=0;E<c.length;E+=a)u(c.slice(E,E+a));else u(c)}getResultsFromCache(c,u,a,E){const s=S.StopWatch.create(!1),t=u.indexOf(k.sep)>=0;let r;for(const h in c.resultsToSearchCache)if(u.startsWith(h)){if(t&&h.indexOf(k.sep)<0&&h!=="")continue;const w=c.resultsToSearchCache[h];r={promise:this.preventCancellation(w.promise),event:w.event,resolved:w.resolved};break}if(!r)return null;const n=s.elapsed(),o=S.StopWatch.create(!1),m=r.event(a);return E&&E.onCancellationRequested(()=>{m.dispose()}),r.promise.then(([h,w])=>{if(E&&E.isCancellationRequested)throw(0,I.canceled)();const T=[],L=(0,C.prepareQuery)(u).normalizedLowercase;for(const O of w)!(0,D.isFilePatternMatch)(O,L)||T.push(O);return[h,T,{cacheWasResolved:r.resolved,cacheLookupTime:n,cacheFilterTime:o.elapsed(),cacheEntryCount:w.length}]})}doSearch(c,u,a,E){return new Promise((s,t)=>{let r=[];E&&E.onCancellationRequested(()=>c.cancel()),c.search(n=>{n&&(a?(r.push(n),a>0&&r.length>=a&&(u(r),r=[])):u(n))},n=>{u(n)},(n,o)=>{r.length&&u(r),n?t(n):s(o)})})}clearCache(c){return delete this.caches[c],Promise.resolve(void 0)}preventCancellation(c){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(u,a){return c.then(u,a)}catch(u){return this.then(void 0,u)}finally(u){return c.finally(u)}}}}e.SearchService=g,g.BATCH_SIZE=512;class d{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const p=new class{getItemLabel(l){return(0,k.basename)(l.relativePath)}getItemDescription(l){return(0,k.dirname)(l.relativePath)}getItemPath(l){return l.relativePath}};function P(l){return{...l,folderQueries:l.folderQueries&&l.folderQueries.map(_),extraFileResources:l.extraFileResources&&l.extraFileResources.map(c=>R.URI.revive(c))}}function _(l){return{...l,folder:R.URI.revive(l.folder)}}}),define(ve[287],we([1,0,6,10,2,28,11,26,17,71,63,31,286,284,88,138]),function(te,e,f,i,I,A,C,k,S,R,F,D,v,b,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let p=class extends R.ExtHostSearch{constructor(_,l,c,u){super(_,c,u);this._pfs=A,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1;const a=new g.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(i.Schemas.userData,new b.RipgrepSearchProvider(a)),l.remote.isRemote&&l.remote.authority&&this._registerEHSearchProviders()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const _=new g.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(i.Schemas.file,new b.RipgrepSearchProvider(_)),this.registerInternalFileSearchProvider(i.Schemas.file,new v.SearchService("fileSearchProvider"))}registerInternalFileSearchProvider(_,l){const c=this._handlePool++;return this._internalFileSearchProvider=l,this._internalFileSearchHandle=c,this._proxy.$registerFileSearchProvider(c,this._transformScheme(_)),(0,f.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(c)})}$provideFileSearchResults(_,l,c,u){const a=(0,R.reviveQuery)(c);return _===this._internalFileSearchHandle?this.doInternalFileSearch(_,l,a,u):super.$provideFileSearchResults(_,l,c,u)}doInternalFileSearch(_,l,c,u){const a=E=>{if((0,D.isSerializedFileMatch)(E)&&(E=[E]),Array.isArray(E)){this._proxy.$handleFileMatch(_,l,E.map(s=>I.URI.file(s.path)));return}E.message&&this._logService.debug("ExtHostSearch",E.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(c,a,u)}$clearCache(_){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(_),super.$clearCache(_)}createTextSearchManager(_,l){return new d.NativeTextSearchManager(_,l,void 0,"textSearchProvider")}};p=Be([Fe(0,S.IExtHostRpcService),Fe(1,k.IExtHostInitDataService),Fe(2,F.IURITransformerService),Fe(3,C.ILogService)],p),e.NativeExtHostSearch=p}),define(ve[140],we([1,0,297,127,60,22,15,3,6,9,12,33,104,105,298]),function(te,e,f,i,I,A,C,k,S,R,F,D,v,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class d{constructor(w,T=""){this.debugLabel=T,this.socket=w,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=L=>{if(this.traceSocketEvent("error",{code:L?.code,message:L?.message}),L){if(L.code==="EPIPE")return;(0,C.onUnexpectedError)(L)}},this.socket.on("error",this._errorListener)}traceSocketEvent(w,T){b.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,w,T)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(w){const T=L=>{this.traceSocketEvent("read",L),w(A.VSBuffer.wrap(L))};return this.socket.on("data",T),{dispose:()=>this.socket.off("data",T)}}onClose(w){const T=L=>{this.traceSocketEvent("close",{hadError:L}),w({type:0,hadError:L,error:void 0})};return this.socket.on("close",T),{dispose:()=>this.socket.off("close",T)}}onEnd(w){const T=()=>{this.traceSocketEvent("nodeEndReceived"),w()};return this.socket.on("end",T),{dispose:()=>this.socket.off("end",T)}}write(w){if(!this.socket.destroyed)try{this.traceSocketEvent("write",w),this.socket.write(w.buffer,T=>{if(T){if(T.code==="EPIPE")return;(0,C.onUnexpectedError)(T)}})}catch(T){if(T.code==="EPIPE")return;(0,C.onUnexpectedError)(T)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((w,T)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),w();return}const L=()=>{this.socket.off("close",L),this.socket.off("end",L),this.socket.off("error",L),this.socket.off("timeout",L),this.socket.off("drain",L),this.traceSocketEvent("nodeDrainEnd"),w()};this.socket.on("close",L),this.socket.on("end",L),this.socket.on("error",L),this.socket.on("timeout",L),this.socket.on("drain",L)})}}e.NodeSocket=d;var p;(function(h){h[h.MinHeaderByteSize=2]="MinHeaderByteSize"})(p||(p={}));var P;(function(h){h[h.PeekHeader=1]="PeekHeader",h[h.ReadHeader=2]="ReadHeader",h[h.ReadBody=3]="ReadBody",h[h.Fin=4]="Fin"})(P||(P={}));class _ extends S.Disposable{constructor(w,T,L,O){super();this._onData=this._register(new k.Emitter),this._onClose=this._register(new k.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=w,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:T,inflateBytesLength:L?.byteLength||0,recordInflateBytes:O}),this._flowManager=this._register(new l(this,T,L,O,this._onData,(y,H)=>this._write(y,H))),this._register(this._flowManager.onError(y=>{console.error(y),(0,C.onUnexpectedError)(y),this._onClose.fire({type:0,hadError:!0,error:y})})),this._incomingData=new b.ChunkStream,this._register(this.socket.onData(y=>this._acceptChunk(y))),this._register(this.socket.onClose(y=>this._onClose.fire(y)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(w,T){this.socket.traceSocketEvent(w,T)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(w){return this._onData.event(w)}onClose(w){return this._onClose.event(w)}onEnd(w){return this.socket.onEnd(w)}write(w){this._flowManager.writeMessage(w)}_write(w,T){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",w);let L=2;w.byteLength<126?L+=0:w.byteLength<2**16?L+=2:L+=8;const O=A.VSBuffer.alloc(L);if(T?O.writeUInt8(194,0):O.writeUInt8(130,0),w.byteLength<126)O.writeUInt8(w.byteLength,1);else if(w.byteLength<2**16){O.writeUInt8(126,1);let y=1;O.writeUInt8(w.byteLength>>>8&255,++y),O.writeUInt8(w.byteLength>>>0&255,++y)}else{O.writeUInt8(127,1);let y=1;O.writeUInt8(0,++y),O.writeUInt8(0,++y),O.writeUInt8(0,++y),O.writeUInt8(0,++y),O.writeUInt8(w.byteLength>>>24&255,++y),O.writeUInt8(w.byteLength>>>16&255,++y),O.writeUInt8(w.byteLength>>>8&255,++y),O.writeUInt8(w.byteLength>>>0&255,++y)}this.socket.write(A.VSBuffer.concat([O,w]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(w){if(w.byteLength!==0){for(this._incomingData.acceptChunk(w);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const T=this._incomingData.peek(this._state.readLen),L=T.readUInt8(0),O=(L&128)>>>7,y=(L&64)>>>6,H=T.readUInt8(1),M=(H&128)>>>7,j=H&127;this._state.state=2,this._state.readLen=2+(M?4:0)+(j===126?2:0)+(j===127?8:0),this._state.fin=O,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(y)),this._state.firstFrameOfMessage=Boolean(O),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const T=this._incomingData.read(this._state.readLen),L=T.readUInt8(1),O=(L&128)>>>7;let y=L&127,H=1;y===126?y=T.readUInt8(++H)*2**8+T.readUInt8(++H):y===127&&(y=T.readUInt8(++H)*0+T.readUInt8(++H)*0+T.readUInt8(++H)*0+T.readUInt8(++H)*0+T.readUInt8(++H)*2**24+T.readUInt8(++H)*2**16+T.readUInt8(++H)*2**8+T.readUInt8(++H));let M=0;O&&(M=T.readUInt8(++H)*2**24+T.readUInt8(++H)*2**16+T.readUInt8(++H)*2**8+T.readUInt8(++H)),this._state.state=3,this._state.readLen=y,this._state.mask=M,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const T=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",T),a(T,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",T),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(T,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await k.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=_;class l extends S.Disposable{constructor(w,T,L,O,y,H){super();this._tracer=w,this._onData=y,this._writeFn=H,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new k.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,T?(this._zlibInflateStream=this._register(new c(this._tracer,O,L,{windowBits:15})),this._zlibDeflateStream=this._register(new u(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(M=>this._onError.fire(M))),this._register(this._zlibDeflateStream.onError(M=>this._onError.fire(M)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:A.VSBuffer.alloc(0)}writeMessage(w){this._writeQueue.push(w),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const w=this._writeQueue.shift();if(this._zlibDeflateStream){const T=await this._deflateMessage(this._zlibDeflateStream,w);this._writeFn(T,!0)}else this._writeFn(w,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(w,T){return new Promise((L,O)=>{w.write(T),w.flush(y=>L(y))})}acceptFrame(w,T,L){this._readQueue.push({data:w,isCompressed:T,isLastFrameOfMessage:L}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const w=this._readQueue.shift();if(this._zlibInflateStream&&w.isCompressed){const T=await this._inflateFrame(this._zlibInflateStream,w.data,w.isLastFrameOfMessage);this._onData.fire(T)}else this._onData.fire(w.data)}this._isProcessingReadQueue=!1}}_inflateFrame(w,T,L){return new Promise((O,y)=>{w.write(T),L&&w.write(A.VSBuffer.fromByteArray([0,0,255,255])),w.flush(H=>O(H))})}}class c extends S.Disposable{constructor(w,T,L,O){super();this._tracer=w,this._recordInflateBytes=T,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=g.createInflateRaw(O),this._zlibInflate.on("error",y=>{this._tracer.traceSocketEvent("zlibInflateError",{message:y?.message,code:y?.code}),this._onError.fire(y)}),this._zlibInflate.on("data",y=>{this._tracer.traceSocketEvent("zlibInflateData",y),this._pendingInflateData.push(A.VSBuffer.wrap(y))}),L&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",L.buffer),this._zlibInflate.write(L.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?A.VSBuffer.concat(this._recordedInflateBytes):A.VSBuffer.alloc(0)}write(w){this._recordInflateBytes&&this._recordedInflateBytes.push(w.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",w),this._zlibInflate.write(w.buffer)}flush(w){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const T=A.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,w(T)})}}class u extends S.Disposable{constructor(w,T){super();this._tracer=w,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=g.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",L=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:L?.message,code:L?.code}),this._onError.fire(L)}),this._zlibDeflate.on("data",L=>{this._tracer.traceSocketEvent("zlibDeflateData",L),this._pendingDeflateData.push(A.VSBuffer.wrap(L))})}write(w){this._tracer.traceSocketEvent("zlibDeflateWrite",w.buffer),this._zlibDeflate.write(w.buffer)}flush(w){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let T=A.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,T=T.slice(0,T.byteLength-4),w(T)})}}function a(h,w){if(w===0)return;let T=h.byteLength>>>2;for(let j=0;j<T;j++){const X=h.readUInt32BE(j*4);h.writeUInt32BE(X^w,j*4)}let L=T*4,O=h.byteLength-L;const y=w>>>24&255,H=w>>>16&255,M=w>>>8&255;O>=1&&h.writeUInt8(h.readUInt8(L)^y,L),O>=2&&h.writeUInt8(h.readUInt8(L+1)^H,L+1),O>=3&&h.writeUInt8(h.readUInt8(L+2)^M,L+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const E={[2]:107,[1]:103};function s(){const h=(0,D.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${h}-sock`;let w;return e.XDG_RUNTIME_DIR?w=(0,R.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${h}.sock`):w=(0,R.join)((0,I.tmpdir)(),`vscode-ipc-${h}.sock`),r(w),w}e.createRandomIPCHandle=s;function t(h,w,T){const L=(0,f.createHash)("md5").update(h).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${L}-${T}-${w}-sock`;let O;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?O=(0,R.join)(e.XDG_RUNTIME_DIR,`vscode-${L.substr(0,8)}-${T}-${w}.sock`):O=(0,R.join)(h,`${T}-${w}.sock`),r(O),O}e.createStaticIPCHandle=t;function r(h){const w=E[F.platform];typeof w=="number"&&h.length>=w&&console.warn(`WARNING: IPC handle "${h}" is longer than ${w} chars, try a shorter --user-data-dir`)}class n extends v.IPCServer{constructor(w){super(n.toClientConnectionEvent(w));this.server=w}static toClientConnectionEvent(w){const T=k.Event.fromNodeEventEmitter(w,"connection");return k.Event.map(T,L=>({protocol:new b.Protocol(new d(L,"ipc-server-connection")),onDidClientDisconnect:k.Event.once(k.Event.fromNodeEventEmitter(L,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=n;function o(h){return new Promise((w,T)=>{const L=(0,i.createServer)();L.on("error",T),L.listen(h,()=>{L.removeListener("error",T),w(new n(L))})})}e.serve=o;function m(h,w){return new Promise((T,L)=>{const O=(0,i.createConnection)(h,()=>{O.removeListener("error",L),T(b.Client.fromSocket(new d(O,`ipc-client${w}`),w))});O.once("error",L)})}e.connect=m}),define(ve[288],we([1,0,140,283,59,39,2,11,43]),function(te,e,f,i,I,A,C,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class R{constructor(v,b,g){this._commands=v,this.logService=b,this._ipcHandlePath=g,this._server=i.createServer((d,p)=>this.onRequest(d,p)),this.setup().catch(d=>(b.error(d),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",v=>this.logService.error(v))}catch{this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(v,b){const g=(p,P)=>{b.writeHead(p,{"content-type":"application/json"}),b.end(JSON.stringify(P),_=>_&&this.logService.error(_))},d=[];v.setEncoding("utf8"),v.on("data",p=>d.push(p)),v.on("end",async()=>{try{const p=JSON.parse(d.join(""));let P;switch(p.type){case"open":P=await this.open(p);break;case"openExternal":P=await this.openExternal(p);break;case"status":P=await this.getStatus(p);break;case"extensionManagement":P=await this.manageExtensions(p);break;default:g(404,`Unknown message type: ${p.type}`);break}g(200,P)}catch(p){const P=p instanceof Error?p.message:JSON.stringify(p);g(500,P),this.logService.error("Error while processing pipe request",p)}})}async open(v){const{fileURIs:b,folderURIs:g,forceNewWindow:d,diffMode:p,addMode:P,forceReuseWindow:_,gotoLineMode:l,waitMarkerFilePath:c,remoteAuthority:u}=v,a=[];if(Array.isArray(g))for(const r of g)try{a.push({folderUri:C.URI.parse(r)})}catch{}if(Array.isArray(b))for(const r of b)try{(0,S.hasWorkspaceFileExtension)(r)?a.push({workspaceUri:C.URI.parse(r)}):a.push({fileUri:C.URI.parse(r)})}catch{}const E=c?C.URI.file(c):void 0,t={forceNewWindow:d,diffMode:p,addMode:P,gotoLineMode:l,forceReuseWindow:_,preferNewWindow:!_&&!E&&!P,waitMarkerFileURI:E,remoteAuthority:u};return this._commands.executeCommand("_remoteCLI.windowOpen",a,t),""}async openExternal(v){for(const b of v.uris){const g=C.URI.parse(b),d=g.scheme==="file"?g:b;await this._commands.executeCommand("_remoteCLI.openExternal",d)}}async manageExtensions(v){const b=d=>d?.map(p=>/\.vsix$/i.test(p)?C.URI.parse(p):p),g={list:v.list,install:b(v.install),uninstall:b(v.uninstall),force:v.force};return await this._commands.executeCommand("_remoteCLI.manageExtensions",g)}async getStatus(v){return await this._commands.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&I.existsSync(this._ipcHandlePath)&&I.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=R;let F=class extends R{constructor(v,b){super(v,b,(0,f.createRandomIPCHandle)())}};F=Be([Fe(0,A.IExtHostCommands),Fe(1,k.ILogService)],F),e.CLIServer=F}),define(ve[289],we([1,0,70,281,270,5,282,40,259,2,10,7,288,103]),function(te,e,f,i,I,A,C,k,S,R,F,D,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class g extends I.RequireInterceptor{_installInterceptor(){const P=this,_=te.__$__nodeRequire("module"),l=_._load;_._load=function(E,s,t){return E=u(E),P._factories.has(E)?P._factories.get(E).load(E,R.URI.file((0,b.realpathSync)(s.filename)),r=>l.apply(this,[r,s,t])):l.apply(this,arguments)};const c=_._resolveLookupPaths;_._resolveLookupPaths=(a,E)=>c.call(this,u(a),E);const u=a=>{for(let E of P._alternatives){let s=E(a);if(s){a=s;break}}return a}}}class d extends k.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=D.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const P=this._instaService.invokeFunction(i.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(S.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const a=this._instaService.createInstance(v.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=a.ipcHandlePath}await this._instaService.createInstance(g,P,this._registry).install(),f.mark("code/extHost/didInitAPI");const l=await this._extHostConfiguration.getConfigProvider();await(0,C.connectProxyResolver)(this._extHostWorkspace,l,this,this._logService,this._mainThreadTelemetryProxy,this._initData),f.mark("code/extHost/didInitProxyResolver");const c=process.send,u=this._extHostContext.getProxy(A.MainContext.MainThreadConsole);process.send=(...a)=>a.length===0||!a[0]||a[0].type!=="__$console"?c.apply(process,a):(u.$logExtensionHostMessage(a[0]),!1)}_getEntryPoint(P){return P.main}_loadCommonJSModule(P,_,l){if(_.scheme!==F.Schemas.file)throw new Error(`Cannot load URI: '${_}', must be of file-scheme`);let c=null;l.codeLoadingStart(),this._logService.trace(`ExtensionService#loadCommonJSModule ${_.toString(!0)}`),this._logService.flush();try{P&&f.mark(`code/extHost/willLoadExtensionCode/${P.value}`),c=te.__$__nodeRequire(_.fsPath)}catch(u){return Promise.reject(u)}finally{P&&f.mark(`code/extHost/didLoadExtensionCode/${P.value}`),l.codeLoadingStop()}return Promise.resolve(c)}async $setRemoteEnvironment(P){if(!!this._initData.remote.isRemote)for(const _ in P){const l=P[_];l===null?delete process.env[_]:process.env[_]=l}}}e.ExtHostExtensionService=d}),define(ve[290],we([1,0,79,262,273,272,287,289,263,54,40,71,69,34,51,66,261,260,11]),function(te,e,f,i,I,A,C,k,S,R,F,D,v,b,g,d,p,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,f.registerSingleton)(F.IExtHostExtensionService,k.ExtHostExtensionService),(0,f.registerSingleton)(_.ILoggerService,P.ExtHostLoggerService),(0,f.registerSingleton)(d.IExtensionStoragePaths,p.ExtensionStoragePaths),(0,f.registerSingleton)(R.IExtHostDebugService,A.ExtHostDebugService),(0,f.registerSingleton)(D.IExtHostSearch,C.NativeExtHostSearch),(0,f.registerSingleton)(v.IExtHostTask,I.ExtHostTask),(0,f.registerSingleton)(b.IExtHostTerminalService,i.ExtHostTerminalService),(0,f.registerSingleton)(g.IExtHostTunnelService,S.ExtHostTunnelService)}),define(ve[299],we([1,0,127,300,70,15,105,140,191,132,271,22,28,103,16,113,206,274,290]),function(te,e,f,i,I,A,C,k,S,R,F,D,v,b,g,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let r=0;r<process.execArgv.length;r++)process.execArgv[r]==="--inspect-port=0"&&(process.execArgv.splice(r,1),r--)}();const P=i(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const t=te.__$__nodeRequire("module"),r=t._load;t._load=function(n){if(n==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return r.apply(this,arguments)}})();const _=process.exit.bind(process);function l(t){process.exit=function(r){if(t)_(r);else{const n=new Error("An extension called process.exit() and this was prevented.");console.warn(n.stack)}},process.crash=function(){const r=new Error("An extension called process.crash() and this was prevented.");console.warn(r.stack)}}let c=function(t){_()};function u(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((t,r)=>{let n=null,o=setTimeout(()=>{c("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4);const m=108e5,h=3e5,w=new g.ProcessTimeRunOnceScheduler(()=>c("renderer disconnected for too long (1)"),m),T=new g.ProcessTimeRunOnceScheduler(()=>c("renderer disconnected for too long (2)"),h);process.on("message",(O,y)=>{if(O&&O.type==="VSCODE_EXTHOST_IPC_SOCKET"){y.setNoDelay(!0);const H=D.VSBuffer.wrap(Buffer.from(O.initialDataChunk,"base64"));let M;if(O.skipWebSocketFrames)M=new k.NodeSocket(y,"extHost-socket");else{const j=D.VSBuffer.wrap(Buffer.from(O.inflateBytes,"base64"));M=new k.WebSocketNodeSocket(new k.NodeSocket(y,"extHost-socket"),O.permessageDeflate,j,!1)}n?(w.cancel(),T.cancel(),n.beginAcceptReconnection(M,H),n.endAcceptReconnection(),n.sendResume()):(clearTimeout(o),n=new C.PersistentProtocol(M,H),n.sendResume(),n.onDidDispose(()=>c("renderer disconnected")),t(n),n.onSocketClose(()=>{w.schedule()}))}if(O&&O.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(T.isScheduled())return;w.isScheduled()&&T.schedule()}});const L={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(L)});{const t=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((r,n)=>{const o=f.createConnection(t,()=>{o.removeListener("error",n),r(new C.PersistentProtocol(new k.NodeSocket(o,"extHost-renderer")))});o.once("error",n),o.on("close",()=>{c("renderer closed the socket")})})}}async function a(){const t=await u();return new class{constructor(){this._onMessage=new C.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,t.onMessage(r=>{(0,R.isMessageOfType)(r,2)?(this._terminating=!0,c("received terminate message from renderer")):this._onMessage.fire(r)})}send(r){this._terminating||t.send(r)}drain(){return t.drain()}}}function E(t){return new Promise(r=>{const n=t.onMessage(o=>{n.dispose();const m=JSON.parse(o.toString()),h=m.commit,w=S.default.commit;h&&w&&h!==w&&_(55);let T=0;setInterval(function(){try{process.kill(m.parentPid,0),T=0}catch(O){O&&O.code==="EPERM"?(T++,T>=3&&c(`parent process ${m.parentPid} does not exist anymore (3 x EPERM): ${O.message} (code: ${O.code}) (errno: ${O.errno})`)):c(`parent process ${m.parentPid} does not exist anymore: ${O.message} (code: ${O.code}) (errno: ${O.errno})`)}},1e3);let L;try{L=te.__$__nodeRequire("native-watchdog"),L.start(m.parentPid)}catch(O){(0,A.onUnexpectedError)(O)}t.send((0,R.createMessageOfType)(0)),r({protocol:t,initData:m})});t.send((0,R.createMessageOfType)(1))})}async function s(){const t=[];process.on("unhandledRejection",(T,L)=>{t.push(L),setTimeout(()=>{const O=t.indexOf(L);O>=0&&L.catch(y=>{t.splice(O,1),(0,A.isCancellationError)(y)||(console.warn(`rejected promise not handled within 1 second: ${y}`),y&&y.stack&&console.warn(`stack trace: ${y.stack}`),T&&(0,A.onUnexpectedError)(T))})},1e3)}),process.on("rejectionHandled",T=>{const L=t.indexOf(T);L>=0&&t.splice(L,1)}),process.on("uncaughtException",function(T){(0,A.onUnexpectedError)(T)}),I.mark("code/extHost/willConnectToRenderer");const r=await a();I.mark("code/extHost/didConnectToRenderer");const n=await E(r);I.mark("code/extHost/didWaitForInitData");const{initData:o}=n;l(!!o.environment.extensionTestsLocationURI),o.environment.useHostProxy=P.useHostProxy!==void 0?P.useHostProxy!=="false":void 0,o.environment.skipWorkspaceStorageLock=(0,d.boolean)(P.skipWorkspaceStorageLock,!1);const m=new class{constructor(){this.pid=process.pid}exit(L){_(L)}exists(L){return v.Promises.exists(L)}realpath(L){return(0,b.realpath)(L)}};let h=null;o.remote.authority&&P.transformURIs&&(h=(0,p.createURITransformer)(o.remote.authority));const w=new F.ExtensionHostMain(n.protocol,o,m,h);c=T=>w.terminate(T)}e.startExtensionHostProcess=s,s().catch(t=>console.log(t))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/0058a3011e8686dc3199f56faf249ecf7663bf91/core/vs/workbench/api/node/extensionHostProcess.js.map
