/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ee=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/strings","vs/base/common/network","vs/base/common/types","vs/platform/log/common/log","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/base/common/errors","vs/base/common/arrays","vs/base/common/path","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/map","vs/base/common/platform","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/base/common/glob","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/severity","vs/base/common/extpath","vs/base/common/uuid","vs/platform/registry/common/platform","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/errorMessage","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTestingPrivateApi","vs/editor/common/core/range","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/idGenerator","vs/base/common/marshalling","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/common/webview","vs/workbench/contrib/testing/common/testCollection","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/collections","vs/base/common/mime","vs/base/common/htmlContent","vs/base/common/labels","vs/editor/common/languageSelector","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/configuration/common/configuration","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/notebook/common/notebookCommon","vs/base/common/process","vs/workbench/services/editor/common/editorGroupsService","vs/editor/common/languages","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostDecorations","vs/base/common/hash","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/codicons","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/common/editor","vs/workbench/api/common/extHostCodeInsets","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/output/common/output","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/base/common/stopwatch","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.common.services","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/prefixSumComputer","vs/base/common/linkedList","vs/editor/common/core/position","vs/base/common/lazy","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/base/common/functional","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],we=function(J){for(var e=[],s=0,I=J.length;s<I;s++)e[s]=Ee[J[s]];return e};define(Ee[42],we([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function s(I,b){if(!I)throw new Error(b?`Assertion failed (${b})`:"Assertion Failed")}e.ok=s}),define(Ee[70],we([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const s=Object.prototype.hasOwnProperty;function I(L){const v=[];for(let u in L)s.call(L,u)&&v.push(L[u]);return v}e.values=I;function b(L,v){for(let u in L)if(s.call(L,u)&&v({key:u,value:L[u]},function(){delete L[u]})===!1)return}e.forEach=b;function B(L,v){const u=Object.create(null);for(const m of L){const l=v(m);let n=u[l];n||(n=u[l]=[]),n.push(m)}return u}e.groupBy=B;function D(L){const v=Object.create(null);return L&&L.forEach((u,m)=>{v[m]=u}),v}e.fromMap=D;function A(L,v){const u=[],m=[];for(let l of L)v.has(l)||u.push(l);for(let l of v)L.has(l)||m.push(l);return{removed:u,added:m}}e.diffSets=A;function y(L,v){const u=[],m=[];for(let[l,n]of L)v.has(l)||u.push(n);for(let[l,n]of v)L.has(l)||m.push(n);return{removed:u,added:m}}e.diffMaps=y;class M{constructor(){this.map=new Map}add(v,u){let m=this.map.get(v);m||(m=new Set,this.map.set(v,m)),m.add(u)}delete(v,u){const m=this.map.get(v);!m||(m.delete(u),m.size===0&&this.map.delete(v))}forEach(v,u){const m=this.map.get(v);!m||m.forEach(u)}}e.SetMap=M}),define(Ee[52],we([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function s(D){return(A,y,M)=>{let L=null,v=null;if(typeof M.value=="function"?(L="value",v=M.value):typeof M.get=="function"&&(L="get",v=M.get),!v)throw new Error("not supported");M[L]=D(v,y)}}e.createDecorator=s;function I(D,A,y){let M=null,L=null;if(typeof y.value=="function"?(M="value",L=y.value,L.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(M="get",L=y.get),!L)throw new Error("not supported");const v=`$memoize$${A}`;y[M]=function(...u){return this.hasOwnProperty(v)||Object.defineProperty(this,v,{configurable:!1,enumerable:!1,writable:!1,value:L.apply(this,u)}),this[v]}}e.memoize=I;function b(D,A,y){return s((M,L)=>{const v=`$debounce$${L}`,u=`$debounce$result$${L}`;return function(...m){this[u]||(this[u]=y?y():void 0),clearTimeout(this[v]),A&&(this[u]=A(this[u],...m),m=[this[u]]),this[v]=setTimeout(()=>{M.apply(this,m),this[u]=y?y():void 0},D)}})}e.debounce=b;function B(D,A,y){return s((M,L)=>{const v=`$throttle$timer$${L}`,u=`$throttle$result$${L}`,m=`$throttle$lastRun$${L}`,l=`$throttle$pending$${L}`;return function(...n){if(this[u]||(this[u]=y?y():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),A&&(this[u]=A(this[u],...n)),this[l])return;const f=this[m]+D;f<=Date.now()?(this[m]=Date.now(),M.apply(this,[this[u]]),this[u]=y?y():void 0):(this[l]=!0,this[v]=setTimeout(()=>{this[l]=!1,this[m]=Date.now(),M.apply(this,[this[u]]),this[u]=y?y():void 0},f-Date.now()))}})}e.throttle=B}),define(Ee[53],we([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class s{constructor(b){this._prefix=b,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=s,e.defaultGenerator=new s("id#")}),define(Ee[100],we([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var s;(function(a){a[a.None=0]="None",a[a.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",a[a.UnexpectedEndOfString=2]="UnexpectedEndOfString",a[a.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",a[a.InvalidUnicode=4]="InvalidUnicode",a[a.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",a[a.InvalidCharacter=6]="InvalidCharacter"})(s=e.ScanError||(e.ScanError={}));var I;(function(a){a[a.OpenBraceToken=1]="OpenBraceToken",a[a.CloseBraceToken=2]="CloseBraceToken",a[a.OpenBracketToken=3]="OpenBracketToken",a[a.CloseBracketToken=4]="CloseBracketToken",a[a.CommaToken=5]="CommaToken",a[a.ColonToken=6]="ColonToken",a[a.NullKeyword=7]="NullKeyword",a[a.TrueKeyword=8]="TrueKeyword",a[a.FalseKeyword=9]="FalseKeyword",a[a.StringLiteral=10]="StringLiteral",a[a.NumericLiteral=11]="NumericLiteral",a[a.LineCommentTrivia=12]="LineCommentTrivia",a[a.BlockCommentTrivia=13]="BlockCommentTrivia",a[a.LineBreakTrivia=14]="LineBreakTrivia",a[a.Trivia=15]="Trivia",a[a.Unknown=16]="Unknown",a[a.EOF=17]="EOF"})(I=e.SyntaxKind||(e.SyntaxKind={}));var b;(function(a){a[a.InvalidSymbol=1]="InvalidSymbol",a[a.InvalidNumberFormat=2]="InvalidNumberFormat",a[a.PropertyNameExpected=3]="PropertyNameExpected",a[a.ValueExpected=4]="ValueExpected",a[a.ColonExpected=5]="ColonExpected",a[a.CommaExpected=6]="CommaExpected",a[a.CloseBraceExpected=7]="CloseBraceExpected",a[a.CloseBracketExpected=8]="CloseBracketExpected",a[a.EndOfFileExpected=9]="EndOfFileExpected",a[a.InvalidCommentToken=10]="InvalidCommentToken",a[a.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",a[a.UnexpectedEndOfString=12]="UnexpectedEndOfString",a[a.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",a[a.InvalidUnicode=14]="InvalidUnicode",a[a.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",a[a.InvalidCharacter=16]="InvalidCharacter"})(b=e.ParseErrorCode||(e.ParseErrorCode={}));var B;(function(a){a.DEFAULT={allowTrailingComma:!0}})(B=e.ParseOptions||(e.ParseOptions={}));function D(a,T=!1){let r=0,i=a.length,c="",t=0,o=16,g=0;function h(z){let q=0,G=0;for(;q<z;){const j=a.charCodeAt(r);if(j>=48&&j<=57)G=G*16+j-48;else if(j>=65&&j<=70)G=G*16+j-65+10;else if(j>=97&&j<=102)G=G*16+j-97+10;else break;r++,q++}return q<z&&(G=-1),G}function _(z){r=z,c="",t=0,o=16,g=0}function P(){const z=r;if(a.charCodeAt(r)===48)r++;else for(r++;r<a.length&&M(a.charCodeAt(r));)r++;if(r<a.length&&a.charCodeAt(r)===46)if(r++,r<a.length&&M(a.charCodeAt(r)))for(r++;r<a.length&&M(a.charCodeAt(r));)r++;else return g=3,a.substring(z,r);let q=r;if(r<a.length&&(a.charCodeAt(r)===69||a.charCodeAt(r)===101))if(r++,(r<a.length&&a.charCodeAt(r)===43||a.charCodeAt(r)===45)&&r++,r<a.length&&M(a.charCodeAt(r))){for(r++;r<a.length&&M(a.charCodeAt(r));)r++;q=r}else g=3;return a.substring(z,q)}function R(){let z="",q=r;for(;;){if(r>=i){z+=a.substring(q,r),g=2;break}const G=a.charCodeAt(r);if(G===34){z+=a.substring(q,r),r++;break}if(G===92){if(z+=a.substring(q,r),r++,r>=i){g=2;break}switch(a.charCodeAt(r++)){case 34:z+='"';break;case 92:z+="\\";break;case 47:z+="/";break;case 98:z+="\b";break;case 102:z+="\f";break;case 110:z+=`
`;break;case 114:z+="\r";break;case 116:z+="	";break;case 117:{const $=h(4);$>=0?z+=String.fromCharCode($):g=4;break}default:g=5}q=r;continue}if(G>=0&&G<=31)if(y(G)){z+=a.substring(q,r),g=2;break}else g=6;r++}return z}function W(){if(c="",g=0,t=r,r>=i)return t=i,o=17;let z=a.charCodeAt(r);if(A(z)){do r++,c+=String.fromCharCode(z),z=a.charCodeAt(r);while(A(z));return o=15}if(y(z))return r++,c+=String.fromCharCode(z),z===13&&a.charCodeAt(r)===10&&(r++,c+=`
`),o=14;switch(z){case 123:return r++,o=1;case 125:return r++,o=2;case 91:return r++,o=3;case 93:return r++,o=4;case 58:return r++,o=6;case 44:return r++,o=5;case 34:return r++,c=R(),o=10;case 47:{const q=r-1;if(a.charCodeAt(r+1)===47){for(r+=2;r<i&&!y(a.charCodeAt(r));)r++;return c=a.substring(q,r),o=12}if(a.charCodeAt(r+1)===42){r+=2;const G=i-1;let j=!1;for(;r<G;){if(a.charCodeAt(r)===42&&a.charCodeAt(r+1)===47){r+=2,j=!0;break}r++}return j||(r++,g=1),c=a.substring(q,r),o=13}return c+=String.fromCharCode(z),r++,o=16}case 45:if(c+=String.fromCharCode(z),r++,r===i||!M(a.charCodeAt(r)))return o=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return c+=P(),o=11;default:for(;r<i&&E(z);)r++,z=a.charCodeAt(r);if(t!==r){switch(c=a.substring(t,r),c){case"true":return o=8;case"false":return o=9;case"null":return o=7}return o=16}return c+=String.fromCharCode(z),r++,o=16}}function E(z){if(A(z)||y(z))return!1;switch(z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function H(){let z;do z=W();while(z>=12&&z<=15);return z}return{setPosition:_,getPosition:()=>r,scan:T?H:W,getToken:()=>o,getTokenValue:()=>c,getTokenOffset:()=>t,getTokenLength:()=>r-t,getTokenError:()=>g}}e.createScanner=D;function A(a){return a===32||a===9||a===11||a===12||a===160||a===5760||a>=8192&&a<=8203||a===8239||a===8287||a===12288||a===65279}function y(a){return a===10||a===13||a===8232||a===8233}function M(a){return a>=48&&a<=57}var L;(function(a){a[a.nullCharacter=0]="nullCharacter",a[a.maxAsciiCharacter=127]="maxAsciiCharacter",a[a.lineFeed=10]="lineFeed",a[a.carriageReturn=13]="carriageReturn",a[a.lineSeparator=8232]="lineSeparator",a[a.paragraphSeparator=8233]="paragraphSeparator",a[a.nextLine=133]="nextLine",a[a.space=32]="space",a[a.nonBreakingSpace=160]="nonBreakingSpace",a[a.enQuad=8192]="enQuad",a[a.emQuad=8193]="emQuad",a[a.enSpace=8194]="enSpace",a[a.emSpace=8195]="emSpace",a[a.threePerEmSpace=8196]="threePerEmSpace",a[a.fourPerEmSpace=8197]="fourPerEmSpace",a[a.sixPerEmSpace=8198]="sixPerEmSpace",a[a.figureSpace=8199]="figureSpace",a[a.punctuationSpace=8200]="punctuationSpace",a[a.thinSpace=8201]="thinSpace",a[a.hairSpace=8202]="hairSpace",a[a.zeroWidthSpace=8203]="zeroWidthSpace",a[a.narrowNoBreakSpace=8239]="narrowNoBreakSpace",a[a.ideographicSpace=12288]="ideographicSpace",a[a.mathematicalSpace=8287]="mathematicalSpace",a[a.ogham=5760]="ogham",a[a._=95]="_",a[a.$=36]="$",a[a._0=48]="_0",a[a._1=49]="_1",a[a._2=50]="_2",a[a._3=51]="_3",a[a._4=52]="_4",a[a._5=53]="_5",a[a._6=54]="_6",a[a._7=55]="_7",a[a._8=56]="_8",a[a._9=57]="_9",a[a.a=97]="a",a[a.b=98]="b",a[a.c=99]="c",a[a.d=100]="d",a[a.e=101]="e",a[a.f=102]="f",a[a.g=103]="g",a[a.h=104]="h",a[a.i=105]="i",a[a.j=106]="j",a[a.k=107]="k",a[a.l=108]="l",a[a.m=109]="m",a[a.n=110]="n",a[a.o=111]="o",a[a.p=112]="p",a[a.q=113]="q",a[a.r=114]="r",a[a.s=115]="s",a[a.t=116]="t",a[a.u=117]="u",a[a.v=118]="v",a[a.w=119]="w",a[a.x=120]="x",a[a.y=121]="y",a[a.z=122]="z",a[a.A=65]="A",a[a.B=66]="B",a[a.C=67]="C",a[a.D=68]="D",a[a.E=69]="E",a[a.F=70]="F",a[a.G=71]="G",a[a.H=72]="H",a[a.I=73]="I",a[a.J=74]="J",a[a.K=75]="K",a[a.L=76]="L",a[a.M=77]="M",a[a.N=78]="N",a[a.O=79]="O",a[a.P=80]="P",a[a.Q=81]="Q",a[a.R=82]="R",a[a.S=83]="S",a[a.T=84]="T",a[a.U=85]="U",a[a.V=86]="V",a[a.W=87]="W",a[a.X=88]="X",a[a.Y=89]="Y",a[a.Z=90]="Z",a[a.ampersand=38]="ampersand",a[a.asterisk=42]="asterisk",a[a.at=64]="at",a[a.backslash=92]="backslash",a[a.bar=124]="bar",a[a.caret=94]="caret",a[a.closeBrace=125]="closeBrace",a[a.closeBracket=93]="closeBracket",a[a.closeParen=41]="closeParen",a[a.colon=58]="colon",a[a.comma=44]="comma",a[a.dot=46]="dot",a[a.doubleQuote=34]="doubleQuote",a[a.equals=61]="equals",a[a.exclamation=33]="exclamation",a[a.greaterThan=62]="greaterThan",a[a.lessThan=60]="lessThan",a[a.minus=45]="minus",a[a.openBrace=123]="openBrace",a[a.openBracket=91]="openBracket",a[a.openParen=40]="openParen",a[a.percent=37]="percent",a[a.plus=43]="plus",a[a.question=63]="question",a[a.semicolon=59]="semicolon",a[a.singleQuote=39]="singleQuote",a[a.slash=47]="slash",a[a.tilde=126]="tilde",a[a.backspace=8]="backspace",a[a.formFeed=12]="formFeed",a[a.byteOrderMark=65279]="byteOrderMark",a[a.tab=9]="tab",a[a.verticalTab=11]="verticalTab"})(L||(L={}));function v(a,T){const r=[],i=new Object;let c;const t={value:{},offset:0,length:0,type:"object",parent:void 0};let o=!1;function g(h,_,P,R){t.value=h,t.offset=_,t.length=P,t.type=R,t.colonOffset=void 0,c=t}try{d(a,{onObjectBegin:(h,_)=>{if(T<=h)throw i;c=void 0,o=T>h,r.push("")},onObjectProperty:(h,_,P)=>{if(T<_||(g(h,_,P,"property"),r[r.length-1]=h,T<=_+P))throw i},onObjectEnd:(h,_)=>{if(T<=h)throw i;c=void 0,r.pop()},onArrayBegin:(h,_)=>{if(T<=h)throw i;c=void 0,r.push(0)},onArrayEnd:(h,_)=>{if(T<=h)throw i;c=void 0,r.pop()},onLiteralValue:(h,_,P)=>{if(T<_||(g(h,_,P,w(h)),T<=_+P))throw i},onSeparator:(h,_,P)=>{if(T<=_)throw i;if(h===":"&&c&&c.type==="property")c.colonOffset=_,o=!1,c=void 0;else if(h===","){const R=r[r.length-1];typeof R=="number"?r[r.length-1]=R+1:(o=!0,r[r.length-1]=""),c=void 0}}})}catch(h){if(h!==i)throw h}return{path:r,previousNode:c,isAtPropertyKey:o,matches:h=>{let _=0;for(let P=0;_<h.length&&P<r.length;P++)if(h[_]===r[P]||h[_]==="*")_++;else if(h[_]!=="**")return!1;return _===h.length}}}e.getLocation=v;function u(a,T=[],r=B.DEFAULT){let i=null,c=[];const t=[];function o(h){Array.isArray(c)?c.push(h):i!==null&&(c[i]=h)}return d(a,{onObjectBegin:()=>{const h={};o(h),t.push(c),c=h,i=null},onObjectProperty:h=>{i=h},onObjectEnd:()=>{c=t.pop()},onArrayBegin:()=>{const h=[];o(h),t.push(c),c=h,i=null},onArrayEnd:()=>{c=t.pop()},onLiteralValue:o,onError:(h,_,P)=>{T.push({error:h,offset:_,length:P})}},r),c[0]}e.parse=u;function m(a,T=[],r=B.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function c(h){i.type==="property"&&(i.length=h-i.offset,i=i.parent)}function t(h){return i.children.push(h),h}d(a,{onObjectBegin:h=>{i=t({type:"object",offset:h,length:-1,parent:i,children:[]})},onObjectProperty:(h,_,P)=>{i=t({type:"property",offset:_,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:h,offset:_,length:P,parent:i})},onObjectEnd:(h,_)=>{i.length=h+_-i.offset,i=i.parent,c(h+_)},onArrayBegin:(h,_)=>{i=t({type:"array",offset:h,length:-1,parent:i,children:[]})},onArrayEnd:(h,_)=>{i.length=h+_-i.offset,i=i.parent,c(h+_)},onLiteralValue:(h,_,P)=>{t({type:w(h),offset:_,length:P,parent:i,value:h}),c(_+P)},onSeparator:(h,_,P)=>{i.type==="property"&&(h===":"?i.colonOffset=_:h===","&&c(_))},onError:(h,_,P)=>{T.push({error:h,offset:_,length:P})}},r);const g=i.children[0];return g&&delete g.parent,g}e.parseTree=m;function l(a,T){if(!a)return;let r=a;for(let i of T)if(typeof i=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let c=!1;for(const t of r.children)if(Array.isArray(t.children)&&t.children[0].value===i){r=t.children[1],c=!0;break}if(!c)return}else{const c=i;if(r.type!=="array"||c<0||!Array.isArray(r.children)||c>=r.children.length)return;r=r.children[c]}return r}e.findNodeAtLocation=l;function n(a){if(!a.parent||!a.parent.children)return[];const T=n(a.parent);if(a.parent.type==="property"){const r=a.parent.children[0].value;T.push(r)}else if(a.parent.type==="array"){const r=a.parent.children.indexOf(a);r!==-1&&T.push(r)}return T}e.getNodePath=n;function f(a){switch(a.type){case"array":return a.children.map(f);case"object":{const T=Object.create(null);for(let r of a.children){const i=r.children[1];i&&(T[r.children[0].value]=f(i))}return T}case"null":case"string":case"number":case"boolean":return a.value;default:return}}e.getNodeValue=f;function S(a,T,r=!1){return T>=a.offset&&T<a.offset+a.length||r&&T===a.offset+a.length}e.contains=S;function k(a,T,r=!1){if(S(a,T,r)){const i=a.children;if(Array.isArray(i))for(let c=0;c<i.length&&i[c].offset<=T;c++){const t=k(i[c],T,r);if(t)return t}return a}}e.findNodeAtOffset=k;function d(a,T,r=B.DEFAULT){const i=D(a,!1);function c(Se){return Se?()=>Se(i.getTokenOffset(),i.getTokenLength()):()=>!0}function t(Se){return Se?fe=>Se(fe,i.getTokenOffset(),i.getTokenLength()):()=>!0}const o=c(T.onObjectBegin),g=t(T.onObjectProperty),h=c(T.onObjectEnd),_=c(T.onArrayBegin),P=c(T.onArrayEnd),R=t(T.onLiteralValue),W=t(T.onSeparator),E=c(T.onComment),H=t(T.onError),z=r&&r.disallowComments,q=r&&r.allowTrailingComma;function G(){for(;;){const Se=i.scan();switch(i.getTokenError()){case 4:j(14);break;case 5:j(15);break;case 3:j(13);break;case 1:z||j(11);break;case 2:j(12);break;case 6:j(16);break}switch(Se){case 12:case 13:z?j(10):E();break;case 16:j(1);break;case 15:case 14:break;default:return Se}}}function j(Se,fe=[],ne=[]){if(H(Se),fe.length+ne.length>0){let me=i.getToken();for(;me!==17;){if(fe.indexOf(me)!==-1){G();break}else if(ne.indexOf(me)!==-1)break;me=G()}}}function $(Se){const fe=i.getTokenValue();return Se?R(fe):g(fe),G(),!0}function ee(){switch(i.getToken()){case 11:{let Se=0;try{Se=JSON.parse(i.getTokenValue()),typeof Se!="number"&&(j(2),Se=0)}catch{j(2)}R(Se);break}case 7:R(null);break;case 8:R(!0);break;case 9:R(!1);break;default:return!1}return G(),!0}function se(){return i.getToken()!==10?(j(3,[],[2,5]),!1):($(!1),i.getToken()===6?(W(":"),G(),ue()||j(4,[],[2,5])):j(5,[],[2,5]),!0)}function Z(){o(),G();let Se=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(Se||j(4,[],[]),W(","),G(),i.getToken()===2&&q)break}else Se&&j(6,[],[]);se()||j(4,[],[2,5]),Se=!0}return h(),i.getToken()!==2?j(7,[2],[]):G(),!0}function le(){_(),G();let Se=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(Se||j(4,[],[]),W(","),G(),i.getToken()===4&&q)break}else Se&&j(6,[],[]);ue()||j(4,[],[4,5]),Se=!0}return P(),i.getToken()!==4?j(8,[4],[]):G(),!0}function ue(){switch(i.getToken()){case 3:return le();case 1:return Z();case 10:return $(!0);default:return ee()}}return G(),i.getToken()===17?r.allowEmptyContent?!0:(j(4,[],[]),!1):ue()?(i.getToken()!==17&&j(9,[],[]),!0):(j(4,[],[]),!1)}e.visit=d;function p(a,T){let r=D(a),i=[],c,t=0,o;do switch(o=r.getPosition(),c=r.scan(),c){case 12:case 13:case 17:t!==o&&i.push(a.substring(t,o)),T!==void 0&&i.push(r.getTokenValue().replace(/[^\r\n]/g,T)),t=r.getPosition();break}while(c!==17);return i.join("")}e.stripComments=p;function w(a){switch(typeof a){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(a){if(Array.isArray(a))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=w}),function(J,e){typeof exports=="object"&&typeof module!="undefined"?e(exports):typeof define=="function"&&define.amd?define(Ee[101],we([0]),e):(J=typeof globalThis!="undefined"?globalThis:J||self,e(J.marked={}))}(this,function(J){"use strict";function e(ge,de){for(var N=0;N<de.length;N++){var F=de[N];F.enumerable=F.enumerable||!1,F.configurable=!0,"value"in F&&(F.writable=!0),Object.defineProperty(ge,F.key,F)}}function s(ge,de,N){return de&&e(ge.prototype,de),N&&e(ge,N),Object.defineProperty(ge,"prototype",{writable:!1}),ge}function I(ge,de){if(!!ge){if(typeof ge=="string")return b(ge,de);var N=Object.prototype.toString.call(ge).slice(8,-1);if(N==="Object"&&ge.constructor&&(N=ge.constructor.name),N==="Map"||N==="Set")return Array.from(ge);if(N==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(N))return b(ge,de)}}function b(ge,de){(de==null||de>ge.length)&&(de=ge.length);for(var N=0,F=new Array(de);N<de;N++)F[N]=ge[N];return F}function B(ge,de){var N=typeof Symbol!="undefined"&&ge[Symbol.iterator]||ge["@@iterator"];if(N)return(N=N.call(ge)).next.bind(N);if(Array.isArray(ge)||(N=I(ge))||de&&ge&&typeof ge.length=="number"){N&&(ge=N);var F=0;return function(){return F>=ge.length?{done:!0}:{done:!1,value:ge[F++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function D(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}J.defaults=D();function A(ge){J.defaults=ge}var y=/[&<>"']/,M=/[&<>"']/g,L=/[<>"']|&(?!#?\w+;)/,v=/[<>"']|&(?!#?\w+;)/g,u={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},m=function(de){return u[de]};function l(ge,de){if(de){if(y.test(ge))return ge.replace(M,m)}else if(L.test(ge))return ge.replace(v,m);return ge}var n=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function f(ge){return ge.replace(n,function(de,N){return N=N.toLowerCase(),N==="colon"?":":N.charAt(0)==="#"?N.charAt(1)==="x"?String.fromCharCode(parseInt(N.substring(2),16)):String.fromCharCode(+N.substring(1)):""})}var S=/(^|[^\[])\^/g;function k(ge,de){ge=ge.source||ge,de=de||"";var N={replace:function(C,O){return O=O.source||O,O=O.replace(S,"$1"),ge=ge.replace(C,O),N},getRegex:function(){return new RegExp(ge,de)}};return N}var d=/[^\w:]/g,p=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function w(ge,de,N){if(ge){var F;try{F=decodeURIComponent(f(N)).replace(d,"").toLowerCase()}catch{return null}if(F.indexOf("javascript:")===0||F.indexOf("vbscript:")===0||F.indexOf("data:")===0)return null}de&&!p.test(N)&&(N=c(de,N));try{N=encodeURI(N).replace(/%25/g,"%")}catch{return null}return N}var a={},T=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function c(ge,de){a[" "+ge]||(T.test(ge)?a[" "+ge]=ge+"/":a[" "+ge]=h(ge,"/",!0)),ge=a[" "+ge];var N=ge.indexOf(":")===-1;return de.substring(0,2)==="//"?N?de:ge.replace(r,"$1")+de:de.charAt(0)==="/"?N?de:ge.replace(i,"$1")+de:ge+de}var t={exec:function(){}};function o(ge){for(var de=1,N,F;de<arguments.length;de++){N=arguments[de];for(F in N)Object.prototype.hasOwnProperty.call(N,F)&&(ge[F]=N[F])}return ge}function g(ge,de){var N=ge.replace(/\|/g,function(O,x,Q){for(var re=!1,ve=x;--ve>=0&&Q[ve]==="\\";)re=!re;return re?"|":" |"}),F=N.split(/ \|/),C=0;if(F[0].trim()||F.shift(),F[F.length-1].trim()||F.pop(),F.length>de)F.splice(de);else for(;F.length<de;)F.push("");for(;C<F.length;C++)F[C]=F[C].trim().replace(/\\\|/g,"|");return F}function h(ge,de,N){var F=ge.length;if(F===0)return"";for(var C=0;C<F;){var O=ge.charAt(F-C-1);if(O===de&&!N)C++;else if(O!==de&&N)C++;else break}return ge.substr(0,F-C)}function _(ge,de){if(ge.indexOf(de[1])===-1)return-1;for(var N=ge.length,F=0,C=0;C<N;C++)if(ge[C]==="\\")C++;else if(ge[C]===de[0])F++;else if(ge[C]===de[1]&&(F--,F<0))return C;return-1}function P(ge){ge&&ge.sanitize&&!ge.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function R(ge,de){if(de<1)return"";for(var N="";de>1;)de&1&&(N+=ge),de>>=1,ge+=ge;return N+ge}function W(ge,de,N,F){var C=de.href,O=de.title?l(de.title):null,x=ge[1].replace(/\\([\[\]])/g,"$1");if(ge[0].charAt(0)!=="!"){F.state.inLink=!0;var Q={type:"link",raw:N,href:C,title:O,text:x,tokens:F.inlineTokens(x,[])};return F.state.inLink=!1,Q}else return{type:"image",raw:N,href:C,title:O,text:l(x)}}function E(ge,de){var N=ge.match(/^(\s+)(?:```)/);if(N===null)return de;var F=N[1];return de.split(`
`).map(function(C){var O=C.match(/^\s+/);if(O===null)return C;var x=O[0];return x.length>=F.length?C.slice(F.length):C}).join(`
`)}var H=function(){function ge(N){this.options=N||J.defaults}var de=ge.prototype;return de.space=function(F){var C=this.rules.block.newline.exec(F);if(C&&C[0].length>0)return{type:"space",raw:C[0]}},de.code=function(F){var C=this.rules.block.code.exec(F);if(C){var O=C[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:C[0],codeBlockStyle:"indented",text:this.options.pedantic?O:h(O,`
`)}}},de.fences=function(F){var C=this.rules.block.fences.exec(F);if(C){var O=C[0],x=E(O,C[3]||"");return{type:"code",raw:O,lang:C[2]?C[2].trim():C[2],text:x}}},de.heading=function(F){var C=this.rules.block.heading.exec(F);if(C){var O=C[2].trim();if(/#$/.test(O)){var x=h(O,"#");(this.options.pedantic||!x||/ $/.test(x))&&(O=x.trim())}var Q={type:"heading",raw:C[0],depth:C[1].length,text:O,tokens:[]};return this.lexer.inline(Q.text,Q.tokens),Q}},de.hr=function(F){var C=this.rules.block.hr.exec(F);if(C)return{type:"hr",raw:C[0]}},de.blockquote=function(F){var C=this.rules.block.blockquote.exec(F);if(C){var O=C[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:C[0],tokens:this.lexer.blockTokens(O,[]),text:O}}},de.list=function(F){var C=this.rules.block.list.exec(F);if(C){var O,x,Q,re,ve,Ie,Me,Le,ze,xe,Re,Qe,tt=C[1].trim(),Te=tt.length>1,it={type:"list",raw:"",ordered:Te,start:Te?+tt.slice(0,-1):"",loose:!1,items:[]};tt=Te?"\\d{1,9}\\"+tt.slice(-1):"\\"+tt,this.options.pedantic&&(tt=Te?tt:"[*+-]");for(var X=new RegExp("^( {0,3}"+tt+")((?: [^\\n]*)?(?:\\n|$))");F&&(Qe=!1,!(!(C=X.exec(F))||this.rules.block.hr.test(F)));){if(O=C[0],F=F.substring(O.length),Le=C[2].split(`
`,1)[0],ze=F.split(`
`,1)[0],this.options.pedantic?(re=2,Re=Le.trimLeft()):(re=C[2].search(/[^ ]/),re=re>4?1:re,Re=Le.slice(re),re+=C[1].length),Ie=!1,!Le&&/^ *$/.test(ze)&&(O+=ze+`
`,F=F.substring(ze.length+1),Qe=!0),!Qe)for(var Y=new RegExp("^ {0,"+Math.min(3,re-1)+"}(?:[*+-]|\\d{1,9}[.)])");F&&(xe=F.split(`
`,1)[0],Le=xe,this.options.pedantic&&(Le=Le.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!Y.test(Le));){if(Le.search(/[^ ]/)>=re||!Le.trim())Re+=`
`+Le.slice(re);else if(!Ie)Re+=`
`+Le;else break;!Ie&&!Le.trim()&&(Ie=!0),O+=xe+`
`,F=F.substring(xe.length+1)}it.loose||(Me?it.loose=!0:/\n *\n *$/.test(O)&&(Me=!0)),this.options.gfm&&(x=/^\[[ xX]\] /.exec(Re),x&&(Q=x[0]!=="[ ] ",Re=Re.replace(/^\[[ xX]\] +/,""))),it.items.push({type:"list_item",raw:O,task:!!x,checked:Q,loose:!1,text:Re}),it.raw+=O}it.items[it.items.length-1].raw=O.trimRight(),it.items[it.items.length-1].text=Re.trimRight(),it.raw=it.raw.trimRight();var ce=it.items.length;for(ve=0;ve<ce;ve++){this.lexer.state.top=!1,it.items[ve].tokens=this.lexer.blockTokens(it.items[ve].text,[]);var Oe=it.items[ve].tokens.filter(function(Ge){return Ge.type==="space"}),We=Oe.every(function(Ge){for(var Je=Ge.raw.split(""),ft=0,It=B(Je),St;!(St=It()).done;){var kt=St.value;if(kt===`
`&&(ft+=1),ft>1)return!0}return!1});!it.loose&&Oe.length&&We&&(it.loose=!0,it.items[ve].loose=!0)}return it}},de.html=function(F){var C=this.rules.block.html.exec(F);if(C){var O={type:"html",raw:C[0],pre:!this.options.sanitizer&&(C[1]==="pre"||C[1]==="script"||C[1]==="style"),text:C[0]};return this.options.sanitize&&(O.type="paragraph",O.text=this.options.sanitizer?this.options.sanitizer(C[0]):l(C[0]),O.tokens=[],this.lexer.inline(O.text,O.tokens)),O}},de.def=function(F){var C=this.rules.block.def.exec(F);if(C){C[3]&&(C[3]=C[3].substring(1,C[3].length-1));var O=C[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:O,raw:C[0],href:C[2],title:C[3]}}},de.table=function(F){var C=this.rules.block.table.exec(F);if(C){var O={type:"table",header:g(C[1]).map(function(Me){return{text:Me}}),align:C[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:C[3]?C[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(O.header.length===O.align.length){O.raw=C[0];var x=O.align.length,Q,re,ve,Ie;for(Q=0;Q<x;Q++)/^ *-+: *$/.test(O.align[Q])?O.align[Q]="right":/^ *:-+: *$/.test(O.align[Q])?O.align[Q]="center":/^ *:-+ *$/.test(O.align[Q])?O.align[Q]="left":O.align[Q]=null;for(x=O.rows.length,Q=0;Q<x;Q++)O.rows[Q]=g(O.rows[Q],O.header.length).map(function(Me){return{text:Me}});for(x=O.header.length,re=0;re<x;re++)O.header[re].tokens=[],this.lexer.inlineTokens(O.header[re].text,O.header[re].tokens);for(x=O.rows.length,re=0;re<x;re++)for(Ie=O.rows[re],ve=0;ve<Ie.length;ve++)Ie[ve].tokens=[],this.lexer.inlineTokens(Ie[ve].text,Ie[ve].tokens);return O}}},de.lheading=function(F){var C=this.rules.block.lheading.exec(F);if(C){var O={type:"heading",raw:C[0],depth:C[2].charAt(0)==="="?1:2,text:C[1],tokens:[]};return this.lexer.inline(O.text,O.tokens),O}},de.paragraph=function(F){var C=this.rules.block.paragraph.exec(F);if(C){var O={type:"paragraph",raw:C[0],text:C[1].charAt(C[1].length-1)===`
`?C[1].slice(0,-1):C[1],tokens:[]};return this.lexer.inline(O.text,O.tokens),O}},de.text=function(F){var C=this.rules.block.text.exec(F);if(C){var O={type:"text",raw:C[0],text:C[0],tokens:[]};return this.lexer.inline(O.text,O.tokens),O}},de.escape=function(F){var C=this.rules.inline.escape.exec(F);if(C)return{type:"escape",raw:C[0],text:l(C[1])}},de.tag=function(F){var C=this.rules.inline.tag.exec(F);if(C)return!this.lexer.state.inLink&&/^<a /i.test(C[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(C[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(C[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(C[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:C[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(C[0]):l(C[0]):C[0]}},de.link=function(F){var C=this.rules.inline.link.exec(F);if(C){var O=C[2].trim();if(!this.options.pedantic&&/^</.test(O)){if(!/>$/.test(O))return;var x=h(O.slice(0,-1),"\\");if((O.length-x.length)%2==0)return}else{var Q=_(C[2],"()");if(Q>-1){var re=C[0].indexOf("!")===0?5:4,ve=re+C[1].length+Q;C[2]=C[2].substring(0,Q),C[0]=C[0].substring(0,ve).trim(),C[3]=""}}var Ie=C[2],Me="";if(this.options.pedantic){var Le=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ie);Le&&(Ie=Le[1],Me=Le[3])}else Me=C[3]?C[3].slice(1,-1):"";return Ie=Ie.trim(),/^</.test(Ie)&&(this.options.pedantic&&!/>$/.test(O)?Ie=Ie.slice(1):Ie=Ie.slice(1,-1)),W(C,{href:Ie&&Ie.replace(this.rules.inline._escapes,"$1"),title:Me&&Me.replace(this.rules.inline._escapes,"$1")},C[0],this.lexer)}},de.reflink=function(F,C){var O;if((O=this.rules.inline.reflink.exec(F))||(O=this.rules.inline.nolink.exec(F))){var x=(O[2]||O[1]).replace(/\s+/g," ");if(x=C[x.toLowerCase()],!x||!x.href){var Q=O[0].charAt(0);return{type:"text",raw:Q,text:Q}}return W(O,x,O[0],this.lexer)}},de.emStrong=function(F,C,O){O===void 0&&(O="");var x=this.rules.inline.emStrong.lDelim.exec(F);if(!!x&&!(x[3]&&O.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Q=x[1]||x[2]||"";if(!Q||Q&&(O===""||this.rules.inline.punctuation.exec(O))){var re=x[0].length-1,ve,Ie,Me=re,Le=0,ze=x[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ze.lastIndex=0,C=C.slice(-1*F.length+re);(x=ze.exec(C))!=null;)if(ve=x[1]||x[2]||x[3]||x[4]||x[5]||x[6],!!ve){if(Ie=ve.length,x[3]||x[4]){Me+=Ie;continue}else if((x[5]||x[6])&&re%3&&!((re+Ie)%3)){Le+=Ie;continue}if(Me-=Ie,!(Me>0)){if(Ie=Math.min(Ie,Ie+Me+Le),Math.min(re,Ie)%2){var xe=F.slice(1,re+x.index+Ie);return{type:"em",raw:F.slice(0,re+x.index+Ie+1),text:xe,tokens:this.lexer.inlineTokens(xe,[])}}var Re=F.slice(2,re+x.index+Ie-1);return{type:"strong",raw:F.slice(0,re+x.index+Ie+1),text:Re,tokens:this.lexer.inlineTokens(Re,[])}}}}}},de.codespan=function(F){var C=this.rules.inline.code.exec(F);if(C){var O=C[2].replace(/\n/g," "),x=/[^ ]/.test(O),Q=/^ /.test(O)&&/ $/.test(O);return x&&Q&&(O=O.substring(1,O.length-1)),O=l(O,!0),{type:"codespan",raw:C[0],text:O}}},de.br=function(F){var C=this.rules.inline.br.exec(F);if(C)return{type:"br",raw:C[0]}},de.del=function(F){var C=this.rules.inline.del.exec(F);if(C)return{type:"del",raw:C[0],text:C[2],tokens:this.lexer.inlineTokens(C[2],[])}},de.autolink=function(F,C){var O=this.rules.inline.autolink.exec(F);if(O){var x,Q;return O[2]==="@"?(x=l(this.options.mangle?C(O[1]):O[1]),Q="mailto:"+x):(x=l(O[1]),Q=x),{type:"link",raw:O[0],text:x,href:Q,tokens:[{type:"text",raw:x,text:x}]}}},de.url=function(F,C){var O;if(O=this.rules.inline.url.exec(F)){var x,Q;if(O[2]==="@")x=l(this.options.mangle?C(O[0]):O[0]),Q="mailto:"+x;else{var re;do re=O[0],O[0]=this.rules.inline._backpedal.exec(O[0])[0];while(re!==O[0]);x=l(O[0]),O[1]==="www."?Q="http://"+x:Q=x}return{type:"link",raw:O[0],text:x,href:Q,tokens:[{type:"text",raw:x,text:x}]}}},de.inlineText=function(F,C){var O=this.rules.inline.text.exec(F);if(O){var x;return this.lexer.state.inRawBlock?x=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(O[0]):l(O[0]):O[0]:x=l(this.options.smartypants?C(O[0]):O[0]),{type:"text",raw:O[0],text:x}}},ge}(),z={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:t,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};z._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,z._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,z.def=k(z.def).replace("label",z._label).replace("title",z._title).getRegex(),z.bullet=/(?:[*+-]|\d{1,9}[.)])/,z.listItemStart=k(/^( *)(bull) */).replace("bull",z.bullet).getRegex(),z.list=k(z.list).replace(/bull/g,z.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+z.def.source+")").getRegex(),z._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",z._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,z.html=k(z.html,"i").replace("comment",z._comment).replace("tag",z._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),z.paragraph=k(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.blockquote=k(z.blockquote).replace("paragraph",z.paragraph).getRegex(),z.normal=o({},z),z.gfm=o({},z.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),z.gfm.table=k(z.gfm.table).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.gfm.paragraph=k(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",z.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.pedantic=o({},z.normal,{html:k(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",z._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:t,paragraph:k(z.normal._paragraph).replace("hr",z.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",z.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var q={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:t,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:t,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};q._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",q.punctuation=k(q.punctuation).replace(/punctuation/g,q._punctuation).getRegex(),q.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,q.escapedEmSt=/\\\*|\\_/g,q._comment=k(z._comment).replace("(?:-->|$)","-->").getRegex(),q.emStrong.lDelim=k(q.emStrong.lDelim).replace(/punct/g,q._punctuation).getRegex(),q.emStrong.rDelimAst=k(q.emStrong.rDelimAst,"g").replace(/punct/g,q._punctuation).getRegex(),q.emStrong.rDelimUnd=k(q.emStrong.rDelimUnd,"g").replace(/punct/g,q._punctuation).getRegex(),q._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,q._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,q._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,q.autolink=k(q.autolink).replace("scheme",q._scheme).replace("email",q._email).getRegex(),q._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,q.tag=k(q.tag).replace("comment",q._comment).replace("attribute",q._attribute).getRegex(),q._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,q._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,q._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,q.link=k(q.link).replace("label",q._label).replace("href",q._href).replace("title",q._title).getRegex(),q.reflink=k(q.reflink).replace("label",q._label).replace("ref",z._label).getRegex(),q.nolink=k(q.nolink).replace("ref",z._label).getRegex(),q.reflinkSearch=k(q.reflinkSearch,"g").replace("reflink",q.reflink).replace("nolink",q.nolink).getRegex(),q.normal=o({},q),q.pedantic=o({},q.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:k(/^!?\[(label)\]\((.*?)\)/).replace("label",q._label).getRegex(),reflink:k(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",q._label).getRegex()}),q.gfm=o({},q.normal,{escape:k(q.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),q.gfm.url=k(q.gfm.url,"i").replace("email",q.gfm._extended_email).getRegex(),q.breaks=o({},q.gfm,{br:k(q.br).replace("{2,}","*").getRegex(),text:k(q.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function G(ge){return ge.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function j(ge){var de="",N,F,C=ge.length;for(N=0;N<C;N++)F=ge.charCodeAt(N),Math.random()>.5&&(F="x"+F.toString(16)),de+="&#"+F+";";return de}var $=function(){function ge(N){this.tokens=[],this.tokens.links=Object.create(null),this.options=N||J.defaults,this.options.tokenizer=this.options.tokenizer||new H,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var F={block:z.normal,inline:q.normal};this.options.pedantic?(F.block=z.pedantic,F.inline=q.pedantic):this.options.gfm&&(F.block=z.gfm,this.options.breaks?F.inline=q.breaks:F.inline=q.gfm),this.tokenizer.rules=F}ge.lex=function(F,C){var O=new ge(C);return O.lex(F)},ge.lexInline=function(F,C){var O=new ge(C);return O.inlineTokens(F)};var de=ge.prototype;return de.lex=function(F){F=F.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(F,this.tokens);for(var C;C=this.inlineQueue.shift();)this.inlineTokens(C.src,C.tokens);return this.tokens},de.blockTokens=function(F,C){var O=this;C===void 0&&(C=[]),this.options.pedantic&&(F=F.replace(/^ +$/gm,""));for(var x,Q,re,ve;F;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Me){return(x=Me.call({lexer:O},F,C))?(F=F.substring(x.raw.length),C.push(x),!0):!1}))){if(x=this.tokenizer.space(F)){F=F.substring(x.raw.length),x.raw.length===1&&C.length>0?C[C.length-1].raw+=`
`:C.push(x);continue}if(x=this.tokenizer.code(F)){F=F.substring(x.raw.length),Q=C[C.length-1],Q&&(Q.type==="paragraph"||Q.type==="text")?(Q.raw+=`
`+x.raw,Q.text+=`
`+x.text,this.inlineQueue[this.inlineQueue.length-1].src=Q.text):C.push(x);continue}if(x=this.tokenizer.fences(F)){F=F.substring(x.raw.length),C.push(x);continue}if(x=this.tokenizer.heading(F)){F=F.substring(x.raw.length),C.push(x);continue}if(x=this.tokenizer.hr(F)){F=F.substring(x.raw.length),C.push(x);continue}if(x=this.tokenizer.blockquote(F)){F=F.substring(x.raw.length),C.push(x);continue}if(x=this.tokenizer.list(F)){F=F.substring(x.raw.length),C.push(x);continue}if(x=this.tokenizer.html(F)){F=F.substring(x.raw.length),C.push(x);continue}if(x=this.tokenizer.def(F)){F=F.substring(x.raw.length),Q=C[C.length-1],Q&&(Q.type==="paragraph"||Q.type==="text")?(Q.raw+=`
`+x.raw,Q.text+=`
`+x.raw,this.inlineQueue[this.inlineQueue.length-1].src=Q.text):this.tokens.links[x.tag]||(this.tokens.links[x.tag]={href:x.href,title:x.title});continue}if(x=this.tokenizer.table(F)){F=F.substring(x.raw.length),C.push(x);continue}if(x=this.tokenizer.lheading(F)){F=F.substring(x.raw.length),C.push(x);continue}if(re=F,this.options.extensions&&this.options.extensions.startBlock&&function(){var Me=1/0,Le=F.slice(1),ze=void 0;O.options.extensions.startBlock.forEach(function(xe){ze=xe.call({lexer:this},Le),typeof ze=="number"&&ze>=0&&(Me=Math.min(Me,ze))}),Me<1/0&&Me>=0&&(re=F.substring(0,Me+1))}(),this.state.top&&(x=this.tokenizer.paragraph(re))){Q=C[C.length-1],ve&&Q.type==="paragraph"?(Q.raw+=`
`+x.raw,Q.text+=`
`+x.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Q.text):C.push(x),ve=re.length!==F.length,F=F.substring(x.raw.length);continue}if(x=this.tokenizer.text(F)){F=F.substring(x.raw.length),Q=C[C.length-1],Q&&Q.type==="text"?(Q.raw+=`
`+x.raw,Q.text+=`
`+x.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Q.text):C.push(x);continue}if(F){var Ie="Infinite loop on byte: "+F.charCodeAt(0);if(this.options.silent){console.error(Ie);break}else throw new Error(Ie)}}return this.state.top=!0,C},de.inline=function(F,C){this.inlineQueue.push({src:F,tokens:C})},de.inlineTokens=function(F,C){var O=this;C===void 0&&(C=[]);var x,Q,re,ve=F,Ie,Me,Le;if(this.tokens.links){var ze=Object.keys(this.tokens.links);if(ze.length>0)for(;(Ie=this.tokenizer.rules.inline.reflinkSearch.exec(ve))!=null;)ze.includes(Ie[0].slice(Ie[0].lastIndexOf("[")+1,-1))&&(ve=ve.slice(0,Ie.index)+"["+R("a",Ie[0].length-2)+"]"+ve.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ie=this.tokenizer.rules.inline.blockSkip.exec(ve))!=null;)ve=ve.slice(0,Ie.index)+"["+R("a",Ie[0].length-2)+"]"+ve.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ie=this.tokenizer.rules.inline.escapedEmSt.exec(ve))!=null;)ve=ve.slice(0,Ie.index)+"++"+ve.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;F;)if(Me||(Le=""),Me=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Re){return(x=Re.call({lexer:O},F,C))?(F=F.substring(x.raw.length),C.push(x),!0):!1}))){if(x=this.tokenizer.escape(F)){F=F.substring(x.raw.length),C.push(x);continue}if(x=this.tokenizer.tag(F)){F=F.substring(x.raw.length),Q=C[C.length-1],Q&&x.type==="text"&&Q.type==="text"?(Q.raw+=x.raw,Q.text+=x.text):C.push(x);continue}if(x=this.tokenizer.link(F)){F=F.substring(x.raw.length),C.push(x);continue}if(x=this.tokenizer.reflink(F,this.tokens.links)){F=F.substring(x.raw.length),Q=C[C.length-1],Q&&x.type==="text"&&Q.type==="text"?(Q.raw+=x.raw,Q.text+=x.text):C.push(x);continue}if(x=this.tokenizer.emStrong(F,ve,Le)){F=F.substring(x.raw.length),C.push(x);continue}if(x=this.tokenizer.codespan(F)){F=F.substring(x.raw.length),C.push(x);continue}if(x=this.tokenizer.br(F)){F=F.substring(x.raw.length),C.push(x);continue}if(x=this.tokenizer.del(F)){F=F.substring(x.raw.length),C.push(x);continue}if(x=this.tokenizer.autolink(F,j)){F=F.substring(x.raw.length),C.push(x);continue}if(!this.state.inLink&&(x=this.tokenizer.url(F,j))){F=F.substring(x.raw.length),C.push(x);continue}if(re=F,this.options.extensions&&this.options.extensions.startInline&&function(){var Re=1/0,Qe=F.slice(1),tt=void 0;O.options.extensions.startInline.forEach(function(Te){tt=Te.call({lexer:this},Qe),typeof tt=="number"&&tt>=0&&(Re=Math.min(Re,tt))}),Re<1/0&&Re>=0&&(re=F.substring(0,Re+1))}(),x=this.tokenizer.inlineText(re,G)){F=F.substring(x.raw.length),x.raw.slice(-1)!=="_"&&(Le=x.raw.slice(-1)),Me=!0,Q=C[C.length-1],Q&&Q.type==="text"?(Q.raw+=x.raw,Q.text+=x.text):C.push(x);continue}if(F){var xe="Infinite loop on byte: "+F.charCodeAt(0);if(this.options.silent){console.error(xe);break}else throw new Error(xe)}}return C},s(ge,null,[{key:"rules",get:function(){return{block:z,inline:q}}}]),ge}(),ee=function(){function ge(N){this.options=N||J.defaults}var de=ge.prototype;return de.code=function(F,C,O){var x=(C||"").match(/\S*/)[0];if(this.options.highlight){var Q=this.options.highlight(F,x);Q!=null&&Q!==F&&(O=!0,F=Q)}return F=F.replace(/\n$/,"")+`
`,x?'<pre><code class="'+this.options.langPrefix+l(x,!0)+'">'+(O?F:l(F,!0))+`</code></pre>
`:"<pre><code>"+(O?F:l(F,!0))+`</code></pre>
`},de.blockquote=function(F){return`<blockquote>
`+F+`</blockquote>
`},de.html=function(F){return F},de.heading=function(F,C,O,x){return this.options.headerIds?"<h"+C+' id="'+this.options.headerPrefix+x.slug(O)+'">'+F+"</h"+C+`>
`:"<h"+C+">"+F+"</h"+C+`>
`},de.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},de.list=function(F,C,O){var x=C?"ol":"ul",Q=C&&O!==1?' start="'+O+'"':"";return"<"+x+Q+`>
`+F+"</"+x+`>
`},de.listitem=function(F){return"<li>"+F+`</li>
`},de.checkbox=function(F){return"<input "+(F?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},de.paragraph=function(F){return"<p>"+F+`</p>
`},de.table=function(F,C){return C&&(C="<tbody>"+C+"</tbody>"),`<table>
<thead>
`+F+`</thead>
`+C+`</table>
`},de.tablerow=function(F){return`<tr>
`+F+`</tr>
`},de.tablecell=function(F,C){var O=C.header?"th":"td",x=C.align?"<"+O+' align="'+C.align+'">':"<"+O+">";return x+F+"</"+O+`>
`},de.strong=function(F){return"<strong>"+F+"</strong>"},de.em=function(F){return"<em>"+F+"</em>"},de.codespan=function(F){return"<code>"+F+"</code>"},de.br=function(){return this.options.xhtml?"<br/>":"<br>"},de.del=function(F){return"<del>"+F+"</del>"},de.link=function(F,C,O){if(F=w(this.options.sanitize,this.options.baseUrl,F),F===null)return O;var x='<a href="'+l(F)+'"';return C&&(x+=' title="'+C+'"'),x+=">"+O+"</a>",x},de.image=function(F,C,O){if(F=w(this.options.sanitize,this.options.baseUrl,F),F===null)return O;var x='<img src="'+F+'" alt="'+O+'"';return C&&(x+=' title="'+C+'"'),x+=this.options.xhtml?"/>":">",x},de.text=function(F){return F},ge}(),se=function(){function ge(){}var de=ge.prototype;return de.strong=function(F){return F},de.em=function(F){return F},de.codespan=function(F){return F},de.del=function(F){return F},de.html=function(F){return F},de.text=function(F){return F},de.link=function(F,C,O){return""+O},de.image=function(F,C,O){return""+O},de.br=function(){return""},ge}(),Z=function(){function ge(){this.seen={}}var de=ge.prototype;return de.serialize=function(F){return F.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},de.getNextSafeSlug=function(F,C){var O=F,x=0;if(this.seen.hasOwnProperty(O)){x=this.seen[F];do x++,O=F+"-"+x;while(this.seen.hasOwnProperty(O))}return C||(this.seen[F]=x,this.seen[O]=0),O},de.slug=function(F,C){C===void 0&&(C={});var O=this.serialize(F);return this.getNextSafeSlug(O,C.dryrun)},ge}(),le=function(){function ge(N){this.options=N||J.defaults,this.options.renderer=this.options.renderer||new ee,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new se,this.slugger=new Z}ge.parse=function(F,C){var O=new ge(C);return O.parse(F)},ge.parseInline=function(F,C){var O=new ge(C);return O.parseInline(F)};var de=ge.prototype;return de.parse=function(F,C){C===void 0&&(C=!0);var O="",x,Q,re,ve,Ie,Me,Le,ze,xe,Re,Qe,tt,Te,it,X,Y,ce,Oe,We,Ge=F.length;for(x=0;x<Ge;x++){if(Re=F[x],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Re.type]&&(We=this.options.extensions.renderers[Re.type].call({parser:this},Re),We!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Re.type))){O+=We||"";continue}switch(Re.type){case"space":continue;case"hr":{O+=this.renderer.hr();continue}case"heading":{O+=this.renderer.heading(this.parseInline(Re.tokens),Re.depth,f(this.parseInline(Re.tokens,this.textRenderer)),this.slugger);continue}case"code":{O+=this.renderer.code(Re.text,Re.lang,Re.escaped);continue}case"table":{for(ze="",Le="",ve=Re.header.length,Q=0;Q<ve;Q++)Le+=this.renderer.tablecell(this.parseInline(Re.header[Q].tokens),{header:!0,align:Re.align[Q]});for(ze+=this.renderer.tablerow(Le),xe="",ve=Re.rows.length,Q=0;Q<ve;Q++){for(Me=Re.rows[Q],Le="",Ie=Me.length,re=0;re<Ie;re++)Le+=this.renderer.tablecell(this.parseInline(Me[re].tokens),{header:!1,align:Re.align[re]});xe+=this.renderer.tablerow(Le)}O+=this.renderer.table(ze,xe);continue}case"blockquote":{xe=this.parse(Re.tokens),O+=this.renderer.blockquote(xe);continue}case"list":{for(Qe=Re.ordered,tt=Re.start,Te=Re.loose,ve=Re.items.length,xe="",Q=0;Q<ve;Q++)X=Re.items[Q],Y=X.checked,ce=X.task,it="",X.task&&(Oe=this.renderer.checkbox(Y),Te?X.tokens.length>0&&X.tokens[0].type==="paragraph"?(X.tokens[0].text=Oe+" "+X.tokens[0].text,X.tokens[0].tokens&&X.tokens[0].tokens.length>0&&X.tokens[0].tokens[0].type==="text"&&(X.tokens[0].tokens[0].text=Oe+" "+X.tokens[0].tokens[0].text)):X.tokens.unshift({type:"text",text:Oe}):it+=Oe),it+=this.parse(X.tokens,Te),xe+=this.renderer.listitem(it,ce,Y);O+=this.renderer.list(xe,Qe,tt);continue}case"html":{O+=this.renderer.html(Re.text);continue}case"paragraph":{O+=this.renderer.paragraph(this.parseInline(Re.tokens));continue}case"text":{for(xe=Re.tokens?this.parseInline(Re.tokens):Re.text;x+1<Ge&&F[x+1].type==="text";)Re=F[++x],xe+=`
`+(Re.tokens?this.parseInline(Re.tokens):Re.text);O+=C?this.renderer.paragraph(xe):xe;continue}default:{var Je='Token with "'+Re.type+'" type was not found.';if(this.options.silent){console.error(Je);return}else throw new Error(Je)}}}return O},de.parseInline=function(F,C){C=C||this.renderer;var O="",x,Q,re,ve=F.length;for(x=0;x<ve;x++){if(Q=F[x],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Q.type]&&(re=this.options.extensions.renderers[Q.type].call({parser:this},Q),re!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Q.type))){O+=re||"";continue}switch(Q.type){case"escape":{O+=C.text(Q.text);break}case"html":{O+=C.html(Q.text);break}case"link":{O+=C.link(Q.href,Q.title,this.parseInline(Q.tokens,C));break}case"image":{O+=C.image(Q.href,Q.title,Q.text);break}case"strong":{O+=C.strong(this.parseInline(Q.tokens,C));break}case"em":{O+=C.em(this.parseInline(Q.tokens,C));break}case"codespan":{O+=C.codespan(Q.text);break}case"br":{O+=C.br();break}case"del":{O+=C.del(this.parseInline(Q.tokens,C));break}case"text":{O+=C.text(Q.text);break}default:{var Ie='Token with "'+Q.type+'" type was not found.';if(this.options.silent){console.error(Ie);return}else throw new Error(Ie)}}}return O},ge}();function ue(ge,de,N){if(typeof ge=="undefined"||ge===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ge!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ge)+", string expected");if(typeof de=="function"&&(N=de,de=null),de=o({},ue.defaults,de||{}),P(de),N){var F=de.highlight,C;try{C=$.lex(ge,de)}catch(re){return N(re)}var O=function(ve){var Ie;if(!ve)try{de.walkTokens&&ue.walkTokens(C,de.walkTokens),Ie=le.parse(C,de)}catch(Me){ve=Me}return de.highlight=F,ve?N(ve):N(null,Ie)};if(!F||F.length<3||(delete de.highlight,!C.length))return O();var x=0;ue.walkTokens(C,function(re){re.type==="code"&&(x++,setTimeout(function(){F(re.text,re.lang,function(ve,Ie){if(ve)return O(ve);Ie!=null&&Ie!==re.text&&(re.text=Ie,re.escaped=!0),x--,x===0&&O()})},0))}),x===0&&O();return}try{var Q=$.lex(ge,de);return de.walkTokens&&ue.walkTokens(Q,de.walkTokens),le.parse(Q,de)}catch(re){if(re.message+=`
Please report this to https://github.com/markedjs/marked.`,de.silent)return"<p>An error occurred:</p><pre>"+l(re.message+"",!0)+"</pre>";throw re}}ue.options=ue.setOptions=function(ge){return o(ue.defaults,ge),A(ue.defaults),ue},ue.getDefaults=D,ue.defaults=J.defaults,ue.use=function(){for(var ge=arguments.length,de=new Array(ge),N=0;N<ge;N++)de[N]=arguments[N];var F=o.apply(void 0,[{}].concat(de)),C=ue.defaults.extensions||{renderers:{},childTokens:{}},O;de.forEach(function(x){if(x.extensions&&(O=!0,x.extensions.forEach(function(re){if(!re.name)throw new Error("extension name required");if(re.renderer){var ve=C.renderers?C.renderers[re.name]:null;ve?C.renderers[re.name]=function(){for(var Ie=arguments.length,Me=new Array(Ie),Le=0;Le<Ie;Le++)Me[Le]=arguments[Le];var ze=re.renderer.apply(this,Me);return ze===!1&&(ze=ve.apply(this,Me)),ze}:C.renderers[re.name]=re.renderer}if(re.tokenizer){if(!re.level||re.level!=="block"&&re.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");C[re.level]?C[re.level].unshift(re.tokenizer):C[re.level]=[re.tokenizer],re.start&&(re.level==="block"?C.startBlock?C.startBlock.push(re.start):C.startBlock=[re.start]:re.level==="inline"&&(C.startInline?C.startInline.push(re.start):C.startInline=[re.start]))}re.childTokens&&(C.childTokens[re.name]=re.childTokens)})),x.renderer&&function(){var re=ue.defaults.renderer||new ee,ve=function(Le){var ze=re[Le];re[Le]=function(){for(var xe=arguments.length,Re=new Array(xe),Qe=0;Qe<xe;Qe++)Re[Qe]=arguments[Qe];var tt=x.renderer[Le].apply(re,Re);return tt===!1&&(tt=ze.apply(re,Re)),tt}};for(var Ie in x.renderer)ve(Ie);F.renderer=re}(),x.tokenizer&&function(){var re=ue.defaults.tokenizer||new H,ve=function(Le){var ze=re[Le];re[Le]=function(){for(var xe=arguments.length,Re=new Array(xe),Qe=0;Qe<xe;Qe++)Re[Qe]=arguments[Qe];var tt=x.tokenizer[Le].apply(re,Re);return tt===!1&&(tt=ze.apply(re,Re)),tt}};for(var Ie in x.tokenizer)ve(Ie);F.tokenizer=re}(),x.walkTokens){var Q=ue.defaults.walkTokens;F.walkTokens=function(re){x.walkTokens.call(this,re),Q&&Q.call(this,re)}}O&&(F.extensions=C),ue.setOptions(F)})},ue.walkTokens=function(ge,de){for(var N=function(){var x=C.value;switch(de.call(ue,x),x.type){case"table":{for(var Q=B(x.header),re;!(re=Q()).done;){var ve=re.value;ue.walkTokens(ve.tokens,de)}for(var Ie=B(x.rows),Me;!(Me=Ie()).done;)for(var Le=Me.value,ze=B(Le),xe;!(xe=ze()).done;){var Re=xe.value;ue.walkTokens(Re.tokens,de)}break}case"list":{ue.walkTokens(x.items,de);break}default:ue.defaults.extensions&&ue.defaults.extensions.childTokens&&ue.defaults.extensions.childTokens[x.type]?ue.defaults.extensions.childTokens[x.type].forEach(function(Qe){ue.walkTokens(x[Qe],de)}):x.tokens&&ue.walkTokens(x.tokens,de)}},F=B(ge),C;!(C=F()).done;)N()},ue.parseInline=function(ge,de){if(typeof ge=="undefined"||ge===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ge!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ge)+", string expected");de=o({},ue.defaults,de||{}),P(de);try{var N=$.lexInline(ge,de);return de.walkTokens&&ue.walkTokens(N,de.walkTokens),le.parseInline(N,de)}catch(F){if(F.message+=`
Please report this to https://github.com/markedjs/marked.`,de.silent)return"<p>An error occurred:</p><pre>"+l(F.message+"",!0)+"</pre>";throw F}},ue.Parser=le,ue.parser=le.parse,ue.Renderer=ee,ue.TextRenderer=se,ue.Lexer=$,ue.lexer=$.lex,ue.Tokenizer=H,ue.Slugger=Z,ue.parse=ue;var Se=ue.options,fe=ue.setOptions,ne=ue.use,me=ue.walkTokens,ke=ue.parseInline,Ae=ue,Be=le.parse,Xe=$.lex;J.Lexer=$,J.Parser=le,J.Renderer=ee,J.Slugger=Z,J.TextRenderer=se,J.Tokenizer=H,J.getDefaults=D,J.lexer=Xe,J.marked=ue,J.options=Se,J.parse=Ae,J.parseInline=ke,J.parser=Be,J.setOptions=fe,J.use=ne,J.walkTokens=me,Object.defineProperty(J,"__esModule",{value:!0})}),define(Ee[102],we([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function s(A,y,M){return Math.min(Math.max(A,y),M)}e.clamp=s;function I(A,y){return(y+A%y)%y}e.rot=I;class b{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=b;class B{constructor(){this._n=1,this._val=0}update(y){return this._val=this._val+(y-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=B;class D{constructor(y){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(y),this._values.fill(0,0,y)}update(y){const M=this._values[this._index];return this._values[this._index]=y,this._index=(this._index+1)%this._values.length,this._sum-=M,this._sum+=y,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=D}),function(){function J(b){const B=[];typeof b=="number"&&B.push("code/timeOrigin",b);function D(y){B.push(y,Date.now())}function A(){const y=[];for(let M=0;M<B.length;M+=2)y.push({name:B[M],startTime:B[M+1]});return y}return{mark:D,getMarks:A}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(b){performance.mark(b)},getMarks(){let b=performance.timeOrigin;typeof b!="number"&&(b=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const B=[{name:"code/timeOrigin",startTime:Math.round(b)}];for(const D of performance.getEntriesByType("mark"))B.push({name:D.name,startTime:Math.round(b+D.startTime)});return B}};if(typeof process=="object"){const b=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(b)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function s(b){return b.MonacoPerformanceMarks||(b.MonacoPerformanceMarks=e()),b.MonacoPerformanceMarks}var I;typeof global=="object"?I=global:typeof self=="object"?I=self:I={},typeof define=="function"?define("vs/base/common/performance",[],function(){return s(I)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=s(I):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),I.perf=s(I))}(),define(Ee[71],we([1,0,17]),function(J,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0;var I;(function(v){v.text="text/plain",v.binary="application/octet-stream",v.unknown="application/unknown",v.markdown="text/markdown",v.latex="text/latex",v.uriList="text/uri-list"})(I=e.Mimes||(e.Mimes={}));const b={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},B={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function D(v){const u=(0,s.extname)(v),m=b[u.toLowerCase()];return m!==void 0?m:A(v)}e.getMediaOrTextMime=D;function A(v){const u=(0,s.extname)(v);return B[u.toLowerCase()]}e.getMediaMime=A;function y(v){for(const u in B)if(B[u]===v)return u}e.getExtensionForMimeType=y;const M=/^(.+)\/(.+?)(;.+)?$/;function L(v,u){const m=M.exec(v);return m?`${m[1].toLowerCase()}/${m[2].toLowerCase()}${m[3]??""}`:u?void 0:v}e.normalizeMimeType=L}),define(Ee[103],we([1,0,15,6]),function(J,e,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function b(p){const w=p;return w?typeof w.read=="function":!1}e.isReadable=b;function B(p){const w=p;return w?[w.on,w.pause,w.resume,w.destroy].every(a=>typeof a=="function"):!1}e.isReadableStream=B;function D(p){const w=p;return w?B(w.stream)&&Array.isArray(w.buffer)&&typeof w.ended=="boolean":!1}e.isReadableBufferedStream=D;function A(p,w){return new y(p,w)}e.newWriteableStream=A;class y{constructor(w,a){this.reducer=w,this.options=a,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(w){if(!this.state.destroyed){if(this.state.flowing)this.emitData(w);else if(this.buffer.data.push(w),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(a=>this.pendingWritePromises.push(a))}}error(w){this.state.destroyed||(this.state.flowing?this.emitError(w):this.buffer.error.push(w))}end(w){this.state.destroyed||(typeof w!="undefined"&&this.write(w),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(w){this.listeners.data.slice(0).forEach(a=>a(w))}emitError(w){this.listeners.error.length===0?(0,s.onUnexpectedError)(w):this.listeners.error.slice(0).forEach(a=>a(w))}emitEnd(){this.listeners.end.slice(0).forEach(w=>w())}on(w,a){if(!this.state.destroyed)switch(w){case"data":this.listeners.data.push(a),this.resume();break;case"end":this.listeners.end.push(a),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(a),this.state.flowing&&this.flowErrors();break}}removeListener(w,a){if(this.state.destroyed)return;let T;switch(w){case"data":T=this.listeners.data;break;case"end":T=this.listeners.end;break;case"error":T=this.listeners.error;break}if(T){const r=T.indexOf(a);r>=0&&T.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const w=this.reducer(this.buffer.data);this.emitData(w),this.buffer.data.length=0;const a=[...this.pendingWritePromises];this.pendingWritePromises.length=0,a.forEach(T=>T())}}flowErrors(){if(this.listeners.error.length>0){for(const w of this.buffer.error)this.emitError(w);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function M(p,w){const a=[];let T;for(;(T=p.read())!==null;)a.push(T);return w(a)}e.consumeReadable=M;function L(p,w,a){const T=[];let r;for(;(r=p.read())!==null&&T.length<a;)T.push(r);return r===null&&T.length>0?w(T):{read:()=>{if(T.length>0)return T.shift();if(typeof r!="undefined"){const i=r;return r=void 0,i}return p.read()}}}e.peekReadable=L;function v(p,w){return new Promise((a,T)=>{const r=[];u(p,{onData:i=>{w&&r.push(i)},onError:i=>{w?T(i):a(void 0)},onEnd:()=>{a(w?w(r):void 0)}})})}e.consumeStream=v;function u(p,w){let a=!1;return p.on("error",T=>{a||w.onError(T)}),p.on("end",()=>{a||w.onEnd()}),p.on("data",T=>{a||w.onData(T)}),(0,I.toDisposable)(()=>a=!0)}e.listenStream=u;function m(p,w){return new Promise((a,T)=>{const r=new I.DisposableStore,i=[],c=g=>{if(i.push(g),i.length>w)return r.dispose(),p.pause(),a({stream:p,buffer:i,ended:!1})},t=g=>T(g),o=()=>a({stream:p,buffer:i,ended:!0});r.add((0,I.toDisposable)(()=>p.removeListener("error",t))),p.on("error",t),r.add((0,I.toDisposable)(()=>p.removeListener("end",o))),p.on("end",o),r.add((0,I.toDisposable)(()=>p.removeListener("data",c))),p.on("data",c)})}e.peekStream=m;function l(p,w){const a=A(w);return a.end(p),a}e.toStream=l;function n(){const p=A(()=>{throw new Error("not supported")});return p.end(),p}e.emptyStream=n;function f(p){let w=!1;return{read:()=>w?null:(w=!0,p)}}e.toReadable=f;function S(p,w,a){const T=A(a);return u(p,{onData:r=>T.write(w.data(r)),onError:r=>T.error(w.error?w.error(r):r),onEnd:()=>T.end()}),T}e.transform=S;function k(p,w,a){let T=!1;return{read:()=>{const r=w.read();return T?r:(T=!0,r!==null?a([p,r]):p)}}}e.prefixedReadable=k;function d(p,w,a){let T=!1;const r=A(a);return u(w,{onData:i=>T?r.write(i):(T=!0,r.write(a([p,i]))),onError:i=>r.error(i),onEnd:()=>{T||(T=!0,r.write(p)),r.end()}}),r}e.prefixedStream=d}),define(Ee[21],we([1,0,103]),function(J,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const I=typeof Buffer!="undefined";let b,B;class D{constructor(g){this.buffer=g,this.byteLength=this.buffer.byteLength}static alloc(g){return I?new D(Buffer.allocUnsafe(g)):new D(new Uint8Array(g))}static wrap(g){return I&&!Buffer.isBuffer(g)&&(g=Buffer.from(g.buffer,g.byteOffset,g.byteLength)),new D(g)}static fromString(g,h){return!(h?.dontUseNodeBuffer||!1)&&I?new D(Buffer.from(g)):(b||(b=new TextEncoder),new D(b.encode(g)))}static fromByteArray(g){const h=D.alloc(g.length);for(let _=0,P=g.length;_<P;_++)h.buffer[_]=g[_];return h}static concat(g,h){if(typeof h=="undefined"){h=0;for(let R=0,W=g.length;R<W;R++)h+=g[R].byteLength}const _=D.alloc(h);let P=0;for(let R=0,W=g.length;R<W;R++){const E=g[R];_.set(E,P),P+=E.byteLength}return _}clone(){const g=D.alloc(this.byteLength);return g.set(this),g}toString(){return I?this.buffer.toString():(B||(B=new TextDecoder),B.decode(this.buffer))}slice(g,h){return new D(this.buffer.subarray(g,h))}set(g,h){if(g instanceof D)this.buffer.set(g.buffer,h);else if(g instanceof Uint8Array)this.buffer.set(g,h);else if(g instanceof ArrayBuffer)this.buffer.set(new Uint8Array(g),h);else if(ArrayBuffer.isView(g))this.buffer.set(new Uint8Array(g.buffer,g.byteOffset,g.byteLength),h);else throw new Error("Unknown argument 'array'")}readUInt32BE(g){return M(this.buffer,g)}writeUInt32BE(g,h){L(this.buffer,g,h)}readUInt32LE(g){return v(this.buffer,g)}writeUInt32LE(g,h){u(this.buffer,g,h)}readUInt8(g){return m(this.buffer,g)}writeUInt8(g,h){l(this.buffer,g,h)}}e.VSBuffer=D;function A(o,g){return o[g+0]<<0>>>0|o[g+1]<<8>>>0}e.readUInt16LE=A;function y(o,g,h){o[h+0]=g&255,g=g>>>8,o[h+1]=g&255}e.writeUInt16LE=y;function M(o,g){return o[g]*2**24+o[g+1]*2**16+o[g+2]*2**8+o[g+3]}e.readUInt32BE=M;function L(o,g,h){o[h+3]=g,g=g>>>8,o[h+2]=g,g=g>>>8,o[h+1]=g,g=g>>>8,o[h]=g}e.writeUInt32BE=L;function v(o,g){return o[g+0]<<0>>>0|o[g+1]<<8>>>0|o[g+2]<<16>>>0|o[g+3]<<24>>>0}e.readUInt32LE=v;function u(o,g,h){o[h+0]=g&255,g=g>>>8,o[h+1]=g&255,g=g>>>8,o[h+2]=g&255,g=g>>>8,o[h+3]=g&255}e.writeUInt32LE=u;function m(o,g){return o[g]}e.readUInt8=m;function l(o,g,h){o[h]=g}e.writeUInt8=l;function n(o){return s.consumeReadable(o,g=>D.concat(g))}e.readableToBuffer=n;function f(o){return s.toReadable(o)}e.bufferToReadable=f;function S(o){return s.consumeStream(o,g=>D.concat(g))}e.streamToBuffer=S;async function k(o){return o.ended?D.concat(o.buffer):D.concat([...o.buffer,await S(o.stream)])}e.bufferedStreamToBuffer=k;function d(o){return s.toStream(o,g=>D.concat(g))}e.bufferToStream=d;function p(o){return s.transform(o,{data:g=>typeof g=="string"?D.fromString(g):D.wrap(g)},g=>D.concat(g))}e.streamToBufferReadableStream=p;function w(o){return s.newWriteableStream(g=>D.concat(g),o)}e.newWriteableBufferStream=w;function a(o,g){return s.prefixedReadable(o,g,h=>D.concat(h))}e.prefixedBufferReadable=a;function T(o,g){return s.prefixedStream(o,g,h=>D.concat(h))}e.prefixedBufferStream=T;function r(o){let g=0,h=0,_=0;const P=new Uint8Array(Math.floor(o.length/4*3)),R=E=>{switch(h){case 3:P[_++]=g|E,h=0;break;case 2:P[_++]=g|E>>>2,g=E<<6,h=3;break;case 1:P[_++]=g|E>>>4,g=E<<4,h=2;break;default:g=E<<2,h=1}};for(let E=0;E<o.length;E++){const H=o.charCodeAt(E);if(H>=65&&H<=90)R(H-65);else if(H>=97&&H<=122)R(H-97+26);else if(H>=48&&H<=57)R(H-48+52);else if(H===43||H===45)R(62);else if(H===47||H===95)R(63);else{if(H===61)break;throw new SyntaxError(`Unexpected base64 character ${o[E]}`)}}const W=_;for(;h>0;)R(0);return D.wrap(P).slice(0,W)}e.decodeBase64=r;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function t({buffer:o},g=!0,h=!1){const _=h?c:i;let P="";const R=o.byteLength%3;let W=0;for(;W<o.byteLength-R;W+=3){const E=o[W+0],H=o[W+1],z=o[W+2];P+=_[E>>>2],P+=_[(E<<4|H>>>4)&63],P+=_[(H<<2|z>>>6)&63],P+=_[z&63]}if(R===1){const E=o[W+0];P+=_[E>>>2],P+=_[E<<4&63],g&&(P+="==")}else if(R===2){const E=o[W+0],H=o[W+1];P+=_[E>>>2],P+=_[(E<<4|H>>>4)&63],P+=_[H<<2&63],g&&(P+="=")}return P}e.encodeBase64=t});var je=this&&this.__classPrivateFieldSet||function(J,e,s,I,b){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!b:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?b.call(J,s):b?b.value=s:e.set(J,s),s},De=this&&this.__classPrivateFieldGet||function(J,e,s,I){if(s==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?I:s==="a"?I.call(J):I?I.value:e.get(J)};define(Ee[22],we([1,0,16,9]),function(J,e,s,I){"use strict";var b,B,D;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function A(r,i,c){let t=r.get(i);return t===void 0&&(t=c,r.set(i,t)),t}e.getOrSet=A;function y(r){const i=[];return r.forEach((c,t)=>{i.push(`${t} => ${c}`)}),`Map(${r.size}) {${i.join(", ")}}`}e.mapToString=y;function M(r){const i=[];return r.forEach(c=>{i.push(c)}),`Set(${r.size}) {${i.join(", ")}}`}e.setToString=M;class L{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const c=i.charCodeAt(0),t=this._value.charCodeAt(this._pos);return c-t}value(){return this._value[this._pos]}}e.StringIterator=L;class v{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,I.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,I.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=v;class u{constructor(i=!0,c=!0){this._splitOnBackslash=i,this._caseSensitive=c}reset(i){this._from=0,this._to=0,this._value=i,this._valueLen=i.length;for(let c=i.length-1;c>=0;c--,this._valueLen--){const t=this._value.charCodeAt(c);if(!(t===47||this._splitOnBackslash&&t===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let i=!0;for(;this._to<this._valueLen;this._to++){const c=this._value.charCodeAt(this._to);if(c===47||this._splitOnBackslash&&c===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,I.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,I.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=u;var m;(function(r){r[r.Scheme=1]="Scheme",r[r.Authority=2]="Authority",r[r.Path=3]="Path",r[r.Query=4]="Query",r[r.Fragment=5]="Fragment"})(m||(m={}));class l{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new u(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,I.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,I.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,I.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,I.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=l;class n{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const i=this.right;return this.right=i.left,i.left=this,this.updateHeight(),i.updateHeight(),i}rotateRight(){const i=this.left;return this.left=i.right,i.right=this,this.updateHeight(),i.updateHeight(),i}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var f;(function(r){r[r.Left=-1]="Left",r[r.Mid=0]="Mid",r[r.Right=1]="Right"})(f||(f={}));class S{constructor(i){this._iter=i}static forUris(i=()=>!1){return new S(new l(i))}static forPaths(i=!1){return new S(new u(void 0,!i))}static forStrings(){return new S(new L)}static forConfigKeys(){return new S(new v)}clear(){this._root=void 0}fill(i,c){if(c){const t=c.slice(0);(0,s.shuffle)(t);for(let o of t)this.set(o,i)}else{const t=i.slice(0);(0,s.shuffle)(t);for(let o of t)this.set(o[0],o[1])}}set(i,c){const t=this._iter.reset(i);let o;this._root||(this._root=new n,this._root.segment=t.value());const g=[];for(o=this._root;;){const _=t.cmp(o.segment);if(_>0)o.left||(o.left=new n,o.left.segment=t.value()),g.push([-1,o]),o=o.left;else if(_<0)o.right||(o.right=new n,o.right.segment=t.value()),g.push([1,o]),o=o.right;else if(t.hasNext())t.next(),o.mid||(o.mid=new n,o.mid.segment=t.value()),g.push([0,o]),o=o.mid;else break}const h=o.value;o.value=c,o.key=i;for(let _=g.length-1;_>=0;_--){const P=g[_][1];P.updateHeight();const R=P.balanceFactor();if(R<-1||R>1){const W=g[_][0],E=g[_+1][0];if(W===1&&E===1)g[_][1]=P.rotateLeft();else if(W===-1&&E===-1)g[_][1]=P.rotateRight();else if(W===1&&E===-1)P.right=g[_+1][1]=g[_+1][1].rotateRight(),g[_][1]=P.rotateLeft();else if(W===-1&&E===1)P.left=g[_+1][1]=g[_+1][1].rotateLeft(),g[_][1]=P.rotateRight();else throw new Error;if(_>0)switch(g[_-1][0]){case-1:g[_-1][1].left=g[_][1];break;case 1:g[_-1][1].right=g[_][1];break;case 0:g[_-1][1].mid=g[_][1];break}else this._root=g[0][1]}}return h}get(i){return this._getNode(i)?.value}_getNode(i){const c=this._iter.reset(i);let t=this._root;for(;t;){const o=c.cmp(t.segment);if(o>0)t=t.left;else if(o<0)t=t.right;else if(c.hasNext())c.next(),t=t.mid;else break}return t}has(i){const c=this._getNode(i);return!(c?.value===void 0&&c?.mid===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,c){const t=this._iter.reset(i),o=[];let g=this._root;for(;g;){const h=t.cmp(g.segment);if(h>0)o.push([-1,g]),g=g.left;else if(h<0)o.push([1,g]),g=g.right;else if(t.hasNext())t.next(),o.push([0,g]),g=g.mid;else break}if(!!g){if(c?(g.left=void 0,g.mid=void 0,g.right=void 0,g.height=1):(g.key=void 0,g.value=void 0),!g.mid&&!g.value)if(g.left&&g.right){const h=this._min(g.right),{key:_,value:P,segment:R}=h;this._delete(h.key,!1),g.key=_,g.value=P,g.segment=R}else{const h=g.left??g.right;if(o.length>0){const[_,P]=o[o.length-1];switch(_){case-1:P.left=h;break;case 0:P.mid=h;break;case 1:P.right=h;break}}else this._root=h}for(let h=o.length-1;h>=0;h--){const _=o[h][1];_.updateHeight();const P=_.balanceFactor();if(P>1?(_.right.balanceFactor()>=0||(_.right=_.right.rotateRight()),o[h][1]=_.rotateLeft()):P<-1&&(_.left.balanceFactor()<=0||(_.left=_.left.rotateLeft()),o[h][1]=_.rotateRight()),h>0)switch(o[h-1][0]){case-1:o[h-1][1].left=o[h][1];break;case 1:o[h-1][1].right=o[h][1];break;case 0:o[h-1][1].mid=o[h][1];break}else this._root=o[0][1]}}}_min(i){for(;i.left;)i=i.left;return i}findSubstr(i){const c=this._iter.reset(i);let t=this._root,o;for(;t;){const g=c.cmp(t.segment);if(g>0)t=t.left;else if(g<0)t=t.right;else if(c.hasNext())c.next(),o=t.value||o,t=t.mid;else break}return t&&t.value||o}findSuperstr(i){const c=this._iter.reset(i);let t=this._root;for(;t;){const o=c.cmp(t.segment);if(o>0)t=t.left;else if(o<0)t=t.right;else if(c.hasNext())c.next(),t=t.mid;else return t.mid?this._entries(t.mid):void 0}}forEach(i){for(const[c,t]of this)i(t,c)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){!i||(i.left&&(yield*this._entries(i.left)),i.value&&(yield[i.key,i.value]),i.mid&&(yield*this._entries(i.mid)),i.right&&(yield*this._entries(i.right)))}_isBalanced(){const i=c=>{if(!c)return!0;const t=c.balanceFactor();return t<-1||t>1?!1:i(c.left)&&i(c.right)};return i(this._root)}}e.TernarySearchTree=S;class k{constructor(i,c){this.uri=i,this.value=c}}class d{constructor(i,c){this[b]="ResourceMap",i instanceof d?(this.map=new Map(i.map),this.toKey=c??d.defaultToKey):(this.map=new Map,this.toKey=i??d.defaultToKey)}set(i,c){return this.map.set(this.toKey(i),new k(i,c)),this}get(i){return this.map.get(this.toKey(i))?.value}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,c){typeof c!="undefined"&&(i=i.bind(c));for(let[t,o]of this.map)i(o.value,o.uri,this)}*values(){for(let i of this.map.values())yield i.value}*keys(){for(let i of this.map.values())yield i.uri}*entries(){for(let i of this.map.values())yield[i.uri,i.value]}*[(b=Symbol.toStringTag,Symbol.iterator)](){for(let[,i]of this.map)yield[i.uri,i.value]}}e.ResourceMap=d,d.defaultToKey=r=>r.toString();var p;(function(r){r[r.None=0]="None",r[r.AsOld=1]="AsOld",r[r.AsNew=2]="AsNew"})(p=e.Touch||(e.Touch={}));class w{constructor(){this[B]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,c=0){const t=this._map.get(i);if(!!t)return c!==0&&this.touch(t,c),t.value}set(i,c,t=0){let o=this._map.get(i);if(o)o.value=c,t!==0&&this.touch(o,t);else{switch(o={key:i,value:c,next:void 0,previous:void 0},t){case 0:this.addItemLast(o);break;case 1:this.addItemFirst(o);break;case 2:this.addItemLast(o);break;default:this.addItemLast(o);break}this._map.set(i,o),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const c=this._map.get(i);if(!!c)return this._map.delete(i),this.removeItem(c),this._size--,c.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,c){const t=this._state;let o=this._head;for(;o;){if(c?i.bind(c)(o.value,o.key,this):i(o.value,o.key,this),this._state!==t)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const i=this,c=this._state;let t=this._head;const o={[Symbol.iterator](){return o},next(){if(i._state!==c)throw new Error("LinkedMap got modified during iteration.");if(t){const g={value:t.key,done:!1};return t=t.next,g}else return{value:void 0,done:!0}}};return o}values(){const i=this,c=this._state;let t=this._head;const o={[Symbol.iterator](){return o},next(){if(i._state!==c)throw new Error("LinkedMap got modified during iteration.");if(t){const g={value:t.value,done:!1};return t=t.next,g}else return{value:void 0,done:!0}}};return o}entries(){const i=this,c=this._state;let t=this._head;const o={[Symbol.iterator](){return o},next(){if(i._state!==c)throw new Error("LinkedMap got modified during iteration.");if(t){const g={value:[t.key,t.value],done:!1};return t=t.next,g}else return{value:void 0,done:!0}}};return o}[(B=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let c=this._head,t=this.size;for(;c&&t>i;)this._map.delete(c.key),c=c.next,t--;this._head=c,this._size=t,c&&(c.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const c=i.next,t=i.previous;if(!c||!t)throw new Error("Invalid list");c.previous=t,t.next=c}i.next=void 0,i.previous=void 0,this._state++}touch(i,c){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(c!==1&&c!==2)){if(c===1){if(i===this._head)return;const t=i.next,o=i.previous;i===this._tail?(o.next=void 0,this._tail=o):(t.previous=o,o.next=t),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(c===2){if(i===this._tail)return;const t=i.next,o=i.previous;i===this._head?(t.previous=void 0,this._head=t):(t.previous=o,o.next=t),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((c,t)=>{i.push([t,c])}),i}fromJSON(i){this.clear();for(const[c,t]of i)this.set(c,t)}}e.LinkedMap=w;class a extends w{constructor(i,c=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,c),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,c=2){return super.get(i,c)}peek(i){return super.get(i,0)}set(i,c){return super.set(i,c,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=a;class T{constructor(i){D.set(this,void 0),je(this,D,i,"f")}get size(){return De(this,D,"f").size}forEach(i,c){De(this,D,"f").forEach(i,c)}get(i){return De(this,D,"f").get(i)}has(i){return De(this,D,"f").has(i)}entries(){return De(this,D,"f").entries()}keys(){return De(this,D,"f").keys()}values(){return De(this,D,"f").values()}[(D=new WeakMap,Symbol.iterator)](){return De(this,D,"f").entries()}}e.ReadonlyMapView=T}),define(Ee[104],we([1,0,22,9]),function(J,e,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function b(...C){return function(O,x){for(let Q=0,re=C.length;Q<re;Q++){const ve=C[Q](O,x);if(ve)return ve}return null}}e.or=b,e.matchesStrictPrefix=B.bind(void 0,!1),e.matchesPrefix=B.bind(void 0,!0);function B(C,O,x){if(!x||x.length<O.length)return null;let Q;return C?Q=I.startsWithIgnoreCase(x,O):Q=x.indexOf(O)===0,Q?O.length>0?[{start:0,end:O.length}]:[]:null}function D(C,O){const x=O.toLowerCase().indexOf(C.toLowerCase());return x===-1?null:[{start:x,end:x+C.length}]}e.matchesContiguousSubString=D;function A(C,O){return y(C.toLowerCase(),O.toLowerCase(),0,0)}e.matchesSubString=A;function y(C,O,x,Q){if(x===C.length)return[];if(Q===O.length)return null;if(C[x]===O[Q]){let re=null;return(re=y(C,O,x+1,Q+1))?S({start:Q,end:Q+1},re):null}return y(C,O,x,Q+1)}function M(C){return 97<=C&&C<=122}function L(C){return 65<=C&&C<=90}e.isUpper=L;function v(C){return 48<=C&&C<=57}function u(C){return C===32||C===9||C===10||C===13}const m=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(C=>m.add(C.charCodeAt(0)));function l(C){return u(C)||m.has(C)}function n(C,O){return C===O||l(C)&&l(O)}function f(C){return M(C)||L(C)||v(C)}function S(C,O){return O.length===0?O=[C]:C.end===O[0].start?O[0].start=C.start:O.unshift(C),O}function k(C,O){for(let x=O;x<C.length;x++){const Q=C.charCodeAt(x);if(L(Q)||v(Q)||x>0&&!f(C.charCodeAt(x-1)))return x}return C.length}function d(C,O,x,Q){if(x===C.length)return[];if(Q===O.length)return null;if(C[x]!==O[Q].toLowerCase())return null;{let re=null,ve=Q+1;for(re=d(C,O,x+1,Q+1);!re&&(ve=k(O,ve))<O.length;)re=d(C,O,x+1,ve),ve++;return re===null?null:S({start:Q,end:Q+1},re)}}function p(C){let O=0,x=0,Q=0,re=0,ve=0;for(let xe=0;xe<C.length;xe++)ve=C.charCodeAt(xe),L(ve)&&O++,M(ve)&&x++,f(ve)&&Q++,v(ve)&&re++;const Ie=O/C.length,Me=x/C.length,Le=Q/C.length,ze=re/C.length;return{upperPercent:Ie,lowerPercent:Me,alphaPercent:Le,numericPercent:ze}}function w(C){const{upperPercent:O,lowerPercent:x}=C;return x===0&&O>.6}function a(C){const{upperPercent:O,lowerPercent:x,alphaPercent:Q,numericPercent:re}=C;return x>.2&&O<.8&&Q>.6&&re<.2}function T(C){let O=0,x=0,Q=0,re=0;for(let ve=0;ve<C.length;ve++)Q=C.charCodeAt(ve),L(Q)&&O++,M(Q)&&x++,u(Q)&&re++;return(O===0||x===0)&&re===0?C.length<=30:O<=5}function r(C,O){if(!O||(O=O.trim(),O.length===0)||!T(C)||O.length>60)return null;const x=p(O);if(!a(x)){if(!w(x))return null;O=O.toLowerCase()}let Q=null,re=0;for(C=C.toLowerCase();re<O.length&&(Q=d(C,O,0,re))===null;)re=k(O,re+1);return Q}e.matchesCamelCase=r;function i(C,O,x=!1){if(!O||O.length===0)return null;let Q=null,re=0;for(C=C.toLowerCase(),O=O.toLowerCase();re<O.length&&(Q=c(C,O,0,re,x))===null;)re=t(O,re+1);return Q}e.matchesWords=i;function c(C,O,x,Q,re){if(x===C.length)return[];if(Q===O.length)return null;if(n(C.charCodeAt(x),O.charCodeAt(Q))){let ve=null,Ie=Q+1;if(ve=c(C,O,x+1,Q+1,re),!re)for(;!ve&&(Ie=t(O,Ie))<O.length;)ve=c(C,O,x+1,Ie,re),Ie++;return ve===null?null:S({start:Q,end:Q+1},ve)}else return null}function t(C,O){for(let x=O;x<C.length;x++)if(l(C.charCodeAt(x))||x>0&&l(C.charCodeAt(x-1)))return x;return C.length}const o=b(e.matchesPrefix,r,D),g=b(e.matchesPrefix,r,A),h=new s.LRUCache(1e4);function _(C,O,x=!1){if(typeof C!="string"||typeof O!="string")return null;let Q=h.get(C);Q||(Q=new RegExp(I.convertSimple2RegExpPattern(C),"i"),h.set(C,Q));const re=Q.exec(O);return re?[{start:re.index,end:re.index+re[0].length}]:x?g(C,O):o(C,O)}e.matchesFuzzy=_;function P(C,O){const x=Ae(C,C.toLowerCase(),0,O,O.toLowerCase(),0,!0);return x?W(x):null}e.matchesFuzzy2=P;function R(C,O,x,Q,re,ve){const Ie=Math.min(13,C.length);for(;x<Ie;x++){const Me=Ae(C,O,x,Q,re,ve,!1);if(Me)return Me}return[0,ve]}e.anyScore=R;function W(C){if(typeof C=="undefined")return[];const O=[],x=C[1];for(let Q=C.length-1;Q>1;Q--){const re=C[Q]+x,ve=O[O.length-1];ve&&ve.end===re?ve.end=re+1:O.push({start:re,end:re+1})}return O}e.createMatches=W;const E=128;function H(){const C=[],O=[];for(let x=0;x<=E;x++)O[x]=0;for(let x=0;x<=E;x++)C.push(O.slice(0));return C}function z(C){const O=[];for(let x=0;x<=C;x++)O[x]=0;return O}const q=z(2*E),G=z(2*E),j=H(),$=H(),ee=H(),se=!1;function Z(C,O,x,Q,re){function ve(Me,Le,ze=" "){for(;Me.length<Le;)Me=ze+Me;return Me}let Ie=` |   |${Q.split("").map(Me=>ve(Me,3)).join("|")}
`;for(let Me=0;Me<=x;Me++)Me===0?Ie+=" |":Ie+=`${O[Me-1]}|`,Ie+=C[Me].slice(0,re+1).map(Le=>ve(Le.toString(),3)).join("|")+`
`;return Ie}function le(C,O,x,Q){C=C.substr(O),x=x.substr(Q),console.log(Z($,C,C.length,x,x.length)),console.log(Z(ee,C,C.length,x,x.length)),console.log(Z(j,C,C.length,x,x.length))}function ue(C,O){if(O<0||O>=C.length)return!1;const x=C.codePointAt(O);switch(x){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!I.isEmojiImprecise(x)}}function Se(C,O){if(O<0||O>=C.length)return!1;switch(C.charCodeAt(O)){case 32:case 9:return!0;default:return!1}}function fe(C,O,x){return O[C]!==x[C]}function ne(C,O,x,Q,re,ve,Ie=!1){for(;O<x&&re<ve;)C[O]===Q[re]&&(Ie&&(q[O]=re),O+=1),re+=1;return O===x}e.isPatternInWord=ne;var me;(function(C){C[C.Diag=1]="Diag",C[C.Left=2]="Left",C[C.LeftLeft=3]="LeftLeft"})(me||(me={}));var ke;(function(C){C.Default=[-100,0];function O(x){return!x||x.length===2&&x[0]===-100&&x[1]===0}C.isDefault=O})(ke=e.FuzzyScore||(e.FuzzyScore={}));function Ae(C,O,x,Q,re,ve,Ie){const Me=C.length>E?E:C.length,Le=Q.length>E?E:Q.length;if(x>=Me||ve>=Le||Me-x>Le-ve||!ne(O,x,Me,re,ve,Le,!0))return;Be(Me,Le,x,ve,O,re);let ze=1,xe=1,Re=x,Qe=ve;const tt=[!1];for(ze=1,Re=x;Re<Me;ze++,Re++){const ce=q[Re],Oe=G[Re],We=Re+1<Me?G[Re+1]:Le;for(xe=ce-ve+1,Qe=ce;Qe<We;xe++,Qe++){let Ge=Number.MIN_SAFE_INTEGER,Je=!1;Qe<=Oe&&(Ge=Xe(C,O,Re,x,Q,re,Qe,Le,ve,j[ze-1][xe-1]===0,tt));let ft=0;Ge!==Number.MAX_SAFE_INTEGER&&(Je=!0,ft=Ge+$[ze-1][xe-1]);const It=Qe>ce,St=It?$[ze][xe-1]+(j[ze][xe-1]>0?-5:0):0,kt=Qe>ce+1&&j[ze][xe-1]>0,qe=kt?$[ze][xe-2]+(j[ze][xe-2]>0?-5:0):0;if(kt&&(!It||qe>=St)&&(!Je||qe>=ft))$[ze][xe]=qe,ee[ze][xe]=3,j[ze][xe]=0;else if(It&&(!Je||St>=ft))$[ze][xe]=St,ee[ze][xe]=2,j[ze][xe]=0;else if(Je)$[ze][xe]=ft,ee[ze][xe]=1,j[ze][xe]=j[ze-1][xe-1]+1;else throw new Error("not possible")}}if(se&&le(C,x,Q,ve),!tt[0]&&!Ie)return;ze--,xe--;const Te=[$[ze][xe],ve];let it=0,X=0;for(;ze>=1;){let ce=xe;do{const Oe=ee[ze][ce];if(Oe===3)ce=ce-2;else if(Oe===2)ce=ce-1;else break}while(ce>=1);it>1&&O[x+ze-1]===re[ve+xe-1]&&!fe(ce+ve-1,Q,re)&&it+1>j[ze][ce]&&(ce=xe),ce===xe?it++:it=1,X||(X=ce),ze--,xe=ce-1,Te.push(xe)}Le===Me&&(Te[0]+=2);const Y=X-Me;return Te[0]-=Y,Te}e.fuzzyScore=Ae;function Be(C,O,x,Q,re,ve){let Ie=C-1,Me=O-1;for(;Ie>=x&&Me>=Q;)re[Ie]===ve[Me]&&(G[Ie]=Me,Ie--),Me--}function Xe(C,O,x,Q,re,ve,Ie,Me,Le,ze,xe){if(O[x]!==ve[Ie])return Number.MIN_SAFE_INTEGER;let Re=1,Qe=!1;return Ie===x-Q?Re=C[x]===re[Ie]?7:5:fe(Ie,re,ve)&&(Ie===0||!fe(Ie-1,re,ve))?(Re=C[x]===re[Ie]?7:5,Qe=!0):ue(ve,Ie)&&(Ie===0||!ue(ve,Ie-1))?Re=5:(ue(ve,Ie-1)||Se(ve,Ie-1))&&(Re=5,Qe=!0),Re>1&&x===Q&&(xe[0]=!0),Qe||(Qe=fe(Ie,re,ve)||ue(ve,Ie-1)||Se(ve,Ie-1)),x===Q?Ie>Le&&(Re-=Qe?3:5):ze?Re+=Qe?2:0:Re+=Qe?0:1,Ie+1===Me&&(Re-=Qe?3:5),Re}function ge(C,O,x,Q,re,ve,Ie){return N(C,O,x,Q,re,ve,!0,Ie)}e.fuzzyScoreGracefulAggressive=ge;function de(C,O,x,Q,re,ve,Ie){return N(C,O,x,Q,re,ve,!1,Ie)}e.fuzzyScoreGraceful=de;function N(C,O,x,Q,re,ve,Ie,Me){let Le=Ae(C,O,x,Q,re,ve,Me);if(Le&&!Ie)return Le;if(C.length>=3){const ze=Math.min(7,C.length-1);for(let xe=x+1;xe<ze;xe++){const Re=F(C,xe);if(Re){const Qe=Ae(Re,Re.toLowerCase(),x,Q,re,ve,Me);Qe&&(Qe[0]-=3,(!Le||Qe[0]>Le[0])&&(Le=Qe))}}}return Le}function F(C,O){if(O+1>=C.length)return;const x=C[O],Q=C[O+1];if(x!==Q)return C.slice(0,O)+Q+x+C.slice(O+2)}}),define(Ee[105],we([1,0,106,104,9]),function(J,e,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const B=new RegExp(`\\$\\(${s.CSSIcon.iconNameExpression}(?:${s.CSSIcon.iconModifierExpression})?\\)`,"g"),D=new RegExp(s.CSSIcon.iconNameCharacter),A=new RegExp(`(\\\\)?${B.source}`,"g");function y(f){return f.replace(A,(S,k)=>k?S:`\\${S}`)}e.escapeIcons=y;const M=new RegExp(`\\\\${B.source}`,"g");function L(f){return f.replace(M,S=>`\\${S}`)}e.markdownEscapeEscapedIcons=L;const v=new RegExp(`(\\s)?(\\\\)?${B.source}(\\s)?`,"g");function u(f){return f.indexOf(e.iconStartMarker)===-1?f:f.replace(v,(S,k,d,p)=>d?S:k||p||"")}e.stripIcons=u;function m(f){const S=f.indexOf(e.iconStartMarker);return S===-1?{text:f}:l(f,S)}e.parseLabelWithIcons=m;function l(f,S){const k=[];let d="";function p(o){if(o){d+=o;for(const g of o)k.push(T)}}let w=-1,a="",T=0,r,i,c=S;const t=f.length;for(p(f.substr(0,S));c<t;)r=f[c],i=f[c+1],r===e.iconStartMarker[0]&&i===e.iconStartMarker[1]?(w=c,p(a),a=e.iconStartMarker,c++):r===")"&&w!==-1?(T+=c-w+1,w=-1,a=""):w!==-1?D.test(r)?a+=r:(p(a),w=-1,a=""):p(r),c++;return p(a),{text:d,iconOffsets:k}}function n(f,S,k=!1){const{text:d,iconOffsets:p}=S;if(!p||p.length===0)return(0,I.matchesFuzzy)(f,d,k);const w=(0,b.ltrim)(d," "),a=d.length-w.length,T=(0,I.matchesFuzzy)(f,w,k);if(T)for(const r of T){const i=p[r.start+a]+a;r.start+=i,r.end+=i}return T}e.matchesFuzzyIconAware=n}),define(Ee[34],we([1,0,9]),function(J,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var I;(function(b){b[b.Ignore=0]="Ignore",b[b.Info=1]="Info",b[b.Warning=2]="Warning",b[b.Error=3]="Error"})(I||(I={})),function(b){const B="error",D="warning",A="warn",y="info",M="ignore";function L(u){return u?s.equalsIgnoreCase(B,u)?b.Error:s.equalsIgnoreCase(D,u)||s.equalsIgnoreCase(A,u)?b.Warning:s.equalsIgnoreCase(y,u)?b.Info:b.Ignore:b.Ignore}b.fromValue=L;function v(u){switch(u){case b.Error:return B;case b.Warning:return D;case b.Info:return y;default:return M}}b.toString=v}(I||(I={})),e.default=I}),define(Ee[35],we([1,0,17,23,9,11]),function(J,e,s,I,b,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function D(c){return c===47||c===92}e.isPathSeparator=D;function A(c){return c.replace(/[\\/]/g,s.posix.sep)}e.toSlashes=A;function y(c){return c.indexOf("/")===-1&&(c=A(c)),/^[a-zA-Z]:(\/|$)/.test(c)&&(c="/"+c),c}e.toPosixPath=y;function M(c,t=s.posix.sep){if(!c)return"";const o=c.length,g=c.charCodeAt(0);if(D(g)){if(D(c.charCodeAt(1))&&!D(c.charCodeAt(2))){let _=3;const P=_;for(;_<o&&!D(c.charCodeAt(_));_++);if(P!==_&&!D(c.charCodeAt(_+1))){for(_+=1;_<o;_++)if(D(c.charCodeAt(_)))return c.slice(0,_+1).replace(/[\\/]/g,t)}}return t}else if(S(g)&&c.charCodeAt(1)===58)return D(c.charCodeAt(2))?c.slice(0,2)+t:c.slice(0,2);let h=c.indexOf("://");if(h!==-1){for(h+=3;h<o;h++)if(D(c.charCodeAt(h)))return c.slice(0,h+1)}return""}e.getRoot=M;function L(c){if(!I.isWindows||!c||c.length<5)return!1;let t=c.charCodeAt(0);if(t!==92||(t=c.charCodeAt(1),t!==92))return!1;let o=2;const g=o;for(;o<c.length&&(t=c.charCodeAt(o),t!==92);o++);return!(g===o||(t=c.charCodeAt(o+1),isNaN(t)||t===92))}e.isUNC=L;const v=/[\\/:\*\?"<>\|]/g,u=/[\\/]/g,m=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function l(c,t=I.isWindows){const o=t?v:u;return!(!c||c.length===0||/^\s+$/.test(c)||(o.lastIndex=0,o.test(c))||t&&m.test(c)||c==="."||c===".."||t&&c[c.length-1]==="."||t&&c.length!==c.trim().length||c.length>255)}e.isValidBasename=l;function n(c,t,o){const g=c===t;return!o||g?g:!c||!t?!1:(0,b.equalsIgnoreCase)(c,t)}e.isEqual=n;function f(c,t,o,g=s.sep){if(c===t)return!0;if(!c||!t||t.length>c.length)return!1;if(o){if(!(0,b.startsWithIgnoreCase)(c,t))return!1;if(t.length===c.length)return!0;let _=t.length;return t.charAt(t.length-1)===g&&_--,c.charAt(_)===g}return t.charAt(t.length-1)!==g&&(t+=g),c.indexOf(t)===0}e.isEqualOrParent=f;function S(c){return c>=65&&c<=90||c>=97&&c<=122}e.isWindowsDriveLetter=S;function k(c,t){return I.isWindows&&c.endsWith(":")&&(c+=s.sep),(0,s.isAbsolute)(c)||(c=(0,s.join)(t,c)),c=(0,s.normalize)(c),I.isWindows?(c=(0,b.rtrim)(c,s.sep),c.endsWith(":")&&(c+=s.sep)):(c=(0,b.rtrim)(c,s.sep),c||(c=s.sep)),c}e.sanitizeFilePath=k;function d(c){const t=(0,s.normalize)(c);return I.isWindows?c.length>3?!1:p(t)&&(c.length===2||t.charCodeAt(2)===92):t===s.posix.sep}e.isRootOrDriveLetter=d;function p(c,t){return(t!==void 0?t:I.isWindows)?S(c.charCodeAt(0))&&c.charCodeAt(1)===58:!1}e.hasDriveLetter=p;function w(c){return p(c)?c[0]:void 0}e.getDriveLetter=w;function a(c,t,o){return t.length>c.length?-1:c===t?0:(o&&(c=c.toLowerCase(),t=t.toLowerCase()),c.indexOf(t))}e.indexOfPath=a;function T(c){const t=c.split(":");let o,g,h;for(const _ of t){const P=Number(_);(0,B.isNumber)(P)?g===void 0?g=P:h===void 0&&(h=P):o=o?[o,_].join(":"):_}if(!o)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:o,line:g!==void 0?g:void 0,column:h!==void 0?h:g!==void 0?1:void 0}}e.parseLineAndColumnAware=T;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function i(c,t,o=8){let g="";for(let _=0;_<o;_++)g+=r.charAt(Math.floor(Math.random()*r.length));let h;return t?h=`${t}-${g}`:h=g,c?(0,s.join)(c,h):h}e.randomPath=i}),define(Ee[54],we([1,0,21,9,2]),function(J,e,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function B(M){return JSON.stringify(M,A)}e.stringify=B;function D(M){let L=JSON.parse(M);return L=y(L),L}e.parse=D;function A(M,L){return L instanceof RegExp?{$mid:2,source:L.source,flags:(0,I.regExpFlags)(L)}:L}function y(M,L=0){if(!M||L>200)return M;if(typeof M=="object"){switch(M.$mid){case 1:return b.URI.revive(M);case 2:return new RegExp(M.source,M.flags);case 14:return new Date(M.source)}if(M instanceof s.VSBuffer||M instanceof Uint8Array)return M;if(Array.isArray(M))for(let v=0;v<M.length;++v)M[v]=y(M[v],L+1);else for(const v in M)Object.hasOwnProperty.call(M,v)&&(M[v]=y(M[v],L+1))}return M}e.revive=y}),define(Ee[10],we([1,0,23,2]),function(J,e,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var b;(function(A){A.inMemory="inmemory",A.vscode="vscode",A.internal="private",A.walkThrough="walkThrough",A.walkThroughSnippet="walkThroughSnippet",A.http="http",A.https="https",A.file="file",A.mailto="mailto",A.untitled="untitled",A.data="data",A.command="command",A.vscodeRemote="vscode-remote",A.vscodeRemoteResource="vscode-remote-resource",A.userData="vscode-userdata",A.vscodeCustomEditor="vscode-custom-editor",A.vscodeNotebook="vscode-notebook",A.vscodeNotebookCell="vscode-notebook-cell",A.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",A.vscodeNotebookCellOutput="vscode-notebook-cell-output",A.vscodeInteractive="vscode-interactive",A.vscodeInteractiveInput="vscode-interactive-input",A.vscodeSettings="vscode-settings",A.vscodeWorkspaceTrust="vscode-workspace-trust",A.vscodeTerminal="vscode-terminal",A.webviewPanel="webview-panel",A.vscodeWebview="vscode-webview",A.extension="extension",A.vscodeFileResource="vscode-file",A.tmp="tmp",A.vsls="vsls"})(b=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class B{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(y){this._preferredWebSchema=y}setDelegate(y){this._delegate=y}set(y,M,L){this._hosts[y]=M,this._ports[y]=L}setConnectionToken(y,M){this._connectionTokens[y]=M}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(y){if(this._delegate)return this._delegate(y);const M=y.authority;let L=this._hosts[M];L&&L.indexOf(":")!==-1&&(L=`[${L}]`);const v=this._ports[M],u=this._connectionTokens[M];let m=`path=${encodeURIComponent(y.path)}`;return typeof u=="string"&&(m+=`&${e.connectionTokenQueryName}=${encodeURIComponent(u)}`),I.URI.from({scheme:s.isWeb?this._preferredWebSchema:b.vscodeRemoteResource,authority:`${L}:${v}`,path:"/vscode-remote-resource",query:m})}}e.RemoteAuthorities=new B;class D{asBrowserUri(y,M){const L=this.toUri(y,M);return L.scheme===b.vscodeRemote?e.RemoteAuthorities.rewrite(L):L.scheme===b.file&&(s.isNative||s.isWebWorker&&s.globals.origin===`${b.vscodeFileResource}://${D.FALLBACK_AUTHORITY}`)?L.with({scheme:b.vscodeFileResource,authority:L.authority||D.FALLBACK_AUTHORITY,query:null,fragment:null}):L}asFileUri(y,M){const L=this.toUri(y,M);return L.scheme===b.vscodeFileResource?L.with({scheme:b.file,authority:L.authority!==D.FALLBACK_AUTHORITY?L.authority:null,query:null,fragment:null}):L}toUri(y,M){return I.URI.isUri(y)?y:I.URI.parse(M.toUrl(y))}}D.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new D}),define(Ee[24],we([1,0,35,10,17,23,9,2]),function(J,e,s,I,b,B,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(m){return(0,A.uriToFsPath)(m,!0)}e.originalFSPath=y;class M{constructor(l){this._ignorePathCasing=l}compare(l,n,f=!1){return l===n?0:(0,D.compare)(this.getComparisonKey(l,f),this.getComparisonKey(n,f))}isEqual(l,n,f=!1){return l===n?!0:!l||!n?!1:this.getComparisonKey(l,f)===this.getComparisonKey(n,f)}getComparisonKey(l,n=!1){return l.with({path:this._ignorePathCasing(l)?l.path.toLowerCase():void 0,fragment:n?null:void 0}).toString()}ignorePathCasing(l){return this._ignorePathCasing(l)}isEqualOrParent(l,n,f=!1){if(l.scheme===n.scheme){if(l.scheme===I.Schemas.file)return s.isEqualOrParent(y(l),y(n),this._ignorePathCasing(l))&&l.query===n.query&&(f||l.fragment===n.fragment);if((0,e.isEqualAuthority)(l.authority,n.authority))return s.isEqualOrParent(l.path,n.path,this._ignorePathCasing(l),"/")&&l.query===n.query&&(f||l.fragment===n.fragment)}return!1}joinPath(l,...n){return A.URI.joinPath(l,...n)}basenameOrAuthority(l){return(0,e.basename)(l)||l.authority}basename(l){return b.posix.basename(l.path)}extname(l){return b.posix.extname(l.path)}dirname(l){if(l.path.length===0)return l;let n;return l.scheme===I.Schemas.file?n=A.URI.file(b.dirname(y(l))).path:(n=b.posix.dirname(l.path),l.authority&&n.length&&n.charCodeAt(0)!==47&&(console.error(`dirname("${l.toString})) resulted in a relative path`),n="/")),l.with({path:n})}normalizePath(l){if(!l.path.length)return l;let n;return l.scheme===I.Schemas.file?n=A.URI.file(b.normalize(y(l))).path:n=b.posix.normalize(l.path),l.with({path:n})}relativePath(l,n){if(l.scheme!==n.scheme||!(0,e.isEqualAuthority)(l.authority,n.authority))return;if(l.scheme===I.Schemas.file){const k=b.relative(y(l),y(n));return B.isWindows?s.toSlashes(k):k}let f=l.path||"/",S=n.path||"/";if(this._ignorePathCasing(l)){let k=0;for(const d=Math.min(f.length,S.length);k<d&&!(f.charCodeAt(k)!==S.charCodeAt(k)&&f.charAt(k).toLowerCase()!==S.charAt(k).toLowerCase());k++);f=S.substr(0,k)+f.substr(k)}return b.posix.relative(f,S)}resolvePath(l,n){if(l.scheme===I.Schemas.file){const f=A.URI.file(b.resolve(y(l),n));return l.with({authority:f.authority,path:f.path})}return n=s.toPosixPath(n),l.with({path:b.posix.resolve(l.path,n)})}isAbsolutePath(l){return!!l.path&&l.path[0]==="/"}isEqualAuthority(l,n){return l===n||l!==void 0&&n!==void 0&&(0,D.equalsIgnoreCase)(l,n)}hasTrailingPathSeparator(l,n=b.sep){if(l.scheme===I.Schemas.file){const f=y(l);return f.length>s.getRoot(f).length&&f[f.length-1]===n}else{const f=l.path;return f.length>1&&f.charCodeAt(f.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(l.fsPath)}}removeTrailingPathSeparator(l,n=b.sep){return(0,e.hasTrailingPathSeparator)(l,n)?l.with({path:l.path.substr(0,l.path.length-1)}):l}addTrailingPathSeparator(l,n=b.sep){let f=!1;if(l.scheme===I.Schemas.file){const S=y(l);f=S!==void 0&&S.length===s.getRoot(S).length&&S[S.length-1]===n}else{n="/";const S=l.path;f=S.length===1&&S.charCodeAt(S.length-1)===47}return!f&&!(0,e.hasTrailingPathSeparator)(l,n)?l.with({path:l.path+"/"}):l}}e.ExtUri=M,e.extUri=new M(()=>!1),e.extUriBiasedIgnorePathCase=new M(m=>m.scheme===I.Schemas.file?!B.isLinux:!0),e.extUriIgnorePathCase=new M(m=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function L(m,l){const n=[];for(let f=0;f<m.length;f++){const S=l(m[f]);m.some((k,d)=>d===f?!1:(0,e.isEqualOrParent)(S,l(k)))||n.push(m[f])}return n}e.distinctParents=L;var v;(function(m){m.META_DATA_LABEL="label",m.META_DATA_DESCRIPTION="description",m.META_DATA_SIZE="size",m.META_DATA_MIME="mime";function l(n){const f=new Map;n.path.substring(n.path.indexOf(";")+1,n.path.lastIndexOf(";")).split(";").forEach(d=>{const[p,w]=d.split(":");p&&w&&f.set(p,w)});const k=n.path.substring(0,n.path.indexOf(";"));return k&&f.set(m.META_DATA_MIME,k),f}m.parseMetaData=l})(v=e.DataUri||(e.DataUri={}));function u(m,l,n){if(l){let f=m.path;return f&&f[0]!==b.posix.sep&&(f=b.posix.sep+f),m.with({scheme:n,authority:l,path:f})}return m.with({scheme:n})}e.toLocalResource=u}),define(Ee[13],we([1,0,20,15,5,6,24,23]),function(J,e,s,I,b,B,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function y(fe){return!!fe&&typeof fe.then=="function"}e.isThenable=y;function M(fe){const ne=new s.CancellationTokenSource,me=fe(ne.token),ke=new Promise((Ae,Be)=>{const Xe=ne.token.onCancellationRequested(()=>{Xe.dispose(),ne.dispose(),Be(new I.CancellationError)});Promise.resolve(me).then(ge=>{Xe.dispose(),ne.dispose(),Ae(ge)},ge=>{Xe.dispose(),ne.dispose(),Be(ge)})});return new class{cancel(){ne.cancel()}then(Ae,Be){return ke.then(Ae,Be)}catch(Ae){return this.then(void 0,Ae)}finally(Ae){return ke.finally(Ae)}}}e.createCancelablePromise=M;function L(fe,ne,me){return new Promise((ke,Ae)=>{const Be=ne.onCancellationRequested(()=>{Be.dispose(),ke(me)});fe.then(ke,Ae).finally(()=>Be.dispose())})}e.raceCancellation=L;function v(fe,ne){return new Promise((me,ke)=>{const Ae=ne.onCancellationRequested(()=>{Ae.dispose(),ke(new I.CancellationError)});fe.then(me,ke).finally(()=>Ae.dispose())})}e.raceCancellationError=v;async function u(fe){let ne=-1;const me=fe.map((Ae,Be)=>Ae.then(Xe=>(ne=Be,Xe))),ke=await Promise.race(me);return fe.forEach((Ae,Be)=>{Be!==ne&&Ae.cancel()}),ke}e.raceCancellablePromises=u;function m(fe,ne,me){let ke;const Ae=setTimeout(()=>{ke?.(void 0),me?.()},ne);return Promise.race([fe.finally(()=>clearTimeout(Ae)),new Promise(Be=>ke=Be)])}e.raceTimeout=m;function l(fe){return new Promise((ne,me)=>{const ke=fe();y(ke)?ke.then(ne,me):ne(ke)})}e.asPromise=l;class n{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(ne){if(this.activePromise){if(this.queuedPromiseFactory=ne,!this.queuedPromise){const me=()=>{this.queuedPromise=null;const ke=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,ke};this.queuedPromise=new Promise(ke=>{this.activePromise.then(me,me).then(ke)})}return new Promise((me,ke)=>{this.queuedPromise.then(me,ke)})}return this.activePromise=ne(),new Promise((me,ke)=>{this.activePromise.then(Ae=>{this.activePromise=null,me(Ae)},Ae=>{this.activePromise=null,ke(Ae)})})}}e.Throttler=n;class f{constructor(){this.current=Promise.resolve(null)}queue(ne){return this.current=this.current.then(()=>ne(),()=>ne())}}e.Sequencer=f;class S{constructor(){this.promiseMap=new Map}queue(ne,me){const Ae=(this.promiseMap.get(ne)??Promise.resolve()).catch(()=>{}).then(me).finally(()=>{this.promiseMap.get(ne)===Ae&&this.promiseMap.delete(ne)});return this.promiseMap.set(ne,Ae),Ae}}e.SequencerByKey=S;const k=(fe,ne)=>{let me=!0;const ke=setTimeout(()=>{me=!1,ne()},fe);return{isTriggered:()=>me,dispose:()=>{clearTimeout(ke),me=!1}}},d=fe=>{let ne=!0;return queueMicrotask(()=>{ne&&(ne=!1,fe())}),{isTriggered:()=>ne,dispose:()=>{ne=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class p{constructor(ne){this.defaultDelay=ne,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(ne,me=this.defaultDelay){this.task=ne,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Ae,Be)=>{this.doResolve=Ae,this.doReject=Be}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Ae=this.task;return this.task=null,Ae()}}));const ke=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=me===e.MicrotaskDelay?d(ke):k(me,ke),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(new I.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=p;class w{constructor(ne){this.delayer=new p(ne),this.throttler=new n}trigger(ne,me){return this.delayer.trigger(()=>this.throttler.queue(ne),me)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=w;class a{constructor(){this._isOpen=!1,this._promise=new Promise((ne,me)=>{this._completePromise=ne})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=a;class T extends a{constructor(ne){super();this._timeout=setTimeout(()=>this.open(),ne)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=T;function r(fe,ne){return ne?new Promise((me,ke)=>{const Ae=setTimeout(()=>{Be.dispose(),me()},fe),Be=ne.onCancellationRequested(()=>{clearTimeout(Ae),Be.dispose(),ke(new I.CancellationError)})}):M(me=>r(fe,me))}e.timeout=r;function i(fe,ne=0){const me=setTimeout(fe,ne);return(0,B.toDisposable)(()=>clearTimeout(me))}e.disposableTimeout=i;function c(fe){const ne=[];let me=0;const ke=fe.length;function Ae(){return me<ke?fe[me++]():null}function Be(Xe){Xe!=null&&ne.push(Xe);const ge=Ae();return ge?ge.then(Be):Promise.resolve(ne)}return Promise.resolve(null).then(Be)}e.sequence=c;function t(fe,ne=ke=>!!ke,me=null){let ke=0;const Ae=fe.length,Be=()=>{if(ke>=Ae)return Promise.resolve(me);const Xe=fe[ke++];return Promise.resolve(Xe()).then(de=>ne(de)?Promise.resolve(de):Be())};return Be()}e.first=t;function o(fe,ne=ke=>!!ke,me=null){if(fe.length===0)return Promise.resolve(me);let ke=fe.length;const Ae=()=>{ke=-1;for(const Be of fe)Be.cancel?.()};return new Promise((Be,Xe)=>{for(const ge of fe)ge.then(de=>{--ke>=0&&ne(de)?(Ae(),Be(de)):ke===0&&Be(me)}).catch(de=>{--ke>=0&&(Ae(),Xe(de))})})}e.firstParallel=o;class g{constructor(ne){this._size=0,this.maxDegreeOfParalellism=ne,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new b.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(ne){return this._size++,new Promise((me,ke)=>{this.outstandingPromises.push({factory:ne,c:me,e:ke}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const ne=this.outstandingPromises.shift();this.runningPromises++;const me=ne.factory();me.then(ne.c,ne.e),me.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=g;class h extends g{constructor(){super(1)}}e.Queue=h;class _{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const ne=new ee;return this.drainers.add(ne),ne.p}isDrained(){for(const[,ne]of this.queues)if(ne.size>0)return!1;return!0}queueFor(ne,me=D.extUri){const ke=me.getComparisonKey(ne);let Ae=this.queues.get(ke);return Ae||(Ae=new h,b.Event.once(Ae.onFinished)(()=>{Ae?.dispose(),this.queues.delete(ke),this.onDidQueueFinish()}),this.queues.set(ke,Ae)),Ae}onDidQueueFinish(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const ne of this.drainers)ne.complete();this.drainers.clear()}dispose(){for(const[,ne]of this.queues)ne.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=_;class P{constructor(ne,me){this._token=-1,typeof ne=="function"&&typeof me=="number"&&this.setIfNotSet(ne,me)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(ne,me){this.cancel(),this._token=setTimeout(()=>{this._token=-1,ne()},me)}setIfNotSet(ne,me){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,ne()},me))}}e.TimeoutTimer=P;class R{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(ne,me){this.cancel(),this._token=setInterval(()=>{ne()},me)}}e.IntervalTimer=R;class W{constructor(ne,me){this.timeoutToken=-1,this.runner=ne,this.timeout=me,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(ne=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,ne)}get delay(){return this.timeout}set delay(ne){this.timeout=ne}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=W;class E{constructor(ne,me){me%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${me}ms is not a multiple of 1000ms.`),this.runner=ne,this.timeout=me,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(ne=this.timeout){ne%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ne}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(ne/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=E;class H extends W{constructor(ne,me){super(ne,me);this.units=[]}work(ne){this.units.push(ne),this.isScheduled()||this.schedule()}doRun(){const ne=this.units;this.units=[],this.runner&&this.runner(ne)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=H;class z extends B.Disposable{constructor(ne,me){super();this.options=ne,this.handler=me,this.pendingWork=[],this.throttler=this._register(new B.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(ne){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+ne.length>this.options.maxBufferedWork)return!1}else if(this.pending+ne.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...ne),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new W(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=z,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=fe=>{(0,A.setTimeout0)(()=>{if(ne)return;const me=Date.now()+15;fe(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,me-Date.now())}}))});let ne=!1;return{dispose(){ne||(ne=!0)}}}:e.runWhenIdle=(fe,ne)=>{const me=requestIdleCallback(fe,typeof ne=="number"?{timeout:ne}:void 0);let ke=!1;return{dispose(){ke||(ke=!0,cancelIdleCallback(me))}}}}();class q{constructor(ne){this._didRun=!1,this._executor=()=>{try{this._value=ne()}catch(me){this._error=me}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=q;async function G(fe,ne,me){let ke;for(let Ae=0;Ae<me;Ae++)try{return await fe()}catch(Be){ke=Be,await r(ne)}throw ke}e.retry=G;class j{hasPending(ne){return this._pending?typeof ne=="number"?this._pending.taskId===ne:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(ne,me,ke){return this._pending={taskId:ne,cancel:()=>ke?.(),promise:me},me.then(()=>this.donePending(ne),()=>this.donePending(ne)),me}donePending(ne){this._pending&&ne===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const ne=this._next;this._next=void 0,ne.run().then(ne.promiseResolve,ne.promiseReject)}}setNext(ne){if(this._next)this._next.run=ne;else{let me,ke;const Ae=new Promise((Be,Xe)=>{me=Be,ke=Xe});this._next={run:ne,promise:Ae,promiseResolve:me,promiseReject:ke}}return this._next.promise}}e.TaskSequentializer=j;class ${constructor(ne,me=()=>Date.now()){this.interval=ne,this.nowFn=me,this.lastIncrementTime=0,this.value=0}increment(){const ne=this.nowFn();return ne-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=ne,this.value=0),this.value++,this.value}}e.IntervalCounter=$;class ee{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((ne,me)=>{this.completeCallback=ne,this.errorCallback=me})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(ne){return new Promise(me=>{this.completeCallback(ne),this.resolved=!0,me()})}error(ne){return new Promise(me=>{this.errorCallback(ne),this.rejected=!0,me()})}cancel(){new Promise(ne=>{this.errorCallback(new I.CancellationError),this.rejected=!0,ne()})}}e.DeferredPromise=ee;var se;(function(fe){async function ne(ke){let Ae;const Be=await Promise.all(ke.map(Xe=>Xe.then(ge=>ge,ge=>{Ae||(Ae=ge)})));if(typeof Ae!="undefined")throw Ae;return Be}fe.settled=ne;function me(ke){return new Promise(async(Ae,Be)=>{try{await ke(Ae,Be)}catch(Xe){Be(Xe)}})}fe.withAsyncBody=me})(se=e.Promises||(e.Promises={}));var Z;(function(fe){fe[fe.Initial=0]="Initial",fe[fe.DoneOK=1]="DoneOK",fe[fe.DoneError=2]="DoneError"})(Z||(Z={}));class le{constructor(ne){this._state=0,this._results=[],this._error=null,this._onStateChanged=new b.Emitter,queueMicrotask(async()=>{const me={emitOne:ke=>this.emitOne(ke),emitMany:ke=>this.emitMany(ke),reject:ke=>this.reject(ke)};try{await Promise.resolve(ne(me)),this.resolve()}catch(ke){this.reject(ke)}finally{me.emitOne=void 0,me.emitMany=void 0,me.reject=void 0}})}static fromArray(ne){return new le(me=>{me.emitMany(ne)})}static fromPromise(ne){return new le(async me=>{me.emitMany(await ne)})}static fromPromises(ne){return new le(async me=>{await Promise.all(ne.map(async ke=>me.emitOne(await ke)))})}static merge(ne){return new le(async me=>{await Promise.all(ne.map(async ke=>{for await(const Ae of ke)me.emitOne(Ae)}))})}[Symbol.asyncIterator](){let ne=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(ne<this._results.length)return{done:!1,value:this._results[ne++]};if(this._state===1)return{done:!0,value:void 0};await b.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(ne,me){return new le(async ke=>{for await(const Ae of ne)ke.emitOne(me(Ae))})}map(ne){return le.map(this,ne)}static filter(ne,me){return new le(async ke=>{for await(const Ae of ne)me(Ae)&&ke.emitOne(Ae)})}filter(ne){return le.filter(this,ne)}static coalesce(ne){return le.filter(ne,me=>!!me)}coalesce(){return le.coalesce(this)}static async toPromise(ne){const me=[];for await(const ke of ne)me.push(ke);return me}toPromise(){return le.toPromise(this)}emitOne(ne){this._state===0&&(this._results.push(ne),this._onStateChanged.fire())}emitMany(ne){this._state===0&&(this._results=this._results.concat(ne),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(ne){this._state===0&&(this._state=2,this._error=ne,this._onStateChanged.fire())}}e.AsyncIterableObject=le,le.EMPTY=le.fromArray([]);class ue extends le{constructor(ne,me){super(me);this._source=ne}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=ue;function Se(fe){const ne=new s.CancellationTokenSource,me=fe(ne.token);return new ue(ne,async ke=>{const Ae=ne.token.onCancellationRequested(()=>{Ae.dispose(),ne.dispose(),ke.reject(new I.CancellationError)});try{for await(const Be of me){if(ne.token.isCancellationRequested)return;ke.emitOne(Be)}Ae.dispose(),ne.dispose()}catch(Be){Ae.dispose(),ne.dispose(),ke.reject(Be)}})}e.createCancelableAsyncIterable=Se}),define(Ee[107],we([1,0,13,17]),function(J,e,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const b=new s.IdleValue(()=>{const h=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:h,collatorIsNumeric:h.resolvedOptions().numeric}}),B=new s.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),D=new s.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function A(h,_,P=!1){const R=h||"",W=_||"",E=b.value.collator.compare(R,W);return b.value.collatorIsNumeric&&E===0&&R!==W?R<W?-1:1:E}e.compareFileNames=A;function y(h,_){const P=B.value.collator;return h=h||"",_=_||"",w(P,h,_)}e.compareFileNamesDefault=y;function M(h,_){const P=B.value.collator;return h=h||"",_=_||"",i(h,_)||w(P,h,_)}e.compareFileNamesUpper=M;function L(h,_){const P=B.value.collator;return h=h||"",_=_||"",r(h,_)||w(P,h,_)}e.compareFileNamesLower=L;function v(h,_){return h=h||"",_=_||"",h===_?0:h<_?-1:1}e.compareFileNamesUnicode=v;function u(h,_,P=!1){P||(h=h&&h.toLowerCase(),_=_&&_.toLowerCase());const[R,W]=d(h),[E,H]=d(_);return R!==E?R<E?-1:1:W===H?0:W<H?-1:1}e.noIntlCompareFileNames=u;function m(h,_){const[P,R]=d(h),[W,E]=d(_);let H=b.value.collator.compare(R,E);if(H===0){if(b.value.collatorIsNumeric&&R!==E)return R<E?-1:1;if(H=b.value.collator.compare(P,W),b.value.collatorIsNumeric&&H===0&&P!==W)return P<W?-1:1}return H}e.compareFileExtensions=m;function l(h,_){h=h||"",_=_||"";const P=p(h),R=p(_),W=B.value.collator,E=D.value.collator;return w(E,P,R)||w(W,h,_)}e.compareFileExtensionsDefault=l;function n(h,_){h=h||"",_=_||"";const P=p(h),R=p(_),W=B.value.collator,E=D.value.collator;return w(E,P,R)||i(h,_)||w(W,h,_)}e.compareFileExtensionsUpper=n;function f(h,_){h=h||"",_=_||"";const P=p(h),R=p(_),W=B.value.collator,E=D.value.collator;return w(E,P,R)||r(h,_)||w(W,h,_)}e.compareFileExtensionsLower=f;function S(h,_){h=h||"",_=_||"";const P=p(h).toLowerCase(),R=p(_).toLowerCase();return P!==R?P<R?-1:1:h!==_?h<_?-1:1:0}e.compareFileExtensionsUnicode=S;const k=/^(.*?)(\.([^.]*))?$/;function d(h,_=!1){const P=h?k.exec(h):[];let R=[P&&P[1]||"",P&&P[3]||""];return _&&(!R[0]&&R[1]||R[0]&&R[0].charAt(0)===".")&&(R=[R[0]+"."+R[1],""]),R}function p(h){const _=h?k.exec(h):[];return _&&_[1]&&_[1].charAt(0)!=="."&&_[3]||""}function w(h,_,P){let R=h.compare(_,P);return R!==0?R:_.length!==P.length?_.length<P.length?-1:1:0}function a(h){const _=h.charAt(0);return _.toLocaleUpperCase()!==_}function T(h){const _=h.charAt(0);return _.toLocaleLowerCase()!==_}function r(h,_){return a(h)&&T(_)?-1:T(h)&&a(_)?1:0}function i(h,_){return T(h)&&a(_)?-1:a(h)&&T(_)?1:0}function c(h,_,P=!1){return P||(h=h&&h.toLowerCase(),_=_&&_.toLowerCase()),h===_?0:h<_?-1:1}function t(h,_,P=!1){const R=h.split(I.sep),W=_.split(I.sep),E=R.length-1,H=W.length-1;let z,q;for(let G=0;;G++){if(z=E===G,q=H===G,z&&q)return A(R[G],W[G],P);if(z)return-1;if(q)return 1;const j=c(R[G],W[G],P);if(j!==0)return j}}e.comparePaths=t;function o(h,_,P){const R=h.toLowerCase(),W=_.toLowerCase(),E=g(h,_,P);if(E)return E;const H=R.endsWith(P),z=W.endsWith(P);if(H!==z)return H?-1:1;const q=A(R,W);return q!==0?q:R.localeCompare(W)}e.compareAnything=o;function g(h,_,P){const R=h.toLowerCase(),W=_.toLowerCase(),E=R.startsWith(P),H=W.startsWith(P);if(E!==H)return E?-1:1;if(E&&H){if(R.length<W.length)return-1;if(R.length>W.length)return 1}return 0}e.compareByPrefix=g}),define(Ee[29],we([1,0,13,35,22,17,23,9]),function(J,e,s,I,b,B,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function y(){return Object.create(null)}e.getEmptyExpression=y,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const M="[/\\\\]",L="[^/\\\\]",v=/\//g;function u(ee){switch(ee){case 0:return"";case 1:return`${L}*?`;default:return`(?:${M}|${L}+${M}|${M}${L}+)*?`}}function m(ee,se){if(!ee)return[];const Z=[];let le=!1,ue=!1,Se="";for(const fe of ee){switch(fe){case se:if(!le&&!ue){Z.push(Se),Se="";continue}break;case"{":le=!0;break;case"}":le=!1;break;case"[":ue=!0;break;case"]":ue=!1;break}Se+=fe}return Se&&Z.push(Se),Z}e.splitGlobAware=m;function l(ee){if(!ee)return"";let se="";const Z=m(ee,e.GLOB_SPLIT);if(Z.every(le=>le===e.GLOBSTAR))se=".*";else{let le=!1;Z.forEach((ue,Se)=>{if(ue===e.GLOBSTAR){le||(se+=u(2),le=!0);return}let fe=!1,ne="",me=!1,ke="";for(const Ae of ue){if(Ae!=="}"&&fe){ne+=Ae;continue}if(me&&(Ae!=="]"||!ke)){let Be;Ae==="-"?Be=Ae:(Ae==="^"||Ae==="!")&&!ke?Be="^":Ae===e.GLOB_SPLIT?Be="":Be=(0,A.escapeRegExpCharacters)(Ae),ke+=Be;continue}switch(Ae){case"{":fe=!0;continue;case"[":me=!0;continue;case"}":{se+=`(?:${m(ne,",").map(ge=>l(ge)).join("|")})`,fe=!1,ne="";break}case"]":se+="["+ke+"]",me=!1,ke="";break;case"?":se+=L;continue;case"*":se+=u(1);continue;default:se+=(0,A.escapeRegExpCharacters)(Ae)}}Se<Z.length-1&&(Z[Se+1]!==e.GLOBSTAR||Se+2<Z.length)&&(se+=M),le=!1})}return se}const n=/^\*\*\/\*\.[\w\.-]+$/,f=/^\*\*\/([\w\.-]+)\/?$/,S=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,k=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,d=/^\*\*((\/[\w\.-]+)+)\/?$/,p=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,w=new b.LRUCache(1e4),a=function(){return!1},T=function(){return null};function r(ee,se){if(!ee)return T;let Z;typeof ee!="string"?Z=ee.pattern:Z=ee,Z=Z.trim();const le=`${Z}_${!!se.trimForExclusions}`;let ue=w.get(le);if(ue)return i(ue,ee);let Se;if(n.test(Z)){const fe=Z.substr(4);ue=function(ne,me){return typeof ne=="string"&&ne.endsWith(fe)?Z:null}}else(Se=f.exec(c(Z,se)))?ue=t(Se[1],Z):(se.trimForExclusions?k:S).test(Z)?ue=o(Z,se):(Se=d.exec(c(Z,se)))?ue=g(Se[1].substr(1),Z,!0):(Se=p.exec(c(Z,se)))?ue=g(Se[1],Z,!1):ue=h(Z);return w.set(le,ue),i(ue,ee)}function i(ee,se){return typeof se=="string"?ee:function(Z,le){return(0,I.isEqualOrParent)(Z,se.base,!D.isLinux)?ee(Z.substr(se.base.length+1),le):null}}function c(ee,se){return se.trimForExclusions&&ee.endsWith("/**")?ee.substr(0,ee.length-2):ee}function t(ee,se){const Z=`/${ee}`,le=`\\${ee}`,ue=function(fe,ne){return typeof fe!="string"?null:ne?ne===ee?se:null:fe===ee||fe.endsWith(Z)||fe.endsWith(le)?se:null},Se=[ee];return ue.basenames=Se,ue.patterns=[se],ue.allBasenames=Se,ue}function o(ee,se){const Z=$(ee.slice(1,-1).split(",").map(ne=>r(ne,se)).filter(ne=>ne!==T),ee),le=Z.length;if(!le)return T;if(le===1)return Z[0];const ue=function(ne,me){for(let ke=0,Ae=Z.length;ke<Ae;ke++)if(Z[ke](ne,me))return ee;return null},Se=Z.find(ne=>!!ne.allBasenames);Se&&(ue.allBasenames=Se.allBasenames);const fe=Z.reduce((ne,me)=>me.allPaths?ne.concat(me.allPaths):ne,[]);return fe.length&&(ue.allPaths=fe),ue}function g(ee,se,Z){const le=B.sep===B.posix.sep,ue=le?ee:ee.replace(v,B.sep),Se=B.sep+ue,fe=B.posix.sep+ee,ne=Z?function(me,ke){return typeof me=="string"&&(me===ue||me.endsWith(Se)||!le&&(me===ee||me.endsWith(fe)))?se:null}:function(me,ke){return typeof me=="string"&&(me===ue||!le&&me===ee)?se:null};return ne.allPaths=[(Z?"*/":"./")+ee],ne}function h(ee){try{const se=new RegExp(`^${l(ee)}$`);return function(Z){return se.lastIndex=0,typeof Z=="string"&&se.test(Z)?ee:null}}catch{return T}}function _(ee,se,Z){return!ee||typeof se!="string"?!1:P(ee)(se,void 0,Z)}e.match=_;function P(ee,se={}){if(!ee)return a;if(typeof ee=="string"||H(ee)){const Z=r(ee,se);if(Z===T)return a;const le=function(ue,Se){return!!Z(ue,Se)};return Z.allBasenames&&(le.allBasenames=Z.allBasenames),Z.allPaths&&(le.allPaths=Z.allPaths),le}return G(ee,se)}e.parse=P;function R(ee){if(!ee)return;let se;return Z=>(se||(se=(ee()||Promise.resolve([])).then(le=>le?E(le):{})),se.then(le=>!!le[Z]))}e.hasSiblingPromiseFn=R;function W(ee){if(!ee)return;let se;return Z=>{if(!se){const le=ee();se=le?E(le):{}}return!!se[Z]}}e.hasSiblingFn=W;function E(ee){const se={};for(const Z of ee)se[Z]=!0;return se}function H(ee){const se=ee;return se?typeof se.base=="string"&&typeof se.pattern=="string":!1}e.isRelativePattern=H;function z(ee){return ee.allBasenames||[]}e.getBasenameTerms=z;function q(ee){return ee.allPaths||[]}e.getPathTerms=q;function G(ee,se){const Z=$(Object.getOwnPropertyNames(ee).map(ne=>j(ne,ee[ne],se)).filter(ne=>ne!==T)),le=Z.length;if(!le)return T;if(!Z.some(ne=>!!ne.requiresSiblings)){if(le===1)return Z[0];const ne=function(Ae,Be){for(let Xe=0,ge=Z.length;Xe<ge;Xe++){const de=Z[Xe](Ae,Be);if(de)return de}return null},me=Z.find(Ae=>!!Ae.allBasenames);me&&(ne.allBasenames=me.allBasenames);const ke=Z.reduce((Ae,Be)=>Be.allPaths?Ae.concat(Be.allPaths):Ae,[]);return ke.length&&(ne.allPaths=ke),ne}const ue=function(ne,me,ke){let Ae;for(let Be=0,Xe=Z.length;Be<Xe;Be++){const ge=Z[Be];ge.requiresSiblings&&ke&&(me||(me=(0,B.basename)(ne)),Ae||(Ae=me.substr(0,me.length-(0,B.extname)(ne).length)));const de=ge(ne,me,Ae,ke);if(de)return de}return null},Se=Z.find(ne=>!!ne.allBasenames);Se&&(ue.allBasenames=Se.allBasenames);const fe=Z.reduce((ne,me)=>me.allPaths?ne.concat(me.allPaths):ne,[]);return fe.length&&(ue.allPaths=fe),ue}function j(ee,se,Z){if(se===!1)return T;const le=r(ee,Z);if(le===T)return T;if(typeof se=="boolean")return le;if(se){const ue=se.when;if(typeof ue=="string"){const Se=(fe,ne,me,ke)=>{if(!ke||!le(fe,ne))return null;const Ae=ue.replace("$(basename)",me),Be=ke(Ae);return(0,s.isThenable)(Be)?Be.then(Xe=>Xe?ee:null):Be?ee:null};return Se.requiresSiblings=!0,Se}}return le}function $(ee,se){const Z=ee.filter(ne=>!!ne.basenames);if(Z.length<2)return ee;const le=Z.reduce((ne,me)=>{const ke=me.basenames;return ke?ne.concat(ke):ne},[]);let ue;if(se){ue=[];for(let ne=0,me=le.length;ne<me;ne++)ue.push(se)}else ue=Z.reduce((ne,me)=>{const ke=me.patterns;return ke?ne.concat(ke):ne},[]);const Se=function(ne,me){if(typeof ne!="string")return null;if(!me){let Ae;for(Ae=ne.length;Ae>0;Ae--){const Be=ne.charCodeAt(Ae-1);if(Be===47||Be===92)break}me=ne.substr(Ae)}const ke=le.indexOf(me);return ke!==-1?ue[ke]:null};Se.basenames=le,Se.patterns=ue,Se.allBasenames=le;const fe=ee.filter(ne=>!ne.basenames);return fe.push(Se),fe}}),define(Ee[72],we([1,0,15,105,24,9,2]),function(J,e,s,I,b,B,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var A;(function(n){n[n.Paragraph=0]="Paragraph",n[n.Break=1]="Break"})(A=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class y{constructor(f="",S=!1){if(this.value=f,typeof this.value!="string")throw(0,s.illegalArgument)("value");typeof S=="boolean"?(this.isTrusted=S,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=S.isTrusted??void 0,this.supportThemeIcons=S.supportThemeIcons??!1,this.supportHtml=S.supportHtml??!1)}appendText(f,S=0){return this.value+=u(this.supportThemeIcons?(0,I.escapeIcons)(f):f).replace(/([ \t]+)/g,(k,d)=>"&nbsp;".repeat(d.length)).replace(/\>/gm,"\\>").replace(/\n/g,S===1?`\\
`:`

`),this}appendMarkdown(f){return this.value+=f,this}appendCodeblock(f,S){return this.value+="\n```",this.value+=f,this.value+=`
`,this.value+=S,this.value+="\n```\n",this}appendLink(f,S,k){return this.value+="[",this.value+=this._escape(S,"]"),this.value+="](",this.value+=this._escape(String(f),")"),k&&(this.value+=` "${this._escape(this._escape(k,'"'),")")}"`),this.value+=")",this}_escape(f,S){const k=new RegExp((0,B.escapeRegExpCharacters)(S),"g");return f.replace(k,(d,p)=>f.charAt(p-1)!=="\\"?`\\${d}`:d)}}e.MarkdownString=y;function M(n){return L(n)?!n.value:Array.isArray(n)?n.every(M):!0}e.isEmptyMarkdownString=M;function L(n){return n instanceof y?!0:n&&typeof n=="object"?typeof n.value=="string"&&(typeof n.isTrusted=="boolean"||n.isTrusted===void 0)&&(typeof n.supportThemeIcons=="boolean"||n.supportThemeIcons===void 0):!1}e.isMarkdownString=L;function v(n,f){return n===f?!0:!n||!f?!1:n.value===f.value&&n.isTrusted===f.isTrusted&&n.supportThemeIcons===f.supportThemeIcons&&n.supportHtml===f.supportHtml&&(n.baseUri===f.baseUri||!!n.baseUri&&!!f.baseUri&&(0,b.isEqual)(D.URI.from(n.baseUri),D.URI.from(f.baseUri)))}e.markdownStringEqual=v;function u(n){return n.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=u;function m(n){return n&&n.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=m;function l(n){const f=[],S=n.split("|").map(d=>d.trim());n=S[0];const k=S[1];if(k){const d=/height=(\d+)/.exec(k),p=/width=(\d+)/.exec(k),w=d?d[1]:"",a=p?p[1]:"",T=isFinite(parseInt(a)),r=isFinite(parseInt(w));T&&f.push(`width="${a}"`),r&&f.push(`height="${w}"`)}return{href:n,dimensions:f}}e.parseHrefAndDimensions=l}),define(Ee[73],we([1,0,35,10,17,23,24,9,2]),function(J,e,s,I,b,B,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function M(i,c,t){if(typeof i=="string"&&(i=y.URI.file(i)),t){const g=t.getWorkspaceFolder(i);if(g){const h=t.getWorkspace().folders.length>1;let _;if((0,D.isEqual)(g.uri,i)?_="":_=(0,D.relativePath)(g.uri,i),h){const P=g.name?g.name:(0,D.basename)(g.uri);_=_?P+" \u2022 "+_:P}return _}}if(i.scheme!==I.Schemas.file&&i.scheme!==I.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if((0,s.hasDriveLetter)(i.fsPath))return(0,b.normalize)(v(i.fsPath));let o=(0,b.normalize)(i.fsPath);return!B.isWindows&&c?.userHome&&(o=m(o,c.userHome.fsPath)),o}e.getPathLabel=M;function L(i){if(!i)return;typeof i=="string"&&(i=y.URI.file(i));const c=(0,D.basename)(i)||(i.scheme===I.Schemas.file?i.fsPath:i.path);return B.isWindows&&(0,s.isRootOrDriveLetter)(c)?v(c):c}e.getBaseLabel=L;function v(i,c){return(0,s.hasDriveLetter)(i,c)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=v;let u=Object.create(null);function m(i,c){if(B.isWindows||!i||!c)return i;let t=u.original===c?u.normalized:void 0;return t||(t=`${(0,A.rtrim)(c,b.posix.sep)}${b.posix.sep}`,u={original:c,normalized:t}),(B.isLinux?i.startsWith(t):(0,A.startsWithIgnoreCase)(i,t))&&(i=`~/${i.substr(t.length)}`),i}e.tildify=m;function l(i,c){return i.replace(/^~($|\/|\\)/,`${c}$1`)}e.untildify=l;const n="\u2026",f="\\\\",S="~";function k(i,c=b.sep){const t=new Array(i.length);let o=!1;for(let g=0;g<i.length;g++){let h=i[g];if(h===""){t[g]=`.${c}`;continue}if(!h){t[g]=h;continue}o=!0;let _="";h.indexOf(f)===0?(_=h.substr(0,h.indexOf(f)+f.length),h=h.substr(h.indexOf(f)+f.length)):h.indexOf(c)===0?(_=h.substr(0,h.indexOf(c)+c.length),h=h.substr(h.indexOf(c)+c.length)):h.indexOf(S)===0&&(_=h.substr(0,h.indexOf(S)+S.length),h=h.substr(h.indexOf(S)+S.length));const P=h.split(c);for(let R=1;o&&R<=P.length;R++)for(let W=P.length-R;o&&W>=0;W--){o=!1;let E=P.slice(W,W+R).join(c);for(let H=0;!o&&H<i.length;H++)if(H!==g&&i[H]&&i[H].indexOf(E)>-1){const z=W+R===P.length,q=W>0&&i[H].indexOf(c)>-1?c+E:E,G=i[H].endsWith(q);o=!z||G}if(!o){let H="";(P[0].endsWith(":")||_!=="")&&(W===1&&(W=0,R++,E=P[0]+c+E),W>0&&(H=P[0]+c),H=_+H),W>0&&(H=H+n+c),H=H+E,W+R<P.length&&(H=H+c+n),t[g]=H}}o&&(t[g]=h)}return t}e.shorten=k;var d;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(d||(d={}));function p(i,c=Object.create(null)){const t=[];let o=!1,g="";for(const h of i)if(h==="$"||o&&h==="{")g&&t.push({value:g,type:d.TEXT}),g="",o=!0;else if(h==="}"&&o){const _=c[g];if(typeof _=="string")_.length&&t.push({value:_,type:d.VARIABLE});else if(_){const P=t[t.length-1];(!P||P.type!==d.SEPARATOR)&&t.push({value:_.label,type:d.SEPARATOR})}g="",o=!1}else g+=h;return g&&!o&&t.push({value:g,type:d.TEXT}),t.filter((h,_)=>{if(h.type===d.SEPARATOR){const P=t[_-1],R=t[_+1];return[P,R].every(W=>W&&(W.type===d.VARIABLE||W.type===d.TEXT)&&W.value.length>0)}return!0}).map(h=>h.value).join("")}e.template=p;function w(i,c){return B.isMacintosh||c?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,B.isMacintosh?"&":"&&"):i.replace(/&&|&/g,t=>t==="&"?"&&":"&")}e.mnemonicMenuLabel=w;function a(i,c){return B.isMacintosh||c?i.replace(/\(&&\w\)|&&/g,""):B.isWindows?i.replace(/&&|&/g,t=>t==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=a;function T(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=T;function r(i){const c=i.indexOf("/")!==-1?b.posix:b.win32,t=c.basename(i),o=c.dirname(i);return t.length?{name:t,parentPath:o}:{name:o,parentPath:""}}e.splitName=r}),define(Ee[108],we([1,0,2]),function(J,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function I(L){return L.toJSON()}class b{constructor(v){this._uriTransformer=v}transformIncoming(v){const u=this._uriTransformer.transformIncoming(v);return u===v?v:I(s.URI.from(u))}transformOutgoing(v){const u=this._uriTransformer.transformOutgoing(v);return u===v?v:I(s.URI.from(u))}transformOutgoingURI(v){const u=this._uriTransformer.transformOutgoing(v);return u===v?v:s.URI.from(u)}transformOutgoingScheme(v){return this._uriTransformer.transformOutgoingScheme(v)}}e.URITransformer=b,e.DefaultURITransformer=new class{transformIncoming(L){return L}transformOutgoing(L){return L}transformOutgoingURI(L){return L}transformOutgoingScheme(L){return L}};function B(L,v,u){if(!L||u>200)return null;if(typeof L=="object"){if(L instanceof s.URI)return v.transformOutgoing(L);for(let m in L)if(Object.hasOwnProperty.call(L,m)){const l=B(L[m],v,u+1);l!==null&&(L[m]=l)}}return null}function D(L,v){const u=B(L,v,0);return u===null?L:u}e.transformOutgoingURIs=D;function A(L,v,u,m){if(!L||m>200)return null;if(typeof L=="object"){if(L.$mid===1)return u?s.URI.revive(v.transformIncoming(L)):v.transformIncoming(L);for(let l in L)if(Object.hasOwnProperty.call(L,l)){const n=A(L[l],v,u,m+1);n!==null&&(L[l]=n)}}return null}function y(L,v){const u=A(L,v,!1,0);return u===null?L:u}e.transformIncomingURIs=y;function M(L,v){const u=A(L,v,!0,0);return u===null?L:u}e.transformAndReviveIncomingURIs=M}),define(Ee[36],we([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const s=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function I(y){return s.test(y)}e.isUUID=I;const b=new Uint8Array(16),B=[];for(let y=0;y<256;y++)B.push(y.toString(16).padStart(2,"0"));let D;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?D=crypto.getRandomValues.bind(crypto):D=function(y){for(let M=0;M<y.length;M++)y[M]=Math.floor(Math.random()*256);return y};function A(){D(b),b[6]=b[6]&15|64,b[8]=b[8]&63|128;let y=0,M="";return M+=B[b[y++]],M+=B[b[y++]],M+=B[b[y++]],M+=B[b[y++]],M+="-",M+=B[b[y++]],M+=B[b[y++]],M+="-",M+=B[b[y++]],M+=B[b[y++]],M+="-",M+=B[b[y++]],M+=B[b[y++]],M+="-",M+=B[b[y++]],M+=B[b[y++]],M+=B[b[y++]],M+=B[b[y++]],M+=B[b[y++]],M+=B[b[y++]],M}e.generateUuid=A}),define(Ee[109],we([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}}}),define(Ee[74],we([1,0,29,17]),function(J,e,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function b(B,D,A,y,M){if(Array.isArray(B)){let L=0;for(const v of B){const u=b(v,D,A,y,M);if(u===10)return u;u>L&&(L=u)}return L}else{if(typeof B=="string")return y?B==="*"?5:B===A?10:0:0;if(B){const{language:L,pattern:v,scheme:u,hasAccessToAllModels:m,notebookType:l}=B;if(!y&&!m)return 0;let n=0;if(u)if(u===D.scheme)n=10;else if(u==="*")n=5;else return 0;if(L)if(L===A)n=10;else if(L==="*")n=Math.max(n,5);else return 0;if(l)if(l===M)n=10;else if(l==="*")n=Math.max(n,5);else return 0;if(v){let f;if(typeof v=="string"?f=v:f={...v,base:(0,I.normalize)(v.base)},f===D.fsPath||(0,s.match)(f,D.fsPath))n=10;else return 0}return n}else return 0}}e.score=b}),define(Ee[110],we([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var s;(function(D){D[D.None=0]="None",D[D.Indent=1]="Indent",D[D.IndentOutdent=2]="IndentOutdent",D[D.Outdent=3]="Outdent"})(s=e.IndentAction||(e.IndentAction={}));class I{constructor(A){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=A.open,this.close=A.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(A.notIn))for(let y=0,M=A.notIn.length;y<M;y++)switch(A.notIn[y]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(A){switch(A){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(A,y){if(A.getTokenCount()===0)return!0;const M=A.findTokenIndexAtOffset(y-2),L=A.getStandardTokenType(M);return this.isOK(L)}_findNeutralCharacterInRange(A,y){for(let M=A;M<=y;M++){const L=String.fromCharCode(M);if(!this.open.includes(L)&&!this.close.includes(L))return L}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=I;class b{constructor(A){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of A)B(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),B(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),B(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),B(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&B(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.AutoClosingPairs=b;function B(D,A,y){D.has(A)?D.get(A).push(y):D.set(A,[y])}}),define(Ee[75],we([1,0,21,23]),function(J,e,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var b;(function(v){v[v.Full=1]="Full",v[v.Delta=2]="Delta"})(b||(b={}));function B(v){for(let u=0,m=v.length;u<m;u+=4){const l=v[u+0],n=v[u+1],f=v[u+2],S=v[u+3];v[u+0]=S,v[u+1]=f,v[u+2]=n,v[u+3]=l}}function D(v){const u=new Uint8Array(v.buffer,v.byteOffset,v.length*4);return I.isLittleEndian()||B(u),s.VSBuffer.wrap(u)}function A(v){const u=v.buffer;if(I.isLittleEndian()||B(u),u.byteOffset%4==0)return new Uint32Array(u.buffer,u.byteOffset,u.length/4);{const m=new Uint8Array(u.byteLength);return m.set(u),new Uint32Array(m.buffer,m.byteOffset,m.length/4)}}function y(v){const u=new Uint32Array(M(v));let m=0;if(u[m++]=v.id,v.type==="full")u[m++]=1,u[m++]=v.data.length,u.set(v.data,m),m+=v.data.length;else{u[m++]=2,u[m++]=v.deltas.length;for(const l of v.deltas)u[m++]=l.start,u[m++]=l.deleteCount,l.data?(u[m++]=l.data.length,u.set(l.data,m),m+=l.data.length):u[m++]=0}return D(u)}e.encodeSemanticTokensDto=y;function M(v){let u=0;if(u+=1+1,v.type==="full")u+=1+v.data.length;else{u+=1,u+=(1+1+1)*v.deltas.length;for(const m of v.deltas)m.data&&(u+=m.data.length)}return u}function L(v){const u=A(v);let m=0;const l=u[m++];if(u[m++]===1){const k=u[m++],d=u.subarray(m,m+k);return m+=k,{id:l,type:"full",data:d}}const f=u[m++],S=[];for(let k=0;k<f;k++){const d=u[m++],p=u[m++],w=u[m++];let a;w>0&&(a=u.subarray(m,m+w),m+=w),S[k]={start:d,deleteCount:p,data:a}}return{id:l,type:"delta",deltas:S}}e.decodeSemanticTokensDto=L}),define(Ee[111],we([18,19]),function(J,e){return J.create("vs/base/common/date",e)}),define(Ee[112],we([1,0,111]),function(J,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const I=60,b=I*60,B=b*24,D=B*7,A=B*30,y=B*365;function M(v,u,m){typeof v!="number"&&(v=v.getTime());const l=Math.round((new Date().getTime()-v)/1e3);if(l<-30)return(0,s.localize)(0,null,M(new Date().getTime()+l*1e3,!1));if(l<30)return(0,s.localize)(1,null);let n;return l<I?(n=l,u?n===1?m?(0,s.localize)(2,null,n):(0,s.localize)(3,null,n):m?(0,s.localize)(4,null,n):(0,s.localize)(5,null,n):n===1?m?(0,s.localize)(6,null,n):(0,s.localize)(7,null,n):m?(0,s.localize)(8,null,n):(0,s.localize)(9,null,n)):l<b?(n=Math.floor(l/I),u?n===1?m?(0,s.localize)(10,null,n):(0,s.localize)(11,null,n):m?(0,s.localize)(12,null,n):(0,s.localize)(13,null,n):n===1?m?(0,s.localize)(14,null,n):(0,s.localize)(15,null,n):m?(0,s.localize)(16,null,n):(0,s.localize)(17,null,n)):l<B?(n=Math.floor(l/b),u?n===1?m?(0,s.localize)(18,null,n):(0,s.localize)(19,null,n):m?(0,s.localize)(20,null,n):(0,s.localize)(21,null,n):n===1?m?(0,s.localize)(22,null,n):(0,s.localize)(23,null,n):m?(0,s.localize)(24,null,n):(0,s.localize)(25,null,n)):l<D?(n=Math.floor(l/B),u?n===1?(0,s.localize)(26,null,n):(0,s.localize)(27,null,n):n===1?(0,s.localize)(28,null,n):(0,s.localize)(29,null,n)):l<A?(n=Math.floor(l/D),u?n===1?m?(0,s.localize)(30,null,n):(0,s.localize)(31,null,n):m?(0,s.localize)(32,null,n):(0,s.localize)(33,null,n):n===1?m?(0,s.localize)(34,null,n):(0,s.localize)(35,null,n):m?(0,s.localize)(36,null,n):(0,s.localize)(37,null,n)):l<y?(n=Math.floor(l/A),u?n===1?m?(0,s.localize)(38,null,n):(0,s.localize)(39,null,n):m?(0,s.localize)(40,null,n):(0,s.localize)(41,null,n):n===1?m?(0,s.localize)(42,null,n):(0,s.localize)(43,null,n):m?(0,s.localize)(44,null,n):(0,s.localize)(45,null,n)):(n=Math.floor(l/y),u?n===1?m?(0,s.localize)(46,null,n):(0,s.localize)(47,null,n):m?(0,s.localize)(48,null,n):(0,s.localize)(49,null,n):n===1?m?(0,s.localize)(50,null,n):(0,s.localize)(51,null,n):m?(0,s.localize)(52,null,n):(0,s.localize)(53,null,n))}e.fromNow=M;function L(v){return v.getFullYear()+"-"+String(v.getMonth()+1).padStart(2,"0")+"-"+String(v.getDate()).padStart(2,"0")+"T"+String(v.getHours()).padStart(2,"0")+":"+String(v.getMinutes()).padStart(2,"0")+":"+String(v.getSeconds()).padStart(2,"0")+"."+(v.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=L}),define(Ee[113],we([18,19]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(Ee[43],we([1,0,16,11,113]),function(J,e,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function B(v,u){return u&&(v.stack||v.stacktrace)?b.localize(0,null,A(v),D(v.stack)||D(v.stacktrace)):A(v)}function D(v){return Array.isArray(v)?v.join(`
`):v}function A(v){return typeof v.code=="string"&&typeof v.errno=="number"&&typeof v.syscall=="string"?b.localize(1,null,v.message):v.message||b.localize(2,null)}function y(v=null,u=!1){if(!v)return b.localize(3,null);if(Array.isArray(v)){const m=s.coalesce(v),l=y(m[0],u);return m.length>1?b.localize(4,null,l,m.length):l}if(I.isString(v))return v;if(v.detail){const m=v.detail;if(m.error)return B(m.error,u);if(m.exception)return B(m.exception,u)}return v.stack?B(v,u):v.message?v.message:b.localize(5,null)}e.toErrorMessage=y;function M(v){const u=v;return u instanceof Error&&Array.isArray(u.actions)}e.isErrorWithActions=M;function L(v,u=Object.create(null)){const m=new Error(v);return u.actions&&(m.actions=u.actions),m}e.createErrorWithActions=L}),define(Ee[114],we([18,19]),function(J,e){return J.create("vs/editor/common/config/editorOptions",e)}),define(Ee[115],we([1,0,114,23,116,16,26,109]),function(J,e,s,I,b,B,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var y;(function(X){X[X.None=0]="None",X[X.Keep=1]="Keep",X[X.Brackets=2]="Brackets",X[X.Advanced=3]="Advanced",X[X.Full=4]="Full"})(y=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class M{constructor(Y){this._values=Y}hasChanged(Y){return this._values[Y]}}e.ConfigurationChangedEvent=M;class L{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=L;class v{constructor(Y,ce,Oe,We){this.id=Y,this.name=ce,this.defaultValue=Oe,this.schema=We}applyUpdate(Y,ce){return m(Y,ce)}compute(Y,ce,Oe){return Oe}}class u{constructor(Y,ce){this.newValue=Y,this.didChange=ce}}e.ApplyUpdateResult=u;function m(X,Y){if(typeof X!="object"||typeof Y!="object"||!X||!Y)return new u(Y,X!==Y);if(Array.isArray(X)||Array.isArray(Y)){const Oe=Array.isArray(X)&&Array.isArray(Y)&&B.equals(X,Y);return new u(Y,Oe)}let ce=!1;for(const Oe in Y)if(Y.hasOwnProperty(Oe)){const We=m(X[Oe],Y[Oe]);We.didChange&&(X[Oe]=We.newValue,ce=!0)}return new u(X,ce)}class l{constructor(Y){this.schema=void 0,this.id=Y,this.name="_never_",this.defaultValue=void 0}applyUpdate(Y,ce){return m(Y,ce)}validate(Y){return this.defaultValue}}class n{constructor(Y,ce,Oe,We){this.id=Y,this.name=ce,this.defaultValue=Oe,this.schema=We}applyUpdate(Y,ce){return m(Y,ce)}validate(Y){return typeof Y=="undefined"?this.defaultValue:Y}compute(Y,ce,Oe){return Oe}}function f(X,Y){return typeof X=="undefined"?Y:X==="false"?!1:Boolean(X)}e.boolean=f;class S extends n{constructor(Y,ce,Oe,We=void 0){typeof We!="undefined"&&(We.type="boolean",We.default=Oe);super(Y,ce,Oe,We)}validate(Y){return f(Y,this.defaultValue)}}function k(X,Y,ce,Oe){if(typeof X=="undefined")return Y;let We=parseInt(X,10);return isNaN(We)?Y:(We=Math.max(ce,We),We=Math.min(Oe,We),We|0)}e.clampedInt=k;class d extends n{constructor(Y,ce,Oe,We,Ge,Je=void 0){typeof Je!="undefined"&&(Je.type="integer",Je.default=Oe,Je.minimum=We,Je.maximum=Ge);super(Y,ce,Oe,Je);this.minimum=We,this.maximum=Ge}static clampedInt(Y,ce,Oe,We){return k(Y,ce,Oe,We)}validate(Y){return d.clampedInt(Y,this.defaultValue,this.minimum,this.maximum)}}class p extends n{constructor(Y,ce,Oe,We,Ge){typeof Ge!="undefined"&&(Ge.type="number",Ge.default=Oe);super(Y,ce,Oe,Ge);this.validationFn=We}static clamp(Y,ce,Oe){return Y<ce?ce:Y>Oe?Oe:Y}static float(Y,ce){if(typeof Y=="number")return Y;if(typeof Y=="undefined")return ce;const Oe=parseFloat(Y);return isNaN(Oe)?ce:Oe}validate(Y){return this.validationFn(p.float(Y,this.defaultValue))}}class w extends n{static string(Y,ce){return typeof Y!="string"?ce:Y}constructor(Y,ce,Oe,We=void 0){typeof We!="undefined"&&(We.type="string",We.default=Oe);super(Y,ce,Oe,We)}validate(Y){return w.string(Y,this.defaultValue)}}function a(X,Y,ce){return typeof X!="string"||ce.indexOf(X)===-1?Y:X}e.stringSet=a;class T extends n{constructor(Y,ce,Oe,We,Ge=void 0){typeof Ge!="undefined"&&(Ge.type="string",Ge.enum=We,Ge.default=Oe);super(Y,ce,Oe,Ge);this._allowedValues=We}validate(Y){return a(Y,this.defaultValue,this._allowedValues)}}class r extends v{constructor(Y,ce,Oe,We,Ge,Je,ft=void 0){typeof ft!="undefined"&&(ft.type="string",ft.enum=Ge,ft.default=We);super(Y,ce,Oe,ft);this._allowedValues=Ge,this._convert=Je}validate(Y){return typeof Y!="string"?this.defaultValue:this._allowedValues.indexOf(Y)===-1?this.defaultValue:this._convert(Y)}}function i(X){switch(X){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class c extends v{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[s.localize(0,null),s.localize(1,null),s.localize(2,null)],default:"auto",description:s.localize(3,null)})}validate(Y){switch(Y){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Y,ce,Oe){return Oe===0?Y.accessibilitySupport:Oe}}class t extends v{constructor(){const Y={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",Y,{"editor.comments.insertSpace":{type:"boolean",default:Y.insertSpace,description:s.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Y.ignoreEmptyLines,description:s.localize(5,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ce=Y;return{insertSpace:f(ce.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:f(ce.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var o;(function(X){X[X.Hidden=0]="Hidden",X[X.Blink=1]="Blink",X[X.Smooth=2]="Smooth",X[X.Phase=3]="Phase",X[X.Expand=4]="Expand",X[X.Solid=5]="Solid"})(o=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function g(X){switch(X){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var h;(function(X){X[X.Line=1]="Line",X[X.Block=2]="Block",X[X.Underline=3]="Underline",X[X.LineThin=4]="LineThin",X[X.BlockOutline=5]="BlockOutline",X[X.UnderlineThin=6]="UnderlineThin"})(h=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function _(X){switch(X){case h.Line:return"line";case h.Block:return"block";case h.Underline:return"underline";case h.LineThin:return"line-thin";case h.BlockOutline:return"block-outline";case h.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=_;function P(X){switch(X){case"line":return h.Line;case"block":return h.Block;case"underline":return h.Underline;case"line-thin":return h.LineThin;case"block-outline":return h.BlockOutline;case"underline-thin":return h.UnderlineThin}}class R extends l{constructor(){super(128)}compute(Y,ce,Oe){const We=["monaco-editor"];return ce.get(33)&&We.push(ce.get(33)),Y.extraEditorClassName&&We.push(Y.extraEditorClassName),ce.get(66)==="default"?We.push("mouse-default"):ce.get(66)==="copy"&&We.push("mouse-copy"),ce.get(100)&&We.push("showUnused"),ce.get(126)&&We.push("showDeprecated"),We.join(" ")}}class W extends S{constructor(){super(32,"emptySelectionClipboard",!0,{description:s.localize(6,null)})}compute(Y,ce,Oe){return Oe&&Y.emptySelectionClipboard}}class E extends v{constructor(){const Y={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(35,"find",Y,{"editor.find.cursorMoveOnType":{type:"boolean",default:Y.cursorMoveOnType,description:s.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Y.seedSearchStringFromSelection,enumDescriptions:[s.localize(8,null),s.localize(9,null),s.localize(10,null)],description:s.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Y.autoFindInSelection,enumDescriptions:[s.localize(12,null),s.localize(13,null),s.localize(14,null)],description:s.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Y.globalFindClipboard,description:s.localize(16,null),included:I.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Y.addExtraSpaceOnTop,description:s.localize(17,null)},"editor.find.loop":{type:"boolean",default:Y.loop,description:s.localize(18,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ce=Y;return{cursorMoveOnType:f(ce.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Y.seedSearchStringFromSelection=="boolean"?Y.seedSearchStringFromSelection?"always":"never":a(ce.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Y.autoFindInSelection=="boolean"?Y.autoFindInSelection?"always":"never":a(ce.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:f(ce.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:f(ce.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:f(ce.loop,this.defaultValue.loop)}}}class H extends v{constructor(){super(45,"fontLigatures",H.OFF,{anyOf:[{type:"boolean",description:s.localize(19,null)},{type:"string",description:s.localize(20,null)}],description:s.localize(21,null),default:!1})}validate(Y){return typeof Y=="undefined"?this.defaultValue:typeof Y=="string"?Y==="false"?H.OFF:Y==="true"?H.ON:Y:Boolean(Y)?H.ON:H.OFF}}e.EditorFontLigatures=H,H.OFF='"liga" off, "calt" off',H.ON='"liga" on, "calt" on';class z extends l{constructor(){super(44)}compute(Y,ce,Oe){return Y.fontInfo}}class q extends n{constructor(){super(46,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:s.localize(22,null)})}validate(Y){const ce=p.float(Y,this.defaultValue);return ce===0?e.EDITOR_FONT_DEFAULTS.fontSize:p.clamp(ce,6,100)}compute(Y,ce,Oe){return Y.fontInfo.fontSize}}class G extends v{constructor(){super(47,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:G.MINIMUM_VALUE,maximum:G.MAXIMUM_VALUE,errorMessage:s.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:G.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:s.localize(24,null)})}validate(Y){return Y==="normal"||Y==="bold"?Y:String(d.clampedInt(Y,e.EDITOR_FONT_DEFAULTS.fontWeight,G.MINIMUM_VALUE,G.MAXIMUM_VALUE))}}G.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],G.MINIMUM_VALUE=1,G.MAXIMUM_VALUE=1e3;class j extends v{constructor(){const Y={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ce={type:"string",enum:["peek","gotoAndPeek","goto"],default:Y.multiple,enumDescriptions:[s.localize(25,null),s.localize(26,null),s.localize(27,null)]},Oe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(51,"gotoLocation",Y,{"editor.gotoLocation.multiple":{deprecationMessage:s.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:s.localize(29,null),...ce},"editor.gotoLocation.multipleTypeDefinitions":{description:s.localize(30,null),...ce},"editor.gotoLocation.multipleDeclarations":{description:s.localize(31,null),...ce},"editor.gotoLocation.multipleImplementations":{description:s.localize(32,null),...ce},"editor.gotoLocation.multipleReferences":{description:s.localize(33,null),...ce},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Y.alternativeDefinitionCommand,enum:Oe,description:s.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Y.alternativeTypeDefinitionCommand,enum:Oe,description:s.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Y.alternativeDeclarationCommand,enum:Oe,description:s.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Y.alternativeImplementationCommand,enum:Oe,description:s.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Y.alternativeReferenceCommand,enum:Oe,description:s.localize(38,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ce=Y;return{multiple:a(ce.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ce.multipleDefinitions??a(ce.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ce.multipleTypeDefinitions??a(ce.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ce.multipleDeclarations??a(ce.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ce.multipleImplementations??a(ce.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ce.multipleReferences??a(ce.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:w.string(ce.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:w.string(ce.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:w.string(ce.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:w.string(ce.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:w.string(ce.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class $ extends v{constructor(){const Y={enabled:!0,delay:300,sticky:!0,above:!0};super(53,"hover",Y,{"editor.hover.enabled":{type:"boolean",default:Y.enabled,description:s.localize(39,null)},"editor.hover.delay":{type:"number",default:Y.delay,minimum:0,maximum:1e4,description:s.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:Y.sticky,description:s.localize(41,null)},"editor.hover.above":{type:"boolean",default:Y.above,description:s.localize(42,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ce=Y;return{enabled:f(ce.enabled,this.defaultValue.enabled),delay:d.clampedInt(ce.delay,this.defaultValue.delay,0,1e4),sticky:f(ce.sticky,this.defaultValue.sticky),above:f(ce.above,this.defaultValue.above)}}}var ee;(function(X){X[X.None=0]="None",X[X.Text=1]="Text",X[X.Blocks=2]="Blocks"})(ee=e.RenderMinimap||(e.RenderMinimap={}));class se extends l{constructor(){super(131)}compute(Y,ce,Oe){return se.computeLayout(ce,{memory:Y.memory,outerWidth:Y.outerWidth,outerHeight:Y.outerHeight,isDominatedByLongLines:Y.isDominatedByLongLines,lineHeight:Y.fontInfo.lineHeight,viewLineCount:Y.viewLineCount,lineNumbersDigitCount:Y.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Y.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Y.fontInfo.maxDigitWidth,pixelRatio:Y.pixelRatio})}static computeContainedMinimapLineCount(Y){const ce=Y.height/Y.lineHeight,Oe=Y.scrollBeyondLastLine?ce-1:0,We=(Y.viewLineCount+Oe)/(Y.pixelRatio*Y.height),Ge=Math.floor(Y.viewLineCount/We);return{typicalViewportLineCount:ce,extraLinesBeyondLastLine:Oe,desiredRatio:We,minimapLineCount:Ge}}static _computeMinimapLayout(Y,ce){const Oe=Y.outerWidth,We=Y.outerHeight,Ge=Y.pixelRatio;if(!Y.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ge*We),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:We};const Je=ce.stableMinimapLayoutInput,ft=Je&&Y.outerHeight===Je.outerHeight&&Y.lineHeight===Je.lineHeight&&Y.typicalHalfwidthCharacterWidth===Je.typicalHalfwidthCharacterWidth&&Y.pixelRatio===Je.pixelRatio&&Y.scrollBeyondLastLine===Je.scrollBeyondLastLine&&Y.minimap.enabled===Je.minimap.enabled&&Y.minimap.side===Je.minimap.side&&Y.minimap.size===Je.minimap.size&&Y.minimap.showSlider===Je.minimap.showSlider&&Y.minimap.renderCharacters===Je.minimap.renderCharacters&&Y.minimap.maxColumn===Je.minimap.maxColumn&&Y.minimap.scale===Je.minimap.scale&&Y.verticalScrollbarWidth===Je.verticalScrollbarWidth&&Y.isViewportWrapping===Je.isViewportWrapping,It=Y.lineHeight,St=Y.typicalHalfwidthCharacterWidth,kt=Y.scrollBeyondLastLine,qe=Y.minimap.renderCharacters;let vt=Ge>=2?Math.round(Y.minimap.scale*2):Y.minimap.scale;const Nt=Y.minimap.maxColumn,nt=Y.minimap.size,ut=Y.minimap.side,At=Y.verticalScrollbarWidth,Tt=Y.viewLineCount,bt=Y.remainingWidth,dt=Y.isViewportWrapping,Rt=qe?2:3;let Lt=Math.floor(Ge*We);const Ft=Lt/Ge;let Ue=!1,he=!1,pe=Rt*vt,ae=vt/Ge,K=1;if(nt==="fill"||nt==="fit"){const{typicalViewportLineCount:Et,extraLinesBeyondLastLine:rt,desiredRatio:at,minimapLineCount:ot}=se.computeContainedMinimapLineCount({viewLineCount:Tt,scrollBeyondLastLine:kt,height:We,lineHeight:It,pixelRatio:Ge});if(Tt/ot>1)Ue=!0,he=!0,vt=1,pe=1,ae=vt/Ge;else{let mt=!1,Dt=vt+1;if(nt==="fit"){const Ut=Math.ceil((Tt+rt)*pe);dt&&ft&&bt<=ce.stableFitRemainingWidth?(mt=!0,Dt=ce.stableFitMaxMinimapScale):mt=Ut>Lt}if(nt==="fill"||mt){Ue=!0;const Ut=vt;pe=Math.min(It*Ge,Math.max(1,Math.floor(1/at))),dt&&ft&&bt<=ce.stableFitRemainingWidth&&(Dt=ce.stableFitMaxMinimapScale),vt=Math.min(Dt,Math.max(1,Math.floor(pe/Rt))),vt>Ut&&(K=Math.min(2,vt/Ut)),ae=vt/Ge/K,Lt=Math.ceil(Math.max(Et,Tt+rt)*pe),dt?(ce.stableMinimapLayoutInput=Y,ce.stableFitRemainingWidth=bt,ce.stableFitMaxMinimapScale=vt):(ce.stableMinimapLayoutInput=null,ce.stableFitRemainingWidth=0)}}}const _e=Math.floor(Nt*ae),Ce=Math.min(_e,Math.max(0,Math.floor((bt-At-2)*ae/(St+ae)))+e.MINIMAP_GUTTER_WIDTH);let $e=Math.floor(Ge*Ce);const Ve=$e/Ge;$e=Math.floor($e*K);const lt=qe?1:2,gt=ut==="left"?0:Oe-Ce-At;return{renderMinimap:lt,minimapLeft:gt,minimapWidth:Ce,minimapHeightIsEditorHeight:Ue,minimapIsSampling:he,minimapScale:vt,minimapLineHeight:pe,minimapCanvasInnerWidth:$e,minimapCanvasInnerHeight:Lt,minimapCanvasOuterWidth:Ve,minimapCanvasOuterHeight:Ft}}static computeLayout(Y,ce){const Oe=ce.outerWidth|0,We=ce.outerHeight|0,Ge=ce.lineHeight|0,Je=ce.lineNumbersDigitCount|0,ft=ce.typicalHalfwidthCharacterWidth,It=ce.maxDigitWidth,St=ce.pixelRatio,kt=ce.viewLineCount,qe=Y.get(123),vt=qe==="inherit"?Y.get(122):qe,Nt=vt==="inherit"?Y.get(118):vt,nt=Y.get(121),ut=Y.get(2),At=ce.isDominatedByLongLines,Tt=Y.get(50),bt=Y.get(60).renderType!==0,dt=Y.get(61),Rt=Y.get(94),Lt=Y.get(65),Ft=Y.get(92),Ue=Ft.verticalScrollbarSize,he=Ft.verticalHasArrows,pe=Ft.arrowSize,ae=Ft.horizontalScrollbarSize,K=Y.get(58),_e=Y.get(37);let Ce;if(typeof K=="string"&&/^\d+(\.\d+)?ch$/.test(K)){const Wt=parseFloat(K.substr(0,K.length-2));Ce=d.clampedInt(Wt*ft,0,0,1e3)}else Ce=d.clampedInt(K,0,0,1e3);_e&&(Ce+=16);let $e=0;if(bt){const Wt=Math.max(Je,dt);$e=Math.round(Wt*It)}let Ve=0;Tt&&(Ve=Ge);let lt=0,gt=lt+Ve,Et=gt+$e,rt=Et+Ce;const at=Oe-Ve-$e-Ce;let ot=!1,Mt=!1,mt=-1;ut!==2&&(vt==="inherit"&&At?(ot=!0,Mt=!0):Nt==="on"||Nt==="bounded"?Mt=!0:Nt==="wordWrapColumn"&&(mt=nt));const Dt=se._computeMinimapLayout({outerWidth:Oe,outerHeight:We,lineHeight:Ge,typicalHalfwidthCharacterWidth:ft,pixelRatio:St,scrollBeyondLastLine:Rt,minimap:Lt,verticalScrollbarWidth:Ue,viewLineCount:kt,remainingWidth:at,isViewportWrapping:Mt},ce.memory||new L);Dt.renderMinimap!==0&&Dt.minimapLeft===0&&(lt+=Dt.minimapWidth,gt+=Dt.minimapWidth,Et+=Dt.minimapWidth,rt+=Dt.minimapWidth);const Ut=at-Dt.minimapWidth,wt=Math.max(1,Math.floor((Ut-Ue-2)/ft)),Bt=he?pe:0;return Mt&&(mt=Math.max(1,wt),Nt==="bounded"&&(mt=Math.min(mt,nt))),{width:Oe,height:We,glyphMarginLeft:lt,glyphMarginWidth:Ve,lineNumbersLeft:gt,lineNumbersWidth:$e,decorationsLeft:Et,decorationsWidth:Ce,contentLeft:rt,contentWidth:Ut,minimap:Dt,viewportColumn:wt,isWordWrapMinified:ot,isViewportWrapping:Mt,wrappingColumn:mt,verticalScrollbarWidth:Ue,horizontalScrollbarHeight:ae,overviewRuler:{top:Bt,width:Ue,height:We-2*Bt,right:0}}}}e.EditorLayoutInfoComputer=se;class Z extends v{constructor(){const Y={enabled:!0};super(57,"lightbulb",Y,{"editor.lightbulb.enabled":{type:"boolean",default:Y.enabled,description:s.localize(43,null)}})}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:{enabled:f(Y.enabled,this.defaultValue.enabled)}}}class le extends v{constructor(){const Y={enabled:!0,fontSize:0,fontFamily:""};super(127,"inlayHints",Y,{"editor.inlayHints.enabled":{type:"boolean",default:Y.enabled,description:s.localize(44,null)},"editor.inlayHints.fontSize":{type:"number",default:Y.fontSize,markdownDescription:s.localize(45,null)},"editor.inlayHints.fontFamily":{type:"string",default:Y.fontFamily,markdownDescription:s.localize(46,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ce=Y;return{enabled:f(ce.enabled,this.defaultValue.enabled),fontSize:d.clampedInt(ce.fontSize,this.defaultValue.fontSize,0,100),fontFamily:w.string(ce.fontFamily,this.defaultValue.fontFamily)}}}class ue extends p{constructor(){super(59,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Y=>p.clamp(Y,0,150),{markdownDescription:s.localize(47,null)})}compute(Y,ce,Oe){return Y.fontInfo.lineHeight}}class Se extends v{constructor(){const Y={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(65,"minimap",Y,{"editor.minimap.enabled":{type:"boolean",default:Y.enabled,description:s.localize(48,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[s.localize(49,null),s.localize(50,null),s.localize(51,null)],default:Y.size,description:s.localize(52,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Y.side,description:s.localize(53,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Y.showSlider,description:s.localize(54,null)},"editor.minimap.scale":{type:"number",default:Y.scale,minimum:1,maximum:3,enum:[1,2,3],description:s.localize(55,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Y.renderCharacters,description:s.localize(56,null)},"editor.minimap.maxColumn":{type:"number",default:Y.maxColumn,description:s.localize(57,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ce=Y;return{enabled:f(ce.enabled,this.defaultValue.enabled),size:a(ce.size,this.defaultValue.size,["proportional","fill","fit"]),side:a(ce.side,this.defaultValue.side,["right","left"]),showSlider:a(ce.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:f(ce.renderCharacters,this.defaultValue.renderCharacters),scale:d.clampedInt(ce.scale,1,1,3),maxColumn:d.clampedInt(ce.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function fe(X){return X==="ctrlCmd"?I.isMacintosh?"metaKey":"ctrlKey":"altKey"}class ne extends v{constructor(){super(75,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:s.localize(58,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:s.localize(59,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ce=Y;return{top:d.clampedInt(ce.top,0,0,1e3),bottom:d.clampedInt(ce.bottom,0,0,1e3)}}}class me extends v{constructor(){const Y={enabled:!0,cycle:!1};super(76,"parameterHints",Y,{"editor.parameterHints.enabled":{type:"boolean",default:Y.enabled,description:s.localize(60,null)},"editor.parameterHints.cycle":{type:"boolean",default:Y.cycle,description:s.localize(61,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ce=Y;return{enabled:f(ce.enabled,this.defaultValue.enabled),cycle:f(ce.cycle,this.defaultValue.cycle)}}}class ke extends l{constructor(){super(129)}compute(Y,ce,Oe){return Y.pixelRatio}}class Ae extends v{constructor(){const Y={other:!0,comments:!1,strings:!1};super(79,"quickSuggestions",Y,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:Y.strings,description:s.localize(62,null)},comments:{type:"boolean",default:Y.comments,description:s.localize(63,null)},other:{type:"boolean",default:Y.other,description:s.localize(64,null)}}}],default:Y,description:s.localize(65,null)});this.defaultValue=Y}validate(Y){if(typeof Y=="boolean")return Y;if(Y&&typeof Y=="object"){const ce=Y,Oe={other:f(ce.other,this.defaultValue.other),comments:f(ce.comments,this.defaultValue.comments),strings:f(ce.strings,this.defaultValue.strings)};return Oe.other&&Oe.comments&&Oe.strings?!0:!Oe.other&&!Oe.comments&&!Oe.strings?!1:Oe}return this.defaultValue}}var Be;(function(X){X[X.Off=0]="Off",X[X.On=1]="On",X[X.Relative=2]="Relative",X[X.Interval=3]="Interval",X[X.Custom=4]="Custom"})(Be=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Xe extends v{constructor(){super(60,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[s.localize(66,null),s.localize(67,null),s.localize(68,null),s.localize(69,null)],default:"on",description:s.localize(70,null)})}validate(Y){let ce=this.defaultValue.renderType,Oe=this.defaultValue.renderFn;return typeof Y!="undefined"&&(typeof Y=="function"?(ce=4,Oe=Y):Y==="interval"?ce=3:Y==="relative"?ce=2:Y==="on"?ce=1:ce=0),{renderType:ce,renderFn:Oe}}}function ge(X){const Y=X.get(87);return Y==="editable"?X.get(81):Y!=="on"}e.filterValidationDecorations=ge;class de extends v{constructor(){const Y=[],ce={type:"number",description:s.localize(71,null)};super(91,"rulers",Y,{type:"array",items:{anyOf:[ce,{type:["object"],properties:{column:ce,color:{type:"string",description:s.localize(72,null),format:"color-hex"}}}]},default:Y,description:s.localize(73,null)})}validate(Y){if(Array.isArray(Y)){const ce=[];for(let Oe of Y)if(typeof Oe=="number")ce.push({column:d.clampedInt(Oe,0,0,1e4),color:null});else if(Oe&&typeof Oe=="object"){const We=Oe;ce.push({column:d.clampedInt(We.column,0,0,1e4),color:We.color})}return ce.sort((Oe,We)=>Oe.column-We.column),ce}return this.defaultValue}}function N(X,Y){if(typeof X!="string")return Y;switch(X){case"hidden":return 2;case"visible":return 3;default:return 1}}class F extends v{constructor(){const Y={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(92,"scrollbar",Y,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[s.localize(74,null),s.localize(75,null),s.localize(76,null)],default:"auto",description:s.localize(77,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[s.localize(78,null),s.localize(79,null),s.localize(80,null)],default:"auto",description:s.localize(81,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Y.verticalScrollbarSize,description:s.localize(82,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Y.horizontalScrollbarSize,description:s.localize(83,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Y.scrollByPage,description:s.localize(84,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ce=Y,Oe=d.clampedInt(ce.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),We=d.clampedInt(ce.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:d.clampedInt(ce.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:N(ce.vertical,this.defaultValue.vertical),horizontal:N(ce.horizontal,this.defaultValue.horizontal),useShadows:f(ce.useShadows,this.defaultValue.useShadows),verticalHasArrows:f(ce.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:f(ce.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:f(ce.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:f(ce.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Oe,horizontalSliderSize:d.clampedInt(ce.horizontalSliderSize,Oe,0,1e3),verticalScrollbarSize:We,verticalSliderSize:d.clampedInt(ce.verticalSliderSize,We,0,1e3),scrollByPage:f(ce.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class C extends v{constructor(){const Y={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(113,"unicodeHighlight",Y,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.nonBasicASCII,description:s.localize(85,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Y.invisibleCharacters,description:s.localize(86,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Y.ambiguousCharacters,description:s.localize(87,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.includeComments,description:s.localize(88,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.includeStrings,description:s.localize(89,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Y.allowedCharacters,description:s.localize(90,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Y.allowedLocales,description:s.localize(91,null)}})}applyUpdate(Y,ce){let Oe=!1;ce.allowedCharacters&&(D.equals(Y.allowedCharacters,ce.allowedCharacters)||(Y={...Y,allowedCharacters:ce.allowedCharacters},Oe=!0)),ce.allowedLocales&&(D.equals(Y.allowedLocales,ce.allowedLocales)||(Y={...Y,allowedLocales:ce.allowedLocales},Oe=!0));const We=super.applyUpdate(Y,ce);return Oe?new u(We.newValue,!0):We}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ce=Y;return{nonBasicASCII:re(ce.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:f(ce.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:f(ce.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:re(ce.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:re(ce.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(Y.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(Y.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(Y,ce){if(typeof Y!="object"||!Y)return ce;const Oe={};for(const[We,Ge]of Object.entries(Y))Ge===!0&&(Oe[We]=!0);return Oe}}class O extends v{constructor(){const Y={enabled:!0,mode:"subwordSmart"};super(55,"inlineSuggest",Y,{"editor.inlineSuggest.enabled":{type:"boolean",default:Y.enabled,description:s.localize(92,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ce=Y;return{enabled:f(ce.enabled,this.defaultValue.enabled),mode:a(ce.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class x extends v{constructor(){const Y={enabled:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",Y,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Y.enabled,description:s.localize(93,null)}})}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:{enabled:f(Y.enabled,this.defaultValue.enabled)}}}class Q extends v{constructor(){const Y={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",Y,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[s.localize(94,null),s.localize(95,null),s.localize(96,null)],default:Y.bracketPairs,description:s.localize(97,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[s.localize(98,null),s.localize(99,null),s.localize(100,null)],default:Y.bracketPairsHorizontal,description:s.localize(101,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Y.highlightActiveBracketPair,description:s.localize(102,null)},"editor.guides.indentation":{type:"boolean",default:Y.indentation,description:s.localize(103,null)},"editor.guides.highlightActiveIndentation":{type:"boolean",default:Y.highlightActiveIndentation,description:s.localize(104,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ce=Y;return{bracketPairs:re(ce.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:re(ce.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:f(ce.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:f(ce.indentation,this.defaultValue.indentation),highlightActiveIndentation:f(ce.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation)}}}function re(X,Y,ce){const Oe=ce.indexOf(X);return Oe===-1?Y:ce[Oe]}class ve extends v{constructor(){const Y={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(106,"suggest",Y,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[s.localize(105,null),s.localize(106,null)],default:Y.insertMode,description:s.localize(107,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Y.filterGraceful,description:s.localize(108,null)},"editor.suggest.localityBonus":{type:"boolean",default:Y.localityBonus,description:s.localize(109,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Y.shareSuggestSelections,markdownDescription:s.localize(110,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Y.snippetsPreventQuickSuggestions,description:s.localize(111,null)},"editor.suggest.showIcons":{type:"boolean",default:Y.showIcons,description:s.localize(112,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Y.showStatusBar,description:s.localize(113,null)},"editor.suggest.preview":{type:"boolean",default:Y.preview,description:s.localize(114,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Y.showInlineDetails,description:s.localize(115,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:s.localize(116,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:s.localize(117,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:s.localize(118,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:s.localize(119,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:s.localize(120,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:s.localize(121,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:s.localize(122,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:s.localize(123,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:s.localize(124,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:s.localize(125,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:s.localize(126,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:s.localize(127,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:s.localize(128,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:s.localize(129,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:s.localize(130,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:s.localize(131,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:s.localize(132,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:s.localize(133,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:s.localize(134,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:s.localize(135,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:s.localize(136,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:s.localize(137,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:s.localize(138,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:s.localize(139,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:s.localize(140,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:s.localize(141,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:s.localize(142,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:s.localize(143,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:s.localize(144,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:s.localize(145,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:s.localize(146,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ce=Y;return{insertMode:a(ce.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:f(ce.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:f(ce.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:f(ce.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:f(ce.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:f(ce.showIcons,this.defaultValue.showIcons),showStatusBar:f(ce.showStatusBar,this.defaultValue.showStatusBar),preview:f(ce.preview,this.defaultValue.preview),previewMode:a(ce.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:f(ce.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:f(ce.showMethods,this.defaultValue.showMethods),showFunctions:f(ce.showFunctions,this.defaultValue.showFunctions),showConstructors:f(ce.showConstructors,this.defaultValue.showConstructors),showDeprecated:f(ce.showDeprecated,this.defaultValue.showDeprecated),showFields:f(ce.showFields,this.defaultValue.showFields),showVariables:f(ce.showVariables,this.defaultValue.showVariables),showClasses:f(ce.showClasses,this.defaultValue.showClasses),showStructs:f(ce.showStructs,this.defaultValue.showStructs),showInterfaces:f(ce.showInterfaces,this.defaultValue.showInterfaces),showModules:f(ce.showModules,this.defaultValue.showModules),showProperties:f(ce.showProperties,this.defaultValue.showProperties),showEvents:f(ce.showEvents,this.defaultValue.showEvents),showOperators:f(ce.showOperators,this.defaultValue.showOperators),showUnits:f(ce.showUnits,this.defaultValue.showUnits),showValues:f(ce.showValues,this.defaultValue.showValues),showConstants:f(ce.showConstants,this.defaultValue.showConstants),showEnums:f(ce.showEnums,this.defaultValue.showEnums),showEnumMembers:f(ce.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:f(ce.showKeywords,this.defaultValue.showKeywords),showWords:f(ce.showWords,this.defaultValue.showWords),showColors:f(ce.showColors,this.defaultValue.showColors),showFiles:f(ce.showFiles,this.defaultValue.showFiles),showReferences:f(ce.showReferences,this.defaultValue.showReferences),showFolders:f(ce.showFolders,this.defaultValue.showFolders),showTypeParameters:f(ce.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:f(ce.showSnippets,this.defaultValue.showSnippets),showUsers:f(ce.showUsers,this.defaultValue.showUsers),showIssues:f(ce.showIssues,this.defaultValue.showIssues)}}}class Ie extends v{constructor(){super(102,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:s.localize(147,null),default:!0,type:"boolean"}})}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:f(Y.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class Me extends l{constructor(){super(130)}compute(Y,ce,Oe){return ce.get(81)?!0:Y.tabFocusMode}}var Le;(function(X){X[X.None=0]="None",X[X.Same=1]="Same",X[X.Indent=2]="Indent",X[X.DeepIndent=3]="DeepIndent"})(Le=e.WrappingIndent||(e.WrappingIndent={}));function ze(X){switch(X){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class xe extends l{constructor(){super(132)}compute(Y,ce,Oe){const We=ce.get(131);return{isDominatedByLongLines:Y.isDominatedByLongLines,isWordWrapMinified:We.isWordWrapMinified,isViewportWrapping:We.isViewportWrapping,wrappingColumn:We.wrappingColumn}}}const Re="Consolas, 'Courier New', monospace",Qe="Menlo, Monaco, 'Courier New', monospace",tt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:I.isMacintosh?Qe:I.isLinux?tt:Re,fontWeight:"normal",fontSize:I.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Te(X){return e.editorOptionsRegistry[X.id]=X,X}var it;(function(X){X[X.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",X[X.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",X[X.accessibilitySupport=2]="accessibilitySupport",X[X.accessibilityPageSize=3]="accessibilityPageSize",X[X.ariaLabel=4]="ariaLabel",X[X.autoClosingBrackets=5]="autoClosingBrackets",X[X.autoClosingDelete=6]="autoClosingDelete",X[X.autoClosingOvertype=7]="autoClosingOvertype",X[X.autoClosingQuotes=8]="autoClosingQuotes",X[X.autoIndent=9]="autoIndent",X[X.automaticLayout=10]="automaticLayout",X[X.autoSurround=11]="autoSurround",X[X.bracketPairColorization=12]="bracketPairColorization",X[X.guides=13]="guides",X[X.codeLens=14]="codeLens",X[X.codeLensFontFamily=15]="codeLensFontFamily",X[X.codeLensFontSize=16]="codeLensFontSize",X[X.colorDecorators=17]="colorDecorators",X[X.columnSelection=18]="columnSelection",X[X.comments=19]="comments",X[X.contextmenu=20]="contextmenu",X[X.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",X[X.cursorBlinking=22]="cursorBlinking",X[X.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",X[X.cursorStyle=24]="cursorStyle",X[X.cursorSurroundingLines=25]="cursorSurroundingLines",X[X.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",X[X.cursorWidth=27]="cursorWidth",X[X.disableLayerHinting=28]="disableLayerHinting",X[X.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",X[X.domReadOnly=30]="domReadOnly",X[X.dragAndDrop=31]="dragAndDrop",X[X.emptySelectionClipboard=32]="emptySelectionClipboard",X[X.extraEditorClassName=33]="extraEditorClassName",X[X.fastScrollSensitivity=34]="fastScrollSensitivity",X[X.find=35]="find",X[X.fixedOverflowWidgets=36]="fixedOverflowWidgets",X[X.folding=37]="folding",X[X.foldingStrategy=38]="foldingStrategy",X[X.foldingHighlight=39]="foldingHighlight",X[X.foldingImportsByDefault=40]="foldingImportsByDefault",X[X.foldingMaximumRegions=41]="foldingMaximumRegions",X[X.unfoldOnClickAfterEndOfLine=42]="unfoldOnClickAfterEndOfLine",X[X.fontFamily=43]="fontFamily",X[X.fontInfo=44]="fontInfo",X[X.fontLigatures=45]="fontLigatures",X[X.fontSize=46]="fontSize",X[X.fontWeight=47]="fontWeight",X[X.formatOnPaste=48]="formatOnPaste",X[X.formatOnType=49]="formatOnType",X[X.glyphMargin=50]="glyphMargin",X[X.gotoLocation=51]="gotoLocation",X[X.hideCursorInOverviewRuler=52]="hideCursorInOverviewRuler",X[X.hover=53]="hover",X[X.inDiffEditor=54]="inDiffEditor",X[X.inlineSuggest=55]="inlineSuggest",X[X.letterSpacing=56]="letterSpacing",X[X.lightbulb=57]="lightbulb",X[X.lineDecorationsWidth=58]="lineDecorationsWidth",X[X.lineHeight=59]="lineHeight",X[X.lineNumbers=60]="lineNumbers",X[X.lineNumbersMinChars=61]="lineNumbersMinChars",X[X.linkedEditing=62]="linkedEditing",X[X.links=63]="links",X[X.matchBrackets=64]="matchBrackets",X[X.minimap=65]="minimap",X[X.mouseStyle=66]="mouseStyle",X[X.mouseWheelScrollSensitivity=67]="mouseWheelScrollSensitivity",X[X.mouseWheelZoom=68]="mouseWheelZoom",X[X.multiCursorMergeOverlapping=69]="multiCursorMergeOverlapping",X[X.multiCursorModifier=70]="multiCursorModifier",X[X.multiCursorPaste=71]="multiCursorPaste",X[X.occurrencesHighlight=72]="occurrencesHighlight",X[X.overviewRulerBorder=73]="overviewRulerBorder",X[X.overviewRulerLanes=74]="overviewRulerLanes",X[X.padding=75]="padding",X[X.parameterHints=76]="parameterHints",X[X.peekWidgetDefaultFocus=77]="peekWidgetDefaultFocus",X[X.definitionLinkOpensInPeek=78]="definitionLinkOpensInPeek",X[X.quickSuggestions=79]="quickSuggestions",X[X.quickSuggestionsDelay=80]="quickSuggestionsDelay",X[X.readOnly=81]="readOnly",X[X.renameOnType=82]="renameOnType",X[X.renderControlCharacters=83]="renderControlCharacters",X[X.renderFinalNewline=84]="renderFinalNewline",X[X.renderLineHighlight=85]="renderLineHighlight",X[X.renderLineHighlightOnlyWhenFocus=86]="renderLineHighlightOnlyWhenFocus",X[X.renderValidationDecorations=87]="renderValidationDecorations",X[X.renderWhitespace=88]="renderWhitespace",X[X.revealHorizontalRightPadding=89]="revealHorizontalRightPadding",X[X.roundedSelection=90]="roundedSelection",X[X.rulers=91]="rulers",X[X.scrollbar=92]="scrollbar",X[X.scrollBeyondLastColumn=93]="scrollBeyondLastColumn",X[X.scrollBeyondLastLine=94]="scrollBeyondLastLine",X[X.scrollPredominantAxis=95]="scrollPredominantAxis",X[X.selectionClipboard=96]="selectionClipboard",X[X.selectionHighlight=97]="selectionHighlight",X[X.selectOnLineNumbers=98]="selectOnLineNumbers",X[X.showFoldingControls=99]="showFoldingControls",X[X.showUnused=100]="showUnused",X[X.snippetSuggestions=101]="snippetSuggestions",X[X.smartSelect=102]="smartSelect",X[X.smoothScrolling=103]="smoothScrolling",X[X.stickyTabStops=104]="stickyTabStops",X[X.stopRenderingLineAfter=105]="stopRenderingLineAfter",X[X.suggest=106]="suggest",X[X.suggestFontSize=107]="suggestFontSize",X[X.suggestLineHeight=108]="suggestLineHeight",X[X.suggestOnTriggerCharacters=109]="suggestOnTriggerCharacters",X[X.suggestSelection=110]="suggestSelection",X[X.tabCompletion=111]="tabCompletion",X[X.tabIndex=112]="tabIndex",X[X.unicodeHighlighting=113]="unicodeHighlighting",X[X.unusualLineTerminators=114]="unusualLineTerminators",X[X.useShadowDOM=115]="useShadowDOM",X[X.useTabStops=116]="useTabStops",X[X.wordSeparators=117]="wordSeparators",X[X.wordWrap=118]="wordWrap",X[X.wordWrapBreakAfterCharacters=119]="wordWrapBreakAfterCharacters",X[X.wordWrapBreakBeforeCharacters=120]="wordWrapBreakBeforeCharacters",X[X.wordWrapColumn=121]="wordWrapColumn",X[X.wordWrapOverride1=122]="wordWrapOverride1",X[X.wordWrapOverride2=123]="wordWrapOverride2",X[X.wrappingIndent=124]="wrappingIndent",X[X.wrappingStrategy=125]="wrappingStrategy",X[X.showDeprecated=126]="showDeprecated",X[X.inlayHints=127]="inlayHints",X[X.editorClassName=128]="editorClassName",X[X.pixelRatio=129]="pixelRatio",X[X.tabFocusMode=130]="tabFocusMode",X[X.layoutInfo=131]="layoutInfo",X[X.wrappingInfo=132]="wrappingInfo"})(it=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Te(new S(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:s.localize(148,null)})),acceptSuggestionOnEnter:Te(new T(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",s.localize(149,null),""],markdownDescription:s.localize(150,null)})),accessibilitySupport:Te(new c),accessibilityPageSize:Te(new d(3,"accessibilityPageSize",10,1,1073741824,{description:s.localize(151,null)})),ariaLabel:Te(new w(4,"ariaLabel",s.localize(152,null))),autoClosingBrackets:Te(new T(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",s.localize(153,null),s.localize(154,null),""],description:s.localize(155,null)})),autoClosingDelete:Te(new T(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",s.localize(156,null),""],description:s.localize(157,null)})),autoClosingOvertype:Te(new T(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",s.localize(158,null),""],description:s.localize(159,null)})),autoClosingQuotes:Te(new T(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",s.localize(160,null),s.localize(161,null),""],description:s.localize(162,null)})),autoIndent:Te(new r(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],i,{enumDescriptions:[s.localize(163,null),s.localize(164,null),s.localize(165,null),s.localize(166,null),s.localize(167,null)],description:s.localize(168,null)})),automaticLayout:Te(new S(10,"automaticLayout",!1)),autoSurround:Te(new T(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[s.localize(169,null),s.localize(170,null),s.localize(171,null),""],description:s.localize(172,null)})),bracketPairColorization:Te(new x),bracketPairGuides:Te(new Q),stickyTabStops:Te(new S(104,"stickyTabStops",!1,{description:s.localize(173,null)})),codeLens:Te(new S(14,"codeLens",!0,{description:s.localize(174,null)})),codeLensFontFamily:Te(new w(15,"codeLensFontFamily","",{description:s.localize(175,null)})),codeLensFontSize:Te(new d(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:s.localize(176,null)})),colorDecorators:Te(new S(17,"colorDecorators",!0,{description:s.localize(177,null)})),columnSelection:Te(new S(18,"columnSelection",!1,{description:s.localize(178,null)})),comments:Te(new t),contextmenu:Te(new S(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Te(new S(21,"copyWithSyntaxHighlighting",!0,{description:s.localize(179,null)})),cursorBlinking:Te(new r(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],g,{description:s.localize(180,null)})),cursorSmoothCaretAnimation:Te(new S(23,"cursorSmoothCaretAnimation",!1,{description:s.localize(181,null)})),cursorStyle:Te(new r(24,"cursorStyle",h.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],P,{description:s.localize(182,null)})),cursorSurroundingLines:Te(new d(25,"cursorSurroundingLines",0,0,1073741824,{description:s.localize(183,null)})),cursorSurroundingLinesStyle:Te(new T(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[s.localize(184,null),s.localize(185,null)],description:s.localize(186,null)})),cursorWidth:Te(new d(27,"cursorWidth",0,0,1073741824,{markdownDescription:s.localize(187,null)})),disableLayerHinting:Te(new S(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Te(new S(29,"disableMonospaceOptimizations",!1)),domReadOnly:Te(new S(30,"domReadOnly",!1)),dragAndDrop:Te(new S(31,"dragAndDrop",!0,{description:s.localize(188,null)})),emptySelectionClipboard:Te(new W),extraEditorClassName:Te(new w(33,"extraEditorClassName","")),fastScrollSensitivity:Te(new p(34,"fastScrollSensitivity",5,X=>X<=0?5:X,{markdownDescription:s.localize(189,null)})),find:Te(new E),fixedOverflowWidgets:Te(new S(36,"fixedOverflowWidgets",!1)),folding:Te(new S(37,"folding",!0,{description:s.localize(190,null)})),foldingStrategy:Te(new T(38,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[s.localize(191,null),s.localize(192,null)],description:s.localize(193,null)})),foldingHighlight:Te(new S(39,"foldingHighlight",!0,{description:s.localize(194,null)})),foldingImportsByDefault:Te(new S(40,"foldingImportsByDefault",!1,{description:s.localize(195,null)})),foldingMaximumRegions:Te(new d(41,"foldingMaximumRegions",5e3,10,65e3,{description:s.localize(196,null)})),unfoldOnClickAfterEndOfLine:Te(new S(42,"unfoldOnClickAfterEndOfLine",!1,{description:s.localize(197,null)})),fontFamily:Te(new w(43,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:s.localize(198,null)})),fontInfo:Te(new z),fontLigatures2:Te(new H),fontSize:Te(new q),fontWeight:Te(new G),formatOnPaste:Te(new S(48,"formatOnPaste",!1,{description:s.localize(199,null)})),formatOnType:Te(new S(49,"formatOnType",!1,{description:s.localize(200,null)})),glyphMargin:Te(new S(50,"glyphMargin",!0,{description:s.localize(201,null)})),gotoLocation:Te(new j),hideCursorInOverviewRuler:Te(new S(52,"hideCursorInOverviewRuler",!1,{description:s.localize(202,null)})),hover:Te(new $),inDiffEditor:Te(new S(54,"inDiffEditor",!1)),letterSpacing:Te(new p(56,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,X=>p.clamp(X,-5,20),{description:s.localize(203,null)})),lightbulb:Te(new Z),lineDecorationsWidth:Te(new n(58,"lineDecorationsWidth",10)),lineHeight:Te(new ue),lineNumbers:Te(new Xe),lineNumbersMinChars:Te(new d(61,"lineNumbersMinChars",5,1,300)),linkedEditing:Te(new S(62,"linkedEditing",!1,{description:s.localize(204,null)})),links:Te(new S(63,"links",!0,{description:s.localize(205,null)})),matchBrackets:Te(new T(64,"matchBrackets","always",["always","near","never"],{description:s.localize(206,null)})),minimap:Te(new Se),mouseStyle:Te(new T(66,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Te(new p(67,"mouseWheelScrollSensitivity",1,X=>X===0?1:X,{markdownDescription:s.localize(207,null)})),mouseWheelZoom:Te(new S(68,"mouseWheelZoom",!1,{markdownDescription:s.localize(208,null)})),multiCursorMergeOverlapping:Te(new S(69,"multiCursorMergeOverlapping",!0,{description:s.localize(209,null)})),multiCursorModifier:Te(new r(70,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],fe,{markdownEnumDescriptions:[s.localize(210,null),s.localize(211,null)],markdownDescription:s.localize(212,null)})),multiCursorPaste:Te(new T(71,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[s.localize(213,null),s.localize(214,null)],markdownDescription:s.localize(215,null)})),occurrencesHighlight:Te(new S(72,"occurrencesHighlight",!0,{description:s.localize(216,null)})),overviewRulerBorder:Te(new S(73,"overviewRulerBorder",!0,{description:s.localize(217,null)})),overviewRulerLanes:Te(new d(74,"overviewRulerLanes",3,0,3)),padding:Te(new ne),parameterHints:Te(new me),peekWidgetDefaultFocus:Te(new T(77,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[s.localize(218,null),s.localize(219,null)],description:s.localize(220,null)})),definitionLinkOpensInPeek:Te(new S(78,"definitionLinkOpensInPeek",!1,{description:s.localize(221,null)})),quickSuggestions:Te(new Ae),quickSuggestionsDelay:Te(new d(80,"quickSuggestionsDelay",10,0,1073741824,{description:s.localize(222,null)})),readOnly:Te(new S(81,"readOnly",!1)),renameOnType:Te(new S(82,"renameOnType",!1,{description:s.localize(223,null),markdownDeprecationMessage:s.localize(224,null)})),renderControlCharacters:Te(new S(83,"renderControlCharacters",!0,{description:s.localize(225,null),restricted:!0})),renderFinalNewline:Te(new S(84,"renderFinalNewline",!0,{description:s.localize(226,null)})),renderLineHighlight:Te(new T(85,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",s.localize(227,null)],description:s.localize(228,null)})),renderLineHighlightOnlyWhenFocus:Te(new S(86,"renderLineHighlightOnlyWhenFocus",!1,{description:s.localize(229,null)})),renderValidationDecorations:Te(new T(87,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Te(new T(88,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",s.localize(230,null),s.localize(231,null),s.localize(232,null),""],description:s.localize(233,null)})),revealHorizontalRightPadding:Te(new d(89,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Te(new S(90,"roundedSelection",!0,{description:s.localize(234,null)})),rulers:Te(new de),scrollbar:Te(new F),scrollBeyondLastColumn:Te(new d(93,"scrollBeyondLastColumn",5,0,1073741824,{description:s.localize(235,null)})),scrollBeyondLastLine:Te(new S(94,"scrollBeyondLastLine",!0,{description:s.localize(236,null)})),scrollPredominantAxis:Te(new S(95,"scrollPredominantAxis",!0,{description:s.localize(237,null)})),selectionClipboard:Te(new S(96,"selectionClipboard",!0,{description:s.localize(238,null),included:I.isLinux})),selectionHighlight:Te(new S(97,"selectionHighlight",!0,{description:s.localize(239,null)})),selectOnLineNumbers:Te(new S(98,"selectOnLineNumbers",!0)),showFoldingControls:Te(new T(99,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[s.localize(240,null),s.localize(241,null)],description:s.localize(242,null)})),showUnused:Te(new S(100,"showUnused",!0,{description:s.localize(243,null)})),showDeprecated:Te(new S(126,"showDeprecated",!0,{description:s.localize(244,null)})),inlayHints:Te(new le),snippetSuggestions:Te(new T(101,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[s.localize(245,null),s.localize(246,null),s.localize(247,null),s.localize(248,null)],description:s.localize(249,null)})),smartSelect:Te(new Ie),smoothScrolling:Te(new S(103,"smoothScrolling",!1,{description:s.localize(250,null)})),stopRenderingLineAfter:Te(new d(105,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Te(new ve),inlineSuggest:Te(new O),suggestFontSize:Te(new d(107,"suggestFontSize",0,0,1e3,{markdownDescription:s.localize(251,null)})),suggestLineHeight:Te(new d(108,"suggestLineHeight",0,0,1e3,{markdownDescription:s.localize(252,null)})),suggestOnTriggerCharacters:Te(new S(109,"suggestOnTriggerCharacters",!0,{description:s.localize(253,null)})),suggestSelection:Te(new T(110,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[s.localize(254,null),s.localize(255,null),s.localize(256,null)],description:s.localize(257,null)})),tabCompletion:Te(new T(111,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[s.localize(258,null),s.localize(259,null),s.localize(260,null)],description:s.localize(261,null)})),tabIndex:Te(new d(112,"tabIndex",0,-1,1073741824)),unicodeHighlight:Te(new C),unusualLineTerminators:Te(new T(114,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[s.localize(262,null),s.localize(263,null),s.localize(264,null)],description:s.localize(265,null)})),useShadowDOM:Te(new S(115,"useShadowDOM",!0)),useTabStops:Te(new S(116,"useTabStops",!0,{description:s.localize(266,null)})),wordSeparators:Te(new w(117,"wordSeparators",b.USUAL_WORD_SEPARATORS,{description:s.localize(267,null)})),wordWrap:Te(new T(118,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[s.localize(268,null),s.localize(269,null),s.localize(270,null),s.localize(271,null)],description:s.localize(272,null)})),wordWrapBreakAfterCharacters:Te(new w(119,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Te(new w(120,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Te(new d(121,"wordWrapColumn",80,1,1073741824,{markdownDescription:s.localize(273,null)})),wordWrapOverride1:Te(new T(122,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Te(new T(123,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Te(new r(124,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],ze,{enumDescriptions:[s.localize(274,null),s.localize(275,null),s.localize(276,null),s.localize(277,null)],description:s.localize(278,null)})),wrappingStrategy:Te(new T(125,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[s.localize(279,null),s.localize(280,null)],description:s.localize(281,null)})),editorClassName:Te(new R),pixelRatio:Te(new ke),tabFocusMode:Te(new Me),layoutInfo:Te(new se),wrappingInfo:Te(new xe)}}),define(Ee[117],we([18,19]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ee[118],we([18,19]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ee[119],we([18,19]),function(J,e){return J.create("vs/platform/files/common/files",e)}),define(Ee[120],we([18,19]),function(J,e){return J.create("vs/platform/markers/common/markers",e)}),define(Ee[121],we([18,19]),function(J,e){return J.create("vs/platform/workspace/common/workspace",e)}),define(Ee[122],we([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ee[123],we([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ee[124],we([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostProgress",e)}),define(Ee[125],we([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ee[126],we([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ee[127],we([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ee[128],we([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ee[129],we([18,19]),function(J,e){return J.create("vs/workbench/common/editor",e)}),define(Ee[130],we([18,19]),function(J,e){return J.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ee[131],we([18,19]),function(J,e){return J.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ee[132],we([18,19]),function(J,e){return J.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(Ee[133],we([18,19]),function(J,e){return J.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ee[134],we([18,19]),function(J,e){return J.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ee[135],we([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionSource=e.TextEditorSelectionRevealType=e.EditorOpenSource=e.EditorResolution=e.EditorActivation=void 0;var s;(function(A){A[A.ACTIVATE=1]="ACTIVATE",A[A.RESTORE=2]="RESTORE",A[A.PRESERVE=3]="PRESERVE"})(s=e.EditorActivation||(e.EditorActivation={}));var I;(function(A){A[A.PICK=0]="PICK",A[A.DISABLED=1]="DISABLED",A[A.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(I=e.EditorResolution||(e.EditorResolution={}));var b;(function(A){A[A.API=0]="API",A[A.USER=1]="USER"})(b=e.EditorOpenSource||(e.EditorOpenSource={}));var B;(function(A){A[A.Center=0]="Center",A[A.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",A[A.NearTop=2]="NearTop",A[A.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(B=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}));var D;(function(A){A.PROGRAMMATIC="api",A.NAVIGATION="code.navigation",A.JUMP="code.jump"})(D=e.TextEditorSelectionSource||(e.TextEditorSelectionSource={}))}),define(Ee[136],we([1,0,118]),function(J,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const I=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function B(u){return u=u.trim(),u==="*"||I.test(u)}e.isValidVersionStr=B;function D(u){if(!B(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let m=u.match(I);return m?{hasCaret:m[1]==="^",hasGreaterEquals:m[1]===">=",majorBase:m[2]==="x"?0:parseInt(m[2],10),majorMustEqual:m[2]!=="x",minorBase:m[4]==="x"?0:parseInt(m[4],10),minorMustEqual:m[4]!=="x",patchBase:m[6]==="x"?0:parseInt(m[6],10),patchMustEqual:m[6]!=="x",preRelease:m[8]||null}:null}e.parseVersion=D;function A(u){if(!u)return null;let m=u.majorBase,l=u.majorMustEqual,n=u.minorBase,f=u.minorMustEqual,S=u.patchBase,k=u.patchMustEqual;u.hasCaret&&(m===0||(f=!1),k=!1);let d=0;if(u.preRelease){const p=b.exec(u.preRelease);if(p){const[,w,a,T]=p;d=Date.UTC(Number(w),Number(a)-1,Number(T))}}return{majorBase:m,majorMustEqual:l,minorBase:n,minorMustEqual:f,patchBase:S,patchMustEqual:k,isMinimum:u.hasGreaterEquals,notBefore:d}}e.normalizeVersion=A;function y(u,m,l){let n;typeof u=="string"?n=A(D(u)):n=u;let f;m instanceof Date?f=m.getTime():typeof m=="string"&&(f=new Date(m).getTime());let S;if(typeof l=="string"?S=A(D(l)):S=l,!n||!S)return!1;let k=n.majorBase,d=n.minorBase,p=n.patchBase,w=S.majorBase,a=S.minorBase,T=S.patchBase,r=S.notBefore,i=S.majorMustEqual,c=S.minorMustEqual,t=S.patchMustEqual;return S.isMinimum?k>w?!0:k<w?!1:d>a?!0:d<a||f&&f<r?!1:p>=T:(k===1&&w===0&&(!i||!c||!t)&&(w=1,a=0,T=0,i=!0,c=!1,t=!1),k<w?!1:k>w?!i:d<a?!1:d>a?!c:p<T?!1:p>T?!t:!(f&&f<r))}e.isValidVersion=y;function M(u,m,l,n){return l.isBuiltin||typeof l.main=="undefined"?!0:v(u,m,l.engines.vscode,n)}e.isValidExtensionVersion=M;function L(u,m,l){return u==="*"||v(m,l,u)}e.isEngineValid=L;function v(u,m,l,n=[]){let f=A(D(l));if(!f)return n.push(s.localize(0,null,l)),!1;if(f.majorBase===0){if(!f.majorMustEqual||!f.minorMustEqual)return n.push(s.localize(1,null,l)),!1}else if(!f.majorMustEqual)return n.push(s.localize(2,null,l)),!1;return y(u,m,f)?!0:(n.push(s.localize(3,null,u,l)),!1)}}),define(Ee[76],we([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class s{constructor(b,B=[],D=!1){this.ctor=b,this.staticArguments=B,this.supportsDelayedInstantiation=D}}e.SyncDescriptor=s}),define(Ee[55],we([1,0,76]),function(J,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const I=[];function b(D,A,y){A instanceof s.SyncDescriptor||(A=new s.SyncDescriptor(A,[],y)),I.push([D,A])}e.registerSingleton=b;function B(){return I}e.getSingletonServiceDescriptors=B}),define(Ee[137],we([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class s{constructor(B){this.incoming=new Map,this.outgoing=new Map,this.data=B}}e.Node=s;class I{constructor(B){this._hashFn=B,this._nodes=new Map}roots(){const B=[];for(let D of this._nodes.values())D.outgoing.size===0&&B.push(D);return B}insertEdge(B,D){const A=this.lookupOrInsertNode(B),y=this.lookupOrInsertNode(D);A.outgoing.set(this._hashFn(D),y),y.incoming.set(this._hashFn(B),A)}removeNode(B){const D=this._hashFn(B);this._nodes.delete(D);for(let A of this._nodes.values())A.outgoing.delete(D),A.incoming.delete(D)}lookupOrInsertNode(B){const D=this._hashFn(B);let A=this._nodes.get(D);return A||(A=new s(B),this._nodes.set(D,A)),A}lookup(B){return this._nodes.get(this._hashFn(B))}isEmpty(){return this._nodes.size===0}toString(){let B=[];for(let[D,A]of this._nodes)B.push(`${D}, (incoming)[${[...A.incoming.keys()].join(", ")}], (outgoing)[${[...A.outgoing.keys()].join(",")}]`);return B.join(`
`)}findCycleSlow(){for(let[B,D]of this._nodes){const A=new Set([B]),y=this._findCycle(D,A);if(y)return y}}_findCycle(B,D){for(let[A,y]of B.outgoing){if(D.has(A))return[...D,A].join(" -> ");D.add(A);const M=this._findCycle(y,D);if(M)return M;D.delete(A)}}}e.Graph=I}),define(Ee[3],we([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var s;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function A(y){return y[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=A})(s=e._util||(e._util={})),e.IInstantiationService=b("instantiationService");function I(D,A,y){A[s.DI_TARGET]===A?A[s.DI_DEPENDENCIES].push({id:D,index:y}):(A[s.DI_DEPENDENCIES]=[{id:D,index:y}],A[s.DI_TARGET]=A)}function b(D){if(s.serviceIds.has(D))return s.serviceIds.get(D);const A=function(y,M,L){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");I(A,y,L)};return A.toString=()=>D,s.serviceIds.set(D,A),A}e.createDecorator=b;function B(D){return D}e.refineServiceDecorator=B}),define(Ee[77],we([1,0,11,2,3]),function(J,e,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,b.createDecorator)("configurationService");function B(f){return f&&typeof f=="object"&&(!f.overrideIdentifier||typeof f.overrideIdentifier=="string")&&(!f.resource||f.resource instanceof I.URI)}e.isConfigurationOverrides=B;function D(f){return f&&typeof f=="object"&&(!f.overrideIdentifiers||s.isArray(f.overrideIdentifiers))&&!f.overrideIdentifier&&(!f.resource||f.resource instanceof I.URI)}e.isConfigurationUpdateOverrides=D;var A;(function(f){f[f.USER=1]="USER",f[f.USER_LOCAL=2]="USER_LOCAL",f[f.USER_REMOTE=3]="USER_REMOTE",f[f.WORKSPACE=4]="WORKSPACE",f[f.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",f[f.DEFAULT=6]="DEFAULT",f[f.MEMORY=7]="MEMORY"})(A=e.ConfigurationTarget||(e.ConfigurationTarget={}));function y(f){switch(f){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=y;function M(f,S){const k=Object.create(null);for(let d in f)L(k,d,f[d],S);return k}e.toValuesTree=M;function L(f,S,k,d){const p=S.split("."),w=p.pop();let a=f;for(let T=0;T<p.length;T++){let r=p[T],i=a[r];switch(typeof i){case"undefined":i=a[r]=Object.create(null);break;case"object":break;default:d(`Ignoring ${S} as ${p.slice(0,T+1).join(".")} is ${JSON.stringify(i)}`);return}a=i}if(typeof a=="object"&&a!==null)try{a[w]=k}catch{d(`Ignoring ${S} as ${p.join(".")} is ${JSON.stringify(a)}`)}else d(`Ignoring ${S} as ${p.join(".")} is ${JSON.stringify(a)}`)}e.addToValueTree=L;function v(f,S){const k=S.split(".");u(f,k)}e.removeFromValueTree=v;function u(f,S){const k=S.shift();if(S.length===0){delete f[k];return}if(Object.keys(f).indexOf(k)!==-1){const d=f[k];typeof d=="object"&&!Array.isArray(d)&&(u(d,S),Object.keys(d).length===0&&delete f[k])}}function m(f,S,k){function d(a,T){let r=a;for(const i of T){if(typeof r!="object"||r===null)return;r=r[i]}return r}const p=S.split("."),w=d(f,p);return typeof w=="undefined"?k:w}e.getConfigurationValue=m;function l(f,S,k){Object.keys(S).forEach(d=>{d!=="__proto__"&&(d in f?s.isObject(f[d])&&s.isObject(S[d])?l(f[d],S[d],k):k&&(f[d]=S[d]):f[d]=S[d])})}e.merge=l;function n(f,S,k){const d=f.inspect(S),p=f.inspect(k);return typeof d.userValue!="undefined"||typeof d.workspaceValue!="undefined"||typeof d.workspaceFolderValue!="undefined"?d.value:typeof p.userValue!="undefined"||typeof p.workspaceValue!="undefined"||typeof p.workspaceFolderValue!="undefined"?p.value:d.defaultValue}e.getMigratedSettingValue=n}),define(Ee[44],we([1,0,23,9,3]),function(J,e,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const B=new Map;B.set("false",!1),B.set("true",!0),B.set("isMac",s.isMacintosh),B.set("isLinux",s.isLinux),B.set("isWindows",s.isWindows),B.set("isWeb",s.isWeb),B.set("isMacNative",s.isMacintosh&&!s.isWeb),B.set("isEdge",s.isEdge),B.set("isFirefox",s.isFirefox),B.set("isChrome",s.isChrome),B.set("isSafari",s.isSafari);const D=Object.prototype.hasOwnProperty;var A;(function(W){W[W.False=0]="False",W[W.True=1]="True",W[W.Defined=2]="Defined",W[W.Not=3]="Not",W[W.Equals=4]="Equals",W[W.NotEquals=5]="NotEquals",W[W.And=6]="And",W[W.Regex=7]="Regex",W[W.NotRegex=8]="NotRegex",W[W.Or=9]="Or",W[W.In=10]="In",W[W.NotIn=11]="NotIn",W[W.Greater=12]="Greater",W[W.GreaterEquals=13]="GreaterEquals",W[W.Smaller=14]="Smaller",W[W.SmallerEquals=15]="SmallerEquals"})(A=e.ContextKeyExprType||(e.ContextKeyExprType={}));class y{static false(){return v.INSTANCE}static true(){return u.INSTANCE}static has(E){return m.create(E)}static equals(E,H){return l.create(E,H)}static notEquals(E,H){return S.create(E,H)}static regex(E,H){return r.create(E,H)}static in(E,H){return n.create(E,H)}static not(E){return k.create(E)}static and(...E){return t.create(E,null)}static or(...E){return o.create(E,null,!0)}static greater(E,H){return p.create(E,H)}static greaterEquals(E,H){return w.create(E,H)}static smaller(E,H){return a.create(E,H)}static smallerEquals(E,H){return T.create(E,H)}static deserialize(E,H=!1){if(!!E)return this._deserializeOrExpression(E,H)}static _deserializeOrExpression(E,H){let z=E.split("||");return o.create(z.map(q=>this._deserializeAndExpression(q,H)),null,!0)}static _deserializeAndExpression(E,H){let z=E.split("&&");return t.create(z.map(q=>this._deserializeOne(q,H)),null)}static _deserializeOne(E,H){if(E=E.trim(),E.indexOf("!=")>=0){let z=E.split("!=");return S.create(z[0].trim(),this._deserializeValue(z[1],H))}if(E.indexOf("==")>=0){let z=E.split("==");return l.create(z[0].trim(),this._deserializeValue(z[1],H))}if(E.indexOf("=~")>=0){let z=E.split("=~");return r.create(z[0].trim(),this._deserializeRegexValue(z[1],H))}if(E.indexOf(" in ")>=0){let z=E.split(" in ");return n.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(E)){const z=E.split(">=");return w.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(E)){const z=E.split(">");return p.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(E)){const z=E.split("<=");return T.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(E)){const z=E.split("<");return a.create(z[0].trim(),z[1].trim())}return/^\!\s*/.test(E)?k.create(E.substr(1).trim()):m.create(E)}static _deserializeValue(E,H){if(E=E.trim(),E==="true")return!0;if(E==="false")return!1;let z=/^'([^']*)'$/.exec(E);return z?z[1].trim():E}static _deserializeRegexValue(E,H){if((0,I.isFalsyOrWhitespace)(E)){if(H)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let z=E.indexOf("/"),q=E.lastIndexOf("/");if(z===q||z<0){if(H)throw new Error(`bad regexp-value '${E}', missing /-enclosure`);return console.warn(`bad regexp-value '${E}', missing /-enclosure`),null}let G=E.slice(z+1,q),j=E[q+1]==="i"?"i":"";try{return new RegExp(G,j)}catch($){if(H)throw new Error(`bad regexp-value '${E}', parse error: ${$}`);return console.warn(`bad regexp-value '${E}', parse error: ${$}`),null}}}e.ContextKeyExpr=y;function M(W,E){const H=W?W.substituteConstants():void 0,z=E?E.substituteConstants():void 0;return!H&&!z?!0:!H||!z?!1:H.equals(z)}e.expressionsAreEqualWithConstantSubstitution=M;function L(W,E){return W.cmp(E)}class v{constructor(){this.type=0}cmp(E){return this.type-E.type}equals(E){return E.type===this.type}substituteConstants(){return this}evaluate(E){return!1}serialize(){return"false"}keys(){return[]}map(E){return this}negate(){return u.INSTANCE}}e.ContextKeyFalseExpr=v,v.INSTANCE=new v;class u{constructor(){this.type=1}cmp(E){return this.type-E.type}equals(E){return E.type===this.type}substituteConstants(){return this}evaluate(E){return!0}serialize(){return"true"}keys(){return[]}map(E){return this}negate(){return v.INSTANCE}}e.ContextKeyTrueExpr=u,u.INSTANCE=new u;class m{constructor(E,H){this.key=E,this.negated=H,this.type=2}static create(E,H=null){const z=B.get(E);return typeof z=="boolean"?z?u.INSTANCE:v.INSTANCE:new m(E,H)}cmp(E){return E.type!==this.type?this.type-E.type:h(this.key,E.key)}equals(E){return E.type===this.type?this.key===E.key:!1}substituteConstants(){const E=B.get(this.key);return typeof E=="boolean"?E?u.INSTANCE:v.INSTANCE:this}evaluate(E){return!!E.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(E){return E.mapDefined(this.key)}negate(){return this.negated||(this.negated=k.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=m;class l{constructor(E,H,z){this.key=E,this.value=H,this.negated=z,this.type=4}static create(E,H,z=null){if(typeof H=="boolean")return H?m.create(E,z):k.create(E,z);const q=B.get(E);return typeof q=="boolean"?H===(q?"true":"false")?u.INSTANCE:v.INSTANCE:new l(E,H,z)}cmp(E){return E.type!==this.type?this.type-E.type:_(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}substituteConstants(){const E=B.get(this.key);if(typeof E=="boolean"){const H=E?"true":"false";return this.value===H?u.INSTANCE:v.INSTANCE}return this}evaluate(E){return E.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(E){return E.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=S.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=l;class n{constructor(E,H){this.key=E,this.valueKey=H,this.type=10,this.negated=null}static create(E,H){return new n(E,H)}cmp(E){return E.type!==this.type?this.type-E.type:_(this.key,this.valueKey,E.key,E.valueKey)}equals(E){return E.type===this.type?this.key===E.key&&this.valueKey===E.valueKey:!1}substituteConstants(){return this}evaluate(E){const H=E.getValue(this.valueKey),z=E.getValue(this.key);return Array.isArray(H)?H.indexOf(z)>=0:typeof z=="string"&&typeof H=="object"&&H!==null?D.call(H,z):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(E){return E.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=f.create(this)),this.negated}}e.ContextKeyInExpr=n;class f{constructor(E){this._actual=E,this.type=11}static create(E){return new f(E)}cmp(E){return E.type!==this.type?this.type-E.type:this._actual.cmp(E._actual)}equals(E){return E.type===this.type?this._actual.equals(E._actual):!1}substituteConstants(){return this}evaluate(E){return!this._actual.evaluate(E)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(E){return new f(this._actual.map(E))}negate(){return this._actual}}e.ContextKeyNotInExpr=f;class S{constructor(E,H,z){this.key=E,this.value=H,this.negated=z,this.type=5}static create(E,H,z=null){if(typeof H=="boolean")return H?k.create(E,z):m.create(E,z);const q=B.get(E);return typeof q=="boolean"?H===(q?"true":"false")?v.INSTANCE:u.INSTANCE:new S(E,H,z)}cmp(E){return E.type!==this.type?this.type-E.type:_(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}substituteConstants(){const E=B.get(this.key);if(typeof E=="boolean"){const H=E?"true":"false";return this.value===H?v.INSTANCE:u.INSTANCE}return this}evaluate(E){return E.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(E){return E.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=S;class k{constructor(E,H){this.key=E,this.negated=H,this.type=3}static create(E,H=null){const z=B.get(E);return typeof z=="boolean"?z?v.INSTANCE:u.INSTANCE:new k(E,H)}cmp(E){return E.type!==this.type?this.type-E.type:h(this.key,E.key)}equals(E){return E.type===this.type?this.key===E.key:!1}substituteConstants(){const E=B.get(this.key);return typeof E=="boolean"?E?v.INSTANCE:u.INSTANCE:this}evaluate(E){return!E.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(E){return E.mapNot(this.key)}negate(){return this.negated||(this.negated=m.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=k;function d(W,E){if(typeof W=="string"){const H=parseFloat(W);isNaN(H)||(W=H)}return typeof W=="string"||typeof W=="number"?E(W):v.INSTANCE}class p{constructor(E,H,z){this.key=E,this.value=H,this.negated=z,this.type=12}static create(E,H,z=null){return d(H,q=>new p(E,q,z))}cmp(E){return E.type!==this.type?this.type-E.type:_(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}substituteConstants(){return this}evaluate(E){return typeof this.value=="string"?!1:parseFloat(E.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(E){return E.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=T.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=p;class w{constructor(E,H,z){this.key=E,this.value=H,this.negated=z,this.type=13}static create(E,H,z=null){return d(H,q=>new w(E,q,z))}cmp(E){return E.type!==this.type?this.type-E.type:_(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}substituteConstants(){return this}evaluate(E){return typeof this.value=="string"?!1:parseFloat(E.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(E){return E.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=a.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=w;class a{constructor(E,H,z){this.key=E,this.value=H,this.negated=z,this.type=14}static create(E,H,z=null){return d(H,q=>new a(E,q,z))}cmp(E){return E.type!==this.type?this.type-E.type:_(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}substituteConstants(){return this}evaluate(E){return typeof this.value=="string"?!1:parseFloat(E.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(E){return E.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=w.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=a;class T{constructor(E,H,z){this.key=E,this.value=H,this.negated=z,this.type=15}static create(E,H,z=null){return d(H,q=>new T(E,q,z))}cmp(E){return E.type!==this.type?this.type-E.type:_(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}substituteConstants(){return this}evaluate(E){return typeof this.value=="string"?!1:parseFloat(E.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(E){return E.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=p.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=T;class r{constructor(E,H){this.key=E,this.regexp=H,this.type=7,this.negated=null}static create(E,H){return new r(E,H)}cmp(E){if(E.type!==this.type)return this.type-E.type;if(this.key<E.key)return-1;if(this.key>E.key)return 1;const H=this.regexp?this.regexp.source:"",z=E.regexp?E.regexp.source:"";return H<z?-1:H>z?1:0}equals(E){if(E.type===this.type){const H=this.regexp?this.regexp.source:"",z=E.regexp?E.regexp.source:"";return this.key===E.key&&H===z}return!1}substituteConstants(){return this}evaluate(E){let H=E.getValue(this.key);return this.regexp?this.regexp.test(H):!1}serialize(){const E=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${E}`}keys(){return[this.key]}map(E){return E.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=i.create(this)),this.negated}}e.ContextKeyRegexExpr=r;class i{constructor(E){this._actual=E,this.type=8}static create(E){return new i(E)}cmp(E){return E.type!==this.type?this.type-E.type:this._actual.cmp(E._actual)}equals(E){return E.type===this.type?this._actual.equals(E._actual):!1}substituteConstants(){return this}evaluate(E){return!this._actual.evaluate(E)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(E){return new i(this._actual.map(E))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=i;function c(W){let E=null;for(let H=0,z=W.length;H<z;H++){const q=W[H].substituteConstants();if(W[H]!==q&&E===null){E=[];for(let G=0;G<H;G++)E[G]=W[G]}E!==null&&(E[H]=q)}return E===null?W:E}class t{constructor(E,H){this.expr=E,this.negated=H,this.type=6}static create(E,H){return t._normalizeArr(E,H)}cmp(E){if(E.type!==this.type)return this.type-E.type;if(this.expr.length<E.expr.length)return-1;if(this.expr.length>E.expr.length)return 1;for(let H=0,z=this.expr.length;H<z;H++){const q=L(this.expr[H],E.expr[H]);if(q!==0)return q}return 0}equals(E){if(E.type===this.type){if(this.expr.length!==E.expr.length)return!1;for(let H=0,z=this.expr.length;H<z;H++)if(!this.expr[H].equals(E.expr[H]))return!1;return!0}return!1}substituteConstants(){const E=c(this.expr);return E===this.expr?this:t.create(E,this.negated)}evaluate(E){for(let H=0,z=this.expr.length;H<z;H++)if(!this.expr[H].evaluate(E))return!1;return!0}static _normalizeArr(E,H){const z=[];let q=!1;for(const G of E)if(!!G){if(G.type===1){q=!0;continue}if(G.type===0)return v.INSTANCE;if(G.type===6){z.push(...G.expr);continue}z.push(G)}if(z.length===0&&q)return u.INSTANCE;if(z.length!==0){if(z.length===1)return z[0];z.sort(L);for(let G=1;G<z.length;G++)z[G-1].equals(z[G])&&(z.splice(G,1),G--);if(z.length===1)return z[0];for(;z.length>1;){const G=z[z.length-1];if(G.type!==9)break;z.pop();const j=z.pop(),$=z.length===0,ee=o.create(G.expr.map(se=>t.create([se,j],null)),null,$);ee&&(z.push(ee),z.sort(L))}return z.length===1?z[0]:new t(z,H)}}serialize(){return this.expr.map(E=>E.serialize()).join(" && ")}keys(){const E=[];for(let H of this.expr)E.push(...H.keys());return E}map(E){return new t(this.expr.map(H=>H.map(E)),null)}negate(){if(!this.negated){const E=[];for(let H of this.expr)E.push(H.negate());this.negated=o.create(E,this,!0)}return this.negated}}class o{constructor(E,H){this.expr=E,this.negated=H,this.type=9}static create(E,H,z){return o._normalizeArr(E,H,z)}cmp(E){if(E.type!==this.type)return this.type-E.type;if(this.expr.length<E.expr.length)return-1;if(this.expr.length>E.expr.length)return 1;for(let H=0,z=this.expr.length;H<z;H++){const q=L(this.expr[H],E.expr[H]);if(q!==0)return q}return 0}equals(E){if(E.type===this.type){if(this.expr.length!==E.expr.length)return!1;for(let H=0,z=this.expr.length;H<z;H++)if(!this.expr[H].equals(E.expr[H]))return!1;return!0}return!1}substituteConstants(){const E=c(this.expr);return E===this.expr?this:o.create(E,this.negated,!1)}evaluate(E){for(let H=0,z=this.expr.length;H<z;H++)if(this.expr[H].evaluate(E))return!0;return!1}static _normalizeArr(E,H,z){let q=[],G=!1;if(E){for(let j=0,$=E.length;j<$;j++){const ee=E[j];if(!!ee){if(ee.type===0){G=!0;continue}if(ee.type===1)return u.INSTANCE;if(ee.type===9){q=q.concat(ee.expr);continue}q.push(ee)}}if(q.length===0&&G)return v.INSTANCE;q.sort(L)}if(q.length!==0){if(q.length===1)return q[0];for(let j=1;j<q.length;j++)q[j-1].equals(q[j])&&(q.splice(j,1),j--);if(q.length===1)return q[0];if(z){for(let j=0;j<q.length;j++)for(let $=j+1;$<q.length;$++)P(q[j],q[$])&&(q.splice($,1),$--);if(q.length===1)return q[0]}return new o(q,H)}}serialize(){return this.expr.map(E=>E.serialize()).join(" || ")}keys(){const E=[];for(let H of this.expr)E.push(...H.keys());return E}map(E){return new o(this.expr.map(H=>H.map(E)),null)}negate(){if(!this.negated){let E=[];for(let H of this.expr)E.push(H.negate());for(;E.length>1;){const H=E.shift(),z=E.shift(),q=[];for(const j of R(H))for(const $ of R(z))q.push(t.create([j,$],null));const G=E.length===0;E.unshift(o.create(q,null,G))}this.negated=E[0]}return this.negated}}class g extends m{constructor(E,H,z){super(E,null);this._defaultValue=H,typeof z=="object"?g._info.push({...z,key:E}):z!==!0&&g._info.push({key:E,description:z,type:H!=null?typeof H:void 0})}static all(){return g._info.values()}bindTo(E){return E.createKey(this.key,this._defaultValue)}getValue(E){return E.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(E){return l.create(this.key,E)}notEqualsTo(E){return S.create(this.key,E)}}e.RawContextKey=g,g._info=[],e.IContextKeyService=(0,b.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function h(W,E){return W<E?-1:W>E?1:0}function _(W,E,H,z){return W<H?-1:W>H?1:E<z?-1:E>z?1:0}function P(W,E){if(E.type===6&&W.type!==9&&W.type!==6){for(const q of E.expr)if(W.equals(q))return!0}const H=W.negate(),z=R(H).concat(R(E));z.sort(L);for(let q=0;q<z.length;q++){const j=z[q].negate();for(let $=q+1;$<z.length;$++){const ee=z[$];if(j.equals(ee))return!0}}return!1}e.implies=P;function R(W){return W.type===9?W.expr:[W]}}),define(Ee[138],we([1,0,3]),function(J,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,s.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,s.refineServiceDecorator)(e.IEnvironmentService)}),define(Ee[45],we([1,0,15,22,17,9,11,2,119,3]),function(J,e,s,I,b,B,D,A,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,M.createDecorator)("fileService");function L(j){return j.create===!0}e.isFileOpenForWriteOptions=L;var v;(function(j){j[j.Unknown=0]="Unknown",j[j.File=1]="File",j[j.Directory=2]="Directory",j[j.SymbolicLink=64]="SymbolicLink"})(v=e.FileType||(e.FileType={}));var u;(function(j){j[j.Readonly=1]="Readonly"})(u=e.FilePermission||(e.FilePermission={}));var m;(function(j){j[j.FileReadWrite=2]="FileReadWrite",j[j.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",j[j.FileReadStream=16]="FileReadStream",j[j.FileFolderCopy=8]="FileFolderCopy",j[j.PathCaseSensitive=1024]="PathCaseSensitive",j[j.Readonly=2048]="Readonly",j[j.Trash=4096]="Trash",j[j.FileWriteUnlock=8192]="FileWriteUnlock",j[j.FileAtomicRead=16384]="FileAtomicRead"})(m=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function l(j){return!!(j.capabilities&2)}e.hasReadWriteCapability=l;function n(j){return!!(j.capabilities&8)}e.hasFileFolderCopyCapability=n;function f(j){return!!(j.capabilities&4)}e.hasOpenReadWriteCloseCapability=f;function S(j){return!!(j.capabilities&16)}e.hasFileReadStreamCapability=S;function k(j){return l(j)?!!(j.capabilities&16384):!1}e.hasFileAtomicReadCapability=k;var d;(function(j){j.FileExists="EntryExists",j.FileNotFound="EntryNotFound",j.FileNotADirectory="EntryNotADirectory",j.FileIsADirectory="EntryIsADirectory",j.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",j.FileTooLarge="EntryTooLarge",j.FileWriteLocked="EntryWriteLocked",j.NoPermissions="NoPermissions",j.Unavailable="Unavailable",j.Unknown="Unknown"})(d=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class p extends Error{constructor($,ee){super($);this.code=ee}}e.FileSystemProviderError=p;function w(j,$){const ee=new p(j.toString(),$);return T(ee,$),ee}e.createFileSystemProviderError=w;function a(j){return j||w((0,y.localize)(0,null),d.Unknown)}e.ensureFileSystemProviderError=a;function T(j,$){return j.name=$?`${$} (FileSystemError)`:"FileSystemError",j}e.markAsFileSystemProviderError=T;function r(j){if(!j)return d.Unknown;if(j instanceof p)return j.code;const $=/^(.+) \(FileSystemError\)$/.exec(j.name);if(!$)return d.Unknown;switch($[1]){case d.FileExists:return d.FileExists;case d.FileIsADirectory:return d.FileIsADirectory;case d.FileNotADirectory:return d.FileNotADirectory;case d.FileNotFound:return d.FileNotFound;case d.FileExceedsMemoryLimit:return d.FileExceedsMemoryLimit;case d.FileTooLarge:return d.FileTooLarge;case d.FileWriteLocked:return d.FileWriteLocked;case d.NoPermissions:return d.NoPermissions;case d.Unavailable:return d.Unavailable}return d.Unknown}e.toFileSystemProviderErrorCode=r;function i(j){if(j instanceof _)return j.fileOperationResult;switch(r(j)){case d.FileNotFound:return 1;case d.FileIsADirectory:return 0;case d.FileNotADirectory:return 10;case d.FileWriteLocked:return 5;case d.NoPermissions:return 6;case d.FileExists:return 4;case d.FileExceedsMemoryLimit:return 9;case d.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=i;var c;(function(j){j[j.CREATE=0]="CREATE",j[j.DELETE=1]="DELETE",j[j.MOVE=2]="MOVE",j[j.COPY=3]="COPY",j[j.WRITE=4]="WRITE"})(c=e.FileOperation||(e.FileOperation={}));class t{constructor($,ee,se){this.resource=$,this.operation=ee,this.target=se}isOperation($){return this.operation===$}}e.FileOperationEvent=t;var o;(function(j){j[j.UPDATED=0]="UPDATED",j[j.ADDED=1]="ADDED",j[j.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class g{constructor($,ee){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=$;const se=new Map;for(const Z of $){const le=se.get(Z.type);switch(le?le.push([Z.resource,Z]):se.set(Z.type,[[Z.resource,Z]]),Z.type){case 1:this.rawAdded.push(Z.resource);break;case 0:this.rawUpdated.push(Z.resource);break;case 2:this.rawDeleted.push(Z.resource);break}}for(const[Z,le]of se)switch(Z){case 1:this.added=I.TernarySearchTree.forUris(()=>ee),this.added.fill(le);break;case 0:this.updated=I.TernarySearchTree.forUris(()=>ee),this.updated.fill(le);break;case 2:this.deleted=I.TernarySearchTree.forUris(()=>ee),this.deleted.fill(le);break}}contains($,...ee){return this.doContains($,{includeChildren:!1},...ee)}affects($,...ee){return this.doContains($,{includeChildren:!0},...ee)}doContains($,ee,...se){if(!$)return!1;const Z=se.length>0;return!!((!Z||se.includes(1))&&(this.added?.get($)||ee.includeChildren&&this.added?.findSuperstr($))||(!Z||se.includes(0))&&(this.updated?.get($)||ee.includeChildren&&this.updated?.findSuperstr($))||(!Z||se.includes(2))&&(this.deleted?.findSubstr($)||ee.includeChildren&&this.deleted?.findSuperstr($)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=g;function h(j,$,ee){return!j||!$||j===$||$.length>j.length?!1:($.charAt($.length-1)!==b.sep&&($+=b.sep),ee?(0,B.startsWithIgnoreCase)(j,$):j.indexOf($)===0)}e.isParent=h;class _ extends s.ErrorNoTelemetry{constructor($,ee,se){super($);this.fileOperationResult=ee,this.options=se}}e.FileOperationError=_;class P extends _{constructor($,ee,se){super($,2,se);this.stat=ee}}e.NotModifiedSinceFileOperationError=P;var R;(function(j){j[j.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",j[j.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",j[j.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",j[j.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",j[j.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",j[j.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",j[j.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",j[j.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",j[j.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",j[j.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",j[j.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",j[j.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(R=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var W;(function(j){j[j.FILE=0]="FILE",j[j.FOLDER=1]="FOLDER",j[j.ROOT_FOLDER=2]="ROOT_FOLDER"})(W=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function E(j){if(!(typeof j.size!="number"||typeof j.mtime!="number"))return j.mtime.toString(29)+j.size.toString(31)}e.etag=E;async function H(j,$){if(!$.hasProvider(A.URI.from({scheme:j.scheme})))return new Promise(ee=>{const se=$.onDidChangeFileSystemProviderRegistrations(Z=>{Z.scheme===j.scheme&&Z.added&&(se.dispose(),ee())})})}e.whenProviderRegistered=H,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class z{static formatSize($){return(0,D.isNumber)($)||($=0),$<z.KB?(0,y.localize)(1,null,$.toFixed(0)):$<z.MB?(0,y.localize)(2,null,($/z.KB).toFixed(2)):$<z.GB?(0,y.localize)(3,null,($/z.MB).toFixed(2)):$<z.TB?(0,y.localize)(4,null,($/z.GB).toFixed(2)):(0,y.localize)(5,null,($/z.TB).toFixed(2))}}e.ByteSize=z,z.KB=1024,z.MB=z.KB*z.KB,z.GB=z.MB*z.KB,z.TB=z.GB*z.KB;var q;(function(j){j[j.IA32=0]="IA32",j[j.OTHER=1]="OTHER"})(q=e.Arch||(e.Arch={}));function G(j){return{maxFileSize:j===0?300*z.MB:16*z.GB,maxHeapSize:j===0?700*z.MB:2*700*z.MB}}e.getPlatformLimits=G}),define(Ee[56],we([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class s{constructor(...b){this._entries=new Map;for(let[B,D]of b)this.set(B,D)}set(b,B){const D=this._entries.get(b);return this._entries.set(b,B),D}has(b){return this._entries.has(b)}get(b){return this._entries.get(b)}}e.ServiceCollection=s}),define(Ee[139],we([1,0,13,15,76,137,3,56]),function(J,e,s,I,b,B,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const y=!1;class M extends Error{constructor(l){super("cyclic dependency between services");this.message=l.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${l.toString()}`}}class L{constructor(l=new A.ServiceCollection,n=!1,f){this._activeInstantiations=new Set,this._services=l,this._strict=n,this._parent=f,this._services.set(D.IInstantiationService,this)}createChild(l){return new L(l,this._strict,this)}invokeFunction(l,...n){let f=u.traceInvocation(l),S=!1;try{return l({get:d=>{if(S)throw(0,I.illegalState)("service accessor is only valid during the invocation of its target method");const p=this._getOrCreateServiceInstance(d,f);if(!p)throw new Error(`[invokeFunction] unknown service '${d}'`);return p}},...n)}finally{S=!0,f.stop()}}createInstance(l,...n){let f,S;return l instanceof b.SyncDescriptor?(f=u.traceCreation(l.ctor),S=this._createInstance(l.ctor,l.staticArguments.concat(n),f)):(f=u.traceCreation(l),S=this._createInstance(l,n,f)),f.stop(),S}_createInstance(l,n=[],f){let S=D._util.getServiceDependencies(l).sort((p,w)=>p.index-w.index),k=[];for(const p of S){let w=this._getOrCreateServiceInstance(p.id,f);w||this._throwIfStrict(`[createInstance] ${l.name} depends on UNKNOWN service ${p.id}.`,!1),k.push(w)}let d=S.length>0?S[0].index:n.length;if(n.length!==d){console.warn(`[createInstance] First service dependency of ${l.name} at position ${d+1} conflicts with ${n.length} static arguments`);let p=d-n.length;p>0?n=n.concat(new Array(p)):n=n.slice(0,d)}return new l(...[...n,...k])}_setServiceInstance(l,n){if(this._services.get(l)instanceof b.SyncDescriptor)this._services.set(l,n);else if(this._parent)this._parent._setServiceInstance(l,n);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(l){let n=this._services.get(l);return!n&&this._parent?this._parent._getServiceInstanceOrDescriptor(l):n}_getOrCreateServiceInstance(l,n){let f=this._getServiceInstanceOrDescriptor(l);return f instanceof b.SyncDescriptor?this._safeCreateAndCacheServiceInstance(l,f,n.branch(l,!0)):(n.branch(l,!1),f)}_safeCreateAndCacheServiceInstance(l,n,f){if(this._activeInstantiations.has(l))throw new Error(`illegal state - RECURSIVELY instantiating service '${l}'`);this._activeInstantiations.add(l);try{return this._createAndCacheServiceInstance(l,n,f)}finally{this._activeInstantiations.delete(l)}}_createAndCacheServiceInstance(l,n,f){const S=new B.Graph(p=>p.id.toString());let k=0;const d=[{id:l,desc:n,_trace:f}];for(;d.length;){const p=d.pop();if(S.lookupOrInsertNode(p),k++>1e3)throw new M(S);for(let w of D._util.getServiceDependencies(p.desc.ctor)){let a=this._getServiceInstanceOrDescriptor(w.id);if(a||this._throwIfStrict(`[createInstance] ${l} depends on ${w.id} which is NOT registered.`,!0),a instanceof b.SyncDescriptor){const T={id:w.id,desc:a,_trace:p._trace.branch(w.id,!0)};S.insertEdge(p,T),d.push(T)}}}for(;;){const p=S.roots();if(p.length===0){if(!S.isEmpty())throw new M(S);break}for(const{data:w}of p){if(this._getServiceInstanceOrDescriptor(w.id)instanceof b.SyncDescriptor){const T=this._createServiceInstanceWithOwner(w.id,w.desc.ctor,w.desc.staticArguments,w.desc.supportsDelayedInstantiation,w._trace);this._setServiceInstance(w.id,T)}S.removeNode(w)}}return this._getServiceInstanceOrDescriptor(l)}_createServiceInstanceWithOwner(l,n,f=[],S,k){if(this._services.get(l)instanceof b.SyncDescriptor)return this._createServiceInstance(n,f,S,k);if(this._parent)return this._parent._createServiceInstanceWithOwner(l,n,f,S,k);throw new Error(`illegalState - creating UNKNOWN service instance ${n.name}`)}_createServiceInstance(l,n=[],f,S){if(f){const k=new s.IdleValue(()=>this._createInstance(l,n,S));return new Proxy(Object.create(null),{get(d,p){if(p in d)return d[p];let w=k.value,a=w[p];return typeof a!="function"||(a=a.bind(w),d[p]=a),a},set(d,p,w){return k.value[p]=w,!0}})}else return this._createInstance(l,n,S)}_throwIfStrict(l,n){if(n&&console.warn(n),this._strict)throw new Error(l)}}e.InstantiationService=L;var v;(function(m){m[m.Creation=0]="Creation",m[m.Invocation=1]="Invocation",m[m.Branch=2]="Branch"})(v||(v={}));class u{constructor(l,n){this.type=l,this.name=n,this._start=Date.now(),this._dep=[]}static traceInvocation(l){return y?new u(1,l.name||l.toString().substring(0,42).replace(/\n/g,"")):u._None}static traceCreation(l){return y?new u(0,l.name):u._None}branch(l,n){let f=new u(2,l.toString());return this._dep.push([l,n,f]),f}stop(){let l=Date.now()-this._start;u._totals+=l;let n=!1;function f(k,d){let p=[],w=new Array(k+1).join("	");for(const[a,T,r]of d._dep)if(T&&r){n=!0,p.push(`${w}CREATES -> ${a}`);let i=f(k+1,r);i&&p.push(i)}else p.push(`${w}uses -> ${a}`);return p.join(`
`)}let S=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${f(1,this)}`,`DONE, took ${l.toFixed(2)}ms (grand total ${u._totals.toFixed(2)}ms)`];(l>2||n)&&console.log(S.join(`
`))}}e.Trace=u,u._None=new class extends u{constructor(){super(-1,null)}stop(){}branch(){return this}},u._totals=0}),define(Ee[12],we([1,0,43,5,6,23,3]),function(J,e,s,I,b,B,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,D.createDecorator)("logService"),e.ILoggerService=(0,D.createDecorator)("loggerService");function A(){return new Date().toISOString()}var y;(function(T){T[T.Trace=0]="Trace",T[T.Debug=1]="Debug",T[T.Info=2]="Info",T[T.Warning=3]="Warning",T[T.Error=4]="Error",T[T.Critical=5]="Critical",T[T.Off=6]="Off"})(y=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=y.Info;function M(T,r,i){switch(r){case y.Trace:T.trace(i);break;case y.Debug:T.debug(i);break;case y.Info:T.info(i);break;case y.Warning:T.warn(i);break;case y.Error:T.error(i);break;case y.Critical:T.critical(i);break;default:throw new Error("Invalid log level")}}e.log=M;function L(T){let r="";for(let i=0;i<T.length;i++){let c=T[i];if(typeof c=="object")try{c=JSON.stringify(c)}catch{}r+=(i>0?" ":"")+c}return r}e.format=L;class v extends b.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new I.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(r){this.level!==r&&(this.level=r,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=v;class u extends v{constructor(r){super();this.logAlways=r}checkLogLevel(r){return this.logAlways||this.getLevel()<=r}trace(r,...i){this.checkLogLevel(y.Trace)&&this.log(y.Trace,L([r,...i]))}debug(r,...i){this.checkLogLevel(y.Debug)&&this.log(y.Debug,L([r,...i]))}info(r,...i){this.checkLogLevel(y.Info)&&this.log(y.Info,L([r,...i]))}warn(r,...i){this.checkLogLevel(y.Warning)&&this.log(y.Warning,L([r,...i]))}error(r,...i){if(this.checkLogLevel(y.Error))if(r instanceof Error){const c=Array.prototype.slice.call(arguments);c[0]=r.stack,this.log(y.Error,L(c))}else this.log(y.Error,L([r,...i]))}critical(r,...i){this.checkLogLevel(y.Critical)&&this.log(y.Critical,L([r,...i]))}flush(){}}e.AbstractMessageLogger=u;class m extends v{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r),this.useColors=!B.isWindows}trace(r,...i){this.getLevel()<=y.Trace&&(this.useColors?console.log(`[90m[main ${A()}][0m`,r,...i):console.log(`[main ${A()}]`,r,...i))}debug(r,...i){this.getLevel()<=y.Debug&&(this.useColors?console.log(`[90m[main ${A()}][0m`,r,...i):console.log(`[main ${A()}]`,r,...i))}info(r,...i){this.getLevel()<=y.Info&&(this.useColors?console.log(`[90m[main ${A()}][0m`,r,...i):console.log(`[main ${A()}]`,r,...i))}warn(r,...i){this.getLevel()<=y.Warning&&(this.useColors?console.warn(`[93m[main ${A()}][0m`,r,...i):console.warn(`[main ${A()}]`,r,...i))}error(r,...i){this.getLevel()<=y.Error&&(this.useColors?console.error(`[91m[main ${A()}][0m`,r,...i):console.error(`[main ${A()}]`,r,...i))}critical(r,...i){this.getLevel()<=y.Critical&&(this.useColors?console.error(`[90m[main ${A()}][0m`,r,...i):console.error(`[main ${A()}]`,r,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=m;class l extends v{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r)}trace(r,...i){this.getLevel()<=y.Trace&&console.log("%cTRACE","color: #888",r,...i)}debug(r,...i){this.getLevel()<=y.Debug&&console.log("%cDEBUG","background: #eee; color: #888",r,...i)}info(r,...i){this.getLevel()<=y.Info&&console.log("%c INFO","color: #33f",r,...i)}warn(r,...i){this.getLevel()<=y.Warning&&console.log("%c WARN","color: #993",r,...i)}error(r,...i){this.getLevel()<=y.Error&&console.log("%c  ERR","color: #f33",r,...i)}critical(r,...i){this.getLevel()<=y.Critical&&console.log("%cCRITI","background: #f33; color: white",r,...i)}dispose(){}flush(){}}e.ConsoleLogger=l;class n extends v{constructor(r,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=r,this.setLevel(i)}trace(r,...i){this.getLevel()<=y.Trace&&this.adapter.log(y.Trace,[this.extractMessage(r),...i])}debug(r,...i){this.getLevel()<=y.Debug&&this.adapter.log(y.Debug,[this.extractMessage(r),...i])}info(r,...i){this.getLevel()<=y.Info&&this.adapter.log(y.Info,[this.extractMessage(r),...i])}warn(r,...i){this.getLevel()<=y.Warning&&this.adapter.log(y.Warning,[this.extractMessage(r),...i])}error(r,...i){this.getLevel()<=y.Error&&this.adapter.log(y.Error,[this.extractMessage(r),...i])}critical(r,...i){this.getLevel()<=y.Critical&&this.adapter.log(y.Critical,[this.extractMessage(r),...i])}extractMessage(r){return typeof r=="string"?r:(0,s.toErrorMessage)(r,this.getLevel()<=y.Trace)}dispose(){}flush(){}}e.AdapterLogger=n;class f extends v{constructor(r){super();this.logServices=r,r.length&&this.setLevel(r[0].getLevel())}setLevel(r){for(const i of this.logServices)i.setLevel(r);super.setLevel(r)}trace(r,...i){for(const c of this.logServices)c.trace(r,...i)}debug(r,...i){for(const c of this.logServices)c.debug(r,...i)}info(r,...i){for(const c of this.logServices)c.info(r,...i)}warn(r,...i){for(const c of this.logServices)c.warn(r,...i)}error(r,...i){for(const c of this.logServices)c.error(r,...i)}critical(r,...i){for(const c of this.logServices)c.critical(r,...i)}flush(){for(const r of this.logServices)r.flush()}dispose(){for(const r of this.logServices)r.dispose()}}e.MultiplexLogService=f;class S extends b.Disposable{constructor(r){super();this.logger=r,this._register(r)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(r){this.logger.setLevel(r)}getLevel(){return this.logger.getLevel()}trace(r,...i){this.logger.trace(r,...i)}debug(r,...i){this.logger.debug(r,...i)}info(r,...i){this.logger.info(r,...i)}warn(r,...i){this.logger.warn(r,...i)}error(r,...i){this.logger.error(r,...i)}critical(r,...i){this.logger.critical(r,...i)}flush(){this.logger.flush()}}e.LogService=S;class k extends b.Disposable{constructor(r,i){super();this.logLevel=r,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(c=>{this.logLevel=c,this.logLevelChangeableLoggers.forEach(t=>t.setLevel(c))}))}getLogger(r){return this.loggers.get(r.toString())}createLogger(r,i){let c=this.loggers.get(r.toString());return c||(c=this.doCreateLogger(r,i?.always?y.Trace:this.logLevel,i),this.loggers.set(r.toString(),c),i?.always||this.logLevelChangeableLoggers.push(c)),c}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(r=>r.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=k;class d{constructor(){this.onDidChangeLogLevel=new I.Emitter().event}setLevel(r){}getLevel(){return y.Info}trace(r,...i){}debug(r,...i){}info(r,...i){}warn(r,...i){}error(r,...i){}critical(r,...i){}dispose(){}flush(){}}e.NullLogService=d;function p(T){if(T.verbose)return y.Trace;if(typeof T.logLevel=="string"){const r=w(T.logLevel.toLowerCase());if(r!==void 0)return r}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=p;function w(T){switch(T){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Critical;case"off":return y.Off}}e.parseLogLevel=w;function a(T){switch(T){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Critical:return"critical";case y.Off:return"off"}}e.LogLevelToString=a}),define(Ee[78],we([1,0,34,120,3]),function(J,e,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var B;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(B=e.MarkerTag||(e.MarkerTag={}));var D;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(D=e.MarkerSeverity||(e.MarkerSeverity={})),function(y){function M(l,n){return n-l}y.compare=M;const L=Object.create(null);L[y.Error]=(0,I.localize)(0,null),L[y.Warning]=(0,I.localize)(1,null),L[y.Info]=(0,I.localize)(2,null);function v(l){return L[l]||""}y.toString=v;function u(l){switch(l){case s.default.Error:return y.Error;case s.default.Warning:return y.Warning;case s.default.Info:return y.Info;case s.default.Ignore:return y.Hint}}y.fromSeverity=u;function m(l){switch(l){case y.Error:return s.default.Error;case y.Warning:return s.default.Warning;case y.Info:return s.default.Info;case y.Hint:return s.default.Ignore}}y.toSeverity=m}(D=e.MarkerSeverity||(e.MarkerSeverity={}));var A;(function(y){const M="";function L(u){return v(u,!0)}y.makeKey=L;function v(u,m){let l=[M];return u.source?l.push(u.source.replace("\xA6","\\\xA6")):l.push(M),u.code?typeof u.code=="string"?l.push(u.code.replace("\xA6","\\\xA6")):l.push(u.code.value.replace("\xA6","\\\xA6")):l.push(M),u.severity!==void 0&&u.severity!==null?l.push(D.toString(u.severity)):l.push(M),u.message&&m?l.push(u.message.replace("\xA6","\\\xA6")):l.push(M),u.startLineNumber!==void 0&&u.startLineNumber!==null?l.push(u.startLineNumber.toString()):l.push(M),u.startColumn!==void 0&&u.startColumn!==null?l.push(u.startColumn.toString()):l.push(M),u.endLineNumber!==void 0&&u.endLineNumber!==null?l.push(u.endLineNumber.toString()):l.push(M),u.endColumn!==void 0&&u.endColumn!==null?l.push(u.endColumn.toString()):l.push(M),l.push(M),l.join("\xA6")}y.makeKeyOptionalMessage=v})(A=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,b.createDecorator)("markerService")}),define(Ee[140],we([1,0,5,34,3]),function(J,e,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=I.default,e.INotificationService=(0,b.createDecorator)("notificationService");var B;(function(M){M[M.WORKSPACE=0]="WORKSPACE",M[M.GLOBAL=1]="GLOBAL"})(B=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var D;(function(M){M[M.OFF=0]="OFF",M[M.SILENT=1]="SILENT",M[M.ERROR=2]="ERROR"})(D=e.NotificationsFilter||(e.NotificationsFilter={}));class A{constructor(){this.progress=new y,this.onDidClose=s.Event.None,this.onDidChangeVisibility=s.Event.None}updateSeverity(L){}updateMessage(L){}updateActions(L){}close(){}}e.NoOpNotification=A;class y{infinite(){}done(){}total(L){}worked(L){}}e.NoOpProgress=y}),define(Ee[79],we([1,0,6,9,2,3]),function(J,e,s,I,b,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,B.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return s.Disposable.None},registerValidator(){return s.Disposable.None},registerExternalUriResolver(){return s.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return s.Disposable.None},async open(){return!1},async resolveExternalUri(L){return{resolved:L,dispose(){}}}});function D(L,v){return b.URI.isUri(L)?(0,I.equalsIgnoreCase)(L.scheme,v):(0,I.startsWithIgnoreCase)(L,v+":")}e.matchesScheme=D;function A(L,...v){return v.some(u=>D(L,u))}e.matchesSomeScheme=A;function y(L,v){return L.with({fragment:`${v.startLineNumber},${v.startColumn}${v.endLineNumber?`-${v.endLineNumber}${v.endColumn?`,${v.endColumn}`:""}`:""}`})}e.withSelection=y;function M(L){let v;const u=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(L.fragment);return u&&(v={startLineNumber:parseInt(u[1]),startColumn:u[2]?parseInt(u[2]):1,endLineNumber:u[4]?parseInt(u[4]):void 0,endColumn:u[4]?u[5]?parseInt(u[5]):1:void 0},L=L.with({fragment:""})),{selection:v,uri:L}}e.extractSelection=M});var Fe=this&&this.__decorate||function(J,e,s,I){var b=arguments.length,B=b<3?e:I===null?I=Object.getOwnPropertyDescriptor(e,s):I,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")B=Reflect.decorate(J,e,s,I);else for(var A=J.length-1;A>=0;A--)(D=J[A])&&(B=(b<3?D(B):b>3?D(e,s,B):D(e,s))||B);return b>3&&B&&Object.defineProperty(e,s,B),B},Ne=this&&this.__param||function(J,e){return function(s,I){e(s,I,J)}};define(Ee[141],we([1,0,13,20,6,3]),function(J,e,s,I,b,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,B.createDecorator)("progressService");var D;(function(L){L[L.Explorer=1]="Explorer",L[L.Scm=3]="Scm",L[L.Extensions=5]="Extensions",L[L.Window=10]="Window",L[L.Notification=15]="Notification",L[L.Dialog=20]="Dialog"})(D=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class A{constructor(v){this.callback=v}get value(){return this._value}report(v){this._value=v,this.callback(this._value)}}e.Progress=A,A.None=Object.freeze({report(){}});let y=class extends b.Disposable{constructor(v,u){super();this.deferred=new s.DeferredPromise,u.withProgress(v,m=>(this.reporter=m,this.lastStep&&m.report(this.lastStep),this.deferred.p)),this._register((0,b.toDisposable)(()=>this.deferred.complete()))}report(v){this.reporter?this.reporter.report(v):this.lastStep=v}};y=Fe([Ne(1,e.IProgressService)],y),e.UnmanagedProgress=y;class M extends b.Disposable{constructor(v){super();this.progressIndicator=v,this.currentOperationId=0,this.currentOperationDisposables=this._register(new b.DisposableStore)}start(v){this.stop();const u=++this.currentOperationId,m=new I.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{u===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},v),this.currentOperationDisposables.add((0,b.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,b.toDisposable)(()=>m.cancel())),this.currentOperationDisposables.add((0,b.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:u,token:m.token,stop:()=>this.doStop(u),isCurrent:()=>this.currentOperationId===u}}stop(){this.doStop(this.currentOperationId)}doStop(v){this.currentOperationId===v&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=M,e.IEditorProgressService=(0,B.createDecorator)("editorProgressService")}),define(Ee[37],we([1,0,42,11]),function(J,e,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class b{constructor(){this.data=new Map}add(D,A){s.ok(I.isString(D)),s.ok(I.isObject(A)),s.ok(!this.data.has(D),"There is already an extension with this id"),this.data.set(D,A)}knows(D){return this.data.has(D)}as(D){return this.data.get(D)||null}}e.Registry=new b}),define(Ee[142],we([1,0,5,37]),function(J,e,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function b(A){return A.length>0&&A.charAt(A.length-1)==="#"?A.substring(0,A.length-1):A}class B{constructor(){this._onDidChangeSchema=new s.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(y,M){this.schemasById[b(y)]=M,this._onDidChangeSchema.fire(y)}notifySchemaChanged(y){this._onDidChangeSchema.fire(y)}getSchemaContributions(){return{schemas:this.schemasById}}}const D=new B;I.Registry.add(e.Extensions.JSONContribution,D)}),define(Ee[80],we([1,0,16,5,11,117,142,37]),function(J,e,s,I,b,B,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var y;(function(p){p.Multiline="multilineText",p.Singleline="singlelineText"})(y=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var M;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.MACHINE=2]="MACHINE",p[p.WINDOW=3]="WINDOW",p[p.RESOURCE=4]="RESOURCE",p[p.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",p[p.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(M=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const L=A.Registry.as(D.Extensions.JSONContribution);class v{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new I.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new I.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:B.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},L.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(w,a=!0){this.registerConfigurations([w],a)}registerConfigurations(w,a=!0){const T=this.doRegisterConfigurations(w,a);L.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:T})}deregisterConfigurations(w){const a=this.doDeregisterConfigurations(w);L.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a})}updateConfigurations({add:w,remove:a}){const T=[];T.push(...this.doDeregisterConfigurations(a)),T.push(...this.doRegisterConfigurations(w,!1)),L.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,s.distinct)(T)})}registerDefaultConfigurations(w){const a=[],T=[];for(const{overrides:r,source:i}of w)for(const c in r)if(a.push(c),e.OVERRIDE_PROPERTY_REGEX.test(c)){const t={...this.configurationDefaultsOverrides.get(c)?.value||{},...r[c]};this.configurationDefaultsOverrides.set(c,{source:i,value:t});const o={type:"object",default:t,description:B.localize(1,null,c),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:t,source:b.isString(i)?void 0:i};T.push(...l(c)),this.configurationProperties[c]=o,this.defaultLanguageConfigurationOverridesNode.properties[c]=o}else{this.configurationDefaultsOverrides.set(c,{value:r[c],source:i});const t=this.configurationProperties[c];t&&(this.updatePropertyDefaultValue(c,t),this.updateSchema(c,t))}this.registerOverrideIdentifiers(T),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a,defaultsOverrides:!0})}deregisterDefaultConfigurations(w){const a=[];for(const{overrides:T,source:r}of w)for(const i in T){const c=this.configurationDefaultsOverrides.get(i),t=b.isString(r)?r:r?.id,o=b.isString(c?.source)?c?.source:c?.source?.id;if(t===o)if(a.push(i),this.configurationDefaultsOverrides.delete(i),e.OVERRIDE_PROPERTY_REGEX.test(i))delete this.configurationProperties[i],delete this.defaultLanguageConfigurationOverridesNode.properties[i];else{const g=this.configurationProperties[i];g&&(this.updatePropertyDefaultValue(i,g),this.updateSchema(i,g))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...w){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(w){for(const a of w)this.overrideIdentifiers.add(a);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(w,a){const T=[];return w.forEach(r=>{T.push(...this.validateAndRegisterProperties(r,a,r.extensionInfo,r.restrictedProperties)),this.configurationContributors.push(r),this.registerJSONConfiguration(r)}),T}doDeregisterConfigurations(w){const a=[],T=r=>{if(r.properties)for(const i in r.properties)a.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,r.properties[i]);r.allOf&&r.allOf.forEach(i=>T(i))};for(const r of w){T(r);const i=this.configurationContributors.indexOf(r);i!==-1&&this.configurationContributors.splice(i,1)}return a}validateAndRegisterProperties(w,a=!0,T,r,i=3){i=b.isUndefinedOrNull(w.scope)?i:w.scope;let c=[],t=w.properties;if(t)for(let g in t){if(a&&k(g)){delete t[g];continue}const h=t[g];if(h.source=T,h.defaultDefaultValue=t[g].default,this.updatePropertyDefaultValue(g,h),e.OVERRIDE_PROPERTY_REGEX.test(g)?h.scope=void 0:(h.scope=b.isUndefinedOrNull(h.scope)?i:h.scope,h.restricted=b.isUndefinedOrNull(h.restricted)?!!r?.includes(g):h.restricted),t[g].hasOwnProperty("included")&&!t[g].included){this.excludedConfigurationProperties[g]=t[g],delete t[g];continue}else this.configurationProperties[g]=t[g];!t[g].deprecationMessage&&t[g].markdownDeprecationMessage&&(t[g].deprecationMessage=t[g].markdownDeprecationMessage),c.push(g)}let o=w.allOf;if(o)for(let g of o)c.push(...this.validateAndRegisterProperties(g,a,T,r,i));return c}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(w){const a=T=>{let r=T.properties;if(r)for(const c in r)this.updateSchema(c,r[c]);let i=T.allOf;i&&i.forEach(a)};a(w)}updateSchema(w,a){switch(e.allSettings.properties[w]=a,a.scope){case 1:e.applicationSettings.properties[w]=a;break;case 2:e.machineSettings.properties[w]=a;break;case 6:e.machineOverridableSettings.properties[w]=a;break;case 3:e.windowSettings.properties[w]=a;break;case 4:e.resourceSettings.properties[w]=a;break;case 5:e.resourceSettings.properties[w]=a,this.resourceLanguageSettingsSchema.properties[w]=a;break}}removeFromSchema(w,a){switch(delete e.allSettings.properties[w],a.scope){case 1:delete e.applicationSettings.properties[w];break;case 2:delete e.machineSettings.properties[w];break;case 6:delete e.machineOverridableSettings.properties[w];break;case 3:delete e.windowSettings.properties[w];break;case 4:case 5:delete e.resourceSettings.properties[w],delete this.resourceLanguageSettingsSchema.properties[w];break}}updateOverridePropertyPatternKey(){for(const w of this.overrideIdentifiers.values()){const a=`[${w}]`,T={type:"object",description:B.localize(2,null),errorMessage:B.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(a,T),e.allSettings.properties[a]=T,e.applicationSettings.properties[a]=T,e.machineSettings.properties[a]=T,e.machineOverridableSettings.properties[a]=T,e.windowSettings.properties[a]=T,e.resourceSettings.properties[a]=T}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const w={type:"object",description:B.localize(4,null),errorMessage:B.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=w,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=w,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=w,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=w,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=w,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=w,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(w,a){const T=this.configurationDefaultsOverrides.get(w);let r=T?.value,i=T?.source;b.isUndefined(r)&&(r=a.defaultDefaultValue,i=void 0),b.isUndefined(r)&&(r=f(a.type)),a.default=r,a.defaultValueSource=i}}const u="\\[([^\\]]+)\\]",m=new RegExp(u,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${u})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function l(p){const w=[];if(e.OVERRIDE_PROPERTY_REGEX.test(p)){let a=m.exec(p);for(;a?.length;){const T=a[1].trim();T&&w.push(T),a=m.exec(p)}}return(0,s.distinct)(w)}e.overrideIdentifiersFromKey=l;function n(p){return p.reduce((w,a)=>`${w}[${a}]`,"")}e.keyFromOverrideIdentifiers=n;function f(p){switch(Array.isArray(p)?p[0]:p){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=f;const S=new v;A.Registry.add(e.Extensions.Configuration,S);function k(p){return p.trim()?e.OVERRIDE_PROPERTY_REGEX.test(p)?B.localize(7,null,p):S.getConfigurationProperties()[p]!==void 0?B.localize(8,null,p):null:B.localize(6,null)}e.validateProperty=k;function d(){const p=[],w=S.getConfigurationProperties();for(const a of Object.keys(w))p.push([a,w[a].scope]);return p.push(["launch",4]),p.push(["task",4]),p}e.getScopes=d}),define(Ee[143],we([1,0,16,5,100,6,22,26,11,2,77,80,37]),function(J,e,s,I,b,B,D,A,y,M,L,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class m{constructor(r={},i=[],c=[]){this._contents=r,this._keys=i,this._overrides=c,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(r){return r?(0,L.getConfigurationValue)(this.contents,r):this.contents}getOverrideValue(r,i){const c=this.getContentsForOverrideIdentifer(i);return c?r?(0,L.getConfigurationValue)(c,r):c:void 0}getKeysForOverrideIdentifier(r){const i=[];for(const c of this.overrides)c.identifiers.includes(r)&&i.push(...c.keys);return s.distinct(i)}getAllOverrideIdentifiers(){const r=[];for(const i of this.overrides)r.push(...i.identifiers);return s.distinct(r)}override(r){let i=this.overrideConfigurations.get(r);return i||(i=this.createOverrideConfigurationModel(r),this.overrideConfigurations.set(r,i)),i}merge(...r){const i=A.deepClone(this.contents),c=A.deepClone(this.overrides),t=[...this.keys];for(const o of r){this.mergeContents(i,o.contents);for(const g of o.overrides){const[h]=c.filter(_=>s.equals(_.identifiers,g.identifiers));h?(this.mergeContents(h.contents,g.contents),h.keys.push(...g.keys),h.keys=s.distinct(h.keys)):c.push(A.deepClone(g))}for(const g of o.keys)t.indexOf(g)===-1&&t.push(g)}return new m(i,t,c)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(r){const i=this.getContentsForOverrideIdentifer(r);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let c={};for(const t of s.distinct([...Object.keys(this.contents),...Object.keys(i)])){let o=this.contents[t],g=i[t];g&&(typeof o=="object"&&typeof g=="object"?(o=A.deepClone(o),this.mergeContents(o,g)):o=g),c[t]=o}return new m(c,this.keys,this.overrides)}mergeContents(r,i){for(const c of Object.keys(i)){if(c in r&&y.isObject(r[c])&&y.isObject(i[c])){this.mergeContents(r[c],i[c]);continue}r[c]=A.deepClone(i[c])}}checkAndFreeze(r){return this.isFrozen&&!Object.isFrozen(r)?A.deepFreeze(r):r}getContentsForOverrideIdentifer(r){let i=null,c=null;const t=o=>{o&&(c?this.mergeContents(c,o):c=A.deepClone(o))};for(const o of this.overrides)s.equals(o.identifiers,[r])?i=o.contents:o.identifiers.includes(r)&&t(o.contents);return t(i),c}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(r,i){this.addKey(r),(0,L.addToValueTree)(this.contents,r,i,c=>{throw new Error(c)})}removeValue(r){this.removeKey(r)&&(0,L.removeFromValueTree)(this.contents,r)}addKey(r){let i=this.keys.length;for(let c=0;c<i;c++)r.indexOf(this.keys[c])===0&&(i=c);this.keys.splice(i,1,r)}removeKey(r){let i=this.keys.indexOf(r);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=m;class l extends m{constructor(r={}){const i=u.Registry.as(v.Extensions.Configuration).getConfigurationProperties(),c=Object.keys(i),t=Object.create(null),o=[];for(const g in i){const h=r[g],_=h!==void 0?h:i[g].default;(0,L.addToValueTree)(t,g,_,P=>console.error(`Conflict in default settings: ${P}`))}for(const g of Object.keys(t))v.OVERRIDE_PROPERTY_REGEX.test(g)&&o.push({identifiers:(0,v.overrideIdentifiersFromKey)(g),keys:Object.keys(t[g]),contents:(0,L.toValuesTree)(t[g],h=>console.error(`Conflict in default settings file: ${h}`))});super(t,c,o)}}e.DefaultConfigurationModel=l;class n{constructor(r){this._name=r,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new m}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(r,i){if(!y.isUndefinedOrNull(r)){const c=this.doParseContent(r);this.parseRaw(c,i)}}reparse(r){this._raw&&this.parseRaw(this._raw,r)}parseRaw(r,i){this._raw=r;const{contents:c,keys:t,overrides:o,restricted:g}=this.doParseRaw(r,i);this._configurationModel=new m(c,t,o),this._restrictedConfigurations=g||[]}doParseContent(r){let i={},c=null,t=[],o=[],g=[];function h(P){Array.isArray(t)?t.push(P):c!==null&&(t[c]=P)}let _={onObjectBegin:()=>{let P={};h(P),o.push(t),t=P,c=null},onObjectProperty:P=>{c=P},onObjectEnd:()=>{t=o.pop()},onArrayBegin:()=>{let P=[];h(P),o.push(t),t=P,c=null},onArrayEnd:()=>{t=o.pop()},onLiteralValue:h,onError:(P,R,W)=>{g.push({error:P,offset:R,length:W})}};if(r)try{b.visit(r,_),i=t[0]||{}}catch(P){console.error(`Error while parsing settings file ${this._name}: ${P}`),this._parseErrors=[P]}return i}doParseRaw(r,i){const c=u.Registry.as(v.Extensions.Configuration).getConfigurationProperties(),t=this.filter(r,c,!0,i);r=t.raw;const o=(0,L.toValuesTree)(r,_=>console.error(`Conflict in settings file ${this._name}: ${_}`)),g=Object.keys(r),h=this.toOverrides(r,_=>console.error(`Conflict in settings file ${this._name}: ${_}`));return{contents:o,keys:g,overrides:h,restricted:t.restricted}}filter(r,i,c,t){if(!t?.scopes&&!t?.skipRestricted)return{raw:r,restricted:[]};const o={},g=[];for(let h in r)if(v.OVERRIDE_PROPERTY_REGEX.test(h)&&c){const _=this.filter(r[h],i,!1,t);o[h]=_.raw,g.push(..._.restricted)}else{const _=i[h],P=_?typeof _.scope!="undefined"?_.scope:3:void 0;_?.restricted&&g.push(h),(P===void 0||t.scopes===void 0||t.scopes.includes(P))&&(t.skipRestricted&&_?.restricted||(o[h]=r[h]))}return{raw:o,restricted:g}}toOverrides(r,i){const c=[];for(const t of Object.keys(r))if(v.OVERRIDE_PROPERTY_REGEX.test(t)){const o={};for(const g in r[t])o[g]=r[t][g];c.push({identifiers:(0,v.overrideIdentifiersFromKey)(t),keys:Object.keys(o),contents:(0,L.toValuesTree)(o,i)})}return c}}e.ConfigurationModelParser=n;class f extends B.Disposable{constructor(r,i,c,t){super();this.userSettingsResource=r,this.scopes=i,this.fileService=t,this._onDidChange=this._register(new I.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new n(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(c.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(I.Event.any(I.Event.filter(this.fileService.onDidFilesChange,o=>o.contains(this.userSettingsResource)),I.Event.filter(this.fileService.onDidRunOperation,o=>(o.isOperation(0)||o.isOperation(1)||o.isOperation(4))&&c.isEqual(o.resource,r)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const r=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(r.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new m}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=f;class S{constructor(r,i,c=new m,t=new m,o=new D.ResourceMap,g=new m,h=new D.ResourceMap,_=!0){this._defaultConfiguration=r,this._localUserConfiguration=i,this._remoteUserConfiguration=c,this._workspaceConfiguration=t,this._folderConfigurations=o,this._memoryConfiguration=g,this._memoryConfigurationByResource=h,this._freeze=_,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new D.ResourceMap,this._userConfiguration=null}getValue(r,i,c){return this.getConsolidateConfigurationModel(i,c).getValue(r)}updateValue(r,i,c={}){let t;c.resource?(t=this._memoryConfigurationByResource.get(c.resource),t||(t=new m,this._memoryConfigurationByResource.set(c.resource,t))):t=this._memoryConfiguration,i===void 0?t.removeValue(r):t.setValue(r,i),c.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(r,i,c){const t=this.getConsolidateConfigurationModel(i,c),o=this.getFolderConfigurationModelForResource(i.resource,c),g=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,h=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this._defaultConfiguration.freeze().getValue(r),_=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.userConfiguration.freeze().getValue(r),P=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.localUserConfiguration.freeze().getValue(r),R=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.remoteUserConfiguration.freeze().getValue(r),W=c?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this._workspaceConfiguration.freeze().getValue(r):void 0,E=o?i.overrideIdentifier?o.freeze().override(i.overrideIdentifier).getValue(r):o.freeze().getValue(r):void 0,H=i.overrideIdentifier?g.override(i.overrideIdentifier).getValue(r):g.getValue(r),z=t.getValue(r),q=s.distinct(s.flatten(t.overrides.map(G=>G.identifiers))).filter(G=>t.getOverrideValue(r,G)!==void 0);return{defaultValue:h,userValue:_,userLocalValue:P,userRemoteValue:R,workspaceValue:W,workspaceFolderValue:E,memoryValue:H,value:z,default:h!==void 0?{value:this._defaultConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,user:_!==void 0?{value:this.userConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,userLocal:P!==void 0?{value:this.localUserConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,userRemote:R!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,workspace:W!==void 0?{value:this._workspaceConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,workspaceFolder:E!==void 0?{value:o?.freeze().getValue(r),override:i.overrideIdentifier?o?.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,memory:H!==void 0?{value:g.getValue(r),override:i.overrideIdentifier?g.getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:q.length?q:void 0}}keys(r){const i=this.getFolderConfigurationModelForResource(void 0,r);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(r){this._defaultConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(r){this._localUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(r){this._remoteUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(r){this._workspaceConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(r,i){this._folderConfigurations.set(r,i),this._foldersConsolidatedConfigurations.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this._foldersConsolidatedConfigurations.delete(r)}compareAndUpdateDefaultConfiguration(r,i){const c=[];if(!i){const{added:t,updated:o,removed:g}=w(this._defaultConfiguration,r);i=[...t,...o,...g]}for(const t of i)for(const o of(0,v.overrideIdentifiersFromKey)(t)){const g=this._defaultConfiguration.getKeysForOverrideIdentifier(o),h=r.getKeysForOverrideIdentifier(o),_=[...h.filter(P=>g.indexOf(P)===-1),...g.filter(P=>h.indexOf(P)===-1),...g.filter(P=>!A.equals(this._defaultConfiguration.override(o).getValue(P),r.override(o).getValue(P)))];c.push([o,_])}return this.updateDefaultConfiguration(r),{keys:i,overrides:c}}compareAndUpdateLocalUserConfiguration(r){const{added:i,updated:c,removed:t,overrides:o}=w(this.localUserConfiguration,r),g=[...i,...c,...t];return g.length&&this.updateLocalUserConfiguration(r),{keys:g,overrides:o}}compareAndUpdateRemoteUserConfiguration(r){const{added:i,updated:c,removed:t,overrides:o}=w(this.remoteUserConfiguration,r);let g=[...i,...c,...t];return g.length&&this.updateRemoteUserConfiguration(r),{keys:g,overrides:o}}compareAndUpdateWorkspaceConfiguration(r){const{added:i,updated:c,removed:t,overrides:o}=w(this.workspaceConfiguration,r);let g=[...i,...c,...t];return g.length&&this.updateWorkspaceConfiguration(r),{keys:g,overrides:o}}compareAndUpdateFolderConfiguration(r,i){const c=this.folderConfigurations.get(r),{added:t,updated:o,removed:g,overrides:h}=w(c,i);let _=[...t,...o,...g];return(_.length||!c)&&this.updateFolderConfiguration(r,i),{keys:_,overrides:h}}compareAndDeleteFolderConfiguration(r){const i=this.folderConfigurations.get(r);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:c,updated:t,removed:o,overrides:g}=w(i,void 0);return{keys:[...c,...t,...o],overrides:g}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(r,i){let c=this.getConsolidatedConfigurationModelForResource(r,i);return r.overrideIdentifier?c.override(r.overrideIdentifier):c}getConsolidatedConfigurationModelForResource({resource:r},i){let c=this.getWorkspaceConsolidatedConfiguration();if(i&&r){const t=i.getFolder(r);t&&(c=this.getFolderConsolidatedConfiguration(t.uri)||c);const o=this._memoryConfigurationByResource.get(r);o&&(c=c.merge(o))}return c}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(r){let i=this._foldersConsolidatedConfigurations.get(r);if(!i){const c=this.getWorkspaceConsolidatedConfiguration(),t=this._folderConfigurations.get(r);t?(i=c.merge(t),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(r,i)):i=c}return i}getFolderConfigurationModelForResource(r,i){if(i&&r){const c=i.getFolder(r);if(c)return this._folderConfigurations.get(c.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((r,i)=>{const{contents:c,overrides:t,keys:o}=this._folderConfigurations.get(i);return r.push([i,{contents:c,overrides:t,keys:o}]),r},[])}}allKeys(){const r=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>r.add(i)),this.userConfiguration.freeze().keys.forEach(i=>r.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(c=>r.add(c))),[...r.values()]}allOverrideIdentifiers(){const r=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(c=>r.add(c))),[...r.values()]}getAllKeysForOverrideIdentifier(r){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(r).forEach(c=>i.add(c)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(c=>i.add(c)),this._workspaceConfiguration.getKeysForOverrideIdentifier(r).forEach(c=>i.add(c)),this._folderConfigurations.forEach(c=>c.getKeysForOverrideIdentifier(r).forEach(t=>i.add(t))),[...i.values()]}static parse(r){const i=this.parseConfigurationModel(r.defaults),c=this.parseConfigurationModel(r.user),t=this.parseConfigurationModel(r.workspace),o=r.folders.reduce((g,h)=>(g.set(M.URI.revive(h[0]),this.parseConfigurationModel(h[1])),g),new D.ResourceMap);return new S(i,c,new m,t,o,new m,new D.ResourceMap,!1)}static parseConfigurationModel(r){return new m(r.contents,r.keys,r.overrides).freeze()}}e.Configuration=S;function k(...T){if(T.length===0)return{keys:[],overrides:[]};if(T.length===1)return T[0];const r=new Set,i=new Map;for(const t of T)t.keys.forEach(o=>r.add(o)),t.overrides.forEach(([o,g])=>{const h=(0,D.getOrSet)(i,o,new Set);g.forEach(_=>h.add(_))});const c=[];return i.forEach((t,o)=>c.push([o,[...t.values()]])),{keys:[...r.values()],overrides:c}}e.mergeChanges=k;class d{constructor(r,i,c,t){this.change=r,this.previous=i,this.currentConfiguraiton=c,this.currentWorkspace=t,this._previousConfiguration=void 0;const o=new Set;r.keys.forEach(h=>o.add(h)),r.overrides.forEach(([,h])=>h.forEach(_=>o.add(_))),this.affectedKeys=[...o.values()];const g=new m;this.affectedKeys.forEach(h=>g.setValue(h,{})),this.affectedKeysTree=g.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=S.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(r,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,r)){if(i){const c=this.previousConfiguration?this.previousConfiguration.getValue(r,i,this.previous?.workspace):void 0,t=this.currentConfiguraiton.getValue(r,i,this.currentWorkspace);return!A.equals(c,t)}return!0}return!1}doesAffectedKeysTreeContains(r,i){let c=(0,L.toValuesTree)({[i]:!0},()=>{}),t;for(;typeof c=="object"&&(t=Object.keys(c)[0]);){if(r=r[t],!r)return!1;c=c[t]}return!0}}e.ConfigurationChangeEvent=d;class p extends d{constructor(r,i,c,t){super({keys:r.allKeys(),overrides:[]},void 0,r,i);this.source=c,this.sourceConfig=t}}e.AllKeysConfigurationChangeEvent=p;function w(T,r){const{added:i,removed:c,updated:t}=a(r,T),o=[],g=T?.getAllOverrideIdentifiers()||[],h=r?.getAllOverrideIdentifiers()||[];if(r){const _=h.filter(P=>!g.includes(P));for(const P of _)o.push([P,r.getKeysForOverrideIdentifier(P)])}if(T){const _=g.filter(P=>!h.includes(P));for(const P of _)o.push([P,T.getKeysForOverrideIdentifier(P)])}if(r&&T){for(const _ of g)if(h.includes(_)){const P=a({contents:T.getOverrideValue(void 0,_)||{},keys:T.getKeysForOverrideIdentifier(_)},{contents:r.getOverrideValue(void 0,_)||{},keys:r.getKeysForOverrideIdentifier(_)});o.push([_,[...P.added,...P.removed,...P.updated]])}}return{added:i,removed:c,updated:t,overrides:o}}function a(T,r){const i=T?r?T.keys.filter(o=>r.keys.indexOf(o)===-1):[...T.keys]:[],c=r?T?r.keys.filter(o=>T.keys.indexOf(o)===-1):[...r.keys]:[],t=[];if(T&&r){for(const o of r.keys)if(T.keys.indexOf(o)!==-1){const g=(0,L.getConfigurationValue)(r.contents,o),h=(0,L.getConfigurationValue)(T.contents,o);A.equals(g,h)||t.push(o)}}return{added:i,removed:c,updated:t}}}),define(Ee[81],we([1,0,3]),function(J,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,s.createDecorator)("remoteAuthorityResolverService");var I;(function(B){B.Unknown="Unknown",B.NotAvailable="NotAvailable",B.TemporarilyNotAvailable="TemporarilyNotAvailable",B.NoResolverFound="NoResolverFound"})(I=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class b extends Error{constructor(D,A=I.Unknown,y){super(D);this._message=D,this._code=A,this._detail=y,this.isHandled=A===I.NotAvailable&&y===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,b.prototype)}static isTemporarilyNotAvailable(D){return D instanceof b&&D._code===I.TemporarilyNotAvailable}static isNoResolverFound(D){return D instanceof b&&D._code===I.NoResolverFound}static isHandled(D){return D instanceof b&&D.isHandled}}e.RemoteAuthorityResolverError=b}),define(Ee[82],we([1,0,10]),function(J,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteName=e.getRemoteAuthority=void 0;function I(B){return B.scheme===s.Schemas.vscodeRemote?B.authority:void 0}e.getRemoteAuthority=I;function b(B){if(!B)return;const D=B.indexOf("+");return D<0?B:B.substr(0,D)}e.getRemoteName=b}),define(Ee[25],we([1,0,9,3,82]),function(J,e,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function B(u){if(typeof u=="object"&&u!==null&&u.supported!==!0)return u.description}e.getWorkspaceSupportTypeMessage=B;function D(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.isIExtensionIdentifier=D,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(u){u[u.System=0]="System",u[u.User=1]="User"})(A=e.ExtensionType||(e.ExtensionType={}));class y{constructor(m){this.value=m,this._lower=m.toLowerCase()}static equals(m,l){if(typeof m=="undefined"||m===null)return typeof l=="undefined"||l===null;if(typeof l=="undefined"||l===null)return!1;if(typeof m=="string"||typeof l=="string"){let n=typeof m=="string"?m:m.value,f=typeof l=="string"?l:l.value;return s.equalsIgnoreCase(n,f)}return m._lower===l._lower}static toKey(m){return typeof m=="string"?m.toLowerCase():m._lower}}e.ExtensionIdentifier=y;function M(u){return u.contributes&&u.contributes.localizations?u.contributes.localizations.length>0:!1}e.isLanguagePackExtension=M;function L(u){return u.contributes&&u.contributes.authentication?u.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=L;function v(u,m){if(m){const l=`onResolveRemoteAuthority:${(0,b.getRemoteName)(m)}`;return u.activationEvents?.indexOf(l)!==-1}return!1}e.isResolverExtension=v,e.IBuiltinExtensionsScannerService=(0,I.createDecorator)("IBuiltinExtensionsScannerService")}),define(Ee[144],we([1,0,9,25]),function(J,e,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function b(l,n){return l.uuid&&n.uuid?l.uuid===n.uuid:l.id===n.id?!0:(0,s.compareIgnoreCase)(l.id,n.id)===0}e.areSameExtensions=b;class B{constructor(n,f){this.version=f,this.id=n.id,this.uuid=n.uuid}key(){return`${this.id}-${this.version}`}equals(n){return n instanceof B?b(this,n)&&this.version===n.version:!1}}e.ExtensionIdentifierWithVersion=B;function D(l,n){return`${l}.${n}`}e.getExtensionId=D;function A(l){return l.toLocaleLowerCase()}e.adoptToGalleryExtensionId=A;function y(l,n){return A(D(l,n))}e.getGalleryExtensionId=y;function M(l,n){const f=[],S=k=>{for(const d of f)if(d.some(p=>b(n(p),n(k))))return d;return null};for(const k of l){const d=S(k);d?d.push(k):f.push([k])}return f}e.groupByExtension=M;function L(l){return{id:l.identifier.id,name:l.manifest.name,galleryId:null,publisherId:l.publisherId,publisherName:l.manifest.publisher,publisherDisplayName:l.publisherDisplayName,dependencies:l.manifest.extensionDependencies&&l.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=L;function v(l){return{id:l.identifier.id,name:l.name,galleryId:l.identifier.uuid,publisherId:l.publisherId,publisherName:l.publisher,publisherDisplayName:l.publisherDisplayName,isPreReleaseVersion:l.properties.isPreReleaseVersion,dependencies:!!(l.properties.dependencies&&l.properties.dependencies.length>0),...l.telemetryData}}e.getGalleryExtensionTelemetryData=v,e.BetterMergeId=new I.ExtensionIdentifier("pprice.better-merge");function u(l){const n=new Set;if(l.malicious)for(const f of l.malicious)n.add(f.id);return n}e.getMaliciousExtensionsSet=u;function m(l,n){const f=[],S=n.manifest.extensionDependencies?.slice(0)??[];for(;S.length;){const k=S.shift();if(k&&f.every(d=>!b(d.identifier,{id:k}))){const d=l.filter(p=>b(p.identifier,{id:k}));d.length===1&&(f.push(d[0]),S.push(...d[0].manifest.extensionDependencies?.slice(0)??[]))}}return f}e.getExtensionDependencies=m}),define(Ee[145],we([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class s{constructor(b){this._callback=b,this._terminalBufferMap=new Map}dispose(){for(const b of this._terminalBufferMap.values())b.dispose()}startBuffering(b,B,D=5){let A;return A=B(y=>{const M=typeof y=="string"?y:y.data;let L=this._terminalBufferMap.get(b);if(L){L.data.push(M);return}const v=setTimeout(()=>this.flushBuffer(b),D);L={data:[M],timeoutId:v,dispose:()=>{clearTimeout(v),this.flushBuffer(b),A.dispose()}},this._terminalBufferMap.set(b,L)}),A}stopBuffering(b){const B=this._terminalBufferMap.get(b);B&&B.dispose()}flushBuffer(b){const B=this._terminalBufferMap.get(b);B&&(this._terminalBufferMap.delete(b),this._callback(b,B.data.join("")))}}e.TerminalDataBufferer=s}),define(Ee[146],we([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var s;(function(I){I.DARK="dark",I.LIGHT="light",I.HIGH_CONTRAST="hc"})(s=e.ColorScheme||(e.ColorScheme={}))}),define(Ee[57],we([1,0,106,5,6,3,37,146]),function(J,e,s,I,b,B,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,B.createDecorator)("themeService");var y;(function(f){function S(k){return k&&typeof k=="object"&&typeof k.id=="string"}f.isThemeColor=S})(y=e.ThemeColor||(e.ThemeColor={}));function M(f){return{id:f}}e.themeColorFromId=M;var L;(function(f){function S(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color=="undefined"||y.isThemeColor(i.color))}f.isThemeIcon=S;const k=new RegExp(`^\\$\\((${s.CSSIcon.iconNameExpression}(?:${s.CSSIcon.iconModifierExpression})?)\\)$`);function d(i){const c=k.exec(i);if(!c)return;let[,t]=c;return{id:t}}f.fromString=d;function p(i){return{id:i}}f.fromId=p;function w(i,c){let t=i.id;const o=t.lastIndexOf("~");return o!==-1&&(t=t.substring(0,o)),c&&(t=`${t}~${c}`),{id:t}}f.modify=w;function a(i){const c=i.id.lastIndexOf("~");if(c!==-1)return i.id.substring(c+1)}f.getModifier=a;function T(i,c){return i.id===c.id&&i.color?.id===c.color?.id}f.isEqual=T;function r(i,c){return{id:i.id,color:c?M(c):void 0}}f.asThemeIcon=r,f.asClassNameArray=s.CSSIcon.asClassNameArray,f.asClassName=s.CSSIcon.asClassName,f.asCSSSelector=s.CSSIcon.asCSSSelector})(L=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=s.Codicon.file,e.FolderThemeIcon=s.Codicon.folder;function v(f){switch(f){case A.ColorScheme.DARK:return"vs-dark";case A.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=v,e.Extensions={ThemingContribution:"base.contributions.theming"};class u{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new I.Emitter}onColorThemeChange(S){return this.themingParticipants.push(S),this.onThemingParticipantAddedEmitter.fire(S),(0,b.toDisposable)(()=>{const k=this.themingParticipants.indexOf(S);this.themingParticipants.splice(k,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let m=new u;D.Registry.add(e.Extensions.ThemingContribution,m);function l(f){return m.onColorThemeChange(f)}e.registerThemingParticipant=l;class n extends b.Disposable{constructor(S){super();this.themeService=S,this.theme=S.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(k=>this.onThemeChange(k)))}onThemeChange(S){this.theme=S,this.updateStyles()}updateStyles(){}getColor(S,k){let d=this.theme.getColor(S);return d&&k&&(d=k(d,this.theme)),d?d.toString():null}}e.Themable=n}),define(Ee[147],we([1,0,5,23,3,12]),function(J,e,s,I,b,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,b.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,b.createDecorator)("sharedTunnelsService");var D;(function(l){l.Http="http",l.Https="https"})(D=e.TunnelProtocol||(e.TunnelProtocol={}));var A;(function(l){l.ConstantPrivate="constantPrivate",l.Private="private",l.Public="public"})(A=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var y;(function(l){l[l.Notify=1]="Notify",l[l.OpenBrowser=2]="OpenBrowser",l[l.OpenPreview=3]="OpenPreview",l[l.Silent=4]="Silent",l[l.Ignore=5]="Ignore",l[l.OpenBrowserOnce=6]="OpenBrowserOnce"})(y=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function M(l){if(l.scheme!=="http"&&l.scheme!=="https")return;const n=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(l.authority);if(!!n)return{address:n[1],port:+n[2]}}e.extractLocalHostUriMetaDataForPortMapping=M,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function L(l){return e.LOCALHOST_ADDRESSES.indexOf(l)>=0}e.isLocalhost=L,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function v(l){return e.ALL_INTERFACES_ADDRESSES.indexOf(l)>=0}e.isAllInterfaces=v;function u(l,n){return n?n!==1&&l<1024:!I.isWindows&&l<1024}e.isPortPrivileged=u;let m=class{constructor(n){this.logService=n,this._onTunnelOpened=new s.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new s.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new s.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(n){return this._tunnelProvider=n,n?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(n){this._canElevate=n.elevation,this._privacyOptions=n.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const n=[],f=Array.from(this._tunnels.values());for(let S of f){const k=Array.from(S.values());for(let d of k){const p=await d.value;p&&n.push(p)}}return n}async dispose(){for(const n of this._tunnels.values()){for(const{value:f}of n.values())await f.then(S=>S?.dispose());n.clear()}this._tunnels.clear()}openTunnel(n,f,S,k,d=!1,p=A.Private,w){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${f}:${S} on local port ${k}.`),!n)return;f||(f="localhost");const a=this.retainOrCreateTunnel(n,f,S,k,d,p,w);return a?a.then(T=>{if(!T){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(f,S);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(T);return(T.tunnelRemoteHost!==f||T.tunnelRemotePort!==S)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),a)}makeTunnel(n){return{tunnelRemotePort:n.tunnelRemotePort,tunnelRemoteHost:n.tunnelRemoteHost,tunnelLocalPort:n.tunnelLocalPort,localAddress:n.localAddress,privacy:n.privacy,protocol:n.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${n.tunnelRemoteHost}:${n.tunnelRemotePort} `);const f=this._tunnels.get(n.tunnelRemoteHost);if(f){const S=f.get(n.tunnelRemotePort);S&&(S.refcount--,await this.tryDisposeTunnel(n.tunnelRemoteHost,n.tunnelRemotePort,S))}}}}async tryDisposeTunnel(n,f,S){if(S.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${n}:${f}.`);const k=S.value.then(async d=>{d&&(await d.dispose(!0),this._onTunnelClosed.fire({host:d.tunnelRemoteHost,port:d.tunnelRemotePort}))});return this._tunnels.has(n)&&this._tunnels.get(n).delete(f),k}}async closeTunnel(n,f){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${n}:${f} `);const S=this._tunnels.get(n);if(S&&S.has(f)){const k=S.get(f);k.refcount=0,await this.tryDisposeTunnel(n,f,k)}}addTunnelToMap(n,f,S){this._tunnels.has(n)||this._tunnels.set(n,new Map),this._tunnels.get(n).set(f,{refcount:1,value:S})}async removeEmptyTunnelFromMap(n,f){const S=this._tunnels.get(n);S&&(await S.get(f)||S.delete(f),S.size===0&&this._tunnels.delete(n))}getTunnelFromMap(n,f){let S=[n];L(n)?(S.push(...e.LOCALHOST_ADDRESSES),S.push(...e.ALL_INTERFACES_ADDRESSES)):v(n)&&S.push(...e.ALL_INTERFACES_ADDRESSES);const k=S.map(d=>this._tunnels.get(d));for(const d of k){const p=d?.get(f);if(p)return p}}canTunnel(n){return!!M(n)}createWithProvider(n,f,S,k,d,p,w){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${f}:${S} on local port ${k}.`);const T={elevationRequired:d?u(k===void 0?S:k):!1},r={remoteAddress:{host:f,port:S},localAddressPort:k,privacy:p,public:p!==A.Private,protocol:w},i=n.forwardPort(r,T);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),i&&this.addTunnelToMap(f,S,i),i}};m=Fe([Ne(0,B.ILogService)],m),e.AbstractTunnelService=m}),define(Ee[148],we([1,0,10]),function(J,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function I(A){return A.scheme!==s.Schemas.file&&A.scheme!==s.Schemas.vscodeRemote}e.isVirtualResource=I;function b(A){if(A.folders.length)return A.folders.every(y=>I(y.uri))?A.folders[0].uri:void 0;if(A.configuration&&I(A.configuration))return A.configuration}e.getVirtualWorkspaceLocation=b;function B(A){return b(A)?.scheme}e.getVirtualWorkspaceScheme=B;function D(A){return b(A)!==void 0}e.isVirtualWorkspace=D}),define(Ee[46],we([1,0,121,17,22,24,2,3,10]),function(J,e,s,I,b,B,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,A.createDecorator)("contextService");function M(r){const i=r;return typeof i?.id=="string"&&D.URI.isUri(i.uri)}e.isSingleFolderWorkspaceIdentifier=M;function L(r){if(r.configuration)return{id:r.id,configPath:r.configuration};if(r.folders.length===1)return{id:r.id,uri:r.folders[0].uri}}e.toWorkspaceIdentifier=L;function v(r){const i=r;return typeof i?.id=="string"&&D.URI.isUri(i.configPath)}e.isWorkspaceIdentifier=v;function u(r){const i=r;if(i?.uri)return{id:i.id,uri:D.URI.revive(i.uri)};const c=r;if(c?.configPath)return{id:c.id,configPath:D.URI.revive(c.configPath)};if(r?.id)return{id:r.id}}e.reviveIdentifier=u;var m;(function(r){r[r.EMPTY=1]="EMPTY",r[r.FOLDER=2]="FOLDER",r[r.WORKSPACE=3]="WORKSPACE"})(m=e.WorkbenchState||(e.WorkbenchState={}));function l(r){const i=r;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&Array.isArray(i.folders))}e.isWorkspace=l;function n(r){const i=r;return!!(i&&typeof i=="object"&&D.URI.isUri(i.uri)&&typeof i.name=="string"&&typeof i.toResource=="function")}e.isWorkspaceFolder=n;class f{constructor(i,c,t,o,g){this._id=i,this._transient=t,this._configuration=o,this._ignorePathCasing=g,this._foldersMap=b.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=c}update(i){this._id=i.id,this._configuration=i.configuration,this._transient=i.transient,this._ignorePathCasing=i._ignorePathCasing,this.folders=i.folders}get folders(){return this._folders}set folders(i){this._folders=i,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(i){this._configuration=i}getFolder(i){return i&&this._foldersMap.findSubstr(i.with({scheme:i.scheme,authority:i.authority,path:i.path}))||null}updateFoldersMap(){this._foldersMap=b.TernarySearchTree.forUris(this._ignorePathCasing);for(const i of this.folders)this._foldersMap.set(i.uri,i)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=f;class S{constructor(i,c){this.raw=c,this.uri=i.uri,this.index=i.index,this.name=i.name}toResource(i){return(0,B.joinPath)(this.uri,i)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=S;function k(r){return new S({uri:r,index:0,name:(0,B.basenameOrAuthority)(r)},{uri:r.toString()})}e.toWorkspaceFolder=k,e.WORKSPACE_EXTENSION="code-workspace";const d=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,s.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function p(r,i){return B.extUriBiasedIgnorePathCase.isEqualOrParent(r,i.untitledWorkspacesHome)}e.isUntitledWorkspace=p;function w(r){let i;return D.URI.isUri(r)?i=r:i=r.configuration,i?.scheme===y.Schemas.tmp}e.isTemporaryWorkspace=w;function a(r,i){return!p(r,i)&&!w(r)}e.isSavedWorkspace=a;function T(r){return(typeof r=="string"?(0,I.extname)(r):(0,B.extname)(r))===d}e.hasWorkspaceFileExtension=T}),define(Ee[58],we([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class s{constructor(b){this.id=b,this._data=new Map,this._idPool=1}add(b){const B=this._idPool++;return this._data.set(B,b),this.logDebugInfo(),B}get(b,B){return this._data.has(b)?this._data.get(b)[B]:void 0}delete(b){this._data.delete(b),this.logDebugInfo()}logDebugInfo(){!s.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=s,s.enableDebugLogging=!1}),define(Ee[30],we([1,0,10,24,3]),function(J,e,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class B{constructor(){this._systemSchemes=new Set(Object.keys(s.Schemas)),this._providerInfo=new Map,this.extUri=new I.ExtUri(A=>{const y=this._providerInfo.get(A.scheme);return!(y===void 0||y&1024)})}$acceptProviderInfos(A,y){y===null?this._providerInfo.delete(A.scheme):this._providerInfo.set(A.scheme,y)}isFreeScheme(A){return!this._providerInfo.has(A)&&!this._systemSchemes.has(A)}getCapabilities(A){return this._providerInfo.get(A)}}e.ExtHostFileSystemInfo=B,e.IExtHostFileSystemInfo=(0,b.createDecorator)("IExtHostFileSystemInfo")}),define(Ee[27],we([1,0,3]),function(J,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,s.createDecorator)("IExtHostInitDataService")}),define(Ee[149],we([1,0,13]),function(J,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class I{constructor(D,A,y){this._deferredPromises=new Map,this._id=D,this._shared=A,this._storage=y,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(M=>(this._value=M,this)),this._storageListener=this._storage.onDidChangeStorage(M=>{M.shared===this._shared&&M.key===this._id&&(this._value=M.value)}),this._scheduler=new s.RunOnceScheduler(()=>{const M=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const L of M.values())L.complete()}catch(L){for(const v of M.values())v.error(L)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,D])=>D!==void 0).map(([D])=>D)}get whenReady(){return this._init}get(D,A){let y=this._value[D];return typeof y=="undefined"&&(y=A),y}update(D,A){this._value[D]=A;let y=this._deferredPromises.get(D);if(y!==void 0)return y.p;const M=new s.DeferredPromise;return this._deferredPromises.set(D,M),this._scheduler.isScheduled()||this._scheduler.schedule(),M.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=I;class b extends I{constructor(D,A){super(D.identifier.value,!0,A);this._extension=D}setKeysForSync(D){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},D)}}e.ExtensionGlobalMemento=b}),define(Ee[150],we([1,0,5,2,12]),function(J,e,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let B=class{constructor(A,y){this._logService=A,this._notebooksAndEditors=y,this._onDidChangeNotebookDocumentMetadata=new s.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new s.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(A,y,M){this._notebooksAndEditors.getNotebookDocument(I.URI.revive(A)).acceptModelChanged(y.value,M)}$acceptDirtyStateChanged(A,y){this._notebooksAndEditors.getNotebookDocument(I.URI.revive(A)).acceptDirty(y)}$acceptModelSaved(A){const y=this._notebooksAndEditors.getNotebookDocument(I.URI.revive(A));this._onDidSaveNotebookDocument.fire(y.apiNotebook)}$acceptDocumentPropertiesChanged(A,y){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",A.path,y);const M=this._notebooksAndEditors.getNotebookDocument(I.URI.revive(A));M.acceptDocumentPropertiesChanged(y),y.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:M.apiNotebook})}};B=Fe([Ne(0,b.ILogService)],B),e.ExtHostNotebookDocuments=B}),define(Ee[14],we([1,0,3]),function(J,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,s.createDecorator)("IExtHostRpcService");class I{constructor(B){this.getProxy=B.getProxy.bind(B),this.set=B.set.bind(B),this.assertRegistered=B.assertRegistered.bind(B),this.drain=B.drain.bind(B)}}e.ExtHostRpcService=I});var je=this&&this.__classPrivateFieldSet||function(J,e,s,I,b){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!b:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?b.call(J,s):b?b.value=s:e.set(J,s),s},De=this&&this.__classPrivateFieldGet||function(J,e,s,I){if(s==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?I:s==="a"?I.call(J):I?I.value:e.get(J)};define(Ee[151],we([1,0,25,5]),function(J,e,s,I){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class B{constructor(A,y){b.set(this,void 0),this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this._id=s.ExtensionIdentifier.toKey(A.identifier),je(this,b,y,"f"),De(this,b,"f").onDidChangePassword(M=>{M.extensionId===this._id&&this._onDidChange.fire({key:M.key})})}get(A){return De(this,b,"f").get(this._id,A)}store(A,y){return De(this,b,"f").store(this._id,A,y)}delete(A){return De(this,b,"f").delete(this._id,A)}}e.ExtensionSecrets=B,b=new WeakMap}),define(Ee[83],we([1,0,3,5]),function(J,e,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class b{constructor(){this._onDidChangeTelemetryEnabled=new I.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=new I.Emitter,this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._level=0}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._level>=2,isUsageEnabled:this._level>=3}}$initializeTelemetryLevel(D){this._level=D}$onDidChangeTelemetryLevel(D){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=D,this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails())}}e.ExtHostTelemetry=b,e.IExtHostTelemetry=(0,s.createDecorator)("IExtHostTelemetry")}),define(Ee[47],we([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var s;(function(k){k[k.Upsert=0]="Upsert",k[k.RemoveChild=1]="RemoveChild",k[k.Invalidated=2]="Invalidated",k[k.SetProp=3]="SetProp",k[k.Bulk=4]="Bulk"})(s=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const I=new WeakMap,b=(k,d)=>{const p={controllerId:d};return I.set(k,p),p};e.createPrivateApiFor=b;const B=k=>I.get(k);e.getPrivateApiFor=B;const D=(k,d,p,w)=>{let a=p;return{enumerable:!0,configurable:!1,get(){return a},set(T){if(!w(a,T)){const r=a;a=T,k.listener?.({op:3,key:d,value:T,previous:r})}}}},A=(k,d)=>k===d,y={range:(k,d)=>k===d?!0:!k||!d?!1:k.isEqual(d),label:A,description:A,sortText:A,busy:A,error:A,canResolveChildren:A,tags:(k,d)=>!(k.length!==d.length||k.some(p=>!d.find(w=>p.id===w.id)))},M=Object.keys(y),L=(k,d)=>({range:D(k,"range",void 0,y.range),label:D(k,"label",d,y.label),description:D(k,"description",void 0,y.description),sortText:D(k,"sortText",void 0,y.sortText),canResolveChildren:D(k,"canResolveChildren",!1,y.canResolveChildren),busy:D(k,"busy",!1,y.busy),error:D(k,"error",void 0,y.error),tags:D(k,"tags",[],y.tags)}),v=(k,d)=>{const p=new Map;for(const w of M)y[w](k[w],d[w])||p.set(w,d[w]);return p};e.diffTestItems=v;class u extends Error{constructor(d){super(`Attempted to insert a duplicate test item ID ${d}`)}}e.DuplicateTestItemError=u;class m extends Error{constructor(d){super(`TestItem with ID "${d}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=m;class l extends Error{constructor(d,p,w){super(`TestItem with ID "${d}" is from controller "${p}" and cannot be added as a child of an item from controller "${w}".`)}}e.MixedTestItemController=l;const n=k=>{const d=(0,e.getPrivateApiFor)(k);let p=new Map;return{get size(){return p.size},forEach(w,a){for(const T of p.values())w.call(a,T,this)},replace(w){const a=new Map,T=new Set(p.keys()),r={op:4,ops:[]};for(const i of w){if(!(i instanceof f))throw new m(i.id);const c=(0,e.getPrivateApiFor)(i).controllerId;if(c!==d.controllerId)throw new l(i.id,c,d.controllerId);if(a.has(i.id))throw new u(i.id);a.set(i.id,i),T.delete(i.id),r.ops.push({op:0,item:i})}for(const i of T.keys())r.ops.push({op:1,id:i});d.listener?.(r),p=a},add(w){if(!(w instanceof f))throw new m(w.id);p.set(w.id,w),d.listener?.({op:0,item:w})},delete(w){p.delete(w)&&d.listener?.({op:1,id:w})},get(w){return p.get(w)},toJSON(){return Array.from(p.values())},[Symbol.iterator](){return p.values()}}};class f{constructor(d,p,w,a){if(p.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(p)} symbol`);const T=(0,e.createPrivateApiFor)(this,d);Object.defineProperties(this,{id:{value:p,enumerable:!0,writable:!1},uri:{value:a,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return T.parent instanceof S?void 0:T.parent}},children:{value:n(this),enumerable:!0,writable:!1},...L(T,w)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=f;class S extends f{constructor(d,p){super(d,d,p,void 0)}}e.TestItemRootImpl=S}),define(Ee[59],we([1,0,3,147,5,14]),function(J,e,s,I,b,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var D;(function(y){function M(v){return{remoteAddress:v.remoteAddress,localAddress:v.localAddress,public:!!v.public,privacy:v.privacy??(v.public?I.TunnelPrivacyId.Public:I.TunnelPrivacyId.Private),protocol:v.protocol}}y.fromApiTunnel=M;function L(v){return{remoteAddress:{host:v.tunnelRemoteHost,port:v.tunnelRemotePort},localAddress:v.localAddress,public:v.privacy!==I.TunnelPrivacyId.ConstantPrivate&&v.privacy!==I.TunnelPrivacyId.ConstantPrivate,privacy:v.privacy,protocol:v.protocol}}y.fromServiceTunnel=L})(D=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,s.createDecorator)("IExtHostTunnelService");let A=class{constructor(M){this.onDidChangeTunnels=new b.Emitter().event}async $applyCandidateFilter(M){return M}async openTunnel(M,L){}async getTunnels(){return[]}async setTunnelFactory(M){return{dispose:()=>{}}}registerPortsAttributesProvider(M,L){return{dispose:()=>{}}}async $providePortAttributes(M,L,v,u,m){return[]}async $forwardPort(M,L){}async $closeTunnel(M){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};A=Fe([Ne(0,B.IExtHostRpcService)],A),e.ExtHostTunnelService=A});var je=this&&this.__classPrivateFieldSet||function(J,e,s,I,b){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!b:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?b.call(J,s):b?b.value=s:e.set(J,s),s},De=this&&this.__classPrivateFieldGet||function(J,e,s,I){if(s==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?I:s==="a"?I.call(J):I?I.value:e.get(J)};define(Ee[7],we([1,0,16,15,72,22,71,9,11,2,36,45,81]),function(J,e,s,I,b,B,D,A,y,M,L,v,u){"use strict";var m,l,n,f,S,k,d,p,w,a,T,r,i,c,t,o,g,h,_,P;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeDataTransfer=e.TreeDataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function R(V){function U(){return Reflect.construct(V,arguments,this.constructor)}return Object.defineProperty(U,"name",Object.getOwnPropertyDescriptor(V,"name")),Object.setPrototypeOf(U,V),Object.setPrototypeOf(U.prototype,V.prototype),U}let W=S=class{constructor(U){m.set(this,void 0),je(this,m,U,"f")}static from(...U){let ie=U;return new S(function(){if(ie){for(const be of ie)be&&typeof be.dispose=="function"&&be.dispose();ie=void 0}})}dispose(){typeof De(this,m,"f")=="function"&&(De(this,m,"f").call(this),je(this,m,void 0,"f"))}};m=new WeakMap,W=S=Fe([R],W),e.Disposable=W;let E=k=class{constructor(U,ie){if(U<0)throw(0,I.illegalArgument)("line must be non-negative");if(ie<0)throw(0,I.illegalArgument)("character must be non-negative");this._line=U,this._character=ie}static Min(...U){if(U.length===0)throw new TypeError;let ie=U[0];for(let be=1;be<U.length;be++){const He=U[be];He.isBefore(ie)&&(ie=He)}return ie}static Max(...U){if(U.length===0)throw new TypeError;let ie=U[0];for(let be=1;be<U.length;be++){const He=U[be];He.isAfter(ie)&&(ie=He)}return ie}static isPosition(U){if(!U)return!1;if(U instanceof k)return!0;let{line:ie,character:be}=U;return typeof ie=="number"&&typeof be=="number"}static of(U){if(U instanceof k)return U;if(this.isPosition(U))return new k(U.line,U.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}isBefore(U){return this._line<U._line?!0:U._line<this._line?!1:this._character<U._character}isBeforeOrEqual(U){return this._line<U._line?!0:U._line<this._line?!1:this._character<=U._character}isAfter(U){return!this.isBeforeOrEqual(U)}isAfterOrEqual(U){return!this.isBefore(U)}isEqual(U){return this._line===U._line&&this._character===U._character}compareTo(U){return this._line<U._line?-1:this._line>U.line?1:this._character<U._character?-1:this._character>U._character?1:0}translate(U,ie=0){if(U===null||ie===null)throw(0,I.illegalArgument)();let be;return typeof U=="undefined"?be=0:typeof U=="number"?be=U:(be=typeof U.lineDelta=="number"?U.lineDelta:0,ie=typeof U.characterDelta=="number"?U.characterDelta:0),be===0&&ie===0?this:new k(this.line+be,this.character+ie)}with(U,ie=this.character){if(U===null||ie===null)throw(0,I.illegalArgument)();let be;return typeof U=="undefined"?be=this.line:typeof U=="number"?be=U:(be=typeof U.line=="number"?U.line:this.line,ie=typeof U.character=="number"?U.character:this.character),be===this.line&&ie===this.character?this:new k(be,ie)}toJSON(){return{line:this.line,character:this.character}}};E=k=Fe([R],E),e.Position=E;let H=d=class{constructor(U,ie,be,He){let Ke,Ye;if(typeof U=="number"&&typeof ie=="number"&&typeof be=="number"&&typeof He=="number"?(Ke=new E(U,ie),Ye=new E(be,He)):E.isPosition(U)&&E.isPosition(ie)&&(Ke=E.of(U),Ye=E.of(ie)),!Ke||!Ye)throw new Error("Invalid arguments");Ke.isBefore(Ye)?(this._start=Ke,this._end=Ye):(this._start=Ye,this._end=Ke)}static isRange(U){return U instanceof d?!0:U?E.isPosition(U.start)&&E.isPosition(U.end):!1}static of(U){if(U instanceof d)return U;if(this.isRange(U))return new d(U.start,U.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}contains(U){return d.isRange(U)?this.contains(U.start)&&this.contains(U.end):E.isPosition(U)?!(E.of(U).isBefore(this._start)||this._end.isBefore(U)):!1}isEqual(U){return this._start.isEqual(U._start)&&this._end.isEqual(U._end)}intersection(U){const ie=E.Max(U.start,this._start),be=E.Min(U.end,this._end);if(!ie.isAfter(be))return new d(ie,be)}union(U){if(this.contains(U))return this;if(U.contains(this))return U;const ie=E.Min(U.start,this._start),be=E.Max(U.end,this.end);return new d(ie,be)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(U,ie=this.end){if(U===null||ie===null)throw(0,I.illegalArgument)();let be;return U?E.isPosition(U)?be=U:(be=U.start||this.start,ie=U.end||this.end):be=this.start,be.isEqual(this._start)&&ie.isEqual(this.end)?this:new d(be,ie)}toJSON(){return[this.start,this.end]}};H=d=Fe([R],H),e.Range=H;let z=p=class extends H{constructor(U,ie,be,He){let Ke,Ye;if(typeof U=="number"&&typeof ie=="number"&&typeof be=="number"&&typeof He=="number"?(Ke=new E(U,ie),Ye=new E(be,He)):E.isPosition(U)&&E.isPosition(ie)&&(Ke=E.of(U),Ye=E.of(ie)),!Ke||!Ye)throw new Error("Invalid arguments");super(Ke,Ye);this._anchor=Ke,this._active=Ye}static isSelection(U){return U instanceof p?!0:U?H.isRange(U)&&E.isPosition(U.anchor)&&E.isPosition(U.active)&&typeof U.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};z=p=Fe([R],z),e.Selection=z;class q{constructor(U,ie,be){if(typeof U!="string"||U.length===0)throw(0,I.illegalArgument)("host");if(typeof ie!="number"||ie===0||Math.round(ie)!==ie)throw(0,I.illegalArgument)("port");if(typeof be!="undefined"&&(typeof be!="string"||be.length===0||!/^[0-9A-Za-z\-]+$/.test(be)))throw(0,I.illegalArgument)("connectionToken");this.host=U,this.port=Math.round(ie),this.connectionToken=be}}e.ResolvedAuthority=q;class G extends Error{constructor(U,ie=u.RemoteAuthorityResolverErrorCode.Unknown,be){super(U);this._message=U,this._code=ie,this._detail=be,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,G.prototype)}static NotAvailable(U,ie){return new G(U,u.RemoteAuthorityResolverErrorCode.NotAvailable,ie)}static TemporarilyNotAvailable(U){return new G(U,u.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=G;var j;(function(V){V[V.LF=1]="LF",V[V.CRLF=2]="CRLF"})(j=e.EndOfLine||(e.EndOfLine={}));var $;(function(V){V[V.Replace=1]="Replace",V[V.Append=2]="Append",V[V.Prepend=3]="Prepend"})($=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let ee=w=class{constructor(U,ie){this._range=U,this._newText=ie}static isTextEdit(U){return U instanceof w?!0:U?H.isRange(U)&&typeof U.newText=="string":!1}static replace(U,ie){return new w(U,ie)}static insert(U,ie){return w.replace(new H(U,U),ie)}static delete(U){return w.replace(U,"")}static setEndOfLine(U){const ie=new w(new H(new E(0,0),new E(0,0)),"");return ie.newEol=U,ie}get range(){return this._range}set range(U){if(U&&!H.isRange(U))throw(0,I.illegalArgument)("range");this._range=U}get newText(){return this._newText||""}set newText(U){if(U&&typeof U!="string")throw(0,I.illegalArgument)("newText");this._newText=U}get newEol(){return this._newEol}set newEol(U){if(U&&typeof U!="number")throw(0,I.illegalArgument)("newEol");this._newEol=U}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};ee=w=Fe([R],ee),e.TextEdit=ee;var se;(function(V){V[V.File=1]="File",V[V.Text=2]="Text",V[V.Cell=3]="Cell",V[V.CellReplace=5]="CellReplace"})(se=e.FileEditType||(e.FileEditType={}));let Z=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(U,ie,be,He){this._edits.push({_type:1,from:U,to:ie,options:be,metadata:He})}createFile(U,ie,be){this._edits.push({_type:1,from:void 0,to:U,options:ie,metadata:be})}deleteFile(U,ie,be){this._edits.push({_type:1,from:U,to:void 0,options:ie,metadata:be})}replaceNotebookMetadata(U,ie,be){this._edits.push({_type:3,metadata:be,uri:U,edit:{editType:5,metadata:ie},notebookMetadata:ie})}replaceNotebookCells(U,ie,be,He,Ke){let Ye,et,_t=[],Pt;if(Gt.isNotebookRange(ie)&&Pe.isNotebookCellDataArray(be)&&!Pe.isNotebookCellDataArray(He)?(Ye=ie.start,et=ie.end,_t=be,Pt=He):typeof ie=="number"&&typeof be=="number"&&Pe.isNotebookCellDataArray(He)&&(Ye=ie,et=be,_t=He,Pt=Ke),Ye===void 0||et===void 0)throw new Error("Invalid arguments");(Ye!==et||_t.length>0)&&this._edits.push({_type:5,uri:U,index:Ye,count:et-Ye,cells:_t,metadata:Pt})}replaceNotebookCellMetadata(U,ie,be,He){this._edits.push({_type:3,metadata:He,uri:U,edit:{editType:8,index:ie,metadata:be}})}replace(U,ie,be,He){this._edits.push({_type:2,uri:U,edit:new ee(ie,be),metadata:He})}insert(U,ie,be,He){this.replace(U,new H(ie,ie),be,He)}delete(U,ie,be){this.replace(U,ie,"",be)}has(U){return this._edits.some(ie=>ie._type===2&&ie.uri.toString()===U.toString())}set(U,ie){if(ie)for(const be of ie)be&&this._edits.push({_type:2,uri:U,edit:be});else{for(let be=0;be<this._edits.length;be++){const He=this._edits[be];He._type===2&&He.uri.toString()===U.toString()&&(this._edits[be]=void 0)}(0,s.coalesceInPlace)(this._edits)}}get(U){const ie=[];for(let be of this._edits)be._type===2&&be.uri.toString()===U.toString()&&ie.push(be.edit);return ie}entries(){const U=new B.ResourceMap;for(let ie of this._edits)if(ie._type===2){let be=U.get(ie.uri);be||(be=[ie.uri,[]],U.set(ie.uri,be)),be[1].push(ie.edit)}return[...U.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};Z=Fe([R],Z),e.WorkspaceEdit=Z;let le=a=class{constructor(U){this._tabstop=1,this.value=U||""}static isSnippetString(U){return U instanceof a?!0:U?typeof U.value=="string":!1}static _escape(U){return U.replace(/\$|}|\\/g,"\\$&")}appendText(U){return this.value+=a._escape(U),this}appendTabstop(U=this._tabstop++){return this.value+="$",this.value+=U,this}appendPlaceholder(U,ie=this._tabstop++){if(typeof U=="function"){const be=new a;be._tabstop=this._tabstop,U(be),this._tabstop=be._tabstop,U=be.value}else U=a._escape(U);return this.value+="${",this.value+=ie,this.value+=":",this.value+=U,this.value+="}",this}appendChoice(U,ie=this._tabstop++){const be=U.map(He=>He.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ie,this.value+="|",this.value+=be,this.value+="|}",this}appendVariable(U,ie){if(typeof ie=="function"){const be=new a;be._tabstop=this._tabstop,ie(be),this._tabstop=be._tabstop,ie=be.value}else typeof ie=="string"&&(ie=ie.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=U,ie&&(this.value+=":",this.value+=ie),this.value+="}",this}};le=a=Fe([R],le),e.SnippetString=le;var ue;(function(V){V[V.Unnecessary=1]="Unnecessary",V[V.Deprecated=2]="Deprecated"})(ue=e.DiagnosticTag||(e.DiagnosticTag={}));var Se;(function(V){V[V.Hint=3]="Hint",V[V.Information=2]="Information",V[V.Warning=1]="Warning",V[V.Error=0]="Error"})(Se=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let fe=T=class{constructor(U,ie){if(this.uri=U,ie)if(H.isRange(ie))this.range=H.of(ie);else if(E.isPosition(ie))this.range=new H(ie,ie);else throw new Error("Illegal argument")}static isLocation(U){return U instanceof T?!0:U?H.isRange(U.range)&&M.URI.isUri(U.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};fe=T=Fe([R],fe),e.Location=fe;let ne=class{constructor(U,ie){this.location=U,this.message=ie}static is(U){return U?typeof U.message=="string"&&U.location&&H.isRange(U.location.range)&&M.URI.isUri(U.location.uri):!1}static isEqual(U,ie){return U===ie?!0:!U||!ie?!1:U.message===ie.message&&U.location.range.isEqual(ie.location.range)&&U.location.uri.toString()===ie.location.uri.toString()}};ne=Fe([R],ne),e.DiagnosticRelatedInformation=ne;let me=class{constructor(U,ie,be=Se.Error){if(!H.isRange(U))throw new TypeError("range must be set");if(!ie)throw new TypeError("message must be set");this.range=U,this.message=ie,this.severity=be}toJSON(){return{severity:Se[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(U,ie){return U===ie?!0:!U||!ie?!1:U.message===ie.message&&U.severity===ie.severity&&U.code===ie.code&&U.severity===ie.severity&&U.source===ie.source&&U.range.isEqual(ie.range)&&(0,s.equals)(U.tags,ie.tags)&&(0,s.equals)(U.relatedInformation,ie.relatedInformation,ne.isEqual)}};me=Fe([R],me),e.Diagnostic=me;let ke=class{constructor(U,ie){if(!U)throw new Error("Illegal argument, contents must be defined");Array.isArray(U)?this.contents=U:this.contents=[U],this.range=ie}};ke=Fe([R],ke),e.Hover=ke;var Ae;(function(V){V[V.Text=0]="Text",V[V.Read=1]="Read",V[V.Write=2]="Write"})(Ae=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Be=class{constructor(U,ie=Ae.Text){this.range=U,this.kind=ie}toJSON(){return{range:this.range,kind:Ae[this.kind]}}};Be=Fe([R],Be),e.DocumentHighlight=Be;var Xe;(function(V){V[V.File=0]="File",V[V.Module=1]="Module",V[V.Namespace=2]="Namespace",V[V.Package=3]="Package",V[V.Class=4]="Class",V[V.Method=5]="Method",V[V.Property=6]="Property",V[V.Field=7]="Field",V[V.Constructor=8]="Constructor",V[V.Enum=9]="Enum",V[V.Interface=10]="Interface",V[V.Function=11]="Function",V[V.Variable=12]="Variable",V[V.Constant=13]="Constant",V[V.String=14]="String",V[V.Number=15]="Number",V[V.Boolean=16]="Boolean",V[V.Array=17]="Array",V[V.Object=18]="Object",V[V.Key=19]="Key",V[V.Null=20]="Null",V[V.EnumMember=21]="EnumMember",V[V.Struct=22]="Struct",V[V.Event=23]="Event",V[V.Operator=24]="Operator",V[V.TypeParameter=25]="TypeParameter"})(Xe=e.SymbolKind||(e.SymbolKind={}));var ge;(function(V){V[V.Deprecated=1]="Deprecated"})(ge=e.SymbolTag||(e.SymbolTag={}));let de=r=class{constructor(U,ie,be,He,Ke){this.name=U,this.kind=ie,this.containerName=Ke,typeof be=="string"&&(this.containerName=be),He instanceof fe?this.location=He:be instanceof H&&(this.location=new fe(He,be)),r.validate(this)}static validate(U){if(!U.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Xe[this.kind],location:this.location,containerName:this.containerName}}};de=r=Fe([R],de),e.SymbolInformation=de;let N=i=class{constructor(U,ie,be,He,Ke){this.name=U,this.detail=ie,this.kind=be,this.range=He,this.selectionRange=Ke,this.children=[],i.validate(this)}static validate(U){if(!U.name)throw new Error("name must not be falsy");if(!U.range.contains(U.selectionRange))throw new Error("selectionRange must be contained in fullRange");U.children&&U.children.forEach(i.validate)}};N=i=Fe([R],N),e.DocumentSymbol=N;var F;(function(V){V[V.Invoke=1]="Invoke",V[V.Automatic=2]="Automatic"})(F=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let C=class{constructor(U,ie){this.title=U,this.kind=ie}};C=Fe([R],C),e.CodeAction=C;let O=c=class{constructor(U){this.value=U}append(U){return new c(this.value?this.value+c.sep+U:U)}intersects(U){return this.contains(U)||U.contains(this)}contains(U){return this.value===U.value||U.value.startsWith(this.value+c.sep)}};O.sep=".",O=c=Fe([R],O),e.CodeActionKind=O,O.Empty=new O(""),O.QuickFix=O.Empty.append("quickfix"),O.Refactor=O.Empty.append("refactor"),O.RefactorExtract=O.Refactor.append("extract"),O.RefactorInline=O.Refactor.append("inline"),O.RefactorRewrite=O.Refactor.append("rewrite"),O.Source=O.Empty.append("source"),O.SourceOrganizeImports=O.Source.append("organizeImports"),O.SourceFixAll=O.Source.append("fixAll");let x=class{constructor(U,ie){if(this.range=U,this.parent=ie,ie&&!ie.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};x=Fe([R],x),e.SelectionRange=x;class Q{constructor(U,ie,be,He,Ke,Ye){this.kind=U,this.name=ie,this.detail=be,this.uri=He,this.range=Ke,this.selectionRange=Ye}}e.CallHierarchyItem=Q;class re{constructor(U,ie){this.fromRanges=ie,this.from=U}}e.CallHierarchyIncomingCall=re;class ve{constructor(U,ie){this.fromRanges=ie,this.to=U}}e.CallHierarchyOutgoingCall=ve;var Ie;(function(V){V[V.Information=0]="Information",V[V.Warning=1]="Warning",V[V.Error=2]="Error"})(Ie=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Me=class{constructor(U,ie){this.range=U,this.command=ie}get isResolved(){return!!this.command}};Me=Fe([R],Me),e.CodeLens=Me;let Le=t=class{constructor(U,ie=!1){l.set(this,void 0),je(this,l,new b.MarkdownString(U,{supportThemeIcons:ie}),"f")}static isMarkdownString(U){return U instanceof t?!0:U&&U.appendCodeblock&&U.appendMarkdown&&U.appendText&&U.value!==void 0}get value(){return De(this,l,"f").value}set value(U){De(this,l,"f").value=U}get isTrusted(){return De(this,l,"f").isTrusted}set isTrusted(U){De(this,l,"f").isTrusted=U}get supportThemeIcons(){return De(this,l,"f").supportThemeIcons}set supportThemeIcons(U){De(this,l,"f").supportThemeIcons=U}get supportHtml(){return De(this,l,"f").supportHtml}set supportHtml(U){De(this,l,"f").supportHtml=U}get baseUri(){return De(this,l,"f").baseUri}set baseUri(U){De(this,l,"f").baseUri=U}appendText(U){return De(this,l,"f").appendText(U),this}appendMarkdown(U){return De(this,l,"f").appendMarkdown(U),this}appendCodeblock(U,ie){return De(this,l,"f").appendCodeblock(ie??"",U),this}};l=new WeakMap,Le=t=Fe([R],Le),e.MarkdownString=Le;let ze=class{constructor(U,ie){this.label=U,this.documentation=ie}};ze=Fe([R],ze),e.ParameterInformation=ze;let xe=class{constructor(U,ie){this.label=U,this.documentation=ie,this.parameters=[]}};xe=Fe([R],xe),e.SignatureInformation=xe;let Re=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};Re=Fe([R],Re),e.SignatureHelp=Re;var Qe;(function(V){V[V.Invoke=1]="Invoke",V[V.TriggerCharacter=2]="TriggerCharacter",V[V.ContentChange=3]="ContentChange"})(Qe=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var tt;(function(V){V[V.Type=1]="Type",V[V.Parameter=2]="Parameter"})(tt=e.InlayHintKind||(e.InlayHintKind={}));let Te=class{constructor(U){this.value=U}};Te=Fe([R],Te),e.InlayHintLabelPart=Te;let it=class{constructor(U,ie,be){this.position=U,this.label=ie,this.kind=be}};it=Fe([R],it),e.InlayHint=it;var X;(function(V){V[V.Invoke=0]="Invoke",V[V.TriggerCharacter=1]="TriggerCharacter",V[V.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(X=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Y;(function(V){V[V.Text=0]="Text",V[V.Method=1]="Method",V[V.Function=2]="Function",V[V.Constructor=3]="Constructor",V[V.Field=4]="Field",V[V.Variable=5]="Variable",V[V.Class=6]="Class",V[V.Interface=7]="Interface",V[V.Module=8]="Module",V[V.Property=9]="Property",V[V.Unit=10]="Unit",V[V.Value=11]="Value",V[V.Enum=12]="Enum",V[V.Keyword=13]="Keyword",V[V.Snippet=14]="Snippet",V[V.Color=15]="Color",V[V.File=16]="File",V[V.Reference=17]="Reference",V[V.Folder=18]="Folder",V[V.EnumMember=19]="EnumMember",V[V.Constant=20]="Constant",V[V.Struct=21]="Struct",V[V.Event=22]="Event",V[V.Operator=23]="Operator",V[V.TypeParameter=24]="TypeParameter",V[V.User=25]="User",V[V.Issue=26]="Issue"})(Y=e.CompletionItemKind||(e.CompletionItemKind={}));var ce;(function(V){V[V.Deprecated=1]="Deprecated"})(ce=e.CompletionItemTag||(e.CompletionItemTag={}));let Oe=class{constructor(U,ie){this.label=U,this.kind=ie}toJSON(){return{label:this.label,kind:this.kind&&Y[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Oe=Fe([R],Oe),e.CompletionItem=Oe;let We=class{constructor(U=[],ie=!1){this.items=U,this.isIncomplete=ie}};We=Fe([R],We),e.CompletionList=We;let Ge=class{constructor(U,ie,be){this.insertText=U,this.range=ie,this.command=be}};Ge=Fe([R],Ge),e.InlineSuggestion=Ge;let Je=class{constructor(U){this.items=U}};Je=Fe([R],Je),e.InlineSuggestions=Je;var ft;(function(V){V[V.Active=-1]="Active",V[V.Beside=-2]="Beside",V[V.One=1]="One",V[V.Two=2]="Two",V[V.Three=3]="Three",V[V.Four=4]="Four",V[V.Five=5]="Five",V[V.Six=6]="Six",V[V.Seven=7]="Seven",V[V.Eight=8]="Eight",V[V.Nine=9]="Nine"})(ft=e.ViewColumn||(e.ViewColumn={}));var It;(function(V){V[V.Left=1]="Left",V[V.Right=2]="Right"})(It=e.StatusBarAlignment||(e.StatusBarAlignment={}));var St;(function(V){V[V.Off=0]="Off",V[V.On=1]="On",V[V.Relative=2]="Relative"})(St=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var kt;(function(V){V[V.Manual=1]="Manual",V[V.AfterDelay=2]="AfterDelay",V[V.FocusOut=3]="FocusOut"})(kt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var qe;(function(V){V[V.Default=0]="Default",V[V.InCenter=1]="InCenter",V[V.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",V[V.AtTop=3]="AtTop"})(qe=e.TextEditorRevealType||(e.TextEditorRevealType={}));var vt;(function(V){V[V.Keyboard=1]="Keyboard",V[V.Mouse=2]="Mouse",V[V.Command=3]="Command"})(vt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Nt;(function(V){V[V.Undo=1]="Undo",V[V.Redo=2]="Redo"})(Nt=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var nt;(function(V){V[V.OpenOpen=0]="OpenOpen",V[V.ClosedClosed=1]="ClosedClosed",V[V.OpenClosed=2]="OpenClosed",V[V.ClosedOpen=3]="ClosedOpen"})(nt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(V){function U(ie){switch(ie){case"keyboard":return V.Keyboard;case"mouse":return V.Mouse;case"api":return V.Command}}V.fromValue=U}(vt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let ut=class{constructor(U,ie){if(ie&&!M.URI.isUri(ie))throw(0,I.illegalArgument)("target");if(!H.isRange(U)||U.isEmpty)throw(0,I.illegalArgument)("range");this.range=U,this.target=ie}};ut=Fe([R],ut),e.DocumentLink=ut;let At=class{constructor(U,ie,be,He){this.red=U,this.green=ie,this.blue=be,this.alpha=He}};At=Fe([R],At),e.Color=At;let Tt=class{constructor(U,ie){if(ie&&!(ie instanceof At))throw(0,I.illegalArgument)("color");if(!H.isRange(U)||U.isEmpty)throw(0,I.illegalArgument)("range");this.range=U,this.color=ie}};Tt=Fe([R],Tt),e.ColorInformation=Tt;let bt=class{constructor(U){if(!U||typeof U!="string")throw(0,I.illegalArgument)("label");this.label=U}};bt=Fe([R],bt),e.ColorPresentation=bt;var dt;(function(V){V[V.RGB=0]="RGB",V[V.HEX=1]="HEX",V[V.HSL=2]="HSL"})(dt=e.ColorFormat||(e.ColorFormat={}));var Rt;(function(V){V[V.Error=0]="Error",V[V.Warning=1]="Warning",V[V.Information=2]="Information"})(Rt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class Lt{constructor(U,ie,be){if(this.startIndex=U,this.length=ie,this.tooltip=be,typeof U!="number"||U<0)throw(0,I.illegalArgument)("startIndex");if(typeof ie!="number"||ie<1)throw(0,I.illegalArgument)("length");if(be!==void 0&&typeof be!="string")throw(0,I.illegalArgument)("tooltip")}}e.TerminalLink=Lt;var Ft;(function(V){V[V.Panel=1]="Panel",V[V.Editor=2]="Editor"})(Ft=e.TerminalLocation||(e.TerminalLocation={}));class Ue{constructor(U){this.options=U,typeof U!="object"&&(0,I.illegalArgument)("options")}}e.TerminalProfile=Ue;var he;(function(V){V[V.Always=1]="Always",V[V.Silent=2]="Silent",V[V.Never=3]="Never"})(he=e.TaskRevealKind||(e.TaskRevealKind={}));var pe;(function(V){V[V.Shared=1]="Shared",V[V.Dedicated=2]="Dedicated",V[V.New=3]="New"})(pe=e.TaskPanelKind||(e.TaskPanelKind={}));let ae=o=class{constructor(U,ie){if(this.label=ie,typeof U!="string"||typeof ie!="string")throw(0,I.illegalArgument)("name");this._id=U}static from(U){switch(U){case"clean":return o.Clean;case"build":return o.Build;case"rebuild":return o.Rebuild;case"test":return o.Test;default:return}}get id(){return this._id}};ae.Clean=new o("clean","Clean"),ae.Build=new o("build","Build"),ae.Rebuild=new o("rebuild","Rebuild"),ae.Test=new o("test","Test"),ae=o=Fe([R],ae),e.TaskGroup=ae;function K(V){let U="";for(let ie=0;ie<V.length;ie++)U+=V[ie].replace(/,/g,",,")+",";return U}let _e=class{constructor(U,ie,be){if(typeof U!="string")throw(0,I.illegalArgument)("process");this._args=[],this._process=U,ie!==void 0&&(Array.isArray(ie)?(this._args=ie,this._options=be):this._options=ie)}get process(){return this._process}set process(U){if(typeof U!="string")throw(0,I.illegalArgument)("process");this._process=U}get args(){return this._args}set args(U){Array.isArray(U)||(U=[]),this._args=U}get options(){return this._options}set options(U){this._options=U}computeId(){const U=[];if(U.push("process"),this._process!==void 0&&U.push(this._process),this._args&&this._args.length>0)for(let ie of this._args)U.push(ie);return K(U)}};_e=Fe([R],_e),e.ProcessExecution=_e;let Ce=class{constructor(U,ie,be){if(this._args=[],Array.isArray(ie)){if(!U)throw(0,I.illegalArgument)("command can't be undefined or null");if(typeof U!="string"&&typeof U.value!="string")throw(0,I.illegalArgument)("command");this._command=U,this._args=ie,this._options=be}else{if(typeof U!="string")throw(0,I.illegalArgument)("commandLine");this._commandLine=U,this._options=ie}}get commandLine(){return this._commandLine}set commandLine(U){if(typeof U!="string")throw(0,I.illegalArgument)("commandLine");this._commandLine=U}get command(){return this._command?this._command:""}set command(U){if(typeof U!="string"&&typeof U.value!="string")throw(0,I.illegalArgument)("command");this._command=U}get args(){return this._args}set args(U){this._args=U||[]}get options(){return this._options}set options(U){this._options=U}computeId(){const U=[];if(U.push("shell"),this._commandLine!==void 0&&U.push(this._commandLine),this._command!==void 0&&U.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let ie of this._args)U.push(typeof ie=="string"?ie:ie.value);return K(U)}};Ce=Fe([R],Ce),e.ShellExecution=Ce;var $e;(function(V){V[V.Escape=1]="Escape",V[V.Strong=2]="Strong",V[V.Weak=3]="Weak"})($e=e.ShellQuoting||(e.ShellQuoting={}));var Ve;(function(V){V[V.Global=1]="Global",V[V.Workspace=2]="Workspace"})(Ve=e.TaskScope||(e.TaskScope={}));class lt{constructor(U){this._callback=U}computeId(){return"customExecution"+(0,L.generateUuid)()}set callback(U){this._callback=U}get callback(){return this._callback}}e.CustomExecution=lt;let gt=g=class{constructor(U,ie,be,He,Ke,Ye){this.__deprecated=!1,this._definition=this.definition=U;let et;typeof ie=="string"?(this._name=this.name=ie,this._source=this.source=be,this.execution=He,et=Ke,this.__deprecated=!0):ie===Ve.Global||ie===Ve.Workspace?(this.target=ie,this._name=this.name=be,this._source=this.source=He,this.execution=Ke,et=Ye):(this.target=ie,this._name=this.name=be,this._source=this.source=He,this.execution=Ke,et=Ye),typeof et=="string"?(this._problemMatchers=[et],this._hasDefinedMatchers=!0):Array.isArray(et)?(this._problemMatchers=et,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(U){this.__id=U}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof _e?this._definition={type:g.ProcessType,id:this._execution.computeId()}:this._execution instanceof Ce?this._definition={type:g.ShellType,id:this._execution.computeId()}:this._execution instanceof lt?this._definition={type:g.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:g.EmptyType,id:(0,L.generateUuid)()}}get definition(){return this._definition}set definition(U){if(U==null)throw(0,I.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=U}get scope(){return this._scope}set target(U){this.clear(),this._scope=U}get name(){return this._name}set name(U){if(typeof U!="string")throw(0,I.illegalArgument)("name");this.clear(),this._name=U}get execution(){return this._execution}set execution(U){U===null&&(U=void 0),this.clear(),this._execution=U;const ie=this._definition.type;(g.EmptyType===ie||g.ProcessType===ie||g.ShellType===ie||g.ExtensionCallbackType===ie)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(U){if(Array.isArray(U))this.clear(),this._problemMatchers=U,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(U){U!==!0&&U!==!1&&(U=!1),this.clear(),this._isBackground=U}get source(){return this._source}set source(U){if(typeof U!="string"||U.length===0)throw(0,I.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=U}get group(){return this._group}set group(U){U===null&&(U=void 0),this.clear(),this._group=U}get detail(){return this._detail}set detail(U){U===null&&(U=void 0),this._detail=U}get presentationOptions(){return this._presentationOptions}set presentationOptions(U){U==null&&(U=Object.create(null)),this.clear(),this._presentationOptions=U}get runOptions(){return this._runOptions}set runOptions(U){U==null&&(U=Object.create(null)),this.clear(),this._runOptions=U}};gt.ExtensionCallbackType="customExecution",gt.ProcessType="process",gt.ShellType="shell",gt.EmptyType="$empty",gt=g=Fe([R],gt),e.Task=gt;var Et;(function(V){V[V.SourceControl=1]="SourceControl",V[V.Window=10]="Window",V[V.Notification=15]="Notification"})(Et=e.ProgressLocation||(e.ProgressLocation={}));let rt=class{constructor(U,ie=at.None){this.collapsibleState=ie,M.URI.isUri(U)?this.resourceUri=U:this.label=U}};rt=Fe([R],rt),e.TreeItem=rt;var at;(function(V){V[V.None=0]="None",V[V.Collapsed=1]="Collapsed",V[V.Expanded=2]="Expanded"})(at=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let ot=class{constructor(U){this.value=U}async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}};ot=Fe([R],ot),e.TreeDataTransferItem=ot;let Mt=class{constructor(){this._items=new Map}get(U){return this._items.get(U)}set(U,ie){this._items.set(U,ie)}forEach(U){this._items.forEach(U)}};Mt=Fe([R],Mt),e.TreeDataTransfer=Mt;let mt=class{constructor(U,ie){this.id=U,this.color=ie}};mt=Fe([R],mt),e.ThemeIcon=mt,mt.File=new mt("file"),mt.Folder=new mt("folder");let Dt=class{constructor(U){this.id=U}};Dt=Fe([R],Dt),e.ThemeColor=Dt;var Ut;(function(V){V[V.Global=1]="Global",V[V.Workspace=2]="Workspace",V[V.WorkspaceFolder=3]="WorkspaceFolder"})(Ut=e.ConfigurationTarget||(e.ConfigurationTarget={}));let wt=class{constructor(U,ie){if(typeof U!="string"&&(!U||!M.URI.isUri(U)&&!M.URI.isUri(U.uri)))throw(0,I.illegalArgument)("base");if(typeof ie!="string")throw(0,I.illegalArgument)("pattern");typeof U=="string"?this.baseUri=M.URI.file(U):M.URI.isUri(U)?this.baseUri=U:this.baseUri=U.uri,this.pattern=ie}get base(){return this._base}set base(U){this._base=U,this._baseUri=M.URI.file(U)}get baseUri(){return this._baseUri}set baseUri(U){this._baseUri=U,this._base=U.fsPath}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};wt=Fe([R],wt),e.RelativePattern=wt;let Bt=class{constructor(U,ie,be,He){this.enabled=typeof U=="boolean"?U:!0,typeof ie=="string"&&(this.condition=ie),typeof be=="string"&&(this.hitCondition=be),typeof He=="string"&&(this.logMessage=He)}get id(){return this._id||(this._id=(0,L.generateUuid)()),this._id}};Bt=Fe([R],Bt),e.Breakpoint=Bt;let Wt=class extends Bt{constructor(U,ie,be,He,Ke){super(ie,be,He,Ke);if(U===null)throw(0,I.illegalArgument)("location");this.location=U}};Wt=Fe([R],Wt),e.SourceBreakpoint=Wt;let pt=class extends Bt{constructor(U,ie,be,He,Ke){super(ie,be,He,Ke);this.functionName=U}};pt=Fe([R],pt),e.FunctionBreakpoint=pt;let ei=class extends Bt{constructor(U,ie,be,He,Ke,Ye,et){super(He,Ke,Ye,et);if(!ie)throw(0,I.illegalArgument)("dataId");this.label=U,this.dataId=ie,this.canPersist=be}};ei=Fe([R],ei),e.DataBreakpoint=ei;let Xt=class{constructor(U,ie,be){this.command=U,this.args=ie||[],this.options=be}};Xt=Fe([R],Xt),e.DebugAdapterExecutable=Xt;let ti=class{constructor(U,ie){this.port=U,this.host=ie}};ti=Fe([R],ti),e.DebugAdapterServer=ti;let ai=class{constructor(U){this.path=U}};ai=Fe([R],ai),e.DebugAdapterNamedPipeServer=ai;let Ct=class{constructor(U){this.implementation=U}};Ct=Fe([R],Ct),e.DebugAdapterInlineImplementation=Ct;let ii=class{constructor(U,ie){this.range=U,this.expression=ie}};ii=Fe([R],ii),e.EvaluatableExpression=ii;var bi;(function(V){V[V.Automatic=0]="Automatic",V[V.Explicit=1]="Explicit"})(bi=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let qt=class{constructor(U,ie){this.range=U,this.text=ie}};qt=Fe([R],qt),e.InlineValueText=qt;let Kt=class{constructor(U,ie,be=!0){this.range=U,this.variableName=ie,this.caseSensitiveLookup=be}};Kt=Fe([R],Kt),e.InlineValueVariableLookup=Kt;let st=class{constructor(U,ie){this.range=U,this.expression=ie}};st=Fe([R],st),e.InlineValueEvaluatableExpression=st;let li=class{constructor(U,ie){this.frameId=U,this.stoppedLocation=ie}};li=Fe([R],li),e.InlineValueContext=li;var Ht;(function(V){V[V.Changed=1]="Changed",V[V.Created=2]="Created",V[V.Deleted=3]="Deleted"})(Ht=e.FileChangeType||(e.FileChangeType={}));let zt=h=class extends Error{constructor(U,ie=v.FileSystemProviderErrorCode.Unknown,be){super(M.URI.isUri(U)?U.toString(!0):U);this.code=be?.name??"Unknown",(0,v.markAsFileSystemProviderError)(this,ie),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,h.prototype),typeof Error.captureStackTrace=="function"&&typeof be=="function"&&Error.captureStackTrace(this,be)}static FileExists(U){return new h(U,v.FileSystemProviderErrorCode.FileExists,h.FileExists)}static FileNotFound(U){return new h(U,v.FileSystemProviderErrorCode.FileNotFound,h.FileNotFound)}static FileNotADirectory(U){return new h(U,v.FileSystemProviderErrorCode.FileNotADirectory,h.FileNotADirectory)}static FileIsADirectory(U){return new h(U,v.FileSystemProviderErrorCode.FileIsADirectory,h.FileIsADirectory)}static NoPermissions(U){return new h(U,v.FileSystemProviderErrorCode.NoPermissions,h.NoPermissions)}static Unavailable(U){return new h(U,v.FileSystemProviderErrorCode.Unavailable,h.Unavailable)}};zt=h=Fe([R],zt),e.FileSystemError=zt;let ni=class{constructor(U,ie,be){this.start=U,this.end=ie,this.kind=be}};ni=Fe([R],ni),e.FoldingRange=ni;var _i;(function(V){V[V.Comment=1]="Comment",V[V.Imports=2]="Imports",V[V.Region=3]="Region"})(_i=e.FoldingRangeKind||(e.FoldingRangeKind={}));var fi;(function(V){V[V.Collapsed=0]="Collapsed",V[V.Expanded=1]="Expanded"})(fi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Si;(function(V){V[V.Editing=0]="Editing",V[V.Preview=1]="Preview"})(Si=e.CommentMode||(e.CommentMode={}));var mi;(function(V){V[V.Unresolved=0]="Unresolved",V[V.Resolved=1]="Resolved"})(mi=e.CommentThreadState||(e.CommentThreadState={}));class ri{constructor(U,ie=[]){this.tokenTypes=U,this.tokenModifiers=ie}}e.SemanticTokensLegend=ri;function yi(V){return typeof V=="undefined"||(0,y.isStringArray)(V)}class Qt{constructor(U){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,U){this._hasLegend=!0;for(let ie=0,be=U.tokenTypes.length;ie<be;ie++)this._tokenTypeStrToInt.set(U.tokenTypes[ie],ie);for(let ie=0,be=U.tokenModifiers.length;ie<be;ie++)this._tokenModifierStrToInt.set(U.tokenModifiers[ie],ie)}}push(U,ie,be,He,Ke){if(typeof U=="number"&&typeof ie=="number"&&typeof be=="number"&&typeof He=="number"&&(typeof Ke=="number"||typeof Ke=="undefined"))return typeof Ke=="undefined"&&(Ke=0),this._pushEncoded(U,ie,be,He,Ke);if(H.isRange(U)&&typeof ie=="string"&&yi(be))return this._push(U,ie,be);throw(0,I.illegalArgument)()}_push(U,ie,be){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(U.start.line!==U.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ie))throw new Error("`tokenType` is not in the provided legend");const He=U.start.line,Ke=U.start.character,Ye=U.end.character-U.start.character,et=this._tokenTypeStrToInt.get(ie);let _t=0;if(be)for(const Pt of be){if(!this._tokenModifierStrToInt.has(Pt))throw new Error("`tokenModifier` is not in the provided legend");const xt=this._tokenModifierStrToInt.get(Pt);_t|=1<<xt>>>0}this._pushEncoded(He,Ke,Ye,et,_t)}_pushEncoded(U,ie,be,He,Ke){if(this._dataIsSortedAndDeltaEncoded&&(U<this._prevLine||U===this._prevLine&&ie<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const _t=this._data.length/5|0;let Pt=0,xt=0;for(let $t=0;$t<_t;$t++){let Vt=this._data[5*$t],di=this._data[5*$t+1];Vt===0?(Vt=Pt,di+=xt):Vt+=Pt,this._data[5*$t]=Vt,this._data[5*$t+1]=di,Pt=Vt,xt=di}}let Ye=U,et=ie;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(Ye-=this._prevLine,Ye===0&&(et-=this._prevChar)),this._data[this._dataLen++]=Ye,this._data[this._dataLen++]=et,this._data[this._dataLen++]=be,this._data[this._dataLen++]=He,this._data[this._dataLen++]=Ke,this._prevLine=U,this._prevChar=ie}static _sortAndDeltaEncode(U){let ie=[];const be=U.length/5|0;for(let et=0;et<be;et++)ie[et]=et;ie.sort((et,_t)=>{const Pt=U[5*et],xt=U[5*_t];if(Pt===xt){const $t=U[5*et+1],Vt=U[5*_t+1];return $t-Vt}return Pt-xt});const He=new Uint32Array(U.length);let Ke=0,Ye=0;for(let et=0;et<be;et++){const _t=5*ie[et],Pt=U[_t+0],xt=U[_t+1],$t=U[_t+2],Vt=U[_t+3],di=U[_t+4],zi=Pt-Ke,Ji=zi===0?xt-Ye:xt,hi=5*et;He[hi+0]=zi,He[hi+1]=Ji,He[hi+2]=$t,He[hi+3]=Vt,He[hi+4]=di,Ke=Pt,Ye=xt}return He}build(U){return this._dataIsSortedAndDeltaEncoded?new Yt(new Uint32Array(this._data),U):new Yt(Qt._sortAndDeltaEncode(this._data),U)}}e.SemanticTokensBuilder=Qt;class Yt{constructor(U,ie){this.resultId=ie,this.data=U}}e.SemanticTokens=Yt;class Di{constructor(U,ie,be){this.start=U,this.deleteCount=ie,this.data=be}}e.SemanticTokensEdit=Di;class Ci{constructor(U,ie){this.resultId=ie,this.edits=U}}e.SemanticTokensEdits=Ci;var Jt;(function(V){V[V.Separate=0]="Separate",V[V.MergeWithParent=1]="MergeWithParent"})(Jt=e.DebugConsoleMode||(e.DebugConsoleMode={}));let si=class{constructor(){}};si.Back={iconPath:new mt("arrow-left")},si=Fe([R],si),e.QuickInputButtons=si;var Ii;(function(V){V[V.Separator=-1]="Separator",V[V.Default=0]="Default"})(Ii=e.QuickPickItemKind||(e.QuickPickItemKind={}));var ki;(function(V){V[V.UI=1]="UI",V[V.Workspace=2]="Workspace"})(ki=e.ExtensionKind||(e.ExtensionKind={}));class Ti{constructor(U,ie,be){this.badge=U,this.tooltip=ie,this.color=be}static validate(U){if(U.badge){let ie=(0,A.nextCharLength)(U.badge,0);if(ie<U.badge.length&&(ie+=(0,A.nextCharLength)(U.badge,ie)),U.badge.length>ie)throw new Error("The 'badge'-property must be undefined or a short character")}if(!U.color&&!U.badge&&!U.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=Ti;let Zt=class{constructor(U){this.kind=U}};Zt=Fe([R],Zt),e.ColorTheme=Zt;var gi;(function(V){V[V.Light=1]="Light",V[V.Dark=2]="Dark",V[V.HighContrast=3]="HighContrast"})(gi=e.ColorThemeKind||(e.ColorThemeKind={}));class Gt{constructor(U,ie){if(U<0)throw(0,I.illegalArgument)("start must be positive");if(ie<0)throw(0,I.illegalArgument)("end must be positive");U<=ie?(this._start=U,this._end=ie):(this._start=ie,this._end=U)}static isNotebookRange(U){return U instanceof Gt?!0:U?typeof U.start=="number"&&typeof U.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(U){let ie=this._start,be=this._end;return U.start!==void 0&&(ie=U.start),U.end!==void 0&&(be=U.end),ie===this._start&&be===this._end?this:new Gt(ie,be)}}e.NotebookRange=Gt;class Pe{constructor(U,ie,be,He,Ke,Ye,et){this.kind=U,this.value=ie,this.languageId=be,this.mime=He,this.outputs=Ke??[],this.metadata=Ye,this.executionSummary=et,Pe.validate(this)}static validate(U){if(typeof U.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof U.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof U.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(U){return Array.isArray(U)&&U.every(ie=>Pe.isNotebookCellData(ie))}static isNotebookCellData(U){return!0}}e.NotebookCellData=Pe;class ci{constructor(U){this.cells=U}}e.NotebookData=ci;class Ot{constructor(U,ie){this.data=U,this.mime=ie;const be=(0,D.normalizeMimeType)(ie,!0);if(!be)throw new Error(`INVALID mime type: ${ie}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=be}static isNotebookCellOutputItem(U){return U instanceof Ot?!0:U?typeof U.mime=="string"&&U.data instanceof Uint8Array:!1}static error(U){const ie={name:U.name,message:U.message,stack:U.stack};return Ot.json(ie,"application/vnd.code.notebook.error")}static stdout(U){return Ot.text(U,"application/vnd.code.notebook.stdout")}static stderr(U){return Ot.text(U,"application/vnd.code.notebook.stderr")}static bytes(U,ie="application/octet-stream"){return new Ot(U,ie)}static text(U,ie=D.Mimes.text){const be=De(Ot,n,"f",f).encode(String(U));return new Ot(be,ie)}static json(U,ie="application/json"){const be=JSON.stringify(U,void 0,"	");return Ot.text(be,ie)}}e.NotebookCellOutputItem=Ot,n=Ot,f={value:new TextEncoder};class ct{constructor(U,ie,be){this.items=ct.ensureUniqueMimeTypes(U,!0),typeof ie=="string"?(this.id=ie,this.metadata=be):(this.id=(0,L.generateUuid)(),this.metadata=ie??be)}static isNotebookCellOutput(U){return U instanceof ct?!0:!U||typeof U!="object"?!1:typeof U.id=="string"&&(0,y.isArray)(U.items)}static ensureUniqueMimeTypes(U,ie=!1){const be=new Set,He=new Set;for(let Ke=0;Ke<U.length;Ke++){const Ye=U[Ke],et=(0,D.normalizeMimeType)(Ye.mime);if(!be.has(et)){be.add(et);continue}He.add(Ke),ie&&console.warn(`DUPLICATED mime type '${Ye.mime}' will be dropped`)}return He.size===0?U:U.filter((Ke,Ye)=>!He.has(Ye))}}e.NotebookCellOutput=ct;var Pi;(function(V){V[V.Markup=1]="Markup",V[V.Code=2]="Code"})(Pi=e.NotebookCellKind||(e.NotebookCellKind={}));var Ai;(function(V){V[V.Idle=1]="Idle",V[V.Pending=2]="Pending",V[V.Executing=3]="Executing"})(Ai=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var pi;(function(V){V[V.Left=1]="Left",V[V.Right=2]="Right"})(pi=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var vi;(function(V){V[V.Default=0]="Default",V[V.InCenter=1]="InCenter",V[V.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",V[V.AtTop=3]="AtTop"})(vi=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Ri{constructor(U,ie){this.text=U,this.alignment=ie}}e.NotebookCellStatusBarItem=Ri;var Oi;(function(V){V[V.Default=1]="Default",V[V.Preferred=2]="Preferred"})(Oi=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Fi{constructor(U,ie=[]){this.uri=U,this.provides=(0,s.asArray)(ie)}}e.NotebookRendererScript=Fi;let ui=class{constructor(U,ie){this.label=U,this.timestamp=ie}};ui=Fe([R],ui),e.TimelineItem=ui;var Ei;(function(V){V[V.Production=1]="Production",V[V.Development=2]="Development",V[V.Test=3]="Test"})(Ei=e.ExtensionMode||(e.ExtensionMode={}));var Mi;(function(V){V[V.Node=1]="Node",V[V.Webworker=2]="Webworker"})(Mi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Ni;(function(V){V[V.Other=0]="Other",V[V.Comment=1]="Comment",V[V.String=2]="String",V[V.RegEx=3]="RegEx"})(Ni=e.StandardTokenType||(e.StandardTokenType={}));class Li{constructor(U,ie){this.ranges=U,this.wordPattern=ie}}e.LinkedEditingRanges=Li;class Ui{constructor(U,ie){this._port=U,this._autoForwardAction=ie}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Ui;var Bi;(function(V){V[V.Queued=1]="Queued",V[V.Running=2]="Running",V[V.Passed=3]="Passed",V[V.Failed=4]="Failed",V[V.Skipped=5]="Skipped",V[V.Errored=6]="Errored"})(Bi=e.TestResultState||(e.TestResultState={}));var te;(function(V){V[V.Run=1]="Run",V[V.Debug=2]="Debug",V[V.Coverage=3]="Coverage"})(te=e.TestRunProfileKind||(e.TestRunProfileKind={}));let oe=class{constructor(U=void 0,ie=void 0,be=void 0){this.include=U,this.exclude=ie,this.profile=be}};oe=Fe([R],oe),e.TestRunRequest=oe;let ye=_=class{constructor(U){this.message=U}static diff(U,ie,be){const He=new _(U);return He.expectedOutput=ie,He.actualOutput=be,He}};ye=_=Fe([R],ye),e.TestMessage=ye;let Ze=class{constructor(U){this.id=U}};Ze=Fe([R],Ze),e.TestTag=Ze;let ht=class{constructor(U,ie){this.covered=U,this.total=ie}};ht=Fe([R],ht),e.CoveredCount=ht;let yt=P=class{constructor(U,ie,be,He){this.uri=U,this.statementCoverage=ie,this.branchCoverage=be,this.functionCoverage=He}static fromDetails(U,ie){const be=new ht(0,0),He=new ht(0,0),Ke=new ht(0,0);for(const et of ie)if("branches"in et){be.total+=1,be.covered+=et.executionCount>0?1:0;for(const _t of et.branches)He.total+=1,He.covered+=_t.executionCount>0?1:0}else Ke.total+=1,Ke.covered+=et.executionCount>0?1:0;const Ye=new P(U,be,He.total>0?He:void 0,Ke.total>0?Ke:void 0);return Ye.detailedCoverage=ie,Ye}};yt=P=Fe([R],yt),e.FileCoverage=yt;let xi=class{constructor(U,ie,be=[]){this.executionCount=U,this.location=ie,this.branches=be}};xi=Fe([R],xi),e.StatementCoverage=xi;let $i=class{constructor(U,ie){this.executionCount=U,this.location=ie}};$i=Fe([R],$i),e.BranchCoverage=$i;let Wi=class{constructor(U,ie){this.executionCount=U,this.location=ie}};Wi=Fe([R],Wi),e.FunctionCoverage=Wi;var Gi;(function(V){V[V.None=0]="None",V[V.Option=1]="Option",V[V.Default=2]="Default",V[V.Preferred=3]="Preferred"})(Gi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Xi;(function(V){V[V.Untrusted=0]="Untrusted",V[V.Trusted=1]="Trusted",V[V.Unspecified=2]="Unspecified"})(Xi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Qi;(function(V){V[V.Notify=1]="Notify",V[V.OpenBrowser=2]="OpenBrowser",V[V.OpenPreview=3]="OpenPreview",V[V.Silent=4]="Silent",V[V.Ignore=5]="Ignore",V[V.OpenBrowserOnce=6]="OpenBrowserOnce"})(Qi=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class Yi{constructor(U,ie,be,He,Ke,Ye){this.kind=U,this.name=ie,this.detail=be,this.uri=He,this.range=Ke,this.selectionRange=Ye}}e.TypeHierarchyItem=Yi}),define(Ee[84],we([1,0,42,10,9,226,116,7,16]),function(J,e,s,I,b,B,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const M=new Map;function L(l,n){n?M.set(l,n):M.delete(l)}e.setWordDefinitionFor=L;function v(l){return M.get(l)}e.getWordDefinitionFor=v;class u extends B.MirrorTextModel{constructor(n,f,S,k,d,p,w,a){super(f,S,k,d);this._proxy=n,this._languageId=p,this._isDirty=w,this._notebook=a,this._isDisposed=!1}dispose(){(0,s.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(n){return(0,y.equals)(this._lines,n)}get document(){if(!this._document){const n=this;this._document={get uri(){return n._uri},get fileName(){return n._uri.fsPath},get isUntitled(){return n._uri.scheme===I.Schemas.untitled},get languageId(){return n._languageId},get version(){return n._versionId},get isClosed(){return n._isDisposed},get isDirty(){return n._isDirty},get notebook(){return n._notebook},save(){return n._save()},getText(f){return f?n._getTextInRange(f):n.getText()},get eol(){return n._eol===`
`?A.EndOfLine.LF:A.EndOfLine.CRLF},get lineCount(){return n._lines.length},lineAt(f){return n._lineAt(f)},offsetAt(f){return n._offsetAt(f)},positionAt(f){return n._positionAt(f)},validateRange(f){return n._validateRange(f)},validatePosition(f){return n._validatePosition(f)},getWordRangeAtPosition(f,S){return n._getWordRangeAtPosition(f,S)}}}return Object.freeze(this._document)}_acceptLanguageId(n){(0,s.ok)(!this._isDisposed),this._languageId=n}_acceptIsDirty(n){(0,s.ok)(!this._isDisposed),this._isDirty=n}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(n){const f=this._validateRange(n);if(f.isEmpty)return"";if(f.isSingleLine)return this._lines[f.start.line].substring(f.start.character,f.end.character);const S=this._eol,k=f.start.line,d=f.end.line,p=[];p.push(this._lines[k].substring(f.start.character));for(let w=k+1;w<d;w++)p.push(this._lines[w]);return p.push(this._lines[d].substring(0,f.end.character)),p.join(S)}_lineAt(n){let f;if(n instanceof A.Position?f=n.line:typeof n=="number"&&(f=n),typeof f!="number"||f<0||f>=this._lines.length||Math.floor(f)!==f)throw new Error("Illegal value for `line`");return new m(f,this._lines[f],f===this._lines.length-1)}_offsetAt(n){return n=this._validatePosition(n),this._ensureLineStarts(),this._lineStarts.getPrefixSum(n.line-1)+n.character}_positionAt(n){n=Math.floor(n),n=Math.max(0,n),this._ensureLineStarts();const f=this._lineStarts.getIndexOf(n),S=this._lines[f.index].length;return new A.Position(f.index,Math.min(f.remainder,S))}_validateRange(n){if(!(n instanceof A.Range))throw new Error("Invalid argument");const f=this._validatePosition(n.start),S=this._validatePosition(n.end);return f===n.start&&S===n.end?n:new A.Range(f.line,f.character,S.line,S.character)}_validatePosition(n){if(!(n instanceof A.Position))throw new Error("Invalid argument");if(this._lines.length===0)return n.with(0,0);let{line:f,character:S}=n,k=!1;if(f<0)f=0,S=0,k=!0;else if(f>=this._lines.length)f=this._lines.length-1,S=this._lines[f].length,k=!0;else{const d=this._lines[f].length;S<0?(S=0,k=!0):S>d&&(S=d,k=!0)}return k?new A.Position(f,S):n}_getWordRangeAtPosition(n,f){const S=this._validatePosition(n);if(!f)f=v(this._languageId);else if((0,b.regExpLeadsToEndlessLoop)(f))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${f.source}' because it matches the empty string.`);const k=(0,D.getWordAtText)(S.character+1,(0,D.ensureValidWordDefinition)(f),this._lines[S.line],0);if(k)return new A.Range(S.line,k.startColumn-1,S.line,k.endColumn-1)}}e.ExtHostDocumentData=u;class m{constructor(n,f,S){this._line=n,this._text=f,this._isLastLine=S}get lineNumber(){return this._line}get text(){return this._text}get range(){return new A.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new A.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=m}),define(Ee[152],we([1,0,7,5,227,6,74,22,2,36]),function(J,e,s,I,b,B,D,A,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class L{constructor(u,m,l,n){this._notebook=l,this._selector=n,this._disposables=new B.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this.uri=y.URI.from({scheme:"vscode-concat-doc",path:(0,M.generateUuid)()}),this._init(),this._disposables.add(m.onDidChangeDocument(S=>{const k=this._cellUris.get(S.document.uri);k!==void 0&&(this._cellLengths.setValue(k,this._cells[k].document.getText().length+1),this._cellLines.setValue(k,this._cells[k].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const f=S=>{S===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(u.onDidChangeNotebookCells(S=>f(S.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new A.ResourceMap;const u=[],m=[];for(const l of this._notebook.getCells())l.kind===s.NotebookCellKind.Code&&(!this._selector||(0,D.score)(this._selector,l.document.uri,l.document.languageId,!0,void 0))&&(this._cellUris.set(l.document.uri,this._cells.length),this._cells.push(l),u.push(l.document.getText().length+1),m.push(l.document.lineCount));this._cellLengths=new b.PrefixSumComputer(new Uint32Array(u)),this._cellLines=new b.PrefixSumComputer(new Uint32Array(m))}get version(){return this._versionId}getText(u){if(!u){let k="";for(const d of this._cells)k+=d.document.getText()+`
`;return k=k.slice(0,-1),k}if(u.isEmpty)return"";const m=this.locationAt(u.start),l=this.locationAt(u.end),n=this._cellUris.get(m.uri),f=this._cellUris.get(l.uri);if(n===void 0||f===void 0)return"";if(n===f)return this._cells[n].document.getText(new s.Range(m.range.start,l.range.end));const S=[this._cells[n].document.getText(new s.Range(m.range.start,new s.Position(this._cells[n].document.lineCount,0)))];for(let k=n+1;k<f;k++)S.push(this._cells[k].document.getText());return S.push(this._cells[f].document.getText(new s.Range(new s.Position(0,0),l.range.end))),S.join(`
`)}offsetAt(u){const m=this._cellLines.getIndexOf(u.line),l=this._cellLengths.getPrefixSum(m.index-1),n=this._cells[m.index].document.offsetAt(u.with(m.remainder));return l+n}positionAt(u){if(typeof u=="number"){const l=this._cellLengths.getIndexOf(u),n=this._cellLines.getPrefixSum(l.index-1);return this._cells[l.index].document.positionAt(l.remainder).translate(n)}const m=this._cellUris.get(u.uri);if(m!==void 0){const l=this._cellLines.getPrefixSum(m-1);return new s.Position(l+u.range.start.line,u.range.start.character)}return new s.Position(0,0)}locationAt(u){s.Range.isRange(u)||(u=new s.Range(u,u));const m=this._cellLines.getIndexOf(u.start.line);let l=m;u.isEmpty||(l=this._cellLines.getIndexOf(u.end.line));const n=new s.Position(m.remainder,u.start.character),f=new s.Position(l.remainder,u.end.character),S=new s.Range(n,f),k=this._cells[m.index];return new s.Location(k.document.uri,k.document.validateRange(S))}contains(u){return this._cellUris.has(u)}validateRange(u){const m=this.validatePosition(u.start),l=this.validatePosition(u.end);return u.with(m,l)}validatePosition(u){const m=this._cellLines.getIndexOf(u.line),l=new s.Position(m.remainder,u.character),n=this._cells[m.index].document.validatePosition(l),f=this._cellLines.getPrefixSum(m.index-1);return new s.Position(f+n.line,n.character)}}e.ExtHostNotebookConcatDocument=L}),define(Ee[153],we([1,0,7,14,5]),function(J,e,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let B=class{constructor(A){this._actual=new s.ColorTheme(s.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new b.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(A){let y=A==="light"?s.ColorThemeKind.Light:A==="dark"?s.ColorThemeKind.Dark:s.ColorThemeKind.HighContrast;this._actual=new s.ColorTheme(y),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};B=Fe([Ne(0,I.IExtHostRpcService)],B),e.ExtHostTheming=B}),define(Ee[60],we([1,0,3]),function(J,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,s.createDecorator)("IURITransformerService");class I{constructor(B){B?(this.transformIncoming=B.transformIncoming.bind(B),this.transformOutgoing=B.transformOutgoing.bind(B),this.transformOutgoingURI=B.transformOutgoingURI.bind(B),this.transformOutgoingScheme=B.transformOutgoingScheme.bind(B)):(this.transformIncoming=D=>D,this.transformOutgoing=D=>D,this.transformOutgoingURI=D=>D,this.transformOutgoingScheme=D=>D)}}e.URITransformerService=I}),define(Ee[154],we([1,0,21]),function(J,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class I{constructor(){this.buffers=[]}add(y){let M=this.buffers.indexOf(y);return M<0&&(M=this.buffers.length,this.buffers.push(y)),M}}function b(A,y){if(y.serializeBuffersForPostMessage){const M=new I,L=(m,l)=>{if(l instanceof ArrayBuffer){const n=M.add(l);return{$$vscode_array_buffer_reference$$:!0,index:n}}else if(ArrayBuffer.isView(l)){const n=B(l);if(n){const f=M.add(l.buffer);return{$$vscode_array_buffer_reference$$:!0,index:f,view:{type:n,byteLength:l.byteLength,byteOffset:l.byteOffset}}}}return l},v=JSON.stringify(A,L),u=M.buffers.map(m=>{const l=new Uint8Array(m);return s.VSBuffer.wrap(l)});return{message:v,buffers:u}}else return{message:JSON.stringify(A),buffers:[]}}e.serializeWebviewMessage=b;function B(A){switch(A.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function D(A,y){const M=y.map(u=>{const m=new ArrayBuffer(u.byteLength);return new Uint8Array(m).set(u.buffer),m}),L=y.length?(u,m)=>{if(m&&typeof m=="object"&&m.$$vscode_array_buffer_reference$$){const l=m,{index:n}=l,f=M[n];if(l.view)switch(l.view.type){case 1:return new Int8Array(f,l.view.byteOffset,l.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(f,l.view.byteOffset,l.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(f,l.view.byteOffset,l.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(f,l.view.byteOffset,l.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(f,l.view.byteOffset,l.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(f,l.view.byteOffset,l.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(f,l.view.byteOffset,l.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(f,l.view.byteOffset,l.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(f,l.view.byteOffset,l.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(f,l.view.byteOffset,l.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(f,l.view.byteOffset,l.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return f}return m}:void 0;return{message:JSON.parse(A,L),arrayBuffers:M}}e.deserializeWebviewMessage=D}),define(Ee[155],we([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var s;(function(I){function b(D){const A=new Map;return D.types.forEach((y,M)=>{A.set(y,{asString:async()=>D.items[M].asString,value:void 0})}),A}I.toITreeDataTransfer=b;async function B(D){const A={types:[],items:[]},y=Array.from(D.entries());for(const M of y)A.types.push(M[0]),A.items.push({asString:await M[1].asString()});return A}I.toTreeDataTransferDTO=B})(s=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(Ee[156],we([1,0,129,11,2,6,3,37,45,16,10]),function(J,e,s,I,b,B,D,A,y,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,s.localize)(0,null),providerDisplayName:(0,s.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var v;(function(G){G[G.PROGRAMMATIC=1]="PROGRAMMATIC",G[G.USER=2]="USER",G[G.EDIT=3]="EDIT",G[G.NAVIGATION=4]="NAVIGATION",G[G.JUMP=5]="JUMP"})(v=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var u;(function(G){G[G.IDENTICAL=1]="IDENTICAL",G[G.SIMILAR=2]="SIMILAR",G[G.DIFFERENT=3]="DIFFERENT"})(u=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function m(G){const j=G;return!!j&&typeof j.getSelection=="function"&&!!j.onDidChangeSelection}e.isEditorPaneWithSelection=m;function l(G,j,$){for(const ee of $.visibleEditorPanes)if(ee.group.id===j&&G.matches(ee.input))return ee.getViewState()}e.findViewStateForEditor=l;function n(G){if(T(G))return!1;const j=G;return b.URI.isUri(j?.resource)}e.isResourceEditorInput=n;function f(G){if(T(G))return!1;const j=G;return j?.original!==void 0&&j.modified!==void 0}e.isResourceDiffEditorInput=f;function S(G){if(T(G)||f(G))return!1;const j=G;return j?.primary!==void 0&&j.secondary!==void 0}e.isResourceSideBySideEditorInput=S;function k(G){if(T(G))return!1;const j=G;return j?j.resource===void 0||j.resource.scheme===L.Schemas.untitled||j.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=k;var d;(function(G){G[G.SHORT=0]="SHORT",G[G.MEDIUM=1]="MEDIUM",G[G.LONG=2]="LONG"})(d=e.Verbosity||(e.Verbosity={}));var p;(function(G){G[G.EXPLICIT=1]="EXPLICIT",G[G.AUTO=2]="AUTO",G[G.FOCUS_CHANGE=3]="FOCUS_CHANGE",G[G.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(p=e.SaveReason||(e.SaveReason={}));var w;(function(G){G[G.None=0]="None",G[G.Readonly=2]="Readonly",G[G.Untitled=4]="Untitled",G[G.Singleton=8]="Singleton",G[G.RequiresTrust=16]="RequiresTrust",G[G.CanSplitInGroup=32]="CanSplitInGroup",G[G.ForceDescription=64]="ForceDescription"})(w=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class a extends B.Disposable{}e.AbstractEditorInput=a;function T(G){return G instanceof a}e.isEditorInput=T;function r(G){const j=G;return b.URI.isUri(j?.preferredResource)}function i(G){const j=G;return T(j?.primary)&&T(j?.secondary)}e.isSideBySideEditorInput=i;function c(G){const j=G;return T(j?.modified)&&T(j?.original)}e.isDiffEditorInput=c;function t(G){return T(G?.editor)}e.isEditorInputWithOptions=t;function o(G){const j=G;return t(G)&&j?.group!==void 0}e.isEditorInputWithOptionsAndGroup=o;function g(G){const j=G;return typeof j?.groupId=="number"&&T(j.editor)}e.isEditorIdentifier=g;var h;(function(G){G[G.UNKNOWN=0]="UNKNOWN",G[G.REPLACE=1]="REPLACE",G[G.MOVE=2]="MOVE",G[G.UNPIN=3]="UNPIN"})(h=e.EditorCloseContext||(e.EditorCloseContext={}));var _;(function(G){G[G.GROUP_ACTIVE=0]="GROUP_ACTIVE",G[G.GROUP_INDEX=1]="GROUP_INDEX",G[G.GROUP_LOCKED=2]="GROUP_LOCKED",G[G.EDITOR_OPEN=3]="EDITOR_OPEN",G[G.EDITOR_CLOSE=4]="EDITOR_CLOSE",G[G.EDITOR_MOVE=5]="EDITOR_MOVE",G[G.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",G[G.EDITOR_LABEL=7]="EDITOR_LABEL",G[G.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",G[G.EDITOR_PIN=9]="EDITOR_PIN",G[G.EDITOR_STICKY=10]="EDITOR_STICKY",G[G.EDITOR_DIRTY=11]="EDITOR_DIRTY",G[G.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(_=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var P;(function(G){G[G.PRIMARY=1]="PRIMARY",G[G.SECONDARY=2]="SECONDARY",G[G.BOTH=3]="BOTH",G[G.ANY=4]="ANY"})(P=e.SideBySideEditor||(e.SideBySideEditor={}));class R{getOriginalUri(j,$){if(!j)return;if($?.supportSideBySide){const{primary:se,secondary:Z}=this.getSideEditors(j);if(se&&Z){if($?.supportSideBySide===P.BOTH)return{primary:this.getOriginalUri(se,{filterByScheme:$.filterByScheme}),secondary:this.getOriginalUri(Z,{filterByScheme:$.filterByScheme})};if($?.supportSideBySide===P.ANY)return this.getOriginalUri(se,{filterByScheme:$.filterByScheme})??this.getOriginalUri(Z,{filterByScheme:$.filterByScheme});j=$.supportSideBySide===P.PRIMARY?se:Z}}if(f(j)||S(j))return;const ee=r(j)?j.preferredResource:j.resource;return!ee||!$||!$.filterByScheme?ee:this.filterUri(ee,$.filterByScheme)}getSideEditors(j){return i(j)||S(j)?{primary:j.primary,secondary:j.secondary}:c(j)||f(j)?{primary:j.modified,secondary:j.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(j,$){if(!j)return;if($?.supportSideBySide){const{primary:se,secondary:Z}=this.getSideEditors(j);if(se&&Z){if($?.supportSideBySide===P.BOTH)return{primary:this.getCanonicalUri(se,{filterByScheme:$.filterByScheme}),secondary:this.getCanonicalUri(Z,{filterByScheme:$.filterByScheme})};if($?.supportSideBySide===P.ANY)return this.getCanonicalUri(se,{filterByScheme:$.filterByScheme})??this.getCanonicalUri(Z,{filterByScheme:$.filterByScheme});j=$.supportSideBySide===P.PRIMARY?se:Z}}if(f(j)||S(j))return;const ee=j.resource;return!ee||!$||!$.filterByScheme?ee:this.filterUri(ee,$.filterByScheme)}filterUri(j,$){if(Array.isArray($)){if($.some(ee=>j.scheme===ee))return j}else if($===j.scheme)return j}}e.EditorResourceAccessor=new R;var W;(function(G){G[G.LEFT=0]="LEFT",G[G.RIGHT=1]="RIGHT"})(W=e.CloseDirection||(e.CloseDirection={}));class E{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(j){const $=this.instantiationService=j.get(D.IInstantiationService);for(const[ee,se]of this.editorSerializerConstructors)this.createEditorSerializer(ee,se,$);this.editorSerializerConstructors.clear()}createEditorSerializer(j,$,ee){const se=ee.createInstance($);this.editorSerializerInstances.set(j,se)}registerFileEditorFactory(j){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=j}getFileEditorFactory(){return(0,I.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(j,$){if(this.editorSerializerConstructors.has(j)||this.editorSerializerInstances.has(j))throw new Error(`A editor serializer with type ID '${j}' was already registered.`);return this.instantiationService?this.createEditorSerializer(j,$,this.instantiationService):this.editorSerializerConstructors.set(j,$),(0,B.toDisposable)(()=>{this.editorSerializerConstructors.delete(j),this.editorSerializerInstances.delete(j)})}getEditorSerializer(j){return this.editorSerializerInstances.get(typeof j=="string"?j:j.typeId)}}A.Registry.add(e.EditorExtensions.EditorFactory,new E);async function H(G,j){if(!G||!G.length)return[];const $=await Promise.all(G.map(async ee=>{const se=b.URI.revive(ee.fileUri);if(!se||!await j.canHandleResource(se))return;let le=ee.exists,ue=ee.type;if(typeof le!="boolean"||typeof ue!="number")try{ue=(await j.stat(se)).isDirectory?y.FileType.Directory:y.FileType.Unknown,le=!0}catch{le=!1}if(!le&&ee.openOnlyIfExists||ue===y.FileType.Directory)return;const Se={selection:le?ee.selection:void 0,pinned:!0,override:ee.editorOverrideId};let fe;return le?fe={resource:se,options:Se}:fe={resource:se,options:Se,forceUntitled:!0},fe}));return(0,M.coalesce)($)}e.pathsToEditors=H;var z;(function(G){G[G.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",G[G.SEQUENTIAL=1]="SEQUENTIAL"})(z=e.EditorsOrder||(e.EditorsOrder={}));function q(G){const j=G;if(!j)return!1;const $=j;if($.modified)return q($.modified);const ee=j;return!!(ee.contributionsState&&ee.viewState&&Array.isArray(ee.cursorState))}e.isTextEditorViewState=q}),define(Ee[61],we([1,0,10,2]),function(J,e,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function b(A,y){return A.scheme===s.Schemas.http||A.scheme===s.Schemas.https?A:(y&&y.authority&&y.isRemote&&A.scheme===s.Schemas.file&&(A=I.URI.from({scheme:s.Schemas.vscodeRemote,authority:y.authority,path:A.path})),I.URI.from({scheme:s.Schemas.https,authority:`${A.scheme}+${B(A.authority)}.${e.webviewRootResourceAuthority}`,path:A.path,fragment:A.fragment,query:A.query}))}e.asWebviewUri=b;function B(A){return A.replace(/./g,y=>{const M=y.charCodeAt(0);return M>=97&&M<=122||M>=65&&M<=90||M>=48&&M<=57?y:"-"+M.toString(16).padStart(4,"0")})}function D(A){return A.replace(/-([0-9a-f]{4})/g,(y,M)=>String.fromCharCode(parseInt(M,16)))}e.decodeAuthority=D}),define(Ee[157],we([1,0,5,6,61]),function(J,e,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class B{constructor(A,y,M){this._proxy=A,this._editors=y,this._initData=M,this._handlePool=0,this._disposables=new I.DisposableStore,this._insets=new Map,this._disposables.add(y.onDidChangeVisibleTextEditors(()=>{const L=y.getVisibleTextEditors();for(const v of this._insets.values())L.indexOf(v.editor)<0&&v.inset.dispose()}))}dispose(){this._insets.forEach(A=>A.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(A,y,M,L,v){let u;for(const d of this._editors.getVisibleTextEditors(!0))if(d.value===A){u=d;break}if(!u)throw new Error("not a visible editor");const m=this,l=this._handlePool++,n=new s.Emitter,f=new s.Emitter,S=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(d){return(0,b.asWebviewUri)(d,m._initData.remote)}get cspSource(){return b.webviewGenericCspSource}set options(d){this._options=d,m._proxy.$setOptions(l,d)}get options(){return this._options}set html(d){this._html=d,m._proxy.$setHtml(l,d)}get html(){return this._html}get onDidReceiveMessage(){return n.event}postMessage(d){return m._proxy.$postMessage(l,d)}},k=new class{constructor(){this.editor=A,this.line=y,this.height=M,this.webview=S,this.onDidDispose=f.event}dispose(){m._insets.has(l)&&(m._insets.delete(l),m._proxy.$disposeEditorInset(l),f.fire(),f.dispose(),n.dispose())}};return this._proxy.$createEditorInset(l,u.id,u.value.document.uri,y+1,M,L||{},v.identifier,v.extensionLocation),this._insets.set(l,{editor:A,inset:k,onDidReceiveMessage:n}),k}$onDidDispose(A){const y=this._insets.get(A);y&&y.inset.dispose()}$onDidReceiveMessage(A,y){const M=this._insets.get(A);M&&M.onDidReceiveMessage.fire(y)}}e.ExtHostEditorInsets=B}),define(Ee[158],we([1,0,5,13,130]),function(J,e,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class B{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new s.Emitter,this._onExit=new s.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(A){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=A}onEvent(A){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=A}onRequest(A){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=A}sendResponse(A){A.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${A.command}`)):this.internalSend("response",A)}sendRequest(A,y,M,L){const v={command:A};if(y&&Object.keys(y).length>0&&(v.arguments=y),this.internalSend("request",v),typeof L=="number"){const u=setTimeout(()=>{clearTimeout(u);const m=this.pendingRequests.get(v.seq);if(m){this.pendingRequests.delete(v.seq);const l={type:"response",seq:0,request_seq:v.seq,success:!1,command:A,message:(0,b.localize)(0,null,L,A)};m(l)}},L)}return M&&this.pendingRequests.set(v.seq,M),v.seq}acceptMessage(A){this.messageCallback?this.messageCallback(A):(this.queue.push(A),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(A,y){return A.type!=="event"||y.type!=="event"}async processQueue(){let A;for(;this.queue.length;){if((!A||this.needsTaskBoundaryBetween(this.queue[0],A))&&await(0,I.timeout)(0),A=this.queue.shift(),!A)return;switch(A.type){case"event":this.eventCallback&&this.eventCallback(A);break;case"request":this.requestCallback&&this.requestCallback(A);break;case"response":{const y=A,M=this.pendingRequests.get(y.request_seq);M&&(this.pendingRequests.delete(y.request_seq),M(y));break}}}}internalSend(A,y){y.type=A,y.seq=this.sequence++,this.sendMessage(y)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const A=new Map;this.pendingRequests.forEach((y,M)=>A.set(M,y)),await(0,I.timeout)(500),A.forEach((y,M)=>{y({type:"response",seq:0,request_seq:M,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(M)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=B}),define(Ee[159],we([1,0,131,44,3]),function(J,e,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ACCESS_TYPE=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.DEBUG_SERVICE_ID=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.DEBUG_SERVICE_ID="debugService",e.CONTEXT_DEBUG_TYPE=new I.RawContextKey("debugType",void 0,{type:"string",description:s.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new I.RawContextKey("debugConfigurationType",void 0,{type:"string",description:s.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new I.RawContextKey("debugState","inactive",{type:"string",description:s.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new I.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:s.localize(3,null)}),e.CONTEXT_IN_DEBUG_MODE=new I.RawContextKey("inDebugMode",!1,{type:"boolean",description:s.localize(4,null)}),e.CONTEXT_IN_DEBUG_REPL=new I.RawContextKey("inDebugRepl",!1,{type:"boolean",description:s.localize(5,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new I.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:s.localize(6,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new I.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:s.localize(7,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new I.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:s.localize(8,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new I.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:s.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new I.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:s.localize(10,null)}),e.CONTEXT_VARIABLES_FOCUSED=new I.RawContextKey("variablesFocused",!0,{type:"boolean",description:s.localize(11,null)}),e.CONTEXT_EXPRESSION_SELECTED=new I.RawContextKey("expressionSelected",!1,{type:"boolean",description:s.localize(12,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new I.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:s.localize(13,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new I.RawContextKey("callStackItemType",void 0,{type:"string",description:s.localize(14,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new I.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:s.localize(15,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new I.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:s.localize(16,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new I.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:s.localize(17,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new I.RawContextKey("watchItemType",void 0,{type:"string",description:s.localize(18,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new I.RawContextKey("canViewMemory",void 0,{type:"boolean",description:s.localize(19,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new I.RawContextKey("breakpointItemType",void 0,{type:"string",description:s.localize(20,null)}),e.CONTEXT_BREAKPOINT_ACCESS_TYPE=new I.RawContextKey("breakpointAccessType",void 0,{type:"string",description:s.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new I.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:s.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new I.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:s.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new I.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:s.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new I.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:s.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new I.RawContextKey("stepBackSupported",!1,{type:"boolean",description:s.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new I.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:s.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new I.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:s.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new I.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:s.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new I.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:s.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new I.RawContextKey("breakpointsExist",!1,{type:"boolean",description:s.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new I.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:s.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new I.RawContextKey("debugExtensionAvailable",!1,{type:"boolean",description:s.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new I.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:s.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new I.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:s.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new I.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:s.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new I.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:s.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new I.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:s.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new I.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:s.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new I.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:s.localize(40,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new I.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:s.localize(41,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new I.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:s.localize(42,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new I.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:s.localize(43,null)}),e.CONTEXT_MULTI_SESSION_REPL=new I.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:s.localize(44,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new I.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:s.localize(45,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new I.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:s.localize(46,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new I.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:s.localize(47,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new I.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:s.localize(48,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new I.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:s.localize(49,null)});const B=v=>s.localize(50,null,v);e.debuggerDisabledMessage=B,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:s.localize(51,null)};var D;(function(v){v[v.Inactive=0]="Inactive",v[v.Initializing=1]="Initializing",v[v.Stopped=2]="Stopped",v[v.Running=3]="Running"})(D=e.State||(e.State={}));function A(v){switch(v){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=A;var y;(function(v){v[v.Valid=0]="Valid",v[v.Unreadable=1]="Unreadable",v[v.Error=2]="Error"})(y=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var M;(function(v){v[v.Initial=1]="Initial",v[v.Dynamic=2]="Dynamic"})(M=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={})),e.IDebugService=(0,b.createDecorator)(e.DEBUG_SERVICE_ID);var L;(function(v){v[v.CONDITION=0]="CONDITION",v[v.HIT_COUNT=1]="HIT_COUNT",v[v.LOG_MESSAGE=2]="LOG_MESSAGE"})(L=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(Ee[160],we([1,0,9,2,17,26,10]),function(J,e,s,I,b,B,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const A=/{([^}]+)}/g;function y(r,i,c){return r.replace(A,function(t,o){return i&&o.length>0&&o[0]!=="_"?t:c&&c.hasOwnProperty(o)?c[o]:t})}e.formatPII=y;function M(r){const i={};for(const c of Object.keys(r))c.startsWith("!")||(i[c]=r[c]);return i}e.filterExceptionsFromTelemetry=M;function L(r){return r.configuration.request==="attach"&&!v(r)&&(!r.parentSession||L(r.parentSession))}e.isSessionAttach=L;function v(r){let i=r.configuration.type;if(!!i)return i==="vslsShare"&&(i=r.configuration.adapterProxy.configuration.type),(0,s.equalsIgnoreCase)(i,"extensionhost")||(0,s.equalsIgnoreCase)(i,"pwa-extensionhost")?r:r.parentSession?v(r.parentSession):void 0}e.getExtensionHostDebugSession=v;function u(r){return r.type&&(r.label||r.program||r.runtime)}e.isDebuggerMainContribution=u;function m(r,i,c){let t,o=0;const g=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let h=null;for(;h=g.exec(r);){const _=h.index+1,P=_+h[0].length;if(_<=i&&P>=c){t=h[0],o=_;break}}if(t){const _=/\w+/g;let P=null;for(;(P=_.exec(t))&&!(P.index+1+o+P[0].length>=c););P&&(t=t.substring(0,_.lastIndex))}return t?{start:o,end:o+t.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=m;const l=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function n(r){return!!(r&&r.match(l))}e.isUri=n;function f(r){if(typeof r.path=="string"&&!(typeof r.sourceReference=="number"&&r.sourceReference>0)){if(n(r.path))return I.URI.parse(r.path);if((0,b.isAbsolute)(r.path))return I.URI.file(r.path)}return r.path}function S(r){if(typeof r.path=="object"){const i=I.URI.revive(r.path);if(i)return i.scheme===D.Schemas.file?i.fsPath:i.toString()}return r.path}function k(r,i){const c=i?f:S,t=(0,B.deepClone)(r);return p(t,(o,g)=>{o&&g&&(g.path=c(g))}),t}e.convertToDAPaths=k;function d(r,i){const c=i?f:S,t=(0,B.deepClone)(r);return p(t,(o,g)=>{!o&&g&&(g.path=c(g))}),t}e.convertToVSCPaths=d;function p(r,i){switch(r.type){case"event":{const c=r;switch(c.event){case"output":i(!1,c.body.source);break;case"loadedSource":i(!1,c.body.source);break;case"breakpoint":i(!1,c.body.breakpoint.source);break;default:break}break}case"request":{const c=r;switch(c.command){case"setBreakpoints":i(!0,c.arguments.source);break;case"breakpointLocations":i(!0,c.arguments.source);break;case"source":i(!0,c.arguments.source);break;case"gotoTargets":i(!0,c.arguments.source);break;case"launchVSCode":c.arguments.args.forEach(t=>i(!1,t));break;default:break}break}case"response":{const c=r;if(c.success&&c.body)switch(c.command){case"stackTrace":c.body.stackFrames.forEach(t=>i(!1,t.source));break;case"loadedSources":c.body.sources.forEach(t=>i(!1,t));break;case"scopes":c.body.scopes.forEach(t=>i(!1,t.source));break;case"setFunctionBreakpoints":c.body.breakpoints.forEach(t=>i(!1,t.source));break;case"setBreakpoints":c.body.breakpoints.forEach(t=>i(!1,t.source));break;case"disassemble":{const t=c;t.body&&t.body.instructions.forEach(o=>i(!1,o.location))}break;default:break}break}}}function w(r){return r.filter(i=>!i.presentation?.hidden).sort((i,c)=>i.presentation?c.presentation?i.presentation.group?c.presentation.group?i.presentation.group!==c.presentation.group?i.presentation.group.localeCompare(c.presentation.group):a(i.presentation.order,c.presentation.order):-1:c.presentation.group?1:a(i.presentation.order,c.presentation.order):-1:c.presentation?1:0)}e.getVisibleAndSorted=w;function a(r,i){return typeof r!="number"?typeof i!="number"?0:1:typeof i!="number"?-1:r-i}async function T(r,i){const c=r.getValue("debug.saveBeforeStart",{overrideIdentifier:i.activeTextEditorLanguageId});if(c!=="none"&&(await i.saveAll(),c==="allEditorsInActiveGroup")){const t=i.activeEditorPane;t&&t.input.resource?.scheme===D.Schemas.untitled&&await i.save({editor:t.input,groupId:t.group.id})}await r.reloadConfiguration()}e.saveAllBeforeDebugStart=T}),define(Ee[85],we([1,0,29,161,71,10,17,23,44]),function(J,e,s,I,b,B,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor";var M;(function(t){t[t.Markup=1]="Markup",t[t.Code=2]="Code"})(M=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",b.Mimes.latex,b.Mimes.markdown,"image/png","image/jpeg",b.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[b.Mimes.latex,b.Mimes.markdown,"application/json",b.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var L;(function(t){t[t.Running=1]="Running",t[t.Idle=2]="Idle"})(L=e.NotebookRunState||(e.NotebookRunState={}));var v;(function(t){t[t.Unconfirmed=1]="Unconfirmed",t[t.Pending=2]="Pending",t[t.Executing=3]="Executing"})(v=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var u;(function(t){t[t.WithHardKernelDependency=0]="WithHardKernelDependency",t[t.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",t[t.Pure=2]="Pure",t[t.Never=3]="Never"})(u=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var m;(function(t){t.Always="always",t.Never="never",t.Optional="optional"})(m=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var l;(function(t){t[t.ModelChange=1]="ModelChange",t[t.Move=2]="Move",t[t.ChangeLanguage=5]="ChangeLanguage",t[t.Initialize=6]="Initialize",t[t.ChangeCellMetadata=7]="ChangeCellMetadata",t[t.Output=8]="Output",t[t.OutputItem=9]="OutputItem",t[t.ChangeCellContent=10]="ChangeCellContent",t[t.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",t[t.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",t[t.ChangeCellMime=13]="ChangeCellMime",t[t.Unknown=100]="Unknown"})(l=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var n;(function(t){t[t.Handle=0]="Handle",t[t.Index=1]="Index"})(n=e.SelectionStateType||(e.SelectionStateType={}));var f;(function(t){t[t.Replace=1]="Replace",t[t.Output=2]="Output",t[t.Metadata=3]="Metadata",t[t.CellLanguage=4]="CellLanguage",t[t.DocumentMetadata=5]="DocumentMetadata",t[t.Move=6]="Move",t[t.OutputItems=7]="OutputItems",t[t.PartialMetadata=8]="PartialMetadata",t[t.PartialInternalMetadata=9]="PartialInternalMetadata"})(f=e.CellEditType||(e.CellEditType={}));var S;(function(t){t.scheme=B.Schemas.vscodeNotebookCell;const o=/^ch(\d{7,})/;function g(E,H){return E.with({scheme:t.scheme,fragment:`ch${H.toString().padStart(7,"0")}${E.scheme!==B.Schemas.file?E.scheme:""}`})}t.generate=g;function h(E){if(E.scheme!==t.scheme)return;const H=o.exec(E.fragment);return H?{handle:Number(H[1]),notebook:E.with({scheme:E.fragment.substring(H[0].length)||B.Schemas.file,fragment:null})}:void 0}t.parse=h;function _(E,H){return E.with({scheme:B.Schemas.vscodeNotebookCellOutput,fragment:`op${H??""},${E.scheme!==B.Schemas.file?E.scheme:""}`})}t.generateCellOutputUri=_;function P(E){if(E.scheme!==B.Schemas.vscodeNotebookCellOutput)return;const H=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(E.fragment);if(!H)return;const z=H[1]&&H[1]!==""?H[1]:void 0,q=H[2];return{outputId:z,notebook:E.with({scheme:q||B.Schemas.file,fragment:null})}}t.parseCellOutputUri=P;function R(E,H,z){return E.with({scheme:z,fragment:`ch${H.toString().padStart(7,"0")}${E.scheme!==B.Schemas.file?E.scheme:""}`})}t.generateCellUri=R;function W(E,H){if(E.scheme!==H)return;const z=o.exec(E.fragment);return z?{handle:Number(z[1]),notebook:E.with({scheme:E.fragment.substring(z[0].length)||B.Schemas.file,fragment:null})}:void 0}t.parseCellUri=W})(S=e.CellUri||(e.CellUri={}));const k=t=>A.isWindows?t.replace(/\//g,"\\"):t;class d{constructor(o=[],g=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=g,this.order=[...new Set(o)].map(h=>({pattern:h,matches:s.parse(k(h))}))}sort(o){const g=new Map(I.Iterable.map(o,_=>[_,k(_)]));let h=[];for(const{matches:_}of this.order)for(const[P,R]of g)if(_(R)){h.push(P),g.delete(P);break}return g.size&&(h=h.concat([...g.keys()].sort((_,P)=>this.defaultOrder.indexOf(_)-this.defaultOrder.indexOf(P)))),h}prioritize(o,g){const h=this.findIndex(o);if(h===-1){this.order.unshift({pattern:o,matches:s.parse(k(o))});return}const _=new Set(g.map(R=>this.findIndex(R,h)));_.delete(-1);const P=Array.from(_).sort();this.order.splice(h+1,0,...P.map(R=>this.order[R]));for(let R=P.length-1;R>=0;R--)this.order.splice(P[R],1)}toArray(){return this.order.map(o=>o.pattern)}findIndex(o,g=this.order.length){const h=k(o);for(let _=0;_<g;_++)if(this.order[_].matches(h))return _;return-1}}e.MimeTypeDisplayOrder=d;function p(t,o,g,h=(_,P)=>_===P){const _=[];function P(E,H,z){if(H===0&&z.length===0)return;const q=_[_.length-1];q&&q.start+q.deleteCount===E?(q.deleteCount+=H,q.toInsert.push(...z)):_.push({start:E,deleteCount:H,toInsert:z})}let R=0,W=0;for(;;){if(R===t.length){P(R,0,o.slice(W));break}if(W===o.length){P(R,t.length-R,[]);break}const E=t[R],H=o[W];if(h(E,H)){R+=1,W+=1;continue}g(H)?(P(R,1,[]),R+=1):(P(R,0,[H]),W+=1)}return _}e.diff=p,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new y.RawContextKey("notebookEditorCursorAtBoundary","none");var w;(function(t){t.default="default",t.option="option"})(w=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function a(t){const o=t;return!!((typeof o.include=="string"||s.isRelativePattern(o.include))&&(typeof o.exclude=="string"||s.isRelativePattern(o.exclude)))}e.isDocumentExcludePattern=a;function T(t,o,g){if(Array.isArray(t.viewType)&&t.viewType.indexOf(o)>=0||t.viewType===o)return!0;if(t.filenamePattern){const h=a(t.filenamePattern)?t.filenamePattern.include:t.filenamePattern,_=a(t.filenamePattern)?t.filenamePattern.exclude:void 0;if(s.match(h,(0,D.basename)(g.fsPath).toLowerCase()))return!(_&&s.match(_,(0,D.basename)(g.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=T;class r{constructor(o){this.textModel=o}getElements(){const o=new Int32Array(this.textModel.cells.length);for(let g=0;g<this.textModel.cells.length;g++)o[g]=this.textModel.cells[g].getHashValue();return o}}e.CellSequence=r,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode"};var i;(function(t){t[t.Left=1]="Left",t[t.Right=2]="Right"})(i=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class c{static create(o){return`${c._prefix}${o}`}static parse(o){if(o.startsWith(c._prefix))return o.substring(c._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=c,c._prefix="notebook/"}),define(Ee[162],we([1,0,3]),function(J,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var I;(function(b){b[b.Output=1]="Output",b[b.OutputItems=2]="OutputItems",b[b.ExecutionState=3]="ExecutionState"})(I=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,s.createDecorator)("INotebookExecutionService")}),define(Ee[163],we([1,0,3,44]),function(J,e,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new I.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new I.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new I.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,s.createDecorator)(e.OUTPUT_SERVICE_ID);var b;(function(B){B[B.Append=1]="Append",B[B.Replace=2]="Replace",B[B.Clear=3]="Clear"})(b=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={}))}),define(Ee[164],we([1,0,132,3,44]),function(J,e,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new b.RawContextKey("customExecutionSupported",!0,s.localize(0,null)),e.ShellExecutionSupportedContext=new b.RawContextKey("shellExecutionSupported",!1,s.localize(1,null)),e.ProcessExecutionSupportedContext=new b.RawContextKey("processExecutionSupported",!1,s.localize(2,null)),e.ITaskService=(0,I.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(Ee[165],we([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function s(b){return[...b.entries()]}e.serializeEnvironmentVariableCollection=s;function I(b){return new Map(b)}e.deserializeEnvironmentVariableCollection=I}),define(Ee[62],we([1,0,2,48]),function(J,e,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var b;(function(c){c[c.Unset=0]="Unset",c[c.Queued=1]="Queued",c[c.Running=2]="Running",c[c.Passed=3]="Passed",c[c.Failed=4]="Failed",c[c.Skipped=5]="Skipped",c[c.Errored=6]="Errored"})(b=e.TestResultState||(e.TestResultState={}));var B;(function(c){c[c.Run=2]="Run",c[c.Debug=4]="Debug",c[c.Coverage=8]="Coverage",c[c.HasNonDefaultProfile=16]="HasNonDefaultProfile",c[c.HasConfigurable=32]="HasConfigurable"})(B=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var D;(function(c){c.serialize=t=>({range:t.range.toJSON(),uri:t.uri.toJSON()}),c.deserialize=t=>({range:I.Range.lift(t.range),uri:s.URI.revive(t.uri)})})(D=e.IRichLocation||(e.IRichLocation={}));var A;(function(c){c[c.Error=0]="Error",c[c.Info=1]="Info"})(A=e.TestMessageType||(e.TestMessageType={}));var y;(function(c){c.serialize=t=>({message:t.message,type:0,expected:t.expected,actual:t.actual,location:t.location&&D.serialize(t.location)}),c.deserialize=t=>({message:t.message,type:0,expected:t.expected,actual:t.actual,location:t.location&&D.deserialize(t.location)})})(y=e.ITestErrorMessage||(e.ITestErrorMessage={}));var M;(function(c){c.serialize=t=>({message:t.message,type:1,offset:t.offset,location:t.location&&D.serialize(t.location)}),c.deserialize=t=>({message:t.message,type:1,offset:t.offset,location:t.location&&D.deserialize(t.location)})})(M=e.ITestOutputMessage||(e.ITestOutputMessage={}));var L;(function(c){c.serialize=t=>t.type===0?y.serialize(t):M.serialize(t),c.deserialize=t=>t.type===0?y.deserialize(t):M.deserialize(t)})(L=e.ITestMessage||(e.ITestMessage={}));var v;(function(c){c.serialize=t=>({state:t.state,duration:t.duration,messages:t.messages.map(L.serialize)}),c.deserialize=t=>({state:t.state,duration:t.duration,messages:t.messages.map(L.deserialize)})})(v=e.ITestTaskState||(e.ITestTaskState={}));const u="\0",m=(c,t)=>c+u+t;e.namespaceTestTag=m;const l=c=>{const t=c.indexOf(u);return{ctrlId:c.slice(0,t),tagId:c.slice(t+1)}};e.denamespaceTestTag=l;var n;(function(c){c.serialize=t=>({extId:t.extId,label:t.label,tags:t.tags,busy:t.busy,children:void 0,uri:t.uri?.toJSON(),range:t.range?.toJSON()||null,description:t.description,error:t.error,sortText:t.sortText}),c.deserialize=t=>({extId:t.extId,label:t.label,tags:t.tags,busy:t.busy,children:void 0,uri:t.uri?s.URI.revive(t.uri):void 0,range:t.range?I.Range.lift(t.range):null,description:t.description,error:t.error,sortText:t.sortText})})(n=e.ITestItem||(e.ITestItem={}));var f;(function(c){c[c.NotExpandable=0]="NotExpandable",c[c.Expandable=1]="Expandable",c[c.BusyExpanding=2]="BusyExpanding",c[c.Expanded=3]="Expanded"})(f=e.TestItemExpandState||(e.TestItemExpandState={}));var S;(function(c){c.serialize=t=>({controllerId:t.controllerId,expand:t.expand,parent:t.parent,item:n.serialize(t.item)}),c.deserialize=t=>({controllerId:t.controllerId,expand:t.expand,parent:t.parent,item:n.deserialize(t.item)})})(S=e.InternalTestItem||(e.InternalTestItem={}));var k;(function(c){c.serialize=t=>{let o;return t.item&&(o={},t.item.label!==void 0&&(o.label=t.item.label),t.item.tags!==void 0&&(o.tags=t.item.tags),t.item.busy!==void 0&&(o.busy=t.item.busy),t.item.uri!==void 0&&(o.uri=t.item.uri?.toJSON()),t.item.range!==void 0&&(o.range=t.item.range?.toJSON()),t.item.description!==void 0&&(o.description=t.item.description),t.item.error!==void 0&&(o.error=t.item.error),t.item.sortText!==void 0&&(o.sortText=t.item.sortText)),{extId:t.extId,expand:t.expand,item:o}},c.deserialize=t=>{let o;return t.item&&(o={},t.item.label!==void 0&&(o.label=t.item.label),t.item.tags!==void 0&&(o.tags=t.item.tags),t.item.busy!==void 0&&(o.busy=t.item.busy),t.item.range!==void 0&&(o.range=t.item.range?I.Range.lift(t.item.range):null),t.item.description!==void 0&&(o.description=t.item.description),t.item.error!==void 0&&(o.error=t.item.error),t.item.sortText!==void 0&&(o.sortText=t.item.sortText)),{extId:t.extId,expand:t.expand,item:o}}})(k=e.ITestItemUpdate||(e.ITestItemUpdate={}));const d=(c,t)=>{t.expand!==void 0&&(c.expand=t.expand),t.item!==void 0&&(c.item=c.item?Object.assign(c.item,t.item):t.item)};e.applyTestItemUpdate=d;var p;(function(c){c.serialize=(t,o)=>({...S.serialize(t),children:o,ownComputedState:t.ownComputedState,computedState:t.computedState,tasks:t.tasks.map(v.serialize)})})(p=e.TestResultItem||(e.TestResultItem={}));var w;(function(c){c[c.Function=0]="Function",c[c.Statement=1]="Statement"})(w=e.DetailType||(e.DetailType={}));var a;(function(c){c[c.Add=0]="Add",c[c.Update=1]="Update",c[c.Remove=2]="Remove",c[c.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",c[c.Retire=4]="Retire",c[c.AddTag=5]="AddTag",c[c.RemoveTag=6]="RemoveTag"})(a=e.TestDiffOpType||(e.TestDiffOpType={}));var T;(function(c){c.deserialize=t=>t.op===0?{op:t.op,item:S.deserialize(t.item)}:t.op===1?{op:t.op,item:k.deserialize(t.item)}:t,c.serialize=t=>t.op===0?{op:t.op,item:S.serialize(t.item)}:t.op===1?{op:t.op,item:k.serialize(t.item)}:t})(T=e.TestsDiffOp||(e.TestsDiffOp={}));class r{add(t){}update(t){}remove(t,o){}complete(){}}e.IncrementalChangeCollector=r;class i{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(t){const o=this.createChangeCollector();for(const g of t)switch(g.op){case 0:{const h=S.deserialize(g.item);if(h.parent){if(this.items.has(h.parent)){const _=this.items.get(h.parent);_.children.add(h.item.extId);const P=this.createItem(h,_);this.items.set(h.item.extId,P),o.add(P)}}else{const _=this.createItem(h);this.roots.add(_),this.items.set(h.item.extId,_),o.add(_)}h.expand===2&&this.busyControllerCount++;break}case 1:{const h=k.deserialize(g.item),_=this.items.get(h.extId);if(!_)break;h.expand!==void 0&&(_.expand===2&&this.busyControllerCount--,h.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(_,h),o.update(_);break}case 2:{const h=this.items.get(g.itemId);if(!h)break;h.parent?this.items.get(h.parent).children.delete(h.item.extId):this.roots.delete(h);const _=[[g.itemId]];for(;_.length;)for(const P of _.pop()){const R=this.items.get(P);R&&(_.push(R.children),this.items.delete(P),o.remove(R,R!==h),R.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(g.itemId);break;case 3:this.updatePendingRoots(g.amount);break;case 5:this._tags.set(g.tag.id,g.tag);break;case 6:this._tags.delete(g.id);break}o.complete()}retireTest(t){}updatePendingRoots(t){this.pendingRootCount+=t}createChangeCollector(){return new r}}e.AbstractIncrementalTestCollection=i}),define(Ee[63],we([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var s;(function(B){B.Delimiter="\0"})(s=e.TestIdPathParts||(e.TestIdPathParts={}));var I;(function(B){B[B.IsSame=0]="IsSame",B[B.Disconnected=1]="Disconnected",B[B.IsChild=2]="IsChild",B[B.IsParent=3]="IsParent"})(I=e.TestPosition||(e.TestPosition={}));class b{constructor(D,A=D.length){if(this.path=D,this.viewEnd=A,D.length===0||A<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(D,A,y=D.parent){if(D.id===A)return new b([A]);let M=[D.id];for(let L=y;L&&L.id!==A;L=L.parent)M.push(L.id);return M.push(A),new b(M.reverse())}static isRoot(D){return!D.includes("\0")}static root(D){const A=D.indexOf("\0");return A===-1?D:D.slice(0,A)}static fromString(D){return new b(D.split("\0"))}static join(D,A){return new b([...D.path,A])}static joinToString(D,A){return D.toString()+"\0"+A}static compare(D,A){return D===A?0:A.startsWith(D+"\0")?2:D.startsWith(A+"\0")?3:1}get parentId(){return this.viewEnd>1?new b(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let D=1;D<=this.viewEnd;D++)yield new b(this.path,D)}compare(D){if(typeof D=="string")return b.compare(this.toString(),D);for(let A=0;A<D.viewEnd&&A<this.viewEnd;A++)if(D.path[A]!==this.path[A])return 1;return D.viewEnd>this.viewEnd?2:D.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let D=1;D<this.viewEnd;D++)this.stringifed+="\0",this.stringifed+=this.path[D]}return this.stringifed}}e.TestId=b}),define(Ee[166],we([1,0,17,86,11,26,23,73,133]),function(J,e,s,I,b,B,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class M{constructor(v,u,m,l){this._contributedVariables=new Map,this._context=v,this._labelService=u,this._userHomePromise=m,l&&(this._envVariablesPromise=l.then(n=>this.prepareEnv(n)))}prepareEnv(v){if(D.isWindows){const u=Object.create(null);return Object.keys(v).forEach(m=>{u[m.toLowerCase()]=v[m]}),u}return v}resolveWithEnvironment(v,u,m){return this.recursiveResolve(this.prepareEnv(v),u?u.uri:void 0,m)}async resolveAsync(v,u){const m={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(m,v?v.uri:void 0,u)}async resolveAnyBase(v,u,m,l){const n=B.deepClone(u);D.isWindows&&n.windows?Object.keys(n.windows).forEach(S=>n[S]=n.windows[S]):D.isMacintosh&&n.osx?Object.keys(n.osx).forEach(S=>n[S]=n.osx[S]):D.isLinux&&n.linux&&Object.keys(n.linux).forEach(S=>n[S]=n.linux[S]),delete n.windows,delete n.osx,delete n.linux;const f={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(f,v?v.uri:void 0,n,m,l)}async resolveAnyAsync(v,u,m){return this.resolveAnyBase(v,u,m)}async resolveAnyMap(v,u,m){const l=new Map;return{newConfig:await this.resolveAnyBase(v,u,m,l),resolvedVariables:l}}resolveWithInteractionReplace(v,u,m,l){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(v,u,m,l){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(v,u){if(this._contributedVariables.has(v))throw new Error("Variable "+v+" is contributed twice.");this._contributedVariables.set(v,u)}recursiveResolve(v,u,m,l,n){if(b.isString(m))return this.resolveString(v,u,m,l,n);if(b.isArray(m))return m.map(f=>this.recursiveResolve(v,u,f,l,n));if(b.isObject(m)){let f=Object.create(null);return Object.keys(m).forEach(S=>{const k=this.resolveString(v,u,S,l,n);f[k]=this.recursiveResolve(v,u,m[S],l,n)}),f}return m}resolveString(v,u,m,l,n){return m.replace(M.VARIABLE_REGEXP,(S,k)=>{if(k.includes(M.VARIABLE_LHS))return S;let d=this.evaluateSingleVariable(v,S,k,u,l);return n&&n.set(k,d),d!==S&&b.isString(d)&&d.match(M.VARIABLE_REGEXP)&&(d=this.resolveString(v,u,d,l,n)),d})}fsPath(v){return this._labelService?this._labelService.getUriLabel(v,{noPrefix:!0}):v.fsPath}evaluateSingleVariable(v,u,m,l,n){let f;const S=m.split(":");S.length>1&&(m=S[0],f=S[1]);const k=()=>{const w=this._context.getFilePath();if(w)return w;throw new Error((0,y.localize)(0,null,u))},d=()=>{const w=k();if(this._context.getWorkspaceFolderPathForFile){const a=this._context.getWorkspaceFolderPathForFile();if(a)return a}throw new Error((0,y.localize)(1,null,u,s.basename(w)))},p=()=>{if(f){const w=this._context.getFolderUri(f);if(w)return w;throw new Error((0,y.localize)(2,null,u,f))}if(l)return l;throw this._context.getWorkspaceFolderCount()>1?new Error((0,y.localize)(3,null,u)):new Error((0,y.localize)(4,null,u))};switch(m){case"env":if(f){if(v.env){const w=v.env[D.isWindows?f.toLowerCase():f];if(b.isString(w))return w}return""}throw new Error((0,y.localize)(5,null,u));case"config":if(f){const w=this._context.getConfigurationValue(l,f);if(b.isUndefinedOrNull(w))throw new Error((0,y.localize)(6,null,u,f));if(b.isObject(w))throw new Error((0,y.localize)(7,null,u,f));return w}throw new Error((0,y.localize)(8,null,u));case"command":return this.resolveFromMap(u,f,n,"command");case"input":return this.resolveFromMap(u,f,n,"input");default:switch(m){case"workspaceRoot":case"workspaceFolder":return(0,A.normalizeDriveLetter)(this.fsPath(p()));case"cwd":return l||f?(0,A.normalizeDriveLetter)(this.fsPath(p())):I.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return s.basename(this.fsPath(p()));case"userHome":{if(v.userHome)return v.userHome;throw new Error((0,y.localize)(9,null,u))}case"lineNumber":{const w=this._context.getLineNumber();if(w)return w;throw new Error((0,y.localize)(10,null,u))}case"selectedText":{const w=this._context.getSelectedText();if(w)return w;throw new Error((0,y.localize)(11,null,u))}case"file":return k();case"fileWorkspaceFolder":return d();case"relativeFile":return l||f?s.relative(this.fsPath(p()),k()):k();case"relativeFileDirname":{const w=s.dirname(k());if(l||f){const a=s.relative(this.fsPath(p()),w);return a.length===0?".":a}return w}case"fileDirname":return s.dirname(k());case"fileExtname":return s.extname(k());case"fileBasename":return s.basename(k());case"fileBasenameNoExtension":{const w=s.basename(k());return w.slice(0,w.length-s.extname(w).length)}case"fileDirnameBasename":return s.basename(s.dirname(k()));case"execPath":{const w=this._context.getExecPath();return w||u}case"execInstallFolder":{const w=this._context.getAppRoot();return w||u}case"pathSeparator":return s.sep;default:try{const w=f?`${m}:${f}`:m;return this.resolveFromMap(u,w,n,void 0)}catch{return u}}}}resolveFromMap(v,u,m,l){if(u&&m){const n=l===void 0?m[u]:m[l+":"+u];if(typeof n=="string")return n;throw new Error((0,y.localize)(12,null,v))}return v}}e.AbstractVariableResolverService=M,M.VARIABLE_LHS="${",M.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Ee[87],we([1,0,3,156]),function(J,e,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,s.createDecorator)("editorGroupsService");var b;(function(l){l[l.UP=0]="UP",l[l.DOWN=1]="DOWN",l[l.LEFT=2]="LEFT",l[l.RIGHT=3]="RIGHT"})(b=e.GroupDirection||(e.GroupDirection={}));var B;(function(l){l[l.HORIZONTAL=0]="HORIZONTAL",l[l.VERTICAL=1]="VERTICAL"})(B=e.GroupOrientation||(e.GroupOrientation={}));var D;(function(l){l[l.FIRST=0]="FIRST",l[l.LAST=1]="LAST",l[l.NEXT=2]="NEXT",l[l.PREVIOUS=3]="PREVIOUS"})(D=e.GroupLocation||(e.GroupLocation={}));var A;(function(l){l[l.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",l[l.EVEN=1]="EVEN",l[l.TOGGLE=2]="TOGGLE"})(A=e.GroupsArrangement||(e.GroupsArrangement={}));var y;(function(l){l[l.COPY_EDITORS=0]="COPY_EDITORS",l[l.MOVE_EDITORS=1]="MOVE_EDITORS"})(y=e.MergeGroupMode||(e.MergeGroupMode={}));function M(l){const n=l;return(0,I.isEditorInput)(n?.editor)&&(0,I.isEditorInput)(n?.replacement)}e.isEditorReplacement=M;var L;(function(l){l[l.CREATION_TIME=0]="CREATION_TIME",l[l.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",l[l.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(L=e.GroupsOrder||(e.GroupsOrder={}));var v;(function(l){l[l.NEW_EDITOR=1]="NEW_EDITOR",l[l.MOVE_EDITOR=2]="MOVE_EDITOR",l[l.COPY_EDITOR=3]="COPY_EDITOR"})(v=e.OpenEditorContext||(e.OpenEditorContext={}));function u(l){const n=l;return!!n&&typeof n.id=="number"&&Array.isArray(n.editors)}e.isEditorGroup=u;function m(l){return l.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=m}),define(Ee[167],we([1,0,3,87]),function(J,e,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,s.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function b(B){const D=B;return typeof B=="number"||(0,I.isEditorGroup)(D)}e.isPreferredGroup=b}),define(Ee[8],we([1,0,16,21,72,101,54,26,11,2,48,88,135,78,47,85,62,63,167,7]),function(J,e,s,I,b,B,D,A,y,M,L,v,u,m,l,n,f,S,k,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var p;(function(he){function pe(K){const{selectionStartLineNumber:_e,selectionStartColumn:Ce,positionLineNumber:$e,positionColumn:Ve}=K,lt=new d.Position(_e-1,Ce-1),gt=new d.Position($e-1,Ve-1);return new d.Selection(lt,gt)}he.to=pe;function ae(K){const{anchor:_e,active:Ce}=K;return{selectionStartLineNumber:_e.line+1,selectionStartColumn:_e.character+1,positionLineNumber:Ce.line+1,positionColumn:Ce.character+1}}he.from=ae})(p=e.Selection||(e.Selection={}));var w;(function(he){function pe(K){if(!K)return;const{start:_e,end:Ce}=K;return{startLineNumber:_e.line+1,startColumn:_e.character+1,endLineNumber:Ce.line+1,endColumn:Ce.character+1}}he.from=pe;function ae(K){if(!K)return;const{startLineNumber:_e,startColumn:Ce,endLineNumber:$e,endColumn:Ve}=K;return new d.Range(_e-1,Ce-1,$e-1,Ve-1)}he.to=ae})(w=e.Range||(e.Range={}));var a;(function(he){function pe(ae){switch(ae){case 1:return d.StandardTokenType.Comment;case 0:return d.StandardTokenType.Other;case 3:return d.StandardTokenType.RegEx;case 2:return d.StandardTokenType.String}}he.to=pe})(a=e.TokenType||(e.TokenType={}));var T;(function(he){function pe(K){return new d.Position(K.lineNumber-1,K.column-1)}he.to=pe;function ae(K){return{lineNumber:K.line+1,column:K.character+1}}he.from=ae})(T=e.Position||(e.Position={}));var r;(function(he){function pe(_e,Ce){return(0,s.coalesce)((0,s.asArray)(_e).map($e=>ae($e,Ce)))}he.from=pe;function ae(_e,Ce){if(typeof _e=="string")return{$serialized:!0,language:_e};if(_e)return{$serialized:!0,language:_e.language,scheme:K(_e.scheme,Ce),pattern:ce.from(_e.pattern)??void 0,exclusive:_e.exclusive,notebookType:_e.notebookType}}function K(_e,Ce){return Ce&&typeof _e=="string"?Ce.transformOutgoingScheme(_e):_e}})(r=e.DocumentSelector||(e.DocumentSelector={}));var i;(function(he){function pe(K){switch(K){case d.DiagnosticTag.Unnecessary:return 1;case d.DiagnosticTag.Deprecated:return 2}}he.from=pe;function ae(K){switch(K){case 1:return d.DiagnosticTag.Unnecessary;case 2:return d.DiagnosticTag.Deprecated;default:return}}he.to=ae})(i=e.DiagnosticTag||(e.DiagnosticTag={}));var c;(function(he){function pe(K){let _e;return K.code&&((0,y.isString)(K.code)||(0,y.isNumber)(K.code)?_e=String(K.code):_e={value:String(K.code.value),target:K.code.target}),{...w.from(K.range),message:K.message,source:K.source,code:_e,severity:o.from(K.severity),relatedInformation:K.relatedInformation&&K.relatedInformation.map(t.from),tags:Array.isArray(K.tags)?(0,s.coalesce)(K.tags.map(i.from)):void 0}}he.from=pe;function ae(K){const _e=new d.Diagnostic(w.to(K),K.message,o.to(K.severity));return _e.source=K.source,_e.code=(0,y.isString)(K.code)?K.code:K.code?.value,_e.relatedInformation=K.relatedInformation&&K.relatedInformation.map(t.to),_e.tags=K.tags&&(0,s.coalesce)(K.tags.map(i.to)),_e}he.to=ae})(c=e.Diagnostic||(e.Diagnostic={}));var t;(function(he){function pe(K){return{...w.from(K.location.range),message:K.message,resource:K.location.uri}}he.from=pe;function ae(K){return new d.DiagnosticRelatedInformation(new d.Location(K.resource,w.to(K)),K.message)}he.to=ae})(t=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var o;(function(he){function pe(K){switch(K){case d.DiagnosticSeverity.Error:return m.MarkerSeverity.Error;case d.DiagnosticSeverity.Warning:return m.MarkerSeverity.Warning;case d.DiagnosticSeverity.Information:return m.MarkerSeverity.Info;case d.DiagnosticSeverity.Hint:return m.MarkerSeverity.Hint}return m.MarkerSeverity.Error}he.from=pe;function ae(K){switch(K){case m.MarkerSeverity.Info:return d.DiagnosticSeverity.Information;case m.MarkerSeverity.Warning:return d.DiagnosticSeverity.Warning;case m.MarkerSeverity.Error:return d.DiagnosticSeverity.Error;case m.MarkerSeverity.Hint:return d.DiagnosticSeverity.Hint;default:return d.DiagnosticSeverity.Error}}he.to=ae})(o=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var g;(function(he){function pe(K){return typeof K=="number"&&K>=d.ViewColumn.One?K-1:K===d.ViewColumn.Beside?k.SIDE_GROUP:k.ACTIVE_GROUP}he.from=pe;function ae(K){if(typeof K=="number"&&K>=0)return K+1;throw new Error("invalid 'EditorGroupColumn'")}he.to=ae})(g=e.ViewColumn||(e.ViewColumn={}));function h(he){return typeof he.range!="undefined"}function _(he){return he.length===0?!0:!!h(he[0])}e.isDecorationOptionsArr=_;var P;(function(he){function pe(Ve){return Ve.map(he.from)}he.fromMany=pe;function ae(Ve){return Ve&&typeof Ve=="object"&&typeof Ve.language=="string"&&typeof Ve.value=="string"}function K(Ve){let lt;if(ae(Ve)){const{language:at,value:ot}=Ve;lt={value:"```"+at+`
`+ot+"\n```\n"}}else d.MarkdownString.isMarkdownString(Ve)?lt={value:Ve.value,isTrusted:Ve.isTrusted,supportThemeIcons:Ve.supportThemeIcons,supportHtml:Ve.supportHtml,baseUri:Ve.baseUri}:typeof Ve=="string"?lt={value:Ve}:lt={value:""};const gt=Object.create(null);lt.uris=gt;const Et=at=>{try{let ot=M.URI.parse(at,!0);ot=ot.with({query:_e(ot.query,gt)}),gt[at]=ot}catch{}return""},rt=new B.marked.Renderer;return rt.link=Et,rt.image=at=>typeof at=="string"?Et(b.parseHrefAndDimensions(at).href):"",(0,B.marked)(lt.value,{renderer:rt}),lt}he.from=K;function _e(Ve,lt){if(!Ve)return Ve;let gt;try{gt=(0,D.parse)(Ve)}catch{}if(!gt)return Ve;let Et=!1;return gt=(0,A.cloneAndChange)(gt,rt=>{if(M.URI.isUri(rt)){const at=`__uri_${Math.random().toString(16).slice(2,8)}`;return lt[at]=rt,Et=!0,at}else return}),Et?JSON.stringify(gt):Ve}function Ce(Ve){const lt=new d.MarkdownString(Ve.value,Ve.supportThemeIcons);return lt.isTrusted=Ve.isTrusted,lt.supportHtml=Ve.supportHtml,lt.baseUri=Ve.baseUri?M.URI.from(Ve.baseUri):void 0,lt}he.to=Ce;function $e(Ve){if(!!Ve)return typeof Ve=="string"?Ve:he.from(Ve)}he.fromStrict=$e})(P=e.MarkdownString||(e.MarkdownString={}));function R(he){return _(he)?he.map(pe=>({range:w.from(pe.range),hoverMessage:Array.isArray(pe.hoverMessage)?P.fromMany(pe.hoverMessage):pe.hoverMessage?P.from(pe.hoverMessage):void 0,renderOptions:pe.renderOptions})):he.map(pe=>({range:w.from(pe)}))}e.fromRangeOrRangeWithMessage=R;function W(he){return typeof he=="undefined"?he:typeof he=="string"?M.URI.file(he):he}e.pathOrURIToURI=W;var E;(function(he){function pe(ae){return typeof ae=="undefined"?ae:{contentText:ae.contentText,contentIconPath:ae.contentIconPath?W(ae.contentIconPath):void 0,border:ae.border,borderColor:ae.borderColor,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,color:ae.color,backgroundColor:ae.backgroundColor,margin:ae.margin,width:ae.width,height:ae.height}}he.from=pe})(E=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var H;(function(he){function pe(ae){return typeof ae=="undefined"?ae:{backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?W(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?E.from(ae.before):void 0,after:ae.after?E.from(ae.after):void 0}}he.from=pe})(H=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var z;(function(he){function pe(ae){if(typeof ae=="undefined")return ae;switch(ae){case d.DecorationRangeBehavior.OpenOpen:return 0;case d.DecorationRangeBehavior.ClosedClosed:return 1;case d.DecorationRangeBehavior.OpenClosed:return 2;case d.DecorationRangeBehavior.ClosedOpen:return 3}}he.from=pe})(z=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var q;(function(he){function pe(ae){return{isWholeLine:ae.isWholeLine,rangeBehavior:ae.rangeBehavior?z.from(ae.rangeBehavior):void 0,overviewRulerLane:ae.overviewRulerLane,light:ae.light?H.from(ae.light):void 0,dark:ae.dark?H.from(ae.dark):void 0,backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?W(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?E.from(ae.before):void 0,after:ae.after?E.from(ae.after):void 0}}he.from=pe})(q=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var G;(function(he){function pe(K){return{text:K.newText,eol:K.newEol&&tt.from(K.newEol),range:w.from(K.range)}}he.from=pe;function ae(K){const _e=new d.TextEdit(w.to(K.range),K.text);return _e.newEol=typeof K.eol=="undefined"?void 0:tt.to(K.eol),_e}he.to=ae})(G=e.TextEdit||(e.TextEdit={}));var j;(function(he){function pe(K,_e){const Ce={edits:[]};if(K instanceof d.WorkspaceEdit)for(let $e of K._allEntries())$e._type===1?Ce.edits.push({_type:1,oldUri:$e.from,newUri:$e.to,options:$e.options,metadata:$e.metadata}):$e._type===2?Ce.edits.push({_type:2,resource:$e.uri,edit:G.from($e.edit),modelVersionId:_e?.getTextDocumentVersion($e.uri),metadata:$e.metadata}):$e._type===3?Ce.edits.push({_type:3,metadata:$e.metadata,resource:$e.uri,edit:$e.edit,notebookMetadata:$e.notebookMetadata,notebookVersionId:_e?.getNotebookDocumentVersion($e.uri)}):$e._type===5&&Ce.edits.push({_type:3,metadata:$e.metadata,resource:$e.uri,notebookVersionId:_e?.getNotebookDocumentVersion($e.uri),edit:{editType:1,index:$e.index,count:$e.count,cells:$e.cells.map(St.from)}});return Ce}he.from=pe;function ae(K){const _e=new d.WorkspaceEdit;for(const Ce of K.edits)Ce.edit?_e.replace(M.URI.revive(Ce.resource),w.to(Ce.edit.range),Ce.edit.text):_e.renameFile(M.URI.revive(Ce.oldUri),M.URI.revive(Ce.newUri),Ce.options);return _e}he.to=ae})(j=e.WorkspaceEdit||(e.WorkspaceEdit={}));var $;(function(he){const pe=Object.create(null);pe[d.SymbolKind.File]=0,pe[d.SymbolKind.Module]=1,pe[d.SymbolKind.Namespace]=2,pe[d.SymbolKind.Package]=3,pe[d.SymbolKind.Class]=4,pe[d.SymbolKind.Method]=5,pe[d.SymbolKind.Property]=6,pe[d.SymbolKind.Field]=7,pe[d.SymbolKind.Constructor]=8,pe[d.SymbolKind.Enum]=9,pe[d.SymbolKind.Interface]=10,pe[d.SymbolKind.Function]=11,pe[d.SymbolKind.Variable]=12,pe[d.SymbolKind.Constant]=13,pe[d.SymbolKind.String]=14,pe[d.SymbolKind.Number]=15,pe[d.SymbolKind.Boolean]=16,pe[d.SymbolKind.Array]=17,pe[d.SymbolKind.Object]=18,pe[d.SymbolKind.Key]=19,pe[d.SymbolKind.Null]=20,pe[d.SymbolKind.EnumMember]=21,pe[d.SymbolKind.Struct]=22,pe[d.SymbolKind.Event]=23,pe[d.SymbolKind.Operator]=24,pe[d.SymbolKind.TypeParameter]=25;function ae(_e){return typeof pe[_e]=="number"?pe[_e]:6}he.from=ae;function K(_e){for(const Ce in pe)if(pe[Ce]===_e)return Number(Ce);return d.SymbolKind.Property}he.to=K})($=e.SymbolKind||(e.SymbolKind={}));var ee;(function(he){function pe(K){switch(K){case d.SymbolTag.Deprecated:return 1}}he.from=pe;function ae(K){switch(K){case 1:return d.SymbolTag.Deprecated}}he.to=ae})(ee=e.SymbolTag||(e.SymbolTag={}));var se;(function(he){function pe(K){return{name:K.name,kind:$.from(K.kind),tags:K.tags&&K.tags.map(ee.from),containerName:K.containerName,location:fe.from(K.location)}}he.from=pe;function ae(K){const _e=new d.SymbolInformation(K.name,$.to(K.kind),K.containerName,fe.to(K.location));return _e.tags=K.tags&&K.tags.map(ee.to),_e}he.to=ae})(se=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var Z;(function(he){function pe(K){const _e={name:K.name||"!!MISSING: name!!",detail:K.detail,range:w.from(K.range),selectionRange:w.from(K.selectionRange),kind:$.from(K.kind),tags:K.tags?.map(ee.from)??[]};return K.children&&(_e.children=K.children.map(pe)),_e}he.from=pe;function ae(K){const _e=new d.DocumentSymbol(K.name,K.detail,$.to(K.kind),w.to(K.range),w.to(K.selectionRange));return(0,s.isNonEmptyArray)(K.tags)&&(_e.tags=K.tags.map(ee.to)),K.children&&(_e.children=K.children.map(ae)),_e}he.to=ae})(Z=e.DocumentSymbol||(e.DocumentSymbol={}));var le;(function(he){function pe(K){const _e=new d.CallHierarchyItem($.to(K.kind),K.name,K.detail||"",M.URI.revive(K.uri),w.to(K.range),w.to(K.selectionRange));return _e._sessionId=K._sessionId,_e._itemId=K._itemId,_e}he.to=pe;function ae(K,_e,Ce){if(_e=_e??K._sessionId,Ce=Ce??K._itemId,_e===void 0||Ce===void 0)throw new Error("invalid item");return{_sessionId:_e,_itemId:Ce,name:K.name,detail:K.detail,kind:$.from(K.kind),uri:K.uri,range:w.from(K.range),selectionRange:w.from(K.selectionRange),tags:K.tags?.map(ee.from)}}he.from=ae})(le=e.CallHierarchyItem||(e.CallHierarchyItem={}));var ue;(function(he){function pe(ae){return new d.CallHierarchyIncomingCall(le.to(ae.from),ae.fromRanges.map(K=>w.to(K)))}he.to=pe})(ue=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var Se;(function(he){function pe(ae){return new d.CallHierarchyOutgoingCall(le.to(ae.to),ae.fromRanges.map(K=>w.to(K)))}he.to=pe})(Se=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var fe;(function(he){function pe(K){return{range:K.range&&w.from(K.range),uri:K.uri}}he.from=pe;function ae(K){return new d.Location(M.URI.revive(K.uri),w.to(K.range))}he.to=ae})(fe=e.location||(e.location={}));var ne;(function(he){function pe(K){const _e=K,Ce=K;return{originSelectionRange:_e.originSelectionRange?w.from(_e.originSelectionRange):void 0,uri:_e.targetUri?_e.targetUri:Ce.uri,range:w.from(_e.targetRange?_e.targetRange:Ce.range),targetSelectionRange:_e.targetSelectionRange?w.from(_e.targetSelectionRange):void 0}}he.from=pe;function ae(K){return{targetUri:M.URI.revive(K.uri),targetRange:w.to(K.range),targetSelectionRange:K.targetSelectionRange?w.to(K.targetSelectionRange):void 0,originSelectionRange:K.originSelectionRange?w.to(K.originSelectionRange):void 0}}he.to=ae})(ne=e.DefinitionLink||(e.DefinitionLink={}));var me;(function(he){function pe(K){return{range:w.from(K.range),contents:P.fromMany(K.contents)}}he.from=pe;function ae(K){return new d.Hover(K.contents.map(P.to),w.to(K.range))}he.to=ae})(me=e.Hover||(e.Hover={}));var ke;(function(he){function pe(K){return{range:w.from(K.range),expression:K.expression}}he.from=pe;function ae(K){return new d.EvaluatableExpression(w.to(K.range),K.expression)}he.to=ae})(ke=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Ae;(function(he){function pe(K){if(K instanceof d.InlineValueText)return{type:"text",range:w.from(K.range),text:K.text};if(K instanceof d.InlineValueVariableLookup)return{type:"variable",range:w.from(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};if(K instanceof d.InlineValueEvaluatableExpression)return{type:"expression",range:w.from(K.range),expression:K.expression};throw new Error("Unknown 'InlineValue' type")}he.from=pe;function ae(K){switch(K.type){case"text":return{range:w.to(K.range),text:K.text};case"variable":return{range:w.to(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};case"expression":return{range:w.to(K.range),expression:K.expression}}}he.to=ae})(Ae=e.InlineValue||(e.InlineValue={}));var Be;(function(he){function pe(K){return{frameId:K.frameId,stoppedLocation:w.from(K.stoppedLocation)}}he.from=pe;function ae(K){return new d.InlineValueContext(K.frameId,w.to(K.stoppedLocation))}he.to=ae})(Be=e.InlineValueContext||(e.InlineValueContext={}));var Xe;(function(he){function pe(K){return{range:w.from(K.range),kind:K.kind}}he.from=pe;function ae(K){return new d.DocumentHighlight(w.to(K.range),K.kind)}he.to=ae})(Xe=e.DocumentHighlight||(e.DocumentHighlight={}));var ge;(function(he){function pe(ae){switch(ae){case 1:return d.CompletionTriggerKind.TriggerCharacter;case 2:return d.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return d.CompletionTriggerKind.Invoke}}he.to=pe})(ge=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var de;(function(he){function pe(ae){return{triggerKind:ge.to(ae.triggerKind),triggerCharacter:ae.triggerCharacter}}he.to=pe})(de=e.CompletionContext||(e.CompletionContext={}));var N;(function(he){function pe(K){switch(K){case d.CompletionItemTag.Deprecated:return 1}}he.from=pe;function ae(K){switch(K){case 1:return d.CompletionItemTag.Deprecated}}he.to=ae})(N=e.CompletionItemTag||(e.CompletionItemTag={}));var F;(function(he){const pe=new Map([[d.CompletionItemKind.Method,0],[d.CompletionItemKind.Function,1],[d.CompletionItemKind.Constructor,2],[d.CompletionItemKind.Field,3],[d.CompletionItemKind.Variable,4],[d.CompletionItemKind.Class,5],[d.CompletionItemKind.Interface,7],[d.CompletionItemKind.Struct,6],[d.CompletionItemKind.Module,8],[d.CompletionItemKind.Property,9],[d.CompletionItemKind.Unit,12],[d.CompletionItemKind.Value,13],[d.CompletionItemKind.Constant,14],[d.CompletionItemKind.Enum,15],[d.CompletionItemKind.EnumMember,16],[d.CompletionItemKind.Keyword,17],[d.CompletionItemKind.Snippet,27],[d.CompletionItemKind.Text,18],[d.CompletionItemKind.Color,19],[d.CompletionItemKind.File,20],[d.CompletionItemKind.Reference,21],[d.CompletionItemKind.Folder,23],[d.CompletionItemKind.Event,10],[d.CompletionItemKind.Operator,11],[d.CompletionItemKind.TypeParameter,24],[d.CompletionItemKind.Issue,26],[d.CompletionItemKind.User,25]]);function ae(Ce){return pe.get(Ce)??9}he.from=ae;const K=new Map([[0,d.CompletionItemKind.Method],[1,d.CompletionItemKind.Function],[2,d.CompletionItemKind.Constructor],[3,d.CompletionItemKind.Field],[4,d.CompletionItemKind.Variable],[5,d.CompletionItemKind.Class],[7,d.CompletionItemKind.Interface],[6,d.CompletionItemKind.Struct],[8,d.CompletionItemKind.Module],[9,d.CompletionItemKind.Property],[12,d.CompletionItemKind.Unit],[13,d.CompletionItemKind.Value],[14,d.CompletionItemKind.Constant],[15,d.CompletionItemKind.Enum],[16,d.CompletionItemKind.EnumMember],[17,d.CompletionItemKind.Keyword],[27,d.CompletionItemKind.Snippet],[18,d.CompletionItemKind.Text],[19,d.CompletionItemKind.Color],[20,d.CompletionItemKind.File],[21,d.CompletionItemKind.Reference],[23,d.CompletionItemKind.Folder],[10,d.CompletionItemKind.Event],[11,d.CompletionItemKind.Operator],[24,d.CompletionItemKind.TypeParameter],[25,d.CompletionItemKind.User],[26,d.CompletionItemKind.Issue]]);function _e(Ce){return K.get(Ce)??d.CompletionItemKind.Property}he.to=_e})(F=e.CompletionItemKind||(e.CompletionItemKind={}));var C;(function(he){function pe(ae,K){const _e=new d.CompletionItem(ae.label);return _e.insertText=ae.insertText,_e.kind=F.to(ae.kind),_e.tags=ae.tags?.map(N.to),_e.detail=ae.detail,_e.documentation=b.isMarkdownString(ae.documentation)?P.to(ae.documentation):ae.documentation,_e.sortText=ae.sortText,_e.filterText=ae.filterText,_e.preselect=ae.preselect,_e.commitCharacters=ae.commitCharacters,L.Range.isIRange(ae.range)?_e.range=w.to(ae.range):typeof ae.range=="object"&&(_e.range={inserting:w.to(ae.range.insert),replacing:w.to(ae.range.replace)}),_e.keepWhitespace=typeof ae.insertTextRules=="undefined"?!1:Boolean(ae.insertTextRules&1),typeof ae.insertTextRules!="undefined"&&ae.insertTextRules&4?_e.insertText=new d.SnippetString(ae.insertText):(_e.insertText=ae.insertText,_e.textEdit=_e.range instanceof d.Range?new d.TextEdit(_e.range,_e.insertText):void 0),ae.additionalTextEdits&&ae.additionalTextEdits.length>0&&(_e.additionalTextEdits=ae.additionalTextEdits.map(Ce=>G.to(Ce))),_e.command=K&&ae.command?K.fromInternal(ae.command):void 0,_e}he.to=pe})(C=e.CompletionItem||(e.CompletionItem={}));var O;(function(he){function pe(K){return{label:K.label,documentation:P.fromStrict(K.documentation)}}he.from=pe;function ae(K){return{label:K.label,documentation:b.isMarkdownString(K.documentation)?P.to(K.documentation):K.documentation}}he.to=ae})(O=e.ParameterInformation||(e.ParameterInformation={}));var x;(function(he){function pe(K){return{label:K.label,documentation:P.fromStrict(K.documentation),parameters:Array.isArray(K.parameters)?K.parameters.map(O.from):[],activeParameter:K.activeParameter}}he.from=pe;function ae(K){return{label:K.label,documentation:b.isMarkdownString(K.documentation)?P.to(K.documentation):K.documentation,parameters:Array.isArray(K.parameters)?K.parameters.map(O.to):[],activeParameter:K.activeParameter}}he.to=ae})(x=e.SignatureInformation||(e.SignatureInformation={}));var Q;(function(he){function pe(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(x.from):[]}}he.from=pe;function ae(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(x.to):[]}}he.to=ae})(Q=e.SignatureHelp||(e.SignatureHelp={}));var re;(function(he){function pe(ae,K){const _e=new d.InlayHint(T.to(K.position),typeof K.label=="string"?K.label:K.label.map(ve.to.bind(void 0,ae)),K.kind&&Ie.to(K.kind));return _e.textEdits=K.textEdits&&K.textEdits.map(G.to),_e.tooltip=b.isMarkdownString(K.tooltip)?P.to(K.tooltip):K.tooltip,_e.paddingLeft=K.paddingLeft,_e.paddingRight=K.paddingRight,_e}he.to=pe})(re=e.InlayHint||(e.InlayHint={}));var ve;(function(he){function pe(ae,K){const _e=new d.InlayHintLabelPart(K.label);return _e.tooltip=b.isMarkdownString(K.tooltip)?P.to(K.tooltip):K.tooltip,v.Command.is(K.command)&&(_e.command=ae.fromInternal(K.command)),K.location&&(_e.location=fe.to(K.location)),_e}he.to=pe})(ve=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var Ie;(function(he){function pe(K){return K}he.from=pe;function ae(K){return K}he.to=ae})(Ie=e.InlayHintKind||(e.InlayHintKind={}));var Me;(function(he){function pe(K){return{range:w.from(K.range),url:K.target,tooltip:K.tooltip}}he.from=pe;function ae(K){let _e;if(K.url)try{_e=typeof K.url=="string"?M.URI.parse(K.url,!0):M.URI.revive(K.url)}catch{}return new d.DocumentLink(w.to(K.range),_e)}he.to=ae})(Me=e.DocumentLink||(e.DocumentLink={}));var Le;(function(he){function pe(K){const _e=new d.ColorPresentation(K.label);return K.textEdit&&(_e.textEdit=G.to(K.textEdit)),K.additionalTextEdits&&(_e.additionalTextEdits=K.additionalTextEdits.map(Ce=>G.to(Ce))),_e}he.to=pe;function ae(K){return{label:K.label,textEdit:K.textEdit?G.from(K.textEdit):void 0,additionalTextEdits:K.additionalTextEdits?K.additionalTextEdits.map(_e=>G.from(_e)):void 0}}he.from=ae})(Le=e.ColorPresentation||(e.ColorPresentation={}));var ze;(function(he){function pe(K){return new d.Color(K[0],K[1],K[2],K[3])}he.to=pe;function ae(K){return[K.red,K.green,K.blue,K.alpha]}he.from=ae})(ze=e.Color||(e.Color={}));var xe;(function(he){function pe(K){return{range:w.from(K.range)}}he.from=pe;function ae(K){return new d.SelectionRange(w.to(K.range))}he.to=ae})(xe=e.SelectionRange||(e.SelectionRange={}));var Re;(function(he){function pe(ae){switch(ae){case 2:return d.TextDocumentSaveReason.AfterDelay;case 1:return d.TextDocumentSaveReason.Manual;case 3:case 4:return d.TextDocumentSaveReason.FocusOut}}he.to=pe})(Re=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Qe;(function(he){function pe(K){switch(K){case d.TextEditorLineNumbersStyle.Off:return 0;case d.TextEditorLineNumbersStyle.Relative:return 2;case d.TextEditorLineNumbersStyle.On:default:return 1}}he.from=pe;function ae(K){switch(K){case 0:return d.TextEditorLineNumbersStyle.Off;case 2:return d.TextEditorLineNumbersStyle.Relative;case 1:default:return d.TextEditorLineNumbersStyle.On}}he.to=ae})(Qe=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var tt;(function(he){function pe(K){if(K===d.EndOfLine.CRLF)return 1;if(K===d.EndOfLine.LF)return 0}he.from=pe;function ae(K){if(K===1)return d.EndOfLine.CRLF;if(K===0)return d.EndOfLine.LF}he.to=ae})(tt=e.EndOfLine||(e.EndOfLine={}));var Te;(function(he){function pe(ae){if(typeof ae=="object")return ae.viewId;switch(ae){case d.ProgressLocation.SourceControl:return 3;case d.ProgressLocation.Window:return 10;case d.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}he.from=pe})(Te=e.ProgressLocation||(e.ProgressLocation={}));var it;(function(he){function pe(ae){const K={start:ae.start+1,end:ae.end+1};return ae.kind&&(K.kind=X.from(ae.kind)),K}he.from=pe})(it=e.FoldingRange||(e.FoldingRange={}));var X;(function(he){function pe(ae){if(ae)switch(ae){case d.FoldingRangeKind.Comment:return v.FoldingRangeKind.Comment;case d.FoldingRangeKind.Imports:return v.FoldingRangeKind.Imports;case d.FoldingRangeKind.Region:return v.FoldingRangeKind.Region}}he.from=pe})(X=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Y;(function(he){function pe(ae){if(ae)return{pinned:typeof ae.preview=="boolean"?!ae.preview:void 0,inactive:ae.background,preserveFocus:ae.preserveFocus,selection:typeof ae.selection=="object"?w.from(ae.selection):void 0,override:typeof ae.override=="boolean"?u.EditorResolution.DISABLED:void 0}}he.from=pe})(Y=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var ce;(function(he){function pe(Ce){return Ce instanceof d.RelativePattern?Ce.toJSON():typeof Ce=="string"?Ce:ae(Ce)||K(Ce)?new d.RelativePattern(Ce.baseUri??Ce.base,Ce.pattern).toJSON():Ce}he.from=pe;function ae(Ce){const $e=Ce;return $e?M.URI.isUri($e.baseUri)&&typeof $e.pattern=="string":!1}function K(Ce){const $e=Ce;return $e?typeof $e.base=="string"&&typeof $e.pattern=="string":!1}function _e(Ce){return typeof Ce=="string"?Ce:new d.RelativePattern(M.URI.revive(Ce.baseUri),Ce.pattern)}he.to=_e})(ce=e.GlobPattern||(e.GlobPattern={}));var Oe;(function(he){function pe(ae){if(ae){if(Array.isArray(ae))return ae.map(pe);if(typeof ae=="string")return ae;{const K=ae;return{language:K.language,scheme:K.scheme,pattern:ce.from(K.pattern),exclusive:K.exclusive}}}else return}he.from=pe})(Oe=e.LanguageSelector||(e.LanguageSelector={}));var We;(function(he){function pe(K){return{start:K.start,end:K.end}}he.from=pe;function ae(K){return new d.NotebookRange(K.start,K.end)}he.to=ae})(We=e.NotebookRange||(e.NotebookRange={}));var Ge;(function(he){function pe(K){return{timing:typeof K.runStartTime=="number"&&typeof K.runEndTime=="number"?{startTime:K.runStartTime,endTime:K.runEndTime}:void 0,executionOrder:K.executionOrder,success:K.lastRunSuccess}}he.to=pe;function ae(K){return{lastRunSuccess:K.success,runStartTime:K.timing?.startTime,runEndTime:K.timing?.endTime,executionOrder:K.executionOrder}}he.from=ae})(Ge=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Je;(function(he){function pe(ae){if(ae===n.NotebookCellExecutionState.Executing)return d.NotebookCellExecutionState.Executing;if(ae===n.NotebookCellExecutionState.Pending)return d.NotebookCellExecutionState.Pending;if(ae===n.NotebookCellExecutionState.Unconfirmed)return d.NotebookCellExecutionState.Pending;throw new Error(`Unknown state: ${ae}`)}he.to=pe})(Je=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var ft;(function(he){function pe(K){switch(K){case d.NotebookCellKind.Markup:return n.CellKind.Markup;case d.NotebookCellKind.Code:default:return n.CellKind.Code}}he.from=pe;function ae(K){switch(K){case n.CellKind.Markup:return d.NotebookCellKind.Markup;case n.CellKind.Code:default:return d.NotebookCellKind.Code}}he.to=ae})(ft=e.NotebookCellKind||(e.NotebookCellKind={}));var It;(function(he){function pe(K){const _e={metadata:K.metadata??Object.create(null),cells:[]};for(let Ce of K.cells)d.NotebookCellData.validate(Ce),_e.cells.push(St.from(Ce));return _e}he.from=pe;function ae(K){const _e=new d.NotebookData(K.cells.map(St.to));return(0,y.isEmptyObject)(K.metadata)||(_e.metadata=K.metadata),_e}he.to=ae})(It=e.NotebookData||(e.NotebookData={}));var St;(function(he){function pe(K){return{cellKind:ft.from(K.kind),language:K.languageId,mime:K.mime,source:K.value,metadata:K.metadata,internalMetadata:Ge.from(K.executionSummary??{}),outputs:K.outputs?K.outputs.map(qe.from):[]}}he.from=pe;function ae(K){return new d.NotebookCellData(ft.to(K.cellKind),K.source,K.language,K.mime,K.outputs?K.outputs.map(qe.to):void 0,K.metadata,K.internalMetadata?Ge.to(K.internalMetadata):void 0)}he.to=ae})(St=e.NotebookCellData||(e.NotebookCellData={}));var kt;(function(he){function pe(K){return{mime:K.mime,valueBytes:I.VSBuffer.wrap(K.data)}}he.from=pe;function ae(K){return new d.NotebookCellOutputItem(K.valueBytes.buffer,K.mime)}he.to=ae})(kt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var qe;(function(he){function pe(K){return{outputId:K.id,items:K.items.map(kt.from),metadata:K.metadata}}he.from=pe;function ae(K){const _e=K.items.map(kt.to);return new d.NotebookCellOutput(_e,K.outputId,K.metadata)}he.to=ae})(qe=e.NotebookCellOutput||(e.NotebookCellOutput={}));var vt;(function(he){function pe(_e){return K(_e)?{include:(0,y.withNullAsUndefined)(ce.from(_e.include)),exclude:(0,y.withNullAsUndefined)(ce.from(_e.exclude))}:(0,y.withNullAsUndefined)(ce.from(_e))}he.from=pe;function ae(_e){return K(_e)?{include:ce.to(_e.include),exclude:ce.to(_e.exclude)}:ce.to(_e)}he.to=ae;function K(_e){const Ce=_e;return Ce?!!Ce.include&&!!Ce.exclude:!1}})(vt=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Nt;(function(he){function pe(ae){return{backgroundColor:ae.backgroundColor,borderColor:ae.borderColor,top:ae.top?E.from(ae.top):void 0}}he.from=pe})(Nt=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var nt;(function(he){function pe(ae,K,_e){const Ce=typeof ae.command=="string"?{title:"",command:ae.command}:ae.command;return{alignment:ae.alignment===d.NotebookCellStatusBarAlignment.Left?1:2,command:K.toInternal(Ce,_e),text:ae.text,tooltip:ae.tooltip,accessibilityInformation:ae.accessibilityInformation,priority:ae.priority}}he.from=pe})(nt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var ut;(function(he){function pe(ae){return{transientOutputs:ae?.transientOutputs??!1,transientCellMetadata:ae?.transientCellMetadata??{},transientDocumentMetadata:ae?.transientDocumentMetadata??{}}}he.from=pe})(ut=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var At;(function(he){function pe(K){return{uri:K.uri,provides:K.provides}}he.from=pe;function ae(K){return new d.NotebookRendererScript(M.URI.revive(K.uri),K.provides)}he.to=ae})(At=e.NotebookRendererScript||(e.NotebookRendererScript={}));var Tt;(function(he){function pe(K){return{message:P.fromStrict(K.message)||"",type:0,expected:K.expectedOutput,actual:K.actualOutput,location:K.location&&{range:w.from(K.location.range),uri:K.location.uri}}}he.from=pe;function ae(K){const _e=new d.TestMessage(typeof K.message=="string"?K.message:P.to(K.message));return _e.actualOutput=K.actual,_e.expectedOutput=K.expected,_e.location=K.location?fe.to(K.location):void 0,_e}he.to=ae})(Tt=e.TestMessage||(e.TestMessage={}));var bt;(function(he){he.namespace=f.namespaceTestTag,he.denamespace=f.denamespaceTestTag})(bt=e.TestTag||(e.TestTag={}));var dt;(function(he){function pe(Ce){const $e=(0,l.getPrivateApiFor)(Ce).controllerId;return{extId:S.TestId.fromExtHostTestItem(Ce,$e).toString(),label:Ce.label,uri:M.URI.revive(Ce.uri),busy:!1,tags:Ce.tags.map(Ve=>bt.namespace($e,Ve.id)),range:L.Range.lift(w.from(Ce.range)),description:Ce.description||null,sortText:Ce.sortText||null,error:Ce.error&&P.fromStrict(Ce.error)||null}}he.from=pe;function ae(Ce){return{parent:void 0,error:void 0,id:S.TestId.fromString(Ce.extId).localId,label:Ce.label,uri:M.URI.revive(Ce.uri),tags:(Ce.tags||[]).map($e=>{const{tagId:Ve}=bt.denamespace($e);return new d.TestTag(Ve)}),range:w.to(Ce.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Ce.description||void 0,sortText:Ce.sortText||void 0}}he.toPlain=ae;function K(Ce){const $e=S.TestId.fromString(Ce.extId),Ve=new l.TestItemImpl($e.controllerId,$e.localId,Ce.label,M.URI.revive(Ce.uri)||void 0);return Ve.range=w.to(Ce.range||void 0),Ve.description=Ce.description||void 0,Ve.sortText=Ce.sortText||void 0,Ve}function _e(Ce){let $e;for(const Ve of Ce.tests){const lt=K(Ve.item);(0,l.getPrivateApiFor)(lt).parent=$e,$e=lt}return $e}he.toItemFromContext=_e})(dt=e.TestItem||(e.TestItem={})),function(he){function pe(K){return{id:K.id}}he.from=pe;function ae(K){return new d.TestTag(K.id)}he.to=ae}(bt=e.TestTag||(e.TestTag={}));var Rt;(function(he){const pe=(K,_e)=>{const Ce={...dt.toPlain(K.item),parent:void 0,taskStates:K.tasks.map($e=>({state:$e.state,duration:$e.duration,messages:$e.messages.filter(Ve=>Ve.type===0).map(Tt.to)})),children:K.children.map($e=>_e.get($e)).filter(y.isDefined).map($e=>pe($e,_e))};for(const $e of Ce.children)$e.parent=Ce;return Ce};function ae(K){const _e=[],Ce=new Map;for(const $e of K.items)Ce.set($e.item.extId,$e),K.request.targets.some(Ve=>Ve.controllerId===$e.controllerId&&Ve.testIds.includes($e.item.extId))&&_e.push($e);return{completedAt:K.completedAt,results:_e.map($e=>pe($e,Ce))}}he.to=ae})(Rt=e.TestResults||(e.TestResults={}));var Lt;(function(he){function pe(Ce){return{covered:Ce.covered,total:Ce.covered}}function ae(Ce){return"line"in Ce?T.from(Ce):w.from(Ce)}function K(Ce){return"branches"in Ce?{count:Ce.executionCount,location:ae(Ce.location),type:1,branches:Ce.branches.length?Ce.branches.map($e=>({count:$e.executionCount,location:$e.location&&ae($e.location)})):void 0}:{type:0,count:Ce.executionCount,location:ae(Ce.location)}}he.fromDetailed=K;function _e(Ce){return{uri:Ce.uri,statement:pe(Ce.statementCoverage),branch:Ce.branchCoverage&&pe(Ce.branchCoverage),function:Ce.functionCoverage&&pe(Ce.functionCoverage),details:Ce.detailedCoverage?.map(K)}}he.fromFile=_e})(Lt=e.TestCoverage||(e.TestCoverage={}));var Ft;(function(he){function pe(ae){switch(ae){case 1:return d.CodeActionTriggerKind.Invoke;case 2:return d.CodeActionTriggerKind.Automatic}}he.to=pe})(Ft=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Ue;(function(he){function pe(K){const _e=new d.TypeHierarchyItem($.to(K.kind),K.name,K.detail||"",M.URI.revive(K.uri),w.to(K.range),w.to(K.selectionRange));return _e._sessionId=K._sessionId,_e._itemId=K._itemId,_e}he.to=pe;function ae(K,_e,Ce){if(_e=_e??K._sessionId,Ce=Ce??K._itemId,_e===void 0||Ce===void 0)throw new Error("invalid item");return{_sessionId:_e,_itemId:Ce,kind:$.from(K.kind),name:K.name,detail:K.detail??"",uri:K.uri,range:w.from(K.range),selectionRange:w.from(K.selectionRange),tags:K.tags?.map(ee.from)}}he.from=ae})(Ue=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(Ee[168],we([1,0,2,15,7,8,228]),function(J,e,s,I,b,B,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class A{constructor(M,L,v,u={timeout:1500,errors:3}){this._logService=M,this._documents=L,this._mainThreadBulkEdits=v,this._thresholds=u,this._callbacks=new D.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(M){return(L,v,u)=>{const l={dispose:this._callbacks.push([L,v,M])};return Array.isArray(u)&&u.push(l),l}}async $participateInSave(M,L){const v=s.URI.revive(M);let u=!1;const m=setTimeout(()=>u=!0,this._thresholds.timeout),l=[];try{for(let n of[...this._callbacks]){if(u)break;const f=this._documents.getDocument(v),S=await this._deliverEventAsyncAndBlameBadListeners(n,{document:f,reason:B.TextDocumentSaveReason.to(L)});l.push(S)}}finally{clearTimeout(m)}return l}_deliverEventAsyncAndBlameBadListeners([M,L,v],u){const m=this._badListeners.get(M);return typeof m=="number"&&m>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(v,M,L,u).then(()=>!0,l=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${v.identifier.value}' threw ERROR`),this._logService.error(l),!(l instanceof Error)||l.message!=="concurrent_edits"){const n=this._badListeners.get(M);this._badListeners.set(M,n?n+1:1),typeof n=="number"&&n>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${v.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(M,L,v,u){const m=[],l=Date.now(),{document:n,reason:f}=u,{version:S}=n,k=Object.freeze({document:n,reason:f,waitUntil(d){if(Object.isFrozen(m))throw(0,I.illegalState)("waitUntil can not be called async");m.push(Promise.resolve(d))}});try{L.apply(v,[k])}catch(d){return Promise.reject(d)}return Object.freeze(m),new Promise((d,p)=>{const w=setTimeout(()=>p(new Error("timeout")),this._thresholds.timeout);return Promise.all(m).then(a=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${M.identifier.value}' finished after ${Date.now()-l}ms`),clearTimeout(w),d(a)}).catch(a=>{clearTimeout(w),p(a)})}).then(d=>{const p={edits:[]};for(const w of d)if(Array.isArray(w)&&w.every(a=>a instanceof b.TextEdit))for(const{newText:a,newEol:T,range:r}of w)p.edits.push({_type:2,resource:n.uri,edit:{range:r&&B.Range.from(r),text:a,eol:T&&B.EndOfLine.from(T)}});if(p.edits.length!==0)return S===n.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(p):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=A}),define(Ee[169],we([1,0,10,26,2,8,85]),function(J,e,s,I,b,B,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class A{constructor(v,u,m,l){this.start=v,this.deletedCount=u,this.deletedItems=m,this.items=l}static asApiEvents(v){return v.map(u=>({start:u.start,deletedCount:u.deletedCount,deletedItems:u.deletedItems,items:u.items.map(m=>m.apiCell)}))}}class y{constructor(v,u,m){this.notebook=v,this._extHostDocument=u,this._cellData=m,this.handle=m.handle,this.uri=b.URI.revive(m.uri),this.cellKind=m.cellKind,this._outputs=m.outputs.map(B.NotebookCellOutput.to),this._internalMetadata=m.internalMetadata??{},this._metadata=Object.freeze(m.metadata??{}),this._previousResult=Object.freeze(B.NotebookCellExecutionSummary.to(m.internalMetadata??{}))}static asModelAddData(v,u){return{EOL:u.eol,lines:u.source,languageId:u.language,uri:u.uri,isDirty:!1,versionId:1,notebook:v}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const v=this,u=this._extHostDocument.getDocument(this.uri);if(!u)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return v.notebook.getCellIndex(v)},notebook:v.notebook.apiNotebook,kind:B.NotebookCellKind.to(this._cellData.cellKind),document:u.document,get mime(){return v._mime},set mime(m){v._mime=m},get outputs(){return v._outputs.slice(0)},get metadata(){return v._metadata},get executionSummary(){return v._previousResult}})}return this._apiCell}setOutputs(v){this._outputs=v.map(B.NotebookCellOutput.to)}setOutputItems(v,u,m){const l=m.map(B.NotebookCellOutputItem.to),n=this._outputs.find(f=>f.id===v);n&&(u||(n.items.length=0),n.items.push(...l))}setMetadata(v){this._metadata=Object.freeze(v)}setInternalMetadata(v){this._internalMetadata=v,this._previousResult=Object.freeze(B.NotebookCellExecutionSummary.to(v))}setMime(v){}}e.ExtHostCell=y;class M{constructor(v,u,m,l,n,f){this._proxy=v,this._textDocumentsAndEditors=u,this._textDocuments=m,this._emitter=l,this.uri=n,this.handle=M._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=f.viewType,this._metadata=Object.freeze(f.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,f.cells]],!0),this._versionId=f.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const v=this;this._notebook={get uri(){return v.uri},get version(){return v._versionId},get notebookType(){return v._notebookType},get isDirty(){return v._isDirty},get isUntitled(){return v.uri.scheme===s.Schemas.untitled},get isClosed(){return v._disposed},get metadata(){return v._metadata},get cellCount(){return v._cells.length},cellAt(u){return u=v._validateIndex(u),v._cells[u].apiCell},getCells(u){return(u?v._getCells(u):v._cells).map(l=>l.apiCell)},save(){return v._save()}}}return this._notebook}updateBackup(v){this._backup?.delete(),this._backup=v}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(v){v.metadata&&(this._metadata=Object.freeze({...this._metadata,...v.metadata}))}acceptDirty(v){this._isDirty=v}acceptModelChanged(v,u){this._versionId=v.versionId,this._isDirty=u;for(const m of v.rawEvents)m.kind===D.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(m.changes,!1):m.kind===D.NotebookCellsChangeType.Move?this._moveCell(m.index,m.newIdx):m.kind===D.NotebookCellsChangeType.Output?this._setCellOutputs(m.index,m.outputs):m.kind===D.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(m.index,m.outputId,m.append,m.outputItems):m.kind===D.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(m.index,m.language):m.kind===D.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(m.index,m.mime):m.kind===D.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(m.index,m.metadata):m.kind===D.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(m.index,m.internalMetadata)}_validateIndex(v){return v=v|0,v<0?0:v>=this._cells.length?this._cells.length-1:v}_validateRange(v){let u=v.start|0,m=v.end|0;return u<0&&(u=0),m>this._cells.length&&(m=this._cells.length),v.with({start:u,end:m})}_getCells(v){v=this._validateRange(v);const u=[];for(let m=v.start;m<v.end;m++)u.push(this._cells[m]);return u}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(v,u){if(this._disposed)return;const m=[],l=[],n=[];v.reverse().forEach(f=>{const k=f[2].map(w=>{const a=new y(this,this._textDocumentsAndEditors,w);return u||l.push(y.asModelAddData(this.apiNotebook,w)),a}),d=new A(f[0],f[1],[],k),p=this._cells.splice(f[0],f[1],...k);for(const w of p)n.push(w.uri),d.deletedItems.push(w.apiCell);m.push(d)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:l,removedDocuments:n}),u||this._emitter.emitModelChange((0,I.deepFreeze)({document:this.apiNotebook,changes:A.asApiEvents(m)}))}_moveCell(v,u){const m=this._cells.splice(v,1);this._cells.splice(u,0,...m);const l=[new A(v,1,m.map(n=>n.apiCell),[]),new A(u,0,[],m)];this._emitter.emitModelChange((0,I.deepFreeze)({document:this.apiNotebook,changes:A.asApiEvents(l)}))}_setCellOutputs(v,u){const m=this._cells[v];m.setOutputs(u),this._emitter.emitCellOutputsChange((0,I.deepFreeze)({document:this.apiNotebook,cells:[m.apiCell]}))}_setCellOutputItems(v,u,m,l){const n=this._cells[v];n.setOutputItems(u,m,l),this._emitter.emitCellOutputsChange((0,I.deepFreeze)({document:this.apiNotebook,cells:[n.apiCell]}))}_changeCellLanguage(v,u){const m=this._cells[v];m.apiCell.document.languageId!==u&&this._textDocuments.$acceptModelLanguageChanged(m.uri,u)}_changeCellMime(v,u){const m=this._cells[v];m.apiCell.mime=u}_changeCellMetadata(v,u){const m=this._cells[v],l=m.apiCell.metadata;m.setMetadata(u);const n=m.apiCell.metadata;(0,I.equals)(l,n)||this._emitter.emitCellMetadataChange((0,I.deepFreeze)({document:this.apiNotebook,cell:m.apiCell}))}_changeCellInternalMetadata(v,u){this._cells[v].setInternalMetadata(u)}getCellFromApiCell(v){return this._cells.find(u=>u.apiCell===v)}getCellFromIndex(v){return this._cells[v]}getCell(v){return this._cells.find(u=>u.handle===v)}getCellIndex(v){return this._cells.indexOf(v)}}e.ExtHostNotebookDocument=M,M._handlePool=0}),define(Ee[89],we([1,0,7,8,15]),function(J,e,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class B{constructor(y){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=y}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(y){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:y})}replaceCellMetadata(y,M){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:y,metadata:M})}replaceCells(y,M,L){this._throwIfFinalized(),!(y===M&&L.length===0)&&this._collectedEdits.push({editType:1,index:y,count:M-y,cells:L.map(I.NotebookCellData.from)})}}class D{constructor(y,M,L,v,u,m){this.id=y,this._proxy=M,this.notebookData=L,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=u,this._visibleRanges=v,this._viewColumn=m}get apiEditor(){if(!this._editor){const y=this;this._editor={get document(){return y.notebookData.apiNotebook},get selections(){return y._selections},set selections(M){if(!Array.isArray(M)||!M.every(s.NotebookRange.isNotebookRange))throw(0,b.illegalArgument)("selections");y._selections=M,y._trySetSelections(M)},get visibleRanges(){return y._visibleRanges},revealRange(M,L){y._proxy.$tryRevealRange(y.id,I.NotebookRange.from(M),L??s.NotebookEditorRevealType.Default)},get viewColumn(){return y._viewColumn},edit(M){const L=new B(this.document.version);return M(L),y._applyEdit(L.finalize())},setDecorations(M,L){return y.setDecorations(M,L)}},D.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(y){this._visible=y}_acceptVisibleRanges(y){this._visibleRanges=y}_acceptSelections(y){this._selections=y}_trySetSelections(y){this._proxy.$trySetSelections(this.id,y.map(I.NotebookRange.from))}_acceptViewColumn(y){this._viewColumn=y}_applyEdit(y){if(y.cellEdits.length===0)return Promise.resolve(!0);const M=[];let L=-1;for(let v=0;v<y.cellEdits.length;v++){if(L<0){M.push(y.cellEdits[v]),L++;continue}const m=M[L],l=y.cellEdits[v];if(m.editType===1&&l.editType===1&&m.index===l.index){m.cells.push(...y.cellEdits[v].cells),m.count+=y.cellEdits[v].count;continue}M.push(y.cellEdits[v]),L++}return this._proxy.$tryApplyEdits(this.id,y.documentVersionId,M)}setDecorations(y,M){if(!(M.isEmpty&&!this._hasDecorationsForKey.has(y.key)))return M.isEmpty?this._hasDecorationsForKey.delete(y.key):this._hasDecorationsForKey.add(y.key),this._proxy.$trySetDecorations(this.id,I.NotebookRange.from(M),y.key)}}e.ExtHostNotebookEditor=D,D.apiEditorsToExtHost=new WeakMap}),define(Ee[170],we([1,0,8,141,124,20,52,15]),function(J,e,s,I,b,B,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class y{constructor(u){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=u}async withProgress(u,m,l){const n=this._handles++,{title:f,location:S,cancellable:k}=m,d={label:(0,b.localize)(0,null,u.displayName||u.name),id:u.identifier.value};return this._proxy.$startProgress(n,{location:s.ProgressLocation.from(S),title:f,source:d,cancellable:k},u.isUnderDevelopment?void 0:u.identifier.value).catch(A.onUnexpectedExternalError),this._withProgress(n,l,!!k)}_withProgress(u,m,l){let n;l&&(n=new B.CancellationTokenSource,this._mapHandleToCancellationSource.set(u,n));const f=k=>{this._proxy.$progressEnd(k),this._mapHandleToCancellationSource.delete(k),n&&n.dispose()};let S;try{S=m(new L(this._proxy,u),l&&n?n.token:B.CancellationToken.None)}catch(k){throw f(u),k}return S.then(k=>f(u),k=>f(u)),S}$acceptProgressCanceled(u){const m=this._mapHandleToCancellationSource.get(u);m&&(m.cancel(),this._mapHandleToCancellationSource.delete(u))}}e.ExtHostProgress=y;function M(v,u){return v.message=u.message,typeof u.increment=="number"&&(typeof v.increment=="number"?v.increment+=u.increment:v.increment=u.increment),v}class L extends I.Progress{constructor(u,m){super(l=>this.throttledReport(l));this._proxy=u,this._handle=m}throttledReport(u){this._proxy.$progressReport(this._handle,u)}}Fe([(0,D.throttle)(100,(v,u)=>M(v,u),()=>Object.create(null))],L.prototype,"throttledReport",null)}),define(Ee[90],we([1,0,42,15,53,8,7]),function(J,e,s,I,b,B,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class A{constructor(u,m,l){const n=A._Keys.nextId();u.$registerTextEditorDecorationType(m.identifier,n,B.DecorationRenderOptions.from(l)),this.value=Object.freeze({key:n,dispose(){u.$removeTextEditorDecorationType(n)}})}}e.TextEditorDecorationType=A,A._Keys=new b.IdGenerator("TextEditorDecorationType");class y{constructor(u,m){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=u,this._documentVersionId=u.version,this._undoStopBefore=m.undoStopBefore,this._undoStopAfter=m.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(u,m){this._throwIfFinalized();let l=null;if(u instanceof D.Position)l=new D.Range(u,u);else if(u instanceof D.Range)l=u;else throw new Error("Unrecognized location");this._pushEdit(l,m,!1)}insert(u,m){this._throwIfFinalized(),this._pushEdit(new D.Range(u,u),m,!0)}delete(u){this._throwIfFinalized();let m=null;if(u instanceof D.Range)m=u;else throw new Error("Unrecognized location");this._pushEdit(m,null,!0)}_pushEdit(u,m,l){const n=this._document.validateRange(u);this._collectedEdits.push({range:n,text:m,forceMoveMarkers:l})}setEndOfLine(u){if(this._throwIfFinalized(),u!==D.EndOfLine.LF&&u!==D.EndOfLine.CRLF)throw(0,I.illegalArgument)("endOfLine");this._setEndOfLine=u}}e.TextEditorEdit=y;class M{constructor(u,m,l,n){this._proxy=u,this._id=m,this._accept(l),this._logService=n;const f=this;this.value={get tabSize(){return f._tabSize},set tabSize(S){f._setTabSize(S)},get insertSpaces(){return f._insertSpaces},set insertSpaces(S){f._setInsertSpaces(S)},get cursorStyle(){return f._cursorStyle},set cursorStyle(S){f._setCursorStyle(S)},get lineNumbers(){return f._lineNumbers},set lineNumbers(S){f._setLineNumbers(S)}}}_accept(u){this._tabSize=u.tabSize,this._insertSpaces=u.insertSpaces,this._cursorStyle=u.cursorStyle,this._lineNumbers=B.TextEditorLineNumbersStyle.to(u.lineNumbers)}_validateTabSize(u){if(u==="auto")return"auto";if(typeof u=="number"){const m=Math.floor(u);return m>0?m:null}if(typeof u=="string"){const m=parseInt(u,10);return isNaN(m)?null:m>0?m:null}return null}_setTabSize(u){const m=this._validateTabSize(u);if(m!==null){if(typeof m=="number"){if(this._tabSize===m)return;this._tabSize=m}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:m}))}}_validateInsertSpaces(u){return u==="auto"?"auto":u==="false"?!1:Boolean(u)}_setInsertSpaces(u){const m=this._validateInsertSpaces(u);if(typeof m=="boolean"){if(this._insertSpaces===m)return;this._insertSpaces=m}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:m}))}_setCursorStyle(u){this._cursorStyle!==u&&(this._cursorStyle=u,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:u})))}_setLineNumbers(u){this._lineNumbers!==u&&(this._lineNumbers=u,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:B.TextEditorLineNumbersStyle.from(u)})))}assign(u){const m={};let l=!1;if(typeof u.tabSize!="undefined"){const n=this._validateTabSize(u.tabSize);n==="auto"?(l=!0,m.tabSize=n):typeof n=="number"&&this._tabSize!==n&&(this._tabSize=n,l=!0,m.tabSize=n)}if(typeof u.insertSpaces!="undefined"){const n=this._validateInsertSpaces(u.insertSpaces);n==="auto"?(l=!0,m.insertSpaces=n):this._insertSpaces!==n&&(this._insertSpaces=n,l=!0,m.insertSpaces=n)}typeof u.cursorStyle!="undefined"&&this._cursorStyle!==u.cursorStyle&&(this._cursorStyle=u.cursorStyle,l=!0,m.cursorStyle=u.cursorStyle),typeof u.lineNumbers!="undefined"&&this._lineNumbers!==u.lineNumbers&&(this._lineNumbers=u.lineNumbers,l=!0,m.lineNumbers=B.TextEditorLineNumbersStyle.from(u.lineNumbers)),l&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,m))}_warnOnError(u,m){m.catch(l=>{this._logService.warn(`ExtHostTextEditorOptions '${u}' failed:'`),this._logService.warn(l)})}}e.ExtHostTextEditorOptions=M;class L{constructor(u,m,l,n,f,S,k,d){this.id=u,this._proxy=m,this._logService=l,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=f,this._options=new M(this._proxy,this.id,S,l),this._visibleRanges=k,this._viewColumn=d;const p=this;this.value=Object.freeze({get document(){return n.getValue()},set document(w){throw(0,I.readonly)("document")},get selection(){return p._selections&&p._selections[0]},set selection(w){if(!(w instanceof D.Selection))throw(0,I.illegalArgument)("selection");p._selections=[w],p._trySetSelection()},get selections(){return p._selections},set selections(w){if(!Array.isArray(w)||w.some(a=>!(a instanceof D.Selection)))throw(0,I.illegalArgument)("selections");p._selections=w,p._trySetSelection()},get visibleRanges(){return p._visibleRanges},set visibleRanges(w){throw(0,I.readonly)("visibleRanges")},get options(){return p._options.value},set options(w){p._disposed||p._options.assign(w)},get viewColumn(){return p._viewColumn},set viewColumn(w){throw(0,I.readonly)("viewColumn")},edit(w,a={undoStopBefore:!0,undoStopAfter:!0}){if(p._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const T=new y(n.getValue(),a);return w(T),p._applyEdit(T)},insertSnippet(w,a,T={undoStopBefore:!0,undoStopAfter:!0}){if(p._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!a||Array.isArray(a)&&a.length===0)r=p._selections.map(i=>B.Range.from(i));else if(a instanceof D.Position){const{lineNumber:i,column:c}=B.Position.from(a);r=[{startLineNumber:i,startColumn:c,endLineNumber:i,endColumn:c}]}else if(a instanceof D.Range)r=[B.Range.from(a)];else{r=[];for(const i of a)if(i instanceof D.Range)r.push(B.Range.from(i));else{const{lineNumber:c,column:t}=B.Position.from(i);r.push({startLineNumber:c,startColumn:t,endLineNumber:c,endColumn:t})}}return m.$tryInsertSnippet(u,w.value,r,T)},setDecorations(w,a){const T=a.length===0;T&&!p._hasDecorationsForKey.has(w.key)||(T?p._hasDecorationsForKey.delete(w.key):p._hasDecorationsForKey.add(w.key),p._runOnProxy(()=>{if(B.isDecorationOptionsArr(a))return m.$trySetDecorations(u,w.key,B.fromRangeOrRangeWithMessage(a));{const r=new Array(4*a.length);for(let i=0,c=a.length;i<c;i++){const t=a[i];r[4*i]=t.start.line+1,r[4*i+1]=t.start.character+1,r[4*i+2]=t.end.line+1,r[4*i+3]=t.end.character+1}return m.$trySetDecorationsFast(u,w.key,r)}}))},revealRange(w,a){p._runOnProxy(()=>m.$tryRevealRange(u,B.Range.from(w),a||D.TextEditorRevealType.Default))},show(w){m.$tryShowEditor(u,B.ViewColumn.from(w))},hide(){m.$tryHideEditor(u)}})}dispose(){(0,s.ok)(!this._disposed),this._disposed=!0}_acceptOptions(u){(0,s.ok)(!this._disposed),this._options._accept(u)}_acceptVisibleRanges(u){(0,s.ok)(!this._disposed),this._visibleRanges=u}_acceptViewColumn(u){(0,s.ok)(!this._disposed),this._viewColumn=u}_acceptSelections(u){(0,s.ok)(!this._disposed),this._selections=u}async _trySetSelection(){const u=this._selections.map(B.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,u)),this.value}_applyEdit(u){const m=u.finalize();if(m.edits.length===0&&!m.setEndOfLine)return Promise.resolve(!0);const l=m.edits.map(f=>f.range);l.sort((f,S)=>f.end.line===S.end.line?f.end.character===S.end.character?f.start.line===S.start.line?f.start.character-S.start.character:f.start.line-S.start.line:f.end.character-S.end.character:f.end.line-S.end.line);for(let f=0,S=l.length-1;f<S;f++){const k=l[f].end;if(l[f+1].start.isBefore(k))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const n=m.edits.map(f=>({range:B.Range.from(f.range),text:f.text,forceMoveMarkers:f.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,m.documentVersionId,n,{setEndOfLine:typeof m.setEndOfLine=="number"?B.EndOfLine.from(m.setEndOfLine):void 0,undoStopBefore:m.undoStopBefore,undoStopAfter:m.undoStopAfter})}_runOnProxy(u){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):u().then(()=>this,m=>(m instanceof Error&&m.name==="DISPOSED"||this._logService.warn(m),null))}}e.ExtHostTextEditor=L}),define(Ee[171],we([1,0,13,5,6,11,47,8,62,63,48]),function(J,e,s,I,b,B,D,A,y,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class v extends b.Disposable{constructor(m){super();this.controllerId=m,this.debounceSendDiff=this._register(new s.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new I.Emitter),this.root=new D.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(m){this._resolveHandler=m;for(const l of this.tree.values())this.updateExpandability(l)}collectDiff(){const m=this.diff;return this.diff=[],m}pushDiff(m){const l=this.diff[this.diff.length-1];if(l&&m.op===1){if(l.op===1&&l.item.extId===m.item.extId){(0,y.applyTestItemUpdate)(l.item,m.item);return}if(l.op===0&&l.item.item.extId===m.item.extId){(0,y.applyTestItemUpdate)(l.item,m.item);return}}this.diff.push(m),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(m,l){const n=this.tree.get(m);if(!!n){if((n.expandLevels===void 0||l>n.expandLevels)&&(n.expandLevels=l),n.expand===1){const f=this.resolveChildren(n);return f.isOpen()?this.expandChildren(n,l-1):f.wait().then(()=>this.expandChildren(n,l-1))}else if(n.expand===3)return n.resolveBarrier?.isOpen()===!1?n.resolveBarrier.wait().then(()=>this.expandChildren(n,l-1)):this.expandChildren(n,l-1)}}dispose(){for(const m of this.tree.values())(0,D.getPrivateApiFor)(m.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(m,l){switch(l.op){case 2:this.pushDiff({op:4,itemId:m.fullId.toString()});break;case 1:this.removeItem(M.TestId.joinToString(m.fullId,l.id));break;case 0:this.upsertItem(l.item,m);break;case 4:for(const n of l.ops)this.onTestItemEvent(m,n);break;case 3:{const{key:n,value:f,previous:S}=l,k=m.fullId.toString();switch(n){case"canResolveChildren":this.updateExpandability(m);break;case"tags":this.diffTagRefs(f,S,k);break;case"range":this.pushDiff({op:1,item:{extId:k,item:{range:L.Range.lift(A.Range.from(f))}}});break;case"error":this.pushDiff({op:1,item:{extId:k,item:{error:A.MarkdownString.fromStrict(f)||null}}});break;default:this.pushDiff({op:1,item:{extId:k,item:{[n]:f??null}}});break}break}default:(0,B.assertNever)(l)}}upsertItem(m,l){if(!(m instanceof D.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${m.id} did not`);const n=M.TestId.fromExtHostTestItem(m,this.root.id,l?.actual),f=(0,D.getPrivateApiFor)(m);f.parent&&f.parent!==l?.actual&&f.parent.children.delete(m.id);let S=this.tree.get(n.toString());if(!S){S={fullId:n,actual:m,parent:l?n.parentId:null,expandLevels:l?.expandLevels?l.expandLevels-1:void 0,expand:0},m.tags.forEach(this.incrementTagRefs,this),this.tree.set(S.fullId.toString(),S),this.setItemParent(m,l),this.pushDiff({op:0,item:{parent:S.parent&&S.parent.toString(),controllerId:this.controllerId,expand:S.expand,item:A.TestItem.from(m)}}),this.connectItemAndChildren(m,S,l);return}if(S.actual===m){this.connectItem(m,S,l);return}const k=S.actual.children,d=S.actual,p=(0,D.diffTestItems)(d,m);(0,D.getPrivateApiFor)(d).listener=void 0,S.actual=m,S.expand=0;for(const[w,a]of p)this.onTestItemEvent(S,{op:3,key:w,value:a,previous:d[w]});this.connectItemAndChildren(m,S,l);for(const w of k)m.children.get(w.id)||this.removeItem(M.TestId.joinToString(n,w.id))}diffTagRefs(m,l,n){const f=new Set(l.map(S=>S.id));for(const S of m)f.delete(S.id)||this.incrementTagRefs(S);this.pushDiff({op:1,item:{extId:n,item:{tags:m.map(S=>A.TestTag.namespace(this.controllerId,S.id))}}}),f.forEach(this.decrementTagRefs,this)}incrementTagRefs(m){const l=this.tags.get(m.id);l?l.refCount++:(this.tags.set(m.id,{refCount:1}),this.pushDiff({op:5,tag:{id:A.TestTag.namespace(this.controllerId,m.id),ctrlLabel:this.root.label}}))}decrementTagRefs(m){const l=this.tags.get(m);l&&!--l.refCount&&(this.tags.delete(m),this.pushDiff({op:6,id:(0,y.namespaceTestTag)(this.controllerId,m)}))}setItemParent(m,l){(0,D.getPrivateApiFor)(m).parent=l&&l.actual!==this.root?l.actual:void 0}connectItem(m,l,n){this.setItemParent(m,n);const f=(0,D.getPrivateApiFor)(m);f.parent=n?.actual,f.listener=S=>this.onTestItemEvent(l,S),this.updateExpandability(l)}connectItemAndChildren(m,l,n){this.connectItem(m,l,n);for(const f of m.children)this.upsertItem(f,l)}updateExpandability(m){let l;this._resolveHandler?m.resolveBarrier?l=m.resolveBarrier.isOpen()?3:2:l=m.actual.canResolveChildren?1:0:l=0,l!==m.expand&&(m.expand=l,this.pushDiff({op:1,item:{extId:m.fullId.toString(),expand:l}}),l===1&&m.expandLevels!==void 0&&this.resolveChildren(m))}expandChildren(m,l){if(l<0)return;const n=[];for(const f of m.actual.children){const S=this.expand(M.TestId.joinToString(m.fullId,f.id),l);(0,s.isThenable)(S)&&n.push(S)}if(n.length)return Promise.all(n).then(()=>{})}resolveChildren(m){if(m.resolveBarrier)return m.resolveBarrier;if(!this._resolveHandler){const S=new s.Barrier;return S.open(),S}m.expand=2,this.pushExpandStateUpdate(m);const l=m.resolveBarrier=new s.Barrier,n=S=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),m.actual!==this.root&&(m.actual.error=S.stack||S.message||String(S))};let f;try{f=this._resolveHandler(m.actual===this.root?void 0:m.actual)}catch(S){n(S)}return(0,s.isThenable)(f)?f.catch(n).then(()=>{l.open(),this.updateExpandability(m)}):(l.open(),this.updateExpandability(m)),m.resolveBarrier}pushExpandStateUpdate(m){this.pushDiff({op:1,item:{extId:m.fullId.toString(),expand:m.expand}})}removeItem(m){const l=this.tree.get(m);if(!l)throw new Error("attempting to remove non-existent child");this.pushDiff({op:2,itemId:m});const n=[l];for(;n.length;){const f=n.pop();if(!!f){(0,D.getPrivateApiFor)(f.actual).listener=void 0;for(const S of f.actual.tags)this.decrementTagRefs(S.id);this.tree.delete(f.fullId.toString());for(const S of f.actual.children)n.push(this.tree.get(M.TestId.joinToString(f.fullId,S.id)))}}}flushDiff(){const m=this.collectDiff();m.length&&this.diffOpEmitter.fire(m)}}e.SingleUseTestCollection=v}),define(Ee[172],we([1,0,3,138]),function(J,e,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,s.refineServiceDecorator)(I.IEnvironmentService)}),define(Ee[173],we([1,0,25,5,17]),function(J,e,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class B{constructor(L){this.removedDueToLooping=L}}e.DeltaExtensionsResult=B;class D{constructor(L){this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=L,this._initialize()}_initialize(){this._extensionDescriptions.sort(y),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const L of this._extensionDescriptions){if(this._extensionsMap.has(s.ExtensionIdentifier.toKey(L.identifier))){console.error("Extension `"+L.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(s.ExtensionIdentifier.toKey(L.identifier),L),this._extensionsArr.push(L),Array.isArray(L.activationEvents))for(let v of L.activationEvents)v==="onUri"&&(v=`onUri:${s.ExtensionIdentifier.toKey(L.identifier)}`),this._activationMap.has(v)||this._activationMap.set(v,[]),this._activationMap.get(v).push(L)}}keepOnly(L){const v=new Set;L.forEach(u=>v.add(s.ExtensionIdentifier.toKey(u))),this._extensionDescriptions=this._extensionDescriptions.filter(u=>v.has(s.ExtensionIdentifier.toKey(u.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(L,v){L.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(L));const u=D._findLoopingExtensions(this._extensionDescriptions);if(v=v.concat(u.map(m=>m.identifier)),v.length>0){const m=new Set;v.forEach(l=>m.add(s.ExtensionIdentifier.toKey(l))),this._extensionDescriptions=this._extensionDescriptions.filter(l=>!m.has(s.ExtensionIdentifier.toKey(l.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new B(u)}static _findLoopingExtensions(L){const v=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(f){this._nodesSet.has(f)||(this._nodesSet.add(f),this._nodesArr.push(f))}addArc(f,S){this.addNode(f),this.addNode(S),this._arcs.has(f)?this._arcs.get(f).push(S):this._arcs.set(f,[S])}getArcs(f){return this._arcs.has(f)?this._arcs.get(f):[]}hasOnlyGoodArcs(f,S){const k=v.getArcs(f);for(let d=0;d<k.length;d++)if(!S.has(k[d]))return!1;return!0}getNodes(){return this._nodesArr}};let u=new Map;for(let f of L){const S=s.ExtensionIdentifier.toKey(f.identifier);if(u.set(S,f),f.extensionDependencies)for(let k of f.extensionDependencies){const d=s.ExtensionIdentifier.toKey(k);v.addArc(S,d)}}let m=new Set;v.getNodes().filter(f=>v.getArcs(f).length===0).forEach(f=>m.add(f));let l=v.getNodes().filter(f=>!m.has(f)),n;do{n=!1;for(let f=0;f<l.length;f++){const S=l[f];v.hasOnlyGoodArcs(S,m)&&(l.splice(f,1),f--,m.add(S),n=!0)}}while(n);return l.map(f=>u.get(f))}containsActivationEvent(L){return this._activationMap.has(L)}containsExtension(L){return this._extensionsMap.has(s.ExtensionIdentifier.toKey(L))}getExtensionDescriptionsForActivationEvent(L){const v=this._activationMap.get(L);return v?v.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(L){const v=this._extensionsMap.get(s.ExtensionIdentifier.toKey(L));return v||void 0}}e.ExtensionDescriptionRegistry=D;var A;(function(M){M[M.Builtin=0]="Builtin",M[M.User=1]="User",M[M.Dev=2]="Dev"})(A||(A={}));function y(M,L){const v=M.isBuiltin?0:M.isUnderDevelopment?2:1,u=L.isBuiltin?0:L.isUnderDevelopment?2:1;if(v!==u)return v-u;const m=b.posix.basename(M.extensionLocation.path),l=b.posix.basename(L.extensionLocation.path);return m<l?-1:m>l?1:0}}),define(Ee[91],we([1,0,21]),function(J,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var I;(function(y){y[y.Desktop=1]="Desktop",y[y.Web=2]="Web"})(I=e.UIKind||(e.UIKind={}));var b;(function(y){y[y.VersionMismatch=55]="VersionMismatch",y[y.UnexpectedError=81]="UnexpectedError"})(b=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var B;(function(y){y[y.Initialized=0]="Initialized",y[y.Ready=1]="Ready",y[y.Terminate=2]="Terminate"})(B=e.MessageType||(e.MessageType={}));function D(y){const M=s.VSBuffer.alloc(1);switch(y){case 0:M.writeUInt8(1,0);break;case 1:M.writeUInt8(2,0);break;case 2:M.writeUInt8(3,0);break}return M}e.createMessageOfType=D;function A(y,M){if(y.byteLength!==1)return!1;switch(y.readUInt8(0)){case 1:return M===0;case 2:return M===1;case 3:return M===2;default:return!1}}e.isMessageOfType=A}),define(Ee[28],we([1,0,5,2,3,25,144]),function(J,e,s,I,b,B,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.extensionRunningLocationToString=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new B.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:I.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,b.createDecorator)("extensionService");var A;(function(p){p[p.None=0]="None",p[p.LocalProcess=1]="LocalProcess",p[p.LocalWebWorker=2]="LocalWebWorker",p[p.Remote=3]="Remote"})(A=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));function y(p){switch(p){case 0:return"None";case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionRunningLocationToString=y;class M{constructor(w){this.dependency=w}}e.MissingExtensionDependency=M;var L;(function(p){p[p.LocalProcess=0]="LocalProcess",p[p.LocalWebWorker=1]="LocalWebWorker",p[p.Remote=2]="Remote"})(L=e.ExtensionHostKind||(e.ExtensionHostKind={}));function v(p){switch(p){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=v;function u(p,w){return p.enabledApiProposals?p.enabledApiProposals.includes(w):!1}e.isProposedApiEnabled=u;function m(p,w){if(!u(p,w))throw new Error(`Extension '${p.identifier.value}' CANNOT use API proposal: ${w}.
Its package.json#enabledApiProposals-property declares: ${p.enabledApiProposals?.join(", ")??"[]"} but NOT ${w}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${p.identifier.value}`)}e.checkProposedApiEnabled=m;class l{constructor(w,a,T,r){this.codeLoadingTime=w,this.activateCallTime=a,this.activateResolvedTime=T,this.activationReason=r}}e.ActivationTimes=l;class n{constructor(w,a){this.description=w,this.value=a}}e.ExtensionPointContribution=n,e.ExtensionHostLogFileName="exthost";var f;(function(p){p[p.Normal=0]="Normal",p[p.Immediate=1]="Immediate"})(f=e.ActivationKind||(e.ActivationKind={}));function S(p){return{type:p.isBuiltin?0:1,isBuiltin:p.isBuiltin||p.isUserBuiltin,identifier:{id:(0,D.getGalleryExtensionId)(p.publisher,p.name),uuid:p.uuid},manifest:p,location:p.extensionLocation}}e.toExtension=S;function k(p,w){return{identifier:new B.ExtensionIdentifier((0,D.getExtensionId)(p.manifest.publisher,p.manifest.name)),isBuiltin:p.type===0,isUserBuiltin:p.type===1&&p.isBuiltin,isUnderDevelopment:!!w,extensionLocation:p.location,...p.manifest,uuid:p.identifier.uuid}}e.toExtensionDescription=k;class d{constructor(){this.onDidRegisterExtensions=s.Event.None,this.onDidChangeExtensionsStatus=s.Event.None,this.onDidChangeExtensions=s.Event.None,this.onWillActivateByEvent=s.Event.None,this.onDidChangeResponsiveChange=s.Event.None}activateByEvent(w){return Promise.resolve(void 0)}activationEventIsDone(w){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(w){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(w){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(w){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(w,a){return Promise.resolve()}}e.NullExtensionService=d}),define(Ee[174],we([1,0,15,25,28,12]),function(J,e,s,I,b,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const D=Promise.resolve(void 0);class A{constructor(n,f,S,k){this.startup=n,this.codeLoadingTime=f,this.activateCallTime=S,this.activateResolvedTime=k}}e.ExtensionActivationTimes=A,A.NONE=new A(!1,-1,-1,-1);class y{constructor(n){this._startup=n,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(n,f){return n===-1||f===-1?-1:f-n}build(){return new A(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=y;class M{constructor(n,f,S,k,d,p){this.activationFailed=n,this.activationFailedError=f,this.activationTimes=S,this.module=k,this.exports=d,this.subscriptions=p}}e.ActivatedExtension=M;class L extends M{constructor(n){super(!1,null,n,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=L;class v extends M{constructor(){super(!1,null,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=v;class u extends M{constructor(n){super(!0,n,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=u;let m=class{constructor(n,f,S,k,d){this._logService=d,this._isDisposed=!1,this._registry=n,this._resolvedExtensionsSet=new Set,f.forEach(p=>this._resolvedExtensionsSet.add(I.ExtensionIdentifier.toKey(p))),this._hostExtensionsMap=new Map,S.forEach(p=>this._hostExtensionsMap.set(I.ExtensionIdentifier.toKey(p),p)),this._host=k,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){this._isDisposed=!0}isActivated(n){const f=I.ExtensionIdentifier.toKey(n);return this._activatedExtensions.has(f)}getActivatedExtension(n){const f=I.ExtensionIdentifier.toKey(n),S=this._activatedExtensions.get(f);if(!S)throw new Error("Extension `"+n.value+"` is not known or not activated");return S}activateByEvent(n,f){if(this._alreadyActivatedEvents[n])return D;const S=this._registry.getExtensionDescriptionsForActivationEvent(n);return this._activateExtensions(S.map(k=>({id:k.identifier,reason:{startup:f,extensionId:k.identifier,activationEvent:n}}))).then(()=>{this._alreadyActivatedEvents[n]=!0})}activateById(n,f){const S=this._registry.getExtensionDescription(n);if(!S)throw new Error("Extension `"+n+"` is not known");return this._activateExtensions([{id:S.identifier,reason:f}])}_handleActivateRequest(n,f,S){if(this._hostExtensionsMap.has(I.ExtensionIdentifier.toKey(n.id))){f[I.ExtensionIdentifier.toKey(n.id)]=n;return}const k=this._registry.getExtensionDescription(n.id);if(!k){const w=new Error(`Cannot activate unknown extension '${n.id.value}'`);this._host.onExtensionActivationError(n.id,w,new b.MissingExtensionDependency(n.id.value)),this._activatedExtensions.set(I.ExtensionIdentifier.toKey(n.id),new u(w));return}const d=typeof k.extensionDependencies=="undefined"?[]:k.extensionDependencies;let p=!0;for(let w=0,a=d.length;w<a;w++){const T=d[w];if(this._resolvedExtensionsSet.has(I.ExtensionIdentifier.toKey(T)))continue;const r=this._activatedExtensions.get(I.ExtensionIdentifier.toKey(T));if(r&&!r.activationFailed)continue;if(r&&r.activationFailed){const o=k.displayName||k.identifier.value,g=this._registry.getExtensionDescription(T),h=g&&g.displayName||T,_=new Error(`Cannot activate the '${o}' extension because its dependency '${h}' failed to activate`);_.detail=r.activationFailedError,this._host.onExtensionActivationError(k.identifier,_,null),this._activatedExtensions.set(I.ExtensionIdentifier.toKey(k.identifier),new u(_));return}if(this._hostExtensionsMap.has(I.ExtensionIdentifier.toKey(T))){p=!1,f[I.ExtensionIdentifier.toKey(T)]={id:this._hostExtensionsMap.get(I.ExtensionIdentifier.toKey(T)),reason:n.reason};continue}const i=this._registry.getExtensionDescription(T);if(i){if(!i.main&&!i.browser)continue;p=!1,f[I.ExtensionIdentifier.toKey(T)]={id:i.identifier,reason:n.reason};continue}const c=k.displayName||k.identifier.value,t=new Error(`Cannot activate the '${c}' extension because it depends on unknown extension '${T}'`);this._host.onExtensionActivationError(k.identifier,t,new b.MissingExtensionDependency(T)),this._activatedExtensions.set(I.ExtensionIdentifier.toKey(k.identifier),new u(t));return}p?f[I.ExtensionIdentifier.toKey(k.identifier)]=n:S.push(n)}_activateExtensions(n){if(n.length===0||(n=n.filter(d=>!this._activatedExtensions.has(I.ExtensionIdentifier.toKey(d.id))),n.length===0))return Promise.resolve(void 0);const f=Object.create(null),S=[];for(let d=0,p=n.length;d<p;d++)this._handleActivateRequest(n[d],f,S);for(let d=0,p=S.length;d<p;d++){const w=I.ExtensionIdentifier.toKey(S[d].id);f[w]&&delete f[w]}const k=Object.keys(f).map(d=>f[d]);return S.length===0?Promise.all(k.map(d=>this._activateExtension(d.id,d.reason))).then(d=>{}):this._activateExtensions(k).then(d=>this._activateExtensions(S))}_activateExtension(n,f){const S=I.ExtensionIdentifier.toKey(n);if(this._activatedExtensions.has(S))return Promise.resolve(void 0);const k=this._activatingExtensions.get(S);if(k)return k;const d=this._host.actualActivateExtension(n,f).then(void 0,p=>{const w=new Error;return p&&p.name&&(w.name=p.name),p&&p.message?w.message=`Activating extension '${n.value}' failed: ${p.message}.`:w.message=`Activating extension '${n.value}' failed: ${p}.`,p&&p.stack&&(w.stack=p.stack),this._isDisposed&&s.isCancellationError(p)?new u(p):(this._host.onExtensionActivationError(n,w,null),this._logService.error(`Activating extension ${n.value} failed due to an error:`),this._logService.error(p),new u(p))}).then(p=>{this._activatedExtensions.set(S,p),this._activatingExtensions.delete(S)});return this._activatingExtensions.set(S,d),d}};m=Fe([Ne(4,B.ILogService)],m),e.ExtensionsActivator=m}),define(Ee[175],we([1,0,12,27,28]),function(J,e,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let B=class extends s.LogService{constructor(A,y){super(A.createLogger(y.logFile,{name:b.ExtensionHostLogFileName}))}};B=Fe([Ne(0,s.ILoggerService),Ne(1,I.IExtHostInitDataService)],B),e.ExtHostLogService=B}),define(Ee[176],we([1,0,15]),function(J,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class I{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((B,D)=>{this._actualOk=B,this._actualErr=D,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(B){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=B,this._actual&&this._actualOk(B))}resolveErr(B){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=B,this._actual?this._actualErr(B):(0,s.onUnexpectedError)(B))}then(B,D){return this._ensureActual().then(B,D)}catch(B){return this._ensureActual().then(void 0,B)}finally(B){return this._ensureActual().finally(B)}}e.LazyPromise=I}),define(Ee[38],we([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class s{constructor(y){this._proxyIdentifierBrand=void 0,this.sid=y,this.nid=++s.count}}e.ProxyIdentifier=s,s.count=0;const I=[];function b(A){const y=new s(A);return I[y.nid]=y,y}e.createProxyIdentifier=b;function B(A){return I[A].sid}e.getStringIdentifierForProxy=B;class D{constructor(y){this.value=y}}e.SerializableObjectWithBuffers=D}),define(Ee[4],we([1,0,54,2,38]),function(J,e,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabKind=e.TextEditorRevealType=void 0;var B;(function(k){k[k.Default=0]="Default",k[k.InCenter=1]="InCenter",k[k.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",k[k.AtTop=3]="AtTop"})(B=e.TextEditorRevealType||(e.TextEditorRevealType={}));var D;(function(k){k[k.Singular=0]="Singular",k[k.Diff=1]="Diff",k[k.SidebySide=2]="SidebySide",k[k.Other=3]="Other"})(D=e.TabKind||(e.TabKind={}));var A;(function(k){k[k.Editable=0]="Editable",k[k.SupportsHotExit=1]="SupportsHotExit"})(A=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var y;(function(k){k[k.Int8Array=1]="Int8Array",k[k.Uint8Array=2]="Uint8Array",k[k.Uint8ClampedArray=3]="Uint8ClampedArray",k[k.Int16Array=4]="Int16Array",k[k.Uint16Array=5]="Uint16Array",k[k.Int32Array=6]="Int32Array",k[k.Uint32Array=7]="Uint32Array",k[k.Float32Array=8]="Float32Array",k[k.Float64Array=9]="Float64Array",k[k.BigInt64Array=10]="BigInt64Array",k[k.BigUint64Array=11]="BigUint64Array"})(y=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var M;(function(k){k[k.Text=1]="Text",k[k.Error=2]="Error",k[k.Rich=3]="Rich"})(M=e.CellOutputKind||(e.CellOutputKind={}));var L;(function(k){k[k.Default=0]="Default",k[k.InCenter=1]="InCenter",k[k.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",k[k.AtTop=3]="AtTop"})(L=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var v;(function(k){k[k.None=0]="None",k[k.Process=1]="Process",k[k.Output=2]="Output"})(v=e.CandidatePortSource||(e.CandidatePortSource={}));class u{static mixin(d){return d._id=u._n++,d}}e.IdObject=u,u._n=0;var m;(function(k){k.label="a",k.kind="b",k.detail="c",k.documentation="d",k.sortText="e",k.filterText="f",k.preselect="g",k.insertText="h",k.insertTextRules="i",k.range="j",k.commitCharacters="k",k.additionalTextEdits="l",k.command="m",k.kindModifier="n"})(m=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var l;(function(k){k.defaultRanges="a",k.completions="b",k.isIncomplete="c",k.duration="d"})(l=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var n;(function(k){k[k.File=1]="File",k[k.Text=2]="Text",k[k.Cell=3]="Cell"})(n=e.WorkspaceEditType||(e.WorkspaceEditType={}));function f(k){if(k&&k.edits)for(const d of k.edits)typeof d.resource=="object"?d.resource=I.URI.revive(d.resource):(d.newUri=I.URI.revive(d.newUri),d.oldUri=I.URI.revive(d.oldUri)),d.metadata&&d.metadata.iconPath&&(d.metadata=(0,s.revive)(d.metadata));return k}e.reviveWorkspaceEditDto=f;var S;(function(k){k[k.Workspace=0]="Workspace",k[k.TextDocument=1]="TextDocument"})(S=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,b.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,b.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,b.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,b.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,b.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,b.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,b.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,b.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,b.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,b.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,b.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,b.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,b.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,b.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,b.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,b.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,b.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,b.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,b.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,b.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,b.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,b.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,b.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,b.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,b.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,b.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,b.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,b.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,b.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,b.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,b.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,b.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,b.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,b.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,b.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,b.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,b.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,b.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,b.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,b.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,b.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,b.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,b.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,b.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,b.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,b.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,b.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,b.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,b.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,b.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,b.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,b.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,b.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,b.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,b.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,b.createProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,b.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,b.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,b.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,b.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,b.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,b.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,b.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,b.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,b.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,b.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,b.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,b.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,b.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,b.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,b.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,b.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,b.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,b.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,b.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,b.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,b.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,b.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,b.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,b.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,b.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,b.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,b.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,b.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,b.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,b.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,b.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,b.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,b.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,b.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,b.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,b.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,b.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,b.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,b.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,b.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,b.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,b.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,b.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,b.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,b.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,b.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,b.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,b.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,b.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,b.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,b.createProxyIdentifier)("ExtHostTelemetry")}}),define(Ee[64],we([1,0,4,5,3]),function(J,e,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class B{constructor(A){this._onDidChangePassword=new I.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=A.getProxy(s.MainContext.MainThreadSecretState)}async $onDidChangePassword(A){this._onDidChangePassword.fire(A)}get(A,y){return this._proxy.$getPassword(A,y)}store(A,y,M){return this._proxy.$setPassword(A,y,M)}delete(A,y){return this._proxy.$deletePassword(A,y)}}e.ExtHostSecretState=B,e.IExtHostSecretState=(0,b.createDecorator)("IExtHostSecretState")}),define(Ee[65],we([1,0,3,12,4,14]),function(J,e,s,I,b,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,s.createDecorator)("IExtHostApiDeprecationService");let D=class{constructor(y,M){this._extHostLogService=M,this._reportedUsages=new Set,this._telemetryShape=y.getProxy(b.MainContext.MainThreadTelemetry)}report(y,M,L){const v=this.getUsageKey(y,M);this._reportedUsages.has(v)||(this._reportedUsages.add(v),M.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${y}' is deprecated. ${L}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:M.identifier.value,apiId:y}))}getUsageKey(y,M){return`${y}-${M.identifier.value}`}};D=Fe([Ne(0,B.IExtHostRpcService),Ne(1,I.ILogService)],D),e.ExtHostApiDeprecationService=D,e.NullApiDeprecationService=Object.freeze(new class{report(A,y,M){}})}),define(Ee[177],we([1,0,5,4,7,25]),function(J,e,s,I,b,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class D{constructor(y){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new s.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=y.getProxy(I.MainContext.MainThreadAuthentication)}$setProviders(y){return this._providers=y,Promise.resolve()}async getSession(y,M,L,v={}){const u=B.ExtensionIdentifier.toKey(y.identifier),m=this._inFlightRequests.get(u)||[],l=[...L].sort().join(" ");let n=m.find(f=>f.scopes===l);if(n)return n.result;{const f=this._getSession(y,u,M,L,v);n={scopes:l,result:f},m.push(n),this._inFlightRequests.set(u,m);try{await f}finally{const S=m.findIndex(k=>k.scopes===l);S>-1&&(m.splice(S),this._inFlightRequests.set(u,m))}return f}}async _getSession(y,M,L,v,u={}){await this._proxy.$ensureProvider(L);const m=y.displayName||y.name;return this._proxy.$getSession(L,v,M,m,u)}async removeSession(y,M){const L=this._authenticationProviders.get(y);return L?L.provider.removeSession(M):this._proxy.$removeSession(y,M)}registerAuthenticationProvider(y,M,L,v){if(this._authenticationProviders.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this._authenticationProviders.set(y,{label:M,provider:L,options:v??{supportsMultipleAccounts:!1}}),this._providers.find(m=>m.id===y)||this._providers.push({id:y,label:M});const u=L.onDidChangeSessions(m=>{this._proxy.$sendDidChangeSessions(y,{added:m.added??[],changed:m.changed??[],removed:m.removed??[]})});return this._proxy.$registerAuthenticationProvider(y,M,v?.supportsMultipleAccounts??!1),new b.Disposable(()=>{u.dispose(),this._authenticationProviders.delete(y);const m=this._providers.findIndex(l=>l.id===y);m>-1&&this._providers.splice(m),this._proxy.$unregisterAuthenticationProvider(y)})}$createSession(y,M){const L=this._authenticationProviders.get(y);if(L)return Promise.resolve(L.provider.createSession(M));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,M){const L=this._authenticationProviders.get(y);if(L)return Promise.resolve(L.provider.removeSession(M));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,M){const L=this._authenticationProviders.get(y);if(L)return Promise.resolve(L.provider.getSessions(M));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,M){return this._onDidChangeSessions.fire({provider:{id:y,label:M}}),Promise.resolve()}}e.ExtHostAuthentication=D}),define(Ee[178],we([1,0,4,14,8]),function(J,e,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let B=class{constructor(A,y){this._proxy=A.getProxy(s.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:M=>y.getDocument(M)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(A){const y=b.WorkspaceEdit.from(A,this._versionInformationProvider);return this._proxy.$tryApplyWorkspaceEdit(y)}};B=Fe([Ne(0,I.IExtHostRpcService)],B),e.ExtHostBulkEdits=B}),define(Ee[179],we([1,0,4]),function(J,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class I{constructor(B){const D=B.getProxy(s.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return D.$readText()},writeText(A){return D.$writeText(A)}})}}e.ExtHostClipboard=I});var je=this&&this.__classPrivateFieldSet||function(J,e,s,I,b){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!b:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?b.call(J,s):b?b.value=s:e.set(J,s),s},De=this&&this.__classPrivateFieldGet||function(J,e,s,I){if(s==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?I:s==="a"?I.call(J):I?I.value:e.get(J)};define(Ee[39],we([1,0,11,7,8,26,4,16,12,54,48,229,2,6,3,14,47,21,38,43]),function(J,e,s,I,b,B,D,A,y,M,L,v,u,m,l,n,f,S,k,d){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let w=class{constructor(t,o){p.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,je(this,p,t.getProxy(D.MainContext.MainThreadCommands),"f"),this._logService=o,this.converter=new a(this,g=>{const h=this._apiCommands.get(g);return h?.result===r.Void?h:void 0},o),this._argumentProcessors=[{processArgument(g){return(0,M.revive)(g)}},{processArgument(g){return(0,B.cloneAndChange)(g,function(h){if(L.Range.isIRange(h))return b.Range.to(h);if(v.Position.isIPosition(h))return b.Position.to(h);if(L.Range.isIRange(h.range)&&u.URI.isUri(h.uri))return b.location.to(h);if(h instanceof S.VSBuffer)return h.buffer.buffer;if(!Array.isArray(h))return h})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const o=this.registerCommand(!1,t.id,async(...g)=>{const h=t.args.map((P,R)=>{if(!P.validate(g[R]))throw new Error(`Invalid argument '${P.name}' when running '${t.id}', received: ${g[R]}`);return P.convert(g[R])}),_=await this.executeCommand(t.internalId,...h);return t.result.convert(_,g,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new I.Disposable(()=>{o.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,o,g,h,_,P){if(this._logService.trace("ExtHostCommands#registerCommand",o),!o.trim().length)throw new Error("invalid id");if(this._commands.has(o))throw new Error(`command '${o}' already exists`);return this._commands.set(o,{callback:g,thisArg:h,description:_,extension:P}),t&&De(this,p,"f").$registerCommand(o),new I.Disposable(()=>{this._commands.delete(o)&&t&&De(this,p,"f").$unregisterCommand(o)})}executeCommand(t,...o){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,o,!0)}async _doExecuteCommand(t,o,g){if(this._commands.has(t))return this._executeContributedCommand(t,o,!1);{let h=!1;const _=(0,B.cloneAndChange)(o,function(P){if(P instanceof I.Position)return b.Position.from(P);if(P instanceof I.Range)return b.Range.from(P);if(P instanceof I.Location)return b.location.from(P);if(I.NotebookRange.isNotebookRange(P))return b.NotebookRange.from(P);if(P instanceof ArrayBuffer)return h=!0,S.VSBuffer.wrap(new Uint8Array(P));if(P instanceof Uint8Array)return h=!0,S.VSBuffer.wrap(P);if(!Array.isArray(P))return P});try{const P=await De(this,p,"f").$executeCommand(t,h?new k.SerializableObjectWithBuffers(_):_,g);return(0,M.revive)(P)}catch(P){if(P instanceof Error&&P.message==="$executeCommand:retry")return this._doExecuteCommand(t,o,!1);throw P}}}async _executeContributedCommand(t,o,g){const h=this._commands.get(t);if(!h)throw new Error("Unknown command");let{callback:_,thisArg:P,description:R}=h;if(R)for(let W=0;W<R.args.length;W++)try{(0,s.validateConstraint)(o[W],R.args[W].constraint)}catch{throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${R.args[W].name}' - ${R.args[W].description}`)}try{return await _.apply(P,o)}catch(W){if(t===this.converter.delegatingCommandId){const E=this.converter.getActualCommand(...o);E&&(t=E.command)}throw this._logService.error(W,t,h.extension?.identifier),g?new class extends Error{constructor(){super((0,d.toErrorMessage)(W));this.id=t,this.source=h.extension?.displayName??h.extension?.name}}:W}}$executeContributedCommand(t,...o){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(o=o.map(g=>this._argumentProcessors.reduce((h,_)=>_.processArgument(h),g)),this._executeContributedCommand(t,o,!0)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),De(this,p,"f").$getCommands().then(o=>(t&&(o=o.filter(g=>g[0]!=="_")),o))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[o,g]of this._commands){let{description:h}=g;h&&(t[o]=h)}return Promise.resolve(t)}};p=new WeakMap,w=Fe([Ne(0,n.IExtHostRpcService),Ne(1,y.ILogService)],w),e.ExtHostCommands=w,e.IExtHostCommands=(0,l.createDecorator)("IExtHostCommands");class a{constructor(t,o,g){this._commands=t,this._lookupApiCommand=o,this._logService=g,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,o){if(!t)return;const g={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return g;const h=this._lookupApiCommand(t.command);if(h)g.id=h.internalId,g.arguments=h.args.map((_,P)=>_.convert(t.arguments&&t.arguments[P]));else if((0,A.isNonEmptyArray)(t.arguments)){const _=++this._cachIdPool;this._cache.set(_,t),o.add((0,m.toDisposable)(()=>{this._cache.delete(_),this._logService.trace("CommandsConverter#DISPOSE",_)})),g.$ident=_,g.id=this.delegatingCommandId,g.arguments=[_],this._logService.trace("CommandsConverter#CREATE",t.command,_)}return g}fromInternal(t){return typeof t.$ident=="number"?this._cache.get(t.$ident):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const o=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],o?o.command:"MISSING"),o?this._commands.executeCommand(o.command,...o.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=a;class T{constructor(t,o,g,h){this.name=t,this.description=o,this.validate=g,this.convert=h}optional(){return new T(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,o){return new T(t??this.name,o??this.description,this.validate,this.convert)}}e.ApiCommandArgument=T,T.Uri=new T("uri","Uri of a text document",c=>u.URI.isUri(c),c=>c),T.Position=new T("position","A position in a text document",c=>I.Position.isPosition(c),b.Position.from),T.Range=new T("range","A range in a text document",c=>I.Range.isRange(c),b.Range.from),T.Selection=new T("selection","A selection in a text document",c=>I.Selection.isSelection(c),b.Selection.from),T.Number=new T("number","",c=>typeof c=="number",c=>c),T.String=new T("string","",c=>typeof c=="string",c=>c),T.CallHierarchyItem=new T("item","A call hierarchy item",c=>c instanceof I.CallHierarchyItem,b.CallHierarchyItem.from),T.TypeHierarchyItem=new T("item","A type hierarchy item",c=>c instanceof I.TypeHierarchyItem,b.TypeHierarchyItem.from),T.TestItem=new T("testItem","A VS Code TestItem",c=>c instanceof f.TestItemImpl,b.TestItem.from);class r{constructor(t,o){this.description=t,this.convert=o}}e.ApiCommandResult=r,r.Void=new r("no result",c=>c);class i{constructor(t,o,g,h,_){this.id=t,this.internalId=o,this.description=g,this.args=h,this.result=_}}e.ApiCommand=i}),define(Ee[180],we([1,0,2,8,7,88,39,16,75,79,10]),function(J,e,s,I,b,B,D,A,y,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const v=[new D.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",m(I.DocumentHighlight.to))),new D.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(n,f)=>{if((0,A.isFalsyOrEmpty)(n))return;class S extends b.SymbolInformation{static to(d){const p=new S(d.name,I.SymbolKind.to(d.kind),d.containerName||"",new b.Location(f[0],I.Range.to(d.range)));return p.detail=d.detail,p.range=p.location.range,p.selectionRange=I.Range.to(d.selectionRange),p.children=d.children?d.children.map(S.to):[],p}}return n.map(S.to)})),new D.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",m(I.TextEdit.to))),new D.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range,new D.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",m(I.TextEdit.to))),new D.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,new D.ApiCommandArgument("ch","Trigger character",n=>typeof n=="string",n=>n),new D.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",m(I.TextEdit.to))),new D.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",l)),new D.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",l)),new D.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",l)),new D.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",l)),new D.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location-instances.",m(I.location.to))),new D.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Hover-instances.",m(I.Hover.to))),new D.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("position","A position in a text document",n=>Array.isArray(n)&&n.every(f=>b.Position.isPosition(f)),n=>n.map(I.Position.from))],new D.ApiCommandResult("A promise that resolves to an array of ranges.",n=>n.map(f=>{let S;for(const k of f.reverse())S=new b.SelectionRange(I.Range.to(k),S);return S}))),new D.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[D.ApiCommandArgument.String.with("query","Search string")],new D.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",n=>n.map(I.WorkspaceSymbol.to))),new D.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(I.CallHierarchyItem.to))),new D.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[D.ApiCommandArgument.CallHierarchyItem],new D.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(I.CallHierarchyIncomingCall.to))),new D.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[D.ApiCommandArgument.CallHierarchyItem],new D.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(I.CallHierarchyOutgoingCall.to))),new D.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to a range and placeholder text.",n=>{if(!!n)return{range:I.Range.to(n.range),placeholder:n.text}})),new D.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("newName","The new symbol name")],new D.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",n=>{if(!!n){if(n.rejectReason)throw new Error(n.rejectReason);return I.WorkspaceEdit.to(n)}})),new D.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new D.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",n=>n.map(I.DocumentLink.to))),new D.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(!!n)return new b.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new D.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const f=(0,y.decodeSemanticTokensDto)(n);if(f.type==="full")return new b.SemanticTokens(f.data,void 0)})),new D.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range.optional()],new D.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(!!n)return new b.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new D.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const f=(0,y.decodeSemanticTokensDto)(n);if(f.type==="full")return new b.SemanticTokens(f.data,void 0)})),new D.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),D.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new D.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(n,f,S)=>{if(!n)return new b.CompletionList([]);const k=n.suggestions.map(d=>I.CompletionItem.to(d,S));return new b.CompletionList(k,n.incomplete)})),new D.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new D.ApiCommandResult("A promise that resolves to SignatureHelp.",n=>{if(n)return I.SignatureHelp.to(n)})),new D.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new D.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(n,f,S)=>m(k=>new b.CodeLens(I.Range.to(k.range),k.command&&S.fromInternal(k.command)))(n))),new D.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",n=>b.Range.isRange(n),n=>b.Selection.isSelection(n)?I.Selection.from(n):I.Range.from(n)),D.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),D.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new D.ApiCommandResult("A promise that resolves to an array of Command-instances.",(n,f,S)=>m(k=>{if(k._isSynthetic){if(!k.command)throw new Error("Synthetic code actions must have a command");return S.fromInternal(k.command)}else{const d=new b.CodeAction(k.title,k.kind?new b.CodeActionKind(k.kind):void 0);return k.edit&&(d.edit=I.WorkspaceEdit.to(k.edit)),k.command&&(d.command=S.fromInternal(k.command)),d.isPreferred=k.isPreferred,d}})(n))),new D.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",n=>n?n.map(f=>new b.ColorInformation(I.Range.to(f.range),I.Color.to(f.color))):[])),new D.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new D.ApiCommandArgument("color","The color to show and insert",n=>n instanceof b.Color,I.Color.from),new D.ApiCommandArgument("context","Context object with uri and range",n=>!0,n=>({uri:n.uri,range:I.Range.from(n.range)}))],new D.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",n=>n?n.map(I.ColorPresentation.to):[])),new D.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to an array of Inlay objects",(n,f,S)=>n.map(I.InlayHint.to.bind(void 0,S)))),new D.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new D.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",m(n=>({viewType:n.viewType,displayName:n.displayName,options:{transientOutputs:n.options.transientOutputs,transientCellMetadata:n.options.transientCellMetadata,transientDocumentMetadata:n.options.transientDocumentMetadata},filenamePattern:n.filenamePattern.map(f=>I.NotebookExclusiveDocumentPattern.to(f))})))),new D.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to an array of InlineValue objects",n=>n.map(I.InlineValue.to))),new D.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new D.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",n=>s.URI.isUri(n)||typeof n=="string"&&(0,M.matchesSomeScheme)(n,L.Schemas.http,L.Schemas.https),n=>n),new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[I.ViewColumn.from(n),void 0]:[I.ViewColumn.from(n.viewColumn),I.TextEditorOpenOptions.from(n)])).optional(),D.ApiCommandArgument.String.with("label","").optional()],D.ApiCommandResult.Void),new D.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[D.ApiCommandArgument.Uri.with("resource","Resource to open"),D.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[I.ViewColumn.from(n),void 0]:[I.ViewColumn.from(n.viewColumn),I.TextEditorOpenOptions.from(n)])).optional()],D.ApiCommandResult.Void),new D.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[D.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),D.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),D.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="object",n=>n&&[I.ViewColumn.from(n.viewColumn),I.TextEditorOpenOptions.from(n)]).optional()],D.ApiCommandResult.Void),new D.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(I.TypeHierarchyItem.to))),new D.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[D.ApiCommandArgument.TypeHierarchyItem],new D.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(I.TypeHierarchyItem.to))),new D.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[D.ApiCommandArgument.TypeHierarchyItem],new D.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(I.TypeHierarchyItem.to))),new D.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[D.ApiCommandArgument.TestItem],D.ApiCommandResult.Void)];class u{static register(f){v.forEach(f.registerApiCommand,f)}}e.ExtHostApiCommands=u;function m(n){return f=>{if(Array.isArray(f))return f.map(n)}}function l(n){if(!Array.isArray(n))return;const f=[];for(const S of n)B.isLocationLink(S)?f.push(I.DefinitionLink.to(S)):f.push(I.location.to(S));return f}}),define(Ee[181],we([1,0,13,52,5,6,2,88,25,8,7,4]),function(J,e,s,I,b,B,D,A,y,M,L,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function u(m,l,n){const f=m.getProxy(v.MainContext.MainThreadComments);class S{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,l.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===6){const c=this._commentControllers.get(i.handle);return c||i}else if(i&&i.$mid===7){const c=this._commentControllers.get(i.commentControlHandle);if(!c)return i;const t=c.getCommentThread(i.commentThreadHandle);return t||i}else if(i&&i.$mid===8){const c=this._commentControllers.get(i.thread.commentControlHandle);if(!c)return i;const t=c.getCommentThread(i.thread.commentThreadHandle);return t?{thread:t,text:i.text}:i}else if(i&&i.$mid===9){const c=this._commentControllers.get(i.thread.commentControlHandle);if(!c)return i;const t=c.getCommentThread(i.thread.commentThreadHandle);if(!t)return i;let o=i.commentUniqueId,g=t.getCommentByUniqueId(o);return g||i}else if(i&&i.$mid===10){const c=this._commentControllers.get(i.thread.commentControlHandle);if(!c)return i;const t=c.getCommentThread(i.thread.commentThreadHandle);if(!t)return i;let o=i.text,g=i.commentUniqueId,h=t.getCommentByUniqueId(g);return h?(h.body=o,h):i}return i}})}createCommentController(i,c,t){const o=S.handlePool++,g=new d(i,o,c,t);this._commentControllers.set(g.handle,g);const h=this._commentControllersByExtension.get(y.ExtensionIdentifier.toKey(i.identifier))||[];return h.push(g),this._commentControllersByExtension.set(y.ExtensionIdentifier.toKey(i.identifier),h),g.value}$createCommentThreadTemplate(i,c,t){const o=this._commentControllers.get(i);!o||o.$createCommentThreadTemplate(c,t)}async $updateCommentThreadTemplate(i,c,t){const o=this._commentControllers.get(i);!o||o.$updateCommentThreadTemplate(c,t)}$deleteCommentThread(i,c){const t=this._commentControllers.get(i);t&&t.$deleteCommentThread(c)}$provideCommentingRanges(i,c,t){const o=this._commentControllers.get(i);if(!o||!o.commentingRangeProvider)return Promise.resolve(void 0);const g=n.getDocument(D.URI.revive(c));return(0,s.asPromise)(()=>o.commentingRangeProvider.provideCommentingRanges(g,t)).then(h=>h?h.map(_=>M.Range.from(_)):void 0)}$toggleReaction(i,c,t,o,g){const h=this._commentControllers.get(i);return!h||!h.reactionHandler?Promise.resolve(void 0):(0,s.asPromise)(()=>{const _=h.getCommentThread(c);if(_){const P=_.getCommentByUniqueId(o.uniqueIdInThread);if(h!==void 0&&P&&h.reactionHandler)return h.reactionHandler(P,a(g))}return Promise.resolve(void 0)})}dispose(){}}S.handlePool=0;class k{constructor(i,c,t,o,g,h,_){this._commentControllerHandle=c,this._id=t,this._uri=o,this._range=g,this._comments=h,this.extensionDescription=_,this.handle=k._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new b.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new B.MutableDisposable,this._acceptInputDisposables.value=new B.DisposableStore,this._id===void 0&&(this._id=`${i}.${this.handle}`),f.$createCommentThread(c,this.handle,this._id,this._uri,M.Range.from(this._range),_.identifier),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=h,this._localDisposables.push({dispose:()=>{f.$deleteCommentThread(c,this.handle)}});const P=this;this.value={get uri(){return P.uri},get range(){return P.range},set range(R){P.range=R},get comments(){return P.comments},set comments(R){P.comments=R},get collapsibleState(){return P.collapsibleState},set collapsibleState(R){P.collapsibleState=R},get canReply(){return P.canReply},set canReply(R){P.canReply=R},get contextValue(){return P.contextValue},set contextValue(R){P.contextValue=R},get label(){return P.label},set label(R){P.label=R},dispose:()=>{P.dispose()}}}set threadId(i){this._id=i}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(i){i.isEqual(this._range)||(this._range=i,this.modifications.range=i,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(i){this._canReply!==i&&(this._canReply=i,this.modifications.canReply=i,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(i){this._label=i,this.modifications.label=i,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(i){this._contextValue=i,this.modifications.contextValue=i,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(i){this._comments=i,this.modifications.comments=i,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(i){this._collapseState=i,this.modifications.collapsibleState=i,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new B.DisposableStore);const i=t=>Object.prototype.hasOwnProperty.call(this.modifications,t),c={};i("range")&&(c.range=M.Range.from(this._range)),i("label")&&(c.label=this.label),i("contextValue")&&(c.contextValue=this.contextValue??null),i("comments")&&(c.comments=this._comments.map(t=>p(this,t,this._commentsMap))),i("collapsibleState")&&(c.collapseState=T(this._collapseState)),i("canReply")&&(c.canReply=this.canReply),this.modifications={},f.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,c)}getCommentByUniqueId(i){for(let c of this._commentsMap){let t=c[0],o=c[1];if(i===o)return t}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(i=>i.dispose())}}k._handlePool=0,Fe([(0,I.debounce)(100)],k.prototype,"eventuallyUpdateCommentThread",null);class d{constructor(i,c,t,o){this._extension=i,this._handle=c,this._id=t,this._label=o,this._threads=new Map,f.$registerCommentController(this.handle,t,o);const g=this;this.value=Object.freeze({id:g.id,label:g.label,get options(){return g.options},set options(h){g.options=h},get commentingRangeProvider(){return g.commentingRangeProvider},set commentingRangeProvider(h){g.commentingRangeProvider=h},get reactionHandler(){return g.reactionHandler},set reactionHandler(h){g.reactionHandler=h},createCommentThread(h,_,P){return g.createCommentThread(h,_,P).value},dispose:()=>{g.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{f.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(i){this._commentingRangeProvider=i,f.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(i){this._reactionHandler=i,f.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!i})}get options(){return this._options}set options(i){this._options=i,f.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(i,c,t,o){if(typeof i=="string"){const g=new k(this.id,this.handle,i,c,t,o,this._extension);return this._threads.set(g.handle,g),g}else{const g=new k(this.id,this.handle,void 0,i,c,t,this._extension);return this._threads.set(g.handle,g),g}}$createCommentThreadTemplate(i,c){const t=new k(this.id,this.handle,void 0,D.URI.revive(i),M.Range.to(c),[],this._extension);return t.collapsibleState=A.CommentThreadCollapsibleState.Expanded,this._threads.set(t.handle,t),t}$updateCommentThreadTemplate(i,c){let t=this._threads.get(i);t&&(t.range=M.Range.to(c))}$deleteCommentThread(i){let c=this._threads.get(i);c&&c.dispose(),this._threads.delete(i)}getCommentThread(i){return this._threads.get(i)}dispose(){this._threads.forEach(i=>{i.dispose()}),this._localDisposables.forEach(i=>i.dispose())}}function p(r,i,c){let t=c.get(i);t||(t=++r.commentHandle,c.set(i,t));const o=i.author&&i.author.iconPath?i.author.iconPath.toString():void 0;return{mode:i.mode,contextValue:i.contextValue,uniqueIdInThread:t,body:typeof i.body=="string"?i.body:M.MarkdownString.from(i.body),userName:i.author.name,userIconPath:o,label:i.label,commentReactions:i.reactions?i.reactions.map(g=>w(g)):void 0,timestamp:i.timestamp?.toJSON()}}function w(r){return{label:r.label,iconPath:r.iconPath?M.pathOrURIToURI(r.iconPath):void 0,count:r.count,hasReacted:r.authorHasReacted}}function a(r){return{label:r.label||"",count:r.count||0,iconPath:r.iconPath?D.URI.revive(r.iconPath):"",authorHasReacted:r.hasReacted||!1}}function T(r){if(r!==void 0)switch(r){case L.CommentThreadCollapsibleState.Expanded:return A.CommentThreadCollapsibleState.Expanded;case L.CommentThreadCollapsibleState.Collapsed:return A.CommentThreadCollapsibleState.Collapsed}return A.CommentThreadCollapsibleState.Collapsed}return new S}e.createExtHostComments=u}),define(Ee[92],we([1,0,2,4,7,3,14,12,16,9,17]),function(J,e,s,I,b,B,D,A,y,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let v=class wi{constructor(m,l){this._logService=l,this._provider=new Map,this._proxy=m.getProxy(I.MainContext.MainThreadDecorations)}registerFileDecorationProvider(m,l){const n=wi._handlePool++;this._provider.set(n,{provider:m,extensionId:l}),this._proxy.$registerDecorationProvider(n,l.value);const f=m.onDidChangeFileDecorations&&m.onDidChangeFileDecorations(S=>{if(!S){this._proxy.$onDidChange(n,null);return}let k=(0,y.asArray)(S);if(k.length<=wi._maxEventSize){this._proxy.$onDidChange(n,k);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",l.value,k.length);const d=k.map(a=>({uri:a,rank:(0,M.count)(a.path,"/")})),p=(0,y.groupBy)(d,(a,T)=>a.rank-T.rank||(0,M.compare)(a.uri.path,T.uri.path));let w=[];e:for(let a of p){let T;for(let r of a){let i=(0,L.dirname)(r.uri.path);if(T!==i&&(T=i,w.push(r.uri)>=wi._maxEventSize))break e}}this._proxy.$onDidChange(n,w)});return new b.Disposable(()=>{f?.dispose(),this._proxy.$unregisterDecorationProvider(n),this._provider.delete(n)})}async $provideDecorations(m,l,n){if(!this._provider.has(m))return Object.create(null);const f=Object.create(null),{provider:S,extensionId:k}=this._provider.get(m);return await Promise.all(l.map(async d=>{try{const{uri:p,id:w}=d,a=await Promise.resolve(S.provideFileDecoration(s.URI.revive(p),n));if(!a)return;try{b.FileDecoration.validate(a),f[w]=[a.propagate,a.tooltip,a.badge,a.color]}catch(T){this._logService.warn(`INVALID decoration from extension '${k.value}': ${T}`)}}catch(p){this._logService.error(p)}})),f}};v._handlePool=0,v._maxEventSize=250,v=Fe([Ne(0,D.IExtHostRpcService),Ne(1,A.ILogService)],v),e.ExtHostDecorations=v,e.IExtHostDecorations=(0,B.createDecorator)("IExtHostDecorations")});var je=this&&this.__classPrivateFieldSet||function(J,e,s,I,b){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!b:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?b.call(J,s):b?b.value=s:e.set(J,s),s},De=this&&this.__classPrivateFieldGet||function(J,e,s,I){if(s==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?I:s==="a"?I.call(J):I?I.value:e.get(J)};define(Ee[182],we([1,0,122,78,2,4,7,8,5,12,22,30]),function(J,e,s,I,b,B,D,A,y,M,L,v){"use strict";var u,m,l;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class n{constructor(k,d,p,w,a,T){this._name=k,this._owner=d,this._maxDiagnosticsPerFile=p,u.set(this,void 0),m.set(this,void 0),l.set(this,void 0),this._isDisposed=!1,je(this,l,new L.ResourceMap(r=>w.getComparisonKey(r)),"f"),je(this,u,a,"f"),je(this,m,T,"f")}dispose(){this._isDisposed||(De(this,m,"f").fire([...De(this,l,"f").keys()]),De(this,u,"f")&&De(this,u,"f").$clear(this._owner),De(this,l,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(k,d){if(!k){this.clear();return}this._checkDisposed();let p=[];if(b.URI.isUri(k)){if(!d){this.delete(k);return}De(this,l,"f").set(k,d.slice()),p=[k]}else if(Array.isArray(k)){p=[];let a;k=[...k].sort(n._compareIndexedTuplesByUri);for(const T of k){const[r,i]=T;if((!a||r.toString()!==a.toString())&&(a&&De(this,l,"f").get(a).length===0&&De(this,l,"f").delete(a),a=r,p.push(r),De(this,l,"f").set(r,[])),i){const c=De(this,l,"f").get(r);c&&c.push(...i)}else{const c=De(this,l,"f").get(r);c&&(c.length=0)}}}if(De(this,m,"f").fire(p),!De(this,u,"f"))return;const w=[];for(let a of p){let T=[];const r=De(this,l,"f").get(a);if(r)if(r.length>this._maxDiagnosticsPerFile){T=[];const i=[D.DiagnosticSeverity.Error,D.DiagnosticSeverity.Warning,D.DiagnosticSeverity.Information,D.DiagnosticSeverity.Hint];e:for(let c=0;c<4;c++)for(let t of r)if(t.severity===i[c]&&T.push(A.Diagnostic.from(t))===this._maxDiagnosticsPerFile)break e;T.push({severity:I.MarkerSeverity.Info,message:(0,s.localize)(0,null,r.length-this._maxDiagnosticsPerFile),startLineNumber:T[T.length-1].startLineNumber,startColumn:T[T.length-1].startColumn,endLineNumber:T[T.length-1].endLineNumber,endColumn:T[T.length-1].endColumn})}else T=r.map(i=>A.Diagnostic.from(i));w.push([a,T])}De(this,u,"f").$changeMany(this._owner,w)}delete(k){this._checkDisposed(),De(this,m,"f").fire([k]),De(this,l,"f").delete(k),De(this,u,"f")&&De(this,u,"f").$changeMany(this._owner,[[k,void 0]])}clear(){this._checkDisposed(),De(this,m,"f").fire([...De(this,l,"f").keys()]),De(this,l,"f").clear(),De(this,u,"f")&&De(this,u,"f").$clear(this._owner)}forEach(k,d){this._checkDisposed();for(let p of De(this,l,"f").keys())k.apply(d,[p,this.get(p),this])}get(k){this._checkDisposed();const d=De(this,l,"f").get(k);return Array.isArray(d)?Object.freeze(d.slice(0)):[]}has(k){return this._checkDisposed(),Array.isArray(De(this,l,"f").get(k))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(k,d){return k[0].toString()<d[0].toString()?-1:k[0].toString()>d[0].toString()?1:0}}e.DiagnosticCollection=n,u=new WeakMap,m=new WeakMap,l=new WeakMap;let f=class oi{constructor(k,d,p){this._logService=d,this._fileSystemInfoService=p,this._collections=new Map,this._onDidChangeDiagnostics=new y.DebounceEmitter({merge:w=>w.flat(),delay:50}),this.onDidChangeDiagnostics=y.Event.map(this._onDidChangeDiagnostics.event,oi._mapper),this._proxy=k.getProxy(B.MainContext.MainThreadDiagnostics)}static _mapper(k){const d=new L.ResourceMap;for(const p of k)d.set(p,p);return{uris:Object.freeze(Array.from(d.values()))}}createDiagnosticCollection(k,d){const{_collections:p,_proxy:w,_onDidChangeDiagnostics:a,_logService:T,_fileSystemInfoService:r}=this,i=new class{$changeMany(o,g){w.$changeMany(o,g),T.trace("[DiagnosticCollection] change many (extension, owner, uris)",k.value,o,g.length===0?"CLEARING":g)}$clear(o){w.$clear(o),T.trace("[DiagnosticCollection] remove all (extension, owner)",k.value,o)}dispose(){w.dispose()}};let c;if(!d)d="_generated_diagnostic_collection_name_#"+oi._idPool++,c=d;else if(!p.has(d))c=d;else{this._logService.warn(`DiagnosticCollection with name '${d}' does already exist.`);do c=d+oi._idPool++;while(p.has(c))}return new class extends n{constructor(){super(d,c,oi._maxDiagnosticsPerFile,r.extUri,i,a);p.set(c,this)}dispose(){super.dispose(),p.delete(c)}}}getDiagnostics(k){if(k)return this._getDiagnostics(k);{const d=new Map,p=[];for(const w of this._collections.values())w.forEach((a,T)=>{let r=d.get(a.toString());typeof r=="undefined"&&(r=p.length,d.set(a.toString(),r),p.push([a,[]])),p[r][1]=p[r][1].concat(...T)});return p}}_getDiagnostics(k){let d=[];for(let p of this._collections.values())p.has(k)&&(d=d.concat(p.get(k)));return d}$acceptMarkersChange(k){if(!this._mirrorCollection){const d="_generated_mirror",p=new n(d,d,oi._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(d,p),this._mirrorCollection=p}for(const[d,p]of k)this._mirrorCollection.set(b.URI.revive(d),p.map(A.Diagnostic.to))}};f._idPool=0,f._maxDiagnosticsPerFile=1e3,f=Fe([Ne(1,M.ILogService),Ne(2,v.IExtHostFileSystemInfo)],f),e.ExtHostDiagnostics=f}),define(Ee[183],we([1,0,2,4]),function(J,e,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class b{constructor(D){this._proxy=D.getProxy(I.MainContext.MainThreadDialogs)}showOpenDialog(D){return this._proxy.$showOpenDialog(D).then(A=>A?A.map(y=>s.URI.revive(y)):void 0)}showSaveDialog(D){return this._proxy.$showSaveDialog(D).then(A=>A?s.URI.revive(A):void 0)}}e.ExtHostDialogs=b}),define(Ee[184],we([1,0,15,2,7,4,10,20,9]),function(J,e,s,I,b,B,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class M{constructor(v,u,m){this._documentsAndEditors=u,this._logService=m,this._documentContentProviders=new Map,this._proxy=v.getProxy(B.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(v,u){if(Object.keys(D.Schemas).indexOf(v)>=0)throw new Error(`scheme '${v}' already registered`);const m=M._handlePool++;this._documentContentProviders.set(m,u),this._proxy.$registerTextContentProvider(m,v);let l;return typeof u.onDidChange=="function"&&(l=u.onDidChange(n=>{if(n.scheme!==v){this._logService.warn(`Provider for scheme '${v}' is firing event for schema '${n.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(n)&&this.$provideTextDocumentContent(m,n).then(f=>{if(!f&&typeof f!="string")return;const S=this._documentsAndEditors.getDocument(n);if(!S)return;const k=(0,y.splitLines)(f);if(!S.equalLines(k))return this._proxy.$onVirtualDocumentChange(n,f)},s.onUnexpectedError)})),new b.Disposable(()=>{this._documentContentProviders.delete(m)&&this._proxy.$unregisterTextContentProvider(m),l&&(l.dispose(),l=void 0)})}$provideTextDocumentContent(v,u){const m=this._documentContentProviders.get(v);return m?Promise.resolve(m.provideTextDocumentContent(I.URI.revive(u),A.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${u.scheme}`))}}e.ExtHostDocumentContentProvider=M,M._handlePool=0}),define(Ee[185],we([1,0,5,6,2,4,84,8,11,26,7]),function(J,e,s,I,b,B,D,A,y,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class v{constructor(m,l){this._onDidAddDocument=new s.Emitter,this._onDidRemoveDocument=new s.Emitter,this._onDidChangeDocument=new s.Emitter,this._onDidSaveDocument=new s.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new I.DisposableStore,this._documentLoader=new Map,this._proxy=m.getProxy(B.MainContext.MainThreadDocuments),this._documentsAndEditors=l,this._documentsAndEditors.onDidRemoveDocuments(n=>{for(const f of n)this._onDidRemoveDocument.fire(f.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(n=>{for(const f of n)this._onDidAddDocument.fire(f.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(m){if(!m)return;const l=this._documentsAndEditors.getDocument(m);if(l)return l}getDocument(m){const l=this.getDocumentData(m);if(!l?.document)throw new Error(`Unable to retrieve document from URI '${m}'`);return l.document}ensureDocumentData(m){const l=this._documentsAndEditors.getDocument(m);if(l)return Promise.resolve(l);let n=this._documentLoader.get(m.toString());return n||(n=this._proxy.$tryOpenDocument(m).then(f=>{this._documentLoader.delete(m.toString());const S=b.URI.revive(f);return(0,y.assertIsDefined)(this._documentsAndEditors.getDocument(S))},f=>(this._documentLoader.delete(m.toString()),Promise.reject(f))),this._documentLoader.set(m.toString(),n)),n}createDocumentData(m){return this._proxy.$tryCreateDocument(m).then(l=>b.URI.revive(l))}$acceptModelLanguageChanged(m,l){const n=b.URI.revive(m),f=this._documentsAndEditors.getDocument(n);if(!f)throw new Error("unknown document");this._onDidRemoveDocument.fire(f.document),f._acceptLanguageId(l),this._onDidAddDocument.fire(f.document)}$acceptModelSaved(m){const l=b.URI.revive(m),n=this._documentsAndEditors.getDocument(l);if(!n)throw new Error("unknown document");this.$acceptDirtyStateChanged(m,!1),this._onDidSaveDocument.fire(n.document)}$acceptDirtyStateChanged(m,l){const n=b.URI.revive(m),f=this._documentsAndEditors.getDocument(n);if(!f)throw new Error("unknown document");f._acceptIsDirty(l),this._onDidChangeDocument.fire({document:f.document,contentChanges:[],reason:void 0})}$acceptModelChanged(m,l,n){const f=b.URI.revive(m),S=this._documentsAndEditors.getDocument(f);if(!S)throw new Error("unknown document");S._acceptIsDirty(n),S.onEvents(l);let k;l.isUndoing?k=L.TextDocumentChangeReason.Undo:l.isRedoing&&(k=L.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,M.deepFreeze)({document:S.document,contentChanges:l.changes.map(d=>({range:A.Range.to(d.range),rangeOffset:d.rangeOffset,rangeLength:d.rangeLength,text:d.text})),reason:k}))}setWordDefinitionFor(m,l){(0,D.setWordDefinitionFor)(m,l)}}e.ExtHostDocuments=v}),define(Ee[49],we([1,0,42,5,6,2,3,4,84,14,90,8,12,22,10,161,230]),function(J,e,s,I,b,B,D,A,y,M,L,v,u,m,l,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class S{constructor(p){this.value=p,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let k=class{constructor(p,w){this._extHostRpc=p,this._logService=w,this._activeEditorId=null,this._editors=new Map,this._documents=new m.ResourceMap,this._onDidAddDocuments=new I.Emitter,this._onDidRemoveDocuments=new I.Emitter,this._onDidChangeVisibleTextEditors=new I.Emitter,this._onDidChangeActiveTextEditor=new I.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(p){this.acceptDocumentsAndEditorsDelta(p)}acceptDocumentsAndEditorsDelta(p){const w=[],a=[],T=[];if(p.removedDocuments)for(const r of p.removedDocuments){const i=B.URI.revive(r),c=this._documents.get(i);c?.unref()&&(this._documents.delete(i),w.push(c.value))}if(p.addedDocuments)for(const r of p.addedDocuments){const i=B.URI.revive(r.uri);let c=this._documents.get(i);if(c&&i.scheme!==l.Schemas.vscodeNotebookCell&&i.scheme!==l.Schemas.vscodeInteractiveInput)throw new Error(`document '${i} already exists!'`);c||(c=new S(new y.ExtHostDocumentData(this._extHostRpc.getProxy(A.MainContext.MainThreadDocuments),i,r.lines,r.EOL,r.versionId,r.languageId,r.isDirty,r.notebook)),this._documents.set(i,c),a.push(c.value)),c.ref()}if(p.removedEditors)for(const r of p.removedEditors){const i=this._editors.get(r);this._editors.delete(r),i&&T.push(i)}if(p.addedEditors)for(const r of p.addedEditors){const i=B.URI.revive(r.documentUri);s.ok(this._documents.has(i),`document '${i}' does not exist`),s.ok(!this._editors.has(r.id),`editor '${r.id}' already exists!`);const c=this._documents.get(i).value,t=new L.ExtHostTextEditor(r.id,this._extHostRpc.getProxy(A.MainContext.MainThreadTextEditors),this._logService,new f.Lazy(()=>c.document),r.selections.map(v.Selection.to),r.options,r.visibleRanges.map(o=>v.Range.to(o)),typeof r.editorPosition=="number"?v.ViewColumn.to(r.editorPosition):void 0);this._editors.set(r.id,t)}p.newActiveEditor!==void 0&&(s.ok(p.newActiveEditor===null||this._editors.has(p.newActiveEditor),`active editor '${p.newActiveEditor}' does not exist`),this._activeEditorId=p.newActiveEditor),(0,b.dispose)(w),(0,b.dispose)(T),p.removedDocuments&&this._onDidRemoveDocuments.fire(w),p.addedDocuments&&this._onDidAddDocuments.fire(a),(p.removedEditors||p.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(r=>r.value)),p.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(p){return this._documents.get(p)?.value}allDocuments(){return n.Iterable.map(this._documents.values(),p=>p.value)}getEditor(p){return this._editors.get(p)}activeEditor(p){if(!this._activeEditorId)return;const w=this._editors.get(this._activeEditorId);return p?w:w?.value}allEditors(){return[...this._editors.values()]}};k=Fe([Ne(0,M.IExtHostRpcService),Ne(1,u.ILogService)],k),e.ExtHostDocumentsAndEditors=k,e.IExtHostDocumentsAndEditors=(0,D.createDecorator)("IExtHostDocumentsAndEditors")}),define(Ee[66],we([1,0,8,4,2,5,3,14]),function(J,e,s,I,b,B,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,D.createDecorator)("IExtHostEditorTabs");let y=class{constructor(L){this._onDidChangeTabGroup=new B.Emitter,this.onDidChangeTabGroup=this._onDidChangeTabGroup.event,this._tabGroups={all:[],activeTabGroup:void 0,onDidChangeTabGroup:this._onDidChangeTabGroup.event},this._proxy=L.getProxy(I.MainContext.MainThreadEditorTabs)}get tabGroups(){return this._tabGroups}$acceptEditorTabModel(L){this._tabGroups.all.length=0;for(const v of L){let u;const m=v.tabs.map(l=>{const n=this.createExtHostTabObject(l);return l.isActive&&(u=n),n});this._tabGroups.all.push(Object.freeze({isActive:v.isActive,viewColumn:s.ViewColumn.to(v.viewColumn),activeTab:u,tabs:m})),v.isActive&&(this._tabGroups.activeTabGroup=this._tabGroups.all[this._tabGroups.all.length-1])}this._onDidChangeTabGroup.fire()}createExtHostTabObject(L){return Object.freeze({label:L.label,viewColumn:s.ViewColumn.to(L.viewColumn),resource:b.URI.revive(L.resource),additionalResourcesAndViewIds:L.additionalResourcesAndViewIds.map(({resource:v,viewId:u})=>({resource:b.URI.revive(v),viewId:u})),viewId:L.editorId,isActive:L.isActive,kind:L.kind,isDirty:L.isDirty,isPinned:L.isPinned,move:async(v,u)=>{this._proxy.$moveTab(L,v,s.ViewColumn.from(u))},close:async()=>{await this._proxy.$closeTab(L)}})}};y=Fe([Ne(0,A.IExtHostRpcService)],y),e.ExtHostEditorTabs=y}),define(Ee[186],we([1,0,2,4,6,7,8,231,9,21,28]),function(J,e,s,I,b,B,D,A,y,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class v{constructor(){this._schemes=[]}add(l){this._stateMachine=void 0,this._schemes.push(l)}delete(l){const n=this._schemes.indexOf(l);n>=0&&(this._schemes.splice(n,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const l=this._schemes.sort(),n=[];let f,S,k=14,d=14;for(const p of l){let w=f?(0,y.commonPrefixLength)(f,p):0;for(w===0?S=1:S=d;w<p.length;w++)w+1===p.length?(k=d,d=9):d+=1,n.push([S,p.toUpperCase().charCodeAt(w),d]),n.push([S,p.toLowerCase().charCodeAt(w),d]),S=d;f=p,d=k}n.push([9,58,10]),n.push([10,47,12]),this._stateMachine=new A.StateMachine(n)}}provideDocumentLinks(l){this._initStateMachine();const n=[],f=A.LinkComputer.computeLinks({getLineContent(S){return l.lineAt(S-1).text},getLineCount(){return l.lineCount}},this._stateMachine);for(const S of f){const k=D.DocumentLink.to(S);k.target&&n.push(k)}return n}}class u{constructor(l,n){this._extHostLanguageFeatures=n,this._linkProvider=new v,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=l.getProxy(I.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(l,n,f,S={}){if(this._registeredSchemes.has(n))throw new Error(`a provider for the scheme '${n}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(l,"*",this._linkProvider));const k=this._handlePool++;this._linkProvider.add(n),this._registeredSchemes.add(n),this._fsProvider.set(k,f);let d=2;S.isCaseSensitive&&(d+=1024),S.isReadonly&&(d+=2048),typeof f.copy=="function"&&(d+=8),typeof f.open=="function"&&typeof f.close=="function"&&typeof f.read=="function"&&typeof f.write=="function"&&((0,L.checkProposedApiEnabled)(l,"fsChunks"),d+=4),this._proxy.$registerFileSystemProvider(k,n,d).catch(w=>{console.error(`FAILED to register filesystem provider of ${l.identifier.value}-extension for the scheme ${n}`),console.error(w)});const p=f.onDidChangeFile(w=>{const a=[];for(const T of w){let{uri:r,type:i}=T;if(r.scheme!==n)continue;let c;switch(i){case B.FileChangeType.Changed:c=0;break;case B.FileChangeType.Created:c=1;break;case B.FileChangeType.Deleted:c=2;break;default:throw new Error("Unknown FileChangeType")}a.push({resource:r,type:c})}this._proxy.$onFileSystemChange(k,a)});return(0,b.toDisposable)(()=>{p.dispose(),this._linkProvider.delete(n),this._registeredSchemes.delete(n),this._fsProvider.delete(k),this._proxy.$unregisterProvider(k)})}static _asIStat(l){const{type:n,ctime:f,mtime:S,size:k,permissions:d}=l;return{type:n,ctime:f,mtime:S,size:k,permissions:d}}$stat(l,n){return Promise.resolve(this._getFsProvider(l).stat(s.URI.revive(n))).then(f=>u._asIStat(f))}$readdir(l,n){return Promise.resolve(this._getFsProvider(l).readDirectory(s.URI.revive(n)))}$readFile(l,n){return Promise.resolve(this._getFsProvider(l).readFile(s.URI.revive(n))).then(f=>M.VSBuffer.wrap(f))}$writeFile(l,n,f,S){return Promise.resolve(this._getFsProvider(l).writeFile(s.URI.revive(n),f.buffer,S))}$delete(l,n,f){return Promise.resolve(this._getFsProvider(l).delete(s.URI.revive(n),f))}$rename(l,n,f,S){return Promise.resolve(this._getFsProvider(l).rename(s.URI.revive(n),s.URI.revive(f),S))}$copy(l,n,f,S){const k=this._getFsProvider(l);if(!k.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(k.copy(s.URI.revive(n),s.URI.revive(f),S))}$mkdir(l,n){return Promise.resolve(this._getFsProvider(l).createDirectory(s.URI.revive(n)))}$watch(l,n,f,S){const k=this._getFsProvider(l).watch(s.URI.revive(f),S);this._watches.set(n,k)}$unwatch(l,n){const f=this._watches.get(n);f&&(f.dispose(),this._watches.delete(n))}$open(l,n,f){const S=this._getFsProvider(l);if(!S.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(S.open(s.URI.revive(n),f))}$close(l,n){const f=this._getFsProvider(l);if(!f.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(f.close(n))}$read(l,n,f,S){const k=this._getFsProvider(l);if(!k.read)throw new Error('FileSystemProvider does not implement "read"');const d=M.VSBuffer.alloc(S);return Promise.resolve(k.read(n,f,d.buffer,0,S)).then(p=>d.slice(0,p))}$write(l,n,f,S){const k=this._getFsProvider(l);if(!k.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(k.write(n,f,S.buffer,0,S.byteLength))}_getFsProvider(l){const n=this._fsProvider.get(l);if(!n){const f=new Error;throw f.name="ENOPRO",f.message="no provider",f}return n}}e.ExtHostFileSystem=u}),define(Ee[50],we([1,0,4,45,7,21,3,14,30,6]),function(J,e,s,I,b,B,D,A,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let L=class jt{constructor(u,m){this._fileSystemProvider=new Map,this._proxy=u.getProxy(s.MainContext.MainThreadFileSystem);const l=this;this.value=Object.freeze({async stat(n){try{const f=l._fileSystemProvider.get(n.scheme);if(!f)return await l._proxy.$stat(n);await l._proxy.$ensureActivation(n.scheme);const S=await f.stat(n);return{type:S.type,ctime:S.ctime,mtime:S.mtime,size:S.size,permissions:S.permissions}}catch(f){jt._handleError(f)}},async readDirectory(n){try{const f=l._fileSystemProvider.get(n.scheme);return f?(await l._proxy.$ensureActivation(n.scheme),(await f.readDirectory(n)).slice()):await l._proxy.$readdir(n)}catch(f){return jt._handleError(f)}},async createDirectory(n){try{return await l._proxy.$mkdir(n)}catch(f){return jt._handleError(f)}},async readFile(n){try{const f=l._fileSystemProvider.get(n.scheme);return f?(await l._proxy.$ensureActivation(n.scheme),(await f.readFile(n)).slice()):(await l._proxy.$readFile(n)).buffer}catch(f){return jt._handleError(f)}},async writeFile(n,f){try{return await l._proxy.$writeFile(n,B.VSBuffer.wrap(f))}catch(S){return jt._handleError(S)}},async delete(n,f){try{const S=l._fileSystemProvider.get(n.scheme);return S?(await l._proxy.$ensureActivation(n.scheme),await S.delete(n,{recursive:!1,...f})):await l._proxy.$delete(n,{recursive:!1,useTrash:!1,...f})}catch(S){return jt._handleError(S)}},async rename(n,f,S){try{return await l._proxy.$rename(n,f,{overwrite:!1,...S})}catch(k){return jt._handleError(k)}},async copy(n,f,S){try{return await l._proxy.$copy(n,f,{overwrite:!1,...S})}catch(k){return jt._handleError(k)}},isWritableFileSystem(n){const f=m.getCapabilities(n);if(typeof f=="number")return!(f&2048)}})}static _handleError(u){if(u instanceof b.FileSystemError)throw u;if(!(u instanceof Error))throw new b.FileSystemError(String(u));if(u.name==="ENOPRO")throw b.FileSystemError.Unavailable(u.message);switch(u.name){case I.FileSystemProviderErrorCode.FileExists:throw b.FileSystemError.FileExists(u.message);case I.FileSystemProviderErrorCode.FileNotFound:throw b.FileSystemError.FileNotFound(u.message);case I.FileSystemProviderErrorCode.FileNotADirectory:throw b.FileSystemError.FileNotADirectory(u.message);case I.FileSystemProviderErrorCode.FileIsADirectory:throw b.FileSystemError.FileIsADirectory(u.message);case I.FileSystemProviderErrorCode.NoPermissions:throw b.FileSystemError.NoPermissions(u.message);case I.FileSystemProviderErrorCode.Unavailable:throw b.FileSystemError.Unavailable(u.message);default:throw new b.FileSystemError(u.message,u.name)}}addFileSystemProvider(u,m){return this._fileSystemProvider.set(u,m),(0,M.toDisposable)(()=>this._fileSystemProvider.delete(u))}};L=Fe([Ne(0,A.IExtHostRpcService),Ne(1,y.IExtHostFileSystemInfo)],L),e.ExtHostConsumerFileSystem=L,e.IExtHostConsumerFileSystem=(0,D.createDecorator)("IExtHostConsumerFileSystem")}),define(Ee[187],we([1,0,5,29,2,4,8,7]),function(J,e,s,I,b,B,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class y{constructor(v,u,m,l,n,f,S,k){this._onDidCreate=new s.Emitter,this._onDidChange=new s.Emitter,this._onDidDelete=new s.Emitter;const d=this.ensureWatching(v,m,n);this._config=0,f&&(this._config+=1),S&&(this._config+=2),k&&(this._config+=4);const p=(0,I.parse)(n),w=typeof n=="string",a=l(T=>{if(!f)for(let r of T.created){const i=b.URI.revive(r);p(i.fsPath)&&(!w||u.getWorkspaceFolder(i))&&this._onDidCreate.fire(i)}if(!S)for(let r of T.changed){const i=b.URI.revive(r);p(i.fsPath)&&(!w||u.getWorkspaceFolder(i))&&this._onDidChange.fire(i)}if(!k)for(let r of T.deleted){const i=b.URI.revive(r);p(i.fsPath)&&(!w||u.getWorkspaceFolder(i))&&this._onDidDelete.fire(i)}});this._disposable=A.Disposable.from(d,this._onDidCreate,this._onDidChange,this._onDidDelete,a)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}ensureWatching(v,u,m){let l=A.Disposable.from();if(typeof m=="string")return l;const n=v.getProxy(B.MainContext.MainThreadFileSystem);let f=!1;(m.pattern.includes(I.GLOBSTAR)||m.pattern.includes(I.GLOB_SPLIT))&&(f=!0);const S=Math.random();return n.$watch(u.identifier.value,S,m.baseUri,{recursive:f,excludes:[]}),A.Disposable.from({dispose:()=>n.$unwatch(S)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class M{constructor(v,u,m){this._mainContext=v,this._logService=u,this._extHostDocumentsAndEditors=m,this._onFileSystemEvent=new s.Emitter,this._onDidRenameFile=new s.Emitter,this._onDidCreateFile=new s.Emitter,this._onDidDeleteFile=new s.Emitter,this._onWillRenameFile=new s.AsyncEmitter,this._onWillCreateFile=new s.AsyncEmitter,this._onWillDeleteFile=new s.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(v,u,m,l,n,f){return new y(this._mainContext,v,u,this._onFileSystemEvent.event,D.GlobPattern.from(m),l,n,f)}$onFileEvent(v){this._onFileSystemEvent.fire(v)}$onDidRunFileOperation(v,u){switch(v){case 2:this._onDidRenameFile.fire(Object.freeze({files:u.map(m=>({oldUri:b.URI.revive(m.source),newUri:b.URI.revive(m.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:u.map(m=>b.URI.revive(m.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:u.map(m=>b.URI.revive(m.target))}));break;default:}}getOnWillRenameFileEvent(v){return this._createWillExecuteEvent(v,this._onWillRenameFile)}getOnWillCreateFileEvent(v){return this._createWillExecuteEvent(v,this._onWillCreateFile)}getOnWillDeleteFileEvent(v){return this._createWillExecuteEvent(v,this._onWillDeleteFile)}_createWillExecuteEvent(v,u){return(m,l,n)=>{const f=function(k){m.call(l,k)};return f.extension=v,u.event(f,void 0,n)}}async $onWillRunFileOperation(v,u,m,l){switch(v){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:u.map(n=>({oldUri:b.URI.revive(n.source),newUri:b.URI.revive(n.target)}))},m,l);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:u.map(n=>b.URI.revive(n.target))},m,l);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:u.map(n=>b.URI.revive(n.target))},m,l)}}async _fireWillEvent(v,u,m,l){const n=new Set,f=[];if(await v.fireAsync(u,l,async(k,d)=>{const p=Date.now(),w=await Promise.resolve(k);w instanceof A.WorkspaceEdit&&(f.push(w),n.add(d.extension.displayName??d.extension.identifier.value)),Date.now()-p>m&&this._logService.warn("SLOW file-participant",d.extension.identifier)}),l.isCancellationRequested||f.length===0)return;const S={edits:[]};for(let k of f){let{edits:d}=D.WorkspaceEdit.from(k,{getTextDocumentVersion:p=>this._extHostDocumentsAndEditors.getDocument(p)?.version,getNotebookDocumentVersion:()=>{}});S.edits=S.edits.concat(d)}return{edit:S,extensionNames:Array.from(n)}}}e.ExtHostFileSystemEventService=M}),define(Ee[188],we([1,0,2,39]),function(J,e,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class b{constructor(D,A,y,M){this._extHostNotebooks=A,this._textDocumentsAndEditors=y,this._commands=M;const L=new I.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new I.ApiCommandArgument("showOptions","Show Options",v=>!0,v=>v),new I.ApiCommandArgument("resource","Interactive resource Uri",v=>!0,v=>v),new I.ApiCommandArgument("controllerId","Notebook controller Id",v=>!0,v=>v),new I.ApiCommandArgument("title","Interactive editor title",v=>!0,v=>v)],new I.ApiCommandResult("Notebook and input URI",v=>{if(v.notebookEditorId!==void 0){const u=this._extHostNotebooks.getEditorById(v.notebookEditorId);return{notebookUri:s.URI.revive(v.notebookUri),inputUri:s.URI.revive(v.inputUri),notebookEditor:u.apiEditor}}return{notebookUri:s.URI.revive(v.notebookUri),inputUri:s.URI.revive(v.inputUri)}}));this._commands.registerApiCommand(L)}$willAddInteractiveDocument(D,A,y,M){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:A,lines:[""],languageId:y,uri:D,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(s.URI.revive(M))?.apiNotebook}]})}$willRemoveInteractiveDocument(D,A){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[D]})}}e.ExtHostInteractive=b}),define(Ee[189],we([1,0,6,4]),function(J,e,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class b{constructor(D){this._handlePool=0,this._proxy=D.getProxy(I.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(D){const A=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(A,D),(0,s.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(A)})}}e.ExtHostLabelService=b}),define(Ee[190],we([1,0,2,26,8,7,4,9,48,16,11,232,20,6,75,53,58,191,15,5,13]),function(J,e,s,I,b,B,D,A,y,M,L,v,u,m,l,n,f,S,k,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class w{constructor(N,F){this._documents=N,this._provider=F}async provideDocumentSymbols(N,F){const C=this._documents.getDocument(N),O=await this._provider.provideDocumentSymbols(C,F);if(!(0,M.isFalsyOrEmpty)(O))return O[0]instanceof B.DocumentSymbol?O.map(b.DocumentSymbol.from):w._asDocumentSymbolTree(O)}static _asDocumentSymbolTree(N){N=N.slice(0).sort((O,x)=>{let Q=O.location.range.start.compareTo(x.location.range.start);return Q===0&&(Q=x.location.range.end.compareTo(O.location.range.end)),Q});const F=[],C=[];for(const O of N){const x={name:O.name||"!!MISSING: name!!",kind:b.SymbolKind.from(O.kind),tags:O.tags?.map(b.SymbolTag.from)||[],detail:"",containerName:O.containerName,range:b.Range.from(O.location.range),selectionRange:b.Range.from(O.location.range),children:[]};for(;;){if(C.length===0){C.push(x),F.push(x);break}const Q=C[C.length-1];if(y.Range.containsRange(Q.range,x.range)&&!y.Range.equalsRange(Q.range,x.range)){Q.children&&Q.children.push(x),C.push(x);break}C.pop()}}return F}}class a{constructor(N,F,C){this._documents=N,this._commands=F,this._provider=C,this._cache=new f.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(N,F){const C=this._documents.getDocument(N),O=await this._provider.provideCodeLenses(C,F);if(!O||F.isCancellationRequested)return;const x=this._cache.add(O),Q=new m.DisposableStore;this._disposables.set(x,Q);const re={cacheId:x,lenses:[]};for(let ve=0;ve<O.length;ve++)re.lenses.push({cacheId:[x,ve],range:b.Range.from(O[ve].range),command:this._commands.toInternal(O[ve].command,Q)});return re}async resolveCodeLens(N,F){const C=N.cacheId&&this._cache.get(...N.cacheId);if(!C)return;let O;if(typeof this._provider.resolveCodeLens!="function"||C.isResolved?O=C:O=await this._provider.resolveCodeLens(C,F),O||(O=C),F.isCancellationRequested)return;const x=N.cacheId&&this._disposables.get(N.cacheId[0]);if(!!x)return N.command=this._commands.toInternal(O.command??a._badCmd,x),N}releaseCodeLenses(N){this._disposables.get(N)?.dispose(),this._disposables.delete(N),this._cache.delete(N)}}a._badCmd={command:"missing",title:"!!MISSING: command!!"};function T(de){return Array.isArray(de)?de.map(b.DefinitionLink.from):de?[b.DefinitionLink.from(de)]:[]}class r{constructor(N,F){this._documents=N,this._provider=F}async provideDefinition(N,F,C){const O=this._documents.getDocument(N),x=b.Position.to(F),Q=await this._provider.provideDefinition(O,x,C);return T(Q)}}class i{constructor(N,F){this._documents=N,this._provider=F}async provideDeclaration(N,F,C){const O=this._documents.getDocument(N),x=b.Position.to(F),Q=await this._provider.provideDeclaration(O,x,C);return T(Q)}}class c{constructor(N,F){this._documents=N,this._provider=F}async provideImplementation(N,F,C){const O=this._documents.getDocument(N),x=b.Position.to(F),Q=await this._provider.provideImplementation(O,x,C);return T(Q)}}class t{constructor(N,F){this._documents=N,this._provider=F}async provideTypeDefinition(N,F,C){const O=this._documents.getDocument(N),x=b.Position.to(F),Q=await this._provider.provideTypeDefinition(O,x,C);return T(Q)}}class o{constructor(N,F){this._documents=N,this._provider=F}async provideHover(N,F,C){const O=this._documents.getDocument(N),x=b.Position.to(F),Q=await this._provider.provideHover(O,x,C);if(!(!Q||(0,M.isFalsyOrEmpty)(Q.contents)))return Q.range||(Q.range=O.getWordRangeAtPosition(x)),Q.range||(Q.range=new B.Range(x,x)),b.Hover.from(Q)}}class g{constructor(N,F){this._documents=N,this._provider=F}async provideEvaluatableExpression(N,F,C){const O=this._documents.getDocument(N),x=b.Position.to(F),Q=await this._provider.provideEvaluatableExpression(O,x,C);if(Q)return b.EvaluatableExpression.from(Q)}}class h{constructor(N,F){this._documents=N,this._provider=F}async provideInlineValues(N,F,C,O){const x=this._documents.getDocument(N),Q=await this._provider.provideInlineValues(x,b.Range.to(F),b.InlineValueContext.to(C),O);if(Array.isArray(Q))return Q.map(re=>b.InlineValue.from(re))}}class _{constructor(N,F){this._documents=N,this._provider=F}async provideDocumentHighlights(N,F,C){const O=this._documents.getDocument(N),x=b.Position.to(F),Q=await this._provider.provideDocumentHighlights(O,x,C);if(Array.isArray(Q))return Q.map(b.DocumentHighlight.from)}}class P{constructor(N,F){this._documents=N,this._provider=F}async provideLinkedEditingRanges(N,F,C){const O=this._documents.getDocument(N),x=b.Position.to(F),Q=await this._provider.provideLinkedEditingRanges(O,x,C);if(Q&&Array.isArray(Q.ranges))return{ranges:(0,M.coalesce)(Q.ranges.map(b.Range.from)),wordPattern:Q.wordPattern}}}class R{constructor(N,F){this._documents=N,this._provider=F}async provideReferences(N,F,C,O){const x=this._documents.getDocument(N),Q=b.Position.to(F),re=await this._provider.provideReferences(x,Q,C,O);if(Array.isArray(re))return re.map(b.location.from)}}class W{constructor(N,F,C,O,x,Q,re){this._documents=N,this._commands=F,this._diagnostics=C,this._provider=O,this._logService=x,this._extension=Q,this._apiDeprecation=re,this._cache=new f.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(N,F,C,O){const x=this._documents.getDocument(N),Q=v.Selection.isISelection(F)?b.Selection.to(F):b.Range.to(F),re=[];for(const xe of this._diagnostics.getDiagnostics(N))if(Q.intersection(xe.range)&&re.push(xe)>W._maxCodeActionsPerFile)break;const ve={diagnostics:re,only:C.only?new B.CodeActionKind(C.only):void 0,triggerKind:b.CodeActionTriggerKind.to(C.trigger)},Ie=await this._provider.provideCodeActions(x,Q,ve,O);if(!(0,M.isNonEmptyArray)(Ie)||O.isCancellationRequested)return;const Me=this._cache.add(Ie),Le=new m.DisposableStore;this._disposables.set(Me,Le);const ze=[];for(let xe=0;xe<Ie.length;xe++){const Re=Ie[xe];!Re||(W._isCommand(Re)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),ze.push({_isSynthetic:!0,title:Re.title,command:this._commands.toInternal(Re,Le)})):(ve.only&&(Re.kind?ve.only.contains(Re.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${ve.only.value} 'requested but returned code action is of kind '${Re.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${ve.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),ze.push({cacheId:[Me,xe],title:Re.title,command:Re.command&&this._commands.toInternal(Re.command,Le),diagnostics:Re.diagnostics&&Re.diagnostics.map(b.Diagnostic.from),edit:Re.edit&&b.WorkspaceEdit.from(Re.edit),kind:Re.kind&&Re.kind.value,isPreferred:Re.isPreferred,disabled:Re.disabled?.reason})))}return{cacheId:Me,actions:ze}}async resolveCodeAction(N,F){const[C,O]=N,x=this._cache.get(C,O);if(!x||W._isCommand(x)||!this._provider.resolveCodeAction)return;const Q=await this._provider.resolveCodeAction(x,F)??x;return Q?.edit?b.WorkspaceEdit.from(Q.edit):void 0}releaseCodeActions(N){this._disposables.get(N)?.dispose(),this._disposables.delete(N),this._cache.delete(N)}static _isCommand(N){return typeof N.command=="string"&&typeof N.title=="string"}}W._maxCodeActionsPerFile=1e3;class E{constructor(N,F){this._documents=N,this._provider=F}async provideDocumentFormattingEdits(N,F,C){const O=this._documents.getDocument(N),x=await this._provider.provideDocumentFormattingEdits(O,F,C);if(Array.isArray(x))return x.map(b.TextEdit.from)}}class H{constructor(N,F){this._documents=N,this._provider=F}async provideDocumentRangeFormattingEdits(N,F,C,O){const x=this._documents.getDocument(N),Q=b.Range.to(F),re=await this._provider.provideDocumentRangeFormattingEdits(x,Q,C,O);if(Array.isArray(re))return re.map(b.TextEdit.from)}}class z{constructor(N,F){this._documents=N,this._provider=F,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(N,F,C,O,x){const Q=this._documents.getDocument(N),re=b.Position.to(F),ve=await this._provider.provideOnTypeFormattingEdits(Q,re,C,O,x);if(Array.isArray(ve))return ve.map(b.TextEdit.from)}}class q{constructor(N,F){this._provider=N,this._logService=F,this._cache=new f.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(N,F){const C=await this._provider.provideWorkspaceSymbols(N,F);if(!(0,M.isNonEmptyArray)(C))return{symbols:[]};const O=this._cache.add(C),x={cacheId:O,symbols:[]};for(let Q=0;Q<C.length;Q++){const re=C[Q];if(!re||!re.name){this._logService.warn("INVALID SymbolInformation",re);continue}x.symbols.push({...b.WorkspaceSymbol.from(re),cacheId:[O,Q]})}return x}async resolveWorkspaceSymbol(N,F){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!N.cacheId)return N;const C=this._cache.get(...N.cacheId);if(C){const O=await this._provider.resolveWorkspaceSymbol(C,F);return O&&(0,I.mixin)(N,b.WorkspaceSymbol.from(O),!0)}}releaseWorkspaceSymbols(N){this._cache.delete(N)}}class G{constructor(N,F,C){this._documents=N,this._provider=F,this._logService=C}static supportsResolving(N){return typeof N.prepareRename=="function"}async provideRenameEdits(N,F,C,O){const x=this._documents.getDocument(N),Q=b.Position.to(F);try{const re=await this._provider.provideRenameEdits(x,Q,C,O);return re?b.WorkspaceEdit.from(re):void 0}catch(re){const ve=G._asMessage(re);return ve?{rejectReason:ve,edits:void 0}:Promise.reject(re)}}async resolveRenameLocation(N,F,C){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const O=this._documents.getDocument(N),x=b.Position.to(F);try{const Q=await this._provider.prepareRename(O,x,C);let re,ve;if(B.Range.isRange(Q)?(re=Q,ve=O.getText(Q)):(0,L.isObject)(Q)&&(re=Q.range,ve=Q.placeholder),!re||!ve)return;if(re.start.line>x.line||re.end.line<x.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:b.Range.from(re),text:ve}}catch(Q){const re=G._asMessage(Q);return re?{rejectReason:re,range:void 0,text:void 0}:Promise.reject(Q)}}static _asMessage(N){return typeof N=="string"?N:N instanceof Error&&typeof N.message=="string"?N.message:void 0}}class j{constructor(N,F){this.resultId=N,this.tokens=F}}class ${constructor(N,F){this._documents=N,this._provider=F,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(N,F,C){const O=this._documents.getDocument(N),x=F!==0?this._previousResults.get(F):null;let Q=typeof x?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(O,x.resultId,C):await this._provider.provideDocumentSemanticTokens(O,C);return x&&this._previousResults.delete(F),Q?(Q=$._fixProvidedSemanticTokens(Q),this._send($._convertToEdits(x,Q),Q)):null}async releaseDocumentSemanticColoring(N){this._previousResults.delete(N)}static _fixProvidedSemanticTokens(N){return $._isSemanticTokens(N)?$._isCorrectSemanticTokens(N)?N:new B.SemanticTokens(new Uint32Array(N.data),N.resultId):$._isSemanticTokensEdits(N)?$._isCorrectSemanticTokensEdits(N)?N:new B.SemanticTokensEdits(N.edits.map(F=>new B.SemanticTokensEdit(F.start,F.deleteCount,F.data?new Uint32Array(F.data):F.data)),N.resultId):N}static _isSemanticTokens(N){return N&&!!N.data}static _isCorrectSemanticTokens(N){return N.data instanceof Uint32Array}static _isSemanticTokensEdits(N){return N&&Array.isArray(N.edits)}static _isCorrectSemanticTokensEdits(N){for(const F of N.edits)if(!(F.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(N,F){if(!$._isSemanticTokens(F)||!N||!N.tokens)return F;const C=N.tokens,O=C.length,x=F.data,Q=x.length;let re=0;const ve=Math.min(O,Q);for(;re<ve&&C[re]===x[re];)re++;if(re===O&&re===Q)return new B.SemanticTokensEdits([],F.resultId);let Ie=0;const Me=ve-re;for(;Ie<Me&&C[O-Ie-1]===x[Q-Ie-1];)Ie++;return new B.SemanticTokensEdits([{start:re,deleteCount:O-re-Ie,data:x.subarray(re,Q-Ie)}],F.resultId)}_send(N,F){if($._isSemanticTokens(N)){const C=this._nextResultId++;return this._previousResults.set(C,new j(N.resultId,N.data)),(0,l.encodeSemanticTokensDto)({id:C,type:"full",data:N.data})}if($._isSemanticTokensEdits(N)){const C=this._nextResultId++;return $._isSemanticTokens(F)?this._previousResults.set(C,new j(F.resultId,F.data)):this._previousResults.set(C,new j(N.resultId)),(0,l.encodeSemanticTokensDto)({id:C,type:"delta",deltas:(N.edits||[]).map(O=>({start:O.start,deleteCount:O.deleteCount,data:O.data}))})}return null}}e.DocumentSemanticTokensAdapter=$;class ee{constructor(N,F){this._documents=N,this._provider=F}async provideDocumentRangeSemanticTokens(N,F,C){const O=this._documents.getDocument(N),x=await this._provider.provideDocumentRangeSemanticTokens(O,b.Range.to(F),C);return x?this._send(x):null}_send(N){return(0,l.encodeSemanticTokensDto)({id:0,type:"full",data:N.data})}}e.DocumentRangeSemanticTokensAdapter=ee;class se{constructor(N,F,C,O,x){this._documents=N,this._commands=F,this._provider=C,this._apiDeprecation=O,this._extension=x,this._cache=new f.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(N){return typeof N.resolveCompletionItem=="function"}async provideCompletionItems(N,F,C,O){const x=this._documents.getDocument(N),Q=b.Position.to(F),re=x.getWordRangeAtPosition(Q)||new B.Range(Q,Q),ve=re.with({end:Q}),Ie=new S.StopWatch(!0),Me=await this._provider.provideCompletionItems(x,Q,O,b.CompletionContext.to(C));if(!Me||O.isCancellationRequested)return;const Le=Array.isArray(Me)?new B.CompletionList(Me):Me,ze=se.supportsResolving(this._provider)?this._cache.add(Le.items):this._cache.add([]),xe=new m.DisposableStore;this._disposables.set(ze,xe);const Re=[],Qe={x:ze,b:Re,a:{replace:b.Range.from(re),insert:b.Range.from(ve)},c:Le.isIncomplete||void 0,d:Ie.elapsed()};for(let tt=0;tt<Le.items.length;tt++){const Te=Le.items[tt],it=this._convertCompletionItem(Te,[ze,tt],ve,re);Re.push(it)}return Qe}async resolveCompletionItem(N,F){if(typeof this._provider.resolveCompletionItem!="function")return;const C=this._cache.get(...N);if(!C)return;const O=await this._provider.resolveCompletionItem(C,F);if(!!O)return this._convertCompletionItem(O,N)}releaseCompletionItems(N){this._disposables.get(N)?.dispose(),this._disposables.delete(N),this._cache.delete(N)}_convertCompletionItem(N,F,C,O){const x=this._disposables.get(F[0]);if(!x)throw Error("DisposableStore is missing...");const Q={x:F,a:N.label,b:N.kind!==void 0?b.CompletionItemKind.from(N.kind):void 0,n:N.tags&&N.tags.map(b.CompletionItemTag.from),c:N.detail,d:typeof N.documentation=="undefined"?void 0:b.MarkdownString.fromStrict(N.documentation),e:N.sortText!==N.label?N.sortText:void 0,f:N.filterText!==N.label?N.filterText:void 0,g:N.preselect||void 0,i:N.keepWhitespace?1:0,k:N.commitCharacters,l:N.additionalTextEdits&&N.additionalTextEdits.map(b.TextEdit.from),m:this._commands.toInternal(N.command,x)};N.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Q.h=N.textEdit.newText):typeof N.insertText=="string"?Q.h=N.insertText:N.insertText instanceof B.SnippetString&&(Q.h=N.insertText.value,Q.i|=4);let re;return N.textEdit?re=N.textEdit.range:N.range&&(re=N.range),B.Range.isRange(re)?Q.j=b.Range.from(re):re&&(!C?.isEqual(re.inserting)||!O?.isEqual(re.replacing))&&(Q.j={insert:b.Range.from(re.inserting),replace:b.Range.from(re.replacing)}),Q}}class Z{constructor(N,F,C){this._documents=N,this._provider=F,this._commands=C,this._cache=new f.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(N,F,C,O){const x=this._documents.getDocument(N),Q=b.Position.to(F),re=await this._provider.provideInlineCompletionItems(x,Q,{selectedCompletionInfo:C.selectedSuggestionInfo?{range:b.Range.to(C.selectedSuggestionInfo.range),text:C.selectedSuggestionInfo.text,isSnippetText:C.selectedSuggestionInfo.isSnippetText,completionKind:b.CompletionItemKind.to(C.selectedSuggestionInfo.completionKind)}:void 0,triggerKind:C.triggerKind},O);if(!re||O.isCancellationRequested)return;const ve=(0,L.isArray)(re)?re:re.items,Ie=this._cache.add(ve);let Me;return{pid:Ie,items:ve.map((Le,ze)=>{let xe;Le.command&&(Me||(Me=new m.DisposableStore,this._disposables.set(Ie,Me)),xe=this._commands.toInternal(Le.command,Me));const Re=Le.insertText??Le.text;if(Re===void 0)throw new Error("text or insertText must be defined");return{text:Re,range:Le.range?b.Range.from(Le.range):void 0,command:xe,idx:ze,completeBracketPairs:Le.completeBracketPairs}})}}disposeCompletions(N){this._cache.delete(N);const F=this._disposables.get(N);F&&F.clear(),this._disposables.delete(N)}handleDidShowCompletionItem(N,F){const C=this._cache.get(N,F);C&&le.get(this._provider).fireOnDidShowCompletionItem({completionItem:C})}}class le{constructor(){this._onDidShowCompletionItemEmitter=new d.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(N){let F=le.map.get(N);return F||(F=new le,le.map.set(N,F)),F}fireOnDidShowCompletionItem(N){this._onDidShowCompletionItemEmitter.fire(N)}}e.InlineCompletionController=le,le.map=new WeakMap;class ue{constructor(N,F){this._documents=N,this._provider=F,this._cache=new f.Cache("SignatureHelp")}async provideSignatureHelp(N,F,C,O){const x=this._documents.getDocument(N),Q=b.Position.to(F),re=this.reviveContext(C),ve=await this._provider.provideSignatureHelp(x,Q,O,re);if(ve){const Ie=this._cache.add([ve]);return{...b.SignatureHelp.from(ve),id:Ie}}}reviveContext(N){let F;if(N.activeSignatureHelp){const C=b.SignatureHelp.to(N.activeSignatureHelp),O=this._cache.get(N.activeSignatureHelp.id,0);O?(F=O,F.activeSignature=C.activeSignature,F.activeParameter=C.activeParameter):F=C}return{...N,activeSignatureHelp:F}}releaseSignatureHelp(N){this._cache.delete(N)}}class Se{constructor(N,F,C,O,x){this._documents=N,this._commands=F,this._provider=C,this._logService=O,this._extension=x,this._cache=new f.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(N,F,C){const O=this._documents.getDocument(N),x=b.Range.to(F),Q=await this._provider.provideInlayHints(O,x,C);if(!Array.isArray(Q)||Q.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${F}`);return}if(C.isCancellationRequested)return;const re=this._cache.add(Q);this._disposables.set(re,new m.DisposableStore);const ve={hints:[],cacheId:re};for(let Ie=0;Ie<Q.length;Ie++)this._isValidInlayHint(Q[Ie],x)&&ve.hints.push(this._convertInlayHint(Q[Ie],[re,Ie]));return this._logService.trace(`[InlayHints] ${ve.hints.length} inlay hints from '${this._extension.identifier.value}' for ${F}`),ve}async resolveInlayHint(N,F){if(typeof this._provider.resolveInlayHint!="function")return;const C=this._cache.get(...N);if(!C)return;const O=await this._provider.resolveInlayHint(C,F);if(!!O&&!!this._isValidInlayHint(O))return this._convertInlayHint(O,N)}releaseHints(N){this._disposables.get(N)?.dispose(),this._disposables.delete(N),this._cache.delete(N)}_isValidInlayHint(N,F){return N.label.length===0||Array.isArray(N.label)&&N.label.every(C=>C.value.length===0)?(console.log("INVALID inlay hint, empty label",N),!1):!(F&&!F.contains(N.position))}_convertInlayHint(N,F){const C=this._disposables.get(F[0]);if(!C)throw Error("DisposableStore is missing...");const O={label:"",cacheId:F,tooltip:b.MarkdownString.fromStrict(N.tooltip),position:b.Position.from(N.position),textEdits:N.textEdits&&N.textEdits.map(b.TextEdit.from),kind:N.kind&&b.InlayHintKind.from(N.kind),paddingLeft:N.paddingLeft,paddingRight:N.paddingRight};return typeof N.label=="string"?O.label=N.label:O.label=N.label.map(x=>{let Q={label:x.value};return Q.tooltip=b.MarkdownString.fromStrict(x.tooltip),B.Location.isLocation(x.location)&&(Q.location=b.location.from(x.location)),x.command&&(Q.command=this._commands.toInternal(x.command,C)),Q}),O}}class fe{constructor(N,F){this._documents=N,this._provider=F,this._cache=new f.Cache("DocumentLink")}async provideLinks(N,F){const C=this._documents.getDocument(N),O=await this._provider.provideDocumentLinks(C,F);if(!(!Array.isArray(O)||O.length===0)&&!F.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:O.filter(fe._validateLink).map(b.DocumentLink.from)};{const x=this._cache.add(O),Q={links:[],cacheId:x};for(let re=0;re<O.length;re++){if(!fe._validateLink(O[re]))continue;const ve=b.DocumentLink.from(O[re]);ve.cacheId=[x,re],Q.links.push(ve)}return Q}}}static _validateLink(N){return N.target&&N.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(N,F){if(typeof this._provider.resolveDocumentLink!="function")return;const C=this._cache.get(...N);if(!C)return;const O=await this._provider.resolveDocumentLink(C,F);if(!(!O||!fe._validateLink(O)))return b.DocumentLink.from(O)}releaseLinks(N){this._cache.delete(N)}}class ne{constructor(N,F){this._documents=N,this._provider=F}async provideColors(N,F){const C=this._documents.getDocument(N),O=await this._provider.provideDocumentColors(C,F);return Array.isArray(O)?O.map(Q=>({color:b.Color.from(Q.color),range:b.Range.from(Q.range)})):[]}async provideColorPresentations(N,F,C){const O=this._documents.getDocument(N),x=b.Range.to(F.range),Q=b.Color.to(F.color),re=await this._provider.provideColorPresentations(Q,{document:O,range:x},C);if(!!Array.isArray(re))return re.map(b.ColorPresentation.from)}}class me{constructor(N,F){this._documents=N,this._provider=F}async provideFoldingRanges(N,F,C){const O=this._documents.getDocument(N),x=await this._provider.provideFoldingRanges(O,F,C);if(!!Array.isArray(x))return x.map(b.FoldingRange.from)}}class ke{constructor(N,F,C){this._documents=N,this._provider=F,this._logService=C}async provideSelectionRanges(N,F,C){const O=this._documents.getDocument(N),x=F.map(b.Position.to),Q=await this._provider.provideSelectionRanges(O,x,C);if(!(0,M.isNonEmptyArray)(Q))return[];if(Q.length!==x.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const re=[];for(let ve=0;ve<x.length;ve++){const Ie=[];re.push(Ie);let Me=x[ve],Le=Q[ve];for(;;){if(!Le.range.contains(Me))throw new Error("INVALID selection range, must contain the previous range");if(Ie.push(b.SelectionRange.from(Le)),!Le.parent)break;Me=Le.range,Le=Le.parent}}return re}}class Ae{constructor(N,F){this._documents=N,this._provider=F,this._idPool=new n.IdGenerator(""),this._cache=new Map}async prepareSession(N,F,C){const O=this._documents.getDocument(N),x=b.Position.to(F),Q=await this._provider.prepareCallHierarchy(O,x,C);if(!Q)return;const re=this._idPool.nextId();return this._cache.set(re,new Map),Array.isArray(Q)?Q.map(ve=>this._cacheAndConvertItem(re,ve)):[this._cacheAndConvertItem(re,Q)]}async provideCallsTo(N,F,C){const O=this._itemFromCache(N,F);if(!O)throw new Error("missing call hierarchy item");const x=await this._provider.provideCallHierarchyIncomingCalls(O,C);if(!!x)return x.map(Q=>({from:this._cacheAndConvertItem(N,Q.from),fromRanges:Q.fromRanges.map(re=>b.Range.from(re))}))}async provideCallsFrom(N,F,C){const O=this._itemFromCache(N,F);if(!O)throw new Error("missing call hierarchy item");const x=await this._provider.provideCallHierarchyOutgoingCalls(O,C);if(!!x)return x.map(Q=>({to:this._cacheAndConvertItem(N,Q.to),fromRanges:Q.fromRanges.map(re=>b.Range.from(re))}))}releaseSession(N){this._cache.delete(N)}_cacheAndConvertItem(N,F){const C=this._cache.get(N),O=b.CallHierarchyItem.from(F,N,C.size.toString(36));return C.set(O._itemId,F),O}_itemFromCache(N,F){return this._cache.get(N)?.get(F)}}class Be{constructor(N,F){this._documents=N,this._provider=F,this._idPool=new n.IdGenerator(""),this._cache=new Map}async prepareSession(N,F,C){const O=this._documents.getDocument(N),x=b.Position.to(F),Q=await this._provider.prepareTypeHierarchy(O,x,C);if(!Q)return;const re=this._idPool.nextId();return this._cache.set(re,new Map),Array.isArray(Q)?Q.map(ve=>this._cacheAndConvertItem(re,ve)):[this._cacheAndConvertItem(re,Q)]}async provideSupertypes(N,F,C){const O=this._itemFromCache(N,F);if(!O)throw new Error("missing type hierarchy item");const x=await this._provider.provideTypeHierarchySupertypes(O,C);if(!!x)return x.map(Q=>this._cacheAndConvertItem(N,Q))}async provideSubtypes(N,F,C){const O=this._itemFromCache(N,F);if(!O)throw new Error("missing type hierarchy item");const x=await this._provider.provideTypeHierarchySubtypes(O,C);if(!!x)return x.map(Q=>this._cacheAndConvertItem(N,Q))}releaseSession(N){this._cache.delete(N)}_cacheAndConvertItem(N,F){const C=this._cache.get(N),O=b.TypeHierarchyItem.from(F,N,C.size.toString(36));return C.set(O._itemId,F),O}_itemFromCache(N,F){return this._cache.get(N)?.get(F)}}class Xe{constructor(N,F){this.adapter=N,this.extension=F}}class ge{constructor(N,F,C,O,x,Q,re){this._adapter=new Map,this._uriTransformer=F,this._proxy=N.getProxy(D.MainContext.MainThreadLanguageFeatures),this._documents=C,this._commands=O,this._diagnostics=x,this._logService=Q,this._apiDeprecation=re}_transformDocumentSelector(N){return b.DocumentSelector.from(N,this._uriTransformer)}_createDisposable(N){return new B.Disposable(()=>{this._adapter.delete(N),this._proxy.$unregister(N)})}_nextHandle(){return ge._handlePool++}async _withAdapter(N,F,C,O,x){const Q=this._adapter.get(N);if(!Q||!(Q.adapter instanceof F))return O;const re=Date.now();this._logService.trace(`[${Q.extension.identifier.value}] INVOKE provider '${C.toString().replace(/[\r\n]/g,"")}'`);const ve=C(Q.adapter,Q.extension);return Promise.resolve(ve).catch(Ie=>{(0,k.isCancellationError)(Ie)||(this._logService.error(`[${Q.extension.identifier.value}] provider FAILED`),this._logService.error(Ie))}).finally(()=>{this._logService.trace(`[${Q.extension.identifier.value}] provider DONE after ${Date.now()-re}ms`)}),u.CancellationToken.isCancellationToken(x)?(0,p.raceCancellationError)(ve,x):ve}_addNewAdapter(N,F){const C=this._nextHandle();return this._adapter.set(C,new Xe(N,F)),C}static _extLabel(N){return N.displayName||N.name}registerDocumentSymbolProvider(N,F,C,O){const x=this._addNewAdapter(new w(this._documents,C),N),Q=O&&O.label||ge._extLabel(N);return this._proxy.$registerDocumentSymbolProvider(x,this._transformDocumentSelector(F),Q),this._createDisposable(x)}$provideDocumentSymbols(N,F,C){return this._withAdapter(N,w,O=>O.provideDocumentSymbols(s.URI.revive(F),C),void 0,C)}registerCodeLensProvider(N,F,C){const O=this._nextHandle(),x=typeof C.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(O,new Xe(new a(this._documents,this._commands.converter,C),N)),this._proxy.$registerCodeLensSupport(O,this._transformDocumentSelector(F),x);let Q=this._createDisposable(O);if(x!==void 0){const re=C.onDidChangeCodeLenses(ve=>this._proxy.$emitCodeLensEvent(x));Q=B.Disposable.from(Q,re)}return Q}$provideCodeLenses(N,F,C){return this._withAdapter(N,a,O=>O.provideCodeLenses(s.URI.revive(F),C),void 0,C)}$resolveCodeLens(N,F,C){return this._withAdapter(N,a,O=>O.resolveCodeLens(F,C),void 0,void 0)}$releaseCodeLenses(N,F){this._withAdapter(N,a,C=>Promise.resolve(C.releaseCodeLenses(F)),void 0,void 0)}registerDefinitionProvider(N,F,C){const O=this._addNewAdapter(new r(this._documents,C),N);return this._proxy.$registerDefinitionSupport(O,this._transformDocumentSelector(F)),this._createDisposable(O)}$provideDefinition(N,F,C,O){return this._withAdapter(N,r,x=>x.provideDefinition(s.URI.revive(F),C,O),[],O)}registerDeclarationProvider(N,F,C){const O=this._addNewAdapter(new i(this._documents,C),N);return this._proxy.$registerDeclarationSupport(O,this._transformDocumentSelector(F)),this._createDisposable(O)}$provideDeclaration(N,F,C,O){return this._withAdapter(N,i,x=>x.provideDeclaration(s.URI.revive(F),C,O),[],O)}registerImplementationProvider(N,F,C){const O=this._addNewAdapter(new c(this._documents,C),N);return this._proxy.$registerImplementationSupport(O,this._transformDocumentSelector(F)),this._createDisposable(O)}$provideImplementation(N,F,C,O){return this._withAdapter(N,c,x=>x.provideImplementation(s.URI.revive(F),C,O),[],O)}registerTypeDefinitionProvider(N,F,C){const O=this._addNewAdapter(new t(this._documents,C),N);return this._proxy.$registerTypeDefinitionSupport(O,this._transformDocumentSelector(F)),this._createDisposable(O)}$provideTypeDefinition(N,F,C,O){return this._withAdapter(N,t,x=>x.provideTypeDefinition(s.URI.revive(F),C,O),[],O)}registerHoverProvider(N,F,C,O){const x=this._addNewAdapter(new o(this._documents,C),N);return this._proxy.$registerHoverProvider(x,this._transformDocumentSelector(F)),this._createDisposable(x)}$provideHover(N,F,C,O){return this._withAdapter(N,o,x=>x.provideHover(s.URI.revive(F),C,O),void 0,O)}registerEvaluatableExpressionProvider(N,F,C,O){const x=this._addNewAdapter(new g(this._documents,C),N);return this._proxy.$registerEvaluatableExpressionProvider(x,this._transformDocumentSelector(F)),this._createDisposable(x)}$provideEvaluatableExpression(N,F,C,O){return this._withAdapter(N,g,x=>x.provideEvaluatableExpression(s.URI.revive(F),C,O),void 0,O)}registerInlineValuesProvider(N,F,C,O){const x=typeof C.onDidChangeInlineValues=="function"?this._nextHandle():void 0,Q=this._addNewAdapter(new h(this._documents,C),N);this._proxy.$registerInlineValuesProvider(Q,this._transformDocumentSelector(F),x);let re=this._createDisposable(Q);if(x!==void 0){const ve=C.onDidChangeInlineValues(Ie=>this._proxy.$emitInlineValuesEvent(x));re=B.Disposable.from(re,ve)}return re}$provideInlineValues(N,F,C,O,x){return this._withAdapter(N,h,Q=>Q.provideInlineValues(s.URI.revive(F),C,O,x),void 0,x)}registerDocumentHighlightProvider(N,F,C){const O=this._addNewAdapter(new _(this._documents,C),N);return this._proxy.$registerDocumentHighlightProvider(O,this._transformDocumentSelector(F)),this._createDisposable(O)}$provideDocumentHighlights(N,F,C,O){return this._withAdapter(N,_,x=>x.provideDocumentHighlights(s.URI.revive(F),C,O),void 0,O)}registerLinkedEditingRangeProvider(N,F,C){const O=this._addNewAdapter(new P(this._documents,C),N);return this._proxy.$registerLinkedEditingRangeProvider(O,this._transformDocumentSelector(F)),this._createDisposable(O)}$provideLinkedEditingRanges(N,F,C,O){return this._withAdapter(N,P,async x=>{const Q=await x.provideLinkedEditingRanges(s.URI.revive(F),C,O);if(Q)return{ranges:Q.ranges,wordPattern:Q.wordPattern?ge._serializeRegExp(Q.wordPattern):void 0}},void 0,O)}registerReferenceProvider(N,F,C){const O=this._addNewAdapter(new R(this._documents,C),N);return this._proxy.$registerReferenceSupport(O,this._transformDocumentSelector(F)),this._createDisposable(O)}$provideReferences(N,F,C,O,x){return this._withAdapter(N,R,Q=>Q.provideReferences(s.URI.revive(F),C,O,x),void 0,x)}registerCodeActionProvider(N,F,C,O){const x=new m.DisposableStore,Q=this._addNewAdapter(new W(this._documents,this._commands.converter,this._diagnostics,C,this._logService,N,this._apiDeprecation),N);return this._proxy.$registerQuickFixSupport(Q,this._transformDocumentSelector(F),{providedKinds:O?.providedCodeActionKinds?.map(re=>re.value),documentation:O?.documentation?.map(re=>({kind:re.kind.value,command:this._commands.converter.toInternal(re.command,x)}))},ge._extLabel(N),Boolean(C.resolveCodeAction)),x.add(this._createDisposable(Q)),x}$provideCodeActions(N,F,C,O,x){return this._withAdapter(N,W,Q=>Q.provideCodeActions(s.URI.revive(F),C,O,x),void 0,x)}$resolveCodeAction(N,F,C){return this._withAdapter(N,W,O=>O.resolveCodeAction(F,C),void 0,void 0)}$releaseCodeActions(N,F){this._withAdapter(N,W,C=>Promise.resolve(C.releaseCodeActions(F)),void 0,void 0)}registerDocumentFormattingEditProvider(N,F,C){const O=this._addNewAdapter(new E(this._documents,C),N);return this._proxy.$registerDocumentFormattingSupport(O,this._transformDocumentSelector(F),N.identifier,N.displayName||N.name),this._createDisposable(O)}$provideDocumentFormattingEdits(N,F,C,O){return this._withAdapter(N,E,x=>x.provideDocumentFormattingEdits(s.URI.revive(F),C,O),void 0,O)}registerDocumentRangeFormattingEditProvider(N,F,C){const O=this._addNewAdapter(new H(this._documents,C),N);return this._proxy.$registerRangeFormattingSupport(O,this._transformDocumentSelector(F),N.identifier,N.displayName||N.name),this._createDisposable(O)}$provideDocumentRangeFormattingEdits(N,F,C,O,x){return this._withAdapter(N,H,Q=>Q.provideDocumentRangeFormattingEdits(s.URI.revive(F),C,O,x),void 0,x)}registerOnTypeFormattingEditProvider(N,F,C,O){const x=this._addNewAdapter(new z(this._documents,C),N);return this._proxy.$registerOnTypeFormattingSupport(x,this._transformDocumentSelector(F),O,N.identifier),this._createDisposable(x)}$provideOnTypeFormattingEdits(N,F,C,O,x,Q){return this._withAdapter(N,z,re=>re.provideOnTypeFormattingEdits(s.URI.revive(F),C,O,x,Q),void 0,Q)}registerWorkspaceSymbolProvider(N,F){const C=this._addNewAdapter(new q(F,this._logService),N);return this._proxy.$registerNavigateTypeSupport(C,typeof F.resolveWorkspaceSymbol=="function"),this._createDisposable(C)}$provideWorkspaceSymbols(N,F,C){return this._withAdapter(N,q,O=>O.provideWorkspaceSymbols(F,C),{symbols:[]},C)}$resolveWorkspaceSymbol(N,F,C){return this._withAdapter(N,q,O=>O.resolveWorkspaceSymbol(F,C),void 0,void 0)}$releaseWorkspaceSymbols(N,F){this._withAdapter(N,q,C=>C.releaseWorkspaceSymbols(F),void 0,void 0)}registerRenameProvider(N,F,C){const O=this._addNewAdapter(new G(this._documents,C,this._logService),N);return this._proxy.$registerRenameSupport(O,this._transformDocumentSelector(F),G.supportsResolving(C)),this._createDisposable(O)}$provideRenameEdits(N,F,C,O,x){return this._withAdapter(N,G,Q=>Q.provideRenameEdits(s.URI.revive(F),C,O,x),void 0,x)}$resolveRenameLocation(N,F,C,O){return this._withAdapter(N,G,x=>x.resolveRenameLocation(s.URI.revive(F),C,O),void 0,O)}registerDocumentSemanticTokensProvider(N,F,C,O){const x=this._addNewAdapter(new $(this._documents,C),N),Q=typeof C.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(x,this._transformDocumentSelector(F),O,Q);let re=this._createDisposable(x);if(Q){const ve=C.onDidChangeSemanticTokens(Ie=>this._proxy.$emitDocumentSemanticTokensEvent(Q));re=B.Disposable.from(re,ve)}return re}$provideDocumentSemanticTokens(N,F,C,O){return this._withAdapter(N,$,x=>x.provideDocumentSemanticTokens(s.URI.revive(F),C,O),null,O)}$releaseDocumentSemanticTokens(N,F){this._withAdapter(N,$,C=>C.releaseDocumentSemanticColoring(F),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(N,F,C,O){const x=this._addNewAdapter(new ee(this._documents,C),N);return this._proxy.$registerDocumentRangeSemanticTokensProvider(x,this._transformDocumentSelector(F),O),this._createDisposable(x)}$provideDocumentRangeSemanticTokens(N,F,C,O){return this._withAdapter(N,ee,x=>x.provideDocumentRangeSemanticTokens(s.URI.revive(F),C,O),null,O)}registerCompletionItemProvider(N,F,C,O){const x=this._addNewAdapter(new se(this._documents,this._commands.converter,C,this._apiDeprecation,N),N);return this._proxy.$registerSuggestSupport(x,this._transformDocumentSelector(F),O,se.supportsResolving(C),`${N.identifier.value}(${O.join("")})`),this._createDisposable(x)}$provideCompletionItems(N,F,C,O,x){return this._withAdapter(N,se,Q=>Q.provideCompletionItems(s.URI.revive(F),C,O,x),void 0,x)}$resolveCompletionItem(N,F,C){return this._withAdapter(N,se,O=>O.resolveCompletionItem(F,C),void 0,C)}$releaseCompletionItems(N,F){this._withAdapter(N,se,C=>C.releaseCompletionItems(F),void 0,void 0)}registerInlineCompletionsProvider(N,F,C){const O=this._addNewAdapter(new Z(this._documents,C,this._commands.converter),N);return this._proxy.$registerInlineCompletionsSupport(O,this._transformDocumentSelector(F)),this._createDisposable(O)}$provideInlineCompletions(N,F,C,O,x){return this._withAdapter(N,Z,Q=>Q.provideInlineCompletions(s.URI.revive(F),C,O,x),void 0,x)}$handleInlineCompletionDidShow(N,F,C){this._withAdapter(N,Z,async O=>{O.handleDidShowCompletionItem(F,C)},void 0,void 0)}$freeInlineCompletionsList(N,F){this._withAdapter(N,Z,async C=>{C.disposeCompletions(F)},void 0,void 0)}registerSignatureHelpProvider(N,F,C,O){const x=Array.isArray(O)?{triggerCharacters:O,retriggerCharacters:[]}:O,Q=this._addNewAdapter(new ue(this._documents,C),N);return this._proxy.$registerSignatureHelpProvider(Q,this._transformDocumentSelector(F),x),this._createDisposable(Q)}$provideSignatureHelp(N,F,C,O,x){return this._withAdapter(N,ue,Q=>Q.provideSignatureHelp(s.URI.revive(F),C,O,x),void 0,x)}$releaseSignatureHelp(N,F){this._withAdapter(N,ue,C=>C.releaseSignatureHelp(F),void 0,void 0)}registerInlayHintsProvider(N,F,C){const O=typeof C.onDidChangeInlayHints=="function"?this._nextHandle():void 0,x=this._addNewAdapter(new Se(this._documents,this._commands.converter,C,this._logService,N),N);this._proxy.$registerInlayHintsProvider(x,this._transformDocumentSelector(F),typeof C.resolveInlayHint=="function",O,ge._extLabel(N));let Q=this._createDisposable(x);if(O!==void 0){const re=C.onDidChangeInlayHints(ve=>this._proxy.$emitInlayHintsEvent(O));Q=B.Disposable.from(Q,re)}return Q}$provideInlayHints(N,F,C,O){return this._withAdapter(N,Se,x=>x.provideInlayHints(s.URI.revive(F),C,O),void 0,O)}$resolveInlayHint(N,F,C){return this._withAdapter(N,Se,O=>O.resolveInlayHint(F,C),void 0,C)}$releaseInlayHints(N,F){this._withAdapter(N,Se,C=>C.releaseHints(F),void 0,void 0)}registerDocumentLinkProvider(N,F,C){const O=this._addNewAdapter(new fe(this._documents,C),N);return this._proxy.$registerDocumentLinkProvider(O,this._transformDocumentSelector(F),typeof C.resolveDocumentLink=="function"),this._createDisposable(O)}$provideDocumentLinks(N,F,C){return this._withAdapter(N,fe,O=>O.provideLinks(s.URI.revive(F),C),void 0,C)}$resolveDocumentLink(N,F,C){return this._withAdapter(N,fe,O=>O.resolveLink(F,C),void 0,void 0)}$releaseDocumentLinks(N,F){this._withAdapter(N,fe,C=>C.releaseLinks(F),void 0,void 0)}registerColorProvider(N,F,C){const O=this._addNewAdapter(new ne(this._documents,C),N);return this._proxy.$registerDocumentColorProvider(O,this._transformDocumentSelector(F)),this._createDisposable(O)}$provideDocumentColors(N,F,C){return this._withAdapter(N,ne,O=>O.provideColors(s.URI.revive(F),C),[],C)}$provideColorPresentations(N,F,C,O){return this._withAdapter(N,ne,x=>x.provideColorPresentations(s.URI.revive(F),C,O),void 0,O)}registerFoldingRangeProvider(N,F,C){const O=this._nextHandle(),x=typeof C.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(O,new Xe(new me(this._documents,C),N)),this._proxy.$registerFoldingRangeProvider(O,this._transformDocumentSelector(F),x);let Q=this._createDisposable(O);if(x!==void 0){const re=C.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(x));Q=B.Disposable.from(Q,re)}return Q}$provideFoldingRanges(N,F,C,O){return this._withAdapter(N,me,x=>x.provideFoldingRanges(s.URI.revive(F),C,O),void 0,O)}registerSelectionRangeProvider(N,F,C){const O=this._addNewAdapter(new ke(this._documents,C,this._logService),N);return this._proxy.$registerSelectionRangeProvider(O,this._transformDocumentSelector(F)),this._createDisposable(O)}$provideSelectionRanges(N,F,C,O){return this._withAdapter(N,ke,x=>x.provideSelectionRanges(s.URI.revive(F),C,O),[],O)}registerCallHierarchyProvider(N,F,C){const O=this._addNewAdapter(new Ae(this._documents,C),N);return this._proxy.$registerCallHierarchyProvider(O,this._transformDocumentSelector(F)),this._createDisposable(O)}$prepareCallHierarchy(N,F,C,O){return this._withAdapter(N,Ae,x=>Promise.resolve(x.prepareSession(s.URI.revive(F),C,O)),void 0,O)}$provideCallHierarchyIncomingCalls(N,F,C,O){return this._withAdapter(N,Ae,x=>x.provideCallsTo(F,C,O),void 0,O)}$provideCallHierarchyOutgoingCalls(N,F,C,O){return this._withAdapter(N,Ae,x=>x.provideCallsFrom(F,C,O),void 0,O)}$releaseCallHierarchy(N,F){this._withAdapter(N,Ae,C=>Promise.resolve(C.releaseSession(F)),void 0,void 0)}registerTypeHierarchyProvider(N,F,C){const O=this._addNewAdapter(new Be(this._documents,C),N);return this._proxy.$registerTypeHierarchyProvider(O,this._transformDocumentSelector(F)),this._createDisposable(O)}$prepareTypeHierarchy(N,F,C,O){return this._withAdapter(N,Be,x=>Promise.resolve(x.prepareSession(s.URI.revive(F),C,O)),void 0,O)}$provideTypeHierarchySupertypes(N,F,C,O){return this._withAdapter(N,Be,x=>x.provideSupertypes(F,C,O),void 0,O)}$provideTypeHierarchySubtypes(N,F,C,O){return this._withAdapter(N,Be,x=>x.provideSubtypes(F,C,O),void 0,O)}$releaseTypeHierarchy(N,F){this._withAdapter(N,Be,C=>Promise.resolve(C.releaseSession(F)),void 0,void 0)}static _serializeRegExp(N){return{pattern:N.source,flags:(0,A.regExpFlags)(N)}}static _serializeIndentationRule(N){return{decreaseIndentPattern:ge._serializeRegExp(N.decreaseIndentPattern),increaseIndentPattern:ge._serializeRegExp(N.increaseIndentPattern),indentNextLinePattern:N.indentNextLinePattern?ge._serializeRegExp(N.indentNextLinePattern):void 0,unIndentedLinePattern:N.unIndentedLinePattern?ge._serializeRegExp(N.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(N){return{beforeText:ge._serializeRegExp(N.beforeText),afterText:N.afterText?ge._serializeRegExp(N.afterText):void 0,previousLineText:N.previousLineText?ge._serializeRegExp(N.previousLineText):void 0,action:N.action}}static _serializeOnEnterRules(N){return N.map(ge._serializeOnEnterRule)}setLanguageConfiguration(N,F,C){let{wordPattern:O}=C;if(O&&(0,A.regExpLeadsToEndlessLoop)(O))throw new Error(`Invalid language configuration: wordPattern '${O}' is not allowed to match the empty string.`);O?this._documents.setWordDefinitionFor(F,O):this._documents.setWordDefinitionFor(F,void 0),C.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",N,"Do not use."),C.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",N,"Do not use.");const x=this._nextHandle(),Q={comments:C.comments,brackets:C.brackets,wordPattern:C.wordPattern?ge._serializeRegExp(C.wordPattern):void 0,indentationRules:C.indentationRules?ge._serializeIndentationRule(C.indentationRules):void 0,onEnterRules:C.onEnterRules?ge._serializeOnEnterRules(C.onEnterRules):void 0,__electricCharacterSupport:C.__electricCharacterSupport,__characterPairSupport:C.__characterPairSupport};return this._proxy.$setLanguageConfiguration(x,F,Q),this._createDisposable(x)}$setWordDefinitions(N){for(const F of N)this._documents.setWordDefinitionFor(F.languageId,new RegExp(F.regexSource,F.regexFlags))}}e.ExtHostLanguageFeatures=ge,ge._handlePool=0}),define(Ee[192],we([1,0,4,8,7,34,13,6]),function(J,e,s,I,b,B,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class y{constructor(L,v,u,m){this._documents=v,this._commands=u,this._uriTransformer=m,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=L.getProxy(s.MainContext.MainThreadLanguages)}$acceptLanguageIds(L){this._languageIds=L}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(L,v){await this._proxy.$changeLanguage(L,v);const u=this._documents.getDocumentData(L);if(!u)throw new Error(`document '${L.toString()}' NOT found`);return u.document}async tokenAtPosition(L,v){const u=L.version,m=I.Position.from(v),l=await this._proxy.$tokensAtPosition(L.uri,m),n={type:b.StandardTokenType.Other,range:L.getWordRangeAtPosition(v)??new b.Range(v.line,v.character,v.line,v.character)};if(!l)return n;const f={range:I.Range.to(l.range),type:I.TokenType.to(l.type)};return!f.range.contains(v)||u!==L.version?n:f}createLanguageStatusItem(L,v,u){const m=this._handlePool++,l=this._proxy,n=this._ids,f=`${L.identifier.value}/${v}`;if(n.has(f))throw new Error(`LanguageStatusItem with id '${v}' ALREADY exists`);n.add(f);const S={selector:u,id:v,name:L.displayName??L.name,severity:b.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let k,d=new A.DisposableStore;const p=()=>{k?.dispose(),k=(0,D.disposableTimeout)(()=>{d.clear(),this._proxy.$setLanguageStatus(m,{id:f,name:S.name??L.displayName??L.name,source:L.displayName??L.name,selector:I.DocumentSelector.from(S.selector,this._uriTransformer),label:S.text,detail:S.detail??"",severity:S.severity===b.LanguageStatusSeverity.Error?B.default.Error:S.severity===b.LanguageStatusSeverity.Warning?B.default.Warning:B.default.Info,command:S.command&&this._commands.toInternal(S.command,d),accessibilityInfo:S.accessibilityInformation,busy:S.busy})},0)},w={dispose(){d.dispose(),k?.dispose(),l.$removeLanguageStatus(m),n.delete(f)},get id(){return S.id},get name(){return S.name},set name(a){S.name=a,p()},get selector(){return S.selector},set selector(a){S.selector=a,p()},get text(){return S.text},set text(a){S.text=a,p()},get detail(){return S.detail},set detail(a){S.detail=a,p()},get severity(){return S.severity},set severity(a){S.severity=a,p()},get accessibilityInformation(){return S.accessibilityInformation},set accessibilityInformation(a){S.accessibilityInformation=a,p()},get command(){return S.command},set command(a){S.command=a,p()},get busy(){return S.busy},set busy(a){S.busy=a,p()}};return p(),w}}e.ExtHostLanguages=y}),define(Ee[193],we([1,0,12,4,27,14,5]),function(J,e,s,I,b,B,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let A=class extends s.AbstractLoggerService{constructor(L,v){const u=new D.Emitter;super(v.logLevel,u.event);this._proxy=L.getProxy(I.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(u)}$setLevel(L){this._onDidChangeLogLevel.fire(L)}doCreateLogger(L,v,u){return new y(this._proxy,L,v,u)}};A=Fe([Ne(0,B.IExtHostRpcService),Ne(1,b.IExtHostInitDataService)],A),e.ExtHostLoggerService=A;class y extends s.AbstractMessageLogger{constructor(L,v,u,m){super(m?.always);this.proxy=L,this.file=v,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(u),this.proxy.$createLogger(v,m).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(L,v){const u=[[L,v]];this.isLoggerCreated?this.doLog(u):this.buffer.push(...u)}doLog(L){this.proxy.$log(this.file,L)}}}),define(Ee[194],we([1,0,4,12,28]),function(J,e,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function B(A){return A&&A.title}let D=class{constructor(y,M){this._logService=M,this._proxy=y.getProxy(s.MainContext.MainThreadMessageService)}showMessage(y,M,L,v,u){const m={source:{identifier:y.identifier,label:y.displayName||y.name}};let l;typeof v=="string"||B(v)?l=[v,...u]:(m.modal=v?.modal,m.useCustom=v?.useCustom,m.detail=v?.detail,l=u),m.useCustom&&(0,b.checkProposedApiEnabled)(y,"resolvers");const n=[];for(let f=0;f<l.length;f++){const S=l[f];if(typeof S=="string")n.push({title:S,handle:f,isCloseAffordance:!1});else if(typeof S=="object"){let{title:k,isCloseAffordance:d}=S;n.push({title:k,isCloseAffordance:!!d,handle:f})}else this._logService.warn("Invalid message item:",S)}return this._proxy.$showMessage(M,L,m,n).then(f=>{if(typeof f=="number")return l[f]})}};D=Fe([Ne(1,I.ILogService)],D),e.ExtHostMessageService=D}),define(Ee[195],we([1,0,21,5,93,6,22,9,11,2,58,4,8,7,38,169,89]),function(J,e,s,I,b,B,D,A,y,M,L,v,u,m,l,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class S{constructor(d,p,w,a,T){this._textDocumentsAndEditors=w,this._textDocuments=a,this._extensionStoragePaths=T,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new D.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new I.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new I.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new I.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new I.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new I.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new I.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new I.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new L.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=d.getProxy(v.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=d.getProxy(v.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=d.getProxy(v.MainContext.MainThreadNotebookEditors),this._commandsConverter=p.converter,p.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===12){const i=r.notebookEditor?.notebookUri,c=r.cell.handle,o=this._documents.get(i)?.getCell(c);if(o)return o.apiCell}return r}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(d=>d.apiEditor)}getEditorById(d){const p=this._editors.get(d);if(!p)throw new Error(`unknown text editor: ${d}. known editors: ${[...this._editors.keys()]} `);return p}getIdByEditor(d){for(const[p,w]of this._editors)if(w.apiEditor===d)return p}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(d,p){const w=this._documents.get(d);if(!w&&!p)throw new Error(`NO notebook document for '${d}'`);return w}_getProviderData(d){const p=this._notebookContentProviders.get(d);if(!p)throw new Error(`NO provider for '${d}'`);return p}registerNotebookContentProvider(d,p,w,a,T){if((0,A.isFalsyOrWhitespace)(p))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(p))throw new Error(`Notebook provider for '${p}' already registered`);this._notebookContentProviders.set(p,{extension:d,provider:w});let r;return w.onDidChangeNotebookContentOptions&&(r=w.onDidChangeNotebookContentOptions(()=>{const i=u.NotebookDocumentContentOptions.from(w.options);this._notebookProxy.$updateNotebookProviderOptions(p,i)})),this._notebookProxy.$registerNotebookProvider({id:d.identifier,location:d.extensionLocation},p,u.NotebookDocumentContentOptions.from(a),S._convertNotebookRegistrationData(d,T)),new m.Disposable(()=>{r?.dispose(),this._notebookContentProviders.delete(p),this._notebookProxy.$unregisterNotebookProvider(p)})}static _convertNotebookRegistrationData(d,p){if(!p)return;const w=p.filenamePattern.map(a=>u.NotebookExclusiveDocumentPattern.from(a)).filter(a=>a!==void 0);if(p.filenamePattern&&!w){console.warn(`Notebook content provider view options file name pattern is invalid ${p.filenamePattern}`);return}return{extension:d.identifier,providerDisplayName:d.displayName||d.name,displayName:p.displayName,filenamePattern:w,exclusive:p.exclusive||!1}}registerNotebookCellStatusBarItemProvider(d,p,w){const a=S._notebookStatusBarItemProviderHandlePool++,T=typeof w.onDidChangeCellStatusBarItems=="function"?S._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(a,w),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(a,T,p);let r;return T!==void 0&&(r=w.onDidChangeCellStatusBarItems(i=>this._notebookProxy.$emitCellStatusBarEvent(T))),new m.Disposable(()=>{this._notebookStatusBarItemProviders.delete(a),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(a,T),r&&r.dispose()})}async createNotebookDocument(d){const p=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:d.viewType,content:d.content&&u.NotebookData.from(d.content)});return M.URI.revive(p)}async openNotebookDocument(d){const p=this._documents.get(d);if(p)return p.apiNotebook;const w=await this._notebookDocumentsProxy.$tryOpenNotebook(d),a=this._documents.get(M.URI.revive(w));return(0,y.assertIsDefined)(a?.apiNotebook)}async showNotebookDocument(d,p){M.URI.isUri(d)&&(d=await this.openNotebookDocument(d));let w;typeof p=="object"?w={position:u.ViewColumn.from(p.viewColumn),preserveFocus:p.preserveFocus,selections:p.selections&&p.selections.map(u.NotebookRange.from),pinned:typeof p.preview=="boolean"?!p.preview:void 0}:w={preserveFocus:!1};const a=await this._notebookEditorsProxy.$tryShowNotebookDocument(d.uri,d.notebookType,w),T=a&&this._editors.get(a)?.apiEditor;if(T)return T;throw a?new Error(`Could NOT open editor for "${d.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${d.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(d,p,w,a){const T=this._notebookStatusBarItemProviders.get(d),r=M.URI.revive(p),i=this._documents.get(r);if(!i||!T)return;const c=i.getCellFromIndex(w);if(!c)return;const t=await T.provideCellStatusBarItems(c.apiCell,a);if(!t)return;const o=new B.DisposableStore,g=this._statusBarCache.add([o]),_=(Array.isArray(t)?t:[t]).map(P=>u.NotebookStatusBarItem.from(P,this._commandsConverter,o));return{cacheId:g,items:_}}$releaseNotebookCellStatusBarItems(d){this._statusBarCache.delete(d)}registerNotebookSerializer(d,p,w,a,T){if((0,A.isFalsyOrWhitespace)(p))throw new Error("viewType cannot be empty or just whitespace");const r=this._handlePool++;return this._notebookSerializer.set(r,w),this._notebookProxy.$registerNotebookSerializer(r,{id:d.identifier,location:d.extensionLocation},p,u.NotebookDocumentContentOptions.from(a),S._convertNotebookRegistrationData(d,T)),(0,B.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(r)})}async $dataToNotebook(d,p,w){const a=this._notebookSerializer.get(d);if(!a)throw new Error("NO serializer found");const T=await a.deserializeNotebook(p.buffer,w);return new l.SerializableObjectWithBuffers(u.NotebookData.from(T))}async $notebookToData(d,p,w){const a=this._notebookSerializer.get(d);if(!a)throw new Error("NO serializer found");const T=await a.serializeNotebook(u.NotebookData.to(p.value),w);return s.VSBuffer.wrap(T)}async $openNotebook(d,p,w,a,T){const{provider:r}=this._getProviderData(d),i=await r.openNotebook(M.URI.revive(p),{backupId:w,untitledDocumentData:a?.buffer},T);return new l.SerializableObjectWithBuffers({metadata:i.metadata??Object.create(null),cells:i.cells.map(u.NotebookCellData.from)})}async $saveNotebook(d,p,w){const a=this.getNotebookDocument(M.URI.revive(p)),{provider:T}=this._getProviderData(d);return await T.saveNotebook(a.apiNotebook,w),!0}async $saveNotebookAs(d,p,w,a){const T=this.getNotebookDocument(M.URI.revive(p)),{provider:r}=this._getProviderData(d);return await r.saveNotebookAs(M.URI.revive(w),T.apiNotebook,a),!0}async $backupNotebook(d,p,w){const a=this.getNotebookDocument(M.URI.revive(p)),T=this._getProviderData(d),r=this._extensionStoragePaths.workspaceValue(T.extension)??this._extensionStoragePaths.globalValue(T.extension),i=String((0,b.hash)([a.uri.toString(),this._backupIdPool++])),c=M.URI.joinPath(r,i),t=await T.provider.backupNotebook(a.apiNotebook,{destination:c},w);return a.updateBackup(t),t.id}_createExtHostEditor(d,p,w){if(this._editors.has(p))throw new Error(`editor with id ALREADY EXSIST: ${p}`);const a=new f.ExtHostNotebookEditor(p,this._notebookEditorsProxy,d,w.visibleRanges.map(u.NotebookRange.to),w.selections.map(u.NotebookRange.to),typeof w.viewColumn=="number"?u.ViewColumn.to(w.viewColumn):void 0);this._editors.set(p,a)}$acceptDocumentAndEditorsDelta(d){if(d.value.removedDocuments)for(const w of d.value.removedDocuments){const a=M.URI.revive(w),T=this._documents.get(a);T&&(T.dispose(),this._documents.delete(a),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:T.apiNotebook.getCells().map(r=>r.document.uri)}),this._onDidCloseNotebookDocument.fire(T.apiNotebook));for(const r of this._editors.values())r.notebookData.uri.toString()===a.toString()&&this._editors.delete(r.id)}if(d.value.addedDocuments){const w=[];for(const a of d.value.addedDocuments){const T=M.URI.revive(a.uri);if(this._documents.has(T))throw new Error(`adding EXISTING notebook ${T} `);const r=this,i=new n.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(c){r._onDidChangeNotebookCells.fire(c)},emitCellOutputsChange(c){r._onDidChangeCellOutputs.fire(c)},emitCellMetadataChange(c){r._onDidChangeCellMetadata.fire(c)}},T,a);w.push(...a.cells.map(c=>n.ExtHostCell.asModelAddData(i.apiNotebook,c))),this._documents.get(T)?.dispose(),this._documents.set(T,i),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:w}),this._onDidOpenNotebookDocument.fire(i.apiNotebook)}}if(d.value.addedEditors)for(const w of d.value.addedEditors){if(this._editors.has(w.id))return;const a=M.URI.revive(w.documentUri),T=this._documents.get(a);T&&this._createExtHostEditor(T,w.id,w)}const p=[];if(d.value.removedEditors)for(const w of d.value.removedEditors){const a=this._editors.get(w);a&&(this._editors.delete(w),this._activeNotebookEditor?.id===a.id&&(this._activeNotebookEditor=void 0),p.push(a))}if(d.value.visibleEditors){this._visibleNotebookEditors=d.value.visibleEditors.map(a=>this._editors.get(a)).filter(a=>!!a);const w=new Set;this._visibleNotebookEditors.forEach(a=>w.add(a.id));for(const a of this._editors.values()){const T=w.has(a.id);a._acceptVisibility(T)}this._visibleNotebookEditors=[...this._editors.values()].map(a=>a).filter(a=>a.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}d.value.newActiveEditor===null?this._activeNotebookEditor=void 0:d.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(d.value.newActiveEditor)),d.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=S,S._notebookStatusBarItemProviderHandlePool=0}),define(Ee[196],we([1,0,5,53,12,4,14,8]),function(J,e,s,I,b,B,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class y{constructor(v,u){const m=y._Keys.nextId();v.$registerNotebookEditorDecorationType(m,A.NotebookDecorationRenderOptions.from(u)),this.value={key:m,dispose(){v.$removeNotebookEditorDecorationType(m)}}}}y._Keys=new I.IdGenerator("NotebookEditorDecorationType");let M=class{constructor(v,u,m){this._logService=v,this._extHostRpc=u,this._notebooksAndEditors=m,this._onDidChangeNotebookEditorSelection=new s.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new s.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(v){return new y(this._extHostRpc.getProxy(B.MainContext.MainThreadNotebookEditors),v).value}$acceptEditorPropertiesChanged(v,u){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",v,u);const m=this._notebooksAndEditors.getEditorById(v);u.visibleRanges&&m._acceptVisibleRanges(u.visibleRanges.ranges.map(A.NotebookRange.to)),u.selections&&m._acceptSelections(u.selections.selections.map(A.NotebookRange.to)),u.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:m.apiEditor,visibleRanges:m.apiEditor.visibleRanges}),u.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:m.apiEditor,selections:m.apiEditor.selections}))}$acceptEditorViewColumns(v){for(const u in v)this._notebooksAndEditors.getEditorById(u)._acceptViewColumn(A.ViewColumn.to(v[u]))}};M=Fe([Ne(0,b.ILogService),Ne(1,D.IExtHostRpcService)],M),e.ExtHostNotebookEditors=M}),define(Ee[197],we([1,0,16,13,20,5,6,22,2,25,12,4,39,8,7,61,162,28,38]),function(J,e,s,I,b,B,D,A,y,M,L,v,u,m,l,n,f,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let d=class{constructor(i,c,t,o,g){this._initData=c,this._extHostNotebook=t,this._commands=o,this._logService=g,this._activeExecutions=new A.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new B.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=i.getProxy(v.MainContext.MainThreadNotebookKernels);const h=new u.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new u.ApiCommandArgument("options","Select kernel options",_=>!0,_=>{if(_&&"notebookEditor"in _&&"id"in _){const P=this._extHostNotebook.getIdByEditor(_.notebookEditor);return{id:_.id,extension:_.extension,notebookEditorId:P}}else if(_&&"notebookEditor"in _){const P=this._extHostNotebook.getIdByEditor(_.notebookEditor);if(P===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${_.notebookEditor.document.uri.toString()}`);return{notebookEditorId:P}}return _})],u.ApiCommandResult.Void);this._commands.registerApiCommand(h)}createNotebookController(i,c,t,o,g,h){for(const le of this._kernelData.values())if(le.controller.id===c&&M.ExtensionIdentifier.equals(i.identifier,le.extensionId))throw new Error(`notebook controller with id '${c}' ALREADY exist`);const _=this._handlePool++,P=this;this._logService.trace(`NotebookController[${_}], CREATED by ${i.identifier.value}, ${c}`);const R=()=>console.warn(`NO execute handler from notebook controller '${q.id}' of extension: '${i.identifier}'`);let W=!1;const E=new D.DisposableStore,H=new B.Emitter,z=new B.Emitter,q={id:T(i,c),notebookType:t,extensionId:i.identifier,extensionLocation:i.extensionLocation,label:o||i.identifier.value,preloads:h?h.map(m.NotebookRendererScript.from):[]};let G=g??R,j;this._proxy.$addKernel(_,q).catch(le=>{console.log(le),W=!0});let $=0;const ee=()=>{if(W)return;const le=++$;Promise.resolve().then(()=>{le===$&&this._proxy.$updateKernel(_,q)})},se=new A.ResourceMap,Z={get id(){return c},get notebookType(){return q.notebookType},onDidChangeSelectedNotebooks:H.event,get label(){return q.label},set label(le){q.label=le??i.displayName??i.name,ee()},get detail(){return q.detail??""},set detail(le){q.detail=le,ee()},get description(){return q.description??""},set description(le){q.description=le,ee()},get kind(){return(0,S.checkProposedApiEnabled)(i,"notebookControllerKind"),q.kind??""},set kind(le){(0,S.checkProposedApiEnabled)(i,"notebookControllerKind"),q.kind=le,ee()},get supportedLanguages(){return q.supportedLanguages},set supportedLanguages(le){q.supportedLanguages=le,ee()},get supportsExecutionOrder(){return q.supportsExecutionOrder??!1},set supportsExecutionOrder(le){q.supportsExecutionOrder=le,ee()},get rendererScripts(){return q.preloads?q.preloads.map(m.NotebookRendererScript.to):[]},get executeHandler(){return G},set executeHandler(le){G=le??R},get interruptHandler(){return j},set interruptHandler(le){j=le,q.supportsInterrupt=Boolean(le),ee()},createNotebookCellExecution(le){if(W)throw new Error("notebook controller is DISPOSED");if(!se.has(le.notebook.uri))throw P._logService.trace(`NotebookController[${_}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(se.keys()).map(ue=>ue.toString())),new Error(`notebook controller is NOT associated to notebook: ${le.notebook.uri.toString()}`);return P._createNotebookCellExecution(le,T(i,this.id))},dispose:()=>{W||(this._logService.trace(`NotebookController[${_}], DISPOSED`),W=!0,this._kernelData.delete(_),E.dispose(),H.dispose(),z.dispose(),this._proxy.$removeKernel(_))},updateNotebookAffinity(le,ue){P._proxy.$updateNotebookPriority(_,le.uri,ue)},onDidReceiveMessage:z.event,postMessage(le,ue){return(0,S.checkProposedApiEnabled)(i,"notebookMessaging"),P._proxy.$postMessage(_,ue&&P._extHostNotebook.getIdByEditor(ue),le)},asWebviewUri(le){return(0,S.checkProposedApiEnabled)(i,"notebookMessaging"),(0,n.asWebviewUri)(le,P._initData.remote)}};return this._kernelData.set(_,{extensionId:i.identifier,controller:Z,onDidReceiveMessage:z,onDidChangeSelection:H,associatedNotebooks:se}),Z}$acceptNotebookAssociation(i,c,t){const o=this._kernelData.get(i);if(o){const g=this._extHostNotebook.getNotebookDocument(y.URI.revive(c));t?o.associatedNotebooks.set(g.uri,!0):o.associatedNotebooks.delete(g.uri),this._logService.trace(`NotebookController[${i}] ASSOCIATE notebook`,g.uri.toString(),t),o.onDidChangeSelection.fire({selected:t,notebook:g.apiNotebook})}}async $executeCells(i,c,t){const o=this._kernelData.get(i);if(!o)return;const g=this._extHostNotebook.getNotebookDocument(y.URI.revive(c)),h=[];for(const _ of t){const P=g.getCell(_);P&&h.push(P.apiCell)}try{this._logService.trace(`NotebookController[${i}] EXECUTE cells`,g.uri.toString(),h.length),await o.controller.executeHandler.call(o.controller,h,g.apiNotebook,o.controller)}catch(_){this._logService.error(`NotebookController[${i}] execute cells FAILED`,_),console.error(_)}}async $cancelCells(i,c,t){const o=this._kernelData.get(i);if(!o)return;const g=this._extHostNotebook.getNotebookDocument(y.URI.revive(c));if(o.controller.interruptHandler)await o.controller.interruptHandler.call(o.controller,g.apiNotebook);else for(const h of t){const _=g.getCell(h);_&&this._activeExecutions.get(_.uri)?.cancel()}}$acceptKernelMessageFromRenderer(i,c,t){const o=this._kernelData.get(i);if(!o)return;const g=this._extHostNotebook.getEditorById(c);o.onDidReceiveMessage.fire(Object.freeze({editor:g.apiEditor,message:t}))}$cellExecutionChanged(i,c,t){const g=this._extHostNotebook.getNotebookDocument(y.URI.revive(i)).getCell(c);g&&this._onDidChangeCellExecutionState.fire({cell:g.apiCell,state:t?m.NotebookCellExecutionState.to(t):l.NotebookCellExecutionState.Idle})}_createNotebookCellExecution(i,c){if(i.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const o=this._extHostNotebook.getNotebookDocument(i.notebook.uri).getCellFromApiCell(i);if(!o)throw new Error("invalid cell");if(this._activeExecutions.has(o.uri))throw new Error(`duplicate execution for ${o.uri}`);const g=new w(c,o,this._proxy);this._activeExecutions.set(o.uri,g);const h=g.onDidChangeState(()=>{g.state===p.Resolved&&(g.dispose(),h.dispose(),this._activeExecutions.delete(o.uri))});return g.asApiObject()}};d=Fe([Ne(4,L.ILogService)],d),e.ExtHostNotebookKernels=d;var p;(function(r){r[r.Init=0]="Init",r[r.Started=1]="Started",r[r.Resolved=2]="Resolved"})(p||(p={}));class w extends D.Disposable{constructor(i,c,t){super();this._cell=c,this._proxy=t,this._handle=w.HANDLE++,this._onDidChangeState=new B.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=p.Init,this._tokenSource=this._register(new b.CancellationTokenSource),this._collector=new a(10,o=>this.update(o)),this._executionOrder=c.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,i,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(i){await this._collector.addItem(i)}async update(i){const c=Array.isArray(i)?i:[i];return this._proxy.$updateExecution(this._handle,new k.SerializableObjectWithBuffers(c))}verifyStateForOutput(){if(this._state===p.Init)throw new Error("Must call start before modifying cell output");if(this._state===p.Resolved)throw new Error("Cannot modify cell output after calling resolve")}validateAndConvertOutputs(i){return i.map(c=>{const t=l.NotebookCellOutput.ensureUniqueMimeTypes(c.items,!0);return t===c.items?m.NotebookCellOutput.from(c):m.NotebookCellOutput.from({items:t,id:c.id,metadata:c.metadata})})}async updateOutputs(i,c,t){const o=this.validateAndConvertOutputs((0,s.asArray)(i));return this.updateSoon({editType:f.CellExecutionUpdateType.Output,append:t,outputs:o})}async updateOutputItems(i,c,t){return i=l.NotebookCellOutput.ensureUniqueMimeTypes((0,s.asArray)(i),!0),this.updateSoon({editType:f.CellExecutionUpdateType.OutputItems,items:i.map(m.NotebookCellOutputItem.from),outputId:c.id,append:t})}asApiObject(){const i=this;return Object.freeze({get token(){return i._tokenSource.token},get cell(){return i._cell.apiCell},get executionOrder(){return i._executionOrder},set executionOrder(t){i._executionOrder=t,i.update([{editType:f.CellExecutionUpdateType.ExecutionState,executionOrder:i._executionOrder}])},start(t){if(i._state===p.Resolved||i._state===p.Started)throw new Error("Cannot call start again");i._state=p.Started,i._onDidChangeState.fire(),i.update({editType:f.CellExecutionUpdateType.ExecutionState,runStartTime:t})},end(t,o){if(i._state===p.Resolved)throw new Error("Cannot call resolve twice");i._state=p.Resolved,i._onDidChangeState.fire(),i._collector.flush(),i._proxy.$completeExecution(i._handle,new k.SerializableObjectWithBuffers({runEndTime:o,lastRunSuccess:t}))},clearOutput(t){return i.verifyStateForOutput(),i.updateOutputs([],t,!1)},appendOutput(t,o){return i.verifyStateForOutput(),i.updateOutputs(t,o,!0)},replaceOutput(t,o){return i.verifyStateForOutput(),i.updateOutputs(t,o,!1)},appendOutputItems(t,o){return i.verifyStateForOutput(),i.updateOutputItems(t,o,!0)},replaceOutputItems(t,o){return i.verifyStateForOutput(),i.updateOutputItems(t,o,!1)}})}}w.HANDLE=0;class a{constructor(i,c){this.delay=i,this.callback=c,this.batch=[],this.startedTimer=Date.now()}addItem(i){return this.batch.push(i),this.currentDeferred||(this.currentDeferred=new I.DeferredPromise,this.startedTimer=Date.now(),(0,I.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const i=this.currentDeferred;this.currentDeferred=void 0;const c=this.batch;return this.batch=[],this.callback(c).finally(()=>i.complete())}}function T(r,i){return`${r.identifier.value}/${i}`}}),define(Ee[198],we([1,0,5,4,89,28]),function(J,e,s,I,b,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class D{constructor(y,M){this._extHostNotebook=M,this._rendererMessageEmitters=new Map,this.proxy=y.getProxy(I.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(y,M,L){const v=this._extHostNotebook.getEditorById(y);this._rendererMessageEmitters.get(M)?.fire({editor:v.apiEditor,message:L})}createRendererMessaging(y,M){if(!y.contributes?.notebookRenderer?.some(m=>m.id===M))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${M})`);const L=(0,B.isProposedApiEnabled)(y,"notebookEditor"),v=new WeakMap;return{onDidReceiveMessage:(m,l,n)=>{const f=L?m:S=>{const k={};v.set(k,S.editor),m({editor:k,message:S.message})};return this.getOrCreateEmitterFor(M).event(f,l,n)},postMessage:(m,l)=>{b.ExtHostNotebookEditor.apiEditorsToExtHost.has(m)&&([m,l]=[l,m]);const n=L?l:v.get(l),f=n&&b.ExtHostNotebookEditor.apiEditorsToExtHost.get(n);return this.proxy.$postMessage(f?.id,M,m)}}}getOrCreateEmitterFor(y){let M=this._rendererMessageEmitters.get(y);return M||(M=new s.Emitter({onLastListenerRemove:()=>{M?.dispose(),this._rendererMessageEmitters.delete(y)}}),this._rendererMessageEmitters.set(y,M),M)}}e.ExtHostNotebookRenderers=D}),define(Ee[94],we([1,0,4,6,3,14,12,163,50,27,30,112,21,11]),function(J,e,s,I,b,B,D,A,y,M,L,v,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class l extends I.Disposable{constructor(S,k,d,p){super();this.id=S,this.name=k,this.logger=d,this.proxy=p,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(S){this.append(S+`
`)}append(S){this.write(S),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,A.OutputChannelUpdateMode.Append))}clear(){const S=this.offset;this.logger.flush(),this.proxy.$update(this.id,A.OutputChannelUpdateMode.Clear,S)}replace(S){const k=this.offset;this.write(S),this.proxy.$update(this.id,A.OutputChannelUpdateMode.Replace,k),this.visible&&this.logger.flush()}show(S,k){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof S=="boolean"?S:k))}hide(){this.proxy.$close(this.id)}write(S){this.offset+=u.VSBuffer.fromString(S).byteLength,this.logger.info(S)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=l;let n=class{constructor(S,k,d,p,w){this.extHostFileSystem=d,this.extHostFileSystemInfo=p,this.loggerService=w,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=S.getProxy(s.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(k.logsLocation,`output_logging_${(0,v.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(S){this.visibleChannelId=S;for(const[k,d]of this.channels)d.visible=k===this.visibleChannelId}createOutputChannel(S,k,d){if(S=S.trim(),!S)throw new Error("illegal argument `name`. must not be falsy");if((0,m.isString)(k)&&!k.trim())throw new Error("illegal argument `languageId`. must not be empty");const p=this.doCreateOutputChannel(S,k,d);return p.then(w=>{this.channels.set(w.id,w),w.visible=w.id===this.visibleChannelId}),this.createExtHostOutputChannel(S,p)}async doCreateOutputChannel(S,k,d){const p=await this.createOutputDirectory(),w=this.extHostFileSystemInfo.extUri.joinPath(p,`${this.namePool++}-${S.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),a=this.loggerService.createLogger(w,{always:!0,donotRotate:!0,donotUseFormatters:!0}),T=await this.proxy.$register(S,!1,w,k,d.identifier.value);return new l(T,S,a,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(S,k){let d=!1;const p=()=>{if(d)throw new Error("Channel has been closed")};return{get name(){return S},append(w){p(),k.then(a=>a.append(w))},appendLine(w){p(),k.then(a=>a.appendLine(w))},clear(){p(),k.then(w=>w.clear())},replace(w){p(),k.then(a=>a.replace(w))},show(w,a){p(),k.then(T=>T.show(w,a))},hide(){p(),k.then(w=>w.hide())},dispose(){d=!0,k.then(w=>w.dispose())}}}};n=Fe([Ne(0,B.IExtHostRpcService),Ne(1,M.IExtHostInitDataService),Ne(2,y.IExtHostConsumerFileSystem),Ne(3,L.IExtHostFileSystemInfo),Ne(4,D.ILoggerService)],n),e.ExtHostOutputService=n,e.IExtHostOutputService=(0,b.createDecorator)("IExtHostOutputService")}),define(Ee[199],we([1,0,13,20,5,6,4,2,7,15,16,34,57]),function(J,e,s,I,b,B,D,A,y,M,L,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function m(l,n,f){const S=l.getProxy(D.MainContext.MainThreadQuickOpen);class k{constructor(t,o){this._sessions=new Map,this._instances=0,this._workspace=t,this._commands=o}showQuickPick(t,o,g=I.CancellationToken.None){this._onDidSelectItem=void 0;const h=Promise.resolve(t),_=++this._instances,P=S.$show(_,{title:o?.title,placeHolder:o?.placeHolder,matchOnDescription:o?.matchOnDescription,matchOnDetail:o?.matchOnDetail,ignoreFocusLost:o?.ignoreFocusOut,canPickMany:o?.canPickMany},g),R={},W=P.then(()=>R);return Promise.race([W,h]).then(E=>{if(E!==R)return h.then(H=>{const z=[];for(let q=0;q<H.length;q++){const G=H[q];typeof G=="string"?z.push({label:G,handle:q}):G.kind===y.QuickPickItemKind.Separator?z.push({type:"separator",label:G.label}):z.push({label:G.label,description:G.description,detail:G.detail,picked:G.picked,alwaysShow:G.alwaysShow,handle:q})}return o&&typeof o.onDidSelectItem=="function"&&(this._onDidSelectItem=q=>{o.onDidSelectItem(H[q])}),S.$setItems(_,z),P.then(q=>{if(typeof q=="number")return H[q];if(Array.isArray(q))return q.map(G=>H[G])})})}).then(void 0,E=>{if(!(0,M.isCancellationError)(E))return S.$setError(_,E),Promise.reject(E)})}$onItemSelected(t){this._onDidSelectItem&&this._onDidSelectItem(t)}showInput(t,o=I.CancellationToken.None){return this._validateInput=t?t.validateInput:void 0,S.$input(t,typeof this._validateInput=="function",o).then(void 0,g=>{if(!(0,M.isCancellationError)(g))return Promise.reject(g)})}$validateInput(t){return this._validateInput?(0,s.asPromise)(()=>this._validateInput(t)):Promise.resolve(void 0)}async showWorkspaceFolderPick(t,o=I.CancellationToken.None){const g=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[t]);if(!g)return;const h=await this._workspace.getWorkspaceFolders2();if(!!h)return h.find(_=>_.uri.toString()===g.uri.toString())}createQuickPick(t){const o=new r(t,()=>this._sessions.delete(o._id));return this._sessions.set(o._id,o),o}createInputBox(t){const o=new i(t,()=>this._sessions.delete(o._id));return this._sessions.set(o._id,o),o}$onDidChangeValue(t,o){const g=this._sessions.get(t);g&&g._fireDidChangeValue(o)}$onDidAccept(t){const o=this._sessions.get(t);o&&o._fireDidAccept()}$onDidChangeActive(t,o){const g=this._sessions.get(t);g instanceof r&&g._fireDidChangeActive(o)}$onDidChangeSelection(t,o){const g=this._sessions.get(t);g instanceof r&&g._fireDidChangeSelection(o)}$onDidTriggerButton(t,o){const g=this._sessions.get(t);g&&g._fireDidTriggerButton(o)}$onDidTriggerItemButton(t,o,g){const h=this._sessions.get(t);h instanceof r&&h._fireDidTriggerItemButton(o,g)}$onDidHide(t){const o=this._sessions.get(t);o&&o._fireDidHide()}}class d{constructor(t,o){this._extensionId=t,this._onDidDispose=o,this._id=r._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new b.Emitter,this._onDidChangeValueEmitter=new b.Emitter,this._onDidTriggerButtonEmitter=new b.Emitter,this._onDidHideEmitter=new b.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(t){this._title=t,this.update({title:t})}get step(){return this._steps}set step(t){this._steps=t,this.update({step:t})}get totalSteps(){return this._totalSteps}set totalSteps(t){this._totalSteps=t,this.update({totalSteps:t})}get enabled(){return this._enabled}set enabled(t){this._enabled=t,this.update({enabled:t})}get busy(){return this._busy}set busy(t){this._busy=t,this.update({busy:t})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(t){this._ignoreFocusOut=t,this.update({ignoreFocusOut:t})}get value(){return this._value}set value(t){this._value=t,this.update({value:t})}get placeholder(){return this._placeholder}set placeholder(t){this._placeholder=t,this.update({placeholder:t})}get buttons(){return this._buttons}set buttons(t){this._buttons=t.slice(),this._handlesToButtons.clear(),t.forEach((o,g)=>{const h=o===y.QuickInputButtons.Back?-1:g;this._handlesToButtons.set(h,o)}),this.update({buttons:t.map((o,g)=>({...T(o),tooltip:o.tooltip,handle:o===y.QuickInputButtons.Back?-1:g}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(t){this._value=t,this._onDidChangeValueEmitter.fire(t)}_fireDidTriggerButton(t){const o=this._handlesToButtons.get(t);o&&this._onDidTriggerButtonEmitter.fire(o)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,B.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),S.$dispose(this._id))}update(t){if(!this._disposed){for(const o of Object.keys(t)){const g=t[o];this._pendingUpdate[o]=g===void 0?null:g}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){S.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}d._nextId=1;function p(c){if(c instanceof y.ThemeIcon)return{id:c.id};const t=a(c),o=w(c);return{dark:typeof t=="string"?A.URI.file(t):t,light:typeof o=="string"?A.URI.file(o):o}}function w(c){return typeof c=="object"&&"light"in c?c.light:c}function a(c){return typeof c=="object"&&"dark"in c?c.dark:c}function T(c){const t=p(c.iconPath);let o,g;return"id"in t?g=u.ThemeIcon.asClassName(t):o=t,{iconPath:o,iconClass:g}}class r extends d{constructor(t,o){super(t.identifier,o);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new b.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new b.Emitter,this._onDidTriggerItemButtonEmitter=new b.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(t){this._items=t.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),t.forEach((g,h)=>{this._handlesToItems.set(h,g),this._itemsToHandles.set(g,h)});const o=[];for(let g=0;g<t.length;g++){const h=t[g];h.kind===y.QuickPickItemKind.Separator?o.push({type:"separator",label:h.label}):o.push({handle:g,label:h.label,description:h.description,detail:h.detail,picked:h.picked,alwaysShow:h.alwaysShow,buttons:h.buttons?.map((_,P)=>({...T(_),tooltip:_.tooltip,handle:P}))})}this.update({items:o})}get canSelectMany(){return this._canSelectMany}set canSelectMany(t){this._canSelectMany=t,this.update({canSelectMany:t})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(t){this._matchOnDescription=t,this.update({matchOnDescription:t})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(t){this._matchOnDetail=t,this.update({matchOnDetail:t})}get sortByLabel(){return this._sortByLabel}set sortByLabel(t){this._sortByLabel=t,this.update({sortByLabel:t})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(t){this._keepScrollPosition=t,this.update({keepScrollPosition:t})}get activeItems(){return this._activeItems}set activeItems(t){this._activeItems=t.filter(o=>this._itemsToHandles.has(o)),this.update({activeItems:this._activeItems.map(o=>this._itemsToHandles.get(o))})}get selectedItems(){return this._selectedItems}set selectedItems(t){this._selectedItems=t.filter(o=>this._itemsToHandles.has(o)),this.update({selectedItems:this._selectedItems.map(o=>this._itemsToHandles.get(o))})}_fireDidChangeActive(t){const o=(0,L.coalesce)(t.map(g=>this._handlesToItems.get(g)));this._activeItems=o,this._onDidChangeActiveEmitter.fire(o)}_fireDidChangeSelection(t){const o=(0,L.coalesce)(t.map(g=>this._handlesToItems.get(g)));this._selectedItems=o,this._onDidChangeSelectionEmitter.fire(o)}_fireDidTriggerItemButton(t,o){const g=this._handlesToItems.get(t);if(!g||!g.buttons||!g.buttons.length)return;const h=g.buttons[o];h&&this._onDidTriggerItemButtonEmitter.fire({button:h,item:g})}}class i extends d{constructor(t,o){super(t,o);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(t){this._password=t,this.update({password:t})}get prompt(){return this._prompt}set prompt(t){this._prompt=t,this.update({prompt:t})}get validationMessage(){return this._validationMessage}set validationMessage(t){this._validationMessage=t,this.update({validationMessage:t,severity:t?v.default.Error:v.default.Ignore})}}return new k(n,f)}e.createExtHostQuickOpen=m});var je=this&&this.__classPrivateFieldSet||function(J,e,s,I,b){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!b:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?b.call(J,s):b?b.value=s:e.set(J,s),s},De=this&&this.__classPrivateFieldGet||function(J,e,s,I){if(s==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?I:s==="a"?I.call(J):I?I.value:e.get(J)};define(Ee[200],we([1,0,2,5,52,6,13,4,16,107,12,25,57,8,28]),function(J,e,s,I,b,B,D,A,y,M,L,v,u,m,l){"use strict";var n,f;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function S(g){if(g)return typeof g.iconPath=="string"?s.URI.file(g.iconPath):s.URI.isUri(g.iconPath)||u.ThemeIcon.isThemeIcon(g.iconPath)?g.iconPath:void 0}function k(g,h){if(!g.iconPath&&!h.iconPath)return 0;if(g.iconPath){if(!h.iconPath)return 1}else return-1;const _=typeof g.iconPath=="string"?g.iconPath:s.URI.isUri(g.iconPath)?g.iconPath.fsPath:g.iconPath.id,P=typeof h.iconPath=="string"?h.iconPath:s.URI.isUri(h.iconPath)?h.iconPath.fsPath:h.iconPath.id;return(0,M.comparePaths)(_,P)}function d(g,h){let _=0;if(g.strikeThrough!==h.strikeThrough)return g.strikeThrough?1:-1;if(g.faded!==h.faded)return g.faded?1:-1;if(g.tooltip!==h.tooltip)return(g.tooltip||"").localeCompare(h.tooltip||"");if(_=k(g,h),_!==0)return _;if(g.light&&h.light)_=k(g.light,h.light);else{if(g.light)return 1;if(h.light)return-1}if(_!==0)return _;if(g.dark&&h.dark)_=k(g.dark,h.dark);else{if(g.dark)return 1;if(h.dark)return-1}return _}function p(g,h){if(g.command!==h.command)return g.command<h.command?-1:1;if(g.title!==h.title)return g.title<h.title?-1:1;if(g.tooltip!==h.tooltip){if(g.tooltip!==void 0&&h.tooltip!==void 0)return g.tooltip<h.tooltip?-1:1;if(g.tooltip!==void 0)return 1;if(h.tooltip!==void 0)return-1}if(g.arguments===h.arguments)return 0;if(g.arguments)if(h.arguments){if(g.arguments.length!==h.arguments.length)return g.arguments.length-h.arguments.length}else return 1;else return-1;for(let _=0;_<g.arguments.length;_++){const P=g.arguments[_],R=h.arguments[_];if(P!==R)return P<R?-1:1}return 0}function w(g,h){let _=(0,M.comparePaths)(g.resourceUri.fsPath,h.resourceUri.fsPath,!0);if(_!==0)return _;if(g.command&&h.command)_=p(g.command,h.command);else{if(g.command)return 1;if(h.command)return-1}if(_!==0)return _;if(g.decorations&&h.decorations)_=d(g.decorations,h.decorations);else{if(g.decorations)return 1;if(h.decorations)return-1}return _}function a(g,h){for(let _=0;_<g.length;_++)if(g[_]!==h[_])return!1;return!0}function T(g,h){return g.command===h.command&&g.title===h.title&&g.tooltip===h.tooltip&&(g.arguments&&h.arguments?a(g.arguments,h.arguments):g.arguments===h.arguments)}function r(g,h){return(0,y.equals)(g,h,T)}class i{constructor(h,_,P){this._extension=h,this._sourceControlHandle=P,n.set(this,void 0),this._value="",this._onDidChange=new I.Emitter,this._placeholder="",this._visible=!0,je(this,n,_,"f")}get value(){return this._value}set value(h){h=h??"",De(this,n,"f").$setInputBoxValue(this._sourceControlHandle,h),this.updateValue(h)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(h){De(this,n,"f").$setInputBoxPlaceholder(this._sourceControlHandle,h),this._placeholder=h}get validateInput(){return(0,l.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(h){if((0,l.checkProposedApiEnabled)(this._extension,"scmValidation"),h&&typeof h!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=h,De(this,n,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!h)}get visible(){return this._visible}set visible(h){h=!!h,this._visible!==h&&(this._visible=h,De(this,n,"f").$setInputBoxVisibility(this._sourceControlHandle,h))}showValidationMessage(h,_){(0,l.checkProposedApiEnabled)(this._extension,"scmValidation"),De(this,n,"f").$showValidationMessage(this._sourceControlHandle,h,_)}$onInputBoxValueChange(h){this.updateValue(h)}updateValue(h){this._value=h,this._onDidChange.fire(h)}}e.ExtHostSCMInputBox=i,n=new WeakMap;class c{constructor(h,_,P,R,W){this._proxy=h,this._commands=_,this._sourceControlHandle=P,this._id=R,this._label=W,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new I.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new I.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=c._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(h){this._label=h,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,h)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(h){this._hideWhenEmpty=h,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(h){this._resourceStates=[...h],this._onDidUpdateResourceStates.fire()}getResourceState(h){return this._resourceStatesMap.get(h)}$executeResourceCommand(h,_){const P=this._resourceStatesCommandsMap.get(h);return P?(0,D.asPromise)(()=>this._commands.executeCommand(P.command,...P.arguments||[],_)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const h=[...this._resourceStates].sort(w),P=(0,y.sortedDiff)(this._resourceSnapshot,h,w).map(E=>{const H=E.toInsert.map(z=>{const q=this._resourceHandlePool++;this._resourceStatesMap.set(q,z);const G=z.resourceUri;let j;if(z.command)if(z.command.command==="vscode.open"||z.command.command==="vscode.diff"){const me=new B.DisposableStore;j=this._commands.converter.toInternal(z.command,me),this._resourceStatesDisposablesMap.set(q,me)}else this._resourceStatesCommandsMap.set(q,z.command);const $=S(z.decorations),ee=z.decorations&&S(z.decorations.light)||$,se=z.decorations&&S(z.decorations.dark)||$,Z=[ee,se],le=z.decorations&&z.decorations.tooltip||"",ue=z.decorations&&!!z.decorations.strikeThrough,Se=z.decorations&&!!z.decorations.faded,fe=z.contextValue||"";return{rawResource:[q,G,Z,le,ue,Se,fe,j],handle:q}});return{start:E.start,deleteCount:E.deleteCount,toInsert:H}}),R=P.map(({start:E,deleteCount:H,toInsert:z})=>[E,H,z.map(q=>q.rawResource)]),W=P.reverse();for(const{start:E,deleteCount:H,toInsert:z}of W){const q=z.map(j=>j.handle),G=this._handlesSnapshot.splice(E,H,...q);for(const j of G)this._resourceStatesMap.delete(j),this._resourceStatesCommandsMap.delete(j),this._resourceStatesDisposablesMap.get(j)?.dispose(),this._resourceStatesDisposablesMap.delete(j)}return this._resourceSnapshot=h,R}dispose(){this._disposed=!0,this._onDidDispose.fire()}}c._handlePool=0;class t{constructor(h,_,P,R,W,E){this._extension=h,this._commands=P,this._id=R,this._label=W,this._rootUri=E,f.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new B.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new B.MutableDisposable,this._statusBarDisposables=new B.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new I.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=t._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,je(this,f,_,"f"),this._inputBox=new i(h,De(this,f,"f"),this.handle),De(this,f,"f").$registerSourceControl(this.handle,R,W,E)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(h){this._count!==h&&(this._count=h,De(this,f,"f").$updateSourceControl(this.handle,{count:h}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(h){this._quickDiffProvider=h,De(this,f,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!h})}get commitTemplate(){return this._commitTemplate}set commitTemplate(h){h!==this._commitTemplate&&(this._commitTemplate=h,De(this,f,"f").$updateSourceControl(this.handle,{commitTemplate:h}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(h){this._acceptInputDisposables.value=new B.DisposableStore,this._acceptInputCommand=h;const _=this._commands.converter.toInternal(h,this._acceptInputDisposables.value);De(this,f,"f").$updateSourceControl(this.handle,{acceptInputCommand:_})}get actionButton(){return(0,l.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(h){(0,l.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new B.DisposableStore,this._actionButton=h;const _=h!==void 0?{command:this._commands.converter.toInternal(h.command,this._actionButtonDisposables.value),description:h.description}:void 0;De(this,f,"f").$updateSourceControl(this.handle,{actionButton:_??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(h){if(this._statusBarCommands&&h&&r(this._statusBarCommands,h))return;this._statusBarDisposables.value=new B.DisposableStore,this._statusBarCommands=h;const _=(h||[]).map(P=>this._commands.converter.toInternal(P,this._statusBarDisposables.value));De(this,f,"f").$updateSourceControl(this.handle,{statusBarCommands:_})}get selected(){return this._selected}createResourceGroup(h,_){const P=new c(De(this,f,"f"),this._commands,this.handle,h,_),R=I.Event.once(P.onDidDispose)(()=>this.createdResourceGroups.delete(P));return this.createdResourceGroups.set(P,R),this.eventuallyAddResourceGroups(),P}eventuallyAddResourceGroups(){const h=[],_=[];for(const[P,R]of this.createdResourceGroups){R.dispose();const W=P.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(P),this.eventuallyUpdateResourceStates()});I.Event.once(P.onDidDispose)(()=>{this.updatedResourceGroups.delete(P),W.dispose(),this._groups.delete(P.handle),De(this,f,"f").$unregisterGroup(this.handle,P.handle)}),h.push([P.handle,P.id,P.label,P.features]);const E=P._takeResourceStateSnapshot();E.length>0&&_.push([P.handle,E]),this._groups.set(P.handle,P)}De(this,f,"f").$registerGroups(this.handle,h,_),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const h=[];this.updatedResourceGroups.forEach(_=>{const P=_._takeResourceStateSnapshot();P.length!==0&&h.push([_.handle,P])}),h.length>0&&De(this,f,"f").$spliceResourceStates(this.handle,h),this.updatedResourceGroups.clear()}getResourceGroup(h){return this._groups.get(h)}setSelectionState(h){this._selected=h,this._onDidChangeSelection.fire(h)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(h=>h.dispose()),De(this,f,"f").$unregisterSourceControl(this.handle)}}f=new WeakMap,t._handlePool=0,Fe([(0,b.debounce)(100)],t.prototype,"eventuallyAddResourceGroups",null),Fe([(0,b.debounce)(100)],t.prototype,"eventuallyUpdateResourceStates",null);let o=class Vi{constructor(h,_,P){this._commands=_,this.logService=P,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new I.Emitter,this._proxy=h.getProxy(A.MainContext.MainThreadSCM),this._telemetry=h.getProxy(A.MainContext.MainThreadTelemetry),_.registerArgumentProcessor({processArgument:R=>{if(R&&R.$mid===3){const W=this._sourceControls.get(R.sourceControlHandle);if(!W)return R;const E=W.getResourceGroup(R.groupHandle);return E?E.getResourceState(R.handle):R}else if(R&&R.$mid===4){const W=this._sourceControls.get(R.sourceControlHandle);return W?W.getResourceGroup(R.groupHandle):R}else if(R&&R.$mid===5){const W=this._sourceControls.get(R.handle);return W||R}return R}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(h,_,P,R){this.logService.trace("ExtHostSCM#createSourceControl",h.identifier.value,_,P,R),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:h.identifier.value});const W=Vi._handlePool++,E=new t(h,this._proxy,this._commands,_,P,R);this._sourceControls.set(W,E);const H=this._sourceControlsByExtension.get(v.ExtensionIdentifier.toKey(h.identifier))||[];return H.push(E),this._sourceControlsByExtension.set(v.ExtensionIdentifier.toKey(h.identifier),H),E}getLastInputBox(h){this.logService.trace("ExtHostSCM#getLastInputBox",h.identifier.value);const _=this._sourceControlsByExtension.get(v.ExtensionIdentifier.toKey(h.identifier)),P=_&&_[_.length-1];return P&&P.inputBox}$provideOriginalResource(h,_,P){const R=s.URI.revive(_);this.logService.trace("ExtHostSCM#$provideOriginalResource",h,R.toString());const W=this._sourceControls.get(h);return!W||!W.quickDiffProvider||!W.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,D.asPromise)(()=>W.quickDiffProvider.provideOriginalResource(R,P)).then(E=>E||null)}$onInputBoxValueChange(h,_){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",h);const P=this._sourceControls.get(h);return P&&P.inputBox.$onInputBoxValueChange(_),Promise.resolve(void 0)}$executeResourceCommand(h,_,P,R){this.logService.trace("ExtHostSCM#$executeResourceCommand",h,_,P);const W=this._sourceControls.get(h);if(!W)return Promise.resolve(void 0);const E=W.getResourceGroup(_);return E?E.$executeResourceCommand(P,R):Promise.resolve(void 0)}$validateInput(h,_,P){this.logService.trace("ExtHostSCM#$validateInput",h);const R=this._sourceControls.get(h);return!R||!R.inputBox.validateInput?Promise.resolve(void 0):(0,D.asPromise)(()=>R.inputBox.validateInput(_,P)).then(W=>{if(!W)return Promise.resolve(void 0);const E=m.MarkdownString.fromStrict(W.message);return E?Promise.resolve([E,W.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(h){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",h),h!==void 0&&this._sourceControls.get(h)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=h,Promise.resolve(void 0)}};o._handlePool=0,o=Fe([Ne(2,L.ILogService)],o),e.ExtHostSCM=o});var je=this&&this.__classPrivateFieldSet||function(J,e,s,I,b){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!b:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?b.call(J,s):b?b.value=s:e.set(J,s),s},De=this&&this.__classPrivateFieldGet||function(J,e,s,I){if(s==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?I:s==="a"?I.call(J):I?I.value:e.get(J)};define(Ee[201],we([1,0,7,4,125,6,8,11]),function(J,e,s,I,b,B,D,A){"use strict";var y,M;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class L{constructor(l,n,f,S,k=s.StatusBarAlignment.Left,d){y.set(this,void 0),M.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new B.DisposableStore,je(this,y,l,"f"),je(this,M,n,"f"),this._entryId=L.ID_GEN++,this._extension=f,this._id=S,this._alignment=k,this._priority=this.validatePriority(d)}validatePriority(l){if(!!(0,A.isNumber)(l))return l===Number.POSITIVE_INFINITY?Number.MAX_VALUE:l===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:l}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(l){this._text=l,this.update()}set name(l){this._name=l,this.update()}set tooltip(l){this._tooltip=l,this.update()}set color(l){this._color=l,this.update()}set backgroundColor(l){l&&!L.ALLOWED_BACKGROUND_COLORS.has(l.id)&&(l=void 0),this._backgroundColor=l,this.update()}set command(l){this._command?.fromApi!==l&&(this._internalCommandRegistration.clear(),typeof l=="string"?this._command={fromApi:l,internal:De(this,M,"f").toInternal({title:"",command:l},this._internalCommandRegistration)}:l?this._command={fromApi:l,internal:De(this,M,"f").toInternal(l,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(l){this._accessibilityInformation=l,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,De(this,y,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let l;this._extension?this._id?l=`${this._extension.identifier.value}.${this._id}`:l=this._extension.identifier.value:l=this._id;let n;this._name?n=this._name:n=(0,b.localize)(0,null,this._extension.displayName||this._extension.name);let f=this._color;this._backgroundColor&&(f=L.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const S=D.MarkdownString.fromStrict(this._tooltip);De(this,y,"f").$setEntry(this._entryId,l,n,this._text,S,this._command?.internal,f,this._backgroundColor,this._alignment===s.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=L,y=new WeakMap,M=new WeakMap,L.ID_GEN=0,L.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new s.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new s.ThemeColor("statusBarItem.warningForeground")]]);class v{constructor(l){this._messages=[],this._item=l.createStatusBarEntry(void 0,"status.extensionMessage",s.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,b.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(l){const n={message:l};return this._messages.unshift(n),this._update(),new s.Disposable(()=>{const f=this._messages.indexOf(n);f>=0&&(this._messages.splice(f,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class u{constructor(l,n){this._proxy=l.getProxy(I.MainContext.MainThreadStatusBar),this._commands=n,this._statusMessage=new v(this)}createStatusBarEntry(l,n,f,S){return new L(this._proxy,this._commands,l,n,f,S)}setStatusBarMessage(l,n){const f=this._statusMessage.setMessage(l);let S;return typeof n=="number"?S=setTimeout(()=>f.dispose(),n):typeof n!="undefined"&&n.then(()=>f.dispose(),()=>f.dispose()),new s.Disposable(()=>{f.dispose(),clearTimeout(S)})}}e.ExtHostStatusBar=u}),define(Ee[67],we([1,0,4,5,3]),function(J,e,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class B{constructor(A){this._onDidChangeStorage=new I.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=A.getProxy(s.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(A,y){this._proxy.$registerExtensionStorageKeysToSync(A,y)}initializeExtensionStorage(A,y,M){return this._proxy.$initializeExtensionStorage(A,y).then(L=>L||M)}setValue(A,y,M){return this._proxy.$setValue(A,y,M)}$acceptValue(A,y,M){this._onDidChangeStorage.fire({shared:A,key:y,value:M})}}e.ExtHostStorage=B,e.IExtHostStorage=(0,b.createDecorator)("IExtHostStorage")}),define(Ee[68],we([1,0,3,27,12,50,2]),function(J,e,s,I,b,B,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,s.createDecorator)("IExtensionStoragePaths");let A=class{constructor(M,L,v){this._logService=L,this._extHostFileSystem=v,this._workspace=M.workspace??void 0,this._environment=M.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(u=>this._value=u)}async _getWorkspaceStorageURI(M){return D.URI.joinPath(this._environment.workspaceStorageHome,M)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const M=this._workspace.id,L=await this._getWorkspaceStorageURI(M);try{return await this._extHostFileSystem.value.stat(L),this._logService.trace("[ExtHostStorage] storage dir already exists",L),L}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",L),await this._extHostFileSystem.value.createDirectory(L),await this._extHostFileSystem.value.writeFile(D.URI.joinPath(L,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:D.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),L}catch(v){this._logService.error("[ExtHostStorage]",v);return}}workspaceValue(M){if(this._value)return D.URI.joinPath(this._value,M.identifier.value)}globalValue(M){return D.URI.joinPath(this._environment.globalStorageHome,M.identifier.value.toLowerCase())}onWillDeactivateAll(){}};A=Fe([Ne(0,I.IExtHostInitDataService),Ne(1,b.ILogService),Ne(2,B.IExtHostConsumerFileSystem)],A),e.ExtensionStoragePaths=A}),define(Ee[40],we([1,0,5,4,3,2,14,6,7,126,15,165,20,36,145,57,11,13]),function(J,e,s,I,b,B,D,A,y,M,L,v,u,m,l,n,f,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,b.createDecorator)("IExtHostTerminalService");class k{constructor(t,o,g,h){this._proxy=t,this._id=o,this._creationOptions=g,this._name=h,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(P=>this._pidPromiseComplete=P);const _=this;this.value={get name(){return _._name||""},get processId(){return _._pidPromise},get creationOptions(){return _._creationOptions},get exitStatus(){return _._exitStatus},get state(){return _._state},sendText(P,R=!0){_._checkDisposed(),_._proxy.$sendText(_._id,P,R)},show(P){_._checkDisposed(),_._proxy.$show(_._id,P)},hide(){_._checkDisposed(),_._proxy.$hide(_._id)},dispose(){_._disposed||(_._disposed=!0,_._proxy.$dispose(_._id))},get dimensions(){if(!(_._cols===void 0||_._rows===void 0))return{columns:_._cols,rows:_._rows}}}}async create(t,o){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:t.name,shellPath:(0,f.withNullAsUndefined)(t.shellPath),shellArgs:(0,f.withNullAsUndefined)(t.shellArgs),cwd:(0,f.withNullAsUndefined)(t.cwd),env:(0,f.withNullAsUndefined)(t.env),icon:(0,f.withNullAsUndefined)(r(t.iconPath)),color:n.ThemeColor.isThemeColor(t.color)?t.color.id:void 0,initialText:(0,f.withNullAsUndefined)(t.message),strictEnv:(0,f.withNullAsUndefined)(t.strictEnv),hideFromUser:(0,f.withNullAsUndefined)(t.hideFromUser),isFeatureTerminal:(0,f.withNullAsUndefined)(o?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,f.withNullAsUndefined)(o?.useShellEnvironment),location:o?.location||this._serializeParentTerminal(t.location,o?.resolvedExtHostIdentifier),isTransient:(0,f.withNullAsUndefined)(t.isTransient)})}async createExtensionTerminal(t,o,g,h){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:g,color:n.ThemeColor.isThemeColor(h)?h.id:void 0,location:this._serializeParentTerminal(t,o),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(t,o){return typeof t=="object"?"parentTerminal"in t&&t.parentTerminal&&o?{parentTerminal:o}:"viewColumn"in t?{viewColumn:t.viewColumn,preserveFocus:t.preserveFocus}:void 0:t}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(t){this._name=t}setExitCode(t){this._exitStatus=Object.freeze({code:t})}setDimensions(t,o){return t===this._cols&&o===this._rows||t===0||o===0?!1:(this._cols=t,this._rows=o,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(t){this._pidPromiseComplete?(this._pidPromiseComplete(t),this._pidPromiseComplete=void 0):this._pidPromise.then(o=>{o!==t&&(this._pidPromise=Promise.resolve(t))})}}e.ExtHostTerminal=k;class d{constructor(t){this._pty=t,this.id=0,this.shouldPersist=!1,this._onProcessData=new s.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new s.Emitter,this._onDidChangeProperty=new s.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new s.Emitter,this.onProcessExit=this._onProcessExit.event}get onProcessReady(){return this._onProcessReady.event}refreshProperty(t){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${t}`)}updateProperty(t,o){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${t}, value: ${o}`)}async start(){}shutdown(){this._pty.close()}input(t){this._pty.handleInput?.(t)}resize(t,o){this._pty.setDimensions?.({columns:t,rows:o})}async processBinary(t){}acknowledgeDataEvent(t){}async setUnicodeVersion(t){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(t){this._pty.onDidWrite(o=>this._onProcessData.fire(o)),this._pty.onDidClose?.((o=void 0)=>{this._onProcessExit.fire(o===void 0?void 0:o)}),this._pty.onDidOverrideDimensions?.(o=>{o&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:o.columns,rows:o.rows}})}),this._pty.onDidChangeName?.(o=>{this._onDidChangeProperty.fire({type:"title",value:o})}),this._pty.open(t||void 0),t&&this._pty.setDimensions?.(t),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=d;let p=1,w=class extends A.Disposable{constructor(t,o){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new s.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new s.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new s.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new s.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new s.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=o.getProxy(I.MainContext.MainThreadTerminalService),this._bufferer=new l.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new s.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(t),this._register({dispose:()=>{for(const[g,h]of this._terminalProcesses)h.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(t=>t.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(t){return(t?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(t){return(t?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(t,o){const g=new k(this._proxy,(0,m.generateUuid)(),t,t.name),h=new d(t.pty);return g.createExtensionTerminal(t.location,this._serializeParentTerminal(t,o).resolvedExtHostIdentifier,r(t.iconPath),i(t.color)).then(_=>{const P=this._setupExtHostProcessListeners(_,h);this._terminalProcessDisposables[_]=P}),this._terminals.push(g),g.value}_serializeParentTerminal(t,o){if(o=o||{},t.location&&typeof t.location=="object"&&"parentTerminal"in t.location){const g=t.location.parentTerminal;if(g){const h=this._terminals.find(_=>_.value===g);h&&(o.resolvedExtHostIdentifier=h._id)}}else t.location&&typeof t.location!="object"?o.location=t.location:o.location&&typeof o.location=="object"&&"splitActiveTerminal"in o.location&&(o.location={splitActiveTerminal:!0});return o}attachPtyToTerminal(t,o){if(!this._getTerminalById(t))throw new Error(`Cannot resolve terminal with id ${t} for virtual process`);const h=new d(o),_=this._setupExtHostProcessListeners(t,h);this._terminalProcessDisposables[t]=_}async $acceptActiveTerminalChanged(t){const o=this._activeTerminal;if(t===null){this._activeTerminal=void 0,o!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const g=this._getTerminalById(t);g&&(this._activeTerminal=g,o!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(t,o){const g=this._getTerminalById(t);g&&this._onDidWriteTerminalData.fire({terminal:g.value,data:o})}async $acceptTerminalDimensions(t,o,g){const h=this._getTerminalById(t);h&&h.setDimensions(o,g)&&this._onDidChangeTerminalDimensions.fire({terminal:h.value,dimensions:h.value.dimensions})}async $acceptTerminalMaximumDimensions(t,o,g){this._terminalProcesses.get(t)?.resize(o,g)}async $acceptTerminalTitleChange(t,o){const g=this._getTerminalById(t);g&&(g.name=o)}async $acceptTerminalClosed(t,o){const g=this._getTerminalObjectIndexById(this._terminals,t);if(g!==null){const h=this._terminals.splice(g,1)[0];h.setExitCode(o),this._onDidCloseTerminal.fire(h.value)}}$acceptTerminalOpened(t,o,g,h){if(o){const R=this._getTerminalObjectIndexById(this._terminals,o);if(R!==null){this._terminals[R]._id=t,this._onDidOpenTerminal.fire(this.terminals[R]),this._terminals[R].isOpen=!0;return}}const _={name:h.name,shellPath:h.executable,shellArgs:h.args,cwd:typeof h.cwd=="string"?h.cwd:B.URI.revive(h.cwd),env:h.env,hideFromUser:h.hideFromUser},P=new k(this._proxy,t,_,g);this._terminals.push(P),this._onDidOpenTerminal.fire(P.value),P.isOpen=!0}async $acceptTerminalProcessId(t,o){const g=this._getTerminalById(t);g&&g._setProcessId(o)}async $startExtensionTerminal(t,o){const g=this._getTerminalById(t);if(!g)return{message:(0,M.localize)(0,null,t)};g.isOpen||await new Promise(_=>{const P=this.onDidOpenTerminal(async R=>{R===g.value&&(P.dispose(),_())})});const h=this._terminalProcesses.get(t);h?h.startSendingEvents(o):this._extensionTerminalAwaitingStart[t]={initialDimensions:o}}_setupExtHostProcessListeners(t,o){const g=new A.DisposableStore;g.add(o.onProcessReady(_=>this._proxy.$sendProcessReady(t,_.pid,_.cwd))),g.add(o.onDidChangeProperty(_=>this._proxy.$sendProcessProperty(t,_))),this._bufferer.startBuffering(t,o.onProcessData),g.add(o.onProcessExit(_=>this._onProcessExit(t,_))),this._terminalProcesses.set(t,o);const h=this._extensionTerminalAwaitingStart[t];return h&&o instanceof d&&(o.startSendingEvents(h.initialDimensions),delete this._extensionTerminalAwaitingStart[t]),g}$acceptProcessAckDataEvent(t,o){this._terminalProcesses.get(t)?.acknowledgeDataEvent(o)}$acceptProcessInput(t,o){this._terminalProcesses.get(t)?.input(o)}$acceptTerminalInteraction(t){const o=this._getTerminalById(t);o?.setInteractedWith()&&this._onDidChangeTerminalState.fire(o.value)}$acceptProcessResize(t,o,g){try{this._terminalProcesses.get(t)?.resize(o,g)}catch(h){if(h.code!=="EPIPE"&&h.code!=="ERR_IPC_CHANNEL_CLOSED")throw h}}$acceptProcessShutdown(t,o){this._terminalProcesses.get(t)?.shutdown(o)}$acceptProcessRequestInitialCwd(t){this._terminalProcesses.get(t)?.getInitialCwd().then(o=>this._proxy.$sendProcessProperty(t,{type:"initialCwd",value:o}))}$acceptProcessRequestCwd(t){this._terminalProcesses.get(t)?.getCwd().then(o=>this._proxy.$sendProcessProperty(t,{type:"cwd",value:o}))}$acceptProcessRequestLatency(t){return Promise.resolve(t)}registerLinkProvider(t){return this._linkProviders.add(t),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new y.Disposable(()=>{this._linkProviders.delete(t),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(t,o,g){if(this._profileProviders.has(o))throw new Error(`Terminal profile provider "${o}" already registered`);return this._profileProviders.set(o,g),this._proxy.$registerProfileProvider(o,t.identifier.value),new y.Disposable(()=>{this._profileProviders.delete(o),this._proxy.$unregisterProfileProvider(o)})}async $createContributedProfileTerminal(t,o){const g=new u.CancellationTokenSource().token;let h=await this._profileProviders.get(t)?.provideTerminalProfile(g);if(!g.isCancellationRequested){if(h&&!("options"in h)&&(h={options:h}),!h||!("options"in h))throw new Error(`No terminal profile options provided for id "${t}"`);if("pty"in h.options){this.createExtensionTerminal(h.options,o);return}this.createTerminalFromOptions(h.options,o)}}async $provideLinks(t,o){const g=this._getTerminalById(t);if(!g)return[];this._terminalLinkCache.delete(t);const h=this._terminalLinkCancellationSource.get(t);h&&h.dispose(!0);const _=new u.CancellationTokenSource;this._terminalLinkCancellationSource.set(t,_);const P=[],R={terminal:g.value,line:o},W=[];for(const z of this._linkProviders)W.push(S.Promises.withAsyncBody(async q=>{_.token.onCancellationRequested(()=>q({provider:z,links:[]}));const G=await z.provideTerminalLinks(R,_.token)||[];_.token.isCancellationRequested||q({provider:z,links:G})}));const E=await Promise.all(W);if(_.token.isCancellationRequested)return[];const H=new Map;for(const z of E)z&&z.links.length>0&&P.push(...z.links.map(q=>{const G={id:p++,startIndex:q.startIndex,length:q.length,label:q.tooltip};return H.set(G.id,{provider:z.provider,link:q}),G}));return this._terminalLinkCache.set(t,H),P}$activateLink(t,o){const g=this._terminalLinkCache.get(t)?.get(o);!g||g.provider.handleTerminalLink(g.link)}_onProcessExit(t,o){this._bufferer.stopBuffering(t),this._terminalProcesses.delete(t),delete this._extensionTerminalAwaitingStart[t];const g=this._terminalProcessDisposables[t];g&&(g.dispose(),delete this._terminalProcessDisposables[t]),this._proxy.$sendProcessExit(t,o)}_getTerminalById(t){return this._getTerminalObjectById(this._terminals,t)}_getTerminalObjectById(t,o){const g=this._getTerminalObjectIndexById(t,o);return g!==null?t[g]:null}_getTerminalObjectIndexById(t,o){let g=null;return t.some((h,_)=>h._id===o?(g=_,!0):!1),g}getEnvironmentVariableCollection(t){let o=this._environmentVariableCollections.get(t.identifier.value);return o||(o=new a,this._setEnvironmentVariableCollection(t.identifier.value,o)),o}_syncEnvironmentVariableCollection(t,o){const g=(0,v.serializeEnvironmentVariableCollection)(o.map);this._proxy.$setEnvironmentVariableCollection(t,o.persistent,g.length===0?void 0:g)}$initEnvironmentVariableCollections(t){t.forEach(o=>{const g=o[0],h=new a(o[1]);this._setEnvironmentVariableCollection(g,h)})}$acceptDefaultProfile(t,o){this._defaultProfile=t,this._defaultAutomationProfile=o}_setEnvironmentVariableCollection(t,o){this._environmentVariableCollections.set(t,o),o.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(t,o)})}};w=Fe([Ne(1,D.IExtHostRpcService)],w),e.BaseExtHostTerminalService=w;class a{constructor(t){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new s.Emitter,this.map=new Map(t)}get persistent(){return this._persistent}set persistent(t){this._persistent=t,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(t,o){this._setIfDiffers(t,{value:o,type:y.EnvironmentVariableMutatorType.Replace})}append(t,o){this._setIfDiffers(t,{value:o,type:y.EnvironmentVariableMutatorType.Append})}prepend(t,o){this._setIfDiffers(t,{value:o,type:y.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(t,o){const g=this.map.get(t);(!g||g.value!==o.value||g.type!==o.type)&&(this.map.set(t,o),this._onDidChangeCollection.fire())}get(t){return this.map.get(t)}forEach(t,o){this.map.forEach((g,h)=>t.call(o,h,g,this))}delete(t){this.map.delete(t),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=a;let T=class extends w{constructor(t){super(!1,t)}createTerminal(t,o,g){throw new L.NotSupportedError}createTerminalFromOptions(t,o){throw new L.NotSupportedError}};T=Fe([Ne(0,D.IExtHostRpcService)],T),e.WorkerExtHostTerminalService=T;function r(c){if(!(!c||typeof c=="string"))return"id"in c?{id:c.id,color:c.color}:c}function i(c){return n.ThemeColor.isThemeColor(c)?c:void 0}});var je=this&&this.__classPrivateFieldSet||function(J,e,s,I,b){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!b:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?b.call(J,s):b?b.value=s:e.set(J,s),s},De=this&&this.__classPrivateFieldGet||function(J,e,s,I){if(s==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?I:s==="a"?I.call(J):I?I.value:e.get(J)};define(Ee[202],we([1,0,16,21,20,5,233,93,6,26,11,36,4,14,47,8,7,171,62,63]),function(J,e,s,I,b,B,D,A,y,M,L,v,u,m,l,n,f,S,k,d){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let w=class{constructor(R,W){this.resultsChangedEmitter=new B.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=R.getProxy(u.MainContext.MainThreadTesting),this.observer=new g(this.proxy),this.runTracker=new T(this.proxy),W.registerArgumentProcessor({processArgument:E=>E?.$mid===13?n.TestItem.toItemFromContext(E):E})}createTestController(R,W,E){if(this.controllers.has(R))throw new Error(`Attempt to insert a duplicate controller with ID "${R}"`);const H=new y.DisposableStore,z=H.add(new S.SingleUseTestCollection(R));z.root.label=W;const q=new Map,G=this.proxy,j={items:z.root.children,get label(){return W},set label(ee){W=ee,z.root.label=ee,G.$updateController(R,{label:W})},get refreshHandler(){return E},set refreshHandler(ee){E=ee,G.$updateController(R,{canRefresh:!!ee})},get id(){return R},createRunProfile:(ee,se,Z,le,ue)=>{let Se=(0,A.hash)(ee);for(;q.has(Se);)Se++;const fe=new h(this.proxy,R,Se,ee,se,Z,le,ue);return q.set(Se,fe),fe},createTestItem(ee,se,Z){return new l.TestItemImpl(R,ee,se,Z)},createTestRun:(ee,se,Z=!0)=>this.runTracker.createTestRun(R,z,ee,se,Z),set resolveHandler(ee){z.resolveHandler=ee},get resolveHandler(){return z.resolveHandler},dispose:()=>{H.dispose()}};G.$registerTestController(R,W,!!E),H.add((0,y.toDisposable)(()=>G.$unregisterTestController(R)));const $={controller:j,collection:z,profiles:q};return this.controllers.set(R,$),H.add((0,y.toDisposable)(()=>this.controllers.delete(R))),H.add(z.onDidGenerateDiff(ee=>G.$publishDiff(R,ee.map(k.TestsDiffOp.serialize)))),j}createTestObserver(){return this.observer.checkout()}async runTests(R,W=b.CancellationToken.None){const E=r(R);if(!E)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const H=this.controllers.get(E.controllerId);if(!H)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:R.include?.map(z=>z.id)??[H.collection.root.id],profileGroup:_[E.kind],profileId:E.profileId,controllerId:E.controllerId}],exclude:R.exclude?.map(z=>z.id)},W)}$provideFileCoverage(R,W,E){return(0,s.mapFind)(this.runTracker.trackers,z=>z.id===R?z.getCoverage(W):void 0)?.provideFileCoverage(E)??Promise.resolve([])}$resolveFileCoverage(R,W,E,H){return(0,s.mapFind)(this.runTracker.trackers,q=>q.id===R?q.getCoverage(W):void 0)?.resolveFileCoverage(E,H)??Promise.resolve([])}$configureRunProfile(R,W){this.controllers.get(R)?.profiles.get(W)?.configureHandler?.()}async $refreshTests(R,W){await this.controllers.get(R)?.controller.refreshHandler?.(W)}$publishTestResults(R){this.results=Object.freeze(R.map(W=>(0,M.deepFreeze)(n.TestResults.to(W))).concat(this.results).sort((W,E)=>E.completedAt-W.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(R,W){const E=this.controllers.get(d.TestId.fromString(R).controllerId)?.collection;E&&(await E.expand(R,W<0?1/0:W),E.flushDiff())}$acceptDiff(R){this.observer.applyDiff(R.map(k.TestsDiffOp.deserialize))}async $runControllerTests(R,W){const E=this.controllers.get(R.controllerId);if(!E)return;const{collection:H,profiles:z}=E,q=z.get(R.profileId);if(!q)return;const G=R.testIds.map(se=>H.tree.get(se)).filter(L.isDefined),j=R.excludeExtIds.map(se=>E.collection.tree.get(se)).filter(L.isDefined).filter(se=>G.some(Z=>Z.fullId.compare(se.fullId)===2));if(!G.length)return;const $=new f.TestRunRequest(G.some(se=>se.actual instanceof l.TestItemRootImpl)?void 0:G.map(se=>se.actual),j.map(se=>se.actual),q),ee=this.runTracker.prepareForMainThreadTestRun($,i.fromInternal(R,E.collection),W);try{await q.runHandler($,W)}finally{ee.isRunning&&!W.isCancellationRequested&&await B.Event.toPromise(ee.onEnd),ee.dispose()}}$cancelExtensionTestRun(R){R===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(R)}};w=Fe([Ne(0,m.IExtHostRpcService)],w),e.ExtHostTesting=w;class a extends y.Disposable{constructor(R,W,E){super();this.dto=R,this.proxy=W,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new B.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new b.CancellationTokenSource(E)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:H}of this.tasks.values())H.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(R){return this.tasks.get(R)?.coverage}createRun(R){const W=this.dto.id,E=this.dto.controllerId,H=(0,v.generateUuid)(),z=new c(this.proxy,W,H),q=ee=>(se,...Z)=>{if(j){console.warn(`Setting the state of test "${se.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(se)||(this.ensureTestIsKnown(se),ee(se,...Z))},G=(ee,se)=>{const Z=se instanceof Array?se.map(n.TestMessage.from):[n.TestMessage.from(se)];if(ee.uri&&ee.range){const le={range:n.Range.from(ee.range),uri:ee.uri};for(const ue of Z)ue.location=ue.location||le}this.proxy.$appendTestMessagesInRun(W,H,d.TestId.fromExtHostTestItem(ee,E).toString(),Z)};let j=!1;const $={isPersisted:this.dto.isPersisted,token:this.cts.token,name:R,get coverageProvider(){return z.coverageProvider},set coverageProvider(ee){z.coverageProvider=ee},enqueued:q(ee=>{this.proxy.$updateTestStateInRun(W,H,d.TestId.fromExtHostTestItem(ee,E).toString(),1)}),skipped:q(ee=>{this.proxy.$updateTestStateInRun(W,H,d.TestId.fromExtHostTestItem(ee,E).toString(),5)}),started:q(ee=>{this.proxy.$updateTestStateInRun(W,H,d.TestId.fromExtHostTestItem(ee,E).toString(),2)}),errored:q((ee,se,Z)=>{G(ee,se),this.proxy.$updateTestStateInRun(W,H,d.TestId.fromExtHostTestItem(ee,E).toString(),6,Z)}),failed:q((ee,se,Z)=>{G(ee,se),this.proxy.$updateTestStateInRun(W,H,d.TestId.fromExtHostTestItem(ee,E).toString(),4,Z)}),passed:q((ee,se)=>{this.proxy.$updateTestStateInRun(W,H,d.TestId.fromExtHostTestItem(ee,this.dto.controllerId).toString(),3,se)}),appendOutput:(ee,se,Z)=>{j||(Z&&(this.dto.isIncluded(Z)?this.ensureTestIsKnown(Z):Z=void 0),this.proxy.$appendOutputToRun(W,H,I.VSBuffer.fromString(ee),se&&n.location.from(se),Z&&d.TestId.fromExtHostTestItem(Z,E).toString()))},end:()=>{j||(j=!0,this.proxy.$finishedTestRunTask(W,H),this.tasks.delete(H),this.isRunning||this.dispose())}};return this.tasks.set(H,{run:$,coverage:z}),this.proxy.$startedTestRunTask(W,{id:H,name:R,running:!0}),$}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(R){if(!(R instanceof l.TestItemImpl))throw new l.InvalidTestItemError(R.id);if(this.sharedTestIds.has(d.TestId.fromExtHostTestItem(R,this.dto.controllerId).toString()))return;const W=[],E=this.dto.colllection.root;for(;;){const H=n.TestItem.from(R);if(W.unshift(H),this.sharedTestIds.has(H.extId)||(this.sharedTestIds.add(H.extId),R===E))break;R=R.parent||E}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,W)}}class T{constructor(R){this.proxy=R,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(R,W,E){return this.getTracker(R,W,E)}cancelRunById(R){for(const W of this.tracked.values())if(W.id===R){W.dispose();return}}cancelAllRuns(){for(const R of this.tracked.values())R.dispose()}createTestRun(R,W,E,H,z){const q=this.tracked.get(E);if(q)return q.createRun(H);const G=i.fromPublic(R,W,E,z),j=r(E);this.proxy.$startedExtensionTestRun({controllerId:R,profile:j&&{group:_[j.kind],id:j.profileId},exclude:E.exclude?.map(ee=>ee.id)??[],id:G.id,include:E.include?.map(ee=>ee.id)??[W.root.id],persist:z});const $=this.getTracker(E,G);return $.onEnd(()=>this.proxy.$finishedExtensionTestRun(G.id)),$.createRun(H)}getTracker(R,W,E){const H=new a(W,this.proxy,E);return this.tracked.set(R,H),H.onEnd(()=>this.tracked.delete(R)),H}}e.TestRunCoordinator=T;const r=P=>{if(!!P.profile){if(!(P.profile instanceof h))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return P.profile}};class i{constructor(R,W,E,H,z,q){this.controllerId=R,this.id=W,this.isPersisted=z,this.colllection=q,this.includePrefix=E.map(G=>G+"\0"),this.excludePrefix=H.map(G=>G+"\0")}static fromPublic(R,W,E,H){return new i(R,(0,v.generateUuid)(),E.include?.map(z=>d.TestId.fromExtHostTestItem(z,R).toString())??[R],E.exclude?.map(z=>d.TestId.fromExtHostTestItem(z,R).toString())??[],H,W)}static fromInternal(R,W){return new i(R.controllerId,R.runId,R.testIds,R.excludeExtIds,!0,W)}isIncluded(R){const W=d.TestId.fromExtHostTestItem(R,this.controllerId).toString()+"\0";for(const E of this.excludePrefix)if(W===E||W.startsWith(E))return!1;for(const E of this.includePrefix)if(W===E||W.startsWith(E))return!0;return!1}}e.TestRunDto=i;class c{constructor(R,W,E){this.proxy=R,this.runId=W,this.taskId=E}set coverageProvider(R){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!R||(this._coverageProvider=R,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(R){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(R))());try{return(await this.fileCoverage)?.map(n.TestCoverage.fromFile)??[]}catch(W){throw this.fileCoverage=void 0,W}}async resolveFileCoverage(R,W){const E=await this.fileCoverage;let H=E?.[R];return!this._coverageProvider||!E||!H?[]:(H.detailedCoverage||(H=E[R]=await this._coverageProvider.resolveFileCoverage?.(H,W)??H),H.detailedCoverage?.map(n.TestCoverage.fromDetailed)??[])}}class t extends k.IncrementalChangeCollector{constructor(R){super();this.emitter=R,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(R){this.added.add(R)}update(R){Object.assign(R.revived,n.TestItem.toPlain(R.item)),this.added.has(R)||this.updated.add(R)}remove(R){if(this.added.has(R)){this.added.delete(R);return}if(this.updated.delete(R),R.parent&&this.alreadyRemoved.has(R.parent)){this.alreadyRemoved.add(R.item.extId);return}this.removed.add(R)}getChangeEvent(){const{added:R,updated:W,removed:E}=this;return{get added(){return[...R].map(H=>H.revived)},get updated(){return[...W].map(H=>H.revived)},get removed(){return[...E].map(H=>H.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class o extends k.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new B.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(R){return this.items.get(R)}getMirroredTestDataByReference(R){return this.items.get(R.id)}createItem(R,W){return{...R,revived:n.TestItem.toPlain(R.item),depth:W?W.depth+1:0,children:new Set}}createChangeCollector(){return new t(this.changeEmitter)}}e.MirroredTestCollection=o;class g{constructor(R){this.proxy=R}checkout(){this.current||(this.current=this.createObserverData());const R=this.current;return R.observers++,{onDidChangeTest:R.tests.onDidChangeTests,get tests(){return[...R.tests.rootTests].map(W=>W.revived)},dispose:(0,D.once)(()=>{--R.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(R){return this.current?.tests.getMirroredTestDataByReference(R)}applyDiff(R){this.current?.tests.apply(R)}createObserverData(){const R=new o;return this.proxy.$subscribeToDiffs(),{observers:0,tests:R}}}class h{constructor(R,W,E,H,z,q,G=!1,j=void 0){this.controllerId=W,this.profileId=E,this._label=H,this.kind=z,this.runHandler=q,this._isDefault=G,this._tag=j,p.set(this,void 0),je(this,p,R,"f");const $=_[z];if(typeof $!="number")throw new Error(`Unknown TestRunProfile.group ${z}`);De(this,p,"f").$publishTestRunProfile({profileId:E,controllerId:W,tag:j?n.TestTag.namespace(this.controllerId,j.id):null,label:H,group:$,isDefault:G,hasConfigurationHandler:!1})}get label(){return this._label}set label(R){R!==this._label&&(this._label=R,De(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:R}))}get isDefault(){return this._isDefault}set isDefault(R){R!==this._isDefault&&(this._isDefault=R,De(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:R}))}get tag(){return this._tag}set tag(R){R?.id!==this._tag?.id&&(this._tag=R,De(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:R?n.TestTag.namespace(this.controllerId,R.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(R){R!==this._configureHandler&&(this._configureHandler=R,De(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!R}))}dispose(){De(this,p,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=h,p=new WeakMap;const _={[f.TestRunProfileKind.Coverage]:8,[f.TestRunProfileKind.Debug]:4,[f.TestRunProfileKind.Run]:2}}),define(Ee[203],we([1,0,5,16,4,90,8,7]),function(J,e,s,I,b,B,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class y{constructor(L,v){this._extHostDocumentsAndEditors=v,this._onDidChangeTextEditorSelection=new s.Emitter,this._onDidChangeTextEditorOptions=new s.Emitter,this._onDidChangeTextEditorVisibleRanges=new s.Emitter,this._onDidChangeTextEditorViewColumn=new s.Emitter,this._onDidChangeActiveTextEditor=new s.Emitter,this._onDidChangeVisibleTextEditors=new s.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=L.getProxy(b.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(u=>this._onDidChangeVisibleTextEditors.fire(u)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(u=>this._onDidChangeActiveTextEditor.fire(u))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(L){const v=this._extHostDocumentsAndEditors.allEditors();return L?v:v.map(u=>u.value)}async showTextDocument(L,v,u){let m;typeof v=="number"?m={position:D.ViewColumn.from(v),preserveFocus:u}:typeof v=="object"?m={position:D.ViewColumn.from(v.viewColumn),preserveFocus:v.preserveFocus,selection:typeof v.selection=="object"?D.Range.from(v.selection):void 0,pinned:typeof v.preview=="boolean"?!v.preview:void 0}:m={preserveFocus:!1};const l=await this._proxy.$tryShowTextDocument(L.uri,m),n=l&&this._extHostDocumentsAndEditors.getEditor(l);if(n)return n.value;throw l?new Error(`Could NOT open editor for "${L.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${L.uri.toString()}".`)}createTextEditorDecorationType(L,v){return new B.TextEditorDecorationType(this._proxy,L,v).value}$acceptEditorPropertiesChanged(L,v){const u=this._extHostDocumentsAndEditors.getEditor(L);if(!u)throw new Error("unknown text editor");if(v.options&&u._acceptOptions(v.options),v.selections){const m=v.selections.selections.map(D.Selection.to);u._acceptSelections(m)}if(v.visibleRanges){const m=I.coalesce(v.visibleRanges.map(D.Range.to));u._acceptVisibleRanges(m)}if(v.options&&this._onDidChangeTextEditorOptions.fire({textEditor:u.value,options:{...v.options,lineNumbers:D.TextEditorLineNumbersStyle.to(v.options.lineNumbers)}}),v.selections){const m=A.TextEditorSelectionChangeKind.fromValue(v.selections.source),l=v.selections.selections.map(D.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:u.value,selections:l,kind:m})}if(v.visibleRanges){const m=I.coalesce(v.visibleRanges.map(D.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:u.value,visibleRanges:m})}}$acceptEditorPositionData(L){for(const v in L){const u=this._extHostDocumentsAndEditors.getEditor(v);if(!u)throw new Error("Unknown text editor");const m=D.ViewColumn.to(L[v]);u.value.viewColumn!==m&&(u._acceptViewColumn(m),this._onDidChangeTextEditorViewColumn.fire({textEditor:u.value,viewColumn:m}))}}getDiffInformation(L){return Promise.resolve(this._proxy.$getDiffInformation(L))}}e.ExtHostEditors=y}),define(Ee[204],we([1,0,2,3,4,6,7,8,11]),function(J,e,s,I,b,B,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,I.createDecorator)("IExtHostTimeline");class M{constructor(u,m){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=u.getProxy(b.MainContext.MainThreadTimeline),m.registerArgumentProcessor({processArgument:l=>{if(l&&l.$mid===11){const n=l.uri===void 0?void 0:s.URI.revive(l.uri);return this._itemsBySourceAndUriMap.get(l.source)?.get(L(n))?.get(l.handle)}return l}})}async $getTimeline(u,m,l,n,f){return this._providers.get(u)?.provideTimeline(s.URI.revive(m),l,n,f)}registerTimelineProvider(u,m,l,n){const f=new B.DisposableStore,S=this.convertTimelineItem(m.id,n,f).bind(this);let k;m.onDidChange&&(k=m.onDidChange(p=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...p,id:m.id}),this));const d=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...m,scheme:u,onDidChange:void 0,async provideTimeline(p,w,a,T){T?.resetCache&&(f.clear(),d.get(m.id)?.clear());const r=await m.provideTimeline(p,w,a);if(r==null)return;const i=S(p,T);return{...r,source:m.id,items:r.items.map(i)}},dispose(){for(const p of d.values())p.get(m.id)?.clear();k?.dispose(),f.dispose()}})}convertTimelineItem(u,m,l){return(n,f)=>{let S;if(f?.cacheResults){let k=this._itemsBySourceAndUriMap.get(u);k===void 0&&(k=new Map,this._itemsBySourceAndUriMap.set(u,k));const d=L(n);S=k.get(d),S===void 0&&(S=new Map,k.set(d,S))}return k=>{const{iconPath:d,...p}=k,w=`${u}|${k.id??k.timestamp}`;S?.set(w,k);let a,T,r;k.iconPath&&(d instanceof D.ThemeIcon?r={id:d.id,color:d.color}:s.URI.isUri(d)?(a=d,T=d):{light:a,dark:T}=d);let i;return D.MarkdownString.isMarkdownString(p.detail)?i=A.MarkdownString.from(p.detail):(0,y.isString)(p.detail)&&(i=p.detail),{...p,id:p.id??void 0,handle:w,source:u,command:k.command?m.toInternal(k.command,l):void 0,icon:a,iconDark:T,themeIcon:r,detail:i,accessibilityInformation:k.accessibilityInformation}}}}registerTimelineProviderCore(u){if(this._providers.get(u.id))throw new Error(`Timeline Provider ${u.id} already exists.`);return this._proxy.$registerTimelineProvider({id:u.id,label:u.label,scheme:u.scheme}),this._providers.set(u.id,u),(0,B.toDisposable)(()=>{for(const l of this._itemsBySourceAndUriMap.values())l.get(u.id)?.clear();this._providers.delete(u.id),this._proxy.$unregisterTimelineProvider(u.id),u.dispose()})}}e.ExtHostTimeline=M;function L(v){return v?.toString()}}),define(Ee[205],we([1,0,6,10,2,4]),function(J,e,s,I,b,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class D{constructor(y){this._openers=new Map,this._proxy=y.getProxy(B.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(y,M,L,v){if(this._openers.has(M))throw new Error(`Opener with id '${M}' already registered`);const u=v.schemes.find(m=>!D.supportedSchemes.has(m));if(u)throw new Error(`Scheme '${u}' is not supported. Only http and https are currently supported.`);return this._openers.set(M,L),this._proxy.$registerUriOpener(M,v.schemes,y,v.label),(0,s.toDisposable)(()=>{this._openers.delete(M),this._proxy.$unregisterUriOpener(M)})}async $canOpenUri(y,M,L){const v=this._openers.get(y);if(!v)throw new Error(`Unknown opener with id: ${y}`);const u=b.URI.revive(M);return v.canOpenExternalUri(u,L)}async $openUri(y,M,L){const v=this._openers.get(y);if(!v)throw new Error(`Unknown opener id: '${y}'`);return v.openExternalUri(b.URI.revive(M.resolvedUri),{sourceUri:b.URI.revive(M.sourceUri)},L)}}e.ExtHostUriOpeners=D,D.supportedSchemes=new Set([I.Schemas.http,I.Schemas.https])}),define(Ee[206],we([1,0,4,2,6,15,25]),function(J,e,s,I,b,B,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class A{constructor(M){this.handles=new Set,this.handlers=new Map,this._proxy=M.getProxy(s.MainContext.MainThreadUrls)}registerUriHandler(M,L){if(this.handles.has(D.ExtensionIdentifier.toKey(M)))throw new Error(`Protocol handler already registered for extension ${M}`);const v=A.HandlePool++;return this.handles.add(D.ExtensionIdentifier.toKey(M)),this.handlers.set(v,L),this._proxy.$registerUriHandler(v,M),(0,b.toDisposable)(()=>{this.handles.delete(D.ExtensionIdentifier.toKey(M)),this.handlers.delete(v),this._proxy.$unregisterUriHandler(v)})}$handleExternalUri(M,L){const v=this.handlers.get(M);if(!v)return Promise.resolve(void 0);try{v.handleUri(I.URI.revive(L))}catch(u){(0,B.onUnexpectedError)(u)}return Promise.resolve(void 0)}async createAppUri(M){return I.URI.revive(await this._proxy.$createAppUri(M))}}e.ExtHostUrls=A,A.HandlePool=0});var je=this&&this.__classPrivateFieldSet||function(J,e,s,I,b){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!b:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?b.call(J,s):b?b.value=s:e.set(J,s),s},De=this&&this.__classPrivateFieldGet||function(J,e,s,I){if(s==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?I:s==="a"?I.call(J):I?I.value:e.get(J)};define(Ee[51],we([1,0,5,10,2,136,154,61,4]),function(J,e,s,I,b,B,D,A,y){"use strict";var M,L,v,u,m,l,n,f,S,k,d,p;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class w{constructor(g,h,_,P,R,W,E){M.set(this,void 0),L.set(this,void 0),v.set(this,void 0),u.set(this,void 0),m.set(this,void 0),l.set(this,void 0),n.set(this,""),f.set(this,void 0),S.set(this,!1),k.set(this,!1),d.set(this,!1),this._onMessageEmitter=new s.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,p.set(this,new s.Emitter),this._onDidDispose=De(this,p,"f").event,je(this,M,g,"f"),je(this,L,h,"f"),je(this,f,_,"f"),je(this,u,P,"f"),je(this,m,R,"f"),je(this,l,W,"f"),je(this,d,a(W),"f"),je(this,v,E,"f")}dispose(){je(this,S,!0,"f"),De(this,p,"f").fire(),De(this,p,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(g){return je(this,k,!0,"f"),(0,A.asWebviewUri)(g,De(this,u,"f").remote)}get cspSource(){const g=De(this,l,"f").extensionLocation;if(g.scheme===I.Schemas.https||g.scheme===I.Schemas.http){let h=g.toString();return h.endsWith("/")||(h+="/"),h+" "+A.webviewGenericCspSource}return A.webviewGenericCspSource}get html(){return this.assertNotDisposed(),De(this,n,"f")}set html(g){this.assertNotDisposed(),De(this,n,"f")!==g&&(je(this,n,g,"f"),!De(this,k,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(g)&&(je(this,k,!0,"f"),De(this,v,"f").report("Webview vscode-resource: uris",De(this,l,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),De(this,L,"f").$setHtml(De(this,M,"f"),g))}get options(){return this.assertNotDisposed(),De(this,f,"f")}set options(g){this.assertNotDisposed(),De(this,L,"f").$setOptions(De(this,M,"f"),i(De(this,l,"f"),De(this,m,"f"),g)),je(this,f,g,"f")}async postMessage(g){if(De(this,S,"f"))return!1;const h=(0,D.serializeWebviewMessage)(g,{serializeBuffersForPostMessage:De(this,d,"f")});return De(this,L,"f").$postMessage(De(this,M,"f"),h.message,...h.buffers)}assertNotDisposed(){if(De(this,S,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=w,M=new WeakMap,L=new WeakMap,v=new WeakMap,u=new WeakMap,m=new WeakMap,l=new WeakMap,n=new WeakMap,f=new WeakMap,S=new WeakMap,k=new WeakMap,d=new WeakMap,p=new WeakMap;function a(o){try{const g=(0,B.normalizeVersion)((0,B.parseVersion)(o.engines.vscode));return!!g&&g.majorBase>=1&&g.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=a;class T{constructor(g,h,_,P,R){this.initData=h,this.workspace=_,this._logService=P,this._deprecationService=R,this._webviews=new Map,this._webviewProxy=g.getProxy(y.MainContext.MainThreadWebviews)}$onMessage(g,h,_){const P=this.getWebview(g);if(P){const{message:R}=(0,D.deserializeWebviewMessage)(h,_.value);P._onMessageEmitter.fire(R)}}$onMissingCsp(g,h){this._logService.warn(`${h} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(g,h,_){const P=new w(g,this._webviewProxy,c(h),this.initData,this.workspace,_,this._deprecationService);return this._webviews.set(g,P),P._onDidDispose(()=>{this._webviews.delete(g)}),P}deleteWebview(g){this._webviews.delete(g)}getWebview(g){return this._webviews.get(g)}}e.ExtHostWebviews=T;function r(o){return{id:o.identifier,location:o.extensionLocation}}e.toExtensionData=r;function i(o,g,h){return{enableCommandUris:h.enableCommandUris,enableScripts:h.enableScripts,enableForms:h.enableForms,portMapping:h.portMapping,localResourceRoots:h.localResourceRoots||t(o,g)}}e.serializeWebviewOptions=i;function c(o){return{enableCommandUris:o.enableCommandUris,enableScripts:o.enableScripts,enableForms:o.enableForms,portMapping:o.portMapping,localResourceRoots:o.localResourceRoots?.map(g=>b.URI.from(g))}}e.reviveOptions=c;function t(o,g){return[...(g?.getWorkspaceFolders()||[]).map(h=>h.uri),o.extensionLocation]}}),define(Ee[207],we([1,0,20,93,6,10,24,2,8,51,58,4,7]),function(J,e,s,I,b,B,D,A,y,M,L,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class m{constructor(a,T){this.document=a,this._storagePath=T,this._backupCounter=1,this._edits=new L.Cache("custom documents")}addEdit(a){return this._edits.add([a])}async undo(a,T){await this.getEdit(a).undo(),T||this.disposeBackup()}async redo(a,T){await this.getEdit(a).redo(),T||this.disposeBackup()}disposeEdits(a){for(const T of a)this._edits.delete(T)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const a=p(this.document.uri)+this._backupCounter++;return(0,D.joinPath)(this._storagePath,a)}updateBackup(a){this._backup?.delete(),this._backup=a}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(a){const T=this._edits.get(a,0);if(!T)throw new Error("No edit found");return T}}class l{constructor(){this._documents=new Map}get(a,T){return this._documents.get(this.key(a,T))}add(a,T,r){const i=this.key(a,T.uri);if(this._documents.has(i))throw new Error(`Document already exists for viewType:${a} resource:${T.uri}`);const c=new m(T,r);return this._documents.set(i,c),c}delete(a,T){const r=this.key(a,T.uri);this._documents.delete(r)}key(a,T){return`${a}@@@${T}`}}var n;(function(w){w[w.Text=0]="Text",w[w.Custom=1]="Custom"})(n||(n={}));class f{constructor(){this._providers=new Map}addTextProvider(a,T,r){return this.add(0,a,T,r)}addCustomProvider(a,T,r){return this.add(1,a,T,r)}get(a){return this._providers.get(a)}add(a,T,r,i){if(this._providers.has(T))throw new Error(`Provider for viewType:${T} already registered`);return this._providers.set(T,{type:a,extension:r,provider:i}),new u.Disposable(()=>this._providers.delete(T))}}class S{constructor(a,T,r,i,c){this._extHostDocuments=T,this._extensionStoragePaths=r,this._extHostWebview=i,this._extHostWebviewPanels=c,this._editorProviders=new f,this._documents=new l,this._proxy=a.getProxy(v.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(a,T,r,i){const c=new b.DisposableStore;return k(r)?(c.add(this._editorProviders.addTextProvider(T,a,r)),this._proxy.$registerTextEditorProvider((0,M.toExtensionData)(a),T,i.webviewOptions||{},{supportsMove:!!r.moveCustomTextEditor},(0,M.shouldSerializeBuffersForPostMessage)(a))):(c.add(this._editorProviders.addCustomProvider(T,a,r)),this.supportEditing(r)&&c.add(r.onDidChangeCustomDocument(t=>{const o=this.getCustomDocumentEntry(T,t.document.uri);if(d(t)){const g=o.addEdit(t);this._proxy.$onDidEdit(t.document.uri,T,g,t.label)}else this._proxy.$onContentChange(t.document.uri,T)})),this._proxy.$registerCustomEditorProvider((0,M.toExtensionData)(a),T,i.webviewOptions||{},!!i.supportsMultipleEditorsPerDocument,(0,M.shouldSerializeBuffersForPostMessage)(a))),u.Disposable.from(c,new u.Disposable(()=>{this._proxy.$unregisterEditorProvider(T)}))}async $createCustomDocument(a,T,r,i,c){const t=this._editorProviders.get(T);if(!t)throw new Error(`No provider found for '${T}'`);if(t.type!==1)throw new Error(`Invalid provide type for '${T}'`);const o=A.URI.revive(a),g=await t.provider.openCustomDocument(o,{backupId:r,untitledDocumentData:i?.buffer},c);let h;return this.supportEditing(t.provider)&&this._extensionStoragePaths&&(h=this._extensionStoragePaths.workspaceValue(t.extension)??this._extensionStoragePaths.globalValue(t.extension)),this._documents.add(T,g,h),{editable:this.supportEditing(t.provider)}}async $disposeCustomDocument(a,T){const r=this._editorProviders.get(T);if(!r)throw new Error(`No provider found for '${T}'`);if(r.type!==1)throw new Error(`Invalid provider type for '${T}'`);const i=A.URI.revive(a),{document:c}=this.getCustomDocumentEntry(T,i);this._documents.delete(T,c),c.dispose()}async $resolveWebviewEditor(a,T,r,i,c,t){const o=this._editorProviders.get(r);if(!o)throw new Error(`No provider found for '${r}'`);const g=y.ViewColumn.to(c),h=this._extHostWebview.createNewWebview(T,i.webviewOptions,o.extension),_=this._extHostWebviewPanels.createNewWebviewPanel(T,r,i.title,g,i.panelOptions,h),P=A.URI.revive(a);switch(o.type){case 1:{const{document:R}=this.getCustomDocumentEntry(r,P);return o.provider.resolveCustomEditor(R,_,t)}case 0:{const R=this._extHostDocuments.getDocument(P);return o.provider.resolveCustomTextEditor(R,_,t)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(a,T,r){this.getCustomDocumentEntry(T,a).disposeEdits(r)}async $onMoveCustomEditor(a,T,r){const i=this._editorProviders.get(r);if(!i)throw new Error(`No provider found for '${r}'`);if(!i.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${r}'`);const c=this._extHostWebviewPanels.getWebviewPanel(a);if(!c)throw new Error("No webview found");const t=A.URI.revive(T),o=this._extHostDocuments.getDocument(t);await i.provider.moveCustomTextEditor(o,c,s.CancellationToken.None)}async $undo(a,T,r,i){return this.getCustomDocumentEntry(T,a).undo(r,i)}async $redo(a,T,r,i){return this.getCustomDocumentEntry(T,a).redo(r,i)}async $revert(a,T,r){const i=this.getCustomDocumentEntry(T,a);await this.getCustomEditorProvider(T).revertCustomDocument(i.document,r),i.disposeBackup()}async $onSave(a,T,r){const i=this.getCustomDocumentEntry(T,a);await this.getCustomEditorProvider(T).saveCustomDocument(i.document,r),i.disposeBackup()}async $onSaveAs(a,T,r,i){const c=this.getCustomDocumentEntry(T,a);return this.getCustomEditorProvider(T).saveCustomDocumentAs(c.document,A.URI.revive(r),i)}async $backup(a,T,r){const i=this.getCustomDocumentEntry(T,a),t=await this.getCustomEditorProvider(T).backupCustomDocument(i.document,{destination:i.getNewBackupUri()},r);return i.updateBackup(t),t.id}getCustomDocumentEntry(a,T){const r=this._documents.get(a,A.URI.revive(T));if(!r)throw new Error("No custom document found");return r}getCustomEditorProvider(a){const r=this._editorProviders.get(a)?.provider;if(!r||!this.supportEditing(r))throw new Error("Custom document is not editable");return r}supportEditing(a){return!!a.onDidChangeCustomDocument}}e.ExtHostCustomEditors=S;function k(w){return typeof w.resolveCustomTextEditor=="function"}function d(w){return typeof w.undo=="function"&&typeof w.redo=="function"}function p(w){const a=w.scheme===B.Schemas.file||w.scheme===B.Schemas.untitled?w.fsPath:w.toString();return(0,I.hash)(a)+""}});var je=this&&this.__classPrivateFieldSet||function(J,e,s,I,b){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!b:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?b.call(J,s):b?b.value=s:e.set(J,s),s},De=this&&this.__classPrivateFieldGet||function(J,e,s,I){if(s==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?I:s==="a"?I.call(J):I?I.value:e.get(J)};define(Ee[208],we([1,0,5,6,2,36,8,51,4,7]),function(J,e,s,I,b,B,D,A,y,M){"use strict";var L,v,u,m,l,n,f,S,k,d,p,w,a;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class T extends I.Disposable{constructor(t,o,g,h,_,P,R){super();L.set(this,void 0),v.set(this,void 0),u.set(this,void 0),m.set(this,void 0),l.set(this,void 0),n.set(this,void 0),f.set(this,void 0),S.set(this,void 0),k.set(this,!0),d.set(this,!0),p.set(this,!1),w.set(this,this._register(new s.Emitter)),this.onDidDispose=De(this,w,"f").event,a.set(this,this._register(new s.Emitter)),this.onDidChangeViewState=De(this,a,"f").event,je(this,L,t,"f"),je(this,v,o,"f"),je(this,u,g,"f"),je(this,l,P,"f"),je(this,S,_,"f"),je(this,n,h,"f"),je(this,m,R,"f")}dispose(){De(this,p,"f")||(je(this,p,!0,"f"),De(this,w,"f").fire(),De(this,v,"f").$disposeWebview(De(this,L,"f")),De(this,m,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),De(this,m,"f")}get viewType(){return this.assertNotDisposed(),De(this,u,"f")}get title(){return this.assertNotDisposed(),De(this,n,"f")}set title(t){this.assertNotDisposed(),De(this,n,"f")!==t&&(je(this,n,t,"f"),De(this,v,"f").$setTitle(De(this,L,"f"),t))}get iconPath(){return this.assertNotDisposed(),De(this,f,"f")}set iconPath(t){this.assertNotDisposed(),De(this,f,"f")!==t&&(je(this,f,t,"f"),De(this,v,"f").$setIconPath(De(this,L,"f"),b.URI.isUri(t)?{light:t,dark:t}:t))}get options(){return De(this,l,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof De(this,S,"f")=="number"&&De(this,S,"f")<0))return De(this,S,"f")}get active(){return this.assertNotDisposed(),De(this,d,"f")}get visible(){return this.assertNotDisposed(),De(this,k,"f")}_updateViewState(t){De(this,p,"f")||(this.active!==t.active||this.visible!==t.visible||this.viewColumn!==t.viewColumn)&&(je(this,d,t.active,"f"),je(this,k,t.visible,"f"),je(this,S,t.viewColumn,"f"),De(this,a,"f").fire({webviewPanel:this}))}reveal(t,o){this.assertNotDisposed(),De(this,v,"f").$reveal(De(this,L,"f"),{viewColumn:typeof t=="undefined"?void 0:D.ViewColumn.from(t),preserveFocus:!!o})}assertNotDisposed(){if(De(this,p,"f"))throw new Error("Webview is disposed")}}L=new WeakMap,v=new WeakMap,u=new WeakMap,m=new WeakMap,l=new WeakMap,n=new WeakMap,f=new WeakMap,S=new WeakMap,k=new WeakMap,d=new WeakMap,p=new WeakMap,w=new WeakMap,a=new WeakMap;class r{constructor(t,o,g){this.webviews=o,this.workspace=g,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=t.getProxy(y.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,B.generateUuid)()}createWebviewPanel(t,o,g,h,_={}){const P=typeof h=="object"?h.viewColumn:h,R={viewColumn:D.ViewColumn.from(P),preserveFocus:typeof h=="object"&&!!h.preserveFocus},W=(0,A.shouldSerializeBuffersForPostMessage)(t),E=r.newHandle();this._proxy.$createWebviewPanel((0,A.toExtensionData)(t),E,o,{title:g,panelOptions:i(_),webviewOptions:(0,A.serializeWebviewOptions)(t,this.workspace,_),serializeBuffersForPostMessage:W},R);const H=this.webviews.createNewWebview(E,_,t);return this.createNewWebviewPanel(E,o,g,P,_,H)}$onDidChangeWebviewPanelViewStates(t){const o=Object.keys(t);o.sort((g,h)=>{const _=t[g],P=t[h];return _.active?1:P.active?-1:+_.visible-+P.visible});for(const g of o){const h=this.getWebviewPanel(g);if(!h)continue;const _=t[g];h._updateViewState({active:_.active,visible:_.visible,viewColumn:D.ViewColumn.to(_.position)})}}async $onDidDisposeWebviewPanel(t){this.getWebviewPanel(t)?.dispose(),this._webviewPanels.delete(t),this.webviews.deleteWebview(t)}registerWebviewPanelSerializer(t,o,g){if(this._serializers.has(o))throw new Error(`Serializer for '${o}' already registered`);return this._serializers.set(o,{serializer:g,extension:t}),this._proxy.$registerSerializer(o,{serializeBuffersForPostMessage:(0,A.shouldSerializeBuffersForPostMessage)(t)}),new M.Disposable(()=>{this._serializers.delete(o),this._proxy.$unregisterSerializer(o)})}async $deserializeWebviewPanel(t,o,g,h){const _=this._serializers.get(o);if(!_)throw new Error(`No serializer found for '${o}'`);const{serializer:P,extension:R}=_,W=this.webviews.createNewWebview(t,g.webviewOptions,R),E=this.createNewWebviewPanel(t,o,g.title,h,g.panelOptions,W);await P.deserializeWebviewPanel(E,g.state)}createNewWebviewPanel(t,o,g,h,_,P){const R=new T(t,this._proxy,o,g,h,_,P);return this._webviewPanels.set(t,R),R}getWebviewPanel(t){return this._webviewPanels.get(t)}}e.ExtHostWebviewPanels=r;function i(c){return{enableFindWidget:c.enableFindWidget,retainContextWhenHidden:c.retainContextWhenHidden}}});var je=this&&this.__classPrivateFieldSet||function(J,e,s,I,b){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!b:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?b.call(J,s):b?b.value=s:e.set(J,s),s},De=this&&this.__classPrivateFieldGet||function(J,e,s,I){if(s==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?I:s==="a"?I.call(J):I?I.value:e.get(J)};define(Ee[209],we([1,0,5,6,51,4,7]),function(J,e,s,I,b,B,D){"use strict";var A,y,M,L,v,u,m,l,n,f;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class S extends I.Disposable{constructor(p,w,a,T,r,i){super();A.set(this,void 0),y.set(this,void 0),M.set(this,void 0),L.set(this,void 0),v.set(this,!1),u.set(this,void 0),m.set(this,void 0),l.set(this,void 0),n.set(this,this._register(new s.Emitter)),this.onDidChangeVisibility=De(this,n,"f").event,f.set(this,this._register(new s.Emitter)),this.onDidDispose=De(this,f,"f").event,je(this,M,a,"f"),je(this,m,T,"f"),je(this,A,p,"f"),je(this,y,w,"f"),je(this,L,r,"f"),je(this,u,i,"f")}dispose(){De(this,v,"f")||(je(this,v,!0,"f"),De(this,f,"f").fire(),De(this,L,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),De(this,m,"f")}set title(p){this.assertNotDisposed(),De(this,m,"f")!==p&&(je(this,m,p,"f"),De(this,y,"f").$setWebviewViewTitle(De(this,A,"f"),p))}get description(){return this.assertNotDisposed(),De(this,l,"f")}set description(p){this.assertNotDisposed(),De(this,l,"f")!==p&&(je(this,l,p,"f"),De(this,y,"f").$setWebviewViewDescription(De(this,A,"f"),p))}get visible(){return De(this,u,"f")}get webview(){return De(this,L,"f")}get viewType(){return De(this,M,"f")}_setVisible(p){p===De(this,u,"f")||De(this,v,"f")||(je(this,u,p,"f"),De(this,n,"f").fire())}show(p){this.assertNotDisposed(),De(this,y,"f").$show(De(this,A,"f"),!!p)}assertNotDisposed(){if(De(this,v,"f"))throw new Error("Webview is disposed")}}A=new WeakMap,y=new WeakMap,M=new WeakMap,L=new WeakMap,v=new WeakMap,u=new WeakMap,m=new WeakMap,l=new WeakMap,n=new WeakMap,f=new WeakMap;class k{constructor(p,w){this._extHostWebview=w,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=p.getProxy(B.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(p,w,a,T){if(this._viewProviders.has(w))throw new Error(`View provider for '${w}' already registered`);return this._viewProviders.set(w,{provider:a,extension:p}),this._proxy.$registerWebviewViewProvider((0,b.toExtensionData)(p),w,{retainContextWhenHidden:T?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new D.Disposable(()=>{this._viewProviders.delete(w),this._proxy.$unregisterWebviewViewProvider(w)})}async $resolveWebviewView(p,w,a,T,r){const i=this._viewProviders.get(w);if(!i)throw new Error(`No view provider found for '${w}'`);const{provider:c,extension:t}=i,o=this._extHostWebview.createNewWebview(p,{},t),g=new S(p,this._proxy,w,a,o,!0);this._webviewViews.set(p,g),await c.resolveWebviewView(g,{state:T},r)}async $onDidChangeWebviewViewVisibility(p,w){this.getWebviewView(p)._setVisible(w)}async $disposeWebviewView(p){const w=this.getWebviewView(p);this._webviewViews.delete(p),w.dispose(),this._extHostWebview.deleteWebview(p)}getWebviewView(p){const w=this._webviewViews.get(p);if(!w)throw new Error("No webview found");return w}}e.ExtHostWebviewViews=k}),define(Ee[95],we([1,0,5,4,2,10,9,3,14]),function(J,e,s,I,b,B,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let M=class ji{constructor(v){this._onDidChangeWindowState=new s.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=ji.InitialState,this._proxy=v.getProxy(I.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(u=>this.$onDidChangeWindowFocus(u))}get state(){return this._state}$onDidChangeWindowFocus(v){v!==this._state.focused&&(this._state={...this._state,focused:v},this._onDidChangeWindowState.fire(this._state))}openUri(v,u){let m;if(typeof v=="string"){m=v;try{v=b.URI.parse(v)}catch{return Promise.reject(`Invalid uri - '${v}'`)}}return(0,D.isFalsyOrWhitespace)(v.scheme)?Promise.reject("Invalid scheme - cannot be empty"):v.scheme===B.Schemas.command?Promise.reject(`Invalid scheme '${v.scheme}'`):this._proxy.$openUri(v,m,u)}async asExternalUri(v,u){if((0,D.isFalsyOrWhitespace)(v.scheme))return Promise.reject("Invalid scheme - cannot be empty");const m=await this._proxy.$asExternalUri(v,u);return b.URI.from(m)}};M.InitialState={focused:!0},M=Fe([Ne(0,y.IExtHostRpcService)],M),e.ExtHostWindow=M,e.IExtHostWindow=(0,A.createDecorator)("IExtHostWindow")}),define(Ee[210],we([1,0,13,21,20,15,5,6,108,176,38]),function(J,e,s,I,b,B,D,A,y,M,L){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function u(_,P){try{return JSON.stringify(_,P)}catch{return"null"}}const m="$$ref$$",l={[m]:-1};class n{constructor(P,R){this.jsonString=P,this.referencedBuffers=R}}function f(_,P=null,R=!1){const W=[];return{jsonString:(R?u:JSON.stringify)(_,(H,z)=>{if(typeof z=="undefined")return l;if(typeof z=="object"){if(z instanceof I.VSBuffer){const q=W.push(z)-1;return{[m]:q}}if(P)return P(H,z)}return z}),referencedBuffers:W}}e.stringifyJsonWithBufferRefs=f;function S(_,P,R){return JSON.parse(_,(W,E)=>{if(E){const H=E[m];if(typeof H=="number")return P[H];if(R&&E.$mid===1)return R.transformIncoming(E)}return E})}e.parseJsonAndRestoreBufferRefs=S;function k(_,P){return JSON.stringify(_,P)}function d(_){return _?(P,R)=>R&&R.$mid===1?_.transformOutgoing(R):R:null}var p;(function(_){_[_.LocalSide=0]="LocalSide",_[_.OtherSide=1]="OtherSide"})(p=e.RequestInitiator||(e.RequestInitiator={}));var w;(function(_){_[_.Responsive=0]="Responsive",_[_.Unresponsive=1]="Unresponsive"})(w=e.ResponsiveState||(e.ResponsiveState={}));const a=()=>{},T=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class i extends A.Disposable{constructor(P,R=null,W=null){super();this[v]=!0,this._onDidChangeResponsiveState=this._register(new D.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=P,this._logger=R,this._uriTransformer=W,this._uriReplacer=d(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let E=0,H=L.ProxyIdentifier.count;E<H;E++)this._locals[E]=null,this._proxies[E]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new s.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(E=>this._receiveOneMessage(E))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(P=>{this._pendingRPCReplies[P].resolveErr(B.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(P){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(P){this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(P){this._responsiveState!==P&&(this._responsiveState=P,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(P){return this._uriTransformer?(0,y.transformIncomingURIs)(P,this._uriTransformer):P}getProxy(P){const{nid:R,sid:W}=P;return this._proxies[R]||(this._proxies[R]=this._createProxy(R,W)),this._proxies[R]}_createProxy(P,R){let W={get:(E,H)=>(typeof H=="string"&&!E[H]&&H.charCodeAt(0)===36&&(E[H]=(...z)=>this._remoteCall(P,H,z)),H===r?R:E[H])};return new Proxy(Object.create(null),W)}set(P,R){return this._locals[P.nid]=R,R}assertRegistered(P){for(let R=0,W=P.length;R<W;R++){const E=P[R];if(!this._locals[E.nid])throw new Error(`Missing proxy instance ${E.sid}`)}}_receiveOneMessage(P){if(this._isDisposed)return;const R=P.byteLength,W=c.read(P,0),E=W.readUInt8(),H=W.readUInt32();switch(E){case 1:case 2:{let{rpcId:z,method:q,args:G}=o.deserializeRequestJSONArgs(W);this._uriTransformer&&(G=(0,y.transformIncomingURIs)(G,this._uriTransformer)),this._receiveRequest(R,H,z,q,G,E===2);break}case 3:case 4:{let{rpcId:z,method:q,args:G}=o.deserializeRequestMixedArgs(W);this._uriTransformer&&(G=(0,y.transformIncomingURIs)(G,this._uriTransformer)),this._receiveRequest(R,H,z,q,G,E===4);break}case 5:{this._logger&&this._logger.logIncoming(R,H,0,"ack"),this._onDidReceiveAcknowledge(H);break}case 6:{this._receiveCancel(R,H);break}case 7:{this._receiveReply(R,H,void 0);break}case 9:{let z=o.deserializeReplyOKJSON(W);this._uriTransformer&&(z=(0,y.transformIncomingURIs)(z,this._uriTransformer)),this._receiveReply(R,H,z);break}case 10:{const z=o.deserializeReplyOKJSONWithBuffers(W,this._uriTransformer);this._receiveReply(R,H,z);break}case 8:{let z=o.deserializeReplyOKVSBuffer(W);this._receiveReply(R,H,z);break}case 11:{let z=o.deserializeReplyErrError(W);this._uriTransformer&&(z=(0,y.transformIncomingURIs)(z,this._uriTransformer)),this._receiveReplyErr(R,H,z);break}case 12:{this._receiveReplyErr(R,H,void 0);break}default:console.error("received unexpected message"),console.error(P)}}_receiveRequest(P,R,W,E,H,z){this._logger&&this._logger.logIncoming(P,R,1,`receiveRequest ${(0,L.getStringIdentifierForProxy)(W)}.${E}(`,H);const q=String(R);let G,j;if(z){const ee=new b.CancellationTokenSource;H.push(ee.token),G=this._invokeHandler(W,E,H),j=()=>ee.cancel()}else G=this._invokeHandler(W,E,H),j=a;this._cancelInvokedHandlers[q]=j;const $=o.serializeAcknowledged(R);this._logger&&this._logger.logOutgoing($.byteLength,R,1,"ack"),this._protocol.send($),G.then(ee=>{delete this._cancelInvokedHandlers[q];const se=o.serializeReplyOK(R,ee,this._uriReplacer);this._logger&&this._logger.logOutgoing(se.byteLength,R,1,"reply:",ee),this._protocol.send(se)},ee=>{delete this._cancelInvokedHandlers[q];const se=o.serializeReplyErr(R,ee);this._logger&&this._logger.logOutgoing(se.byteLength,R,1,"replyErr:",ee),this._protocol.send(se)})}_receiveCancel(P,R){this._logger&&this._logger.logIncoming(P,R,1,"receiveCancel");const W=String(R);this._cancelInvokedHandlers[W]&&this._cancelInvokedHandlers[W]()}_receiveReply(P,R,W){this._logger&&this._logger.logIncoming(P,R,0,"receiveReply:",W);const E=String(R);if(!this._pendingRPCReplies.hasOwnProperty(E))return;const H=this._pendingRPCReplies[E];delete this._pendingRPCReplies[E],H.resolveOk(W)}_receiveReplyErr(P,R,W){this._logger&&this._logger.logIncoming(P,R,0,"receiveReplyErr:",W);const E=String(R);if(!this._pendingRPCReplies.hasOwnProperty(E))return;const H=this._pendingRPCReplies[E];delete this._pendingRPCReplies[E];let z;W&&(W.$isError?(z=new Error,z.name=W.name,z.message=W.message,z.stack=W.stack):z=W),H.resolveErr(z)}_invokeHandler(P,R,W){try{return Promise.resolve(this._doInvokeHandler(P,R,W))}catch(E){return Promise.reject(E)}}_doInvokeHandler(P,R,W){const E=this._locals[P];if(!E)throw new Error("Unknown actor "+(0,L.getStringIdentifierForProxy)(P));let H=E[R];if(typeof H!="function")throw new Error("Unknown method "+R+" on actor "+(0,L.getStringIdentifierForProxy)(P));return H.apply(E,W)}_remoteCall(P,R,W){if(this._isDisposed)return Promise.reject(B.canceled());let E=null;if(W.length>0&&b.CancellationToken.isCancellationToken(W[W.length-1])&&(E=W.pop()),E&&E.isCancellationRequested)return Promise.reject(B.canceled());const H=o.serializeRequestArguments(W,this._uriReplacer),z=++this._lastMessageId,q=String(z),G=new M.LazyPromise;E&&E.onCancellationRequested(()=>{const $=o.serializeCancel(z);this._logger&&this._logger.logOutgoing($.byteLength,z,0,"cancel"),this._protocol.send(o.serializeCancel(z))}),this._pendingRPCReplies[q]=G,this._onWillSendRequest(z);const j=o.serializeRequest(z,P,R,H,!!E);return this._logger&&this._logger.logOutgoing(j.byteLength,z,0,`request: ${(0,L.getStringIdentifierForProxy)(P)}.${R}(`,W),this._protocol.send(j),G}}e.RPCProtocol=i,v=T,i.UNRESPONSIVE_TIME=3*1e3;class c{constructor(P,R){this._buff=P,this._offset=R}static alloc(P,R,W){let E=new c(I.VSBuffer.alloc(W+1+4),0);return E.writeUInt8(P),E.writeUInt32(R),E}static read(P,R){return new c(P,R)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(P){this._buff.writeUInt8(P,this._offset),this._offset+=1}readUInt8(){const P=this._buff.readUInt8(this._offset);return this._offset+=1,P}writeUInt32(P){this._buff.writeUInt32BE(P,this._offset),this._offset+=4}readUInt32(){const P=this._buff.readUInt32BE(this._offset);return this._offset+=4,P}static sizeShortString(P){return 1+P.byteLength}writeShortString(P){this._buff.writeUInt8(P.byteLength,this._offset),this._offset+=1,this._buff.set(P,this._offset),this._offset+=P.byteLength}readShortString(){const P=this._buff.readUInt8(this._offset);this._offset+=1;const W=this._buff.slice(this._offset,this._offset+P).toString();return this._offset+=P,W}static sizeLongString(P){return 4+P.byteLength}writeLongString(P){this._buff.writeUInt32BE(P.byteLength,this._offset),this._offset+=4,this._buff.set(P,this._offset),this._offset+=P.byteLength}readLongString(){const P=this._buff.readUInt32BE(this._offset);this._offset+=4;const W=this._buff.slice(this._offset,this._offset+P).toString();return this._offset+=P,W}writeBuffer(P){this._buff.writeUInt32BE(P.byteLength,this._offset),this._offset+=4,this._buff.set(P,this._offset),this._offset+=P.byteLength}static sizeVSBuffer(P){return 4+P.byteLength}writeVSBuffer(P){this._buff.writeUInt32BE(P.byteLength,this._offset),this._offset+=4,this._buff.set(P,this._offset),this._offset+=P.byteLength}readVSBuffer(){const P=this._buff.readUInt32BE(this._offset);this._offset+=4;const R=this._buff.slice(this._offset,this._offset+P);return this._offset+=P,R}static sizeMixedArray(P){let R=0;R+=1;for(let W=0,E=P.length;W<E;W++){const H=P[W];switch(R+=1,H.type){case 1:R+=this.sizeLongString(H.value);break;case 2:R+=this.sizeVSBuffer(H.value);break;case 3:R+=this.sizeUInt32,R+=this.sizeLongString(H.value);for(let z=0;z<H.buffers.length;++z)R+=this.sizeVSBuffer(H.buffers[z]);break;case 4:break}}return R}writeMixedArray(P){this._buff.writeUInt8(P.length,this._offset),this._offset+=1;for(let R=0,W=P.length;R<W;R++){const E=P[R];switch(E.type){case 1:this.writeUInt8(1),this.writeLongString(E.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(E.value);break;case 3:this.writeUInt8(3),this.writeUInt32(E.buffers.length),this.writeLongString(E.value);for(let H=0;H<E.buffers.length;++H)this.writeBuffer(E.buffers[H]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const P=this._buff.readUInt8(this._offset);this._offset+=1;let R=new Array(P);for(let W=0;W<P;W++)switch(this.readUInt8()){case 1:R[W]=this.readLongString();break;case 2:R[W]=this.readVSBuffer();break;case 3:{const H=this.readUInt32(),z=this.readLongString(),q=[];for(let G=0;G<H;++G)q.push(this.readVSBuffer());R[W]=new L.SerializableObjectWithBuffers(S(z,q,null));break}case 4:R[W]=void 0;break}return R}}c.sizeUInt32=4;var t;(function(_){_[_.Simple=0]="Simple",_[_.Mixed=1]="Mixed"})(t||(t={}));class o{static _useMixedArgSerialization(P){for(let R=0,W=P.length;R<W;R++)if(P[R]instanceof I.VSBuffer||P[R]instanceof L.SerializableObjectWithBuffers||typeof P[R]=="undefined")return!0;return!1}static serializeRequestArguments(P,R){if(this._useMixedArgSerialization(P)){const W=[];for(let E=0,H=P.length;E<H;E++){const z=P[E];if(z instanceof I.VSBuffer)W[E]={type:2,value:z};else if(typeof z=="undefined")W[E]={type:4};else if(z instanceof L.SerializableObjectWithBuffers){const{jsonString:q,referencedBuffers:G}=f(z.value,R);W[E]={type:3,value:I.VSBuffer.fromString(q),buffers:G}}else W[E]={type:1,value:I.VSBuffer.fromString(k(z,R))}}return{type:1,args:W}}return{type:0,args:k(P,R)}}static serializeRequest(P,R,W,E,H){switch(E.type){case 0:return this._requestJSONArgs(P,R,W,E.args,H);case 1:return this._requestMixedArgs(P,R,W,E.args,H)}}static _requestJSONArgs(P,R,W,E,H){const z=I.VSBuffer.fromString(W),q=I.VSBuffer.fromString(E);let G=0;G+=c.sizeUInt8(),G+=c.sizeShortString(z),G+=c.sizeLongString(q);let j=c.alloc(H?2:1,P,G);return j.writeUInt8(R),j.writeShortString(z),j.writeLongString(q),j.buffer}static deserializeRequestJSONArgs(P){const R=P.readUInt8(),W=P.readShortString(),E=P.readLongString();return{rpcId:R,method:W,args:JSON.parse(E)}}static _requestMixedArgs(P,R,W,E,H){const z=I.VSBuffer.fromString(W);let q=0;q+=c.sizeUInt8(),q+=c.sizeShortString(z),q+=c.sizeMixedArray(E);let G=c.alloc(H?4:3,P,q);return G.writeUInt8(R),G.writeShortString(z),G.writeMixedArray(E),G.buffer}static deserializeRequestMixedArgs(P){const R=P.readUInt8(),W=P.readShortString(),E=P.readMixedArray(),H=new Array(E.length);for(let z=0,q=E.length;z<q;z++){const G=E[z];typeof G=="string"?H[z]=JSON.parse(G):H[z]=G}return{rpcId:R,method:W,args:H}}static serializeAcknowledged(P){return c.alloc(5,P,0).buffer}static serializeCancel(P){return c.alloc(6,P,0).buffer}static serializeReplyOK(P,R,W){if(typeof R=="undefined")return this._serializeReplyOKEmpty(P);if(R instanceof I.VSBuffer)return this._serializeReplyOKVSBuffer(P,R);if(R instanceof L.SerializableObjectWithBuffers){const{jsonString:E,referencedBuffers:H}=f(R.value,W,!0);return this._serializeReplyOKJSONWithBuffers(P,E,H)}else return this._serializeReplyOKJSON(P,u(R,W))}static _serializeReplyOKEmpty(P){return c.alloc(7,P,0).buffer}static _serializeReplyOKVSBuffer(P,R){let W=0;W+=c.sizeVSBuffer(R);let E=c.alloc(8,P,W);return E.writeVSBuffer(R),E.buffer}static deserializeReplyOKVSBuffer(P){return P.readVSBuffer()}static _serializeReplyOKJSON(P,R){const W=I.VSBuffer.fromString(R);let E=0;E+=c.sizeLongString(W);let H=c.alloc(9,P,E);return H.writeLongString(W),H.buffer}static _serializeReplyOKJSONWithBuffers(P,R,W){const E=I.VSBuffer.fromString(R);let H=0;H+=c.sizeUInt32,H+=c.sizeLongString(E);for(const q of W)H+=c.sizeVSBuffer(q);let z=c.alloc(10,P,H);z.writeUInt32(W.length),z.writeLongString(E);for(const q of W)z.writeBuffer(q);return z.buffer}static deserializeReplyOKJSON(P){const R=P.readLongString();return JSON.parse(R)}static deserializeReplyOKJSONWithBuffers(P,R){const W=P.readUInt32(),E=P.readLongString(),H=[];for(let z=0;z<W;++z)H.push(P.readVSBuffer());return new L.SerializableObjectWithBuffers(S(E,H,R))}static serializeReplyErr(P,R){const W=R?u(B.transformErrorForSerialization(R),null):void 0;if(typeof W!="string")return this._serializeReplyErrEmpty(P);const E=I.VSBuffer.fromString(W);let H=0;H+=c.sizeLongString(E);let z=c.alloc(11,P,H);return z.writeLongString(E),z.buffer}static deserializeReplyErrError(P){const R=P.readLongString();return JSON.parse(R)}static _serializeReplyErrEmpty(P){return c.alloc(12,P,0).buffer}}var g;(function(_){_[_.RequestJSONArgs=1]="RequestJSONArgs",_[_.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",_[_.RequestMixedArgs=3]="RequestMixedArgs",_[_.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",_[_.Acknowledged=5]="Acknowledged",_[_.Cancel=6]="Cancel",_[_.ReplyOKEmpty=7]="ReplyOKEmpty",_[_.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",_[_.ReplyOKJSON=9]="ReplyOKJSON",_[_.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",_[_.ReplyErrError=11]="ReplyErrError",_[_.ReplyErrEmpty=12]="ReplyErrEmpty"})(g||(g={}));var h;(function(_){_[_.String=1]="String",_[_.VSBuffer=2]="VSBuffer",_[_.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",_[_.Undefined=4]="Undefined"})(h||(h={}))}),define(Ee[211],we([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const s=function(B){const D=A=>{self.removeEventListener("message",D);const y=A.data;Object.defineProperties(self,{postMessage:{value(M,L){y.postMessage(M,L)}},onmessage:{get(){return y.onmessage},set(M){y.onmessage=M}}}),y.addEventListener("message",M=>{self.dispatchEvent(new MessageEvent("message",{data:M.data}))}),y.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(B)};self.addEventListener("message",D)}.toString();class I extends EventTarget{constructor(B,D,A){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const y=`((${s})('${D}'))`,M=new Blob([y],{type:"application/javascript"}),L=URL.createObjectURL(M),v=new MessageChannel,u=L,m={type:"_newWorker",id:u,port:v.port2,url:L,options:A};B(m,[v.port2]),this.postMessage=v.port1.postMessage.bind(v.port1),this.terminate=()=>{const l={type:"_terminateWorker",id:u};v.port1.postMessage(l),URL.revokeObjectURL(L),v.port1.close(),v.port2.close()},Object.defineProperties(this,{onmessage:{get(){return v.port1.onmessage},set(l){v.port1.onmessage=l}},onmessageerror:{get(){return v.port1.onmessageerror},set(l){v.port1.onmessageerror=l}}}),v.port1.addEventListener("messageerror",l=>{const n=new MessageEvent("messageerror",{data:l.data});this.dispatchEvent(n)}),v.port1.addEventListener("message",l=>{const n=new MessageEvent("message",{data:l.data});this.dispatchEvent(n)}),v.port1.start()}}e.NestedWorker=I}),define(Ee[212],we([1,0,3]),function(J,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,s.createDecorator)("remoteAgentService")}),define(Ee[213],we([1,0,35,10,17,23,24,2,3,148,46,172,212]),function(J,e,s,I,b,B,D,A,y,M,L,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,y.createDecorator)("pathService");let m=class qi{constructor(n,f,S,k){this.localUserHome=n,this.remoteAgentService=f,this.environmentService=S,this.contextService=k,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||B.OS)(),this.resolveUserHome=(async()=>{const d=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=d?.userHome||n})()}hasValidBasename(n,f,S){return typeof f=="string"||typeof f=="undefined"?this.resolveOS.then(k=>this.doHasValidBasename(n,k,f)):this.doHasValidBasename(n,f,S)}doHasValidBasename(n,f,S){return n.scheme===I.Schemas.file||n.scheme===I.Schemas.vscodeRemote?(0,s.isValidBasename)(S??(0,D.basename)(n),f===1):!0}get defaultUriScheme(){return qi.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(n,f){if(n.remoteAuthority)return I.Schemas.vscodeRemote;const S=(0,M.getVirtualWorkspaceScheme)(f.getWorkspace());if(S)return S;const k=f.getWorkspace().folders[0];if(k)return k.uri.scheme;const d=f.getWorkspace().configuration;return d?d.scheme:I.Schemas.file}async userHome(n){return n?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(n=>n===1?b.win32:b.posix)}async fileURI(n){let f="";if(await this.resolveOS===1&&(n=n.replace(/\\/g,"/")),n[0]==="/"&&n[1]==="/"){const k=n.indexOf("/",2);k===-1?(f=n.substring(2),n="/"):(f=n.substring(2,k),n=n.substring(k)||"/")}return A.URI.from({scheme:I.Schemas.file,authority:f,path:n,query:"",fragment:""})}};m=Fe([Ne(1,u.IRemoteAgentService),Ne(2,v.IWorkbenchEnvironmentService),Ne(3,L.IWorkspaceContextService)],m),e.AbstractPathService=m}),define(Ee[96],we([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class s{constructor(D,A){this.line=D,this.character=A}isBefore(D){return!1}isBeforeOrEqual(D){return!1}isAfter(D){return!1}isAfterOrEqual(D){return!1}isEqual(D){return!1}compareTo(D){return 0}translate(D,A){return new s(0,0)}with(D){return new s(0,0)}}e.Position=s;class I{constructor(D,A,y,M){this.isEmpty=!1,this.isSingleLine=!1,this.start=new s(D,A),this.end=new s(y,M)}contains(D){return!1}isEqual(D){return!1}intersection(D){}union(D){return new I(0,0,0,0)}with(D){return new I(0,0,0,0)}}e.Range=I;var b;(function(B){B[B.Information=1]="Information",B[B.Warning=2]="Warning"})(b=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(Ee[41],we([1,0,16,29,26,35,9,3,17,15,96,13]),function(J,e,s,I,b,B,D,A,y,M,L,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return L.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const u="\u27EA ",m=" characters skipped \u27EB",l=(u.length+m.length+5)*2;e.ISearchService=(0,A.createDecorator)("searchService");var n;(function($){$[$.file=0]="file",$[$.text=1]="text"})(n=e.SearchProviderType||(e.SearchProviderType={}));var f;(function($){$[$.File=1]="File",$[$.Text=2]="Text"})(f=e.QueryType||(e.QueryType={}));function S($){return!!$.preview}e.resultIsMatch=S;function k($){return!!$.resource}e.isFileMatch=k;function d($){return!!$.message}e.isProgressMessage=d;var p;(function($){$[$.Normal=0]="Normal",$[$.NewSearchStarted=1]="NewSearchStarted"})(p=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class w{constructor(ee){this.resource=ee,this.results=[]}}e.FileMatch=w;class a{constructor(ee,se,Z){this.ranges=se;const le=Array.isArray(se)?se:[se];if(Z&&Z.matchLines===1&&T(le)){ee=(0,D.getNLines)(ee,Z.matchLines);let ue="",Se=0,fe=0;const ne=Math.floor(Z.charsPerLine/5),me=[];for(const ke of le){const Ae=Math.max(ke.startColumn-ne,0),Be=ke.startColumn+Z.charsPerLine;if(Ae>fe+ne+l){const Xe=u+(Ae-fe)+m;ue+=Xe+ee.slice(Ae,Be),Se+=Ae-(fe+Xe.length)}else ue+=ee.slice(fe,Be);me.push(new i(0,ke.startColumn-Se,ke.endColumn-Se)),fe=Be}this.preview={text:ue,matches:Array.isArray(this.ranges)?me:me[0]}}else{const ue=Array.isArray(se)?se[0].startLineNumber:se.startLineNumber;this.preview={text:ee,matches:(0,s.mapArrayOrNot)(se,Se=>new r(Se.startLineNumber-ue,Se.startColumn,Se.endLineNumber-ue,Se.endColumn))}}}}e.TextSearchMatch=a;function T($){const ee=$[0].startLineNumber;for(const se of $)if(se.startLineNumber!==ee||se.endLineNumber!==ee)return!1;return!0}class r{constructor(ee,se,Z,le){this.startLineNumber=ee,this.startColumn=se,this.endLineNumber=Z,this.endColumn=le}}e.SearchRange=r;class i extends r{constructor(ee,se,Z){super(ee,se,ee,Z)}}e.OneLineRange=i;var c;(function($){$.Default="default",$.FileNames="fileNames",$.Type="type",$.Modified="modified",$.CountDescending="countDescending",$.CountAscending="countAscending"})(c=e.SearchSortOrder||(e.SearchSortOrder={}));function t($,ee=!0){const se=$&&$.files&&$.files.exclude,Z=ee&&$&&$.search&&$.search.exclude;if(!se&&!Z)return;if(!se||!Z)return se||Z;let le=Object.create(null);return le=b.mixin(le,b.deepClone(se)),le=b.mixin(le,b.deepClone(Z),!0),le}e.getExcludes=t;function o($,ee){return $.excludePattern&&I.match($.excludePattern,ee)?!1:$.includePattern||$.usingSearchPaths?$.includePattern&&I.match($.includePattern,ee)?!0:$.usingSearchPaths?!!$.folderQueries&&$.folderQueries.some(se=>{const Z=se.folder.fsPath;if(B.isEqualOrParent(ee,Z)){const le=y.relative(Z,ee);return!se.includePattern||!!I.match(se.includePattern,le)}else return!1}):!1:!0}e.pathIncludedInQuery=o;var g;(function($){$[$.unknownEncoding=1]="unknownEncoding",$[$.regexParseError=2]="regexParseError",$[$.globParseError=3]="globParseError",$[$.invalidLiteral=4]="invalidLiteral",$[$.rgProcessError=5]="rgProcessError",$[$.other=6]="other",$[$.canceled=7]="canceled"})(g=e.SearchErrorCode||(e.SearchErrorCode={}));class h extends Error{constructor(ee,se){super(ee);this.code=se}}e.SearchError=h;function _($){const ee=$.message;if((0,M.isCancellationError)($))return new h(ee,g.canceled);try{const se=JSON.parse(ee);return new h(se.message,se.code)}catch{return new h(ee,g.other)}}e.deserializeSearchError=_;function P($){const ee={message:$.message,code:$.code};return new Error(JSON.stringify(ee))}e.serializeSearchError=P;function R($){return $.type==="error"?!0:$.type==="success"}e.isSerializedSearchComplete=R;function W($){return $.type==="success"}e.isSerializedSearchSuccess=W;function E($){return!!$.path}e.isSerializedFileMatch=E;function H($,ee){const se=$.searchPath?$.searchPath:$.relativePath;return(0,D.fuzzyContains)(se,ee)}e.isFilePatternMatch=H;class z{constructor(ee){this.path=ee,this.results=[]}addMatch(ee){this.results.push(ee)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=z;function q($,ee){const se={...$||{},...ee||{}};return Object.keys(se).filter(Z=>{const le=se[Z];return typeof le=="boolean"&&le})}e.resolvePatternsForProvider=q;class G{constructor(ee,se){this._parsedIncludeExpression=null,this._excludeExpression={...ee.excludePattern||{},...se.excludePattern||{}},this._parsedExcludeExpression=I.parse(this._excludeExpression);let Z=ee.includePattern;se.includePattern&&(Z?Z={...Z,...se.includePattern}:Z=se.includePattern),Z&&(this._parsedIncludeExpression=I.parse(Z))}matchesExcludesSync(ee,se,Z){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ee,se,Z))}includedInQuerySync(ee,se,Z){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ee,se,Z)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(ee,se,Z))}includedInQuery(ee,se,Z){const le=this._parsedExcludeExpression(ee,se,Z),ue=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(ee,se,Z):!0;return(0,v.isThenable)(le)?le.then(Se=>Se?!1:ue()):ue()}hasSiblingExcludeClauses(){return j(this._excludeExpression)}}e.QueryGlobTester=G;function j($){for(const ee in $)if(typeof $[ee]!="boolean")return!0;return!1}}),define(Ee[31],we([1,0,16,13,20,5,22,10,102,24,9,11,2,128,3,12,140,46,30,27,14,8,7,41,4]),function(J,e,s,I,b,B,D,A,y,M,L,v,u,m,l,n,f,S,k,d,p,w,a,T,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function i(R,W,E){return new M.ExtUri(H=>g(H,E)).isEqual(R,W)}function c(R,W,E){return i(R.uri,W.uri,E)?0:(0,L.compare)(R.uri.toString(),W.uri.toString())}function t(R,W,E){return R.index!==W.index?R.index<W.index?-1:1:i(R.uri,W.uri,E)?(0,L.compare)(R.name,W.name):(0,L.compare)(R.uri.toString(),W.uri.toString())}function o(R,W,E,H){const z=R.slice(0).sort((G,j)=>E(G,j,H)),q=W.slice(0).sort((G,j)=>E(G,j,H));return(0,s.delta)(z,q,(G,j)=>E(G,j,H))}function g(R,W){const E=W.getCapabilities(R.scheme);return!(E&&E&1024)}class h extends S.Workspace{constructor(W,E,H,z,q,G,j){super(W,H.map($=>new S.WorkspaceFolder($)),z,q,j);this._name=E,this._isUntitled=G,this._workspaceFolders=[],this._structure=D.TernarySearchTree.forUris(j),H.forEach($=>{this._workspaceFolders.push($),this._structure.set($.uri,$)})}static toExtHostWorkspace(W,E,H,z){if(!W)return{workspace:null,added:[],removed:[]};const{id:q,name:G,folders:j,configuration:$,transient:ee,isUntitled:se}=W,Z=[],le=E;E?j.forEach((ne,me)=>{const ke=u.URI.revive(ne.uri),Ae=h._findFolder(H||E,ke,z);Ae?(Ae.name=ne.name,Ae.index=ne.index,Z.push(Ae)):Z.push({uri:ke,name:ne.name,index:me})}):Z.push(...j.map(({uri:ne,name:me,index:ke})=>({uri:u.URI.revive(ne),name:me,index:ke}))),Z.sort((ne,me)=>ne.index<me.index?-1:1);const ue=new h(q,G,Z,!!ee,$?u.URI.revive($):null,!!se,ne=>g(ne,z)),{added:Se,removed:fe}=o(le?le.workspaceFolders:[],ue.workspaceFolders,c,z);return{workspace:ue,added:Se,removed:fe}}static _findFolder(W,E,H){for(let z=0;z<W.folders.length;z++){const q=W.workspaceFolders[z];if(i(q.uri,E,H))return q}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(W,E){return E&&this._structure.get(W)&&(W=(0,M.dirname)(W)),this._structure.findSubstr(W)}resolveWorkspaceFolder(W){return this._structure.get(W)}}let _=class{constructor(W,E,H,z){this._onDidChangeWorkspace=new B.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new B.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=z,this._extHostFileSystemInfo=H,this._requestIdProvider=new y.Counter,this._barrier=new I.Barrier,this._proxy=W.getProxy(r.MainContext.MainThreadWorkspace),this._messageService=W.getProxy(r.MainContext.MainThreadMessageService);const q=E.workspace;this._confirmedWorkspace=q?new h(q.id,q.name,[],!!q.transient,q.configuration?u.URI.revive(q.configuration):null,!!q.isUntitled,G=>g(G,H)):void 0}$initializeWorkspace(W,E){this._trusted=E,this.$acceptWorkspaceData(W),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?u.URI.from({scheme:A.Schemas.untitled,path:(0,M.basename)((0,M.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(W,E,H,...z){const q=[];if(Array.isArray(z)&&z.forEach(se=>{u.URI.isUri(se.uri)&&!q.some(Z=>i(Z.uri,se.uri,this._extHostFileSystemInfo))&&q.push({uri:se.uri,name:se.name||(0,M.basenameOrAuthority)(se.uri)})}),this._unconfirmedWorkspace||[E,H].some(se=>typeof se!="number"||se<0)||H===0&&q.length===0)return!1;const G=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(E+H>G.length)return!1;const j=G.slice(0);j.splice(E,H,...q.map(se=>({uri:se.uri,name:se.name||(0,M.basenameOrAuthority)(se.uri),index:void 0})));for(let se=0;se<j.length;se++){const Z=j[se];if(j.some((le,ue)=>ue!==se&&i(Z.uri,le.uri,this._extHostFileSystemInfo)))return!1}j.forEach((se,Z)=>se.index=Z);const{added:$,removed:ee}=o(G,j,t,this._extHostFileSystemInfo);if($.length===0&&ee.length===0)return!1;if(this._proxy){const se=W.displayName||W.name;this._proxy.$updateWorkspaceFolders(se,E,H,q).then(void 0,Z=>{this._unconfirmedWorkspace=void 0;const le={source:{identifier:W.identifier,label:W.displayName||W.name}};this._messageService.$showMessage(f.Severity.Error,(0,m.localize)(0,null,se,Z.toString()),le,[])})}return this.trySetWorkspaceFolders(j),!0}getWorkspaceFolder(W,E){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(W,E)}async getWorkspaceFolder2(W,E){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(W,E)}async resolveWorkspaceFolder(W){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(W)}getPath(){if(!this._actualWorkspace)return;const{folders:W}=this._actualWorkspace;if(W.length!==0)return W[0].uri.fsPath}getRelativePath(W,E){let H,z="";if(typeof W=="string"?(H=u.URI.file(W),z=W):typeof W!="undefined"&&(H=W,z=W.fsPath),!H)return z;const q=this.getWorkspaceFolder(H,!0);if(!q)return z;typeof E=="undefined"&&this._actualWorkspace&&(E=this._actualWorkspace.folders.length>1);let G=(0,M.relativePath)(q.uri,H);return E&&q.name&&(G=`${q.name}/${G}`),G}trySetWorkspaceFolders(W){this._actualWorkspace&&(this._unconfirmedWorkspace=h.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:W,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(W){const{workspace:E,added:H,removed:z}=h.toExtHostWorkspace(W,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=E||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:H,removed:z}))}findFiles(W,E,H,z,q=b.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${z.value}, entryPoint: findFiles`);let G;if(E===null?G=!1:E&&(typeof E=="string"?G=E:G=E.pattern),q&&q.isCancellationRequested)return Promise.resolve([]);const{includePattern:j,folder:$}=P(w.GlobPattern.from(W));return this._proxy.$startFileSearch((0,v.withUndefinedAsNull)(j),(0,v.withUndefinedAsNull)($),(0,v.withUndefinedAsNull)(G),(0,v.withUndefinedAsNull)(H),q).then(ee=>Array.isArray(ee)?ee.map(se=>u.URI.revive(se)):[])}async findTextInFiles(W,E,H,z,q=b.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${z.value}, entryPoint: findTextInFiles`);const G=this._requestIdProvider.getNext(),j=typeof E.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:E.previewOptions,{includePattern:$,folder:ee}=P(w.GlobPattern.from(E.include)),se=typeof E.exclude=="string"?E.exclude:E.exclude?E.exclude.pattern:void 0,Z={ignoreSymlinks:typeof E.followSymlinks=="boolean"?!E.followSymlinks:void 0,disregardIgnoreFiles:typeof E.useIgnoreFiles=="boolean"?!E.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof E.useGlobalIgnoreFiles=="boolean"?!E.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof E.useParentIgnoreFiles=="boolean"?!E.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof E.useDefaultExcludes=="boolean"?!E.useDefaultExcludes:!0,fileEncoding:E.encoding,maxResults:E.maxResults,previewOptions:j,afterContext:E.afterContext,beforeContext:E.beforeContext,includePattern:$,excludePattern:se},le=!1;if(this._activeSearchCallbacks[G]=ue=>{if(le)return;const Se=u.URI.revive(ue.resource);ue.results.forEach(fe=>{(0,T.resultIsMatch)(fe)?H({uri:Se,preview:{text:fe.preview.text,matches:(0,s.mapArrayOrNot)(fe.preview.matches,ne=>new a.Range(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))},ranges:(0,s.mapArrayOrNot)(fe.ranges,ne=>new a.Range(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))}):H({uri:Se,text:fe.text,lineNumber:fe.lineNumber})})},q.isCancellationRequested)return{};try{const ue=await this._proxy.$startTextSearch(W,(0,v.withUndefinedAsNull)(ee),Z,G,q);return delete this._activeSearchCallbacks[G],ue||{}}catch(ue){throw delete this._activeSearchCallbacks[G],ue}}$handleTextSearchResult(W,E){this._activeSearchCallbacks[E]&&this._activeSearchCallbacks[E](W)}saveAll(W){return this._proxy.$saveAll(W)}resolveProxy(W){return this._proxy.$resolveProxy(W)}get trusted(){return this._trusted}requestWorkspaceTrust(W){return this._proxy.$requestWorkspaceTrust(W)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};_=Fe([Ne(0,p.IExtHostRpcService),Ne(1,d.IExtHostInitDataService),Ne(2,k.IExtHostFileSystemInfo),Ne(3,n.ILogService)],_),e.ExtHostWorkspace=_,e.IExtHostWorkspace=(0,l.createDecorator)("IExtHostWorkspace");function P(R){let W,E;return R&&(typeof R=="string"?W=R:(W=R.pattern,E=u.URI.revive(R.baseUri))),{includePattern:W,folder:E}}}),define(Ee[32],we([1,0,26,5,31,4,7,143,80,11,13,3,14,12,2]),function(J,e,s,I,b,B,D,A,y,M,L,v,u,m,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function n(T,r){if(r){const i=r.split(".");let c=T;for(let t=0;c&&t<i.length;t++)c=c[i[t]];return c}}function f(T){return T instanceof l.URI}function S(T){return T&&T.uri instanceof l.URI&&T.languageId&&typeof T.languageId=="string"}function k(T){return T&&!T.uri&&T.languageId&&typeof T.languageId=="string"}function d(T){return T&&T.uri instanceof l.URI&&(!T.name||typeof T.name=="string")&&(!T.index||typeof T.index=="number")}function p(T){if(f(T))return{resource:T};if(S(T))return{resource:T.uri,overrideIdentifier:T.languageId};if(k(T))return{overrideIdentifier:T.languageId};if(d(T))return{resource:T.uri};if(T===null)return{resource:null}}let w=class{constructor(r,i,c){this._proxy=r.getProxy(B.MainContext.MainThreadConfiguration),this._extHostWorkspace=i,this._logService=c,this._barrier=new L.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(r=>this._actual)}$initializeConfiguration(r){this._actual=new a(this._proxy,this._extHostWorkspace,r,this._logService),this._barrier.open()}$acceptConfigurationChanged(r,i){this.getConfigProvider().then(c=>c.$acceptConfigurationChanged(r,i))}};w=Fe([Ne(0,u.IExtHostRpcService),Ne(1,b.IExtHostWorkspace),Ne(2,m.ILogService)],w),e.ExtHostConfiguration=w;class a{constructor(r,i,c,t){this._onDidChangeConfiguration=new I.Emitter,this._proxy=r,this._logService=t,this._extHostWorkspace=i,this._configuration=A.Configuration.parse(c),this._configurationScopes=this._toMap(c.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(r,i){const c={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=A.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(i,c))}getConfiguration(r,i,c){const t=p(i)||{},o=this._toReadonlyValue(r?n(this._configuration.getValue(void 0,t,this._extHostWorkspace.workspace),r):this._configuration.getValue(void 0,t,this._extHostWorkspace.workspace));r&&this._validateConfigurationAccess(r,t,c?.identifier);function g(_){if(_==null)return null;if(typeof _=="boolean")return _?1:4;switch(_){case D.ConfigurationTarget.Global:return 1;case D.ConfigurationTarget.Workspace:return 4;case D.ConfigurationTarget.WorkspaceFolder:return 5}}const h={has(_){return typeof n(o,_)!="undefined"},get:(_,P)=>{this._validateConfigurationAccess(r?`${r}.${_}`:_,t,c?.identifier);let R=n(o,_);if(typeof R=="undefined")R=P;else{let W;const E=(H,z)=>{let q;const G=()=>{W=W||(0,s.deepClone)(o),q=q||n(W,z)};return(0,M.isObject)(H)?new Proxy(H,{get:(j,$)=>{if(typeof $=="string"&&$.toLowerCase()==="tojson")return G(),()=>q;if(W)return q=q||n(W,z),q[$];const ee=j[$];return typeof $=="string"?E(ee,`${z}.${$}`):ee},set:(j,$,ee)=>(G(),q&&(q[$]=ee),!0),deleteProperty:(j,$)=>(G(),q&&delete q[$],!0),defineProperty:(j,$,ee)=>(G(),q&&Object.defineProperty(q,$,ee),!0)}):H};R=E(R,_)}return R},update:(_,P,R,W)=>{_=r?`${r}.${_}`:_;const E=g(R);return P!==void 0?this._proxy.$updateConfigurationOption(E,_,P,t,W):this._proxy.$removeConfigurationOption(E,_,t,W)},inspect:_=>{_=r?`${r}.${_}`:_;const P=(0,s.deepClone)(this._configuration.inspect(_,t,this._extHostWorkspace.workspace));if(P)return{key:_,defaultValue:P.default?.value,globalValue:P.user?.value,workspaceValue:P.workspace?.value,workspaceFolderValue:P.workspaceFolder?.value,defaultLanguageValue:P.default?.override,globalLanguageValue:P.user?.override,workspaceLanguageValue:P.workspace?.override,workspaceFolderLanguageValue:P.workspaceFolder?.override,languageIds:P.overrideIdentifiers}}};return typeof o=="object"&&(0,s.mixin)(h,o,!1),Object.freeze(h)}_toReadonlyValue(r){const i=c=>(0,M.isObject)(c)?new Proxy(c,{get:(t,o)=>i(t[o]),set:(t,o,g)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(o)}' of object`)},deleteProperty:(t,o)=>{throw new Error(`TypeError: Cannot delete read only property '${String(o)}' of object`)},defineProperty:(t,o)=>{throw new Error(`TypeError: Cannot define property '${String(o)}' for a readonly object`)},setPrototypeOf:t=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):c;return i(r)}_validateConfigurationAccess(r,i,c){const t=y.OVERRIDE_PROPERTY_REGEX.test(r)?4:this._configurationScopes.get(r),o=c?`[${c.value}] `:"";if(t===4){typeof i?.resource=="undefined"&&this._logService.warn(`${o}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(t===3){i?.resource&&this._logService.warn(`${o}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(r,i){const c=new A.ConfigurationChangeEvent(r,i,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(t,o)=>c.affectsConfiguration(t,p(o))})}_toMap(r){return r.reduce((i,c)=>(i.set(c[0],c[1]),i),new Map)}}e.ExtHostConfigProvider=a,e.IExtHostConfiguration=(0,v.createDecorator)("IExtHostConfiguration")});var je=this&&this.__classPrivateFieldSet||function(J,e,s,I,b){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!b:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?b.call(J,s):b?b.value=s:e.set(J,s),s},De=this&&this.__classPrivateFieldGet||function(J,e,s,I){if(s==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?I:s==="a"?I.call(J):I?I.value:e.get(J)};define(Ee[97],we([1,0,2,13,5,4,7,31,49,32,20,40,14,27,3,10,23,12,65,164,15]),function(J,e,s,I,b,B,D,A,y,M,L,v,u,m,l,n,f,S,k,d,p){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var a;(function(z){function q(j){if(j!=null)return j}z.from=q;function G(j){if(j!=null)return j}z.to=G})(a=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var T;(function(z){function q(j){if(j!=null)return j}z.from=q;function G(j){if(j!=null)return j}z.to=G})(T=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var r;(function(z){function q(j){if(j!=null)return j}z.from=q;function G(j){if(j!=null)return j}z.to=G})(r=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var i;(function(z){function q($){if($){const ee=$;return ee&&!!ee.process}else return!1}z.is=q;function G($){if($==null)return;const ee={process:$.process,args:$.args};return $.options&&(ee.options=r.from($.options)),ee}z.from=G;function j($){if($!=null)return new D.ProcessExecution($.process,$.args,$.options)}z.to=j})(i=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var c;(function(z){function q(j){if(j!=null)return j}z.from=q;function G(j){if(j!=null)return j}z.to=G})(c=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var t;(function(z){function q($){if($){const ee=$;return ee&&(!!ee.commandLine||!!ee.command)}else return!1}z.is=q;function G($){if($==null)return;const ee={};return $.commandLine!==void 0?ee.commandLine=$.commandLine:(ee.command=$.command,ee.args=$.args),$.options&&(ee.options=c.from($.options)),ee}z.from=G;function j($){if(!($==null||$.command===void 0&&$.commandLine===void 0))return $.commandLine?new D.ShellExecution($.commandLine,$.options):new D.ShellExecution($.command,$.args?$.args:[],$.options)}z.to=j})(t=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var o;(function(z){function q($){if($){let ee=$;return ee&&ee.customExecution==="customExecution"}else return!1}z.is=q;function G($){return{customExecution:"customExecution"}}z.from=G;function j($,ee){return ee.get($)}z.to=j})(o=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var g;(function(z){function q(G,j){let $;return G.scope!==void 0&&typeof G.scope!="number"?$=G.scope.uri:G.scope!==void 0&&typeof G.scope=="number"&&(G.scope===D.TaskScope.Workspace&&j&&j.workspaceFile?$=j.workspaceFile:$=d.USER_TASKS_GROUP_KEY),{id:G._id,workspaceFolder:$}}z.from=q})(g=e.TaskHandleDTO||(e.TaskHandleDTO={}));var h;(function(z){function q(G){if(G!=null)return{_id:G.id,isDefault:G.isDefault}}z.from=q})(h=e.TaskGroupDTO||(e.TaskGroupDTO={}));var _;(function(z){function q($,ee){if($==null)return[];const se=[];for(let Z of $){const le=G(Z,ee);le&&se.push(le)}return se}z.fromMany=q;function G($,ee){if($==null)return;let se;$.execution instanceof D.ProcessExecution?se=i.from($.execution):$.execution instanceof D.ShellExecution?se=t.from($.execution):$.execution&&$.execution instanceof D.CustomExecution&&(se=o.from($.execution));const Z=a.from($.definition);let le;return $.scope?typeof $.scope=="number"?le=$.scope:le=$.scope.uri:le=D.TaskScope.Workspace,!Z||!le?void 0:{_id:$._id,definition:Z,name:$.name,source:{extensionId:ee.identifier.value,label:$.source,scope:le},execution:se,isBackground:$.isBackground,group:h.from($.group),presentationOptions:T.from($.presentationOptions),problemMatchers:$.problemMatchers,hasDefinedMatchers:$.hasDefinedMatchers,runOptions:$.runOptions?$.runOptions:{reevaluateOnRerun:!0},detail:$.detail}}z.from=G;async function j($,ee,se){if($==null)return;let Z;i.is($.execution)?Z=i.to($.execution):t.is($.execution)?Z=t.to($.execution):o.is($.execution)&&(Z=o.to($._id,se));const le=a.to($.definition);let ue;if($.source&&($.source.scope!==void 0?typeof $.source.scope=="number"?ue=$.source.scope:ue=await ee.resolveWorkspaceFolder(s.URI.revive($.source.scope)):ue=D.TaskScope.Workspace),!le||!ue)return;const Se=new D.Task(le,ue,$.name,$.source.label,Z,$.problemMatchers);return $.isBackground!==void 0&&(Se.isBackground=$.isBackground),$.group!==void 0&&(Se.group=D.TaskGroup.from($.group._id),Se.group&&$.group.isDefault&&(Se.group=new D.TaskGroup(Se.group.id,Se.group.label),$.group.isDefault&&(Se.group.isDefault=$.group.isDefault))),$.presentationOptions&&(Se.presentationOptions=T.to($.presentationOptions)),$._id&&(Se._id=$._id),$.detail&&(Se.detail=$.detail),Se}z.to=j})(_=e.TaskDTO||(e.TaskDTO={}));var P;(function(z){function q(j){return j}z.from=q;function G(j){if(!!j)return Object.assign(Object.create(null),j)}z.to=G})(P=e.TaskFilterDTO||(e.TaskFilterDTO={}));class R{constructor(q,G,j){this._id=G,this._task=j,w.set(this,void 0),je(this,w,q,"f")}get task(){return this._task}terminate(){De(this,w,"f").terminateTask(this)}fireDidStartProcess(q){}fireDidEndProcess(q){}}w=new WeakMap;var W;(function(z){function q(G){return{id:G._id,task:void 0}}z.from=q})(W=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let E=class{constructor(q,G,j,$,ee,se,Z,le){this._onDidExecuteTask=new b.Emitter,this._onDidTerminateTask=new b.Emitter,this._onDidTaskProcessStarted=new b.Emitter,this._onDidTaskProcessEnded=new b.Emitter,this._proxy=q.getProxy(B.MainContext.MainThreadTask),this._workspaceProvider=j,this._editorService=$,this._configurationService=ee,this._terminalService=se,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=Z,this._deprecationService=le,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(q,G,j){if(!j)return new D.Disposable(()=>{});const $=this.nextHandle();return this._handlers.set($,{type:G,provider:j,extension:q}),this._proxy.$registerTaskProvider($,G),new D.Disposable(()=>{this._handlers.delete($),this._proxy.$unregisterTaskProvider($)})}registerTaskSystem(q,G){this._proxy.$registerTaskSystem(q,G)}fetchTasks(q){return this._proxy.$fetchTasks(P.from(q)).then(async G=>{const j=[];for(let $ of G){const ee=await _.to($,this._workspaceProvider,this._providedCustomExecutions2);ee&&j.push(ee)}return j})}get taskExecutions(){const q=[];return this._taskExecutions.forEach(G=>q.push(G)),q}terminateTask(q){if(!(q instanceof R))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(q._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(q,G,j){const $=this._providedCustomExecutions2.get(q.id);$&&(this._activeCustomExecutions2.set(q.id,$),this._terminalService.attachPtyToTerminal(G,await $.callback(j))),this._lastStartedTask=q.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(q)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(q){const G=await this.getTaskExecution(q);this._taskExecutionPromises.delete(q.id),this._taskExecutions.delete(q.id),this.customExecutionComplete(q),this._onDidTerminateTask.fire({execution:G})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(q){const G=await this.getTaskExecution(q.id);this._onDidTaskProcessStarted.fire({execution:G,processId:q.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(q){const G=await this.getTaskExecution(q.id);this._onDidTaskProcessEnded.fire({execution:G,exitCode:q.exitCode})}$provideTasks(q,G){const j=this._handlers.get(q);if(!j)return Promise.reject(new Error("no handler found"));const $=[],ee=(0,I.asPromise)(()=>j.provider.provideTasks(L.CancellationToken.None)).then(se=>this.provideTasksInternal(G,$,j,se));return new Promise(se=>{ee.then(Z=>{Promise.all($).then(()=>{se(Z)})})})}async $resolveTask(q,G){const j=this._handlers.get(q);if(!j)return Promise.reject(new Error("no handler found"));if(G.definition.type!==j.type)throw new Error(`Unexpected: Task of type [${G.definition.type}] cannot be resolved by provider of type [${j.type}].`);const $=await _.to(G,this._workspaceProvider,this._providedCustomExecutions2);if(!$)throw new Error("Unexpected: Task cannot be resolved.");const ee=await j.provider.resolveTask($,L.CancellationToken.None);if(!ee)return;this.checkDeprecation(ee,j);const se=_.from(ee,j.extension);if(!se)throw new Error("Unexpected: Task cannot be resolved.");if(ee.definition!==$.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return o.is(se.execution)&&await this.addCustomExecution(se,ee,!0),await this.resolveTaskInternal(se)}nextHandle(){return this._handleCounter++}async addCustomExecution(q,G,j){const $=await this._proxy.$createTaskId(q);!j&&!this._providedCustomExecutions2.has($)&&(this._notProvidedCustomExecutions.add($),this._activeCustomExecutions2.set($,G.execution)),this._providedCustomExecutions2.set($,G.execution)}async getTaskExecution(q,G){if(typeof q=="string"){const ee=this._taskExecutionPromises.get(q);if(!ee)throw new Error("Unexpected: The specified task is missing an execution");return ee}let j=this._taskExecutionPromises.get(q.id);if(j)return j;const $=new Promise((ee,se)=>{function Z(le,ue,Se){Se?ee(new R(le,ue.id,Se)):se("Unexpected: Task does not exist.")}G?Z(this,q,G):_.to(q.task,this._workspaceProvider,this._providedCustomExecutions2).then(le=>Z(this,q,le))});return this._taskExecutionPromises.set(q.id,$),$.then(ee=>(this._taskExecutions.set(q.id,ee),ee),ee=>Promise.reject(ee))}checkDeprecation(q,G){q._deprecated&&this._deprecationService.report("Task.constructor",G.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(q){this._activeCustomExecutions2.get(q.id)&&this._activeCustomExecutions2.delete(q.id),this._notProvidedCustomExecutions.has(q.id)&&this._lastStartedTask!==q.id&&(this._providedCustomExecutions2.delete(q.id),this._notProvidedCustomExecutions.delete(q.id));let j=this._notProvidedCustomExecutions.values(),$=j.next();for(;!$.done;)!this._activeCustomExecutions2.has($.value)&&this._lastStartedTask!==$.value&&(this._providedCustomExecutions2.delete($.value),this._notProvidedCustomExecutions.delete($.value)),$=j.next()}};E=Fe([Ne(0,u.IExtHostRpcService),Ne(1,m.IExtHostInitDataService),Ne(2,A.IExtHostWorkspace),Ne(3,y.IExtHostDocumentsAndEditors),Ne(4,M.IExtHostConfiguration),Ne(5,v.IExtHostTerminalService),Ne(6,S.ILogService),Ne(7,k.IExtHostApiDeprecationService)],E),e.ExtHostTaskBase=E;let H=class extends E{constructor(q,G,j,$,ee,se,Z,le){super(q,G,j,$,ee,se,Z,le);this.registerTaskSystem(n.Schemas.vscodeRemote,{scheme:n.Schemas.vscodeRemote,authority:"",platform:f.PlatformToString(0)})}async executeTask(q,G){if(!G.execution)throw new Error("Tasks to execute must include an execution");const j=_.from(G,q);if(j===void 0)throw new Error("Task is not valid");if(o.is(j.execution))await this.addCustomExecution(j,G,!1);else throw new p.NotSupportedError;const $=await this.getTaskExecution(await this._proxy.$getTaskExecution(j),G);return this._proxy.$executeTask(j).catch(ee=>{throw new Error(ee)}),$}provideTasksInternal(q,G,j,$){const ee=[];if($)for(let se of $){this.checkDeprecation(se,j),(!se.definition||!q[se.definition.type])&&this._logService.warn(`The task [${se.source}, ${se.name}] uses an undefined task type. The task will be ignored in the future.`);const Z=_.from(se,j.extension);Z&&o.is(Z.execution)?(ee.push(Z),G.push(this.addCustomExecution(Z,se,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:ee,extension:j.extension}}async resolveTaskInternal(q){if(o.is(q.execution))return q;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(q,G){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(q,G,j){}};H=Fe([Ne(0,u.IExtHostRpcService),Ne(1,m.IExtHostInitDataService),Ne(2,A.IExtHostWorkspace),Ne(3,y.IExtHostDocumentsAndEditors),Ne(4,M.IExtHostConfiguration),Ne(5,v.IExtHostTerminalService),Ne(6,S.ILogService),Ne(7,k.IExtHostApiDeprecationService)],H),e.WorkerExtHostTask=H,e.IExtHostTask=(0,l.createDecorator)("IExtHostTask")}),define(Ee[214],we([1,0,17,20,43,29,24,191,41]),function(J,e,s,I,b,B,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class M{constructor(u,m,l){this.config=u,this.provider=m,this.sessionToken=l,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=u.filePattern,this.includePattern=u.includePattern&&B.parse(u.includePattern),this.maxResults=u.maxResults||void 0,this.exists=u.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=u.excludePattern&&B.parse(u.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(u=>u.cancel()),this.activeCancellationTokens=new Set}search(u){const m=this.config.folderQueries||[];return new Promise((l,n)=>{const f=S=>{this.resultCount++,u(S)};if(this.isCanceled)return l({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(S=>{const k=S.toString(),d=s.basename(k);this.globalExcludePattern&&this.globalExcludePattern(k,d)||this.matchFile(f,{base:S,basename:d})}),Promise.all(m.map(S=>this.searchInFolder(S,f))).then(S=>{l({limitHit:this.isLimitHit,stats:S[0]||void 0})},S=>{n(new Error((0,b.toErrorMessage)(S)))})})}async searchInFolder(u,m){const l=new I.CancellationTokenSource,n=this.getSearchOptionsForFolder(u),f=this.initDirectoryTree(),S=new y.QueryGlobTester(this.config,u),k=!S.hasSiblingExcludeClauses();let d;try{this.activeCancellationTokens.add(l),d=A.StopWatch.create();const p=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},n,l.token),w=d.elapsed(),a=A.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(p&&p.forEach(T=>{const r=s.posix.relative(u.folder.path,T.path);if(k){const i=s.basename(T.path);this.matchFile(m,{base:u.folder,relativePath:r,basename:i});return}this.addDirectoryEntries(f,u.folder,r,m)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(f,S,m),{providerTime:w,postProcessTime:a.elapsed()})}finally{l.dispose(),this.activeCancellationTokens.delete(l)}}getSearchOptionsForFolder(u){const m=(0,y.resolvePatternsForProvider)(this.config.includePattern,u.includePattern),l=(0,y.resolvePatternsForProvider)(this.config.excludePattern,u.excludePattern);return{folder:u.folder,excludes:l,includes:m,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!u.disregardParentIgnoreFiles,followSymlinks:!u.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}addDirectoryEntries({pathToEntries:u},m,l,n){if(l===this.filePattern){const S=s.basename(this.filePattern);this.matchFile(n,{base:m,relativePath:this.filePattern,basename:S})}function f(S){const k=s.basename(S),d=s.dirname(S);let p=u[d];p||(p=u[d]=[],f(d)),p.push({base:m,relativePath:S,basename:k})}f(l)}matchDirectoryTree({rootEntries:u,pathToEntries:m},l,n){const f=this,S=this.filePattern;function k(d){const p=B.hasSiblingFn(()=>d.map(w=>w.basename));for(let w=0,a=d.length;w<a;w++){const T=d[w],{relativePath:r,basename:i}=T;if(l.matchesExcludesSync(r,i,S!==i?p:void 0))continue;const c=m[r];if(c)k(c);else{if(r===S)continue;f.matchFile(n,T)}if(f.isLimitHit)break}}k(u)}matchFile(u,m){(!this.includePattern||m.relativePath&&this.includePattern(m.relativePath,m.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||u(m))}}class L{constructor(){this.sessions=new Map}fileSearch(u,m,l,n){const f=this.getSessionTokenSource(u.cacheKey),S=new M(u,m,f&&f.token);let k=0;const d=p=>{k+=p.length,l(p.map(w=>this.rawMatchToSearchItem(w)))};return this.doSearch(S,L.BATCH_SIZE,d,n).then(p=>({limitHit:p.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:k,detailStats:p.stats}}))}clearCache(u){const m=this.getSessionTokenSource(u);m&&m.cancel()}getSessionTokenSource(u){if(!!u)return this.sessions.has(u)||this.sessions.set(u,new I.CancellationTokenSource),this.sessions.get(u)}rawMatchToSearchItem(u){return u.relativePath?{resource:D.joinPath(u.base,u.relativePath)}:{resource:u.base}}doSearch(u,m,l,n){n.onCancellationRequested(()=>{u.cancel()});const f=k=>{k&&(S.push(k),m>0&&S.length>=m&&(l(S),S=[]))};let S=[];return u.search(f).then(k=>(S.length&&l(S),k),k=>(S.length&&l(S),Promise.reject(k)))}}e.FileSearchManager=L,L.BATCH_SIZE=512}),define(Ee[215],we([1,0,16,70,29,73,22,10,17,24,9,11,2,234,134,77,12,46,87,213,41]),function(J,e,s,I,b,B,D,A,y,M,L,v,u,m,l,n,f,S,k,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let w=class{constructor(h,_,P,R,W){this.configurationService=h,this.workspaceContextService=_,this.editorGroupsService=P,this.logService=R,this.pathService=W}text(h,_,P={}){h=this.getContentPattern(h,P);const R=this.configurationService.getValue(),W=_&&_.some(H=>!this.configurationService.getValue({resource:H}).search.useRipgrep);return{...this.commonQuery(_?.map(S.toWorkspaceFolder),P),type:2,contentPattern:h,previewOptions:P.previewOptions,maxFileSize:P.maxFileSize,usePCRE2:R.search.usePCRE2||W||!1,beforeContext:P.beforeContext,afterContext:P.afterContext,userDisabledExcludesAndIgnoreFiles:P.disregardExcludeSettings&&P.disregardIgnoreFiles}}getContentPattern(h,_){const P=this.configurationService.getValue();h.isRegExp&&(h.pattern=h.pattern.replace(/\r?\n/g,"\\n"));const R={...h,wordSeparators:P.editor.wordSeparators};return this.isCaseSensitive(h,_)&&(R.isCaseSensitive=!0),this.isMultiline(h)&&(R.isMultiline=!0),R}file(h,_={}){return{...this.commonQuery(h,_),type:1,filePattern:_.filePattern?_.filePattern.trim():_.filePattern,exists:_.exists,sortByScore:_.sortByScore,cacheKey:_.cacheKey}}handleIncludeExclude(h,_){return h?(h=Array.isArray(h)?h.map(c):c(h),_?this.parseSearchPaths(h):{pattern:T(...Array.isArray(h)?h:[h])}):{}}commonQuery(h=[],_={}){const P=this.handleIncludeExclude(_.includePattern,_.expandPatterns),R=this.handleIncludeExclude(_.excludePattern,_.expandPatterns),W=h.length>1,E=(P.searchPaths&&P.searchPaths.length?P.searchPaths.map(q=>this.getFolderQueryForSearchPath(q,_,R)):h.map(q=>this.getFolderQueryForRoot(q,_,R,W))).filter(q=>!!q),H={_reason:_._reason,folderQueries:E,usingSearchPaths:!!(P.searchPaths&&P.searchPaths.length),extraFileResources:_.extraFileResources,excludePattern:R.pattern,includePattern:P.pattern,onlyOpenEditors:_.onlyOpenEditors,maxResults:_.maxResults};if(_.onlyOpenEditors){const q=s.coalesce(s.flatten(this.editorGroupsService.groups.map($=>$.editors.map(ee=>ee.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(q));const G=q.filter($=>(0,p.pathIncludedInQuery)(H,$.fsPath)),j=this.commonQueryFromFileList(G);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(j)),{...H,...j}}const z=_.extraFileResources&&_.extraFileResources.filter(q=>(0,p.pathIncludedInQuery)(H,q.fsPath));return H.extraFileResources=z&&z.length?z:void 0,H}commonQueryFromFileList(h){const _=[],P=new D.ResourceMap,R={};let W=!1;return h.forEach(E=>{if(E.scheme===A.Schemas.walkThrough)return;if((0,M.isAbsolutePath)(E)){const z=this.workspaceContextService.getWorkspaceFolder(E)?.uri??E.with({path:y.dirname(E.fsPath)});let q=P.get(z);q||(W=!0,q={folder:z,includePattern:{}},_.push(q),P.set(z,q));const G=y.relative(z.fsPath,E.fsPath);(0,v.assertIsDefined)(q.includePattern)[G.replace(/\\/g,"/")]=!0}else E.fsPath&&(W=!0,R[E.fsPath]=!0)}),{folderQueries:_,includePattern:R,usingSearchPaths:!0,excludePattern:W?void 0:{"**/*":!0}}}isCaseSensitive(h,_){if(_.isSmartCase){if(h.isRegExp){if(L.containsUppercaseCharacter(h.pattern,!0))return!0}else if(L.containsUppercaseCharacter(h.pattern))return!0}return!!h.isCaseSensitive}isMultiline(h){return h.isMultiline||h.isRegExp&&(0,m.isMultilineRegexSource)(h.pattern)||h.pattern.indexOf(`
`)>=0?!0:!!h.isMultiline}parseSearchPaths(h){const _=j=>y.isAbsolute(j)||/^\.\.?([\/\\]|$)/.test(j),R=(Array.isArray(h)?h:r(h)).map(j=>{const $=this.pathService.resolvedUserHome;return $?(0,B.untildify)(j,$.scheme===A.Schemas.file?$.fsPath:$.path):j}),W=I.groupBy(R,j=>_(j)?"searchPaths":"exprSegments"),E=(W.exprSegments||[]).map(j=>L.rtrim(j,"/")).map(j=>L.rtrim(j,"\\")).map(j=>(j[0]==="."&&(j="*"+j),i(j))),H={},z=this.expandSearchPathPatterns(W.searchPaths||[]);z&&z.length&&(H.searchPaths=z);const q=s.flatten(E),G=T(...q);return G&&(H.pattern=G),H}getExcludesForFolder(h,_){return _.disregardExcludeSettings?void 0:(0,p.getExcludes)(h,!_.disregardSearchExcludeSettings)}expandSearchPathPatterns(h){if(!h||!h.length)return[];const _=s.flatten(h.map(R=>{let{pathPortion:W,globPortion:E}=a(R);E&&(E=t(E));const H=this.expandOneSearchPath(W);return s.flatten(H.map(z=>this.resolveOneSearchPathPattern(z,E)))})),P=new Map;return _.forEach(R=>{const W=R.searchPath.toString(),E=P.get(W);E?R.pattern&&(E.pattern=E.pattern||{},E.pattern[R.pattern]=!0):P.set(W,{searchPath:R.searchPath,pattern:R.pattern?T(R.pattern):void 0})}),Array.from(P.values())}expandOneSearchPath(h){if(y.isAbsolute(h)){const _=this.workspaceContextService.getWorkspace().folders;return _[0]&&_[0].uri.scheme!==A.Schemas.file?[{searchPath:_[0].uri.with({path:h})}]:[{searchPath:u.URI.file(y.normalize(h))}]}if(this.workspaceContextService.getWorkbenchState()===2){const _=this.workspaceContextService.getWorkspace().folders[0].uri;if(h=c(h),h.startsWith("../")||h===".."){const R=y.posix.resolve(_.path,h);return[{searchPath:_.with({path:R})}]}const P=t(h);return[{searchPath:_,pattern:P}]}else{if(h==="./"||h===".\\")return[];{const _=h.replace(/^\.[\/\\]/,""),R=this.workspaceContextService.getWorkspace().folders.map(W=>{const E=_.match(new RegExp(`^${L.escapeRegExpCharacters(W.name)}(?:/(.*)|$)`));return E?{match:E,folder:W}:null}).filter(v.isDefined);if(R.length)return R.map(W=>{const E=W.match[1];return{searchPath:W.folder.uri,pattern:E&&t(E)}});{const W=h.match(/\.[\/\\](.+)[\/\\]?/),E=W?W[1]:h,H=l.localize(0,null,E);throw new Error(H)}}}}resolveOneSearchPathPattern(h,_){const P=h.pattern&&_?`${h.pattern}/${_}`:h.pattern||_,R=[{searchPath:h.searchPath,pattern:P}];return P&&!P.endsWith("**")&&R.push({searchPath:h.searchPath,pattern:P+"/**"}),R}getFolderQueryForSearchPath(h,_,P){const R=this.getFolderQueryForRoot((0,S.toWorkspaceFolder)(h.searchPath),_,P,!1);return R?{...R,includePattern:h.pattern}:null}getFolderQueryForRoot(h,_,P,R){let W;const E=u.URI.isUri(h)?h:h.uri;if(P.searchPaths){const j=P.searchPaths.filter($=>(0,M.isEqual)($.searchPath,E))[0];if(j&&!j.pattern)return null;j&&(W=j.pattern)}const H=this.configurationService.getValue({resource:E}),q={...this.getExcludesForFolder(H,_)||{},...W||{}},G=u.URI.isUri(h)?(0,M.basename)(h):h.name;return{folder:E,folderName:R?G:void 0,excludePattern:Object.keys(q).length>0?q:void 0,fileEncoding:H.files&&H.files.encoding,disregardIgnoreFiles:typeof _.disregardIgnoreFiles=="boolean"?_.disregardIgnoreFiles:!H.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof _.disregardGlobalIgnoreFiles=="boolean"?_.disregardGlobalIgnoreFiles:!H.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof _.disregardParentIgnoreFiles=="boolean"?_.disregardParentIgnoreFiles:!H.search.useParentIgnoreFiles,ignoreSymlinks:typeof _.ignoreSymlinks=="boolean"?_.ignoreSymlinks:!H.search.followSymlinks}}};w=Fe([Ne(0,n.IConfigurationService),Ne(1,S.IWorkspaceContextService),Ne(2,k.IEditorGroupsService),Ne(3,f.ILogService),Ne(4,d.IPathService)],w),e.QueryBuilder=w;function a(g){const h=g.match(/[\*\{\}\(\)\[\]\?]/);if(h){const _=h.index,P=g.substr(0,_).match(/[/|\\][^/\\]*$/);if(P){let R=g.substr(0,P.index);return R.match(/[/\\]/)||(R+="/"),{pathPortion:R,globPortion:g.substr((P.index||0)+1)}}}return{pathPortion:g}}function T(...g){return g.length?g.reduce((h,_)=>(h[_]=!0,h),Object.create(null)):void 0}function r(g){return b.splitGlobAware(g,",").map(h=>h.trim()).filter(h=>!!h.length)}function i(g){return[`**/${g}/**`,`**/${g}`].map(_=>_.replace(/\*\*\/\*\*/g,"**"))}function c(g){return g.replace(/\\/g,"/")}function t(g){return c(g).replace(/^\.\//,"").replace(/\/+$/g,"")}function o(g,h){g=s.distinct(g,R=>R.toString());const _=[],P=h.getWorkspace();return g&&g.forEach(R=>{let W;if(h.getWorkbenchState()===2)W=(0,M.relativePath)(P.folders[0].uri,R),W&&W!=="."&&(W="./"+W);else{const E=h.getWorkspaceFolder(R);if(E){const H=E.name;if(P.folders.filter(q=>q.name===H).length===1){const q=(0,M.relativePath)(E.uri,R);q===""?W=`./${E.name}`:W=`./${E.name}/${q}`}else W=R.fsPath}}W&&_.push(W)}),_}e.resolveResourcesForSearchIncludes=o}),define(Ee[216],we([1,0,24,2,20,15,3,215,41,46]),function(J,e,s,I,b,B,D,A,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const L=7e3;function v(n,f){const S=f.activationEvents;if(!S)return Promise.resolve(void 0);const k=[],d=[];for(const i of S)if(/^workspaceContains:/.test(i)){const c=i.substr("workspaceContains:".length);c.indexOf("*")>=0||c.indexOf("?")>=0||n.forceUsingSearch?d.push(c):k.push(c)}if(k.length===0&&d.length===0)return Promise.resolve(void 0);let p;const w=new Promise((i,c)=>{p=i}),a=i=>p({activationEvent:i}),T=Promise.all(k.map(i=>u(n,i,a))).then(()=>{}),r=m(n,f.identifier,d,a);return Promise.all([T,r]).then(()=>{p(void 0)}),w}e.checkActivateWorkspaceContainsExtension=v;async function u(n,f,S){for(const k of n.folders)if(await n.exists(s.joinPath(I.URI.revive(k),f))){S(`workspaceContains:${f}`);return}}async function m(n,f,S,k){if(S.length===0)return Promise.resolve(void 0);const d=new b.CancellationTokenSource,p=n.checkExists(n.folders,S,d.token),w=setTimeout(async()=>{d.cancel(),n.logService.info(`Not activating extension '${f.value}': Timed out while searching for 'workspaceContains' pattern ${S.join(",")}`)},L);let a=!1;try{a=await p}catch(T){B.isCancellationError(T)||B.onUnexpectedError(T)}d.dispose(),clearTimeout(w),a&&k(`workspaceContains:${S.join(",")}`)}function l(n,f,S,k){const d=n.get(D.IInstantiationService),p=n.get(y.ISearchService),a=d.createInstance(A.QueryBuilder).file(f.map(T=>(0,M.toWorkspaceFolder)(I.URI.revive(T))),{_reason:"checkExists",includePattern:S,exists:!0});return p.fileSearch(a,k).then(T=>!!T.limitHit,T=>B.isCancellationError(T)?!1:Promise.reject(T))}e.checkGlobFileExists=l});var je=this&&this.__classPrivateFieldSet||function(J,e,s,I,b){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!b:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?b.call(J,s):b?b.value=s:e.set(J,s),s},De=this&&this.__classPrivateFieldGet||function(J,e,s,I){if(s==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?I:s==="a"?I.call(J):I?I.value:e.get(J)};define(Ee[33],we([1,0,123,17,69,24,13,6,22,2,12,4,32,174,67,31,28,173,15,25,21,149,7,81,3,27,68,14,56,59,40,5,216,64,151,10]),function(J,e,s,I,b,B,D,A,y,M,L,v,u,m,l,n,f,S,k,d,p,w,a,T,r,i,c,t,o,g,h,_,P,R,W,E){"use strict";var H,z,q;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let G=class Ki extends A.Disposable{constructor(Z,le,ue,Se,fe,ne,me,ke,Ae,Be){super();this._onDidChangeRemoteConnectionData=this._register(new _.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=le,this._extHostContext=ue,this._initData=me,this._extHostWorkspace=Se,this._extHostConfiguration=fe,this._logService=ne,this._extHostTunnelService=Ae,this._extHostTerminalService=Be,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(v.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(v.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(v.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new D.Barrier,this._readyToStartExtensionHost=new D.Barrier,this._readyToRunExtensions=new D.Barrier,this._eagerExtensionsActivated=new D.Barrier,this._registry=new S.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new l.ExtHostStorage(this._extHostContext),this._secretState=new R.ExtHostSecretState(this._extHostContext),this._storagePath=ke,this._instaService=Z.createChild(new o.ServiceCollection([l.IExtHostStorage,this._storage],[R.IExtHostSecretState,this._secretState]));const Xe=new Set;this._initData.hostExtensions.forEach(ge=>Xe.add(d.ExtensionIdentifier.toKey(ge))),this._activator=this._register(new m.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(ge,de,N)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(ge,k.transformErrorForSerialization(de),N)},actualActivateExtension:async(ge,de)=>{if(Xe.has(d.ExtensionIdentifier.toKey(ge)))return await this._mainThreadExtensionsProxy.$activateExtension(ge,de),new m.HostExtension;const N=this._registry.getExtensionDescription(ge);return this._activateExtension(N,de)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),b.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(Z){k.onUnexpectedError(Z)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let Z=[];try{Z=this._registry.getAllExtensionDescriptions().map(fe=>fe.identifier).filter(fe=>this.isActivated(fe)).map(fe=>this._deactivate(fe))}catch{}await Promise.all(Z)}isActivated(Z){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(Z):!1}_activateByEvent(Z,le){return this._activator.activateByEvent(Z,le)}_activateById(Z,le){return this._activator.activateById(Z,le)}activateByIdWithErrors(Z,le){return this._activateById(Z,le).then(()=>{const ue=this._activator.getActivatedExtension(Z);if(ue.activationFailed)return Promise.reject(ue.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(Z=>this._registry)}getExtensionExports(Z){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(Z).exports:null}async _realPathExtensionUri(Z){if(Z.scheme!==E.Schemas.file)return Z;const le=await this._hostUtils.realpath(Z.fsPath);return M.URI.file(le)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=(async()=>{const Z=y.TernarySearchTree.forUris(le=>B.extUriBiasedIgnorePathCase.ignorePathCasing(le));for(const le of this._registry.getAllExtensionDescriptions())if(this._getEntryPoint(le)){const ue=await this._realPathExtensionUri(le.extensionLocation);Z.set(ue,le)}return Z})()),this._extensionPathIndex}_deactivate(Z){let le=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(Z))return le;const ue=this._activator.getActivatedExtension(Z);if(!ue)return le;try{typeof ue.module.deactivate=="function"&&(le=Promise.resolve(ue.module.deactivate()).then(void 0,Se=>(this._logService.error(Se),Promise.resolve(void 0))))}catch(Se){this._logService.error(`An error occurred when deactivating the extension '${Z.value}':`),this._logService.error(Se)}try{(0,A.dispose)(ue.subscriptions)}catch(Se){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${Z.value}':`),this._logService.error(Se)}return le}async _activateExtension(Z,le){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(Z.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(Z.identifier),this._doActivateExtension(Z,le).then(ue=>{const Se=ue.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(Z.identifier,Se.codeLoadingTime,Se.activateCallTime,Se.activateResolvedTime,le),this._logExtensionActivationTimes(Z,le,"success",Se),ue},ue=>{throw this._logExtensionActivationTimes(Z,le,"failure"),ue})}_logExtensionActivationTimes(Z,le,ue,Se){const fe=j(Z,le);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...fe,...Se||{},outcome:ue})}_doActivateExtension(Z,le){const ue=j(Z,le);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",ue);const Se=this._getEntryPoint(Z);if(!Se)return Promise.resolve(new m.EmptyExtension(m.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${Z.identifier.value}, startup: ${le.startup}, activationEvent: '${le.activationEvent}'${Z.identifier.value!==le.extensionId.value?`, root cause: ${le.extensionId.value}`:""}`),this._logService.flush();const fe=new m.ExtensionActivationTimesBuilder(le.startup);return Promise.all([this._loadCommonJSModule(Z.identifier,(0,B.joinPath)(Z.extensionLocation,Se),fe),this._loadExtensionContext(Z)]).then(ne=>(b.mark(`code/extHost/willActivateExtension/${Z.identifier.value}`),Ki._callActivate(this._logService,Z.identifier,ne[0],ne[1],fe))).then(ne=>(b.mark(`code/extHost/didActivateExtension/${Z.identifier.value}`),ne))}_loadExtensionContext(Z){const le=new w.ExtensionGlobalMemento(Z,this._storage),ue=new w.ExtensionMemento(Z.identifier.value,!1,this._storage),Se=new W.ExtensionSecrets(Z,this._secretState),fe=Z.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?a.ExtensionMode.Test:a.ExtensionMode.Development:a.ExtensionMode.Production,ne=this._initData.remote.isRemote?a.ExtensionKind.Workspace:a.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${Z.identifier.value}`),Promise.all([le.whenReady,ue.whenReady,this._storagePath.whenReady]).then(()=>{const me=this;let ke,Ae;const Be=(0,f.isProposedApiEnabled)(Z,"ipc")?this._initData.messagePorts?.get(d.ExtensionIdentifier.toKey(Z.identifier)):void 0;return Object.freeze({globalState:le,workspaceState:ue,secrets:Se,subscriptions:[],get extensionUri(){return Z.extensionLocation},get extensionPath(){return Z.extensionLocation.fsPath},asAbsolutePath(Xe){return I.join(Z.extensionLocation.fsPath,Xe)},get storagePath(){return me._storagePath.workspaceValue(Z)?.fsPath},get globalStoragePath(){return me._storagePath.globalValue(Z).fsPath},get logPath(){return I.join(me._initData.logsLocation.fsPath,Z.identifier.value)},get logUri(){return M.URI.joinPath(me._initData.logsLocation,Z.identifier.value)},get storageUri(){return me._storagePath.workspaceValue(Z)},get globalStorageUri(){return me._storagePath.globalValue(Z)},get extensionMode(){return fe},get extension(){return ke===void 0&&(ke=new $(me,Z.identifier,Z,ne)),ke},get extensionRuntime(){return(0,f.checkProposedApiEnabled)(Z,"extensionRuntime"),me.extensionRuntime},get environmentVariableCollection(){return me._extHostTerminalService.getEnvironmentVariableCollection(Z)},get messagePassingProtocol(){if(!Ae){if(!Be)return;const Xe=_.Event.buffer(_.Event.fromDOMEventEmitter(Be,"message",ge=>ge.data));Be.start(),Ae={onDidReceiveMessage:Xe,postMessage:Be.postMessage.bind(Be)}}return Ae}})})}static _callActivate(Z,le,ue,Se,fe){return ue=ue||{activate:void 0,deactivate:void 0},this._callActivateOptional(Z,le,ue,Se,fe).then(ne=>new m.ActivatedExtension(!1,null,fe.build(),ue,ne,Se.subscriptions))}static _callActivateOptional(Z,le,ue,Se,fe){if(typeof ue.activate=="function")try{fe.activateCallStart(),Z.trace(`ExtensionService#_callActivateOptional ${le.value}`);const ne=typeof global=="object"?global:self,me=ue.activate.apply(ne,[Se]);return fe.activateCallStop(),fe.activateResolveStart(),Promise.resolve(me).then(ke=>(fe.activateResolveStop(),ke))}catch(ne){return Promise.reject(ne)}else return Promise.resolve(ue)}_activateOneStartupFinished(Z,le){this._activateById(Z.identifier,{startup:!1,extensionId:Z.identifier,activationEvent:le}).then(void 0,ue=>{this._logService.error(ue)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(b.getMarks());for(const Z of this._registry.getAllExtensionDescriptions())if(Z.activationEvents)for(const le of Z.activationEvents)le==="onStartupFinished"&&this._activateOneStartupFinished(Z,le)}_handleEagerExtensions(){const Z=this._activateByEvent("*",!0).then(void 0,fe=>{this._logService.error(fe)});this._register(this._extHostWorkspace.onDidChangeWorkspace(fe=>this._handleWorkspaceContainsEagerExtensions(fe.added)));const le=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],ue=this._handleWorkspaceContainsEagerExtensions(le),Se=Promise.all([Z,ue]).then(()=>{});return Promise.race([Se,(0,D.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),Se}_handleWorkspaceContainsEagerExtensions(Z){return Z.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(le=>this._handleWorkspaceContainsEagerExtension(Z,le))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(Z,le){if(this.isActivated(le.identifier))return;const ue=!this._initData.remote.isRemote&&!!this._initData.remote.authority,Se={logService:this._logService,folders:Z.map(ne=>ne.uri),forceUsingSearch:ue,exists:ne=>this._hostUtils.exists(ne.fsPath),checkExists:(ne,me,ke)=>this._mainThreadWorkspaceProxy.$checkExists(ne,me,ke)},fe=await(0,P.checkActivateWorkspaceContainsExtension)(Se,le);if(!!fe)return this._activateById(le.identifier,{startup:!0,extensionId:le.identifier,activationEvent:fe.activationEvent}).then(void 0,ne=>this._logService.error(ne))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(Z){throw console.error(Z),Z}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:Z,extensionTestsLocationURI:le}=this._initData.environment;if(!Z||!le)throw new Error(s.localize(0,null));const ue=await this._loadCommonJSModule(null,le,new m.ExtensionActivationTimesBuilder(!1));if(!ue||typeof ue.run!="function")throw new Error(s.localize(1,null,le.toString()));return new Promise((Se,fe)=>{const ne=(Ae,Be)=>{Ae?fe(Ae):Se(typeof Be=="number"&&Be>0?1:0)},me=(0,B.originalFSPath)(le),ke=ue.run(me,ne);ke&&ke.then&&ke.then(()=>{Se(0)}).catch(Ae=>{fe(Ae instanceof Error&&Ae.stack?Ae.stack:String(Ae))})})}async $extensionTestsExit(Z){this._logService.info(`Extension host terminating: test runner requested exit with code ${Z}`),this._hostUtils.pid&&this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${Z}`),this._logService.flush(),this._hostUtils.exit(Z)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(Z,le){return this._resolvers[Z]=le,(0,A.toDisposable)(()=>{delete this._resolvers[Z]})}async _activateAndGetResolver(Z){const le=Z.indexOf("+");if(le===-1)throw new Error("Not an authority that can be resolved!");const ue=Z.substr(0,le);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${ue}`,!1),{authorityPrefix:ue,resolver:this._resolvers[ue]}}async $resolveAuthority(Z,le){this._logService.info(`$resolveAuthority invoked for authority (${ee(Z)})`);const{authorityPrefix:ue,resolver:Se}=await this._activateAndGetResolver(Z);if(!Se)return{type:"error",error:{code:T.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${ue}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelFactory(Se)),b.mark(`code/extHost/willResolveAuthority/${ue}`);const fe=await Se.resolve(Z,{resolveAttempt:le});b.mark(`code/extHost/didResolveAuthorityOK/${ue}`);const ne={authority:Z,host:fe.host,port:fe.port,connectionToken:fe.connectionToken},me={extensionHostEnv:fe.extensionHostEnv,isTrusted:fe.isTrusted,authenticationSession:fe.authenticationSessionForInitializingExtensions?{id:fe.authenticationSessionForInitializingExtensions.id,providerId:fe.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:ne,options:me,tunnelInformation:{environmentTunnels:fe.environmentTunnels,features:fe.tunnelFeatures}}}}catch(fe){if(b.mark(`code/extHost/didResolveAuthorityError/${ue}`),fe instanceof a.RemoteAuthorityResolverError)return{type:"error",error:{code:fe._code,message:fe._message,detail:fe._detail}};throw fe}}async $getCanonicalURI(Z,le){this._logService.info(`$getCanonicalURI invoked for authority (${ee(Z)})`);const{authorityPrefix:ue,resolver:Se}=await this._activateAndGetResolver(Z);if(!Se)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${ue}`);const fe=M.URI.revive(le);if(typeof Se.getCanonicalURI=="undefined")return fe;const ne=await(0,D.asPromise)(()=>Se.getCanonicalURI(fe));return ne||fe}$startExtensionHost(Z){return this._registry.keepOnly(Z),this._startExtensionHost()}$activateByEvent(Z,le){return le===1?this._activateByEvent(Z,!1):this._readyToRunExtensions.wait().then(ue=>this._activateByEvent(Z,!1))}async $activate(Z,le){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(Z)?(await this._activateById(Z,le),!0):!1}async $deltaExtensions(Z,le){Z.forEach(Se=>Se.extensionLocation=M.URI.revive(Se.extensionLocation));const ue=await this.getExtensionPathIndex();return await Promise.all(le.map(async Se=>{const fe=this._registry.getExtensionDescription(Se);fe&&ue.delete(await this._realPathExtensionUri(fe.extensionLocation))})),await Promise.all(Z.map(async Se=>{const fe=await this._realPathExtensionUri(Se.extensionLocation);ue.set(fe,Se)})),this._registry.deltaExtensions(Z,le),Promise.resolve(void 0)}async $test_latency(Z){return Z}async $test_up(Z){return Z.byteLength}async $test_down(Z){let le=p.VSBuffer.alloc(Z),ue=Math.random()%256;for(let Se=0;Se<Z;Se++)le.writeUInt8(ue,Se);return le}async $updateRemoteConnectionData(Z){this._remoteConnectionData=Z,this._onDidChangeRemoteConnectionData.fire()}};G=Fe([Ne(0,r.IInstantiationService),Ne(1,e.IHostUtils),Ne(2,t.IExtHostRpcService),Ne(3,n.IExtHostWorkspace),Ne(4,u.IExtHostConfiguration),Ne(5,L.ILogService),Ne(6,i.IExtHostInitDataService),Ne(7,c.IExtensionStoragePaths),Ne(8,g.IExtHostTunnelService),Ne(9,h.IExtHostTerminalService)],G),e.AbstractExtHostExtensionService=G;function j(se,Z){return{id:se.identifier.value,name:se.name,extensionVersion:se.version,publisherDisplayName:se.publisher,activationEvents:se.activationEvents?se.activationEvents.join(","):null,isBuiltin:se.isBuiltin,reason:Z.activationEvent,reasonId:Z.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class ${constructor(Z,le,ue,Se){H.set(this,void 0),z.set(this,void 0),q.set(this,void 0),je(this,H,Z,"f"),je(this,z,le,"f"),je(this,q,ue.identifier,"f"),this.id=ue.identifier.value,this.extensionUri=ue.extensionLocation,this.extensionPath=I.normalize((0,B.originalFSPath)(ue.extensionLocation)),this.packageJSON=ue,this.extensionKind=Se}get isActive(){return De(this,H,"f").isActivated(De(this,q,"f"))}get exports(){if(this.packageJSON.api!=="none")return De(this,H,"f").getExtensionExports(De(this,q,"f"))}activate(){return De(this,H,"f").activateByIdWithErrors(De(this,q,"f"),{startup:!1,extensionId:De(this,z,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=$,H=new WeakMap,z=new WeakMap,q=new WeakMap;function ee(se){const Z=se.indexOf("+");return Z===-1?se:se.substring(0,Z)}}),define(Ee[98],we([1,0,17,2,5,13,4,7,158,31,33,49,166,32,160,14,3,11,86,66]),function(J,e,s,I,b,B,D,A,y,M,L,v,u,m,l,n,f,S,k,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,f.createDecorator)("IExtHostDebugService");let p=class{constructor(o,g,h,_,P,R){this._workspaceService=g,this._extensionService=h,this._editorsService=_,this._configurationService=P,this._editorTabs=R,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new b.Emitter,this._onDidTerminateDebugSession=new b.Emitter,this._onDidChangeActiveDebugSession=new b.Emitter,this._onDidReceiveDebugSessionCustomEvent=new b.Emitter,this._debugServiceProxy=o.getProxy(D.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new b.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new a(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(W=>{W.onDidChange(E=>{this.registerAllDebugTypes(W)}),this.registerAllDebugTypes(W)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(o,g){const h=o;if(typeof h.sourceReference=="number"&&h.sourceReference>0){let _=`debug:${encodeURIComponent(h.path||"")}`,P="?";return g&&(_+=`${P}session=${encodeURIComponent(g.id)}`,P="&"),_+=`${P}ref=${h.sourceReference}`,I.URI.parse(_)}else{if(h.path)return I.URI.file(h.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(o){const g=[];for(const h of o.getAllExtensionDescriptions())if(h.contributes){const _=h.contributes.debuggers;if(_&&_.length>0)for(const P of _)(0,l.isDebuggerMainContribution)(P)&&g.push(P.type)}this._debugServiceProxy.$registerDebugTypes(g)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const o=[];return this._breakpoints.forEach(g=>o.push(g)),o}addBreakpoints(o){this.startBreakpoints();const g=o.filter(P=>{const R=P.id;return this._breakpoints.has(R)?!1:(this._breakpoints.set(R,P),!0)});this.fireBreakpointChanges(g,[],[]);const h=[],_=new Map;for(const P of g)if(P instanceof A.SourceBreakpoint){let R=_.get(P.location.uri.toString());R||(R={type:"sourceMulti",uri:P.location.uri,lines:[]},_.set(P.location.uri.toString(),R),h.push(R)),R.lines.push({id:P.id,enabled:P.enabled,condition:P.condition,hitCondition:P.hitCondition,logMessage:P.logMessage,line:P.location.range.start.line,character:P.location.range.start.character})}else P instanceof A.FunctionBreakpoint&&h.push({type:"function",id:P.id,enabled:P.enabled,hitCondition:P.hitCondition,logMessage:P.logMessage,condition:P.condition,functionName:P.functionName});return this._debugServiceProxy.$registerBreakpoints(h)}removeBreakpoints(o){this.startBreakpoints();const g=o.filter(R=>this._breakpoints.delete(R.id));this.fireBreakpointChanges([],g,[]);const h=g.filter(R=>R instanceof A.SourceBreakpoint).map(R=>R.id),_=g.filter(R=>R instanceof A.FunctionBreakpoint).map(R=>R.id),P=g.filter(R=>R instanceof A.DataBreakpoint).map(R=>R.id);return this._debugServiceProxy.$unregisterBreakpoints(h,_,P)}startDebugging(o,g,h){return this._debugServiceProxy.$startDebugging(o?o.uri:void 0,g,{parentSessionID:h.parentSession?h.parentSession.id:void 0,lifecycleManagedByParent:h.lifecycleManagedByParent,repl:h.consoleMode===A.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:h.noDebug,compact:h.compact,debugUI:h.debugUI,suppressSaveBeforeStart:h.suppressSaveBeforeStart})}stopDebugging(o){return this._debugServiceProxy.$stopDebugging(o?o.id:void 0)}registerDebugConfigurationProvider(o,g,h){if(!g)return new A.Disposable(()=>{});const _=this._configProviderHandleCounter++;return this._configProviders.push({type:o,handle:_,provider:g}),this._debugServiceProxy.$registerDebugConfigurationProvider(o,h,!!g.provideDebugConfigurations,!!g.resolveDebugConfiguration,!!g.resolveDebugConfigurationWithSubstitutedVariables,_),new A.Disposable(()=>{this._configProviders=this._configProviders.filter(P=>P.provider!==g),this._debugServiceProxy.$unregisterDebugConfigurationProvider(_)})}registerDebugAdapterDescriptorFactory(o,g,h){if(!h)return new A.Disposable(()=>{});if(!this.definesDebugType(o,g))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${g}' debugger.`);if(this.getAdapterDescriptorFactoryByType(g))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const _=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:g,handle:_,factory:h}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(g,_),new A.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(P=>P.factory!==h),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(_)})}registerDebugAdapterTrackerFactory(o,g){if(!g)return new A.Disposable(()=>{});const h=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:o,handle:h,factory:g}),new A.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(_=>_.factory!==g)})}async $runInTerminal(o,g){return Promise.resolve(void 0)}async $substituteVariables(o,g){if(!this._variableResolver){const[P,R]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(P||[],this._editorsService,R)}let h;const _=await this.getFolder(o);return _&&(h={uri:_.uri,name:_.name,index:_.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(h,g)}createDebugAdapter(o,g){if(o.type==="implementation")return new i(o.implementation)}createSignService(){}async $startDASession(o,g){const h=this,_=await this.getSession(g);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(_.type),_).then(P=>{if(!P)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${_.type}' (extension might have failed to activate)`);const R=this.convertToDto(P),W=this.createDebugAdapter(R,_);if(!W)throw new Error(`Couldn't create a debug adapter for type '${_.type}'.`);const E=W;return this._debugAdapters.set(o,E),this.getDebugAdapterTrackers(_).then(H=>(H&&this._debugAdaptersTrackers.set(o,H),E.onMessage(async z=>{if(z.type==="request"&&z.command==="handshake"){const q=z,G={type:"response",seq:0,command:q.command,request_seq:q.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const j=await this._signService.sign(q.arguments.value);G.body={signature:j},E.sendResponse(G)}else throw new Error("no signer")}catch(j){G.success=!1,G.message=j.message,E.sendResponse(G)}}else H&&H.onDidSendMessage&&H.onDidSendMessage(z),z=(0,l.convertToVSCPaths)(z,!0),h._debugServiceProxy.$acceptDAMessage(o,z)}),E.onError(z=>{H&&H.onError&&H.onError(z),this._debugServiceProxy.$acceptDAError(o,z.name,z.message,z.stack)}),E.onExit(z=>{H&&H.onExit&&H.onExit((0,S.withNullAsUndefined)(z),void 0),this._debugServiceProxy.$acceptDAExit(o,(0,S.withNullAsUndefined)(z),void 0)}),H&&H.onWillStartSession&&H.onWillStartSession(),E.startSession()))})}$sendDAMessage(o,g){g=(0,l.convertToDAPaths)(g,!1);const h=this._debugAdaptersTrackers.get(o);h&&h.onWillReceiveMessage&&h.onWillReceiveMessage(g);const _=this._debugAdapters.get(o);_&&_.sendMessage(g)}$stopDASession(o){const g=this._debugAdaptersTrackers.get(o);this._debugAdaptersTrackers.delete(o),g&&g.onWillStopSession&&g.onWillStopSession();const h=this._debugAdapters.get(o);return this._debugAdapters.delete(o),h?h.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(o){const g=[],h=[],_=[];if(o.added)for(const P of o.added){const R=P.id;if(R&&!this._breakpoints.has(R)){let W;if(P.type==="function")W=new A.FunctionBreakpoint(P.functionName,P.enabled,P.condition,P.hitCondition,P.logMessage);else if(P.type==="data")W=new A.DataBreakpoint(P.label,P.dataId,P.canPersist,P.enabled,P.hitCondition,P.condition,P.logMessage);else{const E=I.URI.revive(P.uri);W=new A.SourceBreakpoint(new A.Location(E,new A.Position(P.line,P.character)),P.enabled,P.condition,P.hitCondition,P.logMessage)}W._id=R,this._breakpoints.set(R,W),g.push(W)}}if(o.removed)for(const P of o.removed){const R=this._breakpoints.get(P);R&&(this._breakpoints.delete(P),h.push(R))}if(o.changed){for(const P of o.changed)if(P.id){const R=this._breakpoints.get(P.id);if(R){if(R instanceof A.FunctionBreakpoint&&P.type==="function"){const W=R;W.enabled=P.enabled,W.condition=P.condition,W.hitCondition=P.hitCondition,W.logMessage=P.logMessage,W.functionName=P.functionName}else if(R instanceof A.SourceBreakpoint&&P.type==="source"){const W=R;W.enabled=P.enabled,W.condition=P.condition,W.hitCondition=P.hitCondition,W.logMessage=P.logMessage,W.location=new A.Location(I.URI.revive(P.uri),new A.Position(P.line,P.character))}_.push(R)}}}this.fireBreakpointChanges(g,h,_)}$provideDebugConfigurations(o,g,h){return(0,B.asPromise)(async()=>{const _=this.getConfigProviderByHandle(o);if(!_)throw new Error("no DebugConfigurationProvider found");if(!_.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const P=await this.getFolder(g);return _.provideDebugConfigurations(P,h)}).then(_=>{if(!_)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return _})}$resolveDebugConfiguration(o,g,h,_){return(0,B.asPromise)(async()=>{const P=this.getConfigProviderByHandle(o);if(!P)throw new Error("no DebugConfigurationProvider found");if(!P.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const R=await this.getFolder(g);return P.resolveDebugConfiguration(R,h,_)})}$resolveDebugConfigurationWithSubstitutedVariables(o,g,h,_){return(0,B.asPromise)(async()=>{const P=this.getConfigProviderByHandle(o);if(!P)throw new Error("no DebugConfigurationProvider found");if(!P.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const R=await this.getFolder(g);return P.resolveDebugConfigurationWithSubstitutedVariables(R,h,_)})}async $provideDebugAdapter(o,g){const h=this.getAdapterDescriptorFactoryByHandle(o);if(!h)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const _=await this.getSession(g);return this.getAdapterDescriptor(h,_).then(P=>{if(!P)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${_.type}'`);return this.convertToDto(P)})}async $acceptDebugSessionStarted(o){const g=await this.getSession(o);this._onDidStartDebugSession.fire(g)}async $acceptDebugSessionTerminated(o){const g=await this.getSession(o);g&&(this._onDidTerminateDebugSession.fire(g),this._debugSessions.delete(g.id))}async $acceptDebugSessionActiveChanged(o){this._activeDebugSession=o?await this.getSession(o):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(o,g){const h=await this.getSession(o);h&&h._acceptNameChanged(g)}async $acceptDebugSessionCustomEvent(o,g){const _={session:await this.getSession(o),event:g.event,body:g.body};this._onDidReceiveDebugSessionCustomEvent.fire(_)}convertToDto(o){if(o instanceof A.DebugAdapterExecutable)return{type:"executable",command:o.command,args:o.args,options:o.options};if(o instanceof A.DebugAdapterServer)return{type:"server",port:o.port,host:o.host};if(o instanceof A.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:o.path};if(o instanceof A.DebugAdapterInlineImplementation)return{type:"implementation",implementation:o.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(o){const g=this._adapterFactories.filter(h=>h.type===o);if(g.length>0)return g[0].factory}getAdapterDescriptorFactoryByHandle(o){const g=this._adapterFactories.filter(h=>h.handle===o);if(g.length>0)return g[0].factory}getConfigProviderByHandle(o){const g=this._configProviders.filter(h=>h.handle===o);if(g.length>0)return g[0].provider}definesDebugType(o,g){if(o.contributes){const h=o.contributes.debuggers;if(h&&h.length>0){for(const _ of h)if(_.label&&_.type&&_.type===g)return!0}}return!1}getDebugAdapterTrackers(o){const h=o.configuration.type,_=this._trackerFactories.filter(P=>P.type===h||P.type==="*").map(P=>(0,B.asPromise)(()=>P.factory.createDebugAdapterTracker(o)).then(R=>R,R=>null));return Promise.race([Promise.all(_).then(P=>{const R=P.filter(W=>!!W);if(R.length>0)return new r(R)}),new Promise((P,R)=>{const W=setTimeout(()=>{clearTimeout(W),R(new Error("timeout"))},1e3)})]).catch(P=>{})}async getAdapterDescriptor(o,g){const h=g.configuration.debugServer;if(typeof h=="number")return Promise.resolve(new A.DebugAdapterServer(h));if(o){const P=await this._extensionService.getExtensionRegistry();return(0,B.asPromise)(()=>o.createDebugAdapterDescriptor(g,this.daExecutableFromPackage(g,P))).then(R=>{if(R)return R})}const _=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(g,_))}daExecutableFromPackage(o,g){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(o,g,h){(o.length>0||g.length>0||h.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:o,removed:g,changed:h}))}async getSession(o){if(o)if(typeof o=="string"){const g=this._debugSessions.get(o);if(g)return g}else{let g=this._debugSessions.get(o.id);if(!g){const h=await this.getFolder(o.folderUri),_=o.parent?this._debugSessions.get(o.parent):void 0;g=new w(this._debugServiceProxy,o.id,o.type,o.name,h,o.configuration,_),this._debugSessions.set(g.id,g),this._debugServiceProxy.$sessionCached(g.id)}return g}throw new Error("cannot find session")}getFolder(o){if(o){const g=I.URI.revive(o);return this._workspaceService.resolveWorkspaceFolder(g)}return Promise.resolve(void 0)}};p=Fe([Ne(0,n.IExtHostRpcService),Ne(1,M.IExtHostWorkspace),Ne(2,L.IExtHostExtensionService),Ne(3,v.IExtHostDocumentsAndEditors),Ne(4,m.IExtHostConfiguration),Ne(5,d.IExtHostEditorTabs)],p),e.ExtHostDebugServiceBase=p;class w{constructor(o,g,h,_,P,R,W){this._debugServiceProxy=o,this._id=g,this._type=h,this._name=_,this._workspaceFolder=P,this._configuration=R,this._parentSession=W}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(o){this._name=o,this._debugServiceProxy.$setDebugSessionName(this._id,o)}get parentSession(){return this._parentSession}_acceptNameChanged(o){this._name=o}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(o,g){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,o,g)}getDebugProtocolBreakpoint(o){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,o.id)}}e.ExtHostDebugSession=w;class a{constructor(o){this.value=Object.freeze({append(g){o.$appendDebugConsole(g)},appendLine(g){this.append(g+`
`)}})}}e.ExtHostDebugConsole=a;class T extends u.AbstractVariableResolverService{constructor(o,g,h,_,P,R){function W(){if(g){const E=g.activeEditor();if(E)return E.document.uri;const H=_.tabGroups.all.find(z=>z.isActive)?.activeTab;if(H!==void 0){const z=H.resource;return z&&(z.primary||z.secondary)?z.primary??z.secondary:H.resource}}}super({getFolderUri:E=>{const H=o.filter(z=>z.name===E);if(H&&H.length>0)return H[0].uri},getWorkspaceFolderCount:()=>o.length,getConfigurationValue:(E,H)=>h.getConfiguration(void 0,E).get(H),getAppRoot:()=>k.cwd(),getExecPath:()=>k.env.VSCODE_EXEC_PATH,getFilePath:()=>{const E=W();if(E)return s.normalize(E.fsPath)},getWorkspaceFolderPathForFile:()=>{if(P){const E=W();if(E){const H=P.getWorkspaceFolder(E);if(H)return s.normalize(H.uri.fsPath)}}},getSelectedText:()=>{if(g){const E=g.activeEditor();if(E&&!E.selection.isEmpty)return E.document.getText(E.selection)}},getLineNumber:()=>{if(g){const E=g.activeEditor();if(E)return String(E.selection.end.line+1)}}},void 0,R?Promise.resolve(R):void 0,Promise.resolve(k.env))}}e.ExtHostVariableResolverService=T;class r{constructor(o){this.trackers=o}onWillStartSession(){this.trackers.forEach(o=>o.onWillStartSession?o.onWillStartSession():void 0)}onWillReceiveMessage(o){this.trackers.forEach(g=>g.onWillReceiveMessage?g.onWillReceiveMessage(o):void 0)}onDidSendMessage(o){this.trackers.forEach(g=>g.onDidSendMessage?g.onDidSendMessage(o):void 0)}onWillStopSession(){this.trackers.forEach(o=>o.onWillStopSession?o.onWillStopSession():void 0)}onError(o){this.trackers.forEach(g=>g.onError?g.onError(o):void 0)}onExit(o,g){this.trackers.forEach(h=>h.onExit?h.onExit(o,g):void 0)}}class i extends y.AbstractDebugAdapter{constructor(o){super();this.implementation=o,o.onDidSendMessage(g=>{this.acceptMessage(g)})}startSession(){return Promise.resolve(void 0)}sendMessage(o){this.implementation.handleMessage(o)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let c=class extends p{constructor(o,g,h,_,P,R){super(o,g,h,_,P,R)}createVariableResolver(o,g,h){return new T(o,g,h,this._editorTabs)}};c=Fe([Ne(0,n.IExtHostRpcService),Ne(1,M.IExtHostWorkspace),Ne(2,L.IExtHostExtensionService),Ne(3,v.IExtHostDocumentsAndEditors),Ne(4,m.IExtHostConfiguration),Ne(5,d.IExtHostEditorTabs)],c),e.WorkerExtHostDebugService=c}),define(Ee[217],we([1,0,69,2,4,32,28,25,14,27,3,33,86,12,9]),function(J,e,s,I,b,B,D,A,y,M,L,v,u,m,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let n=class{constructor(w,a,T,r,i,c,t){this._apiFactory=w,this._extensionRegistry=a,this._instaService=T,this._extHostConfiguration=r,this._extHostExtensionService=i,this._initData=c,this._logService=t,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),s.mark("code/extHost/willWaitForConfig");const w=await this._extHostConfiguration.getConfigProvider();s.mark("code/extHost/didWaitForConfig");const a=await this._extHostExtensionService.getExtensionPathIndex();this.register(new S(this._apiFactory,a,this._extensionRegistry,w,this._logService)),this.register(this._instaService.createInstance(k,a)),this.register(this._instaService.createInstance(f)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(d,a,this._initData.environment.appUriScheme))}register(w){if("nodeModuleName"in w)if(Array.isArray(w.nodeModuleName))for(let a of w.nodeModuleName)this._factories.set(a,w);else this._factories.set(w.nodeModuleName,w);typeof w.alternativeModuleName=="function"&&this._alternatives.push(a=>w.alternativeModuleName(a))}};n=Fe([Ne(2,L.IInstantiationService),Ne(3,B.IExtHostConfiguration),Ne(4,v.IExtHostExtensionService),Ne(5,M.IExtHostInitDataService),Ne(6,m.ILogService)],n),e.RequireInterceptor=n;let f=class Hi{constructor(w){if(w.environment.appRoot&&Hi.aliased.size){const a=(0,l.escapeRegExpCharacters)(this.forceForwardSlashes(w.environment.appRoot.fsPath)),T="[a-z0-9_.-]",r=`@${T}+\\/${T}+|${T}+`,i="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${a}/${i}\\/)(${r})(.*)$`,"i")}}alternativeModuleName(w){if(!this.re)return;const a=this.re.exec(this.forceForwardSlashes(w));if(!a)return;const[,T,r,i]=a,c=Hi.aliased.get(r);if(c!==void 0)return console.warn(`${r} as been renamed to ${c}, please update your imports`),T+c+i}forceForwardSlashes(w){return w.replace(/\\/g,"/")}};f.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),f=Fe([Ne(0,M.IExtHostInitDataService)],f);class S{constructor(w,a,T,r,i){this._apiFactory=w,this._extensionPaths=a,this._extensionRegistry=T,this._configProvider=r,this._logService=i,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(w,a){const T=this._extensionPaths.findSubstr(a);if(T){let r=this._extApiImpl.get(A.ExtensionIdentifier.toKey(T.identifier));return r||(r=this._apiFactory(T,this._extensionRegistry,this._configProvider),this._extApiImpl.set(A.ExtensionIdentifier.toKey(T.identifier),r)),r}if(!this._defaultApiImpl){let r="";this._extensionPaths.forEach((i,c)=>r+=`	${c} -> ${i.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${a}. These are the extension path mappings: 
${r}`),this._defaultApiImpl=this._apiFactory(D.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let k=class{constructor(w,a,T){this._extensionPaths=w,this.nodeModuleName="keytar",this._mainThreadTelemetry=a.getProxy(b.MainContext.MainThreadTelemetry);const{environment:r}=T,i=a.getProxy(b.MainContext.MainThreadKeytar);if(r.appRoot){let c=r.appRoot.fsPath;u.platform==="win32"&&(c=c.replace(/\\/g,"/")),c[c.length-1]==="/"&&(c=c.substr(0,c.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${c}/node_modules.asar/keytar`),this.alternativeNames.add(`${c}/node_modules/keytar`)}this._impl={getPassword:(c,t)=>i.$getPassword(c,t),setPassword:(c,t,o)=>i.$setPassword(c,t,o),deletePassword:(c,t)=>i.$deletePassword(c,t),findPassword:c=>i.$findPassword(c),findCredentials(c){return i.$findCredentials(c)}}}load(w,a){const T=this._extensionPaths.findSubstr(a);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:T?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(w){const a=w.length;if(a<=7||!this.alternativeNames)return;const T=a-7;if((w.charAt(T)==="/"||w.charAt(T)==="\\")&&w.endsWith("keytar")&&(w=w.replace(/\\/g,"/"),this.alternativeNames.has(w)))return"keytar"}};k=Fe([Ne(1,y.IExtHostRpcService),Ne(2,M.IExtHostInitDataService)],k);let d=class{constructor(w,a,T){this._extensionPaths=w,this._appUriScheme=a,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=T.getProxy(b.MainContext.MainThreadTelemetry);const r=T.getProxy(b.MainContext.MainThreadWindow);this._impl=(i,c)=>{const t=I.URI.parse(i);return c?this.callOriginal(i,c):t.scheme==="http"||t.scheme==="https"?r.$openUri(t,i,{allowTunneling:!0}):t.scheme==="mailto"||t.scheme===this._appUriScheme?r.$openUri(t,i,{}):this.callOriginal(i,c)}}load(w,a,T){const r=this._extensionPaths.findSubstr(a);return r&&(this._extensionId=r.identifier.value,this.sendShimmingTelemetry()),this._original=T(w),this._impl}callOriginal(w,a){return this.sendNoForwardTelemetry(),this._original(w,a)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};d=Fe([Ne(2,y.IExtHostRpcService)],d)}),define(Ee[218],we([1,0,13,15,69,6,2,4,210,12,55,56,27,139,14,60,33,40]),function(J,e,s,I,b,B,D,A,y,M,L,v,u,m,l,n,f,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class k{constructor(p,w,a,T,r){this._disposables=new B.DisposableStore,this._isTerminating=!1,this._hostUtils=a,this._rpcProtocol=new y.RPCProtocol(p,null,T),w=k._transform(w,this._rpcProtocol);const i=new v.ServiceCollection(...(0,L.getSingletonServiceDescriptors)());i.set(u.IExtHostInitDataService,{_serviceBrand:void 0,...w,messagePorts:r}),i.set(l.IExtHostRpcService,new l.ExtHostRpcService(this._rpcProtocol)),i.set(n.IURITransformerService,new n.URITransformerService(T)),i.set(f.IHostUtils,a);const c=new m.InstantiationService(i,!0);this._disposables.add(c.invokeFunction(h=>h.get(S.IExtHostTerminalService))),this._disposables.add(c.invokeFunction(h=>h.get(f.IExtHostExtensionService))),this._logService=c.invokeFunction(h=>h.get(M.ILogService)),b.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",w),this._extensionService=c.invokeFunction(h=>h.get(f.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const t=new WeakMap;this._extensionService.getExtensionPathIndex().then(h=>{Error.prepareStackTrace=(_,P)=>{let R="",W,E;for(const H of P)R+=`
	at ${H.toString()}`,E=H.getFileName(),!W&&E&&(W=h.findSubstr(D.URI.file(E)));return t.set(_,W),`${_.name||"Error"}: ${_.message||""}${R}`}});const o=this._rpcProtocol.getProxy(A.MainContext.MainThreadExtensionService),g=this._rpcProtocol.getProxy(A.MainContext.MainThreadErrors);I.setUnexpectedErrorHandler(h=>{const _=I.transformErrorForSerialization(h),P=t.get(h);P?o.$onExtensionRuntimeError(P.identifier,_):g.$onUnexpectedError(_)})}async asBrowserUri(p){const w=this._rpcProtocol.getProxy(A.MainContext.MainThreadExtensionService);return D.URI.revive(await w.$asBrowserUri(p))}terminate(p){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${p}`),this._logService.flush(),this._disposables.dispose(),I.setUnexpectedErrorHandler(a=>{this._logService.error(a)}),this._rpcProtocol.dispose();const w=this._extensionService.deactivateAll();Promise.race([(0,s.timeout)(5e3),w]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code 0`):this._logService.info("Extension host exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})}static _transform(p,w){p.extensions.forEach(T=>T.extensionLocation=D.URI.revive(w.transformIncomingURIs(T.extensionLocation))),p.environment.appRoot=D.URI.revive(w.transformIncomingURIs(p.environment.appRoot));const a=p.environment.extensionDevelopmentLocationURI;return a&&(p.environment.extensionDevelopmentLocationURI=a.map(T=>D.URI.revive(w.transformIncomingURIs(T)))),p.environment.extensionTestsLocationURI=D.URI.revive(w.transformIncomingURIs(p.environment.extensionTestsLocationURI)),p.environment.globalStorageHome=D.URI.revive(w.transformIncomingURIs(p.environment.globalStorageHome)),p.environment.workspaceStorageHome=D.URI.revive(w.transformIncomingURIs(p.environment.workspaceStorageHome)),p.logsLocation=D.URI.revive(w.transformIncomingURIs(p.logsLocation)),p.logFile=D.URI.revive(w.transformIncomingURIs(p.logFile)),p.workspace=w.transformIncomingURIs(p.workspace),p}}e.ExtensionHostMain=k}),define(Ee[219],we([1,0,16,13,20,43,29,10,17,24,11,2,41]),function(J,e,s,I,b,B,D,A,y,M,L,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class m{constructor(p,w,a,T){this.query=p,this.provider=w,this.fileUtils=a,this.processType=T,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(p,w){const a=this.query.folderQueries||[],T=new b.CancellationTokenSource;return w.onCancellationRequested(()=>T.cancel()),new Promise((r,i)=>{this.collector=new n(p);let c=!1;const t=(o,g)=>{if(!c&&!this.isLimitHit){const h=this.resultSize(o);S(o)&&typeof this.query.maxResults=="number"&&this.resultCount+h>this.query.maxResults&&(this.isLimitHit=!0,c=!0,T.cancel(),o=this.trimResultToSize(o,this.query.maxResults-this.resultCount));const _=this.resultSize(o);this.resultCount+=_,(_>0||!S(o))&&this.collector.add(o,g)}};Promise.all(a.map((o,g)=>this.searchInFolder(o,h=>t(h,g),T.token))).then(o=>{T.dispose(),this.collector.flush();const g=o.some(h=>!!h&&!!h.limitHit);r({limitHit:this.isLimitHit||g,messages:(0,s.flatten)(o.map(h=>h?.message?(0,L.isArray)(h.message)?h.message:[h.message]:[])),stats:{type:this.processType}})},o=>{T.dispose();const g=(0,B.toErrorMessage)(o);i(new Error(g))})})}resultSize(p){return S(p)?Array.isArray(p.ranges)?p.ranges.length:1:0}trimResultToSize(p,w){const a=Array.isArray(p.ranges)?p.ranges:[p.ranges],T=Array.isArray(p.preview.matches)?p.preview.matches:[p.preview.matches];return{ranges:a.slice(0,w),preview:{matches:T.slice(0,w),text:p.preview.text},uri:p.uri}}async searchInFolder(p,w,a){const T=new u.QueryGlobTester(this.query,p),r=[],i={report:o=>{if(!this.validateProviderResult(o))return;const g=p.folder.scheme===A.Schemas.file?D.hasSiblingPromiseFn(()=>this.fileUtils.readdir(M.dirname(o.uri))):void 0,h=M.relativePath(p.folder,o.uri);if(h){const _=T.includedInQuery(h,y.basename(h),g);(0,I.isThenable)(_)?r.push(_.then(P=>{P&&w(o)})):_&&w(o)}}},c=this.getSearchOptionsForFolder(p),t=await this.provider.provideTextSearchResults(l(this.query.contentPattern),c,i,a);return r.length&&await Promise.all(r),t}validateProviderResult(p){if(S(p)){if(Array.isArray(p.ranges)){if(!Array.isArray(p.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(p.preview.matches.length!==p.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(p.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(p){const w=(0,u.resolvePatternsForProvider)(this.query.includePattern,p.includePattern),a=(0,u.resolvePatternsForProvider)(this.query.excludePattern,p.excludePattern),T={folder:v.URI.from(p.folder),excludes:a,includes:w,useIgnoreFiles:!p.disregardIgnoreFiles,useGlobalIgnoreFiles:!p.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!p.disregardParentIgnoreFiles,followSymlinks:!p.ignoreSymlinks,encoding:p.fileEncoding&&this.fileUtils.toCanonicalName(p.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return T.usePCRE2=this.query.usePCRE2,T}}e.TextSearchManager=m;function l(d){return{isCaseSensitive:d.isCaseSensitive||!1,isRegExp:d.isRegExp||!1,isWordMatch:d.isWordMatch||!1,isMultiline:d.isMultiline||!1,pattern:d.pattern}}class n{constructor(p){this._onResult=p,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new k(512,w=>this.sendItems(w))}add(p,w){this._currentFileMatch&&(this._currentFolderIdx!==w||!M.isEqual(this._currentUri,p.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=w,this._currentFileMatch={resource:p.uri,results:[]}),this._currentFileMatch.results.push(f(p))}pushToCollector(){const p=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,p)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(p){this._onResult(p)}}e.TextSearchResultsCollector=n;function f(d){return S(d)?{preview:{matches:(0,s.mapArrayOrNot)(d.preview.matches,p=>({startLineNumber:p.start.line,startColumn:p.start.character,endLineNumber:p.end.line,endColumn:p.end.character})),text:d.preview.text},ranges:(0,s.mapArrayOrNot)(d.ranges,p=>({startLineNumber:p.start.line,startColumn:p.start.character,endLineNumber:p.end.line,endColumn:p.end.character}))}:{text:d.text,lineNumber:d.lineNumber}}function S(d){return!!d.preview}e.extensionResultIsMatch=S;class k{constructor(p,w){this.maxBatchSize=p,this.cb=w,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(p,w){!p||this.addItemToBatch(p,w)}addItems(p,w){!p||this.addItemsToBatch(p,w)}addItemToBatch(p,w){this.batch.push(p),this.batchSize+=w,this.onUpdate()}addItemsToBatch(p,w){this.batch=this.batch.concat(p),this.batchSize+=w,this.onUpdate()}onUpdate(){this.totalNumberCompleted<k.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},k.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=k,k.TIMEOUT=4e3,k.START_BATCH_AFTER_COUNT=50}),define(Ee[99],we([1,0,6,4,3,214,14,60,12,2,219]),function(J,e,s,I,b,B,D,A,y,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,b.createDecorator)("IExtHostSearch");let v=class{constructor(n,f,S){this.extHostRpc=n,this._uriTransformer=f,this._logService=S,this._proxy=this.extHostRpc.getProxy(I.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new B.FileSearchManager}_transformScheme(n){return this._uriTransformer.transformOutgoingScheme(n)}registerTextSearchProvider(n,f){if(this._textSearchUsedSchemes.has(n))throw new Error(`a text search provider for the scheme '${n}' is already registered`);this._textSearchUsedSchemes.add(n);const S=this._handlePool++;return this._textSearchProvider.set(S,f),this._proxy.$registerTextSearchProvider(S,this._transformScheme(n)),(0,s.toDisposable)(()=>{this._textSearchUsedSchemes.delete(n),this._textSearchProvider.delete(S),this._proxy.$unregisterProvider(S)})}registerFileSearchProvider(n,f){if(this._fileSearchUsedSchemes.has(n))throw new Error(`a file search provider for the scheme '${n}' is already registered`);this._fileSearchUsedSchemes.add(n);const S=this._handlePool++;return this._fileSearchProvider.set(S,f),this._proxy.$registerFileSearchProvider(S,this._transformScheme(n)),(0,s.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(n),this._fileSearchProvider.delete(S),this._proxy.$unregisterProvider(S)})}$provideFileSearchResults(n,f,S,k){const d=u(S),p=this._fileSearchProvider.get(n);if(p)return this._fileSearchManager.fileSearch(d,p,w=>{this._proxy.$handleFileMatch(n,f,w.map(a=>a.resource))},k);throw new Error("unknown provider: "+n)}$clearCache(n){return this._fileSearchManager.clearCache(n),Promise.resolve(void 0)}$provideTextSearchResults(n,f,S,k){const d=this._textSearchProvider.get(n);if(!d||!d.provideTextSearchResults)throw new Error(`Unknown provider ${n}`);const p=u(S);return this.createTextSearchManager(p,d).search(a=>this._proxy.$handleTextMatch(n,f,a),k)}$enableExtensionHostSearch(){}createTextSearchManager(n,f){return new L.TextSearchManager(n,f,{readdir:S=>Promise.resolve([]),toCanonicalName:S=>S},"textSearchProvider")}};v=Fe([Ne(0,D.IExtHostRpcService),Ne(1,A.IURITransformerService),Ne(2,y.ILogService)],v),e.ExtHostSearch=v;function u(l){return{...l,folderQueries:l.folderQueries&&l.folderQueries.map(m),extraFileResources:l.extraFileResources&&l.extraFileResources.map(n=>M.URI.revive(n))}}e.reviveQuery=u;function m(l){return{...l,folder:M.URI.revive(l.folder)}}}),define(Ee[220],we([1,0,55,94,31,92,32,39,49,40,97,98,99,67,59,65,95,50,30,64,83,66,193,12,175]),function(J,e,s,I,b,B,D,A,y,M,L,v,u,m,l,n,f,S,k,d,p,w,a,T,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,s.registerSingleton)(T.ILoggerService,a.ExtHostLoggerService),(0,s.registerSingleton)(T.ILogService,r.ExtHostLogService),(0,s.registerSingleton)(n.IExtHostApiDeprecationService,n.ExtHostApiDeprecationService),(0,s.registerSingleton)(A.IExtHostCommands,A.ExtHostCommands),(0,s.registerSingleton)(D.IExtHostConfiguration,D.ExtHostConfiguration),(0,s.registerSingleton)(S.IExtHostConsumerFileSystem,S.ExtHostConsumerFileSystem),(0,s.registerSingleton)(v.IExtHostDebugService,v.WorkerExtHostDebugService),(0,s.registerSingleton)(B.IExtHostDecorations,B.ExtHostDecorations),(0,s.registerSingleton)(y.IExtHostDocumentsAndEditors,y.ExtHostDocumentsAndEditors),(0,s.registerSingleton)(k.IExtHostFileSystemInfo,k.ExtHostFileSystemInfo),(0,s.registerSingleton)(I.IExtHostOutputService,I.ExtHostOutputService),(0,s.registerSingleton)(u.IExtHostSearch,u.ExtHostSearch),(0,s.registerSingleton)(m.IExtHostStorage,m.ExtHostStorage),(0,s.registerSingleton)(L.IExtHostTask,L.WorkerExtHostTask),(0,s.registerSingleton)(M.IExtHostTerminalService,M.WorkerExtHostTerminalService),(0,s.registerSingleton)(l.IExtHostTunnelService,l.ExtHostTunnelService),(0,s.registerSingleton)(f.IExtHostWindow,f.ExtHostWindow),(0,s.registerSingleton)(b.IExtHostWorkspace,b.ExtHostWorkspace),(0,s.registerSingleton)(d.IExtHostSecretState,d.ExtHostSecretState),(0,s.registerSingleton)(p.IExtHostTelemetry,p.ExtHostTelemetry),(0,s.registerSingleton)(w.IExtHostEditorTabs,w.ExtHostEditorTabs)}),define(Ee[221],we([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class s{constructor(){this._dragOperations=new Map,this._renderedElements=new Map}removeDragOperationTransfer(b){if(b&&this._dragOperations.has(b)){const B=this._dragOperations.get(b);return this._dragOperations.delete(b),B}}addDragOperationTransfer(b,B){this._dragOperations.set(b,B)}getRenderedTreeElement(b){if(this._renderedElements.has(b))return this._renderedElements.get(b)}addRenderedTreeItemElement(b,B){this._renderedElements.set(b,B)}removeRenderedTreeItemElement(b){this._renderedElements.has(b)&&this._renderedElements.delete(b)}}e.TreeviewsService=s}),define(Ee[222],we([1,0,127,24,2,5,6,13,7,11,16,8,20,155,221]),function(J,e,s,I,b,B,D,A,y,M,L,v,u,m,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function n(k,d){if((0,M.isString)(k))return{label:k};if(k&&typeof k=="object"&&typeof k.label=="string"){let p;return Array.isArray(k.highlights)&&(p=k.highlights.filter(w=>w.length===2&&typeof w[0]=="number"&&typeof w[1]=="number"),p=p.length?p:void 0),{label:k.label,highlights:p}}}class f{constructor(d,p,w){this._proxy=d,this.commands=p,this.logService=w,this.treeViews=new Map,this.treeDragAndDropService=new l.TreeviewsService;function a(T){return T&&T.$treeViewId&&T.$treeItemHandle}p.registerArgumentProcessor({processArgument:T=>a(T)?this.convertArgument(T):Array.isArray(T)&&T.length>0?T.map(r=>a(r)?this.convertArgument(r):r):T})}registerTreeDataProvider(d,p,w){const a=this.createTreeView(d,{treeDataProvider:p},w);return{dispose:()=>a.dispose()}}createTreeView(d,p,w){if(!p||!p.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const a=p.dragAndDropController?.dropMimeTypes??[],T=p.dragAndDropController?.dragMimeTypes??[],r=!!p.dragAndDropController?.handleDrag,i=!!p.dragAndDropController?.handleDrop,c=this._proxy.$registerTreeViewDataProvider(d,{showCollapseAll:!!p.showCollapseAll,canSelectMany:!!p.canSelectMany,dropMimeTypes:a,dragMimeTypes:T,hasHandleDrag:r,hasHandleDrop:i}),t=this.createExtHostTreeView(d,p,w);return{get onDidCollapseElement(){return t.onDidCollapseElement},get onDidExpandElement(){return t.onDidExpandElement},get selection(){return t.selectedElements},get onDidChangeSelection(){return t.onDidChangeSelection},get visible(){return t.visible},get onDidChangeVisibility(){return t.onDidChangeVisibility},get message(){return t.message},set message(o){t.message=o},get title(){return t.title},set title(o){t.title=o},get description(){return t.description},set description(o){t.description=o},reveal:(o,g)=>t.reveal(o,g),dispose:async()=>{await c,this.treeViews.delete(d),t.dispose()}}}$getChildren(d,p){const w=this.treeViews.get(d);return w?w.getChildren(p):Promise.reject(new Error((0,s.localize)(0,null,d)))}async $handleDrop(d,p,w,a,T,r,i){const c=this.treeViews.get(d);if(!c)return Promise.reject(new Error((0,s.localize)(1,null,d)));const t=m.TreeDataTransferConverter.toITreeDataTransfer(p);return r===d&&i&&await this.addAdditionalTransferItems(t,c,i,a,T),c.onDrop(t,w,a)}async addAdditionalTransferItems(d,p,w,a,T){const r=this.treeDragAndDropService.removeDragOperationTransfer(T);if(r)(await r)?.forEach((i,c)=>{i&&d.set(c,i)});else if(T&&p.handleDrag){const i=p.handleDrag(w,d,a);this.treeDragAndDropService.addDragOperationTransfer(T,i),await i}return d}async $handleDrag(d,p,w,a){const T=this.treeViews.get(d);if(!T)return Promise.reject(new Error((0,s.localize)(2,null,d)));const r=await this.addAdditionalTransferItems(new Map,T,p,a,w);if(!!r)return m.TreeDataTransferConverter.toTreeDataTransferDTO(r)}async $hasResolve(d){const p=this.treeViews.get(d);if(!p)throw new Error((0,s.localize)(3,null,d));return p.hasResolve}$resolve(d,p,w){const a=this.treeViews.get(d);if(!a)throw new Error((0,s.localize)(4,null,d));return a.resolveTreeItem(p,w)}$setExpanded(d,p,w){const a=this.treeViews.get(d);if(!a)throw new Error((0,s.localize)(5,null,d));a.setExpanded(p,w)}$setSelection(d,p){const w=this.treeViews.get(d);if(!w)throw new Error((0,s.localize)(6,null,d));w.setSelection(p)}$setVisible(d,p){const w=this.treeViews.get(d);if(!w)throw new Error((0,s.localize)(7,null,d));w.setVisible(p)}createExtHostTreeView(d,p,w){const a=new S(d,p,this._proxy,this.commands.converter,this.logService,w);return this.treeViews.set(d,a),a}convertArgument(d){const p=this.treeViews.get(d.$treeViewId);return p?p.getExtensionElement(d.$treeItemHandle):null}}e.ExtHostTreeViews=f;class S extends D.Disposable{constructor(d,p,w,a,T,r){super();if(this.viewId=d,this.proxy=w,this.commands=a,this.logService=T,this.extension=r,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new B.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new B.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new B.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new B.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new B.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new u.CancellationTokenSource,r.contributes&&r.contributes.views)for(const t in r.contributes.views)for(const o of r.contributes.views[t])o.id===d&&(this._title=o.name);this.dataProvider=p.treeDataProvider,this.dndController=p.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(t=>this._onDidChangeData.fire({message:!1,element:t}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(t=>this._onDidChangeData.fire({message:!1,element:t})));let i,c;this._register(B.Event.debounce(this._onDidChangeData.event,(t,o)=>(t||(t={message:!1,elements:[]}),o.element!==!1&&(i||(i=new Promise(g=>c=g),this.refreshPromise=this.refreshPromise.then(()=>i)),Array.isArray(o.element)?t.elements.push(...o.element):t.elements.push(o.element)),o.message&&(t.message=!0),t),200,!0)(({message:t,elements:o})=>{o.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const g=c;return i=null,this.refresh(o).then(()=>g())})),t&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(d=>this.getExtensionElement(d)).filter(d=>!(0,M.isUndefinedOrNull)(d))}async getChildren(d){const p=d?this.getExtensionElement(d):void 0;if(d&&!p)return this.logService.error(`No tree item with id '${d}' found.`),Promise.resolve([]);let w=this.getChildrenNodes(d);return w||(w=await this.fetchChildrenNodes(p)),w?w.map(a=>a.item):void 0}getExtensionElement(d){return this.elements.get(d)}reveal(d,p){p=p||{select:!0,focus:!1};const w=(0,M.isUndefinedOrNull)(p.select)?!0:p.select,a=(0,M.isUndefinedOrNull)(p.focus)?!1:p.focus,T=(0,M.isUndefinedOrNull)(p.expand)?!1:p.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):d?this.refreshPromise.then(()=>this.resolveUnknownParentChain(d)).then(r=>this.resolveTreeNode(d,r[r.length-1]).then(i=>this.proxy.$reveal(this.viewId,{item:i.item,parentChain:r.map(c=>c.item)},{select:w,focus:a,expand:T})),r=>this.logService.error(r)):this.proxy.$reveal(this.viewId,void 0,{select:w,focus:a,expand:T})}get message(){return this._message}set message(d){this._message=d,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(d){this._title=d,this.proxy.$setTitle(this.viewId,d,this._description)}get description(){return this._description}set description(d){this._description=d,this.proxy.$setTitle(this.viewId,this._title,d)}setExpanded(d,p){const w=this.getExtensionElement(d);w&&(p?this._onDidExpandElement.fire(Object.freeze({element:w})):this._onDidCollapseElement.fire(Object.freeze({element:w})))}setSelection(d){(0,L.equals)(this._selectedHandles,d)||(this._selectedHandles=d,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(d){d!==this._visible&&(this._visible=d,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async handleDrag(d,p,w){const a=[];for(const T of d){const r=this.getExtensionElement(T);r&&a.push(r)}if(!(!this.dndController?.handleDrag||a.length===0))return await this.dndController.handleDrag(a,p,w),p}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(d,p,w){const a=this.getExtensionElement(p);if(!(!a||!this.dndController?.handleDrop))return(0,A.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(a,d,w):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(d,p){if(!this.dataProvider.resolveTreeItem)return;const w=this.elements.get(d);if(w){const a=this.nodes.get(w);if(a){const T=await this.dataProvider.resolveTreeItem(a.extensionItem,w,p)??a.extensionItem;return a.item.tooltip=this.getTooltip(T.tooltip),a.item.command=this.getCommand(a.disposableStore,T.command),a.item}}}resolveUnknownParentChain(d){return this.resolveParent(d).then(p=>p?this.resolveUnknownParentChain(p).then(w=>this.resolveTreeNode(p,w[w.length-1]).then(a=>(w.push(a),w))):Promise.resolve([]))}resolveParent(d){const p=this.nodes.get(d);return p?Promise.resolve(p.parent?this.elements.get(p.parent.item.handle):void 0):(0,A.asPromise)(()=>this.dataProvider.getParent(d))}resolveTreeNode(d,p){const w=this.nodes.get(d);return w?Promise.resolve(w):(0,A.asPromise)(()=>this.dataProvider.getTreeItem(d)).then(a=>this.createHandle(d,a,p,!0)).then(a=>this.getChildren(p?p.item.handle:void 0).then(()=>{const T=this.getExtensionElement(a);if(T){const r=this.nodes.get(T);if(r)return Promise.resolve(r)}throw new Error(`Cannot resolve tree item for element ${a}`)}))}getChildrenNodes(d){if(d){let p;if(typeof d=="string"){const w=this.getExtensionElement(d);p=w?this.nodes.get(w):void 0}else p=d;return p&&p.children||void 0}return this.roots}async fetchChildrenNodes(d){this.clearChildren(d);const p=new u.CancellationTokenSource(this._refreshCancellationSource.token);try{const w=d?this.nodes.get(d):void 0,a=await this.dataProvider.getChildren(d);if(p.token.isCancellationRequested)return;const T=await Promise.all((0,L.coalesce)(a||[]).map(async r=>{const i=await this.dataProvider.getTreeItem(r);return i&&!p.token.isCancellationRequested?this.createAndRegisterTreeNode(r,i,w):null}));return p.token.isCancellationRequested?void 0:(0,L.coalesce)(T)}finally{p.dispose()}}refresh(d){if(d.some(w=>!w))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new u.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const w=this.getHandlesToRefresh(d);if(w.length)return this.refreshHandles(w)}return Promise.resolve(void 0)}getHandlesToRefresh(d){const p=new Set,w=d.map(T=>this.nodes.get(T));for(const T of w)if(T&&!p.has(T.item.handle)){let r=T;for(;r&&r.parent&&w.findIndex(i=>r&&r.parent&&i&&i.item.handle===r.parent.item.handle)===-1;){const i=this.elements.get(r.parent.item.handle);r=i?this.nodes.get(i):void 0}r&&!r.parent&&p.add(T.item.handle)}const a=[];return p.forEach(T=>{const r=this.elements.get(T);if(r){const i=this.nodes.get(r);i&&(!i.parent||!p.has(i.parent.item.handle))&&a.push(T)}}),a}refreshHandles(d){const p={};return Promise.all(d.map(w=>this.refreshNode(w).then(a=>{a&&(p[w]=a.item)}))).then(()=>Object.keys(p).length?this.proxy.$refresh(this.viewId,p):void 0)}refreshNode(d){const p=this.getExtensionElement(d);if(p){const w=this.nodes.get(p);if(w)return this.clearChildren(p),(0,A.asPromise)(()=>this.dataProvider.getTreeItem(p)).then(a=>{if(a){const T=this.createTreeNode(p,a,w.parent);return this.updateNodeCache(p,T,w,w.parent),w.dispose(),T}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(d,p,w){const a=this.createTreeNode(d,p,w);if(p.id&&this.elements.has(a.item.handle))throw new Error((0,s.localize)(8,null,p.id));return this.addNodeToCache(d,a),this.addNodeToParentCache(a,w),a}getTooltip(d){return y.MarkdownString.isMarkdownString(d)?v.MarkdownString.from(d):d}getCommand(d,p){return p?this.commands.toInternal(p,d):void 0}createTreeNode(d,p,w){const a=new D.DisposableStore,T=this.createHandle(d,p,w),r=this.getLightIconPath(p);return{item:{handle:T,parentHandle:w?w.item.handle:void 0,label:n(p.label,this.extension),description:p.description,resourceUri:p.resourceUri,tooltip:this.getTooltip(p.tooltip),command:this.getCommand(a,p.command),contextValue:p.contextValue,icon:r,iconDark:this.getDarkIconPath(p)||r,themeIcon:this.getThemeIcon(p),collapsibleState:(0,M.isUndefinedOrNull)(p.collapsibleState)?y.TreeItemCollapsibleState.None:p.collapsibleState,accessibilityInformation:p.accessibilityInformation},extensionItem:p,parent:w,children:void 0,disposableStore:a,dispose(){a.dispose()}}}getThemeIcon(d){return d.iconPath instanceof y.ThemeIcon?d.iconPath:void 0}createHandle(d,{id:p,label:w,resourceUri:a},T,r){if(p)return`${S.ID_HANDLE_PREFIX}/${p}`;const i=n(w,this.extension),c=T?T.item.handle:S.LABEL_HANDLE_PREFIX;let t=i?i.label:a?(0,I.basename)(a):"";t=t.indexOf("/")!==-1?t.replace("/","//"):t;const o=this.nodes.has(d)?this.nodes.get(d).item.handle:void 0,g=this.getChildrenNodes(T)||[];let h,_=0;do{if(h=`${c}/${_}:${t}`,r||!this.elements.has(h)||o===h)break;_++}while(_<=g.length);return h}getLightIconPath(d){if(d.iconPath&&!(d.iconPath instanceof y.ThemeIcon))return typeof d.iconPath=="string"||b.URI.isUri(d.iconPath)?this.getIconPath(d.iconPath):this.getIconPath(d.iconPath.light)}getDarkIconPath(d){if(d.iconPath&&!(d.iconPath instanceof y.ThemeIcon)&&d.iconPath.dark)return this.getIconPath(d.iconPath.dark)}getIconPath(d){return b.URI.isUri(d)?d:b.URI.file(d)}addNodeToCache(d,p){this.elements.set(p.item.handle,d),this.nodes.set(d,p)}updateNodeCache(d,p,w,a){this.elements.delete(p.item.handle),this.nodes.delete(d),p.item.handle!==w.item.handle&&this.elements.delete(w.item.handle),this.addNodeToCache(d,p);const T=this.getChildrenNodes(a)||[],r=T.filter(i=>i.item.handle===w.item.handle)[0];r&&T.splice(T.indexOf(r),1,p)}addNodeToParentCache(d,p){p?(p.children||(p.children=[]),p.children.push(d)):(this.roots||(this.roots=[]),this.roots.push(d))}clearChildren(d){if(d){const p=this.nodes.get(d);if(p){if(p.children)for(const w of p.children){const a=this.elements.get(w.item.handle);a&&this.clear(a)}p.children=void 0}}else this.clearAll()}clear(d){const p=this.nodes.get(d);if(p){if(p.children)for(const w of p.children){const a=this.elements.get(w.item.handle);a&&this.clear(a)}this.nodes.delete(d),this.elements.delete(p.item.handle),p.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(d=>d.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}S.LABEL_HANDLE_PREFIX="0",S.ID_HANDLE_PREFIX="1"}),define(Ee[223],we([1,0,20,15,5,34,2,115,235,110,74,45,4,91,180,179,39,181,32,182,183,184,168,185,49,33,186,187,190,192,194,94,170,199,200,201,67,40,203,222,8,7,206,51,95,31,70,157,189,82,92,97,98,99,12,60,14,27,195,153,59,65,177,204,152,68,50,209,207,208,178,30,202,205,64,66,83,197,96,198,10,79,196,150,188,6,28,159]),function(J,e,s,I,b,B,D,A,y,M,L,v,u,m,l,n,f,S,k,d,p,w,a,T,r,i,c,t,o,g,h,_,P,R,W,E,H,z,q,G,j,$,ee,se,Z,le,ue,Se,fe,ne,me,ke,Ae,Be,Xe,ge,de,N,F,C,O,x,Q,re,ve,Ie,Me,Le,ze,xe,Re,Qe,tt,Te,it,X,Y,ce,Oe,We,Ge,Je,ft,It,St,kt,qe,vt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Nt(nt){const ut=nt.get(N.IExtHostInitDataService),At=nt.get(Qe.IExtHostFileSystemInfo),Tt=nt.get(Me.IExtHostConsumerFileSystem),bt=nt.get(i.IExtHostExtensionService),dt=nt.get(le.IExtHostWorkspace),Rt=nt.get(Y.IExtHostTelemetry),Lt=nt.get(k.IExtHostConfiguration),Ft=nt.get(ge.IURITransformerService),Ue=nt.get(de.IExtHostRpcService),he=nt.get(H.IExtHostStorage),pe=nt.get(Ie.IExtensionStoragePaths),ae=nt.get(Xe.ILoggerService),K=nt.get(Xe.ILogService),_e=nt.get(O.IExtHostTunnelService),Ce=nt.get(x.IExtHostApiDeprecationService),$e=nt.get(Z.IExtHostWindow),Ve=nt.get(it.IExtHostSecretState),lt=nt.get(X.IExtHostEditorTabs);Ue.set(u.ExtHostContext.ExtHostFileSystemInfo,At),Ue.set(u.ExtHostContext.ExtHostLogLevelServiceShape,ae),Ue.set(u.ExtHostContext.ExtHostWorkspace,dt),Ue.set(u.ExtHostContext.ExtHostConfiguration,Lt),Ue.set(u.ExtHostContext.ExtHostExtensionService,bt),Ue.set(u.ExtHostContext.ExtHostStorage,he),Ue.set(u.ExtHostContext.ExtHostTunnelService,_e),Ue.set(u.ExtHostContext.ExtHostWindow,$e),Ue.set(u.ExtHostContext.ExtHostSecretState,Ve),Ue.set(u.ExtHostContext.ExtHostTelemetry,Rt),Ue.set(u.ExtHostContext.ExtHostEditorTabs,lt);const gt=Ue.set(u.ExtHostContext.ExtHostDecorations,nt.get(me.IExtHostDecorations)),Et=Ue.set(u.ExtHostContext.ExtHostDocumentsAndEditors,nt.get(r.IExtHostDocumentsAndEditors)),rt=Ue.set(u.ExtHostContext.ExtHostCommands,nt.get(f.IExtHostCommands)),at=Ue.set(u.ExtHostContext.ExtHostTerminalService,nt.get(z.IExtHostTerminalService)),ot=Ue.set(u.ExtHostContext.ExtHostDebugService,nt.get(Ae.IExtHostDebugService)),Mt=Ue.set(u.ExtHostContext.ExtHostSearch,nt.get(Be.IExtHostSearch)),mt=Ue.set(u.ExtHostContext.ExtHostTask,nt.get(ke.IExtHostTask)),Dt=Ue.set(u.ExtHostContext.ExtHostOutputService,nt.get(_.IExtHostOutputService)),Ut=Ue.set(u.ExtHostContext.ExtHostUrls,new ee.ExtHostUrls(Ue)),wt=Ue.set(u.ExtHostContext.ExtHostDocuments,new T.ExtHostDocuments(Ue,Et)),Bt=Ue.set(u.ExtHostContext.ExtHostDocumentContentProviders,new w.ExtHostDocumentContentProvider(Ue,Et,K)),Wt=Ue.set(u.ExtHostContext.ExtHostDocumentSaveParticipant,new a.ExtHostDocumentSaveParticipant(K,wt,Ue.getProxy(u.MainContext.MainThreadBulkEdits))),pt=Ue.set(u.ExtHostContext.ExtHostNotebook,new F.ExtHostNotebookController(Ue,rt,Et,wt,pe)),ei=Ue.set(u.ExtHostContext.ExtHostNotebookDocuments,new It.ExtHostNotebookDocuments(K,pt)),Xt=Ue.set(u.ExtHostContext.ExtHostNotebookEditors,new ft.ExtHostNotebookEditors(K,Ue,pt)),ti=Ue.set(u.ExtHostContext.ExtHostNotebookKernels,new ce.ExtHostNotebookKernels(Ue,ut,pt,rt,K)),ai=Ue.set(u.ExtHostContext.ExtHostNotebookRenderers,new We.ExtHostNotebookRenderers(Ue,pt)),Ct=Ue.set(u.ExtHostContext.ExtHostEditors,new q.ExtHostEditors(Ue,Et)),ii=Ue.set(u.ExtHostContext.ExtHostTreeViews,new G.ExtHostTreeViews(Ue.getProxy(u.MainContext.MainThreadTreeViews),rt,K)),bi=Ue.set(u.ExtHostContext.ExtHostEditorInsets,new Se.ExtHostEditorInsets(Ue.getProxy(u.MainContext.MainThreadEditorInsets),Ct,ut)),qt=Ue.set(u.ExtHostContext.ExtHostDiagnostics,new d.ExtHostDiagnostics(Ue,K,At)),Kt=Ue.set(u.ExtHostContext.ExtHostLanguages,new g.ExtHostLanguages(Ue,wt,rt.converter,Ft)),st=Ue.set(u.ExtHostContext.ExtHostLanguageFeatures,new o.ExtHostLanguageFeatures(Ue,Ft,wt,rt,qt,K,Ce)),li=Ue.set(u.ExtHostContext.ExtHostFileSystem,new c.ExtHostFileSystem(Ue,st)),Ht=Ue.set(u.ExtHostContext.ExtHostFileSystemEventService,new t.ExtHostFileSystemEventService(Ue,K,Et)),zt=Ue.set(u.ExtHostContext.ExtHostQuickOpen,(0,R.createExtHostQuickOpen)(Ue,dt,rt)),ni=Ue.set(u.ExtHostContext.ExtHostSCM,new W.ExtHostSCM(Ue,rt,K)),_i=Ue.set(u.ExtHostContext.ExtHostComments,(0,S.createExtHostComments)(Ue,rt,wt)),fi=Ue.set(u.ExtHostContext.ExtHostProgress,new P.ExtHostProgress(Ue.getProxy(u.MainContext.MainThreadProgress))),Si=Ue.set(u.ExtHostContext.ExtHosLabelService,new fe.ExtHostLabelService(Ue)),mi=Ue.set(u.ExtHostContext.ExtHostTheming,new C.ExtHostTheming(Ue)),ri=Ue.set(u.ExtHostContext.ExtHostAuthentication,new Q.ExtHostAuthentication(Ue)),yi=Ue.set(u.ExtHostContext.ExtHostTimeline,new re.ExtHostTimeline(Ue,rt)),Qt=Ue.set(u.ExtHostContext.ExtHostWebviews,new se.ExtHostWebviews(Ue,{remote:ut.remote},dt,K,Ce)),Yt=Ue.set(u.ExtHostContext.ExtHostWebviewPanels,new xe.ExtHostWebviewPanels(Ue,Qt,dt)),Di=Ue.set(u.ExtHostContext.ExtHostCustomEditors,new ze.ExtHostCustomEditors(Ue,wt,pe,Qt,Yt)),Ci=Ue.set(u.ExtHostContext.ExtHostWebviewViews,new Le.ExtHostWebviewViews(Ue,Qt)),Jt=Ue.set(u.ExtHostContext.ExtHostTesting,new tt.ExtHostTesting(Ue,rt)),si=Ue.set(u.ExtHostContext.ExtHostUriOpeners,new Te.ExtHostUriOpeners(Ue));Ue.set(u.ExtHostContext.ExtHostInteractive,new St.ExtHostInteractive(Ue,pt,Et,rt));const Ii=(0,ue.values)(u.ExtHostContext);Ue.assertRegistered(Ii);const ki=new Re.ExtHostBulkEdits(Ue,Et),Ti=new n.ExtHostClipboard(Ue),Zt=new h.ExtHostMessageService(Ue,K),gi=new p.ExtHostDialogs(Ue),Gt=new E.ExtHostStatusBar(Ue,rt.converter);return l.ExtHostApiCommands.register(rt),function(Pe,ci,Ot){const ct=function(){let te=!Pe.isUnderDevelopment;function oe(){te||(K.info(`Extension '${Pe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),te=!0)}return function ye(Ze){if(Array.isArray(Ze))Ze.forEach(ye);else if(typeof Ze=="string")oe();else{const ht=Ze;typeof ht.scheme=="undefined"&&oe(),typeof ht.exclusive=="boolean"&&(0,qe.checkProposedApiEnabled)(Pe,"documentFiltersExclusive"),typeof ht.notebookType=="string"&&(0,qe.checkProposedApiEnabled)(Pe,"notebookDocumentSelector")}return Ze}}(),Pi={getSession(te,oe,ye){return ri.getSession(Pe,te,oe,ye)},async hasSession(te,oe){return(0,qe.checkProposedApiEnabled)(Pe,"authSession"),!!await ri.getSession(Pe,te,oe,{silent:!0})},get onDidChangeSessions(){return ri.onDidChangeSessions},registerAuthenticationProvider(te,oe,ye,Ze){return ri.registerAuthenticationProvider(te,oe,ye,Ze)}},Ai={registerCommand(te,oe,ye){return rt.registerCommand(!0,te,oe,ye,void 0,Pe)},registerTextEditorCommand(te,oe,ye){return rt.registerCommand(!0,te,(...Ze)=>{const ht=Ct.getActiveTextEditor();if(!ht){K.warn("Cannot execute "+te+" because there is no active text editor.");return}return ht.edit(yt=>{oe.apply(ye,[ht,yt,...Ze])}).then(yt=>{yt||K.warn("Edits from command "+te+" were not applied.")},yt=>{K.warn("An error occurred while running command "+te,yt)})},void 0,void 0,Pe)},registerDiffInformationCommand:(te,oe,ye)=>((0,qe.checkProposedApiEnabled)(Pe,"diffCommand"),rt.registerCommand(!0,te,async(...Ze)=>{const ht=Et.activeEditor(!0);if(!ht){K.warn("Cannot execute "+te+" because there is no active text editor.");return}const yt=await Ct.getDiffInformation(ht.id);oe.apply(ye,[yt,...Ze])},void 0,void 0,Pe)),executeCommand(te,...oe){return rt.executeCommand(te,...oe)},getCommands(te=!1){return rt.getCommands(te)}},pi={get machineId(){return ut.telemetryInfo.machineId},get sessionId(){return ut.telemetryInfo.sessionId},get language(){return ut.environment.appLanguage},get appName(){return ut.environment.appName},get appRoot(){return ut.environment.appRoot?.fsPath??""},get appHost(){return ut.environment.appHost},get uriScheme(){return ut.environment.appUriScheme},get clipboard(){return Ti.value},get shell(){return at.getDefaultShell(!1)},get isTelemetryEnabled(){return Rt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Rt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,qe.checkProposedApiEnabled)(Pe,"telemetry"),Rt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,qe.checkProposedApiEnabled)(Pe,"telemetry"),Rt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){const te=Date.now()-new Date(ut.telemetryInfo.firstSessionDate).getTime();return isNaN(te)?!1:te<1e3*60*60*24},openExternal(te,oe){return $e.openUri(te,{allowTunneling:!!ut.remote.authority,allowContributedOpeners:oe?.allowContributedOpeners})},async asExternalUri(te){if(te.scheme===ut.environment.appUriScheme)return Ut.createAppUri(te);try{return await $e.asExternalUri(te,{allowTunneling:!!ut.remote.authority})}catch(oe){if((0,Je.matchesScheme)(te,Ge.Schemas.http)||(0,Je.matchesScheme)(te,Ge.Schemas.https))return te;throw oe}},get remoteName(){return(0,ne.getRemoteName)(ut.remote.authority)},get remoteAuthority(){return(0,qe.checkProposedApiEnabled)(Pe,"resolvers"),ut.remote.authority},get uiKind(){return ut.uiKind}};ut.environment.extensionTestsLocationURI||Object.freeze(pi);const vi=ut.remote.isRemote?$.ExtensionKind.Workspace:$.ExtensionKind.UI,Ri={createTestController(te,oe,ye){return Jt.createTestController(te,oe,ye)},createTestObserver(){return(0,qe.checkProposedApiEnabled)(Pe,"testObserver"),Jt.createTestObserver()},runTests(te){return(0,qe.checkProposedApiEnabled)(Pe,"testObserver"),Jt.runTests(te)},get onDidChangeTestResults(){return(0,qe.checkProposedApiEnabled)(Pe,"testObserver"),Jt.onResultsChanged},get testResults(){return(0,qe.checkProposedApiEnabled)(Pe,"testObserver"),Jt.results}},Oi={getExtension(te){const oe=ci.getExtensionDescription(te);if(oe)return new i.Extension(bt,Pe.identifier,oe,vi)},get all(){return ci.getAllExtensionDescriptions().map(te=>new i.Extension(bt,Pe.identifier,te,vi))},get onDidChange(){return ci.onDidChange}},Fi={createDiagnosticCollection(te){return qt.createDiagnosticCollection(Pe.identifier,te)},get onDidChangeDiagnostics(){return qt.onDidChangeDiagnostics},getDiagnostics:te=>qt.getDiagnostics(te),getLanguages(){return Kt.getLanguages()},setTextDocumentLanguage(te,oe){return Kt.changeLanguage(te.uri,oe)},match(te,oe){return(0,L.score)(j.LanguageSelector.from(te),oe.uri,oe.languageId,!0,oe.notebook?.notebookType)},registerCodeActionsProvider(te,oe,ye){return st.registerCodeActionProvider(Pe,ct(te),oe,ye)},registerCodeLensProvider(te,oe){return st.registerCodeLensProvider(Pe,ct(te),oe)},registerDefinitionProvider(te,oe){return st.registerDefinitionProvider(Pe,ct(te),oe)},registerDeclarationProvider(te,oe){return st.registerDeclarationProvider(Pe,ct(te),oe)},registerImplementationProvider(te,oe){return st.registerImplementationProvider(Pe,ct(te),oe)},registerTypeDefinitionProvider(te,oe){return st.registerTypeDefinitionProvider(Pe,ct(te),oe)},registerHoverProvider(te,oe){return st.registerHoverProvider(Pe,ct(te),oe,Pe.identifier)},registerEvaluatableExpressionProvider(te,oe){return st.registerEvaluatableExpressionProvider(Pe,ct(te),oe,Pe.identifier)},registerInlineValuesProvider(te,oe){return st.registerInlineValuesProvider(Pe,ct(te),oe,Pe.identifier)},registerDocumentHighlightProvider(te,oe){return st.registerDocumentHighlightProvider(Pe,ct(te),oe)},registerLinkedEditingRangeProvider(te,oe){return st.registerLinkedEditingRangeProvider(Pe,ct(te),oe)},registerReferenceProvider(te,oe){return st.registerReferenceProvider(Pe,ct(te),oe)},registerRenameProvider(te,oe){return st.registerRenameProvider(Pe,ct(te),oe)},registerDocumentSymbolProvider(te,oe,ye){return st.registerDocumentSymbolProvider(Pe,ct(te),oe,ye)},registerWorkspaceSymbolProvider(te){return st.registerWorkspaceSymbolProvider(Pe,te)},registerDocumentFormattingEditProvider(te,oe){return st.registerDocumentFormattingEditProvider(Pe,ct(te),oe)},registerDocumentRangeFormattingEditProvider(te,oe){return st.registerDocumentRangeFormattingEditProvider(Pe,ct(te),oe)},registerOnTypeFormattingEditProvider(te,oe,ye,...Ze){return st.registerOnTypeFormattingEditProvider(Pe,ct(te),oe,[ye].concat(Ze))},registerDocumentSemanticTokensProvider(te,oe,ye){return st.registerDocumentSemanticTokensProvider(Pe,ct(te),oe,ye)},registerDocumentRangeSemanticTokensProvider(te,oe,ye){return st.registerDocumentRangeSemanticTokensProvider(Pe,ct(te),oe,ye)},registerSignatureHelpProvider(te,oe,ye,...Ze){return typeof ye=="object"?st.registerSignatureHelpProvider(Pe,ct(te),oe,ye):st.registerSignatureHelpProvider(Pe,ct(te),oe,typeof ye=="undefined"?[]:[ye,...Ze])},registerCompletionItemProvider(te,oe,...ye){return st.registerCompletionItemProvider(Pe,ct(te),oe,ye)},registerInlineCompletionItemProvider(te,oe){return(0,qe.checkProposedApiEnabled)(Pe,"inlineCompletions"),st.registerInlineCompletionsProvider(Pe,ct(te),oe)},registerDocumentLinkProvider(te,oe){return st.registerDocumentLinkProvider(Pe,ct(te),oe)},registerColorProvider(te,oe){return st.registerColorProvider(Pe,ct(te),oe)},registerFoldingRangeProvider(te,oe){return st.registerFoldingRangeProvider(Pe,ct(te),oe)},registerSelectionRangeProvider(te,oe){return st.registerSelectionRangeProvider(Pe,te,oe)},registerCallHierarchyProvider(te,oe){return st.registerCallHierarchyProvider(Pe,te,oe)},registerTypeHierarchyProvider(te,oe){return st.registerTypeHierarchyProvider(Pe,te,oe)},setLanguageConfiguration:(te,oe)=>st.setLanguageConfiguration(Pe,te,oe),getTokenInformationAtPosition(te,oe){return(0,qe.checkProposedApiEnabled)(Pe,"tokenInformation"),Kt.tokenAtPosition(te,oe)},registerInlayHintsProvider(te,oe){return st.registerInlayHintsProvider(Pe,te,oe)},createLanguageStatusItem(te,oe){return Kt.createLanguageStatusItem(Pe,te,oe)}},ui={get activeTextEditor(){return Ct.getActiveTextEditor()},get visibleTextEditors(){return Ct.getVisibleTextEditors()},get activeTerminal(){return at.activeTerminal},get terminals(){return at.terminals},async showTextDocument(te,oe,ye){const Ze=await(D.URI.isUri(te)?Promise.resolve(Ei.openTextDocument(te)):Promise.resolve(te));return Ct.showTextDocument(Ze,oe,ye)},createTextEditorDecorationType(te){return Ct.createTextEditorDecorationType(Pe,te)},onDidChangeActiveTextEditor(te,oe,ye){return Ct.onDidChangeActiveTextEditor(te,oe,ye)},onDidChangeVisibleTextEditors(te,oe,ye){return Ct.onDidChangeVisibleTextEditors(te,oe,ye)},onDidChangeTextEditorSelection(te,oe,ye){return Ct.onDidChangeTextEditorSelection(te,oe,ye)},onDidChangeTextEditorOptions(te,oe,ye){return Ct.onDidChangeTextEditorOptions(te,oe,ye)},onDidChangeTextEditorVisibleRanges(te,oe,ye){return Ct.onDidChangeTextEditorVisibleRanges(te,oe,ye)},onDidChangeTextEditorViewColumn(te,oe,ye){return Ct.onDidChangeTextEditorViewColumn(te,oe,ye)},onDidCloseTerminal(te,oe,ye){return at.onDidCloseTerminal(te,oe,ye)},onDidOpenTerminal(te,oe,ye){return at.onDidOpenTerminal(te,oe,ye)},onDidChangeActiveTerminal(te,oe,ye){return at.onDidChangeActiveTerminal(te,oe,ye)},onDidChangeTerminalDimensions(te,oe,ye){return(0,qe.checkProposedApiEnabled)(Pe,"terminalDimensions"),at.onDidChangeTerminalDimensions(te,oe,ye)},onDidChangeTerminalState(te,oe,ye){return at.onDidChangeTerminalState(te,oe,ye)},onDidWriteTerminalData(te,oe,ye){return(0,qe.checkProposedApiEnabled)(Pe,"terminalDataWriteEvent"),at.onDidWriteTerminalData(te,oe,ye)},get state(){return $e.state},onDidChangeWindowState(te,oe,ye){return $e.onDidChangeWindowState(te,oe,ye)},showInformationMessage(te,...oe){return Zt.showMessage(Pe,B.default.Info,te,oe[0],oe.slice(1))},showWarningMessage(te,...oe){return Zt.showMessage(Pe,B.default.Warning,te,oe[0],oe.slice(1))},showErrorMessage(te,...oe){return Zt.showMessage(Pe,B.default.Error,te,oe[0],oe.slice(1))},showQuickPick(te,oe,ye){return zt.showQuickPick(te,oe,ye)},showWorkspaceFolderPick(te){return zt.showWorkspaceFolderPick(te)},showInputBox(te,oe){return zt.showInput(te,oe)},showOpenDialog(te){return gi.showOpenDialog(te)},showSaveDialog(te){return gi.showSaveDialog(te)},createStatusBarItem(te,oe,ye){let Ze,ht,yt;return typeof te=="string"?(Ze=te,ht=oe,yt=ye):(ht=te,yt=oe),Gt.createStatusBarEntry(Pe,Ze,ht,yt)},setStatusBarMessage(te,oe){return Gt.setStatusBarMessage(te,oe)},withScmProgress(te){return Ce.report("window.withScmProgress",Pe,"Use 'withProgress' instead."),fi.withProgress(Pe,{location:$.ProgressLocation.SourceControl},(oe,ye)=>te({report(Ze){}}))},withProgress(te,oe){return fi.withProgress(Pe,te,oe)},createOutputChannel(te,oe){return oe&&(0,qe.checkProposedApiEnabled)(Pe,"outputChannelLanguage"),Dt.createOutputChannel(te,oe,Pe)},createWebviewPanel(te,oe,ye,Ze){return Yt.createWebviewPanel(Pe,te,oe,ye,Ze)},createWebviewTextEditorInset(te,oe,ye,Ze){return(0,qe.checkProposedApiEnabled)(Pe,"editorInsets"),bi.createWebviewEditorInset(te,oe,ye,Ze,Pe)},createTerminal(te,oe,ye){return typeof te=="object"?"pty"in te?at.createExtensionTerminal(te):at.createTerminalFromOptions(te):at.createTerminal(te,oe,ye)},registerTerminalLinkProvider(te){return at.registerLinkProvider(te)},registerTerminalProfileProvider(te,oe){return at.registerProfileProvider(Pe,te,oe)},registerTreeDataProvider(te,oe){return ii.registerTreeDataProvider(te,oe,Pe)},createTreeView(te,oe){return ii.createTreeView(te,oe,Pe)},registerWebviewPanelSerializer:(te,oe)=>Yt.registerWebviewPanelSerializer(Pe,te,oe),registerCustomEditorProvider:(te,oe,ye={})=>Di.registerCustomEditorProvider(Pe,te,oe,ye),registerFileDecorationProvider(te){return gt.registerFileDecorationProvider(te,Pe.identifier)},registerUriHandler(te){return Ut.registerUriHandler(Pe.identifier,te)},createQuickPick(){return zt.createQuickPick(Pe)},createInputBox(){return zt.createInputBox(Pe.identifier)},get activeColorTheme(){return mi.activeColorTheme},onDidChangeActiveColorTheme(te,oe,ye){return mi.onDidChangeActiveColorTheme(te,oe,ye)},registerWebviewViewProvider(te,oe,ye){return Ci.registerWebviewViewProvider(Pe,te,oe,ye?.webviewOptions)},get activeNotebookEditor(){return(0,qe.checkProposedApiEnabled)(Pe,"notebookEditor"),pt.activeNotebookEditor},onDidChangeActiveNotebookEditor(te,oe,ye){return(0,qe.checkProposedApiEnabled)(Pe,"notebookEditor"),pt.onDidChangeActiveNotebookEditor(te,oe,ye)},get visibleNotebookEditors(){return(0,qe.checkProposedApiEnabled)(Pe,"notebookEditor"),pt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,qe.checkProposedApiEnabled)(Pe,"notebookEditor"),pt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(te,oe,ye){return(0,qe.checkProposedApiEnabled)(Pe,"notebookEditor"),Xt.onDidChangeNotebookEditorSelection(te,oe,ye)},onDidChangeNotebookEditorVisibleRanges(te,oe,ye){return(0,qe.checkProposedApiEnabled)(Pe,"notebookEditor"),Xt.onDidChangeNotebookEditorVisibleRanges(te,oe,ye)},showNotebookDocument(te,oe){return(0,qe.checkProposedApiEnabled)(Pe,"notebookEditor"),pt.showNotebookDocument(te,oe)},registerExternalUriOpener(te,oe,ye){return(0,qe.checkProposedApiEnabled)(Pe,"externalUriOpener"),si.registerExternalUriOpener(Pe.identifier,te,oe,ye)},get tabGroups(){return(0,qe.checkProposedApiEnabled)(Pe,"tabs"),lt.tabGroups},getInlineCompletionItemController(te){return(0,qe.checkProposedApiEnabled)(Pe,"inlineCompletions"),o.InlineCompletionController.get(te)}},Ei={get rootPath(){return Ce.report("workspace.rootPath",Pe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),dt.getPath()},set rootPath(te){throw I.readonly()},getWorkspaceFolder(te){return dt.getWorkspaceFolder(te)},get workspaceFolders(){return dt.getWorkspaceFolders()},get name(){return dt.name},set name(te){throw I.readonly()},get workspaceFile(){return dt.workspaceFile},set workspaceFile(te){throw I.readonly()},updateWorkspaceFolders:(te,oe,...ye)=>dt.updateWorkspaceFolders(Pe,te,oe||0,...ye),onDidChangeWorkspaceFolders:function(te,oe,ye){return dt.onDidChangeWorkspace(te,oe,ye)},asRelativePath:(te,oe)=>dt.getRelativePath(te,oe),findFiles:(te,oe,ye,Ze)=>dt.findFiles(te,oe,ye,Pe.identifier,Ze),findTextInFiles:(te,oe,ye,Ze)=>{(0,qe.checkProposedApiEnabled)(Pe,"findTextInFiles");let ht,yt;return typeof oe=="object"?(ht=oe,yt=ye):(ht={},yt=oe,Ze=ye),dt.findTextInFiles(te,ht||{},yt,Pe.identifier,Ze)},saveAll:te=>dt.saveAll(te),applyEdit(te){return ki.applyWorkspaceEdit(te)},createFileSystemWatcher:(te,oe,ye,Ze)=>Ht.createFileSystemWatcher(dt,Pe,te,oe,ye,Ze),get textDocuments(){return wt.getAllDocumentData().map(te=>te.document)},set textDocuments(te){throw I.readonly()},openTextDocument(te){let oe;const ye=te;if(typeof te=="string")oe=Promise.resolve(D.URI.file(te));else if(D.URI.isUri(te))oe=Promise.resolve(te);else if(!ye||typeof ye=="object")oe=wt.createDocumentData(ye);else throw new Error("illegal argument - uriOrFileNameOrOptions");return oe.then(Ze=>wt.ensureDocumentData(Ze).then(ht=>ht.document))},onDidOpenTextDocument:(te,oe,ye)=>wt.onDidAddDocument(te,oe,ye),onDidCloseTextDocument:(te,oe,ye)=>wt.onDidRemoveDocument(te,oe,ye),onDidChangeTextDocument:(te,oe,ye)=>wt.onDidChangeDocument(te,oe,ye),onDidSaveTextDocument:(te,oe,ye)=>wt.onDidSaveDocument(te,oe,ye),onWillSaveTextDocument:(te,oe,ye)=>Wt.getOnWillSaveTextDocumentEvent(Pe)(te,oe,ye),get notebookDocuments(){return pt.notebookDocuments.map(te=>te.apiNotebook)},async openNotebookDocument(te,oe){let ye;if(D.URI.isUri(te))ye=te,await pt.openNotebookDocument(te);else if(typeof te=="string")ye=D.URI.revive(await pt.createNotebookDocument({viewType:te,content:oe}));else throw new Error("Invalid arguments");return pt.getNotebookDocument(ye).apiNotebook},get onDidOpenNotebookDocument(){return pt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return pt.onDidCloseNotebookDocument},registerNotebookSerializer(te,oe,ye,Ze){return pt.registerNotebookSerializer(Pe,te,oe,ye,(0,qe.isProposedApiEnabled)(Pe,"notebookLiveShare")?Ze:void 0)},registerNotebookContentProvider:(te,oe,ye,Ze)=>((0,qe.checkProposedApiEnabled)(Pe,"notebookContentProvider"),pt.registerNotebookContentProvider(Pe,te,oe,ye,(0,qe.isProposedApiEnabled)(Pe,"notebookLiveShare")?Ze:void 0)),onDidChangeConfiguration:(te,oe,ye)=>Ot.onDidChangeConfiguration(te,oe,ye),getConfiguration(te,oe){return oe=arguments.length===1?void 0:oe,Ot.getConfiguration(te,oe,Pe)},registerTextDocumentContentProvider(te,oe){return Bt.registerTextDocumentContentProvider(te,oe)},registerTaskProvider:(te,oe)=>(Ce.report("window.registerTaskProvider",Pe,"Use the corresponding function on the 'tasks' namespace instead"),mt.registerTaskProvider(Pe,te,oe)),registerFileSystemProvider(te,oe,ye){return(0,kt.combinedDisposable)(li.registerFileSystemProvider(Pe,te,oe,ye),Tt.addFileSystemProvider(te,oe))},get fs(){return Tt.value},registerFileSearchProvider:(te,oe)=>((0,qe.checkProposedApiEnabled)(Pe,"fileSearchProvider"),Mt.registerFileSearchProvider(te,oe)),registerTextSearchProvider:(te,oe)=>((0,qe.checkProposedApiEnabled)(Pe,"textSearchProvider"),Mt.registerTextSearchProvider(te,oe)),registerRemoteAuthorityResolver:(te,oe)=>((0,qe.checkProposedApiEnabled)(Pe,"resolvers"),bt.registerRemoteAuthorityResolver(te,oe)),registerResourceLabelFormatter:te=>((0,qe.checkProposedApiEnabled)(Pe,"resolvers"),Si.$registerResourceLabelFormatter(te)),onDidCreateFiles:(te,oe,ye)=>Ht.onDidCreateFile(te,oe,ye),onDidDeleteFiles:(te,oe,ye)=>Ht.onDidDeleteFile(te,oe,ye),onDidRenameFiles:(te,oe,ye)=>Ht.onDidRenameFile(te,oe,ye),onWillCreateFiles:(te,oe,ye)=>Ht.getOnWillCreateFileEvent(Pe)(te,oe,ye),onWillDeleteFiles:(te,oe,ye)=>Ht.getOnWillDeleteFileEvent(Pe)(te,oe,ye),onWillRenameFiles:(te,oe,ye)=>Ht.getOnWillRenameFileEvent(Pe)(te,oe,ye),openTunnel:te=>((0,qe.checkProposedApiEnabled)(Pe,"resolvers"),_e.openTunnel(Pe,te).then(oe=>{if(!oe)throw new Error("cannot open tunnel");return oe})),get tunnels(){return(0,qe.checkProposedApiEnabled)(Pe,"resolvers"),_e.getTunnels()},onDidChangeTunnels:(te,oe,ye)=>((0,qe.checkProposedApiEnabled)(Pe,"resolvers"),_e.onDidChangeTunnels(te,oe,ye)),registerPortAttributesProvider:(te,oe)=>((0,qe.checkProposedApiEnabled)(Pe,"portsAttributes"),_e.registerPortsAttributesProvider(te,oe)),registerTimelineProvider:(te,oe)=>((0,qe.checkProposedApiEnabled)(Pe,"timeline"),yi.registerTimelineProvider(te,oe,Pe.identifier,rt.converter)),get isTrusted(){return dt.trusted},requestWorkspaceTrust:te=>((0,qe.checkProposedApiEnabled)(Pe,"workspaceTrust"),dt.requestWorkspaceTrust(te)),onDidGrantWorkspaceTrust:(te,oe,ye)=>dt.onDidGrantWorkspaceTrust(te,oe,ye)},Mi={get inputBox(){return Ce.report("scm.inputBox",Pe,"Use 'SourceControl.inputBox' instead"),ni.getLastInputBox(Pe)},createSourceControl(te,oe,ye){return ni.createSourceControl(Pe,te,oe,ye)}},Ni={createCommentController(te,oe){return _i.createCommentController(Pe,te,oe)}},Li={get activeDebugSession(){return ot.activeDebugSession},get activeDebugConsole(){return ot.activeDebugConsole},get breakpoints(){return ot.breakpoints},onDidStartDebugSession(te,oe,ye){return ot.onDidStartDebugSession(te,oe,ye)},onDidTerminateDebugSession(te,oe,ye){return ot.onDidTerminateDebugSession(te,oe,ye)},onDidChangeActiveDebugSession(te,oe,ye){return ot.onDidChangeActiveDebugSession(te,oe,ye)},onDidReceiveDebugSessionCustomEvent(te,oe,ye){return ot.onDidReceiveDebugSessionCustomEvent(te,oe,ye)},onDidChangeBreakpoints(te,oe,ye){return ot.onDidChangeBreakpoints(te,oe,ye)},registerDebugConfigurationProvider(te,oe,ye){return ot.registerDebugConfigurationProvider(te,oe,ye||vt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(te,oe){return ot.registerDebugAdapterDescriptorFactory(Pe,te,oe)},registerDebugAdapterTrackerFactory(te,oe){return ot.registerDebugAdapterTrackerFactory(te,oe)},startDebugging(te,oe,ye){return!ye||typeof ye=="object"&&"configuration"in ye?ot.startDebugging(te,oe,{parentSession:ye}):ot.startDebugging(te,oe,ye||{})},stopDebugging(te){return ot.stopDebugging(te)},addBreakpoints(te){return ot.addBreakpoints(te)},removeBreakpoints(te){return ot.removeBreakpoints(te)},asDebugSourceUri(te,oe){return ot.asDebugSourceUri(te,oe)}},Ui={registerTaskProvider:(te,oe)=>mt.registerTaskProvider(Pe,te,oe),fetchTasks:te=>mt.fetchTasks(te),executeTask:te=>mt.executeTask(Pe,te),get taskExecutions(){return mt.taskExecutions},onDidStartTask:(te,oe,ye)=>mt.onDidStartTask(te,oe,ye),onDidEndTask:(te,oe,ye)=>mt.onDidEndTask(te,oe,ye),onDidStartTaskProcess:(te,oe,ye)=>mt.onDidStartTaskProcess(te,oe,ye),onDidEndTaskProcess:(te,oe,ye)=>mt.onDidEndTaskProcess(te,oe,ye)},Bi={createNotebookController(te,oe,ye,Ze,ht){return ti.createNotebookController(Pe,te,oe,ye,Ze,(0,qe.isProposedApiEnabled)(Pe,"notebookMessaging")?ht:void 0)},registerNotebookCellStatusBarItemProvider:(te,oe)=>pt.registerNotebookCellStatusBarItemProvider(Pe,te,oe),get onDidSaveNotebookDocument(){return(0,qe.checkProposedApiEnabled)(Pe,"notebookEditor"),ei.onDidSaveNotebookDocument},createNotebookEditorDecorationType(te){return(0,qe.checkProposedApiEnabled)(Pe,"notebookEditorDecorationType"),Xt.createNotebookEditorDecorationType(te)},createRendererMessaging(te){return ai.createRendererMessaging(Pe,te)},onDidChangeNotebookDocumentMetadata(te,oe,ye){return(0,qe.checkProposedApiEnabled)(Pe,"notebookEditor"),ei.onDidChangeNotebookDocumentMetadata(te,oe,ye)},onDidChangeNotebookCells(te,oe,ye){return(0,qe.checkProposedApiEnabled)(Pe,"notebookEditor"),pt.onDidChangeNotebookCells(te,oe,ye)},onDidChangeNotebookCellExecutionState(te,oe,ye){return(0,qe.checkProposedApiEnabled)(Pe,"notebookCellExecutionState"),ti.onDidChangeNotebookCellExecutionState(te,oe,ye)},onDidChangeCellOutputs(te,oe,ye){return(0,qe.checkProposedApiEnabled)(Pe,"notebookEditor"),pt.onDidChangeCellOutputs(te,oe,ye)},onDidChangeCellMetadata(te,oe,ye){return(0,qe.checkProposedApiEnabled)(Pe,"notebookEditor"),pt.onDidChangeCellMetadata(te,oe,ye)},createConcatTextDocument(te,oe){return(0,qe.checkProposedApiEnabled)(Pe,"notebookConcatTextDocument"),new ve.ExtHostNotebookConcatDocument(pt,wt,te,oe)}};return{version:ut.version,authentication:Pi,commands:Ai,comments:Ni,debug:Li,env:pi,extensions:Oi,languages:Fi,notebooks:Bi,scm:Mi,tasks:Ui,tests:Ri,window:ui,workspace:Ei,Breakpoint:$.Breakpoint,CallHierarchyIncomingCall:$.CallHierarchyIncomingCall,CallHierarchyItem:$.CallHierarchyItem,CallHierarchyOutgoingCall:$.CallHierarchyOutgoingCall,CancellationError:I.CancellationError,CancellationTokenSource:s.CancellationTokenSource,CandidatePortSource:u.CandidatePortSource,CodeAction:$.CodeAction,CodeActionKind:$.CodeActionKind,CodeActionTriggerKind:$.CodeActionTriggerKind,CodeLens:$.CodeLens,Color:$.Color,ColorInformation:$.ColorInformation,ColorPresentation:$.ColorPresentation,ColorThemeKind:$.ColorThemeKind,CommentMode:$.CommentMode,CommentThreadCollapsibleState:$.CommentThreadCollapsibleState,CommentThreadState:$.CommentThreadState,CompletionItem:$.CompletionItem,CompletionItemKind:$.CompletionItemKind,CompletionItemTag:$.CompletionItemTag,CompletionList:$.CompletionList,CompletionTriggerKind:$.CompletionTriggerKind,ConfigurationTarget:$.ConfigurationTarget,CustomExecution:$.CustomExecution,DebugAdapterExecutable:$.DebugAdapterExecutable,DebugAdapterInlineImplementation:$.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:$.DebugAdapterNamedPipeServer,DebugAdapterServer:$.DebugAdapterServer,DebugConfigurationProviderTriggerKind:vt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:$.DebugConsoleMode,DecorationRangeBehavior:$.DecorationRangeBehavior,Diagnostic:$.Diagnostic,DiagnosticRelatedInformation:$.DiagnosticRelatedInformation,DiagnosticSeverity:$.DiagnosticSeverity,DiagnosticTag:$.DiagnosticTag,Disposable:$.Disposable,DocumentHighlight:$.DocumentHighlight,DocumentHighlightKind:$.DocumentHighlightKind,DocumentLink:$.DocumentLink,DocumentSymbol:$.DocumentSymbol,EndOfLine:$.EndOfLine,EnvironmentVariableMutatorType:$.EnvironmentVariableMutatorType,EvaluatableExpression:$.EvaluatableExpression,InlineValueText:$.InlineValueText,InlineValueVariableLookup:$.InlineValueVariableLookup,InlineValueEvaluatableExpression:$.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:$.InlineCompletionTriggerKind,EventEmitter:b.Emitter,ExtensionKind:$.ExtensionKind,ExtensionMode:$.ExtensionMode,ExternalUriOpenerPriority:$.ExternalUriOpenerPriority,FileChangeType:$.FileChangeType,FileDecoration:$.FileDecoration,FileSystemError:$.FileSystemError,FileType:v.FileType,FilePermission:v.FilePermission,FoldingRange:$.FoldingRange,FoldingRangeKind:$.FoldingRangeKind,FunctionBreakpoint:$.FunctionBreakpoint,InlineCompletionItem:$.InlineSuggestion,InlineCompletionList:$.InlineSuggestions,Hover:$.Hover,IndentAction:M.IndentAction,Location:$.Location,MarkdownString:$.MarkdownString,OverviewRulerLane:y.OverviewRulerLane,ParameterInformation:$.ParameterInformation,PortAutoForwardAction:$.PortAutoForwardAction,Position:$.Position,ProcessExecution:$.ProcessExecution,ProgressLocation:$.ProgressLocation,QuickInputButtons:$.QuickInputButtons,Range:$.Range,RelativePattern:$.RelativePattern,Selection:$.Selection,SelectionRange:$.SelectionRange,SemanticTokens:$.SemanticTokens,SemanticTokensBuilder:$.SemanticTokensBuilder,SemanticTokensEdit:$.SemanticTokensEdit,SemanticTokensEdits:$.SemanticTokensEdits,SemanticTokensLegend:$.SemanticTokensLegend,ShellExecution:$.ShellExecution,ShellQuoting:$.ShellQuoting,SignatureHelp:$.SignatureHelp,SignatureHelpTriggerKind:$.SignatureHelpTriggerKind,SignatureInformation:$.SignatureInformation,SnippetString:$.SnippetString,SourceBreakpoint:$.SourceBreakpoint,StandardTokenType:$.StandardTokenType,StatusBarAlignment:$.StatusBarAlignment,SymbolInformation:$.SymbolInformation,SymbolKind:$.SymbolKind,SymbolTag:$.SymbolTag,TabKind:u.TabKind,Task:$.Task,TaskGroup:$.TaskGroup,TaskPanelKind:$.TaskPanelKind,TaskRevealKind:$.TaskRevealKind,TaskScope:$.TaskScope,TerminalLink:$.TerminalLink,TerminalLocation:$.TerminalLocation,TerminalProfile:$.TerminalProfile,TextDocumentSaveReason:$.TextDocumentSaveReason,TextEdit:$.TextEdit,TextEditorCursorStyle:A.TextEditorCursorStyle,TextEditorLineNumbersStyle:$.TextEditorLineNumbersStyle,TextEditorRevealType:$.TextEditorRevealType,TextEditorSelectionChangeKind:$.TextEditorSelectionChangeKind,TextDocumentChangeReason:$.TextDocumentChangeReason,ThemeColor:$.ThemeColor,ThemeIcon:$.ThemeIcon,TreeItem:$.TreeItem,TreeItemCollapsibleState:$.TreeItemCollapsibleState,TypeHierarchyItem:$.TypeHierarchyItem,UIKind:m.UIKind,Uri:D.URI,ViewColumn:$.ViewColumn,WorkspaceEdit:$.WorkspaceEdit,InlayHint:$.InlayHint,InlayHintLabelPart:$.InlayHintLabelPart,InlayHintKind:$.InlayHintKind,RemoteAuthorityResolverError:$.RemoteAuthorityResolverError,ResolvedAuthority:$.ResolvedAuthority,SourceControlInputBoxValidationType:$.SourceControlInputBoxValidationType,ExtensionRuntime:$.ExtensionRuntime,TimelineItem:$.TimelineItem,NotebookRange:$.NotebookRange,NotebookCellKind:$.NotebookCellKind,NotebookCellExecutionState:$.NotebookCellExecutionState,NotebookCellData:$.NotebookCellData,NotebookData:$.NotebookData,NotebookRendererScript:$.NotebookRendererScript,NotebookCellStatusBarAlignment:$.NotebookCellStatusBarAlignment,NotebookEditorRevealType:$.NotebookEditorRevealType,NotebookCellOutput:$.NotebookCellOutput,NotebookCellOutputItem:$.NotebookCellOutputItem,NotebookCellStatusBarItem:$.NotebookCellStatusBarItem,NotebookControllerAffinity:$.NotebookControllerAffinity,PortAttributes:$.PortAttributes,LinkedEditingRanges:$.LinkedEditingRanges,TestResultState:$.TestResultState,TestRunRequest:$.TestRunRequest,TestMessage:$.TestMessage,TestTag:$.TestTag,TestRunProfileKind:$.TestRunProfileKind,TextSearchCompleteMessageType:Oe.TextSearchCompleteMessageType,TreeDataTransfer:$.TreeDataTransfer,TreeDataTransferItem:$.TreeDataTransferItem,CoveredCount:$.CoveredCount,FileCoverage:$.FileCoverage,StatementCoverage:$.StatementCoverage,BranchCoverage:$.BranchCoverage,FunctionCoverage:$.FunctionCoverage,WorkspaceTrustState:$.WorkspaceTrustState,LanguageStatusSeverity:$.LanguageStatusSeverity,QuickPickItemKind:$.QuickPickItemKind}}}e.createApiFactoryAndRegisterActors=Nt}),define(Ee[224],we([1,0,223,33,2,217,7,13,4]),function(J,e,s,I,b,B,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class M extends B.RequireInterceptor{_installInterceptor(){}getModule(l,n){for(let f of this._alternatives){let S=f(l);if(S){l=S;break}}if(this._factories.has(l))return this._factories.get(l).load(l,n,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class L extends I.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=D.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const l=this._extHostContext.getProxy(y.MainContext.MainThreadConsole);u(l,this._initData.environment.isExtensionDevelopmentDebug);const n=this._instaService.invokeFunction(s.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(M,n,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(l){return l.browser}async _loadCommonJSModule(l,n,f){n=n.with({path:v(n.path,".js")}),l&&performance.mark(`code/extHost/willFetchExtensionCode/${l.value}`);const S=b.URI.revive(await this._mainThreadExtensionsProxy.$asBrowserUri(n)),k=await fetch(S.toString(!0));if(l&&performance.mark(`code/extHost/didFetchExtensionCode/${l.value}`),k.status!==200)throw new Error(k.statusText);const d=await k.text(),p=`${n.toString(!0)}#vscode-extension`,w=`${d}
//# sourceURL=${p}`;let a;try{a=new Function("module","exports","require",w)}catch(c){throw console.error(l?`Loading code for extension ${l.value} failed: ${c.message}`:`Loading code failed: ${c.message}`),console.error(`${n.toString(!0)}${typeof c.line=="number"?` line ${c.line}`:""}${typeof c.column=="number"?` column ${c.column}`:""}`),console.error(c),c}const T={},r={exports:T},i=c=>{const t=this._fakeModules.getModule(c,n);if(t===void 0)throw new Error(`Cannot load module '${c}'`);return t};try{return f.codeLoadingStart(),l&&performance.mark(`code/extHost/willLoadExtensionCode/${l.value}`),a(r,T,i),r.exports!==T?r.exports:T}finally{l&&performance.mark(`code/extHost/didLoadExtensionCode/${l.value}`),f.codeLoadingStop()}}async $setRemoteEnvironment(l){}async _waitForDebuggerAttachment(l=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const n=Date.now()+l;for(;Date.now()<n&&!("__jsDebugIsReady"in globalThis);)await(0,A.timeout)(10)}}e.ExtHostExtensionService=L;function v(m,l){return m.endsWith(l)?m:m+l}function u(m,l){n("info","log"),n("log","log"),n("warn","warn"),n("error","error");function n(k,d){const p=console[k];console[k]=function(){m.$logExtensionHostMessage({type:"__$console",severity:d,arguments:S(arguments)}),l&&p.apply(console,arguments)}}const f=1e5;function S(k){const d=[],p=[];if(k.length)for(let w=0;w<k.length;w++){if(typeof k[w]=="undefined")k[w]="undefined";else if(k[w]instanceof Error){const a=k[w];a.stack?k[w]=a.stack:k[w]=a.toString()}p.push(k[w])}try{const w=JSON.stringify(p,function(a,T){if(T&&typeof T=="object"){if(d.indexOf(T)!==-1)return"[Circular]";d.push(T)}return T});return w.length>f?"Output omitted for a large object that exceeds the limits":w}catch(w){return`Output omitted for an object that cannot be inspected ('${w.toString()}')`}}}}),define(Ee[225],we([1,0,55,33,68,224]),function(J,e,s,I,b,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,s.registerSingleton)(I.IExtHostExtensionService,B.ExtHostExtensionService),(0,s.registerSingleton)(b.IExtensionStoragePaths,b.ExtensionStoragePaths)}),define(Ee[236],we([1,0,21,5,91,218,211,17,69,10,2,220,225]),function(J,e,s,I,b,B,D,A,y,M,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const v=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const u=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function m(a){return/^(file|vscode-remote):/i.test(a)}const l=fetch.bind(self);function n(a){self.fetch=async function(T,r){return T instanceof Request||m(String(T))&&(T=(await a(L.URI.parse(String(T)))).toString(!0)),l(T,r)},self.XMLHttpRequest=class extends XMLHttpRequest{open(T,r,i,c,t){(async()=>{m(r.toString())&&(r=(await a(L.URI.parse(r.toString()))).toString(!0)),super.open(T,r,i??!0,c,t)})()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const a=self.Worker;Worker=function(T,r){if(/^file:/i.test(T.toString()))T=M.FileAccess.asBrowserUri(L.URI.parse(T.toString())).toString(!0);else if(/^vscode-remote:/i.test(T.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const c=`(${function(h){function _(W){return typeof W=="string"||W instanceof URL?String(W).replace(/^file:\/\//i,"vscode-file://vscode-app"):W}const P=fetch.bind(self);self.fetch=function(W,E){return W instanceof Request?P(W,E):P(_(W),E)},self.XMLHttpRequest=class extends XMLHttpRequest{open(W,E,H,z,q){return super.open(W,_(E),H??!0,z,q)}};const R=importScripts.bind(self);self.importScripts=(...W)=>{R(...W.map(_))},R(h)}.toString()}('${T}'))`;r=r||{},r.name=r.name||A.basename(T.toString());const t=new Blob([c],{type:"application/javascript"}),o=URL.createObjectURL(t);return new a(o,r)}}else self.Worker=class extends D.NestedWorker{constructor(a,T){super(u,a,{name:A.basename(a.toString()),...T})}};const f=new class{constructor(){this.pid=void 0}exit(a){v()}async exists(a){return!0}async realpath(a){return a}};class S{constructor(){const T=new MessageChannel,r=new I.Emitter;let i=!1;u(T.port2,[T.port2]),T.port1.onmessage=c=>{const{data:t}=c;if(!(t instanceof ArrayBuffer)){console.warn("UNKNOWN data received",t);return}const o=s.VSBuffer.wrap(new Uint8Array(t,0,t.byteLength));if((0,b.isMessageOfType)(o,2)){i=!0,d("received terminate message from renderer");return}r.fire(o)},this.protocol={onMessage:r.event,send:c=>{if(!i){const t=c.buffer.buffer.slice(c.buffer.byteOffset,c.buffer.byteOffset+c.buffer.byteLength);T.port1.postMessage(t,[t])}}}}}function k(a){return new Promise(T=>{const r=a.onMessage(i=>{r.dispose();const c=JSON.parse(i.toString());a.send((0,b.createMessageOfType)(0)),T({protocol:a,initData:c})});a.send((0,b.createMessageOfType)(1))})}let d=a=>v();function p(a){return!!a&&typeof a=="object"&&a.type==="vscode.init"&&a.data instanceof Map}function w(){y.mark("code/extHost/willConnectToRenderer");const a=new S;return{onmessage(T){!p(T)||k(a.protocol).then(r=>{y.mark("code/extHost/didWaitForInitData");const i=new B.ExtensionHostMain(r.protocol,r.initData,f,null,T.data);n(c=>i.asBrowserUri(c)),d=c=>i.terminate(c)})}}}e.create=w})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/0058a3011e8686dc3199f56faf249ecf7663bf91/core/vs/workbench/api/worker/extensionHostWorker.js.map
